/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/uri","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/base/common/strings","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/userDataSync","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","os","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/map","child_process","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","vs/platform/product/common/product","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","minimist","assert","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],w=0,I=K.length;w<I;w++)e[w]=Z[K[w]];return e};define(Z[90],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(I,L){if(!I)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=w}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const w=Object.prototype.hasOwnProperty;function I(n){const y=[];for(let m in n)w.call(n,m)&&y.push(n[m]);return y}e.values=I;function L(n,y){for(let m in n)if(w.call(n,m)&&y({key:m,value:n[m]},function(){delete n[m]})===!1)return}e.forEach=L;function k(n,y){const m=Object.create(null);for(const g of n){const u=y(g);let C=m[u];C||(C=m[u]=[]),C.push(g)}return m}e.groupBy=k;function A(n){const y=Object.create(null);return n&&n.forEach((m,g)=>{y[g]=m}),y}e.fromMap=A;function D(n,y){const m=[],g=[];for(let u of n)y.has(u)||m.push(u);for(let u of y)n.has(u)||g.push(u);return{removed:m,added:g}}e.diffSets=D;function E(n,y){const m=[],g=[];for(let[u,C]of n)y.has(u)||m.push(C);for(let[u,C]of y)n.has(u)||g.push(C);return{removed:m,added:g}}e.diffMaps=E;class v{constructor(){this.map=new Map}add(y,m){let g=this.map.get(y);g||(g=new Set,this.map.set(y,g)),g.add(m)}delete(y,m){const g=this.map.get(y);!g||(g.delete(m),g.size===0&&this.map.delete(y))}forEach(y,m){const g=this.map.get(y);!g||g.forEach(m)}}e.SetMap=v}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(A){return(D,E,v)=>{let n=null,y=null;if(typeof v.value=="function"?(n="value",y=v.value):typeof v.get=="function"&&(n="get",y=v.get),!y)throw new Error("not supported");v[n]=A(y,E)}}e.createDecorator=w;function I(A,D,E){let v=null,n=null;if(typeof E.value=="function"?(v="value",n=E.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(v="get",n=E.get),!n)throw new Error("not supported");const y=`$memoize$${D}`;E[v]=function(...m){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,m)}),this[y]}}e.memoize=I;function L(A,D,E){return w((v,n)=>{const y=`$debounce$${n}`,m=`$debounce$result$${n}`;return function(...g){this[m]||(this[m]=E?E():void 0),clearTimeout(this[y]),D&&(this[m]=D(this[m],...g),g=[this[m]]),this[y]=setTimeout(()=>{v.apply(this,g),this[m]=E?E():void 0},A)}})}e.debounce=L;function k(A,D,E){return w((v,n)=>{const y=`$throttle$timer$${n}`,m=`$throttle$result$${n}`,g=`$throttle$lastRun$${n}`,u=`$throttle$pending$${n}`;return function(...C){if(this[m]||(this[m]=E?E():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),D&&(this[m]=D(this[m],...C)),this[u])return;const P=this[g]+A;P<=Date.now()?(this[g]=Date.now(),v.apply(this,[this[m]]),this[m]=E?E():void 0):(this[u]=!0,this[y]=setTimeout(()=>{this[u]=!1,this[g]=Date.now(),v.apply(this,[this[m]]),this[m]=E?E():void 0},P-Date.now()))}})}e.throttle=k}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=w,e.errorHandler=new w;function I(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=I;function L(a){E(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=L;function k(a){E(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=k;function A(a){if(a instanceof Error){let{name:t,message:r}=a;const i=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:i}}return a}e.transformErrorForSerialization=A;const D="Canceled";function E(a){return a instanceof Error&&a.name===D&&a.message===D}e.isPromiseCanceledError=E;class v extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=v;function n(){const a=new Error(D);return a.name=a.message,a}e.canceled=n;function y(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=y;function m(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=m;function g(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function u(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function C(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=C;class P extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=P;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class R extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=R;function p(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=p;function o(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(Z[23],ee([0,1,11]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I(N,G=0){return N[N.length-(1+G)]}e.tail=I;function L(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=L;function k(N,G,B=(J,Q)=>J===Q){if(N===G)return!0;if(!N||!G||N.length!==G.length)return!1;for(let J=0,Q=N.length;J<Q;J++)if(!B(N[J],G[J]))return!1;return!0}e.equals=k;function A(N,G,B){let J=0,Q=N.length-1;for(;J<=Q;){const ie=(J+Q)/2|0,ne=B(N[ie],G);if(ne<0)J=ie+1;else if(ne>0)Q=ie-1;else return ie}return-(J+1)}e.binarySearch=A;function D(N,G){let B=0,J=N.length;if(J===0)return 0;for(;B<J;){const Q=Math.floor((B+J)/2);G(N[Q])?J=Q:B=Q+1}return B}e.findFirstInSorted=D;function E(N,G,B){if(N=N|0,N>=G.length)throw new TypeError("invalid index");let J=G[Math.floor(G.length*Math.random())],Q=[],ie=[],ne=[];for(let le of G){const fe=B(le,J);fe<0?Q.push(le):fe>0?ie.push(le):ne.push(le)}return N<Q.length?E(N,Q,B):N<Q.length+ne.length?ne[0]:E(N-(Q.length+ne.length),ie,B)}e.quickSelect=E;function v(N,G){const B=[];let J;for(const Q of N.slice(0).sort(G))!J||G(J[0],Q)!==0?(J=[Q],B.push(J)):J.push(Q);return B}e.groupBy=v;function n(N,G,B){const J=[];function Q(le,fe,me){if(fe===0&&me.length===0)return;const Se=J[J.length-1];Se&&Se.start+Se.deleteCount===le?(Se.deleteCount+=fe,Se.toInsert.push(...me)):J.push({start:le,deleteCount:fe,toInsert:me})}let ie=0,ne=0;for(;;){if(ie===N.length){Q(ie,0,G.slice(ne));break}if(ne===G.length){Q(ie,N.length-ie,[]);break}const le=N[ie],fe=G[ne],me=B(le,fe);me===0?(ie+=1,ne+=1):me<0?(Q(ie,1,[]),ie+=1):me>0&&(Q(ie,0,[fe]),ne+=1)}return J}e.sortedDiff=n;function y(N,G,B){const J=n(N,G,B),Q=[],ie=[];for(const ne of J)Q.push(...N.slice(ne.start,ne.start+ne.deleteCount)),ie.push(...ne.toInsert);return{removed:Q,added:ie}}e.delta=y;function m(N,G,B){if(B===0)return[];const J=N.slice(0,B).sort(G);return u(N,G,J,B,N.length),J}e.top=m;function g(N,G,B,J,Q){return B===0?Promise.resolve([]):new Promise((ie,ne)=>{(async()=>{const le=N.length,fe=N.slice(0,B).sort(G);for(let me=B,Se=Math.min(B+J,le);me<le;me=Se,Se=Math.min(Se+J,le)){if(me>B&&await new Promise(Pe=>setTimeout(Pe)),Q&&Q.isCancellationRequested)throw(0,w.canceled)();u(N,G,fe,me,Se)}return fe})().then(ie,ne)})}e.topAsync=g;function u(N,G,B,J,Q){for(const ie=B.length;J<Q;J++){const ne=N[J];if(G(ne,B[ie-1])<0){B.pop();const le=D(B,fe=>G(ne,fe)<0);B.splice(le,0,ne)}}}function C(N){return N.filter(G=>!!G)}e.coalesce=C;function P(N){let G=0;for(let B=0;B<N.length;B++)N[B]&&(N[G]=N[B],G+=1);N.length=G}e.coalesceInPlace=P;function b(N,G,B){N.splice(B,0,N.splice(G,1)[0])}e.move=b;function R(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=R;function p(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=p;function o(N,G){if(!G)return N.filter((J,Q)=>N.indexOf(J)===Q);const B=Object.create(null);return N.filter(J=>{const Q=G(J);return B[Q]?!1:(B[Q]=!0,!0)})}e.distinct=o;function a(N){const G=new Set;return N.filter(B=>G.has(B)?!1:(G.add(B),!0))}e.distinctES6=a;function t(N){const G=Object.create(null);return B=>{const J=N(B);return G[J]?!1:(G[J]=!0,!0)}}e.uniqueFilter=t;function r(N,G){for(let B=N.length-1;B>=0;B--){const J=N[B];if(G(J))return B}return-1}e.lastIndex=r;function i(N,G){return N.length>0?N[0]:G}e.firstOrDefault=i;function s(N,G,B=(J,Q)=>J===Q){let J=0;for(let Q=0,ie=Math.min(N.length,G.length);Q<ie&&B(N[Q],G[Q]);Q++)J++;return J}e.commonPrefixLength=s;function h(N){return[].concat(...N)}e.flatten=h;function c(N,G){let B=typeof G=="number"?N:0;typeof G=="number"?B=N:(B=0,G=N);const J=[];if(B<=G)for(let Q=B;Q<G;Q++)J.push(Q);else for(let Q=B;Q>G;Q--)J.push(Q);return J}e.range=c;function l(N,G,B){return N.reduce((J,Q)=>(J[G(Q)]=B?B(Q):Q,J),Object.create(null))}e.index=l;function f(N,G){return N.push(G),()=>S(N,G)}e.insert=f;function S(N,G){const B=N.indexOf(G);if(B>-1)return N.splice(B,1),G}e.remove=S;function d(N,G,B){const J=N.slice(0,G),Q=N.slice(G);return J.concat(B,Q)}e.arrayInsert=d;function T(N,G){let B;if(typeof G=="number"){let J=G;B=()=>{const Q=Math.sin(J++)*179426549;return Q-Math.floor(Q)}}else B=Math.random;for(let J=N.length-1;J>0;J-=1){const Q=Math.floor(B()*(J+1)),ie=N[J];N[J]=N[Q],N[Q]=ie}}e.shuffle=T;function O(N,G){const B=N.indexOf(G);B>-1&&(N.splice(B,1),N.unshift(G))}e.pushToStart=O;function _(N,G){const B=N.indexOf(G);B>-1&&(N.splice(B,1),N.push(G))}e.pushToEnd=_;function z(N,G){return Array.isArray(N)?N.map(G):G(N)}e.mapArrayOrNot=z;function H(N){return Array.isArray(N)?N:[N]}e.asArray=H;function V(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=V;function U(N,G){for(const B of N){const J=G(B);if(J!==void 0)return J}}e.mapFind=U;function x(N,G,B){const J=$(N,G),Q=N.length,ie=B.length;N.length=Q+ie;for(let ne=Q-1;ne>=J;ne--)N[ne+ie]=N[ne];for(let ne=0;ne<ie;ne++)N[ne+J]=B[ne]}e.insertInto=x;function M(N,G,B,J){const Q=$(N,G),ie=N.splice(Q,B);return x(N,Q,J),ie}e.splice=M;function $(N,G){return G<0?Math.max(G+N.length,0):Math.min(G,N.length)}function q(N,G){let B=Number.MAX_SAFE_INTEGER,J=0;return N.forEach((Q,ie)=>{const ne=G(Q);ne<B&&(B=ne,J=ie)}),J}e.minIndex=q;function F(N,G){let B=Number.MIN_SAFE_INTEGER,J=0;return N.forEach((Q,ie)=>{const ne=G(Q);ne>B&&(B=ne,J=ie)}),J}e.maxIndex=F;class W{constructor(G){this.items=G,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(G){let B=this.firstIdx;for(;B<this.items.length&&G(this.items[B]);)B++;const J=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,J}takeFromEndWhile(G){let B=this.lastIdx;for(;B>=0&&G(this.items[B]);)B--;const J=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,J}}e.ArrayQueue=W}),define(Z[65],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(I){const L=this;let k=!1,A;return function(){return k||(k=!0,A=I.apply(L,arguments)),A}}e.once=w}),define(Z[55],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(I){function L(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}I.is=L;const k=Object.freeze([]);function A(){return k}I.empty=A;function*D(a){yield a}I.single=D;function E(a){return a||k}I.from=E;function v(a){return!a||a[Symbol.iterator]().next().done===!0}I.isEmpty=v;function n(a){return a[Symbol.iterator]().next().value}I.first=n;function y(a,t){for(const r of a)if(t(r))return!0;return!1}I.some=y;function m(a,t){for(const r of a)if(t(r))return r}I.find=m;function*g(a,t){for(const r of a)t(r)&&(yield r)}I.filter=g;function*u(a,t){let r=0;for(const i of a)yield t(i,r++)}I.map=u;function*C(...a){for(const t of a)for(const r of t)yield r}I.concat=C;function*P(a){for(const t of a)for(const r of t)yield r}I.concatNested=P;function b(a,t,r){let i=r;for(const s of a)i=t(i,s);return i}I.reduce=b;function*R(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}I.slice=R;function p(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const i=a[Symbol.iterator]();for(let s=0;s<t;s++){const h=i.next();if(h.done)return[r,I.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return i}}]}I.consume=p;function o(a,t,r=(i,s)=>i===s){const i=a[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const h=i.next(),c=s.next();if(h.done!==c.done)return!1;if(h.done)return!0;if(!r(h.value,c.value))return!1}}I.equals=o})(w=e.Iterable||(e.Iterable={}))}),define(Z[33],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let i=0,s=t.length,h="",c=0,l=16,f=0;function S(V){let U=0,x=0;for(;U<V;){const M=t.charCodeAt(i);if(M>=48&&M<=57)x=x*16+M-48;else if(M>=65&&M<=70)x=x*16+M-65+10;else if(M>=97&&M<=102)x=x*16+M-97+10;else break;i++,U++}return U<V&&(x=-1),x}function d(V){i=V,h="",c=0,l=16,f=0}function T(){const V=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&v(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&v(t.charCodeAt(i)))for(i++;i<t.length&&v(t.charCodeAt(i));)i++;else return f=3,t.substring(V,i);let U=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&v(t.charCodeAt(i))){for(i++;i<t.length&&v(t.charCodeAt(i));)i++;U=i}else f=3;return t.substring(V,U)}function O(){let V="",U=i;for(;;){if(i>=s){V+=t.substring(U,i),f=2;break}const x=t.charCodeAt(i);if(x===34){V+=t.substring(U,i),i++;break}if(x===92){if(V+=t.substring(U,i),i++,i>=s){f=2;break}switch(t.charCodeAt(i++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:const $=S(4);$>=0?V+=String.fromCharCode($):f=4;break;default:f=5}U=i;continue}if(x>=0&&x<=31)if(E(x)){V+=t.substring(U,i),f=2;break}else f=6;i++}return V}function _(){if(h="",f=0,c=i,i>=s)return c=s,l=17;let V=t.charCodeAt(i);if(D(V)){do i++,h+=String.fromCharCode(V),V=t.charCodeAt(i);while(D(V));return l=15}if(E(V))return i++,h+=String.fromCharCode(V),V===13&&t.charCodeAt(i)===10&&(i++,h+=`
`),l=14;switch(V){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,h=O(),l=10;case 47:const U=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!E(t.charCodeAt(i));)i++;return h=t.substring(U,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const x=s-1;let M=!1;for(;i<x;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,M=!0;break}i++}return M||(i++,f=1),h=t.substring(U,i),l=13}return h+=String.fromCharCode(V),i++,l=16;case 45:if(h+=String.fromCharCode(V),i++,i===s||!v(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=T(),l=11;default:for(;i<s&&z(V);)i++,V=t.charCodeAt(i);if(c!==i){switch(h=t.substring(c,i),h){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return h+=String.fromCharCode(V),i++,l=16}}function z(V){if(D(V)||E(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let V;do V=_();while(V>=12&&V<=15);return V}return{setPosition:d,getPosition:()=>i,scan:r?H:_,getToken:()=>l,getTokenValue:()=>h,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>f}}e.createScanner=A;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function y(t,r){const i=[],s=new Object;let h;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function f(S,d,T,O){c.value=S,c.offset=d,c.length=T,c.type=O,c.colonOffset=void 0,h=c}try{p(t,{onObjectBegin:(S,d)=>{if(r<=S)throw s;h=void 0,l=r>S,i.push("")},onObjectProperty:(S,d,T)=>{if(r<d||(f(S,d,T,"property"),i[i.length-1]=S,r<=d+T))throw s},onObjectEnd:(S,d)=>{if(r<=S)throw s;h=void 0,i.pop()},onArrayBegin:(S,d)=>{if(r<=S)throw s;h=void 0,i.push(0)},onArrayEnd:(S,d)=>{if(r<=S)throw s;h=void 0,i.pop()},onLiteralValue:(S,d,T)=>{if(r<d||(f(S,d,T,a(S)),r<=d+T))throw s},onSeparator:(S,d,T)=>{if(r<=d)throw s;if(S===":"&&h&&h.type==="property")h.colonOffset=d,l=!1,h=void 0;else if(S===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(l=!0,i[i.length-1]=""),h=void 0}}})}catch(S){if(S!==s)throw S}return{path:i,previousNode:h,isAtPropertyKey:l,matches:S=>{let d=0;for(let T=0;d<S.length&&T<i.length;T++)if(S[d]===i[T]||S[d]==="*")d++;else if(S[d]!=="**")return!1;return d===S.length}}}e.getLocation=y;function m(t,r=[],i=k.DEFAULT){let s=null,h=[];const c=[];function l(S){Array.isArray(h)?h.push(S):s!==null&&(h[s]=S)}return p(t,{onObjectBegin:()=>{const S={};l(S),c.push(h),h=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{h=c.pop()},onArrayBegin:()=>{const S=[];l(S),c.push(h),h=S,s=null},onArrayEnd:()=>{h=c.pop()},onLiteralValue:l,onError:(S,d,T)=>{r.push({error:S,offset:d,length:T})}},i),h[0]}e.parse=m;function g(t,r=[],i=k.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(S){s.type==="property"&&(s.length=S-s.offset,s=s.parent)}function c(S){return s.children.push(S),S}p(t,{onObjectBegin:S=>{s=c({type:"object",offset:S,length:-1,parent:s,children:[]})},onObjectProperty:(S,d,T)=>{s=c({type:"property",offset:d,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:S,offset:d,length:T,parent:s})},onObjectEnd:(S,d)=>{s.length=S+d-s.offset,s=s.parent,h(S+d)},onArrayBegin:(S,d)=>{s=c({type:"array",offset:S,length:-1,parent:s,children:[]})},onArrayEnd:(S,d)=>{s.length=S+d-s.offset,s=s.parent,h(S+d)},onLiteralValue:(S,d,T)=>{c({type:a(S),offset:d,length:T,parent:s,value:S}),h(d+T)},onSeparator:(S,d,T)=>{s.type==="property"&&(S===":"?s.colonOffset=d:S===","&&h(d))},onError:(S,d,T)=>{r.push({error:S,offset:d,length:T})}},i);const f=s.children[0];return f&&delete f.parent,f}e.parseTree=g;function u(t,r){if(!t)return;let i=t;for(let s of r)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let h=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===s){i=c.children[1],h=!0;break}if(!h)return}else{const h=s;if(i.type!=="array"||h<0||!Array.isArray(i.children)||h>=i.children.length)return;i=i.children[h]}return i}e.findNodeAtLocation=u;function C(t){if(!t.parent||!t.parent.children)return[];const r=C(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=C;function P(t){switch(t.type){case"array":return t.children.map(P);case"object":const r=Object.create(null);for(let i of t.children){const s=i.children[1];s&&(r[i.children[0].value]=P(s))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=P;function b(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=b;function R(t,r,i=!1){if(b(t,r,i)){const s=t.children;if(Array.isArray(s))for(let h=0;h<s.length&&s[h].offset<=r;h++){const c=R(s[h],r,i);if(c)return c}return t}}e.findNodeAtOffset=R;function p(t,r,i=k.DEFAULT){const s=A(t,!1);function h(B){return B?()=>B(s.getTokenOffset(),s.getTokenLength()):()=>!0}function c(B){return B?J=>B(J,s.getTokenOffset(),s.getTokenLength()):()=>!0}const l=h(r.onObjectBegin),f=c(r.onObjectProperty),S=h(r.onObjectEnd),d=h(r.onArrayBegin),T=h(r.onArrayEnd),O=c(r.onLiteralValue),_=c(r.onSeparator),z=h(r.onComment),H=c(r.onError),V=i&&i.disallowComments,U=i&&i.allowTrailingComma;function x(){for(;;){const B=s.scan();switch(s.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:V||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(B){case 12:case 13:V?M(10):z();break;case 16:M(1);break;case 15:case 14:break;default:return B}}}function M(B,J=[],Q=[]){if(H(B),J.length+Q.length>0){let ie=s.getToken();for(;ie!==17;){if(J.indexOf(ie)!==-1){x();break}else if(Q.indexOf(ie)!==-1)break;ie=x()}}}function $(B){const J=s.getTokenValue();return B?O(J):f(J),x(),!0}function q(){switch(s.getToken()){case 11:let B=0;try{B=JSON.parse(s.getTokenValue()),typeof B!="number"&&(M(2),B=0)}catch(J){M(2)}O(B);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return x(),!0}function F(){return s.getToken()!==10?(M(3,[],[2,5]),!1):($(!1),s.getToken()===6?(_(":"),x(),G()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function W(){l(),x();let B=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(B||M(4,[],[]),_(","),x(),s.getToken()===2&&U)break}else B&&M(6,[],[]);F()||M(4,[],[2,5]),B=!0}return S(),s.getToken()!==2?M(7,[2],[]):x(),!0}function N(){d(),x();let B=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(B||M(4,[],[]),_(","),x(),s.getToken()===4&&U)break}else B&&M(6,[],[]);G()||M(4,[],[4,5]),B=!0}return T(),s.getToken()!==4?M(8,[4],[]):x(),!0}function G(){switch(s.getToken()){case 3:return N();case 1:return W();case 10:return $(!0);default:return q()}}return x(),s.getToken()===17?i.allowEmptyContent?!0:(M(4,[],[]),!1):G()?(s.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=p;function o(t,r){let i=A(t),s=[],h,c=0,l;do switch(l=i.getPosition(),h=i.scan(),h){case 12:case 13:case 17:c!==l&&s.push(t.substring(c,l)),r!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,r)),c=i.getPosition();break}while(h!==17);return s.join("")}e.stripComments=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(Z[47],ee([0,1,33]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(E,v,n){let y,m,g,u,C;if(v){for(u=v.offset,C=u+v.length,g=u;g>0&&!D(E,g-1);)g--;let c=C;for(;c<E.length&&!D(E,c);)c++;m=E.substring(g,c),y=k(m,n)}else m=E,y=0,g=0,u=0,C=E.length;const P=A(n,E);let b=!1,R=0,p;n.insertSpaces?p=L(" ",n.tabSize||4):p="	";const o=(0,w.createScanner)(m,!1);let a=!1;function t(){return P+L(p,y+R)}function r(){let c=o.scan();for(b=!1;c===15||c===14;)b=b||c===14,c=o.scan();return a=c===16||o.getTokenError()!==0,c}const i=[];function s(c,l,f){!a&&l<C&&f>u&&E.substring(l,f)!==c&&i.push({offset:l,length:f-l,content:c})}let h=r();if(h!==17){const c=o.getTokenOffset()+g,l=L(p,y);s(l,g,c)}for(;h!==17;){let c=o.getTokenOffset()+o.getTokenLength()+g,l=r(),f="";for(;!b&&(l===12||l===13);){const d=o.getTokenOffset()+g;s(" ",c,d),c=o.getTokenOffset()+o.getTokenLength()+g,f=l===12?t():"",l=r()}if(l===2)h!==1&&(R--,f=t());else if(l===4)h!==3&&(R--,f=t());else{switch(h){case 3:case 1:R++,f=t();break;case 5:case 12:f=t();break;case 13:b?f=t():f=" ";break;case 6:f=" ";break;case 10:if(l===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?f=" ":l!==5&&l!==17&&(a=!0);break;case 16:a=!0;break}b&&(l===12||l===13)&&(f=t())}const S=o.getTokenOffset()+g;s(f,c,S),h=l}return i}e.format=I;function L(E,v){let n="";for(let y=0;y<v;y++)n+=E;return n}function k(E,v){let n=0,y=0;const m=v.tabSize||4;for(;n<E.length;){const g=E.charAt(n);if(g===" ")y++;else if(g==="	")y+=m;else break;n++}return Math.floor(y/m)}function A(E,v){for(let n=0;n<v.length;n++){const y=v.charAt(n);if(y==="\r")return n+1<v.length&&v.charAt(n+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=A;function D(E,v){return`\r
`.indexOf(E.charAt(v))!==-1}e.isEOL=D}),define(Z[42],ee([0,1,33,47]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(v,n,y){return k(v,n,void 0,y)}e.removeProperty=L;function k(v,n,y,m,g){const u=n.slice(),C=[],P=(0,w.parseTree)(v,C);let b,R;for(;u.length>0&&(R=u.pop(),b=(0,w.findNodeAtLocation)(P,u),b===void 0&&y!==void 0);)typeof R=="string"?y={[R]:y}:y=[y];if(b)if(b.type==="object"&&typeof R=="string"&&Array.isArray(b.children)){const p=(0,w.findNodeAtLocation)(b,[R]);if(p!==void 0)if(y===void 0){if(!p.parent)throw new Error("Malformed AST");const o=b.children.indexOf(p.parent);let a,t=p.parent.offset+p.parent.length;if(o>0){const r=b.children[o-1];a=r.offset+r.length}else a=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return A(v,{offset:a,length:t-a,content:""},m)}else return A(v,{offset:p.offset,length:p.length,content:JSON.stringify(y)},m);else{if(y===void 0)return[];const o=`${JSON.stringify(R)}: ${JSON.stringify(y)}`,a=g?g(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(a>0){const r=b.children[a-1];t={offset:r.offset+r.length,length:0,content:","+o}}else b.children.length===0?t={offset:b.offset+1,length:0,content:o}:t={offset:b.offset+1,length:0,content:o+","};return A(v,t,m)}}else if(b.type==="array"&&typeof R=="number"&&Array.isArray(b.children))if(y!==void 0){const p=`${JSON.stringify(y)}`;let o;if(b.children.length===0||R===0)o={offset:b.offset+1,length:0,content:b.children.length===0?p:p+","};else{const a=R===-1||R>b.children.length?b.children.length:R,t=b.children[a-1];o={offset:t.offset+t.length,length:0,content:","+p}}return A(v,o,m)}else{const p=R,o=b.children[p];let a;if(b.children.length===1)a={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===p){const t=b.children[p-1],r=t.offset+t.length,i=b.offset+b.length;a={offset:r,length:i-2-r,content:""}}else a={offset:o.offset,length:b.children[p+1].offset-o.offset,content:""};return A(v,a,m)}else throw new Error(`Can not add ${typeof R!="number"?"index":"property"} to parent of type ${b.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return A(v,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(y)},m)}}e.setProperty=k;function A(v,n,y){let m=D(v,n),g=n.offset,u=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;g>0&&!(0,I.isEOL)(m,g-1);)g--;for(;u<m.length&&!(0,I.isEOL)(m,u);)u++}const C=(0,I.format)(m,{offset:g,length:u-g},y);for(let b=C.length-1;b>=0;b--){const R=C[b];m=D(m,R),g=Math.min(g,R.offset),u=Math.max(u,R.offset+R.length),u+=R.content.length-R.length}const P=v.length-(m.length-u)-g;return[{offset:g,length:P,content:m.substring(g,u)}]}e.withFormatting=A;function D(v,n){return v.substring(0,n.offset)+n.content+v.substring(n.offset+n.length)}e.applyEdit=D;function E(v,n){let y=n.slice(0).sort((g,u)=>{const C=g.offset-u.offset;return C===0?g.length-u.length:C}),m=v.length;for(let g=y.length-1;g>=0;g--){let u=y[g];if(u.offset+u.length<=m)v=D(v,u);else throw new Error("Overlapping edit");m=u.offset}return v}e.applyEdits=E}),define(Z[2],ee([0,1,65,55]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let k=null;function A(i){k=i}if(e.setDisposableTracker=A,L){const i="__is_disposable_tracked__";A(new class{trackDisposable(s){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[i]||console.log(h)},3e3)}setParent(s,h){if(s&&s!==R.None)try{s[i]=!0}catch{}}markAsDisposed(s){if(s&&s!==R.None)try{s[i]=!0}catch{}}markAsSingleton(s){}})}function D(i){return k?.trackDisposable(i),i}function E(i){k?.markAsDisposed(i)}function v(i,s){k?.setParent(i,s)}function n(i,s){if(!!k)for(const h of i)k.setParent(h,s)}function y(i){return k?.markAsSingleton(i),i}e.markAsSingleton=y;class m extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=m;function g(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=g;function u(i){if(I.Iterable.is(i)){let s=[];for(const h of i)if(h)try{h.dispose()}catch(c){s.push(c)}if(s.length===1)throw s[0];if(s.length>1)throw new m(s);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=u;function C(...i){const s=P(()=>u(i));return n(i,s),s}e.combinedDisposable=C;function P(i){const s=D({dispose:(0,w.once)(()=>{E(s),i()})});return s}e.toDisposable=P;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return v(s,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class R{constructor(){this._store=new b,D(this),v(this._store,this)}dispose(){E(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=R,R.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&v(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&v(s,null),s}}e.MutableDisposable=p;class o{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class a{constructor(){this.references=new Map}acquire(s,...h){let c=this.references.get(s);c||(c={counter:0,object:this.createReferencedObject(s,...h)},this.references.set(s,c));const{object:l}=c,f=(0,w.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(s,c.object),this.references.delete(s))});return c.counter++,{object:l,dispose:f}}}e.ReferenceCollection=a;class t{constructor(s){this.referenceCollection=s}async acquire(s,...h){const c=this.referenceCollection.acquire(s,...h);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(l){throw c.dispose(),l}}}e.AsyncReferenceCollection=t;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r}),define(Z[91],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(k){this.element=k,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class I{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let k=this._first;for(;k!==w.Undefined;){const A=k.next;k.prev=w.Undefined,k.next=w.Undefined,k=A}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,A){const D=new w(k);if(this._first===w.Undefined)this._first=D,this._last=D;else if(A){const v=this._last;this._last=D,D.prev=v,v.next=D}else{const v=this._first;this._first=D,D.next=v,v.prev=D}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(D))}}shift(){if(this._first!==w.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==w.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==w.Undefined&&k.next!==w.Undefined){const A=k.prev;A.next=k.next,k.next.prev=A}else k.prev===w.Undefined&&k.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):k.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):k.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==w.Undefined;)yield k.element,k=k.next}}e.LinkedList=I}),function(){function K(L){const k=[];typeof L=="number"&&k.push("code/timeOrigin",L);function A(E){k.push(E,Date.now())}function D(){const E=[];for(let v=0;v<k.length;v+=2)E.push({name:k[v],startTime:k[v+1]});return E}return{mark:A,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(L+A.startTime)});return k}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function w(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=w(I))}(),define(Z[4],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const w="en";let I=!1,L=!1,k=!1,A=!1,D=!1,E=!1,v=!1,n,y=w,m,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const C=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=C&&u?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=u?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!C)g=navigator.userAgent,I=g.indexOf("Windows")>=0,L=g.indexOf("Macintosh")>=0,v=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=g.indexOf("Linux")>=0,E=!0,n=navigator.language,y=n;else if(typeof u=="object"){I=u.platform==="win32",L=u.platform==="darwin",k=u.platform==="linux",A=k&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,n=w,y=w;const i=u.env.VSCODE_NLS_CONFIG;if(i)try{const s=JSON.parse(i),h=s.availableLanguages["*"];n=s.locale,y=h||w,m=s._translationsConfigFile}catch(s){}D=!0}else console.error("Unable to resolve platform.");var P;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function b(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let R=0;L?R=1:I?R=3:k&&(R=2),e.isWindows=I,e.isMacintosh=L,e.isLinux=k,e.isLinuxSnap=A,e.isNative=D,e.isWeb=E,e.isIOS=v,e.platform=R,e.userAgent=g,e.language=y;var p;(function(i){function s(){return e.language}i.value=s;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=h;function c(){return e.language==="en"}i.isDefault=c})(p=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeSetImmediateId)for(let f=0,S=h.length;f<S;f++){const d=h[f];if(d.id===l.data.vscodeSetImmediateId){h.splice(f,1),d.callback();return}}});let c=0;return l=>{const f=++c;h.push({id:f,callback:l}),e.globals.postMessage({vscodeSetImmediateId:f},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const s=Promise.resolve();return h=>s.then(h)}();var o;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||v?2:I?1:3;let a=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,a=new Uint16Array(i.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=r}),define(Z[35],ee([0,1,4]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof w.globals.vscode!="undefined"&&typeof w.globals.vscode.process!="undefined"){const L=w.globals.vscode.process;I={get platform(){return L.platform},get env(){return L.env},cwd(){return L.cwd()},nextTick(k){return(0,w.setImmediate)(k)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(L){return process.nextTick(L)}}:I={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},nextTick(L){return(0,w.setImmediate)(L)},get env(){return{}},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(Z[8],ee([0,1,35]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,L=97,k=90,A=122,D=46,E=47,v=92,n=58,y=63;class m extends Error{constructor(o,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const i=o.indexOf(".")!==-1?"property":"argument";let s=`The "${o}" ${i} ${r} of type ${a}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function g(p,o){if(typeof p!="string")throw new m(o,"string",p)}function u(p){return p===E||p===v}function C(p){return p===E}function P(p){return p>=I&&p<=k||p>=L&&p<=A}function b(p,o,a,t){let r="",i=0,s=-1,h=0,c=0;for(let l=0;l<=p.length;++l){if(l<p.length)c=p.charCodeAt(l);else{if(t(c))break;c=E}if(t(c)){if(!(s===l-1||h===1))if(h===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==D||r.charCodeAt(r.length-2)!==D){if(r.length>2){const f=r.lastIndexOf(a);f===-1?(r="",i=0):(r=r.slice(0,f),i=r.length-1-r.lastIndexOf(a)),s=l,h=0;continue}else if(r.length!==0){r="",i=0,s=l,h=0;continue}}o&&(r+=r.length>0?`${a}..`:"..",i=2)}else r.length>0?r+=`${a}${p.slice(s+1,l)}`:r=p.slice(s+1,l),i=l-s-1;s=l,h=0}else c===D&&h!==-1?++h:h=-1}return r}function R(p,o){if(o===null||typeof o!="object")throw new m("pathObject","Object",o);const a=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return a?a===o.root?`${a}${t}`:`${a}${p}${t}`:t}e.win32={resolve(...p){let o="",a="",t=!1;for(let r=p.length-1;r>=-1;r--){let i;if(r>=0){if(i=p[r],g(i,"path"),i.length===0)continue}else o.length===0?i=w.cwd():(i=w.env[`=${o}`]||w.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==o.toLowerCase()&&i.charCodeAt(2)===v)&&(i=`${o}\\`));const s=i.length;let h=0,c="",l=!1;const f=i.charCodeAt(0);if(s===1)u(f)&&(h=1,l=!0);else if(u(f))if(l=!0,u(i.charCodeAt(1))){let S=2,d=S;for(;S<s&&!u(i.charCodeAt(S));)S++;if(S<s&&S!==d){const T=i.slice(d,S);for(d=S;S<s&&u(i.charCodeAt(S));)S++;if(S<s&&S!==d){for(d=S;S<s&&!u(i.charCodeAt(S));)S++;(S===s||S!==d)&&(c=`\\\\${T}\\${i.slice(d,S)}`,h=S)}}}else h=1;else P(f)&&i.charCodeAt(1)===n&&(c=i.slice(0,2),h=2,s>2&&u(i.charCodeAt(2))&&(l=!0,h=3));if(c.length>0)if(o.length>0){if(c.toLowerCase()!==o.toLowerCase())continue}else o=c;if(t){if(o.length>0)break}else if(a=`${i.slice(h)}\\${a}`,t=l,l&&o.length>0)break}return a=b(a,!t,"\\",u),t?`${o}\\${a}`:`${o}${a}`||"."},normalize(p){g(p,"path");const o=p.length;if(o===0)return".";let a=0,t,r=!1;const i=p.charCodeAt(0);if(o===1)return C(i)?"\\":p;if(u(i))if(r=!0,u(p.charCodeAt(1))){let h=2,c=h;for(;h<o&&!u(p.charCodeAt(h));)h++;if(h<o&&h!==c){const l=p.slice(c,h);for(c=h;h<o&&u(p.charCodeAt(h));)h++;if(h<o&&h!==c){for(c=h;h<o&&!u(p.charCodeAt(h));)h++;if(h===o)return`\\\\${l}\\${p.slice(c)}\\`;h!==c&&(t=`\\\\${l}\\${p.slice(c,h)}`,a=h)}}}else a=1;else P(i)&&p.charCodeAt(1)===n&&(t=p.slice(0,2),a=2,o>2&&u(p.charCodeAt(2))&&(r=!0,a=3));let s=a<o?b(p.slice(a),!r,"\\",u):"";return s.length===0&&!r&&(s="."),s.length>0&&u(p.charCodeAt(o-1))&&(s+="\\"),t===void 0?r?`\\${s}`:s:r?`${t}\\${s}`:`${t}${s}`},isAbsolute(p){g(p,"path");const o=p.length;if(o===0)return!1;const a=p.charCodeAt(0);return u(a)||o>2&&P(a)&&p.charCodeAt(1)===n&&u(p.charCodeAt(2))},join(...p){if(p.length===0)return".";let o,a;for(let i=0;i<p.length;++i){const s=p[i];g(s,"path"),s.length>0&&(o===void 0?o=a=s:o+=`\\${s}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&u(a.charCodeAt(0))){++r;const i=a.length;i>1&&u(a.charCodeAt(1))&&(++r,i>2&&(u(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&u(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(p,o){if(g(p,"from"),g(o,"to"),p===o)return"";const a=e.win32.resolve(p),t=e.win32.resolve(o);if(a===t||(p=a.toLowerCase(),o=t.toLowerCase(),p===o))return"";let r=0;for(;r<p.length&&p.charCodeAt(r)===v;)r++;let i=p.length;for(;i-1>r&&p.charCodeAt(i-1)===v;)i--;const s=i-r;let h=0;for(;h<o.length&&o.charCodeAt(h)===v;)h++;let c=o.length;for(;c-1>h&&o.charCodeAt(c-1)===v;)c--;const l=c-h,f=s<l?s:l;let S=-1,d=0;for(;d<f;d++){const O=p.charCodeAt(r+d);if(O!==o.charCodeAt(h+d))break;O===v&&(S=d)}if(d!==f){if(S===-1)return t}else{if(l>f){if(o.charCodeAt(h+d)===v)return t.slice(h+d+1);if(d===2)return t.slice(h+d)}s>f&&(p.charCodeAt(r+d)===v?S=d:d===2&&(S=3)),S===-1&&(S=0)}let T="";for(d=r+S+1;d<=i;++d)(d===i||p.charCodeAt(d)===v)&&(T+=T.length===0?"..":"\\..");return h+=S,T.length>0?`${T}${t.slice(h,c)}`:(t.charCodeAt(h)===v&&++h,t.slice(h,c))},toNamespacedPath(p){if(typeof p!="string")return p;if(p.length===0)return"";const o=e.win32.resolve(p);if(o.length<=2)return p;if(o.charCodeAt(0)===v){if(o.charCodeAt(1)===v){const a=o.charCodeAt(2);if(a!==y&&a!==D)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(P(o.charCodeAt(0))&&o.charCodeAt(1)===n&&o.charCodeAt(2)===v)return`\\\\?\\${o}`;return p},dirname(p){g(p,"path");const o=p.length;if(o===0)return".";let a=-1,t=0;const r=p.charCodeAt(0);if(o===1)return u(r)?p:".";if(u(r)){if(a=t=1,u(p.charCodeAt(1))){let h=2,c=h;for(;h<o&&!u(p.charCodeAt(h));)h++;if(h<o&&h!==c){for(c=h;h<o&&u(p.charCodeAt(h));)h++;if(h<o&&h!==c){for(c=h;h<o&&!u(p.charCodeAt(h));)h++;if(h===o)return p;h!==c&&(a=t=h+1)}}}}else P(r)&&p.charCodeAt(1)===n&&(a=o>2&&u(p.charCodeAt(2))?3:2,t=a);let i=-1,s=!0;for(let h=o-1;h>=t;--h)if(u(p.charCodeAt(h))){if(!s){i=h;break}}else s=!1;if(i===-1){if(a===-1)return".";i=a}return p.slice(0,i)},basename(p,o){o!==void 0&&g(o,"ext"),g(p,"path");let a=0,t=-1,r=!0,i;if(p.length>=2&&P(p.charCodeAt(0))&&p.charCodeAt(1)===n&&(a=2),o!==void 0&&o.length>0&&o.length<=p.length){if(o===p)return"";let s=o.length-1,h=-1;for(i=p.length-1;i>=a;--i){const c=p.charCodeAt(i);if(u(c)){if(!r){a=i+1;break}}else h===-1&&(r=!1,h=i+1),s>=0&&(c===o.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=h))}return a===t?t=h:t===-1&&(t=p.length),p.slice(a,t)}for(i=p.length-1;i>=a;--i)if(u(p.charCodeAt(i))){if(!r){a=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":p.slice(a,t)},extname(p){g(p,"path");let o=0,a=-1,t=0,r=-1,i=!0,s=0;p.length>=2&&p.charCodeAt(1)===n&&P(p.charCodeAt(0))&&(o=t=2);for(let h=p.length-1;h>=o;--h){const c=p.charCodeAt(h);if(u(c)){if(!i){t=h+1;break}continue}r===-1&&(i=!1,r=h+1),c===D?a===-1?a=h:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||r===-1||s===0||s===1&&a===r-1&&a===t+1?"":p.slice(a,r)},format:R.bind(null,"\\"),parse(p){g(p,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return o;const a=p.length;let t=0,r=p.charCodeAt(0);if(a===1)return u(r)?(o.root=o.dir=p,o):(o.base=o.name=p,o);if(u(r)){if(t=1,u(p.charCodeAt(1))){let S=2,d=S;for(;S<a&&!u(p.charCodeAt(S));)S++;if(S<a&&S!==d){for(d=S;S<a&&u(p.charCodeAt(S));)S++;if(S<a&&S!==d){for(d=S;S<a&&!u(p.charCodeAt(S));)S++;S===a?t=S:S!==d&&(t=S+1)}}}}else if(P(r)&&p.charCodeAt(1)===n){if(a<=2)return o.root=o.dir=p,o;if(t=2,u(p.charCodeAt(2))){if(a===3)return o.root=o.dir=p,o;t=3}}t>0&&(o.root=p.slice(0,t));let i=-1,s=t,h=-1,c=!0,l=p.length-1,f=0;for(;l>=t;--l){if(r=p.charCodeAt(l),u(r)){if(!c){s=l+1;break}continue}h===-1&&(c=!1,h=l+1),r===D?i===-1?i=l:f!==1&&(f=1):i!==-1&&(f=-1)}return h!==-1&&(i===-1||f===0||f===1&&i===h-1&&i===s+1?o.base=o.name=p.slice(s,h):(o.name=p.slice(s,i),o.base=p.slice(s,h),o.ext=p.slice(i,h))),s>0&&s!==t?o.dir=p.slice(0,s-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...p){let o="",a=!1;for(let t=p.length-1;t>=-1&&!a;t--){const r=t>=0?p[t]:w.cwd();g(r,"path"),r.length!==0&&(o=`${r}/${o}`,a=r.charCodeAt(0)===E)}return o=b(o,!a,"/",C),a?`/${o}`:o.length>0?o:"."},normalize(p){if(g(p,"path"),p.length===0)return".";const o=p.charCodeAt(0)===E,a=p.charCodeAt(p.length-1)===E;return p=b(p,!o,"/",C),p.length===0?o?"/":a?"./":".":(a&&(p+="/"),o?`/${p}`:p)},isAbsolute(p){return g(p,"path"),p.length>0&&p.charCodeAt(0)===E},join(...p){if(p.length===0)return".";let o;for(let a=0;a<p.length;++a){const t=p[a];g(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(p,o){if(g(p,"from"),g(o,"to"),p===o||(p=e.posix.resolve(p),o=e.posix.resolve(o),p===o))return"";const a=1,t=p.length,r=t-a,i=1,s=o.length-i,h=r<s?r:s;let c=-1,l=0;for(;l<h;l++){const S=p.charCodeAt(a+l);if(S!==o.charCodeAt(i+l))break;S===E&&(c=l)}if(l===h)if(s>h){if(o.charCodeAt(i+l)===E)return o.slice(i+l+1);if(l===0)return o.slice(i+l)}else r>h&&(p.charCodeAt(a+l)===E?c=l:l===0&&(c=0));let f="";for(l=a+c+1;l<=t;++l)(l===t||p.charCodeAt(l)===E)&&(f+=f.length===0?"..":"/..");return`${f}${o.slice(i+c)}`},toNamespacedPath(p){return p},dirname(p){if(g(p,"path"),p.length===0)return".";const o=p.charCodeAt(0)===E;let a=-1,t=!0;for(let r=p.length-1;r>=1;--r)if(p.charCodeAt(r)===E){if(!t){a=r;break}}else t=!1;return a===-1?o?"/":".":o&&a===1?"//":p.slice(0,a)},basename(p,o){o!==void 0&&g(o,"ext"),g(p,"path");let a=0,t=-1,r=!0,i;if(o!==void 0&&o.length>0&&o.length<=p.length){if(o===p)return"";let s=o.length-1,h=-1;for(i=p.length-1;i>=0;--i){const c=p.charCodeAt(i);if(c===E){if(!r){a=i+1;break}}else h===-1&&(r=!1,h=i+1),s>=0&&(c===o.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=h))}return a===t?t=h:t===-1&&(t=p.length),p.slice(a,t)}for(i=p.length-1;i>=0;--i)if(p.charCodeAt(i)===E){if(!r){a=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":p.slice(a,t)},extname(p){g(p,"path");let o=-1,a=0,t=-1,r=!0,i=0;for(let s=p.length-1;s>=0;--s){const h=p.charCodeAt(s);if(h===E){if(!r){a=s+1;break}continue}t===-1&&(r=!1,t=s+1),h===D?o===-1?o=s:i!==1&&(i=1):o!==-1&&(i=-1)}return o===-1||t===-1||i===0||i===1&&o===t-1&&o===a+1?"":p.slice(o,t)},format:R.bind(null,"/"),parse(p){g(p,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return o;const a=p.charCodeAt(0)===E;let t;a?(o.root="/",t=1):t=0;let r=-1,i=0,s=-1,h=!0,c=p.length-1,l=0;for(;c>=t;--c){const f=p.charCodeAt(c);if(f===E){if(!h){i=c+1;break}continue}s===-1&&(h=!1,s=c+1),f===D?r===-1?r=c:l!==1&&(l=1):r!==-1&&(l=-1)}if(s!==-1){const f=i===0&&a?1:i;r===-1||l===0||l===1&&r===s-1&&r===i+1?o.base=o.name=p.slice(f,s):(o.name=p.slice(f,r),o.base=p.slice(f,s),o.ext=p.slice(r,s))}return i>0?o.dir=p.slice(0,i-1):a&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var I in w)(typeof exports=="object"?exports:K)[I]=w[I]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function w(I){if(e[I])return e[I].exports;var L=e[I]={i:I,l:!1,exports:{}};return K[I].call(L.exports,L,L.exports,w),L.l=!0,L.exports}return w.m=K,w.c=e,w.d=function(I,L,k){w.o(I,L)||Object.defineProperty(I,L,{enumerable:!0,get:k})},w.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},w.t=function(I,L){if(1&L&&(I=w(I)),8&L||4&L&&typeof I=="object"&&I&&I.__esModule)return I;var k=Object.create(null);if(w.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:I}),2&L&&typeof I!="string")for(var A in I)w.d(k,A,function(D){return I[D]}.bind(null,A));return k},w.n=function(I){var L=I&&I.__esModule?function(){return I.default}:function(){return I};return w.d(L,"a",L),L},w.o=function(I,L){return Object.prototype.hasOwnProperty.call(I,L)},w.p="",w(w.s=0)}([function(K,e,w){(function(I){var L;e=K.exports=Q,L=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],E=e.src=[],v=0,n=v++;E[n]="0|[1-9]\\d*";var y=v++;E[y]="[0-9]+";var m=v++;E[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=v++;E[g]="("+E[n]+")\\.("+E[n]+")\\.("+E[n]+")";var u=v++;E[u]="("+E[y]+")\\.("+E[y]+")\\.("+E[y]+")";var C=v++;E[C]="(?:"+E[n]+"|"+E[m]+")";var P=v++;E[P]="(?:"+E[y]+"|"+E[m]+")";var b=v++;E[b]="(?:-("+E[C]+"(?:\\."+E[C]+")*))";var R=v++;E[R]="(?:-?("+E[P]+"(?:\\."+E[P]+")*))";var p=v++;E[p]="[0-9A-Za-z-]+";var o=v++;E[o]="(?:\\+("+E[p]+"(?:\\."+E[p]+")*))";var a=v++,t="v?"+E[g]+E[b]+"?"+E[o]+"?";E[a]="^"+t+"$";var r="[v=\\s]*"+E[u]+E[R]+"?"+E[o]+"?",i=v++;E[i]="^"+r+"$";var s=v++;E[s]="((?:<|>)?=?)";var h=v++;E[h]=E[y]+"|x|X|\\*";var c=v++;E[c]=E[n]+"|x|X|\\*";var l=v++;E[l]="[v=\\s]*("+E[c]+")(?:\\.("+E[c]+")(?:\\.("+E[c]+")(?:"+E[b]+")?"+E[o]+"?)?)?";var f=v++;E[f]="[v=\\s]*("+E[h]+")(?:\\.("+E[h]+")(?:\\.("+E[h]+")(?:"+E[R]+")?"+E[o]+"?)?)?";var S=v++;E[S]="^"+E[s]+"\\s*"+E[l]+"$";var d=v++;E[d]="^"+E[s]+"\\s*"+E[f]+"$";var T=v++;E[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=v++;E[O]="(?:~>?)";var _=v++;E[_]="(\\s*)"+E[O]+"\\s+",D[_]=new RegExp(E[_],"g");var z=v++;E[z]="^"+E[O]+E[l]+"$";var H=v++;E[H]="^"+E[O]+E[f]+"$";var V=v++;E[V]="(?:\\^)";var U=v++;E[U]="(\\s*)"+E[V]+"\\s+",D[U]=new RegExp(E[U],"g");var x=v++;E[x]="^"+E[V]+E[l]+"$";var M=v++;E[M]="^"+E[V]+E[f]+"$";var $=v++;E[$]="^"+E[s]+"\\s*("+r+")$|^$";var q=v++;E[q]="^"+E[s]+"\\s*("+t+")$|^$";var F=v++;E[F]="(\\s*)"+E[s]+"\\s*("+r+"|"+E[l]+")",D[F]=new RegExp(E[F],"g");var W=v++;E[W]="^\\s*("+E[l]+")\\s+-\\s+("+E[l]+")\\s*$";var N=v++;E[N]="^\\s*("+E[f]+")\\s+-\\s+("+E[f]+")\\s*$";var G=v++;E[G]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)L(B,E[B]),D[B]||(D[B]=new RegExp(E[B]));function J(X,re){if(X instanceof Q)return X;if(typeof X!="string"||X.length>k||!(re?D[i]:D[a]).test(X))return null;try{return new Q(X,re)}catch(se){return null}}function Q(X,re){if(X instanceof Q){if(X.loose===re)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof Q))return new Q(X,re);L("SemVer",X,re),this.loose=re;var se=X.trim().match(re?D[i]:D[a]);if(!se)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var pe=+ye;if(pe>=0&&pe<A)return pe}return ye}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=J,e.valid=function(X,re){var se=J(X,re);return se?se.version:null},e.clean=function(X,re){var se=J(X.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(X){return L("SemVer.compare",this.version,this.loose,X),X instanceof Q||(X=new Q(X,this.loose)),this.compareMain(X)||this.comparePre(X)},Q.prototype.compareMain=function(X){return X instanceof Q||(X=new Q(X,this.loose)),ne(this.major,X.major)||ne(this.minor,X.minor)||ne(this.patch,X.patch)},Q.prototype.comparePre=function(X){if(X instanceof Q||(X=new Q(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],ye=X.prerelease[re];if(L("prerelease compare",re,se,ye),se===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(se===void 0)return-1;if(se!==ye)return ne(se,ye)}while(++re)},Q.prototype.inc=function(X,re){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,re,se,ye){typeof se=="string"&&(ye=se,se=void 0);try{return new Q(X,se).inc(re,ye).version}catch(pe){return null}},e.diff=function(X,re){if(Se(X,re))return null;var se=J(X),ye=J(re);if(se.prerelease.length||ye.prerelease.length){for(var pe in se)if((pe==="major"||pe==="minor"||pe==="patch")&&se[pe]!==ye[pe])return"pre"+pe;return"prerelease"}for(var pe in se)if((pe==="major"||pe==="minor"||pe==="patch")&&se[pe]!==ye[pe])return pe},e.compareIdentifiers=ne;var ie=/^[0-9]+$/;function ne(X,re){var se=ie.test(X),ye=ie.test(re);return se&&ye&&(X=+X,re=+re),se&&!ye?-1:ye&&!se?1:X<re?-1:X>re?1:0}function le(X,re,se){return new Q(X,se).compare(new Q(re,se))}function fe(X,re,se){return le(X,re,se)>0}function me(X,re,se){return le(X,re,se)<0}function Se(X,re,se){return le(X,re,se)===0}function Pe(X,re,se){return le(X,re,se)!==0}function ke(X,re,se){return le(X,re,se)>=0}function Ne(X,re,se){return le(X,re,se)<=0}function Oe(X,re,se,ye){var pe;switch(re){case"===":typeof X=="object"&&(X=X.version),typeof se=="object"&&(se=se.version),pe=X===se;break;case"!==":typeof X=="object"&&(X=X.version),typeof se=="object"&&(se=se.version),pe=X!==se;break;case"":case"=":case"==":pe=Se(X,se,ye);break;case"!=":pe=Pe(X,se,ye);break;case">":pe=fe(X,se,ye);break;case">=":pe=ke(X,se,ye);break;case"<":pe=me(X,se,ye);break;case"<=":pe=Ne(X,se,ye);break;default:throw new TypeError("Invalid operator: "+re)}return pe}function Le(X,re){if(X instanceof Le){if(X.loose===re)return X;X=X.value}if(!(this instanceof Le))return new Le(X,re);L("comparator",X,re),this.loose=re,this.parse(X),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(X,re){return ne(re,X)},e.major=function(X,re){return new Q(X,re).major},e.minor=function(X,re){return new Q(X,re).minor},e.patch=function(X,re){return new Q(X,re).patch},e.compare=le,e.compareLoose=function(X,re){return le(X,re,!0)},e.rcompare=function(X,re,se){return le(re,X,se)},e.sort=function(X,re){return X.sort(function(se,ye){return e.compare(se,ye,re)})},e.rsort=function(X,re){return X.sort(function(se,ye){return e.rcompare(se,ye,re)})},e.gt=fe,e.lt=me,e.eq=Se,e.neq=Pe,e.gte=ke,e.lte=Ne,e.cmp=Oe,e.Comparator=Le;var _e={};function be(X,re){if(X instanceof be)return X.loose===re?X:new be(X.raw,re);if(X instanceof Le)return new be(X.value,re);if(!(this instanceof be))return new be(X,re);if(this.loose=re,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Ae(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ye(X,re,se,ye,pe,De,we,Te,Ce,Re,Ue,j,te){return((re=Ae(se)?"":Ae(ye)?">="+se+".0.0":Ae(pe)?">="+se+"."+ye+".0":">="+re)+" "+(Te=Ae(Ce)?"":Ae(Re)?"<"+(+Ce+1)+".0.0":Ae(Ue)?"<"+Ce+"."+(+Re+1)+".0":j?"<="+Ce+"."+Re+"."+Ue+"-"+j:"<="+Te)).trim()}function Je(X,re){for(var se=0;se<X.length;se++)if(!X[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<X.length;se++)if(L(X[se].semver),X[se].semver!==_e&&X[se].semver.prerelease.length>0){var ye=X[se].semver;if(ye.major===re.major&&ye.minor===re.minor&&ye.patch===re.patch)return!0}return!1}return!0}function xe(X,re,se){try{re=new be(re,se)}catch(ye){return!1}return re.test(X)}function qe(X,re,se,ye){var pe,De,we,Te,Ce;switch(X=new Q(X,ye),re=new be(re,ye),se){case">":pe=fe,De=Ne,we=me,Te=">",Ce=">=";break;case"<":pe=me,De=ke,we=fe,Te="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(X,re,ye))return!1;for(var Re=0;Re<re.set.length;++Re){var Ue=re.set[Re],j=null,te=null;if(Ue.forEach(function(ae){ae.semver===_e&&(ae=new Le(">=0.0.0")),j=j||ae,te=te||ae,pe(ae.semver,j.semver,ye)?j=ae:we(ae.semver,te.semver,ye)&&(te=ae)}),j.operator===Te||j.operator===Ce||(!te.operator||te.operator===Te)&&De(X,te.semver)||te.operator===Ce&&we(X,te.semver))return!1}return!0}Le.prototype.parse=function(X){var re=this.loose?D[$]:D[q],se=X.match(re);if(!se)throw new TypeError("Invalid comparator: "+X);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new Q(se[2],this.loose):this.semver=_e},Le.prototype.toString=function(){return this.value},Le.prototype.test=function(X){return L("Comparator.test",X,this.loose),this.semver===_e||(typeof X=="string"&&(X=new Q(X,this.loose)),Oe(X,this.operator,this.semver,this.loose))},Le.prototype.intersects=function(X,re){if(!(X instanceof Le))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new be(X.value,re),xe(this.value,se,re);if(X.operator==="")return se=new be(this.value,re),xe(X.semver,se,re);var ye=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),De=this.semver.version===X.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Te=Oe(this.semver,"<",X.semver,re)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),Ce=Oe(this.semver,">",X.semver,re)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return ye||pe||De&&we||Te||Ce},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(X){var re=this.loose;X=X.trim(),L("range",X,re);var se=re?D[N]:D[W];X=X.replace(se,Ye),L("hyphen replace",X),X=X.replace(D[F],"$1$2$3"),L("comparator trim",X,D[F]),X=(X=(X=X.replace(D[_],"$1~")).replace(D[U],"$1^")).split(/\s+/).join(" ");var ye=re?D[$]:D[q],pe=X.split(" ").map(function(De){return function(we,Te){return L("comp",we),we=function(Ce,Re){return Ce.trim().split(/\s+/).map(function(Ue){return function(j,te){L("caret",j,te);var ae=te?D[M]:D[x];return j.replace(ae,function(ce,oe,he,ge,ve){var ue;return L("caret",j,ce,oe,he,ge,ve),Ae(oe)?ue="":Ae(he)?ue=">="+oe+".0.0 <"+(+oe+1)+".0.0":Ae(ge)?ue=oe==="0"?">="+oe+"."+he+".0 <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+".0 <"+(+oe+1)+".0.0":ve?(L("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ue=oe==="0"?he==="0"?">="+oe+"."+he+"."+ge+ve+" <"+oe+"."+he+"."+(+ge+1):">="+oe+"."+he+"."+ge+ve+" <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+"."+ge+ve+" <"+(+oe+1)+".0.0"):(L("no pr"),ue=oe==="0"?he==="0"?">="+oe+"."+he+"."+ge+" <"+oe+"."+he+"."+(+ge+1):">="+oe+"."+he+"."+ge+" <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+"."+ge+" <"+(+oe+1)+".0.0"),L("caret return",ue),ue})}(Ue,Re)}).join(" ")}(we,Te),L("caret",we),we=function(Ce,Re){return Ce.trim().split(/\s+/).map(function(Ue){return function(j,te){var ae=te?D[H]:D[z];return j.replace(ae,function(ce,oe,he,ge,ve){var ue;return L("tilde",j,ce,oe,he,ge,ve),Ae(oe)?ue="":Ae(he)?ue=">="+oe+".0.0 <"+(+oe+1)+".0.0":Ae(ge)?ue=">="+oe+"."+he+".0 <"+oe+"."+(+he+1)+".0":ve?(L("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ue=">="+oe+"."+he+"."+ge+ve+" <"+oe+"."+(+he+1)+".0"):ue=">="+oe+"."+he+"."+ge+" <"+oe+"."+(+he+1)+".0",L("tilde return",ue),ue})}(Ue,Re)}).join(" ")}(we,Te),L("tildes",we),we=function(Ce,Re){return L("replaceXRanges",Ce,Re),Ce.split(/\s+/).map(function(Ue){return function(j,te){j=j.trim();var ae=te?D[d]:D[S];return j.replace(ae,function(ce,oe,he,ge,ve,ue){L("xRange",j,ce,oe,he,ge,ve,ue);var Ee=Ae(he),Ie=Ee||Ae(ge),Fe=Ie||Ae(ve);return oe==="="&&Fe&&(oe=""),Ee?ce=oe===">"||oe==="<"?"<0.0.0":"*":oe&&Fe?(Ie&&(ge=0),Fe&&(ve=0),oe===">"?(oe=">=",Ie?(he=+he+1,ge=0,ve=0):Fe&&(ge=+ge+1,ve=0)):oe==="<="&&(oe="<",Ie?he=+he+1:ge=+ge+1),ce=oe+he+"."+ge+"."+ve):Ie?ce=">="+he+".0.0 <"+(+he+1)+".0.0":Fe&&(ce=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),L("xRange return",ce),ce})}(Ue,Re)}).join(" ")}(we,Te),L("xrange",we),we=function(Ce,Re){return L("replaceStars",Ce,Re),Ce.trim().replace(D[G],"")}(we,Te),L("stars",we),we}(De,re)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(De){return!!De.match(ye)})),pe=pe.map(function(De){return new Le(De,re)})},be.prototype.intersects=function(X,re){if(!(X instanceof be))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(ye){return X.set.some(function(pe){return pe.every(function(De){return ye.intersects(De,re)})})})})},e.toComparators=function(X,re){return new be(X,re).set.map(function(se){return se.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},be.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new Q(X,this.loose));for(var re=0;re<this.set.length;re++)if(Je(this.set[re],X))return!0;return!1},e.satisfies=xe,e.maxSatisfying=function(X,re,se){var ye=null,pe=null;try{var De=new be(re,se)}catch(we){return null}return X.forEach(function(we){De.test(we)&&(ye&&pe.compare(we)!==-1||(pe=new Q(ye=we,se)))}),ye},e.minSatisfying=function(X,re,se){var ye=null,pe=null;try{var De=new be(re,se)}catch(we){return null}return X.forEach(function(we){De.test(we)&&(ye&&pe.compare(we)!==1||(pe=new Q(ye=we,se)))}),ye},e.validRange=function(X,re){try{return new be(X,re).range||"*"}catch(se){return null}},e.ltr=function(X,re,se){return qe(X,re,"<",se)},e.gtr=function(X,re,se){return qe(X,re,">",se)},e.outside=qe,e.prerelease=function(X,re){var se=J(X,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(X,re,se){return X=new be(X,se),re=new be(re,se),X.intersects(re)},e.coerce=function(X){if(X instanceof Q)return X;if(typeof X!="string")return null;var re=X.match(D[T]);return re==null?null:J((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,w(1))},function(K,e){var w,I,L=K.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function D(P){if(w===setTimeout)return setTimeout(P,0);if((w===k||!w)&&setTimeout)return w=setTimeout,setTimeout(P,0);try{return w(P,0)}catch(b){try{return w.call(null,P,0)}catch(R){return w.call(this,P,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:k}catch(P){w=k}try{I=typeof clearTimeout=="function"?clearTimeout:A}catch(P){I=A}})();var E,v=[],n=!1,y=-1;function m(){n&&E&&(n=!1,E.length?v=E.concat(v):y=-1,v.length&&g())}function g(){if(!n){var P=D(m);n=!0;for(var b=v.length;b;){for(E=v,v=[];++y<b;)E&&E[y].run();y=-1,b=v.length}E=null,n=!1,function(R){if(I===clearTimeout)return clearTimeout(R);if((I===A||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(R);try{I(R)}catch(p){try{return I.call(null,R)}catch(o){return I.call(this,R)}}}(P)}}function u(P,b){this.fun=P,this.array=b}function C(){}L.nextTick=function(P){var b=new Array(arguments.length-1);if(arguments.length>1)for(var R=1;R<arguments.length;R++)b[R-1]=arguments[R];v.push(new u(P,b)),v.length!==1||n||D(g)},u.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=C,L.addListener=C,L.once=C,L.off=C,L.removeListener=C,L.removeAllListeners=C,L.emit=C,L.prependListener=C,L.prependOnceListener=C,L.listeners=function(P){return[]},L.binding=function(P){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(P){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(Z[92],ee([0,1,4]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=w.globals.performance&&typeof w.globals.performance.now=="function";class L{constructor(A){this._highResolution=I&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new L(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=L}),define(Z[3],ee([0,1,11,65,2,91,92]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(p){p.None=()=>L.Disposable.None;function o(V){return(U,x=null,M)=>{let $=!1,q;return q=V(F=>{if(!$)return q?q.dispose():$=!0,U.call(x,F)},null,M),$&&q.dispose(),q}}p.once=o;function a(V,U){return c((x,M=null,$)=>V(q=>x.call(M,U(q)),null,$))}p.map=a;function t(V,U){return c((x,M=null,$)=>V(q=>{U(q),x.call(M,q)},null,$))}p.forEach=t;function r(V,U){return c((x,M=null,$)=>V(q=>U(q)&&x.call(M,q),null,$))}p.filter=r;function i(V){return V}p.signal=i;function s(...V){return(U,x=null,M)=>(0,L.combinedDisposable)(...V.map($=>$(q=>U.call(x,q),null,M)))}p.any=s;function h(V,U,x){let M=x;return a(V,$=>(M=U(M,$),M))}p.reduce=h;function c(V){let U;const x=new m({onFirstListenerAdd(){U=V(x.fire,x)},onLastListenerRemove(){U.dispose()}});return x.event}function l(V,U,x=100,M=!1,$){let q,F,W,N=0;const G=new m({leakWarningThreshold:$,onFirstListenerAdd(){q=V(B=>{N++,F=U(F,B),M&&!W&&(G.fire(F),F=void 0),clearTimeout(W),W=setTimeout(()=>{const J=F;F=void 0,W=void 0,(!M||N>1)&&G.fire(J),N=0},x)})},onLastListenerRemove(){q.dispose()}});return G.event}p.debounce=l;function f(V,U=(x,M)=>x===M){let x=!0,M;return r(V,$=>{const q=x||!U($,M);return x=!1,M=$,q})}p.latch=f;function S(V,U){return[p.filter(V,U),p.filter(V,x=>!U(x))]}p.split=S;function d(V,U=!1,x=[]){let M=x.slice(),$=V(W=>{M?M.push(W):F.fire(W)});const q=()=>{M&&M.forEach(W=>F.fire(W)),M=null},F=new m({onFirstListenerAdd(){$||($=V(W=>F.fire(W)))},onFirstListenerDidAdd(){M&&(U?setTimeout(q):q())},onLastListenerRemove(){$&&$.dispose(),$=null}});return F.event}p.buffer=d;class T{constructor(U){this.event=U}map(U){return new T(a(this.event,U))}forEach(U){return new T(t(this.event,U))}filter(U){return new T(r(this.event,U))}reduce(U,x){return new T(h(this.event,U,x))}latch(){return new T(f(this.event))}debounce(U,x=100,M=!1,$){return new T(l(this.event,U,x,M,$))}on(U,x,M){return this.event(U,x,M)}once(U,x,M){return o(this.event)(U,x,M)}}function O(V){return new T(V)}p.chain=O;function _(V,U,x=M=>M){const M=(...W)=>F.fire(x(...W)),$=()=>V.on(U,M),q=()=>V.removeListener(U,M),F=new m({onFirstListenerAdd:$,onLastListenerRemove:q});return F.event}p.fromNodeEventEmitter=_;function z(V,U,x=M=>M){const M=(...W)=>F.fire(x(...W)),$=()=>V.addEventListener(U,M),q=()=>V.removeEventListener(U,M),F=new m({onFirstListenerAdd:$,onLastListenerRemove:q});return F.event}p.fromDOMEventEmitter=z;function H(V){return new Promise(U=>o(V)(U))}p.toPromise=H})(D=e.Event||(e.Event={}));class E{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${E._idPool++}`}start(o){this._stopWatch=new A.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let v=-1;function n(p){const o=v;return v=p,{dispose(){v=o}}}e.setGlobalLeakWarningThreshold=n;class y{constructor(o,a=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let a=v;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||o<a)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let i,s=0;for(const[h,c]of this._stacks)(!i||s<c)&&(i=h,s=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class m{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=v>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0}get event(){return this._event||(this._event=(o,a,t)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(a?[o,a]:o);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,a);const s=this._leakageMon?.check(this._listeners.size),h=(0,L.toDisposable)(()=>{s&&s(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof L.DisposableStore?t.add(h):Array.isArray(t)&&t.push(h),h}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(r){(0,w.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class g extends m{async fireAsync(o,a,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,o]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),s=[],h={...i,waitUntil:c=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");t&&(c=t(c,typeof r=="function"?r:r[0])),s.push(c)}};try{typeof r=="function"?r.call(void 0,h):r[0].call(r[1],h)}catch(c){(0,w.onUnexpectedError)(c);continue}Object.freeze(s),await Promise.allSettled(s).then(c=>{for(const l of c)l.status==="rejected"&&(0,w.onUnexpectedError)(l.reason)})}}}}e.AsyncEmitter=g;class u extends m{constructor(o){super(o);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=u;class C extends u{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=C;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const a={event:o,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const t=()=>{this.hasListeners&&this.unhook(a);const r=this.events.indexOf(a);this.events.splice(r,1)};return(0,L.toDisposable)((0,I.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(a=>this.emitter.fire(a))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class b{constructor(){this.buffers=[]}wrapEvent(o){return(a,t,r)=>o(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>a.call(t,i)):a.call(t,i)},void 0,r)}bufferEvents(o){const a=[];this.buffers.push(a);const t=o();return this.buffers.pop(),a.forEach(r=>r()),t}}e.EventBufferer=b;class R{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=L.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=R}),define(Z[29],ee([0,1,3]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(D,E){const v=setTimeout(D.bind(E),0);return{dispose(){clearTimeout(v)}}});var L;(function(D){function E(v){return v===D.None||v===D.Cancelled||v instanceof k?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}D.isCancellationToken=E,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(L=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=L.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=A}),define(Z[48],ee([0,1,3]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(y){const m=this._icons.get(y.id);m?y.description?m.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const L=new I;e.iconRegistry=L;function k(n,y){return new D(n,y)}e.registerCodicon=k;function A(n){return n?n.replace(/\$\((.*?)\)/g,(y,m)=>` ${m} `).trim():""}e.getCodiconAriaLabel=A;class D{constructor(y,m,g){this.id=y,this.definition=m,this.description=g,L.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function E(n,y){const m=["codicon","codicon-"+n];return y&&m.push("codicon-modifier-"+y),m}e.getClassNamesArray=E;var v;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const y=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function m(C){if(C instanceof D)return["codicon","codicon-"+C.id];const P=y.exec(C.id);if(!P)return m(D.error);let[,b,R]=P;const p=["codicon","codicon-"+b];return R&&p.push("codicon-modifier-"+R.substr(1)),p}n.asClassNameArray=m;function g(C){return m(C).join(" ")}n.asClassName=g;function u(C){return"."+m(C).join(".")}n.asCSSSelector=u})(v=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(Z[49],ee([0,1,11,2]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(p){const o=p;return o?[o.on,o.pause,o.resume,o.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=L;function k(p){const o=p;return o?L(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=k;function A(p,o){return new D(p,o)}e.newWriteableStream=A;class D{constructor(o,a){this.reducer=o,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(a=>a(o))}emitError(o){this.listeners.error.length===0?(0,w.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(a=>a(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,a){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(o,a){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(a);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(p,o){const a=[];let t;for(;(t=p.read())!==null;)a.push(t);return o(a)}e.consumeReadable=E;function v(p,o,a){const t=[];let r;for(;(r=p.read())!==null&&t.length<a;)t.push(r);return r===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return p.read()}}}e.peekReadable=v;function n(p,o){return new Promise((a,t)=>{const r=[];y(p,{onData:i=>{o&&r.push(i)},onError:i=>{o?t(i):a(void 0)},onEnd:()=>{a(o?o(r):void 0)}})})}e.consumeStream=n;function y(p,o){p.on("error",a=>o.onError(a)),p.on("end",()=>o.onEnd()),p.on("data",a=>o.onData(a))}e.listenStream=y;function m(p,o){return new Promise((a,t)=>{const r=new I.DisposableStore,i=[],s=l=>{if(i.push(l),i.length>o)return r.dispose(),p.pause(),a({stream:p,buffer:i,ended:!1})},h=l=>t(l),c=()=>a({stream:p,buffer:i,ended:!0});r.add((0,I.toDisposable)(()=>p.removeListener("error",h))),p.on("error",h),r.add((0,I.toDisposable)(()=>p.removeListener("end",c))),p.on("end",c),r.add((0,I.toDisposable)(()=>p.removeListener("data",s))),p.on("data",s)})}e.peekStream=m;function g(p,o){const a=A(o);return a.end(p),a}e.toStream=g;function u(){const p=A(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=u;function C(p){let o=!1;return{read:()=>o?null:(o=!0,p)}}e.toReadable=C;function P(p,o,a){const t=A(a);return y(p,{onData:r=>t.write(o.data(r)),onError:r=>t.error(o.error?o.error(r):r),onEnd:()=>t.end()}),t}e.transform=P;function b(p,o,a){let t=!1;return{read:()=>{const r=o.read();return t?r:(t=!0,r!==null?a([p,r]):p)}}}e.prefixedReadable=b;function R(p,o,a){let t=!1;const r=A(a);return y(o,{onData:i=>t?r.write(i):(t=!0,r.write(a([p,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(p)),r.end()}}),r}e.prefixedStream=R}),define(Z[19],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function w(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=w;const I=/{(\d+)}/g;function L(j,...te){return te.length===0?j:j.replace(I,function(ae,ce){const oe=parseInt(ce,10);return isNaN(oe)||oe<0||oe>=te.length?ae:te[oe]})}e.format=L;const k=/{([^}]+)}/g;function A(j,te){return j.replace(k,(ae,ce)=>te[ce]??ae)}e.format2=A;function D(j){return j.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=D;function E(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function v(j,te){let ae=0;const ce=te.charCodeAt(0);for(let oe=j.length-1;oe>=0;oe--)j.charCodeAt(oe)===ce&&ae++;return ae}e.count=v;function n(j,te,ae="\u2026"){return j.length<=te?j:`${j.substr(0,te)}${ae}`}e.truncate=n;function y(j,te=" "){const ae=m(j,te);return g(ae,te)}e.trim=y;function m(j,te){if(!j||!te)return j;const ae=te.length;if(ae===0||j.length===0)return j;let ce=0;for(;j.indexOf(te,ce)===ce;)ce=ce+ae;return j.substring(ce)}e.ltrim=m;function g(j,te){if(!j||!te)return j;const ae=te.length,ce=j.length;if(ae===0||ce===0)return j;let oe=ce,he=-1;for(;he=j.lastIndexOf(te,oe-1),!(he===-1||he+ae!==oe);){if(he===0)return"";oe=he}return j.substring(0,oe)}e.rtrim=g;function u(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function C(j){return j.replace(/\*/g,"")}e.stripWildcards=C;function P(j,te,ae={}){if(!j)throw new Error("Cannot create regex from empty string");te||(j=E(j)),ae.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(j,ce)}e.createRegExp=P;function b(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function R(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=R;function p(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=p;function o(j){return j.split(/\r\n|\r|\n/)}e.splitLines=o;function a(j){for(let te=0,ae=j.length;te<ae;te++){const ce=j.charCodeAt(te);if(ce!==32&&ce!==9)return te}return-1}e.firstNonWhitespaceIndex=a;function t(j,te=0,ae=j.length){for(let ce=te;ce<ae;ce++){const oe=j.charCodeAt(ce);if(oe!==32&&oe!==9)return j.substring(te,ce)}return j.substring(te,ae)}e.getLeadingWhitespace=t;function r(j,te=j.length-1){for(let ae=te;ae>=0;ae--){const ce=j.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=r;function i(j,te){return j<te?-1:j>te?1:0}e.compare=i;function s(j,te,ae=0,ce=j.length,oe=0,he=te.length){for(;ae<ce&&oe<he;ae++,oe++){let ue=j.charCodeAt(ae),Ee=te.charCodeAt(oe);if(ue<Ee)return-1;if(ue>Ee)return 1}const ge=ce-ae,ve=he-oe;return ge<ve?-1:ge>ve?1:0}e.compareSubstring=s;function h(j,te){return c(j,te,0,j.length,0,te.length)}e.compareIgnoreCase=h;function c(j,te,ae=0,ce=j.length,oe=0,he=te.length){for(;ae<ce&&oe<he;ae++,oe++){let ue=j.charCodeAt(ae),Ee=te.charCodeAt(oe);if(ue===Ee)continue;const Ie=ue-Ee;if(!(Ie===32&&f(Ee))&&!(Ie===-32&&f(ue)))return l(ue)&&l(Ee)?Ie:s(j.toLowerCase(),te.toLowerCase(),ae,ce,oe,he)}const ge=ce-ae,ve=he-oe;return ge<ve?-1:ge>ve?1:0}e.compareSubstringIgnoreCase=c;function l(j){return j>=97&&j<=122}e.isLowerAsciiLetter=l;function f(j){return j>=65&&j<=90}e.isUpperAsciiLetter=f;function S(j){return l(j)||f(j)}function d(j,te){return j.length===te.length&&T(j,te)}e.equalsIgnoreCase=d;function T(j,te,ae=j.length){for(let ce=0;ce<ae;ce++){const oe=j.charCodeAt(ce),he=te.charCodeAt(ce);if(oe!==he){if(S(oe)&&S(he)){const ge=Math.abs(oe-he);if(ge!==0&&ge!==32)return!1}else if(String.fromCharCode(oe).toLowerCase()!==String.fromCharCode(he).toLowerCase())return!1}}return!0}function O(j,te){const ae=te.length;return te.length>j.length?!1:T(j,te,ae)}e.startsWithIgnoreCase=O;function _(j,te){let ae,ce=Math.min(j.length,te.length);for(ae=0;ae<ce;ae++)if(j.charCodeAt(ae)!==te.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=_;function z(j,te){let ae,ce=Math.min(j.length,te.length);const oe=j.length-1,he=te.length-1;for(ae=0;ae<ce;ae++)if(j.charCodeAt(oe-ae)!==te.charCodeAt(he-ae))return ae;return ce}e.commonSuffixLength=z;function H(j){return 55296<=j&&j<=56319}e.isHighSurrogate=H;function V(j){return 56320<=j&&j<=57343}e.isLowSurrogate=V;function U(j,te){return(j-55296<<10)+(te-56320)+65536}e.computeCodePoint=U;function x(j,te,ae){const ce=j.charCodeAt(ae);if(H(ce)&&ae+1<te){const oe=j.charCodeAt(ae+1);if(V(oe))return U(ce,oe)}return ce}e.getNextCodePoint=x;function M(j,te){const ae=j.charCodeAt(te-1);if(V(ae)&&te>1){const ce=j.charCodeAt(te-2);if(H(ce))return U(ce,ae)}return ae}function $(j,te){const ae=pe.getInstance(),ce=te,oe=j.length,he=x(j,oe,te);te+=he>=65536?2:1;let ge=ae.getGraphemeBreakType(he);for(;te<oe;){const ve=x(j,oe,te),ue=ae.getGraphemeBreakType(ve);if(se(ge,ue))break;te+=ve>=65536?2:1,ge=ue}return te-ce}e.nextCharLength=$;function q(j,te){const ae=pe.getInstance(),ce=te,oe=M(j,te);te-=oe>=65536?2:1;let he=ae.getGraphemeBreakType(oe);for(;te>0;){const ge=M(j,te),ve=ae.getGraphemeBreakType(ge);if(se(ve,he))break;te-=ge>=65536?2:1,he=ve}return ce-te}e.prevCharLength=q;function F(j,te){const ae=pe.getInstance(),ce=j.length,oe=te,he=x(j,ce,te),ge=ae.getGraphemeBreakType(he);te+=he>=65536?2:1;let ve=ge;for(;te<ce;){const Ee=x(j,ce,te),Ie=ae.getGraphemeBreakType(Ee);if(se(ve,Ie))break;te+=Ee>=65536?2:1,ve=Ie}const ue=te;for(te=oe,ve=ge;te>0;){const Ee=M(j,te),Ie=ae.getGraphemeBreakType(Ee);if(se(Ie,ve))break;te-=Ee>=65536?2:1,ve=Ie}return[te,ue]}function W(j,te){return te>0&&V(j.charCodeAt(te))?F(j,te-1):F(j,te)}e.getCharContainingOffset=W;function N(j){const te=j.length;let ae=0,ce=0;for(;ce<te;){const ge=x(j,te,ce);ce+=ge>=65536?2:1,ge<128?ae+=1:ge<2048?ae+=2:ge<65536?ae+=3:ae+=4}const oe=new Uint8Array(ae);ce=0;let he=0;for(;ce<te;){const ge=x(j,te,ce);ce+=ge>=65536?2:1,ge<128?oe[he++]=ge:ge<2048?(oe[he++]=192|(ge&1984)>>>6,oe[he++]=128|(ge&63)>>>0):ge<65536?(oe[he++]=224|(ge&61440)>>>12,oe[he++]=128|(ge&4032)>>>6,oe[he++]=128|(ge&63)>>>0):(oe[he++]=240|(ge&1835008)>>>18,oe[he++]=128|(ge&258048)>>>12,oe[he++]=128|(ge&4032)>>>6,oe[he++]=128|(ge&63)>>>0)}return oe}e.encodeUTF8=N;function G(j){const te=j.byteLength,ae=[];let ce=0;for(;ce<te;){const oe=j[ce];let he;if(oe>=240&&ce+3<te?he=(j[ce++]&7)<<18>>>0|(j[ce++]&63)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:oe>=224&&ce+2<te?he=(j[ce++]&15)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:oe>=192&&ce+1<te?he=(j[ce++]&31)<<6>>>0|(j[ce++]&63)<<0>>>0:he=j[ce++],he>=0&&he<=55295||he>=57344&&he<=65535)ae.push(String.fromCharCode(he));else if(he>=65536&&he<=1114111){const ge=he-65536,ve=55296+((ge&1047552)>>>10),ue=56320+((ge&1023)>>>0);ae.push(String.fromCharCode(ve)),ae.push(String.fromCharCode(ue))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=G;const B=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function J(j){return B.test(j)}e.containsRTL=J;const Q=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ie(j){return Q.test(j)}e.containsEmoji=ie;const ne=/^[\t\n\r\x20-\x7E]*$/;function le(j){return ne.test(j)}e.isBasicASCII=le,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function fe(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=fe;function me(j){for(let te=0,ae=j.length;te<ae;te++)if(Se(j.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=me;function Se(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=Se;function Pe(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=Pe;function ke(j,te){if(j.length<te)return j;const ae=/\b/g;let ce=0;for(;ae.test(j)&&!(j.length-ae.lastIndex<te);)ce=ae.lastIndex,ae.lastIndex+=1;return j.substring(ce).replace(/^\s/,"")}e.lcut=ke;const Ne=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,Le=/\x1b\[0?m/g;function _e(j){return j&&(j=j.replace(Ne,""),j=j.replace(Oe,""),j=j.replace(Le,"")),j}e.removeAnsiEscapeCodes=_e,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Ae(j){return be(j)?j.substr(1):j}e.stripUTF8BOM=Ae;function Ye(j,te){if(!j||!te||j.length<te.length)return!1;const ae=te.length,ce=j.toLowerCase();let oe=0,he=-1;for(;oe<ae;){const ge=ce.indexOf(te[oe],he+1);if(ge<0)return!1;he=ge,oe++}return!0}e.fuzzyContains=Ye;function Je(j,te=!1){return j?(te&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=Je;function xe(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=xe;function qe(j,te=1){if(te===0)return"";let ae=-1;do ae=j.indexOf(`
`,ae+1),te--;while(te>0&&ae>=0);return ae===-1?j:(j[ae-1]==="\r"&&ae--,j.substr(0,ae))}e.getNLines=qe;function X(j){const te=90-65+1;return j=j%(2*te),j<te?String.fromCharCode(97+j):String.fromCharCode(65+j-te)}e.singleLetterHash=X;function re(j){return pe.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=re;function se(j,te){return j===0?te!==5&&te!==7:j===2&&te===3?!1:j===4||j===2||j===3||te===4||te===2||te===3?!0:!(j===8&&(te===8||te===9||te===11||te===12)||(j===11||j===9)&&(te===9||te===10)||(j===12||j===10)&&te===10||te===5||te===13||te===7||j===1||j===13&&te===14||j===6&&te===6)}e.breakBetweenGraphemeBreakType=se;var ye;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(ye=e.GraphemeBreakType||(e.GraphemeBreakType={}));class pe{constructor(){this._data=De()}static getInstance(){return pe._INSTANCE||(pe._INSTANCE=new pe),pe._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const ae=this._data,ce=ae.length/3;let oe=1;for(;oe<=ce;)if(te<ae[3*oe])oe=2*oe;else if(te>ae[3*oe+1])oe=2*oe+1;else return ae[3*oe+2];return 0}}pe._INSTANCE=null;function De(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function we(j,te){if(j===0)return 0;const ae=Te(j,te);if(ae!==void 0)return ae;const ce=M(te,j);return j-=Ce(ce),j}e.getLeftDeleteOffset=we;function Te(j,te){let ae=M(te,j);for(j-=Ce(ae);Re(ae)||ae===65039||ae===8419;){if(j===0)return;ae=M(te,j),j-=Ce(ae)}if(!!Pe(ae)){if(j>=0){const ce=M(te,j);ce===8205&&(j-=Ce(ce))}return j}}function Ce(j){return j>=65536?2:1}function Re(j){return 127995<=j&&j<=127999}var Ue;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={}))}),define(Z[25],ee([0,1,19,49]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined",k=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let D,E;class v{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return L?new v(Buffer.allocUnsafe(l)):new v(new Uint8Array(l))}static wrap(l){return L&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new v(l)}static fromString(l,f){return!(f?.dontUseNodeBuffer||!1)&&L?new v(Buffer.from(l)):k?(D||(D=new TextEncoder),new v(D.encode(l))):new v(w.encodeUTF8(l))}static concat(l,f){if(typeof f=="undefined"){f=0;for(let T=0,O=l.length;T<O;T++)f+=l[T].byteLength}const S=v.alloc(f);let d=0;for(let T=0,O=l.length;T<O;T++){const _=l[T];S.set(_,d),d+=_.byteLength}return S}toString(){return L?this.buffer.toString():A?(E||(E=new TextDecoder),E.decode(this.buffer)):w.decodeUTF8(this.buffer)}slice(l,f){return new v(this.buffer.subarray(l,f))}set(l,f){l instanceof v?this.buffer.set(l.buffer,f):this.buffer.set(l,f)}readUInt32BE(l){return m(this.buffer,l)}writeUInt32BE(l,f){g(this.buffer,l,f)}readUInt32LE(l){return u(this.buffer,l)}writeUInt32LE(l,f){C(this.buffer,l,f)}readUInt8(l){return P(this.buffer,l)}writeUInt8(l,f){b(this.buffer,l,f)}}e.VSBuffer=v;function n(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0}e.readUInt16LE=n;function y(c,l,f){c[f+0]=l&255,l=l>>>8,c[f+1]=l&255}e.writeUInt16LE=y;function m(c,l){return c[l]*2**24+c[l+1]*2**16+c[l+2]*2**8+c[l+3]}e.readUInt32BE=m;function g(c,l,f){c[f+3]=l,l=l>>>8,c[f+2]=l,l=l>>>8,c[f+1]=l,l=l>>>8,c[f]=l}e.writeUInt32BE=g;function u(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0|c[l+2]<<16>>>0|c[l+3]<<24>>>0}e.readUInt32LE=u;function C(c,l,f){c[f+0]=l&255,l=l>>>8,c[f+1]=l&255,l=l>>>8,c[f+2]=l&255,l=l>>>8,c[f+3]=l&255}e.writeUInt32LE=C;function P(c,l){return c[l]}e.readUInt8=P;function b(c,l,f){c[f]=l}e.writeUInt8=b;function R(c){return I.consumeReadable(c,l=>v.concat(l))}e.readableToBuffer=R;function p(c){return I.toReadable(c)}e.bufferToReadable=p;function o(c){return I.consumeStream(c,l=>v.concat(l))}e.streamToBuffer=o;async function a(c){return c.ended?v.concat(c.buffer):v.concat([...c.buffer,await o(c.stream)])}e.bufferedStreamToBuffer=a;function t(c){return I.toStream(c,l=>v.concat(l))}e.bufferToStream=t;function r(c){return I.transform(c,{data:l=>typeof l=="string"?v.fromString(l):v.wrap(l)},l=>v.concat(l))}e.streamToBufferReadableStream=r;function i(c){return I.newWriteableStream(l=>v.concat(l),c)}e.newWriteableBufferStream=i;function s(c,l){return I.prefixedReadable(c,l,f=>v.concat(f))}e.prefixedBufferReadable=s;function h(c,l){return I.prefixedStream(c,l,f=>v.concat(f))}e.prefixedBufferStream=h}),define(Z[16],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(l){return Array.isArray(l)}e.isArray=w;function I(l){return typeof l=="string"}e.isString=I;function L(l){return Array.isArray(l)&&l.every(f=>I(f))}e.isStringArray=L;function k(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=k;function A(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=A;function D(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=D;function E(l){return l===!0||l===!1}e.isBoolean=E;function v(l){return typeof l=="undefined"}e.isUndefined=v;function n(l){return!y(l)}e.isDefined=n;function y(l){return v(l)||l===null}e.isUndefinedOrNull=y;function m(l,f){if(!l)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}e.assertType=m;function g(l){if(y(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=g;function u(...l){const f=[];for(let S=0;S<l.length;S++){const d=l[S];if(y(d))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);f.push(d)}return f}e.assertAllDefined=u;const C=Object.prototype.hasOwnProperty;function P(l){if(!k(l))return!1;for(let f in l)if(C.call(l,f))return!1;return!0}e.isEmptyObject=P;function b(l){return typeof l=="function"}e.isFunction=b;function R(...l){return l.length>0&&l.every(b)}e.areFunctions=R;function p(l,f){const S=Math.min(l.length,f.length);for(let d=0;d<S;d++)o(l[d],f[d])}e.validateConstraints=p;function o(l,f){if(I(f)){if(typeof l!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if(b(f)){try{if(l instanceof f)return}catch{}if(!y(l)&&l.constructor===f||f.length===1&&f.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function a(l){let f=[],S=Object.getPrototypeOf(l);for(;Object.prototype!==S;)f=f.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return f}e.getAllPropertyNames=a;function t(l){const f=[];for(const S of a(l))typeof l[S]=="function"&&f.push(S);return f}e.getAllMethodNames=t;function r(l,f){const S=T=>function(){const O=Array.prototype.slice.call(arguments,0);return f(T,O)};let d={};for(const T of l)d[T]=S(T);return d}e.createProxyObject=r;function i(l){return l===null?void 0:l}e.withNullAsUndefined=i;function s(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=s;function h(l){return class{constructor(){return new Proxy({},{get(f,S){if(f[S])return f[S];throw new Error(`Not Implemented: ${l}->${String(S)}`)}})}}}e.NotImplementedProxy=h;function c(l,f="Unreachable"){throw new Error(f)}e.assertNever=c}),define(Z[43],ee([0,1,4,19,8,16]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(i){return i===47||i===92}e.isPathSeparator=A;function D(i){return i.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=D;function E(i){return i.indexOf("/")===-1&&(i=D(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=E;function v(i,s=L.posix.sep){if(!i)return"";const h=i.length,c=i.charCodeAt(0);if(A(c)){if(A(i.charCodeAt(1))&&!A(i.charCodeAt(2))){let f=3;const S=f;for(;f<h&&!A(i.charCodeAt(f));f++);if(S!==f&&!A(i.charCodeAt(f+1))){for(f+=1;f<h;f++)if(A(i.charCodeAt(f)))return i.slice(0,f+1).replace(/[\\/]/g,s)}}return s}else if(b(c)&&i.charCodeAt(1)===58)return A(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<h;l++)if(A(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=v;function n(i){if(!w.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let h=2;const c=h;for(;h<i.length&&(s=i.charCodeAt(h),s!==92);h++);return!(c===h||(s=i.charCodeAt(h+1),isNaN(s)||s===92))}e.isUNC=n;const y=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(i,s=w.isWindows){const h=s?y:m;return!(!i||i.length===0||/^\s+$/.test(i)||(h.lastIndex=0,h.test(i))||s&&g.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=u;function C(i,s,h){const c=i===s;return!h||c?c:!i||!s?!1:(0,I.equalsIgnoreCase)(i,s)}e.isEqual=C;function P(i,s,h,c=L.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(h){if(!(0,I.startsWithIgnoreCase)(i,s))return!1;if(s.length===i.length)return!0;let f=s.length;return s.charAt(s.length-1)===c&&f--,i.charAt(f)===c}return s.charAt(s.length-1)!==c&&(s+=c),i.indexOf(s)===0}e.isEqualOrParent=P;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function R(i,s){return w.isWindows&&i.endsWith(":")&&(i+=L.sep),(0,L.isAbsolute)(i)||(i=(0,L.join)(s,i)),i=(0,L.normalize)(i),w.isWindows?(i=(0,I.rtrim)(i,L.sep),i.endsWith(":")&&(i+=L.sep)):(i=(0,I.rtrim)(i,L.sep),i||(i=L.sep)),i}e.sanitizeFilePath=R;function p(i){const s=(0,L.normalize)(i);return w.isWindows?i.length>3?!1:o(s)&&(i.length===2||s.charCodeAt(2)===92):s===L.posix.sep}e.isRootOrDriveLetter=p;function o(i){return w.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function a(i){return o(i)?i[0]:void 0}e.getDriveLetter=a;function t(i,s,h){return s.length>i.length?-1:i===s?0:(h&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=t;function r(i){const s=i.split(":");let h,c,l;if(s.forEach(f=>{const S=Number(f);(0,k.isNumber)(S)?c===void 0?c=S:l===void 0&&(l=S):h=h?[h,f].join(":"):f}),!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:c!==void 0?c:void 0,column:l!==void 0?l:c!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],ee([0,1,16]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(C){if(!C||typeof C!="object"||C instanceof RegExp)return C;const P=Array.isArray(C)?[]:{};return Object.keys(C).forEach(b=>{C[b]&&typeof C[b]=="object"?P[b]=I(C[b]):P[b]=C[b]}),P}e.deepClone=I;function L(C){if(!C||typeof C!="object")return C;const P=[C];for(;P.length>0;){const b=P.shift();Object.freeze(b);for(const R in b)if(k.call(b,R)){const p=b[R];typeof p=="object"&&!Object.isFrozen(p)&&P.push(p)}}return C}e.deepFreeze=L;const k=Object.prototype.hasOwnProperty;function A(C,P){return D(C,P,new Set)}e.cloneAndChange=A;function D(C,P,b){if((0,w.isUndefinedOrNull)(C))return C;const R=P(C);if(typeof R!="undefined")return R;if((0,w.isArray)(C)){const p=[];for(const o of C)p.push(D(o,P,b));return p}if((0,w.isObject)(C)){if(b.has(C))throw new Error("Cannot clone recursive data-structure");b.add(C);const p={};for(let o in C)k.call(C,o)&&(p[o]=D(C[o],P,b));return b.delete(C),p}return C}function E(C,P,b=!0){return(0,w.isObject)(C)?((0,w.isObject)(P)&&Object.keys(P).forEach(R=>{R in C?b&&((0,w.isObject)(C[R])&&(0,w.isObject)(P[R])?E(C[R],P[R],b):C[R]=P[R]):C[R]=P[R]}),C):P}e.mixin=E;function v(C,P){if(C===P)return!0;if(C==null||P===null||P===void 0||typeof C!=typeof P||typeof C!="object"||Array.isArray(C)!==Array.isArray(P))return!1;let b,R;if(Array.isArray(C)){if(C.length!==P.length)return!1;for(b=0;b<C.length;b++)if(!v(C[b],P[b]))return!1}else{const p=[];for(R in C)p.push(R);p.sort();const o=[];for(R in P)o.push(R);if(o.sort(),!v(p,o))return!1;for(b=0;b<p.length;b++)if(!v(C[p[b]],P[p[b]]))return!1}return!0}e.equals=v;function n(C){const P=new Set;return JSON.stringify(C,(b,R)=>{if((0,w.isObject)(R)||Array.isArray(R)){if(P.has(R))return"[Circular]";P.add(R)}return R})}e.safeStringify=n;function y(C,P,b){const R=P(C);return typeof R=="undefined"?b:R}e.getOrDefault=y;function m(C,P){const b=Object.create(null);return!C||!P||Object.keys(P).forEach(p=>{const o=C[p],a=P[p];v(o,a)||(b[p]=a)}),b}e.distinct=m;function g(C,P){const b=P.toLowerCase(),R=Object.keys(C).find(p=>p.toLowerCase()===b);return R?C[R]:C[P]}e.getCaseInsensitive=g;function u(C,P){const b=Object.create(null);for(const R of Object.keys(C))P(R,C[R])&&(b[R]=C[R]);return b}e.filter=u}),define(Z[5],ee([0,1,4,8]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function D(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!k.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(i,s){return!i&&!s?"file":i}function v(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==y&&(s=y+s):s=y;break}return s}const n="",y="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(s,h,c,l,f,S=!1){typeof s=="object"?(this.scheme=s.scheme||n,this.authority=s.authority||n,this.path=s.path||n,this.query=s.query||n,this.fragment=s.fragment||n):(this.scheme=E(s,S),this.authority=h||n,this.path=v(this.scheme,c||n),this.query=l||n,this.fragment=f||n,D(this,S))}static isUri(s){return s instanceof g?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return p(this,!1)}with(s){if(!s)return this;let{scheme:h,authority:c,path:l,query:f,fragment:S}=s;return h===void 0?h=this.scheme:h===null&&(h=n),c===void 0?c=this.authority:c===null&&(c=n),l===void 0?l=this.path:l===null&&(l=n),f===void 0?f=this.query:f===null&&(f=n),S===void 0?S=this.fragment:S===null&&(S=n),h===this.scheme&&c===this.authority&&l===this.path&&f===this.query&&S===this.fragment?this:new C(h,c,l,f,S)}static parse(s,h=!1){const c=m.exec(s);return c?new C(c[2]||n,r(c[4]||n),r(c[5]||n),r(c[7]||n),r(c[9]||n),h):new C(n,n,n,n,n)}static file(s){let h=n;if(w.isWindows&&(s=s.replace(/\\/g,y)),s[0]===y&&s[1]===y){const c=s.indexOf(y,2);c===-1?(h=s.substring(2),s=y):(h=s.substring(2,c),s=s.substring(c)||y)}return new C("file",h,s,n,n)}static from(s){const h=new C(s.scheme,s.authority,s.path,s.query,s.fragment);return D(h,!0),h}static joinPath(s,...h){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return w.isWindows&&s.scheme==="file"?c=g.file(I.win32.join(p(s,!0),...h)).path:c=I.posix.join(s.path,...h),s.with({path:c})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof g)return s;{const h=new C(s);return h._formatted=s.external,h._fsPath=s._sep===u?s.fsPath:null,h}}else return s}}e.URI=g;const u=w.isWindows?1:void 0;class C extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=u),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,s){let h,c=-1;for(let l=0;l<i.length;l++){const f=i.charCodeAt(l);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||s&&f===47)c!==-1&&(h+=encodeURIComponent(i.substring(c,l)),c=-1),h!==void 0&&(h+=i.charAt(l));else{h===void 0&&(h=i.substr(0,l));const S=P[f];S!==void 0?(c!==-1&&(h+=encodeURIComponent(i.substring(c,l)),c=-1),h+=S):c===-1&&(c=l)}}return c!==-1&&(h+=encodeURIComponent(i.substring(c))),h!==void 0?h:i}function R(i){let s;for(let h=0;h<i.length;h++){const c=i.charCodeAt(h);c===35||c===63?(s===void 0&&(s=i.substr(0,h)),s+=P[c]):s!==void 0&&(s+=i[h])}return s!==void 0?s:i}function p(i,s){let h;return i.authority&&i.path.length>1&&i.scheme==="file"?h=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?h=i.path.substr(1):h=i.path[1].toLowerCase()+i.path.substr(2):h=i.path,w.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=p;function o(i,s){const h=s?R:b;let c="",{scheme:l,authority:f,path:S,query:d,fragment:T}=i;if(l&&(c+=l,c+=":"),(f||l==="file")&&(c+=y,c+=y),f){let O=f.indexOf("@");if(O!==-1){const _=f.substr(0,O);f=f.substr(O+1),O=_.indexOf(":"),O===-1?c+=h(_,!1):(c+=h(_.substr(0,O),!1),c+=":",c+=h(_.substr(O+1),!1)),c+="@"}f=f.toLowerCase(),O=f.indexOf(":"),O===-1?c+=h(f,!1):(c+=h(f.substr(0,O),!1),c+=f.substr(O))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const O=S.charCodeAt(1);O>=65&&O<=90&&(S=`/${String.fromCharCode(O+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const O=S.charCodeAt(0);O>=65&&O<=90&&(S=`${String.fromCharCode(O+32)}:${S.substr(2)}`)}c+=h(S,!0)}return d&&(c+="?",c+=h(d,!1)),T&&(c+="#",c+=s?T:b(T,!1)),c}function a(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+a(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,s=>a(s)):i}}),define(Z[93],ee([0,1,5]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function I(v){const n=v;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=I;function L(v){const n=[];let y;try{const m=JSON.parse(v.arguments),g=m[m.length-1];g&&g.__$stack&&(m.pop(),y=g.__$stack),n.push(...m)}catch(m){n.push("Unable to log remote console arguments",v.arguments)}return{args:n,stack:y}}e.parse=L;function k(v){if(typeof v!="string")return k(L(v).stack);const n=v;if(n){const y=A(n),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(m&&m.length===4)return{uri:w.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=k;function A(v){if(!v)return v;const n=v.indexOf(`
`);return n===-1?v:v.substring(0,n)}function D(v,n){const{args:y,stack:m}=L(v),g=typeof y[0]=="string"&&y.length===1;let u=A(m);u&&(u=`(${u.trim()})`);let C=[];if(typeof y[0]=="string"?u&&g?C=[`%c[${n}] %c${y[0]} %c${u}`,E("blue"),E(""),E("grey")]:C=[`%c[${n}] %c${y[0]}`,E("blue"),E(""),...y.slice(1)]:C=[`%c[${n}]%`,E("blue"),...y],u&&!g&&C.push(u),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,C)}e.log=D;function E(v){return`color: ${v}`}});var ut=this&&this.__classPrivateFieldSet||function(K,e,w,I,L){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?L.call(K,w):L?L.value=w:e.set(K,w),w},ze=this&&this.__classPrivateFieldGet||function(K,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!I:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(K):I?I.value:e.get(K)};define(Z[39],ee([0,1,5,19]),function(K,e,w,I){"use strict";var L,k,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,r,i){let s=t.get(r);return s===void 0&&(s=i,t.set(r,s)),s}e.getOrSet=D;function E(t){const r=[];return t.forEach((i,s)=>{r.push(`${s} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=E;function v(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=v;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),s=this._value.charCodeAt(this._pos);return i-s}value(){return this._value[this._pos]}}e.StringIterator=n;class y{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,I.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class m{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,I.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class u{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,I.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class C{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(r){this._iter=r}static forUris(r=()=>!1){return new P(new u(r))}static forPaths(){return new P(new m)}static forStrings(){return new P(new n)}static forConfigKeys(){return new P(new y)}clear(){this._root=void 0}set(r,i){const s=this._iter.reset(r);let h;for(this._root||(this._root=new C,this._root.segment=s.value()),h=this._root;;){const l=s.cmp(h.segment);if(l>0)h.left||(h.left=new C,h.left.segment=s.value()),h=h.left;else if(l<0)h.right||(h.right=new C,h.right.segment=s.value()),h=h.right;else if(s.hasNext())s.next(),h.mid||(h.mid=new C,h.mid.segment=s.value()),h=h.mid;else break}const c=h.value;return h.value=i,h.key=r,c}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const h=i.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else break}return s}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const s=this._iter.reset(r),h=[];let c=this._root;for(;c;){const l=s.cmp(c.segment);if(l>0)h.push([1,c]),c=c.left;else if(l<0)h.push([-1,c]),c=c.right;else if(s.hasNext())s.next(),h.push([0,c]),c=c.mid;else{for(i?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;h.length>0&&c.isEmpty();){let[f,S]=h.pop();switch(f){case 1:S.left=void 0;break;case 0:S.mid=void 0;break;case-1:S.right=void 0;break}c=S}break}}}findSubstr(r){const i=this._iter.reset(r);let s=this._root,h;for(;s;){const c=i.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(i.hasNext())i.next(),h=s.value||h,s=s.mid;else break}return s&&s.value||h}findSuperstr(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const h=i.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(r){for(const[i,s]of this)r(s,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const s=i.pop();s&&(s.value&&(yield[s.key,s.value]),s.left&&i.push(s.left),s.mid&&i.push(s.mid),s.right&&i.push(s.right))}}}e.TernarySearchTree=P;class b{constructor(r,i){this[L]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=i??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[s,h]of this.map)r(h,w.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield w.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[w.URI.parse(r[0]),r[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[w.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var R;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(R=e.Touch||(e.Touch={}));class p{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const s=this._map.get(r);if(!!s)return i!==0&&this.touch(s,i),s.value}set(r,i,s=0){let h=this._map.get(r);if(h)h.value=i,s!==0&&this.touch(h,s);else{switch(h={key:r,value:i,next:void 0,previous:void 0},s){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const s=this._state;let h=this._head;for(;h;){if(i?r.bind(i)(h.value,h.key,this):r(h.value,h.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,i=this._state;let s=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const c={value:s.key,done:!1};return s=s.next,c}else return{value:void 0,done:!0}}};return h}values(){const r=this,i=this._state;let s=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const c={value:s.value,done:!1};return s=s.next,c}else return{value:void 0,done:!0}}};return h}entries(){const r=this,i=this._state;let s=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const c={value:[s.key,s.value],done:!1};return s=s.next,c}else return{value:void 0,done:!0}}};return h}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>r;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,s=r.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const s=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(s.previous=h,h.next=s),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const s=r.next,h=r.previous;r===this._head?(s.previous=void 0,this._head=s):(s.previous=h,h.next=s),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,s)=>{r.push([s,i])}),r}fromJSON(r){this.clear();for(const[i,s]of r)this.set(i,s)}}e.LinkedMap=p;class o extends p{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class a{constructor(r){A.set(this,void 0),ut(this,A,r,"f")}get size(){return ze(this,A,"f").size}forEach(r,i){ze(this,A,"f").forEach(r,i)}get(r){return ze(this,A,"f").get(r)}has(r){return ze(this,A,"f").has(r)}entries(){return ze(this,A,"f").entries()}keys(){return ze(this,A,"f").keys()}values(){return ze(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return ze(this,A,"f").entries()}}e.ReadonlyMapView=a}),define(Z[94],ee([0,1,25,19,5]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(n){return JSON.stringify(n,E)}e.stringify=k;function A(n){let y=JSON.parse(n);return y=v(y),y}e.parse=A;var D;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(D=e.MarshalledId||(e.MarshalledId={}));function E(n,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,I.regExpFlags)(y)}:y}function v(n,y=0){if(!n||y>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return L.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof w.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let m=0;m<n.length;++m)n[m]=v(n[m],y+1);else for(const m in n)Object.hasOwnProperty.call(n,m)&&(n[m]=v(n[m],y+1))}return n}e.revive=v}),define(Z[17],ee([0,1,5,4]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(L=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,v,n){this._hosts[E]=v,this._ports[E]=n}setConnectionToken(E,v){this._connectionTokens[E]=v}rewrite(E){if(this._delegate)return this._delegate(E);const v=E.authority;let n=this._hosts[v];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const y=this._ports[v],m=this._connectionTokens[v];let g=`path=${encodeURIComponent(E.path)}`;return typeof m=="string"&&(g+=`&tkn=${encodeURIComponent(m)}`),w.URI.from({scheme:I.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${n}:${y}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new k;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(E,v,n){const y=this.toUri(E,v);if(y.scheme===L.vscodeRemote)return e.RemoteAuthorities.rewrite(y);let m=!1;return I.isNative&&(n||I.isPreferringBrowserCodeLoad)&&y.scheme===L.file&&(m=!0),y.scheme===L.file&&typeof I.globals.importScripts=="function"&&I.globals.origin==="vscode-file://vscode-app"&&(m=!0),m?y.with({scheme:L.vscodeFileResource,authority:y.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(E,v){const n=this.toUri(E,v);return n.scheme===L.vscodeFileResource?n.with({scheme:L.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(E,v){return w.URI.isUri(E)?E:w.URI.parse(v.toUrl(E))}}e.FileAccess=new A}),define(Z[66],ee([0,1,39]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const I=new w.LRUCache(1e4);function L(v){return E(v,"NFC",I)}e.normalizeNFC=L;const k=new w.LRUCache(1e4);function A(v){return E(v,"NFD",k)}e.normalizeNFD=A;const D=/[^\u0000-\u0080]/;function E(v,n,y){if(!v)return v;const m=y.get(v);if(m)return m;let g;return D.test(v)?g=v.normalize(n):g=v,y.set(v,g),g}e.removeAccents=function(){const v=/[\u0300-\u036f]/g;return function(n){return A(n).replace(v,"")}}()}),define(Z[15],ee([0,1,43,8,5,19,17,4]),function(K,e,w,I,L,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(g){return(0,L.uriToFsPath)(g,!0)}e.originalFSPath=E;class v{constructor(u){this._ignorePathCasing=u}compare(u,C,P=!1){return u===C?0:(0,k.compare)(this.getComparisonKey(u,P),this.getComparisonKey(C,P))}isEqual(u,C,P=!1){return u===C?!0:!u||!C?!1:this.getComparisonKey(u,P)===this.getComparisonKey(C,P)}getComparisonKey(u,C=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,C,P=!1){if(u.scheme===C.scheme){if(u.scheme===A.Schemas.file)return w.isEqualOrParent(E(u),E(C),this._ignorePathCasing(u))&&u.query===C.query&&(P||u.fragment===C.fragment);if((0,e.isEqualAuthority)(u.authority,C.authority))return w.isEqualOrParent(u.path,C.path,this._ignorePathCasing(u),"/")&&u.query===C.query&&(P||u.fragment===C.fragment)}return!1}joinPath(u,...C){return L.URI.joinPath(u,...C)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return I.posix.basename(u.path)}extname(u){return I.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let C;return u.scheme===A.Schemas.file?C=L.URI.file(I.dirname(E(u))).path:(C=I.posix.dirname(u.path),u.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),C="/")),u.with({path:C})}normalizePath(u){if(!u.path.length)return u;let C;return u.scheme===A.Schemas.file?C=L.URI.file(I.normalize(E(u))).path:C=I.posix.normalize(u.path),u.with({path:C})}relativePath(u,C){if(u.scheme!==C.scheme||!(0,e.isEqualAuthority)(u.authority,C.authority))return;if(u.scheme===A.Schemas.file){const R=I.relative(E(u),E(C));return D.isWindows?w.toSlashes(R):R}let P=u.path||"/",b=C.path||"/";if(this._ignorePathCasing(u)){let R=0;for(const p=Math.min(P.length,b.length);R<p&&!(P.charCodeAt(R)!==b.charCodeAt(R)&&P.charAt(R).toLowerCase()!==b.charAt(R).toLowerCase());R++);P=b.substr(0,R)+P.substr(R)}return I.posix.relative(P,b)}resolvePath(u,C){if(u.scheme===A.Schemas.file){const P=L.URI.file(I.resolve(E(u),C));return u.with({authority:P.authority,path:P.path})}return C=w.toPosixPath(C),u.with({path:I.posix.resolve(u.path,C)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,C){return u===C||(0,k.equalsIgnoreCase)(u,C)}hasTrailingPathSeparator(u,C=I.sep){if(u.scheme===A.Schemas.file){const P=E(u);return P.length>w.getRoot(P).length&&P[P.length-1]===C}else{const P=u.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,C=I.sep){return(0,e.hasTrailingPathSeparator)(u,C)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,C=I.sep){let P=!1;if(u.scheme===A.Schemas.file){const b=E(u);P=b!==void 0&&b.length===w.getRoot(b).length&&b[b.length-1]===C}else{C="/";const b=u.path;P=b.length===1&&b.charCodeAt(b.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(u,C)?u.with({path:u.path+"/"}):u}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(g=>g.scheme===A.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new v(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(g,u){const C=[];for(let P=0;P<g.length;P++){const b=u(g[P]);g.some((R,p)=>p===P?!1:(0,e.isEqualOrParent)(b,u(R)))||C.push(g[P])}return C}e.distinctParents=n;var y;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function u(C){const P=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(p=>{const[o,a]=p.split(":");o&&a&&P.set(o,a)});const R=C.path.substring(0,C.path.indexOf(";"));return R&&P.set(g.META_DATA_MIME,R),P}g.parseMetaData=u})(y=e.DataUri||(e.DataUri={}));function m(g,u,C){if(u){let P=g.path;return P&&P[0]!==I.posix.sep&&(P=I.posix.sep+P),g.with({scheme:C,authority:u,path:P})}return g.with({scheme:C})}e.toLocalResource=m}),define(Z[6],ee([0,1,29,11,3,2,15]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(x){return!!x&&typeof x.then=="function"}e.isThenable=D;function E(x){const M=new w.CancellationTokenSource,$=x(M.token),q=new Promise((F,W)=>{const N=M.token.onCancellationRequested(()=>{N.dispose(),M.dispose(),W((0,I.canceled)())});Promise.resolve($).then(G=>{N.dispose(),M.dispose(),F(G)},G=>{N.dispose(),M.dispose(),W(G)})});return new class{cancel(){M.cancel()}then(F,W){return q.then(F,W)}catch(F){return this.then(void 0,F)}finally(F){return q.finally(F)}}}e.createCancelablePromise=E;function v(x,M,$){return Promise.race([x,new Promise(q=>M.onCancellationRequested(()=>q($)))])}e.raceCancellation=v;async function n(x){let M=-1;const $=x.map((F,W)=>F.then(N=>(M=W,N))),q=await Promise.race($);return x.forEach((F,W)=>{W!==M&&F.cancel()}),q}e.raceCancellablePromises=n;function y(x,M,$){let q;const F=setTimeout(()=>{q?.(void 0),$?.()},M);return Promise.race([x.finally(()=>clearTimeout(F)),new Promise(W=>q=W)])}e.raceTimeout=y;function m(x){return new Promise((M,$)=>{const q=x();D(q)?q.then(M,$):M(q)})}e.asPromise=m;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then($,$).then(q)})}return new Promise(($,q)=>{this.queuedPromise.then($,q)})}return this.activePromise=M(),new Promise(($,q)=>{this.activePromise.then(F=>{this.activePromise=null,$(F)},F=>{this.activePromise=null,q(F)})})}}e.Throttler=g;class u{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=u;class C{constructor(){this.promiseMap=new Map}queue(M,$){const F=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(M)===F&&this.promiseMap.delete(M)});return this.promiseMap.set(M,F),F}}e.SequencerByKey=C;class P{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,$=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,F)=>{this.doResolve=q,this.doReject=F}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class b{constructor(M){this.delayer=new P(M),this.throttler=new g}trigger(M,$){return this.delayer.trigger(()=>this.throttler.queue(M),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class R{constructor(){this._isOpen=!1,this._promise=new Promise((M,$)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=R;class p extends R{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=p;function o(x,M){return M?new Promise(($,q)=>{const F=setTimeout(()=>{W.dispose(),$()},x),W=M.onCancellationRequested(()=>{clearTimeout(F),W.dispose(),q((0,I.canceled)())})}):E($=>o(x,$))}e.timeout=o;function a(x,M=0){const $=setTimeout(x,M);return(0,k.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=a;function t(x){const M=[];let $=0;const q=x.length;function F(){return $<q?x[$++]():null}function W(N){N!=null&&M.push(N);const G=F();return G?G.then(W):Promise.resolve(M)}return Promise.resolve(null).then(W)}e.sequence=t;function r(x,M=q=>!!q,$=null){let q=0;const F=x.length,W=()=>{if(q>=F)return Promise.resolve($);const N=x[q++];return Promise.resolve(N()).then(B=>M(B)?Promise.resolve(B):W())};return W()}e.first=r;function i(x,M=q=>!!q,$=null){if(x.length===0)return Promise.resolve($);let q=x.length;const F=()=>{q=-1;for(const W of x)W.cancel?.()};return new Promise((W,N)=>{for(const G of x)G.then(B=>{--q>=0&&M(B)?(F(),W(B)):q===0&&W($)}).catch(B=>{--q>=0&&(F(),N(B))})})}e.firstParallel=i;class s{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise(($,q)=>{this.outstandingPromises.push({factory:M,c:$,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const $=M.factory();$.then(M.c,M.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class h extends s{constructor(){super(1)}}e.Queue=h;class c{constructor(){this.queues=new Map}queueFor(M,$=A.extUri){const q=$.getComparisonKey(M);let F=this.queues.get(q);return F||(F=new h,L.Event.once(F.onFinished)(()=>{F?.dispose(),this.queues.delete(q)}),this.queues.set(q,F)),F}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=c;class l{constructor(M,$){this._token=-1,typeof M=="function"&&typeof $=="number"&&this.setIfNotSet(M,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},$)}setIfNotSet(M,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},$))}}e.TimeoutTimer=l;class f{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,$){this.cancel(),this._token=setInterval(()=>{M()},$)}}e.IntervalTimer=f;class S{constructor(M,$){this.timeoutToken=-1,this.runner=M,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=S;class d extends S{constructor(M,$){super(M,$);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=d;class T extends k.Disposable{constructor(M,$,q,F){super();this.maxWorkChunkSize=M,this.maxPendingWork=$,this.throttleDelay=q,this.handler=F,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.maxPendingWork)return!1}else if(this.pending+M.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...M),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new S(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=T,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const $=setTimeout(()=>M(x));let q=!1;return{dispose(){q||(q=!0,clearTimeout($))}}}}else e.runWhenIdle=(x,M)=>{const $=requestIdleCallback(x,typeof M=="number"?{timeout:M}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback($))}}}}();class O{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=O;async function _(x,M,$){let q;for(let F=0;F<$;F++)try{return await x()}catch(W){q=W,await o(M)}throw q}e.retry=_;class z{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(M,$,q){return this._pending={taskId:M,cancel:()=>q?.(),promise:$},$.then(()=>this.donePending(M),()=>this.donePending(M)),$}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let $,q;const F=new Promise((W,N)=>{$=W,q=N});this._next={run:M,promise:F,promiseResolve:$,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=z;class H{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,$)=>{this.completeCallback=M,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise($=>{this.completeCallback(M),this.resolved=!0,$()})}error(M){return new Promise($=>{this.errorCallback(M),this.rejected=!0,$()})}cancel(){new Promise(M=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=V;var U;(function(x){async function M($){let q;const F=await Promise.all($.map(W=>W.then(N=>N,N=>{q||(q=N)})));if(typeof q!="undefined")throw q;return F}x.settled=M})(U=e.Promises||(e.Promises={}))}),define(Z[67],ee([0,1,19,43,8,39,6]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const E="**",v="/",n="[/\\\\]",y="[^/\\\\]",m=/\//g;function g(F){switch(F){case 0:return"";case 1:return`${y}*?`;default:return`(?:${n}|${y}+${n}|${n}${y}+)*?`}}function u(F,W){if(!F)return[];const N=[];let G=!1,B=!1,J="";for(const Q of F){switch(Q){case W:if(!G&&!B){N.push(J),J="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":B=!0;break;case"]":B=!1;break}J+=Q}return J&&N.push(J),N}e.splitGlobAware=u;function C(F){if(!F)return"";let W="";const N=u(F,v);if(N.every(G=>G===E))W=".*";else{let G=!1;N.forEach((B,J)=>{if(B===E){G||(W+=g(2),G=!0);return}let Q=!1,ie="",ne=!1,le="";for(const fe of B){if(fe!=="}"&&Q){ie+=fe;continue}if(ne&&(fe!=="]"||!le)){let me;fe==="-"?me=fe:(fe==="^"||fe==="!")&&!le?me="^":fe===v?me="":me=w.escapeRegExpCharacters(fe),le+=me;continue}switch(fe){case"{":Q=!0;continue;case"[":ne=!0;continue;case"}":W+=`(?:${u(ie,",").map(Pe=>C(Pe)).join("|")})`,Q=!1,ie="";break;case"]":W+="["+le+"]",ne=!1,le="";break;case"?":W+=y;continue;case"*":W+=g(1);continue;default:W+=w.escapeRegExpCharacters(fe)}}J<N.length-1&&(N[J+1]!==E||J+2<N.length)&&(W+=n),G=!1})}return W}const P=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,R=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),r=function(){return!1},i=function(){return null};function s(F,W){if(!F)return i;let N;typeof F!="string"?N=F.pattern:N=F,N=N.trim();const G=`${N}_${!!W.trimForExclusions}`;let B=t.get(G);if(B)return h(B,F);let J;if(P.test(N)){const Q=N.substr(4);B=function(ie,ne){return typeof ie=="string"&&ie.endsWith(Q)?N:null}}else(J=b.exec(c(N,W)))?B=l(J[1],N):(W.trimForExclusions?p:R).test(N)?B=f(N,W):(J=o.exec(c(N,W)))?B=S(J[1].substr(1),N,!0):(J=a.exec(c(N,W)))?B=S(J[1],N,!1):B=d(N);return t.set(G,B),h(B,F)}function h(F,W){return typeof W=="string"?F:function(N,G){return I.isEqualOrParent(N,W.base)?F(L.relative(W.base,N),G):null}}function c(F,W){return W.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function l(F,W){const N=`/${F}`,G=`\\${F}`,B=function(Q,ie){return typeof Q!="string"?null:ie?ie===F?W:null:Q===F||Q.endsWith(N)||Q.endsWith(G)?W:null},J=[F];return B.basenames=J,B.patterns=[W],B.allBasenames=J,B}function f(F,W){const N=q(F.slice(1,-1).split(",").map(ie=>s(ie,W)).filter(ie=>ie!==i),F),G=N.length;if(!G)return i;if(G===1)return N[0];const B=function(ie,ne){for(let le=0,fe=N.length;le<fe;le++)if(N[le](ie,ne))return F;return null},J=N.find(ie=>!!ie.allBasenames);J&&(B.allBasenames=J.allBasenames);const Q=N.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return Q.length&&(B.allPaths=Q),B}function S(F,W,N){const G=L.sep===L.posix.sep,B=G?F:F.replace(m,L.sep),J=L.sep+B,Q=L.posix.sep+F,ie=N?function(ne,le){return typeof ne=="string"&&(ne===B||ne.endsWith(J)||!G&&(ne===F||ne.endsWith(Q)))?W:null}:function(ne,le){return typeof ne=="string"&&(ne===B||!G&&ne===F)?W:null};return ie.allPaths=[(N?"*/":"./")+F],ie}function d(F){try{const W=new RegExp(`^${C(F)}$`);return function(N){return W.lastIndex=0,typeof N=="string"&&W.test(N)?F:null}}catch(W){return i}}function T(F,W,N){return!F||typeof W!="string"?!1:O(F)(W,void 0,N)}e.match=T;function O(F,W={}){if(!F)return r;if(typeof F=="string"||V(F)){const N=s(F,W);if(N===i)return r;const G=function(B,J){return!!N(B,J)};return N.allBasenames&&(G.allBasenames=N.allBasenames),N.allPaths&&(G.allPaths=N.allPaths),G}return M(F,W)}e.parse=O;function _(F){if(!F)return;let W;return N=>(W||(W=(F()||Promise.resolve([])).then(G=>G?H(G):{})),W.then(G=>!!G[N]))}e.hasSiblingPromiseFn=_;function z(F){if(!F)return;let W;return N=>{if(!W){const G=F();W=G?H(G):{}}return!!W[N]}}e.hasSiblingFn=z;function H(F){const W={};for(const N of F)W[N]=!0;return W}function V(F){const W=F;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=V;function U(F){return F.allBasenames||[]}e.getBasenameTerms=U;function x(F){return F.allPaths||[]}e.getPathTerms=x;function M(F,W){const N=q(Object.getOwnPropertyNames(F).map(ie=>$(ie,F[ie],W)).filter(ie=>ie!==i)),G=N.length;if(!G)return i;if(!N.some(ie=>!!ie.requiresSiblings)){if(G===1)return N[0];const ie=function(fe,me){for(let Se=0,Pe=N.length;Se<Pe;Se++){const ke=N[Se](fe,me);if(ke)return ke}return null},ne=N.find(fe=>!!fe.allBasenames);ne&&(ie.allBasenames=ne.allBasenames);const le=N.reduce((fe,me)=>me.allPaths?fe.concat(me.allPaths):fe,[]);return le.length&&(ie.allPaths=le),ie}const B=function(ie,ne,le){let fe;for(let me=0,Se=N.length;me<Se;me++){const Pe=N[me];Pe.requiresSiblings&&le&&(ne||(ne=L.basename(ie)),fe||(fe=ne.substr(0,ne.length-L.extname(ie).length)));const ke=Pe(ie,ne,fe,le);if(ke)return ke}return null},J=N.find(ie=>!!ie.allBasenames);J&&(B.allBasenames=J.allBasenames);const Q=N.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return Q.length&&(B.allPaths=Q),B}function $(F,W,N){if(W===!1)return i;const G=s(F,N);if(G===i)return i;if(typeof W=="boolean")return G;if(W){const B=W.when;if(typeof B=="string"){const J=(Q,ie,ne,le)=>{if(!le||!G(Q,ie))return null;const fe=B.replace("$(basename)",ne),me=le(fe);return(0,A.isThenable)(me)?me.then(Se=>Se?F:null):me?F:null};return J.requiresSiblings=!0,J}}return G}function q(F,W){const N=F.filter(ie=>!!ie.basenames);if(N.length<2)return F;const G=N.reduce((ie,ne)=>{const le=ne.basenames;return le?ie.concat(le):ie},[]);let B;if(W){B=[];for(let ie=0,ne=G.length;ie<ne;ie++)B.push(W)}else B=N.reduce((ie,ne)=>{const le=ne.patterns;return le?ie.concat(le):ie},[]);const J=function(ie,ne){if(typeof ie!="string")return null;if(!ne){let fe;for(fe=ie.length;fe>0;fe--){const me=ie.charCodeAt(fe-1);if(me===47||me===92)break}ne=ie.substr(fe)}const le=G.indexOf(ne);return le!==-1?B[le]:null};J.basenames=G,J.patterns=B,J.allBasenames=G;const Q=F.filter(ie=>!ie.basenames);return Q.push(J),Q}}),define(Z[95],ee([0,1,8,19,67,17,15]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(D=e.Mimes||(e.Mimes={}));let E=[],v=[],n=[];function y(r,i=!1){const s=m(r);E.push(s),s.userConfigured?n.push(s):v.push(s),i&&!s.userConfigured&&E.forEach(h=>{h.mime===s.mime||h.userConfigured||(s.extension&&h.extension===s.extension&&console.warn(`Overwriting extension <<${s.extension}>> to now point to mime <<${s.mime}>>`),s.filename&&h.filename===s.filename&&console.warn(`Overwriting filename <<${s.filename}>> to now point to mime <<${s.mime}>>`),s.filepattern&&h.filepattern===s.filepattern&&console.warn(`Overwriting filepattern <<${s.filepattern}>> to now point to mime <<${s.mime}>>`),s.firstline&&h.firstline===s.firstline&&console.warn(`Overwriting firstline <<${s.firstline}>> to now point to mime <<${s.mime}>>`))})}e.registerTextMime=y;function m(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(w.posix.sep)>=0:!1}}function g(r){r?(E=E.filter(i=>!i.userConfigured),n=[]):(E=[],v=[],n=[])}e.clearTextMimes=g;function u(r,i){let s;if(r)switch(r.scheme){case k.Schemas.file:s=r.fsPath;break;case k.Schemas.data:s=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:s=r.path}if(!s)return[D.unknown];s=s.toLowerCase();const h=(0,w.basename)(s),c=C(s,h,n);if(c)return[c,D.text];const l=C(s,h,v);if(l)return[l,D.text];if(i){const f=P(i);if(f)return[f,D.text]}return[D.unknown]}e.guessMimeTypes=u;function C(r,i,s){let h=null,c=null,l=null;for(let f=s.length-1;f>=0;f--){const S=s[f];if(i===S.filenameLowercase){h=S;break}if(S.filepattern&&(!c||S.filepattern.length>c.filepattern.length)){const d=S.filepatternOnPath?r:i;(0,L.match)(S.filepatternLowercase,d)&&(c=S)}S.extension&&(!l||S.extension.length>l.extension.length)&&i.endsWith(S.extensionLowercase)&&(l=S)}return h?h.mime:c?c.mime:l?l.mime:null}function P(r){if((0,I.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let i=E.length-1;i>=0;i--){const s=E[i];if(!s.firstline)continue;const h=r.match(s.firstline);if(h&&h.length>0)return s.mime}return null}function b(r){return r?typeof r=="string"?r===D.binary||r===D.text||r===D.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function p(r){const i=(0,w.extname)(r);return R[i.toLowerCase()]}e.getMediaMime=p;function o(r){for(const i in R)if(R[i]===r)return i}e.getExtensionForMimeType=o;const a=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){const s=a.exec(r);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:i?void 0:r}e.normalizeMimeType=t}),define(Z[96],ee([0,1,5]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(n){return n.toJSON()}class L{constructor(y){this._uriTransformer=y}transformIncoming(y){const m=this._uriTransformer.transformIncoming(y);return m===y?y:I(w.URI.from(m))}transformOutgoing(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:I(w.URI.from(m))}transformOutgoingURI(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:w.URI.from(m)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function k(n,y,m){if(!n||m>200)return null;if(typeof n=="object"){if(n instanceof w.URI)return y.transformOutgoing(n);for(let g in n)if(Object.hasOwnProperty.call(n,g)){const u=k(n[g],y,m+1);u!==null&&(n[g]=u)}}return null}function A(n,y){const m=k(n,y,0);return m===null?n:m}e.transformOutgoingURIs=A;function D(n,y,m,g){if(!n||g>200)return null;if(typeof n=="object"){if(n.$mid===1)return m?w.URI.revive(y.transformIncoming(n)):y.transformIncoming(n);for(let u in n)if(Object.hasOwnProperty.call(n,u)){const C=D(n[u],y,m,g+1);C!==null&&(n[u]=C)}}return null}function E(n,y){const m=D(n,y,!1,0);return m===null?n:m}e.transformIncomingURIs=E;function v(n,y){const m=D(n,y,!0,0);return m===null?n:m}e.transformAndReviveIncomingURIs=v}),define(Z[30],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(E){return w.test(E)}e.isUUID=I;const L=new Uint8Array(16),k=[];for(let E=0;E<256;E++)k.push(E.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(E){for(let v=0;v<E.length;v++)E[v]=Math.floor(Math.random()*256);return E};function D(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,v="";return v+=k[L[E++]],v+=k[L[E++]],v+=k[L[E++]],v+=k[L[E++]],v+="-",v+=k[L[E++]],v+=k[L[E++]],v+="-",v+=k[L[E++]],v+=k[L[E++]],v+="-",v+=k[L[E++]],v+=k[L[E++]],v+="-",v+=k[L[E++]],v+=k[L[E++]],v+=k[L[E++]],v+=k[L[E++]],v+=k[L[E++]],v+=k[L[E++]],v}e.generateUuid=D}),define(Z[68],ee([0,1,218]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class I{constructor(k="utf8"){this.stringDecoder=new w.StringDecoder(k),this.remaining=null}write(k){const A=[],D=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(D.length<1)return A;let E=0,v,n=E;for(;n<D.length;)if(v=D.charCodeAt(n),v===13||v===10){if(A.push(D.substring(E,n)),n++,n<D.length){const y=v;v=D.charCodeAt(n),(y===13&&v===10||y===10&&v===13)&&n++}E=n}else n++;return this.remaining=E<D.length?D.substr(E):null,A}end(){return this.remaining}}e.LineDecoder=I}),define(Z[97],ee([0,1,34]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const I=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(D){const E=D.replace(/\-/g,":").toLowerCase();return!I.has(E)}function k(){return new Promise(async(D,E)=>{const v=setTimeout(()=>E("Unable to retrieve mac address (timeout after 10s)"),1e4);try{D(await A())}catch(n){E(n)}finally{clearTimeout(v)}})}e.getMac=k;function A(){return new Promise((D,E)=>{try{const v=(0,w.networkInterfaces)();for(let n in v){const y=v[n];if(y){for(const{mac:m}of y)if(L(m))return D(m)}}E("Unable to retrieve mac address (unexpected format)")}catch(v){E(v)}})}}),define(Z[98],ee([0,1,11,30,34,39,97]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,y=0;const m=(0,L.networkInterfaces)();for(let g in m){const u=m[g];if(u)for(const{mac:C,internal:P}of u)P||(y+=1,this._isVirtualMachineMacAdress(C.toUpperCase())&&(n+=1))}this._value=y>0?n/y:0}return this._value}};let D;async function E(){return D||(D=(async()=>await v()||I.generateUuid())()),D}e.getMachineId=E;async function v(){try{const n=await new Promise((m,g)=>{K(["crypto"],m,g)}),y=await(0,A.getMac)();return n.createHash("sha256").update(y,"utf8").digest("hex")}catch(n){w.onUnexpectedError(n);return}}}),define(Z[18],ee([0,1,50,34,219,8,6,4,43,30,66,15,5]),function(K,e,w,I,L,k,A,D,E,v,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function u(U,x=g.UNLINK){if((0,E.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return x===g.UNLINK?P(U):C(U)}async function C(U){try{const x=(0,k.join)((0,I.tmpdir)(),(0,v.generateUuid)());try{await e.Promises.rename(U,x)}catch(M){return P(U)}P(x).catch(M=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function P(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function b(U){if((0,E.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");w.rmdirSync(U,{recursive:!0})}e.rimrafSync=b;async function R(U,x){return a(await(x?p(U):(0,L.promisify)(w.readdir)(U)))}async function p(U){try{return await(0,L.promisify)(w.readdir)(U,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const x=[],M=await R(U);for(const $ of M){let q=!1,F=!1,W=!1;try{const N=await e.Promises.lstat((0,k.join)(U,$));q=N.isFile(),F=N.isDirectory(),W=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}x.push({name:$,isFile:()=>q,isDirectory:()=>F,isSymbolicLink:()=>W})}return x}function o(U){return a(w.readdirSync(U))}e.readdirSync=o;function a(U){return U.map(x=>typeof x=="string"?D.isMacintosh?(0,n.normalizeNFC)(x):x:(x.name=D.isMacintosh?(0,n.normalizeNFC)(x.name):x.name,x))}async function t(U){const x=await R(U),M=[];for(const $ of x)await i.existsDirectory((0,k.join)(U,$))&&M.push($);return M}function r(U,x=1e3){return new Promise(M=>{let $=!1;const q=setInterval(()=>{$||($=!0,w.access(U,F=>{$=!1,F&&(clearInterval(q),M(void 0))}))},x)})}e.whenDeleted=r;var i;(function(U){async function x(q){let F;try{if(F=await e.Promises.lstat(q),!F.isSymbolicLink())return{stat:F}}catch(W){}try{return{stat:await e.Promises.stat(q),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(D.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw N}throw W}}U.stat=x;async function M(q){try{const{stat:F,symbolicLink:W}=await U.stat(q);return F.isFile()&&W?.dangling!==!0}catch(F){}return!1}U.existsFile=M;async function $(q){try{const{stat:F,symbolicLink:W}=await U.stat(q);return F.isDirectory()&&W?.dangling!==!0}catch(F){}return!1}U.existsDirectory=$})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new A.ResourceQueue;function h(U,x,M){return s.queueFor(m.URI.file(U),y.extUriBiasedIgnorePathCase).queue(()=>{const $=S(M);return new Promise((q,F)=>l(U,x,$,W=>W?F(W):q()))})}let c=!0;function l(U,x,M,$){if(!c)return w.writeFile(U,x,{mode:M.mode,flag:M.flag},$);w.open(U,M.flag,M.mode,(q,F)=>{if(q)return $(q);w.writeFile(F,x,W=>{if(W)return w.close(F,()=>$(W));w.fdatasync(F,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),c=!1),w.close(F,G=>$(G))))})})}function f(U,x,M){const $=S(M);if(!c)return w.writeFileSync(U,x,{mode:$.mode,flag:$.flag});const q=w.openSync(U,$.flag,$.mode);try{w.writeFileSync(q,x);try{w.fdatasyncSync(q)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),c=!1}}finally{w.closeSync(q)}}e.writeFileSync=f;function S(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function d(U,x){if(U===x)return;async function M($){try{const q=await e.Promises.lstat($);if(q.isDirectory()||q.isSymbolicLink())return;await e.Promises.utimes($,q.atime,new Date)}catch(q){}}try{await e.Promises.rename(U,x),await M(x)}catch($){if(U.toLowerCase()!==x.toLowerCase()&&$.code==="EXDEV"||U.endsWith("."))await T(U,x,{preserveSymlinks:!1}),await u(U,g.MOVE),await M(x);else throw $}}async function T(U,x,M){return _(U,x,{root:{source:U,target:x},options:M,handledSourcePaths:new Set})}const O=511;async function _(U,x,M){if(M.handledSourcePaths.has(U))return;M.handledSourcePaths.add(U);const{stat:$,symbolicLink:q}=await i.stat(U);if(q){if(M.options.preserveSymlinks)try{return await V(U,x,M)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(q.dangling)return}return $.isDirectory()?z(U,x,$.mode&O,M):H(U,x,$.mode&O)}async function z(U,x,M,$){await e.Promises.mkdir(x,{recursive:!0,mode:M});const q=await R(U);for(const F of q)await _((0,k.join)(U,F),(0,k.join)(x,F),$)}async function H(U,x,M){await e.Promises.copyFile(U,x),await e.Promises.chmod(x,M)}async function V(U,x,M){let $=await e.Promises.readlink(U);(0,E.isEqualOrParent)($,M.root.source,!D.isLinux)&&($=(0,k.join)(M.root.target,$.substr(M.root.source.length+1))),await e.Promises.symlink($,x)}e.Promises=new class{get access(){return(0,L.promisify)(w.access)}get stat(){return(0,L.promisify)(w.stat)}get lstat(){return(0,L.promisify)(w.lstat)}get utimes(){return(0,L.promisify)(w.utimes)}get read(){return(0,L.promisify)(w.read)}get readFile(){return(0,L.promisify)(w.readFile)}get write(){return(0,L.promisify)(w.write)}get appendFile(){return(0,L.promisify)(w.appendFile)}get fdatasync(){return(0,L.promisify)(w.fdatasync)}get truncate(){return(0,L.promisify)(w.truncate)}get rename(){return(0,L.promisify)(w.rename)}get copyFile(){return(0,L.promisify)(w.copyFile)}get open(){return(0,L.promisify)(w.open)}get close(){return(0,L.promisify)(w.close)}get symlink(){return(0,L.promisify)(w.symlink)}get readlink(){return(0,L.promisify)(w.readlink)}get chmod(){return(0,L.promisify)(w.chmod)}get mkdir(){return(0,L.promisify)(w.mkdir)}get unlink(){return(0,L.promisify)(w.unlink)}get rmdir(){return(0,L.promisify)(w.rmdir)}get realpath(){return(0,L.promisify)(w.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return R}get readDirsInDir(){return t}get writeFile(){return h}get rm(){return u}get move(){return d}get copy(){return T}}}),define(Z[99],ee([0,1,50,19,8,18]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const y=(0,L.dirname)(n);if(n===y)return n;const m=((0,L.basename)(n)||n).toLowerCase();try{const u=(0,k.readdirSync)(y).filter(C=>C.toLowerCase()===m);if(u.length===1){const C=A(y);if(C)return(0,L.join)(C,u[0])}else if(u.length>1){const C=u.indexOf(m);if(C>=0){const P=A(y);if(P)return(0,L.join)(P,u[C])}}}catch(g){}return null}e.realcaseSync=A;async function D(n){try{return await k.Promises.realpath(n)}catch(y){const m=v(n);return await k.Promises.access(m,w.constants.R_OK),m}}e.realpath=D;function E(n){try{return w.realpathSync(n)}catch(y){const m=v(n);return w.accessSync(m,w.constants.R_OK),m}}e.realpathSync=E;function v(n){return(0,I.rtrim)((0,L.normalize)(n),L.sep)}}),define(Z[69],ee([0,1,18,34,8]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var E;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(E||(E={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class y{constructor(a,t,r){this.exePath=a,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:o=!1}={}){return o?v===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:o=!1,findPreview:a=!1}={}){const t=m({useAlternateBitness:o});if(!t)return null;const r=L.join(t,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(r))return null;let i=-1,s=null;for(const l of await w.Promises.readdir(r)){let f=-1;if(a){const d=l.indexOf("-");if(d<0)continue;const T=l.substring(0,d);if(!k.test(T)||l.substring(d+1)!=="preview")continue;f=parseInt(T,10)}else{if(!k.test(l))continue;f=parseInt(l,10)}if(f<=i)continue;const S=L.join(r,l,"pwsh.exe");!await w.SymlinkSupport.existsFile(S)||(s=S,i=f)}if(!s)return null;const h=t.includes("x86")?" (x86)":"",c=a?" Preview":"";return new y(s,`PowerShell${c}${h}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const a=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=o?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await w.Promises.readdir(a))if(t.test(i)){const s=L.join(a,i,"pwsh.exe");return new y(s,r)}return null}function C(){const o=L.join(I.homedir(),".dotnet","tools","pwsh.exe");return new y(o,".NET Core PowerShell Global Tool")}function P(){const o=L.join(process.env.windir,v===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(o,"Windows PowerShell",!0)}async function*b(){let o=await g();o&&(yield o),o=await g({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=C(),o&&(yield o),o=await g({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await g({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=P(),o&&(yield o)}async function*R(){for await(const o of b())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=R;async function p(){for await(const o of R())return o;return null}e.getFirstAvailablePowerShellInstallation=p}),define(Z[100],ee([0,1,40,17]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(A){return new Promise((D,E)=>{let v;const n=new Map;function y(g,u,C,P,b){const R=n.get(u);if(g===A||R){const p={name:m(C),cmd:C,pid:g,ppid:u,load:P,mem:b};n.set(g,p),g===A&&(v=p),R&&(R.children||(R.children=[]),R.children.push(p),R.children.length>1&&(R.children=R.children.sort((o,a)=>o.pid-a.pid)))}}function m(g){const u=/--disable-blink-features=Auxclick/,C=/\\watcher\\win32\\CodeHelper\.exe/,P=/--crashes-directory/,b=/\\pipe\\winpty-control/,R=/conhost\.exe/,p=/--type=([a-zA-Z-]+)/;if(C.exec(g))return"watcherService ";if(P.exec(g))return"electron-crash-reporter";if(b.exec(g))return"winpty-process";if(R.exec(g))return"console-window-host (Windows internal process)";let o=p.exec(g);if(o&&o.length===2)return o[1]==="renderer"?u.exec(g)?"shared-process":"window":o[1];const a=/[a-zA-Z-]+\.js/g;let t="";do o=a.exec(g),o&&(t+=o+" ");while(o);return t&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${t}`:g}if(process.platform==="win32"){const g=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,C)=>{K(["windows-process-tree"],u,C)}).then(u=>{u.getProcessList(A,C=>{u.getProcessCpuUsage(C,P=>{const b=new Map;P.forEach(R=>{const p=g(R.commandLine||"");b.set(R.pid,{name:m(p),cmd:p,pid:R.pid,ppid:R.ppid,load:R.cpu||0,mem:R.memory||0})}),v=b.get(A),v?(b.forEach(R=>{const p=b.get(R.ppid);p&&(p.children||(p.children=[]),p.children.push(R))}),b.forEach(R=>{R.children&&(R.children=R.children.sort((p,o)=>p.pid-o.pid))}),D(v)):E(new Error(`Root process ${A} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let g=function(){let u=[v];const C=[];for(;u.length;){const b=u.shift();b&&(C.push(b.pid),b.children&&(u=u.concat(b.children)))}let P=JSON.stringify(I.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);P+=" "+C.join(" "),(0,w.exec)(P,{},(b,R,p)=>{if(b||p)E(b||new Error(p.toString()));else{const o=R.toString().split(`
`);for(let a=0;a<C.length;a++){const t=n.get(C[a]);t.load=parseFloat(o[a])}if(!v){E(new Error(`Root process ${A} not found`));return}D(v)}})};(0,w.exec)("which ps",{},(u,C,P)=>{if(u||P)if(process.platform!=="linux")E(u||new Error(P.toString()));else{const b=JSON.stringify(I.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,w.exec)(b,{},(R,p,o)=>{R||o?E(R||new Error(o.toString())):(k(p,y),g())})}else{const b=C.toString().trim(),R="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${b} ${R}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,o,a)=>{p||a&&!a.includes("screen size is bogus")?E(p||new Error(a.toString())):(k(o,y),process.platform==="linux"?g():v?D(v):E(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=L;function k(A,D){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=A.toString().split(`
`);for(const n of v){const y=E.exec(n.trim());y&&y.length===6&&D(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(Z[101],ee([0,1,8,50,4,66,2,18]),function(K,e,w,I,L,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function E(y,m,g){return n({path:y,isDirectory:!1},m,g)}e.watchFile=E;function v(y,m,g){return n({path:y,isDirectory:!0},m,g)}e.watchFolder=v,e.CHANGE_BUFFER_DELAY=100;function n(y,m,g){const u=(0,w.basename)(y.path),C=new Map;let P=!1,b=[(0,A.toDisposable)(()=>{C.forEach(R=>(0,A.dispose)(R)),C.clear()})];try{const R=(0,I.watch)(y.path);b.push((0,A.toDisposable)(()=>{R.removeAllListeners(),R.close()}));const p=new Set;y.isDirectory&&D.Promises.readdir(y.path).then(o=>o.forEach(a=>p.add(a))),R.on("error",(o,a)=>{P||g(`Failed to watch ${y.path} for changes using fs.watch() (${o}, ${a})`)}),R.on("change",(o,a)=>{if(P)return;let t="";if(a&&(t=a.toString(),L.isMacintosh&&(t=(0,k.normalizeNFC)(t))),!t||o!=="change"&&o!=="rename")return;const r=y.isDirectory?(0,w.join)(y.path,t):y.path;if(y.isDirectory)if(o==="rename"){const i=C.get(r);i&&(0,A.dispose)(i);const s=setTimeout(async()=>{C.delete(r);const h=await D.Promises.exists(r);if(P)return;let c;h?p.has(t)?c="changed":(c="added",p.add(t)):(p.delete(t),c="deleted"),m(c,r)},e.CHANGE_BUFFER_DELAY);C.set(r,(0,A.toDisposable)(()=>clearTimeout(s)))}else{let i;p.has(t)?i="changed":(i="added",p.add(t)),m(i,r)}else if(o==="rename"||t!==u){const i=setTimeout(async()=>{const s=await D.Promises.exists(r);P||(s?(m("changed",r),b=[n(y,m,g)]):m("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,A.dispose)(b),b=[(0,A.toDisposable)(()=>clearTimeout(i))]}else m("changed",r)})}catch(R){D.Promises.exists(y.path).then(p=>{p&&!P&&g(`Failed to watch ${y.path} for changes using fs.watch() (${R.toString()})`)})}return(0,A.toDisposable)(()=>{P=!0,b=(0,A.dispose)(b)})}});var de=this&&this.__decorate||function(K,e,w,I){var L=arguments.length,k=L<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,w):I,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(K,e,w,I);else for(var D=K.length-1;D>=0;D--)(A=K[D])&&(k=(L<3?A(k):L>3?A(e,w,k):A(e,w))||k);return L>3&&k&&Object.defineProperty(e,w,k),k};define(Z[36],ee([0,1,3,2,6,29,11,25,23,16,94,19,64]),function(K,e,w,I,L,k,A,D,E,v,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function u(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(C=e.ResponseType||(e.ResponseType={}));function P(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(b||(b={}));class R{constructor(F){this.buffer=F,this.pos=0}read(F){const W=this.buffer.slice(this.pos,this.pos+F);return this.pos+=W.byteLength,W}}class p{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var o;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(o||(o={}));function a(q){const F=D.VSBuffer.alloc(4);return F.writeUInt32BE(q,0),F}function t(q){return q.read(4).readUInt32BE(0)}function r(q){const F=D.VSBuffer.alloc(1);return F.writeUInt8(q,0),F}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object)},s=typeof Buffer!="undefined";function h(q,F){if(typeof F=="undefined")q.write(i.Undefined);else if(typeof F=="string"){const W=D.VSBuffer.fromString(F);q.write(i.String),q.write(a(W.byteLength)),q.write(W)}else if(s&&Buffer.isBuffer(F)){const W=D.VSBuffer.wrap(F);q.write(i.Buffer),q.write(a(W.byteLength)),q.write(W)}else if(F instanceof D.VSBuffer)q.write(i.VSBuffer),q.write(a(F.byteLength)),q.write(F);else if(Array.isArray(F)){q.write(i.Array),q.write(a(F.length));for(const W of F)h(q,W)}else{const W=D.VSBuffer.fromString(JSON.stringify(F));q.write(i.Object),q.write(a(W.byteLength)),q.write(W)}}function c(q){switch(q.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return q.read(t(q)).toString();case o.Buffer:return q.read(t(q)).buffer;case o.VSBuffer:return q.read(t(q));case o.Array:{const W=t(q),N=[];for(let G=0;G<W;G++)N.push(c(q));return N}case o.Object:return JSON.parse(q.read(t(q)).toString())}}class l{constructor(F,W,N=null,G=1e3){this.protocol=F,this.ctx=W,this.logger=N,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(F,W){this.channels.set(F,W),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const W=this.send([F.type]);this.logger&&this.logger.logOutgoing(W,0,1,P(F.type));return}case 201:case 202:case 204:case 203:{const W=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(W,F.id,1,P(F.type),F.data);return}}}send(F,W=void 0){const N=new p;return h(N,F),h(N,W),this.sendBuffer(N.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(W){return 0}}onRawMessage(F){const W=new R(F),N=c(W),G=c(W),B=N[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,N[1],1,`${u(B)}: ${N[2]}.${N[3]}`,G),this.onPromise({type:B,id:N[1],channelName:N[2],name:N[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,N[1],1,`${u(B)}: ${N[2]}.${N[3]}`,G),this.onEventListen({type:B,id:N[1],channelName:N[2],name:N[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,N[1],1,`${u(B)}`),this.disposeActiveRequest({type:B,id:N[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,N[1],1,`${u(B)}`),this.disposeActiveRequest({type:B,id:N[1]})}}onPromise(F){const W=this.channels.get(F.channelName);if(!W){this.collectPendingRequest(F);return}const N=new k.CancellationTokenSource;let G;try{G=W.call(this.ctx,F.name,F.arg,N.token)}catch(Q){G=Promise.reject(Q)}const B=F.id;G.then(Q=>{this.sendResponse({id:B,data:Q,type:201}),this.activeRequests.delete(F.id)},Q=>{Q instanceof Error?this.sendResponse({id:B,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:B,data:Q,type:203}),this.activeRequests.delete(F.id)});const J=(0,I.toDisposable)(()=>N.cancel());this.activeRequests.set(F.id,J)}onEventListen(F){const W=this.channels.get(F.channelName);if(!W){this.collectPendingRequest(F);return}const N=F.id,B=W.listen(this.ctx,F.name,F.arg)(J=>this.sendResponse({id:N,data:J,type:204}));this.activeRequests.set(F.id,B)}disposeActiveRequest(F){const W=this.activeRequests.get(F.id);W&&(W.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let W=this.pendingRequests.get(F.channelName);W||(W=[],this.pendingRequests.set(F.channelName,W));const N=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:F,timeoutTimer:N})}flushPendingRequests(F){const W=this.pendingRequests.get(F);if(W){for(const N of W)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var f;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(F,W=null){this.protocol=F,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=W}getChannel(F){const W=this;return{call(N,G,B){return W.isDisposed?Promise.reject(A.canceled()):W.requestPromise(F,N,G,B)},listen(N,G){return W.isDisposed?Promise.reject(A.canceled()):W.requestEvent(F,N,G)}}}requestPromise(F,W,N,G=k.CancellationToken.None){const B=this.lastRequestId++,Q={id:B,type:100,channelName:F,name:W,arg:N};if(G.isCancellationRequested)return Promise.reject(A.canceled());let ie;return new Promise((le,fe)=>{if(G.isCancellationRequested)return fe(A.canceled());const me=()=>{const Ne=Oe=>{switch(Oe.type){case 201:this.handlers.delete(B),le(Oe.data);break;case 202:this.handlers.delete(B);const Le=new Error(Oe.data.message);Le.stack=Oe.data.stack,Le.name=Oe.data.name,fe(Le);break;case 203:this.handlers.delete(B),fe(Oe.data);break}};this.handlers.set(B,Ne),this.sendRequest(Q)};let Se=null;this.state===b.Idle?me():(Se=(0,L.createCancelablePromise)(Ne=>this.whenInitialized()),Se.then(()=>{Se=null,me()}));const Pe=()=>{Se?(Se.cancel(),Se=null):this.sendRequest({id:B,type:101}),fe(A.canceled())},ke=G.onCancellationRequested(Pe);ie=(0,I.combinedDisposable)((0,I.toDisposable)(Pe),ke),this.activeRequests.add(ie)}).finally(()=>{this.activeRequests.delete(ie)})}requestEvent(F,W,N){const G=this.lastRequestId++,J={id:G,type:102,channelName:F,name:W,arg:N};let Q=null;const ie=new w.Emitter({onFirstListenerAdd:()=>{Q=(0,L.createCancelablePromise)(le=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(ie),this.sendRequest(J)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(ie),this.sendRequest({id:G,type:103}))}}),ne=le=>ie.fire(le.data);return this.handlers.set(G,ne),ie.event}sendRequest(F){switch(F.type){case 100:case 102:{const W=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(W,F.id,0,`${u(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const W=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(W,F.id,0,u(F.type));return}}}send(F,W=void 0){const N=new p;return h(N,F),h(N,W),this.sendBuffer(N.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(W){return 0}}onBuffer(F){const W=new R(F),N=c(W),G=c(W),B=N[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,P(B)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,N[1],0,P(B),G),this.onResponse({type:N[0],id:N[1],data:G})}}onResponse(F){if(F.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(F.id);W&&W(F)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}de([m.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class d{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:W,onDidClientDisconnect:N})=>{w.Event.once(W.onMessage)(B=>{const J=new R(B),Q=c(J),ie=new l(W,Q),ne=new S(W);this.channels.forEach((fe,me)=>ie.registerChannel(me,fe));const le={channelServer:ie,channelClient:ne,ctx:Q};this._connections.add(le),this._onDidAddConnection.fire(le),N(()=>{ie.dispose(),ne.dispose(),this._connections.delete(le),this._onDidRemoveConnection.fire(le)})})})}get connections(){const F=[];return this._connections.forEach(W=>F.push(W)),F}getChannel(F,W){const N=this;return{call(G,B,J){let Q;if((0,v.isFunction)(W)){let ne=(0,E.getRandomElement)(N.connections.filter(W));Q=ne?Promise.resolve(ne):w.Event.toPromise(w.Event.filter(N.onDidAddConnection,W))}else Q=W.routeCall(N,G,B);const ie=Q.then(ne=>ne.channelClient.getChannel(F));return O(ie).call(G,B,J)},listen(G,B){if((0,v.isFunction)(W))return N.getMulticastEvent(F,W,G,B);const J=W.routeEvent(N,G,B).then(Q=>Q.channelClient.getChannel(F));return O(J).listen(G,B)}}}getMulticastEvent(F,W,N,G){const B=this;let J=new I.DisposableStore;const Q=new w.Emitter({onFirstListenerAdd:()=>{J=new I.DisposableStore;const ie=new w.EventMultiplexer,ne=new Map,le=me=>{const Pe=me.channelClient.getChannel(F).listen(N,G),ke=ie.add(Pe);ne.set(me,ke)},fe=me=>{const Se=ne.get(me);!Se||(Se.dispose(),ne.delete(me))};B.connections.filter(W).forEach(le),w.Event.filter(B.onDidAddConnection,W)(le,void 0,J),B.onDidRemoveConnection(fe,void 0,J),ie.event(Q.fire,Q,J),J.add(ie)},onLastListenerRemove:()=>{J.dispose()}});return Q.event}registerChannel(F,W){this.channels.set(F,W),this._connections.forEach(N=>{N.channelServer.registerChannel(F,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class T{constructor(F,W,N=null){const G=new p;h(G,W),F.send(G.buffer),this.channelClient=new S(F,N),this.channelServer=new l(F,W,N)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,W){this.channelServer.registerChannel(F,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function O(q){return{call(F,W,N){return q.then(G=>G.call(F,W,N))},listen(F,W){const N=new w.Relay;return q.then(G=>N.input=G.listen(F,W)),N.event}}}e.getDelayedChannel=O;function _(q){let F=!1;return{call(W,N,G){return F?q.call(W,N,G):(0,L.timeout)(0).then(()=>F=!0).then(()=>q.call(W,N,G))},listen(W,N){if(F)return q.listen(W,N);const G=new w.Relay;return(0,L.timeout)(0).then(()=>F=!0).then(()=>G.input=q.listen(W,N)),G.event}}}e.getNextTickChannel=_;class z{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const W of F.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await w.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=z;var H;(function(q){function F(G,B){const J=G,Q=B&&B.disableMarshalling,ie=new Map;for(const ne in J)N(ne)&&ie.set(ne,w.Event.buffer(J[ne],!0));return new class{listen(ne,le){const fe=ie.get(le);if(fe)return fe;throw new Error(`Event not found: ${le}`)}call(ne,le,fe){const me=J[le];if(typeof me=="function"){if(!Q&&Array.isArray(fe))for(let Se=0;Se<fe.length;Se++)fe[Se]=(0,n.revive)(fe[Se]);return me.apply(J,fe)}throw new Error(`Method not found: ${le}`)}}}q.fromService=F;function W(G,B){const J=B&&B.disableMarshalling;return new Proxy({},{get(Q,ie){if(typeof ie=="string")return B?.properties?.has(ie)?B.properties.get(ie):N(ie)?G.listen(ie):async function(...ne){let le;B&&!(0,v.isUndefinedOrNull)(B.context)?le=[B.context,...ne]:le=ne;const fe=await G.call(ie,le);return J?fe:(0,n.revive)(fe)};throw new Error(`Property not found: ${String(ie)}`)}})}q.toService=W;function N(G){return G[0]==="o"&&G[1]==="n"&&y.isUpperAsciiLetter(G.charCodeAt(2))}})(H=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let F=q.toString();if(F!=="[object Object]")return F}return q}function x(q){return Array.isArray(q)?q.map(U):U(q)}function M(q,F,W,N,G,B,J){J=x(J);const Q=V[G],ie=Q[N%Q.length];let ne=[`%c[${q}]%c[${String(F).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(B)?(ne=ne.concat(J),ne.push(")")):ne.push(J),console.log.apply(console,ne)}e.logWithColors=M;class ${constructor(F,W){this._outgoingPrefix=F,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,W,N,G,B){this._totalOutgoing+=F,M(this._outgoingPrefix,this._totalOutgoing,F,W,N,G,B)}logIncoming(F,W,N,G,B){this._totalIncoming+=F,M(this._incomingPrefix,this._totalIncoming,F,W,N,G,B)}}e.IPCLogger=$}),define(Z[102],ee([0,1,3,36,25]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(E){this.port=E,this.onMessage=w.Event.fromDOMEventEmitter(this.port,"message",v=>L.VSBuffer.wrap(v.data)),E.start()}send(E){this.port.postMessage(E.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class A extends I.IPCClient{constructor(E,v){const n=new k(E);super(n,v);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=A}),define(Z[103],ee([0,1,104,3,36,102]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends L.IPCServer{static getOnDidClientConnect(){const E=I.Event.fromNodeEventEmitter(w.ipcRenderer,"vscode:createMessageChannel",(v,n)=>n);return I.Event.map(E,v=>{const{port1:n,port2:y}=new MessageChannel,g={protocol:new k.Protocol(n),onDidClientDisconnect:I.Event.fromDOMEventEmitter(n,"close")};return w.ipcRenderer.postMessage("vscode:createMessageChannelResult",v,[y]),g})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(Z[105],ee([0,1,11,25]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(D,E){D.proxyAuthorization&&(D.headers={...D.headers||{},"Proxy-Authorization":D.proxyAuthorization});const v=new XMLHttpRequest;return new Promise((n,y)=>{v.open(D.type||"GET",D.url||"",!0,D.user,D.password),k(v,D),v.responseType="arraybuffer",v.onerror=m=>y(new Error(v.statusText&&"XHR failed: "+v.statusText||"XHR failed")),v.onload=m=>{n({res:{statusCode:v.status,headers:A(v)},stream:(0,I.bufferToStream)(I.VSBuffer.wrap(new Uint8Array(v.response)))})},v.ontimeout=m=>y(new Error(`XHR timeout: ${D.timeout}ms`)),D.timeout&&(v.timeout=D.timeout),v.send(D.data),E.onCancellationRequested(()=>{v.abort(),y((0,w.canceled)())})})}e.request=L;function k(D,E){if(E.headers){e:for(let v in E.headers){switch(v){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}D.setRequestHeader(v,E.headers[v])}}}function A(D){const E=Object.create(null);for(const v of D.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(v){const n=v.indexOf(":");E[v.substr(0,n).trim().toLowerCase()]=v.substr(n+1).trim()}return E}}),define(Z[70],ee([0,1,2,3,6,16]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var A;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));var D;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(D||(D={}));class E extends w.Disposable{constructor(y,m=Object.create(null)){super();this.database=y,this.options=m,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=D.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((m,g)=>this.accept(g,m)),y.deleted?.forEach(m=>this.accept(m,void 0))}accept(y,m){if(this.state===D.Closed)return;let g=!1;(0,k.isUndefinedOrNull)(m)?g=this.cache.delete(y):this.cache.get(y)!==m&&(this.cache.set(y,m),g=!0),g&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===D.None&&(this.state=D.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,m){const g=this.cache.get(y);return(0,k.isUndefinedOrNull)(g)?m:g}getBoolean(y,m){const g=this.get(y);return(0,k.isUndefinedOrNull)(g)?m:g==="true"}getNumber(y,m){const g=this.get(y);return(0,k.isUndefinedOrNull)(g)?m:parseInt(g,10)}async set(y,m){if(this.state===D.Closed)return;if((0,k.isUndefinedOrNull)(m))return this.delete(y);const g=String(m);if(this.cache.get(y)!==g)return this.cache.set(y,g),this.pendingInserts.set(y,g),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async delete(y){if(!(this.state===D.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=D.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(y){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class v{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((m,g)=>this.items.set(g,m)),y.delete&&y.delete.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=v}),define(Z[106],ee([9,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[56],ee([0,1,106]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,L=I*60,k=L*24,A=k*7,D=k*30,E=k*365;function v(y,m){typeof y!="number"&&(y=y.getTime());const g=Math.round((new Date().getTime()-y)/1e3);if(g<-30)return(0,w.localize)(0,null,v(new Date().getTime()+g*1e3,!1));if(g<30)return(0,w.localize)(1,null);let u;return g<I?(u=g,m?u===1?(0,w.localize)(2,null,u):(0,w.localize)(3,null,u):u===1?(0,w.localize)(4,null,u):(0,w.localize)(5,null,u)):g<L?(u=Math.floor(g/I),m?u===1?(0,w.localize)(6,null,u):(0,w.localize)(7,null,u):u===1?(0,w.localize)(8,null,u):(0,w.localize)(9,null,u)):g<k?(u=Math.floor(g/L),m?u===1?(0,w.localize)(10,null,u):(0,w.localize)(11,null,u):u===1?(0,w.localize)(12,null,u):(0,w.localize)(13,null,u)):g<A?(u=Math.floor(g/k),m?u===1?(0,w.localize)(14,null,u):(0,w.localize)(15,null,u):u===1?(0,w.localize)(16,null,u):(0,w.localize)(17,null,u)):g<D?(u=Math.floor(g/A),m?u===1?(0,w.localize)(18,null,u):(0,w.localize)(19,null,u):u===1?(0,w.localize)(20,null,u):(0,w.localize)(21,null,u)):g<E?(u=Math.floor(g/D),m?u===1?(0,w.localize)(22,null,u):(0,w.localize)(23,null,u):u===1?(0,w.localize)(24,null,u):(0,w.localize)(25,null,u)):(u=Math.floor(g/E),m?u===1?(0,w.localize)(26,null,u):(0,w.localize)(27,null,u):u===1?(0,w.localize)(28,null,u):(0,w.localize)(29,null,u))}e.fromNow=v;function n(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Z[107],ee([9,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[37],ee([0,1,107,16,23]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(v,n){return n&&(v.stack||v.stacktrace)?w.localize(0,null,D(v),A(v.stack)||A(v.stacktrace)):D(v)}function A(v){return Array.isArray(v)?v.join(`
`):v}function D(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?w.localize(1,null,v.message):v.message||w.localize(2,null)}function E(v=null,n=!1){if(!v)return w.localize(3,null);if(Array.isArray(v)){const y=L.coalesce(v),m=E(y[0],n);return y.length>1?w.localize(4,null,m,y.length):m}if(I.isString(v))return v;if(v.detail){const y=v.detail;if(y.error)return k(y.error,n);if(y.exception)return k(y.exception,n)}return v.stack?k(v,n):v.message?v.message:w.localize(5,null)}e.toErrorMessage=E}),define(Z[108],ee([9,10]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[71],ee([0,1,8,18,40,108,35,16,26,43,4,68,17]),function(K,e,w,I,L,k,A,D,E,v,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function g(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(o,a){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const r=L.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(i=>{r.once("error",s=>{i({success:!1,error:s})}),r.once("exit",(s,h)=>{i(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?g(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=m.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(r=>{L.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(i,s,h)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function C(o=A.env){return o.comspec||"cmd.exe"}e.getWindowsShell=C;class P{constructor(a,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=a,this.args=t,this.shell=r,this.options=i;else{const s=a;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(A.env).forEach(h=>{s[h]=A.env[h]}),Object.keys(this.options.env).forEach(h=>{s[h]=this.options.env[h]}),this.options.env=s}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(w.sep);return t!==-1&&(a=a.substring(t+1)),P.WellKnowCommands[a]?a:"other"}start(a){return n.isWindows&&(this.options&&this.options.cwd&&v.isUNC(this.options.cwd)||!this.options&&v.isUNC(A.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(t=>{let r,i;const s=new Promise((h,c)=>{r=h,i=c});if(t){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=L.exec(h,this.options,(c,l,f)=>{this.childProcess=null;const S=c;S&&S.killed?i({killed:this.terminateRequested,stdout:l.toString(),stderr:f.toString()}):this.handleExec(r,a,c,l,f)})}else{let h=null;const c=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,a,i);const f={terminated:this.terminateRequested};D.isNumber(l)&&(f.cmdCode=l),r(f)};if(this.shell&&n.isWindows){const l=E.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let f=!1,S=!1;const d=[];let T=this.ensureQuotes(this.cmd);d.push(T.value),f=T.quoted,this.args&&this.args.forEach(_=>{T=this.ensureQuotes(_),d.push(T.value),S=S&&T.quoted});const O=["/s","/c"];f?S?O.push('"'+d.join(" ")+'"'):d.length>1?O.push('"'+d[0]+'" '+d.slice(1).join(" ")):O.push('"'+d[0]+'"'):O.push(d.join(" ")),h=L.spawn(C(),O,l)}else this.cmd&&(h=L.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(D.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",l=>{this.childProcess=null,i({terminated:this.terminateRequested,error:l})}),h.pid&&(this.childProcess.on("close",c),this.handleSpawn(h,r,a,i,!0)))}return s})}handleClose(a,t,r,i){}ensureQuotes(a){return P.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,u(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!n.isWindows)return a(!1);const t=L.spawn(C(),["/s","/c"]);t.on("error",r=>a(!0)),t.on("exit",r=>a(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class b extends P{constructor(a,t,r,i){super(a,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,r,i,s){[i,s].forEach((h,c)=>{const l=new y.LineDecoder;l.write(h).forEach(d=>{t({line:d,source:c===0?0:1})});const S=l.end();S&&t({line:S,source:c===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,t,r,i,s){const h=new y.LineDecoder,c=new y.LineDecoder;a.stdout.on("data",l=>{h.write(l).forEach(S=>r({line:S,source:0}))}),a.stderr.on("data",l=>{c.write(l).forEach(S=>r({line:S,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=c}handleClose(a,t,r,i){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&r({line:h,source:1})}}e.LineProcess=b;function R(o){let a=[],t=!1;const r=function(i){if(t){a.push(i);return}(!o.send(i,h=>{if(h&&console.error(h),t=!1,a.length>0){const c=a.slice(0);a=[],c.forEach(l=>r(l))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=R;var p;(function(o){async function a(t,r,i){if(w.isAbsolute(t))return t;if(r===void 0&&(r=A.cwd()),w.dirname(t)!=="."||(i===void 0&&D.isString(A.env.PATH)&&(i=A.env.PATH.split(w.delimiter)),i===void 0||i.length===0))return w.join(r,t);async function h(c){return await I.Promises.exists(c)?!(await I.Promises.stat(c)).isDirectory():!1}for(let c of i){let l;if(w.isAbsolute(c)?l=w.join(c,t):l=w.join(r,c,t),await h(l))return l;let f=l+".com";if(await h(f)||(f=l+".exe",await h(f)))return f}return w.join(r,t)}o.findExecutable=a})(p=e.win32||(e.win32={}))}),define(Z[109],ee([0,1,34,4,69,71]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(g,u){return g===1?I.isWindows?y():k.getWindowsShell(u):v(g,u)}e.getSystemShell=A;function D(g,u){return g===1?I.isWindows?m(u):k.getWindowsShell(u):v(g,u)}e.getSystemShellSync=D;let E=null;function v(g,u){if(I.isLinux&&g===2||I.isMacintosh&&g===3)return"/bin/bash";if(!E){let C;if(I.isWindows)C="/bin/bash";else{if(C=u.SHELL,!C)try{C=(0,w.userInfo)().shell}catch(P){}C||(C="sh"),C==="/bin/false"&&(C="/bin/bash")}E=C}return E}let n=null;async function y(){return n||(n=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),n}function m(g){if(n)return n;const u=I.isWindows&&parseFloat((0,w.release)())>=10,C=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${g.windir}\\${C?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?P:k.getWindowsShell(g)}}),define(Z[51],ee([0,1,40,2,6,26,3,71,36,93,29,11,25,4]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends E.ChannelServer{constructor(b){super({send:R=>{try{process.send&&process.send(R.buffer.toString("base64"))}catch(p){}},onMessage:A.Event.fromNodeEventEmitter(process,"message",R=>m.VSBuffer.wrap(Buffer.from(R,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=u;class C{constructor(b,R){this.modulePath=b,this.options=R,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new A.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const p=R&&R.timeout?R.timeout:6e4;this.disposeDelayer=new L.Delayer(p),this.child=null,this._client=null}getChannel(b){const R=this;return{call(p,o,a){return R.requestPromise(b,p,o,a)},listen(p,o){return R.requestEvent(b,p,o)}}}requestPromise(b,R,p,o=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(b),t=(0,L.createCancelablePromise)(s=>a.call(R,p,s)),r=o.onCancellationRequested(()=>t.cancel()),i=(0,I.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,R,p){if(!this.disposeDelayer)return A.Event.None;this.disposeDelayer.cancel();let o;const a=new A.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(b).listen(R,p)(a.fire,a),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],R=Object.create(null);R.env={...(0,k.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(R.env={...R.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(R.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(R.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(R.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),R.execArgv===void 0&&(R.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),g.isMacintosh&&R.env&&delete R.env.DYLD_LIBRARY_PATH,this.child=(0,w.fork)(this.modulePath,b,R);const p=new A.Emitter;A.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if((0,v.isRemoteConsoleLog)(h)){(0,v.log)(h,`IPC Library: ${this.options.serverName}`);return}p.fire(m.VSBuffer.wrap(Buffer.from(h,"base64")))});const a=this.options.useQueue?(0,D.createQueuedSender)(this.child):this.child,t=h=>this.child&&this.child.connected&&a.send(h.buffer.toString("base64")),r=p.event,i={send:t,onMessage:r};this._client=new E.ChannelClient(i);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,c)=>{process.removeListener("exit",s),this.activeRequests.forEach(l=>(0,I.dispose)(l)),this.activeRequests.clear(),h!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:c})})}return this._client}getCachedChannel(b){let R=this.channels.get(b);return R||(R=this.client.getChannel(b),this.channels.set(b,R)),R}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(Z[110],ee([9,10]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[111],ee([9,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[112],ee([9,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(Z[113],ee([9,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(Z[114],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[115],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[116],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[117],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[118],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[119],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[120],ee([9,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[121],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[122],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[123],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[124],ee([9,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[125],ee([9,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[126],ee([9,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[127],ee([9,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[128],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[129],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[130],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[131],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[132],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[133],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[134],ee([0,1,8,15,64,56,17,5,35]),function(K,e,w,I,L,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class v{constructor(u,C,P){this._args=u,this.paths=C,this.productService=P}get appRoot(){return(0,w.dirname)(A.FileAccess.asFileUri("",K).fsPath)}get userHome(){return D.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return D.URI.file((0,w.join)(this.userDataPath,"User"))}get tmpDir(){return D.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,w.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return D.URI.file((0,w.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(D.URI.file((0,w.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return D.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return D.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=E.env.VSCODE_PORTABLE;return u?D.URI.file((0,w.join)(u,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return D.URI.file((0,w.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,w.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,w.resolve)(u):(0,w.normalize)((0,w.join)(A.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?(0,w.resolve)(u):(0,w.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,w.resolve)(u);const C=E.env.VSCODE_EXTENSIONS;if(C)return C;const P=E.env.VSCODE_PORTABLE;return P?(0,w.join)(P,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(C=>/^[^:/?#]+?:\/\//.test(C)?D.URI.parse(C):D.URI.file((0,w.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?D.URI.parse(u):D.URI.file((0,w.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!E.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(D.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return D.URI.file((0,w.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([L.memoize],v.prototype,"appRoot",null),de([L.memoize],v.prototype,"userHome",null),de([L.memoize],v.prototype,"userDataPath",null),de([L.memoize],v.prototype,"appSettingsHome",null),de([L.memoize],v.prototype,"tmpDir",null),de([L.memoize],v.prototype,"userRoamingDataHome",null),de([L.memoize],v.prototype,"settingsResource",null),de([L.memoize],v.prototype,"userDataSyncHome",null),de([L.memoize],v.prototype,"userDataSyncLogResource",null),de([L.memoize],v.prototype,"sync",null),de([L.memoize],v.prototype,"machineSettingsResource",null),de([L.memoize],v.prototype,"globalStorageHome",null),de([L.memoize],v.prototype,"workspaceStorageHome",null),de([L.memoize],v.prototype,"keybindingsResource",null),de([L.memoize],v.prototype,"keyboardLayoutResource",null),de([L.memoize],v.prototype,"argvResource",null),de([L.memoize],v.prototype,"snippetsHome",null),de([L.memoize],v.prototype,"isExtensionDevelopment",null),de([L.memoize],v.prototype,"untitledWorkspacesHome",null),de([L.memoize],v.prototype,"installSourcePath",null),de([L.memoize],v.prototype,"builtinExtensionsPath",null),de([L.memoize],v.prototype,"extensionsPath",null),de([L.memoize],v.prototype,"extensionDevelopmentLocationURI",null),de([L.memoize],v.prototype,"extensionDevelopmentKind",null),de([L.memoize],v.prototype,"extensionTestsLocationURI",null),de([L.memoize],v.prototype,"debugExtensionHost",null),de([L.memoize],v.prototype,"serviceMachineIdResource",null),de([L.memoize],v.prototype,"telemetryLogResource",null),de([L.memoize],v.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=v;function n(g,u){return m(g["inspect-extensions"],g["inspect-brk-extensions"],5870,u,g.debugId)}e.parseExtensionHostPort=n;function y(g,u){return m(g["inspect-search"],g["inspect-brk-search"],5876,u)}e.parseSearchPort=y;function m(g,u,C,P,b){const p=Number(u||g)||(P?null:C),o=p?Boolean(!!u):!1;return{port:p,break:o,debugId:b}}}),define(Z[135],ee([0,1,220,112,4]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,I.localize)(0,null),e:(0,I.localize)(1,null),t:(0,I.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,I.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,I.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,I.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,I.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,I.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,I.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,I.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,I.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,I.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,I.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,I.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,I.localize)(14,null)},category:{type:"string",cat:"e",description:(0,I.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,I.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,I.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,I.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,I.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,I.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,I.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,I.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,I.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,I.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,I.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,I.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,I.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,I.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,I.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,I.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,I.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{}};function D(u,C,P=A){const b={},R=[],p=[];for(let r in C){const i=C[r];i.alias&&(b[r]=i.alias),i.type==="string"||i.type==="string[]"?(R.push(r),i.deprecates&&R.push(i.deprecates)):i.type==="boolean"&&(p.push(r),i.deprecates&&p.push(i.deprecates))}const o=w(u,{string:R,boolean:p,alias:b}),a={},t=o;a._=o._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in C){const i=C[r];i.alias&&delete t[i.alias];let s=t[r];i.deprecates&&t.hasOwnProperty(i.deprecates)&&(s||(s=t[i.deprecates]),delete t[i.deprecates]),typeof s!="undefined"&&(i.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):i.type==="string"&&Array.isArray(s)&&(s=s.pop(),P.onMultipleValues(r,s)),a[r]=s),delete t[r]}for(let r in t)P.onUnknownOption(r);return a}e.parseArgs=D;function E(u,C){let P="";return C.args&&(Array.isArray(C.args)?P=` <${C.args.join("> <")}>`:P=` <${C.args}>`),C.alias?`-${C.alias} --${u}${P}`:`--${u}${P}`}function v(u,C){let P=0,b=[];for(const a in u){const t=u[a],r=E(a,t);P=Math.max(P,r.length),b.push([r,t.description])}let R=P+2+1;if(C-R<25)return b.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let p=C-R-1,o=[];for(const a of b){let t=a[0],r=y(a[1],p),i=n(R-t.length-2);o.push("  "+t+i+r[0]);for(let s=1;s<r.length;s++)o.push(n(R)+r[s])}return o}e.formatOptions=v;function n(u){return" ".repeat(u)}function y(u,C){let P=[];for(;u.length;){let b=u.length<C?u.length:u.lastIndexOf(" ",C),R=u.slice(0,b).trim();u=u.slice(b),P.push(R)}return P}function m(u,C,P,b,R=!0){const p=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${u} ${P}`];o.push(""),o.push(`${(0,I.localize)(32,null)}: ${C} [${(0,I.localize)(33,null)}][${(0,I.localize)(34,null)}...]`),o.push(""),R&&(L.isWindows?o.push((0,I.localize)(35,null,C)):o.push((0,I.localize)(36,null,C)),o.push(""));const a={};for(const t in b){const r=b[t];if(r.description&&r.cat){let i=a[r.cat];i||(a[r.cat]=i={}),i[t]=r}}for(let t in a){const r=t;let i=a[r];i&&(o.push(k[r]),o.push(...v(i,p)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=m;function g(u,C){return`${u||(0,I.localize)(37,null)}
${C||(0,I.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=g}),function(){"use strict";function K(e,w,I,L){function k(D){const E=A(D),v=[E];return e.isAbsolute(E)||v.unshift(L),e.resolve(...v)}function A(D){const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return e.join(v,I);const n=D["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=e.join(y,"AppData","Roaming")}break;case"darwin":v=e.join(w.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(v,I)}return{getUserDataPath:k}}if(typeof define=="function")define(Z[136],ee([0,137,34,17,15,35]),function(e,w,I,L,k,A){const D=k.dirname(L.FileAccess.asFileUri("",e)),E=e.__$__nodeRequire(k.joinPath(D,"package.json").fsPath);return K(w,I,E.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),I=require("os");module.exports=K(w,I,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[138],ee([0,1,34,136,134]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends L.AbstractNativeEnvironmentService{constructor(D,E){super(D,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,I.getUserDataPath)(D)},E)}}e.NativeEnvironmentService=k}),define(Z[139],ee([0,1,5]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const I=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,D=/^\s*url\s*=\s*(.+\S)\s*$/mg,E=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function v(P){const b=P.match(A);return b?b[1]:null}function n(P){if(P.indexOf("://")===-1){const b=P.match(I);return b?v(b[2]):null}try{const b=w.URI.parse(P);if(b.authority)return v(b.authority)}catch(b){}return null}function y(P,b){const R=new Set;let p;for(;p=D.exec(P);){const a=n(p[1]);a&&R.add(a)}const o=new Set(b);return Array.from(R).map(a=>o.has(a)?a:a.replace(E,"a"))}e.getDomainsOfRemotes=y;function m(P){const b=P.match(k);return b?b[2]:null}function g(P,b,R){return P&&b?(R&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${P}${b}`:`${P}/${b}`):null}function u(P,b){if(P.indexOf("://")===-1){const R=P.match(L);if(R)return g(R[2],R[3],b)}try{const R=w.URI.parse(P);if(R.authority)return g(m(R.authority),R.path,b)}catch(R){}return null}function C(P,b=!1){const R=[];let p;for(;p=D.exec(P);){const o=u(p[1],b);o&&R.push(o)}return R}e.getRemotes=C}),define(Z[140],ee([0,1,3,5,96,26,2]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function D(u,C){return I.URI.revive(C?C.transformIncoming(u):u)}function E(u,C){return C?C.transformOutgoingURI(u):u}function v(u,C){C=C||L.DefaultURITransformer;const P=u.manifest;return{...(0,L.transformAndReviveIncomingURIs)({...u,manifest:void 0},C),manifest:P}}function n(u,C){return C?(0,k.cloneAndChange)(u,P=>P instanceof I.URI?C.transformOutgoingURI(P):void 0):u}class y{constructor(C,P){this.service=C,this.getUriTransformer=P,this.onInstallExtension=w.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtensions=w.Event.buffer(C.onDidInstallExtensions,!0),this.onUninstallExtension=w.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=w.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,P){const b=this.getUriTransformer(C);switch(P){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return w.Event.map(this.onDidInstallExtensions,R=>R.map(p=>({...p,local:p.local?n(p.local,b):p.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,P,b){const R=this.getUriTransformer(C);switch(P){case"zip":return this.service.zip(v(b[0],R)).then(p=>E(p,R));case"unzip":return this.service.unzip(D(b[0],R));case"install":return this.service.install(D(b[0],R),b[1]);case"getManifest":return this.service.getManifest(D(b[0],R));case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(v(b[0],R),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(v(b[0],R));case"getInstalled":return this.service.getInstalled(b[0]).then(p=>p.map(o=>n(o,R)));case"updateMetadata":return this.service.updateMetadata(v(b[0],R),b[1]).then(p=>n(p,R));case"updateExtensionScope":return this.service.updateExtensionScope(v(b[0],R),b[1]).then(p=>n(p,R));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class m extends A.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new w.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new w.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new w.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new w.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(P=>this._onInstallExtension.fire({identifier:P.identifier,source:this.isUriComponents(P.source)?I.URI.revive(P.source):P.source}))),this._register(this.channel.listen("onDidInstallExtensions")(P=>this._onDidInstallExtensions.fire(P.map(b=>({...b,local:b.local?v(b.local,null):b.local,source:this.isUriComponents(b.source)?I.URI.revive(b.source):b.source}))))),this._register(this.channel.listen("onUninstallExtension")(P=>this._onUninstallExtension.fire(P))),this._register(this.channel.listen("onDidUninstallExtension")(P=>this._onDidUninstallExtension.fire(P)))}isUriComponents(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(P=>I.URI.revive(P)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C,P){return Promise.resolve(this.channel.call("install",[C,P])).then(b=>v(b,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}async canInstall(C){return!0}installFromGallery(C,P){return Promise.resolve(this.channel.call("installFromGallery",[C,P])).then(b=>v(b,null))}uninstall(C,P){return Promise.resolve(this.channel.call("uninstall",[C,P]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(P=>P.map(b=>v(b,null)))}updateMetadata(C,P){return Promise.resolve(this.channel.call("updateMetadata",[C,P])).then(b=>v(b,null))}updateExtensionScope(C,P){return Promise.resolve(this.channel.call("updateExtensionScope",[C,P])).then(b=>v(b,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=m;class g{constructor(C){this.service=C}listen(C,P){throw new Error("Invalid listen")}call(C,P,b){switch(P){case"getConfigBasedTips":return this.service.getConfigBasedTips(I.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(Z[141],ee([0,1,26]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const I=/^%([\w\d.-]+)%$/i;function L(k,A){const D=E=>{if(typeof E!="string")return;const v=I.exec(E);if(!v)return;const n=A[v[1]]??E;return typeof n=="string"?n:typeof n.message=="string"?n.message:E};return(0,w.cloneAndChange)(k,D)}e.localizeManifest=L}),define(Z[142],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class w{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,A,D,E){return this.channel.call("promptImportantExtensionsInstallNotification",[k,A,D,E])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=w;class I{constructor(k){this.service=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,D){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(D[0],D[1],D[2],D[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=I}),define(Z[72],ee([0,1,120]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function k(m){return m=m.trim(),m==="*"||I.test(m)}e.isValidVersionStr=k;function A(m){if(!k(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=m.match(I);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=A;function D(m){if(!m)return null;let g=m.majorBase,u=m.majorMustEqual,C=m.minorBase,P=m.minorMustEqual,b=m.patchBase,R=m.patchMustEqual;m.hasCaret&&(g===0||(P=!1),R=!1);let p=0;if(m.preRelease){const o=L.exec(m.preRelease);if(o){const[,a,t,r]=o;p=Date.UTC(Number(a),Number(t)-1,Number(r))}}return{majorBase:g,majorMustEqual:u,minorBase:C,minorMustEqual:P,patchBase:b,patchMustEqual:R,isMinimum:m.hasGreaterEquals,notBefore:p}}e.normalizeVersion=D;function E(m,g,u){let C;typeof m=="string"?C=D(A(m)):C=m;let P;g instanceof Date?P=g.getTime():typeof g=="string"&&(P=new Date(g).getTime());let b;if(typeof u=="string"?b=D(A(u)):b=u,!C||!b)return!1;let R=C.majorBase,p=C.minorBase,o=C.patchBase,a=b.majorBase,t=b.minorBase,r=b.patchBase,i=b.notBefore,s=b.majorMustEqual,h=b.minorMustEqual,c=b.patchMustEqual;return b.isMinimum?R>a?!0:R<a?!1:p>t?!0:p<t||P&&P<i?!1:o>=r:(R===1&&a===0&&(!s||!h||!c)&&(a=1,t=0,r=0,s=!0,h=!1,c=!1),R<a?!1:R>a?!s:p<t?!1:p>t?!h:o<r?!1:o>r?!c:!(P&&P<i))}e.isValidVersion=E;function v(m,g,u,C){return u.isBuiltin||typeof u.main=="undefined"?!0:y(m,g,u.engines.vscode,C)}e.isValidExtensionVersion=v;function n(m,g,u){return m==="*"||y(g,u,m)}e.isEngineValid=n;function y(m,g,u,C=[]){let P=D(A(u));if(!P)return C.push(w.localize(0,null,u)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return C.push(w.localize(1,null,u)),!1}else if(!P.majorMustEqual)return C.push(w.localize(2,null,u)),!1;return E(m,g,P)?!0:(C.push(w.localize(3,null,m,u)),!1)}}),define(Z[143],ee([0,1,36,51,2,17]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends L.Disposable{constructor(E,v,n,y){super();this.folders=E,this.onDidFilesChange=v,this.onLogMessage=n,this.verboseLogging=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const E=this._register(new I.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(E.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(E.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.setFolders(this.folders)}setVerboseLogging(E){this.verboseLogging=E,!this.isDisposed&&this.service&&this.service.setVerboseLogging(E)}error(E){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${E}`})}setFolders(E){this.folders=E,this.service&&this.service.setRoots(E)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[144],ee([0,1,36,51,2,17]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends L.Disposable{constructor(E,v,n,y,m={}){super();this.folders=E,this.onDidFilesChange=v,this.onLogMessage=n,this.verboseLogging=y,this.watcherOptions=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const E=this._register(new I.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(E.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(E.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.service.setRoots(this.folders)}error(E){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${E}`})}setVerboseLogging(E){this.verboseLogging=E,this.service&&this.service.setVerboseLogging(E)}setFolders(E){this.folders=E,this.service&&this.service.setRoots(E)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[145],ee([0,1,40,68,67,17]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(E,v,n,y,m){this.watchedFolder=E,this.eventCallback=n,this.logCallback=y,this.verboseLogging=m,this.restartCounter=0,Array.isArray(v)?this.ignored=v.map(g=>(0,L.parse)(g)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${E}, excludes: ${v.join(",")}`),this.startWatcher()}startWatcher(){const E=[this.watchedFolder];this.verboseLogging&&E.push("-verbose"),this.handle=(0,w.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,E);const v=new I.LineDecoder;this.handle.stdout.on("data",n=>{const y=[];for(const m of v.write(n)){const g=m.split("|");if(g.length===2){const u=Number(g[0]),C=g[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(P=>P(C))){this.verboseLogging&&this.log(C);continue}y.push({type:A.changeTypeMap[u],path:C})}else this.log(g[1])}}y.length>0&&this.eventCallback(y)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,y)=>this.onExit(n,y))}onError(E){this.error("process error: "+E.toString())}onExit(E,v){this.handle&&(this.error(`terminated unexpectedly (code: ${E}, signal: ${v})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(E){this.logCallback({type:"error",message:`[File Watcher (C#)] ${E}`})}log(E){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${E}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(Z[146],ee([0,1,145,8,19]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k{constructor(D,E,v,n){this.onDidFilesChange=E,this.onLogMessage=v,this.verboseLogging=n,this.service=void 0,this.folder=D[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(I.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,I.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new w.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,D=>this.onFileEvents(D),D=>this.onLogMessage(D),this.verboseLogging)}setVerboseLogging(D){this.verboseLogging=D,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(D){this.isDisposed||D.length>0&&this.onDidFilesChange(D)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=k}),define(Z[52],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(L,k=[],A=!1){this.ctor=L,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=w}),define(Z[147],ee([0,1,52]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function L(A,D,E){D instanceof w.SyncDescriptor||(D=new w.SyncDescriptor(D,[],E)),I.push([A,D])}e.registerSingleton=L;function k(){return I}e.getSingletonServiceDescriptors=k}),define(Z[148],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=w;class I{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let A of this._nodes.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const D=this.lookupOrInsertNode(k),E=this.lookupOrInsertNode(A);D.outgoing.set(this._hashFn(A),E),E.incoming.set(this._hashFn(k),D)}removeNode(k){const A=this._hashFn(k);this._nodes.delete(A);for(let D of this._nodes.values())D.outgoing.delete(A),D.incoming.delete(A)}lookupOrInsertNode(k){const A=this._hashFn(k);let D=this._nodes.get(A);return D||(D=new w(k),this._nodes.set(A,D)),D}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[A,D]of this._nodes)k.push(`${A}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,A]of this._nodes){const D=new Set([k]),E=this._findCycle(A,D);if(E)return E}}_findCycle(k,A){for(let[D,E]of k.outgoing){if(A.has(D))return[...A,D].join(" -> ");A.add(D);const v=this._findCycle(E,A);if(v)return v;A.delete(D)}}}e.Graph=I}),define(Z[7],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function E(v){return v[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=E})(w=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function I(D,E,v,n){E[w.DI_TARGET]===E?E[w.DI_DEPENDENCIES].push({id:D,index:v,optional:n}):(E[w.DI_DEPENDENCIES]=[{id:D,index:v,optional:n}],E[w.DI_TARGET]=E)}function L(D){if(w.serviceIds.has(D))return w.serviceIds.get(D);const E=function(v,n,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(E,v,y,!1)};return E.toString=()=>D,w.serviceIds.set(D,E),E}e.createDecorator=L;function k(D){return D}e.refineServiceDecorator=k;function A(D){return function(E,v,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(D,E,n,!0)}}e.optional=A}),define(Z[149],ee([0,1,7]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,w.createDecorator)("checksumService")}),define(Z[150],ee([0,1,19,7,4]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=L.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",L.isMacintosh),A.set("isLinux",L.isLinux),A.set("isWindows",L.isWindows),A.set("isWeb",L.isWeb),A.set("isMacNative",L.isMacintosh&&!L.isWeb),A.set("isEdge",k.indexOf("Edg/")>=0),A.set("isFirefox",k.indexOf("Firefox")>=0),A.set("isChrome",k.indexOf("Chrome")>=0),A.set("isSafari",k.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var E;(function(S){S[S.False=0]="False",S[S.True=1]="True",S[S.Defined=2]="Defined",S[S.Not=3]="Not",S[S.Equals=4]="Equals",S[S.NotEquals=5]="NotEquals",S[S.And=6]="And",S[S.Regex=7]="Regex",S[S.NotRegex=8]="NotRegex",S[S.Or=9]="Or",S[S.In=10]="In",S[S.NotIn=11]="NotIn",S[S.Greater=12]="Greater",S[S.GreaterEquals=13]="GreaterEquals",S[S.Smaller=14]="Smaller",S[S.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return y.INSTANCE}static true(){return m.INSTANCE}static has(d){return g.create(d)}static equals(d,T){return u.create(d,T)}static notEquals(d,T){return b.create(d,T)}static regex(d,T){return r.create(d,T)}static in(d,T){return C.create(d,T)}static not(d){return R.create(d)}static and(...d){return s.create(d)}static or(...d){return h.create(d)}static greater(d,T){return p.create(d,T)}static less(d,T){return a.create(d,T)}static deserialize(d,T=!1){if(!!d)return this._deserializeOrExpression(d,T)}static _deserializeOrExpression(d,T){let O=d.split("||");return h.create(O.map(_=>this._deserializeAndExpression(_,T)))}static _deserializeAndExpression(d,T){let O=d.split("&&");return s.create(O.map(_=>this._deserializeOne(_,T)))}static _deserializeOne(d,T){if(d=d.trim(),d.indexOf("!=")>=0){let O=d.split("!=");return b.create(O[0].trim(),this._deserializeValue(O[1],T))}if(d.indexOf("==")>=0){let O=d.split("==");return u.create(O[0].trim(),this._deserializeValue(O[1],T))}if(d.indexOf("=~")>=0){let O=d.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],T))}if(d.indexOf(" in ")>=0){let O=d.split(" in ");return C.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(d)){const O=d.split(">=");return o.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(d)){const O=d.split(">");return p.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(d)){const O=d.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(d)){const O=d.split("<");return a.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(d)?R.create(d.substr(1).trim()):g.create(d)}static _deserializeValue(d,T){if(d=d.trim(),d==="true")return!0;if(d==="false")return!1;let O=/^'([^']*)'$/.exec(d);return O?O[1].trim():d}static _deserializeRegexValue(d,T){if((0,w.isFalsyOrWhitespace)(d)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=d.indexOf("/"),_=d.lastIndexOf("/");if(O===_||O<0){if(T)throw new Error(`bad regexp-value '${d}', missing /-enclosure`);return console.warn(`bad regexp-value '${d}', missing /-enclosure`),null}let z=d.slice(O+1,_),H=d[_+1]==="i"?"i":"";try{return new RegExp(z,H)}catch(V){if(T)throw new Error(`bad regexp-value '${d}', parse error: ${V}`);return console.warn(`bad regexp-value '${d}', parse error: ${V}`),null}}}e.ContextKeyExpr=v;function n(S,d){return S.cmp(d)}class y{constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class m{constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class g{constructor(d){this.key=d,this.type=2}static create(d){const T=A.get(d);return typeof T=="boolean"?T?m.INSTANCE:y.INSTANCE:new g(d)}cmp(d){return d.type!==this.type?this.type-d.type:l(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return R.create(this.key)}}e.ContextKeyDefinedExpr=g;class u{constructor(d,T){this.key=d,this.value=T,this.type=4}static create(d,T){if(typeof T=="boolean")return T?g.create(d):R.create(d);const O=A.get(d);return typeof O=="boolean"?T===(O?"true":"false")?m.INSTANCE:y.INSTANCE:new u(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(d){return d.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class C{constructor(d,T){this.key=d,this.valueKey=T,this.type=10}static create(d,T){return new C(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.valueKey,d.key,d.valueKey)}equals(d){return d.type===this.type?this.key===d.key&&this.valueKey===d.valueKey:!1}evaluate(d){const T=d.getValue(this.valueKey),O=d.getValue(this.key);return Array.isArray(T)?T.indexOf(O)>=0:typeof O=="string"&&typeof T=="object"&&T!==null?D.call(T,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(d){return d.mapIn(this.key,this.valueKey)}negate(){return P.create(this)}}e.ContextKeyInExpr=C;class P{constructor(d){this._actual=d,this.type=11}static create(d){return new P(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new P(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotInExpr=P;class b{constructor(d,T){this.key=d,this.value=T,this.type=5}static create(d,T){if(typeof T=="boolean")return T?R.create(d):g.create(d);const O=A.get(d);return typeof O=="boolean"?T===(O?"true":"false")?y.INSTANCE:m.INSTANCE:new b(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(d){return d.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class R{constructor(d){this.key=d,this.type=3}static create(d){const T=A.get(d);return typeof T=="boolean"?T?y.INSTANCE:m.INSTANCE:new R(d)}cmp(d){return d.type!==this.type?this.type-d.type:l(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!d.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(d){return d.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=R;class p{constructor(d,T){this.key=d,this.value=T,this.type=12}static create(d,T){return new p(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=p;class o{constructor(d,T){this.key=d,this.value=T,this.type=13}static create(d,T){return new o(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreaterEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=o;class a{constructor(d,T){this.key=d,this.value=T,this.type=14}static create(d,T){return new a(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmaller(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerExpr=a;class t{constructor(d,T){this.key=d,this.value=T,this.type=15}static create(d,T){return new t(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmallerEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(d,T){this.key=d,this.regexp=T,this.type=7}static create(d,T){return new r(d,T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.key<d.key)return-1;if(this.key>d.key)return 1;const T=this.regexp?this.regexp.source:"",O=d.regexp?d.regexp.source:"";return T<O?-1:T>O?1:0}equals(d){if(d.type===this.type){const T=this.regexp?this.regexp.source:"",O=d.regexp?d.regexp.source:"";return this.key===d.key&&T===O}return!1}evaluate(d){let T=d.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const d=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${d}`}keys(){return[this.key]}map(d){return d.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(d){this._actual=d,this.type=8}static create(d){return new i(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new i(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class s{constructor(d){this.expr=d,this.type=6}static create(d){return s._normalizeArr(d)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const _=n(this.expr[T],d.expr[T]);if(_!==0)return _}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].evaluate(d))return!1;return!0}static _normalizeArr(d){const T=[];let O=!1;for(const _ of d)if(!!_){if(_.type===1){O=!0;continue}if(_.type===0)return y.INSTANCE;if(_.type===6){T.push(..._.expr);continue}T.push(_)}if(T.length===0&&O)return m.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(n);T.length>1;){const _=T[T.length-1];if(_.type!==9)break;T.pop();const z=T.pop(),H=h.create(_.expr.map(V=>s.create([V,z])));H&&(T.push(H),T.sort(n))}return T.length===1?T[0]:new s(T)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new s(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let T of this.expr)d.push(T.negate());return h.create(d)}}e.ContextKeyAndExpr=s;class h{constructor(d){this.expr=d,this.type=9}static create(d){const T=h._normalizeArr(d);if(T.length!==0)return T.length===1?T[0]:new h(T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const _=n(this.expr[T],d.expr[T]);if(_!==0)return _}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,O=this.expr.length;T<O;T++)if(this.expr[T].evaluate(d))return!0;return!1}static _normalizeArr(d){let T=[],O=!1;if(d){for(let _=0,z=d.length;_<z;_++){const H=d[_];if(!!H){if(H.type===0){O=!0;continue}if(H.type===1)return[m.INSTANCE];if(H.type===9){T=T.concat(H.expr);continue}T.push(H)}}if(T.length===0&&O)return[y.INSTANCE];T.sort(n)}return T}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new h(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let O of this.expr)d.push(O.negate());const T=O=>O.type===9?O.expr:[O];for(;d.length>1;){const O=d.shift(),_=d.shift(),z=[];for(const H of T(O))for(const V of T(_))z.push(v.and(H,V));d.unshift(v.or(...z))}return d[0]}}e.ContextKeyOrExpr=h;class c extends g{constructor(d,T,O){super(d);this._defaultValue=T,typeof O=="object"?c._info.push({...O,key:d}):O!==!0&&c._info.push({key:d,description:O,type:T!=null?typeof T:void 0})}static all(){return c._info.values()}bindTo(d){return d.createKey(this.key,this._defaultValue)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return v.not(this.key)}isEqualTo(d){return v.equals(this.key,d)}notEqualsTo(d){return v.notEquals(this.key,d)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(S,d){return S<d?-1:S>d?1:0}function f(S,d,T,O){return S<T?-1:S>T?1:d<O?-1:d>O?1:0}}),define(Z[73],ee([0,1,7]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function I(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=I}),define(Z[74],ee([0,1,7]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,w.createDecorator)("downloadService")}),define(Z[12],ee([0,1,7]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[27],ee([0,1,115,7,17]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=k;var A;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=5]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var D;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(D=e.SortOrder||(e.SortOrder={}));var E;(function(y){y.Install="install",y.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var v;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(m,g){super(m);this.code=g,this.name=g}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,w.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")});var Y=this&&this.__param||function(K,e){return function(w,I){e(w,I,K)}};define(Z[151],ee([0,1,2,27]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let L=class extends w.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};L=de([Y(0,I.IExtensionManagementService)],L),e.DeprecatedExtensionsCleaner=L}),define(Z[75],ee([0,1,7]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var I;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(I=e.RecommendationSource||(e.RecommendationSource={}));function L(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var k;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,w.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[76],ee([0,1,19,7]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=L;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class D{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,m){if(typeof y=="undefined"||y===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof y=="string"||typeof m=="string"){let g=typeof y=="string"?y:y.value,u=typeof m=="string"?m:m.value;return w.equalsIgnoreCase(g,u)}return y._lower===m._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=D;function E(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function v(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=v,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[31],ee([0,1,19,76]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(u,C){return u.uuid&&C.uuid?u.uuid===C.uuid:u.id===C.id?!0:(0,w.compareIgnoreCase)(u.id,C.id)===0}e.areSameExtensions=L;class k{constructor(C,P){this.version=P,this.id=C.id,this.uuid=C.uuid}key(){return`${this.id}-${this.version}`}equals(C){return C instanceof k?L(this,C)&&this.version===C.version:!1}}e.ExtensionIdentifierWithVersion=k;function A(u,C){return`${u}.${C}`}e.getExtensionId=A;function D(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function E(u,C){return D(A(u,C))}e.getGalleryExtensionId=E;function v(u,C){const P=[],b=R=>{for(const p of P)if(p.some(o=>L(C(o),C(R))))return p;return null};for(const R of u){const p=b(R);p?p.push(R):P.push([R])}return P}e.groupByExtension=v;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function y(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function m(u){const C=new Set;for(const P of u)P.malicious&&C.add(P.id.id);return C}e.getMaliciousExtensionsSet=m;function g(u,C){const P=[],b=C.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const R=b.shift();if(R&&P.every(p=>!L(p.identifier,{id:R}))){const p=u.filter(o=>L(o.identifier,{id:R}));p.length===1&&(P.push(p[0]),b.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return P}e.getExtensionDependencies=g}),define(Z[152],ee([0,1,2,8,76,18]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends w.Disposable{constructor(E,v){super();this.environmentService=E,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(v.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(v.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(E){E.some(v=>!!v.local)&&this.invalidate()}onDidUnInstallExtension(E){E.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(Z[13],ee([0,1,122,8,5,7,19,16,39]),function(K,e,w,I,L,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,k.createDecorator)("fileService");function v(U){return U.create===!0}e.isFileOpenForWriteOptions=v;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var y;(function(U){U[U.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var m;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=g;function u(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=u;function C(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function P(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=P;var b;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class R extends Error{constructor(x,M){super(x);this.code=M}}e.FileSystemProviderError=R;function p(U,x){const M=new R(U.toString(),x);return a(M,x),M}e.createFileSystemProviderError=p;function o(U){return U||p((0,w.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=o;function a(U,x){return U.name=x?`${x} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=a;function t(U){if(!U)return b.Unknown;if(U instanceof R)return U.code;const x=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!x)return b.Unknown;switch(x[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(U){if(U instanceof f)return U.fileOperationResult;switch(t(U)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(x,M,$){this.resource=x,this.operation=M,this.target=$}isOperation(x){return this.operation===x}}e.FileOperationEvent=s;var h;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class c{constructor(x,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const $ of x)switch($.type){case 1:this.added||(this.added=E.TernarySearchTree.forUris(()=>M)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=E.TernarySearchTree.forUris(()=>M)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=E.TernarySearchTree.forUris(()=>M)),this.deleted.set($.resource,$);break}}contains(x,...M){return this.doContains(x,{includeChildren:!1},...M)}affects(x,...M){return this.doContains(x,{includeChildren:!0},...M)}doContains(x,M,...$){if(!x)return!1;const q=$.length>0;return!!((!q||$.includes(1))&&(this.added?.get(x)||M.includeChildren&&this.added?.findSuperstr(x))||(!q||$.includes(0))&&(this.updated?.get(x)||M.includeChildren&&this.updated?.findSuperstr(x))||(!q||$.includes(2))&&(this.deleted?.findSubstr(x)||M.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function l(U,x,M){return!U||!x||U===x||x.length>U.length?!1:(x.charAt(x.length-1)!==I.sep&&(x+=I.sep),M?(0,A.startsWithIgnoreCase)(U,x):U.indexOf(x)===0)}e.isParent=l;class f extends Error{constructor(x,M,$){super(x);this.fileOperationResult=M,this.options=$}}e.FileOperationError=f;class S extends f{constructor(x,M,$){super(x,2,$);this.stat=M}}e.NotModifiedSinceFileOperationError=S;var d;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(d=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=O;async function _(U,x){if(!x.canHandleResource(L.URI.from({scheme:U.scheme})))return new Promise(M=>{const $=x.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===U.scheme&&q.added&&($.dispose(),M())})})}e.whenProviderRegistered=_,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(x){return(0,D.isNumber)(x)||(x=0),x<z.KB?(0,w.localize)(1,null,x.toFixed(0)):x<z.MB?(0,w.localize)(2,null,(x/z.KB).toFixed(2)):x<z.GB?(0,w.localize)(3,null,(x/z.MB).toFixed(2)):x<z.TB?(0,w.localize)(4,null,(x/z.GB).toFixed(2)):(0,w.localize)(5,null,(x/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var H;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function V(U){return{maxFileSize:U===0?300*z.MB:16*z.GB,maxHeapSize:U===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=V}),define(Z[153],ee([0,1,154,49,13]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(D){this.fileService=D}checksum(D){return new Promise(async(E,v)=>{const n=(0,w.createHash)("md5"),y=(await this.fileService.readFileStream(D)).value;(0,I.listenStream)(y,{onData:m=>n.update(m.buffer),onError:m=>v(m),onEnd:()=>E(n.digest("base64").replace(/=+$/,""))})})}};k=de([Y(0,L.IFileService)],k),e.ChecksumService=k}),define(Z[155],ee([0,1,221,113,13,135]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(m,g){const u={onUnknownOption:P=>{console.warn((0,I.localize)(0,null,P))},onMultipleValues:(P,b)=>{console.warn((0,I.localize)(1,null,P,b))}},C=(0,k.parseArgs)(m,k.OPTIONS,g?u:void 0);return C.goto&&C._.forEach(P=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),(0,I.localize)(2,null))),C["max-memory"]&&w(parseInt(C["max-memory"])>=L.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${L.MIN_MAX_MEMORY_SIZE_MB} MB.`),C}function D(m){const g=m.findIndex(u=>!/^-/.test(u));if(g>-1)return[...m.slice(0,g),...m.slice(g+1)]}function E(m){let[,...g]=m;process.env.VSCODE_DEV&&(g=D(g)||[]);const u=!y(process.env);return A(g,u)}e.parseMainProcessArgv=E;function v(m){const[,,...g]=m;return A(g,!0)}e.parseCLIProcessArgv=v;function n(m,...g){const u=m.indexOf("--");return u===-1?m.push(...g):m.splice(u,0,...g),m}e.addArg=n;function y(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=y}),define(Z[156],ee([0,1,137,40,30,4,155,37,109,29,11]),function(K,e,w,I,L,k,A,D,E,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function y(u,C,P){return C["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):k.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,A.isLaunchedFromCli)(P)&&!C["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,A.isLaunchedFromCli)(P)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=new Promise(async b=>{const R=new v.CancellationTokenSource,p=setTimeout(()=>{u.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),R.dispose(!0),b({})},1e4);try{const o=await g(u,R.token);b(o)}catch(o){(0,n.isPromiseCanceledError)(o)||u.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),b({})}finally{clearTimeout(p),R.dispose()}})),m)}e.resolveShellEnv=y;let m;async function g(u,C){const P=new Promise(async(b,R)=>{const p=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",p);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",o);const a=(0,L.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",r);const i=await(0,E.getSystemShell)(k.OS,r);if(u.trace("getUnixShellEnvironment#shell",i),C.isCancellationRequested)return R(n.canceled);const s=w.basename(i);let h,c;/^pwsh(-preview)?$/.test(s)?(h=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,c=["-Login","-Command"]):(h=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(c),h);const l=(0,I.spawn)(i,[...c,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});C.onCancellationRequested(()=>(l.kill(),R(n.canceled))),l.on("error",d=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(d)),b({})});const f=[];l.stdout.on("data",d=>f.push(d));const S=[];l.stderr.on("data",d=>S.push(d)),l.on("close",(d,T)=>{const O=Buffer.concat(f).toString("utf8");u.trace("getUnixShellEnvironment#raw",O);const _=Buffer.concat(S).toString("utf8");if(_.trim()&&u.trace("getUnixShellEnvironment#stderr",_),d||T)return R(new Error(`Failed to get environment (code ${d}, signal ${T})`));const z=t.exec(O),H=z?z[1]:"{}";try{const V=JSON.parse(H);p?V.ELECTRON_RUN_AS_NODE=p:delete V.ELECTRON_RUN_AS_NODE,o?V.ELECTRON_NO_ATTACH_CONSOLE=o:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",V),b(V)}catch(V){u.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(V)),R(V)}})});try{return await P}catch(b){return u.error("getUnixShellEnvironment#error",(0,D.toErrorMessage)(b)),{}}}}),define(Z[77],ee([0,1,5,13,4]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function k(E){return E.map(v=>({type:v.type,resource:w.URI.file(v.path)}))}e.toFileChanges=k;function A(E){const v=new D;for(const n of E)v.processEvent(n);return v.normalize()}e.normalizeFileChanges=A;class D{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(v){const n=this.mapPathToChange.get(v.path);if(n){const y=n.type,m=v.type;y===1&&m===2?(this.mapPathToChange.delete(v.path),this.normalized.splice(this.normalized.indexOf(n),1)):y===2&&m===1?n.type=0:y===1&&m===0||(n.type=m)}else this.normalized.push(v),this.mapPathToChange.set(v.path,v)}normalize(){const v=[],n=[];return this.normalized.filter(y=>y.type!==2?(v.push(y),!1):!0).sort((y,m)=>y.path.length-m.path.length).filter(y=>n.some(m=>(0,I.isParent)(y.path,m,!L.isLinux))?!1:(n.push(y.path),!0)).concat(v)}}}),define(Z[157],ee([0,1,77,2,18,99,101,6,8]),function(K,e,w,I,L,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class v extends I.Disposable{constructor(y,m,g,u){super();this.path=y,this.onDidFilesChange=m,this.onLogMessage=g,this.verboseLogging=u,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(A.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(y){this.verboseLogging=y}async startWatching(){try{const{stat:y,symbolicLink:m}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let g=this.path;if(m)try{g=await(0,k.realpath)(g)}catch(u){if(this.onError(u),m.dangling)return}y.isDirectory()?this._register((0,A.watchFolder)(g,(u,C)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,E.join)(this.path,(0,E.basename)(C))})},u=>this.onError(u))):this._register((0,A.watchFile)(g,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(y){y.code!=="ENOENT"&&this.onError(y)}}onFileChange(y){this.fileChangesBuffer.push(y),this.verboseLogging&&this.onVerbose(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const g=(0,w.normalizeFileChanges)(m);if(this.verboseLogging)for(const u of g)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);g.length>0&&this.onDidFilesChange(g)})}onError(y){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${y}`})}onVerbose(y){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=v}),define(Z[78],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...L){this._entries=new Map;for(let[k,A]of L)this.set(k,A)}set(L,k){const A=this._entries.get(L);return this._entries.set(L,k),A}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=w}),define(Z[158],ee([0,1,11,148,52,7,78,6]),function(K,e,w,I,L,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const E=!1;class v extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class n{constructor(u=new A.ServiceCollection,C=!1,P){this._activeInstantiations=new Set,this._services=u,this._strict=C,this._parent=P,this._services.set(k.IInstantiationService,this)}createChild(u){return new n(u,this._strict,this)}invokeFunction(u,...C){let P=m.traceInvocation(u),b=!1;try{return u({get:(p,o)=>{if(b)throw(0,w.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(p,P);if(!a&&o!==k.optional)throw new Error(`[invokeFunction] unknown service '${p}'`);return a}},...C)}finally{b=!0,P.stop()}}createInstance(u,...C){let P,b;return u instanceof L.SyncDescriptor?(P=m.traceCreation(u.ctor),b=this._createInstance(u.ctor,u.staticArguments.concat(C),P)):(P=m.traceCreation(u),b=this._createInstance(u,C,P)),P.stop(),b}_createInstance(u,C=[],P){let b=k._util.getServiceDependencies(u).sort((o,a)=>o.index-a.index),R=[];for(const o of b){let a=this._getOrCreateServiceInstance(o.id,P);if(!a&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);R.push(a)}let p=b.length>0?b[0].index:C.length;if(C.length!==p){console.warn(`[createInstance] First service dependency of ${u.name} at position ${p+1} conflicts with ${C.length} static arguments`);let o=p-C.length;o>0?C=C.concat(new Array(o)):C=C.slice(0,p)}return new u(...[...C,...R])}_setServiceInstance(u,C){if(this._services.get(u)instanceof L.SyncDescriptor)this._services.set(u,C);else if(this._parent)this._parent._setServiceInstance(u,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let C=this._services.get(u);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):C}_getOrCreateServiceInstance(u,C){let P=this._getServiceInstanceOrDescriptor(u);return P instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,P,C.branch(u,!0)):(C.branch(u,!1),P)}_safeCreateAndCacheServiceInstance(u,C,P){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,C,P)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,C,P){const b=new I.Graph(o=>o.id.toString());let R=0;const p=[{id:u,desc:C,_trace:P}];for(;p.length;){const o=p.pop();if(b.lookupOrInsertNode(o),R++>1e3)throw new v(b);for(let a of k._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`),t instanceof L.SyncDescriptor){const r={id:a.id,desc:t,_trace:o._trace.branch(a.id,!0)};b.insertEdge(o,r),p.push(r)}}}for(;;){const o=b.roots();if(o.length===0){if(!b.isEmpty())throw new v(b);break}for(const{data:a}of o){if(this._getServiceInstanceOrDescriptor(a.id)instanceof L.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}b.removeNode(a)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,C,P=[],b,R){if(this._services.get(u)instanceof L.SyncDescriptor)return this._createServiceInstance(C,P,b,R);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,C,P,b,R);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(u,C=[],P,b){if(P){const R=new D.IdleValue(()=>this._createInstance(u,C,b));return new Proxy(Object.create(null),{get(p,o){if(o in p)return p[o];let a=R.value,t=a[o];return typeof t!="function"||(t=t.bind(a),p[o]=t),t},set(p,o,a){return R.value[o]=a,!0}})}else return this._createInstance(u,C,b)}}e.InstantiationService=n;var y;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(y||(y={}));class m{constructor(u,C){this.type=u,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return E?new m(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(u){return E?new m(0,u.name):m._None}branch(u,C){let P=new m(2,u.toString());return this._dep.push([u,C,P]),P}stop(){let u=Date.now()-this._start;m._totals+=u;let C=!1;function P(R,p){let o=[],a=new Array(R+1).join("	");for(const[t,r,i]of p._dep)if(r&&i){C=!0,o.push(`${a}CREATES -> ${t}`);let s=P(R+1,i);s&&o.push(s)}else o.push(`${a}uses -> ${t}`);return o.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(u>2||C)&&console.log(b.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Z[159],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class w{constructor(L,k){this.server=L,this.router=k}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,k){this.server.registerChannel(L,k)}}e.MessagePortMainProcessService=w}),define(Z[160],ee([0,1,36,52,147,7]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(g,u,C){const P=C.getChannel(g);return D(u)?new u.channelClientCtor(P):w.ProxyChannel.toService(P,u?.proxyOptions)}}function D(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let E=class extends A{constructor(g,u,C){super(g,u,C)}};E=de([Y(2,e.IMainProcessService)],E);function v(m,g,u){(0,L.registerSingleton)(m,new I.SyncDescriptor(E,[g,u],u?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=v,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let n=class extends A{constructor(g,u,C){super(g,u,C)}};n=de([Y(2,e.ISharedProcessService)],n);function y(m,g,u){(0,L.registerSingleton)(m,new I.SyncDescriptor(n,[g,u],u?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=y}),define(Z[57],ee([0,1,7]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,w.createDecorator)("localizationsService");function I(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const k of L.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=I}),define(Z[161],ee([0,1,2,57]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends w.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=de([Y(0,I.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(Z[14],ee([0,1,7,2,4,3,37]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function D(){return new Date().toISOString()}var E;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;class v extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class n extends v{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(E.Trace)&&this.log(E.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(E.Debug)&&this.log(E.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(E.Info)&&this.log(E.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(E.Warning)&&this.log(E.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(E.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(E.Error,this.format(i))}else this.log(E.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(E.Critical)&&this.log(E.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let s=t[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch(h){}r+=(i>0?" ":"")+s}return r}}e.AbstractMessageLogger=n;class y extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...r){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}debug(t,...r){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}info(t,...r){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}warn(t,...r){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...r):console.warn(`[main ${D()}]`,t,...r))}error(t,...r){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...r):console.error(`[main ${D()}]`,t,...r))}critical(t,...r){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...r):console.error(`[main ${D()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class m extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=m;class g extends v{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,A.toErrorMessage)(t,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class u extends v{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class C extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=C;class P extends I.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(i))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,r?.always?E.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),r?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class b{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(t){}getLevel(){return E.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function R(a){if(a.verbose)return E.Trace;if(typeof a.logLevel=="string"){const t=p(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=R;function p(a){switch(a){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=p;function o(a){switch(a){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=o}),define(Z[162],ee([0,1,12,8,18,11,2,6,14]),function(K,e,w,I,L,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let v=class extends A.Disposable{constructor(y,m){super();this.environmentService=y,this.logService=m,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const y=(0,I.basename)(this.environmentService.logsPath),m=(0,I.dirname)(this.environmentService.logsPath),C=(await L.Promises.readdir(m)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==y),P=C.slice(0,Math.max(0,C.length-9));P.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${P.join(", ")}'`),await Promise.all(P.map(b=>L.Promises.rm((0,I.join)(m,b)))))}catch(y){(0,k.onUnexpectedError)(y)}}};v=de([Y(0,w.IEnvironmentService),Y(1,E.ILogService)],v),e.LogsDataCleaner=v}),define(Z[163],ee([0,1,12,8,18,11,2,6,14]),function(K,e,w,I,L,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let v=class lt extends A.Disposable{constructor(y,m,g){super();this.backupWorkspacesPath=y,this.environmentService=m,this.logService=g,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const y=await L.Promises.readFile(this.backupWorkspacesPath,"utf8"),g=JSON.parse(y).emptyWorkspaceInfos.map(C=>C.backupFolder),u=await L.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(u.map(async C=>{C.length!==lt.NON_EMPTY_WORKSPACE_ID_LENGTH&&g.indexOf(C)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${C}.`),await L.Promises.rm((0,I.join)(this.environmentService.workspaceStorageHome.fsPath,C)))}))}catch(y){(0,k.onUnexpectedError)(y)}}};v.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,v=de([Y(1,w.INativeEnvironmentService),Y(2,E.ILogService)],v),e.StorageDataCleaner=v}),define(Z[164],ee([0,1,18,2,13,27,12,5,15,31,14,30,58,4,6,11]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends I.Disposable{constructor(p,o,a,t){super();this.fileService=o,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=D.URI.file(p.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(p,o){await this.cleanUpPromise;const a=this.getName(p),t=(0,E.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const r=(0,E.joinPath)(this.extensionsDownloadDir,`.${(0,y.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(p,r,o);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(s){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",p.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,C.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(p){}async rename(p,o,a){try{await w.Promises.rename(p.fsPath,o.fsPath)}catch(t){if(g.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${p} to ${o} with 'EPERM' error. Trying again...`),this.rename(p,o,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const p=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const o=[],a=[];for(const i of p.children){const s=this.parse(i.name);s&&a.push([s,i])}const t=(0,v.groupByExtension)(a,([i])=>i),r=[];for(const i of t)i.sort((s,h)=>m.rcompare(s[0].version,h[0].version)),o.push(...i.slice(1).map(s=>s[1].resource)),r.push(i[0][1]);r.sort((i,s)=>i.mtime-s.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await u.Promises.settled(o.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(p){this.logService.error(p)}}getName(p){return this.cache?new v.ExtensionIdentifierWithVersion(p.identifier,p.version).key().toLowerCase():(0,y.generateUuid)()}parse(p){const o=P.exec(p);return o&&o[1]&&o[2]?new v.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};b=de([Y(0,A.INativeEnvironmentService),Y(1,L.IFileService),Y(2,k.IExtensionGalleryService),Y(3,n.ILogService)],b),e.ExtensionsDownloader=b}),define(Z[165],ee([0,1,2,14,40,37,8,6,3,17,18,12]),function(K,e,w,I,L,k,A,D,E,v,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends w.Disposable{constructor(u,C){super();this.environmentService=u,this.logService=C,this.processesLimiter=new D.Limiter(5)}async postUninstall(u){const C=this.parseScript(u,"uninstall");return C&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),P=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${P}`)))),n.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,P=>this.logService.error("Error while removing extension storage path",P))}parseScript(u,C){const P=`vscode:${C}`;if(u.location.scheme===v.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[P]=="string"){const b=u.manifest.scripts[P].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${P} should be a node script`),null):{script:(0,A.join)(u.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(u,C,P,b,R){return new Promise((p,o)=>{const a=this.start(u,C,P,R);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?o(i):p(void 0)};a.on("error",i=>{r((0,k.toErrorMessage)(i)||"Unknown")}),a.on("exit",(i,s)=>{r(i?`post-${C} process exited with code ${i}`:void 0)}),b&&(t=setTimeout(()=>{t=null,a.kill(),o("timed out")},5e3))})}start(u,C,P,b){const R={silent:!0,execArgv:void 0},p=(0,L.fork)(u,[`--type=extension-post-${C}`,...P],R);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const o=E.Event.fromNodeEventEmitter(p.stdout,"data"),a=E.Event.fromNodeEventEmitter(p.stderr,"data");o(i=>this.logService.info(b.identifier.id,b.manifest.version,`post-${C}`,i)),a(i=>this.logService.error(b.identifier.id,b.manifest.version,`post-${C}`,i));const t=E.Event.any(E.Event.map(o,i=>({data:`%c${i}`,format:[""]})),E.Event.map(a,i=>({data:`%c${i}`,format:["color: red"]})));return E.Event.debounce(t,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(b.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),p}getExtensionStoragePath(u){return(0,A.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};m=de([Y(0,y.IEnvironmentService),Y(1,I.ILogService)],m),e.ExtensionsLifecycle=m}),define(Z[166],ee([0,1,2,12,3,13,5,31,15,14]),function(K,e,w,I,L,k,A,D,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends w.Disposable{constructor(m,g,u,C){super();this.extensionsManagementService=m,this.logService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(R=>{this.installedExtensions=R.map(p=>p.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(R=>this.onInstallExtension(R))),this._register(m.onDidInstallExtensions(R=>this.onDidInstallExtensions(R))),this._register(m.onDidUninstallExtension(R=>this.onDidUninstallExtension(R)));const P=A.URI.file(u.extensionsPath),b=new E.ExtUri(R=>!g.hasCapability(R,1024));this._register(g.watch(P)),this._register(L.Event.filter(g.onDidChangeFilesRaw,R=>R.changes.some(p=>this.doesChangeAffects(p,P,b)))(()=>this.onDidChange()))}doesChangeAffects(m,g,u){return u.isEqual(u.dirname(m.resource),g)?u.isEqual(m.resource,u.joinPath(g,".obsolete"))?!0:!(m.type!==1&&m.type!==2||u.basename(m.resource).startsWith(".")):!1}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const g of m)this.removeInstallingExtension(g.identifier),g.local&&this.addInstalledExtension(g.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(g=>!(0,D.areSameExtensions)(g,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(g=>!(0,D.areSameExtensions)(g,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(1),g=m.filter(C=>[...this.installingExtensions,...this.installedExtensions].some(P=>(0,D.areSameExtensions)(P,C.identifier))?!1:C.installedTimestamp&&C.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",C.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",C.identifier.id),!1)),u=this.installedExtensions.filter(C=>this.installingExtensions.some(P=>(0,D.areSameExtensions)(P,C))?!1:m.every(P=>!(0,D.areSameExtensions)(P.identifier,C))?(this.logService.info("Detected extension removed from another source",C.id),!0):!1);this.installedExtensions=m.map(C=>C.identifier),(g.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:g,removed:u})}}};n=de([Y(1,k.IFileService),Y(2,I.INativeEnvironmentService),Y(3,v.ILogService)],n),e.ExtensionsWatcher=n}),define(Z[167],ee([0,1,18,154,27,2,12,6,31,14,57,23,17,8]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends k.Disposable{constructor(b,R,p){super();this.extensionManagementService=b,this.logService=p,this.cache=this._register(new C(R,p)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const b=await this.cache.getLanguagePacks(),R=["en",...Object.keys(b)];return(0,y.distinct)(R)}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const R=await this.cache.getLanguagePacks();Object.keys(R).some(p=>R[p]&&R[p].extensions.some(o=>(0,E.areSameExtensions)(o.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,R]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),p=await this.cache.update(R);return!(0,y.equals)(Object.keys(b),Object.keys(p))}};u=de([Y(0,L.IExtensionManagementService),Y(1,A.INativeEnvironmentService),Y(2,v.ILogService)],u),e.LocalizationsService=u;let C=class extends k.Disposable{constructor(b,R){super();this.logService=R,this.languagePacks={},this.languagePacksFilePath=(0,g.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(R=>{Object.keys(R).forEach(p=>delete R[p]),this.createLanguagePacksFromExtensions(R,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...R){for(const p of R)p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,p);Object.keys(b).forEach(p=>this.updateHash(b[p]))}createLanguagePacksFromExtension(b,R){const p=R.identifier,o=R.manifest.contributes&&R.manifest.contributes.localizations?R.manifest.contributes.localizations:[];for(const a of o)if(R.location.scheme===m.Schemas.file&&(0,n.isValidLocalization)(a)){let t=b[a.languageId];t||(t={hash:"",extensions:[],translations:{}},b[a.languageId]=t);let r=t.extensions.filter(i=>(0,E.areSameExtensions)(i.extensionIdentifier,p))[0];r?r.version=R.manifest.version:t.extensions.push({extensionIdentifier:p,version:R.manifest.version});for(const i of a.translations)t.translations[i.id]=(0,g.join)(R.location.fsPath,i.path)}}updateHash(b){if(b){const R=(0,I.createHash)("md5");for(const p of b.extensions)R.update(p.extensionIdentifier.uuid||p.extensionIdentifier.id).update(p.version);b.hash=R.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let R=null;return w.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,p=>p.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(p)).then(p=>{try{return JSON.parse(p)}catch(o){return{}}}).then(p=>(R=b(p),p)).then(p=>{for(const a of Object.keys(p))p[a]||delete p[a];this.languagePacks=p,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),w.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>R,p=>this.logService.error(p))})}};C=de([Y(0,A.INativeEnvironmentService),Y(1,v.ILogService)],C)}),define(Z[79],ee([0,1,14,3,5]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(m){this.service=m,this.onDidChangeLogLevel=I.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(m,g,u){switch(g){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=k;class A{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){A.setLevel(this.channel,m)}static setLevel(m,g){return m.call("setLevel",g)}}e.LogLevelChannelClient=A;class D{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,g){throw new Error(`Event not found: ${g}`)}async call(m,g,u){switch(g){case"createLogger":this.createLogger(L.URI.revive(u[0]),u[1]);return;case"log":return this.log(L.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${g}`)}createLogger(m,g){this.loggers.set(m.toString(),this.loggerService.createLogger(m,g))}consoleLog(m,g){let u=console.log;switch(m){case w.LogLevel.Error:u=console.error;break;case w.LogLevel.Warning:u=console.warn;break;case w.LogLevel.Info:u=console.info;break}u.call(console,...g)}log(m,g){const u=this.loggers.get(m.toString());if(!u)throw new Error("Create the logger before logging");for(const[C,P]of g)switch(C){case w.LogLevel.Trace:u.trace(P);break;case w.LogLevel.Debug:u.debug(P);break;case w.LogLevel.Info:u.info(P);break;case w.LogLevel.Warning:u.warn(P);break;case w.LogLevel.Error:u.error(P);break;case w.LogLevel.Critical:u.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=D;class E extends w.AbstractLoggerService{constructor(m,g,u){super(m,g);this.channel=u}createConsoleMainLogger(){return new w.AdapterLogger({log:(m,g)=>{this.channel.call("consoleLog",[m,g])}})}doCreateLogger(m,g,u){return new v(this.channel,m,g,u)}}e.LoggerChannelClient=E;class v extends w.AbstractMessageLogger{constructor(m,g,u,C){super(C?.always);this.channel=m,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[g,C]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,g){const u=[[m,g]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(m){this.channel.call("log",[this.file,m])}}class n extends w.LogService{constructor(m,g){super(g);this.parent=m,this._register(m.onDidChangeLogLevel(u=>g.setLevel(u)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=n}),define(Z[59],ee([0,1,7]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,w.createDecorator)("nativeHostService")}),define(Z[44],ee([0,1,17,4,35,15]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof I.globals.vscode!="undefined"&&typeof I.globals.vscode.context!="undefined"){const D=I.globals.vscode.context.configuration();if(D)A=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const D=(0,k.dirname)(w.FileAccess.asFileUri("",K));A=K.__$__nodeRequire((0,k.joinPath)(D,"product.json").fsPath);const E=K.__$__nodeRequire((0,k.joinPath)(D,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:E.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.59.0-dev",nameShort:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(Z[80],ee([0,1,123,25,13,11,44]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(y,m,g,u,C,P){let b;try{await E(y,m,g,u,C,P)}catch(R){b=R}finally{b&&C.errorTransformer&&(b=C.errorTransformer(b)),typeof b!="undefined"&&g.error(b),g.end()}}e.readFileIntoStream=D;async function E(y,m,g,u,C,P){v(P);const b=await y.open(m,{create:!1});try{v(P);let R=0,p=0,o=C&&typeof C.length=="number"?C.length:void 0,a=I.VSBuffer.alloc(Math.min(C.bufferSize,typeof o=="number"?o:C.bufferSize)),t=C&&typeof C.position=="number"?C.position:0,r=0;do p=await y.read(b,t,a.buffer,r,a.byteLength-r),t+=p,r+=p,R+=p,typeof o=="number"&&(o-=p),r===a.byteLength&&(await g.write(u(a)),a=I.VSBuffer.alloc(Math.min(C.bufferSize,typeof o=="number"?o:C.bufferSize)),r=0);while(p>0&&(typeof o!="number"||o>0)&&v(P)&&n(R,C));if(r>0){let i=r;typeof o=="number"&&(i=Math.min(r,o)),g.write(u(a.slice(0,i)))}}catch(R){throw(0,L.ensureFileSystemProviderError)(R)}finally{await y.close(b)}}function v(y){if(y.isCancellationRequested)throw(0,k.canceled)();return!0}function n(y,m){if(m?.limits){if(typeof m.limits.memory=="number"&&y>m.limits.memory)throw(0,L.createFileSystemProviderError)((0,w.localize)(0,null,A.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof m.limits.size=="number"&&y>m.limits.size)throw(0,L.createFileSystemProviderError)((0,w.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[168],ee([0,1,121,169,2,13,3,15,39,23,14,25,49,6,29,17,80,55]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let R=class $e extends L.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new A.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new g.ThrottledWorker($e.FILE_EVENTS_THROTTLING.maxChangesChunkSize,$e.FILE_EVENTS_THROTTLING.maxChangesBufferSize,$e.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new k.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new g.ThrottledWorker($e.FILE_EVENTS_THROTTLING.maxChangesChunkSize,$e.FILE_EVENTS_THROTTLING.maxChangesBufferSize,$e.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new k.FileChangesEvent(a,!0)))),this.watchedResources=E.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new g.ResourceQueue)}registerProvider(o,a){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:a});const t=new L.DisposableStore;return t.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:o}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,L.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:a}),this.provider.delete(o),(0,L.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){a.push(t)}}),!this.provider.has(o)&&await g.Promises.settled(a)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,a){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return b.Iterable.map(this.provider,([o,a])=>({scheme:o,capabilities:a.capabilities}))}async withProvider(o){if(!(0,D.isAbsolutePath)(o))throw new k.FileOperationError((0,w.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const a=this.provider.get(o.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,w.localize)(1,null,o.toString()),t}return a}async withReadProvider(o){const a=await this.withProvider(o);if((0,k.hasOpenReadWriteCloseCapability)(a)||(0,k.hasReadWriteCapability)(a)||(0,k.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const a=await this.withProvider(o);if((0,k.hasOpenReadWriteCloseCapability)(a)||(0,k.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,a){try{return await this.doResolveFile(o,a)}catch(t){throw(0,k.toFileSystemProviderErrorCode)(t)===k.FileSystemProviderErrorCode.FileNotFound?new k.FileOperationError((0,w.localize)(2,null,this.resourceForError(o)),1):(0,k.ensureFileSystemProviderError)(t)}}async doResolveFile(o,a){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),i=a?.resolveTo,s=a?.resolveSingleChildDescendants,h=a?.resolveMetadata,c=await t.stat(o);let l;return this.toFileStat(t,o,c,void 0,!!h,(f,S)=>(l||(l=E.TernarySearchTree.forUris(()=>!r),l.set(o,!0),(0,v.isNonEmptyArray)(i)&&i.forEach(d=>l.set(d,!0))),Boolean(l.findSuperstr(f.resource)||l.get(f.resource))?!0:f.isDirectory&&s?S===1:!1))}async toFileStat(o,a,t,r,i,s){const{providerExtUri:h}=this.getExtUri(o),c={resource:a,name:h.basename(a),isFile:(t.type&k.FileType.File)!=0,isDirectory:(t.type&k.FileType.Directory)!=0,isSymbolicLink:(t.type&k.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&k.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,k.etag)({mtime:t.mtime,size:t.size})};if(c.isDirectory&&s(c,r)){try{const l=await o.readdir(a),f=await g.Promises.settled(l.map(async([S,d])=>{try{const T=h.joinPath(a,S),O=i?await o.stat(T):{type:d};return await this.toFileStat(o,T,O,l.length,i,s)}catch(T){return this.logService.trace(T),null}}));c.children=(0,v.coalesce)(f)}catch(l){this.logService.trace(l),c.children=[]}return c}return c}async resolveAll(o){return g.Promises.settled(o.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const a=await this.withProvider(o);try{return!!await a.stat(o)}catch(t){return!1}}async canCreateFile(o,a){try{await this.doValidateCreateFile(o,a)}catch(t){return t}return!0}async doValidateCreateFile(o,a){if(!a?.overwrite&&await this.exists(o))throw new k.FileOperationError((0,w.localize)(3,null,this.resourceForError(o)),3,a)}async createFile(o,a=y.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,a);return this._onDidRunOperation.fire(new k.FileOperationEvent(o,0,r)),r}async writeFile(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,i.dirname(o));let h;if((0,k.hasReadWriteCapability)(r)&&!(a instanceof y.VSBuffer))if((0,m.isReadableStream)(a)){const c=await(0,m.peekStream)(a,3);c.ended?h=y.VSBuffer.concat(c.buffer):h=c}else h=(0,m.peekReadable)(a,c=>y.VSBuffer.concat(c),3);else h=a;!(0,k.hasOpenReadWriteCloseCapability)(r)||(0,k.hasReadWriteCapability)(r)&&h instanceof y.VSBuffer?await this.doWriteUnbuffered(r,o,t,h):await this.doWriteBuffered(r,o,t,h instanceof y.VSBuffer?(0,y.bufferToReadable)(h):h)}catch(s){throw new k.FileOperationError((0,w.localize)(4,null,this.resourceForError(o),(0,k.ensureFileSystemProviderError)(s).toString()),(0,k.toFileOperationResult)(s),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,a,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,w.localize)(5,null,this.resourceForError(a)));let i;try{i=await o.stat(a)}catch(s){return}if((i.type&k.FileType.Directory)!=0)throw new k.FileOperationError((0,w.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==(0,k.etag)({mtime:t.mtime,size:i.size}))throw new k.FileOperationError((0,w.localize)(7,null),3,t);return i}async readFile(o,a){const t=await this.withReadProvider(o);return a?.atomic?this.doReadFileAtomic(t,o,a):this.doReadFile(t,o,a)}async doReadFileAtomic(o,a,t){return new Promise((r,i)=>{this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,a,t);r(s)}catch(s){i(s)}})})}async doReadFile(o,a,t){const r=await this.doReadFileStream(o,a,{...t,preferUnbuffered:!0});return{...r,value:await(0,y.streamToBuffer)(r.value)}}async readFileStream(o,a){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,a)}async doReadFileStream(o,a,t){const r=new u.CancellationTokenSource,i=this.validateReadFile(a,t).then(h=>h,h=>{throw r.cancel(),h});let s;try{return t&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&await i,!((0,k.hasOpenReadWriteCloseCapability)(o)||(0,k.hasFileReadStreamCapability)(o))||(0,k.hasReadWriteCapability)(o)&&t?.preferUnbuffered?s=this.readFileUnbuffered(o,a,t):(0,k.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,a,r.token,t):s=this.readFileBuffered(o,a,r.token,t),{...await i,value:s}}catch(h){s&&await(0,m.consumeStream)(s);const c=(0,w.localize)(8,null,this.resourceForError(a),(0,k.ensureFileSystemProviderError)(h).toString());throw h instanceof k.NotModifiedSinceFileOperationError?new k.NotModifiedSinceFileOperationError(c,h.stat,t):new k.FileOperationError(c,(0,k.toFileOperationResult)(h),t)}}readFileStreamed(o,a,t,r=Object.create(null)){const i=o.readFileStream(a,r,t);return(0,m.transform)(i,{data:s=>s instanceof y.VSBuffer?s:y.VSBuffer.wrap(s),error:s=>new k.FileOperationError((0,w.localize)(9,null,this.resourceForError(a),(0,k.ensureFileSystemProviderError)(s).toString()),(0,k.toFileOperationResult)(s),r)},s=>y.VSBuffer.concat(s))}readFileBuffered(o,a,t,r=Object.create(null)){const i=(0,y.newWriteableBufferStream)();return(0,P.readFileIntoStream)(o,a,i,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new k.FileOperationError((0,w.localize)(10,null,this.resourceForError(a),(0,k.ensureFileSystemProviderError)(s).toString()),(0,k.toFileOperationResult)(s),r)},t),i}readFileUnbuffered(o,a,t){const r=(0,m.newWriteableStream)(i=>y.VSBuffer.concat(i));return(async()=>{try{let i=await o.readFile(a);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(a,i.byteLength,t),r.end(y.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(o,a){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new k.FileOperationError((0,w.localize)(11,null,this.resourceForError(o)),0,a);if(a&&typeof a.etag=="string"&&a.etag!==k.ETAG_DISABLED&&a.etag===t.etag)throw new k.NotModifiedSinceFileOperationError((0,w.localize)(12,null),t,a);return this.validateReadFileLimits(o,t.size,a),t}validateReadFileLimits(o,a,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&a>t.limits.size&&(r=7),typeof r=="number")throw new k.FileOperationError((0,w.localize)(13,null,this.resourceForError(o)),r)}}async canMove(o,a,t){return this.doCanMoveCopy(o,a,"move",t)}async canCopy(o,a,t){return this.doCanMoveCopy(o,a,"copy",t)}async doCanMoveCopy(o,a,t,r){if(o.toString()!==a.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(i,o,s,a,t,r)}catch(i){return i}return!0}async move(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,o,i,a,"move",!!t),h=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(o,s==="move"?2:3,h)),h}async copy(o,a,t){const r=await this.withReadProvider(o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,o,i,a,"copy",!!t),h=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(o,s==="copy"?3:2,h)),h}async doMoveCopy(o,a,t,r,i,s){if(a.toString()===r.toString())return i;const{exists:h,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(o,a,t,r,i,s);if(h&&!c&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(o===t&&(0,k.hasFileFolderCopyCapability)(o))await o.copy(a,r,{overwrite:s});else{const l=await this.resolve(a);l.isDirectory?await this.doCopyFolder(o,l,t,r):await this.doCopyFile(o,a,t,r)}return i}else return o===t?(await o.rename(a,r,{overwrite:s}),i):(await this.doMoveCopy(o,a,t,r,"copy",s),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(o,a,t,r){if((0,k.hasOpenReadWriteCloseCapability)(o)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,a,t,r);if((0,k.hasOpenReadWriteCloseCapability)(o)&&(0,k.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,a,t,r);if((0,k.hasReadWriteCapability)(o)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,a,t,r);if((0,k.hasReadWriteCapability)(o)&&(0,k.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,a,t,r)}async doCopyFolder(o,a,t,r){await t.mkdir(r),Array.isArray(a.children)&&await g.Promises.settled(a.children.map(async i=>{const s=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(o,await this.resolve(i.resource),t,s):this.doCopyFile(o,i.resource,t,s)}))}async doValidateMoveCopy(o,a,t,r,i,s){let h=!1;if(o===t){const{providerExtUri:l,isPathCaseSensitive:f}=this.getExtUri(o);if(f||(h=l.isEqual(a,r)),h&&i==="copy")throw new Error((0,w.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!h&&l.isEqualOrParent(r,a))throw new Error((0,w.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const c=await this.exists(r);if(c&&!h){if(!s)throw new k.FileOperationError((0,w.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(o===t){const{providerExtUri:l}=this.getExtUri(o);if(l.isEqualOrParent(a,r))throw new Error((0,w.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:c,isSameResourceWithDifferentPathCase:h}}getExtUri(o){const a=this.isPathCaseSensitive(o);return{providerExtUri:a?D.extUri:D.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(a,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(o,0,t)),t}async mkdirp(o,a){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(a,r.dirname(a));)try{if(((await o.stat(a)).type&k.FileType.Directory)==0)throw new Error((0,w.localize)(18,null,this.resourceForError(a)));break}catch(i){if((0,k.toFileSystemProviderErrorCode)(i)!==k.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(a)),a=r.dirname(a)}for(let i=t.length-1;i>=0;i--){a=r.joinPath(a,t[i]);try{await o.mkdir(a)}catch(s){if((0,k.toFileSystemProviderErrorCode)(s)!==k.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,a){try{await this.doValidateDelete(o,a)}catch(t){return t}return!0}async doValidateDelete(o,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,w.localize)(19,null,this.resourceForError(o)));let i;try{i=await t.stat(o)}catch(h){}if(i)this.throwIfFileIsReadonly(o,i);else throw new k.FileOperationError((0,w.localize)(20,null,this.resourceForError(o)),1);if(!!!a?.recursive){const h=await this.resolve(o);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,w.localize)(21,null,this.resourceForError(o)))}return t}async del(o,a){const t=await this.doValidateDelete(o,a),r=!!a?.useTrash,i=!!a?.recursive;await t.delete(o,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new k.FileOperationEvent(o,1))}onDidChangeFile(o,a){this._onDidChangeFilesRaw.fire({changes:o});let t,r;{for(const i of o)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new k.FileChangesEvent(t,!a))}if(r){const i=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&$e.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,a={recursive:!1,excludes:[]}){const t=new L.DisposableStore;{let r=!1,i=()=>{r=!0};t.add((0,L.toDisposable)(()=>i())),this.doWatch(o,a).then(s=>{r?(0,L.dispose)(s):i=()=>(0,L.dispose)(s)},s=>this.logService.error(s))}return a.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,L.toDisposable)(()=>{const r=this.watchedResources.get(o);typeof r=="number"&&(r<=1?this.watchedResources.delete(o):this.watchedResources.set(o,r-1))}))),t}async doWatch(o,a){const t=await this.withProvider(o),r=this.toWatchKey(t,o,a),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,a)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,(0,L.toDisposable)(()=>{i.count--,i.count===0&&((0,L.dispose)(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,a,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>(0,L.dispose)(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{const i=await o.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,m.isReadableStream)(r)||(0,m.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(o,i,r):await this.doWriteReadableBufferedQueued(o,i,r)}catch(s){throw(0,k.ensureFileSystemProviderError)(s)}finally{await o.close(i)}})}async doWriteStreamBufferedQueued(o,a,t){let r=0,i;if((0,m.isReadableBufferedStream)(t)){if(t.buffer.length>0){const s=y.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,a,s,s.byteLength,r,0),r+=s.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(s,h)=>{(0,m.listenStream)(i,{onData:async c=>{i.pause();try{await this.doWriteBuffer(o,a,c,c.byteLength,r,0)}catch(l){return h(l)}r+=c.byteLength,setTimeout(()=>i.resume())},onError:c=>h(c),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,a,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(o,a,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(o,a,t,r,i,s){let h=0;for(;h<r;)h+=await o.write(a,i+h,t.buffer,s+h,r-h)}async doWriteUnbuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,a,t,r))}async doWriteUnbufferedQueued(o,a,t,r){let i;r instanceof y.VSBuffer?i=r:(0,m.isReadableStream)(r)?i=await(0,y.streamToBuffer)(r):(0,m.isReadableBufferedStream)(r)?i=await(0,y.bufferedStreamToBuffer)(r):i=(0,y.readableToBuffer)(r),await o.writeFile(a,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,a,t,r))}async doPipeBufferedQueued(o,a,t,r){let i,s;try{i=await o.open(a,{create:!1}),s=await t.open(r,{create:!0,unlock:!1});const h=y.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,l=0,f=0;do f=await o.read(i,c,h.buffer,l,h.byteLength-l),await this.doWriteBuffer(t,s,h,f,c,l),c+=f,l+=f,l===h.byteLength&&(l=0);while(f>0)}catch(h){throw(0,k.ensureFileSystemProviderError)(h)}finally{await g.Promises.settled([typeof i=="number"?o.close(i):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,a,t,r))}async doPipeUnbufferedQueued(o,a,t,r){return t.writeFile(r,await o.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,a,t,r))}async doPipeUnbufferedToBufferedQueued(o,a,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const s=await o.readFile(a);await this.doWriteBuffer(t,i,y.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,k.ensureFileSystemProviderError)(s)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(o,a,t,r){const i=await(0,y.streamToBuffer)(this.readFileBuffered(o,a,u.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(o,a){if(o.capabilities&2048)throw new k.FileOperationError((0,w.localize)(22,null,this.resourceForError(a)),6);return o}throwIfFileIsReadonly(o,a){if((a.permissions??0)&k.FilePermission.Readonly)throw new k.FileOperationError((0,w.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===C.Schemas.file?o.fsPath:o.toString(!0)}};R.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},R=de([Y(0,n.ILogService)],R),e.FileService=R}),define(Z[170],ee([0,1,2,13,3,4,18,8,15,43,6,14,124,77,144,146,143,157,49,80,23,25]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P,b,R,p,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends w.Disposable{constructor(i,s){super();this.logService=i,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:s,symbolicLink:h}=await A.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(s,h),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(i){try{const s=await A.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),h=[];return await Promise.all(s.map(async c=>{try{let l;c.isSymbolicLink()?l=(await this.stat((0,E.joinPath)(i,c.name))).type:l=this.toType(c),h.push([c.name,l])}catch(l){this.logService.trace(l)}})),h}catch(s){throw this.toFileSystemProviderError(s)}}toType(i,s){let h;return s?.dangling?h=I.FileType.Unknown:i.isFile()?h=I.FileType.File:i.isDirectory()?h=I.FileType.Directory:h=I.FileType.Unknown,s&&(h|=I.FileType.SymbolicLink),h}async readFile(i){try{const s=this.toFilePath(i);return await A.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(i,s,h){const c=(0,R.newWriteableStream)(l=>a.VSBuffer.concat(l.map(f=>a.VSBuffer.wrap(f))).buffer);return(0,p.readFileIntoStream)(this,i,c,l=>l.buffer,{...s,bufferSize:this.BUFFER_SIZE},h),c}async writeFile(i,s,h){let c;try{const l=this.toFilePath(i);if(!h.create||!h.overwrite){if(await A.Promises.exists(l)){if(!h.overwrite)throw(0,I.createFileSystemProviderError)((0,m.localize)(0,null),I.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw(0,I.createFileSystemProviderError)((0,m.localize)(1,null),I.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:h.unlock}),await this.write(c,0,s,0,s.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof c=="number"&&await this.close(c)}}async open(i,s){try{const h=this.toFilePath(i);if((0,I.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:f}=await A.SymlinkSupport.stat(h);f.mode&128||await A.Promises.chmod(h,f.mode|128)}catch(f){this.logService.trace(f)}let c;if((0,I.isFileOpenForWriteOptions)(s)){if(k.isWindows)try{await A.Promises.truncate(h,0),c="r+"}catch(f){f.code!=="ENOENT"&&this.logService.trace(f)}c||(c="w")}else c="r";const l=await A.Promises.open(h,c);return this.mapHandleToPos.set(l,0),(0,I.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(l,i),l}catch(h){throw(0,I.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(i,h):this.toFileSystemProviderError(h)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await A.Promises.fdatasync(i)}catch(s){this.canFlush=!1,this.logService.error(s)}return await A.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}}async read(i,s,h,c,l){const f=this.normalizePos(i,s);let S=null;try{const d=await A.Promises.read(i,h,c,l,f);return typeof d=="number"?S=d:S=d.bytesRead,S}catch(d){throw this.toFileSystemProviderError(d)}finally{this.updatePos(i,f,S)}}normalizePos(i,s){return s===this.mapHandleToPos.get(i)?null:s}updatePos(i,s,h){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof s=="number"||(typeof h=="number"?this.mapHandleToPos.set(i,c+h):this.mapHandleToPos.delete(i)))}async write(i,s,h,c,l){return(0,n.retry)(()=>this.doWrite(i,s,h,c,l),100,3)}async doWrite(i,s,h,c,l){const f=this.normalizePos(i,s);let S=null;try{const d=await A.Promises.write(i,h,c,l,f);return typeof d=="number"?S=d:S=d.bytesWritten,S}catch(d){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),d)}finally{this.updatePos(i,f,S)}}async mkdir(i){try{await A.Promises.mkdir(this.toFilePath(i))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(i,s){try{const h=this.toFilePath(i);await this.doDelete(h,s)}catch(h){throw this.toFileSystemProviderError(h)}}async doDelete(i,s){s.recursive?await A.Promises.rm(i,A.RimRafMode.MOVE):await A.Promises.unlink(i)}async rename(i,s,h){const c=this.toFilePath(i),l=this.toFilePath(s);if(c!==l)try{await this.validateTargetDeleted(i,s,"move",h.overwrite),await A.Promises.move(c,l)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,m.localize)(2,null,(0,D.basename)(c),(0,D.basename)((0,D.dirname)(l)),f.toString()))),this.toFileSystemProviderError(f)}}async copy(i,s,h){const c=this.toFilePath(i),l=this.toFilePath(s);if(c!==l)try{await this.validateTargetDeleted(i,s,"copy",h.overwrite),await A.Promises.copy(c,l,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,m.localize)(3,null,(0,D.basename)(c),(0,D.basename)((0,D.dirname)(l)),f.toString()))),this.toFileSystemProviderError(f)}}async validateTargetDeleted(i,s,h,c){const l=this.toFilePath(i),f=this.toFilePath(s);let S=!1;if(!!(this.capabilities&1024)||(S=(0,v.isEqual)(l,f,!0)),S&&h==="copy")throw(0,I.createFileSystemProviderError)((0,m.localize)(4,null),I.FileSystemProviderErrorCode.FileExists);if(!S&&await A.Promises.exists(f)){if(!c)throw(0,I.createFileSystemProviderError)((0,m.localize)(5,null),I.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(i,s){return s.recursive?this.watchRecursive(i,s.excludes):this.watchNonRecursive(i)}watchRecursive(i,s){const h={path:this.toFilePath(i),excludes:s},c=(0,o.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,w.toDisposable)(()=>{c(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof P.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,w.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,s;this.options?.watcher?.usePolling?(i=u.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?k.isWindows?i=C.FileWatcher:i=u.FileWatcher:i=P.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,h=>this._onDidChangeFile.fire((0,g.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===y.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))}}watchNonRecursive(i){const s=new b.FileWatcher(this.toFilePath(i),c=>this._onDidChangeFile.fire((0,g.toFileChanges)(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===y.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)});return(0,w.combinedDisposable)(s,h)}toFilePath(i){return(0,D.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof I.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=I.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=I.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=I.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=I.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=I.FileSystemProviderErrorCode.NoPermissions;break;default:s=I.FileSystemProviderErrorCode.Unknown}return(0,I.createFileSystemProviderError)(i,s)}async toFileSystemProviderWriteError(i,s){let h=this.toFileSystemProviderError(s);if(i&&h.code===I.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await A.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(h=(0,I.createFileSystemProviderError)(s,I.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return h}dispose(){super.dispose(),(0,w.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,w.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Z[28],ee([0,1,7]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService")}),define(Z[171],ee([0,1,8,11,2,18,28,6,14]),function(K,e,w,I,L,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let v=class extends L.Disposable{constructor(y,m,g){super();this.productService=m,this.logService=g,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(y)},30*1e3)).schedule()}async cleanUpCodeCaches(y){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),g=(0,w.dirname)(y),u=(0,w.basename)(y),C=await k.Promises.readdir(g);await Promise.all(C.map(async P=>{if(P===u)return;const b=(0,w.join)(g,P),R=await k.Promises.stat(b);if(R.isDirectory()&&m-R.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${P}.`),k.Promises.rm(b)}))}catch(m){(0,I.onUnexpectedError)(m)}}};v=de([Y(1,A.IProductService),Y(2,E.ILogService)],v),e.CodeCacheCleaner=v}),define(Z[172],ee([0,1,8,18,28,2,11,14,12,6]),function(K,e,w,I,L,k,A,D,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends k.Disposable{constructor(m,g,u){super();this.environmentService=m,this.logService=g,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new v.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),g=JSON.parse(await I.Promises.readFile((0,w.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let R of Object.keys(g)){const p=g[R];m[`${p.hash}.${R}`]=!0}const u=(0,w.join)(this.environmentService.userDataPath,"clp");if(!await I.Promises.exists(u))return;const P=await I.Promises.readdir(u);for(const R of P){if(m[R]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${R}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${R}`),await I.Promises.rm((0,w.join)(u,R))}const b=Date.now();for(const R of Object.keys(m)){const p=(0,w.join)(u,R),o=await I.Promises.readdir(p);for(const a of o){if(a==="tcf.json")continue;const t=(0,w.join)(p,a),r=await I.Promises.stat(t);r.isDirectory()&&b-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,w.join)(R,a)}`),await I.Promises.rm(t))}}}catch(m){(0,A.onUnexpectedError)(m)}}};n=de([Y(0,E.INativeEnvironmentService),Y(1,D.ILogService),Y(2,L.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(Z[32],ee([0,1,16,90]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(A,D){I.ok(w.isString(A)),I.ok(w.isObject(D)),I.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,D)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new L}),define(Z[81],ee([0,1,32,3]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class k{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,v){this.schemasById[L(E)]=v,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new k;w.Registry.add(e.Extensions.JSONContribution,A)}),define(Z[38],ee([0,1,111,3,32,16,81]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const v=L.Registry.as(A.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(R,p=!0){this.registerConfigurations([R],p)}registerConfigurations(R,p=!0){const o=[];R.forEach(a=>{o.push(...this.validateAndRegisterProperties(a,p,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(R){const p=[],o=a=>{if(a.properties)for(const t in a.properties)p.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,a.properties[t]);a.allOf&&a.allOf.forEach(t=>o(t))};for(const a of R){o(a);const t=this.configurationContributors.indexOf(a);t!==-1&&this.configurationContributors.splice(t,1)}v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}registerDefaultConfigurations(R){const p=[],o=[];for(const a of R)for(const t in a)if(p.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...a[t]};const r={type:"object",default:this.defaultValues[t],description:w.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};o.push(m(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=a[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterDefaultConfigurations(R){const p=[];for(const o of R)for(const a in o)if(p.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}notifyConfigurationSchemaUpdated(...R){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(R){for(const p of R)this.overrideIdentifiers.add(p);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(R,p=!0,o,a=3){a=k.isUndefinedOrNull(R.scope)?a:R.scope;let t=[],r=R.properties;if(r)for(let s in r){if(p&&C(s)){delete r[s];continue}const h=r[s];if(this.updatePropertyDefaultValue(s,h),e.OVERRIDE_PROPERTY_PATTERN.test(s)?h.scope=void 0:(h.scope=k.isUndefinedOrNull(h.scope)?a:h.scope,h.restricted=k.isUndefinedOrNull(h.restricted)?!!o?.restrictedConfigurations?.includes(s):h.restricted),r[s].hasOwnProperty("included")&&!r[s].included){this.excludedConfigurationProperties[s]=r[s],delete r[s];continue}else this.configurationProperties[s]=r[s];!r[s].deprecationMessage&&r[s].markdownDeprecationMessage&&(r[s].deprecationMessage=r[s].markdownDeprecationMessage),t.push(s)}let i=R.allOf;if(i)for(let s of i)t.push(...this.validateAndRegisterProperties(s,p,o,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(R){const p=o=>{let a=o.properties;if(a)for(const r in a)this.updateSchema(r,a[r]);let t=o.allOf;t&&t.forEach(p)};p(R)}updateSchema(R,p){switch(e.allSettings.properties[R]=p,p.scope){case 1:e.applicationSettings.properties[R]=p;break;case 2:e.machineSettings.properties[R]=p;break;case 6:e.machineOverridableSettings.properties[R]=p;break;case 3:e.windowSettings.properties[R]=p;break;case 4:e.resourceSettings.properties[R]=p;break;case 5:e.resourceSettings.properties[R]=p,this.resourceLanguageSettingsSchema.properties[R]=p;break}}removeFromSchema(R,p){switch(delete e.allSettings.properties[R],p.scope){case 1:delete e.applicationSettings.properties[R];break;case 2:delete e.machineSettings.properties[R];break;case 6:delete e.machineOverridableSettings.properties[R];break;case 3:delete e.windowSettings.properties[R];break;case 4:case 5:delete e.resourceSettings.properties[R];break}}updateOverridePropertyPatternKey(){for(const R of this.overrideIdentifiers.values()){const p=`[${R}]`,o={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(p,o),e.allSettings.properties[p]=o,e.applicationSettings.properties[p]=o,e.machineSettings.properties[p]=o,e.machineOverridableSettings.properties[p]=o,e.windowSettings.properties[p]=o,e.resourceSettings.properties[p]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(R,p){let o=this.defaultValues[R];k.isUndefined(o)&&(o=p.default),k.isUndefined(o)&&(o=g(p.type)),p.default=o}}const y="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(y);function m(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=m;function g(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const u=new n;L.Registry.add(e.Extensions.Configuration,u);function C(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?w.localize(5,null,b):u.getConfigurationProperties()[b]!==void 0?w.localize(6,null,b):null:w.localize(4,null)}e.validateProperty=C;function P(){const b=[],R=u.getConfigurationProperties();for(const p of Object.keys(R))b.push([p,R[p].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=P}),define(Z[24],ee([0,1,26,16,5,32,7,38]),function(K,e,w,I,L,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function E(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=E;var v;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(v=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function y(r,i){const s=i?r?i.keys.filter(T=>r.keys.indexOf(T)===-1):[...i.keys]:[],h=r?i?r.keys.filter(T=>i.keys.indexOf(T)===-1):[...r.keys]:[],c=[];if(i&&r){for(const T of r.keys)if(i.keys.indexOf(T)!==-1){const O=b(r.contents,T),_=b(i.contents,T);w.equals(O,_)||c.push(T)}}const l=[],f=T=>{const O={};for(const _ of T)for(const z of _.identifiers)O[a(z)]=_;return O},S=i?f(i.overrides):{},d=r?f(r.overrides):{};if(Object.keys(S).length)for(const T of s){const O=S[T];O&&l.push([(0,D.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(d).length)for(const T of h){const O=d[T];O&&l.push([(0,D.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(S).length&&Object.keys(d).length)for(const T of c){const O=d[T],_=S[T];if(O&&_){const z=y({contents:O.contents,keys:O.keys,overrides:[]},{contents:_.contents,keys:_.keys,overrides:[]});l.push([(0,D.overrideIdentifierFromKey)(T),[...z.added,...z.removed,...z.updated]])}}return{added:s,removed:h,updated:c,overrides:l}}e.compare=y;function m(r,i){const s=[];for(const h of Object.keys(r))if(D.OVERRIDE_PROPERTY_PATTERN.test(h)){const c={};for(const l in r[h])c[l]=r[h][l];s.push({identifiers:[(0,D.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(c),contents:g(c,i)})}return s}e.toOverrides=m;function g(r,i){const s=Object.create(null);for(let h in r)u(s,h,r[h],i);return s}e.toValuesTree=g;function u(r,i,s,h){const c=i.split("."),l=c.pop();let f=r;for(let S=0;S<c.length;S++){let d=c[S],T=f[d];switch(typeof T){case"undefined":T=f[d]=Object.create(null);break;case"object":break;default:h(`Ignoring ${i} as ${c.slice(0,S+1).join(".")} is ${JSON.stringify(T)}`);return}f=T}if(typeof f=="object"&&f!==null)try{f[l]=s}catch(S){h(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(f)}`)}else h(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(f)}`)}e.addToValueTree=u;function C(r,i){const s=i.split(".");P(r,s)}e.removeFromValueTree=C;function P(r,i){const s=i.shift();if(i.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const h=r[s];typeof h=="object"&&!Array.isArray(h)&&(P(h,i),Object.keys(h).length===0&&delete r[s])}}function b(r,i,s){function h(f,S){let d=f;for(const T of S){if(typeof d!="object"||d===null)return;d=d[T]}return d}const c=i.split("."),l=h(r,c);return typeof l=="undefined"?s:l}e.getConfigurationValue=b;function R(r,i,s){Object.keys(i).forEach(h=>{h!=="__proto__"&&(h in r?I.isObject(r[h])&&I.isObject(i[h])?R(r[h],i[h],s):s&&(r[h]=i[h]):r[h]=i[h])})}e.merge=R;function p(){const r=k.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=p;function o(){const r=Object.create(null),i=k.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let s in i){let h=i[s].default;u(r,s,h,c=>console.error(`Conflict in default settings: ${c}`))}return r}e.getDefaultValues=o;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,i,s){const h=r.inspect(i),c=r.inspect(s);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:h.defaultValue}e.getMigratedSettingValue=t}),define(Z[173],ee([0,1,33,39,23,16,26,5,38,24,32,2,3]),function(K,e,w,I,L,k,A,D,E,v,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,v.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?(0,v.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const s of L.distinct([...Object.keys(this.contents),...Object.keys(r)])){let h=this.contents[s],c=r[s];c&&(typeof h=="object"&&typeof c=="object"?(h=A.deepClone(h),this.mergeContents(h,c)):h=c),i[s]=h}return new g(i,this.keys,this.overrides)}merge(...t){const r=A.deepClone(this.contents),i=A.deepClone(this.overrides),s=[...this.keys];for(const h of t){this.mergeContents(r,h.contents);for(const c of h.overrides){const[l]=i.filter(f=>L.equals(f.identifiers,c.identifiers));l?this.mergeContents(l.contents,c.contents):i.push(A.deepClone(c))}for(const c of h.keys)s.indexOf(c)===-1&&s.push(c)}return new g(r,s,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&k.isObject(t[i])&&k.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=A.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,v.addToValueTree)(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,v.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=g;class u extends g{constructor(){const t=(0,v.getDefaultValues)(),r=(0,v.getConfigurationKeys)(),i=[];for(const s of Object.keys(t))E.OVERRIDE_PROPERTY_PATTERN.test(s)&&i.push({identifiers:[(0,E.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,v.toValuesTree)(t[s],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,r,i)}}e.DefaultConfigurationModel=u;class C{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!k.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:s,overrides:h,restricted:c}=this.doParseRaw(t,r);this._configurationModel=new g(i,s,h),this._restrictedConfigurations=c||[]}doParseContent(t){let r={},i=null,s=[],h=[],c=[];function l(S){Array.isArray(s)?s.push(S):i!==null&&(s[i]=S)}let f={onObjectBegin:()=>{let S={};l(S),h.push(s),s=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{s=h.pop()},onArrayBegin:()=>{let S=[];l(S),h.push(s),s=S,i=null},onArrayEnd:()=>{s=h.pop()},onLiteralValue:l,onError:(S,d,T)=>{c.push({error:S,offset:d,length:T})}};if(t)try{w.visit(t,f),r=s[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return r}doParseRaw(t,r){const i=n.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,i,!0,r);t=s.raw;const h=(0,v.toValuesTree)(t,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),c=Object.keys(t),l=(0,v.toOverrides)(t,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:h,keys:c,overrides:l,restricted:s.restricted}}filter(t,r,i,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:t,restricted:[]};const h={},c=[];for(let l in t)if(E.OVERRIDE_PROPERTY_PATTERN.test(l)&&i){const f=this.filter(t[l],r,!1,s);h[l]=f.raw,c.push(...f.restricted)}else{const f=r[l],S=f?typeof f.scope!="undefined"?f.scope:3:void 0;f?.restricted&&c.push(l),(S===void 0||s.scopes===void 0||s.scopes.includes(S))&&(s.skipRestricted&&f?.restricted||(h[l]=t[l]))}return{raw:h,restricted:c}}}e.ConfigurationModelParser=C;class P extends y.Disposable{constructor(t,r,i,s){super();this.userSettingsResource=t,this.scopes=r,this.fileService=s,this._onDidChange=this._register(new m.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(m.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class b{constructor(t,r,i=new g,s=new g,h=new I.ResourceMap,c=new g,l=new I.ResourceMap,f=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=s,this._folderConfigurations=h,this._memoryConfiguration=c,this._memoryConfigurationByResource=l,this._freeze=f,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let s;i.resource?(s=this._memoryConfigurationByResource.get(i.resource),s||(s=new g,this._memoryConfigurationByResource.set(i.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(t):s.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const s=this.getConsolidateConfigurationModel(r,i),h=this.getFolderConfigurationModelForResource(r.resource,i),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),f=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),S=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),d=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=h?r.overrideIdentifier?h.freeze().override(r.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,_=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(t):c.getValue(t),z=s.getValue(t),H=L.distinct(L.flatten(s.overrides.map(V=>V.identifiers))).filter(V=>s.getOverrideValue(t,V)!==void 0);return{defaultValue:l,userValue:f,userLocalValue:S,userRemoteValue:d,workspaceValue:T,workspaceFolderValue:O,memoryValue:_,value:z,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:f!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:d!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:h?.freeze().getValue(t),override:r.overrideIdentifier?h?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:_!==void 0?{value:c.getValue(t),override:r.overrideIdentifier?c.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(s=>E.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const h=(0,E.overrideIdentifierFromKey)(s),c=this._defaultConfiguration.getKeysForOverrideIdentifier(h),l=t.getKeysForOverrideIdentifier(h),f=[...l.filter(S=>c.indexOf(S)===-1),...c.filter(S=>l.indexOf(S)===-1),...c.filter(S=>!A.equals(this._defaultConfiguration.override(h).getValue(S),t.override(h).getValue(S)))];return[h,f]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:h}=(0,v.compare)(this.localUserConfiguration,t),c=[...r,...i,...s];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:h}=(0,v.compare)(this.remoteUserConfiguration,t);let c=[...r,...i,...s];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:s,overrides:h}=(0,v.compare)(this.workspaceConfiguration,t);let c=[...r,...i,...s];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:h}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:s,updated:h,removed:c,overrides:l}=(0,v.compare)(i,r);let f=[...s,...h,...c];return(f.length||!i)&&this.updateFolderConfiguration(t,r),{keys:f,overrides:l}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:s,removed:h,overrides:c}=(0,v.compare)(r,void 0);return{keys:[...i,...s,...h],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const s=r.getFolder(t);s&&(i=this.getFolderConsolidatedConfiguration(s.uri)||i);const h=this._memoryConfigurationByResource.get(t);h&&(i=i.merge(h))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(r=i.merge(s),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:s,keys:h}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:s,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((c,l)=>(c.set(D.URI.revive(l[0]),this.parseConfigurationModel(l[1])),c),new I.ResourceMap);return new b(r,i,new g,s,h,new g,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function R(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const s of a)s.keys.forEach(h=>t.add(h)),s.overrides.forEach(([h,c])=>{const l=(0,I.getOrSet)(r,h,new Set);c.forEach(f=>l.add(f))});const i=[];return r.forEach((s,h)=>i.push([h,[...s.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=R;class p{constructor(t,r,i,s){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=s,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(l=>h.add(l)),t.overrides.forEach(([,l])=>l.forEach(f=>h.add(f))),this.affectedKeys=[...h.values()];const c=new g;this.affectedKeys.forEach(l=>c.setValue(l,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!A.equals(i,s)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=(0,v.toValuesTree)({[r]:!0},()=>{}),s;for(;typeof i=="object"&&(s=Object.keys(i)[0]);){if(t=t[s],!t)return!1;i=i[s]}return!0}}e.ConfigurationChangeEvent=p;class o extends p{constructor(t,r,i,s){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=o}),define(Z[174],ee([0,1,32,38,2,24,173,3,6,15]),function(K,e,w,I,L,k,A,D,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends L.Disposable{constructor(m,g){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new A.UserSettings(this.settingsResource,void 0,v.extUriBiasedIgnorePathCase,g)),this.configuration=new A.Configuration(new A.DefaultConfigurationModel,new A.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new A.Configuration(new A.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,g){const u=typeof m=="string"?m:void 0,C=(0,k.isConfigurationOverrides)(m)?m:(0,k.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(u,C,void 0)}updateValue(m,g,u,C){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const g=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(u,g,1)}onDidDefaultConfigurationChange(m){const g=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new A.DefaultConfigurationModel,m);this.trigger(u,g,6)}trigger(m,g,u){const C=new A.ConfigurationChangeEvent(m,{data:g},this.configuration);C.source=u,C.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Z[175],ee([0,1,24,14,105]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(D,E){this.configurationService=D,this.logService=E}request(D,E){return this.logService.trace("RequestService#request",D.url),D.proxyAuthorization||(D.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,L.request)(D,E)}async resolveProxy(D){}};k=de([Y(0,w.IConfigurationService),Y(1,I.ILogService)],k),e.RequestService=k}),define(Z[41],ee([0,1,125,7,38,32,25]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");function D(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=D;function E(u){return u.res.statusCode===204}async function v(u){if(!D(u))throw new Error("Server returned "+u.res.statusCode);return E(u)?null:(await(0,A.streamToBuffer)(u.stream)).toString()}e.asText=v;async function n(u){if(!D(u))throw new Error("Server returned "+u.res.statusCode);if(E(u))return null;const P=(await(0,A.streamToBuffer)(u.stream)).toString();try{return JSON.parse(P)}catch(b){throw b.message+=`:
`+P,b}}e.asJson=n;function y(u){g(u)}e.updateProxyConfigurationsScope=y;let m;function g(u){const C=k.Registry.as(L.Extensions.Configuration);m&&C.deregisterConfigurations([m]),m={id:"http",order:15,title:(0,w.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,w.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,w.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,w.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,w.localize)(4,null),(0,w.localize)(5,null),(0,w.localize)(6,null),(0,w.localize)(7,null)],default:"override",description:(0,w.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,w.localize)(9,null),restricted:!0}}},C.registerConfiguration(m)}g(2)}),define(Z[176],ee([0,1,41,29,13,17]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(E,v){this.requestService=E,this.fileService=v}async download(E,v,n=I.CancellationToken.None){if(E.scheme===k.Schemas.file||E.scheme===k.Schemas.vscodeRemote){await this.fileService.copy(E,v);return}const y={type:"GET",url:E.toString()},m=await this.requestService.request(y,n);if(m.res.statusCode===200)await this.fileService.writeFile(v,m.stream);else{const g=await(0,w.asText)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${g}`)}}};A=de([Y(0,w.IRequestService),Y(1,L.IFileService)],A),e.DownloadService=A}),define(Z[177],ee([0,1,28,13,23,63,41,29,14,15,139,2]),function(K,e,w,I,L,k,A,D,E,v,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let m=class extends y.Disposable{constructor(u,C,P,b){super();this.fileService=u,this.productService=C,this.requestService=P,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:R})=>this.allConfigBasedTips.set(R.configPath,R))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const C=[];for(const[P,b]of this.allConfigBasedTips)try{const R=await this.fileService.readFile((0,v.joinPath)(u,P)),p=new Map;(0,k.forEach)(b.recommendations,({key:a,value:t})=>{if((0,L.isNonEmptyArray)(t.remotes))for(const r of t.remotes)p.set(r,{extensionId:a,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else C.push({extensionId:a,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=(0,n.getDomainsOfRemotes)(R.value.toString(),[...p.keys()]);for(const a of o){const t=p.get(a);t&&C.push(t)}}catch(R){}return C}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const u=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},D.CancellationToken.None);if(u.res.statusCode!==200)return[];const C=await(0,A.asJson)(u);return C?C.workspaceRecommendations||[]:[]}catch(u){return this.logService.error(u),[]}}};m=de([Y(0,I.IFileService),Y(1,w.IProductService),Y(2,A.IRequestService),Y(3,E.ILogService)],m),e.ExtensionTipsService=m}),define(Z[45],ee([0,1,30,25]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(k,A,D){let E=D&&D.get("storage.serviceMachineId",0)||null;if(E)return E;try{const n=(await A.readFile(k.serviceMachineIdResource)).value.toString();E=(0,w.isUUID)(n)?n:null}catch(v){E=null}if(!E){E=(0,w.generateUuid)();try{await A.writeFile(k.serviceMachineIdResource,I.VSBuffer.fromString(E))}catch(v){}}return D&&D.store("storage.serviceMachineId",E,0,1),E}e.getServiceMachineId=L}),define(Z[20],ee([0,1,7,3,2,16,70,6]),function(K,e,w,I,L,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,w.createDecorator)("storageService");var v;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(v=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var y;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class m extends L.Disposable{constructor(P={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,b){b===E?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:b,target:this.getKeyTargets(P)[b]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,b,R){return this.getStorage(b)?.get(P,R)}getBoolean(P,b,R){return this.getStorage(b)?.getBoolean(P,R)}getNumber(P,b,R){return this.getStorage(b)?.getNumber(P,R)}store(P,b,R,p){if((0,k.isUndefinedOrNull)(b)){this.remove(P,R);return}this.withPausedEmitters(()=>{this.updateKeyTarget(P,R,p),this.getStorage(R)?.set(P,b)})}remove(P,b){this.withPausedEmitters(()=>{this.updateKeyTarget(P,b,void 0),this.getStorage(b)?.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,b){const R=[],p=this.getKeyTargets(P);for(const o of Object.keys(p))p[o]===b&&R.push(o);return R}updateKeyTarget(P,b,R){const p=this.getKeyTargets(b);typeof R=="number"?p[P]!==R&&(p[P]=R,this.getStorage(b)?.set(E,JSON.stringify(p))):typeof p[P]=="number"&&(delete p[P],this.getStorage(b)?.set(E,JSON.stringify(p)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const b=this.get(E,P);if(b)try{return JSON.parse(b)}catch(R){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(){this._onWillSaveState.fire({reason:v.NONE}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const P=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return u(P,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;class g extends m{constructor(){super();this.globalStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=g;async function u(C,P,b,R){const p=h=>{try{return JSON.parse(h)}catch(c){return h}},o=new Map,a=new Map;C.forEach((h,c)=>{o.set(c,h),a.set(c,p(h))});const t=new Map,r=new Map;P.forEach((h,c)=>{t.set(c,h),r.set(c,p(h))}),console.group(`Storage: Global (path: ${b})`);let i=[];o.forEach((h,c)=>{i.push({key:c,value:h})}),console.table(i),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${R})`);let s=[];t.forEach((h,c)=>{s.push({key:c,value:h})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=u}),define(Z[178],ee([0,1,3,2,27,31,20,16]),function(K,e,w,I,L,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let E=class extends I.Disposable{constructor(y){super();this._onDidChangeEnablement=new w.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new v(y)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"})))}async enableExtension(y,m){return this._removeFromDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:m}),!0):!1}async disableExtension(y,m){return this._addToDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(y){let m=this.getDisabledExtensions();return m.every(g=>!(0,k.areSameExtensions)(g,y))?(m.push(y),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(y){let m=this.getDisabledExtensions();for(let g=0;g<m.length;g++){const u=m[g];if((0,k.areSameExtensions)(u,y))return m.splice(g,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(y){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,y)}_getExtensions(y){return this.storageManger.get(y,0)}_setExtensions(y,m){this.storageManger.set(y,m,0)}};E=de([Y(0,A.IStorageService)],E),e.GlobalExtensionEnablementService=E;class v extends I.Disposable{constructor(y){super();this.storageService=y,this.storage=Object.create(null),this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this._register(y.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(y,m){let g;return m===0?((0,D.isUndefinedOrNull)(this.storage[y])&&(this.storage[y]=this._get(y,m)),g=this.storage[y]):g=this._get(y,m),JSON.parse(g)}set(y,m,g){let u=JSON.stringify(m.map(({id:P,uuid:b})=>({id:P,uuid:b})));this._get(y,g)!==u&&(g===0&&(m.length?this.storage[y]=u:delete this.storage[y]),this._set(y,m.length?u:void 0,g))}onDidStorageChange(y){if(y.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[y.key])&&this._get(y.key,y.scope)!==this.storage[y.key]){const g=this.get(y.key,y.scope);delete this.storage[y.key];const u=this.get(y.key,y.scope),C=g.filter(b=>!u.some(R=>(0,k.areSameExtensions)(b,R))),P=u.filter(b=>!g.some(R=>(0,k.areSameExtensions)(R,b)));(C.length||P.length)&&this._onDidChange.fire([...C,...P])}}_get(y,m){return this.storageService.get(y,m,"[]")}_set(y,m,g){m?this.storageService.store(y,m,g,1):this.storageService.remove(y,g)}}e.StorageManager=v}),define(Z[179],ee([0,1,3,2]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends I.Disposable{constructor(v,n){super();this.channel=v,this.workspace=n}async getItems(){const v={workspace:this.workspace},n=await this.channel.call("getItems",v);return new Map(n)}updateItems(v){const n={workspace:this.workspace};return v.insert&&(n.insert=Array.from(v.insert.entries())),v.delete&&(n.delete=Array.from(v.delete.values())),this.channel.call("updateItems",n)}}class k extends L{constructor(v){super(v,void 0);this._onDidChangeItemsExternal=this._register(new w.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(v=>this.onDidChangeGlobalStorage(v)))}onDidChangeGlobalStorage(v){(Array.isArray(v.changed)||Array.isArray(v.deleted))&&this._onDidChangeItemsExternal.fire({changed:v.changed?new Map(v.changed):void 0,deleted:v.deleted?new Set(v.deleted):void 0})}async close(){this.dispose()}}class A extends L{constructor(v,n){super(v,n);this.onDidChangeItemsExternal=w.Event.None}async close(){const v={workspace:this.workspace};return this.channel.call("close",v)}}class D extends I.Disposable{constructor(v,n){super();this.channel=v,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=D}),define(Z[180],ee([0,1,2,20,70,6,169,179,15]),function(K,e,w,I,L,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class v extends I.AbstractStorageService{constructor(y,m,g){super();this.mainProcessService=m,this.environmentService=g,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new w.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(y)}createGlobalStorage(){const y=new D.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),m=new L.Storage(y.globalStorage);return this._register(m.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),m}createWorkspaceStorage(y){const m=new D.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),y);if(m.workspaceStorage){const g=new L.Storage(m.workspaceStorage);return this.workspaceStorageDisposable.value=g.onDidChangeStorage(u=>this.emitDidChangeValue(1,u)),this.workspaceStorageId=y?.id,g}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,A.mark)("code/willInitStorage");try{await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,A.mark)("code/didInitStorage")}}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,E.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(I.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(y){const m=this.workspaceStorage,g=m?.items??new Map;m&&(await m.close(),m.dispose()),this.workspaceStorage=this.createWorkspaceStorage(y),await this.workspaceStorage.init();for(const[u,C]of g)this.workspaceStorage.set(u,C)}}e.NativeStorageService=v}),define(Z[181],ee([0,1,4,35,30,5]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(v){if(w.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function D(v,n,y,m,g,u,C,P,b,R){const p=Object.create(null);p["common.machineId"]=C,p.sessionID=(0,L.generateUuid)()+Date.now(),p.commitHash=g,p.version=u,p["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,w.PlatformToString)(w.platform),p["common.nodePlatform"]=I.platform,p["common.nodeArch"]=m,p["common.product"]=R||"desktop";const o=E(P||[]);o&&(p["common.msftInternal"]=o);let a=0;const t=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),w.isLinuxSnap&&(p["common.snap"]="true");const r=A(y);r&&(p["common.platformDetail"]=r);try{const i=await v.readFile(k.URI.file(b));p["common.source"]=i.value.toString().slice(0,30)}catch(i){}return p}e.resolveCommonProperties=D;function E(v){const n=I.env.USERDNSDOMAIN;if(!n)return!1;const y=n.toLowerCase();return v.some(m=>y===m)}e.verifyMicrosoftInternalDomain=E}),define(Z[21],ee([0,1,7]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[182],ee([0,1,34,98,73,8,33,100,28,4,5,21,55,17,13,18]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function P(a,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,s=new Map,h=2e4;function c(S,d,T,O){const _=d.substring(S.length+1);return new Promise(async z=>{let H;try{H=await C.Promises.readdir(d,{withFileTypes:!0})}catch(x){z();return}if(O.count>=h){O.count+=H.length,O.maxReached=!0,z();return}let V=H.length;if(V===0){z();return}let U=H;O.count+H.length>h&&(O.maxReached=!0,V=h-O.count,U=H.slice(0,V)),O.count+=H.length;for(const x of U)if(x.isDirectory()){if(T.includes(x.name)||await c(S,(0,k.join)(d,x.name),T,O),--V==0){z();return}}else{const M=x.name.lastIndexOf(".");if(M>=0){const $=x.name.substring(M+1);$&&i.set($,(i.get($)??0)+1)}for(const $ of r)$.relativePathPattern?.test(_)!==!1&&$.filePattern.test(x.name)&&s.set($.tag,(s.get($.tag)??0)+1);if(--V==0){z();return}}})}const l={count:0,maxReached:!1};await c(a,a,t,l);const f=await p(a);return{configFiles:b(s),fileTypes:b(i),fileCount:l.count,maxFilesReached:l.maxReached,launchConfigFiles:f}}e.collectWorkspaceStats=P;function b(a){return[...m.Iterable.map(a.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function R(){const a={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},t=w.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=R;async function p(a){try{const t=new Map,r=(0,k.join)(a,".vscode","launch.json"),i=await C.Promises.readFile(r),s=[],h=(0,A.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,A.getNodeType)(h)==="object"&&h.configurations)for(const c of h.configurations){const l=c.type;l&&(t.has(l)?t.set(l,t.get(l)+1):t.set(l,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=p;let o=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const i=w.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(w.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),v.isWindows||r.push(`Load (avg):       ${w.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,D.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[s,h]=i,c=this.formatProcessList(t,s);return r.forEach(l=>{if((0,L.isRemoteDiagnosticError)(l))c+=`
${l.errorMessage}`,h+=`
${l.errorMessage}`;else if(c+=`

Remote: ${l.hostName}`,l.processes&&(c+=`
${this.formatProcessList(t,l.processes)}`),l.workspaceMetadata){h+=`
|  Remote: ${l.hostName}`;for(const f of Object.keys(l.workspaceMetadata)){const S=l.workspaceMetadata[f];let d=`${S.fileCount} files`;S.maxFilesReached&&(d=`more than ${d}`),h+=`|    Folder (${f}): ${d}`,h+=this.formatWorkspaceStats(S)}}}),{processInfo:c,workspaceInfo:h}})}async getSystemInfo(t,r){const{memory:i,vmHint:s,os:h,cpus:c}=R(),l={os:h,memory:i,cpus:c,vmHint:s,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return v.isWindows||(l.load=`${w.loadavg().map(f=>Math.round(f)).join(", ")}`),v.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(t,r){const i=[];return(0,D.listProcesses)(t.mainPID).then(async s=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,s)),t.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(h=>{if((0,L.isRemoteDiagnosticError)(h))i.push(`
${h.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${h.hostName}`),i.push(this.formatMachineInfo(h.machineInfo)),h.processes&&i.push(this.formatProcessList(t,h.processes)),h.workspaceMetadata)for(const c of Object.keys(h.workspaceMetadata)){const l=h.workspaceMetadata[c];let f=`${l.fileCount} files`;l.maxFilesReached&&(f=`more than ${f}`),i.push(`Folder (${c}): ${f}`),i.push(this.formatWorkspaceStats(l))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let s=0;const h=(S,d)=>{const T=` ${S}(${d})`;s+T.length>i?(r.push(c),c="|                 ",s=c.length):s+=T.length,c+=T};let c="|      File types:";const l=10;let f=t.fileTypes.length>l?l:t.fileTypes.length;for(let S=0;S<f;S++){const d=t.fileTypes[S];h(d.name,d.count)}if(r.push(c),t.configFiles.length>=0&&(c="|      Conf files:",s=0,t.configFiles.forEach(S=>{h(S.name,S.count)}),r.push(c)),t.launchConfigFiles.length>0){let S="|      Launch Configs:";t.launchConfigFiles.forEach(d=>{S+=d.count>1?` ${d.name}(${d.count})`:` ${d.name}`}),r.push(S)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(h=>{const c=n.URI.revive(h);if(c.scheme===g.Schemas.file){const l=c.fsPath;i.push(P(l,["node_modules",".git"]).then(f=>{let S=`${f.fileCount} files`;f.maxFilesReached&&(S=`more than ${S}`),r.push(`|    Folder (${(0,k.basename)(l)}): ${S}`),r.push(this.formatWorkspaceStats(f))}).catch(f=>{r.push(`|      Error: Unable to collect workspace stats for folder ${l} (${f.toString()})`)}))}else r.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(h=>i.set(h.pid,h.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,s,r,0),s.join(`
`)}formatProcessItem(t,r,i,s,h){const c=h===0;let l;c?l=s.pid===t?`${this.productService.applicationName} main`:"remote agent":(l=`${"  ".repeat(h)} ${s.name}`,s.name==="window"&&(l=`${l} (${r.get(s.pid)})`));const f=process.platform==="win32"?s.mem:w.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(f/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(s.children)&&s.children.forEach(S=>this.formatProcessItem(t,r,i,S,h+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=n.URI.revive(r);if(i.scheme!==g.Schemas.file)continue;const s=i.fsPath;try{const h=await P(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),h.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),h.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),h.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};o=de([Y(0,y.ITelemetryService),Y(1,E.IProductService)],o),e.DiagnosticsService=o}),define(Z[183],ee([0,1,114,2,27,31,3,44,14,21,29,11,5,6,4]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let C=class extends I.Disposable{constructor(o,a,t){super();this.galleryService=o,this.telemetryService=a,this.logService=t,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(o,a={}){if(!this.galleryService.isEnabled())throw new Error(w.localize(0,null));try{o=await this.checkAndGetCompatibleVersion(o)}catch(r){throw this.logService.error((0,y.getErrorMessage)(r)),b(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(o),void 0,r),r}if(!await this.canInstall(o)){const r=new L.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",o.identifier.id,r.message),b(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(o),void 0,r),r}const t=await this.galleryService.getManifest(o,n.CancellationToken.None);if(t===null){const r=new L.ExtensionManagementError(`Missing manifest for extension ${o.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",o.identifier.id,r.message),b(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(o),void 0,r),r}return this.installExtension(t,o,a)}async uninstall(o,a={}){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.unininstallExtension(o,a)}async reinstallFromGallery(o){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",o.identifier.id),!this.galleryService.isEnabled())throw new Error(w.localize(1,null));const a=await this.findGalleryExtension(o);if(!a)throw new Error(w.localize(2,null));await this.createUninstallExtensionTask(o,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(a)}getExtensionsReport(){const o=new Date().getTime();return(!this.reportedExtensions||o-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=o),this.reportedExtensions}registerParticipant(o){this.participants.push(o)}async installExtension(o,a,t){if(!m.URI.isUri(a)){let c=this.installingExtensions.get(new k.ExtensionIdentifierWithVersion(a.identifier,a.version).key());if(c)return this.logService.info("Extensions is already requested to install",a.identifier.id),c.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],i=[],s=this.createInstallExtensionTask(o,a,t);m.URI.isUri(a)||this.installingExtensions.set(new k.ExtensionIdentifierWithVersion(s.identifier,o.version).key(),s),this._onInstallExtension.fire({identifier:s.identifier,source:a}),this.logService.info("Installing extension:",s.identifier.id),r.push({task:s,manifest:o});let h=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",s.identifier.id);else try{const l=await this.getAllDepsAndPackExtensionsToInstall(s.identifier,o,!!t.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:f,manifest:S}of l)if(h=h||!!S.extensionDependencies?.some(d=>(0,k.areSameExtensions)({id:d},s.identifier)),this.installingExtensions.has(new k.ExtensionIdentifierWithVersion(f.identifier,f.version).key()))this.logService.info("Extension is already requested to install",f.identifier.id);else{const d=this.createInstallExtensionTask(S,f,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new k.ExtensionIdentifierWithVersion(d.identifier,S.version).key(),d),this._onInstallExtension.fire({identifier:d.identifier,source:f}),this.logService.info("Installing extension:",d.identifier.id),r.push({task:d,manifest:S})}}catch(l){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",s.identifier.id),this.logService.error(l),l}const c=r.reduce((l,{task:f,manifest:S})=>(l.set(f.identifier.id.toLowerCase(),{task:f,manifest:S}),l),new Map);for(;c.size;){let l;const f=[...c.values()].filter(({manifest:S})=>!S.extensionDependencies?.some(d=>c.has(d.toLowerCase())));f.length?l=c.size===1?f:f.filter(({task:S})=>!(S===s&&!h)):(this.logService.info("Found extensions with circular dependencies",f.map(({task:S})=>S.identifier.id)),l=[...c.values()]),await this.joinAllSettled(l.map(async({task:S})=>{const d=new Date().getTime();try{const T=await S.run();if(await this.joinAllSettled(this.participants.map(O=>O.postInstall(T,S.source,t,n.CancellationToken.None))),!m.URI.isUri(S.source)&&(b(this.telemetryService,S.operation===2?"extensionGallery:update":"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(S.source),new Date().getTime()-d,void 0),u.isWeb&&S.operation===1))try{await this.galleryService.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch(O){}i.push({local:T,identifier:S.identifier,operation:S.operation,source:S.source})}catch(T){throw m.URI.isUri(S.source)||b(this.telemetryService,S.operation===2?"extensionGallery:update":"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(S.source),new Date().getTime()-d,T),this.logService.error("Error while installing the extension:",S.identifier.id),this.logService.error(T),T}finally{c.delete(S.identifier.id.toLowerCase())}}))}return i.forEach(({identifier:l})=>this.logService.info("Extension installed successfully:",l.id)),this._onDidInstallExtensions.fire(i),i.filter(({identifier:l})=>(0,k.areSameExtensions)(l,s.identifier))[0].local}catch(c){if(r.forEach(({task:l})=>l.cancel()),i.length)try{const l=await Promise.allSettled(i.map(({local:f})=>this.createUninstallExtensionTask(f,{versionOnly:!0}).run()));for(let f=0;f<l.length;f++){const S=l[f],{identifier:d}=i[f];S.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",d.id):this.logService.warn("Rollback: Error while uninstalling extension",d.id,(0,y.getErrorMessage)(S.reason))}}catch(l){this.logService.warn("Error while rolling back extensions",(0,y.getErrorMessage)(l),i.map(({identifier:f})=>f.id))}throw this.logService.error("Failed to install extension:",s.identifier.id,(0,y.getErrorMessage)(c)),this._onDidInstallExtensions.fire(r.map(({task:l})=>({identifier:l.identifier,operation:1,source:l.source}))),c instanceof Error&&(c.name=c&&c.code?c.code:e.ERROR_UNKNOWN),c}finally{for(const{task:c,manifest:l}of r)if(!m.URI.isUri(c.source)){const f=new k.ExtensionIdentifierWithVersion(c.identifier,l.version).key();this.installingExtensions.delete(f)||this.logService.warn("Installation task is not found in the cache",f)}}}async joinAllSettled(o){const a=[],t=[],r=await Promise.allSettled(o);for(const i of r)i.status==="fulfilled"?a.push(i.value):t.push(i.reason);if(t.length)throw P(t);return a}async getAllDepsAndPackExtensionsToInstall(o,a,t){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const i=[o,...r.map(c=>c.identifier)],s=[],h=async(c,l)=>{const f=l.extensionDependencies||[];if(l.extensionPack){const S=t?r.find(d=>(0,k.areSameExtensions)(d.identifier,c)):void 0;for(const d of l.extensionPack)S&&S.manifest.extensionPack&&S.manifest.extensionPack.some(T=>(0,k.areSameExtensions)({id:T},{id:d}))||f.every(T=>!(0,k.areSameExtensions)({id:T},{id:d}))&&f.push(d)}if(f.length){const S=[...i,...s.map(T=>T.gallery.identifier)],d=f.filter(T=>S.every(O=>!(0,k.areSameExtensions)(O,{id:T})));if(d.length){const T=await this.galleryService.query({names:d,pageSize:f.length},n.CancellationToken.None);for(const O of T.firstPage){if(S.find(H=>(0,k.areSameExtensions)(H,O.identifier)))continue;const _=await this.checkAndGetCompatibleVersion(O);if(!await this.canInstall(_)){this.logService.info("Skipping the extension as it cannot be installed",_.identifier.id);continue}const z=await this.galleryService.getManifest(_,n.CancellationToken.None);if(z===null)throw new L.ExtensionManagementError(`Missing manifest for extension ${_.identifier.id}`,e.INSTALL_ERROR_VALIDATING);s.push({gallery:_,manifest:z}),await h(_.identifier,z)}}}};return await h(o,a),r=await this.getInstalled(),s.filter(c=>!r.some(l=>(0,k.areSameExtensions)(l.identifier,c.gallery.identifier)))}async checkAndGetCompatibleVersion(o){if(await this.isMalicious(o))throw new L.ExtensionManagementError(w.localize(3,null,o.identifier.id),L.INSTALL_ERROR_MALICIOUS);const a=await this.galleryService.getCompatibleExtension(o);if(!a)throw new L.ExtensionManagementError(w.localize(4,null,o.identifier.id,D.default.version),L.INSTALL_ERROR_INCOMPATIBLE);return a}async isMalicious(o){const a=await this.getExtensionsReport();return(0,k.getMaliciousExtensionsSet)(a).has(o.identifier.id)}async unininstallExtension(o,a){const t=this.uninstallingExtensions.get(o.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",o.identifier.id),t.waitUntilTaskIsFinished();const r=(c,l)=>{const f=this.createUninstallExtensionTask(c,l);return this.uninstallingExtensions.set(f.extension.identifier.id.toLowerCase(),f),this.logService.info("Uninstalling extension:",c.identifier.id),this._onUninstallExtension.fire(c.identifier),f},i=(c,l)=>{l?this.logService.error("Failed to uninstall extension:",c.identifier.id,l.message):this.logService.info("Successfully uninstalled extension:",c.identifier.id),b(this.telemetryService,"extensionGallery:uninstall",(0,k.getLocalExtensionTelemetryData)(c),void 0,l),this._onDidUninstallExtension.fire({identifier:c.identifier,error:l?.code})},s=[],h=[];try{s.push(r(o,{}));const c=await this.getInstalled(1);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",o.identifier.id);else{const l=this.getAllPackExtensionsToUninstall(o,c);for(const f of l)this.uninstallingExtensions.has(f.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",f.identifier.id):s.push(r(f,{}))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",o.identifier.id):this.checkForDependents(s.map(l=>l.extension),c,o),await this.joinAllSettled(s.map(async l=>{try{if(await l.run(),await this.joinAllSettled(this.participants.map(f=>f.postUninstall(l.extension,a,n.CancellationToken.None))),l.extension.identifier.uuid)try{await this.galleryService.reportStatistic(l.extension.manifest.publisher,l.extension.manifest.name,l.extension.manifest.version,"uninstall")}catch(f){}i(l.extension)}catch(f){const S=f instanceof L.ExtensionManagementError?f:new L.ExtensionManagementError((0,y.getErrorMessage)(f),e.ERROR_UNKNOWN);throw i(l.extension,S),S}finally{h.push(l)}}))}catch(c){const l=c instanceof L.ExtensionManagementError?c:new L.ExtensionManagementError((0,y.getErrorMessage)(c),e.ERROR_UNKNOWN);for(const f of s){try{f.cancel()}catch(S){}h.includes(f)||i(f.extension,l)}throw l}finally{for(const c of s)this.uninstallingExtensions.delete(c.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",c.extension.identifier.id)}}checkForDependents(o,a,t){for(const r of o){const i=this.getDependents(r,a);if(i.length){const s=i.filter(h=>o.indexOf(h)===-1);if(s.length)throw new Error(this.getDependentsErrorMessage(r,s,t))}}}getDependentsErrorMessage(o,a,t){return t===o?a.length===1?w.localize(5,null,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?w.localize(6,null,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):w.localize(7,null,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?w.localize(8,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?w.localize(9,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):w.localize(10,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}getAllPackExtensionsToUninstall(o,a,t=[]){if(t.indexOf(o)!==-1)return[];t.push(o);const r=o.manifest.extensionPack?o.manifest.extensionPack:[];if(r.length){const i=a.filter(h=>!h.isBuiltin&&r.some(c=>(0,k.areSameExtensions)({id:c},h.identifier))),s=[];for(const h of i)s.push(...this.getAllPackExtensionsToUninstall(h,a,t));return[...i,...s]}return[]}getDependents(o,a){return a.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(r=>(0,k.areSameExtensions)({id:r},o.identifier)))}async findGalleryExtension(o){if(o.identifier.uuid){const a=await this.findGalleryExtensionById(o.identifier.uuid);return a||this.findGalleryExtensionByName(o.identifier.id)}return this.findGalleryExtensionByName(o.identifier.id)}async findGalleryExtensionById(o){return(await this.galleryService.query({ids:[o],pageSize:1},n.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(o){return(await this.galleryService.query({names:[o],pageSize:1},n.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const o=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${o.length} reported extensions from service`),o}catch(o){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};C=de([Y(0,L.IExtensionGalleryService),Y(1,v.ITelemetryService),Y(2,E.ILogService)],C),e.AbstractExtensionManagementService=C;function P(p){const o=Array.isArray(p)?p:[p];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((a,t)=>new Error(`${a.message}${a.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=P;function b(p,o,a,t,r){const i=r?r instanceof L.ExtensionManagementError?r.code:e.ERROR_UNKNOWN:void 0;p.publicLogError(o,{...a,success:!r,duration:t,errorcode:i})}e.reportTelemetry=b;class R{constructor(){this.barrier=new g.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,g.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,g.createCancelablePromise)(o=>new Promise((a,t)=>{const r=o.onCancellationRequested(()=>{r.dispose(),t((0,y.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=R}),define(Z[184],ee([0,1,11,27,31,26,21,41,72,12,29,14,13,5,28,20,45,7,4]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var p;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished"})(p||(p={}));function o(...M){return String(M.reduce(($,q)=>$|q,0))}var a;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:p.None,criteria:[],assetTypes:[]};class h{constructor($=s){this.state=$}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage($,q=this.state.pageSize){return new h({...this.state,pageNumber:$,pageSize:q})}withFilter($,...q){const F=[...this.state.criteria,...q.length?q.map(W=>({filterType:$,value:W})):[{filterType:$}]];return new h({...this.state,criteria:F})}withSortBy($){return new h({...this.state,sortBy:$})}withSortOrder($){return new h({...this.state,sortOrder:$})}withFlags(...$){return new h({...this.state,flags:$.reduce((q,F)=>q|F,0)})}withAssetTypes(...$){return new h({...this.state,assetTypes:$})}get raw(){const{criteria:$,pageNumber:q,pageSize:F,sortBy:W,sortOrder:N,flags:G,assetTypes:B}=this.state;return{filters:[{criteria:$,pageNumber:q,pageSize:F,sortBy:W,sortOrder:N}],assetTypes:B,flags:G}}get searchText(){const $=this.state.criteria.filter(q=>q.filterType===a.SearchText)[0];return $&&$.value?$.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map($=>String($.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function c(M,$){const q=(M||[]).filter(F=>F.statisticName===$)[0];return q?q.value:0}function l(M){const $="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(F=>F.assetType.indexOf($)===0).reduce((F,W)=>{const N=T(M,W.assetType);return N&&F.push([W.assetType.substring($.length),N]),F},[])}function f(M){if(M.properties){const $=M.properties.filter(W=>W.key===t.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=$.filter(W=>q.test(W.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return T(M,t.Repository)}function S(M){return{uri:`${M.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${M.fallbackAssetUri}/${t.VSIX}`}}function d(M){const $=T(M,t.Icon);if($)return $;const q=I.DefaultIconPath;return{uri:q,fallbackUri:q}}function T(M,$){return M.files.filter(F=>F.assetType===$)[0]?{uri:`${M.assetUri}/${$}`,fallbackUri:`${M.fallbackAssetUri}/${$}`}:null}function O(M,$){const q=M.properties?M.properties.filter(W=>W.key===$):[],F=q.length>0&&q[0].value;return F?F.split(",").map(W=>(0,L.adoptToGalleryExtensionId)(W)):[]}function _(M){const $=M.properties?M.properties.filter(q=>q.key===r.Engine):[];return $.length>0&&$[0].value||""}function z(M){const $=M.properties?M.properties.filter(F=>F.key===r.LocalizedLanguages):[],q=$.length>0&&$[0].value||"";return q?q.split(","):[]}function H(M){return M.indexOf("preview")!==-1}function V(M,$,q,F,W){const N={manifest:T($,t.Manifest),readme:T($,t.Details),changelog:T($,t.Changelog),license:T($,t.License),repository:f($),download:S($),icon:d($),coreTranslations:l($)};return{identifier:{id:(0,L.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:$.version,date:$.lastUpdated,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,description:M.shortDescription||"",installCount:c(M.statistics,"install"),rating:c(M.statistics,"averagerating"),ratingCount:c(M.statistics,"ratingcount"),assetUri:g.URI.parse($.assetUri),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),webExtension:!!M.tags?.includes(I.WEB_EXTENSION_TAG),assetTypes:$.files.map(({assetType:G})=>G),assets:N,properties:{dependencies:O($,r.Dependency),extensionPack:O($,r.ExtensionPack),engine:_($),localizedLanguages:z($)},telemetryData:{index:(F.pageNumber-1)*F.pageSize+q,querySource:W},preview:H(M.flags)}}let U=class{constructor($,q,F,W,N,G,B){this.requestService=$,this.logService=q,this.environmentService=F,this.telemetryService=W,this.fileService=N,this.productService=G;const J=G.extensionsGallery;this.extensionsGalleryUrl=J&&J.serviceUrl,this.extensionsControlUrl=J&&J.controlUrl,this.commonHeadersPromise=x(G.version,this.environmentService,this.fileService,B)}api($=""){return`${this.extensionsGalleryUrl}${$}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions($,q){const F=[];let{total:W,firstPage:N,getPage:G}=await this.query({names:$,pageSize:$.length},q);F.push(...N);for(let B=1;F.length<W&&(N=await G(B,q),N.length);B++)F.push(...N);return F}async getCompatibleExtension($,q){return this.getCompatibleExtensionByEngine($,q)}async getCompatibleExtensionByEngine($,q){const F=(0,I.isIExtensionIdentifier)($)?null:$;if(F&&F.properties.engine&&(0,E.isEngineValid)(F.properties.engine,this.productService.version,this.productService.date))return F;const{id:W,uuid:N}=F?F.identifier:$;let G=new h().withFlags(p.IncludeAssetUri,p.IncludeStatistics,p.IncludeCategoryAndTags,p.IncludeFiles,p.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");N?G=G.withFilter(a.ExtensionId,N):G=G.withFilter(a.ExtensionName,W);const{galleryExtensions:B}=await this.queryGallery(G,n.CancellationToken.None),[J]=B;if(!J||!J.versions.length)return null;if(q){const ie=J.versions.filter(ne=>ne.version===q)[0];if(ie){const ne=V(J,ie,0,G);if(ne.properties.engine&&(0,E.isEngineValid)(ne.properties.engine,this.productService.version,this.productService.date))return ne}return null}const Q=await this.getLastValidExtensionVersion(J,J.versions);return Q?V(J,Q,0,G):null}async query($,q){const F=n.CancellationToken.isCancellationToken($)?{}:$,W=n.CancellationToken.isCancellationToken($)?$:q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let N=F.text||"";const G=(0,k.getOrDefault)(F,le=>le.pageSize,50);let B=new h().withFlags(p.IncludeLatestVersionOnly,p.IncludeAssetUri,p.IncludeStatistics,p.IncludeCategoryAndTags,p.IncludeFiles,p.IncludeVersionProperties).withPage(1,G).withFilter(a.Target,"Microsoft.VisualStudio.Code");N?(N=N.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,fe,me)=>(B=B.withFilter(a.Category,me||fe),"")),N=N.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,fe,me)=>(B=B.withFilter(a.Tag,me||fe),"")),N=N.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(a.Featured),"")),N=N.trim(),N&&(N=N.length<200?N:N.substring(0,200),B=B.withFilter(a.SearchText,N)),B=B.withSortBy(0)):F.ids?B=B.withFilter(a.ExtensionId,...F.ids):F.names?B=B.withFilter(a.ExtensionName,...F.names):B=B.withSortBy(4),typeof F.sortBy=="number"&&(B=B.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(B=B.withSortOrder(F.sortOrder));const{galleryExtensions:J,total:Q}=await this.queryGallery(B,W),ie=J.map((le,fe)=>V(le,le.versions[0],fe,B,F.source)),ne=async(le,fe)=>{if(fe.isCancellationRequested)throw(0,w.canceled)();const me=B.withPage(le+1),{galleryExtensions:Se}=await this.queryGallery(me,fe);return Se.map((Pe,ke)=>V(Pe,Pe.versions[0],ke,me,F.source))};return{firstPage:ie,total:Q,pageSize:B.pageSize,getPage:ne}}async queryGallery($,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");$=$.withFlags($.flags,p.ExcludeNonValidated).withFilter(a.ExcludeWithFlags,o(p.Unpublished));const F=await this.commonHeadersPromise,W=JSON.stringify($.raw),N={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)},G=new Date().getTime();let B,J,Q=0;try{if(B=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:N},q),B.res.statusCode&&B.res.statusCode>=400&&B.res.statusCode<500)return{galleryExtensions:[],total:Q};const ie=await(0,D.asJson)(B);if(ie){const ne=ie.results[0],le=ne.extensions,fe=ne.resultMetadata&&ne.resultMetadata.filter(me=>me.metadataType==="ResultCount")[0];return Q=fe&&fe.metadataItems.filter(me=>me.name==="TotalCount")[0].count||0,{galleryExtensions:le,total:Q}}return{galleryExtensions:[],total:Q}}catch(ie){throw J=ie,ie}finally{this.telemetryService.publicLog2("galleryService:query",{...$.telemetryData,requestBodySize:String(W.length),duration:new Date().getTime()-G,success:!!B&&(0,D.isSuccess)(B),responseBodySize:B?.res.headers["Content-Length"],statusCode:B?String(B.res.statusCode):void 0,errorCode:J?(0,w.isPromiseCanceledError)(J)?"canceled":(0,w.getErrorMessage)(J).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Q)})}}async reportStatistic($,q,F,W){if(!this.isEnabled())return;const N=R.isWeb?this.api(`/itemName/${$}.${q}/version/${F}/statType/${W==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${$}/extensions/${q}/${F}/stats?statType=${W}`),G=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",J={...await this.commonHeadersPromise,Accept:G};try{await this.requestService.request({type:"POST",url:N,headers:J},n.CancellationToken.None)}catch(Q){}}async download($,q,F){this.logService.trace("ExtensionGalleryService#download",$.identifier.id);const W=(0,L.getGalleryExtensionTelemetryData)($),N=new Date().getTime(),G=ie=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...W,duration:ie}),B=F===1?"install":F===2?"update":"",J=B?{uri:`${$.assets.download.uri}&${B}=true`,fallbackUri:`${$.assets.download.fallbackUri}?${B}=true`}:$.assets.download,Q=await this.getAsset(J);await this.fileService.writeFile(q,Q.stream),G(new Date().getTime()-N)}async getReadme($,q){if($.assets.readme){const F=await this.getAsset($.assets.readme,{},q);return await(0,D.asText)(F)||""}return""}async getManifest($,q){if($.assets.manifest){const F=await this.getAsset($.assets.manifest,{},q),W=await(0,D.asText)(F);return W?JSON.parse(W):null}return null}async getCoreTranslation($,q){const F=$.assets.coreTranslations.filter(W=>W[0]===q.toUpperCase())[0];if(F){const W=await this.getAsset(F[1]),N=await(0,D.asText)(W);return N?JSON.parse(N):null}return null}async getChangelog($,q){if($.assets.changelog){const F=await this.getAsset($.assets.changelog,{},q);return await(0,D.asText)(F)||""}return""}async getAllVersions($,q){let F=new h().withFlags(p.IncludeVersions,p.IncludeCategoryAndTags,p.IncludeFiles,p.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");$.identifier.uuid?F=F.withFilter(a.ExtensionId,$.identifier.uuid):F=F.withFilter(a.ExtensionName,$.identifier.id);const W=[],{galleryExtensions:N}=await this.queryGallery(F,n.CancellationToken.None);return N.length&&(q?await Promise.all(N[0].versions.map(async G=>{let B;try{B=await this.getEngine(G)}catch(J){}B&&(0,E.isEngineValid)(B,this.productService.version,this.productService.date)&&W.push({version:G.version,date:G.lastUpdated})})):W.push(...N[0].versions.map(G=>({version:G.version,date:G.lastUpdated})))),W}async getAsset($,q={},F=n.CancellationToken.None){const W=await this.commonHeadersPromise,N={type:"GET"},G={...W,...q.headers||{}};q={...q,...N,headers:G};const B=$.uri,J=$.fallbackUri,Q={...q,url:B};try{const ie=await this.requestService.request(Q,F);if(ie.res.statusCode===200)return ie;const ne=await(0,D.asText)(ie);throw new Error(`Expected 200, got back ${ie.res.statusCode} instead.

${ne}`)}catch(ie){if((0,w.isPromiseCanceledError)(ie))throw ie;const ne=(0,w.getErrorMessage)(ie);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:B,message:ne});const le={...q,url:J};return this.requestService.request(le,F)}}async getLastValidExtensionVersion($,q){const F=this.getLastValidExtensionVersionFromProperties($,q);return F||this.getLastValidExtensionVersionRecursively($,q)}getLastValidExtensionVersionFromProperties($,q){for(const F of q){const W=_(F);if(!W)return null;if((0,E.isEngineValid)(W,this.productService.version,this.productService.date))return F}return null}async getEngine($){const q=_($);if(q)return q;const F=T($,t.Manifest);if(!F)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},N=await this.getAsset(F,{headers:W}),G=await(0,D.asJson)(N);if(G)return G.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively($,q){if(!q.length)return null;const F=q[0],W=await this.getEngine(F);return(0,E.isEngineValid)(W,this.productService.version,this.productService.date)?{...F,properties:[...F.properties||[],{key:r.Engine,value:W}]}:this.getLastValidExtensionVersionRecursively($,q.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const $=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if($.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,D.asJson)($),F=new Map;if(q)for(const W of q.malicious){const N=F.get(W)||{id:{id:W},malicious:!0,slow:!1};N.malicious=!0,F.set(W,N)}return[...F.values()]}};U=de([Y(0,D.IRequestService),Y(1,y.ILogService),Y(2,v.IEnvironmentService),Y(3,A.ITelemetryService),Y(4,m.IFileService),Y(5,u.IProductService),Y(6,(0,b.optional)(C.IStorageService))],U),e.ExtensionGalleryService=U;async function x(M,$,q,F){const W={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M}`},N=await(0,P.getServiceMachineId)($,q,F);return W["X-Market-User-Id"]=N,W}e.resolveMarketplaceHeaders=x}),define(Z[185],ee([0,1,5,8,28,12,35,13,4,23,27,63,41,14,177,6,21,75,116,20,3,59]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P,b,R,p,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends u.ExtensionTipsService{constructor(h,c,l,f,S,d,T,O,_,z){super(T,O,_,z);this.environmentService=h,this.telemetryService=c,this.extensionManagementService=l,this.storageService=f,this.nativeHostService=S,this.extensionRecommendationNotificationService=d,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,y.forEach)(O.exeBasedExtensionTips,({key:H,value:V})=>{const U=[],x=[],M=[];(0,y.forEach)(V.recommendations,({key:$,value:q})=>{q.important?V.important?U.push({extensionId:$,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):x.push({extensionId:$,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):M.push({extensionId:$,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:U}),x.length&&this.mediumImportanceExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:x}),M.length&&this.allOtherExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:M})}),(0,C.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const h=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...h,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const h=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(h,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,l)}groupImportantTipsByExe(h,c){const l=new Map;h.forEach(O=>l.set(O.extensionId.toLowerCase(),O));const{installed:f,uninstalled:S}=this.groupByInstalled([...l.keys()],c);for(const O of f){const _=l.get(O);_&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:_.exeName})}for(const O of S){const _=l.get(O);_&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:_.exeName})}const d=this.getPromptedExecutableTips(),T=new Map;for(const O of S){const _=l.get(O);if(_&&(!d[_.exeName]||!d[_.exeName].includes(_.extensionId))){let z=T.get(_.exeName);z||(z=[],T.set(_.exeName,z)),z.push(_)}}return T}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[h,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(h);break;case"incompatibleWindow":const f=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const S=this._register((0,C.disposableTimeout)(()=>{S.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const h=this.getLastPromptedMediumExeTime(),c=Date.now()-h,l=7*24*60*60*1e3;if(c<l){const d=this._register((0,C.disposableTimeout)(()=>{d.dispose(),this.promptMediumImportanceExeBasedTip()},l-c));return}const[f,S]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(S).then(d=>{switch(d){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(S[0].exeName,S);const T=this._register((0,C.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},l));break;case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const _=this._register((0,C.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(h){const c=h.map(({extensionId:f})=>f.toLowerCase()),l=(0,R.localize)(0,null,h[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,l,`@exe:"${h[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let h=this.storageService.getNumber(r,0);return h||(h=Date.now(),this.updateLastPromptedMediumExeTime(h)),h}updateLastPromptedMediumExeTime(h){this.storageService.store(r,h,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(h,c){const l=this.getPromptedExecutableTips();l[h]=c.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(t,JSON.stringify(l),0,0)}groupByInstalled(h,c){const l=[],f=[],S=c.reduce((d,T)=>(d.add(T.identifier.id.toLowerCase()),d),new Set);return h.forEach(d=>{S.has(d.toLowerCase())?l.push(d):f.push(d)}),{installed:l,uninstalled:f}}async getValidExecutableBasedExtensionTips(h){const c=[],l=new Map;for(const f of h.keys()){const S=h.get(f);if(!S||!(0,v.isNonEmptyArray)(S.recommendations))continue;const d=[];E.isWindows?S.windowsPath&&d.push(S.windowsPath.replace("%USERPROFILE%",A.env.USERPROFILE).replace("%ProgramFiles(x86)%",A.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",A.env.ProgramFiles).replace("%APPDATA%",A.env.APPDATA).replace("%WINDIR%",A.env.WINDIR)):(d.push((0,I.join)("/usr/local/bin",f)),d.push((0,I.join)("/usr/bin",f)),d.push((0,I.join)(this.environmentService.userHome.fsPath,f)));for(const T of d){let O=l.get(T);if(O===void 0&&(O=await this.fileService.exists(w.URI.file(T)),l.set(T,O)),O)for(const{extensionId:_,extensionName:z,isExtensionPack:H}of S.recommendations)c.push({extensionId:_,extensionName:z,isExtensionPack:H,exeName:f,exeFriendlyName:S.exeFriendlyName,windowsPath:S.windowsPath})}}return c}};i=de([Y(0,k.INativeEnvironmentService),Y(1,P.ITelemetryService),Y(2,n.IExtensionManagementService),Y(3,p.IStorageService),Y(4,a.INativeHostService),Y(5,b.IExtensionRecommendationNotificationService),Y(6,D.IFileService),Y(7,L.IProductService),Y(8,m.IRequestService),Y(9,g.ILogService)],i),e.ExtensionTipsService=i}),define(Z[82],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(k){this.appender=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,{eventName:D,data:E}){return this.appender.log(D,E),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class I{constructor(k){this.channel=k}log(k,A){return this.channel.call("log",{eventName:k,data:A}).then(void 0,D=>`Failed to log telemetry: ${console.warn(D)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=I}),define(Z[83],ee([0,1,44,126,19,7,24,38,2,26,32]),function(K,e,w,I,L,k,A,D,E,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(u,C){this._configurationService=C,this._experimentProperties={},this._disposables=new E.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const b=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(u,C){this._experimentProperties[u]=C}setEnabled(u){this._enabled=u}_updateUserOptIn(){const u=this._configurationService?.getValue(m);this._userOptIn=u?u.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let C=u.sessionID,P=u["common.instanceId"],b=u["common.machineId"],R=u["common.firstSessionDate"],p=u["common.msftInternal"];return{sessionId:C,instanceId:P,machineId:b,firstSessionDate:R,msftInternal:p}}dispose(){this._disposables.dispose()}publicLog(u,C,P){return this.isOptedIn?this._commonProperties.then(b=>{C=(0,v.mixin)(C,b),C=(0,v.mixin)(C,this._experimentProperties),C=(0,v.cloneAndChange)(C,R=>{if(typeof R=="string")return this._cleanupInfo(R,P)}),this._appender.log(u,C)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(u,C,P){return this.publicLog(u,C,P)}publicLogError(u,C){return this.sendErrorTelemetry?this.publicLog(u,C,!0):Promise.resolve(void 0)}publicLogError2(u,C){return this.publicLogError(u,C)}_cleanupInfo(u,C){let P=u;if(C){const b=[];for(let a of this._cleanupPatterns)for(;;){const t=a.exec(u);if(!t)break;b.push([t.index,a.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(P="";;){const a=p.exec(u);if(!a)break;!R.test(a[0])&&b.every(([t,r])=>a.index<t||a.index>=r)&&(P+=u.substring(o,a.index)+"<REDACTED: user-file-path>",o=p.lastIndex)}o<u.length&&(P+=u.substr(o))}for(let b of this._cleanupPatterns)P=P.replace(b,"");return P}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=de([Y(1,(0,k.optional)(A.IConfigurationService))],y),e.TelemetryService=y;const m="telemetry";n.Registry.as(D.Extensions.Configuration).registerConfiguration({id:m,order:110,type:"object",title:(0,I.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,I.localize)(2,null,w.default.nameLong,w.default.privacyStatementUrl):(0,I.localize)(1,null,w.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[53],ee([0,1,24,26,16,6]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(u,C){return Promise.resolve(void 0)}publicLog2(u,C){return this.publicLog(u,C)}publicLogError(u,C){return Promise.resolve(void 0)}publicLogError2(u,C){return this.publicLogError(u,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class A{async publicLog(C,P,b){}async publicLogError(C,P,b){}}e.NullEndpointTelemetryService=A;function D(...u){return{log:(C,P)=>u.forEach(b=>b.log(C,P)),flush:()=>k.Promises.settled(u.map(C=>C.flush())),productIdentifier:u.find(C=>C.productIdentifier!==void 0)?.productIdentifier}}e.combinedAppender=D,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(u,C){return C.onDidChangeConfiguration(P=>{P.source!==6&&u.publicLog2("updateConfiguration",{configurationSource:(0,w.ConfigurationTargetToString)(P.source),configurationKeys:m(P.sourceConfig)})})}e.configurationTelemetry=E;function v(u){const C=Object.create(null),P=Object.create(null),b=Object.create(null);y(u,b);for(let R in b){R=R.length>150?R.substr(R.length-149):R;const p=b[R];typeof p=="number"?P[R]=p:typeof p=="boolean"?P[R]=p?1:0:typeof p=="string"?C[R]=p.substring(0,1023):typeof p!="undefined"&&p!==null&&(C[R]=p)}return{properties:C,measurements:P}}e.validateTelemetryData=v;function n(u){if(!u)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{u.indexOf(`${b}+`)===0&&(C=b)}),C}e.cleanRemoteAuthority=n;function y(u,C,P=0,b){if(!!u)for(let R of Object.getOwnPropertyNames(u)){const p=u[R],o=b?b+R:R;Array.isArray(p)?C[o]=(0,I.safeStringify)(p):p instanceof Date?C[o]=p.toISOString():(0,L.isObject)(p)?P<2?y(p,C,P+1,o+"."):C[o]=(0,I.safeStringify)(p):C[o]=p}}function m(u){if(!u)return[];const C=[];return g(C,"",u),C}function g(u,C,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(b=>g(u,C?`${C}.${b}`:b,P[b])):u.push(C)}}),define(Z[84],ee([0,1,2,12,14,53]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends w.Disposable{constructor(E,v,n=""){super();this.prefix=n;const y=E.getLogger(v.telemetryLogResource);y?this.logger=this._register(y):(this.logger=this._register(E.createLogger(v.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(E,v){this.logger.trace(`${this.prefix}telemetry/${E}`,(0,k.validateTelemetryData)(v))}};A=de([Y(0,L.ILoggerService),Y(1,I.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(Z[186],ee([0,1,11,26,53]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(D){const E=await new Promise((n,y)=>{K(["applicationinsights"],n,y)});let v;return E.defaultClient?(v=new E.TelemetryClient(D),v.channel.setUseDiskRetryCaching(!0)):(E.setup(D).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),v=E.defaultClient),D.indexOf("AIF-")===0&&(v.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),v}class A{constructor(E,v,n){this._eventPrefix=E,this._defaultData=v,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(E){if(!!this._aiClient){if(typeof this._aiClient!="string"){E(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(v=>{E(v)},v=>{(0,w.onUnexpectedError)(v),console.error(v)})}}log(E,v){!this._aiClient||(v=(0,I.mixin)(v,this._defaultData),v=(0,L.validateTelemetryData)(v),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+E,properties:v.properties,measurements:v.measurements})))}flush(){return this._aiClient?new Promise(E=>{this._withAIClient(v=>{v.flush({callback:()=>{this._aiClient=void 0,E(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(Z[187],ee([0,1,51,82,17,83,24,21,53,12,14,84]),function(K,e,w,I,L,k,A,D,E,v,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(u,C,P,b){this.configurationService=u,this.telemetryService=C,this.loggerService=P,this.environmentService=b,this.customTelemetryServices=new Map}async getCustomTelemetryService(u){if(!this.customTelemetryServices.has(u.id)){const{machineId:C,sessionId:P}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=C,b["common.vscodesessionid"]=P;const R=[u.id,JSON.stringify(b),u.aiKey],o=new w.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:R,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),a=(0,E.combinedAppender)(new I.TelemetryAppenderClient(o),new y.TelemetryLogAppender(this.loggerService,this.environmentService,`[${u.id}] `));this.customTelemetryServices.set(u.id,new k.TelemetryService({appender:a,sendErrorTelemetry:u.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(u.id)}async publicLog(u,C,P){await(await this.getCustomTelemetryService(u)).publicLog(C,P)}async publicLogError(u,C,P){await(await this.getCustomTelemetryService(u)).publicLogError(C,P)}};m=de([Y(0,A.IConfigurationService),Y(1,D.ITelemetryService),Y(2,n.ILoggerService),Y(3,v.IEnvironmentService)],m),e.CustomEndpointTelemetryService=m}),define(Z[188],ee([0,1,6,29,3,2,14]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let D=class extends k.Disposable{constructor(v,n){super();this._logService=n,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=v===void 0?15e3:v}createRequest(v){return new Promise((n,y)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,n),this._onCreateRequest.fire({requestId:m,...v});const g=new I.CancellationTokenSource;(0,w.timeout)(this._timeout,g.token).then(()=>y(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,k.toDisposable)(()=>g.cancel())])})}acceptReply(v,n){const y=this._pendingRequests.get(v);y?(this._pendingRequests.delete(v),(0,k.dispose)(this._pendingRequestDisposables.get(v)||[]),this._pendingRequestDisposables.delete(v),y(n)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${v}`)}};D=de([Y(1,A.ILogService)],D),e.RequestStore=D}),define(Z[85],ee([0,1,7]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var I;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(I=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.TitleMode="terminal.integrated.titleMode",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence"})(A=e.TitleEventSource||(e.TitleEventSource={}));var D;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(D=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,w.createDecorator)("ptyService");var E;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var v;(function(g){g.TerminalView="view",g.Editor="editor"})(v=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var m;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(m=e.ProfileSource||(e.ProfileSource={}))}),define(Z[189],ee([0,1,7]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,w.createDecorator)("localPtyService")}),define(Z[190],ee([0,1,34,8,35,18,16,26,4]),function(K,e,w,I,L,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function v(){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(w.release());let m=0;return y&&y.length===4&&(m=parseInt(y[3])),m}e.getWindowsBuildNumber=v;async function n(y,m,g,u=L.env,C=k.Promises.exists){if(I.isAbsolute(y))return await C(y)?y:void 0;if(m===void 0&&(m=L.cwd()),I.dirname(y)!=="."){const p=I.join(m,y);return await C(p)?p:void 0}const b=(0,D.getCaseInsensitive)(u,"PATH");if(g===void 0&&(0,A.isString)(b)&&(g=b.split(I.delimiter)),g===void 0||g.length===0){const p=I.join(m,y);return await C(p)?p:void 0}for(let p of g){let o;if(I.isAbsolute(p)?o=I.join(p,y):o=I.join(m,p,y),await C(o))return o;if(E.isWindows){let a=o+".com";if(await C(a)||(a=o+".exe",await C(a)))return a}}const R=I.join(m,y);return await C(R)?R:void 0}e.findExecutable=n}),define(Z[191],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(Z[86],ee([0,1,7,2,32,3,191,48]),function(K,e,w,I,L,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,w.createDecorator)("themeService");var E;(function(P){function b(R){return R&&typeof R=="object"&&typeof R.id=="string"}P.isThemeColor=b})(E=e.ThemeColor||(e.ThemeColor={}));function v(P){return{id:P}}e.themeColorFromId=v;var n;(function(P){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||E.isThemeColor(r.color))}P.isThemeIcon=b;const R=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function p(r){const i=R.exec(r);if(!i)return;let[,s]=i;return{id:s}}P.fromString=p;function o(r,i){let s=r.id;const h=s.lastIndexOf("~");return h!==-1&&(s=s.substring(0,h)),i&&(s=`${s}~${i}`),{id:s}}P.modify=o;function a(r,i){return r.id===i.id&&r.color?.id===i.color?.id}P.isEqual=a;function t(r,i){return{id:r.id,color:i?v(i):void 0}}P.asThemeIcon=t,P.asClassNameArray=D.CSSIcon.asClassNameArray,P.asClassName=D.CSSIcon.asClassName,P.asCSSSelector=D.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function y(P){switch(P){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,I.toDisposable)(()=>{const R=this.themingParticipants.indexOf(b);this.themingParticipants.splice(R,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new m;L.Registry.add(e.Extensions.ThemingContribution,g);function u(P){return g.onColorThemeChange(P)}e.registerThemingParticipant=u;class C extends I.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(R=>this.onThemeChange(R)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,R){let p=this.theme.getColor(b);return p&&R&&(p=R(p,this.theme)),p?p.toString():null}}e.Themable=C}),define(Z[192],ee([0,1,48,86]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function L(D,E){const v=D.map(n=>({name:n.profileName,description:k(n)}));return E&&v.push(...E.map(n=>({name:n.title,description:A(n)}))),{values:v.map(n=>n.name),markdownDescriptions:v.map(n=>n.description)}}e.createProfileSchemaEnums=L;function k(D){let E=`$(${I.ThemeIcon.isThemeIcon(D.icon)?D.icon.id:D.icon?D.icon:w.Codicon.terminal.id}) ${D.profileName}
- path: ${D.path}`;return D.args&&(typeof D.args=="string"?E+=`
- args: "${D.args}"`:E+=`
- args: [${D.args.length===0?"":`'${D.args.join("','")}'`}]`),D.overrideName!==void 0&&(E+=`
- overrideName: ${D.overrideName}`),D.color&&(E+=`
- color: ${D.color}`),D.env&&(E+=`
- env: ${JSON.stringify(D.env)}`),E}function A(D){return`$(${I.ThemeIcon.isThemeIcon(D.icon)?D.icon.id:D.icon?D.icon:w.Codicon.terminal.id}) ${D.title}
- extensionIdenfifier: ${D.extensionIdentifier}`}}),define(Z[193],ee([0,1,48,127,38,32,192]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const D={args:{description:(0,I.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,I.localize)(1,null),type:"boolean"},icon:{description:(0,I.localize)(2,null),type:"string",enum:Array.from(w.iconRegistry.all,P=>P.id),markdownEnumDescriptions:Array.from(w.iconRegistry.all,P=>`$(${P.id})`)},color:{description:(0,I.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,I.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,I.localize)(5,null),type:["string","array"],items:{type:"string"}},...D}},v=(0,I.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,I.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),y=(0,I.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m={id:"terminal",order:100,title:(0,I.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,I.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,I.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,I.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,I.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,I.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,I.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,I.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:v},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,I.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,I.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,I.localize)(19,null)}},{type:"string",markdownDescription:(0,I.localize)(20,null)}],default:[],markdownDeprecationMessage:y},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,I.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,I.localize)(22,null),enum:["PowerShell","Git Bash"]},...D}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(23,null),type:"string"},id:{description:(0,I.localize)(24,null),type:"string"},title:{description:(0,I.localize)(25,null),type:"string"},...D}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,I.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(27,null),type:"string"},id:{description:(0,I.localize)(28,null),type:"string"},title:{description:(0,I.localize)(29,null),type:"string"},...D}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,I.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(31,null),type:"string"},id:{description:(0,I.localize)(32,null),type:"string"},title:{description:(0,I.localize)(33,null),type:"string"},...D}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,I.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,I.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,I.localize)(36,null),type:"boolean",default:!0}}};function g(){k.Registry.as(L.Extensions.Configuration).registerConfiguration(m),C()}e.registerTerminalPlatformConfiguration=g;let u;function C(P,b){const R=k.Registry.as(L.Extensions.Configuration);u&&R.deregisterConfigurations([u]);let p;P&&(p=(0,A.createProfileSchemaEnums)(P?.profiles,b)),u={id:"terminal",order:100,title:(0,I.localize)(37,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,I.localize)(38,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:P?.os===3?p?.values:void 0,markdownEnumDescriptions:P?.os===3?p?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,I.localize)(39,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:P?.os===2?p?.values:void 0,markdownEnumDescriptions:P?.os===2?p?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,I.localize)(40,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:P?.os===1?p?.values:void 0,markdownEnumDescriptions:P?.os===1?p?.markdownDescriptions:void 0}}},R.registerConfiguration(u)}e.registerTerminalDefaultProfileConfiguration=C}),define(Z[194],ee([0,1,8,69,190,40,18,48,4,86]),function(K,e,w,I,L,k,A,D,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function y(t,r,i,s,h=process.env,c,l,f,S){return c=c||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},E.isWindows?m(i,c,h,l,s.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:s.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:s.getValue("terminal.integrated.defaultProfile.windows"),S,f):p(c,l,i,t&&typeof t=="object"?{...t}:s.getValue(E.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:s.getValue(E.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),S,f,h)}e.detectAvailableProfiles=y;async function m(t,r,i,s,h,c,l,f,S){const d=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),T=`${process.env.windir}\\${d?"Sysnative":"System32"}`;let O=!1;(0,L.getWindowsBuildNumber)()>=16299&&(O=!0),await C(f);const _=new Map;t&&(_.set("PowerShell",{source:"PowerShell",icon:D.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Windows PowerShell",{path:`${T}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),_.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),_.set("Command Prompt",{path:`${T}\\cmd.exe`,icon:D.Codicon.terminalCmd,isAutoDetected:!0})),o(c,_);const z=await g(_.entries(),l,r,i,s,S);if(t||!t&&h)try{const H=await b(`${T}\\${O?"wsl":"bash"}.exe`,l);for(const V of H)(!c||!(V.profileName in c))&&z.push(V)}catch(H){s?.info("WSL is not installed, so could not detect WSL profiles")}return z}async function g(t,r,i,s=process.env,h,c){const l=[];for(const[f,S]of t){if(S===null)continue;let d,T,O;if("source"in S){const H=n?.get(S.source);if(!H)continue;d=H.paths,T=S.args||H.args,S.icon?O=u(S.icon):H.icon&&(O=H.icon)}else d=Array.isArray(S.path)?S.path:[S.path],T=E.isWindows||Array.isArray(S.args)?S.args:void 0,O=u(S.icon)||void 0;const _=await c?.(d)||d.slice(),z=await a(f,r,_,i,s,T,S.env,S.overrideName,S.isAutoDetected,h);z?(z.isAutoDetected=S.isAutoDetected,z.icon=O,z.color=S.color,l.push(z)):h?.trace("profile not validated",f,d)}return l}function u(t){return typeof t=="string"?{id:t}:t}async function C(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await P(),icon:v.ThemeIcon.asThemeIcon(D.Codicon.terminalPowershell)}))}async function P(){const t=[];for await(const r of(0,I.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function b(t,r){const i=[],s=await new Promise((l,f)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(S,d)=>{if(S)return f("Problem occurred when getting wsl distros");l(d)})});if(!s)return[];const h=new RegExp(/[\r?\n]/),c=s.split(h).filter(l=>l.trim().length>0&&l!=="");for(const l of c){if(l===""||l.startsWith("docker-desktop"))continue;const f=`${l} (WSL)`,S={profileName:f,path:t,args:["-d",`${l}`],isDefault:f===r,icon:R(l)};i.push(S)}return i}function R(t){return t.includes("Ubuntu")?v.ThemeIcon.asThemeIcon(D.Codicon.terminalUbuntu):t.includes("Debian")?v.ThemeIcon.asThemeIcon(D.Codicon.terminalDebian):v.ThemeIcon.asThemeIcon(D.Codicon.terminalLinux)}async function p(t,r,i,s,h,c,l,f){const S=new Map;if(i){const d=(await t.readFile("/etc/shells")).toString(),T=c||d.split(`
`).filter(_=>_.trim().indexOf("#")!==0&&_.trim().length>0),O=new Map;for(const _ of T){let z=(0,w.basename)(_),H=O.get(z)||0;H++,H>1&&(z=`${z} (${H})`),O.set(z,H),S.set(z,{path:_,isAutoDetected:!0})}}return o(s,S),await g(S.entries(),h,t,f,r,l)}function o(t,r){if(!!t)for(const[i,s]of Object.entries(t))s===null||!("path"in s)&&!("source"in s)?r.delete(i):r.set(i,s)}async function a(t,r,i,s,h,c,l,f,S,d){if(i.length===0)return Promise.resolve(void 0);const T=i.shift();if(T==="")return a(t,r,i,s,h,c,l,f,S);const O={profileName:t,path:T,args:c,env:l,overrideName:f,isAutoDetected:S,isDefault:t===r};if((0,w.basename)(T)===T){const z=h.PATH?h.PATH.split(w.delimiter):void 0;return await(0,L.findExecutable)(T,void 0,z,void 0,s.existsFile)?O:a(t,r,i,s,h,c)}return await s.existsFile((0,w.normalize)(T))?O:a(t,r,i,s,h,c,l,f,S)}}),define(Z[195],ee([0,1,2,14,85,51,17,36,4,3,79,21,194,24,193,188,156]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var b;(function(o){o[o.MaxRestarts=5]="MaxRestarts"})(b||(b={}));let R=0,p=class extends w.Disposable{constructor(a,t,r,i){super();this._reconnectConstants=a,this._configurationService=t,this._logService=r,this._telemetryService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new v.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new v.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new v.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new v.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new v.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new v.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new v.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new v.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new v.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new v.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new v.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new v.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new v.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new v.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new v.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new v.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,(0,u.registerTerminalPlatformConfiguration)(),this._shellEnv=E.isWindows?Promise.resolve(process.env):(0,P.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,w.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new C.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new k.Client(A.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:R,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),D.ProxyChannel.toService(a.getChannel(L.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(a.onDidProcessExit(s=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(s.code),this._isDisposed||(this._restartCount<=b.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const r=a.getChannel(L.TerminalIpcChannels.Log);n.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{n.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const i=D.ProxyChannel.toService(a.getChannel(L.TerminalIpcChannels.PtyHost));return this._register(i.onProcessData(s=>this._onProcessData.fire(s))),this._register(i.onProcessExit(s=>this._onProcessExit.fire(s))),this._register(i.onProcessReady(s=>this._onProcessReady.fire(s))),this._register(i.onProcessTitleChanged(s=>this._onProcessTitleChanged.fire(s))),this._register(i.onProcessShellTypeChanged(s=>this._onProcessShellTypeChanged.fire(s))),this._register(i.onProcessOverrideDimensions(s=>this._onProcessOverrideDimensions.fire(s))),this._register(i.onProcessResolvedShellLaunchConfig(s=>this._onProcessResolvedShellLaunchConfig.fire(s))),this._register(i.onProcessDidChangeHasChildProcesses(s=>this._onProcessDidChangeHasChildProcesses.fire(s))),this._register(i.onProcessReplay(s=>this._onProcessReplay.fire(s))),this._register(i.onProcessOrphanQuestion(s=>this._onProcessOrphanQuestion.fire(s))),this._register(i.onDidRequestDetach(s=>this._onDidRequestDetach.fire(s))),[a,i]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,t,r,i,s,h,c,l,f,S){const d=setTimeout(()=>this._handleUnresponsiveCreateProcess(),L.HeartbeatConstants.CreateProcessTimeout),T=await this._proxy.createProcess(a,t,r,i,s,h,c,l,f,S);return clearTimeout(d),R=Math.max(R,T),T}updateTitle(a,t,r){return this._proxy.updateTitle(a,t,r)}updateIcon(a,t,r){return this._proxy.updateIcon(a,t,r)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,t){return this._proxy.shutdown(a,t)}input(a,t){return this._proxy.input(a,t)}processBinary(a,t){return this._proxy.processBinary(a,t)}resize(a,t,r){return this._proxy.resize(a,t,r)}acknowledgeDataEvent(a,t){return this._proxy.acknowledgeDataEvent(a,t)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,t,r,i=!1){const s=await this._shellEnv;return(0,m.detectAvailableProfiles)(t,r,i,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,t){return this._proxy.requestDetachInstance(a,t)}async acceptDetachInstanceReply(a,t){return this._proxy.acceptDetachInstanceReply(a,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier+L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${L.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,t){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:t})}async acceptPtyHostResolvedVariables(a,t){this._resolveVariablesRequestStore.acceptReply(a,t)}};p=de([Y(1,g.IConfigurationService),Y(2,I.ILogService),Y(3,y.ITelemetryService)],p),e.PtyHostService=p}),define(Z[54],ee([0,1,42]),function(K,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function I(A,D,E,v){const n=(0,w.setProperty)(A,D,E,v)[0];return n&&(A=A.substring(0,n.offset)+n.content+A.substring(n.offset+n.length)),A}e.edit=I;function L(A,D,E){let v=E;for(;v>=0;){if(A.charAt(v)===D.charAt(D.length-1)&&D.length===1)return v+1;if(v--,D.length===2&&v>=0&&A.charAt(v)===D.charAt(0))return v+2}return 0}e.getLineStartOffset=L;function k(A,D,E){let v=E;for(;v>=0;)if(A.charAt(v)===D.charAt(D.length-1)&&D.length===1||(v++,D.length===2&&v>=0&&A.charAt(v)===D.charAt(1)))return v;return A.length-1}e.getLineEndOffset=k}),define(Z[196],ee([0,1,26,58]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(y,m,g,u,C){const P=[],b=[],R=[];if(!m){const T=y.filter(({identifier:O})=>C.every(_=>_.toLowerCase()!==O.id.toLowerCase()));return{local:{added:P,removed:b,updated:R},remote:T.length>0?{added:T,updated:[],removed:[],all:T}:null}}y=y.map(v),m=m.map(v),g=g?g.map(v):null;const p=new Map,o=T=>{T.uuid&&p.set(T.id.toLowerCase(),T.uuid)};y.forEach(({identifier:T})=>o(T)),m.forEach(({identifier:T})=>o(T)),g&&g.forEach(({identifier:T})=>o(T));const a=T=>{const O=T.identifier.uuid||p.get(T.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${T.identifier.id.toLowerCase()}`},t=(T,O)=>(T.set(a(O),O),T),r=y.reduce(t,new Map),i=m.reduce(t,new Map),s=m.reduce((T,O)=>{const _=a(O);O=(0,w.deepClone)(O);const z=r.get(_);return z&&(z.installed&&(O.installed=!0),O.version||(O.version=z.version)),t(T,O)},new Map),h=g?g.reduce(t,new Map):null,c=u.reduce(t,new Map),l=C.reduce((T,O)=>{const _=p.get(O.toLowerCase());return T.add(_?`uuid:${_}`:`id:${O.toLowerCase()}`)},new Set),f=k(r,i,l);if(f.added.size>0||f.removed.size>0||f.updated.size>0){const T=k(h,r,l),O=k(h,i,l),_=(z,H)=>{const V=r.get(z);if(V){const U=i.get(z);return{...H?U:V,version:(U.version&&I.gt(U.version,V.version),V.version),state:A(V,U,h?.get(z))}}};for(const z of O.removed.values()){const H=r.get(z);H&&b.push(H.identifier)}for(const z of O.added.values())if(T.added.has(z)){if(f.updated.has(z)){const H=_(z,!0);H&&(R.push(n(H,z)),s.set(z,H))}}else{const H=i.get(z);H.installed&&P.push(n(H,z))}for(const z of O.updated.values()){const H=_(z,!0);H&&(R.push(n(H,z)),s.set(z,H))}for(const z of T.added.values())O.added.has(z)||s.set(z,r.get(z));for(const z of T.updated.values())if(!O.removed.has(z)&&!O.updated.has(z)){const H=_(z,!1);H&&(s.get(z)?.installed&&(H.installed=!0),s.set(z,H))}for(const z of T.removed.values())!c.has(z)&&!O.updated.has(z)&&h?.get(z)?.installed&&s.delete(z)}const S=[],d=k(i,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(d.added.size>0||d.updated.size>0||d.removed.size>0)&&s.forEach((T,O)=>S.push(n(T,O))),{local:{added:P,removed:b,updated:R},remote:S.length?{added:[...d.added].map(T=>s.get(T)),updated:[...d.updated].map(T=>s.get(T)),removed:[...d.removed].map(T=>i.get(T)),all:S}:null}}e.merge=L;function k(y,m,g,{checkInstalledProperty:u,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const P=y?[...y.keys()].filter(a=>!g.has(a)):[],b=[...m.keys()].filter(a=>!g.has(a)),R=b.filter(a=>P.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),p=P.filter(a=>b.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),o=new Set;for(const a of P){if(p.has(a))continue;const t=y.get(a),r=m.get(a);(!r||t.disabled!==r.disabled||!E(t.state,r.state)||C&&t.version!==r.version||u&&t.installed!==r.installed)&&o.add(a)}return{added:R,removed:p,updated:o}}function A(y,m,g){const u=y.state,C=m.state,P=g?.state;if(!m.version||u&&I.gt(y.version,m.version))return u;if(C&&I.gt(m.version,y.version)||!u)return C;if(!C)return u;const b=(0,w.deepClone)(u),R=P?D(P,C):{added:Object.keys(C).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set},p=P?D(P,u):{added:Object.keys(u).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set};for(const o of[...R.added.values(),...R.updated.values()])b[o]=C[o];for(const o of R.removed.values())p.updated.has(o)||delete b[o];return b}function D(y,m){const g=Object.keys(y),u=Object.keys(m),C=u.filter(R=>g.indexOf(R)===-1).reduce((R,p)=>(R.add(p),R),new Set),P=g.filter(R=>u.indexOf(R)===-1).reduce((R,p)=>(R.add(p),R),new Set),b=new Set;for(const R of g){if(P.has(R))continue;const p=y[R],o=m[R];(0,w.equals)(p,o)||b.add(R)}return{added:C,removed:P,updated:b}}function E(y={},m={}){const{added:g,removed:u,updated:C}=D(y,m);return g.size===0&&u.size===0&&C.size===0}function v(y){return{...y,disabled:!!y.disabled,installed:!!y.installed}}function n(y,m){const g={identifier:{id:y.identifier.id,uuid:m.startsWith("uuid:")?m.substring("uuid:".length):void 0}};return y.version&&(g.version=y.version),y.disabled&&(g.disabled=!0),y.installed&&(g.installed=!0),y.state&&(g.state=y.state),g}}),define(Z[87],ee([0,1,23,3,2,31,7,28,20]),function(K,e,w,I,L,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const v=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends L.Disposable{constructor(m,g){super();this.storageService=m,this.productService=g,this._onDidChangeExtensionsStorage=this._register(new I.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}static toKey(m){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static fromKey(m){const g=v.exec(m);if(g&&g[1])return{id:g[1],version:g[2]}}initialize(){const m=this.storageService.keys(0,1);for(const g of m){const u=Ze.fromKey(g);u&&this.extensionsWithKeysForSync.add(u.id.toLowerCase())}}onDidChangeStorageValue(m){if(m.scope!==0)return;if(this.extensionsWithKeysForSync.has(m.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const g=Ze.fromKey(m.key);if(g){this.extensionsWithKeysForSync.add(g.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(m,g){this.storageService.store(Ze.toKey(m),JSON.stringify(g),0,1)}getKeysForSync(m){const g=this.productService.extensionSyncedKeys?.[m.id.toLowerCase()],u=this.storageService.get(Ze.toKey(m),0),C=u?JSON.parse(u):void 0;return C&&g?(0,w.distinct)([...C,...g]):C||g}};n=de([Y(0,E.IStorageService),Y(1,D.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(Z[88],ee([0,1,23,24,7]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(D){this.configurationService=D}hasToNeverSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(D.toLowerCase())}hasToAlwaysSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(`-${D.toLowerCase()}`)}updateIgnoredExtensions(D,E){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return v=v.filter(n=>n!==D&&n!==`-${D}`),E&&v.push(D.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,1)}updateSynchronizedExtensions(D,E){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return v=v.filter(n=>n!==D&&n!==`-${D}`),E&&v.push(`-${D.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,1)}getIgnoredExtensions(D){const E=D.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),v=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),n=[],y=[];if(Array.isArray(v))for(const m of v)m.startsWith("-")?y.push(m.substring(1)):n.push(m);return(0,w.distinct)([...E,...n].filter(m=>y.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let D=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return D!==void 0||(D=this.configurationService.inspect("sync.ignoredExtensions").userValue,D!==void 0)?D:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(E=>E.toLowerCase())}};k=de([Y(0,I.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(Z[197],ee([0,1,26,33,23,150,54]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function D(o){return(0,I.parse)(o)||[]}e.parseKeybindings=D;async function E(o,a,t,r,i){const s=D(o),h=D(a),c=t?D(t):null,l=[...s,...h,...c||[]].map(x=>x.key),f=await i.resolveUserBindings(l);let S=n(s,h,c,f);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const d=m(s),T=m(h),O=c?m(c):null,_=u(d,T,f),z=O?u(O,d,f):{added:[...d.keys()].reduce((x,M)=>(x.add(M),x),new Set),removed:new Set,updated:new Set},H=O?u(O,T,f):{added:[...T.keys()].reduce((x,M)=>(x.add(M),x),new Set),removed:new Set,updated:new Set},V=v(_,z,H);let U=o;for(const x of V.removed.values())V.conflicts.has(x)||(U=R(U,x,r));for(const x of V.added.values()){if(V.conflicts.has(x))continue;const M=T.get(x);if(M.some($=>$.command!==`-${x}`&&S.conflicts.has(f[$.key]))){V.conflicts.add(x);continue}U=b(U,M,r)}for(const x of V.updated.values()){if(V.conflicts.has(x))continue;const M=T.get(x);if(M.some($=>$.command!==`-${x}`&&S.conflicts.has(f[$.key]))){V.conflicts.add(x);continue}U=p(U,x,M,r)}return{mergeContent:U,hasChanges:!0,hasConflicts:V.conflicts.size>0}}e.merge=E;function v(o,a,t){const r=new Set,i=new Set,s=new Set,h=new Set;for(const c of a.removed.values())t.updated.has(c)&&h.add(c);for(const c of t.removed.values())h.has(c)||(a.updated.has(c)?h.add(c):i.add(c));for(const c of a.added.values())h.has(c)||t.added.has(c)&&o.updated.has(c)&&h.add(c);for(const c of t.added.values())h.has(c)||(a.added.has(c)?o.updated.has(c)&&h.add(c):r.add(c));for(const c of a.updated.values())h.has(c)||t.updated.has(c)&&o.updated.has(c)&&h.add(c);for(const c of t.updated.values())h.has(c)||(a.updated.has(c)?o.updated.has(c)&&h.add(c):s.add(c));return{added:r,removed:i,updated:s,conflicts:h}}function n(o,a,t,r){const i=new Set,s=y(o,r),h=y(a,r),c=t?y(t,r):null,l=g(s,h);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const f=c?g(c,s):{added:[...s.keys()].reduce((z,H)=>(z.add(H),z),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const S=c?g(c,h):{added:[...h.keys()].reduce((z,H)=>(z.add(H),z),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:d,removed:T,updated:O,conflicts:_}=v(l,f,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:d,removed:T,updated:O,conflicts:_}}function y(o,a){const t=new Map;for(const r of o){const i=a[r.key];let s=t.get(i);s||(s=[],t.set(i,s)),s.push(r)}return t}function m(o){const a=new Map;for(const t of o){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=a.get(r);i||(i=[],a.set(r,i)),i.push(t)}return a}function g(o,a){const t=[...o.keys()],r=[...a.keys()],i=r.filter(c=>t.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),s=t.filter(c=>r.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),h=new Set;for(const c of t){if(s.has(c))continue;const l=o.get(c).map(S=>({...S,key:c})),f=a.get(c).map(S=>({...S,key:c}));(0,L.equals)(l,f,(S,d)=>P(S,d))||h.add(c)}return{added:i,removed:s,updated:h}}function u(o,a,t){const r=[...o.keys()],i=[...a.keys()],s=i.filter(l=>r.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),h=r.filter(l=>i.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),c=new Set;for(const l of r){if(h.has(l))continue;const f=o.get(l).map(d=>({...d,key:t[d.key]})),S=a.get(l).map(d=>({...d,key:t[d.key]}));C(f,S)||c.add(l)}return{added:s,removed:h,updated:c}}function C(o,a){return!(!(0,L.equals)(o.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,r)=>P(t,r))||!(0,L.equals)(o.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,r)=>P(t,r)))}function P(o,a){if(o.command!==a.command||o.key!==a.key)return!1;const t=k.ContextKeyExpr.deserialize(o.when),r=k.ContextKeyExpr.deserialize(a.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!w.equals(o.args,a.args))}function b(o,a,t){for(const r of a)o=A.edit(o,[-1],r,t);return o}function R(o,a,t){const r=D(o);for(let i=r.length-1;i>=0;i--)(r[i].command===a||r[i].command===`-${a}`)&&(o=A.edit(o,[i],void 0,t));return o}function p(o,a,t,r){const i=D(o),s=i.findIndex(h=>h.command===a||h.command===`-${a}`);for(let h=i.length-1;h>=0;h--)(i[h].command===a||i[h].command===`-${a}`)&&(o=A.edit(o,[h],void 0,r));for(let h=t.length-1;h>=0;h--)o=A.edit(o,[s],t[h],r);return o}}),define(Z[198],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function w(k,A,D){const E={},v={},n=new Set;if(!A)return{local:{added:E,updated:v,removed:[...n.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const y=I(k,A);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:E,updated:v,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=I(D,k),g=I(D,A),u={},C={},P=new Set,b=new Set;for(const R of m.removed.values())g.updated.has(R)?E[R]=A[R]:P.add(R);for(const R of g.removed.values())b.has(R)||(m.updated.has(R)?b.add(R):n.add(R));for(const R of m.updated.values())b.has(R)||(g.updated.has(R)?y.updated.has(R)&&b.add(R):C[R]=k[R]);for(const R of g.updated.values())b.has(R)||(m.updated.has(R)?y.updated.has(R)&&b.add(R):k[R]!==void 0&&(v[R]=A[R]));for(const R of m.added.values())b.has(R)||(g.added.has(R)?y.updated.has(R)&&b.add(R):u[R]=k[R]);for(const R of g.added.values())b.has(R)||(m.added.has(R)?y.updated.has(R)&&b.add(R):E[R]=A[R]);return{local:{added:E,removed:[...n.values()],updated:v},remote:{added:u,removed:[...P.values()],updated:C},conflicts:[...b.values()]}}e.merge=w;function I(k,A){const D=k?Object.keys(k):[],E=A?Object.keys(A):[],v=E.filter(m=>D.indexOf(m)===-1).reduce((m,g)=>(m.add(g),m),new Set),n=D.filter(m=>E.indexOf(m)===-1).reduce((m,g)=>(m.add(g),m),new Set),y=new Set;for(const m of D){if(n.has(m))continue;const g=k[m],u=A[m];g!==u&&y.add(m)}return{added:v,removed:n,updated:y}}function L(k,A){const{added:D,removed:E,updated:v}=I(k,A);return D.size===0&&E.size===0&&v.size===0}e.areSame=L}),define(Z[22],ee([0,1,7,27,32,38,132,81,15,23,16]),function(K,e,w,I,L,k,A,D,E,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function y(){const c=L.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(l=>!!c[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=y;function m(){const c=L.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(c).filter(d=>!!c[d].ignoreSync),f=Object.keys(c).filter(d=>c[d].scope===2||c[d].scope===6),S=y();return(0,v.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...f,...S])}e.getDefaultIgnoredSettings=m;function g(){const c="vscode://schemas/ignoredSettings",l=L.Registry.as(k.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:I.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const f=L.Registry.as(D.Extensions.JSONContribution),S=()=>{const d=y(),T=m().filter(H=>H!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(k.allSettings.properties).filter(H=>T.indexOf(H)===-1),_=T.filter(H=>d.indexOf(H)===-1),z={items:{type:"string",enum:[...O,..._.map(H=>`-${H}`)]}};f.registerSchema(c,z)};return l.onDidUpdateConfiguration(()=>S())}e.registerConfiguration=g;function u(c){return c&&(0,n.isObject)(c)&&(0,n.isString)(c.id)&&(0,n.isArray)(c.scopes)}e.isAuthenticationProvider=u;var C;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(C=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function P(c,l,f){return f.joinPath(l.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=P,e.IUserDataSyncStoreManagementService=(0,w.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,w.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,w.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(c){const l={};return l[e.HEADER_EXECUTION_ID]=c,l}e.createSyncHeaders=b;var R;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(R=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class p extends Error{constructor(l,f,S,d){super(l);this.code=f,this.resource=S,this.operationId=d,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=p;class o extends p{constructor(l,f,S,d,T){super(l,S,void 0,T);this.url=f,this.serverCode=d}}e.UserDataSyncStoreError=o;class a extends p{constructor(l,f){super(l,f)}}e.UserDataAutoSyncError=a,function(c){function l(f){if(f instanceof c)return f;const S=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(f.name);if(S&&S[1]){const d=S[2]==="unknown"?void 0:S[2],T=S[3]==="unknown"?void 0:S[3];return new c(f.message,S[1],d,T)}return new c(f.message,"Unknown")}c.toUserDataSyncError=l}(p=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(c){return`sync.enable.${c}`}e.getEnablementKey=s,e.IUserDataSyncResourceEnablementService=(0,w.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,w.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,w.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,w.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,w.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,w.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function h(c,l){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(f=>(0,E.isEqualOrParent)(c,(0,E.joinPath)(l.userDataSyncHome,f,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=h}),define(Z[46],ee([0,1,2,13,25,5,22,12,15,6,3,21,33,128,24,16,19,23,45,20,29]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P,b,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(h){return!!(h&&h.version!==void 0&&typeof h.version=="number"&&h.content!==void 0&&typeof h.content=="string"&&(Object.keys(h).length===2||Object.keys(h).length===3&&h.machineId!==void 0&&typeof h.machineId=="string"))}e.isSyncData=a;let t=class extends w.Disposable{constructor(c,l,f,S,d,T,O,_,z,H){super();this.resource=c,this.fileService=l,this.environmentService=f,this.userDataSyncStoreService=d,this.userDataSyncBackupStoreService=T,this.userDataSyncResourceEnablementService=O,this.telemetryService=_,this.logService=z,this.configurationService=H,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new v.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,P.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(f.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(f.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,A.PREVIEW_DIR_NAME),this.lastSyncResource=(0,A.getLastSyncResourceUri)(c,f,this.extUri),this.currentMachineIdPromise=(0,R.getServiceMachineId)(f,l,S)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0);this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?(await this.doGenerateSyncResourcePreview(c,c,!0,o.CancellationToken.None)).resourcePreviews.some(({remoteChange:f})=>f!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const l=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),l==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,l={}){await this._sync(c,!0,l)}async preview(c,l={}){return this._sync(c,!1,l)}async apply(c,l={}){try{this.syncHeaders={...l};const f=await this.doApply(c);return this.setStatus(f),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,l,f){try{if(this.syncHeaders={...f},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let S="idle";try{const d=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(c,d);return S=await this.performSync(T,d,l),S==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):S==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(S)}}finally{this.syncHeaders={}}}async replace(c){const l=await this.resolveContent(c);if(!l)return!1;const f=this.parseSyncData(l);if(!f)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const S=await this.getLastSyncUserData(),d=await this.getLatestRemoteUserData(null,S),T=await this.isRemoteDataFromCurrentMachine(d),O=await this.generateSyncPreview({ref:d.ref,syncData:f},S,T,o.CancellationToken.None),_=[];for(const z of O){const H=await this.getAcceptResult(z,z.remoteResource,void 0,o.CancellationToken.None),{remoteChange:V}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,o.CancellationToken.None);_.push([z,{...H,remoteChange:V!==0?V:2}])}await this.applyResult(d,S,_,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const l=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===l}async getLatestRemoteUserData(c,l){if(l){const f=c&&c.latest?c.latest[this.resource]:void 0;if(l.ref===f||f===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(c,l,f){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new A.UserDataSyncError((0,g.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,l,f)}catch(S){if(S instanceof A.UserDataSyncError)switch(S.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,l,f);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(c,l,f)}throw S}}async doSync(c,l,f){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,v.createCancelablePromise)(d=>this.doGenerateSyncResourcePreview(c,l,f,d)));const S=await this.syncPreviewPromise;return this.updateConflicts(S.resourcePreviews),S.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":f?await this.doApply(!1):"syncing"}catch(S){throw this.syncPreviewPromise=null,S}}async merge(c){return await this.updateSyncResourcePreview(c,async l=>{const f=await this.getMergeResult(l,o.CancellationToken.None);await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString(f?.content||""));const S=f&&!f.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,o.CancellationToken.None):void 0;return l.acceptResult=S,l.mergeState=f.hasConflicts?"conflict":S?"accepted":"preview",l.localChange=S?S.localChange:f.localChange,l.remoteChange=S?S.remoteChange:f.remoteChange,l}),this.syncPreviewPromise}async accept(c,l){return await this.updateSyncResourcePreview(c,async f=>{const S=await this.getAcceptResult(f,c,l,o.CancellationToken.None);return f.acceptResult=S,f.mergeState="accepted",f.localChange=S.localChange,f.remoteChange=S.remoteChange,f}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async l=>{const f=await this.getMergeResult(l,o.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString(f.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=f.localChange,l.remoteChange=f.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(c,l){if(!this.syncPreviewPromise)return;let f=await this.syncPreviewPromise;const S=f.resourcePreviews.findIndex(({localResource:d,remoteResource:T,previewResource:O})=>this.extUri.isEqual(d,c)||this.extUri.isEqual(T,c)||this.extUri.isEqual(O,c));S!==-1&&(this.syncPreviewPromise=(0,v.createCancelablePromise)(async d=>{const T=[...f.resourcePreviews];return T[S]=await l(T[S]),{...f,resourcePreviews:T}}),f=await this.syncPreviewPromise,this.updateConflicts(f.resourcePreviews),f.resourcePreviews.some(({mergeState:d})=>d==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:f})=>f==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:f})=>f!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(f=>[f,f.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(c){}}updateConflicts(c){const l=c.filter(({mergeState:f})=>f==="conflict");(0,b.equals)(this._conflicts,l,(f,S)=>this.extUri.isEqual(f.previewResource,S.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:l,ref:f})=>({created:l,uri:this.toRemoteBackupResource(f)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:l,ref:f})=>({created:l,uri:this.toLocalBackupResource(f)}))}toRemoteBackupResource(c){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const l=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(l))){const{content:f}=await this.getUserData(l);if(f)return this.parseSyncData(f)?.machineId}}async resolveContent(c){const l=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(l))){const{content:f}=await this.getUserData(l);return f}return this.extUri.isEqual(c,this.toLocalBackupResource(l))?this.userDataSyncBackupStoreService.resolveContent(this.resource,l):null}async resolvePreviewContent(c){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const f of l.resourcePreviews){if(this.extUri.isEqual(f.acceptedResource,c))return f.acceptResult?f.acceptResult.content:null;if(this.extUri.isEqual(f.remoteResource,c))return f.remoteContent;if(this.extUri.isEqual(f.localResource,c))return f.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(c){}}async doGenerateSyncResourcePreview(c,l,f,S){const d=await this.isRemoteDataFromCurrentMachine(c),T=await this.generateSyncPreview(c,l,d,S),O=[];for(const _ of T){const z=_.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(_.localChange===0&&_.remoteChange===0)O.push({..._,acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const H=f?await this.getMergeResult(_,S):void 0;if(S.isCancellationRequested)break;await this.fileService.writeFile(_.previewResource,L.VSBuffer.fromString(H?.content||""));const V=H&&!H.hasConflicts?await this.getAcceptResult(_,_.previewResource,void 0,S):void 0;O.push({..._,acceptResult:V,mergeState:H?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:H?H.localChange:_.localChange,remoteChange:V?V.remoteChange:H?H.remoteChange:_.remoteChange})}}return{remoteUserData:c,lastSyncUserData:l,resourcePreviews:O,isLastSyncFromCurrentMachine:d}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(c.value.toString()),f=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=l.version&&f&&l.version!==f,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${f}.`),await this.resetLocal(),null;const S=l;if(S.content===null)return{ref:l.ref,syncData:null};const d=JSON.parse(S.content);if(a(d))return{...l,syncData:d,content:void 0}}catch(c){c instanceof I.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,l={}){if(l.ref||l.content||l.version)throw new Error("Cannot have core properties as additional");const f=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),S={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:f,...l};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(S)))}async getRemoteUserData(c){const{ref:l,content:f}=await this.getUserData(c);let S=null;return f!==null&&(S=this.parseSyncData(f)),{ref:l,syncData:S}}parseSyncData(c){try{const l=JSON.parse(c);if(a(l))return l}catch(l){this.logService.error(l)}throw new A.UserDataSyncError((0,g.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,C.isString)(c)){const l=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:l}}else{const l=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,l,this.syncHeaders)}}async updateRemoteUserData(c,l){const f=await this.currentMachineIdPromise,S={version:this.version,machineId:f,content:c};return l=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(S),l,this.syncHeaders),{ref:l,syncData:S}}async backupLocal(c){const l={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=de([Y(1,I.IFileService),Y(2,D.IEnvironmentService),Y(3,p.IStorageService),Y(4,A.IUserDataSyncStoreService),Y(5,A.IUserDataSyncBackupStoreService),Y(6,A.IUserDataSyncResourceEnablementService),Y(7,y.ITelemetryService),Y(8,A.IUserDataSyncLogService),Y(9,u.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(c,l,f,S,d,T,O,_,z,H,V){super(l,f,S,d,T,O,_,z,H,V);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(c){return null}}async updateLocalFileContent(c,l,f){try{l?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(c),f?void 0:l):await this.fileService.createFile(this.file,L.VSBuffer.fromString(c),{overwrite:f})}catch(S){throw S instanceof I.FileOperationError&&S.fileOperationResult===1||S instanceof I.FileOperationError&&S.fileOperationResult===3?new A.UserDataSyncError(S.message,"LocalPreconditionFailed"):S}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};r=de([Y(2,I.IFileService),Y(3,D.IEnvironmentService),Y(4,p.IStorageService),Y(5,A.IUserDataSyncStoreService),Y(6,A.IUserDataSyncBackupStoreService),Y(7,A.IUserDataSyncResourceEnablementService),Y(8,y.ITelemetryService),Y(9,A.IUserDataSyncLogService),Y(10,u.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let i=class extends r{constructor(c,l,f,S,d,T,O,_,z,H,V,U){super(c,l,f,S,d,T,O,_,z,H,U);this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(c){const l=[];return(0,m.parse)(c,l,{allowEmptyContent:!0,allowTrailingComma:!0}),l.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=de([Y(2,I.IFileService),Y(3,D.IEnvironmentService),Y(4,p.IStorageService),Y(5,A.IUserDataSyncStoreService),Y(6,A.IUserDataSyncBackupStoreService),Y(7,A.IUserDataSyncResourceEnablementService),Y(8,y.ITelemetryService),Y(9,A.IUserDataSyncLogService),Y(10,A.IUserDataSyncUtilService),Y(11,u.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let s=class{constructor(c,l,f,S){this.resource=c,this.environmentService=l,this.logService=f,this.fileService=S,this.extUri=this.fileService.hasCapability(l.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.lastSyncResource=(0,A.getLastSyncResourceUri)(this.resource,l,E.extUri)}async initialize({ref:c,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const f=this.parseSyncData(l);if(!f)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:c,syncData:f})}catch(d){this.logService.error(d)}}parseSyncData(c){try{const l=JSON.parse(c);if(a(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,l={}){const f={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...l};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(f)))}};s=de([Y(1,D.IEnvironmentService),Y(2,A.IUserDataSyncLogService),Y(3,I.IFileService)],s),e.AbstractInitializer=s}),define(Z[199],ee([0,1,22,3,12,27,31,13,24,196,46,21,5,47,42,19,20,88,11,87,6]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P,b,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function a(h,c){const l=JSON.parse(h.content);if(h.version===1||h.version===2){const f=(await c.getInstalled(0)).filter(S=>S.isBuiltin);for(const S of l)h.version===1&&(S.enabled===!1&&(S.disabled=!0),delete S.enabled),h.version===2&&f.every(d=>!(0,A.areSameExtensions)(d.identifier,S.identifier))&&(S.installed=!0)}return l}function t(h,c,l){const f=l.get((0,A.getExtensionId)(h,c),0)||"{}";return JSON.parse(f)}e.getExtensionStorageState=t;function r(h,c,l,f){f.store((0,A.getExtensionId)(h,c),JSON.stringify(l),0,1)}e.storeExtensionStorageState=r;let i=class at extends n.AbstractSynchroniser{constructor(c,l,f,S,d,T,O,_,z,H,V,U,x,M){super("extensions",l,c,f,S,d,U,x,z,V);this.storageService=f,this.extensionManagementService=T,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=_,this.extensionGalleryService=H,this.extensionsStorageSyncService=M,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(I.Event.debounce(I.Event.any(I.Event.filter(this.extensionManagementService.onDidInstallExtensions,$=>$.some(({local:q})=>!!q)),I.Event.filter(this.extensionManagementService.onDidUninstallExtension,$=>!$.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(c,l){const f=c.syncData?await a(c.syncData,this.extensionManagementService):null,S=l?.skippedExtensions||[],d=l?.syncData?await a(l.syncData,this.extensionManagementService):null,T=await this.extensionManagementService.getInstalled(),O=this.getLocalExtensions(T),_=this.ignoredExtensionsManagementService.getIgnoredExtensions(T);f?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:H}=(0,v.merge)(O,f,d,S,_),V={local:z,remote:H,content:this.getPreviewContent(O,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:H!==null?2:0};return[{skippedExtensions:S,localResource:this.localResource,localContent:this.format(O),localExtensions:O,remoteResource:this.remoteResource,remoteContent:f?this.format(f):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(c,l,f,S){const d=[...l,...f],T=new Set,O=_=>{T.add(_.id.toLowerCase()),_.uuid&&T.add(_.uuid)};d.forEach(({identifier:_})=>O(_)),S.forEach(O);for(const _ of c)T.has(_.identifier.id.toLowerCase())||_.identifier.uuid&&T.has(_.identifier.uuid)||d.push(_);return this.format(d)}async getMergeResult(c,l){return{...c.previewResult,hasConflicts:!1}}async getAcceptResult(c,l,f,S){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(l,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(c){const l=await this.extensionManagementService.getInstalled(),f=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),S=(0,v.merge)(c.localExtensions,null,null,c.skippedExtensions,f),{local:d,remote:T}=S;return{content:c.localContent,local:d,remote:T,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:T!==null?2:0}}async acceptRemote(c){const l=await this.extensionManagementService.getInstalled(),f=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),S=c.remoteContent?JSON.parse(c.remoteContent):null;if(S!==null){const d=(0,v.merge)(c.localExtensions,S,c.localExtensions,[],f),{local:T,remote:O}=d;return{content:c.remoteContent,local:T,remote:O,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(c,l,f,S){let{skippedExtensions:d,localExtensions:T}=f[0][0],{local:O,remote:_,localChange:z,remoteChange:H}=f[0][1];if(z===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(T)),d=await this.updateLocalExtensions(O.added,O.removed,O.updated,d)),_){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const V=JSON.stringify(_.all);c=await this.updateRemoteUserData(V,S?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${_.added.length?` Added: ${JSON.stringify(_.added.map(U=>U.identifier.id))}.`:""}${_.updated.length?` Updated: ${JSON.stringify(_.updated.map(U=>U.identifier.id))}.`:""}${_.removed.length?` Removed: ${JSON.stringify(_.removed.map(U=>U.identifier.id))}.`:""}`)}l?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:d}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${d.length?` Skipped: ${JSON.stringify(d.map(V=>V.identifier.id))}.`:""}`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,at.EXTENSIONS_DATA_URI)){const f=await this.extensionManagementService.getInstalled(),S=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),d=this.getLocalExtensions(f).filter(T=>!S.some(O=>(0,A.areSameExtensions)({id:O},T.identifier)));return this.format(d)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let l=await super.resolveContent(c);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(c)),l){const f=this.parseSyncData(l);if(f)switch(this.extUri.basename(c)){case"extensions.json":return this.format(this.parseExtensions(f))}}return null}format(c){c.sort((S,d)=>!S.identifier.uuid&&d.identifier.uuid?-1:S.identifier.uuid&&!d.identifier.uuid?1:(0,C.compare)(S.identifier.id,d.identifier.id));const l=JSON.stringify(c),f=(0,g.format)(l,void 0,{});return(0,u.applyEdits)(l,f)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(c).some(f=>f.installed||f.disabled))return!0}catch(c){}return!1}async updateLocalExtensions(c,l,f,S){const d=[],T=[],O=await this.extensionManagementService.getInstalled();if(l.length){const z=O.filter(({identifier:H,isBuiltin:V})=>!V&&l.some(U=>(0,A.areSameExtensions)(H,U)));await o.Promises.settled(z.map(async H=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,H.identifier.id),await this.extensionManagementService.uninstall(H,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,H.identifier.id),d.push(H.identifier)}))}(c.length||f.length)&&await o.Promises.settled([...c,...f].map(async z=>{const H=O.find(U=>(0,A.areSameExtensions)(U.identifier,z.identifier));if(H&&H.isBuiltin){z.state&&H.manifest.version===z.version&&this.updateExtensionState(z.state,H.manifest.publisher,H.manifest.name,H.manifest.version),z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id)),d.push(z.identifier);return}const V=await this.extensionGalleryService.getCompatibleExtension(z.identifier);if(z.state&&(H?H.manifest.version===z.version:!!V)){const U=H?H.manifest.publisher:V.publisher,x=H?H.manifest.name:V.name;this.updateExtensionState(z.state,U,x,H?.manifest.version)}if(V)try{z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,V.version),await this.extensionEnablementService.disableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,V.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,V.version),await this.extensionEnablementService.enableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,V.version)),H||(await this.extensionManagementService.canInstall(V)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,V.version),await this.extensionManagementService.installFromGallery(V,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,V.version),d.push(V.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,V.displayName||V.identifier.id),T.push(z)))}catch(U){T.push(z),this.logService.error(U),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,V.displayName||V.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,z.identifier.id),T.push(z)}));const _=[];for(const z of S)d.some(H=>(0,A.areSameExtensions)(H,z.identifier))||_.push(z);for(const z of T)_.some(H=>(0,A.areSameExtensions)(H.identifier,z.identifier))||_.push(z);return _}updateExtensionState(c,l,f,S){const d=t(l,f,this.storageService),T=S?this.extensionsStorageSyncService.getKeysForSync({id:(0,A.getGalleryExtensionId)(l,f),version:S}):void 0;T?T.forEach(O=>{d[O]=c[O]}):Object.keys(c).forEach(O=>d[O]=c[O]),r(l,f,d,this.storageService)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const l=this.extensionEnablementService.getDisabledExtensions();return c.map(({identifier:f,isBuiltin:S,manifest:d})=>{const T={identifier:f,version:d.version};l.some(O=>(0,A.areSameExtensions)(O,f))&&(T.disabled=!0),S||(T.installed=!0);try{const O=this.extensionsStorageSyncService.getKeysForSync({id:f.id,version:d.version});if(O){const _=t(d.publisher,d.name,this.storageService);T.state=Object.keys(_).reduce((z,H)=>(O.includes(H)&&(z[H]=_[H]),z),{})}}catch(O){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,R.getErrorMessage)(O))}return T})}};i.EXTENSIONS_DATA_URI=m.URI.from({scheme:w.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([Y(0,L.IEnvironmentService),Y(1,D.IFileService),Y(2,P.IStorageService),Y(3,w.IUserDataSyncStoreService),Y(4,w.IUserDataSyncBackupStoreService),Y(5,k.IExtensionManagementService),Y(6,k.IGlobalExtensionEnablementService),Y(7,b.IIgnoredExtensionsManagementService),Y(8,w.IUserDataSyncLogService),Y(9,k.IExtensionGalleryService),Y(10,E.IConfigurationService),Y(11,w.IUserDataSyncResourceEnablementService),Y(12,y.ITelemetryService),Y(13,p.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let s=class extends n.AbstractInitializer{constructor(c,l,f,S,d){super("extensions",S,d,f);this.extensionManagementService=c,this.ignoredExtensionsManagementService=l}async parseExtensions(c){return c.syncData?await a(c.syncData,this.extensionManagementService):null}generatePreview(c,l){const f=[],S=[],d=[];for(const T of c){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(T.identifier.id))continue;const O=l.find(_=>(0,A.areSameExtensions)(_.identifier,T.identifier));O?(f.push(O),T.disabled&&d.push(T.identifier)):T.installed&&(S.push(T.identifier),T.disabled&&d.push(T.identifier))}return{installedExtensions:f,newExtensions:S,disabledExtensions:d,remoteExtensions:c}}};s=de([Y(0,k.IExtensionManagementService),Y(1,b.IIgnoredExtensionsManagementService),Y(2,D.IFileService),Y(3,L.IEnvironmentService),Y(4,w.IUserDataSyncLogService)],s),e.AbstractExtensionsInitializer=s}),define(Z[200],ee([0,1,26,22]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(D,E,v,n,y){if(!E)return{remote:Object.keys(D).length>0?D:null,local:{added:{},removed:[],updated:{}}};const m=k(D,E);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const g=v?k(v,E):{added:Object.keys(E).reduce((R,p)=>(R.add(p),R),new Set),removed:new Set,updated:new Set},u=v?k(v,D):{added:Object.keys(D).reduce((R,p)=>(R.add(p),R),new Set),removed:new Set,updated:new Set},C={added:{},removed:[],updated:{}},P=w.deepClone(E),b=!v;for(const R of u.added.values())R!==I.SYNC_SERVICE_URL_TYPE&&b&&g.added.has(R)||(P[R]=D[R]);for(const R of u.updated.values())P[R]=D[R];for(const R of u.removed.values())n.unregistered.includes(R)||delete P[R];for(const R of g.added.values()){const p=E[R];if(n.machine.includes(R)){y.info(`GlobalState: Skipped adding ${R} in local storage because it is declared as machine scoped.`);continue}if(v&&u.added.has(R))continue;const o=D[R];o&&o.value===p.value||R===I.SYNC_SERVICE_URL_TYPE&&b&&u.added.has(R)||(o?C.updated[R]=p:C.added[R]=p)}for(const R of g.updated.values()){const p=E[R];if(n.machine.includes(R)){y.info(`GlobalState: Skipped updating ${R} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(R)||u.removed.has(R))continue;const o=D[R];o&&o.value===p.value||(C.updated[R]=p)}for(const R of g.removed.values()){if(n.machine.includes(R)){y.trace(`GlobalState: Skipped removing ${R} in local storage because it is declared as machine scoped.`);continue}u.updated.has(R)||u.removed.has(R)||C.removed.push(R)}return{local:C,remote:A(P,E)?null:P}}e.merge=L;function k(D,E){const v=Object.keys(D),n=Object.keys(E),y=n.filter(u=>v.indexOf(u)===-1).reduce((u,C)=>(u.add(C),u),new Set),m=v.filter(u=>n.indexOf(u)===-1).reduce((u,C)=>(u.add(C),u),new Set),g=new Set;for(const u of v){if(m.has(u))continue;const C=D[u],P=E[u];w.equals(C,P)||g.add(u)}return{added:y,removed:m,updated:g}}function A(D,E){const{added:v,removed:n,updated:y}=k(D,E);return v.size===0&&n.size===0&&y.size===0}}),define(Z[201],ee([0,1,22,25,3,12,13,54,200,33,46,21,24,5,47,42,20,4,45,30,14]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P,b,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",t=["locale"];function r(l){const f=l.storage?Object.keys(l.storage).sort():[],S={};f.forEach(O=>S[O]=l.storage[O]),l.storage=S;const d=JSON.stringify(l),T=(0,u.format)(d,void 0,{});return(0,C.applyEdits)(d,T)}const i=1;let s=class ot extends n.AbstractSynchroniser{constructor(f,S,d,T,O,_,z,H,V){super("globalState",f,O,V,S,d,_,z,T,H);this.storageService=V,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(f.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(f.onDidFilesChange,U=>U.contains(this.environmentService.argvResource)),L.Event.filter(V.onDidChangeValue,U=>U.scope===0&&U.target!==void 0?U.target===0:V.keys(0,0).includes(U.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(f,S,d,T){const O=f.syncData?JSON.parse(f.syncData.content):null;S=S===null&&d?f:S;const _=S&&S.syncData?JSON.parse(S.syncData.content):null,z=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=this.getStorageKeys(_),{local:V,remote:U}=(0,E.merge)(z.storage,O?O.storage:null,_?_.storage:null,H,this.logService),x={content:null,local:V,remote:U,localChange:Object.keys(V.added).length>0||Object.keys(V.updated).length>0||V.removed.length>0?2:0,remoteChange:U!==null?2:0};return[{localResource:this.localResource,localContent:r(z),localUserData:z,remoteResource:this.remoteResource,remoteContent:O?r(O):null,previewResource:this.previewResource,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.acceptedResource,storageKeys:H}]}async getMergeResult(f,S){return{...f.previewResult,hasConflicts:!1}}async getAcceptResult(f,S,d,T){if(this.extUri.isEqual(S,this.localResource))return this.acceptLocal(f);if(this.extUri.isEqual(S,this.remoteResource))return this.acceptRemote(f);if(this.extUri.isEqual(S,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${S.toString()}`)}async acceptLocal(f){return{content:f.localContent,local:{added:{},removed:[],updated:{}},remote:f.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(f){if(f.remoteContent!==null){const S=JSON.parse(f.remoteContent),{local:d,remote:T}=(0,E.merge)(f.localUserData.storage,S.storage,null,f.storageKeys,this.logService);return{content:f.remoteContent,local:d,remote:T,localChange:Object.keys(d.added).length>0||Object.keys(d.updated).length>0||d.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:f.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(f,S,d,T){let{localUserData:O}=d[0][0],{local:_,remote:z,localChange:H,remoteChange:V}=d[0][1];if(H===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),H!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(O)),await this.writeLocalGlobalState(_),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),V!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:z});f=await this.updateRemoteUserData(U,T?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}S?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:f}){return[{resource:this.extUri.joinPath(f,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(f){if(this.extUri.isEqual(f,ot.GLOBAL_STATE_DATA_URI)){const d=await this.getLocalGlobalState();return r(d)}if(this.extUri.isEqual(this.remoteResource,f)||this.extUri.isEqual(this.localResource,f)||this.extUri.isEqual(this.acceptedResource,f))return this.resolvePreviewContent(f);let S=await super.resolveContent(f);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(f)),S){const d=this.parseSyncData(S);if(d)switch(this.extUri.basename(f)){case"globalState.json":return r(JSON.parse(d.content))}}return null}async hasLocalData(){try{const{storage:f}=await this.getLocalGlobalState();if(Object.keys(f).length>1||f[`${a}.locale`]?.value!=="en")return!0}catch(f){}return!1}async getLocalGlobalState(){const f={},S=await this.getLocalArgvContent(),d=(0,v.parse)(S);for(const T of t)d[T]!==void 0&&(f[`${a}${T}`]={version:1,value:d[T]});for(const T of this.storageService.keys(0,0)){const O=this.storageService.get(T,0);O&&(f[T]={version:1,value:O})}return{storage:f}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(f){}return"{}"}async writeLocalGlobalState({added:f,removed:S,updated:d}){const T={},O={},_=(H,V)=>{for(const U of H){if(U.startsWith(a)){T[U.substring(a.length)]=V?V[U].value:void 0;continue}if(V){const x=V[U];x.value!==String(this.storageService.get(U,0))&&(O[U]=x.value)}else this.storageService.get(U,0)!==void 0&&(O[U]=void 0)}};if(_(Object.keys(f),f),_(Object.keys(d),d),_(S),Object.keys(T).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(T),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(O).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const H of Object.keys(O))this.storageService.store(H,O[H],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(O))}}async updateArgv(f){const S=await this.getLocalArgvContent();let d=S;for(const T of Object.keys(f))d=(0,D.edit)(d,[T],f[T],{});S!==d&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,I.VSBuffer.fromString(d)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(f){const S=this.storageService.keys(0,0),d=this.storageService.keys(0,1),T=[...S,...d],O=f?.storage?Object.keys(f.storage).filter(_=>!_.startsWith(a)&&!T.includes(_)&&this.storageService.get(_,0)!==void 0):[];if(!b.isWeb){const _=[...w.ALL_SYNC_RESOURCES.map(z=>(0,w.getEnablementKey)(z)),w.SYNC_SERVICE_URL_TYPE];O.push(..._),d.push(..._)}return{user:S,machine:d,unregistered:O}}};s.GLOBAL_STATE_DATA_URI=g.URI.from({scheme:w.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=de([Y(0,A.IFileService),Y(1,w.IUserDataSyncStoreService),Y(2,w.IUserDataSyncBackupStoreService),Y(3,w.IUserDataSyncLogService),Y(4,k.IEnvironmentService),Y(5,w.IUserDataSyncResourceEnablementService),Y(6,y.ITelemetryService),Y(7,m.IConfigurationService),Y(8,P.IStorageService)],s),e.GlobalStateSynchroniser=s;let h=class extends n.AbstractInitializer{constructor(f,S,d,T){super("globalState",d,T,S);this.storageService=f}async doInitialize(f){const S=f.syncData?JSON.parse(f.syncData.content):null;if(!S){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const d={},T={};for(const O of Object.keys(S.storage))O.startsWith(a)?d[O.substring(a.length)]=S.storage[O].value:this.storageService.get(O,0)===void 0&&(T[O]=S.storage[O].value);if(Object.keys(d).length){let O="{}";try{O=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(_){}for(const _ of Object.keys(d))O=(0,D.edit)(O,[_],d[_],{});await this.fileService.writeFile(this.environmentService.argvResource,I.VSBuffer.fromString(O))}if(Object.keys(T).length)for(const O of Object.keys(T))this.storageService.store(O,T[O],0,0)}};h=de([Y(0,P.IStorageService),Y(1,A.IFileService),Y(2,k.IEnvironmentService),Y(3,w.IUserDataSyncLogService)],h),e.GlobalStateInitializer=h;let c=class{constructor(f,S,d,T,O){this.userDataSyncStoreClient=f,this.storageService=S,this.environmentService=d,this.fileService=T,this.logService=O}getSyncStoreType(f){return this.parseGlobalState(f)?.storage[w.SYNC_SERVICE_URL_TYPE]?.value}async sync(f){const S=(0,w.createSyncHeaders)((0,p.generateUuid)());try{return await this.doSync(f,S)}catch(d){if(d instanceof w.UserDataSyncError)switch(d.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(f,S)}throw d}}async doSync(f,S){const d=await this.userDataSyncStoreClient.read("globalState",null,S),T=this.parseGlobalState(d)||{storage:{}};T.storage[w.SYNC_SERVICE_URL_TYPE]={value:f,version:i};const O=await(0,R.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),_={version:i,machineId:O,content:r(T)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(_),d.ref,S)}parseGlobalState({content:f}){if(!f)return null;const S=JSON.parse(f);if((0,n.isSyncData)(S))return S?JSON.parse(S.content):null;throw new Error("Invalid remote data")}};c=de([Y(1,P.IStorageService),Y(2,k.IEnvironmentService),Y(3,A.IFileService),Y(4,o.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(Z[202],ee([0,1,13,22,197,33,129,12,24,4,16,23,46,21,20,25,3]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(o,a){const t=JSON.parse(o);if(!a)return(0,n.isUndefined)(t.all)?null:t.all;switch(v.OS){case 2:return(0,n.isUndefined)(t.mac)?null:t.mac;case 3:return(0,n.isUndefined)(t.linux)?null:t.linux;case 1:return(0,n.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=b;let R=class extends m.AbstractJsonFileSynchroniser{constructor(a,t,r,i,s,h,c,l,f,S){super(c.keybindingsResource,"keybindings",h,c,l,a,t,s,S,r,f,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(P.Event.filter(i.onDidChangeConfiguration,d=>d.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,r,i){const s=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;t=t===null&&r?a:t;const h=t?this.getKeybindingsContentFromLastSyncUserData(t):null,c=await this.getLocalFileContent(),l=await this.getFormattingOptions();let f=null,S=!1,d=!1,T=!1;if(s){let _=c?c.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new I.UserDataSyncError((0,A.localize)(0,null),"LocalInvalidContent",this.resource);if(!h||h!==_||h!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,L.merge)(_,s,h,l,this.userDataSyncUtilService);z.hasChanges&&(f=z.mergeContent,T=z.hasConflicts,S=T||z.mergeContent!==_,d=T||z.mergeContent!==s)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=c.value.toString(),d=!0);const O={content:f,localChange:S?c?2:1:0,remoteChange:d?2:0,hasConflicts:T};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,r,i){const{fileContent:s}=r[0][0];let{content:h,localChange:c,remoteChange:l}=r[0][1];if(c===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),h!==null&&(h=h.trim(),h=h||"[]",this.hasErrors(h)))throw new I.UserDataSyncError((0,A.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(h||"[]",s,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),l!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const f=this.toSyncContent(h||"[]",a.syncData?.content);a=await this.updateRemoteUserData(f,i?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(f){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=(0,k.parse)(a.value.toString());if((0,y.isNonEmptyArray)(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(a)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(a.syncData.content)}getKeybindingsContentFromSyncContent(a){try{return b(a,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(a,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=a,v.OS){case 2:r.mac=a;break;case 3:r.linux=a;break;case 1:r.windows=a;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let a=!!this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return a!==void 0||(a=!!this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,a!==void 0)?a:!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};R=de([Y(0,I.IUserDataSyncStoreService),Y(1,I.IUserDataSyncBackupStoreService),Y(2,I.IUserDataSyncLogService),Y(3,E.IConfigurationService),Y(4,I.IUserDataSyncResourceEnablementService),Y(5,w.IFileService),Y(6,D.IEnvironmentService),Y(7,u.IStorageService),Y(8,I.IUserDataSyncUtilService),Y(9,g.ITelemetryService)],R),e.KeybindingsSynchroniser=R;let p=class extends m.AbstractInitializer{constructor(a,t,r){super("keybindings",t,r,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,C.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,k.parse)(a.value.toString());return!(0,y.isNonEmptyArray)(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return b(a,!0)}catch(t){return this.logService.error(t),null}}};p=de([Y(0,w.IFileService),Y(1,D.IEnvironmentService),Y(2,I.IUserDataSyncLogService)],p),e.KeybindingsInitializer=p}),define(Z[203],ee([0,1,26,33,42,47,54,22,23]),function(K,e,w,I,L,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function v(c,l,f){let S=[];f?S=y(f):S=n(l);const d=[],T=[...(0,D.getDisallowedIgnoredSettings)()];if(Array.isArray(S))for(const O of S)O.startsWith("-")?T.push(O.substring(1)):d.push(O);return(0,E.distinct)([...c,...d].filter(O=>T.indexOf(O)===-1))}e.getIgnoredSettings=v;function n(c){let l=c.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=c.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:c.getValue("settingsSync.ignoredSettings")||[]}function y(c){const l=(0,I.parse)(c);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function m(c,l,f,S){if(f.length){const d=h(l),T=(0,I.parse)(l),O=(0,I.parse)(c),_=[];for(const z of f){const H=T[z],V=O[z];H===void 0?c=A.edit(c,[z],void 0,S):V!==void 0?c=A.edit(c,[z],H,S):_.push(a(z,d))}_.sort((z,H)=>z.startOffset-H.startOffset),_.forEach(z=>c=b(z.setting.key,l,c,S))}return c}e.updateIgnoredSettings=m;function g(c,l,f,S,d,T){const O=m(c,l,S,T),_=f!==O,z=f!==l;if(!_&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(_&&!z)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(z&&!_)return{conflictsSettings:[],localContent:m(l,c,S,T),remoteContent:null,hasConflicts:!1};if(f===null&&C(c)){const ne=u(c,l,S)?null:m(l,c,S,T);return{conflictsSettings:[],localContent:ne,remoteContent:null,hasConflicts:!1}}let H=c,V=l;const U=(0,I.parse)(c),x=(0,I.parse)(l),M=f?(0,I.parse)(f):null,$=S.reduce((ne,le)=>(ne.add(le),ne),new Set),q=P(U,x,$),F=P(M,U,$),W=P(M,x,$),N=new Map,G=new Set,B=ne=>{G.add(ne);const le=d.filter(({key:fe})=>fe===ne)[0];le?(H=A.edit(H,[ne],le.value,T),V=A.edit(V,[ne],le.value,T)):N.set(ne,{key:ne,localValue:U[ne],remoteValue:x[ne]})};for(const ne of F.removed.values())W.updated.has(ne)?B(ne):V=A.edit(V,[ne],void 0,T);for(const ne of W.removed.values())G.has(ne)||(F.updated.has(ne)?B(ne):H=A.edit(H,[ne],void 0,T));for(const ne of F.updated.values())G.has(ne)||(W.updated.has(ne)?q.updated.has(ne)&&B(ne):V=A.edit(V,[ne],U[ne],T));for(const ne of W.updated.values())G.has(ne)||(F.updated.has(ne)?q.updated.has(ne)&&B(ne):H=A.edit(H,[ne],x[ne],T));for(const ne of F.added.values())G.has(ne)||(W.added.has(ne)?q.updated.has(ne)&&B(ne):V=b(ne,H,V,T));for(const ne of W.added.values())G.has(ne)||(F.added.has(ne)?q.updated.has(ne)&&B(ne):H=b(ne,V,H,T));const J=N.size>0||!u(H,V,S),Q=J||!u(H,c,[]),ie=J||!u(V,l,[]);return{localContent:Q?H:null,remoteContent:ie?V:null,conflictsSettings:[...N.values()],hasConflicts:J}}e.merge=g;function u(c,l,f){if(c===l)return!0;const S=(0,I.parse)(c),d=(0,I.parse)(l),T=f.reduce((z,H)=>(z.add(H),z),new Set),O=h(c).filter(z=>!(z.setting&&T.has(z.setting.key))),_=h(l).filter(z=>!(z.setting&&T.has(z.setting.key)));if(O.length!==_.length)return!1;for(let z=0;z<O.length;z++){const H=O[z],V=_[z];if(H.setting&&V.setting){if(H.setting.key!==V.setting.key||!w.equals(S[H.setting.key],d[H.setting.key]))return!1}else if(!H.setting&&!V.setting){if(H.value!==V.value)return!1}else return!1}return!0}e.areSame=u;function C(c){return c?h(c).length===0:!0}e.isEmpty=C;function P(c,l,f){const S=c?Object.keys(c).filter(z=>!f.has(z)):[],d=Object.keys(l).filter(z=>!f.has(z)),T=d.filter(z=>S.indexOf(z)===-1).reduce((z,H)=>(z.add(H),z),new Set),O=S.filter(z=>d.indexOf(z)===-1).reduce((z,H)=>(z.add(H),z),new Set),_=new Set;if(c)for(const z of S){if(O.has(z))continue;const H=c[z],V=l[z];w.equals(H,V)||_.add(z)}return{added:T,removed:O,updated:_}}function b(c,l,f,S){const d=(0,I.parse)(l),T=h(l),O=h(f),_=R(c,T,O);return p(f,c,d[c],_,O,S)}e.addSetting=b;function R(c,l,f){const S=l.findIndex(T=>T.setting?.key===c),d=l[S-1];if(d){if(d.setting){const O=a(d.setting.key,f);if(O)return{index:f.indexOf(O),insertAfter:!0}}else{const O=t(S,l);if(O){const _=a(O.setting.key,f);if(_){const z=r(f.indexOf(_),f),H=i(l,O,l[S]);if(z){const V=i(f,_,z),U=s(H,V);return U?{index:f.indexOf(U),insertAfter:!0}:{index:f.indexOf(z),insertAfter:!1}}else{const V=i(f,_,f[f.length-1]),U=s(H,V);return U?{index:f.indexOf(U),insertAfter:!0}:{index:f.length-1,insertAfter:!0}}}}}const T=l[S+1];if(T)if(T.setting){const O=a(T.setting.key,f);if(O)return{index:f.indexOf(O),insertAfter:!1}}else{const O=r(S,l);if(O){const _=a(O.setting.key,f);if(_){const z=t(f.indexOf(_),f),H=i(l,l[S],O);if(z){const V=i(f,z,_),U=s(H.reverse(),V.reverse());return U?{index:f.indexOf(U),insertAfter:!1}:{index:f.indexOf(z),insertAfter:!0}}else{const V=i(f,f[0],_),U=s(H.reverse(),V.reverse());return U?{index:f.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:f.length-1,insertAfter:!0}}function p(c,l,f,S,d,T){let O;return S.index===-1?O=(0,L.setProperty)(c,[l],f,T):O=o(c,l,f,S,d,T).map(_=>(0,L.withFormatting)(c,_,T)[0]),(0,L.applyEdits)(c,O)}function o(c,l,f,S,d,T){const O=`${JSON.stringify(l)}: ${JSON.stringify(f)}`,_=(0,k.getEOL)(T,c),z=d[S.index];if(S.insertAfter){const H=[];if(z.setting)H.push({offset:z.endOffset,length:0,content:","+O});else{const V=r(S.index,d),U=t(S.index,d),x=U?.setting?.commaOffset;U&&x===void 0&&H.push({offset:U.endOffset,length:0,content:","});const M=x!==void 0&&x>z.endOffset;H.push({offset:M?x+1:z.endOffset,length:0,content:V?_+O+",":_+O})}return H}else{if(z.setting)return[{offset:z.startOffset,length:0,content:O+","}];const H=(d[S.index-1]&&!d[S.index-1].setting?_:"")+O+(r(S.index,d)?",":"")+_;return[{offset:z.startOffset,length:0,content:H}]}}function a(c,l){return l.filter(f=>f.setting?.key===c)[0]}function t(c,l){for(let f=c-1;f>=0;f--)if(l[f].setting)return l[f]}function r(c,l){for(let f=c+1;f<l.length;f++)if(l[f].setting)return l[f]}function i(c,l,f){const S=c.indexOf(l),d=c.indexOf(f);return c.filter((T,O)=>S<O&&O<d)}function s(c,l){if(c.length&&l.length){let f=0;for(;f<l.length&&f<c.length;f++)if(c[f].value!==l[f].value)return l[f-1];return l[f-1]}}function h(c){const l=[];let f=-1,S,d;const T={onObjectBegin:O=>{f++},onObjectProperty:(O,_,z)=>{f===0&&(S=_,d=O)},onObjectEnd:(O,_)=>{f--,f===0&&l.push({startOffset:S,endOffset:O+_,value:c.substring(S,O+_),setting:{key:d,commaOffset:void 0}})},onArrayBegin:(O,_)=>{f++},onArrayEnd:(O,_)=>{f--,f===0&&l.push({startOffset:S,endOffset:O+_,value:c.substring(S,O+_),setting:{key:d,commaOffset:void 0}})},onLiteralValue:(O,_,z)=>{f===0&&l.push({startOffset:S,endOffset:_+z,value:c.substring(S,_+z),setting:{key:d,commaOffset:void 0}})},onSeparator:(O,_,z)=>{if(f===0&&O===","){let H=l.length-1;for(;H>=0&&!l[H].setting;H--);const V=l[H];V&&l.splice(H,1,{startOffset:V.startOffset,endOffset:V.endOffset,value:V.value,setting:{key:V.setting.key,commaOffset:_}})}},onComment:(O,_)=>{f===0&&l.push({startOffset:O,endOffset:O+_,value:c.substring(O,O+_)})}};return(0,I.visit)(c,T),l}}),define(Z[204],ee([0,1,13,22,25,130,3,12,24,203,54,46,21,27,20,42]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function P(a){return a&&a.settings&&typeof a.settings=="string"&&Object.keys(a).length===1}function b(a){const t=JSON.parse(a);return P(t)?t:{settings:a}}e.parseSettingsSyncContent=b;let R=class extends y.AbstractJsonFileSynchroniser{constructor(t,r,i,s,h,c,l,f,S,d,T){super(r.settingsResource,"settings",t,r,i,s,h,S,d,c,l,f);this.extensionManagementService=T,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i,s){const h=await this.getLocalFileContent(),c=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const f=r?this.getSettingsSyncContent(r):null,S=await this.getIgnoredSettings();let d=null,T=!1,O=!1,_=!1;if(l){let H=h?h.value.toString().trim():"{}";H=H||"{}",this.validateContent(H),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const V=(0,v.merge)(H,l.settings,f?f.settings:null,S,[],c);d=V.localContent||V.remoteContent,T=V.localContent!==null,O=V.remoteContent!==null,_=V.hasConflicts}else h&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),d=h.value.toString(),O=!0);const z={content:d,localChange:T?2:0,remoteChange:O?2:0,hasConflicts:_};return[{fileContent:h,localResource:this.localResource,localContent:h?h.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,v.updateIgnoredSettings)(t.previewResult.content,"{}",s,i):null}}async getAcceptResult(t,r,i,s){const h=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,v.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",c,h):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,v.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",c,h):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?(0,v.updateIgnoredSettings)(i,t.fileContent?t.fileContent.value.toString():"{}",c,h):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,s){const{fileContent:h}=i[0][0];let{content:c,localChange:l,remoteChange:f}=i[0][1];if(l===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),h&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(h.value.toString()))),await this.updateLocalFileContent(c,h,s),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),f!==0){const S=await this.getFormattingOptions(),d=this.getSettingsSyncContent(t),T=await this.getIgnoredSettings(c);c=(0,v.updateIgnoredSettings)(c,d?d.settings:"{}",T,S),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),s?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(S){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=(0,n.edit)(t.value.toString(),[I.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,v.isEmpty)(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const s=this.parseSettingsSyncContent(i.content);if(s)switch(this.extUri.basename(t)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();r=(0,v.updateIgnoredSettings)(r,"{}",s,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:h})=>!!h)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,v.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new I.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!o(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let s=i.settings;const h=await this.getFormattingOptions();for(const c in r)if(["version","content","machineId"].indexOf(c)===-1&&r[c]!==void 0){const l=(0,C.setProperty)(s,[c],r[c],h);l.length&&(s=(0,C.applyEdits)(s,l))}await this.fileService.writeFile(this.file,L.VSBuffer.fromString(s))}catch(t){}}};R=de([Y(0,w.IFileService),Y(1,D.IEnvironmentService),Y(2,u.IStorageService),Y(3,I.IUserDataSyncStoreService),Y(4,I.IUserDataSyncBackupStoreService),Y(5,I.IUserDataSyncLogService),Y(6,I.IUserDataSyncUtilService),Y(7,E.IConfigurationService),Y(8,I.IUserDataSyncResourceEnablementService),Y(9,m.ITelemetryService),Y(10,g.IExtensionManagementService)],R),e.SettingsSynchroniser=R;let p=class extends y.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,v.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}};p=de([Y(0,w.IFileService),Y(1,D.IEnvironmentService),Y(2,I.IUserDataSyncLogService)],p),e.SettingsInitializer=p;function o(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&a.machineId!==void 0&&typeof a.machineId=="string")}}),define(Z[205],ee([0,1,22,12,13,24,46,21,25,198,20,26,3]),function(K,e,w,I,L,k,A,D,E,v,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let g=class extends A.AbstractSynchroniser{constructor(P,b,R,p,o,a,t,r,i){super("snippets",b,P,R,p,o,r,i,a,t);this.version=1,this.snippetsFolder=P.snippetsHome,this._register(this.fileService.watch(P.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(m.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(P,b,R,p){const o=await this.getSnippetsFileContents(),a=this.toSnippetsContents(o),t=P.syncData?this.parseSnippets(P.syncData):null;b=b===null&&R?P:b;const r=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,v.merge)(a,t,r);return this.getResourcePreviews(i,o,t||{})}async getMergeResult(P,b){return P.previewResult}async getAcceptResult(P,b,R,p){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:P.fileContent?P.fileContent.value.toString():null,localChange:0,remoteChange:P.fileContent?P.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:P.remoteContent,localChange:P.remoteContent!==null?P.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return R===void 0?{content:P.previewResult.content,localChange:P.previewResult.localChange,remoteChange:P.previewResult.remoteChange}:{content:R,localChange:R===null?P.fileContent!==null?3:0:2,remoteChange:R===null?P.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(P,b,R,p){const o=R.map(([a,t])=>({...a,acceptResult:t}));o.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,p)),o.some(({remoteChange:a})=>a!==0)&&(P=await this.updateRemoteSnippets(o,P,p)),b?.ref!==P.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(P),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of o)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(P,b,R){const p=new Map;for(const o of Object.keys(P.local.added)){const a={content:P.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};p.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(P.local.updated)){const a={content:P.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o],localContent:b[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of P.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o],localContent:b[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(P.remote.added)){const a={content:P.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o],localContent:b[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(P.remote.updated)){const a={content:P.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o],localContent:b[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of P.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of P.conflicts){const a={content:b[o]?b[o].value.toString():null,hasConflicts:!0,localChange:b[o]?2:1,remoteChange:R[o]?2:1};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o]||null,localContent:b[o]?b[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(b))if(!p.has(o)){const a={content:b[o]?b[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o]||null,localContent:b[o]?b[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...p.values()]}async getAssociatedResources({uri:P}){let b=await super.resolveContent(P);if(b){const R=this.parseSyncData(b);if(R){const p=this.parseSnippets(R),o=[];for(const a of Object.keys(p)){const t=this.extUri.joinPath(P,a),r=this.extUri.joinPath(this.snippetsFolder,a),i=await this.fileService.exists(r);o.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(P){if(this.extUri.isEqualOrParent(P,this.syncPreviewFolder.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(P,this.syncPreviewFolder.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(P,this.syncPreviewFolder.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(P);let b=await super.resolveContent(P);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(P)),b){const R=this.parseSyncData(b);if(R)return this.parseSnippets(R)[this.extUri.basename(P)]||null}return null}async hasLocalData(){try{const P=await this.getSnippetsFileContents();if(Object.keys(P).length)return!0}catch(P){}return!1}async updateLocalBackup(P){const b={};for(const R of P)R.fileContent&&(b[this.extUri.basename(R.localResource)]=R.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(P,b){for(const{fileContent:R,acceptResult:p,localResource:o,remoteResource:a,localChange:t}of P)if(t!==0){const r=a?this.extUri.basename(a):this.extUri.basename(o),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,E.VSBuffer.fromString(p.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,E.VSBuffer.fromString(p.content),b?void 0:R),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(P,b,R){const p=b.syncData?this.parseSnippets(b.syncData):{},o=(0,y.deepClone)(p);for(const{acceptResult:a,localResource:t,remoteResource:r,remoteChange:i}of P)if(i!==0){const s=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete o[s]:o[s]=a.content}return(0,v.areSame)(p,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(o),R?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(P){return JSON.parse(P.content)}toSnippetsContents(P){const b={};for(const R of Object.keys(P))b[R]=P[R].value.toString();return b}async getSnippetsFileContents(){const P={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(R){if(R instanceof L.FileOperationError&&R.fileOperationResult===1)return P;throw R}for(const R of b.children||[]){const p=R.resource,o=this.extUri.extname(p);if(o===".json"||o===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,p),t=await this.fileService.readFile(p);P[a]=t}}return P}};g=de([Y(0,I.IEnvironmentService),Y(1,L.IFileService),Y(2,n.IStorageService),Y(3,w.IUserDataSyncStoreService),Y(4,w.IUserDataSyncBackupStoreService),Y(5,w.IUserDataSyncLogService),Y(6,k.IConfigurationService),Y(7,w.IUserDataSyncResourceEnablementService),Y(8,D.ITelemetryService)],g),e.SnippetsSynchroniser=g;let u=class extends A.AbstractInitializer{constructor(P,b,R){super("snippets",b,R,P)}async doInitialize(P){const b=P.syncData?JSON.parse(P.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const p of Object.keys(b)){const o=b[p];if(o){const a=this.extUri.joinPath(this.environmentService.snippetsHome,p);await this.fileService.createFile(a,E.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(P)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(P){return P.fileOperationResult===1}}};u=de([Y(0,L.IFileService),Y(1,I.IEnvironmentService),Y(2,w.IUserDataSyncLogService)],u),e.SnippetsInitializer=u}),define(Z[60],ee([0,1,7,3,2,22]),function(K,e,w,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,w.createDecorator)("IUserDataSyncAccountService");let A=class extends L.Disposable{constructor(E){super();this.userDataSyncStoreService=E,this._onDidChangeAccount=this._register(new I.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new I.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(E.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(E.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(E){(E&&this._account?E.token!==this._account.token||E.authenticationProviderId!==this._account.authenticationProviderId:E!==this._account)&&(this._account=E,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(E))}};A=de([Y(0,k.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(Z[206],ee([0,1,2,22,15,24,13,12,56,25,6]),function(K,e,w,I,L,k,A,D,E,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let y=class extends w.Disposable{constructor(g,u,C,P){super();this.environmentService=g,this.fileService=u,this.configurationService=C,this.logService=P,I.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(g){const u=(0,L.joinPath)(this.environmentService.userDataSyncHome,g),C=await this.fileService.resolve(u);return C.children?C.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(g,u){if(!u){const C=await this.getAllRefs(g);C.length&&(u=C[C.length-1].ref)}if(u){const C=(0,L.joinPath)(this.environmentService.userDataSyncHome,g,u);return(await this.fileService.readFile(C)).value.toString()}return null}async backup(g,u){const C=(0,L.joinPath)(this.environmentService.userDataSyncHome,g),P=(0,L.joinPath)(C,`${(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(P,v.VSBuffer.fromString(u))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(g)}catch(b){}}async cleanUpBackup(g){const u=(0,L.joinPath)(this.environmentService.userDataSyncHome,g);try{try{if(!await this.fileService.exists(u))return}catch(P){return}const C=await this.fileService.resolve(u);if(C.children){const P=C.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let R=P.filter(o=>Date.now()-this.getCreationTime(o)>b);const p=P.length-R.length;p<10&&(R=R.slice(10-p)),await n.Promises.settled(R.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(C){this.logService.error(C)}}getCreationTime(g){return g.ctime||new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};y=de([Y(0,D.IEnvironmentService),Y(1,A.IFileService),Y(2,k.IConfigurationService),Y(3,I.IUserDataSyncLogService)],y),e.UserDataSyncBackupStoreService=y}),define(Z[207],ee([0,1,5,2]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(m){this.service=m}listen(m,g){switch(g){case"onError":return this.service.onError}throw new Error(`Event not found: ${g}`)}call(m,g,u){switch(g){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class k{constructor(m){this.service=m}listen(m,g){throw new Error(`Event not found: ${g}`)}call(m,g,u){switch(g){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(w.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class A{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=A;class D{constructor(m){this.service=m}listen(m,g){switch(g){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${g}`)}async call(m,g,u){switch(g){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=D;class E{constructor(m){this.service=m}listen(m,g){switch(g){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${g}`)}call(m,g,u){switch(g){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=E;class v{constructor(m){this.service=m}listen(m,g){switch(g){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${g}`)}call(m,g,u){switch(g){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=v;class n extends I.Disposable{constructor(m){super();this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:w.URI.revive(m.url),type:m.type,defaultUrl:w.URI.revive(m.defaultUrl),insidersUrl:w.URI.revive(m.insidersUrl),stableUrl:w.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(Z[208],ee([0,1,14,12]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends w.AbstractLogger{constructor(A,D){super();this.logger=this._register(A.createLogger(D.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...D){this.logger.trace(A,...D)}debug(A,...D){this.logger.debug(A,...D)}info(A,...D){this.logger.info(A,...D)}warn(A,...D){this.logger.warn(A,...D)}error(A,...D){this.logger.error(A,...D)}critical(A,...D){this.logger.critical(A,...D)}flush(){this.logger.flush()}};L=de([Y(0,w.ILoggerService),Y(1,I.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(Z[61],ee([0,1,7,2,45,12,13,20,22,133,28,4,19,3]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,w.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName";let C=class Ke extends I.Disposable{constructor(b,R,p,o,a,t){super();this.storageService=p,this.userDataSyncStoreService=o,this.logService=a,this.productService=t,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,L.getServiceMachineId)(b,R,p)}async getMachines(b){const R=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(o=>({...o,isCurrent:o.id===R}))}async addCurrentMachine(b){const R=await this.currentMachineIdPromise,p=await this.readMachinesData(b);p.machines.some(({id:o})=>o===R)||(p.machines.push({id:R,name:this.computeCurrentMachineName(p.machines)}),await this.writeMachinesData(p))}async removeCurrentMachine(b){const R=await this.currentMachineIdPromise,p=await this.readMachinesData(b),o=p.machines.filter(({id:a})=>a!==R);o.length!==p.machines.length&&(p.machines=o,await this.writeMachinesData(p))}async renameMachine(b,R,p){const o=await this.currentMachineIdPromise,a=await this.readMachinesData(p),t=a.machines.find(({id:r})=>r===b);t&&(t.name=R,await this.writeMachinesData(a),a.machines.some(({id:r})=>r===o)&&this.storageService.store(u,R,0,1))}async setEnablement(b,R){const p=await this.readMachinesData(),o=p.machines.find(({id:a})=>a===b);o&&(o.disabled=R?void 0:!0,await this.writeMachinesData(p))}computeCurrentMachineName(b){const R=this.storageService.get(u,0);if(R)return R;const p=`${this.productService.nameLong} (${(0,y.PlatformToString)(y.isWeb?0:y.platform)})`,o=new RegExp(`${(0,m.escapeRegExpCharacters)(p)}\\s#(\\d+)`);let a=0;for(const t of b){const r=o.exec(t.name),i=r?parseInt(r[1]):0;a=i>a?i:a}return`${p} #${a+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const R=this.parse(this.userData);if(R.version!==Ke.VERSION)throw new Error((0,v.localize)(0,null,this.productService.nameLong));return R}async writeMachinesData(b){const R=JSON.stringify(b),p=await this.userDataSyncStoreService.write(Ke.RESOURCE,R,this.userData?.ref||null);this.userData={ref:p,content:R},this._onDidChange.fire()}async readUserData(b){if(this.userData){const R=b&&b.latest?b.latest[Ke.RESOURCE]:void 0;if(this.userData.ref===R)return this.userData;if(R===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ke.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(R){this.logService.error(R)}return{version:Ke.VERSION,machines:[]}}};C.VERSION=1,C.RESOURCE="machines",C=de([Y(0,k.IEnvironmentService),Y(1,A.IFileService),Y(2,D.IStorageService),Y(3,E.IUserDataSyncStoreService),Y(4,E.IUserDataSyncLogService),Y(5,n.IProductService)],C),e.UserDataSyncMachinesService=C}),define(Z[89],ee([0,1,6,3,2,22,60,21,11,20,12,61,131,56,5,15,4,28,37]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const p="sync.enable",o="sync.disableMachineEventually",a="sync.sessionId",t="sync.storeUrl",r="sync.productQuality";let i=class extends L.Disposable{constructor(l,f,S){super();this.storageService=l,this.environmentService=f,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new I.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(l.onDidChangeValue(d=>this.onDidStorageChange(d)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(p,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(l){l&&!this.canToggleEnablement()||this.storageService.store(p,l,0,1)}onDidStorageChange(l){if(l.scope===0&&p===l.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=de([Y(0,v.IStorageService),Y(1,n.IEnvironmentService),Y(2,k.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let s=class extends L.Disposable{constructor(l,f,S,d,T,O,_,z,H,V,U){super();this.userDataSyncStoreManagementService=f,this.userDataSyncStoreService=S,this.userDataSyncResourceEnablementService=d,this.userDataSyncService=T,this.logService=O,this.userDataSyncAccountService=_,this.telemetryService=z,this.userDataSyncMachinesService=H,this.storageService=V,this.autoSync=this._register(new L.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=U,this.syncTriggerDelayer=this._register(new w.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=f.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=l.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(f.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,f.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=f.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(S.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(I.Event.debounce(T.onDidChangeLocal,(x,M)=>x?[...x,M]:[M],1e3)(x=>this.triggerSync(x,!1,!1))),this._register(I.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,x])=>x)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const l=this.storageService.get(t,0);return l?u.URI.parse(l):void 0}set syncUrl(l){l?this.storageService.store(t,l.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(r,0)}set productQuality(l){l?this.storageService.store(r,l,0,1):this.storageService.remove(r,0)}updateAutoSync(){const{enabled:l,message:f}=this.isAutoSyncEnabled();l?this.autoSync.value===void 0&&(this.autoSync.value=new h(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(S=>this.onDidFinishSync(S))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(f&&this.logService.info(f),this.autoSync.clear()):f&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(f))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,g.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(l,f,S){try{this.userDataSyncAccountService.account&&!S&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),l?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(d){if(f)this.logService.error(d),this.updateEnablement(!1);else throw d}}updateEnablement(l){this.userDataAutoSyncEnablementService.isEnabled()!==l&&(this.telemetryService.publicLog2(p,{enabled:l}),this.userDataAutoSyncEnablementService.setEnablement(l),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(l){if(!l){this.successiveFailures=0;return}const f=k.UserDataSyncError.toUserDataSyncError(l);f instanceof k.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:f.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),f.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):f.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):f.code==="LocalTooManyRequests"||f.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):f.code==="UpgradeRequired"||f.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):f.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${f.resource} content with newer version than of client. Requires client upgrade.`)):f.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${f.resource} content with older version than of client. Requires server reset.`)):f.code==="ServiceChanged"||f.code==="DefaultServiceChanged"?P.isWeb&&f.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(f),this.successiveFailures++),this._onError.fire(f)}async disableMachineEventually(){this.storageService.store(o,!0,0,1),await(0,w.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(o,0,!1)}stopDisableMachineEventually(){this.storageService.remove(o,0)}async triggerSync(l,f,S){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(f&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...l),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",S)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};s=de([Y(0,b.IProductService),Y(1,k.IUserDataSyncStoreManagementService),Y(2,k.IUserDataSyncStoreService),Y(3,k.IUserDataSyncResourceEnablementService),Y(4,k.IUserDataSyncService),Y(5,k.IUserDataSyncLogService),Y(6,A.IUserDataSyncAccountService),Y(7,D.ITelemetryService),Y(8,y.IUserDataSyncMachinesService),Y(9,v.IStorageService),Y(10,k.IUserDataAutoSyncEnablementService)],s),e.UserDataAutoSyncService=s;class h extends L.Disposable{constructor(l,f,S,d,T,O,_,z){super();this.lastSyncUrl=l,this.interval=f,this.userDataSyncStoreManagementService=S,this.userDataSyncStoreService=d,this.userDataSyncService=T,this.userDataSyncMachinesService=O,this.logService=_,this.storageService=z,this.intervalHandler=this._register(new L.MutableDisposable),this._onDidStartSync=this._register(new I.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new I.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,L.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(h.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,w.disposableTimeout)(()=>this.sync(h.INTERVAL_SYNCING,!1),this.interval)}sync(l,f){const S=(0,w.createCancelablePromise)(async d=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(T){if((0,E.isPromiseCanceledError)(T))return}return this.doSync(l,f,d)});return this.syncPromise=S,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const l=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),f=this.userDataSyncStoreManagementService.userDataSyncStore;return!!f&&!!l&&(!(0,C.isEqual)(f.defaultUrl,l.defaultUrl)||!(0,C.isEqual)(f.insidersUrl,l.insidersUrl)||!(0,C.isEqual)(f.stableUrl,l.stableUrl))}async doSync(l,f,S){this.logService.info(`Auto Sync: Triggered by ${l}`),this._onDidStartSync.fire();let d;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,f),S.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,m.localize)(0,null),"DefaultServiceChanged"):new k.UserDataAutoSyncError((0,m.localize)(1,null),"ServiceChanged"):new k.UserDataAutoSyncError((0,m.localize)(2,null),"TurnedOff");const T=this.storageService.get(a,0);if(T&&this.manifest&&T!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,m.localize)(3,null),"DefaultServiceChanged"):new k.UserDataAutoSyncError((0,m.localize)(4,null),"ServiceChanged"):new k.UserDataAutoSyncError((0,m.localize)(5,null),"SessionExpired");const O=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(S.isCancellationRequested)return;const _=O.find(z=>z.isCurrent);if(_?.disabled)throw new k.UserDataAutoSyncError((0,m.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(z){throw new k.UserDataAutoSyncError((0,R.toErrorMessage)(z),z instanceof k.UserDataSyncError?z.code:"Unknown")}if(this.manifest&&this.manifest.session!==T&&this.storageService.store(a,this.manifest.session,0,1),S.isCancellationRequested)return;_||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(T){this.logService.error(T),d=T}this._onDidFinishSync.fire(d)}register(l){return super._register(l)}}h.INTERVAL_SYNCING="Interval"}),define(Z[209],ee([0,1,22,2,3,20,21,4]),function(K,e,w,I,L,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let E=class extends I.Disposable{constructor(n,y){super();this.storageService=n,this.telemetryService=y,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(m=>this.onDidStorageChange(m)))}isResourceEnabled(n){return this.storageService.getBoolean((0,w.getEnablementKey)(n),0,!0)}setResourceEnablement(n,y){if(this.isResourceEnabled(n)!==y){const m=(0,w.getEnablementKey)(n);this.telemetryService.publicLog2(m,{enabled:y}),this.storeResourceEnablement(m,y)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,y){this.storageService.store(n,y,0,D.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const y=w.ALL_SYNC_RESOURCES.filter(m=>(0,w.getEnablementKey)(m)===n.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}}};E=de([Y(0,k.IStorageService),Y(1,A.ITelemetryService)],E),e.UserDataSyncResourceEnablementService=E}),define(Z[210],ee([0,1,22,2,7,3,199,202,201,37,21,23,20,204,15,205,30,6,11]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const p="sync.lastSyncTime";let o=class extends I.Disposable{constructor(i,s,h,c,l,f){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=s,this.instantiationService=h,this.logService=c,this.telemetryService=l,this.storageService=f,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(g.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(D.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(C.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(E.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(A.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(S=>k.Event.map(S.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(S=>k.Event.map(S.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(p,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(S=>k.Event.map(S.onDidChangeLocal,()=>S.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i,s){await this.checkEnablement();const h=(0,P.generateUuid)();try{const S=(0,w.createSyncHeaders)(h);s&&(S["Cache-Control"]="no-cache"),i=await this.userDataSyncStoreService.manifest(i,S)}catch(S){const d=w.UserDataSyncError.toUserDataSyncError(S);throw this.reportUserDataSyncError(d,h),d}let c=!1;const l=this;let f;return{manifest:i,run(){if(c)throw new Error("Can run a task only once");return f=(0,b.createCancelablePromise)(S=>l.sync(i,h,S)),f.finally(()=>f=void 0)},async stop(){if(f&&f.cancel(),l.status!=="idle")return l.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=(0,P.generateUuid)(),s=(0,w.createSyncHeaders)(i);let h;try{h=await this.userDataSyncStoreService.manifest(null,s)}catch(c){const l=w.UserDataSyncError.toUserDataSyncError(c);throw this.reportUserDataSyncError(l,i),l}return new a(i,h,s,this.synchronisers,this.logService)}async sync(i,s,h){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),h.isCancellationRequested)return;const c=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const l=(0,w.createSyncHeaders)(s);for(const f of this.synchronisers){if(h.isCancellationRequested)return;try{await f.sync(i,l)}catch(S){let d=!1;if(S instanceof w.UserDataSyncError)switch(S.code){case"TooLarge":S=new w.UserDataSyncError(S.message,S.code,f.resource),d=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":d=!0;break}const T=w.UserDataSyncError.toUserDataSyncError(S);if(this.reportUserDataSyncError(T,s),d)throw T;this.logService.error(S),this.logService.error(`${f.resource}: ${(0,v.toErrorMessage)(S)}`),this._syncErrors.push([f.resource,T])}}this.logService.info(`Sync done. Took ${new Date().getTime()-c}ms`),this.updateLastSyncTime()}catch(l){const f=w.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(f,s),f}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(s){this.logService.error(s)}}async replace(i){await this.checkEnablement();for(const s of this.synchronisers)if(await s.replace(i))return}async accept(i,s,h,c){await this.checkEnablement();const l=this.getSynchroniser(i);await l.accept(s,h),c&&await l.apply(!1,(0,w.createSyncHeaders)((0,P.generateUuid)()))}async resolveContent(i){for(const s of this.synchronisers){const h=await s.resolveContent(i);if(h)return h}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,s){return this.getSynchroniser(i).getAssociatedResources(s)}getMachineId(i,s){return this.getSynchroniser(i).getMachineId(s)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const s of i)if(await s.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(p,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(s){this.logService.error(`${i.resource}: ${(0,v.toErrorMessage)(s)}`),this.logService.error(s)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const s=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();(0,y.equals)(this._conflicts,i,([s,h],[c,l])=>s===s&&(0,y.equals)(h,l,(f,S)=>(0,u.isEqual)(f.previewResource,S.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(p,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,s){this.telemetryService.publicLog2("sync/error",{code:i.code,serverCode:i instanceof w.UserDataSyncStoreError?String(i.serverCode):void 0,url:i instanceof w.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(s=>s.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=de([Y(0,w.IUserDataSyncStoreService),Y(1,w.IUserDataSyncStoreManagementService),Y(2,L.IInstantiationService),Y(3,w.IUserDataSyncLogService),Y(4,n.ITelemetryService),Y(5,m.IStorageService)],o),e.UserDataSyncService=o;class a extends I.Disposable{constructor(i,s,h,c,l){super();this.id=i,this.manifest=s,this.syncHeaders=h,this.synchronisers=c,this.logService=l,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,b.createCancelablePromise)(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,s){try{return await this.performAction(i,h=>h.accept(i,s))}catch(h){throw this.logService.error(h),h}}async merge(i){try{return i?await this.performAction(i,s=>s.merge(i)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(i){try{return await this.performAction(i,s=>s.discard(i))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,s]of this.previews)for(const h of s.resourcePreviews)h.mergeState==="conflict"&&i.push(h.previewResource);for(const s of i)await this.discard(s);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[s,h]of this.previews){this.synchronizingResources.push([s,h.resourcePreviews.map(f=>f.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(f=>f.resource===s);for(const f of h.resourcePreviews)(f.localChange!==0||f.remoteChange!==0)&&f.mergeState==="preview"&&await c.merge(f.previewResource);const l=await c.apply(!1,this.syncHeaders);l&&i.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(f=>f[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,s]of this.previews){this.synchronizingResources.push([i,s.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(c=>c.resource===i);for(const c of s.resourcePreviews)await h.accept(c.remoteResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,s]of this.previews){this.synchronizingResources.push([i,s.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(c=>c.resource===i);for(const c of s.resourcePreviews)await h.accept(c.localResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(s){(0,R.isPromiseCanceledError)(s)||this.logService.error(s)}this.reset()}async performAction(i,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const h=this.previews.findIndex(([,_])=>_.resourcePreviews.some(({localResource:z,previewResource:H,remoteResource:V})=>(0,u.isEqual)(i,z)||(0,u.isEqual)(i,H)||(0,u.isEqual)(i,V)));if(h===-1)return this.previews;const[c,l]=this.previews[h],f=l.resourcePreviews.find(({localResource:_,remoteResource:z,previewResource:H})=>(0,u.isEqual)(_,i)||(0,u.isEqual)(z,i)||(0,u.isEqual)(H,i));if(!f)return this.previews;let S=this.synchronizingResources.find(_=>_[0]===c);S||(S=[c,[]],this.synchronizingResources.push(S)),S[1].some(_=>(0,u.isEqual)(_,f.localResource))||(S[1].push(f.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const d=this.synchronisers.find(_=>_.resource===this.previews[h][0]),T=await s(d);T?this.previews.splice(h,1,this.toSyncResourcePreview(d.resource,T)):this.previews.splice(h,1);const O=this.synchronizingResources.findIndex(_=>_[0]===c);return this.synchronizingResources[O][1].splice(S[1].findIndex(_=>(0,u.isEqual)(_,f.localResource)),1),S[1].length||(this.synchronizingResources.splice(O,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[s,h]of this.previews){this.synchronizingResources.push([s,h.resourcePreviews.map(f=>f.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(f=>f.resource===s);let l=h;for(const f of h.resourcePreviews)(f.localChange!==0||f.remoteChange!==0)&&f.mergeState==="preview"&&(l=await c.merge(f.previewResource));l&&i.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(f=>f[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const s=[];for(const h of this.synchronisers){if(i.isCancellationRequested)return[];const c=await h.preview(this.manifest,this.syncHeaders);c&&s.push(this.toSyncResourcePreview(h.resource,c))}return s}toSyncResourcePreview(i,s){return[i,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[211],ee([0,1,3,22,5,2,16]),function(K,e,w,I,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class D{constructor(y,m){this.service=y,this.logService=m,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new w.Emitter}listen(y,m){switch(m){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${m}`)}async call(y,m,g){try{return await this._call(y,m,g)}catch(u){throw this.logService.error(u),u}}async _call(y,m,g){switch(m){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(g[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(g[0],L.URI.revive(g[1]),g[2],g[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(g[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(g[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(g[0]);case"getAssociatedResources":return this.service.getAssociatedResources(g[0],{created:g[1].created,uri:L.URI.revive(g[1].uri)});case"getMachineId":return this.service.getMachineId(g[0],{created:g[1].created,uri:L.URI.revive(g[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(m.startsWith("manualSync/")){const u=m.substring("manualSync/".length),C=g[0],P=this.getManualSyncTask(C);switch(g=g.slice(1),u){case"preview":return P.preview();case"accept":return P.accept(L.URI.revive(g[0]),g[1]);case"merge":return P.merge(L.URI.revive(g[0]));case"discard":return P.discard(L.URI.revive(g[0]));case"discardConflicts":return P.discardConflicts();case"apply":return P.apply();case"pull":return P.pull();case"push":return P.push();case"stop":return P.stop();case"_getStatus":return P.status;case"dispose":return this.disposeManualSyncTask(P)}}throw new Error("Invalid call")}getManualSyncTask(y){const m=this.manualSyncTasks.get(this.createKey(y));if(!m)throw new Error(`Manual sync taks not found: ${y}`);return m.manualSyncTask}async createManualSyncTask(){const y=new k.DisposableStore,m=y.add(await this.service.createManualSyncTask());return y.add(m.onSynchronizeResources(g=>this.onManualSynchronizeResources.fire({manualSyncTaskId:m.id,data:g}))),this.manualSyncTasks.set(this.createKey(m.id),{manualSyncTask:m,disposables:y}),{id:m.id,manifest:m.manifest,status:m.status}}disposeManualSyncTask(y){y.dispose();const m=this.createKey(y.id);this.manualSyncTasks.get(m)?.disposables.dispose(),this.manualSyncTasks.delete(m)}createKey(y){return`manualSyncTask-${y}`}}e.UserDataSyncChannel=D;class E extends k.Disposable{constructor(y){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new w.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new w.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new w.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new w.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(m,g,u){return y.call(m,g,u).then(null,C=>{throw I.UserDataSyncError.toUserDataSyncError(C)})},listen(m,g){return y.listen(m,g)}},this.channel.call("_getInitialData").then(([m,g,u])=>{this.updateStatus(m),this.updateConflicts(g),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(C=>this.updateStatus(C))),this._register(this.channel.listen("onDidChangeLastSyncTime")(C=>this.updateLastSyncTime(C)))}),this._register(this.channel.listen("onDidChangeConflicts")(m=>this.updateConflicts(m))),this._register(this.channel.listen("onSyncErrors")(m=>this._onSyncErrors.fire(m.map(([g,u])=>[g,I.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:y,manifest:m,status:g}=await this.channel.call("createManualSyncTask"),u=this,C=new v(y,m,g,{async call(P,b,R){return u.channel.call(`manualSync/${P}`,[y,...(0,A.isArray)(b)?b:[b]],R)},listen(P,b){return w.Event.map(w.Event.filter(u.channel.listen(`manualSync/${P}`,b),R=>!C.isDiposed()&&R.manualSyncTaskId===y),R=>R.data)}});return C}replace(y){return this.channel.call("replace",[y])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(y,m,g,u){return this.channel.call("accept",[y,m,g,u])}resolveContent(y){return this.channel.call("resolveContent",[y])}async getLocalSyncResourceHandles(y){return(await this.channel.call("getLocalSyncResourceHandles",[y])).map(({created:g,uri:u})=>({created:g,uri:L.URI.revive(u)}))}async getRemoteSyncResourceHandles(y){return(await this.channel.call("getRemoteSyncResourceHandles",[y])).map(({created:g,uri:u})=>({created:g,uri:L.URI.revive(u)}))}async getAssociatedResources(y,m){return(await this.channel.call("getAssociatedResources",[y,m])).map(({resource:u,comparableResource:C})=>({resource:L.URI.revive(u),comparableResource:L.URI.revive(C)}))}async getMachineId(y,m){return this.channel.call("getMachineId",[y,m])}async updateStatus(y){this._status=y,this._onDidChangeStatus.fire(y)}async updateConflicts(y){this._conflicts=y.map(([m,g])=>[m,g.map(u=>({...u,localResource:L.URI.revive(u.localResource),remoteResource:L.URI.revive(u.remoteResource),previewResource:L.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(y){this._lastSyncTime!==y&&(this._lastSyncTime=y,this._onDidChangeLastSyncTime.fire(y))}}e.UserDataSyncChannelClient=E;class v extends k.Disposable{constructor(y,m,g,u){super();this.id=y,this.manifest=m,this._disposed=!1,this._status=g;const C=this;this.channel={async call(P,b,R){try{const p=await u.call(P,b,R);return C.isDiposed()||(C._status=await u.call("_getStatus")),p}catch(p){throw I.UserDataSyncError.toUserDataSyncError(p)}},listen(P,b){return u.listen(P,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const y=await this.channel.call("preview");return this.deserializePreviews(y)}async accept(y,m){const g=await this.channel.call("accept",[y,m]);return this.deserializePreviews(g)}async merge(y){const m=await this.channel.call("merge",[y]);return this.deserializePreviews(m)}async discard(y){const m=await this.channel.call("discard",[y]);return this.deserializePreviews(m)}async discardConflicts(){const y=await this.channel.call("discardConflicts");return this.deserializePreviews(y)}async apply(){const y=await this.channel.call("apply");return this.deserializePreviews(y)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(y){return y.map(([m,g])=>[m,{isLastSyncFromCurrentMachine:g.isLastSyncFromCurrentMachine,resourcePreviews:g.resourcePreviews.map(u=>({...u,localResource:L.URI.revive(u.localResource),remoteResource:L.URI.revive(u.remoteResource),previewResource:L.URI.revive(u.previewResource),acceptedResource:L.URI.revive(u.acceptedResource)}))}])}}}),define(Z[212],ee([0,1,2,22,41,15,29,24,28,45,12,13,20,30,4,3,6,16,5,11,95]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P,b,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",s=100,h=1e3*60*5;let c=class extends w.Disposable{constructor(O,_,z){super();this.productService=O,this.configurationService=_,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new C.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(C.Event.filter(z.onDidChangeValue,H=>H.key===I.SYNC_SERVICE_URL_TYPE&&H.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(I.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(I.SYNC_SERVICE_URL_TYPE,O,0,u.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[I.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(I.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,_){O=u.isWeb&&O?.web?{...O,...O.web}:O;const z={...O||{},..._||{}};if(z&&(0,b.isString)(z.url)&&(0,b.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(H=>(0,b.isArray)(z.authenticationProviders[H].scopes))){const H=z,V=!!H.canSwitch&&!_?.url,U=H.url===H.insidersUrl?"insiders":"stable",x=(V?this.userDataSyncStoreType:void 0)||U,M=_?.url||(x==="insiders"?H.insidersUrl:x==="stable"?H.stableUrl:H.url);return{url:R.URI.parse(M),type:x,defaultType:U,defaultUrl:R.URI.parse(H.url),stableUrl:R.URI.parse(H.stableUrl),insidersUrl:R.URI.parse(H.insidersUrl),canSwitch:V,authenticationProviders:Object.keys(H.authenticationProviders).reduce(($,q)=>($.push({id:q,scopes:H.authenticationProviders[q].scopes}),$),[])}}}};c=de([Y(0,E.IProductService),Y(1,D.IConfigurationService),Y(2,m.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let l=class extends c{constructor(O,_,z){super(O,_,z);const H=this.storageService.get(a,0);H&&(this.previousConfigurationSyncStore=JSON.parse(H));const V=this.productService[I.CONFIGURATION_SYNC_STORE_KEY];V?this.storageService.store(a,JSON.stringify(V),0,1):this.storageService.remove(a,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=de([Y(0,E.IProductService),Y(1,D.IConfigurationService),Y(2,m.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let f=class extends w.Disposable{constructor(O,_,z,H,V,U,x){super();this.requestService=z,this.logService=H,this.storageService=x,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new C.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new C.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,v.getServiceMachineId)(V,U,x).then(M=>{const $={"X-Client-Name":`${_.applicationName}${u.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":M};return _.commit&&($["X-Client-Commit"]=_.commit),$}),this.session=new d(s,h,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,w.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,_){this.authToken={token:O,type:_}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,k.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,P.createCancelablePromise)(_=>(0,P.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),_).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,_=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O),z={},H=await this.request(_.toString(),{type:"GET",headers:z},[],A.CancellationToken.None);return(await(0,L.asJson)(H)||[]).map(({url:U,created:x})=>({ref:(0,k.relativePath)(_,_.with({path:U})),created:x*1e3}))}async resolveContent(O,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,_).toString(),H={};H["Cache-Control"]="no-cache";const V=await this.request(z,{type:"GET",headers:H},[],A.CancellationToken.None);return await(0,L.asText)(V)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),z={};await this.request(_,{type:"DELETE",headers:z},[],A.CancellationToken.None)}async read(O,_,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();z={...z},z["Cache-Control"]="no-cache",_&&(z["If-None-Match"]=_.ref);const V=await this.request(H,{type:"GET",headers:z},[304],A.CancellationToken.None);let U=null;if(V.res.statusCode===304&&(U=_),U===null){const x=V.res.headers.etag;if(!x)throw new I.UserDataSyncStoreError("Server did not return the ref",H,"NoRef",V.res.statusCode,V.res.headers[I.HEADER_OPERATION_ID]);const M=await(0,L.asText)(V);if(!M&&V.res.statusCode===304)throw new I.UserDataSyncStoreError("Empty response",H,"EmptyResponse",V.res.statusCode,V.res.headers[I.HEADER_OPERATION_ID]);U={ref:x,content:M}}return U}async write(O,_,z,H={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();H={...H},H["Content-Type"]=o.Mimes.text,z&&(H["If-Match"]=z);const U=await this.request(V,{type:"POST",data:_,headers:H},[],A.CancellationToken.None),x=U.res.headers.etag;if(!x)throw new I.UserDataSyncStoreError("Server did not return the ref",V,"NoRef",U.res.statusCode,U.res.headers[I.HEADER_OPERATION_ID]);return x}async manifest(O,_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,k.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();_={..._},_["Content-Type"]="application/json",O&&(_["If-None-Match"]=O.ref);const H=await this.request(z,{type:"GET",headers:_},[304],A.CancellationToken.None);let V=null;if(H.res.statusCode===304&&(V=O),!V){const x=H.res.headers.etag;if(!x)throw new I.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",H.res.statusCode,H.res.headers[I.HEADER_OPERATION_ID]);const M=await(0,L.asText)(H);if(!M&&H.res.statusCode===304)throw new I.UserDataSyncStoreError("Empty response",z,"EmptyResponse",H.res.statusCode,H.res.headers[I.HEADER_OPERATION_ID]);M&&(V={...JSON.parse(M),ref:x})}const U=this.storageService.get(r,0);return U&&V&&U!==V.session&&this.clearSession(),V===null&&U&&this.clearSession(),V&&this.storageService.store(r,V.session,0,1),V}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":o.Mimes.text};await this.request(O,{type:"DELETE",headers:_},[],A.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(O,_,z,H){if(!this.authToken)throw new I.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new I.UserDataSyncStoreError(`${_.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const V=await this.commonHeadersPromise;_.headers={..._.headers||{},...V,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:O,type:_.type,headers:{..._.headers,authorization:void 0}});let U;try{U=await this.session.request(O,_,H)}catch(q){if(!(q instanceof I.UserDataSyncStoreError)){let F="RequestFailed";const W=(0,p.getErrorMessage)(q).toLowerCase();W.includes("xhr timeout")?F="RequestTimeout":W.includes("protocol")&&W.includes("not supported")?F="RequestProtocolNotSupported":W.includes("request path contains unescaped characters")?F="RequestPathNotEscaped":W.includes("headers must be an object")?F="RequestHeadersNotObject":(0,p.isPromiseCanceledError)(q)&&(F="RequestCanceled"),q=new I.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,F,void 0,void 0)}throw this.logService.info("Request failed",O),q}const x=U.res.headers[I.HEADER_OPERATION_ID],M={url:O,status:U.res.statusCode,"execution-id":_.headers[I.HEADER_EXECUTION_ID],"operation-id":x},$=(0,L.isSuccess)(U)||U.res.statusCode&&z.indexOf(U.res.statusCode)!==-1;if($?this.logService.trace("Request succeeded",M):this.logService.info("Request failed",M),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new I.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",U.res.statusCode,x);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new I.UserDataSyncStoreError(`${_.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",U.res.statusCode,x);if(U.res.statusCode===410)throw new I.UserDataSyncStoreError(`${_.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",U.res.statusCode,x);if(U.res.statusCode===412)throw new I.UserDataSyncStoreError(`${_.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",U.res.statusCode,x);if(U.res.statusCode===413)throw new I.UserDataSyncStoreError(`${_.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",U.res.statusCode,x);if(U.res.statusCode===426)throw new I.UserDataSyncStoreError(`${_.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",U.res.statusCode,x);if(U.res.statusCode===429){const q=U.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new I.UserDataSyncStoreError(`${_.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",U.res.statusCode,x)):new I.UserDataSyncStoreError(`${_.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",U.res.statusCode,x)}if(!$)throw new I.UserDataSyncStoreError("Server returned "+U.res.statusCode,O,"Unknown",U.res.statusCode,x);return U}addSessionHeaders(O){let _=this.storageService.get(i,0);_===void 0&&(_=(0,g.generateUuid)(),this.storageService.store(i,_,0,1)),O["X-Machine-Session-Id"]=_;const z=this.storageService.get(r,0);z!==void 0&&(O["X-User-Session-Id"]=z)}};f=de([Y(1,E.IProductService),Y(2,L.IRequestService),Y(3,I.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,y.IFileService),Y(6,m.IStorageService)],f),e.UserDataSyncStoreClient=f;let S=class extends f{constructor(O,_,z,H,V,U,x){super(O.userDataSyncStore?.url,_,z,H,V,U,x);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};S=de([Y(0,I.IUserDataSyncStoreManagementService),Y(1,E.IProductService),Y(2,L.IRequestService),Y(3,I.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,y.IFileService),Y(6,m.IStorageService)],S),e.UserDataSyncStoreService=S;class d{constructor(O,_,z,H){this.limit=O,this.interval=_,this.requestService=z,this.logService=H,this.requests=[],this.startTime=void 0}request(O,_,z){if(this.isExpired()&&this.reset(),_.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new I.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(_,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=d}),define(Z[213],ee([0,1,22,3,59,89,60,21,20,61,28]),function(K,e,w,I,L,k,A,D,E,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let y=class extends k.UserDataAutoSyncService{constructor(g,u,C,P,b,R,p,o,a,t,r,i){super(g,u,C,P,b,p,o,a,t,r,i);this._register(I.Event.debounce(I.Event.any(I.Event.map(R.onDidFocusWindow,()=>"windowFocus"),I.Event.map(R.onDidOpenWindow,()=>"windowOpen")),(s,h)=>s?[...s,h]:[h],1e3)(s=>this.triggerSync(s,!0,!1)))}};y=de([Y(0,n.IProductService),Y(1,w.IUserDataSyncStoreManagementService),Y(2,w.IUserDataSyncStoreService),Y(3,w.IUserDataSyncResourceEnablementService),Y(4,w.IUserDataSyncService),Y(5,L.INativeHostService),Y(6,w.IUserDataSyncLogService),Y(7,A.IUserDataSyncAccountService),Y(8,D.ITelemetryService),Y(9,v.IUserDataSyncMachinesService),Y(10,E.IStorageService),Y(11,w.IUserDataAutoSyncEnablementService)],y),e.UserDataAutoSyncService=y}),define(Z[214],ee([0,1,3,2,6]),function(K,e,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends I.Disposable{constructor({onDidOpenWindow:D,onDidFocusWindow:E,getActiveWindowId:v}){super();this.disposables=this._register(new I.DisposableStore),w.Event.latch(w.Event.any(D,E))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>v()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch(y){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(D){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=D}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(Z[62],ee([0,1,110,8,50,6,18,222,223,16]),function(K,e,w,I,L,k,A,D,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function y(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function m(a){if(a instanceof n)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new n(t,a)}function g(a,t,r,i,s,h){const c=I.dirname(t),l=I.join(i,c);if(!l.startsWith(i))return Promise.reject(new Error(w.localize(0,null,t)));const f=I.join(i,t);let S;return h.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(A.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((d,T)=>{if(!h.isCancellationRequested)try{S=(0,L.createWriteStream)(f,{mode:r}),S.once("close",()=>d()),S.once("error",T),a.once("error",T),a.pipe(S)}catch(O){T(O)}}))}function u(a,t,r,i){let s=(0,k.createCancelablePromise)(()=>Promise.resolve()),h=0;return i.onCancellationRequested(()=>{s.cancel(),a.close()}),new Promise((c,l)=>{const f=new k.Sequencer,S=d=>{d.isCancellationRequested||(h++,a.readEntry())};a.once("error",l),a.once("close",()=>s.then(()=>{i.isCancellationRequested||a.entryCount===h?c():l(new n("Incomplete",new Error(w.localize(1,null,h,a.entryCount))))},l)),a.readEntry(),a.on("entry",d=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(d.fileName)){S(i);return}const T=d.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(T)){const z=I.join(t,T);s=(0,k.createCancelablePromise)(H=>A.Promises.mkdir(z,{recursive:!0}).then(()=>S(H)).then(void 0,l));return}const O=P(a,d),_=y(d);s=(0,k.createCancelablePromise)(z=>f.queue(()=>O.then(H=>g(H,T,_,t,r,z).then(()=>S(z)))).then(null,l))})})}function C(a,t=!1){return new Promise((r,i)=>{(0,D.open)(a,t?{lazyEntries:!0}:void 0,(s,h)=>{s?i(m(s)):r((0,v.assertIsDefined)(h))})})}function P(a,t){return new Promise((r,i)=>{a.openReadStream(t,(s,h)=>{s?i(m(s)):r((0,v.assertIsDefined)(h))})})}function b(a,t){return new Promise((r,i)=>{const s=new E.ZipFile;t.forEach(c=>{c.contents?s.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&s.addFile(c.localPath,c.path)}),s.end();const h=(0,L.createWriteStream)(a);s.outputStream.pipe(h),s.outputStream.once("error",i),h.once("error",i),h.once("finish",()=>r(a))})}e.zip=b;function R(a,t,r={},i){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let h=C(a,!0);return r.overwrite&&(h=h.then(c=>A.Promises.rm(t).then(()=>c))),h.then(c=>u(c,t,{sourcePathRegex:s},i))}e.extract=R;function p(a,t){return C(a).then(r=>new Promise((i,s)=>{r.on("entry",h=>{h.fileName===t&&P(r,h).then(c=>i(c),c=>s(c))}),r.once("close",()=>s(new Error(w.localize(2,null,t))))}))}function o(a,t){return p(a,t).then(r=>new Promise((i,s)=>{const h=[];r.once("error",s),r.on("data",c=>h.push(c)),r.on("end",()=>i(Buffer.concat(h)))}))}e.buffer=o}),define(Z[215],ee([0,1,62,118]),function(K,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(k){return(0,w.buffer)(k,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(D){throw new Error((0,I.localize)(0,null))}})}e.getManifest=L}),define(Z[216],ee([0,1,58,2,18,8,14,27,31,6,5,12,141,119,28,62,4,23,17,13,15,30,11]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P,b,R,p,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",s="extracting",h="deleting",c="renaming";let l=class extends I.Disposable{constructor(S,d,T,O,_){super();this.beforeRemovingExtension=S,this.fileService=d,this.logService=T,this.environmentService=O,this.productService=_,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new v.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(S){const d=[];(S===null||S===0)&&d.push(this.scanSystemExtensions().then(null,T=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(T).message,r)))),(S===null||S===1)&&d.push(this.scanUserExtensions(!0).then(null,T=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(T).message,i))));try{const T=await Promise.all(d);return(0,b.flatten)(T)}catch(T){throw this.joinErrors(T)}}async scanUserExtensions(S){this.logService.trace("Started scanning user extensions");let[d,T]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return T=T.filter(O=>!d[new E.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),S&&(T=(0,E.groupByExtension)(T,_=>_.identifier).map(_=>_.sort((z,H)=>w.rcompare(z.manifest.version,H.manifest.version))[0])),this.logService.trace("Scanned user extensions:",T.length),T}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(S,d,T){const O=S.key(),_=k.join(this.extensionsPath,`.${(0,a.generateUuid)()}`),z=k.join(this.extensionsPath,O);try{await L.Promises.rm(z)}catch(V){try{await L.Promises.rm(z)}catch(U){}throw new D.ExtensionManagementError((0,g.localize)(0,null,z,S.id),h)}await this.extractAtLocation(S,d,_,T);let H=await this.scanExtension(n.URI.file(_),1);if(!H)throw new Error((0,g.localize)(1,null,_));await this.storeMetadata(H,{installedTimestamp:Date.now()});try{await this.rename(S,_,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(V){try{await L.Promises.rm(_)}catch(U){}if(V.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",S.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(V)}. Deleted from extracted location`,_),V}try{H=await this.scanExtension(n.URI.file(z),1)}catch(V){}if(H)return H;throw new Error((0,g.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(S,d){return this.setMetadata(S,d),await this.storeMetadata(S,{...d,installedTimestamp:S.installedTimestamp}),S}async storeMetadata(S,d){d.isMachineScoped=d.isMachineScoped||void 0,d.isBuiltin=d.isBuiltin||void 0,d.installedTimestamp=d.installedTimestamp||void 0;const T=k.join(S.location.fsPath,"package.json"),O=await L.Promises.readFile(T,"utf8"),{manifest:_}=await this.parseManifest(O);return _.__metadata=d,await L.Promises.writeFile(T,JSON.stringify(_,null,"	")),S}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...S){const d=S.map(T=>new E.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version));await this.withUninstalledExtensions(T=>{d.forEach(O=>T[O.key()]=!0)})}async setInstalled(S){await this.withUninstalledExtensions(O=>delete O[S.key()]);const T=(await this.scanExtensions(1)).find(O=>new E.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(S))||null;return T?(await this.storeMetadata(T,{installedTimestamp:Date.now()}),this.scanExtension(T.location,1)):null}async withUninstalledExtensions(S){return this.uninstalledFileLimiter.queue(async()=>{let d;try{d=await L.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let T={};if(d)try{T=JSON.parse(d)}catch(O){}return S&&(S(T),Object.keys(T).length?await L.Promises.writeFile(this.uninstalledPath,JSON.stringify(T)):await L.Promises.rm(this.uninstalledPath)),T})}async removeExtension(S,d){this.logService.trace(`Deleting ${d} extension from disk`,S.identifier.id,S.location.fsPath),await L.Promises.rm(S.location.fsPath),this.logService.info("Deleted from disk",S.identifier.id,S.location.fsPath)}async removeUninstalledExtension(S){await this.removeExtension(S,"uninstalled"),await this.withUninstalledExtensions(d=>delete d[new E.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()])}async extractAtLocation(S,d,T,O){this.logService.trace(`Started extracting the extension from ${d} to ${T}`);try{await L.Promises.rm(T)}catch(_){throw new D.ExtensionManagementError(this.joinErrors(_).message,h)}try{await(0,C.extract)(d,T,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${T}:`,S.id)}catch(_){try{await L.Promises.rm(T)}catch(z){}throw new D.ExtensionManagementError(_.message,_ instanceof C.ExtractError&&_.type?_.type:s)}}async rename(S,d,T,O){try{await L.Promises.rename(d,T)}catch(_){if(P.isWindows&&_&&_.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${d} to ${T} with 'EPERM' error. Trying again...`,S.id),this.rename(S,d,T,O);throw new D.ExtensionManagementError(_.message||(0,g.localize)(3,null,d,T),_.code||c)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const S=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return S;const d=this.scanDevSystemExtensions(),[T,O]=await Promise.all([S,d]);return[...T,...O]}async scanExtensionsInDir(S,d){const T=new v.Limiter(10),O=await this.fileService.resolve(n.URI.file(S));return O.children?(await Promise.all(O.children.filter(z=>z.isDirectory).map(z=>T.queue(async()=>d===1&&(0,o.basename)(z.resource).indexOf(".")===0?null:this.scanExtension(z.resource,d))))).filter(z=>z&&z.identifier):[]}async scanExtension(S,d){try{const T=await this.fileService.resolve(S);if(T.children){const{manifest:O,metadata:_}=await this.readManifest(S.fsPath),z=T.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,H=T.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource,V={id:(0,E.getGalleryExtensionId)(O.publisher,O.name)},U={type:d,identifier:V,manifest:O,location:S,readmeUrl:z,changelogUrl:H,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:d===0};return _&&(this.setMetadata(U,_),U.installedTimestamp=_.installedTimestamp),U}}catch(T){d!==0&&this.logService.trace(T)}return null}async scanDefaultSystemExtensions(){const S=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",S.length),S}async scanDevSystemExtensions(){const S=this.getDevSystemExtensionsList();if(S.length){const d=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",d.length),d.filter(T=>S.some(O=>(0,E.areSameExtensions)(T.identifier,{id:O})))}else return[]}setMetadata(S,d){S.publisherDisplayName=d.publisherDisplayName||null,S.publisherId=d.publisherId||null,S.identifier.uuid=d.id,S.isMachineScoped=!!d.isMachineScoped,S.isBuiltin=S.type===0||!!d.isBuiltin}async removeUninstalledExtensions(){const S=await this.getUninstalledExtensions(),d=await this.scanAllUserExtensions(),T=new Set;for(const z of d)S[new E.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]||T.add(z.identifier.id.toLowerCase());const O=(0,E.groupByExtension)(d,z=>z.identifier);await v.Promises.settled(O.map(async z=>{const H=z.sort((V,U)=>w.rcompare(V.manifest.version,U.manifest.version))[0];T.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(H)}));const _=d.filter(z=>S[new E.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]);await v.Promises.settled(_.map(z=>this.removeUninstalledExtension(z)))}async removeOutdatedExtensions(){const S=await this.scanAllUserExtensions(),d=[],T=(0,E.groupByExtension)(S,O=>O.identifier);d.push(...(0,b.flatten)(T.map(O=>O.sort((_,z)=>w.rcompare(_.manifest.version,z.manifest.version)).slice(1)))),await v.Promises.settled(d.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(S=>S.name)}joinErrors(S){const d=Array.isArray(S)?S:[S];return d.length===1?d[0]instanceof Error?d[0]:new Error(d[0]):d.reduce((T,O)=>new Error(`${T.message}${T.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(R.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(S){const d=[L.Promises.readFile(k.join(S,"package.json"),"utf8").then(z=>this.parseManifest(z)),L.Promises.readFile(k.join(S,"package.nls.json"),"utf8").then(void 0,z=>z.code!=="ENOENT"?Promise.reject(z):"{}").then(z=>JSON.parse(z))],[{manifest:T,metadata:O},_]=await Promise.all(d);return{manifest:(0,m.localizeManifest)(T,_),metadata:O}}parseManifest(S){return new Promise((d,T)=>{try{const O=JSON.parse(S),_=O.__metadata||null;d({manifest:O,metadata:_})}catch(O){T(new Error((0,g.localize)(4,null)))}})}};l=de([Y(1,p.IFileService),Y(2,A.ILogService),Y(3,y.INativeEnvironmentService),Y(4,u.IProductService)],l),e.ExtensionsScanner=l}),define(Z[217],ee([0,1,117,8,18,62,27,31,12,58,5,44,4,14,152,37,21,72,15,30,74,7,17,215,164,216,165,166,13,183]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P,b,R,p,o,a,t,r,i,s,h,c,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const S="unsetUninstalled",d="downloading";let T=class extends f.AbstractExtensionManagementService{constructor(U,x,M,$,q,F,W){super(U,x,M);this.environmentService=$,this.downloadService=q;const N=this._register(F.createInstance(h.ExtensionsLifecycle));this.extensionsScanner=this._register(F.createInstance(s.ExtensionsScanner,B=>N.postUninstall(B))),this.manifestCache=this._register(new u.ExtensionsManifestCache($,this)),this.extensionsDownloader=this._register(F.createInstance(i.ExtensionsDownloader));const G=this._register(new c.ExtensionsWatcher(this,W,$,M));this._register(G.onDidChangeExtensionsByAnotherSource(({added:B,removed:J})=>{B.length&&this._onDidInstallExtensions.fire(B.map(Q=>({identifier:Q.identifier,operation:0,local:Q}))),J.forEach(Q=>this._onDidUninstallExtension.fire({identifier:Q}))}))}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const x=await this.collectFiles(U),M=await(0,k.zip)((0,R.joinPath)(this.environmentService.tmpDir,(0,p.generateUuid)()).fsPath,x);return n.URI.file(M)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const x=await this.downloadVsix(U),M=I.resolve(x.fsPath);return(0,r.getManifest)(M)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async canInstall(U){return!0}async install(U,x={}){this.logService.trace("ExtensionManagementService#install",U.toString());const M=await this.downloadVsix(U),$=await(0,r.getManifest)(I.resolve(M.fsPath));if($.engines&&$.engines.vscode&&!(0,b.isEngineValid)($.engines.vscode,y.default.version,y.default.date))throw new Error(w.localize(0,null,(0,D.getGalleryExtensionId)($.publisher,$.name),y.default.version));return this.installExtension($,M,x)}async updateMetadata(U,x){return this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...x}),this.manifestCache.invalidate(),U}async updateExtensionScope(U,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:x}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===t.Schemas.file)return U;if(!this.downloadService)throw new Error("Download service is not available");const x=(0,R.joinPath)(this.environmentService.tmpDir,(0,p.generateUuid)());return await this.downloadService.download(U,x),x}createInstallExtensionTask(U,x,M){return n.URI.isUri(x)?new z(U,x,M,this.galleryService,this.extensionsScanner,this.logService):new _(x,M,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,x){return new H(U,x,this.extensionsScanner)}async collectFiles(U){const x=async $=>{let q=await L.Promises.readdir($);q=q.map(N=>I.join($,N));const F=await Promise.all(q.map(N=>L.Promises.stat(N)));let W=Promise.resolve([]);return F.forEach((N,G)=>{const B=q[G];N.isFile()&&(W=W.then(J=>[...J,B])),N.isDirectory()&&(W=W.then(J=>x(B).then(Q=>[...J,...Q])))}),W};return(await x(U.location.fsPath)).map($=>({path:`extension/${I.relative(U.location.fsPath,$)}`,localPath:$}))}};T=de([Y(0,A.IExtensionGalleryService),Y(1,P.ITelemetryService),Y(2,g.ILogService),Y(3,E.INativeEnvironmentService),Y(4,(0,a.optional)(o.IDownloadService)),Y(5,a.IInstantiationService),Y(6,l.IFileService)],T),e.ExtensionManagementService=T;class O extends f.AbstractExtensionTask{constructor(U,x,M,$){super();this.identifier=U,this.source=x,this.extensionsScanner=M,this.logService=$,this._operation=1}get operation(){return this._operation}async installExtension(U,x){try{const M=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(M)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(M,U.metadata):M}catch(M){throw m.isMacintosh?new A.ExtensionManagementError(w.localize(1,null),S):new A.ExtensionManagementError(w.localize(2,null),S)}return this.extract(U,x)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const M=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),M}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:x,metadata:M},$){let q=await this.extensionsScanner.extractUserExtension(x,U,$);return this.logService.info("Extracting completed.",x.id),M&&(q=await this.extensionsScanner.saveMetadataForLocalExtension(q,M)),q}}class _ extends O{constructor(U,x,M,$,q){super(U.identifier,U,$,q);this.gallery=U,this.options=x,this.extensionsDownloader=M}async doRun(U){const M=(await this.extensionsScanner.scanExtensions(null)).find(F=>(0,D.areSameExtensions)(F.identifier,this.gallery.identifier));M&&(this._operation=2);const $=await this.downloadInstallableExtension(this.gallery,this._operation);$.metadata.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,$.metadata.isBuiltin=this.options.isBuiltin||M?.isBuiltin;const q=await this.installExtension($,U);M&&v.neq(M.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(M);try{await this.extensionsDownloader.delete(n.URI.file($.zipPath))}catch(F){}return q}async downloadInstallableExtension(U,x){const M={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let $;try{this.logService.trace("Started downloading extension:",U.identifier.id),$=(await this.extensionsDownloader.downloadExtension(U,x)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,$)}catch(q){throw new A.ExtensionManagementError((0,f.joinErrors)(q).message,d)}try{const q=await(0,r.getManifest)($);return{zipPath:$,identifierWithVersion:new D.ExtensionIdentifierWithVersion(U.identifier,q.version),metadata:M}}catch(q){throw new A.ExtensionManagementError((0,f.joinErrors)(q).message,f.INSTALL_ERROR_VALIDATING)}}}class z extends O{constructor(U,x,M,$,q,F){super({id:(0,D.getGalleryExtensionId)(U.publisher,U.name)},x,q,F);this.manifest=U,this.location=x,this.options=M,this.galleryService=$}async doRun(U){const x=new D.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),$=(await this.extensionsScanner.scanExtensions(1)).find(F=>(0,D.areSameExtensions)(this.identifier,F.identifier)),q=await this.getMetadata(this.identifier.id,U);if($)if(q.isMachineScoped=this.options.isMachineScoped||$.isMachineScoped,q.isBuiltin=this.options.isBuiltin||$.isBuiltin,this._operation=2,x.equals(new D.ExtensionIdentifierWithVersion($.identifier,$.manifest.version)))try{await this.extensionsScanner.removeExtension($,"existing")}catch(F){throw new Error(w.localize(3,null,this.manifest.displayName||this.manifest.name))}else v.gt($.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled($);else{const F=await this.unsetUninstalledAndGetLocal(x);if(F)try{await this.extensionsScanner.removeExtension(F,"existing")}catch(W){throw new Error(w.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:I.resolve(this.location.fsPath),identifierWithVersion:x,metadata:q},U)}async getMetadata(U,x){try{const M=(await this.galleryService.query({names:[U],pageSize:1},x)).firstPage[0];if(M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId}}catch(M){}return{}}}class H extends f.AbstractExtensionTask{constructor(U,x,M){super();this.extension=U,this.options=x,this.extensionsScanner=M}async doRun(U){const x=[],M=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const $=new D.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);x.push(...M.filter(q=>$.equals(new D.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version))))}else x.push(...M.filter($=>(0,D.areSameExtensions)($.identifier,this.extension.identifier)));if(!x.length)throw new Error(w.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const $ of x)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension($)}catch(q){throw new Error(w.localize(6,null,(0,C.toErrorMessage)(q)))}}}}),define(Z[224],ee([0,1,50,34,225,104,44,103,36,78,52,158,12,138,140,27,217,184,24,174,41,175,21,53,181,82,83,186,14,79,167,57,2,176,74,171,172,163,162,160,159,182,73,168,13,170,17,28,22,210,212,207,59,208,213,180,20,178,209,60,206,185,61,75,142,214,84,89,88,87,7,161,151,11,37,85,195,189,211,149,153,187,5,15]),function(K,e,w,I,L,k,A,D,E,v,n,y,m,g,u,C,P,b,R,p,o,a,t,r,i,s,h,c,l,f,S,d,T,O,_,z,H,V,U,x,M,$,q,F,W,N,G,B,J,Q,ie,ne,le,fe,me,Se,Pe,ke,Ne,Oe,Le,_e,be,Ae,Ye,Je,xe,qe,X,re,se,ye,pe,De,we,Te,Ce,Re,Ue,j,te,ae,ce,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class he extends T.Disposable{constructor(ue){super();this.configuration=ue,this.server=this._register(new D.Server),(0,L.gracefulify)(w),this.registerListeners()}registerListeners(){const ue=()=>this.dispose();process.once("exit",ue),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ue)}async open(){const ue=await this.initServices();(0,J.registerConfiguration)(),ue.invokeFunction(Ee=>{const Ie=Ee.get(l.ILogService);Ie.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ee),this.registerErrorHandler(Ie)}),this._register((0,T.combinedDisposable)(ue.createInstance(z.CodeCacheCleaner,this.configuration.codeCachePath),ue.createInstance(H.LanguagePackCachedDataCleaner),ue.createInstance(V.StorageDataCleaner,this.configuration.backupWorkspacesPath),ue.createInstance(U.LogsDataCleaner),ue.createInstance(ye.LocalizationsUpdater),ue.createInstance(pe.DeprecatedExtensionsCleaner)))}async initServices(){const ue=new v.ServiceCollection,Ee={_serviceBrand:void 0,...A.default};ue.set(B.IProductService,Ee);const Ie=new E.StaticRouter(We=>We==="main"),Fe=new M.MessagePortMainProcessService(this.server,Ie);ue.set(x.IMainProcessService,Fe);const Me=new g.NativeEnvironmentService(this.configuration.args,Ee);ue.set(m.INativeEnvironmentService,Me);const et=new f.LogLevelChannelClient(this.server.getChannel("logLevel",Ie)),Be=new f.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Fe.getChannel("logger"));ue.set(l.ILoggerService,Be);const nt=this._register(new l.MultiplexLogService([this._register(new l.ConsoleLogger(this.configuration.logLevel)),this._register(Be.createLogger((0,oe.joinPath)(ce.URI.file(Me.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new f.FollowerLogService(et,nt));ue.set(l.ILogService,Ve);const He=this._register(new F.FileService(Ve));ue.set(W.IFileService,He);const it=this._register(new N.DiskFileSystemProvider(Ve));He.registerProvider(G.Schemas.file,it);const je=this._register(new p.ConfigurationService(Me.settingsResource,He));ue.set(R.IConfigurationService,je),await je.initialize();const Xe=new Se.NativeStorageService(void 0,Fe,Me);ue.set(Pe.IStorageService,Xe),await Xe.initialize(),this._register((0,T.toDisposable)(()=>Xe.flush())),ue.set(o.IRequestService,new n.SyncDescriptor(a.RequestService)),ue.set(j.IChecksumService,new n.SyncDescriptor(te.ChecksumService));const tt=E.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});ue.set(le.INativeHostService,tt),ue.set(_.IDownloadService,new n.SyncDescriptor(O.DownloadService));const rt=this._register(new Je.ActiveWindowManager(tt)),ht=new E.StaticRouter(We=>rt.getActiveClientId().then(st=>We===st));ue.set(Ae.IExtensionRecommendationNotificationService,new Ye.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let Qe,Ge;if(!Me.isExtensionDevelopment&&!Me.disableTelemetry&&Ee.enableTelemetry){Ge=new xe.TelemetryLogAppender(Be,Me);const{appRoot:We,extensionsPath:st,isBuilt:dt,installSourcePath:gt}=Me;if(Ee.aiConfig&&Ee.aiConfig.asimovKey&&dt){const ct=new c.AppInsightsAppender("monacoworkbench",null,Ee.aiConfig.asimovKey);this._register((0,T.toDisposable)(()=>ct.flush())),Ge=(0,r.combinedAppender)(ct,Ge)}Qe=new h.TelemetryService({appender:Ge,commonProperties:(0,i.resolveCommonProperties)(He,(0,I.release)(),(0,I.hostname)(),process.arch,Ee.commit,Ee.version,this.configuration.machineId,Ee.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[We,st]},je)}else Qe=r.NullTelemetryService,Ge=r.NullAppender;this.server.registerChannel("telemetryAppender",new s.TelemetryAppenderChannel(Ge)),ue.set(t.ITelemetryService,Qe);const ft=new ae.CustomEndpointTelemetryService(je,Qe,Be,Me);return ue.set(t.ICustomEndpointTelemetryService,ft),ue.set(C.IExtensionManagementService,new n.SyncDescriptor(P.ExtensionManagementService)),ue.set(C.IExtensionGalleryService,new n.SyncDescriptor(b.ExtensionGalleryService)),ue.set(C.IExtensionTipsService,new n.SyncDescriptor(_e.ExtensionTipsService)),ue.set(d.ILocalizationsService,new n.SyncDescriptor(S.LocalizationsService)),ue.set(q.IDiagnosticsService,new n.SyncDescriptor($.DiagnosticsService)),ue.set(Oe.IUserDataSyncAccountService,new n.SyncDescriptor(Oe.UserDataSyncAccountService)),ue.set(J.IUserDataSyncLogService,new n.SyncDescriptor(fe.UserDataSyncLogService)),ue.set(J.IUserDataSyncUtilService,new ne.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),ue.set(C.IGlobalExtensionEnablementService,new n.SyncDescriptor(ke.GlobalExtensionEnablementService)),ue.set(X.IIgnoredExtensionsManagementService,new n.SyncDescriptor(X.IgnoredExtensionsManagementService)),ue.set(re.IExtensionsStorageSyncService,new n.SyncDescriptor(re.ExtensionsStorageSyncService)),ue.set(J.IUserDataSyncStoreManagementService,new n.SyncDescriptor(ie.UserDataSyncStoreManagementService)),ue.set(J.IUserDataSyncStoreService,new n.SyncDescriptor(ie.UserDataSyncStoreService)),ue.set(be.IUserDataSyncMachinesService,new n.SyncDescriptor(be.UserDataSyncMachinesService)),ue.set(J.IUserDataSyncBackupStoreService,new n.SyncDescriptor(Le.UserDataSyncBackupStoreService)),ue.set(J.IUserDataAutoSyncEnablementService,new n.SyncDescriptor(qe.UserDataAutoSyncEnablementService)),ue.set(J.IUserDataSyncResourceEnablementService,new n.SyncDescriptor(Ne.UserDataSyncResourceEnablementService)),ue.set(J.IUserDataSyncService,new n.SyncDescriptor(Q.UserDataSyncService)),ue.set(Re.ILocalPtyService,this._register(new Ce.PtyHostService({GraceTime:6e4,ShortGraceTime:6e3},je,Ve,Qe))),new y.InstantiationService(ue)}initChannels(ue){const Ee=new u.ExtensionManagementChannel(ue.get(C.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ee);const Ie=E.ProxyChannel.fromService(ue.get(d.ILocalizationsService));this.server.registerChannel("localizations",Ie);const Fe=E.ProxyChannel.fromService(ue.get(q.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Me=new u.ExtensionTipsChannel(ue.get(C.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Me);const et=E.ProxyChannel.fromService(ue.get(j.IChecksumService));this.server.registerChannel("checksum",et);const Be=new ne.UserDataSyncMachinesServiceChannel(ue.get(be.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Be);const nt=E.ProxyChannel.fromService(ue.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Ve=new ne.UserDataSyncAccountServiceChannel(ue.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const He=new ne.UserDataSyncStoreManagementServiceChannel(ue.get(J.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",He);const it=new Ue.UserDataSyncChannel(ue.get(J.IUserDataSyncService),ue.get(l.ILogService));this.server.registerChannel("userDataSync",it);const je=this._register(ue.get(se.IInstantiationService).createInstance(me.UserDataAutoSyncService)),Xe=new ne.UserDataAutoSyncChannel(je);this.server.registerChannel("userDataAutoSync",Xe);const tt=ue.get(Re.ILocalPtyService),rt=E.ProxyChannel.fromService(tt);this.server.registerChannel(Te.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(ue){window.addEventListener("unhandledrejection",Ee=>{(0,De.onUnexpectedError)(Ee.reason),Ee.preventDefault()}),(0,De.setUnexpectedErrorHandler)(Ee=>{const Ie=(0,we.toErrorMessage)(Ee,!0);!Ie||ue.error(`[uncaught exception in sharedProcess]: ${Ie}`)})}}async function ge(ve){const ue=new he(ve);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ue.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/379476f0e13988d90fab105c5c19e7abc8b1dea8/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
