/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","fs","vs/base/common/extpath","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function(V){for(var e=[],m=0,M=V.length;m<M;m++)e[m]=J[V[m]];return e};define(J[102],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(M,D){if(!M)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=m}),define(J[47],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(E){return(n,p,g)=>{let i=null,b=null;if(typeof g.value=="function"?(i="value",b=g.value):typeof g.get=="function"&&(i="get",b=g.get),!b)throw new Error("not supported");g[i]=E(b,p)}}e.createDecorator=m;function M(E,n,p){let g=null,i=null;if(typeof p.value=="function"?(g="value",i=p.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(g="get",i=p.get),!i)throw new Error("not supported");const b=`$memoize$${n}`;p[g]=function(...k){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,k)}),this[b]}}e.memoize=M;function D(E,n,p){return m((g,i)=>{const b=`$debounce$${i}`,k=`$debounce$result$${i}`;return function(...y){this[k]||(this[k]=p?p():void 0),clearTimeout(this[b]),n&&(this[k]=n(this[k],...y),y=[this[k]]),this[b]=setTimeout(()=>{g.apply(this,y),this[k]=p?p():void 0},E)}})}e.debounce=D;function S(E,n,p){return m((g,i)=>{const b=`$throttle$timer$${i}`,k=`$throttle$result$${i}`,y=`$throttle$lastRun$${i}`,d=`$throttle$pending$${i}`;return function(...v){if(this[k]||(this[k]=p?p():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),n&&(this[k]=n(this[k],...v)),this[d])return;const P=this[y]+E;P<=Date.now()?(this[y]=Date.now(),g.apply(this,[this[k]]),this[k]=p?p():void 0):(this[d]=!0,this[b]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),g.apply(this,[this[k]]),this[k]=p?p():void 0},P-Date.now()))}})}e.throttle=S}),define(J[16],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function M(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=M;function D(u){p(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=D;function S(u){p(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=S;function E(u){if(u instanceof Error){let{name:t,message:s}=u;const r=u.stacktrace||u.stack;return{$isError:!0,name:t,message:s,stack:r}}return u}e.transformErrorForSerialization=E;const n="Canceled";function p(u){return u instanceof Error&&u.name===n&&u.message===n}e.isPromiseCanceledError=p;class g extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=g;function i(){const u=new Error(n);return u.name=u.message,u}e.canceled=i;function b(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=b;function k(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=k;function y(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(u){const t=new Error(`${u} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function v(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=v;class P extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=P;class I extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=I;class c extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=c;function h(u){const t=u;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=h;function a(u,t=Object.create(null)){const s=new Error(u);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=a}),define(J[36],Z([0,1,16]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(T,A=0){return T[T.length-(1+A)]}e.tail=M;function D(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=D;function S(T,A,O=(H,Y)=>H===Y){if(T===A)return!0;if(!T||!A||T.length!==A.length)return!1;for(let H=0,Y=T.length;H<Y;H++)if(!O(T[H],A[H]))return!1;return!0}e.equals=S;function E(T,A,O){let H=0,Y=T.length-1;for(;H<=Y;){const q=(H+Y)/2|0,X=O(T[q],A);if(X<0)H=q+1;else if(X>0)Y=q-1;else return q}return-(H+1)}e.binarySearch=E;function n(T,A){let O=0,H=T.length;if(H===0)return 0;for(;O<H;){const Y=Math.floor((O+H)/2);A(T[Y])?H=Y:O=Y+1}return O}e.findFirstInSorted=n;function p(T,A,O){if(T=T|0,T>=A.length)throw new TypeError("invalid index");let H=A[Math.floor(A.length*Math.random())],Y=[],q=[],X=[];for(let ne of A){const se=O(ne,H);se<0?Y.push(ne):se>0?q.push(ne):X.push(ne)}return T<Y.length?p(T,Y,O):T<Y.length+X.length?X[0]:p(T-(Y.length+X.length),q,O)}e.quickSelect=p;function g(T,A){const O=[];let H;for(const Y of T.slice(0).sort(A))!H||A(H[0],Y)!==0?(H=[Y],O.push(H)):H.push(Y);return O}e.groupBy=g;function i(T,A,O){const H=[];function Y(ne,se,ae){if(se===0&&ae.length===0)return;const de=H[H.length-1];de&&de.start+de.deleteCount===ne?(de.deleteCount+=se,de.toInsert.push(...ae)):H.push({start:ne,deleteCount:se,toInsert:ae})}let q=0,X=0;for(;;){if(q===T.length){Y(q,0,A.slice(X));break}if(X===A.length){Y(q,T.length-q,[]);break}const ne=T[q],se=A[X],ae=O(ne,se);ae===0?(q+=1,X+=1):ae<0?(Y(q,1,[]),q+=1):ae>0&&(Y(q,0,[se]),X+=1)}return H}e.sortedDiff=i;function b(T,A,O){const H=i(T,A,O),Y=[],q=[];for(const X of H)Y.push(...T.slice(X.start,X.start+X.deleteCount)),q.push(...X.toInsert);return{removed:Y,added:q}}e.delta=b;function k(T,A,O){if(O===0)return[];const H=T.slice(0,O).sort(A);return d(T,A,H,O,T.length),H}e.top=k;function y(T,A,O,H,Y){return O===0?Promise.resolve([]):new Promise((q,X)=>{(async()=>{const ne=T.length,se=T.slice(0,O).sort(A);for(let ae=O,de=Math.min(O+H,ne);ae<ne;ae=de,de=Math.min(de+H,ne)){if(ae>O&&await new Promise(re=>setTimeout(re)),Y&&Y.isCancellationRequested)throw(0,m.canceled)();d(T,A,se,ae,de)}return se})().then(q,X)})}e.topAsync=y;function d(T,A,O,H,Y){for(const q=O.length;H<Y;H++){const X=T[H];if(A(X,O[q-1])<0){O.pop();const ne=n(O,se=>A(X,se)<0);O.splice(ne,0,X)}}}function v(T){return T.filter(A=>!!A)}e.coalesce=v;function P(T){let A=0;for(let O=0;O<T.length;O++)T[O]&&(T[A]=T[O],A+=1);T.length=A}e.coalesceInPlace=P;function I(T,A,O){T.splice(O,0,T.splice(A,1)[0])}e.move=I;function c(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=c;function h(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=h;function a(T,A){if(!A)return T.filter((H,Y)=>T.indexOf(H)===Y);const O=Object.create(null);return T.filter(H=>{const Y=A(H);return O[Y]?!1:(O[Y]=!0,!0)})}e.distinct=a;function u(T){const A=new Set;return T.filter(O=>A.has(O)?!1:(A.add(O),!0))}e.distinctES6=u;function t(T){const A=Object.create(null);return O=>{const H=T(O);return A[H]?!1:(A[H]=!0,!0)}}e.uniqueFilter=t;function s(T,A){for(let O=T.length-1;O>=0;O--){const H=T[O];if(A(H))return O}return-1}e.lastIndex=s;function r(T,A){return T.length>0?T[0]:A}e.firstOrDefault=r;function o(T,A,O=(H,Y)=>H===Y){let H=0;for(let Y=0,q=Math.min(T.length,A.length);Y<q&&O(T[Y],A[Y]);Y++)H++;return H}e.commonPrefixLength=o;function l(T){return[].concat(...T)}e.flatten=l;function w(T,A){let O=typeof A=="number"?T:0;typeof A=="number"?O=T:(O=0,A=T);const H=[];if(O<=A)for(let Y=O;Y<A;Y++)H.push(Y);else for(let Y=O;Y>A;Y--)H.push(Y);return H}e.range=w;function f(T,A,O){return T.reduce((H,Y)=>(H[A(Y)]=O?O(Y):Y,H),Object.create(null))}e.index=f;function L(T,A){return T.push(A),()=>R(T,A)}e.insert=L;function R(T,A){const O=T.indexOf(A);if(O>-1)return T.splice(O,1),A}e.remove=R;function _(T,A,O){const H=T.slice(0,A),Y=T.slice(A);return H.concat(O,Y)}e.arrayInsert=_;function C(T,A){let O;if(typeof A=="number"){let H=A;O=()=>{const Y=Math.sin(H++)*179426549;return Y-Math.floor(Y)}}else O=Math.random;for(let H=T.length-1;H>0;H-=1){const Y=Math.floor(O()*(H+1)),q=T[H];T[H]=T[Y],T[Y]=q}}e.shuffle=C;function K(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.unshift(A))}e.pushToStart=K;function x(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.push(A))}e.pushToEnd=x;function ie(T,A){return Array.isArray(T)?T.map(A):A(T)}e.mapArrayOrNot=ie;function G(T){return Array.isArray(T)?T:[T]}e.asArray=G;function Q(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=Q;function U(T,A){for(const O of T){const H=A(O);if(H!==void 0)return H}}e.mapFind=U;function $(T,A,O){const H=N(T,A),Y=T.length,q=O.length;T.length=Y+q;for(let X=Y-1;X>=H;X--)T[X+q]=T[X];for(let X=0;X<q;X++)T[X+H]=O[X]}e.insertInto=$;function F(T,A,O,H){const Y=N(T,A),q=T.splice(Y,O);return $(T,Y,H),q}e.splice=F;function N(T,A){return A<0?Math.max(A+T.length,0):Math.min(A,T.length)}function B(T,A){let O=Number.MAX_SAFE_INTEGER,H=0;return T.forEach((Y,q)=>{const X=A(Y);X<O&&(O=X,H=q)}),H}e.minIndex=B;function W(T,A){let O=Number.MIN_SAFE_INTEGER,H=0;return T.forEach((Y,q)=>{const X=A(Y);X>O&&(O=X,H=q)}),H}e.maxIndex=W;class z{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let O=this.firstIdx;for(;O<this.items.length&&A(this.items[O]);)O++;const H=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,H}takeFromEndWhile(A){let O=this.lastIdx;for(;O>=0&&A(this.items[O]);)O--;const H=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,H}}e.ArrayQueue=z}),define(J[43],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(M){const D=this;let S=!1,E;return function(){return S||(S=!0,E=M.apply(D,arguments)),E}}e.once=m}),define(J[63],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(M){function D(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}M.is=D;const S=Object.freeze([]);function E(){return S}M.empty=E;function*n(u){yield u}M.single=n;function p(u){return u||S}M.from=p;function g(u){return!u||u[Symbol.iterator]().next().done===!0}M.isEmpty=g;function i(u){return u[Symbol.iterator]().next().value}M.first=i;function b(u,t){for(const s of u)if(t(s))return!0;return!1}M.some=b;function k(u,t){for(const s of u)if(t(s))return s}M.find=k;function*y(u,t){for(const s of u)t(s)&&(yield s)}M.filter=y;function*d(u,t){let s=0;for(const r of u)yield t(r,s++)}M.map=d;function*v(...u){for(const t of u)for(const s of t)yield s}M.concat=v;function*P(u){for(const t of u)for(const s of t)yield s}M.concatNested=P;function I(u,t,s){let r=s;for(const o of u)r=t(r,o);return r}M.reduce=I;function*c(u,t,s=u.length){for(t<0&&(t+=u.length),s<0?s+=u.length:s>u.length&&(s=u.length);t<s;t++)yield u[t]}M.slice=c;function h(u,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,u];const r=u[Symbol.iterator]();for(let o=0;o<t;o++){const l=r.next();if(l.done)return[s,M.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return r}}]}M.consume=h;function a(u,t,s=(r,o)=>r===o){const r=u[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const l=r.next(),w=o.next();if(l.done!==w.done)return!1;if(l.done)return!0;if(!s(l.value,w.value))return!1}}M.equals=a})(m=e.Iterable||(e.Iterable={}))}),define(J[40],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function E(t,s=!1){let r=0,o=t.length,l="",w=0,f=16,L=0;function R(Q){let U=0,$=0;for(;U<Q;){const F=t.charCodeAt(r);if(F>=48&&F<=57)$=$*16+F-48;else if(F>=65&&F<=70)$=$*16+F-65+10;else if(F>=97&&F<=102)$=$*16+F-97+10;else break;r++,U++}return U<Q&&($=-1),$}function _(Q){r=Q,l="",w=0,f=16,L=0}function C(){const Q=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&g(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&g(t.charCodeAt(r)))for(r++;r<t.length&&g(t.charCodeAt(r));)r++;else return L=3,t.substring(Q,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&g(t.charCodeAt(r))){for(r++;r<t.length&&g(t.charCodeAt(r));)r++;U=r}else L=3;return t.substring(Q,U)}function K(){let Q="",U=r;for(;;){if(r>=o){Q+=t.substring(U,r),L=2;break}const $=t.charCodeAt(r);if($===34){Q+=t.substring(U,r),r++;break}if($===92){if(Q+=t.substring(U,r),r++,r>=o){L=2;break}switch(t.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const N=R(4);N>=0?Q+=String.fromCharCode(N):L=4;break;default:L=5}U=r;continue}if($>=0&&$<=31)if(p($)){Q+=t.substring(U,r),L=2;break}else L=6;r++}return Q}function x(){if(l="",L=0,w=r,r>=o)return w=o,f=17;let Q=t.charCodeAt(r);if(n(Q)){do r++,l+=String.fromCharCode(Q),Q=t.charCodeAt(r);while(n(Q));return f=15}if(p(Q))return r++,l+=String.fromCharCode(Q),Q===13&&t.charCodeAt(r)===10&&(r++,l+=`
`),f=14;switch(Q){case 123:return r++,f=1;case 125:return r++,f=2;case 91:return r++,f=3;case 93:return r++,f=4;case 58:return r++,f=6;case 44:return r++,f=5;case 34:return r++,l=K(),f=10;case 47:const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<o&&!p(t.charCodeAt(r));)r++;return l=t.substring(U,r),f=12}if(t.charCodeAt(r+1)===42){r+=2;const $=o-1;let F=!1;for(;r<$;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,F=!0;break}r++}return F||(r++,L=1),l=t.substring(U,r),f=13}return l+=String.fromCharCode(Q),r++,f=16;case 45:if(l+=String.fromCharCode(Q),r++,r===o||!g(t.charCodeAt(r)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=C(),f=11;default:for(;r<o&&ie(Q);)r++,Q=t.charCodeAt(r);if(w!==r){switch(l=t.substring(w,r),l){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return l+=String.fromCharCode(Q),r++,f=16}}function ie(Q){if(n(Q)||p(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let Q;do Q=x();while(Q>=12&&Q<=15);return Q}return{setPosition:_,getPosition:()=>r,scan:s?G:x,getToken:()=>f,getTokenValue:()=>l,getTokenOffset:()=>w,getTokenLength:()=>r-w,getTokenError:()=>L}}e.createScanner=E;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function b(t,s){const r=[],o=new Object;let l;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function L(R,_,C,K){w.value=R,w.offset=_,w.length=C,w.type=K,w.colonOffset=void 0,l=w}try{h(t,{onObjectBegin:(R,_)=>{if(s<=R)throw o;l=void 0,f=s>R,r.push("")},onObjectProperty:(R,_,C)=>{if(s<_||(L(R,_,C,"property"),r[r.length-1]=R,s<=_+C))throw o},onObjectEnd:(R,_)=>{if(s<=R)throw o;l=void 0,r.pop()},onArrayBegin:(R,_)=>{if(s<=R)throw o;l=void 0,r.push(0)},onArrayEnd:(R,_)=>{if(s<=R)throw o;l=void 0,r.pop()},onLiteralValue:(R,_,C)=>{if(s<_||(L(R,_,C,u(R)),s<=_+C))throw o},onSeparator:(R,_,C)=>{if(s<=_)throw o;if(R===":"&&l&&l.type==="property")l.colonOffset=_,f=!1,l=void 0;else if(R===","){const K=r[r.length-1];typeof K=="number"?r[r.length-1]=K+1:(f=!0,r[r.length-1]=""),l=void 0}}})}catch(R){if(R!==o)throw R}return{path:r,previousNode:l,isAtPropertyKey:f,matches:R=>{let _=0;for(let C=0;_<R.length&&C<r.length;C++)if(R[_]===r[C]||R[_]==="*")_++;else if(R[_]!=="**")return!1;return _===R.length}}}e.getLocation=b;function k(t,s=[],r=S.DEFAULT){let o=null,l=[];const w=[];function f(R){Array.isArray(l)?l.push(R):o!==null&&(l[o]=R)}return h(t,{onObjectBegin:()=>{const R={};f(R),w.push(l),l=R,o=null},onObjectProperty:R=>{o=R},onObjectEnd:()=>{l=w.pop()},onArrayBegin:()=>{const R=[];f(R),w.push(l),l=R,o=null},onArrayEnd:()=>{l=w.pop()},onLiteralValue:f,onError:(R,_,C)=>{s.push({error:R,offset:_,length:C})}},r),l[0]}e.parse=k;function y(t,s=[],r=S.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(R){o.type==="property"&&(o.length=R-o.offset,o=o.parent)}function w(R){return o.children.push(R),R}h(t,{onObjectBegin:R=>{o=w({type:"object",offset:R,length:-1,parent:o,children:[]})},onObjectProperty:(R,_,C)=>{o=w({type:"property",offset:_,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:R,offset:_,length:C,parent:o})},onObjectEnd:(R,_)=>{o.length=R+_-o.offset,o=o.parent,l(R+_)},onArrayBegin:(R,_)=>{o=w({type:"array",offset:R,length:-1,parent:o,children:[]})},onArrayEnd:(R,_)=>{o.length=R+_-o.offset,o=o.parent,l(R+_)},onLiteralValue:(R,_,C)=>{w({type:u(R),offset:_,length:C,parent:o,value:R}),l(_+C)},onSeparator:(R,_,C)=>{o.type==="property"&&(R===":"?o.colonOffset=_:R===","&&l(_))},onError:(R,_,C)=>{s.push({error:R,offset:_,length:C})}},r);const L=o.children[0];return L&&delete L.parent,L}e.parseTree=y;function d(t,s){if(!t)return;let r=t;for(let o of s)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const w of r.children)if(Array.isArray(w.children)&&w.children[0].value===o){r=w.children[1],l=!0;break}if(!l)return}else{const l=o;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=d;function v(t){if(!t.parent||!t.parent.children)return[];const s=v(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=v;function P(t){switch(t.type){case"array":return t.children.map(P);case"object":const s=Object.create(null);for(let r of t.children){const o=r.children[1];o&&(s[r.children[0].value]=P(o))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=P;function I(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=I;function c(t,s,r=!1){if(I(t,s,r)){const o=t.children;if(Array.isArray(o))for(let l=0;l<o.length&&o[l].offset<=s;l++){const w=c(o[l],s,r);if(w)return w}return t}}e.findNodeAtOffset=c;function h(t,s,r=S.DEFAULT){const o=E(t,!1);function l(O){return O?()=>O(o.getTokenOffset(),o.getTokenLength()):()=>!0}function w(O){return O?H=>O(H,o.getTokenOffset(),o.getTokenLength()):()=>!0}const f=l(s.onObjectBegin),L=w(s.onObjectProperty),R=l(s.onObjectEnd),_=l(s.onArrayBegin),C=l(s.onArrayEnd),K=w(s.onLiteralValue),x=w(s.onSeparator),ie=l(s.onComment),G=w(s.onError),Q=r&&r.disallowComments,U=r&&r.allowTrailingComma;function $(){for(;;){const O=o.scan();switch(o.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:Q||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(O){case 12:case 13:Q?F(10):ie();break;case 16:F(1);break;case 15:case 14:break;default:return O}}}function F(O,H=[],Y=[]){if(G(O),H.length+Y.length>0){let q=o.getToken();for(;q!==17;){if(H.indexOf(q)!==-1){$();break}else if(Y.indexOf(q)!==-1)break;q=$()}}}function N(O){const H=o.getTokenValue();return O?K(H):L(H),$(),!0}function B(){switch(o.getToken()){case 11:let O=0;try{O=JSON.parse(o.getTokenValue()),typeof O!="number"&&(F(2),O=0)}catch(H){F(2)}K(O);break;case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return $(),!0}function W(){return o.getToken()!==10?(F(3,[],[2,5]),!1):(N(!1),o.getToken()===6?(x(":"),$(),A()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function z(){f(),$();let O=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(O||F(4,[],[]),x(","),$(),o.getToken()===2&&U)break}else O&&F(6,[],[]);W()||F(4,[],[2,5]),O=!0}return R(),o.getToken()!==2?F(7,[2],[]):$(),!0}function T(){_(),$();let O=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(O||F(4,[],[]),x(","),$(),o.getToken()===4&&U)break}else O&&F(6,[],[]);A()||F(4,[],[4,5]),O=!0}return C(),o.getToken()!==4?F(8,[4],[]):$(),!0}function A(){switch(o.getToken()){case 3:return T();case 1:return z();case 10:return N(!0);default:return B()}}return $(),o.getToken()===17?r.allowEmptyContent?!0:(F(4,[],[]),!1):A()?(o.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=h;function a(t,s){let r=E(t),o=[],l,w=0,f;do switch(f=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:w!==f&&o.push(t.substring(w,f)),s!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,s)),w=r.getPosition();break}while(l!==17);return o.join("")}e.stripComments=a;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(J[103],Z([0,1,40]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function M(p,g,i){let b,k,y,d,v;if(g){for(d=g.offset,v=d+g.length,y=d;y>0&&!n(p,y-1);)y--;let w=v;for(;w<p.length&&!n(p,w);)w++;k=p.substring(y,w),b=S(k,i)}else k=p,b=0,y=0,d=0,v=p.length;const P=E(i,p);let I=!1,c=0,h;i.insertSpaces?h=D(" ",i.tabSize||4):h="	";const a=(0,m.createScanner)(k,!1);let u=!1;function t(){return P+D(h,b+c)}function s(){let w=a.scan();for(I=!1;w===15||w===14;)I=I||w===14,w=a.scan();return u=w===16||a.getTokenError()!==0,w}const r=[];function o(w,f,L){!u&&f<v&&L>d&&p.substring(f,L)!==w&&r.push({offset:f,length:L-f,content:w})}let l=s();if(l!==17){const w=a.getTokenOffset()+y,f=D(h,b);o(f,y,w)}for(;l!==17;){let w=a.getTokenOffset()+a.getTokenLength()+y,f=s(),L="";for(;!I&&(f===12||f===13);){const _=a.getTokenOffset()+y;o(" ",w,_),w=a.getTokenOffset()+a.getTokenLength()+y,L=f===12?t():"",f=s()}if(f===2)l!==1&&(c--,L=t());else if(f===4)l!==3&&(c--,L=t());else{switch(l){case 3:case 1:c++,L=t();break;case 5:case 12:L=t();break;case 13:I?L=t():L=" ";break;case 6:L=" ";break;case 10:if(f===6){L="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?L=" ":f!==5&&f!==17&&(u=!0);break;case 16:u=!0;break}I&&(f===12||f===13)&&(L=t())}const R=a.getTokenOffset()+y;o(L,w,R),l=f}return r}e.format=M;function D(p,g){let i="";for(let b=0;b<g;b++)i+=p;return i}function S(p,g){let i=0,b=0;const k=g.tabSize||4;for(;i<p.length;){const y=p.charAt(i);if(y===" ")b++;else if(y==="	")b+=k;else break;i++}return Math.floor(b/k)}function E(p,g){for(let i=0;i<g.length;i++){const b=g.charAt(i);if(b==="\r")return i+1<g.length&&g.charAt(i+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=E;function n(p,g){return`\r
`.indexOf(p.charAt(g))!==-1}e.isEOL=n}),define(J[76],Z([0,1,40,103]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(g,i,b){return S(g,i,void 0,b)}e.removeProperty=D;function S(g,i,b,k,y){const d=i.slice(),v=[],P=(0,m.parseTree)(g,v);let I,c;for(;d.length>0&&(c=d.pop(),I=(0,m.findNodeAtLocation)(P,d),I===void 0&&b!==void 0);)typeof c=="string"?b={[c]:b}:b=[b];if(I)if(I.type==="object"&&typeof c=="string"&&Array.isArray(I.children)){const h=(0,m.findNodeAtLocation)(I,[c]);if(h!==void 0)if(b===void 0){if(!h.parent)throw new Error("Malformed AST");const a=I.children.indexOf(h.parent);let u,t=h.parent.offset+h.parent.length;if(a>0){const s=I.children[a-1];u=s.offset+s.length}else u=I.offset+1,I.children.length>1&&(t=I.children[1].offset);return E(g,{offset:u,length:t-u,content:""},k)}else return E(g,{offset:h.offset,length:h.length,content:JSON.stringify(b)},k);else{if(b===void 0)return[];const a=`${JSON.stringify(c)}: ${JSON.stringify(b)}`,u=y?y(I.children.map(s=>s.children[0].value)):I.children.length;let t;if(u>0){const s=I.children[u-1];t={offset:s.offset+s.length,length:0,content:","+a}}else I.children.length===0?t={offset:I.offset+1,length:0,content:a}:t={offset:I.offset+1,length:0,content:a+","};return E(g,t,k)}}else if(I.type==="array"&&typeof c=="number"&&Array.isArray(I.children))if(b!==void 0){const h=`${JSON.stringify(b)}`;let a;if(I.children.length===0||c===0)a={offset:I.offset+1,length:0,content:I.children.length===0?h:h+","};else{const u=c===-1||c>I.children.length?I.children.length:c,t=I.children[u-1];a={offset:t.offset+t.length,length:0,content:","+h}}return E(g,a,k)}else{const h=c,a=I.children[h];let u;if(I.children.length===1)u={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===h){const t=I.children[h-1],s=t.offset+t.length,r=I.offset+I.length;u={offset:s,length:r-2-s,content:""}}else u={offset:a.offset,length:I.children[h+1].offset-a.offset,content:""};return E(g,u,k)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${I.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return E(g,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(b)},k)}}e.setProperty=S;function E(g,i,b){let k=n(g,i),y=i.offset,d=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;y>0&&!(0,M.isEOL)(k,y-1);)y--;for(;d<k.length&&!(0,M.isEOL)(k,d);)d++}const v=(0,M.format)(k,{offset:y,length:d-y},b);for(let I=v.length-1;I>=0;I--){const c=v[I];k=n(k,c),y=Math.min(y,c.offset),d=Math.max(d,c.offset+c.length),d+=c.content.length-c.length}const P=g.length-(k.length-d)-y;return[{offset:y,length:P,content:k.substring(y,d)}]}e.withFormatting=E;function n(g,i){return g.substring(0,i.offset)+i.content+g.substring(i.offset+i.length)}e.applyEdit=n;function p(g,i){let b=i.slice(0).sort((y,d)=>{const v=y.offset-d.offset;return v===0?y.length-d.length:v}),k=g.length;for(let y=b.length-1;y>=0;y--){let d=b[y];if(d.offset+d.length<=k)g=n(g,d);else throw new Error("Overlapping edit");k=d.offset}return g}e.applyEdits=p}),define(J[57],Z([0,1,16]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var M;(function(c){c[c.DependsOnKbLayout=-1]="DependsOnKbLayout",c[c.Unknown=0]="Unknown",c[c.Backspace=1]="Backspace",c[c.Tab=2]="Tab",c[c.Enter=3]="Enter",c[c.Shift=4]="Shift",c[c.Ctrl=5]="Ctrl",c[c.Alt=6]="Alt",c[c.PauseBreak=7]="PauseBreak",c[c.CapsLock=8]="CapsLock",c[c.Escape=9]="Escape",c[c.Space=10]="Space",c[c.PageUp=11]="PageUp",c[c.PageDown=12]="PageDown",c[c.End=13]="End",c[c.Home=14]="Home",c[c.LeftArrow=15]="LeftArrow",c[c.UpArrow=16]="UpArrow",c[c.RightArrow=17]="RightArrow",c[c.DownArrow=18]="DownArrow",c[c.Insert=19]="Insert",c[c.Delete=20]="Delete",c[c.KEY_0=21]="KEY_0",c[c.KEY_1=22]="KEY_1",c[c.KEY_2=23]="KEY_2",c[c.KEY_3=24]="KEY_3",c[c.KEY_4=25]="KEY_4",c[c.KEY_5=26]="KEY_5",c[c.KEY_6=27]="KEY_6",c[c.KEY_7=28]="KEY_7",c[c.KEY_8=29]="KEY_8",c[c.KEY_9=30]="KEY_9",c[c.KEY_A=31]="KEY_A",c[c.KEY_B=32]="KEY_B",c[c.KEY_C=33]="KEY_C",c[c.KEY_D=34]="KEY_D",c[c.KEY_E=35]="KEY_E",c[c.KEY_F=36]="KEY_F",c[c.KEY_G=37]="KEY_G",c[c.KEY_H=38]="KEY_H",c[c.KEY_I=39]="KEY_I",c[c.KEY_J=40]="KEY_J",c[c.KEY_K=41]="KEY_K",c[c.KEY_L=42]="KEY_L",c[c.KEY_M=43]="KEY_M",c[c.KEY_N=44]="KEY_N",c[c.KEY_O=45]="KEY_O",c[c.KEY_P=46]="KEY_P",c[c.KEY_Q=47]="KEY_Q",c[c.KEY_R=48]="KEY_R",c[c.KEY_S=49]="KEY_S",c[c.KEY_T=50]="KEY_T",c[c.KEY_U=51]="KEY_U",c[c.KEY_V=52]="KEY_V",c[c.KEY_W=53]="KEY_W",c[c.KEY_X=54]="KEY_X",c[c.KEY_Y=55]="KEY_Y",c[c.KEY_Z=56]="KEY_Z",c[c.Meta=57]="Meta",c[c.ContextMenu=58]="ContextMenu",c[c.F1=59]="F1",c[c.F2=60]="F2",c[c.F3=61]="F3",c[c.F4=62]="F4",c[c.F5=63]="F5",c[c.F6=64]="F6",c[c.F7=65]="F7",c[c.F8=66]="F8",c[c.F9=67]="F9",c[c.F10=68]="F10",c[c.F11=69]="F11",c[c.F12=70]="F12",c[c.F13=71]="F13",c[c.F14=72]="F14",c[c.F15=73]="F15",c[c.F16=74]="F16",c[c.F17=75]="F17",c[c.F18=76]="F18",c[c.F19=77]="F19",c[c.NumLock=78]="NumLock",c[c.ScrollLock=79]="ScrollLock",c[c.US_SEMICOLON=80]="US_SEMICOLON",c[c.US_EQUAL=81]="US_EQUAL",c[c.US_COMMA=82]="US_COMMA",c[c.US_MINUS=83]="US_MINUS",c[c.US_DOT=84]="US_DOT",c[c.US_SLASH=85]="US_SLASH",c[c.US_BACKTICK=86]="US_BACKTICK",c[c.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",c[c.US_BACKSLASH=88]="US_BACKSLASH",c[c.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",c[c.US_QUOTE=90]="US_QUOTE",c[c.OEM_8=91]="OEM_8",c[c.OEM_102=92]="OEM_102",c[c.NUMPAD_0=93]="NUMPAD_0",c[c.NUMPAD_1=94]="NUMPAD_1",c[c.NUMPAD_2=95]="NUMPAD_2",c[c.NUMPAD_3=96]="NUMPAD_3",c[c.NUMPAD_4=97]="NUMPAD_4",c[c.NUMPAD_5=98]="NUMPAD_5",c[c.NUMPAD_6=99]="NUMPAD_6",c[c.NUMPAD_7=100]="NUMPAD_7",c[c.NUMPAD_8=101]="NUMPAD_8",c[c.NUMPAD_9=102]="NUMPAD_9",c[c.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",c[c.NUMPAD_ADD=104]="NUMPAD_ADD",c[c.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",c[c.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",c[c.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",c[c.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",c[c.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",c[c.ABNT_C1=110]="ABNT_C1",c[c.ABNT_C2=111]="ABNT_C2",c[c.MAX_VALUE=112]="MAX_VALUE"})(M=e.KeyCode||(e.KeyCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,a){this._keyCodeToStr[h]=a,this._strToKeyCode[a.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const S=new D,E=new D,n=new D;(function(){function c(h,a,u=a,t=u){S.define(h,a),E.define(h,u),n.define(h,t)}c(0,"unknown"),c(1,"Backspace"),c(2,"Tab"),c(3,"Enter"),c(4,"Shift"),c(5,"Ctrl"),c(6,"Alt"),c(7,"PauseBreak"),c(8,"CapsLock"),c(9,"Escape"),c(10,"Space"),c(11,"PageUp"),c(12,"PageDown"),c(13,"End"),c(14,"Home"),c(15,"LeftArrow","Left"),c(16,"UpArrow","Up"),c(17,"RightArrow","Right"),c(18,"DownArrow","Down"),c(19,"Insert"),c(20,"Delete"),c(21,"0"),c(22,"1"),c(23,"2"),c(24,"3"),c(25,"4"),c(26,"5"),c(27,"6"),c(28,"7"),c(29,"8"),c(30,"9"),c(31,"A"),c(32,"B"),c(33,"C"),c(34,"D"),c(35,"E"),c(36,"F"),c(37,"G"),c(38,"H"),c(39,"I"),c(40,"J"),c(41,"K"),c(42,"L"),c(43,"M"),c(44,"N"),c(45,"O"),c(46,"P"),c(47,"Q"),c(48,"R"),c(49,"S"),c(50,"T"),c(51,"U"),c(52,"V"),c(53,"W"),c(54,"X"),c(55,"Y"),c(56,"Z"),c(57,"Meta"),c(58,"ContextMenu"),c(59,"F1"),c(60,"F2"),c(61,"F3"),c(62,"F4"),c(63,"F5"),c(64,"F6"),c(65,"F7"),c(66,"F8"),c(67,"F9"),c(68,"F10"),c(69,"F11"),c(70,"F12"),c(71,"F13"),c(72,"F14"),c(73,"F15"),c(74,"F16"),c(75,"F17"),c(76,"F18"),c(77,"F19"),c(78,"NumLock"),c(79,"ScrollLock"),c(80,";",";","OEM_1"),c(81,"=","=","OEM_PLUS"),c(82,",",",","OEM_COMMA"),c(83,"-","-","OEM_MINUS"),c(84,".",".","OEM_PERIOD"),c(85,"/","/","OEM_2"),c(86,"`","`","OEM_3"),c(110,"ABNT_C1"),c(111,"ABNT_C2"),c(87,"[","[","OEM_4"),c(88,"\\","\\","OEM_5"),c(89,"]","]","OEM_6"),c(90,"'","'","OEM_7"),c(91,"OEM_8"),c(92,"OEM_102"),c(93,"NumPad0"),c(94,"NumPad1"),c(95,"NumPad2"),c(96,"NumPad3"),c(97,"NumPad4"),c(98,"NumPad5"),c(99,"NumPad6"),c(100,"NumPad7"),c(101,"NumPad8"),c(102,"NumPad9"),c(103,"NumPad_Multiply"),c(104,"NumPad_Add"),c(105,"NumPad_Separator"),c(106,"NumPad_Subtract"),c(107,"NumPad_Decimal"),c(108,"NumPad_Divide")})();var p;(function(c){function h(r){return S.keyCodeToStr(r)}c.toString=h;function a(r){return S.strToKeyCode(r)}c.fromString=a;function u(r){return E.keyCodeToStr(r)}c.toUserSettingsUS=u;function t(r){return n.keyCodeToStr(r)}c.toUserSettingsGeneral=t;function s(r){return E.strToKeyCode(r)||n.strToKeyCode(r)}c.fromUserSettings=s})(p=e.KeyCodeUtils||(e.KeyCodeUtils={}));var g;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl",c[c.KeyCode=255]="KeyCode"})(g||(g={}));var i;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl"})(i=e.KeyMod||(e.KeyMod={}));function b(c,h){const a=(h&65535)<<16>>>0;return(c|a)>>>0}e.KeyChord=b;function k(c,h){if(c===0)return null;const a=(c&65535)>>>0,u=(c&4294901760)>>>16;return u!==0?new v([y(a,h),y(u,h)]):new v([y(a,h)])}e.createKeybinding=k;function y(c,h){const a=!!(c&2048),u=!!(c&256),t=h===2?u:a,s=!!(c&1024),r=!!(c&512),o=h===2?a:u,l=c&255;return new d(t,s,r,o,l)}e.createSimpleKeybinding=y;class d{constructor(h,a,u,t,s){this.ctrlKey=h,this.shiftKey=a,this.altKey=u,this.metaKey=t,this.keyCode=s}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",u=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${h}${a}${u}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new v([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class v{constructor(h){if(h.length===0)throw(0,m.illegalArgument)("parts");this.parts=h}getHashCode(){let h="";for(let a=0,u=this.parts.length;a<u;a++)a!==0&&(h+=";"),h+=this.parts[a].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let a=0;a<this.parts.length;a++)if(!this.parts[a].equals(h.parts[a]))return!1;return!0}}e.ChordKeybinding=v;class P{constructor(h,a,u,t,s,r){this.ctrlKey=h,this.shiftKey=a,this.altKey=u,this.metaKey=t,this.keyLabel=s,this.keyAriaLabel=r}}e.ResolvedKeybindingPart=P;class I{}e.ResolvedKeybinding=I}),define(J[2],Z([0,1,43,63]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let S=null;function E(r){S=r}if(e.setDisposableTracker=E,D){const r="__is_disposable_tracked__";E(new class{trackDisposable(o){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[r]||console.log(l)},3e3)}setParent(o,l){if(o&&o!==c.None)try{o[r]=!0}catch{}}markAsDisposed(o){if(o&&o!==c.None)try{o[r]=!0}catch{}}markAsSingleton(o){}})}function n(r){return S?.trackDisposable(r),r}function p(r){S?.markAsDisposed(r)}function g(r,o){S?.setParent(r,o)}function i(r,o){if(!!S)for(const l of r)S.setParent(l,o)}function b(r){return S?.markAsSingleton(r),r}e.markAsSingleton=b;class k extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=k;function y(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=y;function d(r){if(M.Iterable.is(r)){let o=[];for(const l of r)if(l)try{l.dispose()}catch(w){o.push(w)}if(o.length===1)throw o[0];if(o.length>1)throw new k(o);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=d;function v(...r){const o=P(()=>d(r));return i(r,o),o}e.combinedDisposable=v;function P(r){const o=n({dispose:(0,m.once)(()=>{p(o),r()})});return o}e.toDisposable=P;class I{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return g(o,this),this._isDisposed?I.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=I,I.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new I,n(this),g(this._store,this)}dispose(){p(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&g(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&g(o,null),o}}e.MutableDisposable=h;class a{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class u{constructor(){this.references=new Map}acquire(o,...l){let w=this.references.get(o);w||(w={counter:0,object:this.createReferencedObject(o,...l)},this.references.set(o,w));const{object:f}=w,L=(0,m.once)(()=>{--w.counter==0&&(this.destroyReferencedObject(o,w.object),this.references.delete(o))});return w.counter++,{object:f,dispose:L}}}e.ReferenceCollection=u;class t{constructor(o){this.referenceCollection=o}async acquire(o,...l){const w=this.referenceCollection.acquire(o,...l);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(f){throw w.dispose(),f}}}e.AsyncReferenceCollection=t;class s{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=s}),define(J[104],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(S){this.element=S,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class M{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let S=this._first;for(;S!==m.Undefined;){const E=S.next;S.prev=m.Undefined,S.next=m.Undefined,S=E}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,E){const n=new m(S);if(this._first===m.Undefined)this._first=n,this._last=n;else if(E){const g=this._last;this._last=n,n.prev=g,g.next=n}else{const g=this._first;this._first=n,n.next=g,g.prev=n}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(n))}}shift(){if(this._first!==m.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==m.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==m.Undefined&&S.next!==m.Undefined){const E=S.prev;E.next=S.next,S.next.prev=E}else S.prev===m.Undefined&&S.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):S.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):S.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==m.Undefined;)yield S.element,S=S.next}}e.LinkedList=M}),function(){function V(D){const S=[];typeof D=="number"&&S.push("code/timeOrigin",D);function E(p){S.push(p,Date.now())}function n(){const p=[];for(let g=0;g<S.length;g+=2)p.push({name:S[g],startTime:S[g+1]});return p}return{mark:E,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const E of performance.getEntriesByType("mark"))S.push({name:E.name,startTime:Math.round(D+E.startTime)});return S}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function m(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=m(M))}(),define(J[3],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const m="en";let M=!1,D=!1,S=!1,E=!1,n=!1,p=!1,g=!1,i,b=m,k,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const v=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=v&&d?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=d?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!v)y=navigator.userAgent,M=y.indexOf("Windows")>=0,D=y.indexOf("Macintosh")>=0,g=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=y.indexOf("Linux")>=0,p=!0,i=navigator.language,b=i;else if(typeof d=="object"){M=d.platform==="win32",D=d.platform==="darwin",S=d.platform==="linux",E=S&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,i=m,b=m;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),l=o.availableLanguages["*"];i=o.locale,b=l||m,k=o._translationsConfigFile}catch(o){}n=!0}else console.error("Unable to resolve platform.");var P;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function I(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let c=0;D?c=1:M?c=3:S&&(c=2),e.isWindows=M,e.isMacintosh=D,e.isLinux=S,e.isLinuxSnap=E,e.isNative=n,e.isWeb=p,e.isIOS=g,e.platform=c,e.userAgent=y,e.language=b;var h;(function(r){function o(){return e.language}r.value=o;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=l;function w(){return e.language==="en"}r.isDefault=w})(h=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=k,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeSetImmediateId)for(let L=0,R=l.length;L<R;L++){const _=l[L];if(_.id===f.data.vscodeSetImmediateId){l.splice(L,1),_.callback();return}}});let w=0;return f=>{const L=++w;l.push({id:L,callback:f}),e.globals.postMessage({vscodeSetImmediateId:L},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const o=Promise.resolve();return l=>o.then(l)}();var a;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||g?2:M?1:3;let u=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,u=new Uint16Array(r.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=s}),define(J[33],Z([0,1,3]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let M;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const D=m.globals.vscode.process;M={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(S){return(0,m.setImmediate)(S)}}}else typeof process!="undefined"?M={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:M={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(D){return(0,m.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.platform=M.platform,e.nextTick=M.nextTick}),define(J[8],Z([0,1,33]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const M=65,D=97,S=90,E=122,n=46,p=47,g=92,i=58,b=63;class k extends Error{constructor(a,u,t){let s;typeof u=="string"&&u.indexOf("not ")===0?(s="must not be",u=u.replace(/^not /,"")):s="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${s} of type ${u}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function y(h,a){if(typeof h!="string")throw new k(a,"string",h)}function d(h){return h===p||h===g}function v(h){return h===p}function P(h){return h>=M&&h<=S||h>=D&&h<=E}function I(h,a,u,t){let s="",r=0,o=-1,l=0,w=0;for(let f=0;f<=h.length;++f){if(f<h.length)w=h.charCodeAt(f);else{if(t(w))break;w=p}if(t(w)){if(!(o===f-1||l===1))if(l===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==n||s.charCodeAt(s.length-2)!==n){if(s.length>2){const L=s.lastIndexOf(u);L===-1?(s="",r=0):(s=s.slice(0,L),r=s.length-1-s.lastIndexOf(u)),o=f,l=0;continue}else if(s.length!==0){s="",r=0,o=f,l=0;continue}}a&&(s+=s.length>0?`${u}..`:"..",r=2)}else s.length>0?s+=`${u}${h.slice(o+1,f)}`:s=h.slice(o+1,f),r=f-o-1;o=f,l=0}else w===n&&l!==-1?++l:l=-1}return s}function c(h,a){if(a===null||typeof a!="object")throw new k("pathObject","Object",a);const u=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return u?u===a.root?`${u}${t}`:`${u}${h}${t}`:t}e.win32={resolve(...h){let a="",u="",t=!1;for(let s=h.length-1;s>=-1;s--){let r;if(s>=0){if(r=h[s],y(r,"path"),r.length===0)continue}else a.length===0?r=m.cwd():(r=m.env[`=${a}`]||m.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${a}\\`));const o=r.length;let l=0,w="",f=!1;const L=r.charCodeAt(0);if(o===1)d(L)&&(l=1,f=!0);else if(d(L))if(f=!0,d(r.charCodeAt(1))){let R=2,_=R;for(;R<o&&!d(r.charCodeAt(R));)R++;if(R<o&&R!==_){const C=r.slice(_,R);for(_=R;R<o&&d(r.charCodeAt(R));)R++;if(R<o&&R!==_){for(_=R;R<o&&!d(r.charCodeAt(R));)R++;(R===o||R!==_)&&(w=`\\\\${C}\\${r.slice(_,R)}`,l=R)}}}else l=1;else P(L)&&r.charCodeAt(1)===i&&(w=r.slice(0,2),l=2,o>2&&d(r.charCodeAt(2))&&(f=!0,l=3));if(w.length>0)if(a.length>0){if(w.toLowerCase()!==a.toLowerCase())continue}else a=w;if(t){if(a.length>0)break}else if(u=`${r.slice(l)}\\${u}`,t=f,f&&a.length>0)break}return u=I(u,!t,"\\",d),t?`${a}\\${u}`:`${a}${u}`||"."},normalize(h){y(h,"path");const a=h.length;if(a===0)return".";let u=0,t,s=!1;const r=h.charCodeAt(0);if(a===1)return v(r)?"\\":h;if(d(r))if(s=!0,d(h.charCodeAt(1))){let l=2,w=l;for(;l<a&&!d(h.charCodeAt(l));)l++;if(l<a&&l!==w){const f=h.slice(w,l);for(w=l;l<a&&d(h.charCodeAt(l));)l++;if(l<a&&l!==w){for(w=l;l<a&&!d(h.charCodeAt(l));)l++;if(l===a)return`\\\\${f}\\${h.slice(w)}\\`;l!==w&&(t=`\\\\${f}\\${h.slice(w,l)}`,u=l)}}}else u=1;else P(r)&&h.charCodeAt(1)===i&&(t=h.slice(0,2),u=2,a>2&&d(h.charCodeAt(2))&&(s=!0,u=3));let o=u<a?I(h.slice(u),!s,"\\",d):"";return o.length===0&&!s&&(o="."),o.length>0&&d(h.charCodeAt(a-1))&&(o+="\\"),t===void 0?s?`\\${o}`:o:s?`${t}\\${o}`:`${t}${o}`},isAbsolute(h){y(h,"path");const a=h.length;if(a===0)return!1;const u=h.charCodeAt(0);return d(u)||a>2&&P(u)&&h.charCodeAt(1)===i&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let a,u;for(let r=0;r<h.length;++r){const o=h[r];y(o,"path"),o.length>0&&(a===void 0?a=u=o:a+=`\\${o}`)}if(a===void 0)return".";let t=!0,s=0;if(typeof u=="string"&&d(u.charCodeAt(0))){++s;const r=u.length;r>1&&d(u.charCodeAt(1))&&(++s,r>2&&(d(u.charCodeAt(2))?++s:t=!1))}if(t){for(;s<a.length&&d(a.charCodeAt(s));)s++;s>=2&&(a=`\\${a.slice(s)}`)}return e.win32.normalize(a)},relative(h,a){if(y(h,"from"),y(a,"to"),h===a)return"";const u=e.win32.resolve(h),t=e.win32.resolve(a);if(u===t||(h=u.toLowerCase(),a=t.toLowerCase(),h===a))return"";let s=0;for(;s<h.length&&h.charCodeAt(s)===g;)s++;let r=h.length;for(;r-1>s&&h.charCodeAt(r-1)===g;)r--;const o=r-s;let l=0;for(;l<a.length&&a.charCodeAt(l)===g;)l++;let w=a.length;for(;w-1>l&&a.charCodeAt(w-1)===g;)w--;const f=w-l,L=o<f?o:f;let R=-1,_=0;for(;_<L;_++){const K=h.charCodeAt(s+_);if(K!==a.charCodeAt(l+_))break;K===g&&(R=_)}if(_!==L){if(R===-1)return t}else{if(f>L){if(a.charCodeAt(l+_)===g)return t.slice(l+_+1);if(_===2)return t.slice(l+_)}o>L&&(h.charCodeAt(s+_)===g?R=_:_===2&&(R=3)),R===-1&&(R=0)}let C="";for(_=s+R+1;_<=r;++_)(_===r||h.charCodeAt(_)===g)&&(C+=C.length===0?"..":"\\..");return l+=R,C.length>0?`${C}${t.slice(l,w)}`:(t.charCodeAt(l)===g&&++l,t.slice(l,w))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const a=e.win32.resolve(h);if(a.length<=2)return h;if(a.charCodeAt(0)===g){if(a.charCodeAt(1)===g){const u=a.charCodeAt(2);if(u!==b&&u!==n)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(P(a.charCodeAt(0))&&a.charCodeAt(1)===i&&a.charCodeAt(2)===g)return`\\\\?\\${a}`;return h},dirname(h){y(h,"path");const a=h.length;if(a===0)return".";let u=-1,t=0;const s=h.charCodeAt(0);if(a===1)return d(s)?h:".";if(d(s)){if(u=t=1,d(h.charCodeAt(1))){let l=2,w=l;for(;l<a&&!d(h.charCodeAt(l));)l++;if(l<a&&l!==w){for(w=l;l<a&&d(h.charCodeAt(l));)l++;if(l<a&&l!==w){for(w=l;l<a&&!d(h.charCodeAt(l));)l++;if(l===a)return h;l!==w&&(u=t=l+1)}}}}else P(s)&&h.charCodeAt(1)===i&&(u=a>2&&d(h.charCodeAt(2))?3:2,t=u);let r=-1,o=!0;for(let l=a-1;l>=t;--l)if(d(h.charCodeAt(l))){if(!o){r=l;break}}else o=!1;if(r===-1){if(u===-1)return".";r=u}return h.slice(0,r)},basename(h,a){a!==void 0&&y(a,"ext"),y(h,"path");let u=0,t=-1,s=!0,r;if(h.length>=2&&P(h.charCodeAt(0))&&h.charCodeAt(1)===i&&(u=2),a!==void 0&&a.length>0&&a.length<=h.length){if(a===h)return"";let o=a.length-1,l=-1;for(r=h.length-1;r>=u;--r){const w=h.charCodeAt(r);if(d(w)){if(!s){u=r+1;break}}else l===-1&&(s=!1,l=r+1),o>=0&&(w===a.charCodeAt(o)?--o==-1&&(t=r):(o=-1,t=l))}return u===t?t=l:t===-1&&(t=h.length),h.slice(u,t)}for(r=h.length-1;r>=u;--r)if(d(h.charCodeAt(r))){if(!s){u=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":h.slice(u,t)},extname(h){y(h,"path");let a=0,u=-1,t=0,s=-1,r=!0,o=0;h.length>=2&&h.charCodeAt(1)===i&&P(h.charCodeAt(0))&&(a=t=2);for(let l=h.length-1;l>=a;--l){const w=h.charCodeAt(l);if(d(w)){if(!r){t=l+1;break}continue}s===-1&&(r=!1,s=l+1),w===n?u===-1?u=l:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||s===-1||o===0||o===1&&u===s-1&&u===t+1?"":h.slice(u,s)},format:c.bind(null,"\\"),parse(h){y(h,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return a;const u=h.length;let t=0,s=h.charCodeAt(0);if(u===1)return d(s)?(a.root=a.dir=h,a):(a.base=a.name=h,a);if(d(s)){if(t=1,d(h.charCodeAt(1))){let R=2,_=R;for(;R<u&&!d(h.charCodeAt(R));)R++;if(R<u&&R!==_){for(_=R;R<u&&d(h.charCodeAt(R));)R++;if(R<u&&R!==_){for(_=R;R<u&&!d(h.charCodeAt(R));)R++;R===u?t=R:R!==_&&(t=R+1)}}}}else if(P(s)&&h.charCodeAt(1)===i){if(u<=2)return a.root=a.dir=h,a;if(t=2,d(h.charCodeAt(2))){if(u===3)return a.root=a.dir=h,a;t=3}}t>0&&(a.root=h.slice(0,t));let r=-1,o=t,l=-1,w=!0,f=h.length-1,L=0;for(;f>=t;--f){if(s=h.charCodeAt(f),d(s)){if(!w){o=f+1;break}continue}l===-1&&(w=!1,l=f+1),s===n?r===-1?r=f:L!==1&&(L=1):r!==-1&&(L=-1)}return l!==-1&&(r===-1||L===0||L===1&&r===l-1&&r===o+1?a.base=a.name=h.slice(o,l):(a.name=h.slice(o,r),a.base=h.slice(o,l),a.ext=h.slice(r,l))),o>0&&o!==t?a.dir=h.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let a="",u=!1;for(let t=h.length-1;t>=-1&&!u;t--){const s=t>=0?h[t]:m.cwd();y(s,"path"),s.length!==0&&(a=`${s}/${a}`,u=s.charCodeAt(0)===p)}return a=I(a,!u,"/",v),u?`/${a}`:a.length>0?a:"."},normalize(h){if(y(h,"path"),h.length===0)return".";const a=h.charCodeAt(0)===p,u=h.charCodeAt(h.length-1)===p;return h=I(h,!a,"/",v),h.length===0?a?"/":u?"./":".":(u&&(h+="/"),a?`/${h}`:h)},isAbsolute(h){return y(h,"path"),h.length>0&&h.charCodeAt(0)===p},join(...h){if(h.length===0)return".";let a;for(let u=0;u<h.length;++u){const t=h[u];y(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(h,a){if(y(h,"from"),y(a,"to"),h===a||(h=e.posix.resolve(h),a=e.posix.resolve(a),h===a))return"";const u=1,t=h.length,s=t-u,r=1,o=a.length-r,l=s<o?s:o;let w=-1,f=0;for(;f<l;f++){const R=h.charCodeAt(u+f);if(R!==a.charCodeAt(r+f))break;R===p&&(w=f)}if(f===l)if(o>l){if(a.charCodeAt(r+f)===p)return a.slice(r+f+1);if(f===0)return a.slice(r+f)}else s>l&&(h.charCodeAt(u+f)===p?w=f:f===0&&(w=0));let L="";for(f=u+w+1;f<=t;++f)(f===t||h.charCodeAt(f)===p)&&(L+=L.length===0?"..":"/..");return`${L}${a.slice(r+w)}`},toNamespacedPath(h){return h},dirname(h){if(y(h,"path"),h.length===0)return".";const a=h.charCodeAt(0)===p;let u=-1,t=!0;for(let s=h.length-1;s>=1;--s)if(h.charCodeAt(s)===p){if(!t){u=s;break}}else t=!1;return u===-1?a?"/":".":a&&u===1?"//":h.slice(0,u)},basename(h,a){a!==void 0&&y(a,"ext"),y(h,"path");let u=0,t=-1,s=!0,r;if(a!==void 0&&a.length>0&&a.length<=h.length){if(a===h)return"";let o=a.length-1,l=-1;for(r=h.length-1;r>=0;--r){const w=h.charCodeAt(r);if(w===p){if(!s){u=r+1;break}}else l===-1&&(s=!1,l=r+1),o>=0&&(w===a.charCodeAt(o)?--o==-1&&(t=r):(o=-1,t=l))}return u===t?t=l:t===-1&&(t=h.length),h.slice(u,t)}for(r=h.length-1;r>=0;--r)if(h.charCodeAt(r)===p){if(!s){u=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":h.slice(u,t)},extname(h){y(h,"path");let a=-1,u=0,t=-1,s=!0,r=0;for(let o=h.length-1;o>=0;--o){const l=h.charCodeAt(o);if(l===p){if(!s){u=o+1;break}continue}t===-1&&(s=!1,t=o+1),l===n?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||t===-1||r===0||r===1&&a===t-1&&a===u+1?"":h.slice(a,t)},format:c.bind(null,"/"),parse(h){y(h,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return a;const u=h.charCodeAt(0)===p;let t;u?(a.root="/",t=1):t=0;let s=-1,r=0,o=-1,l=!0,w=h.length-1,f=0;for(;w>=t;--w){const L=h.charCodeAt(w);if(L===p){if(!l){r=w+1;break}continue}o===-1&&(l=!1,o=w+1),L===n?s===-1?s=w:f!==1&&(f=1):s!==-1&&(f=-1)}if(o!==-1){const L=r===0&&u?1:r;s===-1||f===0||f===1&&s===o-1&&s===r+1?a.base=a.name=h.slice(L,o):(a.name=h.slice(L,s),a.base=h.slice(L,o),a.ext=h.slice(s,o))}return r>0?a.dir=h.slice(0,r-1):u&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[105],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var M;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(M=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(S,...E){const n=E.reduce((i,b)=>(i[b]=!0,i),{}),p=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!n[i]).forEach(i=>{for(let b=0;b<p.length;b++)if(i.search(p[b])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=D}),define(J[77],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var m;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(m=e.ScanCode||(e.ScanCode={}));const M=[],D=Object.create(null),S=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>S[n]||0,toEnum:n=>D[n]||0,toString:n=>M[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class E{constructor(p,g,i,b,k){this.ctrlKey=p,this.shiftKey=g,this.altKey=i,this.metaKey=b,this.scanCode=k}equals(p){return this.ctrlKey===p.ctrlKey&&this.shiftKey===p.shiftKey&&this.altKey===p.altKey&&this.metaKey===p.metaKey&&this.scanCode===p.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=E,function(){function n(p,g){M[p]=g,D[g]=p,S[g.toLowerCase()]=p}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let p=0;p<=193;p++)e.IMMUTABLE_CODE_TO_KEY_CODE[p]=-1;for(let p=0;p<=112;p++)e.IMMUTABLE_KEY_CODE_TO_CODE[p]=-1;function n(p,g){e.IMMUTABLE_CODE_TO_KEY_CODE[p]=g,g!==0&&g!==3&&g!==5&&g!==4&&g!==6&&g!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[g]=p)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(J[106],Z([0,1,57,77]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(E){E=E.toLowerCase().trim();let n=!1,p=!1,g=!1,i=!1,b;do b=!1,/^ctrl(\+|\-)/.test(E)&&(n=!0,E=E.substr("ctrl-".length),b=!0),/^shift(\+|\-)/.test(E)&&(p=!0,E=E.substr("shift-".length),b=!0),/^alt(\+|\-)/.test(E)&&(g=!0,E=E.substr("alt-".length),b=!0),/^meta(\+|\-)/.test(E)&&(i=!0,E=E.substr("meta-".length),b=!0),/^win(\+|\-)/.test(E)&&(i=!0,E=E.substr("win-".length),b=!0),/^cmd(\+|\-)/.test(E)&&(i=!0,E=E.substr("cmd-".length),b=!0);while(b);let k;const y=E.indexOf(" ");return y>0?(k=E.substring(0,y),E=E.substring(y)):(k=E,E=""),{remains:E,ctrl:n,shift:p,alt:g,meta:i,key:k}}static parseSimpleKeybinding(E){const n=this._readModifiers(E),p=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,p),n.remains]}static parseKeybinding(E,n){if(!E)return null;const p=[];let g;do[g,E]=this.parseSimpleKeybinding(E),p.push(g);while(E.length>0);return new m.ChordKeybinding(p)}static parseSimpleUserBinding(E){const n=this._readModifiers(E),p=n.key.match(/^\[([^\]]+)\]$/);if(p){const i=p[1],b=M.ScanCodeUtils.lowerCaseToEnum(i);return[new M.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,b),n.remains]}const g=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,g),n.remains]}static parseUserBinding(E){if(!E)return[];const n=[];let p;for(;E.length>0;)[p,E]=this.parseSimpleUserBinding(E),n.push(p);return n}}e.KeybindingParser=D}),define(J[107],Z([0,1,3]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const M=m.globals.performance&&typeof m.globals.performance.now=="function";class D{constructor(E){this._highResolution=M&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new D(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=D}),define(J[5],Z([0,1,16,43,2,104,107]),function(V,e,m,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(h){h.None=()=>D.Disposable.None;function a(Q){return(U,$=null,F)=>{let N=!1,B;return B=Q(W=>{if(!N)return B?B.dispose():N=!0,U.call($,W)},null,F),N&&B.dispose(),B}}h.once=a;function u(Q,U){return w(($,F=null,N)=>Q(B=>$.call(F,U(B)),null,N))}h.map=u;function t(Q,U){return w(($,F=null,N)=>Q(B=>{U(B),$.call(F,B)},null,N))}h.forEach=t;function s(Q,U){return w(($,F=null,N)=>Q(B=>U(B)&&$.call(F,B),null,N))}h.filter=s;function r(Q){return Q}h.signal=r;function o(...Q){return(U,$=null,F)=>(0,D.combinedDisposable)(...Q.map(N=>N(B=>U.call($,B),null,F)))}h.any=o;function l(Q,U,$){let F=$;return u(Q,N=>(F=U(F,N),F))}h.reduce=l;function w(Q){let U;const $=new k({onFirstListenerAdd(){U=Q($.fire,$)},onLastListenerRemove(){U.dispose()}});return $.event}function f(Q,U,$=100,F=!1,N){let B,W,z,T=0;const A=new k({leakWarningThreshold:N,onFirstListenerAdd(){B=Q(O=>{T++,W=U(W,O),F&&!z&&(A.fire(W),W=void 0),clearTimeout(z),z=setTimeout(()=>{const H=W;W=void 0,z=void 0,(!F||T>1)&&A.fire(H),T=0},$)})},onLastListenerRemove(){B.dispose()}});return A.event}h.debounce=f;function L(Q,U=($,F)=>$===F){let $=!0,F;return s(Q,N=>{const B=$||!U(N,F);return $=!1,F=N,B})}h.latch=L;function R(Q,U){return[h.filter(Q,U),h.filter(Q,$=>!U($))]}h.split=R;function _(Q,U=!1,$=[]){let F=$.slice(),N=Q(z=>{F?F.push(z):W.fire(z)});const B=()=>{F&&F.forEach(z=>W.fire(z)),F=null},W=new k({onFirstListenerAdd(){N||(N=Q(z=>W.fire(z)))},onFirstListenerDidAdd(){F&&(U?setTimeout(B):B())},onLastListenerRemove(){N&&N.dispose(),N=null}});return W.event}h.buffer=_;class C{constructor(U){this.event=U}map(U){return new C(u(this.event,U))}forEach(U){return new C(t(this.event,U))}filter(U){return new C(s(this.event,U))}reduce(U,$){return new C(l(this.event,U,$))}latch(){return new C(L(this.event))}debounce(U,$=100,F=!1,N){return new C(f(this.event,U,$,F,N))}on(U,$,F){return this.event(U,$,F)}once(U,$,F){return a(this.event)(U,$,F)}}function K(Q){return new C(Q)}h.chain=K;function x(Q,U,$=F=>F){const F=(...z)=>W.fire($(...z)),N=()=>Q.on(U,F),B=()=>Q.removeListener(U,F),W=new k({onFirstListenerAdd:N,onLastListenerRemove:B});return W.event}h.fromNodeEventEmitter=x;function ie(Q,U,$=F=>F){const F=(...z)=>W.fire($(...z)),N=()=>Q.addEventListener(U,F),B=()=>Q.removeEventListener(U,F),W=new k({onFirstListenerAdd:N,onLastListenerRemove:B});return W.event}h.fromDOMEventEmitter=ie;function G(Q){return new Promise(U=>a(Q)(U))}h.toPromise=G})(n=e.Event||(e.Event={}));class p{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${p._idPool++}`}start(a){this._stopWatch=new E.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let g=-1;function i(h){const a=g;return g=h,{dispose(){g=a}}}e.setGlobalLeakWarningThreshold=i;class b{constructor(a,u=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let u=g;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||a<u)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let r,o=0;for(const[l,w]of this._stacks)(!r||o<w)&&(r=l,o=w);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${o}):`),console.warn(r)}return()=>{const r=this._stacks.get(t)||0;this._stacks.set(t,r-1)}}}class k{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=g>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0}get event(){return this._event||(this._event=(a,u,t)=>{this._listeners||(this._listeners=new S.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(u?[a,u]:a);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,u);const o=this._leakageMon?.check(this._listeners.size),l=(0,D.toDisposable)(()=>{o&&o(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof D.DisposableStore?t.add(l):Array.isArray(t)&&t.push(l),l}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let u of this._listeners)this._deliveryQueue.push([u,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[u,t]=this._deliveryQueue.shift();try{typeof u=="function"?u.call(void 0,t):u[0].call(u[1],t)}catch(s){(0,m.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=k;class y extends k{async fireAsync(a,u,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,a]);for(;this._asyncDeliveryQueue.size>0&&!u.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),o=[],l={...r,waitUntil:w=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");t&&(w=t(w,typeof s=="function"?s:s[0])),o.push(w)}};try{typeof s=="function"?s.call(void 0,l):s[0].call(s[1],l)}catch(w){(0,m.onUnexpectedError)(w);continue}Object.freeze(o),await Promise.allSettled(o).then(w=>{for(const f of w)f.status==="rejected"&&(0,m.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=y;class d extends k{constructor(a){super(a);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=d;class v extends d{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=v;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new k({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const u={event:a,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const t=()=>{this.hasListeners&&this.unhook(u);const s=this.events.indexOf(u);this.events.splice(s,1)};return(0,D.toDisposable)((0,M.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(u=>this.emitter.fire(u))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class I{constructor(){this.buffers=[]}wrapEvent(a){return(u,t,s)=>a(r=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>u.call(t,r)):u.call(t,r)},void 0,s)}bufferEvents(a){const u=[];this.buffers.push(u);const t=a();return this.buffers.pop(),u.forEach(s=>s()),t}}e.EventBufferer=I;class c{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=D.Disposable.None,this.emitter=new k({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(J[25],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const M=Object.freeze(function(n,p){const g=setTimeout(n.bind(p),0);return{dispose(){clearTimeout(g)}}});var D;(function(n){function p(g){return g===n.None||g===n.Cancelled||g instanceof S?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}n.isCancellationToken=p,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(D=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=D.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=E}),define(J[108],Z([0,1,5]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(b){const k=this._icons.get(b.id);k?b.description?k.description=b.description:console.error(`Duplicate registration of codicon ${b.id}`):(this._icons.set(b.id,b),this._onDidRegister.fire(b))}get(b){return this._icons.get(b)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new M;e.iconRegistry=D;function S(i,b){return new n(i,b)}e.registerCodicon=S;function E(i){return i?i.replace(/\$\((.*?)\)/g,(b,k)=>` ${k} `).trim():""}e.getCodiconAriaLabel=E;class n{constructor(b,k,y){this.id=b,this.definition=k,this.description=y,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function p(i,b){const k=["codicon","codicon-"+i];return b&&k.push("codicon-modifier-"+b),k}e.getClassNamesArray=p;var g;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const b=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function k(v){if(v instanceof n)return["codicon","codicon-"+v.id];const P=b.exec(v.id);if(!P)return k(n.error);let[,I,c]=P;const h=["codicon","codicon-"+I];return c&&h.push("codicon-modifier-"+c.substr(1)),h}i.asClassNameArray=k;function y(v){return k(v).join(" ")}i.asClassName=y;function d(v){return"."+k(v).join(".")}i.asCSSSelector=d})(g=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(J[64],Z([0,1,16,2]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(h){const a=h;return a?[a.on,a.pause,a.resume,a.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=D;function S(h){const a=h;return a?D(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=S;function E(h,a){return new n(h,a)}e.newWriteableStream=E;class n{constructor(a,u){this.reducer=a,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(u=>u(a))}emitError(a){this.listeners.error.length===0?(0,m.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(u=>u(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,u){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(a,u){if(this.state.destroyed)return;let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(u);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(h,a){const u=[];let t;for(;(t=h.read())!==null;)u.push(t);return a(u)}e.consumeReadable=p;function g(h,a,u){const t=[];let s;for(;(s=h.read())!==null&&t.length<u;)t.push(s);return s===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return h.read()}}}e.peekReadable=g;function i(h,a){return new Promise((u,t)=>{const s=[];b(h,{onData:r=>{a&&s.push(r)},onError:r=>{a?t(r):u(void 0)},onEnd:()=>{u(a?a(s):void 0)}})})}e.consumeStream=i;function b(h,a){h.on("error",u=>a.onError(u)),h.on("end",()=>a.onEnd()),h.on("data",u=>a.onData(u))}e.listenStream=b;function k(h,a){return new Promise((u,t)=>{const s=new M.DisposableStore,r=[],o=f=>{if(r.push(f),r.length>a)return s.dispose(),h.pause(),u({stream:h,buffer:r,ended:!1})},l=f=>t(f),w=()=>u({stream:h,buffer:r,ended:!0});s.add((0,M.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),s.add((0,M.toDisposable)(()=>h.removeListener("end",w))),h.on("end",w),s.add((0,M.toDisposable)(()=>h.removeListener("data",o))),h.on("data",o)})}e.peekStream=k;function y(h,a){const u=E(a);return u.end(h),u}e.toStream=y;function d(){const h=E(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function v(h){let a=!1;return{read:()=>a?null:(a=!0,h)}}e.toReadable=v;function P(h,a,u){const t=E(u);return b(h,{onData:s=>t.write(a.data(s)),onError:s=>t.error(a.error?a.error(s):s),onEnd:()=>t.end()}),t}e.transform=P;function I(h,a,u){let t=!1;return{read:()=>{const s=a.read();return t?s:(t=!0,s!==null?u([h,s]):h)}}}e.prefixedReadable=I;function c(h,a,u){let t=!1;const s=E(u);return b(a,{onData:r=>t?s.write(r):(t=!0,s.write(u([h,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(h)),s.end()}}),s}e.prefixedStream=c}),define(J[23],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=m;const M=/{(\d+)}/g;function D(j,...te){return te.length===0?j:j.replace(M,function(oe,le){const fe=parseInt(le,10);return isNaN(fe)||fe<0||fe>=te.length?oe:te[fe]})}e.format=D;const S=/{([^}]+)}/g;function E(j,te){return j.replace(S,(oe,le)=>te[le]??oe)}e.format2=E;function n(j){return j.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=n;function p(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function g(j,te){let oe=0;const le=te.charCodeAt(0);for(let fe=j.length-1;fe>=0;fe--)j.charCodeAt(fe)===le&&oe++;return oe}e.count=g;function i(j,te,oe="\u2026"){return j.length<=te?j:`${j.substr(0,te)}${oe}`}e.truncate=i;function b(j,te=" "){const oe=k(j,te);return y(oe,te)}e.trim=b;function k(j,te){if(!j||!te)return j;const oe=te.length;if(oe===0||j.length===0)return j;let le=0;for(;j.indexOf(te,le)===le;)le=le+oe;return j.substring(le)}e.ltrim=k;function y(j,te){if(!j||!te)return j;const oe=te.length,le=j.length;if(oe===0||le===0)return j;let fe=le,Se=-1;for(;Se=j.lastIndexOf(te,fe-1),!(Se===-1||Se+oe!==fe);){if(Se===0)return"";fe=Se}return j.substring(0,fe)}e.rtrim=y;function d(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function v(j){return j.replace(/\*/g,"")}e.stripWildcards=v;function P(j,te,oe={}){if(!j)throw new Error("Cannot create regex from empty string");te||(j=p(j)),oe.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let le="";return oe.global&&(le+="g"),oe.matchCase||(le+="i"),oe.multiline&&(le+="m"),oe.unicode&&(le+="u"),new RegExp(j,le)}e.createRegExp=P;function I(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function c(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function h(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=h;function a(j){return j.split(/\r\n|\r|\n/)}e.splitLines=a;function u(j){for(let te=0,oe=j.length;te<oe;te++){const le=j.charCodeAt(te);if(le!==32&&le!==9)return te}return-1}e.firstNonWhitespaceIndex=u;function t(j,te=0,oe=j.length){for(let le=te;le<oe;le++){const fe=j.charCodeAt(le);if(fe!==32&&fe!==9)return j.substring(te,le)}return j.substring(te,oe)}e.getLeadingWhitespace=t;function s(j,te=j.length-1){for(let oe=te;oe>=0;oe--){const le=j.charCodeAt(oe);if(le!==32&&le!==9)return oe}return-1}e.lastNonWhitespaceIndex=s;function r(j,te){return j<te?-1:j>te?1:0}e.compare=r;function o(j,te,oe=0,le=j.length,fe=0,Se=te.length){for(;oe<le&&fe<Se;oe++,fe++){let ue=j.charCodeAt(oe),ge=te.charCodeAt(fe);if(ue<ge)return-1;if(ue>ge)return 1}const Pe=le-oe,Fe=Se-fe;return Pe<Fe?-1:Pe>Fe?1:0}e.compareSubstring=o;function l(j,te){return w(j,te,0,j.length,0,te.length)}e.compareIgnoreCase=l;function w(j,te,oe=0,le=j.length,fe=0,Se=te.length){for(;oe<le&&fe<Se;oe++,fe++){let ue=j.charCodeAt(oe),ge=te.charCodeAt(fe);if(ue===ge)continue;const pe=ue-ge;if(!(pe===32&&L(ge))&&!(pe===-32&&L(ue)))return f(ue)&&f(ge)?pe:o(j.toLowerCase(),te.toLowerCase(),oe,le,fe,Se)}const Pe=le-oe,Fe=Se-fe;return Pe<Fe?-1:Pe>Fe?1:0}e.compareSubstringIgnoreCase=w;function f(j){return j>=97&&j<=122}e.isLowerAsciiLetter=f;function L(j){return j>=65&&j<=90}e.isUpperAsciiLetter=L;function R(j){return f(j)||L(j)}function _(j,te){return j.length===te.length&&C(j,te)}e.equalsIgnoreCase=_;function C(j,te,oe=j.length){for(let le=0;le<oe;le++){const fe=j.charCodeAt(le),Se=te.charCodeAt(le);if(fe!==Se){if(R(fe)&&R(Se)){const Pe=Math.abs(fe-Se);if(Pe!==0&&Pe!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(Se).toLowerCase())return!1}}return!0}function K(j,te){const oe=te.length;return te.length>j.length?!1:C(j,te,oe)}e.startsWithIgnoreCase=K;function x(j,te){let oe,le=Math.min(j.length,te.length);for(oe=0;oe<le;oe++)if(j.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return le}e.commonPrefixLength=x;function ie(j,te){let oe,le=Math.min(j.length,te.length);const fe=j.length-1,Se=te.length-1;for(oe=0;oe<le;oe++)if(j.charCodeAt(fe-oe)!==te.charCodeAt(Se-oe))return oe;return le}e.commonSuffixLength=ie;function G(j){return 55296<=j&&j<=56319}e.isHighSurrogate=G;function Q(j){return 56320<=j&&j<=57343}e.isLowSurrogate=Q;function U(j,te){return(j-55296<<10)+(te-56320)+65536}e.computeCodePoint=U;function $(j,te,oe){const le=j.charCodeAt(oe);if(G(le)&&oe+1<te){const fe=j.charCodeAt(oe+1);if(Q(fe))return U(le,fe)}return le}e.getNextCodePoint=$;function F(j,te){const oe=j.charCodeAt(te-1);if(Q(oe)&&te>1){const le=j.charCodeAt(te-2);if(G(le))return U(le,oe)}return oe}function N(j,te){const oe=Ce.getInstance(),le=te,fe=j.length,Se=$(j,fe,te);te+=Se>=65536?2:1;let Pe=oe.getGraphemeBreakType(Se);for(;te<fe;){const Fe=$(j,fe,te),ue=oe.getGraphemeBreakType(Fe);if($e(Pe,ue))break;te+=Fe>=65536?2:1,Pe=ue}return te-le}e.nextCharLength=N;function B(j,te){const oe=Ce.getInstance(),le=te,fe=F(j,te);te-=fe>=65536?2:1;let Se=oe.getGraphemeBreakType(fe);for(;te>0;){const Pe=F(j,te),Fe=oe.getGraphemeBreakType(Pe);if($e(Fe,Se))break;te-=Pe>=65536?2:1,Se=Fe}return le-te}e.prevCharLength=B;function W(j,te){const oe=Ce.getInstance(),le=j.length,fe=te,Se=$(j,le,te),Pe=oe.getGraphemeBreakType(Se);te+=Se>=65536?2:1;let Fe=Pe;for(;te<le;){const ge=$(j,le,te),pe=oe.getGraphemeBreakType(ge);if($e(Fe,pe))break;te+=ge>=65536?2:1,Fe=pe}const ue=te;for(te=fe,Fe=Pe;te>0;){const ge=F(j,te),pe=oe.getGraphemeBreakType(ge);if($e(pe,Fe))break;te-=ge>=65536?2:1,Fe=pe}return[te,ue]}function z(j,te){return te>0&&Q(j.charCodeAt(te))?W(j,te-1):W(j,te)}e.getCharContainingOffset=z;function T(j){const te=j.length;let oe=0,le=0;for(;le<te;){const Pe=$(j,te,le);le+=Pe>=65536?2:1,Pe<128?oe+=1:Pe<2048?oe+=2:Pe<65536?oe+=3:oe+=4}const fe=new Uint8Array(oe);le=0;let Se=0;for(;le<te;){const Pe=$(j,te,le);le+=Pe>=65536?2:1,Pe<128?fe[Se++]=Pe:Pe<2048?(fe[Se++]=192|(Pe&1984)>>>6,fe[Se++]=128|(Pe&63)>>>0):Pe<65536?(fe[Se++]=224|(Pe&61440)>>>12,fe[Se++]=128|(Pe&4032)>>>6,fe[Se++]=128|(Pe&63)>>>0):(fe[Se++]=240|(Pe&1835008)>>>18,fe[Se++]=128|(Pe&258048)>>>12,fe[Se++]=128|(Pe&4032)>>>6,fe[Se++]=128|(Pe&63)>>>0)}return fe}e.encodeUTF8=T;function A(j){const te=j.byteLength,oe=[];let le=0;for(;le<te;){const fe=j[le];let Se;if(fe>=240&&le+3<te?Se=(j[le++]&7)<<18>>>0|(j[le++]&63)<<12>>>0|(j[le++]&63)<<6>>>0|(j[le++]&63)<<0>>>0:fe>=224&&le+2<te?Se=(j[le++]&15)<<12>>>0|(j[le++]&63)<<6>>>0|(j[le++]&63)<<0>>>0:fe>=192&&le+1<te?Se=(j[le++]&31)<<6>>>0|(j[le++]&63)<<0>>>0:Se=j[le++],Se>=0&&Se<=55295||Se>=57344&&Se<=65535)oe.push(String.fromCharCode(Se));else if(Se>=65536&&Se<=1114111){const Pe=Se-65536,Fe=55296+((Pe&1047552)>>>10),ue=56320+((Pe&1023)>>>0);oe.push(String.fromCharCode(Fe)),oe.push(String.fromCharCode(ue))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=A;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function H(j){return O.test(j)}e.containsRTL=H;const Y=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function q(j){return Y.test(j)}e.containsEmoji=q;const X=/^[\t\n\r\x20-\x7E]*$/;function ne(j){return X.test(j)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=se;function ae(j){for(let te=0,oe=j.length;te<oe;te++)if(de(j.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ae;function de(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=de;function re(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=re;function ce(j,te){if(j.length<te)return j;const oe=/\b/g;let le=0;for(;oe.test(j)&&!(j.length-oe.lastIndex<te);)le=oe.lastIndex,oe.lastIndex+=1;return j.substring(le).replace(/^\s/,"")}e.lcut=ce;const be=/\x1B\x5B[12]?K/g,ve=/\x1b\[\d+m/g,Ee=/\x1b\[0?m/g;function Te(j){return j&&(j=j.replace(be,""),j=j.replace(ve,""),j=j.replace(Ee,"")),j}e.removeAnsiEscapeCodes=Te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ye(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ye;function we(j){return ye(j)?j.substr(1):j}e.stripUTF8BOM=we;function Ie(j,te){if(!j||!te||j.length<te.length)return!1;const oe=te.length,le=j.toLowerCase();let fe=0,Se=-1;for(;fe<oe;){const Pe=le.indexOf(te[fe],Se+1);if(Pe<0)return!1;Se=Pe,fe++}return!0}e.fuzzyContains=Ie;function De(j,te=!1){return j?(te&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=De;function Oe(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=Oe;function Ue(j,te=1){if(te===0)return"";let oe=-1;do oe=j.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?j:(j[oe-1]==="\r"&&oe--,j.substr(0,oe))}e.getNLines=Ue;function je(j){const te=90-65+1;return j=j%(2*te),j<te?String.fromCharCode(97+j):String.fromCharCode(65+j-te)}e.singleLetterHash=je;function Qe(j){return Ce.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=Qe;function $e(j,te){return j===0?te!==5&&te!==7:j===2&&te===3?!1:j===4||j===2||j===3||te===4||te===2||te===3?!0:!(j===8&&(te===8||te===9||te===11||te===12)||(j===11||j===9)&&(te===9||te===10)||(j===12||j===10)&&te===10||te===5||te===13||te===7||j===1||j===13&&te===14||j===6&&te===6)}e.breakBetweenGraphemeBreakType=$e;var nt;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(nt=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=ct()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,le=oe.length/3;let fe=1;for(;fe<=le;)if(te<oe[3*fe])fe=2*fe;else if(te>oe[3*fe+1])fe=2*fe+1;else return oe[3*fe+2];return 0}}Ce._INSTANCE=null;function ct(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Je(j,te){if(j===0)return 0;const oe=ut(j,te);if(oe!==void 0)return oe;const le=F(te,j);return j-=Ke(le),j}e.getLeftDeleteOffset=Je;function ut(j,te){let oe=F(te,j);for(j-=Ke(oe);rt(oe)||oe===65039||oe===8419;){if(j===0)return;oe=F(te,j),j-=Ke(oe)}if(!!re(oe)){if(j>=0){const le=F(te,j);le===8205&&(j-=Ke(le))}return j}}function Ke(j){return j>=65536?2:1}function rt(j){return 127995<=j&&j<=127999}var st;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={}))}),define(J[17],Z([0,1,23,64]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",E=typeof TextDecoder!="undefined";let n,p;class g{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return D?new g(Buffer.allocUnsafe(f)):new g(new Uint8Array(f))}static wrap(f){return D&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new g(f)}static fromString(f,L){return!(L?.dontUseNodeBuffer||!1)&&D?new g(Buffer.from(f)):S?(n||(n=new TextEncoder),new g(n.encode(f))):new g(m.encodeUTF8(f))}static concat(f,L){if(typeof L=="undefined"){L=0;for(let C=0,K=f.length;C<K;C++)L+=f[C].byteLength}const R=g.alloc(L);let _=0;for(let C=0,K=f.length;C<K;C++){const x=f[C];R.set(x,_),_+=x.byteLength}return R}toString(){return D?this.buffer.toString():E?(p||(p=new TextDecoder),p.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(f,L){return new g(this.buffer.subarray(f,L))}set(f,L){f instanceof g?this.buffer.set(f.buffer,L):this.buffer.set(f,L)}readUInt32BE(f){return k(this.buffer,f)}writeUInt32BE(f,L){y(this.buffer,f,L)}readUInt32LE(f){return d(this.buffer,f)}writeUInt32LE(f,L){v(this.buffer,f,L)}readUInt8(f){return P(this.buffer,f)}writeUInt8(f,L){I(this.buffer,f,L)}}e.VSBuffer=g;function i(w,f){return w[f+0]<<0>>>0|w[f+1]<<8>>>0}e.readUInt16LE=i;function b(w,f,L){w[L+0]=f&255,f=f>>>8,w[L+1]=f&255}e.writeUInt16LE=b;function k(w,f){return w[f]*2**24+w[f+1]*2**16+w[f+2]*2**8+w[f+3]}e.readUInt32BE=k;function y(w,f,L){w[L+3]=f,f=f>>>8,w[L+2]=f,f=f>>>8,w[L+1]=f,f=f>>>8,w[L]=f}e.writeUInt32BE=y;function d(w,f){return w[f+0]<<0>>>0|w[f+1]<<8>>>0|w[f+2]<<16>>>0|w[f+3]<<24>>>0}e.readUInt32LE=d;function v(w,f,L){w[L+0]=f&255,f=f>>>8,w[L+1]=f&255,f=f>>>8,w[L+2]=f&255,f=f>>>8,w[L+3]=f&255}e.writeUInt32LE=v;function P(w,f){return w[f]}e.readUInt8=P;function I(w,f,L){w[L]=f}e.writeUInt8=I;function c(w){return M.consumeReadable(w,f=>g.concat(f))}e.readableToBuffer=c;function h(w){return M.toReadable(w)}e.bufferToReadable=h;function a(w){return M.consumeStream(w,f=>g.concat(f))}e.streamToBuffer=a;async function u(w){return w.ended?g.concat(w.buffer):g.concat([...w.buffer,await a(w.stream)])}e.bufferedStreamToBuffer=u;function t(w){return M.toStream(w,f=>g.concat(f))}e.bufferToStream=t;function s(w){return M.transform(w,{data:f=>typeof f=="string"?g.fromString(f):g.wrap(f)},f=>g.concat(f))}e.streamToBufferReadableStream=s;function r(w){return M.newWriteableStream(f=>g.concat(f),w)}e.newWriteableBufferStream=r;function o(w,f){return M.prefixedReadable(w,f,L=>g.concat(L))}e.prefixedBufferReadable=o;function l(w,f){return M.prefixedStream(w,f,L=>g.concat(L))}e.prefixedBufferStream=l}),define(J[78],Z([0,1,23]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function M(I){return D(I,0)}e.hash=M;function D(I,c){switch(typeof I){case"object":return I===null?S(349,c):Array.isArray(I)?p(I,c):g(I,c);case"string":return n(I,c);case"boolean":return E(I,c);case"number":return S(I,c);case"undefined":return S(937,c);default:return S(617,c)}}e.doHash=D;function S(I,c){return(c<<5)-c+I|0}function E(I,c){return S(I?433:863,c)}function n(I,c){c=S(149417,c);for(let h=0,a=I.length;h<a;h++)c=S(I.charCodeAt(h),c);return c}e.stringHash=n;function p(I,c){return c=S(104579,c),I.reduce((h,a)=>D(a,h),c)}function g(I,c){return c=S(181387,c),Object.keys(I).sort().reduce((h,a)=>(h=n(a,h),D(I[a],h)),c)}class i{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=D(c,this._value),this._value}}e.Hasher=i;var b;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function k(I,c,h=32){const a=h-c,u=~((1<<a)-1);return(I<<c|(u&I)>>>a)>>>0}function y(I,c=0,h=I.byteLength,a=0){for(let u=0;u<h;u++)I[c+u]=a}function d(I,c,h="0"){for(;I.length<c;)I=h+I;return I}function v(I,c=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((I>>>0).toString(16),c/4)}e.toHexString=v;class P{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const h=c.length;if(h===0)return;const a=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=c.charCodeAt(0),r=0);;){let o=s;if(m.isHighSurrogate(s))if(r+1<h){const l=c.charCodeAt(r+1);m.isLowSurrogate(l)?(r++,o=m.computeCodePoint(s,l)):o=65533}else{t=s;break}else m.isLowSurrogate(s)&&(o=65533);if(u=this._push(a,u,o),r++,r<h)s=c.charCodeAt(r);else break}this._buffLen=u,this._leftoverHighSurrogate=t}_push(c,h,a){return a<128?c[h++]=a:a<2048?(c[h++]=192|(a&1984)>>>6,c[h++]=128|(a&63)>>>0):a<65536?(c[h++]=224|(a&61440)>>>12,c[h++]=128|(a&4032)>>>6,c[h++]=128|(a&63)>>>0):(c[h++]=240|(a&1835008)>>>18,c[h++]=128|(a&258048)>>>12,c[h++]=128|(a&4032)>>>6,c[h++]=128|(a&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=P._bigBlock32,h=this._buffDV;for(let f=0;f<64;f+=4)c.setUint32(f,h.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)c.setUint32(f,k(c.getUint32(f-12,!1)^c.getUint32(f-32,!1)^c.getUint32(f-56,!1)^c.getUint32(f-64,!1),1),!1);let a=this._h0,u=this._h1,t=this._h2,s=this._h3,r=this._h4,o,l,w;for(let f=0;f<80;f++)f<20?(o=u&t|~u&s,l=1518500249):f<40?(o=u^t^s,l=1859775393):f<60?(o=u&t|u&s|t&s,l=2400959708):(o=u^t^s,l=3395469782),w=k(a,5)+o+r+l+c.getUint32(f*4,!1)&4294967295,r=s,s=t,t=k(u,30),u=a,a=w;this._h0=this._h0+a&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=P,P._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(f){return Array.isArray(f)}e.isArray=m;function M(f){return typeof f=="string"}e.isString=M;function D(f){return Array.isArray(f)&&f.every(L=>M(L))}e.isStringArray=D;function S(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=S;function E(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=E;function n(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=n;function p(f){return f===!0||f===!1}e.isBoolean=p;function g(f){return typeof f=="undefined"}e.isUndefined=g;function i(f){return!b(f)}e.isDefined=i;function b(f){return g(f)||f===null}e.isUndefinedOrNull=b;function k(f,L){if(!f)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}e.assertType=k;function y(f){if(b(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=y;function d(...f){const L=[];for(let R=0;R<f.length;R++){const _=f[R];if(b(_))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);L.push(_)}return L}e.assertAllDefined=d;const v=Object.prototype.hasOwnProperty;function P(f){if(!S(f))return!1;for(let L in f)if(v.call(f,L))return!1;return!0}e.isEmptyObject=P;function I(f){return typeof f=="function"}e.isFunction=I;function c(...f){return f.length>0&&f.every(I)}e.areFunctions=c;function h(f,L){const R=Math.min(f.length,L.length);for(let _=0;_<R;_++)a(f[_],L[_])}e.validateConstraints=h;function a(f,L){if(M(L)){if(typeof f!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(I(L)){try{if(f instanceof L)return}catch{}if(!b(f)&&f.constructor===L||L.length===1&&L.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function u(f){let L=[],R=Object.getPrototypeOf(f);for(;Object.prototype!==R;)L=L.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return L}e.getAllPropertyNames=u;function t(f){const L=[];for(const R of u(f))typeof f[R]=="function"&&L.push(R);return L}e.getAllMethodNames=t;function s(f,L){const R=C=>function(){const K=Array.prototype.slice.call(arguments,0);return L(C,K)};let _={};for(const C of f)_[C]=R(C);return _}e.createProxyObject=s;function r(f){return f===null?void 0:f}e.withNullAsUndefined=r;function o(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=o;function l(f){return class{constructor(){return new Proxy({},{get(L,R){if(L[R])return L[R];throw new Error(`Not Implemented: ${f}->${String(R)}`)}})}}}e.NotImplementedProxy=l;function w(f,L="Unreachable"){throw new Error(L)}e.assertNever=w}),define(J[30],Z([0,1,3,23,8,13]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(r){return r===47||r===92}e.isPathSeparator=E;function n(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=n;function p(r){return r.indexOf("/")===-1&&(r=n(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=p;function g(r,o=D.posix.sep){if(!r)return"";const l=r.length,w=r.charCodeAt(0);if(E(w)){if(E(r.charCodeAt(1))&&!E(r.charCodeAt(2))){let L=3;const R=L;for(;L<l&&!E(r.charCodeAt(L));L++);if(R!==L&&!E(r.charCodeAt(L+1))){for(L+=1;L<l;L++)if(E(r.charCodeAt(L)))return r.slice(0,L+1).replace(/[\\/]/g,o)}}return o}else if(I(w)&&r.charCodeAt(1)===58)return E(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<l;f++)if(E(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=g;function i(r){if(!m.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let l=2;const w=l;for(;l<r.length&&(o=r.charCodeAt(l),o!==92);l++);return!(w===l||(o=r.charCodeAt(l+1),isNaN(o)||o===92))}e.isUNC=i;const b=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,o=m.isWindows){const l=o?b:k;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||o&&y.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function v(r,o,l){const w=r===o;return!l||w?w:!r||!o?!1:(0,M.equalsIgnoreCase)(r,o)}e.isEqual=v;function P(r,o,l,w=D.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(l){if(!(0,M.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let L=o.length;return o.charAt(o.length-1)===w&&L--,r.charAt(L)===w}return o.charAt(o.length-1)!==w&&(o+=w),r.indexOf(o)===0}e.isEqualOrParent=P;function I(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=I;function c(r,o){return m.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(o,r)),r=(0,D.normalize)(r),m.isWindows?(r=(0,M.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,M.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=c;function h(r){const o=(0,D.normalize)(r);return m.isWindows?r.length>3?!1:a(o)&&(r.length===2||o.charCodeAt(2)===92):o===D.posix.sep}e.isRootOrDriveLetter=h;function a(r){return m.isWindows?I(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function u(r){return a(r)?r[0]:void 0}e.getDriveLetter=u;function t(r,o,l){return o.length>r.length?-1:r===o?0:(l&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=t;function s(r){const o=r.split(":");let l,w,f;if(o.forEach(L=>{const R=Number(L);(0,S.isNumber)(R)?w===void 0?w=R:f===void 0&&(f=R):l=l?[l,L].join(":"):L}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:w!==void 0?w:void 0,column:f!==void 0?f:w!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(J[44],Z([0,1,13]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const P=Array.isArray(v)?[]:{};return Object.keys(v).forEach(I=>{v[I]&&typeof v[I]=="object"?P[I]=M(v[I]):P[I]=v[I]}),P}e.deepClone=M;function D(v){if(!v||typeof v!="object")return v;const P=[v];for(;P.length>0;){const I=P.shift();Object.freeze(I);for(const c in I)if(S.call(I,c)){const h=I[c];typeof h=="object"&&!Object.isFrozen(h)&&P.push(h)}}return v}e.deepFreeze=D;const S=Object.prototype.hasOwnProperty;function E(v,P){return n(v,P,new Set)}e.cloneAndChange=E;function n(v,P,I){if((0,m.isUndefinedOrNull)(v))return v;const c=P(v);if(typeof c!="undefined")return c;if((0,m.isArray)(v)){const h=[];for(const a of v)h.push(n(a,P,I));return h}if((0,m.isObject)(v)){if(I.has(v))throw new Error("Cannot clone recursive data-structure");I.add(v);const h={};for(let a in v)S.call(v,a)&&(h[a]=n(v[a],P,I));return I.delete(v),h}return v}function p(v,P,I=!0){return(0,m.isObject)(v)?((0,m.isObject)(P)&&Object.keys(P).forEach(c=>{c in v?I&&((0,m.isObject)(v[c])&&(0,m.isObject)(P[c])?p(v[c],P[c],I):v[c]=P[c]):v[c]=P[c]}),v):P}e.mixin=p;function g(v,P){if(v===P)return!0;if(v==null||P===null||P===void 0||typeof v!=typeof P||typeof v!="object"||Array.isArray(v)!==Array.isArray(P))return!1;let I,c;if(Array.isArray(v)){if(v.length!==P.length)return!1;for(I=0;I<v.length;I++)if(!g(v[I],P[I]))return!1}else{const h=[];for(c in v)h.push(c);h.sort();const a=[];for(c in P)a.push(c);if(a.sort(),!g(h,a))return!1;for(I=0;I<h.length;I++)if(!g(v[h[I]],P[h[I]]))return!1}return!0}e.equals=g;function i(v){const P=new Set;return JSON.stringify(v,(I,c)=>{if((0,m.isObject)(c)||Array.isArray(c)){if(P.has(c))return"[Circular]";P.add(c)}return c})}e.safeStringify=i;function b(v,P,I){const c=P(v);return typeof c=="undefined"?I:c}e.getOrDefault=b;function k(v,P){const I=Object.create(null);return!v||!P||Object.keys(P).forEach(h=>{const a=v[h],u=P[h];g(a,u)||(I[h]=u)}),I}e.distinct=k;function y(v,P){const I=P.toLowerCase(),c=Object.keys(v).find(h=>h.toLowerCase()===I);return c?v[c]:v[P]}e.getCaseInsensitive=y;function d(v,P){const I=Object.create(null);for(const c of Object.keys(v))P(c,v[c])&&(I[c]=v[c]);return I}e.filter=d}),define(J[7],Z([0,1,3,8]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,S=/^\//,E=/^\/\//;function n(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!S.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(r,o){return!r&&!o?"file":r}function g(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==b&&(o=b+o):o=b;break}return o}const i="",b="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(o,l,w,f,L,R=!1){typeof o=="object"?(this.scheme=o.scheme||i,this.authority=o.authority||i,this.path=o.path||i,this.query=o.query||i,this.fragment=o.fragment||i):(this.scheme=p(o,R),this.authority=l||i,this.path=g(this.scheme,w||i),this.query=f||i,this.fragment=L||i,n(this,R))}static isUri(o){return o instanceof y?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return h(this,!1)}with(o){if(!o)return this;let{scheme:l,authority:w,path:f,query:L,fragment:R}=o;return l===void 0?l=this.scheme:l===null&&(l=i),w===void 0?w=this.authority:w===null&&(w=i),f===void 0?f=this.path:f===null&&(f=i),L===void 0?L=this.query:L===null&&(L=i),R===void 0?R=this.fragment:R===null&&(R=i),l===this.scheme&&w===this.authority&&f===this.path&&L===this.query&&R===this.fragment?this:new v(l,w,f,L,R)}static parse(o,l=!1){const w=k.exec(o);return w?new v(w[2]||i,s(w[4]||i),s(w[5]||i),s(w[7]||i),s(w[9]||i),l):new v(i,i,i,i,i)}static file(o){let l=i;if(m.isWindows&&(o=o.replace(/\\/g,b)),o[0]===b&&o[1]===b){const w=o.indexOf(b,2);w===-1?(l=o.substring(2),o=b):(l=o.substring(2,w),o=o.substring(w)||b)}return new v("file",l,o,i,i)}static from(o){const l=new v(o.scheme,o.authority,o.path,o.query,o.fragment);return n(l,!0),l}static joinPath(o,...l){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return m.isWindows&&o.scheme==="file"?w=y.file(M.win32.join(h(o,!0),...l)).path:w=M.posix.join(o.path,...l),o.with({path:w})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof y)return o;{const l=new v(o);return l._formatted=o.external,l._fsPath=o._sep===d?o.fsPath:null,l}}else return o}}e.URI=y;const d=m.isWindows?1:void 0;class v extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=d),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(r,o){let l,w=-1;for(let f=0;f<r.length;f++){const L=r.charCodeAt(f);if(L>=97&&L<=122||L>=65&&L<=90||L>=48&&L<=57||L===45||L===46||L===95||L===126||o&&L===47)w!==-1&&(l+=encodeURIComponent(r.substring(w,f)),w=-1),l!==void 0&&(l+=r.charAt(f));else{l===void 0&&(l=r.substr(0,f));const R=P[L];R!==void 0?(w!==-1&&(l+=encodeURIComponent(r.substring(w,f)),w=-1),l+=R):w===-1&&(w=f)}}return w!==-1&&(l+=encodeURIComponent(r.substring(w))),l!==void 0?l:r}function c(r){let o;for(let l=0;l<r.length;l++){const w=r.charCodeAt(l);w===35||w===63?(o===void 0&&(o=r.substr(0,l)),o+=P[w]):o!==void 0&&(o+=r[l])}return o!==void 0?o:r}function h(r,o){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?o?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,m.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=h;function a(r,o){const l=o?c:I;let w="",{scheme:f,authority:L,path:R,query:_,fragment:C}=r;if(f&&(w+=f,w+=":"),(L||f==="file")&&(w+=b,w+=b),L){let K=L.indexOf("@");if(K!==-1){const x=L.substr(0,K);L=L.substr(K+1),K=x.indexOf(":"),K===-1?w+=l(x,!1):(w+=l(x.substr(0,K),!1),w+=":",w+=l(x.substr(K+1),!1)),w+="@"}L=L.toLowerCase(),K=L.indexOf(":"),K===-1?w+=l(L,!1):(w+=l(L.substr(0,K),!1),w+=L.substr(K))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const K=R.charCodeAt(1);K>=65&&K<=90&&(R=`/${String.fromCharCode(K+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const K=R.charCodeAt(0);K>=65&&K<=90&&(R=`${String.fromCharCode(K+32)}:${R.substr(2)}`)}w+=l(R,!0)}return _&&(w+="?",w+=l(_,!1)),C&&(w+="#",w+=o?C:I(C,!1)),w}function u(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+u(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,o=>u(o)):r}}),define(J[109],Z([0,1,7]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function M(g){const i=g;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=M;function D(g){const i=[];let b;try{const k=JSON.parse(g.arguments),y=k[k.length-1];y&&y.__$stack&&(k.pop(),b=y.__$stack),i.push(...k)}catch(k){i.push("Unable to log remote console arguments",g.arguments)}return{args:i,stack:b}}e.parse=D;function S(g){if(typeof g!="string")return S(D(g).stack);const i=g;if(i){const b=E(i),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(k&&k.length===4)return{uri:m.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}e.getFirstFrame=S;function E(g){if(!g)return g;const i=g.indexOf(`
`);return i===-1?g:g.substring(0,i)}function n(g,i){const{args:b,stack:k}=D(g),y=typeof b[0]=="string"&&b.length===1;let d=E(k);d&&(d=`(${d.trim()})`);let v=[];if(typeof b[0]=="string"?d&&y?v=[`%c[${i}] %c${b[0]} %c${d}`,p("blue"),p(""),p("grey")]:v=[`%c[${i}] %c${b[0]}`,p("blue"),p(""),...b.slice(1)]:v=[`%c[${i}]%`,p("blue"),...b],d&&!y&&v.push(d),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,v)}e.log=n;function p(g){return`color: ${g}`}});var bt=this&&this.__classPrivateFieldSet||function(V,e,m,M,D){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!D:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?D.call(V,m):D?D.value=m:e.set(V,m),m},He=this&&this.__classPrivateFieldGet||function(V,e,m,M){if(m==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!M:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?M:m==="a"?M.call(V):M?M.value:e.get(V)};define(J[37],Z([0,1,7,23]),function(V,e,m,M){"use strict";var D,S,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(t,s,r){let o=t.get(s);return o===void 0&&(o=r,t.set(s,o)),o}e.getOrSet=n;function p(t){const s=[];return t.forEach((r,o)=>{s.push(`${o} => ${r}`)}),`Map(${t.size}) {${s.join(", ")}}`}e.mapToString=p;function g(t){const s=[];return t.forEach(r=>{s.push(r)}),`Set(${t.size}) {${s.join(", ")}}`}e.setToString=g;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const r=s.charCodeAt(0),o=this._value.charCodeAt(this._pos);return r-o}value(){return this._value[this._pos]}}e.StringIterator=i;class b{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,M.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class k{constructor(s=!0,r=!0){this._splitOnBackslash=s,this._caseSensitive=r}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,M.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var y;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(y||(y={}));class d{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,M.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(s){this._iter=s}static forUris(s=()=>!1){return new P(new d(s))}static forPaths(){return new P(new k)}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new b)}clear(){this._root=void 0}set(s,r){const o=this._iter.reset(s);let l;for(this._root||(this._root=new v,this._root.segment=o.value()),l=this._root;;){const f=o.cmp(l.segment);if(f>0)l.left||(l.left=new v,l.left.segment=o.value()),l=l.left;else if(f<0)l.right||(l.right=new v,l.right.segment=o.value()),l=l.right;else if(o.hasNext())o.next(),l.mid||(l.mid=new v,l.mid.segment=o.value()),l=l.mid;else break}const w=l.value;return l.value=r,l.key=s,w}get(s){return this._getNode(s)?.value}_getNode(s){const r=this._iter.reset(s);let o=this._root;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(s){const r=this._getNode(s);return!(r?.value===void 0&&r?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,r){const o=this._iter.reset(s),l=[];let w=this._root;for(;w;){const f=o.cmp(w.segment);if(f>0)l.push([1,w]),w=w.left;else if(f<0)l.push([-1,w]),w=w.right;else if(o.hasNext())o.next(),l.push([0,w]),w=w.mid;else{for(r?(w.left=void 0,w.mid=void 0,w.right=void 0):w.value=void 0;l.length>0&&w.isEmpty();){let[L,R]=l.pop();switch(L){case 1:R.left=void 0;break;case 0:R.mid=void 0;break;case-1:R.right=void 0;break}w=R}break}}}findSubstr(s){const r=this._iter.reset(s);let o=this._root,l;for(;o;){const w=r.cmp(o.segment);if(w>0)o=o.left;else if(w<0)o=o.right;else if(r.hasNext())r.next(),l=o.value||l,o=o.mid;else break}return o&&o.value||l}findSuperstr(s){const r=this._iter.reset(s);let o=this._root;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(s){for(const[r,o]of this)s(o,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const r=[s];for(;r.length>0;){const o=r.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&r.push(o.left),o.mid&&r.push(o.mid),o.right&&r.push(o.right))}}}e.TernarySearchTree=P;class I{constructor(s,r){this[D]="ResourceMap",s instanceof I?(this.map=new Map(s.map),this.toKey=r??I.defaultToKey):(this.map=new Map,this.toKey=s??I.defaultToKey)}set(s,r){return this.map.set(this.toKey(s),r),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,r){typeof r!="undefined"&&(s=s.bind(r));for(let[o,l]of this.map)s(l,m.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield m.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[m.URI.parse(s[0]),s[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[m.URI.parse(s[0]),s[1]]}}e.ResourceMap=I,I.defaultToKey=t=>t.toString();var c;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class h{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,r=0){const o=this._map.get(s);if(!!o)return r!==0&&this.touch(o,r),o.value}set(s,r,o=0){let l=this._map.get(s);if(l)l.value=r,o!==0&&this.touch(l,o);else{switch(l={key:s,value:r,next:void 0,previous:void 0},o){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(s,l),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this._map.get(s);if(!!r)return this._map.delete(s),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,r){const o=this._state;let l=this._head;for(;l;){if(r?s.bind(r)(l.value,l.key,this):s(l.value,l.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const s=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const w={value:o.key,done:!1};return o=o.next,w}else return{value:void 0,done:!0}}};return l}values(){const s=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const w={value:o.value,done:!1};return o=o.next,w}else return{value:void 0,done:!0}}};return l}entries(){const s=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const w={value:[o.key,o.value],done:!1};return o=o.next,w}else return{value:void 0,done:!0}}};return l}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this._head,o=this.size;for(;r&&o>s;)this._map.delete(r.key),r=r.next,o--;this._head=r,this._size=o,r&&(r.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const r=s.next,o=s.previous;if(!r||!o)throw new Error("Invalid list");r.previous=o,o.next=r}s.next=void 0,s.previous=void 0,this._state++}touch(s,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this._head)return;const o=s.next,l=s.previous;s===this._tail?(l.next=void 0,this._tail=l):(o.previous=l,l.next=o),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(r===2){if(s===this._tail)return;const o=s.next,l=s.previous;s===this._head?(o.previous=void 0,this._head=o):(o.previous=l,l.next=o),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((r,o)=>{s.push([o,r])}),s}fromJSON(s){this.clear();for(const[r,o]of s)this.set(r,o)}}e.LinkedMap=h;class a extends h{constructor(s,r=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class u{constructor(s){E.set(this,void 0),bt(this,E,s,"f")}get size(){return He(this,E,"f").size}forEach(s,r){He(this,E,"f").forEach(s,r)}get(s){return He(this,E,"f").get(s)}has(s){return He(this,E,"f").has(s)}entries(){return He(this,E,"f").entries()}keys(){return He(this,E,"f").keys()}values(){return He(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return He(this,E,"f").entries()}}e.ReadonlyMapView=u}),define(J[110],Z([0,1,17,23,7]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function S(i){return JSON.stringify(i,p)}e.stringify=S;function E(i){let b=JSON.parse(i);return b=g(b),b}e.parse=E;var n;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function p(i,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,M.regExpFlags)(b)}:b}function g(i,b=0){if(!i||b>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof m.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let k=0;k<i.length;++k)i[k]=g(i[k],b+1);else for(const k in i)Object.hasOwnProperty.call(i,k)&&(i[k]=g(i[k],b+1))}return i}e.revive=g}),define(J[10],Z([0,1,7,3]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}set(p,g,i){this._hosts[p]=g,this._ports[p]=i}setConnectionToken(p,g){this._connectionTokens[p]=g}rewrite(p){if(this._delegate)return this._delegate(p);const g=p.authority;let i=this._hosts[g];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const b=this._ports[g],k=this._connectionTokens[g];let y=`path=${encodeURIComponent(p.path)}`;return typeof k=="string"&&(y+=`&tkn=${encodeURIComponent(k)}`),m.URI.from({scheme:M.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${b}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new S;class E{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(p,g,i){const b=this.toUri(p,g);if(b.scheme===D.vscodeRemote)return e.RemoteAuthorities.rewrite(b);let k=!1;return M.isNative&&(i||M.isPreferringBrowserCodeLoad)&&b.scheme===D.file&&(k=!0),b.scheme===D.file&&typeof M.globals.importScripts=="function"&&M.globals.origin==="vscode-file://vscode-app"&&(k=!0),k?b.with({scheme:D.vscodeFileResource,authority:b.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(p,g){const i=this.toUri(p,g);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(p,g){return m.URI.isUri(p)?p:m.URI.parse(g.toUrl(p))}}e.FileAccess=new E}),define(J[65],Z([0,1,37]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const M=new m.LRUCache(1e4);function D(g){return p(g,"NFC",M)}e.normalizeNFC=D;const S=new m.LRUCache(1e4);function E(g){return p(g,"NFD",S)}e.normalizeNFD=E;const n=/[^\u0000-\u0080]/;function p(g,i,b){if(!g)return g;const k=b.get(g);if(k)return k;let y;return n.test(g)?y=g.normalize(i):y=g,b.set(g,y),y}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(i){return E(i).replace(g,"")}}()}),define(J[15],Z([0,1,30,8,7,23,10,3]),function(V,e,m,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(y){return(0,D.uriToFsPath)(y,!0)}e.originalFSPath=p;class g{constructor(d){this._ignorePathCasing=d}compare(d,v,P=!1){return d===v?0:(0,S.compare)(this.getComparisonKey(d,P),this.getComparisonKey(v,P))}isEqual(d,v,P=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,P)===this.getComparisonKey(v,P)}getComparisonKey(d,v=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,v,P=!1){if(d.scheme===v.scheme){if(d.scheme===E.Schemas.file)return m.isEqualOrParent(p(d),p(v),this._ignorePathCasing(d))&&d.query===v.query&&(P||d.fragment===v.fragment);if((0,e.isEqualAuthority)(d.authority,v.authority))return m.isEqualOrParent(d.path,v.path,this._ignorePathCasing(d),"/")&&d.query===v.query&&(P||d.fragment===v.fragment)}return!1}joinPath(d,...v){return D.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return M.posix.basename(d.path)}extname(d){return M.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===E.Schemas.file?v=D.URI.file(M.dirname(p(d))).path:(v=M.posix.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===E.Schemas.file?v=D.URI.file(M.normalize(p(d))).path:v=M.posix.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.isEqualAuthority)(d.authority,v.authority))return;if(d.scheme===E.Schemas.file){const c=M.relative(p(d),p(v));return n.isWindows?m.toSlashes(c):c}let P=d.path||"/",I=v.path||"/";if(this._ignorePathCasing(d)){let c=0;for(const h=Math.min(P.length,I.length);c<h&&!(P.charCodeAt(c)!==I.charCodeAt(c)&&P.charAt(c).toLowerCase()!==I.charAt(c).toLowerCase());c++);P=I.substr(0,c)+P.substr(c)}return M.posix.relative(P,I)}resolvePath(d,v){if(d.scheme===E.Schemas.file){const P=D.URI.file(M.resolve(p(d),v));return d.with({authority:P.authority,path:P.path})}return v=m.toPosixPath(v),d.with({path:M.posix.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||(0,S.equalsIgnoreCase)(d,v)}hasTrailingPathSeparator(d,v=M.sep){if(d.scheme===E.Schemas.file){const P=p(d);return P.length>m.getRoot(P).length&&P[P.length-1]===v}else{const P=d.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=M.sep){return(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=M.sep){let P=!1;if(d.scheme===E.Schemas.file){const I=p(d);P=I!==void 0&&I.length===m.getRoot(I).length&&I[I.length-1]===v}else{v="/";const I=d.path;P=I.length===1&&I.charCodeAt(I.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path+"/"}):d}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(y=>y.scheme===E.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new g(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(y,d){const v=[];for(let P=0;P<y.length;P++){const I=d(y[P]);y.some((c,h)=>h===P?!1:(0,e.isEqualOrParent)(I,d(c)))||v.push(y[P])}return v}e.distinctParents=i;var b;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(v){const P=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(h=>{const[a,u]=h.split(":");a&&u&&P.set(a,u)});const c=v.path.substring(0,v.path.indexOf(";"));return c&&P.set(y.META_DATA_MIME,c),P}y.parseMetaData=d})(b=e.DataUri||(e.DataUri={}));function k(y,d,v){if(d){let P=y.path;return P&&P[0]!==M.posix.sep&&(P=M.posix.sep+P),y.with({scheme:v,authority:d,path:P})}return y.with({scheme:v})}e.toLocalResource=k}),define(J[9],Z([0,1,25,16,5,2,15]),function(V,e,m,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n($){return!!$&&typeof $.then=="function"}e.isThenable=n;function p($){const F=new m.CancellationTokenSource,N=$(F.token),B=new Promise((W,z)=>{const T=F.token.onCancellationRequested(()=>{T.dispose(),F.dispose(),z((0,M.canceled)())});Promise.resolve(N).then(A=>{T.dispose(),F.dispose(),W(A)},A=>{T.dispose(),F.dispose(),z(A)})});return new class{cancel(){F.cancel()}then(W,z){return B.then(W,z)}catch(W){return this.then(void 0,W)}finally(W){return B.finally(W)}}}e.createCancelablePromise=p;function g($,F,N){return Promise.race([$,new Promise(B=>F.onCancellationRequested(()=>B(N)))])}e.raceCancellation=g;async function i($){let F=-1;const N=$.map((W,z)=>W.then(T=>(F=z,T))),B=await Promise.race(N);return $.forEach((W,z)=>{z!==F&&W.cancel()}),B}e.raceCancellablePromises=i;function b($,F,N){let B;const W=setTimeout(()=>{B?.(void 0),N?.()},F);return Promise.race([$.finally(()=>clearTimeout(W)),new Promise(z=>B=z)])}e.raceTimeout=b;function k($){return new Promise((F,N)=>{const B=$();n(B)?B.then(F,N):F(B)})}e.asPromise=k;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(N,N).then(B)})}return new Promise((N,B)=>{this.queuedPromise.then(N,B)})}return this.activePromise=F(),new Promise((N,B)=>{this.activePromise.then(W=>{this.activePromise=null,N(W)},W=>{this.activePromise=null,B(W)})})}}e.Throttler=y;class d{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=d;class v{constructor(){this.promiseMap=new Map}queue(F,N){const W=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(F)===W&&this.promiseMap.delete(F)});return this.promiseMap.set(F,W),W}}e.SequencerByKey=v;class P{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,N=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,W)=>{this.doResolve=B,this.doReject=W}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},N),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class I{constructor(F){this.delayer=new P(F),this.throttler=new y}trigger(F,N){return this.delayer.trigger(()=>this.throttler.queue(F),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class c{constructor(){this._isOpen=!1,this._promise=new Promise((F,N)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class h extends c{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function a($,F){return F?new Promise((N,B)=>{const W=setTimeout(()=>{z.dispose(),N()},$),z=F.onCancellationRequested(()=>{clearTimeout(W),z.dispose(),B((0,M.canceled)())})}):p(N=>a($,N))}e.timeout=a;function u($,F=0){const N=setTimeout($,F);return(0,S.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=u;function t($){const F=[];let N=0;const B=$.length;function W(){return N<B?$[N++]():null}function z(T){T!=null&&F.push(T);const A=W();return A?A.then(z):Promise.resolve(F)}return Promise.resolve(null).then(z)}e.sequence=t;function s($,F=B=>!!B,N=null){let B=0;const W=$.length,z=()=>{if(B>=W)return Promise.resolve(N);const T=$[B++];return Promise.resolve(T()).then(O=>F(O)?Promise.resolve(O):z())};return z()}e.first=s;function r($,F=B=>!!B,N=null){if($.length===0)return Promise.resolve(N);let B=$.length;const W=()=>{B=-1;for(const z of $)z.cancel?.()};return new Promise((z,T)=>{for(const A of $)A.then(O=>{--B>=0&&F(O)?(W(),z(O)):B===0&&z(N)}).catch(O=>{--B>=0&&(W(),T(O))})})}e.firstParallel=r;class o{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((N,B)=>{this.outstandingPromises.push({factory:F,c:N,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const N=F.factory();N.then(F.c,F.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class l extends o{constructor(){super(1)}}e.Queue=l;class w{constructor(){this.queues=new Map}queueFor(F,N=E.extUri){const B=N.getComparisonKey(F);let W=this.queues.get(B);return W||(W=new l,D.Event.once(W.onFinished)(()=>{W?.dispose(),this.queues.delete(B)}),this.queues.set(B,W)),W}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=w;class f{constructor(F,N){this._token=-1,typeof F=="function"&&typeof N=="number"&&this.setIfNotSet(F,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},N)}setIfNotSet(F,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},N))}}e.TimeoutTimer=f;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,N){this.cancel(),this._token=setInterval(()=>{F()},N)}}e.IntervalTimer=L;class R{constructor(F,N){this.timeoutToken=-1,this.runner=F,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class _ extends R{constructor(F,N){super(F,N);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class C extends S.Disposable{constructor(F,N,B,W){super();this.maxWorkChunkSize=F,this.maxPendingWork=N,this.throttleDelay=B,this.handler=W,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=C,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const N=setTimeout(()=>F($));let B=!1;return{dispose(){B||(B=!0,clearTimeout(N))}}}}else e.runWhenIdle=($,F)=>{const N=requestIdleCallback($,typeof F=="number"?{timeout:F}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(N))}}}}();class K{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=K;async function x($,F,N){let B;for(let W=0;W<N;W++)try{return await $()}catch(z){B=z,await a(F)}throw B}e.retry=x;class ie{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,N,B){return this._pending={taskId:F,cancel:()=>B?.(),promise:N},N.then(()=>this.donePending(F),()=>this.donePending(F)),N}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let N,B;const W=new Promise((z,T)=>{N=z,B=T});this._next={run:F,promise:W,promiseResolve:N,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=ie;class G{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class Q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,N)=>{this.completeCallback=F,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(N=>{this.completeCallback(F),this.resolved=!0,N()})}error(F){return new Promise(N=>{this.errorCallback(F),this.rejected=!0,N()})}cancel(){new Promise(F=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=Q;var U;(function($){async function F(N){let B;const W=await Promise.all(N.map(z=>z.then(T=>T,T=>{B||(B=T)})));if(typeof B!="undefined")throw B;return W}$.settled=F})(U=e.Promises||(e.Promises={}))}),define(J[111],Z([0,1,23,30,8,37,9]),function(V,e,m,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const p="**",g="/",i="[/\\\\]",b="[^/\\\\]",k=/\//g;function y(W){switch(W){case 0:return"";case 1:return`${b}*?`;default:return`(?:${i}|${b}+${i}|${i}${b}+)*?`}}function d(W,z){if(!W)return[];const T=[];let A=!1,O=!1,H="";for(const Y of W){switch(Y){case z:if(!A&&!O){T.push(H),H="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":O=!0;break;case"]":O=!1;break}H+=Y}return H&&T.push(H),T}e.splitGlobAware=d;function v(W){if(!W)return"";let z="";const T=d(W,g);if(T.every(A=>A===p))z=".*";else{let A=!1;T.forEach((O,H)=>{if(O===p){A||(z+=y(2),A=!0);return}let Y=!1,q="",X=!1,ne="";for(const se of O){if(se!=="}"&&Y){q+=se;continue}if(X&&(se!=="]"||!ne)){let ae;se==="-"?ae=se:(se==="^"||se==="!")&&!ne?ae="^":se===g?ae="":ae=m.escapeRegExpCharacters(se),ne+=ae;continue}switch(se){case"{":Y=!0;continue;case"[":X=!0;continue;case"}":z+=`(?:${d(q,",").map(re=>v(re)).join("|")})`,Y=!1,q="";break;case"]":z+="["+ne+"]",X=!1,ne="";break;case"?":z+=b;continue;case"*":z+=y(1);continue;default:z+=m.escapeRegExpCharacters(se)}}H<T.length-1&&(T[H+1]!==p||H+2<T.length)&&(z+=i),A=!1})}return z}const P=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),s=function(){return!1},r=function(){return null};function o(W,z){if(!W)return r;let T;typeof W!="string"?T=W.pattern:T=W,T=T.trim();const A=`${T}_${!!z.trimForExclusions}`;let O=t.get(A);if(O)return l(O,W);let H;if(P.test(T)){const Y=T.substr(4);O=function(q,X){return typeof q=="string"&&q.endsWith(Y)?T:null}}else(H=I.exec(w(T,z)))?O=f(H[1],T):(z.trimForExclusions?h:c).test(T)?O=L(T,z):(H=a.exec(w(T,z)))?O=R(H[1].substr(1),T,!0):(H=u.exec(w(T,z)))?O=R(H[1],T,!1):O=_(T);return t.set(A,O),l(O,W)}function l(W,z){return typeof z=="string"?W:function(T,A){return M.isEqualOrParent(T,z.base)?W(D.relative(z.base,T),A):null}}function w(W,z){return z.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function f(W,z){const T=`/${W}`,A=`\\${W}`,O=function(Y,q){return typeof Y!="string"?null:q?q===W?z:null:Y===W||Y.endsWith(T)||Y.endsWith(A)?z:null},H=[W];return O.basenames=H,O.patterns=[z],O.allBasenames=H,O}function L(W,z){const T=B(W.slice(1,-1).split(",").map(q=>o(q,z)).filter(q=>q!==r),W),A=T.length;if(!A)return r;if(A===1)return T[0];const O=function(q,X){for(let ne=0,se=T.length;ne<se;ne++)if(T[ne](q,X))return W;return null},H=T.find(q=>!!q.allBasenames);H&&(O.allBasenames=H.allBasenames);const Y=T.reduce((q,X)=>X.allPaths?q.concat(X.allPaths):q,[]);return Y.length&&(O.allPaths=Y),O}function R(W,z,T){const A=D.sep===D.posix.sep,O=A?W:W.replace(k,D.sep),H=D.sep+O,Y=D.posix.sep+W,q=T?function(X,ne){return typeof X=="string"&&(X===O||X.endsWith(H)||!A&&(X===W||X.endsWith(Y)))?z:null}:function(X,ne){return typeof X=="string"&&(X===O||!A&&X===W)?z:null};return q.allPaths=[(T?"*/":"./")+W],q}function _(W){try{const z=new RegExp(`^${v(W)}$`);return function(T){return z.lastIndex=0,typeof T=="string"&&z.test(T)?W:null}}catch(z){return r}}function C(W,z,T){return!W||typeof z!="string"?!1:K(W)(z,void 0,T)}e.match=C;function K(W,z={}){if(!W)return s;if(typeof W=="string"||Q(W)){const T=o(W,z);if(T===r)return s;const A=function(O,H){return!!T(O,H)};return T.allBasenames&&(A.allBasenames=T.allBasenames),T.allPaths&&(A.allPaths=T.allPaths),A}return F(W,z)}e.parse=K;function x(W){if(!W)return;let z;return T=>(z||(z=(W()||Promise.resolve([])).then(A=>A?G(A):{})),z.then(A=>!!A[T]))}e.hasSiblingPromiseFn=x;function ie(W){if(!W)return;let z;return T=>{if(!z){const A=W();z=A?G(A):{}}return!!z[T]}}e.hasSiblingFn=ie;function G(W){const z={};for(const T of W)z[T]=!0;return z}function Q(W){const z=W;return z&&typeof z.base=="string"&&typeof z.pattern=="string"}e.isRelativePattern=Q;function U(W){return W.allBasenames||[]}e.getBasenameTerms=U;function $(W){return W.allPaths||[]}e.getPathTerms=$;function F(W,z){const T=B(Object.getOwnPropertyNames(W).map(q=>N(q,W[q],z)).filter(q=>q!==r)),A=T.length;if(!A)return r;if(!T.some(q=>!!q.requiresSiblings)){if(A===1)return T[0];const q=function(se,ae){for(let de=0,re=T.length;de<re;de++){const ce=T[de](se,ae);if(ce)return ce}return null},X=T.find(se=>!!se.allBasenames);X&&(q.allBasenames=X.allBasenames);const ne=T.reduce((se,ae)=>ae.allPaths?se.concat(ae.allPaths):se,[]);return ne.length&&(q.allPaths=ne),q}const O=function(q,X,ne){let se;for(let ae=0,de=T.length;ae<de;ae++){const re=T[ae];re.requiresSiblings&&ne&&(X||(X=D.basename(q)),se||(se=X.substr(0,X.length-D.extname(q).length)));const ce=re(q,X,se,ne);if(ce)return ce}return null},H=T.find(q=>!!q.allBasenames);H&&(O.allBasenames=H.allBasenames);const Y=T.reduce((q,X)=>X.allPaths?q.concat(X.allPaths):q,[]);return Y.length&&(O.allPaths=Y),O}function N(W,z,T){if(z===!1)return r;const A=o(W,T);if(A===r)return r;if(typeof z=="boolean")return A;if(z){const O=z.when;if(typeof O=="string"){const H=(Y,q,X,ne)=>{if(!ne||!A(Y,q))return null;const se=O.replace("$(basename)",X),ae=ne(se);return(0,E.isThenable)(ae)?ae.then(de=>de?W:null):ae?W:null};return H.requiresSiblings=!0,H}}return A}function B(W,z){const T=W.filter(q=>!!q.basenames);if(T.length<2)return W;const A=T.reduce((q,X)=>{const ne=X.basenames;return ne?q.concat(ne):q},[]);let O;if(z){O=[];for(let q=0,X=A.length;q<X;q++)O.push(z)}else O=T.reduce((q,X)=>{const ne=X.patterns;return ne?q.concat(ne):q},[]);const H=function(q,X){if(typeof q!="string")return null;if(!X){let se;for(se=q.length;se>0;se--){const ae=q.charCodeAt(se-1);if(ae===47||ae===92)break}X=q.substr(se)}const ne=A.indexOf(X);return ne!==-1?O[ne]:null};H.basenames=A,H.patterns=O,H.allBasenames=A;const Y=W.filter(q=>!q.basenames);return Y.push(H),Y}}),define(J[31],Z([0,1,7,8,23,10,3,15,30]),function(V,e,m,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function g(o,l,w){if(typeof o=="string"&&(o=m.URI.file(o)),w){const L=w.getWorkspaceFolder(o);if(L){const R=w.getWorkspace().folders.length>1;let _;if((0,n.isEqual)(L.uri,o)?_="":_=(0,n.relativePath)(L.uri,o),R){const C=L.name?L.name:(0,n.basename)(L.uri);_=_?C+" \u2022 "+_:C}return _}}if(o.scheme!==S.Schemas.file&&o.scheme!==S.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(o.fsPath))return(0,M.normalize)(b(o.fsPath));let f=(0,M.normalize)(o.fsPath);return!E.isWindows&&l?.userHome&&(f=y(f,l.userHome.fsPath)),f}e.getPathLabel=g;function i(o){if(!o)return;typeof o=="string"&&(o=m.URI.file(o));const l=(0,n.basename)(o)||(o.scheme===S.Schemas.file?o.fsPath:o.path);return E.isWindows&&(0,p.isRootOrDriveLetter)(l)?b(l):l}e.getBaseLabel=i;function b(o){return(0,p.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=b;let k=Object.create(null);function y(o,l){if(E.isWindows||!o||!l)return o;let w=k.original===l?k.normalized:void 0;return w||(w=`${(0,D.rtrim)(l,M.posix.sep)}${M.posix.sep}`,k={original:l,normalized:w}),(E.isLinux?o.startsWith(w):(0,D.startsWithIgnoreCase)(o,w))&&(o=`~/${o.substr(w.length)}`),o}e.tildify=y;function d(o,l){return o.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=d;const v="\u2026",P="\\\\",I="~";function c(o,l=M.sep){const w=new Array(o.length);let f=!1;for(let L=0;L<o.length;L++){let R=o[L];if(R===""){w[L]=`.${l}`;continue}if(!R){w[L]=R;continue}f=!0;let _="";R.indexOf(P)===0?(_=R.substr(0,R.indexOf(P)+P.length),R=R.substr(R.indexOf(P)+P.length)):R.indexOf(l)===0?(_=R.substr(0,R.indexOf(l)+l.length),R=R.substr(R.indexOf(l)+l.length)):R.indexOf(I)===0&&(_=R.substr(0,R.indexOf(I)+I.length),R=R.substr(R.indexOf(I)+I.length));const C=R.split(l);for(let K=1;f&&K<=C.length;K++)for(let x=C.length-K;f&&x>=0;x--){f=!1;let ie=C.slice(x,x+K).join(l);for(let G=0;!f&&G<o.length;G++)if(G!==L&&o[G]&&o[G].indexOf(ie)>-1){const Q=x+K===C.length,U=x>0&&o[G].indexOf(l)>-1?l+ie:ie,$=o[G].endsWith(U);f=!Q||$}if(!f){let G="";(C[0].endsWith(":")||_!=="")&&(x===1&&(x=0,K++,ie=C[0]+l+ie),x>0&&(G=C[0]+l),G=_+G),x>0&&(G=G+v+l),G=G+ie,x+K<C.length&&(G=G+l+v),w[L]=G}}f&&(w[L]=R)}return w}e.shorten=c;var h;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function a(o,l=Object.create(null)){const w=[];let f=!1,L="";for(const R of o)if(R==="$"||f&&R==="{")L&&w.push({value:L,type:h.TEXT}),L="",f=!0;else if(R==="}"&&f){const _=l[L];if(typeof _=="string")_.length&&w.push({value:_,type:h.VARIABLE});else if(_){const C=w[w.length-1];(!C||C.type!==h.SEPARATOR)&&w.push({value:_.label,type:h.SEPARATOR})}L="",f=!1}else L+=R;return L&&!f&&w.push({value:L,type:h.TEXT}),w.filter((R,_)=>{if(R.type===h.SEPARATOR){const C=w[_-1],K=w[_+1];return[C,K].every(x=>x&&(x.type===h.VARIABLE||x.type===h.TEXT)&&x.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=a;function u(o,l){return E.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,E.isMacintosh?"&":"&&"):o.replace(/&&|&/g,w=>w==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function t(o,l){return E.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,""):E.isWindows?o.replace(/&&|&/g,w=>w==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(o){const l=o.indexOf("/")!==-1?M.posix:M.win32,w=l.basename(o),f=l.dirname(o);return w.length?{name:w,parentPath:f}:{name:f,parentPath:""}}e.splitName=r}),define(J[28],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(p){return m.test(p)}e.isUUID=M;const D=new Uint8Array(16),S=[];for(let p=0;p<256;p++)S.push(p.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(p){for(let g=0;g<p.length;g++)p[g]=Math.floor(Math.random()*256);return p};function n(){E(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let p=0,g="";return g+=S[D[p++]],g+=S[D[p++]],g+=S[D[p++]],g+=S[D[p++]],g+="-",g+=S[D[p++]],g+=S[D[p++]],g+="-",g+=S[D[p++]],g+=S[D[p++]],g+="-",g+=S[D[p++]],g+=S[D[p++]],g+="-",g+=S[D[p++]],g+=S[D[p++]],g+=S[D[p++]],g+=S[D[p++]],g+=S[D[p++]],g+=S[D[p++]],g}e.generateUuid=n}),define(J[112],Z([0,1,29,58,43]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function S(E,n){if(await new Promise((i,b)=>{const k=m.createReadStream(E),y=M.createHash("sha1");k.pipe(y);const d=(0,D.once)((v,P)=>{k.removeAllListeners(),y.removeAllListeners(),v?b(v):i(P)});k.once("error",d),k.once("end",d),y.once("error",d),y.once("data",v=>d(void 0,v.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=S}),define(J[79],Z([0,1,239]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class M{constructor(S="utf8"){this.stringDecoder=new m.StringDecoder(S),this.remaining=null}write(S){const E=[],n=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(n.length<1)return E;let p=0,g,i=p;for(;i<n.length;)if(g=n.charCodeAt(i),g===13||g===10){if(E.push(n.substring(p,i)),i++,i<n.length){const b=g;g=n.charCodeAt(i),(b===13&&g===10||b===10&&g===13)&&i++}p=i}else i++;return this.remaining=p<n.length?n.substr(p):null,E}end(){return this.remaining}}e.LineDecoder=M}),define(J[113],Z([0,1,26]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const M=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(n){const p=n.replace(/\-/g,":").toLowerCase();return!M.has(p)}function S(){return new Promise(async(n,p)=>{const g=setTimeout(()=>p("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await E())}catch(i){p(i)}finally{clearTimeout(g)}})}e.getMac=S;function E(){return new Promise((n,p)=>{try{const g=(0,m.networkInterfaces)();for(let i in g){const b=g[i];if(b){for(const{mac:k}of b)if(D(k))return n(k)}}p("Unable to retrieve mac address (unexpected format)")}catch(g){p(g)}})}}),define(J[66],Z([0,1,16,28,26,37,113]),function(V,e,m,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=S.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,b=0;const k=(0,D.networkInterfaces)();for(let y in k){const d=k[y];if(d)for(const{mac:v,internal:P}of d)P||(b+=1,this._isVirtualMachineMacAdress(v.toUpperCase())&&(i+=1))}this._value=b>0?i/b:0}return this._value}};let n;async function p(){return n||(n=(async()=>await g()||M.generateUuid())()),n}e.getMachineId=p;async function g(){try{const i=await new Promise((k,y)=>{V(["crypto"],k,y)}),b=await(0,E.getMac)();return i.createHash("sha256").update(b,"utf8").digest("hex")}catch(i){m.onUnexpectedError(i);return}}}),define(J[18],Z([0,1,29,26,114,8,9,3,30,28,65,15,7]),function(V,e,m,M,D,S,E,n,p,g,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function d(U,$=y.UNLINK){if((0,p.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return $===y.UNLINK?P(U):v(U)}async function v(U){try{const $=(0,S.join)((0,M.tmpdir)(),(0,g.generateUuid)());try{await e.Promises.rename(U,$)}catch(F){return P(U)}P($).catch(F=>{})}catch($){if($.code!=="ENOENT")throw $}}async function P(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function I(U){if((0,p.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(U,{recursive:!0})}e.rimrafSync=I;async function c(U,$){return u(await($?h(U):(0,D.promisify)(m.readdir)(U)))}async function h(U){try{return await(0,D.promisify)(m.readdir)(U,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const $=[],F=await c(U);for(const N of F){let B=!1,W=!1,z=!1;try{const T=await e.Promises.lstat((0,S.join)(U,N));B=T.isFile(),W=T.isDirectory(),z=T.isSymbolicLink()}catch(T){console.warn("[node.js fs] unexpected error from lstat after readdir: ",T)}$.push({name:N,isFile:()=>B,isDirectory:()=>W,isSymbolicLink:()=>z})}return $}function a(U){return u(m.readdirSync(U))}e.readdirSync=a;function u(U){return U.map($=>typeof $=="string"?n.isMacintosh?(0,i.normalizeNFC)($):$:($.name=n.isMacintosh?(0,i.normalizeNFC)($.name):$.name,$))}async function t(U){const $=await c(U),F=[];for(const N of $)await r.existsDirectory((0,S.join)(U,N))&&F.push(N);return F}function s(U,$=1e3){return new Promise(F=>{let N=!1;const B=setInterval(()=>{N||(N=!0,m.access(U,W=>{N=!1,W&&(clearInterval(B),F(void 0))}))},$)})}e.whenDeleted=s;var r;(function(U){async function $(B){let W;try{if(W=await e.Promises.lstat(B),!W.isSymbolicLink())return{stat:W}}catch(z){}try{return{stat:await e.Promises.stat(B),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(n.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(T){if(T.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw T}throw z}}U.stat=$;async function F(B){try{const{stat:W,symbolicLink:z}=await U.stat(B);return W.isFile()&&z?.dangling!==!0}catch(W){}return!1}U.existsFile=F;async function N(B){try{const{stat:W,symbolicLink:z}=await U.stat(B);return W.isDirectory()&&z?.dangling!==!0}catch(W){}return!1}U.existsDirectory=N})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new E.ResourceQueue;function l(U,$,F){return o.queueFor(k.URI.file(U),b.extUriBiasedIgnorePathCase).queue(()=>{const N=R(F);return new Promise((B,W)=>f(U,$,N,z=>z?W(z):B()))})}let w=!0;function f(U,$,F,N){if(!w)return m.writeFile(U,$,{mode:F.mode,flag:F.flag},N);m.open(U,F.flag,F.mode,(B,W)=>{if(B)return N(B);m.writeFile(W,$,z=>{if(z)return m.close(W,()=>N(z));m.fdatasync(W,T=>(T&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",T),w=!1),m.close(W,A=>N(A))))})})}function L(U,$,F){const N=R(F);if(!w)return m.writeFileSync(U,$,{mode:N.mode,flag:N.flag});const B=m.openSync(U,N.flag,N.mode);try{m.writeFileSync(B,$);try{m.fdatasyncSync(B)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),w=!1}}finally{m.closeSync(B)}}e.writeFileSync=L;function R(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function _(U,$){if(U===$)return;async function F(N){try{const B=await e.Promises.lstat(N);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(N,B.atime,new Date)}catch(B){}}try{await e.Promises.rename(U,$),await F($)}catch(N){if(U.toLowerCase()!==$.toLowerCase()&&N.code==="EXDEV"||U.endsWith("."))await C(U,$,{preserveSymlinks:!1}),await d(U,y.MOVE),await F($);else throw N}}async function C(U,$,F){return x(U,$,{root:{source:U,target:$},options:F,handledSourcePaths:new Set})}const K=511;async function x(U,$,F){if(F.handledSourcePaths.has(U))return;F.handledSourcePaths.add(U);const{stat:N,symbolicLink:B}=await r.stat(U);if(B){if(F.options.preserveSymlinks)try{return await Q(U,$,F)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(B.dangling)return}return N.isDirectory()?ie(U,$,N.mode&K,F):G(U,$,N.mode&K)}async function ie(U,$,F,N){await e.Promises.mkdir($,{recursive:!0,mode:F});const B=await c(U);for(const W of B)await x((0,S.join)(U,W),(0,S.join)($,W),N)}async function G(U,$,F){await e.Promises.copyFile(U,$),await e.Promises.chmod($,F)}async function Q(U,$,F){let N=await e.Promises.readlink(U);(0,p.isEqualOrParent)(N,F.root.source,!n.isLinux)&&(N=(0,S.join)(F.root.target,N.substr(F.root.source.length+1))),await e.Promises.symlink(N,$)}e.Promises=new class{get access(){return(0,D.promisify)(m.access)}get stat(){return(0,D.promisify)(m.stat)}get lstat(){return(0,D.promisify)(m.lstat)}get utimes(){return(0,D.promisify)(m.utimes)}get read(){return(0,D.promisify)(m.read)}get readFile(){return(0,D.promisify)(m.readFile)}get write(){return(0,D.promisify)(m.write)}get appendFile(){return(0,D.promisify)(m.appendFile)}get fdatasync(){return(0,D.promisify)(m.fdatasync)}get truncate(){return(0,D.promisify)(m.truncate)}get rename(){return(0,D.promisify)(m.rename)}get copyFile(){return(0,D.promisify)(m.copyFile)}get open(){return(0,D.promisify)(m.open)}get close(){return(0,D.promisify)(m.close)}get symlink(){return(0,D.promisify)(m.symlink)}get readlink(){return(0,D.promisify)(m.readlink)}get chmod(){return(0,D.promisify)(m.chmod)}get mkdir(){return(0,D.promisify)(m.mkdir)}get unlink(){return(0,D.promisify)(m.unlink)}get rmdir(){return(0,D.promisify)(m.rmdir)}get realpath(){return(0,D.promisify)(m.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return d}get move(){return _}get copy(){return C}}}),define(J[80],Z([0,1,29,23,8,18]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function E(i){const b=(0,D.dirname)(i);if(i===b)return i;const k=((0,D.basename)(i)||i).toLowerCase();try{const d=(0,S.readdirSync)(b).filter(v=>v.toLowerCase()===k);if(d.length===1){const v=E(b);if(v)return(0,D.join)(v,d[0])}else if(d.length>1){const v=d.indexOf(k);if(v>=0){const P=E(b);if(P)return(0,D.join)(P,d[v])}}}catch(y){}return null}e.realcaseSync=E;async function n(i){try{return await S.Promises.realpath(i)}catch(b){const k=g(i);return await S.Promises.access(k,m.constants.R_OK),k}}e.realpath=n;function p(i){try{return m.realpathSync(i)}catch(b){const k=g(i);return m.accessSync(k,m.constants.R_OK),k}}e.realpathSync=p;function g(i){return(0,M.rtrim)((0,D.normalize)(i),D.sep)}}),define(J[115],Z([0,1,59]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function M(n,p,g){let i=!1;return new Promise(b=>{const k=setTimeout(()=>{if(!i)return i=!0,b(0)},g);D(n,p,y=>{if(!i)return i=!0,clearTimeout(k),b(y)})})}e.findFreePort=M;function D(n,p,g){if(p===0)return g(0);const i=new m.Socket;i.once("connect",()=>(E(i),D(n+1,p-1,g))),i.once("data",()=>{}),i.once("error",b=>(E(i),b.code!=="ECONNREFUSED"?D(n+1,p-1,g):g(n))),i.connect(n,"127.0.0.1")}function S(n,p,g){let i=!1,b,k=1;const y=m.createServer({pauseOnConnect:!0});function d(v,P){i||(i=!0,y.removeAllListeners(),y.close(),b&&clearTimeout(b),P(v))}return new Promise(v=>{b=setTimeout(()=>{d(0,v)},g),y.on("listening",()=>{d(n,v)}),y.on("error",P=>{P&&(P.code==="EADDRINUSE"||P.code==="EACCES")&&k<p?(n++,k++,y.listen(n,"127.0.0.1")):d(0,v)}),y.on("close",()=>{d(0,v)}),y.listen(n,"127.0.0.1")})}e.findFreePortFaster=S;function E(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(p){console.error(p)}}}),define(J[116],Z([0,1,18,26,8]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,E=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var p;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(p||(p={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class b{constructor(u,t,s){this.exePath=u,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function k({useAlternateBitness:a=!1}={}){return a?g===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:a=!1,findPreview:u=!1}={}){const t=k({useAlternateBitness:a});if(!t)return null;const s=D.join(t,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(s))return null;let r=-1,o=null;for(const f of await m.Promises.readdir(s)){let L=-1;if(u){const _=f.indexOf("-");if(_<0)continue;const C=f.substring(0,_);if(!S.test(C)||f.substring(_+1)!=="preview")continue;L=parseInt(C,10)}else{if(!S.test(f))continue;L=parseInt(f,10)}if(L<=r)continue;const R=D.join(s,f,"pwsh.exe");!await m.SymlinkSupport.existsFile(R)||(o=R,r=L)}if(!o)return null;const l=t.includes("x86")?" (x86)":"",w=u?" Preview":"";return new b(o,`PowerShell${w}${l}`,!0)}async function d({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const u=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=a?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:E,pwshMsixName:"PowerShell (Store)"};for(const r of await m.Promises.readdir(u))if(t.test(r)){const o=D.join(u,r,"pwsh.exe");return new b(o,s)}return null}function v(){const a=D.join(M.homedir(),".dotnet","tools","pwsh.exe");return new b(a,".NET Core PowerShell Global Tool")}function P(){const a=D.join(process.env.windir,g===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(a,"Windows PowerShell",!0)}async function*I(){let a=await y();a&&(yield a),a=await y({useAlternateBitness:!0}),a&&(yield a),a=await d(),a&&(yield a),a=v(),a&&(yield a),a=await y({findPreview:!0}),a&&(yield a),a=await d({findPreview:!0}),a&&(yield a),a=await y({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=P(),a&&(yield a)}async function*c(){for await(const a of I())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=c;async function h(){for await(const a of c())return a;return null}e.getFirstAvailablePowerShellInstallation=h}),define(J[81],Z([0,1,41,10]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(E){return new Promise((n,p)=>{let g;const i=new Map;function b(y,d,v,P,I){const c=i.get(d);if(y===E||c){const h={name:k(v),cmd:v,pid:y,ppid:d,load:P,mem:I};i.set(y,h),y===E&&(g=h),c&&(c.children||(c.children=[]),c.children.push(h),c.children.length>1&&(c.children=c.children.sort((a,u)=>a.pid-u.pid)))}}function k(y){const d=/--disable-blink-features=Auxclick/,v=/\\watcher\\win32\\CodeHelper\.exe/,P=/--crashes-directory/,I=/\\pipe\\winpty-control/,c=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(v.exec(y))return"watcherService ";if(P.exec(y))return"electron-crash-reporter";if(I.exec(y))return"winpty-process";if(c.exec(y))return"console-window-host (Windows internal process)";let a=h.exec(y);if(a&&a.length===2)return a[1]==="renderer"?d.exec(y)?"shared-process":"window":a[1];const u=/[a-zA-Z-]+\.js/g;let t="";do a=u.exec(y),a&&(t+=a+" ");while(a);return t&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${t}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,v)=>{V(["windows-process-tree"],d,v)}).then(d=>{d.getProcessList(E,v=>{d.getProcessCpuUsage(v,P=>{const I=new Map;P.forEach(c=>{const h=y(c.commandLine||"");I.set(c.pid,{name:k(h),cmd:h,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),g=I.get(E),g?(I.forEach(c=>{const h=I.get(c.ppid);h&&(h.children||(h.children=[]),h.children.push(c))}),I.forEach(c=>{c.children&&(c.children=c.children.sort((h,a)=>h.pid-a.pid))}),n(g)):p(new Error(`Root process ${E} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[g];const v=[];for(;d.length;){const I=d.shift();I&&(v.push(I.pid),I.children&&(d=d.concat(I.children)))}let P=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);P+=" "+v.join(" "),(0,m.exec)(P,{},(I,c,h)=>{if(I||h)p(I||new Error(h.toString()));else{const a=c.toString().split(`
`);for(let u=0;u<v.length;u++){const t=i.get(v[u]);t.load=parseFloat(a[u])}if(!g){p(new Error(`Root process ${E} not found`));return}n(g)}})};(0,m.exec)("which ps",{},(d,v,P)=>{if(d||P)if(process.platform!=="linux")p(d||new Error(P.toString()));else{const I=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,m.exec)(I,{},(c,h,a)=>{c||a?p(c||new Error(a.toString())):(S(h,b),y())})}else{const I=v.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,m.exec)(`${I} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,a,u)=>{h||u&&!u.includes("screen size is bogus")?p(h||new Error(u.toString())):(S(a,b),process.platform==="linux"?y():g?n(g):p(new Error(`Root process ${E} not found`)))})}})}})}e.listProcesses=D;function S(E,n){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=E.toString().split(`
`);for(const i of g){const b=p.exec(i.trim());b&&b.length===6&&n(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(J[117],Z([0,1,8,29,3,65,2,18]),function(V,e,m,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function p(b,k,y){return i({path:b,isDirectory:!1},k,y)}e.watchFile=p;function g(b,k,y){return i({path:b,isDirectory:!0},k,y)}e.watchFolder=g,e.CHANGE_BUFFER_DELAY=100;function i(b,k,y){const d=(0,m.basename)(b.path),v=new Map;let P=!1,I=[(0,E.toDisposable)(()=>{v.forEach(c=>(0,E.dispose)(c)),v.clear()})];try{const c=(0,M.watch)(b.path);I.push((0,E.toDisposable)(()=>{c.removeAllListeners(),c.close()}));const h=new Set;b.isDirectory&&n.Promises.readdir(b.path).then(a=>a.forEach(u=>h.add(u))),c.on("error",(a,u)=>{P||y(`Failed to watch ${b.path} for changes using fs.watch() (${a}, ${u})`)}),c.on("change",(a,u)=>{if(P)return;let t="";if(u&&(t=u.toString(),D.isMacintosh&&(t=(0,S.normalizeNFC)(t))),!t||a!=="change"&&a!=="rename")return;const s=b.isDirectory?(0,m.join)(b.path,t):b.path;if(b.isDirectory)if(a==="rename"){const r=v.get(s);r&&(0,E.dispose)(r);const o=setTimeout(async()=>{v.delete(s);const l=await n.Promises.exists(s);if(P)return;let w;l?h.has(t)?w="changed":(w="added",h.add(t)):(h.delete(t),w="deleted"),k(w,s)},e.CHANGE_BUFFER_DELAY);v.set(s,(0,E.toDisposable)(()=>clearTimeout(o)))}else{let r;h.has(t)?r="changed":(r="added",h.add(t)),k(r,s)}else if(a==="rename"||t!==d){const r=setTimeout(async()=>{const o=await n.Promises.exists(s);P||(o?(k("changed",s),I=[i(b,k,y)]):k("deleted",s))},e.CHANGE_BUFFER_DELAY);(0,E.dispose)(I),I=[(0,E.toDisposable)(()=>clearTimeout(r))]}else k("changed",s)})}catch(c){n.Promises.exists(b.path).then(h=>{h&&!P&&y(`Failed to watch ${b.path} for changes using fs.watch() (${c.toString()})`)})}return(0,E.toDisposable)(()=>{P=!0,I=(0,E.dispose)(I)})}}),define(J[118],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[119],Z([0,1,14,118,13]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function S(){m.ipcMain.on(M.CONTEXT_MENU_CHANNEL,(n,p,g,i,b)=>{const k=E(n,i,g);k.popup({window:(0,D.withNullAsUndefined)(m.BrowserWindow.fromWebContents(n.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{k&&n.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,p)}})})}e.registerContextMenuListener=S;function E(n,p,g){const i=new m.Menu;return g.forEach(b=>{let k;b.type==="separator"?k=new m.MenuItem({type:b.type}):Array.isArray(b.submenu)?k=new m.MenuItem({submenu:E(n,p,b.submenu),label:b.label}):k=new m.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(y,d,v)=>n.sender.send(p,b.id,v)}),i.append(k)}),i}});var he=this&&this.__decorate||function(V,e,m,M){var D=arguments.length,S=D<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,m):M,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(V,e,m,M);else for(var n=V.length-1;n>=0;n--)(E=V[n])&&(S=(D<3?E(S):D>3?E(e,m,S):E(e,m))||S);return D>3&&S&&Object.defineProperty(e,m,S),S};define(J[34],Z([0,1,5,2,9,25,16,17,36,13,110,23,47]),function(V,e,m,M,D,S,E,n,p,g,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function P(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(I||(I={}));class c{constructor(W){this.buffer=W,this.pos=0}read(W){const z=this.buffer.slice(this.pos,this.pos+W);return this.pos+=z.byteLength,z}}class h{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}var a;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(a||(a={}));function u(B){const W=n.VSBuffer.alloc(4);return W.writeUInt32BE(B,0),W}function t(B){return B.read(4).readUInt32BE(0)}function s(B){const W=n.VSBuffer.alloc(1);return W.writeUInt8(B,0),W}const r={Undefined:s(a.Undefined),String:s(a.String),Buffer:s(a.Buffer),VSBuffer:s(a.VSBuffer),Array:s(a.Array),Object:s(a.Object)},o=typeof Buffer!="undefined";function l(B,W){if(typeof W=="undefined")B.write(r.Undefined);else if(typeof W=="string"){const z=n.VSBuffer.fromString(W);B.write(r.String),B.write(u(z.byteLength)),B.write(z)}else if(o&&Buffer.isBuffer(W)){const z=n.VSBuffer.wrap(W);B.write(r.Buffer),B.write(u(z.byteLength)),B.write(z)}else if(W instanceof n.VSBuffer)B.write(r.VSBuffer),B.write(u(W.byteLength)),B.write(W);else if(Array.isArray(W)){B.write(r.Array),B.write(u(W.length));for(const z of W)l(B,z)}else{const z=n.VSBuffer.fromString(JSON.stringify(W));B.write(r.Object),B.write(u(z.byteLength)),B.write(z)}}function w(B){switch(B.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return B.read(t(B)).toString();case a.Buffer:return B.read(t(B)).buffer;case a.VSBuffer:return B.read(t(B));case a.Array:{const z=t(B),T=[];for(let A=0;A<z;A++)T.push(w(B));return T}case a.Object:return JSON.parse(B.read(t(B)).toString())}}class f{constructor(W,z,T=null,A=1e3){this.protocol=W,this.ctx=z,this.logger=T,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(O=>this.onRawMessage(O)),this.sendResponse({type:200})}registerChannel(W,z){this.channels.set(W,z),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const z=this.send([W.type]);this.logger&&this.logger.logOutgoing(z,0,1,P(W.type));return}case 201:case 202:case 204:case 203:{const z=this.send([W.type,W.id],W.data);this.logger&&this.logger.logOutgoing(z,W.id,1,P(W.type),W.data);return}}}send(W,z=void 0){const T=new h;return l(T,W),l(T,z),this.sendBuffer(T.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch(z){return 0}}onRawMessage(W){const z=new c(W),T=w(z),A=w(z),O=T[0];switch(O){case 100:return this.logger&&this.logger.logIncoming(W.byteLength,T[1],1,`${d(O)}: ${T[2]}.${T[3]}`,A),this.onPromise({type:O,id:T[1],channelName:T[2],name:T[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(W.byteLength,T[1],1,`${d(O)}: ${T[2]}.${T[3]}`,A),this.onEventListen({type:O,id:T[1],channelName:T[2],name:T[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(W.byteLength,T[1],1,`${d(O)}`),this.disposeActiveRequest({type:O,id:T[1]});case 103:return this.logger&&this.logger.logIncoming(W.byteLength,T[1],1,`${d(O)}`),this.disposeActiveRequest({type:O,id:T[1]})}}onPromise(W){const z=this.channels.get(W.channelName);if(!z){this.collectPendingRequest(W);return}const T=new S.CancellationTokenSource;let A;try{A=z.call(this.ctx,W.name,W.arg,T.token)}catch(Y){A=Promise.reject(Y)}const O=W.id;A.then(Y=>{this.sendResponse({id:O,data:Y,type:201}),this.activeRequests.delete(W.id)},Y=>{Y instanceof Error?this.sendResponse({id:O,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:O,data:Y,type:203}),this.activeRequests.delete(W.id)});const H=(0,M.toDisposable)(()=>T.cancel());this.activeRequests.set(W.id,H)}onEventListen(W){const z=this.channels.get(W.channelName);if(!z){this.collectPendingRequest(W);return}const T=W.id,O=z.listen(this.ctx,W.name,W.arg)(H=>this.sendResponse({id:T,data:H,type:204}));this.activeRequests.set(W.id,O)}disposeActiveRequest(W){const z=this.activeRequests.get(W.id);z&&(z.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let z=this.pendingRequests.get(W.channelName);z||(z=[],this.pendingRequests.set(W.channelName,z));const T=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:W,timeoutTimer:T})}flushPendingRequests(W){const z=this.pendingRequests.get(W);if(z){for(const T of z)switch(clearTimeout(T.timeoutTimer),T.request.type){case 100:this.onPromise(T.request);break;case 102:this.onEventListen(T.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(W=>W.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var L;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(L=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(W,z=null){this.protocol=W,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(T=>this.onBuffer(T)),this.logger=z}getChannel(W){const z=this;return{call(T,A,O){return z.isDisposed?Promise.reject(E.canceled()):z.requestPromise(W,T,A,O)},listen(T,A){return z.isDisposed?Promise.reject(E.canceled()):z.requestEvent(W,T,A)}}}requestPromise(W,z,T,A=S.CancellationToken.None){const O=this.lastRequestId++,Y={id:O,type:100,channelName:W,name:z,arg:T};if(A.isCancellationRequested)return Promise.reject(E.canceled());let q;return new Promise((ne,se)=>{if(A.isCancellationRequested)return se(E.canceled());const ae=()=>{const be=ve=>{switch(ve.type){case 201:this.handlers.delete(O),ne(ve.data);break;case 202:this.handlers.delete(O);const Ee=new Error(ve.data.message);Ee.stack=ve.data.stack,Ee.name=ve.data.name,se(Ee);break;case 203:this.handlers.delete(O),se(ve.data);break}};this.handlers.set(O,be),this.sendRequest(Y)};let de=null;this.state===I.Idle?ae():(de=(0,D.createCancelablePromise)(be=>this.whenInitialized()),de.then(()=>{de=null,ae()}));const re=()=>{de?(de.cancel(),de=null):this.sendRequest({id:O,type:101}),se(E.canceled())},ce=A.onCancellationRequested(re);q=(0,M.combinedDisposable)((0,M.toDisposable)(re),ce),this.activeRequests.add(q)}).finally(()=>{this.activeRequests.delete(q)})}requestEvent(W,z,T){const A=this.lastRequestId++,H={id:A,type:102,channelName:W,name:z,arg:T};let Y=null;const q=new m.Emitter({onFirstListenerAdd:()=>{Y=(0,D.createCancelablePromise)(ne=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(q),this.sendRequest(H)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(q),this.sendRequest({id:A,type:103}))}}),X=ne=>q.fire(ne.data);return this.handlers.set(A,X),q.event}sendRequest(W){switch(W.type){case 100:case 102:{const z=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger&&this.logger.logOutgoing(z,W.id,0,`${d(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const z=this.send([W.type,W.id]);this.logger&&this.logger.logOutgoing(z,W.id,0,d(W.type));return}}}send(W,z=void 0){const T=new h;return l(T,W),l(T,z),this.sendBuffer(T.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch(z){return 0}}onBuffer(W){const z=new c(W),T=w(z),A=w(z),O=T[0];switch(O){case 200:return this.logger&&this.logger.logIncoming(W.byteLength,0,0,P(O)),this.onResponse({type:T[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(W.byteLength,T[1],0,P(O),A),this.onResponse({type:T[0],id:T[1],data:A})}}onResponse(W){if(W.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const z=this.handlers.get(W.id);z&&z(W)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===I.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(W=>W.dispose()),this.activeRequests.clear()}}he([k.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class _{constructor(W){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,W(({protocol:z,onDidClientDisconnect:T})=>{m.Event.once(z.onMessage)(O=>{const H=new c(O),Y=w(H),q=new f(z,Y),X=new R(z);this.channels.forEach((se,ae)=>q.registerChannel(ae,se));const ne={channelServer:q,channelClient:X,ctx:Y};this._connections.add(ne),this._onDidAddConnection.fire(ne),T(()=>{q.dispose(),X.dispose(),this._connections.delete(ne),this._onDidRemoveConnection.fire(ne)})})})}get connections(){const W=[];return this._connections.forEach(z=>W.push(z)),W}getChannel(W,z){const T=this;return{call(A,O,H){let Y;if((0,g.isFunction)(z)){let X=(0,p.getRandomElement)(T.connections.filter(z));Y=X?Promise.resolve(X):m.Event.toPromise(m.Event.filter(T.onDidAddConnection,z))}else Y=z.routeCall(T,A,O);const q=Y.then(X=>X.channelClient.getChannel(W));return K(q).call(A,O,H)},listen(A,O){if((0,g.isFunction)(z))return T.getMulticastEvent(W,z,A,O);const H=z.routeEvent(T,A,O).then(Y=>Y.channelClient.getChannel(W));return K(H).listen(A,O)}}}getMulticastEvent(W,z,T,A){const O=this;let H=new M.DisposableStore;const Y=new m.Emitter({onFirstListenerAdd:()=>{H=new M.DisposableStore;const q=new m.EventMultiplexer,X=new Map,ne=ae=>{const re=ae.channelClient.getChannel(W).listen(T,A),ce=q.add(re);X.set(ae,ce)},se=ae=>{const de=X.get(ae);!de||(de.dispose(),X.delete(ae))};O.connections.filter(z).forEach(ne),m.Event.filter(O.onDidAddConnection,z)(ne,void 0,H),O.onDidRemoveConnection(se,void 0,H),q.event(Y.fire,Y,H),H.add(q)},onLastListenerRemove:()=>{H.dispose()}});return Y.event}registerChannel(W,z){this.channels.set(W,z),this._connections.forEach(T=>{T.channelServer.registerChannel(W,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class C{constructor(W,z,T=null){const A=new h;l(A,z),W.send(A.buffer),this.channelClient=new R(W,T),this.channelServer=new f(W,z,T)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,z){this.channelServer.registerChannel(W,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=C;function K(B){return{call(W,z,T){return B.then(A=>A.call(W,z,T))},listen(W,z){const T=new m.Relay;return B.then(A=>T.input=A.listen(W,z)),T.event}}}e.getDelayedChannel=K;function x(B){let W=!1;return{call(z,T,A){return W?B.call(z,T,A):(0,D.timeout)(0).then(()=>W=!0).then(()=>B.call(z,T,A))},listen(z,T){if(W)return B.listen(z,T);const A=new m.Relay;return(0,D.timeout)(0).then(()=>W=!0).then(()=>A.input=B.listen(z,T)),A.event}}}e.getNextTickChannel=x;class ie{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const z of W.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await m.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=ie;var G;(function(B){function W(A,O){const H=A,Y=O&&O.disableMarshalling,q=new Map;for(const X in H)T(X)&&q.set(X,m.Event.buffer(H[X],!0));return new class{listen(X,ne){const se=q.get(ne);if(se)return se;throw new Error(`Event not found: ${ne}`)}call(X,ne,se){const ae=H[ne];if(typeof ae=="function"){if(!Y&&Array.isArray(se))for(let de=0;de<se.length;de++)se[de]=(0,i.revive)(se[de]);return ae.apply(H,se)}throw new Error(`Method not found: ${ne}`)}}}B.fromService=W;function z(A,O){const H=O&&O.disableMarshalling;return new Proxy({},{get(Y,q){if(typeof q=="string")return O?.properties?.has(q)?O.properties.get(q):T(q)?A.listen(q):async function(...X){let ne;O&&!(0,g.isUndefinedOrNull)(O.context)?ne=[O.context,...X]:ne=X;const se=await A.call(q,ne);return H?se:(0,i.revive)(se)};throw new Error(`Property not found: ${String(q)}`)}})}B.toService=z;function T(A){return A[0]==="o"&&A[1]==="n"&&b.isUpperAsciiLetter(A.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let W=B.toString();if(W!=="[object Object]")return W}return B}function $(B){return Array.isArray(B)?B.map(U):U(B)}function F(B,W,z,T,A,O,H){H=$(H);const Y=Q[A],q=Y[T%Y.length];let X=[`%c[${B}]%c[${String(W).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(T).padStart(5," ")} - ${O}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(O)?(X=X.concat(H),X.push(")")):X.push(H),console.log.apply(console,X)}e.logWithColors=F;class N{constructor(W,z){this._outgoingPrefix=W,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,z,T,A,O){this._totalOutgoing+=W,F(this._outgoingPrefix,this._totalOutgoing,W,z,T,A,O)}logIncoming(W,z,T,A,O){this._totalIncoming+=W,F(this._incomingPrefix,this._totalIncoming,W,z,T,A,O)}}e.IPCLogger=N}),define(J[120],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class m{constructor(D,S){this.sender=D,this.onMessage=S}send(D){try{this.sender.send("vscode:message",D.buffer)}catch(S){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=m}),define(J[121],Z([0,1,5,34,17]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class S{constructor(p){this.port=p,this.onMessage=m.Event.fromDOMEventEmitter(this.port,"message",g=>D.VSBuffer.wrap(g.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=S;class E extends M.IPCClient{constructor(p,g){const i=new S(p);super(i,g);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=E}),define(J[82],Z([0,1,5,34,2,17,3,33]),function(V,e,m,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var p;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p=e.SocketCloseEventType||(e.SocketCloseEventType={}));let g=null;function i(){return g||(g=S.VSBuffer.alloc(0)),g}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,l){if(o===0)return i();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const R=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=o),R}if(this._chunks[0].byteLength>o){const R=this._chunks[0].slice(0,o);return l&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),R}let w=S.VSBuffer.alloc(o),f=0,L=0;for(;o>0;){const R=this._chunks[L];if(R.byteLength>o){const _=R.slice(0,o);w.set(_,f),f+=o,l&&(this._chunks[L]=R.slice(o),this._totalLength-=o),o-=o}else w.set(R,f),f+=R.byteLength,l?(this._chunks.shift(),this._totalLength-=R.byteLength):L++,o-=R.byteLength}return w}}e.ChunkStream=b;var k;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(k||(k={}));var y;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(o,l,w,f){this.type=o,this.id=l,this.ack=w,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends D.Disposable{constructor(o){super();this._onMessage=this._register(new m.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const w=this._state.messageType,f=this._state.id,L=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(w,f,L,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class P{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=S.VSBuffer.alloc(13);l.writeUInt8(o.type,0),l.writeUInt32BE(o.id,1),l.writeUInt32BE(o.ack,5),l.writeUInt32BE(o.data.byteLength,9),this._writeSoon(l,o.data)}_bufferAdd(o,l){const w=this._totalLength===0;return this._data.push(o,l),this._totalLength+=o.byteLength+l.byteLength,w}_bufferTake(){const o=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,l){this._bufferAdd(o,l)&&E.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class I extends D.Disposable{constructor(o){super();this._onMessage=new m.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new m.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new P(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new d(1,0,0,o))}}e.Protocol=I;class c extends M.IPCClient{constructor(o,l,w=null){super(o,l,w);this.protocol=o}static fromSocket(o,l){return new c(new I(o),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=c;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new m.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class a{constructor(o){this.data=o,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],l=0,w=this._first;for(;w;)o[l++]=w.data,w=w.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const l=new a(o);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class t{constructor(){this.lastRuns=[];const o=Date.now();for(let l=0;l<t._HISTORY_LENGTH;l++)this.lastRuns[l]=o-1e3*l;setInterval(()=>{for(let l=t._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const o=Date.now(),l=(1+t._HISTORY_LENGTH)*1e3;let w=0;for(let f=0;f<t._HISTORY_LENGTH;f++)o-this.lastRuns[f]<=l&&w++;return 1-w/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(o,l=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.push(this._socket.onClose(w=>this._onSocketClose.fire(w))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new d(5,0,0,i());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const l=new d(4,0,0,i());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,l){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.push(this._socket.onClose(w=>this._onSocketClose.fire(w))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let l=0,w=o.length;l<w;l++)this._socketWriter.write(o[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new d(6,0,0,i())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const l=this._outgoingUnackMsg.toArray();for(let w=0,f=l.length;w<f;w++)this._socketWriter.write(l[w]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const w=new d(1,l,this._incomingAckId,o);this._outgoingUnackMsg.push(w),this._isReconnecting||(this._socketWriter.write(w),this._recvAckCheck())}sendControl(o){const l=new d(2,0,0,o);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const o=this._outgoingUnackMsg.peek(),l=Date.now()-o.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new d(3,0,this._incomingAckId,i());this._socketWriter.write(o)}}e.PersistentProtocol=s}),define(J[122],Z([0,1,14,5,34,120,2,17]),function(V,e,m,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function p(i,b){const k=M.Event.fromNodeEventEmitter(m.ipcMain,b,(d,v)=>({event:d,message:v})),y=M.Event.filter(k,({event:d})=>d.sender.id===i);return M.Event.map(y,({message:d})=>d&&n.VSBuffer.wrap(d))}class g extends D.IPCServer{constructor(){super(g.getOnDidClientConnect())}static getOnDidClientConnect(){const b=M.Event.fromNodeEventEmitter(m.ipcMain,"vscode:hello",({sender:k})=>k);return M.Event.map(b,k=>{const y=k.id,d=g.Clients.get(y);d&&d.dispose();const v=new M.Emitter;g.Clients.set(y,(0,E.toDisposable)(()=>v.fire()));const P=p(y,"vscode:message"),I=M.Event.any(M.Event.signal(p(y,"vscode:disconnect")),v.event);return{protocol:new S.Protocol(k,P),onDidClientDisconnect:I}})}}e.Server=g,g.Clients=new Map}),define(J[83],Z([0,1,14,5,28,121]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class E extends S.Client{constructor(g,i){super({addEventListener:(b,k)=>g.addListener(b,k),removeEventListener:(b,k)=>g.removeListener(b,k),postMessage:b=>g.postMessage(b),start:()=>g.start(),close:()=>g.close()},i)}}e.Client=E;async function n(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const g=(0,D.generateUuid)();p.webContents.send("vscode:createMessageChannel",g);const i=M.Event.fromNodeEventEmitter(m.ipcMain,"vscode:createMessageChannelResult",(k,y)=>({nonce:y,port:k.ports[0]})),{port:b}=await M.Event.toPromise(M.Event.once(M.Event.filter(i,k=>k.nonce===g)));return b}e.connect=n}),define(J[84],Z([0,1,2,5,9,13]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var E;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(E=e.StorageHint||(e.StorageHint={}));var n;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(n||(n={}));class p extends m.Disposable{constructor(b,k=Object.create(null)){super();this.database=b,this.options=k,this._onDidChangeStorage=this._register(new M.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((k,y)=>this.accept(y,k)),b.deleted?.forEach(k=>this.accept(k,void 0))}accept(b,k){if(this.state===n.Closed)return;let y=!1;(0,S.isUndefinedOrNull)(k)?y=this.cache.delete(b):this.cache.get(b)!==k&&(this.cache.set(b,k),y=!0),y&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,k){const y=this.cache.get(b);return(0,S.isUndefinedOrNull)(y)?k:y}getBoolean(b,k){const y=this.get(b);return(0,S.isUndefinedOrNull)(y)?k:y==="true"}getNumber(b,k){const y=this.get(b);return(0,S.isUndefinedOrNull)(y)?k:parseInt(y,10)}async set(b,k){if(this.state===n.Closed)return;if((0,S.isUndefinedOrNull)(k))return this.delete(b);const y=String(k);if(this.cache.get(b)!==y)return this.cache.set(b,y),this.pendingInserts.set(b,y),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async delete(b){if(!(this.state===n.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class g{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((k,y)=>this.items.set(y,k)),b.delete&&b.delete.forEach(k=>this.items.delete(k))}async close(){}}e.InMemoryStorageDatabase=g}),define(J[123],Z([0,1,5,9,37,8,18]),function(V,e,m,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(i,b=Object.create(null)){this.path=i,this.options=b,this.name=(0,S.basename)(this.path),this.logger=new p(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return m.Event.None}async getItems(){const i=await this.whenConnected,b=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(y=>b.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(i){const b=await this.whenConnected;return this.doUpdateItems(b,i)}doUpdateItems(i,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,D.mapToString)(b.insert):"0"}), delete(${b.delete?(0,D.setToString)(b.delete):"0"})`),this.transaction(i,()=>{const k=b.insert,y=b.delete;if(k&&k.size>0){const d=[];d.push([]);let v=0;k.forEach((P,I)=>{let c=d[v];c.length>n.MAX_HOST_PARAMETERS&&(v++,c=[],d.push(c)),c.push(I,P)}),d.forEach(P=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(P.length/2).fill("(?,?)").join(",")}`,I=>I.run(P),()=>{const I=[];let c=0;return k.forEach((h,a)=>{I.push(a),c+=h.length}),`Keys: ${I.join(", ")} Length: ${c}`})})}if(y&&y.size){const d=[];d.push([]);let v=0;y.forEach(P=>{let I=d[v];I.length>n.MAX_HOST_PARAMETERS&&(v++,I=[],d.push(I)),I.push(P)}),d.forEach(P=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(P.length).fill("?").join(",")})`,I=>I.run(P),()=>{const I=[];return y.forEach(c=>{I.push(c)}),`Keys: ${I.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,i)}doClose(i,b){return new Promise((k,y)=>{i.db.close(d=>(d&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${d}`),this.path===n.IN_MEMORY_PATH?k():!i.isErroneous&&!i.isInMemory?this.backup().then(k,v=>(this.logger.error(`[storage ${this.name}] backup(): ${v}`),k())):typeof b=="function"?E.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(v=>{const P=()=>this.doClose(v,void 0);return this.doUpdateItems(v,{insert:b()}).then(()=>P(),I=>(P(),Promise.reject(I)))})).then(k,y):y(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return E.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const b=await this.whenConnected,k=await this.get(b,i?"PRAGMA integrity_check":"PRAGMA quick_check"),y=i?k.integrity_check:k.quick_check;return b.isErroneous?`${y} (last error: ${b.lastError})`:b.isInMemory?`${y} (in-memory!)`:y}async connect(i,b=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${b})`);try{return await this.doConnect(i)}catch(k){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${k}`),k.code==="SQLITE_BUSY"&&b)return await(0,M.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await E.Promises.unlink(i);try{await E.Promises.rename(this.toBackupPath(i),i)}catch(y){}return await this.doConnect(i)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(i,b){i.isErroneous=!0,i.lastError=b,this.logger.error(b)}doConnect(i){return new Promise((b,k)=>{new Promise((y,d)=>{V(["vscode-sqlite3"],y,d)}).then(y=>{const d={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(i,v=>v?d.db?d.db.close(()=>k(v)):k(v):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(d),P=>d.db.close(()=>k(P)))),isInMemory:i===n.IN_MEMORY_PATH};d.db.on("error",v=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${v}`)),this.logger.isTracing&&d.db.on("trace",v=>this.logger.trace(`[storage ${this.name}] Trace (event): ${v}`))},k)})}exec(i,b){return new Promise((k,y)=>{i.db.exec(b,d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${d}`),y(d)):k())})}get(i,b){return new Promise((k,y)=>{i.db.get(b,(d,v)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${d}`),y(d)):k(v))})}all(i,b){return new Promise((k,y)=>{i.db.all(b,(d,v)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${d}`),y(d)):k(v))})}transaction(i,b){return new Promise((k,y)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),b(),i.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${d}`),y(d)):k())})})}prepare(i,b,k,y){const d=i.db.prepare(b),v=P=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${P} (${b}). Details: ${y()}`)};d.on("error",v),k(d),d.finalize(P=>{P&&v(P),d.removeListener("error",v)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class p{constructor(i){i&&typeof i.logTrace=="function"&&process.env[p.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}p.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[124],Z([12,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(J[125],Z([0,1,124]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,D=M*60,S=D*24,E=S*7,n=S*30,p=S*365;function g(b,k){typeof b!="number"&&(b=b.getTime());const y=Math.round((new Date().getTime()-b)/1e3);if(y<-30)return(0,m.localize)(0,null,g(new Date().getTime()+y*1e3,!1));if(y<30)return(0,m.localize)(1,null);let d;return y<M?(d=y,k?d===1?(0,m.localize)(2,null,d):(0,m.localize)(3,null,d):d===1?(0,m.localize)(4,null,d):(0,m.localize)(5,null,d)):y<D?(d=Math.floor(y/M),k?d===1?(0,m.localize)(6,null,d):(0,m.localize)(7,null,d):d===1?(0,m.localize)(8,null,d):(0,m.localize)(9,null,d)):y<S?(d=Math.floor(y/D),k?d===1?(0,m.localize)(10,null,d):(0,m.localize)(11,null,d):d===1?(0,m.localize)(12,null,d):(0,m.localize)(13,null,d)):y<E?(d=Math.floor(y/S),k?d===1?(0,m.localize)(14,null,d):(0,m.localize)(15,null,d):d===1?(0,m.localize)(16,null,d):(0,m.localize)(17,null,d)):y<n?(d=Math.floor(y/E),k?d===1?(0,m.localize)(18,null,d):(0,m.localize)(19,null,d):d===1?(0,m.localize)(20,null,d):(0,m.localize)(21,null,d)):y<p?(d=Math.floor(y/n),k?d===1?(0,m.localize)(22,null,d):(0,m.localize)(23,null,d):d===1?(0,m.localize)(24,null,d):(0,m.localize)(25,null,d)):(d=Math.floor(y/p),k?d===1?(0,m.localize)(26,null,d):(0,m.localize)(27,null,d):d===1?(0,m.localize)(28,null,d):(0,m.localize)(29,null,d))}e.fromNow=g;function i(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(J[126],Z([12,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(J[67],Z([0,1,126,13,36]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(g,i){return i&&(g.stack||g.stacktrace)?m.localize(0,null,n(g),E(g.stack)||E(g.stacktrace)):n(g)}function E(g){return Array.isArray(g)?g.join(`
`):g}function n(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?m.localize(1,null,g.message):g.message||m.localize(2,null)}function p(g=null,i=!1){if(!g)return m.localize(3,null);if(Array.isArray(g)){const b=D.coalesce(g),k=p(b[0],i);return b.length>1?m.localize(4,null,k,b.length):k}if(M.isString(g))return g;if(g.detail){const b=g.detail;if(b.error)return S(b.error,i);if(b.exception)return S(b.exception,i)}return g.stack?S(g,i):g.message?g.message:m.localize(5,null)}e.toErrorMessage=p}),define(J[127],Z([12,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(J[128],Z([0,1,127]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class M{constructor(E,n,p=n){this.modifierLabels=[null],this.modifierLabels[2]=E,this.modifierLabels[1]=n,this.modifierLabels[3]=p}toLabel(E,n,p){if(n.length===0)return null;const g=[];for(let i=0,b=n.length;i<b;i++){const k=n[i],y=p(k);if(y===null)return null;g[i]=D(k,y,this.modifierLabels[E])}return g.join(" ")}}e.ModifierLabelProvider=M,e.UILabelProvider=new M({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:m.localize(0,null),shiftKey:m.localize(1,null),altKey:m.localize(2,null),metaKey:m.localize(3,null),separator:"+"},{ctrlKey:m.localize(4,null),shiftKey:m.localize(5,null),altKey:m.localize(6,null),metaKey:m.localize(7,null),separator:"+"}),e.AriaLabelProvider=new M({ctrlKey:m.localize(8,null),shiftKey:m.localize(9,null),altKey:m.localize(10,null),metaKey:m.localize(11,null),separator:"+"},{ctrlKey:m.localize(12,null),shiftKey:m.localize(13,null),altKey:m.localize(14,null),metaKey:m.localize(15,null),separator:"+"},{ctrlKey:m.localize(16,null),shiftKey:m.localize(17,null),altKey:m.localize(18,null),metaKey:m.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new M({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new M({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(S,E,n){if(E===null)return"";const p=[];return S.ctrlKey&&p.push(n.ctrlKey),S.shiftKey&&p.push(n.shiftKey),S.altKey&&p.push(n.altKey),S.metaKey&&p.push(n.metaKey),E!==""&&p.push(E),p.join(n.separator)}}),define(J[129],Z([12,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(J[68],Z([0,1,8,18,41,129,33,13,44,30,3,79,10]),function(V,e,m,M,D,S,E,n,p,g,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function y(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(a,u){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};u&&(t.cwd=u);const s=D.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],t);return new Promise(r=>{s.once("error",o=>{r({success:!1,error:o})}),s.once("exit",(o,l)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?y(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(s=>{D.execFile(t,[a.pid.toString()],{encoding:"utf8",shell:!0},(r,o,l)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function v(a=E.env){return a.comspec||"cmd.exe"}e.getWindowsShell=v;class P{constructor(u,t,s,r){if(t!==void 0&&s!==void 0&&r!==void 0)this.cmd=u,this.args=t,this.shell=s,this.options=r;else{const o=u;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(E.env).forEach(l=>{o[l]=E.env[l]}),Object.keys(this.options.env).forEach(l=>{o[l]=this.options.env[l]}),this.options.env=o}}getSanitizedCommand(){let u=this.cmd.toLowerCase();const t=u.lastIndexOf(m.sep);return t!==-1&&(u=u.substring(t+1)),P.WellKnowCommands[u]?u:"other"}start(u){return i.isWindows&&(this.options&&this.options.cwd&&g.isUNC(this.options.cwd)||!this.options&&g.isUNC(E.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(t=>{let s,r;const o=new Promise((l,w)=>{s=l,r=w});if(t){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=D.exec(l,this.options,(w,f,L)=>{this.childProcess=null;const R=w;R&&R.killed?r({killed:this.terminateRequested,stdout:f.toString(),stderr:L.toString()}):this.handleExec(s,u,w,f,L)})}else{let l=null;const w=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,s,u,r);const L={terminated:this.terminateRequested};n.isNumber(f)&&(L.cmdCode=f),s(L)};if(this.shell&&i.isWindows){const f=p.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let L=!1,R=!1;const _=[];let C=this.ensureQuotes(this.cmd);_.push(C.value),L=C.quoted,this.args&&this.args.forEach(x=>{C=this.ensureQuotes(x),_.push(C.value),R=R&&C.quoted});const K=["/s","/c"];L?R?K.push('"'+_.join(" ")+'"'):_.length>1?K.push('"'+_[0]+'" '+_.slice(1).join(" ")):K.push('"'+_[0]+'"'):K.push(_.join(" ")),l=D.spawn(v(),K,f)}else this.cmd&&(l=D.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(n.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",f=>{this.childProcess=null,r({terminated:this.terminateRequested,error:f})}),l.pid&&(this.childProcess.on("close",w),this.handleSpawn(l,s,u,r,!0)))}return o})}handleClose(u,t,s,r){}ensureQuotes(u){return P.regexp.test(u)?{value:'"'+u+'"',quoted:!0}:{value:u,quoted:u.length>0&&u[0]==='"'&&u[u.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(u=>u.pid,u=>-1):new Promise(u=>{this.pidResolve=u})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(u=>(this.terminateRequested=!0,d(u,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),u=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(u=>{if(!this.shell||!i.isWindows)return u(!1);const t=D.spawn(v(),["/s","/c"]);t.on("error",s=>u(!0)),t.on("exit",s=>u(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class I extends P{constructor(u,t,s,r){super(u,t,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(u,t,s,r,o){[r,o].forEach((l,w)=>{const f=new b.LineDecoder;f.write(l).forEach(_=>{t({line:_,source:w===0?0:1})});const R=f.end();R&&t({line:R,source:w===0?0:1})}),u({terminated:this.terminateRequested,error:s})}handleSpawn(u,t,s,r,o){const l=new b.LineDecoder,w=new b.LineDecoder;u.stdout.on("data",f=>{l.write(f).forEach(R=>s({line:R,source:0}))}),u.stderr.on("data",f=>{w.write(f).forEach(R=>s({line:R,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=w}handleClose(u,t,s,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&s({line:o,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&s({line:l,source:1})}}e.LineProcess=I;function c(a){let u=[],t=!1;const s=function(r){if(t){u.push(r);return}(!a.send(r,l=>{if(l&&console.error(l),t=!1,u.length>0){const w=u.slice(0);u=[],w.forEach(f=>s(f))}})||i.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=c;var h;(function(a){async function u(t,s,r){if(m.isAbsolute(t))return t;if(s===void 0&&(s=E.cwd()),m.dirname(t)!=="."||(r===void 0&&n.isString(E.env.PATH)&&(r=E.env.PATH.split(m.delimiter)),r===void 0||r.length===0))return m.join(s,t);async function l(w){return await M.Promises.exists(w)?!(await M.Promises.stat(w)).isDirectory():!1}for(let w of r){let f;if(m.isAbsolute(w)?f=m.join(w,t):f=m.join(s,w,t),await l(f))return f;let L=f+".com";if(await l(L)||(L=f+".exe",await l(L)))return L}return m.join(s,t)}a.findExecutable=u})(h=e.win32||(e.win32={}))}),define(J[130],Z([0,1,26,3,116,68]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function E(y,d){return y===1?M.isWindows?b():S.getWindowsShell(d):g(y,d)}e.getSystemShell=E;function n(y,d){return y===1?M.isWindows?k(d):S.getWindowsShell(d):g(y,d)}e.getSystemShellSync=n;let p=null;function g(y,d){if(M.isLinux&&y===2||M.isMacintosh&&y===3)return"/bin/bash";if(!p){let v;if(M.isWindows)v="/bin/bash";else{if(v=d.SHELL,!v)try{v=(0,m.userInfo)().shell}catch(P){}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}p=v}return p}let i=null;async function b(){return i||(i=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),i}function k(y){if(i)return i;const d=M.isWindows&&parseFloat((0,m.release)())>=10,v=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${y.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?P:S.getWindowsShell(y)}}),define(J[85],Z([0,1,41,2,9,44,5,68,34,109,25,16,17,3]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends p.ChannelServer{constructor(I){super({send:c=>{try{process.send&&process.send(c.buffer.toString("base64"))}catch(h){}},onMessage:E.Event.fromNodeEventEmitter(process,"message",c=>k.VSBuffer.wrap(Buffer.from(c,"base64")))},I);process.once("disconnect",()=>this.dispose())}}e.Server=d;class v{constructor(I,c){this.modulePath=I,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new D.Delayer(h),this.child=null,this._client=null}getChannel(I){const c=this;return{call(h,a,u){return c.requestPromise(I,h,a,u)},listen(h,a){return c.requestEvent(I,h,a)}}}requestPromise(I,c,h,a=i.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(I),t=(0,D.createCancelablePromise)(o=>u.call(c,h,o)),s=a.onCancellationRequested(()=>t.cancel()),r=(0,M.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{s.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(I,c,h){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let a;const u=new E.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(I).listen(c,h)(u.fire,u),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const I=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(c.env={...c.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),y.isMacintosh&&c.env&&delete c.env.DYLD_LIBRARY_PATH,this.child=(0,m.fork)(this.modulePath,I,c);const h=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,g.isRemoteConsoleLog)(l)){(0,g.log)(l,`IPC Library: ${this.options.serverName}`);return}h.fire(k.VSBuffer.wrap(Buffer.from(l,"base64")))});const u=this.options.useQueue?(0,n.createQueuedSender)(this.child):this.child,t=l=>this.child&&this.child.connected&&u.send(l.buffer.toString("base64")),s=h.event,r={send:t,onMessage:s};this._client=new p.ChannelClient(r);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,w)=>{process.removeListener("exit",o),this.activeRequests.forEach(f=>(0,M.dispose)(f)),this.activeRequests.clear(),l!==0&&w!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+w),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:w})})}return this._client}getCachedChannel(I){let c=this.channels.get(I);return c||(c=this.client.getChannel(I),this.channels.set(I,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(J[131],Z([12,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(J[132],Z([12,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[133],Z([12,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[134],Z([12,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(J[135],Z([12,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(J[136],Z([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[137],Z([12,11]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[138],Z([12,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[139],Z([12,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(J[140],Z([12,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(J[141],Z([12,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(J[142],Z([12,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[143],Z([12,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[144],Z([12,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[145],Z([12,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[146],Z([12,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(J[147],Z([12,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[148],Z([12,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(J[149],Z([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(J[150],Z([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[151],Z([12,11]),function(V,e){return V.create("vs/platform/workspaces/common/workspaces",e)}),define(J[152],Z([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[153],Z([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[154],Z([0,1,5,2]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new m.Emitter,this._onReloadEmitter=new m.Emitter,this._onTerminateEmitter=new m.Emitter,this._onAttachEmitter=new m.Emitter}call(n,p,g){switch(p){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(n,p,g){switch(p){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class S extends M.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,p,g){this.channel.call("attach",[n,p,g])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,p){this.channel.call("terminate",[n,p])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,p,g){return this.channel.call("openExtensionDevelopmentHostWindow",[n,p||{},g])}}e.ExtensionHostDebugChannelClient=S}),define(J[155],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class m{constructor(E){this.driver=E}listen(E,n){throw new Error(`No event found: ${n}`)}call(E,n,p){switch(n){case"click":return this.driver.click(p[0],p[1],p[2]);case"doubleClick":return this.driver.doubleClick(p);case"setValue":return this.driver.setValue(p[0],p[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(p);case"getElements":return this.driver.getElements(p[0],p[1]);case"getElementXY":return this.driver.getElementXY(p[0],p[1],p[2]);case"typeInEditor":return this.driver.typeInEditor(p[0],p[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(p);case"writeInTerminal":return this.driver.writeInTerminal(p[0],p[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=m;class M{constructor(E){this.channel=E}click(E,n,p){return this.channel.call("click",[E,n,p])}doubleClick(E){return this.channel.call("doubleClick",E)}setValue(E,n){return this.channel.call("setValue",[E,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(E){return this.channel.call("isActiveElement",E)}getElements(E,n){return this.channel.call("getElements",[E,n])}getElementXY(E,n,p){return this.channel.call("getElementXY",[E,n,p])}typeInEditor(E,n){return this.channel.call("typeInEditor",[E,n])}getTerminalBuffer(E){return this.channel.call("getTerminalBuffer",E)}writeInTerminal(E,n){return this.channel.call("writeInTerminal",[E,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=M;class D{constructor(E){this.channel=E}registerWindowDriver(E){return this.channel.call("registerWindowDriver",E)}reloadWindowDriver(E){return this.channel.call("reloadWindowDriver",E)}}e.WindowDriverRegistryChannelClient=D}),define(J[156],Z([0,1,8,15,47,125,10,7,33]),function(V,e,m,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class g{constructor(d,v,P){this._args=d,this.paths=v,this.productService=P}get appRoot(){return(0,m.dirname)(E.FileAccess.asFileUri("",V).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,M.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,M.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file((0,m.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,M.joinPath)(n.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,M.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,M.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=p.env.VSCODE_PORTABLE;return d?n.URI.file((0,m.join)(d,"argv.json")):(0,M.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,M.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,m.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,m.resolve)(d):(0,m.normalize)((0,m.join)(E.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,m.resolve)(d):(0,m.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,m.resolve)(d);const v=p.env.VSCODE_EXTENSIONS;if(v)return v;const P=p.env.VSCODE_PORTABLE;return P?(0,m.join)(P,"extensions"):(0,M.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(v=>/^[^:/?#]+?:\/\//.test(v)?n.URI.parse(v):n.URI.file((0,m.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?n.URI.parse(d):n.URI.file((0,m.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!p.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,M.joinPath)(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file((0,m.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([D.memoize],g.prototype,"appRoot",null),he([D.memoize],g.prototype,"userHome",null),he([D.memoize],g.prototype,"userDataPath",null),he([D.memoize],g.prototype,"appSettingsHome",null),he([D.memoize],g.prototype,"tmpDir",null),he([D.memoize],g.prototype,"userRoamingDataHome",null),he([D.memoize],g.prototype,"settingsResource",null),he([D.memoize],g.prototype,"userDataSyncHome",null),he([D.memoize],g.prototype,"userDataSyncLogResource",null),he([D.memoize],g.prototype,"sync",null),he([D.memoize],g.prototype,"machineSettingsResource",null),he([D.memoize],g.prototype,"globalStorageHome",null),he([D.memoize],g.prototype,"workspaceStorageHome",null),he([D.memoize],g.prototype,"keybindingsResource",null),he([D.memoize],g.prototype,"keyboardLayoutResource",null),he([D.memoize],g.prototype,"argvResource",null),he([D.memoize],g.prototype,"snippetsHome",null),he([D.memoize],g.prototype,"isExtensionDevelopment",null),he([D.memoize],g.prototype,"untitledWorkspacesHome",null),he([D.memoize],g.prototype,"installSourcePath",null),he([D.memoize],g.prototype,"builtinExtensionsPath",null),he([D.memoize],g.prototype,"extensionsPath",null),he([D.memoize],g.prototype,"extensionDevelopmentLocationURI",null),he([D.memoize],g.prototype,"extensionDevelopmentKind",null),he([D.memoize],g.prototype,"extensionTestsLocationURI",null),he([D.memoize],g.prototype,"debugExtensionHost",null),he([D.memoize],g.prototype,"serviceMachineIdResource",null),he([D.memoize],g.prototype,"telemetryLogResource",null),he([D.memoize],g.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=g;function i(y,d){return k(y["inspect-extensions"],y["inspect-brk-extensions"],5870,d,y.debugId)}e.parseExtensionHostPort=i;function b(y,d){return k(y["inspect-search"],y["inspect-brk-search"],5876,d)}e.parseSearchPort=b;function k(y,d,v,P,I){const h=Number(d||y)||(P?null:v),a=h?Boolean(!!d):!1;return{port:h,break:a,debugId:I}}}),define(J[86],Z([0,1,240,134,3]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:(0,M.localize)(0,null),e:(0,M.localize)(1,null),t:(0,M.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,M.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,M.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,M.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,M.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,M.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,M.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,M.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,M.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,M.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,M.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,M.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,M.localize)(14,null)},category:{type:"string",cat:"e",description:(0,M.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,M.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,M.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,M.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,M.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,M.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,M.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,M.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,M.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,M.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,M.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,M.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,M.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,M.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,M.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const E={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,v,P=E){const I={},c=[],h=[];for(let s in v){const r=v[s];r.alias&&(I[s]=r.alias),r.type==="string"||r.type==="string[]"?(c.push(s),r.deprecates&&c.push(r.deprecates)):r.type==="boolean"&&(h.push(s),r.deprecates&&h.push(r.deprecates))}const a=m(d,{string:c,boolean:h,alias:I}),u={},t=a;u._=a._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in v){const r=v[s];r.alias&&delete t[r.alias];let o=t[s];r.deprecates&&t.hasOwnProperty(r.deprecates)&&(o||(o=t[r.deprecates]),delete t[r.deprecates]),typeof o!="undefined"&&(r.type==="string[]"?o&&!Array.isArray(o)&&(o=[o]):r.type==="string"&&Array.isArray(o)&&(o=o.pop(),P.onMultipleValues(s,o)),u[s]=o),delete t[s]}for(let s in t)P.onUnknownOption(s);return u}e.parseArgs=n;function p(d,v){let P="";return v.args&&(Array.isArray(v.args)?P=` <${v.args.join("> <")}>`:P=` <${v.args}>`),v.alias?`-${v.alias} --${d}${P}`:`--${d}${P}`}function g(d,v){let P=0,I=[];for(const u in d){const t=d[u],s=p(u,t);P=Math.max(P,s.length),I.push([s,t.description])}let c=P+2+1;if(v-c<25)return I.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let h=v-c-1,a=[];for(const u of I){let t=u[0],s=b(u[1],h),r=i(c-t.length-2);a.push("  "+t+r+s[0]);for(let o=1;o<s.length;o++)a.push(i(c)+s[o])}return a}e.formatOptions=g;function i(d){return" ".repeat(d)}function b(d,v){let P=[];for(;d.length;){let I=d.length<v?d.length:d.lastIndexOf(" ",v),c=d.slice(0,I).trim();d=d.slice(I),P.push(c)}return P}function k(d,v,P,I,c=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${d} ${P}`];a.push(""),a.push(`${(0,M.localize)(32,null)}: ${v} [${(0,M.localize)(33,null)}][${(0,M.localize)(34,null)}...]`),a.push(""),c&&(D.isWindows?a.push((0,M.localize)(35,null,v)):a.push((0,M.localize)(36,null,v)),a.push(""));const u={};for(const t in I){const s=I[t];if(s.description&&s.cat){let r=u[s.cat];r||(u[s.cat]=r={}),r[t]=s}}for(let t in u){const s=t;let r=u[s];r&&(a.push(S[s]),a.push(...g(r,h)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=k;function y(d,v){return`${d||(0,M.localize)(37,null)}
${v||(0,M.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=y}),define(J[157],Z([0,1,86,59,154]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class S extends D.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,p,g){return p==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(g[0],g[1],g[2]):super.call(n,p,g)}async openExtensionDevelopmentHostWindow(n,p,g){const i=(0,m.parseArgs)(n,m.OPTIONS);i.debugRenderer=g;const b=i.extensionDevelopmentPath;if(!b)return{success:!1};let k;const y=Object.keys(p);for(let h of y){let a=p[h];a===null||(k||(k=Object.create(null)),k[h]=a)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(b,{context:5,cli:i,userEnv:k});if(!g)return{success:!0};const v=d.win;if(!v)return{success:!0};const P=v.webContents.debugger;let I=P.isAttached()?Infinity:0;const c=(0,M.createServer)(h=>{I++==0&&P.attach();let a=!1;const u=r=>{a||h.write(JSON.stringify(r)+"\0")},t=(r,o,l,w)=>u({method:o,params:l,sessionId:w});v.on("close",()=>{P.removeListener("message",t),h.end(),a=!0}),P.addListener("message",t);let s=Buffer.alloc(0);h.on("data",r=>{s=Buffer.concat([s,r]);for(let o=s.indexOf(0);o!==-1;o=s.indexOf(0)){let l;try{const w=s.slice(0,o).toString("utf8");s=s.slice(o+1),l=JSON.parse(w)}catch(w){console.error("error reading cdp line",w)}P.sendCommand(l.method,l.params,l.sessionId).then(w=>u({id:l.id,sessionId:l.sessionId,result:w})).catch(w=>u({id:l.id,sessionId:l.sessionId,error:{code:0,message:w.message}}))}}),h.on("error",r=>{console.error("error on cdp pipe:",r)}),h.on("close",()=>{a=!0,--I==0&&P.detach()})});return await new Promise(h=>c.listen(0,h)),v.on("close",()=>c.close()),{rendererDebugPort:c.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=S}),function(){"use strict";function V(e,m,M,D){function S(n){const p=E(n),g=[p];return e.isAbsolute(p)||g.unshift(D),e.resolve(...g)}function E(n){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,M);const i=n["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(b,"AppData","Roaming")}break;case"darwin":g=e.join(m.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,M)}return{getUserDataPath:S}}if(typeof define=="function")define(J[158],Z([0,159,26,10,15,33]),function(e,m,M,D,S,E){const n=S.dirname(D.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(S.joinPath(n,"package.json").fsPath);return V(m,M,p.name,E.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),M=require("os");module.exports=V(m,M,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[160],Z([0,1,26,158,156]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends D.AbstractNativeEnvironmentService{constructor(n,p){super(n,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,M.getUserDataPath)(n)},p)}}e.NativeEnvironmentService=S}),define(J[161],Z([0,1,29,26,8]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function S(E){const n=(0,D.join)((0,M.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return m.writeFileSync(n,""),E&&console.log(`Marker file for --wait created: ${n}`),n}catch(p){E&&console.error(`Failed to create marker file for --wait: ${p}`);return}}e.createWaitMarkerFile=S}),define(J[162],Z([0,1,137]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function S(k){return k=k.trim(),k==="*"||M.test(k)}e.isValidVersionStr=S;function E(k){if(!S(k))return null;if(k=k.trim(),k==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=k.match(M);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=E;function n(k){if(!k)return null;let y=k.majorBase,d=k.majorMustEqual,v=k.minorBase,P=k.minorMustEqual,I=k.patchBase,c=k.patchMustEqual;k.hasCaret&&(y===0||(P=!1),c=!1);let h=0;if(k.preRelease){const a=D.exec(k.preRelease);if(a){const[,u,t,s]=a;h=Date.UTC(Number(u),Number(t)-1,Number(s))}}return{majorBase:y,majorMustEqual:d,minorBase:v,minorMustEqual:P,patchBase:I,patchMustEqual:c,isMinimum:k.hasGreaterEquals,notBefore:h}}e.normalizeVersion=n;function p(k,y,d){let v;typeof k=="string"?v=n(E(k)):v=k;let P;y instanceof Date?P=y.getTime():typeof y=="string"&&(P=new Date(y).getTime());let I;if(typeof d=="string"?I=n(E(d)):I=d,!v||!I)return!1;let c=v.majorBase,h=v.minorBase,a=v.patchBase,u=I.majorBase,t=I.minorBase,s=I.patchBase,r=I.notBefore,o=I.majorMustEqual,l=I.minorMustEqual,w=I.patchMustEqual;return I.isMinimum?c>u?!0:c<u?!1:h>t?!0:h<t||P&&P<r?!1:a>=s:(c===1&&u===0&&(!o||!l||!w)&&(u=1,t=0,s=0,o=!0,l=!1,w=!1),c<u?!1:c>u?!o:h<t?!1:h>t?!l:a<s?!1:a>s?!w:!(P&&P<r))}e.isValidVersion=p;function g(k,y,d,v){return d.isBuiltin||typeof d.main=="undefined"?!0:b(k,y,d.engines.vscode,v)}e.isValidExtensionVersion=g;function i(k,y,d){return k==="*"||b(y,d,k)}e.isEngineValid=i;function b(k,y,d,v=[]){let P=n(E(d));if(!P)return v.push(m.localize(0,null,d)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return v.push(m.localize(1,null,d)),!1}else if(!P.majorMustEqual)return v.push(m.localize(2,null,d)),!1;return p(k,y,P)?!0:(v.push(m.localize(3,null,k,d)),!1)}}),define(J[163],Z([0,1,34,85,2,10]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends D.Disposable{constructor(p,g,i,b){super();this.folders=p,this.onDidFilesChange=g,this.onLogMessage=i,this.verboseLogging=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new M.Client(S.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(p.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(p){this.verboseLogging=p,!this.isDisposed&&this.service&&this.service.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${p}`})}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[164],Z([0,1,34,85,2,10]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends D.Disposable{constructor(p,g,i,b,k={}){super();this.folders=p,this.onDidFilesChange=g,this.onLogMessage=i,this.verboseLogging=b,this.watcherOptions=k,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new M.Client(S.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(p.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${p}`})}setVerboseLogging(p){this.verboseLogging=p,this.service&&this.service.setVerboseLogging(p)}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[165],Z([0,1,41,79,111,10]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class E{constructor(p,g,i,b,k){this.watchedFolder=p,this.eventCallback=i,this.logCallback=b,this.verboseLogging=k,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(y=>(0,D.parse)(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${p}, excludes: ${g.join(",")}`),this.startWatcher()}startWatcher(){const p=[this.watchedFolder];this.verboseLogging&&p.push("-verbose"),this.handle=(0,m.spawn)(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",V).fsPath,p);const g=new M.LineDecoder;this.handle.stdout.on("data",i=>{const b=[];for(const k of g.write(i)){const y=k.split("|");if(y.length===2){const d=Number(y[0]),v=y[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(P=>P(v))){this.verboseLogging&&this.log(v);continue}b.push({type:E.changeTypeMap[d],path:v})}else this.log(y[1])}}b.length>0&&this.eventCallback(b)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,b)=>this.onExit(i,b))}onError(p){this.error("process error: "+p.toString())}onExit(p,g){this.handle&&(this.error(`terminated unexpectedly (code: ${p}, signal: ${g})`),this.restartCounter<=E.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(p){this.logCallback({type:"error",message:`[File Watcher (C#)] ${p}`})}log(p){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${p}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=E,E.MAX_RESTARTS=5,E.changeTypeMap=[0,1,2]}),define(J[166],Z([0,1,165,8,23]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S{constructor(n,p,g,i){this.onDidFilesChange=p,this.onLogMessage=g,this.verboseLogging=i,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(M.posix.sep)&&(this.folder.path=(0,D.rtrim)(this.folder.path,M.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=S}),define(J[69],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(D,S=[],E=!1){this.ctor=D,this.staticArguments=S,this.supportsDelayedInstantiation=E}}e.SyncDescriptor=m}),define(J[167],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=m;class M{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let E of this._nodes.values())E.outgoing.size===0&&S.push(E);return S}insertEdge(S,E){const n=this.lookupOrInsertNode(S),p=this.lookupOrInsertNode(E);n.outgoing.set(this._hashFn(E),p),p.incoming.set(this._hashFn(S),n)}removeNode(S){const E=this._hashFn(S);this._nodes.delete(E);for(let n of this._nodes.values())n.outgoing.delete(E),n.incoming.delete(E)}lookupOrInsertNode(S){const E=this._hashFn(S);let n=this._nodes.get(E);return n||(n=new m(S),this._nodes.set(E,n)),n}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[E,n]of this._nodes)S.push(`${E}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,E]of this._nodes){const n=new Set([S]),p=this._findCycle(E,n);if(p)return p}}_findCycle(S,E){for(let[n,p]of S.outgoing){if(E.has(n))return[...E,n].join(" -> ");E.add(n);const g=this._findCycle(p,E);if(g)return g;E.delete(n)}}}e.Graph=M}),define(J[4],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function p(g){return g[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=p})(m=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function M(n,p,g,i){p[m.DI_TARGET]===p?p[m.DI_DEPENDENCIES].push({id:n,index:g,optional:i}):(p[m.DI_DEPENDENCIES]=[{id:n,index:g,optional:i}],p[m.DI_TARGET]=p)}function D(n){if(m.serviceIds.has(n))return m.serviceIds.get(n);const p=function(g,i,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(p,g,b,!1)};return p.toString=()=>n,m.serviceIds.set(n,p),p}e.createDecorator=D;function S(n){return n}e.refineServiceDecorator=S;function E(n){return function(p,g,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(n,p,i,!0)}}e.optional=E}),define(J[70],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,m.createDecorator)(e.ID);function M(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=M}),define(J[87],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,m.createDecorator)("encryptionMainService");class M{constructor(S){this.machineId=S}encryption(){return new Promise((S,E)=>V(["vscode-encrypt"],S,E))}async encrypt(S){try{return(await this.encryption()).encrypt(this.machineId,S)}catch(E){return S}}async decrypt(S){try{return(await this.encryption()).decrypt(this.machineId,S)}catch(E){return S}}}e.EncryptionMainService=M}),define(J[48],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(J[168],Z([0,1,136,4,10]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=S;var E;(function(b){b[b.NoneOrRelevance=0]="NoneOrRelevance",b[b.LastUpdatedDate=1]="LastUpdatedDate",b[b.Title=2]="Title",b[b.PublisherName=3]="PublisherName",b[b.InstallCount=4]="InstallCount",b[b.PublishedDate=5]="PublishedDate",b[b.AverageRating=6]="AverageRating",b[b.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var n;(function(b){b[b.Default=0]="Default",b[b.Ascending=1]="Ascending",b[b.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var p;(function(b){b.Install="install",b.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var g;(function(b){b[b.None=0]="None",b[b.Install=1]="Install",b[b.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(k,y){super(k);this.code=y,this.name=y}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",V).toString(!0),e.ExtensionsLabel=(0,m.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,m.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,M.createDecorator)("IExtensionManagementCLIService")}),define(J[169],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,m.createDecorator)("extensionUrlTrustService")}),define(J[170],Z([0,1,23,4]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=D;function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class n{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,k){if(typeof b=="undefined"||b===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof b=="string"||typeof k=="string"){let y=typeof b=="string"?b:b.value,d=typeof k=="string"?k:k.value;return m.equalsIgnoreCase(y,d)}return b._lower===k._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=n;function p(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function g(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=g,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[171],Z([0,1,23,170]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(d,v){return d.uuid&&v.uuid?d.uuid===v.uuid:d.id===v.id?!0:(0,m.compareIgnoreCase)(d.id,v.id)===0}e.areSameExtensions=D;class S{constructor(v,P){this.version=P,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof S?D(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=S;function E(d,v){return`${d}.${v}`}e.getExtensionId=E;function n(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function p(d,v){return n(E(d,v))}e.getGalleryExtensionId=p;function g(d,v){const P=[],I=c=>{for(const h of P)if(h.some(a=>D(v(a),v(c))))return h;return null};for(const c of d){const h=I(c);h?h.push(c):P.push([c])}return P}e.groupByExtension=g;function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function b(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function k(d){const v=new Set;for(const P of d)P.malicious&&v.add(P.id.id);return v}e.getMaliciousExtensionsSet=k;function y(d,v){const P=[],I=v.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const c=I.shift();if(c&&P.every(h=>!D(h.identifier,{id:c}))){const h=d.filter(a=>D(a.identifier,{id:c}));h.length===1&&(P.push(h[0]),I.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return P}e.getExtensionDependencies=y}),define(J[88],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(J[172],Z([0,1,41,8,68,138,18,3,88,10,105]),function(V,e,m,M,D,S,E,n,p,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=S.localize(0,null);class k{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends k{openTerminal(a,u){return this.spawnTerminal(m,a,D.getWindowsShell(),u)}spawnTerminal(a,u,t,s){const r=u.windowsExec||y.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const o=M.basename(r).toLowerCase();if(o==="cmder"||o==="cmder.exe")return a.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push('""'),l.push(r),(o==="wt"||o==="wt.exe")&&l.push("-d ."),new Promise((w,f)=>{const L=P(process),R=a.spawn(t,l,{cwd:s,env:L});R.on("error",f),R.on("exit",()=>w())})}runInTerminal(a,u,t,s,r){const o="windowsExec"in r&&r.windowsExec?r.windowsExec:y.getDefaultTerminalWindows();return new Promise((l,w)=>{const f=`"${u} - ${b}"`,L=`""${t.join('" "')}" & pause"`,R=["/c","start",f,"/wait",o,"/c",L],_=Object.assign({},P(process),s);Object.keys(_).filter(x=>_[x]===null).forEach(x=>delete _[x]);const C={cwd:u,env:_,windowsVerbatimArguments:!0};m.spawn(y.CMD,R,C).on("error",x=>{w(I(x))}),l(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class d extends k{openTerminal(a,u){return this.spawnTerminal(m,a,u)}runInTerminal(a,u,t,s,r){const o=r.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((l,w)=>{if(o===p.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const f=o===p.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[g.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${f}.scpt`,V).fsPath,"-t",a||b,"-w",u];for(let K of t)R.push("-a"),R.push(K);if(s){const K=Object.assign({},P(process),s);for(let x in K){const ie=K[x];ie===null?(R.push("-u"),R.push(x)):(R.push("-e"),R.push(`${x}=${ie}`))}}let _="";const C=m.spawn(d.OSASCRIPT,R);C.on("error",K=>{w(I(K))}),C.stderr.on("data",K=>{_+=K.toString()}),C.on("exit",K=>{if(K===0)l(void 0);else if(_){const x=_.split(`
`,1);w(new Error(x[0]))}else w(new Error(S.localize(1,null,f,K)))})}else w(new Error(S.localize(2,null,o)))})}spawnTerminal(a,u,t){const s=u.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((r,o)=>{const l=["-a",s];t&&l.push(t);const w=P(process),f=a.spawn("/usr/bin/open",l,{cwd:t,env:w});f.on("error",o),f.on("exit",()=>r())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class v extends k{openTerminal(a,u){return this.spawnTerminal(m,a,u)}runInTerminal(a,u,t,s,r){const o=r.linuxExec?Promise.resolve(r.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((l,w)=>{let f=[];o.then(L=>{L.indexOf("gnome-terminal")>=0?f.push("-x"):f.push("-e"),f.push("bash"),f.push("-c");const R=`${c(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;f.push(`''${R}''`);const _=Object.assign({},P(process),s);Object.keys(_).filter(ie=>_[ie]===null).forEach(ie=>delete _[ie]);const C={cwd:u,env:_};let K="";const x=m.spawn(L,f,C);x.on("error",ie=>{w(I(ie))}),x.stderr.on("data",ie=>{K+=ie.toString()}),x.on("exit",ie=>{if(ie===0)l(void 0);else if(K){const G=K.split(`
`,1);w(new Error(G[0]))}else w(new Error(S.localize(4,null,L,ie)))})})})}static async getDefaultTerminalLinuxReady(){return v._DEFAULT_TERMINAL_LINUX_READY||(v._DEFAULT_TERMINAL_LINUX_READY=new Promise(async a=>{n.isLinux?await E.Promises.exists("/etc/debian_version")?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm"):a("xterm")})),v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,u,t){const s=u.linuxExec?Promise.resolve(u.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{s.then(l=>{const w=P(process),f=a.spawn(l,[],{cwd:t,env:w});f.on("error",o),f.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=S.localize(3,null);function P(h){const a={...h.env};return(0,i.sanitizeProcessEnvironment)(a),a}function I(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(S.localize(5,null,h.path)):h}function c(h){let a="";for(let u of h)u.indexOf(" ")>=0?a+='"'+u+'"':a+=u,a+=" ";return a}}),define(J[19],Z([0,1,140,8,7,4,23,13,37]),function(V,e,m,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function g(U){return U.create===!0}e.isFileOpenForWriteOptions=g;var i;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var b;(function(U){U[U.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var k;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(k=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=y;function d(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=d;function v(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function P(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=P;var I;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor($,F){super($);this.code=F}}e.FileSystemProviderError=c;function h(U,$){const F=new c(U.toString(),$);return u(F,$),F}e.createFileSystemProviderError=h;function a(U){return U||h((0,m.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=a;function u(U,$){return U.name=$?`${$} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=u;function t(U){if(!U)return I.Unknown;if(U instanceof c)return U.code;const $=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!$)return I.Unknown;switch($[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=t;function s(U){if(U instanceof L)return U.fileOperationResult;switch(t(U)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class o{constructor($,F,N){this.resource=$,this.operation=F,this.target=N}isOperation($){return this.operation===$}}e.FileOperationEvent=o;var l;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class w{constructor($,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const N of $)switch(N.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>F)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>F)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>F)),this.deleted.set(N.resource,N);break}}contains($,...F){return this.doContains($,{includeChildren:!1},...F)}affects($,...F){return this.doContains($,{includeChildren:!0},...F)}doContains($,F,...N){if(!$)return!1;const B=N.length>0;return!!((!B||N.includes(1))&&(this.added?.get($)||F.includeChildren&&this.added?.findSuperstr($))||(!B||N.includes(0))&&(this.updated?.get($)||F.includeChildren&&this.updated?.findSuperstr($))||(!B||N.includes(2))&&(this.deleted?.findSubstr($)||F.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=w;function f(U,$,F){return!U||!$||U===$||$.length>U.length?!1:($.charAt($.length-1)!==M.sep&&($+=M.sep),F?(0,E.startsWithIgnoreCase)(U,$):U.indexOf($)===0)}e.isParent=f;class L extends Error{constructor($,F,N){super($);this.fileOperationResult=F,this.options=N}}e.FileOperationError=L;class R extends L{constructor($,F,N){super($,2,N);this.stat=F}}e.NotModifiedSinceFileOperationError=R;var _;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var C;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(C=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function K(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=K;async function x(U,$){if(!$.canHandleResource(D.URI.from({scheme:U.scheme})))return new Promise(F=>{const N=$.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===U.scheme&&B.added&&(N.dispose(),F())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ie{static formatSize($){return(0,n.isNumber)($)||($=0),$<ie.KB?(0,m.localize)(1,null,$.toFixed(0)):$<ie.MB?(0,m.localize)(2,null,($/ie.KB).toFixed(2)):$<ie.GB?(0,m.localize)(3,null,($/ie.MB).toFixed(2)):$<ie.TB?(0,m.localize)(4,null,($/ie.GB).toFixed(2)):(0,m.localize)(5,null,($/ie.TB).toFixed(2))}}e.ByteSize=ie,ie.KB=1024,ie.MB=ie.KB*ie.KB,ie.GB=ie.MB*ie.KB,ie.TB=ie.GB*ie.KB;var G;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function Q(U){return{maxFileSize:U===0?300*ie.MB:16*ie.GB,maxHeapSize:U===0?700*ie.MB:2*700*ie.MB}}e.getPlatformLimits=Q}),define(J[54],Z([0,1,241,135,19,86]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function E(k,y){const d={onUnknownOption:P=>{console.warn((0,M.localize)(0,null,P))},onMultipleValues:(P,I)=>{console.warn((0,M.localize)(1,null,P,I))}},v=(0,S.parseArgs)(k,S.OPTIONS,y?d:void 0);return v.goto&&v._.forEach(P=>m(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),(0,M.localize)(2,null))),v["max-memory"]&&m(parseInt(v["max-memory"])>=D.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${D.MIN_MAX_MEMORY_SIZE_MB} MB.`),v}function n(k){const y=k.findIndex(d=>!/^-/.test(d));if(y>-1)return[...k.slice(0,y),...k.slice(y+1)]}function p(k){let[,...y]=k;process.env.VSCODE_DEV&&(y=n(y)||[]);const d=!b(process.env);return E(y,d)}e.parseMainProcessArgv=p;function g(k){const[,,...y]=k;return E(y,!0)}e.parseCLIProcessArgv=g;function i(k,...y){const d=k.indexOf("--");return d===-1?k.push(...y):k.splice(d,0,...y),k}e.addArg=i;function b(k){return k.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(J[89],Z([0,1,159,41,28,3,54,67,130,25,16]),function(V,e,m,M,D,S,E,n,p,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function b(d,v,P){return v["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(P)&&!v["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(P)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),k||(k=new Promise(async I=>{const c=new g.CancellationTokenSource,h=setTimeout(()=>{d.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),c.dispose(!0),I({})},1e4);try{const a=await y(d,c.token);I(a)}catch(a){(0,i.isPromiseCanceledError)(a)||d.error(`[resolve shell env] Unable to resolve shell environment (${a}). Proceeding without shell environment...`),I({})}finally{clearTimeout(h),c.dispose()}})),k)}e.resolveShellEnv=b;let k;async function y(d,v){const P=new Promise(async(I,c)=>{const h=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",h);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",a);const u=(0,D.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(u+"(.*)"+u),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",s);const r=await(0,p.getSystemShell)(S.OS,s);if(d.trace("getUnixShellEnvironment#shell",r),v.isCancellationRequested)return c(i.canceled);const o=m.basename(r);let l,w;/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,w=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,w=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(w),l);const f=(0,M.spawn)(r,[...w,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});v.onCancellationRequested(()=>(f.kill(),c(i.canceled))),f.on("error",_=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,n.toErrorMessage)(_)),I({})});const L=[];f.stdout.on("data",_=>L.push(_));const R=[];f.stderr.on("data",_=>R.push(_)),f.on("close",(_,C)=>{const K=Buffer.concat(L).toString("utf8");d.trace("getUnixShellEnvironment#raw",K);const x=Buffer.concat(R).toString("utf8");if(x.trim()&&d.trace("getUnixShellEnvironment#stderr",x),_||C)return c(new Error(`Failed to get environment (code ${_}, signal ${C})`));const ie=t.exec(K),G=ie?ie[1]:"{}";try{const Q=JSON.parse(G);h?Q.ELECTRON_RUN_AS_NODE=h:delete Q.ELECTRON_RUN_AS_NODE,a?Q.ELECTRON_NO_ATTACH_CONSOLE=a:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",Q),I(Q)}catch(Q){d.error("getUnixShellEnvironment#errorCaught",(0,n.toErrorMessage)(Q)),c(Q)}})});try{return await P}catch(I){return d.error("getUnixShellEnvironment#error",(0,n.toErrorMessage)(I)),{}}}}),define(J[90],Z([0,1,7,19,3]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function S(p){return p.map(g=>({type:g.type,resource:m.URI.file(g.path)}))}e.toFileChanges=S;function E(p){const g=new n;for(const i of p)g.processEvent(i);return g.normalize()}e.normalizeFileChanges=E;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const i=this.mapPathToChange.get(g.path);if(i){const b=i.type,k=g.type;b===1&&k===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(i),1)):b===2&&k===1?i.type=0:b===1&&k===0||(i.type=k)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],i=[];return this.normalized.filter(b=>b.type!==2?(g.push(b),!1):!0).sort((b,k)=>b.path.length-k.path.length).filter(b=>i.some(k=>(0,M.isParent)(b.path,k,!D.isLinux))?!1:(i.push(b.path),!0)).concat(g)}}}),define(J[173],Z([0,1,90,2,18,80,117,9,8]),function(V,e,m,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class g extends M.Disposable{constructor(b,k,y,d){super();this.path=b,this.onDidFilesChange=k,this.onLogMessage=y,this.verboseLogging=d,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(E.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(b){this.verboseLogging=b}async startWatching(){try{const{stat:b,symbolicLink:k}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(k)try{y=await(0,S.realpath)(y)}catch(d){if(this.onError(d),k.dangling)return}b.isDirectory()?this._register((0,E.watchFolder)(y,(d,v)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,p.join)(this.path,(0,p.basename)(v))})},d=>this.onError(d))):this._register((0,E.watchFile)(y,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(b){b.code!=="ENOENT"&&this.onError(b)}}onFileChange(b){this.fileChangesBuffer.push(b),this.verboseLogging&&this.onVerbose(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),this.fileChangesDelayer.trigger(async()=>{const k=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,m.normalizeFileChanges)(k);if(this.verboseLogging)for(const d of y)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);y.length>0&&this.onDidFilesChange(y)})}onError(b){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${b}`})}onVerbose(b){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=g}),define(J[71],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...D){this._entries=new Map;for(let[S,E]of D)this.set(S,E)}set(D,S){const E=this._entries.get(D);return this._entries.set(D,S),E}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=m}),define(J[174],Z([0,1,16,167,69,4,71,9]),function(V,e,m,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const p=!1;class g extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class i{constructor(d=new E.ServiceCollection,v=!1,P){this._activeInstantiations=new Set,this._services=d,this._strict=v,this._parent=P,this._services.set(S.IInstantiationService,this)}createChild(d){return new i(d,this._strict,this)}invokeFunction(d,...v){let P=k.traceInvocation(d),I=!1;try{return d({get:(h,a)=>{if(I)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(h,P);if(!u&&a!==S.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return u}},...v)}finally{I=!0,P.stop()}}createInstance(d,...v){let P,I;return d instanceof D.SyncDescriptor?(P=k.traceCreation(d.ctor),I=this._createInstance(d.ctor,d.staticArguments.concat(v),P)):(P=k.traceCreation(d),I=this._createInstance(d,v,P)),P.stop(),I}_createInstance(d,v=[],P){let I=S._util.getServiceDependencies(d).sort((a,u)=>a.index-u.index),c=[];for(const a of I){let u=this._getOrCreateServiceInstance(a.id,P);if(!u&&this._strict&&!a.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${a.id}.`);c.push(u)}let h=I.length>0?I[0].index:v.length;if(v.length!==h){console.warn(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${v.length} static arguments`);let a=h-v.length;a>0?v=v.concat(new Array(a)):v=v.slice(0,h)}return new d(...[...v,...c])}_setServiceInstance(d,v){if(this._services.get(d)instanceof D.SyncDescriptor)this._services.set(d,v);else if(this._parent)this._parent._setServiceInstance(d,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let v=this._services.get(d);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):v}_getOrCreateServiceInstance(d,v){let P=this._getServiceInstanceOrDescriptor(d);return P instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,P,v.branch(d,!0)):(v.branch(d,!1),P)}_safeCreateAndCacheServiceInstance(d,v,P){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,v,P)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,v,P){const I=new M.Graph(a=>a.id.toString());let c=0;const h=[{id:d,desc:v,_trace:P}];for(;h.length;){const a=h.pop();if(I.lookupOrInsertNode(a),c++>1e3)throw new g(I);for(let u of S._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(u.id);if(!t&&!u.optional&&console.warn(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const s={id:u.id,desc:t,_trace:a._trace.branch(u.id,!0)};I.insertEdge(a,s),h.push(s)}}}for(;;){const a=I.roots();if(a.length===0){if(!I.isEmpty())throw new g(I);break}for(const{data:u}of a){if(this._getServiceInstanceOrDescriptor(u.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,s)}I.removeNode(u)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,v,P=[],I,c){if(this._services.get(d)instanceof D.SyncDescriptor)return this._createServiceInstance(v,P,I,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,v,P,I,c);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(d,v=[],P,I){if(P){const c=new n.IdleValue(()=>this._createInstance(d,v,I));return new Proxy(Object.create(null),{get(h,a){if(a in h)return h[a];let u=c.value,t=u[a];return typeof t!="function"||(t=t.bind(u),h[a]=t),t},set(h,a,u){return c.value[a]=u,!0}})}else return this._createInstance(d,v,I)}}e.InstantiationService=i;var b;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(b||(b={}));class k{constructor(d,v){this.type=d,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return p?new k(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):k._None}static traceCreation(d){return p?new k(0,d.name):k._None}branch(d,v){let P=new k(2,d.toString());return this._dep.push([d,v,P]),P}stop(){let d=Date.now()-this._start;k._totals+=d;let v=!1;function P(c,h){let a=[],u=new Array(c+1).join("	");for(const[t,s,r]of h._dep)if(s&&r){v=!0,a.push(`${u}CREATES -> ${t}`);let o=P(c+1,r);o&&a.push(o)}else a.push(`${u}uses -> ${t}`);return a.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${k._totals.toFixed(2)}ms)`];(d>2||v)&&console.log(I.join(`
`))}}k._None=new class extends k{constructor(){super(-1,null)}stop(){}branch(){return this}},k._totals=0}),define(J[175],Z([0,1,16,128,57]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class S extends D.ResolvedKeybinding{constructor(n,p){super();if(p.length===0)throw(0,m.illegalArgument)("parts");this._os=n,this._parts=p}getLabel(){return M.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return M.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:M.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return M.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new D.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=S}),define(J[176],Z([0,1,57,175]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class D extends M.BaseResolvedKeybinding{constructor(E,n){super(n,E.parts)}_keyCodeToUILabel(E){if(this._os===2)switch(E){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return m.KeyCodeUtils.toString(E)}_getLabel(E){return E.isDuplicateModifierCase()?"":this._keyCodeToUILabel(E.keyCode)}_getAriaLabel(E){return E.isDuplicateModifierCase()?"":m.KeyCodeUtils.toString(E.keyCode)}_keyCodeToElectronAccelerator(E){if(E>=93&&E<=108)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return m.KeyCodeUtils.toString(E)}_getElectronAccelerator(E){return E.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(E.keyCode)}_getUserSettingsLabel(E){if(E.isDuplicateModifierCase())return"";const n=m.KeyCodeUtils.toUserSettingsUS(E.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(E){return D.getDispatchStr(E)}static getDispatchStr(E){if(E.isModifierKey())return null;let n="";return E.ctrlKey&&(n+="ctrl+"),E.shiftKey&&(n+="shift+"),E.altKey&&(n+="alt+"),E.metaKey&&(n+="meta+"),n+=m.KeyCodeUtils.toString(E.keyCode),n}_getSingleModifierDispatchPart(E){return E.keyCode===5&&!E.shiftKey&&!E.altKey&&!E.metaKey?"ctrl":E.keyCode===4&&!E.ctrlKey&&!E.altKey&&!E.metaKey?"shift":E.keyCode===6&&!E.ctrlKey&&!E.shiftKey&&!E.metaKey?"alt":E.keyCode===57&&!E.ctrlKey&&!E.shiftKey&&!E.altKey?"meta":null}}e.USLayoutResolvedKeybinding=D}),define(J[177],Z([0,1,9]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function M(D,S){if(D.length===0)return Promise.resolve(!1);const E=[];let n=!1;for(let p of D){if(p===!0)return Promise.resolve(!0);(0,m.isThenable)(p)&&E.push(p.then(g=>{g&&(n=!0)},g=>{S(g),n=!0}))}return m.Promises.settled(E).then(()=>n)}e.handleVetos=M}),define(J[6],Z([0,1,4,2,3,5,67]),function(V,e,m,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function n(){return new Date().toISOString()}var p;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;class g extends M.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=g;class i extends g{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(p.Trace)&&this.log(p.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(p.Debug)&&this.log(p.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(p.Info)&&this.log(p.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(p.Warning)&&this.log(p.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(p.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(p.Error,this.format(r))}else this.log(p.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(p.Critical)&&this.log(p.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let o=t[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch(l){}s+=(r>0?" ":"")+o}return s}}e.AbstractMessageLogger=i;class b extends g{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...s){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...s):console.log(`[main ${n()}]`,t,...s))}debug(t,...s){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...s):console.log(`[main ${n()}]`,t,...s))}info(t,...s){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...s):console.log(`[main ${n()}]`,t,...s))}warn(t,...s){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...s):console.warn(`[main ${n()}]`,t,...s))}error(t,...s){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...s):console.error(`[main ${n()}]`,t,...s))}critical(t,...s){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...s):console.error(`[main ${n()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class k extends g{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=k;class y extends g{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,E.toErrorMessage)(t,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class d extends g{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class v extends M.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=v;class P extends M.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?p.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class I{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return p.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=I;function c(u){if(u.verbose)return p.Trace;if(typeof u.logLevel=="string"){const t=h(u.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function h(u){switch(u){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=h;function a(u){switch(u){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=a});var ee=this&&this.__param||function(V,e){return function(m,M){e(m,M,V)}};define(J[178],Z([0,1,9,17,40,76,48,19,4,6]),function(V,e,m,M,D,S,E,n,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(k){k.ERROR_INVALID_FILE="ERROR_INVALID_FILE",k.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,p.createDecorator)(e.UserConfigurationFileServiceId);let b=class{constructor(y,d,v){this.environmentService=y,this.fileService=d,this.logService=v,this.queue=new m.Queue}async updateSettings(y,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,y,d))}async doWrite(y,d,v){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,y.toString(),d);const{value:P,mtime:I,etag:c}=await this.fileService.readFile(y,{atomic:!0});let h=P.toString();const a=[];if((0,D.parse)(h,a,{allowTrailingComma:!0,allowEmptyContent:!0}),a.length)throw new Error("ERROR_INVALID_FILE");const u=this.getEdits(d,h,v)[0];if(u){h=h.substring(0,u.offset)+u.content+h.substring(u.offset+u.length);try{await this.fileService.writeFile(y,M.VSBuffer.fromString(h),{etag:c,mtime:I})}catch(t){if(t.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:y,path:d},v,P){return d.length?(0,S.setProperty)(v,d,y,P):[{content:JSON.stringify(y,null,P.insertSpaces&&P.tabSize?" ".repeat(P.tabSize):"	"),length:v.length,offset:0}]}};b=he([ee(0,E.IEnvironmentService),ee(1,n.IFileService),ee(2,g.ILogService)],b),e.UserConfigurationFileService=b}),define(J[91],Z([0,1,6]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function M(S,E){switch(E){case m.LogLevel.Trace:return S.trace;case m.LogLevel.Debug:return S.debug;case m.LogLevel.Info:return S.info;case m.LogLevel.Warning:return S.warn;case m.LogLevel.Error:return S.error;case m.LogLevel.Critical:return S.critical;default:throw new Error("Invalid log level")}}class D extends m.AbstractLogger{constructor(E=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(E),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(E){this._logger=E;for(const{level:n,args:p}of this.buffer)M(E,n).apply(E,p);this.buffer=[]}_log(E,...n){this._logger?M(this._logger,E).apply(this._logger,n):this.getLevel()<=E&&this.buffer.push({level:E,args:n})}trace(E,...n){this._log(m.LogLevel.Trace,E,...n)}debug(E,...n){this._log(m.LogLevel.Debug,E,...n)}info(E,...n){this._log(m.LogLevel.Info,E,...n)}warn(E,...n){this._log(m.LogLevel.Warning,E,...n)}error(E,...n){this._log(m.LogLevel.Error,E,...n)}critical(E,...n){this._log(m.LogLevel.Critical,E,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(J[179],Z([0,1,6,19,9,17,15,4,91]),function(V,e,m,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const g=5*M.ByteSize.MB;let i=class extends m.AbstractLogger{constructor(y,d,v,P,I){super();this.name=y,this.resource=d,this.donotUseFormatters=P,this.fileService=I,this.backupIndex=1,this.setLevel(v),this.queue=this._register(new D.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=y.stack,this._log(m.LogLevel.Error,this.format(d))}else this._log(m.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,this.format(arguments))}flush(){}log(y,d){this._log(y,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,d){this.queue.queue(async()=>{await this.initializePromise;let v=await this.loadContent();v.length>g&&(await this.fileService.writeFile(this.getBackupResource(),S.VSBuffer.fromString(v)),v=""),this.donotUseFormatters?v+=d:v+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${d}
`,await this.fileService.writeFile(this.resource,S.VSBuffer.fromString(v))})}getCurrentTimestamp(){const y=P=>P<10?`0${P}`:P,d=P=>P<10?`00${P}`:P<100?`0${P}`:P,v=new Date;return`${v.getFullYear()}-${y(v.getMonth()+1)}-${y(v.getDate())} ${y(v.getHours())}:${y(v.getMinutes())}:${y(v.getSeconds())}.${d(v.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,E.joinPath)((0,E.dirname)(this.resource),`${(0,E.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(y){return""}}stringifyLogLevel(y){switch(y){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}format(y){let d="";for(let v=0;v<y.length;v++){let P=y[v];if(typeof P=="object")try{P=JSON.stringify(P)}catch(I){}d+=(v>0?" ":"")+P}return d}};i=he([ee(4,M.IFileService)],i),e.FileLogger=i;let b=class extends m.AbstractLoggerService{constructor(y,d,v){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=d,this.fileService=v}doCreateLogger(y,d,v){const P=new p.BufferLogService(d);return(0,M.whenProviderRegistered)(y,this.fileService).then(()=>P.logger=this.instantiationService.createInstance(i,(0,E.basename)(y),y,P.getLevel(),!!v?.donotUseFormatters)),P}};b=he([ee(0,m.ILogService),ee(1,n.IInstantiationService),ee(2,M.IFileService)],b),e.FileLoggerService=b}),define(J[180],Z([0,1,6,5,7]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(k){this.service=k,this.onDidChangeLogLevel=M.Event.buffer(k.onDidChangeLogLevel,!0)}listen(k,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(k,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=S;class E{constructor(k){this.channel=k}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(k){E.setLevel(this.channel,k)}static setLevel(k,y){return k.call("setLevel",y)}}e.LogLevelChannelClient=E;class n{constructor(k){this.loggerService=k,this.loggers=new Map}listen(k,y){throw new Error(`Event not found: ${y}`)}async call(k,y,d){switch(y){case"createLogger":this.createLogger(D.URI.revive(d[0]),d[1]);return;case"log":return this.log(D.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(k,y){this.loggers.set(k.toString(),this.loggerService.createLogger(k,y))}consoleLog(k,y){let d=console.log;switch(k){case m.LogLevel.Error:d=console.error;break;case m.LogLevel.Warning:d=console.warn;break;case m.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(k,y){const d=this.loggers.get(k.toString());if(!d)throw new Error("Create the logger before logging");for(const[v,P]of y)switch(v){case m.LogLevel.Trace:d.trace(P);break;case m.LogLevel.Debug:d.debug(P);break;case m.LogLevel.Info:d.info(P);break;case m.LogLevel.Warning:d.warn(P);break;case m.LogLevel.Error:d.error(P);break;case m.LogLevel.Critical:d.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class p extends m.AbstractLoggerService{constructor(k,y,d){super(k,y);this.channel=d}createConsoleMainLogger(){return new m.AdapterLogger({log:(k,y)=>{this.channel.call("consoleLog",[k,y])}})}doCreateLogger(k,y,d){return new g(this.channel,k,y,d)}}e.LoggerChannelClient=p;class g extends m.AbstractMessageLogger{constructor(k,y,d,v){super(v?.always);this.channel=k,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(k,y){const d=[[k,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(k){this.channel.call("log",[this.file,k])}}class i extends m.LogService{constructor(k,y){super(y);this.parent=k,this._register(k.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(k){super.setLevel(k),this.parent.setLevel(k)}}e.FollowerLogService=i}),define(J[92],Z([0,1,6,19]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(p,g,i,b){try{const k=await new Promise((y,d)=>{V(["spdlog"],y,d)});return k.setFlushOn(m.LogLevel.Trace),k.createAsyncRotatingLogger(p,g,i,b)}catch(k){console.error(k)}return null}function S(p,g,i,b){const k=V.__$__nodeRequire("spdlog");return k.setFlushOn(m.LogLevel.Trace),k.createRotatingLogger(p,g,i,b)}e.createRotatingLogger=S;function E(p,g,i){switch(g){case m.LogLevel.Trace:p.trace(i);break;case m.LogLevel.Debug:p.debug(i);break;case m.LogLevel.Info:p.info(i);break;case m.LogLevel.Warning:p.warn(i);break;case m.LogLevel.Error:p.error(i);break;case m.LogLevel.Critical:p.critical(i);break;default:throw new Error("Invalid log level")}}class n extends m.AbstractMessageLogger{constructor(g,i,b,k){super();this.name=g,this.filepath=i,this.rotating=b,this.buffer=[],this.setLevel(k),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const g=this.rotating?6:1,i=30/g*M.ByteSize.MB;return D(this.name,this.filepath,i,g).then(b=>{if(b){this._logger=b,this._logger.setLevel(this.getLevel());for(const{level:k,message:y}of this.buffer)E(this._logger,k,y);this.buffer=[]}})}log(g,i){this._logger?E(this._logger,g,i):this.getLevel()<=g&&this.buffer.push({level:g,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(J[181],Z([0,1,6,15,10,179,92,19,28]),function(V,e,m,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let g=class extends m.AbstractLoggerService{constructor(b,k){super(b.getLevel(),b.onDidChangeLogLevel);this.fileService=k}doCreateLogger(b,k,y){if(b.scheme===D.Schemas.file){const d=new E.SpdLogLogger(y?.name||(0,p.generateUuid)(),b.fsPath,!y?.donotRotate,k);return y?.donotUseFormatters&&d.clearFormatters(),d}else return new S.FileLogger(y?.name??(0,M.basename)(b),b,k,!!y?.donotUseFormatters,this.fileService)}};g=he([ee(0,m.ILogService),ee(1,n.IFileService)],g),e.LoggerService=g}),define(J[182],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function m(E){return E.submenu!==void 0}e.isMenubarMenuItemSubmenu=m;function M(E){return E.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=M;function D(E){return E.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function S(E){return!m(E)&&!M(E)&&!D(E)}e.isMenubarMenuItemAction=S}),define(J[49],Z([0,1,10,3,33,15]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let E;if(typeof M.globals.vscode!="undefined"&&typeof M.globals.vscode.context!="undefined"){const n=M.globals.vscode.context.configuration();if(n)E=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const n=(0,S.dirname)(m.FileAccess.asFileUri("",V));E=V.__$__nodeRequire((0,S.joinPath)(n,"product.json").fsPath);const p=V.__$__nodeRequire((0,S.joinPath)(n,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(E,{nameShort:`${E.nameShort} Dev`,nameLong:`${E.nameLong} Dev`,dataFolderName:`${E.dataFolderName}-dev`}),Object.assign(E,{version:p.version})}else E={},Object.keys(E).length===0&&Object.assign(E,{version:"1.59.0-dev",nameShort:M.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:M.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=E}),define(J[93],Z([0,1,141,17,19,16,49]),function(V,e,m,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(b,k,y,d,v,P){let I;try{await p(b,k,y,d,v,P)}catch(c){I=c}finally{I&&v.errorTransformer&&(I=v.errorTransformer(I)),typeof I!="undefined"&&y.error(I),y.end()}}e.readFileIntoStream=n;async function p(b,k,y,d,v,P){g(P);const I=await b.open(k,{create:!1});try{g(P);let c=0,h=0,a=v&&typeof v.length=="number"?v.length:void 0,u=M.VSBuffer.alloc(Math.min(v.bufferSize,typeof a=="number"?a:v.bufferSize)),t=v&&typeof v.position=="number"?v.position:0,s=0;do h=await b.read(I,t,u.buffer,s,u.byteLength-s),t+=h,s+=h,c+=h,typeof a=="number"&&(a-=h),s===u.byteLength&&(await y.write(d(u)),u=M.VSBuffer.alloc(Math.min(v.bufferSize,typeof a=="number"?a:v.bufferSize)),s=0);while(h>0&&(typeof a!="number"||a>0)&&g(P)&&i(c,v));if(s>0){let r=s;typeof a=="number"&&(r=Math.min(s,a)),y.write(d(u.slice(0,r)))}}catch(c){throw(0,D.ensureFileSystemProviderError)(c)}finally{await b.close(I)}}function g(b){if(b.isCancellationRequested)throw(0,S.canceled)();return!0}function i(b,k){if(k?.limits){if(typeof k.limits.memory=="number"&&b>k.limits.memory)throw(0,D.createFileSystemProviderError)((0,m.localize)(0,null,E.default.nameShort),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&b>k.limits.size)throw(0,D.createFileSystemProviderError)((0,m.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[183],Z([0,1,139,72,2,19,5,15,37,36,6,17,64,9,25,10,93,63]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class qe extends D.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new E.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new E.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new E.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new E.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new E.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new E.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new y.ThrottledWorker(qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,qe.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new S.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new y.ThrottledWorker(qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,qe.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new S.FileChangesEvent(u,!0)))),this.watchedResources=p.TernarySearchTree.forUris(u=>{const t=this.getProvider(u.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new y.ResourceQueue)}registerProvider(a,u){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,M.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:u});const t=new D.DisposableStore;return t.add(u.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(u)))),t.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:a}))),typeof u.onDidErrorOccur=="function"&&t.add(u.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,D.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:u}),this.provider.delete(a),(0,D.dispose)(t)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(t){u.push(t)}}),!this.provider.has(a)&&await y.Promises.settled(u)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,u){const t=this.provider.get(a.scheme);return!!(t&&t.capabilities&u)}listCapabilities(){return I.Iterable.map(this.provider,([a,u])=>({scheme:a,capabilities:u.capabilities}))}async withProvider(a){if(!(0,n.isAbsolutePath)(a))throw new S.FileOperationError((0,m.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const u=this.provider.get(a.scheme);if(!u){const t=new Error;throw t.name="ENOPRO",t.message=(0,m.localize)(1,null,a.toString()),t}return u}async withReadProvider(a){const u=await this.withProvider(a);if((0,S.hasOpenReadWriteCloseCapability)(u)||(0,S.hasReadWriteCapability)(u)||(0,S.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const u=await this.withProvider(a);if((0,S.hasOpenReadWriteCloseCapability)(u)||(0,S.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,u){try{return await this.doResolveFile(a,u)}catch(t){throw(0,S.toFileSystemProviderErrorCode)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,m.localize)(2,null,this.resourceForError(a)),1):(0,S.ensureFileSystemProviderError)(t)}}async doResolveFile(a,u){const t=await this.withProvider(a),s=this.isPathCaseSensitive(t),r=u?.resolveTo,o=u?.resolveSingleChildDescendants,l=u?.resolveMetadata,w=await t.stat(a);let f;return this.toFileStat(t,a,w,void 0,!!l,(L,R)=>(f||(f=p.TernarySearchTree.forUris(()=>!s),f.set(a,!0),(0,g.isNonEmptyArray)(r)&&r.forEach(_=>f.set(_,!0))),Boolean(f.findSuperstr(L.resource)||f.get(L.resource))?!0:L.isDirectory&&o?R===1:!1))}async toFileStat(a,u,t,s,r,o){const{providerExtUri:l}=this.getExtUri(a),w={resource:u,name:l.basename(u),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&S.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,S.etag)({mtime:t.mtime,size:t.size})};if(w.isDirectory&&o(w,s)){try{const f=await a.readdir(u),L=await y.Promises.settled(f.map(async([R,_])=>{try{const C=l.joinPath(u,R),K=r?await a.stat(C):{type:_};return await this.toFileStat(a,C,K,f.length,r,o)}catch(C){return this.logService.trace(C),null}}));w.children=(0,g.coalesce)(L)}catch(f){this.logService.trace(f),w.children=[]}return w}return w}async resolveAll(a){return y.Promises.settled(a.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(a){const u=await this.withProvider(a);try{return!!await u.stat(a)}catch(t){return!1}}async canCreateFile(a,u){try{await this.doValidateCreateFile(a,u)}catch(t){return t}return!0}async doValidateCreateFile(a,u){if(!u?.overwrite&&await this.exists(a))throw new S.FileOperationError((0,m.localize)(3,null,this.resourceForError(a)),3,u)}async createFile(a,u=b.VSBuffer.fromString(""),t){await this.doValidateCreateFile(a,t);const s=await this.writeFile(a,u);return this._onDidRunOperation.fire(new S.FileOperationEvent(a,0,s)),s}async writeFile(a,u,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,a,t)||await this.mkdirp(s,r.dirname(a));let l;if((0,S.hasReadWriteCapability)(s)&&!(u instanceof b.VSBuffer))if((0,k.isReadableStream)(u)){const w=await(0,k.peekStream)(u,3);w.ended?l=b.VSBuffer.concat(w.buffer):l=w}else l=(0,k.peekReadable)(u,w=>b.VSBuffer.concat(w),3);else l=u;!(0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasReadWriteCapability)(s)&&l instanceof b.VSBuffer?await this.doWriteUnbuffered(s,a,t,l):await this.doWriteBuffered(s,a,t,l instanceof b.VSBuffer?(0,b.bufferToReadable)(l):l)}catch(o){throw new S.FileOperationError((0,m.localize)(4,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),t)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,u,t){if(!!t?.unlock&&!(a.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(u)));let r;try{r=await a.stat(u)}catch(o){return}if((r.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,m.localize)(6,null,this.resourceForError(u)),0,t);if(this.throwIfFileIsReadonly(u,r),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,S.etag)({mtime:t.mtime,size:r.size}))throw new S.FileOperationError((0,m.localize)(7,null),3,t);return r}async readFile(a,u){const t=await this.withReadProvider(a);return u?.atomic?this.doReadFileAtomic(t,a,u):this.doReadFile(t,a,u)}async doReadFileAtomic(a,u,t){return new Promise((s,r)=>{this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(a,u,t);s(o)}catch(o){r(o)}})})}async doReadFile(a,u,t){const s=await this.doReadFileStream(a,u,{...t,preferUnbuffered:!0});return{...s,value:await(0,b.streamToBuffer)(s.value)}}async readFileStream(a,u){const t=await this.withReadProvider(a);return this.doReadFileStream(t,a,u)}async doReadFileStream(a,u,t){const s=new d.CancellationTokenSource,r=this.validateReadFile(u,t).then(l=>l,l=>{throw s.cancel(),l});let o;try{return t&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await r,!((0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasFileReadStreamCapability)(a))||(0,S.hasReadWriteCapability)(a)&&t?.preferUnbuffered?o=this.readFileUnbuffered(a,u,t):(0,S.hasFileReadStreamCapability)(a)?o=this.readFileStreamed(a,u,s.token,t):o=this.readFileBuffered(a,u,s.token,t),{...await r,value:o}}catch(l){o&&await(0,k.consumeStream)(o);const w=(0,m.localize)(8,null,this.resourceForError(u),(0,S.ensureFileSystemProviderError)(l).toString());throw l instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(w,l.stat,t):new S.FileOperationError(w,(0,S.toFileOperationResult)(l),t)}}readFileStreamed(a,u,t,s=Object.create(null)){const r=a.readFileStream(u,s,t);return(0,k.transform)(r,{data:o=>o instanceof b.VSBuffer?o:b.VSBuffer.wrap(o),error:o=>new S.FileOperationError((0,m.localize)(9,null,this.resourceForError(u),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),s)},o=>b.VSBuffer.concat(o))}readFileBuffered(a,u,t,s=Object.create(null)){const r=(0,b.newWriteableBufferStream)();return(0,P.readFileIntoStream)(a,u,r,o=>o,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new S.FileOperationError((0,m.localize)(10,null,this.resourceForError(u),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),s)},t),r}readFileUnbuffered(a,u,t){const s=(0,k.newWriteableStream)(r=>b.VSBuffer.concat(r));return(async()=>{try{let r=await a.readFile(u);t&&typeof t.position=="number"&&(r=r.slice(t.position)),t&&typeof t.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(u,r.byteLength,t),s.end(b.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(a,u){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError((0,m.localize)(11,null,this.resourceForError(a)),0,u);if(u&&typeof u.etag=="string"&&u.etag!==S.ETAG_DISABLED&&u.etag===t.etag)throw new S.NotModifiedSinceFileOperationError((0,m.localize)(12,null),t,u);return this.validateReadFileLimits(a,t.size,u),t}validateReadFileLimits(a,u,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&u>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&u>t.limits.size&&(s=7),typeof s=="number")throw new S.FileOperationError((0,m.localize)(13,null,this.resourceForError(a)),s)}}async canMove(a,u,t){return this.doCanMoveCopy(a,u,"move",t)}async canCopy(a,u,t){return this.doCanMoveCopy(a,u,"copy",t)}async doCanMoveCopy(a,u,t,s){if(a.toString()!==u.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(r,a,o,u,t,s)}catch(r){return r}return!0}async move(a,u,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),o=await this.doMoveCopy(s,a,r,u,"move",!!t),l=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(a,o==="move"?2:3,l)),l}async copy(a,u,t){const s=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),o=await this.doMoveCopy(s,a,r,u,"copy",!!t),l=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(a,o==="copy"?3:2,l)),l}async doMoveCopy(a,u,t,s,r,o){if(u.toString()===s.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:w}=await this.doValidateMoveCopy(a,u,t,s,r,o);if(l&&!w&&o&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),r==="copy"){if(a===t&&(0,S.hasFileFolderCopyCapability)(a))await a.copy(u,s,{overwrite:o});else{const f=await this.resolve(u);f.isDirectory?await this.doCopyFolder(a,f,t,s):await this.doCopyFile(a,u,t,s)}return r}else return a===t?(await a.rename(u,s,{overwrite:o}),r):(await this.doMoveCopy(a,u,t,s,"copy",o),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(a,u,t,s){if((0,S.hasOpenReadWriteCloseCapability)(a)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(a,u,t,s);if((0,S.hasOpenReadWriteCloseCapability)(a)&&(0,S.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(a,u,t,s);if((0,S.hasReadWriteCapability)(a)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(a,u,t,s);if((0,S.hasReadWriteCapability)(a)&&(0,S.hasReadWriteCapability)(t))return this.doPipeUnbuffered(a,u,t,s)}async doCopyFolder(a,u,t,s){await t.mkdir(s),Array.isArray(u.children)&&await y.Promises.settled(u.children.map(async r=>{const o=this.getExtUri(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),t,o):this.doCopyFile(a,r.resource,t,o)}))}async doValidateMoveCopy(a,u,t,s,r,o){let l=!1;if(a===t){const{providerExtUri:f,isPathCaseSensitive:L}=this.getExtUri(a);if(L||(l=f.isEqual(u,s)),l&&r==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(u),this.resourceForError(s)));if(!l&&f.isEqualOrParent(s,u))throw new Error((0,m.localize)(15,null,this.resourceForError(u),this.resourceForError(s)))}const w=await this.exists(s);if(w&&!l){if(!o)throw new S.FileOperationError((0,m.localize)(16,null,this.resourceForError(u),this.resourceForError(s)),4);if(a===t){const{providerExtUri:f}=this.getExtUri(a);if(f.isEqualOrParent(u,s))throw new Error((0,m.localize)(17,null,this.resourceForError(u),this.resourceForError(s)))}}return{exists:w,isSameResourceWithDifferentPathCase:l}}getExtUri(a){const u=this.isPathCaseSensitive(a);return{providerExtUri:u?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(u,a);const t=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(a,0,t)),t}async mkdirp(a,u){const t=[],{providerExtUri:s}=this.getExtUri(a);for(;!s.isEqual(u,s.dirname(u));)try{if(((await a.stat(u)).type&S.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(u)));break}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(u)),u=s.dirname(u)}for(let r=t.length-1;r>=0;r--){u=s.joinPath(u,t[r]);try{await a.mkdir(u)}catch(o){if((0,S.toFileSystemProviderErrorCode)(o)!==S.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,u){try{await this.doValidateDelete(a,u)}catch(t){return t}return!0}async doValidateDelete(a,u){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!u?.useTrash&&!(t.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(a)));let r;try{r=await t.stat(a)}catch(l){}if(r)this.throwIfFileIsReadonly(a,r);else throw new S.FileOperationError((0,m.localize)(20,null,this.resourceForError(a)),1);if(!!!u?.recursive){const l=await this.resolve(a);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(a)))}return t}async del(a,u){const t=await this.doValidateDelete(a,u),s=!!u?.useTrash,r=!!u?.recursive;await t.delete(a,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new S.FileOperationEvent(a,1))}onDidChangeFile(a,u){this._onDidChangeFilesRaw.fire({changes:a});let t,s;{for(const r of a)this.watchedResources.has(r.resource)?(t||(t=[]),t.push(r)):(s||(s=[]),s.push(r));t&&this._onDidFilesChange.fire(new S.FileChangesEvent(t,!u))}if(s){const r=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&qe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,u={recursive:!1,excludes:[]}){const t=new D.DisposableStore;{let s=!1,r=()=>{s=!0};t.add((0,D.toDisposable)(()=>r())),this.doWatch(a,u).then(o=>{s?(0,D.dispose)(o):r=()=>(0,D.dispose)(o)},o=>this.logService.error(o))}return u.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),t.add((0,D.toDisposable)(()=>{const s=this.watchedResources.get(a);typeof s=="number"&&(s<=1?this.watchedResources.delete(a):this.watchedResources.set(a,s-1))}))),t}async doWatch(a,u){const t=await this.withProvider(a),s=this.toWatchKey(t,a,u),r=this.activeWatchers.get(s)||{count:0,disposable:t.watch(a,u)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,r),r.count+=1,(0,D.toDisposable)(()=>{r.count--,r.count===0&&((0,D.dispose)(r.disposable),this.activeWatchers.delete(s))})}toWatchKey(a,u,t){const{providerExtUri:s}=this.getExtUri(a);return[s.getComparisonKey(u),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(a=>(0,D.dispose)(a.disposable)),this.activeWatchers.clear()}async doWriteBuffered(a,u,t,s){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{const r=await a.open(u,{create:!0,unlock:t?.unlock??!1});try{(0,k.isReadableStream)(s)||(0,k.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(a,r,s):await this.doWriteReadableBufferedQueued(a,r,s)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,u,t){let s=0,r;if((0,k.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=b.VSBuffer.concat(t.buffer);await this.doWriteBuffer(a,u,o,o.byteLength,s,0),s+=o.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise(async(o,l)=>{(0,k.listenStream)(r,{onData:async w=>{r.pause();try{await this.doWriteBuffer(a,u,w,w.byteLength,s,0)}catch(f){return l(f)}s+=w.byteLength,setTimeout(()=>r.resume())},onError:w=>l(w),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(a,u,t){let s=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(a,u,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(a,u,t,s,r,o){let l=0;for(;l<s;)l+=await a.write(u,r+l,t.buffer,o+l,s-l)}async doWriteUnbuffered(a,u,t,s){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,u,t,s))}async doWriteUnbufferedQueued(a,u,t,s){let r;s instanceof b.VSBuffer?r=s:(0,k.isReadableStream)(s)?r=await(0,b.streamToBuffer)(s):(0,k.isReadableBufferedStream)(s)?r=await(0,b.bufferedStreamToBuffer)(s):r=(0,b.readableToBuffer)(s),await a.writeFile(u,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(a,u,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,u,t,s))}async doPipeBufferedQueued(a,u,t,s){let r,o;try{r=await a.open(u,{create:!1}),o=await t.open(s,{create:!0,unlock:!1});const l=b.VSBuffer.alloc(this.BUFFER_SIZE);let w=0,f=0,L=0;do L=await a.read(r,w,l.buffer,f,l.byteLength-f),await this.doWriteBuffer(t,o,l,L,w,f),w+=L,f+=L,f===l.byteLength&&(f=0);while(L>0)}catch(l){throw(0,S.ensureFileSystemProviderError)(l)}finally{await y.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(a,u,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,u,t,s))}async doPipeUnbufferedQueued(a,u,t,s){return t.writeFile(s,await a.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,u,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,u,t,s))}async doPipeUnbufferedToBufferedQueued(a,u,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const o=await a.readFile(u);await this.doWriteBuffer(t,r,b.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(a,u,t,s){const r=await(0,b.streamToBuffer)(this.readFileBuffered(a,u,d.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,r)}throwIfFileSystemIsReadonly(a,u){if(a.capabilities&2048)throw new S.FileOperationError((0,m.localize)(22,null,this.resourceForError(u)),6);return a}throwIfFileIsReadonly(a,u){if((u.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,m.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===v.Schemas.file?a.fsPath:a.toString(!0)}};c.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},c=he([ee(0,i.ILogService)],c),e.FileService=c}),define(J[184],Z([0,1,2,19,5,3,18,8,15,30,9,6,142,90,164,166,163,173,64,93,36,17]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P,I,c,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends m.Disposable{constructor(r,o){super();this.logService=r,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=D.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,S.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:o,symbolicLink:l}=await E.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(o,l),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(r){try{const o=await E.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),l=[];return await Promise.all(o.map(async w=>{try{let f;w.isSymbolicLink()?f=(await this.stat((0,p.joinPath)(r,w.name))).type:f=this.toType(w),l.push([w.name,f])}catch(f){this.logService.trace(f)}})),l}catch(o){throw this.toFileSystemProviderError(o)}}toType(r,o){let l;return o?.dangling?l=M.FileType.Unknown:r.isFile()?l=M.FileType.File:r.isDirectory()?l=M.FileType.Directory:l=M.FileType.Unknown,o&&(l|=M.FileType.SymbolicLink),l}async readFile(r){try{const o=this.toFilePath(r);return await E.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(r,o,l){const w=(0,c.newWriteableStream)(f=>u.VSBuffer.concat(f.map(L=>u.VSBuffer.wrap(L))).buffer);return(0,h.readFileIntoStream)(this,r,w,f=>f.buffer,{...o,bufferSize:this.BUFFER_SIZE},l),w}async writeFile(r,o,l){let w;try{const f=this.toFilePath(r);if(!l.create||!l.overwrite){if(await E.Promises.exists(f)){if(!l.overwrite)throw(0,M.createFileSystemProviderError)((0,k.localize)(0,null),M.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,M.createFileSystemProviderError)((0,k.localize)(1,null),M.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(r,{create:!0,unlock:l.unlock}),await this.write(w,0,o,0,o.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(r,f)}finally{typeof w=="number"&&await this.close(w)}}async open(r,o){try{const l=this.toFilePath(r);if((0,M.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:L}=await E.SymlinkSupport.stat(l);L.mode&128||await E.Promises.chmod(l,L.mode|128)}catch(L){this.logService.trace(L)}let w;if((0,M.isFileOpenForWriteOptions)(o)){if(S.isWindows)try{await E.Promises.truncate(l,0),w="r+"}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}w||(w="w")}else w="r";const f=await E.Promises.open(l,w);return this.mapHandleToPos.set(f,0),(0,M.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(f,r),f}catch(l){throw(0,M.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(r,l):this.toFileSystemProviderError(l)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await E.Promises.fdatasync(r)}catch(o){this.canFlush=!1,this.logService.error(o)}return await E.Promises.close(r)}catch(o){throw this.toFileSystemProviderError(o)}}async read(r,o,l,w,f){const L=this.normalizePos(r,o);let R=null;try{const _=await E.Promises.read(r,l,w,f,L);return typeof _=="number"?R=_:R=_.bytesRead,R}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(r,L,R)}}normalizePos(r,o){return o===this.mapHandleToPos.get(r)?null:o}updatePos(r,o,l){const w=this.mapHandleToPos.get(r);typeof w=="number"&&(typeof o=="number"||(typeof l=="number"?this.mapHandleToPos.set(r,w+l):this.mapHandleToPos.delete(r)))}async write(r,o,l,w,f){return(0,i.retry)(()=>this.doWrite(r,o,l,w,f),100,3)}async doWrite(r,o,l,w,f){const L=this.normalizePos(r,o);let R=null;try{const _=await E.Promises.write(r,l,w,f,L);return typeof _=="number"?R=_:R=_.bytesWritten,R}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),_)}finally{this.updatePos(r,L,R)}}async mkdir(r){try{await E.Promises.mkdir(this.toFilePath(r))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(r,o){try{const l=this.toFilePath(r);await this.doDelete(l,o)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(r,o){o.recursive?await E.Promises.rm(r,E.RimRafMode.MOVE):await E.Promises.unlink(r)}async rename(r,o,l){const w=this.toFilePath(r),f=this.toFilePath(o);if(w!==f)try{await this.validateTargetDeleted(r,o,"move",l.overwrite),await E.Promises.move(w,f)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,k.localize)(2,null,(0,n.basename)(w),(0,n.basename)((0,n.dirname)(f)),L.toString()))),this.toFileSystemProviderError(L)}}async copy(r,o,l){const w=this.toFilePath(r),f=this.toFilePath(o);if(w!==f)try{await this.validateTargetDeleted(r,o,"copy",l.overwrite),await E.Promises.copy(w,f,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,k.localize)(3,null,(0,n.basename)(w),(0,n.basename)((0,n.dirname)(f)),L.toString()))),this.toFileSystemProviderError(L)}}async validateTargetDeleted(r,o,l,w){const f=this.toFilePath(r),L=this.toFilePath(o);let R=!1;if(!!(this.capabilities&1024)||(R=(0,g.isEqual)(f,L,!0)),R&&l==="copy")throw(0,M.createFileSystemProviderError)((0,k.localize)(4,null),M.FileSystemProviderErrorCode.FileExists);if(!R&&await E.Promises.exists(L)){if(!w)throw(0,M.createFileSystemProviderError)((0,k.localize)(5,null),M.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(r,o){return o.recursive?this.watchRecursive(r,o.excludes):this.watchNonRecursive(r)}watchRecursive(r,o){const l={path:this.toFilePath(r),excludes:o},w=(0,a.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,m.toDisposable)(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof P.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,m.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,o;this.options?.watcher?.usePolling?(r=d.FileWatcher,o=this.options?.watcher):this.recursiveFoldersToWatch.length===1?S.isWindows?r=v.FileWatcher:r=d.FileWatcher:r=P.FileWatcher,this.recursiveWatcher=new r(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,y.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===b.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))}}watchNonRecursive(r){const o=new I.FileWatcher(this.toFilePath(r),w=>this._onDidChangeFile.fire((0,y.toFileChanges)(w)),w=>{w.type==="error"&&this._onDidWatchErrorOccur.fire(w.message),this.logService[w.type](w.message)},this.logService.getLevel()===b.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,m.combinedDisposable)(o,l)}toFilePath(r){return(0,n.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof M.FileSystemProviderError)return r;let o;switch(r.code){case"ENOENT":o=M.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=M.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=M.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=M.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=M.FileSystemProviderErrorCode.NoPermissions;break;default:o=M.FileSystemProviderErrorCode.Unknown}return(0,M.createFileSystemProviderError)(r,o)}async toFileSystemProviderWriteError(r,o){let l=this.toFileSystemProviderError(o);if(r&&l.code===M.FileSystemProviderErrorCode.NoPermissions)try{const{stat:w}=await E.SymlinkSupport.stat(this.toFilePath(r));w.mode&128||(l=(0,M.createFileSystemProviderError)(o,M.FileSystemProviderErrorCode.FileWriteLocked))}catch(w){this.logService.trace(w)}return l}dispose(){super.dispose(),(0,m.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,m.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(J[20],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,m.createDecorator)("productService")}),define(J[185],Z([0,1,58,6,20]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let S=class{constructor(n,p){this.productService=n,this.logService=p,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,p){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const g=/^(.*)#([^#]+)$/.exec(p);if(!g)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",p),!1;const[,i,b]=g;let k=this.trustedExtensionUrlPublicKeys.get(n);if(!k){if(k=this.productService.trustedExtensionUrlPublicKeys[n],!k||k.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...k])}const y=Buffer.from(decodeURIComponent(b),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",p),!1;const d=y.slice(0,6),v=y.readUIntBE(0,6),P=Date.now()-v;if(P<0||P>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",p),!1;const I=y.slice(6),c=m.createVerify("SHA256");c.write(d),c.write(Buffer.from(i)),c.end();for(let h=0;h<k.length;h++){let a=k[h];if(a!==null){if(typeof a=="string")try{a=m.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),k[h]=a}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${n}:`,u),k[h]=null;continue}if(c.verify(a,I))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",p),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",p),!1}};S=he([ee(0,D.IProductService),ee(1,M.ILogService)],S),e.ExtensionUrlTrustService=S}),define(J[55],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,m.createDecorator)("protocolMainService")}),define(J[186],Z([0,1,2,10,7,48,14,6,37,3,15,28]),function(V,e,m,M,D,S,E,n,p,g,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let k=class extends m.Disposable{constructor(d,v){super();this.logService=v,this.validRoots=p.TernarySearchTree.forUris(()=>!g.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(D.URI.file(d.appRoot)),this.addValidFileRoot(D.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=E.session;d.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(v,P)=>this.handleResourceRequest(v,P)),d.protocol.interceptFileProtocol(M.Schemas.file,(v,P)=>this.handleFileRequest(v,P)),this._register((0,m.toDisposable)(()=>{d.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?m.Disposable.None:(this.validRoots.set(d,!0),(0,m.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,v){const P=D.URI.parse(d.url);return g.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${P.fsPath} from ${M.Schemas.file}: protocol (original URL: ${d.url})`),v({error:-3})):this.validRoots.findSubstr(P)?v({path:P.fsPath}):this.validExtensions.has((0,i.extname)(P))?v({path:P.fsPath}):(this.logService.error(`${M.Schemas.file}: Refused to load resource ${P.fsPath} from ${M.Schemas.file}: protocol (original URL: ${d.url})`),v({error:-3}))}handleResourceRequest(d,v){const P=D.URI.parse(d.url),I=M.FileAccess.asFileUri(P);return this.validRoots.findSubstr(I)?v({path:I.fsPath}):this.validExtensions.has((0,i.extname)(I))?v({path:I.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${I.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),v({error:-3}))}createIPCObjectUrl(){let d;const v=D.URI.from({scheme:"vscode",path:(0,b.generateUuid)()}),P=v.toString(),I=async()=>d;return E.ipcMain.handle(P,I),this.logService.trace(`IPC Object URL: Registered new channel ${P}.`),{resource:v,update:c=>d=c,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${P}.`),E.ipcMain.removeHandler(P)}}}};k=he([ee(0,S.INativeEnvironmentService),ee(1,n.ILogService)],k),e.ProtocolMainService=k}),define(J[38],Z([0,1,13,102]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(E,n){M.ok(m.isString(E)),M.ok(m.isObject(n)),M.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,n)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new D}),define(J[187],Z([0,1,38,5]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class S{constructor(){this._onDidChangeSchema=new M.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,g){this.schemasById[D(p)]=g,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new S;m.Registry.add(e.Extensions.JSONContribution,E)}),define(J[50],Z([0,1,132,5,38,13,187]),function(V,e,m,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var n;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(n=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const g=D.Registry.as(E.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(c,h=!0){this.registerConfigurations([c],h)}registerConfigurations(c,h=!0){const a=[];c.forEach(u=>{a.push(...this.validateAndRegisterProperties(u,h,u.extensionInfo)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(c){const h=[],a=u=>{if(u.properties)for(const t in u.properties)h.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,u.properties[t]);u.allOf&&u.allOf.forEach(t=>a(t))};for(const u of c){a(u);const t=this.configurationContributors.indexOf(u);t!==-1&&this.configurationContributors.splice(t,1)}g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}registerDefaultConfigurations(c){const h=[],a=[];for(const u of c)for(const t in u)if(h.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...u[t]};const s={type:"object",default:this.defaultValues[t],description:m.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};a.push(k(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=u[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(c){const h=[];for(const a of c)for(const u in a)if(h.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const t=this.configurationProperties[u];t&&(this.updatePropertyDefaultValue(u,t),this.updateSchema(u,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const h of c)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(c,h=!0,a,u=3){u=S.isUndefinedOrNull(c.scope)?u:c.scope;let t=[],s=c.properties;if(s)for(let o in s){if(h&&v(o)){delete s[o];continue}const l=s[o];if(this.updatePropertyDefaultValue(o,l),e.OVERRIDE_PROPERTY_PATTERN.test(o)?l.scope=void 0:(l.scope=S.isUndefinedOrNull(l.scope)?u:l.scope,l.restricted=S.isUndefinedOrNull(l.restricted)?!!a?.restrictedConfigurations?.includes(o):l.restricted),s[o].hasOwnProperty("included")&&!s[o].included){this.excludedConfigurationProperties[o]=s[o],delete s[o];continue}else this.configurationProperties[o]=s[o];!s[o].deprecationMessage&&s[o].markdownDeprecationMessage&&(s[o].deprecationMessage=s[o].markdownDeprecationMessage),t.push(o)}let r=c.allOf;if(r)for(let o of r)t.push(...this.validateAndRegisterProperties(o,h,a,u));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(c){const h=a=>{let u=a.properties;if(u)for(const s in u)this.updateSchema(s,u[s]);let t=a.allOf;t&&t.forEach(h)};h(c)}updateSchema(c,h){switch(e.allSettings.properties[c]=h,h.scope){case 1:e.applicationSettings.properties[c]=h;break;case 2:e.machineSettings.properties[c]=h;break;case 6:e.machineOverridableSettings.properties[c]=h;break;case 3:e.windowSettings.properties[c]=h;break;case 4:e.resourceSettings.properties[c]=h;break;case 5:e.resourceSettings.properties[c]=h,this.resourceLanguageSettingsSchema.properties[c]=h;break}}removeFromSchema(c,h){switch(delete e.allSettings.properties[c],h.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const h=`[${c}]`,a={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,a),e.allSettings.properties[h]=a,e.applicationSettings.properties[h]=a,e.machineSettings.properties[h]=a,e.machineOverridableSettings.properties[h]=a,e.windowSettings.properties[h]=a,e.resourceSettings.properties[h]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,h){let a=this.defaultValues[c];S.isUndefined(a)&&(a=h.default),S.isUndefined(a)&&(a=y(h.type)),h.default=a}}const b="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(b);function k(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=k;function y(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const d=new i;D.Registry.add(e.Extensions.Configuration,d);function v(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?m.localize(5,null,I):d.getConfigurationProperties()[I]!==void 0?m.localize(6,null,I):null:m.localize(4,null)}e.validateProperty=v;function P(){const I=[],c=d.getConfigurationProperties();for(const h of Object.keys(c))I.push([h,c[h].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=P}),define(J[21],Z([0,1,44,13,7,38,4,50]),function(V,e,m,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function p(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof D.URI)}e.isConfigurationOverrides=p;var g;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(g=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function b(s,r){const o=r?s?r.keys.filter(C=>s.keys.indexOf(C)===-1):[...r.keys]:[],l=s?r?s.keys.filter(C=>r.keys.indexOf(C)===-1):[...s.keys]:[],w=[];if(r&&s){for(const C of s.keys)if(r.keys.indexOf(C)!==-1){const K=I(s.contents,C),x=I(r.contents,C);m.equals(K,x)||w.push(C)}}const f=[],L=C=>{const K={};for(const x of C)for(const ie of x.identifiers)K[u(ie)]=x;return K},R=r?L(r.overrides):{},_=s?L(s.overrides):{};if(Object.keys(R).length)for(const C of o){const K=R[C];K&&f.push([(0,n.overrideIdentifierFromKey)(C),K.keys])}if(Object.keys(_).length)for(const C of l){const K=_[C];K&&f.push([(0,n.overrideIdentifierFromKey)(C),K.keys])}if(Object.keys(R).length&&Object.keys(_).length)for(const C of w){const K=_[C],x=R[C];if(K&&x){const ie=b({contents:K.contents,keys:K.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});f.push([(0,n.overrideIdentifierFromKey)(C),[...ie.added,...ie.removed,...ie.updated]])}}return{added:o,removed:l,updated:w,overrides:f}}e.compare=b;function k(s,r){const o=[];for(const l of Object.keys(s))if(n.OVERRIDE_PROPERTY_PATTERN.test(l)){const w={};for(const f in s[l])w[f]=s[l][f];o.push({identifiers:[(0,n.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(w),contents:y(w,r)})}return o}e.toOverrides=k;function y(s,r){const o=Object.create(null);for(let l in s)d(o,l,s[l],r);return o}e.toValuesTree=y;function d(s,r,o,l){const w=r.split("."),f=w.pop();let L=s;for(let R=0;R<w.length;R++){let _=w[R],C=L[_];switch(typeof C){case"undefined":C=L[_]=Object.create(null);break;case"object":break;default:l(`Ignoring ${r} as ${w.slice(0,R+1).join(".")} is ${JSON.stringify(C)}`);return}L=C}if(typeof L=="object"&&L!==null)try{L[f]=o}catch(R){l(`Ignoring ${r} as ${w.join(".")} is ${JSON.stringify(L)}`)}else l(`Ignoring ${r} as ${w.join(".")} is ${JSON.stringify(L)}`)}e.addToValueTree=d;function v(s,r){const o=r.split(".");P(s,o)}e.removeFromValueTree=v;function P(s,r){const o=r.shift();if(r.length===0){delete s[o];return}if(Object.keys(s).indexOf(o)!==-1){const l=s[o];typeof l=="object"&&!Array.isArray(l)&&(P(l,r),Object.keys(l).length===0&&delete s[o])}}function I(s,r,o){function l(L,R){let _=L;for(const C of R){if(typeof _!="object"||_===null)return;_=_[C]}return _}const w=r.split("."),f=l(s,w);return typeof f=="undefined"?o:f}e.getConfigurationValue=I;function c(s,r,o){Object.keys(r).forEach(l=>{l!=="__proto__"&&(l in s?M.isObject(s[l])&&M.isObject(r[l])?c(s[l],r[l],o):o&&(s[l]=r[l]):s[l]=r[l])})}e.merge=c;function h(){const s=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=h;function a(){const s=Object.create(null),r=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let o in r){let l=r[o].default;d(s,o,l,w=>console.error(`Conflict in default settings: ${w}`))}return s}e.getDefaultValues=a;function u(s){return`[${s}]`}e.keyFromOverrideIdentifier=u;function t(s,r,o){const l=s.inspect(r),w=s.inspect(o);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:l.defaultValue}e.getMigratedSettingValue=t}),define(J[188],Z([0,1,40,37,36,13,44,7,50,21,38,2,5]),function(V,e,m,M,D,S,E,n,p,g,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,g.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,g.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const o of D.distinct([...Object.keys(this.contents),...Object.keys(s)])){let l=this.contents[o],w=s[o];w&&(typeof l=="object"&&typeof w=="object"?(l=E.deepClone(l),this.mergeContents(l,w)):l=w),r[o]=l}return new y(r,this.keys,this.overrides)}merge(...t){const s=E.deepClone(this.contents),r=E.deepClone(this.overrides),o=[...this.keys];for(const l of t){this.mergeContents(s,l.contents);for(const w of l.overrides){const[f]=r.filter(L=>D.equals(L.identifiers,w.identifiers));f?this.mergeContents(f.contents,w.contents):r.push(E.deepClone(w))}for(const w of l.keys)o.indexOf(w)===-1&&o.push(w)}return new y(s,o,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&S.isObject(t[r])&&S.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=E.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,g.addToValueTree)(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,g.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=y;class d extends y{constructor(){const t=(0,g.getDefaultValues)(),s=(0,g.getConfigurationKeys)(),r=[];for(const o of Object.keys(t))p.OVERRIDE_PROPERTY_PATTERN.test(o)&&r.push({identifiers:[(0,p.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,g.toValuesTree)(t[o],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,s,r)}}e.DefaultConfigurationModel=d;class v{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!S.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:o,overrides:l,restricted:w}=this.doParseRaw(t,s);this._configurationModel=new y(r,o,l),this._restrictedConfigurations=w||[]}doParseContent(t){let s={},r=null,o=[],l=[],w=[];function f(R){Array.isArray(o)?o.push(R):r!==null&&(o[r]=R)}let L={onObjectBegin:()=>{let R={};f(R),l.push(o),o=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{let R=[];f(R),l.push(o),o=R,r=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:f,onError:(R,_,C)=>{w.push({error:R,offset:_,length:C})}};if(t)try{m.visit(t,L),s=o[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return s}doParseRaw(t,s){const r=i.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,r,!0,s);t=o.raw;const l=(0,g.toValuesTree)(t,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),w=Object.keys(t),f=(0,g.toOverrides)(t,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:l,keys:w,overrides:f,restricted:o.restricted}}filter(t,s,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:t,restricted:[]};const l={},w=[];for(let f in t)if(p.OVERRIDE_PROPERTY_PATTERN.test(f)&&r){const L=this.filter(t[f],s,!1,o);l[f]=L.raw,w.push(...L.restricted)}else{const L=s[f],R=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&w.push(f),(R===void 0||o.scopes===void 0||o.scopes.includes(R))&&(o.skipRestricted&&L?.restricted||(l[f]=t[f]))}return{raw:l,restricted:w}}}e.ConfigurationModelParser=v;class P extends b.Disposable{constructor(t,s,r,o){super();this.userSettingsResource=t,this.scopes=s,this.fileService=o,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class I{constructor(t,s,r=new y,o=new y,l=new M.ResourceMap,w=new y,f=new M.ResourceMap,L=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=w,this._memoryConfigurationByResource=f,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new y,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,s===void 0?o.removeValue(t):o.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const o=this.getConsolidateConfigurationModel(s,r),l=this.getFolderConfigurationModelForResource(s.resource,r),w=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,f=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),L=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),R=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),_=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),C=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,K=l?s.overrideIdentifier?l.freeze().override(s.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,x=s.overrideIdentifier?w.override(s.overrideIdentifier).getValue(t):w.getValue(t),ie=o.getValue(t),G=D.distinct(D.flatten(o.overrides.map(Q=>Q.identifiers))).filter(Q=>o.getOverrideValue(t,Q)!==void 0);return{defaultValue:f,userValue:L,userLocalValue:R,userRemoteValue:_,workspaceValue:C,workspaceFolderValue:K,memoryValue:x,value:ie,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:C!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:K!==void 0?{value:l?.freeze().getValue(t),override:s.overrideIdentifier?l?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:w.getValue(t),override:s.overrideIdentifier?w.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(o=>p.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const l=(0,p.overrideIdentifierFromKey)(o),w=this._defaultConfiguration.getKeysForOverrideIdentifier(l),f=t.getKeysForOverrideIdentifier(l),L=[...f.filter(R=>w.indexOf(R)===-1),...w.filter(R=>f.indexOf(R)===-1),...w.filter(R=>!E.equals(this._defaultConfiguration.override(l).getValue(R),t.override(l).getValue(R)))];return[l,L]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:l}=(0,g.compare)(this.localUserConfiguration,t),w=[...s,...r,...o];return w.length&&this.updateLocalUserConfiguration(t),{keys:w,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:l}=(0,g.compare)(this.remoteUserConfiguration,t);let w=[...s,...r,...o];return w.length&&this.updateRemoteUserConfiguration(t),{keys:w,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:o,overrides:l}=(0,g.compare)(this.workspaceConfiguration,t);let w=[...s,...r,...o];return w.length&&this.updateWorkspaceConfiguration(t),{keys:w,overrides:l}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:o,updated:l,removed:w,overrides:f}=(0,g.compare)(r,s);let L=[...o,...l,...w];return(L.length||!r)&&this.updateFolderConfiguration(t,s),{keys:L,overrides:f}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:l,overrides:w}=(0,g.compare)(s,void 0);return{keys:[...r,...o,...l],overrides:w}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const o=s.getFolder(t);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const l=this._memoryConfigurationByResource.get(t);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(s=r.merge(o),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:o,keys:l}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((w,f)=>(w.set(n.URI.revive(f[0]),this.parseConfigurationModel(f[1])),w),new M.ResourceMap);return new I(s,r,new y,o,l,new y,new M.ResourceMap,!1)}static parseConfigurationModel(t){return new y(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=I;function c(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const t=new Set,s=new Map;for(const o of u)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,w])=>{const f=(0,M.getOrSet)(s,l,new Set);w.forEach(L=>f.add(L))});const r=[];return s.forEach((o,l)=>r.push([l,[...o.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=c;class h{constructor(t,s,r,o){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(f=>l.add(f)),t.overrides.forEach(([,f])=>f.forEach(L=>l.add(L))),this.affectedKeys=[...l.values()];const w=new y;this.affectedKeys.forEach(f=>w.setValue(f,{})),this.affectedKeysTree=w.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!E.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=(0,g.toValuesTree)({[s]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(t=t[o],!t)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=h;class a extends h{constructor(t,s,r,o){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=a}),define(J[189],Z([0,1,38,50,2,21,188,5,9,15]),function(V,e,m,M,D,S,E,n,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends D.Disposable{constructor(k,y){super();this.settingsResource=k,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,g.extUriBiasedIgnorePathCase,y)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(M.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const k=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,k)}getConfigurationData(){return this.configuration.toData()}getValue(k,y){const d=typeof k=="string"?k:void 0,v=(0,S.isConfigurationOverrides)(k)?k:(0,S.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(d,v,void 0)}updateValue(k,y,d,v){return Promise.reject(new Error("not supported"))}inspect(k){return this.configuration.inspect(k,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const k=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(k)}onDidChangeUserConfiguration(k){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(k);this.trigger(d,y,1)}onDidDefaultConfigurationChange(k){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,k);this.trigger(d,y,6)}trigger(k,y,d){const v=new E.ConfigurationChangeEvent(k,{data:y},this.configuration);v.source=d,v.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(k){switch(k){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(J[190],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var M;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(E,n=M.Unknown,p){super(E);this._message=E,this._code=n,this._detail=p,this.isHandled=n===M.NotAvailable&&p===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(E){return E instanceof D&&E._code===M.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof D&&E._code===M.NoResolverFound}static isHandled(E){return E instanceof D&&E.isHandled}}e.RemoteAuthorityResolverError=D}),define(J[191],Z([0,1,82,28,2,17,5,190,16,9,25]),function(V,e,m,M,D,S,E,n,p,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var k;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(k=e.ConnectionType||(e.ConnectionType={}));function y(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(T){const A=new i.CancellationTokenSource;return setTimeout(()=>A.cancel(),T),A.token}function v(T,A){if(T.isCancellationRequested||A.isCancellationRequested)return i.CancellationToken.Cancelled;const O=new i.CancellationTokenSource;return T.onCancellationRequested(()=>O.cancel()),A.onCancellationRequested(()=>O.cancel()),O.token}class P{constructor(A){this._state="pending",this._disposables=new D.DisposableStore,this.promise=new Promise((O,H)=>{this._resolvePromise=O,this._rejectPromise=H}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function I(T,A){const O=new P(A);return O.registerDisposable(T.onControlMessage(H=>{const Y=JSON.parse(H.toString()),q=F(Y);q?O.reject(q):O.resolve(Y)})),O.promise}function c(T,A,O,H,Y,q){const X=new P(q);return A.connect(O,H,Y,(ne,se)=>{X.didTimeout?(ne&&T.error(ne),se?.dispose()):ne||!se?X.reject(ne):X.resolve(se)}),X.promise}function h(T,A){const O=new P(A);return T.then(H=>{O.didTimeout||O.resolve(H)},H=>{O.didTimeout||O.reject(H)}),O.promise}async function a(T,A,O,H){const Y=W(T,A);T.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let q;try{q=await c(T.logService,T.socketFactory,T.host,T.port,`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,H)}catch(ae){throw T.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),T.logService.error(ae),ae}T.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let X,ne;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(q,null),X=T.reconnectionProtocol,ne=!1):(X=new m.PersistentProtocol(q,null),ne=!0),T.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const se={type:"auth",auth:T.connectionToken||"00000000000000000000"};X.sendControl(S.VSBuffer.fromString(JSON.stringify(se)));try{const ae=await I(X,v(H,d(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const ce=new Error("Unexpected handshake message");throw ce.code="VSCODE_CONNECTION_ERROR",ce}T.logService.trace(`${Y} 4/6. received SignRequest control message.`);const de=await h(T.signService.sign(ae.data),H),re={type:"connectionType",commit:T.commit,signedData:de,desiredConnectionType:A};return O&&(re.args=O),T.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(S.VSBuffer.fromString(JSON.stringify(re))),{protocol:X,ownsProtocol:ne}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(T.logService.error(`${Y} the handshake timed out. Error:`),T.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${Y} received error control message when negotiating connection. Error:`),T.logService.error(ae)),ne&&$(X),ae}}async function u(T,A,O,H){const Y=Date.now(),q=W(T,A),{protocol:X,ownsProtocol:ne}=await a(T,A,O,H),se=new P(H);return se.registerDisposable(X.onControlMessage(ae=>{const de=JSON.parse(ae.toString()),re=F(de);re?(T.logService.error(`${q} received error control message when negotiating connection. Error:`),T.logService.error(re),ne&&$(X),se.reject(re)):(T.reconnectionProtocol&&T.reconnectionProtocol.endAcceptReconnection(),T.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${z(Y)}!`),se.resolve({protocol:X,firstMessage:de}))})),se.promise}async function t(T,A){const{protocol:O}=await u(T,1,void 0,A);return{protocol:O}}async function s(T,A,O){const{protocol:H,firstMessage:Y}=await u(T,2,A,O),q=Y&&Y.debugPort;return{protocol:H,debugPort:q}}async function r(T,A,O){const H=Date.now(),Y=W(T,3),{protocol:q}=await a(T,3,A,O);return T.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${z(H)}!`),q}async function o(T,A,O){const{host:H,port:Y,connectionToken:q}=await T.addressProvider.getAddress();return{commit:T.commit,host:H,port:Y,connectionToken:q,reconnectionToken:A,reconnectionProtocol:O,socketFactory:T.socketFactory,signService:T.signService,logService:T.logService}}async function l(T,A,O){try{const H=(0,M.generateUuid)(),Y=await o(T,H,null),{protocol:q}=await t(Y,i.CancellationToken.None);return new Q(T,A,O,H,q)}catch(H){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(H),G.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(H)),H}}e.connectRemoteAgentManagement=l;async function w(T,A){try{const O=(0,M.generateUuid)(),H=await o(T,O,null),{protocol:Y,debugPort:q}=await s(H,A,i.CancellationToken.None);return new U(T,A,O,Y,q)}catch(O){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(O),G.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(O)),O}}e.connectRemoteAgentExtensionHost=w;async function f(T,A){const O=await o(T,(0,M.generateUuid)(),null);return await r(O,{port:A},i.CancellationToken.None)}e.connectRemoteAgentTunnel=f;function L(T){return(0,g.createCancelablePromise)(A=>new Promise((O,H)=>{const Y=setTimeout(O,T*1e3);A.onCancellationRequested(()=>{clearTimeout(Y),O()})}))}var R;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class _{constructor(A,O){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=_;class C{constructor(A,O,H,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.durationSeconds=H,this.cancellableTimer=Y,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=C;class K{constructor(A,O,H){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=H,this.type=2}}e.ReconnectionRunningEvent=K;class x{constructor(A,O,H){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=H,this.type=4}}e.ConnectionGainEvent=x;class ie{constructor(A,O,H,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=H,this.handled=Y,this.type=3}}e.ReconnectionPermanentFailureEvent=ie;class G extends D.Disposable{constructor(A,O,H,Y){super();this._connectionType=A,this._onDidStateChange=this._register(new E.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=O,this.reconnectionToken=H,this.protocol=Y,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(Y.onSocketClose(q=>{const X=B(this._connectionType,this.reconnectionToken,!0);q?q.type===0?(this._options.logService.info(`${X} received socket close event (hadError: ${q.hadError}).`),q.error&&this._options.logService.error(q.error)):(this._options.logService.info(`${X} received socket close event (wasClean: ${q.wasClean}, code: ${q.code}, reason: ${q.reason}).`),q.event&&this._options.logService.error(q.event)):this._options.logService.info(`${X} received socket close event.`),this._beginReconnecting()})),this._register(Y.onSocketTimeout(()=>{const q=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${q} received socket timeout event.`),this._beginReconnecting()})),G._instances.push(this),G._permanentFailure&&this._gotoPermanentFailure(G._permanentFailureMillisSinceLastIncomingData,G._permanentFailureAttempt,G._permanentFailureHandled)}static triggerPermanentFailure(A,O,H){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=O,this._permanentFailureHandled=H,this._instances.forEach(Y=>Y._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(G._permanentFailure)return;const A=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let H=-1;do{H++;const Y=H<O.length?O[H]:O[O.length-1];try{if(Y>0){const X=L(Y);this._onDidStateChange.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,X)),this._options.logService.info(`${A} waiting for ${Y} seconds before reconnecting...`);try{await X}catch{}}if(G._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1)),this._options.logService.info(`${A} resolving connection...`);const q=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${q.host}:${q.port}...`),await this._reconnect(q,d(b)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(q),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(H>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(q),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((0,p.isPromiseCanceledError)(q)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if(q instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(q),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,n.RemoteAuthorityResolverError.isHandled(q));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(q),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}}while(!G._permanentFailure)}_gotoPermanentFailure(A,O,H){this._onDidStateChange.fire(new ie(this.reconnectionToken,A,O,H)),$(this.protocol)}}G._permanentFailure=!1,G._permanentFailureMillisSinceLastIncomingData=0,G._permanentFailureAttempt=0,G._permanentFailureHandled=!1,G._instances=[];class Q extends G{constructor(A,O,H,Y,q){super(1,A,Y,q);this.client=this._register(new m.Client(q,{remoteAuthority:O,clientId:H},A.ipcLogger))}async _reconnect(A,O){await t(A,O)}}e.ManagementPersistentConnection=Q;class U extends G{constructor(A,O,H,Y,q){super(2,A,H,Y);this._startArguments=O,this.debugPort=q}async _reconnect(A,O){await s(A,this._startArguments,O)}}e.ExtensionHostPersistentConnection=U;function $(T){try{T.acceptDisconnect();const A=T.getSocket();T.dispose(),A.dispose()}catch(A){(0,p.onUnexpectedError)(A)}}function F(T){if(T&&T.type==="error"){const A=new Error(`Connection error: ${T.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function N(T,A){for(;T.length<A;)T+=" ";return T}function B(T,A,O){return`[remote-connection][${N(y(T),13)}][${A.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function W(T,A){return`${B(A,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.host}:${T.port}]`}function z(T){return`${Date.now()-T} ms`}}),define(J[73],Z([0,1,10]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(g){return g.scheme===m.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=M;function D(g){if(!g)return;const i=g.indexOf("+");return i<0?g:g.substr(0,i)}e.getRemoteName=D;function S(g){return g.scheme!==m.Schemas.file&&g.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=S;function E(g){if(g.folders.length)return g.folders.every(i=>S(i.uri))?g.folders[0].uri:void 0;if(g.configuration&&S(g.configuration))return g.configuration}e.getVirtualWorkspaceLocation=E;function n(g){return E(g)?.scheme}e.getVirtualWorkspaceScheme=n;function p(g){return E(g)!==void 0}e.isVirtualWorkspace=p}),define(J[94],Z([0,1,5,3,4,6]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var E;(function(y){y.Http="http",y.Https="https"})(E=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(n=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function p(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=p,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=g,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=i;function b(y,d){return d?d!==1&&y<1024:!M.isWindows&&y<1024}e.isPortPrivileged=b;let k=class{constructor(d){this.logService=d,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,v){return this._tunnelProvider=d,d?(this._canElevate=v.elevation,this._canMakePublic=v.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async d=>{const v=[],P=Array.from(this._tunnels.values());for(let I of P){const c=Array.from(I.values());for(let h of c){const a=await h.value;a&&v.push(a)}}d(v)})}async dispose(){for(const d of this._tunnels.values()){for(const{value:v}of d.values())await v.then(P=>P?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,v,P,I,c=!1,h=!1,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${P} on local port ${I}.`),!d)return;v||(v="localhost");const u=this.retainOrCreateTunnel(d,v,P,I,c,h,a);return u?u.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==v||t.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,public:d.public,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const v=this._tunnels.get(d.tunnelRemoteHost);if(v){const P=v.get(d.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,P))}}}}async tryDisposeTunnel(d,v,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${v}.`);const I=P.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(v),I}}async closeTunnel(d,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${v} `);const P=this._tunnels.get(d);if(P&&P.has(v)){const I=P.get(v);I.refcount=0,await this.tryDisposeTunnel(d,v,I)}}addTunnelToMap(d,v,P){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(v,{refcount:1,value:P})}async removeEmptyTunnelFromMap(d,v){const P=this._tunnels.get(d);P&&(await P.get(v)||P.delete(v),P.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,v){let P=[d];g(d)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):i(d)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const I=P.map(c=>this._tunnels.get(c));for(const c of I){const h=c?.get(v);if(h)return h}}canTunnel(d){return!!p(d)}createWithProvider(d,v,P,I,c,h,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${P} on local port ${I}.`);const t={elevationRequired:c?b(I===void 0?P:I):!1},s={remoteAddress:{host:v,port:P},localAddressPort:I,public:h,protocol:a},r=d.forwardPort(s,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(v,P,r),r}};k=he([ee(0,S.ILogService)],k),e.AbstractTunnelService=k}),define(J[51],Z([0,1,146,4,50,38,17]),function(V,e,m,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function n(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=n;function p(d){return d.res.statusCode===204}async function g(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);return p(d)?null:(await(0,E.streamToBuffer)(d.stream)).toString()}e.asText=g;async function i(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);if(p(d))return null;const P=(await(0,E.streamToBuffer)(d.stream)).toString();try{return JSON.parse(P)}catch(I){throw I.message+=`:
`+P,I}}e.asJson=i;function b(d){y(d)}e.updateProxyConfigurationsScope=b;let k;function y(d){const v=S.Registry.as(D.Extensions.Configuration);k&&v.deregisterConfigurations([k]),k={id:"http",order:15,title:(0,m.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,m.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,m.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,m.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,m.localize)(4,null),(0,m.localize)(5,null),(0,m.localize)(6,null),(0,m.localize)(7,null)],default:"override",description:(0,m.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,m.localize)(9,null),restricted:!0}}},v.registerConfiguration(k)}y(2)}),define(J[192],Z([0,1,193,13]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(E,n){return E.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:E.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function S(E,n,p={}){const g=(0,m.parse)(E),i=p.proxyUrl||D(g,n);if(!i)return null;const b=(0,m.parse)(i);if(!/^https?:$/.test(b.protocol||""))return null;const k={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,M.isBoolean)(p.strictSSL)?p.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((y,d)=>{V(["http-proxy-agent"],y,d)}))(k):new(await new Promise((y,d)=>{V(["https-proxy-agent"],y,d)}))(k)}e.getProxyAgent=S}),define(J[194],Z([0,1,28,17]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(S,E,n){let p=n&&n.get("storage.serviceMachineId",0)||null;if(p)return p;try{const i=(await E.readFile(S.serviceMachineIdResource)).value.toString();p=(0,m.isUUID)(i)?i:null}catch(g){p=null}if(!p){p=(0,m.generateUuid)();try{await E.writeFile(S.serviceMachineIdResource,M.VSBuffer.fromString(p))}catch(g){}}return n&&n.store("storage.serviceMachineId",p,0,1),p}e.getServiceMachineId=D}),define(J[74],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,m.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[195],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((D,S)=>V(["vsda"],D,S))}async sign(D){try{const S=await this.vsda(),E=new S.signer;if(E)return E.sign(D)}catch(S){}return D}}e.SignService=m}),define(J[39],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,m.createDecorator)("stateMainService")}),define(J[22],Z([0,1,14,6,39,5,4,177,3,2,9,13,33]),function(V,e,m,M,D,S,E,n,p,g,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,E.createDecorator)("lifecycleMainService");var y;(function(v){v[v.Starting=1]="Starting",v[v.Ready=2]="Ready",v[v.AfterWindowOpen=3]="AfterWindowOpen"})(y=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class at extends g.Disposable{constructor(P,I){super();this.logService=P,this.stateMainService=I,this._onBeforeShutdown=this._register(new S.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new S.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new S.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new S.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new S.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(at.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(at.QUIT_AND_RESTART_KEY)}registerListeners(){const P=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),p.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};m.app.addListener("before-quit",P);const I=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!p.isMacintosh)&&m.app.quit()};m.app.addListener("window-all-closed",I),m.app.once("will-quit",c=>{this.logService.trace("Lifecycle#app.on(will-quit)"),c.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),m.app.removeListener("before-quit",P),m.app.removeListener("window-all-closed",I),m.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const P=[];return this._onWillShutdown.fire({join(I){P.push(I)}}),this.pendingWillShutdownPromise=(async()=>{try{await i.Promises.settled(P)}catch(I){this.logService.error(I)}try{await this.stateMainService.close()}catch(I){this.logService.error(I)}})(),this.pendingWillShutdownPromise}set phase(P){if(P<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===P)return;this.logService.trace(`lifecycle (main): phase changed (value: ${P})`),this._phase=P;const I=this.phaseWhen.get(this._phase);I&&(I.open(),this.phaseWhen.delete(this._phase))}async when(P){if(P<=this._phase)return;let I=this.phaseWhen.get(P);I||(I=new i.Barrier,this.phaseWhen.set(P,I)),await I.wait()}registerWindow(P){const I=new g.DisposableStore;this.windowCounter++,I.add(P.onWillLoad(h=>this._onWillLoadWindow.fire({window:P,workspace:h.workspace,reason:h.reason})));const c=(0,b.assertIsDefined)(P.win);c.on("close",h=>{const a=P.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${P.id}`),h.preventDefault(),this.unload(P,1).then(u=>{if(u){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(P),P.close()})}),c.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${P.id}`),this.windowCounter--,I.dispose(),this.windowCounter===0&&(!p.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(P,I){await this.unload(P,3)||P.reload(I)}async unload(P,I){if(!P.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${P.id}`);const c=this._quitRequested?2:I;let h=await this.onBeforeUnloadWindowInRenderer(P,c);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${P.id})`),this.handleWindowUnloadVeto(h)):(h=await this.onBeforeUnloadWindowInMain(P,c),h?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${P.id})`),this.handleWindowUnloadVeto(h)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${P.id})`),await this.onWillUnloadWindowInRenderer(P,c),!1))}handleWindowUnloadVeto(P){return P?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(P){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(P),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(P,I){return new Promise(c=>{const h=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${h}`,u=`vscode:cancel${h}`;m.ipcMain.once(a,()=>{c(!1)}),m.ipcMain.once(u,()=>{c(!0)}),P.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:u,reason:I})})}onBeforeUnloadWindowInMain(P,I){const c=[];return this._onBeforeUnloadWindow.fire({reason:I,window:P,veto(h){c.push(h)}}),(0,n.handleVetos)(c,h=>this.logService.error(h))}onWillUnloadWindowInRenderer(P,I){return new Promise(c=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;m.ipcMain.once(a,()=>c()),P.send("vscode:onWillUnload",{replyChannel:a,reason:I})})}quit(P){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${P}`),P&&this.stateMainService.setItem(at.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(I=>{this.pendingQuitPromiseResolve=I,this.logService.trace("Lifecycle#quit() - calling app.quit()"),m.app.quit()}),this.pendingQuitPromise)}async relaunch(P){this.logService.trace("Lifecycle#relaunch()");const I=process.argv.slice(1);if(P?.addArgs&&I.push(...P.addArgs),P?.removeArgs)for(const a of P.removeArgs){const u=I.indexOf(a);u>=0&&I.splice(u,1)}const c=()=>{try{if(p.isWindows){const a=(0,k.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),m.app.relaunch({args:I})};m.app.once("quit",c),await this.quit(!0)&&m.app.removeListener("quit",c)}async kill(P){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,i.timeout)(1e3),(async()=>{for(const I of m.BrowserWindow.getAllWindows())if(I&&!I.isDestroyed()){let c;I.webContents&&!I.webContents.isDestroyed()?c=new Promise(h=>I.once("closed",h)):c=Promise.resolve(),I.destroy(),await c}})()]),m.app.exit(P)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=he([ee(0,M.ILogService),ee(1,D.IStateMainService)],d),e.LifecycleMainService=d}),define(J[196],Z([0,1,4,5,2,22]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,m.createDecorator)("keyboardLayoutMainService");let E=class extends D.Disposable{constructor(g){super();this._onDidChangeKeyboardLayout=this._register(new M.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,g.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const g=await new Promise((i,b)=>{V(["native-keymap"],i,b)});this._keyboardLayoutData=n(g),g.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(g),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=he([ee(0,S.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function n(p){const g=p.getKeyMap(),i=p.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:i}}}),define(J[95],Z([0,1,4,5,2,13,84,9]),function(V,e,m,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";e.IStorageService=(0,m.createDecorator)("storageService");var g;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(g=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var b;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));class k extends D.Disposable{constructor(P={flushInterval:k.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new M.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new M.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new M.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,n.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,I){I===p?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:I,target:this.getKeyTargets(P)[I]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,I,c){return this.getStorage(I)?.get(P,c)}getBoolean(P,I,c){return this.getStorage(I)?.getBoolean(P,c)}getNumber(P,I,c){return this.getStorage(I)?.getNumber(P,c)}store(P,I,c,h){if((0,S.isUndefinedOrNull)(I)){this.remove(P,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(P,c,h),this.getStorage(c)?.set(P,I)})}remove(P,I){this.withPausedEmitters(()=>{this.updateKeyTarget(P,I,void 0),this.getStorage(I)?.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,I){const c=[],h=this.getKeyTargets(P);for(const a of Object.keys(h))h[a]===I&&c.push(a);return c}updateKeyTarget(P,I,c){const h=this.getKeyTargets(I);typeof c=="number"?h[P]!==c&&(h[P]=c,this.getStorage(I)?.set(p,JSON.stringify(h))):typeof h[P]=="number"&&(delete h[P],this.getStorage(I)?.set(p,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const I=this.get(p,P);if(I)try{return JSON.parse(I)}catch(c){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(){this._onWillSaveState.fire({reason:g.NONE}),await n.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const P=this.getStorage(0)?.items??new Map,I=this.getStorage(1)?.items??new Map;return d(P,I,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=k,k.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends k{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=y;async function d(v,P,I,c){const h=l=>{try{return JSON.parse(l)}catch(w){return l}},a=new Map,u=new Map;v.forEach((l,w)=>{a.set(w,l),u.set(w,h(l))});const t=new Map,s=new Map;P.forEach((l,w)=>{t.set(w,l),s.set(w,h(l))}),console.group(`Storage: Global (path: ${I})`);let r=[];a.forEach((l,w)=>{r.push({key:w,value:l})}),console.table(r),console.groupEnd(),console.log(u),console.group(`Storage: Workspace (path: ${c})`);let o=[];t.forEach((l,w)=>{o.push({key:w,value:l})}),console.table(o),console.groupEnd(),console.log(s)}e.logStorage=d}),define(J[197],Z([0,1,3,33,28,7]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(g){if(m.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function n(g,i,b,k,y,d,v,P,I,c){const h=Object.create(null);h["common.machineId"]=v,h.sessionID=(0,D.generateUuid)()+Date.now(),h.commitHash=y,h.version=d,h["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,m.PlatformToString)(m.platform),h["common.nodePlatform"]=M.platform,h["common.nodeArch"]=k,h["common.product"]=c||"desktop";const a=p(P||[]);a&&(h["common.msftInternal"]=a);let u=0;const t=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),m.isLinuxSnap&&(h["common.snap"]="true");const s=E(b);s&&(h["common.platformDetail"]=s);try{const r=await g.readFile(S.URI.file(I));h["common.source"]=r.value.toString().slice(0,30)}catch(r){}return h}e.resolveCommonProperties=n;function p(g){const i=M.env.USERDNSDOMAIN;if(!i)return!1;const b=i.toLowerCase();return g.some(k=>b===k)}e.verifyMicrosoftInternalDomain=p}),define(J[32],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,m.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[198],Z([0,1,26,66,70,8,40,81,20,3,7,32,63,10,19,18]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function P(u,t){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,o=new Map,l=2e4;function w(R,_,C,K){const x=_.substring(R.length+1);return new Promise(async ie=>{let G;try{G=await v.Promises.readdir(_,{withFileTypes:!0})}catch($){ie();return}if(K.count>=l){K.count+=G.length,K.maxReached=!0,ie();return}let Q=G.length;if(Q===0){ie();return}let U=G;K.count+G.length>l&&(K.maxReached=!0,Q=l-K.count,U=G.slice(0,Q)),K.count+=G.length;for(const $ of U)if($.isDirectory()){if(C.includes($.name)||await w(R,(0,S.join)(_,$.name),C,K),--Q==0){ie();return}}else{const F=$.name.lastIndexOf(".");if(F>=0){const N=$.name.substring(F+1);N&&r.set(N,(r.get(N)??0)+1)}for(const N of s)N.relativePathPattern?.test(x)!==!1&&N.filePattern.test($.name)&&o.set(N.tag,(o.get(N.tag)??0)+1);if(--Q==0){ie();return}}})}const f={count:0,maxReached:!1};await w(u,u,t,f);const L=await h(u);return{configFiles:I(o),fileTypes:I(r),fileCount:f.count,maxFilesReached:f.maxReached,launchConfigFiles:L}}e.collectWorkspaceStats=P;function I(u){return[...k.Iterable.map(u.entries(),([t,s])=>({name:t,count:s}))].sort((t,s)=>s.count-t.count)}function c(){const u={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(M.virtualMachineHint.value()*100)}%`},t=m.cpus();return t&&t.length>0&&(u.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),u}e.getMachineInfo=c;async function h(u){try{const t=new Map,s=(0,S.join)(u,".vscode","launch.json"),r=await v.Promises.readFile(s),o=[],l=(0,E.parse)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,E.getNodeType)(l)==="object"&&l.configurations)for(const w of l.configurations){const f=w.type;f&&(t.has(f)?t.set(f,t.get(f)+1):t.set(f,1))}return I(t)}catch(t){return[]}}e.collectLaunchConfigs=h;let a=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const r=m.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(m.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),g.isWindows||s.push(`Load (avg):       ${m.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(M.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,n.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async r=>{let[o,l]=r,w=this.formatProcessList(t,o);return s.forEach(f=>{if((0,D.isRemoteDiagnosticError)(f))w+=`
${f.errorMessage}`,l+=`
${f.errorMessage}`;else if(w+=`

Remote: ${f.hostName}`,f.processes&&(w+=`
${this.formatProcessList(t,f.processes)}`),f.workspaceMetadata){l+=`
|  Remote: ${f.hostName}`;for(const L of Object.keys(f.workspaceMetadata)){const R=f.workspaceMetadata[L];let _=`${R.fileCount} files`;R.maxFilesReached&&(_=`more than ${_}`),l+=`|    Folder (${L}): ${_}`,l+=this.formatWorkspaceStats(R)}}}),{processInfo:w,workspaceInfo:l}})}async getSystemInfo(t,s){const{memory:r,vmHint:o,os:l,cpus:w}=c(),f={os:l,memory:r,cpus:w,vmHint:o,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return g.isWindows||(f.load=`${m.loadavg().map(L=>Math.round(L)).join(", ")}`),g.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(t,s){const r=[];return(0,n.listProcesses)(t.mainPID).then(async o=>(r.push(""),r.push(this.formatEnvironment(t)),r.push(""),r.push(this.formatProcessList(t,o)),t.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(t))),s.forEach(l=>{if((0,D.isRemoteDiagnosticError)(l))r.push(`
${l.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${l.hostName}`),r.push(this.formatMachineInfo(l.machineInfo)),l.processes&&r.push(this.formatProcessList(t,l.processes)),l.workspaceMetadata)for(const w of Object.keys(l.workspaceMetadata)){const f=l.workspaceMetadata[w];let L=`${f.fileCount} files`;f.maxFilesReached&&(L=`more than ${L}`),r.push(`Folder (${w}): ${L}`),r.push(this.formatWorkspaceStats(f))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(t){const s=[],r=60;let o=0;const l=(R,_)=>{const C=` ${R}(${_})`;o+C.length>r?(s.push(w),w="|                 ",o=w.length):o+=C.length,w+=C};let w="|      File types:";const f=10;let L=t.fileTypes.length>f?f:t.fileTypes.length;for(let R=0;R<L;R++){const _=t.fileTypes[R];l(_.name,_.count)}if(s.push(w),t.configFiles.length>=0&&(w="|      Conf files:",o=0,t.configFiles.forEach(R=>{l(R.name,R.count)}),s.push(w)),t.launchConfigFiles.length>0){let R="|      Launch Configs:";t.launchConfigFiles.forEach(_=>{R+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),s.push(R)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${t[r]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],r=[];return t.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const w=i.URI.revive(l);if(w.scheme===y.Schemas.file){const f=w.fsPath;r.push(P(f,["node_modules",".git"]).then(L=>{let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),s.push(`|    Folder (${(0,S.basename)(f)}): ${R}`),s.push(this.formatWorkspaceStats(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${f} (${L.toString()})`)}))}else s.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(t,s){const r=new Map;t.windows.forEach(l=>r.set(l.pid,l.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,r,o,s,0),o.join(`
`)}formatProcessItem(t,s,r,o,l){const w=l===0;let f;w?f=o.pid===t?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(l)} ${o.name}`,o.name==="window"&&(f=`${f} (${s.get(o.pid)})`));const L=process.platform==="win32"?o.mem:m.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(L/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(o.children)&&o.children.forEach(R=>this.formatProcessItem(t,s,r,R,l+1))}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const r=i.URI.revive(s);if(r.scheme!==y.Schemas.file)continue;const o=r.fsPath;try{const l=await P(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),l.fileTypes.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:w.name,count:w.count})}),l.launchConfigFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:w.name,count:w.count})}),l.configFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:w.name,count:w.count})})}catch{}}}};a=he([ee(0,b.ITelemetryService),ee(1,p.IProductService)],a),e.DiagnosticsService=a}),define(J[199],Z([0,1,16,168,171,44,32,51,162,48,25,6,19,7,20,95,194,4,3]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var h;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished"})(h||(h={}));function a(...F){return String(F.reduce((N,B)=>N|B,0))}var u;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(u||(u={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:h.None,criteria:[],assetTypes:[]};class l{constructor(N=o){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,B=this.state.pageSize){return new l({...this.state,pageNumber:N,pageSize:B})}withFilter(N,...B){const W=[...this.state.criteria,...B.length?B.map(z=>({filterType:N,value:z})):[{filterType:N}]];return new l({...this.state,criteria:W})}withSortBy(N){return new l({...this.state,sortBy:N})}withSortOrder(N){return new l({...this.state,sortOrder:N})}withFlags(...N){return new l({...this.state,flags:N.reduce((B,W)=>B|W,0)})}withAssetTypes(...N){return new l({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:B,pageSize:W,sortBy:z,sortOrder:T,flags:A,assetTypes:O}=this.state;return{filters:[{criteria:N,pageNumber:B,pageSize:W,sortBy:z,sortOrder:T}],assetTypes:O,flags:A}}get searchText(){const N=this.state.criteria.filter(B=>B.filterType===u.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function w(F,N){const B=(F||[]).filter(W=>W.statisticName===N)[0];return B?B.value:0}function f(F){const N="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(W=>W.assetType.indexOf(N)===0).reduce((W,z)=>{const T=C(F,z.assetType);return T&&W.push([z.assetType.substring(N.length),T]),W},[])}function L(F){if(F.properties){const N=F.properties.filter(z=>z.key===t.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=N.filter(z=>B.test(z.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return C(F,t.Repository)}function R(F){return{uri:`${F.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${F.fallbackAssetUri}/${t.VSIX}`}}function _(F){const N=C(F,t.Icon);if(N)return N;const B=M.DefaultIconPath;return{uri:B,fallbackUri:B}}function C(F,N){return F.files.filter(W=>W.assetType===N)[0]?{uri:`${F.assetUri}/${N}`,fallbackUri:`${F.fallbackAssetUri}/${N}`}:null}function K(F,N){const B=F.properties?F.properties.filter(z=>z.key===N):[],W=B.length>0&&B[0].value;return W?W.split(",").map(z=>(0,D.adoptToGalleryExtensionId)(z)):[]}function x(F){const N=F.properties?F.properties.filter(B=>B.key===s.Engine):[];return N.length>0&&N[0].value||""}function ie(F){const N=F.properties?F.properties.filter(W=>W.key===s.LocalizedLanguages):[],B=N.length>0&&N[0].value||"";return B?B.split(","):[]}function G(F){return F.indexOf("preview")!==-1}function Q(F,N,B,W,z){const T={manifest:C(N,t.Manifest),readme:C(N,t.Details),changelog:C(N,t.Changelog),license:C(N,t.License),repository:L(N),download:R(N),icon:_(N),coreTranslations:f(N)};return{identifier:{id:(0,D.getGalleryExtensionId)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:N.version,date:N.lastUpdated,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,description:F.shortDescription||"",installCount:w(F.statistics,"install"),rating:w(F.statistics,"averagerating"),ratingCount:w(F.statistics,"ratingcount"),assetUri:y.URI.parse(N.assetUri),categories:F.categories||[],tags:F.tags||[],releaseDate:Date.parse(F.releaseDate),lastUpdated:Date.parse(F.lastUpdated),webExtension:!!F.tags?.includes(M.WEB_EXTENSION_TAG),assetTypes:N.files.map(({assetType:A})=>A),assets:T,properties:{dependencies:K(N,s.Dependency),extensionPack:K(N,s.ExtensionPack),engine:x(N),localizedLanguages:ie(N)},telemetryData:{index:(W.pageNumber-1)*W.pageSize+B,querySource:z},preview:G(F.flags)}}let U=class{constructor(N,B,W,z,T,A,O){this.requestService=N,this.logService=B,this.environmentService=W,this.telemetryService=z,this.fileService=T,this.productService=A;const H=A.extensionsGallery;this.extensionsGalleryUrl=H&&H.serviceUrl,this.extensionsControlUrl=H&&H.controlUrl,this.commonHeadersPromise=$(A.version,this.environmentService,this.fileService,O)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,B){const W=[];let{total:z,firstPage:T,getPage:A}=await this.query({names:N,pageSize:N.length},B);W.push(...T);for(let O=1;W.length<z&&(T=await A(O,B),T.length);O++)W.push(...T);return W}async getCompatibleExtension(N,B){return this.getCompatibleExtensionByEngine(N,B)}async getCompatibleExtensionByEngine(N,B){const W=(0,M.isIExtensionIdentifier)(N)?null:N;if(W&&W.properties.engine&&(0,p.isEngineValid)(W.properties.engine,this.productService.version,this.productService.date))return W;const{id:z,uuid:T}=W?W.identifier:N;let A=new l().withFlags(h.IncludeAssetUri,h.IncludeStatistics,h.IncludeCategoryAndTags,h.IncludeFiles,h.IncludeVersionProperties).withPage(1,1).withFilter(u.Target,"Microsoft.VisualStudio.Code");T?A=A.withFilter(u.ExtensionId,T):A=A.withFilter(u.ExtensionName,z);const{galleryExtensions:O}=await this.queryGallery(A,i.CancellationToken.None),[H]=O;if(!H||!H.versions.length)return null;if(B){const q=H.versions.filter(X=>X.version===B)[0];if(q){const X=Q(H,q,0,A);if(X.properties.engine&&(0,p.isEngineValid)(X.properties.engine,this.productService.version,this.productService.date))return X}return null}const Y=await this.getLastValidExtensionVersion(H,H.versions);return Y?Q(H,Y,0,A):null}async query(N,B){const W=i.CancellationToken.isCancellationToken(N)?{}:N,z=i.CancellationToken.isCancellationToken(N)?N:B;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let T=W.text||"";const A=(0,S.getOrDefault)(W,ne=>ne.pageSize,50);let O=new l().withFlags(h.IncludeLatestVersionOnly,h.IncludeAssetUri,h.IncludeStatistics,h.IncludeCategoryAndTags,h.IncludeFiles,h.IncludeVersionProperties).withPage(1,A).withFilter(u.Target,"Microsoft.VisualStudio.Code");T?(T=T.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,se,ae)=>(O=O.withFilter(u.Category,ae||se),"")),T=T.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,se,ae)=>(O=O.withFilter(u.Tag,ae||se),"")),T=T.replace(/\bfeatured(\s+|\b|$)/g,()=>(O=O.withFilter(u.Featured),"")),T=T.trim(),T&&(T=T.length<200?T:T.substring(0,200),O=O.withFilter(u.SearchText,T)),O=O.withSortBy(0)):W.ids?O=O.withFilter(u.ExtensionId,...W.ids):W.names?O=O.withFilter(u.ExtensionName,...W.names):O=O.withSortBy(4),typeof W.sortBy=="number"&&(O=O.withSortBy(W.sortBy)),typeof W.sortOrder=="number"&&(O=O.withSortOrder(W.sortOrder));const{galleryExtensions:H,total:Y}=await this.queryGallery(O,z),q=H.map((ne,se)=>Q(ne,ne.versions[0],se,O,W.source)),X=async(ne,se)=>{if(se.isCancellationRequested)throw(0,m.canceled)();const ae=O.withPage(ne+1),{galleryExtensions:de}=await this.queryGallery(ae,se);return de.map((re,ce)=>Q(re,re.versions[0],ce,ae,W.source))};return{firstPage:q,total:Y,pageSize:O.pageSize,getPage:X}}async queryGallery(N,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,h.ExcludeNonValidated).withFilter(u.ExcludeWithFlags,a(h.Unpublished));const W=await this.commonHeadersPromise,z=JSON.stringify(N.raw),T={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(z.length)},A=new Date().getTime();let O,H,Y=0;try{if(O=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:z,headers:T},B),O.res.statusCode&&O.res.statusCode>=400&&O.res.statusCode<500)return{galleryExtensions:[],total:Y};const q=await(0,n.asJson)(O);if(q){const X=q.results[0],ne=X.extensions,se=X.resultMetadata&&X.resultMetadata.filter(ae=>ae.metadataType==="ResultCount")[0];return Y=se&&se.metadataItems.filter(ae=>ae.name==="TotalCount")[0].count||0,{galleryExtensions:ne,total:Y}}return{galleryExtensions:[],total:Y}}catch(q){throw H=q,q}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(z.length),duration:new Date().getTime()-A,success:!!O&&(0,n.isSuccess)(O),responseBodySize:O?.res.headers["Content-Length"],statusCode:O?String(O.res.statusCode):void 0,errorCode:H?(0,m.isPromiseCanceledError)(H)?"canceled":(0,m.getErrorMessage)(H).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Y)})}}async reportStatistic(N,B,W,z){if(!this.isEnabled())return;const T=c.isWeb?this.api(`/itemName/${N}.${B}/version/${W}/statType/${z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${B}/${W}/stats?statType=${z}`),A=c.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",H={...await this.commonHeadersPromise,Accept:A};try{await this.requestService.request({type:"POST",url:T,headers:H},i.CancellationToken.None)}catch(Y){}}async download(N,B,W){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const z=(0,D.getGalleryExtensionTelemetryData)(N),T=new Date().getTime(),A=q=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...z,duration:q}),O=W===1?"install":W===2?"update":"",H=O?{uri:`${N.assets.download.uri}&${O}=true`,fallbackUri:`${N.assets.download.fallbackUri}?${O}=true`}:N.assets.download,Y=await this.getAsset(H);await this.fileService.writeFile(B,Y.stream),A(new Date().getTime()-T)}async getReadme(N,B){if(N.assets.readme){const W=await this.getAsset(N.assets.readme,{},B);return await(0,n.asText)(W)||""}return""}async getManifest(N,B){if(N.assets.manifest){const W=await this.getAsset(N.assets.manifest,{},B),z=await(0,n.asText)(W);return z?JSON.parse(z):null}return null}async getCoreTranslation(N,B){const W=N.assets.coreTranslations.filter(z=>z[0]===B.toUpperCase())[0];if(W){const z=await this.getAsset(W[1]),T=await(0,n.asText)(z);return T?JSON.parse(T):null}return null}async getChangelog(N,B){if(N.assets.changelog){const W=await this.getAsset(N.assets.changelog,{},B);return await(0,n.asText)(W)||""}return""}async getAllVersions(N,B){let W=new l().withFlags(h.IncludeVersions,h.IncludeCategoryAndTags,h.IncludeFiles,h.IncludeVersionProperties).withPage(1,1).withFilter(u.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?W=W.withFilter(u.ExtensionId,N.identifier.uuid):W=W.withFilter(u.ExtensionName,N.identifier.id);const z=[],{galleryExtensions:T}=await this.queryGallery(W,i.CancellationToken.None);return T.length&&(B?await Promise.all(T[0].versions.map(async A=>{let O;try{O=await this.getEngine(A)}catch(H){}O&&(0,p.isEngineValid)(O,this.productService.version,this.productService.date)&&z.push({version:A.version,date:A.lastUpdated})})):z.push(...T[0].versions.map(A=>({version:A.version,date:A.lastUpdated})))),z}async getAsset(N,B={},W=i.CancellationToken.None){const z=await this.commonHeadersPromise,T={type:"GET"},A={...z,...B.headers||{}};B={...B,...T,headers:A};const O=N.uri,H=N.fallbackUri,Y={...B,url:O};try{const q=await this.requestService.request(Y,W);if(q.res.statusCode===200)return q;const X=await(0,n.asText)(q);throw new Error(`Expected 200, got back ${q.res.statusCode} instead.

${X}`)}catch(q){if((0,m.isPromiseCanceledError)(q))throw q;const X=(0,m.getErrorMessage)(q);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:O,message:X});const ne={...B,url:H};return this.requestService.request(ne,W)}}async getLastValidExtensionVersion(N,B){const W=this.getLastValidExtensionVersionFromProperties(N,B);return W||this.getLastValidExtensionVersionRecursively(N,B)}getLastValidExtensionVersionFromProperties(N,B){for(const W of B){const z=x(W);if(!z)return null;if((0,p.isEngineValid)(z,this.productService.version,this.productService.date))return W}return null}async getEngine(N){const B=x(N);if(B)return B;const W=C(N,t.Manifest);if(!W)throw new Error("Manifest was not found");const z={"Accept-Encoding":"gzip"},T=await this.getAsset(W,{headers:z}),A=await(0,n.asJson)(T);if(A)return A.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(N,B){if(!B.length)return null;const W=B[0],z=await this.getEngine(W);return(0,p.isEngineValid)(z,this.productService.version,this.productService.date)?{...W,properties:[...W.properties||[],{key:s.Engine,value:z}]}:this.getLastValidExtensionVersionRecursively(N,B.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,n.asJson)(N),W=new Map;if(B)for(const z of B.malicious){const T=W.get(z)||{id:{id:z},malicious:!0,slow:!1};T.malicious=!0,W.set(z,T)}return[...W.values()]}};U=he([ee(0,n.IRequestService),ee(1,b.ILogService),ee(2,g.IEnvironmentService),ee(3,E.ITelemetryService),ee(4,k.IFileService),ee(5,d.IProductService),ee(6,(0,I.optional)(v.IStorageService))],U),e.ExtensionGalleryService=U;async function $(F,N,B,W){const z={"X-Market-Client-Id":`VSCode ${F}`,"User-Agent":`VSCode ${F}`},T=await(0,P.getServiceMachineId)(N,B,W);return z["X-Market-User-Id"]=T,z}e.resolveMarketplaceHeaders=$}),define(J[200],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(S){this.appender=S}listen(S,E){throw new Error(`Event not found: ${E}`)}call(S,E,{eventName:n,data:p}){return this.appender.log(n,p),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class M{constructor(S){this.channel=S}log(S,E){return this.channel.call("log",{eventName:S,data:E}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=M}),define(J[201],Z([0,1,49,147,23,4,21,50,2,44,38]),function(V,e,m,M,D,S,E,n,p,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(d,v){this._configurationService=v,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const I=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!I})}))}setExperimentProperty(d,v){this._experimentProperties[d]=v}setEnabled(d){this._enabled=d}_updateUserOptIn(){const d=this._configurationService?.getValue(k);this._userOptIn=d?d.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let v=d.sessionID,P=d["common.instanceId"],I=d["common.machineId"],c=d["common.firstSessionDate"],h=d["common.msftInternal"];return{sessionId:v,instanceId:P,machineId:I,firstSessionDate:c,msftInternal:h}}dispose(){this._disposables.dispose()}publicLog(d,v,P){return this.isOptedIn?this._commonProperties.then(I=>{v=(0,g.mixin)(v,I),v=(0,g.mixin)(v,this._experimentProperties),v=(0,g.cloneAndChange)(v,c=>{if(typeof c=="string")return this._cleanupInfo(c,P)}),this._appender.log(d,v)},I=>{console.error(I)}):Promise.resolve(void 0)}publicLog2(d,v,P){return this.publicLog(d,v,P)}publicLogError(d,v){return this.sendErrorTelemetry?this.publicLog(d,v,!0):Promise.resolve(void 0)}publicLogError2(d,v){return this.publicLogError(d,v)}_cleanupInfo(d,v){let P=d;if(v){const I=[];for(let u of this._cleanupPatterns)for(;;){const t=u.exec(d);if(!t)break;I.push([t.index,u.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(P="";;){const u=h.exec(d);if(!u)break;!c.test(u[0])&&I.every(([t,s])=>u.index<t||u.index>=s)&&(P+=d.substring(a,u.index)+"<REDACTED: user-file-path>",a=h.lastIndex)}a<d.length&&(P+=d.substr(a))}for(let I of this._cleanupPatterns)P=P.replace(I,"");return P}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=he([ee(1,(0,S.optional)(E.IConfigurationService))],b),e.TelemetryService=b;const k="telemetry";i.Registry.as(n.Extensions.Configuration).registerConfiguration({id:k,order:110,type:"object",title:(0,M.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,M.localize)(2,null,m.default.nameLong,m.default.privacyStatementUrl):(0,M.localize)(1,null,m.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[96],Z([0,1,21,44,13,9]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,v){return Promise.resolve(void 0)}publicLog2(d,v){return this.publicLog(d,v)}publicLogError(d,v){return Promise.resolve(void 0)}publicLogError2(d,v){return this.publicLogError(d,v)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class E{async publicLog(v,P,I){}async publicLogError(v,P,I){}}e.NullEndpointTelemetryService=E;function n(...d){return{log:(v,P)=>d.forEach(I=>I.log(v,P)),flush:()=>S.Promises.settled(d.map(v=>v.flush())),productIdentifier:d.find(v=>v.productIdentifier!==void 0)?.productIdentifier}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(d,v){return v.onDidChangeConfiguration(P=>{P.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,m.ConfigurationTargetToString)(P.source),configurationKeys:k(P.sourceConfig)})})}e.configurationTelemetry=p;function g(d){const v=Object.create(null),P=Object.create(null),I=Object.create(null);b(d,I);for(let c in I){c=c.length>150?c.substr(c.length-149):c;const h=I[c];typeof h=="number"?P[c]=h:typeof h=="boolean"?P[c]=h?1:0:typeof h=="string"?v[c]=h.substring(0,1023):typeof h!="undefined"&&h!==null&&(v[c]=h)}return{properties:v,measurements:P}}e.validateTelemetryData=g;function i(d){if(!d)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(I=>{d.indexOf(`${I}+`)===0&&(v=I)}),v}e.cleanRemoteAuthority=i;function b(d,v,P=0,I){if(!!d)for(let c of Object.getOwnPropertyNames(d)){const h=d[c],a=I?I+c:c;Array.isArray(h)?v[a]=(0,M.safeStringify)(h):h instanceof Date?v[a]=h.toISOString():(0,D.isObject)(h)?P<2?b(h,v,P+1,a+"."):v[a]=(0,M.safeStringify)(h):v[a]=h}}function k(d){if(!d)return[];const v=[];return y(v,"",d),v}function y(d,v,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(I=>y(d,v?`${v}.${I}`:I,P[I])):d.push(v)}}),define(J[202],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(J[203],Z([0,1,4,2,38,5,202,108]),function(V,e,m,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,m.createDecorator)("themeService");var p;(function(P){function I(c){return c&&typeof c=="object"&&typeof c.id=="string"}P.isThemeColor=I})(p=e.ThemeColor||(e.ThemeColor={}));function g(P){return{id:P}}e.themeColorFromId=g;var i;(function(P){function I(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||p.isThemeColor(s.color))}P.isThemeIcon=I;const c=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function h(s){const r=c.exec(s);if(!r)return;let[,o]=r;return{id:o}}P.fromString=h;function a(s,r){let o=s.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),r&&(o=`${o}~${r}`),{id:o}}P.modify=a;function u(s,r){return s.id===r.id&&s.color?.id===r.color?.id}P.isEqual=u;function t(s,r){return{id:s.id,color:r?g(r):void 0}}P.asThemeIcon=t,P.asClassNameArray=n.CSSIcon.asClassNameArray,P.asClassName=n.CSSIcon.asClassName,P.asCSSSelector=n.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function b(P){switch(P){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class k{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,M.toDisposable)(()=>{const c=this.themingParticipants.indexOf(I);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new k;D.Registry.add(e.Extensions.ThemingContribution,y);function d(P){return y.onColorThemeChange(P)}e.registerThemingParticipant=d;class v extends M.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,c){let h=this.theme.getColor(I);return h&&c&&(h=c(h,this.theme)),h?h.toString():null}}e.Themable=v}),define(J[60],Z([0,1,14,3,39,4]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",n="#1E1E1E",p="#000000",g="theme",i="themeBackground",b="windowSplash";e.IThemeMainService=(0,S.createDecorator)("themeMainService");let k=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((M.isWindows||M.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme)return p;let d=this.stateMainService.getItem(i,null);if(!d){let v;(M.isWindows||M.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme?v="hc-black":v=this.stateMainService.getItem(g,"vs-dark").split(" ")[0],d=v==="hc-black"?p:v==="vs"?E:n}return M.isMacintosh&&d.toUpperCase()===n&&(d="#171717"),d}saveWindowSplash(d,v){this.stateMainService.setItems([{key:g,data:v.baseTheme},{key:i,data:v.colorInfo.background},{key:b,data:v}]),typeof d=="number"&&this.updateBackgroundColor(d,v)}updateBackgroundColor(d,v){for(const P of m.BrowserWindow.getAllWindows())if(P.id===d){P.setBackgroundColor(v.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(b)}};k=he([ee(0,D.IStateMainService)],k),e.ThemeMainService=k}),define(J[42],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var M;(function(S){S.Uninitialized="uninitialized",S.Idle="idle",S.CheckingForUpdates="checking for updates",S.AvailableForDownload="available for download",S.Downloading="downloading",S.Downloaded="downloaded",S.Updating="updating",S.Ready="ready"})(M=e.StateType||(e.StateType={}));var D;(function(S){S[S.Setup=0]="Setup",S[S.Archive=1]="Archive",S[S.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(S,E)=>({type:"idle",updateType:S,error:E}),CheckingForUpdates:S=>({type:"checking for updates",explicit:S}),AvailableForDownload:S=>({type:"available for download",update:S}),Downloading:S=>({type:"downloading",update:S}),Downloaded:S=>({type:"downloaded",update:S}),Updating:S=>({type:"updating",update:S}),Ready:S=>({type:"ready",update:S})},e.IUpdateService=(0,m.createDecorator)("updateService")}),define(J[204],Z([0,1,38,50,148,3]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.Registry.as(M.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[205],Z([0,1,5,42]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(n){this.service=n}listen(n,p){switch(p){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${p}`)}call(n,p,g){switch(p){case"checkForUpdates":return this.service.checkForUpdates(g);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${p}`)}}e.UpdateChannel=D;class S{constructor(n){this.channel=n,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,this._state=M.State.Uninitialized,this.channel.listen("onStateChange")(p=>this.state=p),this.channel.call("_getInitialState").then(p=>this.state=p)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=S}),define(J[97],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,m.createDecorator)("urlService")}),define(J[206],Z([0,1,7]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class M{constructor(n){this.handler=n}listen(n,p){throw new Error(`Event not found: ${p}`)}call(n,p,g){switch(p){case"handleURL":return this.handler.handleURL(m.URI.revive(g[0]),g[1])}throw new Error(`Call not found: ${p}`)}}e.URLHandlerChannel=M;class D{constructor(n){this.channel=n}handleURL(n,p){return this.channel.call("handleURL",[n.toJSON(),p])}}e.URLHandlerChannelClient=D;class S{constructor(n){this.next=n}async routeCall(n,p,g,i){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(g){const b=m.URI.revive(g);if(b&&b.query){const k=/\bwindowId=(\d+)/.exec(b.query);if(k){const y=k[1],d=new RegExp(`window:${y}`),v=n.connections.find(P=>d.test(P.ctx));if(v)return v}}}return this.next.routeCall(n,p,g,i)}routeEvent(n,p){throw new Error(`Event not found: ${p}`)}}e.URLHandlerRouter=S}),define(J[207],Z([0,1,7,9,2,20]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class E extends D.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(g,i){const b=[...this.handlers.values()];return(0,M.first)(b.map(k=>()=>k.handleURL(g,i)),void 0,!1).then(k=>k||!1)}registerHandler(g){return this.handlers.add(g),(0,D.toDisposable)(()=>this.handlers.delete(g))}}e.AbstractURLService=E;let n=class extends E{constructor(g){super();this.productService=g}create(g){let{authority:i,path:b,query:k,fragment:y}=g||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&b&&b.indexOf("/")!==0&&(b=`/${b}`),m.URI.from({scheme:this.productService.urlProtocol,authority:i,path:b,query:k,fragment:y})}};n=he([ee(0,S.IProductService)],n),e.NativeURLService=n}),define(J[208],Z([0,1,5,14,7,2,3,9]),function(V,e,m,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function p(i){try{return D.URI.parse(i)}catch(b){return null}}class g{constructor(b,k,y,d,v){if(this.urlService=k,this.uris=[],this.retryCount=0,this.flushDisposable=S.Disposable.None,this.disposables=new S.DisposableStore,this.uris=b,E.isWindows){const c=d.isBuilt?[]:[`"${d.appRoot}"`];c.push("--open-url","--"),M.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,c)}const P=m.Event.map(m.Event.fromNodeEventEmitter(M.app,"open-url",(c,h)=>({event:c,url:h})),({event:c,url:h})=>(c.preventDefault(),h));this.disposables.add(P(c=>{const h=p(c);!h||this.urlService.open(h,{originalUrl:c})})),y.getWindows().filter(c=>c.isReady).length>0?this.flush():m.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const b=[];for(const k of this.uris)await this.urlService.open(k.uri,{originalUrl:k.url})||b.push(k);b.length!==0&&(this.uris=b,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=g}),define(J[209],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,m.createDecorator)("webviewManagerService")}),define(J[210],Z([0,1,14,2,10,7]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class E extends M.Disposable{constructor(){super();const p=this.handleWebviewRequest.bind(this);m.protocol.registerFileProtocol(D.Schemas.vscodeWebview,p)}handleWebviewRequest(p,g){try{const i=S.URI.parse(p.url),b=E.validWebviewFilePaths.get(i.path);if(typeof b=="string"){const k=`vs/workbench/contrib/webview/browser/pre/${b}`,y=D.FileAccess.asFileUri(k,V);return g(decodeURIComponent(y.fsPath))}else return g({error:-10})}catch{}return g({error:-2})}}e.WebviewProtocolProvider=E,E.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],Z([0,1,3]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function M(g){return!!g.workspaceUri}e.isWorkspaceToOpen=M;function D(g){return!!g.folderUri}e.isFolderToOpen=D;function S(g){return!!g.fileUri}e.isFileToOpen=S;function E(g){const i=n(g),b=g.getValue("window.menuBarVisibility");return b==="default"||i==="native"&&b==="compact"||m.isMacintosh&&m.isNative?"classic":b}e.getMenuBarVisibility=E;function n(g){if(m.isWeb)return"custom";const i=g.getValue("window");if(i){if(m.isMacintosh&&i.nativeTabs===!0||m.isMacintosh&&i.nativeFullScreen===!1)return"native";const y=i.titleBarStyle;if(y==="native"||y==="custom")return y}return m.isLinux?"native":"custom"}e.getTitleBarStyle=n;function p(g=0){return Math.pow(1.2,g)}e.zoomLevelToZoomFactor=p}),define(J[35],Z([0,1,4]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var M;(function(g){g[g.INITIAL=1]="INITIAL",g[g.LOAD=2]="LOAD",g[g.RELOAD=3]="RELOAD"})(M=e.LoadReason||(e.LoadReason={}));var D;(function(g){g[g.CLOSE=1]="CLOSE",g[g.QUIT=2]="QUIT",g[g.RELOAD=3]="RELOAD",g[g.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var S;(function(g){g[g.CLI=0]="CLI",g[g.DOCK=1]="DOCK",g[g.MENU=2]="MENU",g[g.DIALOG=3]="DIALOG",g[g.DESKTOP=4]="DESKTOP",g[g.API=5]="API"})(S=e.OpenContext||(e.OpenContext={}));const E=function(g=1){return{width:1024,height:768,mode:g}};e.defaultWindowState=E;var n;(function(g){g[g.Maximized=0]="Maximized",g[g.Normal=1]="Normal",g[g.Minimized=2]="Minimized",g[g.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var p;(function(g){g[g.UNRESPONSIVE=1]="UNRESPONSIVE",g[g.CRASHED=2]="CRASHED",g[g.LOAD=3]="LOAD"})(p=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,m.createDecorator)("windowsMainService")}),define(J[211],Z([0,1,14,5,2,210,35]),function(V,e,m,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let n=class extends D.Disposable{constructor(g){super();this.windowsMainService=g,this._onFoundInFrame=this._register(new M.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new S.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(g,i){let b;if(typeof g.windowId=="number"){const{windowId:k}=g,y=this.windowsMainService.getWindowById(k);if(!y?.win)throw new Error(`Invalid windowId: ${k}`);b=y.win.webContents}else{const{webContentsId:k}=g;if(b=m.webContents.fromId(k),!b)throw new Error(`Invalid webContentsId: ${k}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(i)}async findInFrame(g,i,b,k){const y=this.getFrameByName(g,i),d=y;if(typeof d.findInFrame=="function"){d.findInFrame(b,{findNext:k.findNext,forward:k.forward});const v=(P,I)=>{I.finalUpdate&&(this._onFoundInFrame.fire(I),y.removeListener("found-in-frame",v))};y.on("found-in-frame",v)}}async stopFindInFrame(g,i,b){const y=this.getFrameByName(g,i);typeof y.stopFindInFrame=="function"&&y.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}getFrameByName(g,i){const b=this.windowsMainService.getWindowById(g.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${g}`);const k=b.win.webContents.mainFrame.framesInSubtree.find(y=>y.name===i);if(!k)throw new Error(`Unknown frame: ${i}`);return k}};n=he([ee(0,E.IWindowsMainService)],n),e.WebviewMainService=n}),define(J[212],Z([0,1,5,2,9]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class S extends M.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:p,getActiveWindowId:g}){super();this.disposables=this._register(new M.DisposableStore),m.Event.latch(m.Event.any(n,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>g()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch(b){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=S}),define(J[213],Z([0,1,7,15,4,37]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var E;(function(k){k[k.EMPTY=1]="EMPTY",k[k.FOLDER=2]="FOLDER",k[k.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function n(k){const y=k;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=n;function p(k){const y=k;return!!(y&&typeof y=="object"&&m.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=p;class g{constructor(y,d,v,P){this._id=y,this._configuration=v,this._ignorePathCasing=P,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(y){this._id=y.id,this._configuration=y.configuration,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=g;class i{constructor(y,d){this.raw=d,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,M.joinPath)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function b(k){return new i({uri:k,index:0,name:(0,M.basenameOrAuthority)(k)},{uri:k.toString()})}e.toWorkspaceFolder=b}),define(J[27],Z([0,1,4,151,213,7,3,8,15,76,40,10,31,30,73]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,M.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(U){return(typeof U=="string"?(0,n.extname)(U):(0,p.extname)(U))===v}e.hasWorkspaceFileExtension=P,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function I(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function c(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=c;function h(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=h;function a(U){const $=U;return typeof $?.id=="string"&&S.URI.isUri($.uri)}e.isSingleFolderWorkspaceIdentifier=a;function u(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=u;function t(U){const $=U;return typeof $?.id=="string"&&S.URI.isUri($.configPath)}e.isWorkspaceIdentifier=t;function s(U){const $=U;if($?.uri)return{id:$.id,uri:S.URI.revive($.uri)};const F=U;if(F?.configPath)return{id:F.id,configPath:S.URI.revive(F.configPath)};if(U?.id)return{id:U.id}}e.reviveIdentifier=s;function r(U,$){return p.extUriBiasedIgnorePathCase.isEqualOrParent(U,$.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function o(U){return l(U)||w(U)}e.isStoredWorkspaceFolder=o;function l(U){const $=U;return typeof $?.path=="string"&&(!$.name||typeof $.name=="string")}e.isRawFileWorkspaceFolder=l;function w(U){const $=U;return typeof $?.uri=="string"&&(!$.name||typeof $.name=="string")}e.isRawUriWorkspaceFolder=w;function f(U,$,F,N,B=!E.isWindows,W){if(U.scheme!==N.scheme)return{name:F,uri:U.toString(!0)};let z=$?void 0:W.relativePath(N,U);if(z!==void 0)z.length===0?z=".":E.isWindows&&U.scheme===b.Schemas.file&&!B&&(z=z.replace(/\//g,"\\"));else if(U.scheme===b.Schemas.file)z=U.fsPath,E.isWindows&&(z=(0,k.normalizeDriveLetter)(z),B&&(z=(0,y.toSlashes)(z)));else{if(!W.isEqualAuthority(U.authority,N.authority))return{name:F,uri:U.toString(!0)};z=U.path}return{name:F,path:z}}e.getStoredWorkspaceFolder=f;function L(U,$,F){let N=[],B=new Set;const W=F.dirname($);for(let z of U){let T;if(l(z))z.path&&(T=F.resolvePath(W,z.path));else if(w(z))try{T=S.URI.parse(z.uri),T.path[0]!=="/"&&(T=T.with({path:"/"+T.path}))}catch(A){console.warn(A)}if(T){let A=F.getComparisonKey(T);if(!B.has(A)){B.add(A);const O=z.name||F.basenameOrAuthority(T);N.push(new D.WorkspaceFolder({uri:T,name:O,index:N.length},z))}}}return N}e.toWorkspaceFolders=L;function R(U,$,F,N,B){let W=_($,U);const z=B.dirname($),T=B.dirname(N),A=[],O=C(W.folders);for(const X of W.folders){const ne=l(X)?B.resolvePath(z,X.path):S.URI.parse(X.uri);let se;F?se=!1:se=!l(X)||(0,n.isAbsolute)(X.path),A.push(f(ne,se,X.name,T,O,B))}const H={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},Y=g.setProperty(U,["folders"],A,H);let q=g.applyEdits(U,Y);return W.remoteAuthority===(0,d.getRemoteAuthority)(N)&&(q=g.applyEdits(q,g.removeProperty(q,["remoteAuthority"],H))),q}e.rewriteWorkspaceFileForNewLocation=R;function _(U,$){let F=i.parse($);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(N=>o(N));else throw new Error(`${U} looks like an invalid workspace file.`);return F}function C(U){return E.isWindows?U.some($=>l($)&&$.path.indexOf("/")>=0):!0}e.useSlashForPath=C;function K(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function x(U){return typeof U.folderUri=="string"}function ie(U){return typeof U.fileUri=="string"}function G(U,$){const F={workspaces:[],files:[]};if(U){const N=function(W,z){for(let T=0;T<W.length;T++)try{z(W[T],T)}catch(A){$.warn(`Error restoring recent entry ${JSON.stringify(W[T])}: ${A.toString()}. Skip entry.`)}},B=U;if(Array.isArray(B.entries))N(B.entries,W=>{const z=W.label,T=W.remoteAuthority;K(W)?F.workspaces.push({label:z,remoteAuthority:T,workspace:{id:W.workspace.id,configPath:S.URI.parse(W.workspace.configPath)}}):x(W)?F.workspaces.push({label:z,remoteAuthority:T,folderUri:S.URI.parse(W.folderUri)}):ie(W)&&F.files.push({label:z,remoteAuthority:T,fileUri:S.URI.parse(W.fileUri)})});else{const W=U;Array.isArray(W.workspaces3)&&N(W.workspaces3,(z,T)=>{const A=Array.isArray(W.workspaceLabels)&&W.workspaceLabels[T]||void 0;typeof z=="object"&&typeof z.id=="string"&&typeof z.configURIPath=="string"?F.workspaces.push({label:A,workspace:{id:z.id,configPath:S.URI.parse(z.configURIPath)}}):typeof z=="string"&&F.workspaces.push({label:A,folderUri:S.URI.parse(z)})}),Array.isArray(W.files2)&&N(W.files2,(z,T)=>{const A=Array.isArray(W.fileLabels)&&W.fileLabels[T]||void 0;typeof z=="string"&&F.files.push({label:A,fileUri:S.URI.parse(z)})})}}return F}e.restoreRecentlyOpened=G;function Q(U){const $={entries:[]};for(const F of U.workspaces)c(F)?$.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):$.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of U.files)$.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return $}e.toStoreData=Q}),define(J[52],Z([0,1,4,27]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,m.createDecorator)("backupMainService");function D(S){const E=S;return E&&(0,M.isWorkspaceIdentifier)(E.workspace)}e.isWorkspaceBackupInfo=D}),define(J[53],Z([0,1,4,14,9,39,3,8,65,18,13,133,27,31,2,78]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,m.createDecorator)("dialogMainService");let P=class gt{constructor(c){this.stateMainService=c,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new D.Queue}pickFileFolder(c,h){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},h)}pickFolder(c,h){return this.doPick({...c,pickFolders:!0,title:(0,b.localize)(1,null)},h)}pickFile(c,h){return this.doPick({...c,pickFiles:!0,title:(0,b.localize)(2,null)},h)}pickWorkspace(c,h){const a=(0,b.localize)(3,null),u=(0,y.mnemonicButtonLabel)((0,b.localize)(4,null)),t=k.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:a,filters:t,buttonLabel:u},h)}async doPick(c,h){const a={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};a.defaultPath=c.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(a.properties=void 0,c.pickFiles&&c.pickFolders&&(a.properties=["multiSelections","openDirectory","openFile","createDirectory"])),a.properties||(a.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),E.isMacintosh&&a.properties.push("treatPackageAsDirectory");const u=h||M.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(a,(0,i.withNullAsUndefined)(u));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,n.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(c){if(c){let h=this.windowDialogQueues.get(c.id);return h||(h=new D.Queue,this.windowDialogQueues.set(c.id,h)),h}else return this.noWindowDialogueQueue}showMessageBox(c,h){return this.getWindowDialogQueue(h).queue(async()=>h?M.dialog.showMessageBox(h,c):M.dialog.showMessageBox(c))}async showSaveDialog(c,h){const a=this.acquireFileDialogLock(c,h);if(!a)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let u;return h?u=await M.dialog.showSaveDialog(h,c):u=await M.dialog.showSaveDialog(c),u.filePath=this.normalizePath(u.filePath),u})}finally{(0,d.dispose)(a)}}normalizePath(c){return c&&E.isMacintosh&&(c=(0,p.normalizeNFC)(c)),c}normalizePaths(c){return c.map(h=>this.normalizePath(h))}async showOpenDialog(c,h){c.defaultPath&&(await g.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const a=this.acquireFileDialogLock(c,h);if(!a)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let u;return h?u=await M.dialog.showOpenDialog(h,c):u=await M.dialog.showOpenDialog(c),u.filePaths=this.normalizePaths(u.filePaths),u})}finally{(0,d.dispose)(a)}}acquireFileDialogLock(c,h){if(!h)return d.Disposable.None;let a=this.windowFileDialogLocks.get(h.id);a||(a=new Set,this.windowFileDialogLocks.set(h.id,a));const u=(0,v.hash)(c);if(!a.has(u))return a.add(u),(0,d.toDisposable)(()=>{a?.delete(u),a?.size===0&&this.windowFileDialogLocks.delete(h.id)})}};P.workingDirPickerStorageKey="pickerWorkingDir",P=he([ee(0,S.IStateMainService)],P),e.DialogMainService=P}),define(J[214],Z([0,1,5,2,27]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class S extends M.Disposable{constructor(n,p){super();this.logService=n,this.storageMainService=p,this._onDidChangeGlobalStorage=this._register(new m.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(m.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,p)=>(n?n.push(p):n=[p],n),S.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const p=new Map,g=new Set;return n.forEach(i=>{const b=this.storageMainService.globalStorage.get(i.key);typeof b=="string"?p.set(i.key,b):g.add(i.key)}),{changed:Array.from(p.entries()),deleted:Array.from(g.values())}}listen(n,p){switch(p){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${p}`)}async call(n,p,g){const i=(0,D.reviveIdentifier)(g.workspace),b=await this.withStorageInitialized(i);switch(p){case"getItems":return Array.from(b.items.entries());case"updateItems":{const k=g;if(k.insert)for(const[y,d]of k.insert)b.set(y,d);k.delete&&k.delete.forEach(y=>b.delete(y));break}case"close":{if(i)return b.close();break}default:throw new Error(`Call not found: ${p}`)}}async withStorageInitialized(n){const p=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await p.init()}catch(g){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${g}`)}return p}}e.StorageDatabaseChannel=S,S.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[215],Z([0,1,18,5,2,6,123,84,8,95,32,28,27]),function(V,e,m,M,D,S,E,n,p,g,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends D.Disposable{constructor(I){super();this.logService=I,this._onDidChangeStorage=this._register(new M.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new M.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const I=await this.doCreate();this.storage.dispose(),this.storage=I,this._register(I.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(I);const c=I.getBoolean(g.IS_NEW_KEY);c===void 0?I.set(g.IS_NEW_KEY,!0):c&&I.set(g.IS_NEW_KEY,!1)}catch(I){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${I}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?I=>this.logService.trace(I):void 0,logError:I=>this.logService.error(I)}}doInit(I){return I.init()}get items(){return this.storage.items}get(I,c){return this.storage.get(I,c)}set(I,c){return this.storage.set(I,c)}delete(I){return this.storage.delete(I)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends y{constructor(I,c,h){super(c);this.options=I,this.environmentService=h}async doCreate(){let I;return this.options.useInMemoryStorage?I=E.SQLiteStorageDatabase.IN_MEMORY_PATH:I=(0,p.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new n.Storage(new E.SQLiteStorageDatabase(I,{logging:this.createLogginOptions()}))}async doInit(I){await super.doInit(I),this.updateTelemetryState(I)}updateTelemetryState(I){I.get(i.instanceStorageKey,void 0)===void 0&&I.set(i.instanceStorageKey,(0,b.generateUuid)()),I.get(i.firstSessionDateStorageKey,void 0)===void 0&&I.set(i.firstSessionDateStorageKey,new Date().toUTCString());const a=I.get(i.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();I.set(i.lastSessionDateStorageKey,typeof a=="undefined"?null:a),I.set(i.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class v extends y{constructor(I,c,h,a){super(h);this.workspace=I,this.options=c,this.environmentService=a}async doCreate(){const{storageFilePath:I,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new E.SQLiteStorageDatabase(I,{logging:this.createLogginOptions()}),{hint:c?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:E.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const I=(0,p.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,p.join)(I,v.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(I)?{storageFilePath:c,wasCreated:!1}:(await m.Promises.mkdir(I,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(I),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(I){let c;if((0,k.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,k.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const h=(0,p.join)(I,v.WORKSPACE_META_NAME);await m.Promises.exists(h)||await m.Promises.writeFile(h,JSON.stringify(c,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=v,v.WORKSPACE_STORAGE_NAME="state.vscdb",v.WORKSPACE_META_NAME="workspace.json"}),define(J[98],Z([0,1,43,2,48,4,22,6,215]),function(V,e,m,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,S.createDecorator)("storageMainService");let g=class extends M.Disposable{constructor(b,k,y){super();this.logService=b,this.environmentService=k,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async b=>{if(b.workspace){if(b.reason!==1)return;this.workspaceStorage(b.workspace).init()}})),this._register(this.lifecycleMainService.onWillShutdown(b=>{b.join(this.globalStorage.close());for(const[,k]of this.mapWorkspaceToStorage)b.join(k.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const b=new p.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,m.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),b}createWorkspaceStorage(b){return new p.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(b){let k=this.mapWorkspaceToStorage.get(b.id);return k||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),k=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,k),(0,m.once)(k.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),k}};g=he([ee(0,n.ILogService),ee(1,D.IEnvironmentService),ee(2,E.ILifecycleMainService)],g),e.StorageMainService=g}),define(J[99],Z([0,1,7,27,15]),function(V,e,m,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function S(p,g,i){for(const k of p){const y=k.openedWorkspace;if((0,M.isWorkspaceIdentifier)(y)){const d=i(y);if(d){if(d.folders.some(v=>D.extUriBiasedIgnorePathCase.isEqualOrParent(g,v.uri)))return k}else if(D.extUriBiasedIgnorePathCase.isEqualOrParent(g,y.configPath))return k}}const b=p.filter(k=>(0,M.isSingleFolderWorkspaceIdentifier)(k.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqualOrParent(g,k.openedWorkspace.uri));if(b.length)return b.sort((k,y)=>-(k.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=S;function E(p,g){for(const i of p)if((0,M.isWorkspaceIdentifier)(i.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,g)||(0,M.isSingleFolderWorkspaceIdentifier)(i.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,g))return i}e.findWindowOnWorkspaceOrFolder=E;function n(p,g){const i=b=>g.some(k=>D.extUriBiasedIgnorePathCase.isEqual(m.URI.file(k),m.URI.file(b)));for(const b of p)if(b.config?.extensionDevelopmentPath?.some(k=>i(k)))return b}e.findWindowOnExtensionDevelopmentPath=n}),define(J[216],Z([0,1,14,2,3,15,7,21,22,6,39,35,27]),function(V,e,m,M,D,S,E,n,p,g,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class mt extends M.Disposable{constructor(h,a,u,t,s){super();this.windowsMainService=h,this.stateMainService=a,this.lifecycleMainService=u,this.logService=t,this.configurationService=s,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){m.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(s=>!s.isExtensionDevelopmentHost)),t&&(h.lastActiveWindow=this.toWindowState(t))}const a=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);a&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const u=P(h);this.stateMainService.setItem(mt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(u=>{const t=(0,k.isWorkspaceIdentifier)(h.openedWorkspace)&&u.workspace?.id===h.openedWorkspace.id,s=(0,k.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&u.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(u.folderUri,h.openedWorkspace.uri);(t||s)&&(u.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(h){return{workspace:(0,k.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,k.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const a=this.doGetNewWindowState(h),u=this.configurationService.getValue("window");let t;return a.hasDefaultState?t=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),t&&D.isMacintosh&&this.windowsMainService.getWindows().some(s=>s.isFullScreen)&&(t=!1)),a.mode===3&&!t&&(a.mode=1),a}doGetNewWindowState(h){const a=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=h.workspace;if((0,k.isWorkspaceIdentifier)(l)){const f=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===l.id).map(L=>L.uiState);if(f.length)return f[0]}if((0,k.isSingleFolderWorkspaceIdentifier)(l)){const f=this.state.openedWindows.filter(L=>L.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(L.folderUri,l.uri)).map(L=>L.uiState);if(f.length)return f[0]}else if(h.backupPath){const f=this.state.openedWindows.filter(L=>L.backupPath===h.backupPath).map(L=>L.uiState);if(f.length)return f[0]}const w=this.lastClosedState||this.state.lastActiveWindow;if(!a&&w)return w.uiState}let u;const t=m.screen.getAllDisplays();if(t.length===1)u=t[0];else{if(D.isMacintosh){const l=m.screen.getCursorScreenPoint();u=m.screen.getDisplayNearestPoint(l)}!u&&a&&(u=m.screen.getDisplayMatching(a.getBounds())),u||(u=m.screen.getPrimaryDisplay()||t[0])}let s=(0,b.defaultWindowState)();s.x=Math.round(u.bounds.x+u.bounds.width/2-s.width/2),s.y=Math.round(u.bounds.y+u.bounds.height/2-s.height/2);const r=this.configurationService.getValue("window");let o=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")s.mode=0,o=!1;else if(r.newWindowDimensions==="fullscreen")s.mode=3,o=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&a){const l=a.serializeWindowState();l.mode===3?s.mode=3:s=l,o=s.mode!==3&&r.newWindowDimensions==="offset"}}return o&&(s=this.ensureNoOverlap(s)),s.hasDefaultState=!0,s}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const a=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;a.some(u=>u.x===h.x||u.y===h.y);)h.x+=30,h.y+=30;return h}};y.windowsStateStorageKey="windowsState",y=he([ee(0,b.IWindowsMainService),ee(1,i.IStateMainService),ee(2,p.ILifecycleMainService),ee(3,g.ILogService),ee(4,n.IConfigurationService)],y),e.WindowsStateHandler=y;function d(c){const h={openedWindows:[]},a=c||{openedWindows:[]};return a.lastActiveWindow&&(h.lastActiveWindow=v(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=v(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(h.openedWindows=a.openedWindows.map(u=>v(u))),h}e.restoreWindowsState=d;function v(c){const h={uiState:c.uiState};return c.backupPath&&(h.backupPath=c.backupPath),c.remoteAuthority&&(h.remoteAuthority=c.remoteAuthority),c.folder&&(h.folderUri=E.URI.parse(c.folder)),c.workspaceIdentifier&&(h.workspace={id:c.workspaceIdentifier.id,configPath:E.URI.parse(c.workspaceIdentifier.configURIPath)}),h}function P(c){return{lastActiveWindow:c.lastActiveWindow&&I(c.lastActiveWindow),lastPluginDevelopmentHostWindow:c.lastPluginDevelopmentHostWindow&&I(c.lastPluginDevelopmentHostWindow),openedWindows:c.openedWindows.map(h=>I(h))}}e.getWindowsStateStoreData=P;function I(c){return{workspaceIdentifier:c.workspace&&{id:c.workspace.id,configURIPath:c.workspace.configPath.toString()},folder:c.folderUri&&c.folderUri.toString(),backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.uiState}}}),define(J[100],Z([0,1,29,3,58,10,15]),function(V,e,m,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(g){function i(){let b=g.scheme===S.Schemas.file?(0,E.originalFSPath)(g):g.toString();return M.isLinux||(b=b.toLowerCase()),(0,D.createHash)("md5").update(b).digest("hex")}return{id:i(),configPath:g}}e.getWorkspaceIdentifier=n;function p(g,i){function b(){if(g.scheme!==S.Schemas.file)return(0,D.createHash)("md5").update(g.toString()).digest("hex");if(!i)try{i=(0,m.statSync)(g.fsPath)}catch(d){return}let y;return M.isLinux?y=i.ino:M.isMacintosh?y=i.birthtime.getTime():M.isWindows&&(typeof i.birthtimeMs=="number"?y=Math.floor(i.birthtimeMs):y=i.birthtime.getTime()),(0,D.createHash)("md5").update(g.fsPath).update(y?String(y):"").digest("hex")}const k=b();if(typeof k=="string")return{id:k,uri:g}}e.getSingleFolderWorkspaceIdentifier=p}),define(J[56],Z([0,1,58,59,217,5,34,8,26,28,2,17,82,16,3]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(f){this.socket=f,this._errorListener=L=>{if(L){if(L.code==="EPIPE")return;(0,y.onUnexpectedError)(L)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(f){const L=R=>f(b.VSBuffer.wrap(R));return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(f){const L=R=>{f({type:0,hadError:R,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(f){return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(f){if(!this.socket.destroyed)try{this.socket.write(f.buffer,L=>{if(L){if(L.code==="EPIPE")return;(0,y.onUnexpectedError)(L)}})}catch(L){if(L.code==="EPIPE")return;(0,y.onUnexpectedError)(L)}}end(){this.socket.end()}drain(){return new Promise((f,L)=>{if(this.socket.bufferSize===0){f();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),f()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=v;var P;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var I;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(I||(I={}));class c extends i.Disposable{constructor(f,L,R,_){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=f,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=L,this._recordInflateBytes=_,L?(this._zlibInflate=D.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",C=>{console.error(C),(0,y.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibInflate.on("data",C=>{this._pendingInflateData.push(C)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=D.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",C=>{console.error(C),(0,y.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibDeflate.on("data",C=>{this._pendingDeflateData.push(C)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new k.ChunkStream,this._register(this.socket.onData(C=>this._acceptChunk(C))),this._register(this.socket.onClose(C=>this._onClose.fire(C)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?b.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):b.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){this._totalOutgoingDataBytes+=f.byteLength,this._zlibDeflate?(this._zlibDeflate.write(f.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let L=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,L=L.slice(0,L.length-4),this._isEnded||this._write(b.VSBuffer.wrap(L),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(f,!1)}_write(f,L){let R=2;f.byteLength<126?R+=0:f.byteLength<2**16?R+=2:R+=8;const _=b.VSBuffer.alloc(R);if(L?_.writeUInt8(194,0):_.writeUInt8(130,0),f.byteLength<126)_.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){_.writeUInt8(126,1);let C=1;_.writeUInt8(f.byteLength>>>8&255,++C),_.writeUInt8(f.byteLength>>>0&255,++C)}else{_.writeUInt8(127,1);let C=1;_.writeUInt8(0,++C),_.writeUInt8(0,++C),_.writeUInt8(0,++C),_.writeUInt8(0,++C),_.writeUInt8(f.byteLength>>>24&255,++C),_.writeUInt8(f.byteLength>>>16&255,++C),_.writeUInt8(f.byteLength>>>8&255,++C),_.writeUInt8(f.byteLength>>>0&255,++C)}this._totalOutgoingWireBytes+=_.byteLength+f.byteLength,this.socket.write(b.VSBuffer.concat([_,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._totalIncomingWireBytes+=f.byteLength,this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const L=this._incomingData.peek(this._state.readLen),_=(L.readUInt8(0)&128)>>>7,C=L.readUInt8(1),K=(C&128)>>>7,x=C&127;this._state.state=2,this._state.readLen=2+(K?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=_,this._state.mask=0}else if(this._state.state===2){const L=this._incomingData.read(this._state.readLen),R=L.readUInt8(1),_=(R&128)>>>7;let C=R&127,K=1;C===126?C=L.readUInt8(++K)*2**8+L.readUInt8(++K):C===127&&(C=L.readUInt8(++K)*0+L.readUInt8(++K)*0+L.readUInt8(++K)*0+L.readUInt8(++K)*0+L.readUInt8(++K)*2**24+L.readUInt8(++K)*2**16+L.readUInt8(++K)*2**8+L.readUInt8(++K));let x=0;_&&(x=L.readUInt8(++K)*2**24+L.readUInt8(++K)*2**16+L.readUInt8(++K)*2**8+L.readUInt8(++K)),this._state.state=3,this._state.readLen=C,this._state.mask=x}else if(this._state.state===3){const L=this._incomingData.read(this._state.readLen);h(L,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(L.buffer)),this._zlibInflate.write(L.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(b.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=L.byteLength,this._onData.fire(L))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=c;function h(w,f){if(f===0)return;let L=w.byteLength>>>2;for(let ie=0;ie<L;ie++){const G=w.readUInt32BE(ie*4);w.writeUInt32BE(G^f,ie*4)}let R=L*4,_=w.byteLength-R;const C=f>>>24&255,K=f>>>16&255,x=f>>>8&255;_>=1&&w.writeUInt8(w.readUInt8(R)^C,R),_>=2&&w.writeUInt8(w.readUInt8(R+1)^K,R+1),_>=3&&w.writeUInt8(w.readUInt8(R+2)^x,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function u(){const w=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;let f;return e.XDG_RUNTIME_DIR?f=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${w}.sock`):f=(0,n.join)((0,p.tmpdir)(),`vscode-ipc-${w}.sock`),s(f),f}e.createRandomIPCHandle=u;function t(w,f,L){const R=(0,m.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${L}-${f}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${L}-${f}.sock`):_=(0,n.join)(w,`${L}-${f}.sock`),s(_),_}e.createStaticIPCHandle=t;function s(w){const f=a[d.platform];typeof f=="number"&&w.length>=f&&console.warn(`WARNING: IPC handle "${w}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends E.IPCServer{constructor(f){super(r.toClientConnectionEvent(f));this.server=f}static toClientConnectionEvent(f){const L=S.Event.fromNodeEventEmitter(f,"connection");return S.Event.map(L,R=>({protocol:new k.Protocol(new v(R)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function o(w){return new Promise((f,L)=>{const R=(0,M.createServer)();R.on("error",L),R.listen(w,()=>{R.removeListener("error",L),f(new r(R))})})}e.serve=o;function l(w,f){return new Promise((L,R)=>{const _=(0,M.createConnection)(w,()=>{_.removeListener("error",R),L(k.Client.fromSocket(new v(_),f))});_.once("error",R)})}e.connect=l}),define(J[218],Z([0,1,56]),function(V,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class M{constructor(p){this.driver=p}listen(p,g){throw new Error("No event found")}call(p,g,i){switch(g){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(i);case"getLocalizedStrings":return this.driver.getLocalizedStrings(i)}throw new Error(`Call not found: ${g}`)}}e.DriverChannel=M;class D{constructor(p){this.channel=p}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(p){return this.channel.call("capturePage",p)}reloadWindow(p){return this.channel.call("reloadWindow",p)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(p,g){return this.channel.call("dispatchKeybinding",[p,g])}click(p,g,i,b){return this.channel.call("click",[p,g,i,b])}doubleClick(p,g){return this.channel.call("doubleClick",[p,g])}setValue(p,g,i){return this.channel.call("setValue",[p,g,i])}getTitle(p){return this.channel.call("getTitle",[p])}isActiveElement(p,g){return this.channel.call("isActiveElement",[p,g])}getElements(p,g,i){return this.channel.call("getElements",[p,g,i])}getElementXY(p,g,i,b){return this.channel.call("getElementXY",[p,g,i,b])}typeInEditor(p,g,i){return this.channel.call("typeInEditor",[p,g,i])}getTerminalBuffer(p,g){return this.channel.call("getTerminalBuffer",[p,g])}writeInTerminal(p,g,i){return this.channel.call("writeInTerminal",[p,g,i])}getLocaleInfo(p){return this.channel.call("getLocaleInfo",p)}getLocalizedStrings(p){return this.channel.call("getLocalizedStrings",p)}}e.DriverChannelClient=D;class S{constructor(p){this.registry=p}listen(p,g){throw new Error(`Event not found: ${g}`)}call(p,g,i){switch(g){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${g}`)}}e.WindowDriverRegistryChannel=S;async function E(n){const p=await(0,m.connect)(n,"driverClient"),g=p.getChannel("driver"),i=new D(g);return{client:p,driver:i}}e.connect=E}),define(J[24],Z([0,1,8,47,4,48,160,56]),function(V,e,m,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,D.refineServiceDecorator)(S.IEnvironmentService);class p extends E.NativeEnvironmentService{get cachedLanguagesPath(){return(0,m.join)(this.userDataPath,"clp")}get backupHome(){return(0,m.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,m.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,m.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}}he([M.memoize],p.prototype,"cachedLanguagesPath",null),he([M.memoize],p.prototype,"backupHome",null),he([M.memoize],p.prototype,"backupWorkspacesPath",null),he([M.memoize],p.prototype,"mainIPCHandle",null),he([M.memoize],p.prototype,"mainLockfile",null),he([M.memoize],p.prototype,"sandbox",null),he([M.memoize],p.prototype,"driverVerbose",null),he([M.memoize],p.prototype,"disableUpdates",null),he([M.memoize],p.prototype,"disableKeytar",null),he([M.memoize],p.prototype,"codeCachePath",null),e.EnvironmentMainService=p}),define(J[219],Z([0,1,29,58,8,3,18,52,24,21,19,6,27,7,30,10,15]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let I=class{constructor(h,a,u){this.configurationService=a,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,s)=>(0,d.isEqual)(t,s,!S.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await E.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let a=[];try{Array.isArray(h.rootURIWorkspaces)&&(a=h.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:y.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(a);let u=[];try{Array.isArray(h.folderURIWorkspaces)&&(u=h.folderURIWorkspaces.map(t=>y.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==i.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===i.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||i.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,a){this.workspaces.some(t=>h.workspace.id===t.workspace.id)||(this.workspaces.push(h),this.saveSync());const u=this.getBackupPath(h.workspace.id);return a&&this.moveBackupFolderSync(u,a),u}moveBackupFolderSync(h,a){if(m.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),m.existsSync(a))try{m.renameSync(a,h)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(h){const a=h.id,u=this.workspaces.findIndex(t=>t.workspace.id===a);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(a=>this.backupUriComparer.isEqual(h,a))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const a=this.folders.findIndex(u=>this.backupUriComparer.isEqual(h,u));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(h,a){const u=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:a}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(h){const a=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,h));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(h){return(0,D.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const a=new Set,u=[];for(let t of h){const s=t.workspace;if(!(0,k.isWorkspaceIdentifier)(s))return[];if(!a.has(s.id)){a.add(s.id);const r=this.getBackupPath(s.id);await this.doHasBackups(r)?s.configPath.scheme!==v.Schemas.file||await E.Promises.exists(s.configPath.fsPath)?u.push(t):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return u}async validateFolders(h){if(!Array.isArray(h))return[];const a=[],u=new Set;for(let t of h){const s=this.backupUriComparer.getComparisonKey(t);if(!u.has(s)){u.add(s);const r=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(r)?t.scheme!==v.Schemas.file||await E.Promises.exists(t.fsPath)?a.push(t):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return a}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const a=[],u=new Set;for(let t of h){const s=t.backupFolder;if(typeof s!="string")return[];if(!u.has(s)){u.add(s);const r=this.getBackupPath(s);await this.doHasBackups(r)?a.push(t):await this.deleteStaleBackup(r)}}return a}async deleteStaleBackup(h){try{await E.Promises.exists(h)&&await E.Promises.rm(h,E.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(h){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{await E.Promises.rename(h,u)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(h){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{m.renameSync(h,u)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const h=[];for(const a of this.workspaces)await this.hasBackups(a)&&h.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&h.push(a);return h}hasBackups(h){let a;return y.URI.isUri(h)?a=this.getBackupPath(this.getFolderHash(h)):(0,n.isWorkspaceBackupInfo)(h)?a=this.getBackupPath(h.workspace.id):a=h.backupFolder,this.doHasBackups(a)}async doHasBackups(h){try{const a=await E.Promises.readdir(h);for(const u of a)try{if((await E.Promises.readdir((0,D.join)(h,u))).length>0)return!0}catch(t){}}catch(a){}return!1}saveSync(){try{(0,E.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await E.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let a;return h.scheme===v.Schemas.file?a=S.isLinux?h.fsPath:h.fsPath.toLowerCase():a=h.toString().toLowerCase(),(0,M.createHash)("md5").update(a).digest("hex")}};I=he([ee(0,p.IEnvironmentMainService),ee(1,g.IConfigurationService),ee(2,b.ILogService)],I),e.BackupMainService=I}),define(J[220],Z([0,1,59,56]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,S,E,n){const p=i=>n(i,void 0),g=m.createConnection({host:D,port:S},()=>{g.removeListener("error",p);const i=Buffer.alloc(16);for(let d=0;d<16;d++)i[d]=Math.round(Math.random()*256);const b=i.toString("base64");let k=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${S}/?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${b}`];g.write(k.join(`\r
`)+`\r
\r
`);const y=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(g.off("data",y),n(void 0,new M.NodeSocket(g)))};g.on("data",y)});g.once("error",p)}}}),define(J[221],Z([0,1,59,9,2,115,21,6,20,191,94,220,74]),function(V,e,m,M,D,S,E,n,p,g,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function y(I,c,h,a,u){return new d(I,c,h,a,u).waitForReady()}class d extends D.Disposable{constructor(c,h,a,u,t){super();this.defaultTunnelHost=h,this.suggestedLocalPort=t,this.public=!1,this._socketsDispose=new Map,this._options=c,this._server=m.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=u,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let c=await(0,S.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(c){c.pause();const h=await(0,g.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),a=h.getSocket().socket,u=h.readEntireBuffer();h.dispose(),u.byteLength>0&&c.write(u.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),a.end()}),c.on("close",()=>a.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),a.destroy()}),a.on("end",()=>c.end()),a.on("close",()=>c.end()),a.on("error",()=>{c.destroy()}),c.pipe(a),a.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),a.end()})}}let v=class extends i.AbstractTunnelService{constructor(c,h,a,u,t){super(h);this.socketFactory=c,this.signService=a,this.productService=u,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,h,a,u,t,s,r){const o=this.getTunnelFromMap(h,a);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,a,u,t,s,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${a} on local port ${u}.`);const l={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},w=y(l,this.defaultTunnelHost,h,a,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,a,w),w}}};v=he([ee(1,n.ILogService),ee(2,k.ISignService),ee(3,p.IProductService),ee(4,E.IConfigurationService)],v),e.BaseTunnelService=v;let P=class extends v{constructor(c,h,a,u){super(b.nodeSocketFactory,c,h,a,u)}};P=he([ee(0,n.ILogService),ee(1,k.ISignService),ee(2,p.IProductService),ee(3,E.IConfigurationService)],P),e.TunnelService=P}),define(J[222],Z([0,1,217,193,2,13,16,192,21,6,17,48,89]),function(V,e,m,M,D,S,E,n,p,g,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends D.Disposable{constructor(v,P,I){super();this.environmentService=P,this.logService=I,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,P){this.logService.trace("RequestService#request",v.url);const{proxyUrl:I,strictSSL:c}=this,h={...process.env,...await(0,k.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},a=v.agent?v.agent:await(0,n.getProxyAgent)(v.url||"",h,{proxyUrl:I,strictSSL:c});return v.agent=a,v.strictSSL=c,this.authorization&&(v.headers={...v.headers||{},"Proxy-Authorization":this.authorization}),this._request(v,P)}async getNodeRequest(v){return((0,M.parse)(v.url).protocol==="https:"?await new Promise((c,h)=>{V(["https"],c,h)}):await new Promise((c,h)=>{V(["http"],c,h)})).request}_request(v,P){return new Promise(async(I,c)=>{let h;const a=(0,M.parse)(v.url),u=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),t={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,S.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(t.auth=v.user+":"+v.password),h=u(t,s=>{const r=(0,S.isNumber)(v.followRedirects)?v.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&r>0&&s.headers.location)this._request({...v,url:s.headers.location,followRedirects:r-1},P).then(I,c);else{let o=s;s.headers["content-encoding"]==="gzip"&&(o=s.pipe((0,m.createGunzip)())),I({res:s,stream:(0,i.streamToBufferReadableStream)(o)})}}),h.on("error",c),v.timeout&&h.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&h.write(v.data),h.end(),P.onCancellationRequested(()=>{h.abort(),c((0,E.canceled)())})})}async resolveProxy(v){}};y=he([ee(0,p.IConfigurationService),ee(1,b.INativeEnvironmentService),ee(2,g.ILogService)],y),e.RequestService=y}),define(J[223],Z([0,1,222,14]),function(V,e,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(E){return M.net.request}class S extends m.RequestService{request(n,p){return super.request({...n||{},getRawRequest:D},p)}}e.RequestMainService=S}),define(J[224],Z([0,1,49,14,24,9,6,22,60,10,3,2,83,13,5,55]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let P=class extends b.Disposable{constructor(c,h,a,u,t,s,r){super();this.machineId=c,this.userEnv=h,this.environmentMainService=a,this.lifecycleMainService=u,this.logService=t,this.themeMainService=s,this.protocolMainService=r,this.firstWindowConnectionBarrier=new S.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new d.Emitter),this.onDidError=d.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),M.ipcMain.on("vscode:createSharedProcessMessageChannel",async(c,h)=>this.onWindowConnection(c,h))}async onWindowConnection(c,h){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(c.sender.isDestroyed())return a.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",h,[a])}onWillShutdown(){const c=this.window;!c||(!c.isDestroyed()&&!c.webContents.isDestroyed()&&c.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch(h){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>M.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>M.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new M.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`],v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(g.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,h)=>this._onDidError.fire({type:2,details:h})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,h,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:h}})))}async connect(){await this.whenIpcReady;const c=(0,y.assertIsDefined)(this.window);return(0,k.connect)(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};P=he([ee(2,D.IEnvironmentMainService),ee(3,n.ILifecycleMainService),ee(4,E.ILogService),ee(5,p.IThemeMainService),ee(6,v.IProtocolMainService)],P),e.SharedProcess=P}),define(J[225],Z([0,1,7,8,13,6,24,9,19,17]),function(V,e,m,M,D,S,E,n,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(y,d,v){this.storagePath=y,this.logService=d,this.fileService=v,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new n.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,d){const v=this.storage[y];return(0,D.isUndefinedOrNull)(v)?d:v}setItem(y,d){this.setItems([{key:y,data:d}])}setItems(y){let d=!1;for(const{key:v,data:P}of y)this.storage[v]!==P&&((0,D.isUndefinedOrNull)(P)?(0,D.isUndefined)(this.storage[v])||(this.storage[v]=void 0,d=!0):(this.storage[v]=P,d=!0));d&&this.save()}removeItem(y){(0,D.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,g.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let b=class yt{constructor(y,d,v){this.fileStorage=new i(m.URI.file((0,M.join)(y.userDataPath,yt.STATE_FILE)),d,v)}async init(){return this.fileStorage.init()}getItem(y,d){return this.fileStorage.getItem(y,d)}setItem(y,d){this.fileStorage.setItem(y,d)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};b.STATE_FILE="storage.json",b=he([ee(0,E.IEnvironmentMainService),ee(1,S.ILogService),ee(2,p.IFileService)],b),e.StateMainService=b}),define(J[75],Z([0,1,5,9,21,22,20,42,24,6,51,25]),function(V,e,m,M,D,S,E,n,p,g,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function k(d,v,P){return`${P.updateUrl}/api/update/${d}/${v}/${P.commit}`}e.createUpdateURL=k;let y=class{constructor(v,P,I,c,h,a){this.lifecycleMainService=v,this.configurationService=P,this.environmentMainService=I,this.requestService=c,this.logService=h,this.productService=a,this._state=n.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const v=(0,D.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),P=this.getProductQuality(v);if(!P){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(P),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),v==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,I=>this.logService.error(I))}getProductQuality(v){return v==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(v=60*60*1e3){return(0,M.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(v){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},b.CancellationToken.None).then(v=>v.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};y=he([ee(0,S.ILifecycleMainService),ee(1,D.IConfigurationService),ee(2,p.IEnvironmentMainService),ee(3,i.IRequestService),ee(4,g.ILogService),ee(5,E.IProductService)],y),e.AbstractUpdateService=y}),define(J[226],Z([0,1,14,2,5,47,21,22,42,32,24,6,75,51,20]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=class extends k.AbstractUpdateService{constructor(I,c,h,a,u,t,s){super(I,c,a,u,t,s);this.telemetryService=h,this.disposables=new M.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(m.autoUpdater,"error",(I,c)=>c)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(m.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(m.autoUpdater,"update-available",(I,c,h)=>({url:c,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(m.autoUpdater,"update-downloaded",(I,c,h,a)=>({releaseNotes:c,version:h,productVersion:h,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(I){this.logService.error("UpdateService error:",I);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?I:void 0;this.setState(p.State.Idle(1,h))}buildUpdateFeedUrl(I){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,k.createUpdateURL)(c,I,this.productService);try{m.autoUpdater.setFeedURL({url:h})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return h}doCheckForUpdates(I){this.setState(p.State.CheckingForUpdates(I)),m.autoUpdater.checkForUpdates()}onUpdateAvailable(I){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(I))}onUpdateDownloaded(I){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:I.version}),this.setState(p.State.Ready(I)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),m.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([S.memoize],v.prototype,"onRawError",null),he([S.memoize],v.prototype,"onRawUpdateNotAvailable",null),he([S.memoize],v.prototype,"onRawUpdateAvailable",null),he([S.memoize],v.prototype,"onRawUpdateDownloaded",null),v=he([ee(0,n.ILifecycleMainService),ee(1,E.IConfigurationService),ee(2,g.ITelemetryService),ee(3,i.IEnvironmentMainService),ee(4,y.IRequestService),ee(5,b.ILogService),ee(6,d.IProductService)],v),e.DarwinUpdateService=v}),define(J[227],Z([0,1,5,9,22,42,24,6,8,29,41,32]),function(V,e,m,M,D,S,E,n,p,g,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let k=class{constructor(v,P,I){if(this.lifecycleMainService=v,this.logService=I,this._state=S.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,P.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}scheduleCheckForUpdates(v=60*60*1e3){return(0,M.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(v){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};k=he([ee(0,D.ILifecycleMainService),ee(1,E.IEnvironmentMainService),ee(2,n.ILogService)],k);let y=class extends k{constructor(v,P,I,c,h,a){super(I,c,h);this.snap=v,this.snapRevision=P,this.telemetryService=a;const u=(0,g.watch)(p.dirname(this.snap)),t=m.Event.fromNodeEventEmitter(u,"change",(l,w)=>w),s=m.Event.filter(t,l=>l==="current"),o=m.Event.debounce(s,(l,w)=>w,2e3)(()=>this.checkForUpdates(!1));I.onWillShutdown(()=>{o.dispose(),u.close()})}doCheckForUpdates(){this.setState(S.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(v=>{v?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2)))},v=>{this.logService.error(v),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2,v.message||v))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+p.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const v=await new Promise((I,c)=>(0,g.realpath)(`${p.dirname(this.snap)}/current`,(h,a)=>h?c(h):I(a))),P=p.basename(v);return this.snapRevision!==P}isLatestVersion(){return this.isUpdateAvailable().then(void 0,v=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=he([ee(2,D.ILifecycleMainService),ee(3,E.IEnvironmentMainService),ee(4,n.ILogService),ee(5,b.ITelemetryService)],y),e.SnapUpdateService=y}),define(J[45],Z([0,1,27,24,8,18,29,3,5,6,100,40,10,2,15,4,153,20,14,13,52,53,99,31]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P,I,c,h,a,u,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,v.createDecorator)("workspacesManagementMainService");let r=class extends y.Disposable{constructor(l,w,f,L,R){super();this.environmentMainService=l,this.logService=w,this.backupMainService=f,this.dialogMainService=L,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new p.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new p.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(l){return this.doResolveLocalWorkspace(l,w=>(0,E.readFileSync)(w,"utf8"))}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,w=>S.Promises.readFile(w,"utf8"))}doResolveLocalWorkspace(l,w){if(!!this.isWorkspacePath(l)&&l.scheme===k.Schemas.file)try{const f=w(l.fsPath);return f instanceof Promise?f.then(L=>this.doResolveWorkspace(l,L),L=>{}):this.doResolveWorkspace(l,f)}catch{return}}isWorkspacePath(l){return(0,m.isUntitledWorkspace)(l,this.environmentMainService)||(0,m.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,w){try{const f=this.doParseStoredWorkspace(l,w),L=(0,i.getWorkspaceIdentifier)(l);return{id:L.id,configPath:L.configPath,folders:(0,m.toWorkspaceFolders)(f.folders,L.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:f.remoteAuthority,transient:f.transient}}catch(f){this.logService.warn(f.toString())}}doParseStoredWorkspace(l,w){const f=(0,b.parse)(w);if(f&&Array.isArray(f.folders))f.folders=f.folders.filter(L=>(0,m.isStoredWorkspaceFolder)(L));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return f}async createUntitledWorkspace(l,w){const{workspace:f,storedWorkspace:L}=this.newUntitledWorkspace(l,w),R=f.configPath.fsPath;return await S.Promises.mkdir((0,D.dirname)(R),{recursive:!0}),await S.Promises.writeFile(R,JSON.stringify(L,null,"	")),f}createUntitledWorkspaceSync(l,w){const{workspace:f,storedWorkspace:L}=this.newUntitledWorkspace(l,w),R=f.configPath.fsPath;return(0,E.mkdirSync)((0,D.dirname)(R),{recursive:!0}),(0,S.writeFileSync)(R,JSON.stringify(L,null,"	")),f}newUntitledWorkspace(l=[],w){const f=(Date.now()+Math.round(Math.random()*1e3)).toString(),L=(0,d.joinPath)(this.untitledWorkspacesHome,f),R=(0,d.joinPath)(L,m.UNTITLED_WORKSPACE_NAME),_=[];for(const C of l)_.push((0,m.getStoredWorkspaceFolder)(C.uri,!0,C.name,L,!n.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(R),storedWorkspace:{folders:_,remoteAuthority:w}}}async getWorkspaceIdentifier(l){return(0,i.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,m.isUntitledWorkspace)(l.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(l){!this.isUntitledWorkspace(l)||(this.doDeleteUntitledWorkspaceSync(l),this._onDidDeleteUntitledWorkspace.fire(l))}async deleteUntitledWorkspace(l){this.deleteUntitledWorkspaceSync(l)}doDeleteUntitledWorkspaceSync(l){const w=(0,d.originalFSPath)(l.configPath);try{(0,S.rimrafSync)((0,D.dirname)(w));const f=(0,D.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);(0,E.existsSync)(f)&&(0,S.writeFileSync)((0,D.join)(f,"obsolete"),"")}catch(f){this.logService.warn(`Unable to delete untitled workspace ${w} (${f}).`)}}getUntitledWorkspacesSync(){const l=[];try{const w=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(f=>(0,d.joinPath)(this.untitledWorkspacesHome,f,m.UNTITLED_WORKSPACE_NAME));for(const f of w){const L=(0,i.getWorkspaceIdentifier)(f),R=this.resolveLocalWorkspaceSync(f);R?l.push({workspace:L,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(L)}}catch(w){w.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${w}).`)}return l}async enterWorkspace(l,w,f){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,w,f))return;const R=this.doEnterWorkspace(l,(0,i.getWorkspaceIdentifier)(f));if(!!R)return this._onDidEnterWorkspace.fire({window:l,workspace:R.workspace}),R}async isValidTargetWorkspacePath(l,w,f){if(!f)return!0;if((0,m.isWorkspaceIdentifier)(l.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,f))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(w,f)){const L={title:this.productService.nameLong,type:"info",buttons:[(0,s.mnemonicButtonLabel)((0,P.localize)(0,null))],message:(0,P.localize)(1,null,(0,d.basename)(f)),detail:(0,P.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(L,(0,h.withNullAsUndefined)(c.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(l,w){if(!l.config)return;l.focus();let f;return l.config.extensionDevelopmentPath||(f=this.backupMainService.registerWorkspaceBackupSync({workspace:w,remoteAuthority:l.remoteAuthority},l.config.backupPath)),(0,m.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&this.deleteUntitledWorkspaceSync(l.openedWorkspace),l.config.workspace=w,l.config.backupPath=f,{workspace:w,backupPath:f}}};r=he([ee(0,M.IEnvironmentMainService),ee(1,g.ILogService),ee(2,a.IBackupMainService),ee(3,u.IDialogMainService),ee(4,I.IProductService)],r),e.WorkspacesManagementMainService=r}),define(J[101],Z([0,1,6,97,3,4,35,18,45,21,7,14,36,54,25,27,13]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,S.createDecorator)(e.ID);let I=class{constructor(h,a,u,t,s){this.logService=h,this.windowsMainService=a,this.urlService=u,this.workspacesManagementMainService=t,this.configurationService=s}async start(h,a){this.logService.trace("Received data from other instance: ",h,a),D.isMacintosh&&b.app.focus({steal:!0});const u=this.parseOpenUrl(h);if(u.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:s,url:r}of u)this.urlService.open(s,{originalUrl:r})})}else return this.startOpenWindow(h,a)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,k.coalesce)(h._urls.map(a=>{try{return{uri:i.URI.parse(a),url:a}}catch(u){return null}})):[]}async startOpenWindow(h,a){const u=(0,y.isLaunchedFromCli)(a)?0:4;let t=[];const s=h.wait&&h.waitMarkerFilePath?i.URI.file(h.waitMarkerFilePath):void 0,r=h.remote||void 0;if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,{context:u,cli:h,userEnv:a,waitMarkerFileURI:s,remoteAuthority:r});else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let o=!1;if(h["new-window"]||h["unity-launch"])o=!0;else if(h["reuse-window"])o=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!D.isMacintosh}if(o)t=this.windowsMainService.open({context:u,cli:h,userEnv:a,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:s,remoteAuthority:r});else{const l=this.windowsMainService.getLastActiveWindow();l?(l.focus(),t=[l]):t=this.windowsMainService.open({context:u,cli:h,forceEmpty:!0,remoteAuthority:r})}}else t=this.windowsMainService.open({context:u,cli:h,userEnv:a,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],waitMarkerFileURI:s,gotoLineMode:h.goto,remoteAuthority:r});if(s&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,n.whenDeleted)(s.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return b.BrowserWindow.getAllWindows().forEach(a=>{const u=this.windowsMainService.getWindowById(a.id);u?h.push(this.codeWindowToInfo(u)):h.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!b.app.accessibilitySupportEnabled,gpuFeatureStatus:b.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(t=>new Promise(s=>{const r=t.remoteAuthority;if(r){const o=`vscode:getDiagnosticInfoResponse${t.id}`,l={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:o,args:l}),b.ipcMain.once(o,(w,f)=>{f||s({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),s(f)}),setTimeout(()=>{s({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else s(void 0)})))).filter(t=>!!t)}getFolderURIs(h){const a=[],u=h.openedWorkspace;if((0,v.isSingleFolderWorkspaceIdentifier)(u))a.push(u.uri);else if((0,v.isWorkspaceIdentifier)(u)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);t&&t.folders.forEach(r=>{a.push(r.uri)})}return a}codeWindowToInfo(h){const a=this.getFolderURIs(h),u=(0,P.assertIsDefined)(h.win);return this.browserWindowToInfo(u,a,h.remoteAuthority)}browserWindowToInfo(h,a=[],u){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:a,remoteAuthority:u}}};I=he([ee(0,m.ILogService),ee(1,E.IWindowsMainService),ee(2,M.IURLService),ee(3,p.IWorkspacesManagementMainService),ee(4,g.IConfigurationService)],I),e.LaunchMainService=I}),define(J[46],Z([0,1,41,114,145,80,5,35,14,22,3,24,53,18,7,32,4,26,66,6,8,20,47,2,60,31,27,10,45]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P,I,c,h,a,u,t,s,r,o,l,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,P.createDecorator)("nativeHostMainService");let L=class lt extends s.Disposable{constructor(_,C,K,x,ie,G,Q,U,$,F){super();this.sharedProcess=_,this.windowsMainService=C,this.dialogMainService=K,this.lifecycleMainService=x,this.environmentMainService=ie,this.telemetryService=G,this.logService=Q,this.productService=U,this.themeMainService=$,this.workspacesManagementMainService=F,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,N=>N.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(p.app,"browser-window-maximize",(N,B)=>B.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(p.app,"browser-window-unmaximize",(N,B)=>B.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(p.app,"browser-window-blur",(N,B)=>B.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),N=>!!N),N=>N.id),E.Event.filter(E.Event.fromNodeEventEmitter(p.app,"browser-window-focus",(N,B)=>B.id),N=>!!this.windowsMainService.getWindowById(N))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(p.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new E.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(p.screen,"display-metrics-changed",(N,B,W)=>W),N=>!(Array.isArray(N)&&N.length===1&&N[0]==="workArea")),E.Event.fromNodeEventEmitter(p.screen,"display-added"),E.Event.fromNodeEventEmitter(p.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){p.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors,dark:p.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(C=>({id:C.id,workspace:C.openedWorkspace,title:C.win?.getTitle()??"",filename:C.getRepresentedFilename(),dirty:C.isDocumentEdited()}))}async getWindowCount(_){return this.windowsMainService.getWindowCount()}async getActiveWindowId(_){const C=p.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(C)return C.id}openWindow(_,C,K){return Array.isArray(C)?this.doOpenWindow(_,C,K):this.doOpenEmptyWindow(_,C)}async doOpenWindow(_,C,K=Object.create(null)){C.length>0&&this.windowsMainService.open({context:5,contextWindowId:_,urisToOpen:C,cli:this.environmentMainService.args,forceNewWindow:K.forceNewWindow,forceReuseWindow:K.forceReuseWindow,preferNewWindow:K.preferNewWindow,diffMode:K.diffMode,addMode:K.addMode,gotoLineMode:K.gotoLineMode,noRecentEntry:K.noRecentEntry,waitMarkerFileURI:K.waitMarkerFileURI,remoteAuthority:K.remoteAuthority||void 0})}async doOpenEmptyWindow(_,C){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:_},C)}async toggleFullScreen(_){const C=this.windowById(_);C&&C.toggleFullScreen()}async handleTitleDoubleClick(_){const C=this.windowById(_);C&&C.handleTitleDoubleClick()}async isMaximized(_){const C=this.windowById(_);return C?.win?C.win.isMaximized():!1}async maximizeWindow(_){const C=this.windowById(_);C?.win&&C.win.maximize()}async unmaximizeWindow(_){const C=this.windowById(_);C?.win&&C.win.unmaximize()}async minimizeWindow(_){const C=this.windowById(_);C?.win&&C.win.minimize()}async focusWindow(_,C){C&&typeof C.windowId=="number"&&(_=C.windowId);const K=this.windowById(_);K&&K.focus({force:C?.force??!1})}async setMinimumSize(_,C,K){const x=this.windowById(_);if(x?.win){const[ie,G]=x.win.getSize(),[Q,U]=x.win.getMinimumSize(),[$,F]=[C??Q,K??U],[N,B]=[Math.max(ie,$),Math.max(G,F)];(Q!==$||U!==F)&&x.win.setMinimumSize($,F),(ie!==N||G!==B)&&x.win.setSize(N,B)}}async saveWindowSplash(_,C){this.themeMainService.saveWindowSplash(_,C)}async installShellCommand(_){const{source:C,target:K}=await this.getShellCommandLink();try{const{symbolicLink:x}=await y.SymlinkSupport.stat(C);if(x&&!x.dangling){const ie=await(0,S.realpath)(C);if(K===ie)return}await y.Promises.unlink(C)}catch(x){if(x.code!=="ENOENT")throw x}try{await y.Promises.symlink(K,C)}catch(x){if(x.code!=="EACCES"&&x.code!=="ENOENT")throw x;const{response:ie}=await this.showMessageBox(_,{title:this.productService.nameLong,type:"info",message:(0,D.localize)(0,null,this.productService.nameShort),buttons:[(0,o.mnemonicButtonLabel)((0,D.localize)(1,null)),(0,o.mnemonicButtonLabel)((0,D.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ie===0)try{const G=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${K}' '${C}'\\" with administrator privileges"`;await(0,M.promisify)(m.exec)(G)}catch(G){throw new Error((0,D.localize)(3,null,C))}}}async uninstallShellCommand(_){const{source:C}=await this.getShellCommandLink();try{await y.Promises.unlink(C)}catch(K){switch(K.code){case"EACCES":const{response:x}=await this.showMessageBox(_,{title:this.productService.nameLong,type:"info",message:(0,D.localize)(4,null,this.productService.nameShort),buttons:[(0,o.mnemonicButtonLabel)((0,D.localize)(5,null)),(0,o.mnemonicButtonLabel)((0,D.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(x===0)try{const ie=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await(0,M.promisify)(m.exec)(ie)}catch(ie){throw new Error((0,D.localize)(7,null,C))}break;case"ENOENT":break;default:throw K}}}async getShellCommandLink(){const _=(0,a.resolve)(this.environmentMainService.appRoot,"bin","code"),C=`/usr/local/bin/${this.productService.applicationName}`;if(!await y.Promises.exists(_))throw new Error((0,D.localize)(8,null,_));return{source:C,target:_}}async showMessageBox(_,C){return this.dialogMainService.showMessageBox(C,this.toBrowserWindow(_))}async showSaveDialog(_,C){return this.dialogMainService.showSaveDialog(C,this.toBrowserWindow(_))}async showOpenDialog(_,C){return this.dialogMainService.showOpenDialog(C,this.toBrowserWindow(_))}toBrowserWindow(_){const C=this.windowById(_);if(C?.win)return C.win}async pickFileFolderAndOpen(_,C){const K=await this.dialogMainService.pickFileFolder(C);K&&(this.sendPickerTelemetry(K,C.telemetryEventName||"openFileFolder",C.telemetryExtraData),this.doOpenPicked(await Promise.all(K.map(async x=>await y.SymlinkSupport.existsDirectory(x)?{folderUri:d.URI.file(x)}:{fileUri:d.URI.file(x)})),C,_))}async pickFolderAndOpen(_,C){const K=await this.dialogMainService.pickFolder(C);K&&(this.sendPickerTelemetry(K,C.telemetryEventName||"openFolder",C.telemetryExtraData),this.doOpenPicked(K.map(x=>({folderUri:d.URI.file(x)})),C,_))}async pickFileAndOpen(_,C){const K=await this.dialogMainService.pickFile(C);K&&(this.sendPickerTelemetry(K,C.telemetryEventName||"openFile",C.telemetryExtraData),this.doOpenPicked(K.map(x=>({fileUri:d.URI.file(x)})),C,_))}async pickWorkspaceAndOpen(_,C){const K=await this.dialogMainService.pickWorkspace(C);K&&(this.sendPickerTelemetry(K,C.telemetryEventName||"openWorkspace",C.telemetryExtraData),this.doOpenPicked(K.map(x=>({workspaceUri:d.URI.file(x)})),C,_))}doOpenPicked(_,C,K){this.windowsMainService.open({context:3,contextWindowId:K,cli:this.environmentMainService.args,urisToOpen:_,forceNewWindow:C.forceNewWindow})}sendPickerTelemetry(_,C,K){const x=_?_.length:0;this.telemetryService.publicLog(C,{...K,outcome:x?"success":"canceled",numberOfPaths:x})}async showItemInFolder(_,C){p.shell.showItemInFolder(C)}async setRepresentedFilename(_,C){const K=this.windowById(_);K&&K.setRepresentedFilename(C)}async setDocumentEdited(_,C){const K=this.windowById(_);K&&K.setDocumentEdited(C)}async openExternal(_,C){return i.isLinuxSnap?this.safeSnapOpenExternal(C):p.shell.openExternal(C),!0}safeSnapOpenExternal(_){const C=process.env.GDK_PIXBUF_MODULE_FILE,K=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,p.shell.openExternal(_),process.env.GDK_PIXBUF_MODULE_FILE=C,process.env.GDK_PIXBUF_MODULEDIR=K}moveItemToTrash(_,C){return p.shell.trashItem(C)}async isAdmin(){let _;return i.isWindows?_=(await new Promise((C,K)=>{V(["native-is-elevated"],C,K)}))():_=process.getuid()===0,_}async writeElevated(_,C,K,x){const ie=await new Promise((G,Q)=>{V(["sudo-prompt"],G,Q)});return new Promise((G,Q)=>{const U=[`"${this.cliPath}"`];x?.unlock&&U.push("--file-chmod"),U.push("--file-write",`"${C.fsPath}"`,`"${K.fsPath}"`);const $={name:this.productService.nameLong.replace("-",""),icns:i.isMacintosh&&this.environmentMainService.isBuilt?(0,a.join)((0,a.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ie.exec(U.join(" "),$,(F,N,B)=>{N&&this.logService.trace(`[sudo-prompt] received stdout: ${N}`),B&&this.logService.trace(`[sudo-prompt] received stderr: ${B}`),F?Q(F):G(void 0)})})}get cliPath(){return i.isWindows?this.environmentMainService.isBuilt?(0,a.join)((0,a.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,a.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):i.isLinux?this.environmentMainService.isBuilt?(0,a.join)((0,a.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,a.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,a.join)(this.environmentMainService.appRoot,"bin","code"):(0,a.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,I.totalmem)(),freemem:(0,I.freemem)(),loadavg:(0,I.loadavg)()}}async getOSProperties(){return{arch:(0,I.arch)(),platform:(0,I.platform)(),release:(0,I.release)(),type:(0,I.type)(),cpus:(0,I.cpus)()}}async getOSVirtualMachineHint(){return c.virtualMachineHint.value()}async killProcess(_,C,K){process.kill(C,K)}async readClipboardText(_,C){return p.clipboard.readText(C)}async writeClipboardText(_,C,K){return p.clipboard.writeText(C,K)}async readClipboardFindText(_){return p.clipboard.readFindText()}async writeClipboardFindText(_,C){return p.clipboard.writeFindText(C)}async writeClipboardBuffer(_,C,K,x){return p.clipboard.writeBuffer(C,Buffer.from(K),x)}async readClipboardBuffer(_,C){return p.clipboard.readBuffer(C)}async hasClipboard(_,C,K){return p.clipboard.has(C,K)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){p.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){p.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){p.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){p.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){p.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(_,C){const K=this.windowById(_);K&&K.updateTouchBar(C)}async notifyReady(_){const C=this.windowById(_);C&&C.setReady()}async relaunch(_,C){return this.lifecycleMainService.relaunch(C)}async reload(_,C){const K=this.windowById(_);if(K){if((0,l.isWorkspaceIdentifier)(K.openedWorkspace)){const x=K.openedWorkspace.configPath;if(x.scheme===w.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(x))?.transient)return this.openWindow(K.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(K,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(_){this.closeWindowById(_,_)}async closeWindowById(_,C){const K=this.windowById(C);if(K?.win)return K.win.close()}async quit(_){const C=this.windowsMainService.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&C.win?C.win.close():this.lifecycleMainService.quit()}async exit(_,C){await this.lifecycleMainService.kill(C)}async resolveProxy(_,C){const x=this.windowById(_)?.win?.webContents?.session;if(x)return x.resolveProxy(C)}async openDevTools(_,C){const K=this.windowById(_);K?.win&&K.win.webContents.openDevTools(C)}async toggleDevTools(_){const C=this.windowById(_);C?.win&&C.win.webContents.toggleDevTools()}async sendInputEvent(_,C){const K=this.windowById(_);K?.win&&(C.type==="mouseDown"||C.type==="mouseUp")&&K.win.webContents.sendInputEvent(C)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(_,C,K,x){if(!i.isWindows)return;const ie=await new Promise((G,Q)=>{V(["vscode-windows-registry"],G,Q)});try{return ie.GetStringRegKey(C,K,x)}catch{return}}async getPassword(_,C,K){const x=await this.withKeytar(),ie=await x.getPassword(C,K);if(ie)try{let{content:G,hasNextChunk:Q}=JSON.parse(ie);if(!G||!Q)return ie;let U=1;for(;Q;){const $=await x.getPassword(C,`${K}-${U}`),F=JSON.parse($);G+=F.content,Q=F.hasNextChunk,U++}return G}catch{return ie}return ie}async setPassword(_,C,K,x){const ie=await this.withKeytar(),G=3,Q=async(U,$,F)=>{let N=0,B;for(;N<G;)try{await ie.setPassword(U,$,F);return}catch(W){B=W,this.logService.warn("Error attempting to set a password: ",W),N++,await new Promise(z=>setTimeout(z,200))}throw B};if(i.isWindows&&x.length>lt.MAX_PASSWORD_LENGTH){let U=0,$=0,F=!0;for(;F;){const N=x.substring(U,U+lt.PASSWORD_CHUNK_SIZE);U+=lt.PASSWORD_CHUNK_SIZE,F=x.length-U>0;const B={content:N,hasNextChunk:F};await Q(C,$?`${K}-${$}`:K,JSON.stringify(B)),$++}}else await Q(C,K,x);this._onDidChangePassword.fire({service:C,account:K})}async deletePassword(_,C,K){const ie=await(await this.withKeytar()).deletePassword(C,K);return ie&&this._onDidChangePassword.fire({service:C,account:K}),ie}async findPassword(_,C){return(await this.withKeytar()).findPassword(C)}async findCredentials(_,C){return(await this.withKeytar()).findCredentials(C)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((_,C)=>{V(["keytar"],_,C)})}windowById(_){if(typeof _=="number")return this.windowsMainService.getWindowById(_)}};L.MAX_PASSWORD_LENGTH=2500,L.PASSWORD_CHUNK_SIZE=L.MAX_PASSWORD_LENGTH-100,he([t.memoize],L.prototype,"cliPath",null),L=he([ee(1,n.IWindowsMainService),ee(2,k.IDialogMainService),ee(3,g.ILifecycleMainService),ee(4,b.IEnvironmentMainService),ee(5,v.ITelemetryService),ee(6,h.ILogService),ee(7,u.IProductService),ee(8,r.IThemeMainService),ee(9,f.IWorkspacesManagementMainService)],L),e.NativeHostMainService=L}),define(J[228],Z([0,1,2,5,78,14,6,35,46,87,28,20,25]),function(V,e,m,M,D,S,E,n,p,g,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let d=class extends m.Disposable{constructor(P,I,c,h,a){super();this.logService=P,this.windowsMainService=I,this.nativeHostMainService=c,this.encryptionMainService=h,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const P=M.Event.fromNodeEventEmitter(S.app,"login",(I,c,h,a,u)=>({event:I,webContents:c,req:h,authInfo:a,callback:u}));this._register(P(this.onLogin,this))}async onLogin({event:P,authInfo:I,req:c,callback:h}){if(!I.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&c.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}P.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(I);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(a?.username,a?.password)}async resolveProxyCredentials(P){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const I=await this.doResolveProxyCredentials(P);if(I)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),I;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(P){this.logService.trace("auth#doResolveProxyCredentials - enter",P);const I=String((0,D.hash)({scheme:P.scheme,host:P.host,port:P.port}));let c,h;try{const s=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,I);if(s){const r=JSON.parse(await this.encryptionMainService.decrypt(s));c=r.username,h=r.password}}catch(s){this.logService.error(s)}if(this.state!==y.StoredCredentialsUsed&&typeof c=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:c,password:h};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const u={authInfo:P,username:this.sessionCredentials?.username??c,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,i.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",k.CancellationToken.None,u),this.state=y.LoginDialogShown;const t=await new Promise(s=>{const r=async(o,l,w)=>{if(l===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",r),w){const f={username:w.username,password:w.password};try{if(w.remember){const L=await this.encryptionMainService.encrypt(JSON.stringify(f));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,I,L)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,I)}catch(L){this.logService.error(L)}s({username:f.username,password:f.password})}else s(void 0)};a.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=t,t}};d=he([ee(0,E.ILogService),ee(1,n.IWindowsMainService),ee(2,p.INativeHostMainService),ee(3,g.IEncryptionMainService),ee(4,b.IProductService)],d),e.ProxyAuthHandler=d}),define(J[229],Z([0,1,218,155,35,56,2,34,57,176,3,5,77,106,9,22,46]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function I(a){return a<21}let c=class{constructor(u,t,s,r,o){this.windowServer=u,this.options=t,this.windowsMainService=s,this.lifecycleMainService=r,this.nativeHostMainService=o,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new b.Emitter}async registerWindowDriver(u){return this.registeredWindowIds.add(u),this.reloadingWindowIds.delete(u),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(u){this.reloadingWindowIds.add(u)}async getWindowIds(){return this.windowsMainService.getWindows().map(u=>u.id).filter(u=>this.registeredWindowIds.has(u)&&!this.reloadingWindowIds.has(u))}async capturePage(u){await this.whenUnfrozen(u);const t=this.windowsMainService.getWindowById(u);if(!t?.win)throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(u){await this.whenUnfrozen(u);const t=this.windowsMainService.getWindowById(u);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(u),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(u,t){await this.whenUnfrozen(u);const s=y.KeybindingParser.parseUserBinding(t);for(let r of s)await this._dispatchKeybinding(u,r)}async _dispatchKeybinding(u,t){if(t instanceof k.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const s=this.windowsMainService.getWindowById(u);if(!s?.win)throw new Error("Invalid window");const r=s.win.webContents,o=new p.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),w=new g.USLayoutResolvedKeybinding(o.toChord(),i.OS).getElectronAccelerator(),f=[];t.ctrlKey&&f.push("ctrl"),t.metaKey&&f.push("meta"),t.shiftKey&&f.push("shift"),t.altKey&&f.push("alt"),r.sendInputEvent({type:"keyDown",keyCode:w,modifiers:f}),I(t.keyCode)||r.sendInputEvent({type:"char",keyCode:w,modifiers:f}),r.sendInputEvent({type:"keyUp",keyCode:w,modifiers:f}),await(0,d.timeout)(100)}async click(u,t,s,r){await(await this.getWindowDriver(u)).click(t,s,r)}async doubleClick(u,t){await(await this.getWindowDriver(u)).doubleClick(t)}async setValue(u,t,s){await(await this.getWindowDriver(u)).setValue(t,s)}async getTitle(u){return await(await this.getWindowDriver(u)).getTitle()}async isActiveElement(u,t){return await(await this.getWindowDriver(u)).isActiveElement(t)}async getElements(u,t,s){return await(await this.getWindowDriver(u)).getElements(t,s)}async getElementXY(u,t,s,r){return await(await this.getWindowDriver(u)).getElementXY(t,s,r)}async typeInEditor(u,t,s){await(await this.getWindowDriver(u)).typeInEditor(t,s)}async getTerminalBuffer(u,t){return await(await this.getWindowDriver(u)).getTerminalBuffer(t)}async writeInTerminal(u,t,s){await(await this.getWindowDriver(u)).writeInTerminal(t,s)}async getLocaleInfo(u){return await(await this.getWindowDriver(u)).getLocaleInfo()}async getLocalizedStrings(u){return await(await this.getWindowDriver(u)).getLocalizedStrings()}async getWindowDriver(u){await this.whenUnfrozen(u);const t=`window:${u}`,s=new n.StaticRouter(o=>o===t),r=this.windowServer.getChannel("windowDriver",s);return new M.WindowDriverChannelClient(r)}async whenUnfrozen(u){for(;this.reloadingWindowIds.has(u);)await b.Event.toPromise(this.onDidReloadingChange.event)}};c=he([ee(2,D.IWindowsMainService),ee(3,v.ILifecycleMainService),ee(4,P.INativeHostMainService)],c),e.Driver=c;async function h(a,u,t,s){const r=t.driverVerbose,o=s.createInstance(c,a,{verbose:r}),l=new m.WindowDriverRegistryChannel(o);a.registerChannel("windowDriverRegistry",l);const w=await(0,S.serve)(u),f=new m.DriverChannel(o);return w.registerChannel("driver",f),(0,E.combinedDisposable)(w,a)}e.serve=h}),define(J[230],Z([0,1,143,26,49,14,101,70,24,3,6,81,53,4,61,10,46,55,2,31,20]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P,I,c,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let u=class St{constructor(s,r,o,l,w,f,L,R,_){this.userEnv=s,this.environmentMainService=r,this.launchMainService=o,this.logService=l,this.diagnosticsService=w,this.dialogMainService=f,this.nativeHostMainService=L,this.protocolMainService=R,this.productService=_,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){S.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[r,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(r,o);this.safeSend(s,"vscode:issueSystemInfoResponse",l)}),S.ipcMain.on("vscode:listProcesses",async s=>{const r=[];try{const o=await this.launchMainService.getMainProcessId();r.push({name:(0,m.localize)(0,null),rootProcess:await(0,b.listProcesses)(o)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(w=>{(0,n.isRemoteDiagnosticError)(w)?r.push({name:w.hostName,rootProcess:w}):w.processes&&r.push({name:w.hostName,rootProcess:w.processes})})}catch(o){this.logService.error(`Listing processes failed: ${o}`)}this.safeSend(s,"vscode:listProcessesResponse",r)}),S.ipcMain.on("vscode:issueReporterClipboard",async s=>{const r={title:this.productService.nameLong,message:(0,m.localize)(1,null),type:"warning",buttons:[(0,h.mnemonicButtonLabel)((0,m.localize)(2,null)),(0,h.mnemonicButtonLabel)((0,m.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const o=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",o.response===0)}}),S.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const r=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",r)}),S.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,m.localize)(4,null),type:"warning",buttons:[(0,h.mnemonicButtonLabel)((0,m.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,m.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),S.ipcMain.on("vscode:workbenchCommand",(s,r)=>{const{id:o,from:l,args:w}=r;let f;switch(l){case"issueReporter":f=this.issueReporterParentWindow;break;case"processExplorer":f=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}f&&f.webContents.send("vscode:runAction",{id:o,from:l,args:w})}),S.ipcMain.on("vscode:openExternal",(s,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),S.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),S.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),S.ipcMain.on("vscode:windowsInfoRequest",async s=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",r.windows)})}safeSend(s,r,...o){s.sender.isDestroyed()||s.sender.send(r,...o)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new c.DisposableStore,o=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,o,{backgroundColor:s.styles.backgroundColor,title:(0,m.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1}),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,M.type)(),arch:(0,M.arch)(),release:(0,M.release)()},product:D.default}),this.issueReporterWindow.loadURL(v.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new c.DisposableStore,o=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,o,{backgroundColor:s.styles.backgroundColor,title:(0,m.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0}),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:D.default}),this.processExplorerWindow.loadURL(v.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(s,r,o){const l=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:o.title,backgroundColor:o.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`],v8CacheOptions:g.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,d.zoomLevelToZoomFactor)(o.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:o.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,r)}getWindowPosition(s,r,o){let l;const w=S.screen.getAllDisplays();if(w.length===1)l=w[0];else{if(g.isMacintosh){const R=S.screen.getCursorScreenPoint();l=S.screen.getDisplayNearestPoint(R)}!l&&s&&(l=S.screen.getDisplayMatching(s.getBounds())),l||(l=S.screen.getPrimaryDisplay()||w[0])}const f={width:r,height:o},L=l.bounds;return f.x=L.x+L.width/2-f.width/2,f.y=L.y+L.height/2-f.height/2,L.width>0&&L.height>0&&(f.x<L.x&&(f.x=L.x),f.y<L.y&&(f.y=L.y),f.x>L.x+L.width&&(f.x=L.x),f.y>L.y+L.height&&(f.y=L.y),f.width>L.width&&(f.width=L.width),f.height>L.height&&(f.height=L.height)),f}async getPerformanceInfo(){try{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,r)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([ee(1,p.IEnvironmentMainService),ee(2,E.ILaunchMainService),ee(3,i.ILogService),ee(4,n.IDiagnosticsService),ee(5,k.IDialogMainService),ee(6,P.INativeHostMainService),ee(7,I.IProtocolMainService),ee(8,a.IProductService)],u),e.IssueMainService=u}),define(J[231],Z([0,1,20,21,22,42,32,24,6,75,51,25,46]),function(V,e,m,M,D,S,E,n,p,g,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends g.AbstractUpdateService{constructor(v,P,I,c,h,a,u,t){super(v,P,c,h,a,t);this.telemetryService=I,this.nativeHostMainService=u}buildUpdateFeedUrl(v){return(0,g.createUpdateURL)(`linux-${process.arch}`,v,this.productService)}doCheckForUpdates(v){!this.url||(this.setState(S.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},b.CancellationToken.None).then(i.asJson).then(P=>{!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(P))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v});const I=v?P.message||P:void 0;this.setState(S.State.Idle(1,I))}))}async doDownloadUpdate(v){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(S.State.Idle(1))}};y=he([ee(0,D.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,E.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,i.IRequestService),ee(5,p.ILogService),ee(6,k.INativeHostMainService),ee(7,m.IProductService)],y),e.LinuxUpdateService=y}),define(J[232],Z([0,1,29,8,18,47,21,22,20,42,32,24,6,75,51,112,26,41,25,9,19,7,46]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P,I,c,h,a,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(w,f=1e3){for(;!w();)await(0,h.timeout)(f)}let r;function o(){return typeof r=="undefined"&&(r=m.existsSync(M.join(M.dirname(process.execPath),"unins000.exe"))?0:1),r}let l=class extends y.AbstractUpdateService{constructor(f,L,R,_,C,K,x,ie,G){super(f,L,_,C,K,G);this.telemetryService=R,this.fileService=x,this.nativeHostMainService=ie}get cachePath(){const f=M.join((0,P.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return D.Promises.mkdir(f,{recursive:!0}).then(()=>f)}initialize(){super.initialize(),o()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(f){let L="win32";return process.arch!=="ia32"&&(L+=`-${process.arch}`),o()===1?L+="-archive":this.productService.target==="user"&&(L+="-user"),(0,y.createUpdateURL)(L,f,this.productService)}doCheckForUpdates(f){!this.url||(this.setState(g.State.CheckingForUpdates(f)),this.requestService.request({url:this.url},c.CancellationToken.None).then(d.asJson).then(L=>{const R=o();return!L||!L.url||!L.version||!L.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f}),this.setState(g.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(g.State.AvailableForDownload(L)),Promise.resolve(null)):(this.setState(g.State.Downloading(L)),this.cleanup(L.version).then(()=>this.getUpdatePackagePath(L.version).then(_=>D.Promises.exists(_).then(C=>{if(C)return Promise.resolve(_);const K=L.url,x=L.hash,ie=`${_}.tmp`;return this.requestService.request({url:K},c.CancellationToken.None).then(G=>this.fileService.writeFile(u.URI.file(ie),G.stream)).then(x?()=>(0,v.checksum)(ie,L.hash):()=>{}).then(()=>D.Promises.rename(ie,_)).then(()=>_)})).then(_=>{const C=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:_},C&&L.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(g.State.Downloaded(L)):this.setState(g.State.Ready(L))})))}).then(void 0,L=>{this.logService.error(L),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f});const R=f?L.message||L:void 0;this.setState(g.State.Idle(o(),R))}))}async doDownloadUpdate(f){f.update.url&&this.nativeHostMainService.openExternal(void 0,f.update.url),this.setState(g.State.Idle(o()))}async getUpdatePackagePath(f){const L=await this.cachePath;return M.join(L,`CodeSetup-${this.productService.quality}-${f}.exe`)}async cleanup(f=null){const L=f?K=>!new RegExp(`${this.productService.quality}-${f}\\.exe$`).test(K):()=>!0,R=await this.cachePath,C=(await D.Promises.readdir(R)).filter(L).map(async K=>{try{await D.Promises.unlink(M.join(R,K))}catch(x){}});await Promise.all(C)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const f=this.state.update;this.setState(g.State.Updating(f));const L=await this.cachePath;this.availableUpdate.updateFilePath=M.join(L,`CodeSetup-${this.productService.quality}-${f.version}.flag`),await D.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,I.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(g.State.Idle(o()))});const _=`${this.productService.win32MutexName}-ready`,C=await new Promise((K,x)=>{V(["windows-mutex"],K,x)});s(()=>C.isActive(_)).then(()=>this.setState(g.State.Ready(f)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?m.unlinkSync(this.availableUpdate.updateFilePath):(0,I.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return o()}};he([S.memoize],l.prototype,"cachePath",null),l=he([ee(0,n.ILifecycleMainService),ee(1,E.IConfigurationService),ee(2,i.ITelemetryService),ee(3,b.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,k.ILogService),ee(6,a.IFileService),ee(7,t.INativeHostMainService),ee(8,p.IProductService)],l),e.Win32UpdateService=l}),define(J[233],Z([0,1,8,149,72,5,7,14,24,6,21,20,61,2,3,35,27,45,52,199,60,32,53,31,203,22,98,19,10,54,25,55,9]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P,I,c,h,a,u,t,s,r,o,l,w,f,L,R,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var K;(function(ie){ie[ie.NONE=0]="NONE",ie[ie.LOADING=1]="LOADING",ie[ie.NAVIGATING=2]="NAVIGATING",ie[ie.READY=3]="READY"})(K||(K={}));let x=class extends y.Disposable{constructor(G,Q,U,$,F,N,B,W,z,T,A,O,H,Y){super();this.logService=Q,this.environmentMainService=U,this.fileService=$,this.configurationService=N,this.themeMainService=B,this.workspacesManagementMainService=W,this.backupMainService=z,this.telemetryService=T,this.dialogMainService=A,this.lifecycleMainService=O,this.productService=H,this.protocolMainService=Y,this._onWillLoad=this._register(new S.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new S.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new S.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new S.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[q,X]=this.restoreWindowState(G.state);this.windowState=q,this.logService.trace("window#ctor: using window state",q);const ne=this.windowState.mode===0||this.windowState.mode===3,se=this.configurationService.getValue("window"),ae={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!ne,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:d.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,k.zoomLevelToZoomFactor)(se?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};d.browserCodeLoadingCacheStrategy?this.logService.info(`window: using vscode-file:// protocol and V8 cache options: ${d.browserCodeLoadingCacheStrategy}`):this.logService.info("window: vscode-file:// protocol is explicitly disabled"),d.isLinux?ae.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):d.isWindows&&!this.environmentMainService.isBuilt&&(ae.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),d.isMacintosh&&!this.useNativeFullScreen()&&(ae.fullscreenable=!1),d.isMacintosh&&(ae.acceptFirstMouse=!0,se?.clickThroughInactive===!1&&(ae.acceptFirstMouse=!1));const de=d.isMacintosh&&se?.nativeTabs===!0;de&&(ae.tabbingIdentifier=this.productService.nameShort);const re=(0,k.getTitleBarStyle)(this.configurationService)==="custom";if(re&&(ae.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,d.isMacintosh||(ae.frame=!1)),(0,D.mark)("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(ae),(0,D.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),d.isMacintosh&&re&&this._win.setSheetOffset(22),d.isMacintosh&&X&&(!de||n.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ce=>typeof ce=="number")){const ce=this.windowState;this._win.setBounds({width:ce.width,height:ce.height,x:ce.x,y:ce.y})}ne&&((0,D.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,D.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,h.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:q=>F.globalStorage.get(q),store:(q,X)=>F.globalStorage.set(q,X)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(G){d.isMacintosh?this._win.setRepresentedFilename(G):this.representedFilename=G}getRepresentedFilename(){return d.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(G){d.isMacintosh&&this._win.setDocumentEdited(G),this.documentEdited=G}isDocumentEdited(){return d.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(G){d.isMacintosh&&G?.force&&n.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(G=>{if(this.isReady)return G(this);this.whenReadyCallbacks.push(G)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(G=>{function Q(){U.dispose(),$.dispose(),G()}const U=this.onDidClose(()=>Q()),$=this.onWillLoad(()=>Q())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(F,N)=>this.onWindowError(2,N)),this._win.webContents.on("did-fail-load",(F,N,B)=>this.onWindowError(3,{reason:B,exitCode:N})),this._win.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const G=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Q=F=>{for(let N=F;N;N=N.parent)if(N.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},U=F=>F.resourceType==="xhr"||Q(F.frame);this._win.webContents.session.webRequest.onBeforeRequest((F,N)=>{const B=E.URI.parse(F.url);return B.path.endsWith(".svg")&&!(G.has(B.scheme)||B.path.includes(f.Schemas.vscodeRemoteResource))?N({cancel:!U(F)}):N({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((F,N)=>{const B=F.responseHeaders,W=B["content-type"]||B["Content-Type"];if(W&&Array.isArray(W)){const z=E.URI.parse(F.url);if(z.path.endsWith(".svg")&&G.has(z.scheme))return B["Content-Type"]=["image/svg+xml"],N({cancel:!1,responseHeaders:B});if(!z.path.includes(f.Schemas.vscodeRemoteResource)&&W.some(T=>T.toLowerCase().includes("image/svg")))return N({cancel:!U(F)})}return N({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",F=>{this.currentConfig&&(this.currentConfig.maximized=!0),n.app.emit("browser-window-maximize",F,this._win)}),this._win.on("unmaximize",F=>{this.currentConfig&&(this.currentConfig.maximized=!1),n.app.emit("browser-window-unmaximize",F,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",R.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",R.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(F=>this.onDidDeleteUntitledWorkspace(F)));const $=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:$},async(F,N)=>{const B=await this.marketplaceHeadersPromise;N({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,B)})})}async onWindowError(G,Q){switch(G){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${Q?.reason||"<unknown>"}, code: ${Q?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${Q?.reason||"<unknown>"}, code: ${Q?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:G,reason:Q?.reason,code:Q?.exitCode}),G){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(G===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const U=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,s.mnemonicButtonLabel)((0,M.localize)(0,null)),(0,s.mnemonicButtonLabel)((0,M.localize)(1,null)),(0,s.mnemonicButtonLabel)((0,M.localize)(2,null))],message:(0,M.localize)(3,null),detail:(0,M.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;U.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):U.response===2&&this.destroyWindow()}else if(G===2){let U;Q?U=(0,M.localize)(6,null,Q.reason,Q.exitCode??"<unknown>"):U=(0,M.localize)(5,null);const $=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,s.mnemonicButtonLabel)((0,M.localize)(7,null)),(0,s.mnemonicButtonLabel)((0,M.localize)(8,null))],message:U,detail:(0,M.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;$.response===0?this.reload():$.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(G){this.openedWorkspace?.id===G.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const G=this.getMenuBarVisibility();G!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=G,this.setMenuBarVisibility(G));let Q=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;Q?.endsWith("/")&&(Q=Q.substr(0,Q.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Q||"").indexOf("@")===-1&&(Q!==this.currentHttpProxy||U!==this.currentNoProxy)){this.currentHttpProxy=Q,this.currentNoProxy=U;const $=Q||"",F=U?`${U},<local>`:"<local>";this.logService.trace(`Setting proxy to '${$}', bypassing '${F}'`),this._win.webContents.session.setProxy({proxyRules:$,proxyBypassRules:F,pacScript:""})}}addTabbedWindow(G){d.isMacintosh&&G.win&&this._win.addTabbedWindow(G.win)}load(G,Q=Object.create(null)){this.isDocumentEdited()&&(!Q.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Q.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(G,Q),this.readyState===0?this.currentConfig=G:(this.pendingLoadConfig=G,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const U=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new C.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:G.workspace,reason:Q.isReload?3:U?2:1})}updateConfiguration(G,Q){const U=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(U){const $=(0,L.isLaunchedFromCli)(U)&&!(0,L.isLaunchedFromCli)(G.userEnv),F=this.isExtensionDevelopmentHost;($||F)&&(G.userEnv={...U,...G.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(G.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Q.disableExtensions!==void 0&&(G["disable-extensions"]=Q.disableExtensions),G.fullscreen=this.isFullScreen,G.maximized=this._win.isMaximized(),G.partsSplash=this.themeMainService.getWindowSplash(),(0,D.mark)("code/willOpenNewWindow"),G.perfMarks=(0,D.getMarks)(),this.configObjectUrl.update(G)}async reload(G){const Q=Object.assign({},this.currentConfig);Q.workspace=await this.validateWorkspaceBeforeReload(Q),delete Q.filesToOpenOrCreate,delete Q.filesToDiff,delete Q.filesToWait,this.isExtensionDevelopmentHost&&G&&(Q.verbose=G.verbose,Q.debugId=G.debugId,Q["inspect-extensions"]=G["inspect-extensions"],Q["inspect-brk-extensions"]=G["inspect-brk-extensions"],Q["extensions-dir"]=G["extensions-dir"]),Q.isInitialStartup=!1,this.load(Q,{isReload:!0,disableExtensions:G?.["disable-extensions"]})}async validateWorkspaceBeforeReload(G){if((0,P.isWorkspaceIdentifier)(G.workspace)){const Q=G.workspace.configPath;if(Q.scheme===f.Schemas.file&&!await this.fileService.exists(Q))return}else if((0,P.isSingleFolderWorkspaceIdentifier)(G.workspace)){const Q=G.workspace.uri;if(Q.scheme===f.Schemas.file&&!await this.fileService.exists(Q))return}return G.workspace}serializeWindowState(){if(!this._win)return(0,v.defaultWindowState)();if(this.isFullScreen){let U;try{U=n.screen.getDisplayMatching(this.getBounds())}catch(N){}const $=(0,v.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.windowState.width||$.width,height:this.windowState.height||$.height,x:this.windowState.x||0,y:this.windowState.y||0}}const G=Object.create(null);let Q;if(!d.isMacintosh&&this._win.isMaximized()?Q=0:Q=1,Q===0?G.mode=0:G.mode=1,Q===1||Q===0){let U;Q===1?U=this.getBounds():U=this._win.getNormalBounds(),G.x=U.x,G.y=U.y,G.width=U.width,G.height=U.height}return G}restoreWindowState(G){(0,D.mark)("code/willRestoreCodeWindowState");let Q=!1;if(G)try{const U=n.screen.getAllDisplays();Q=U.length>1,G=this.validateWindowState(G,U)}catch(U){this.logService.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,D.mark)("code/didRestoreCodeWindowState"),[G||(0,v.defaultWindowState)(),Q]}validateWindowState(G,Q){if(this.logService.trace(`window#validateWindowState: validating window state on ${Q.length} display(s)`,G),typeof G.x!="number"||typeof G.y!="number"||typeof G.width!="number"||typeof G.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(G.width<=0||G.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Q.length===1){const F=this.getWorkingArea(Q[0]);if(F){let N=function(){!G||typeof G.x!="number"||typeof G.y!="number"||!F||(G.x<F.x&&(G.x=F.x),G.y<F.y&&(G.y=F.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",F),N(),G.width>F.width&&(G.width=F.width),G.height>F.height&&(G.height=F.height),G.x>F.x+F.width-128&&(G.x=F.x+F.width-G.width),G.y>F.y+F.height-128&&(G.y=F.y+F.height-G.height),N()}return G}if(G.display&&G.mode===3){const F=Q.find(N=>N.id===G.display);if(F&&typeof F.bounds?.x=="number"&&typeof F.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const N=(0,v.defaultWindowState)(3);return N.x=F.bounds.x,N.y=F.bounds.y,N}}let U,$;try{U=n.screen.getDisplayMatching({x:G.x,y:G.y,width:G.width,height:G.height}),$=this.getWorkingArea(U)}catch(F){}if(U&&$&&G.x+G.width>$.x&&G.y+G.height>$.y&&G.x<$.x+$.width&&G.y<$.y+$.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",$),G}getWorkingArea(G){if(G.workArea.width>0&&G.workArea.height>0)return G.workArea;if(G.bounds.width>0&&G.bounds.height>0)return G.bounds}getBounds(){const[G,Q]=this._win.getPosition(),[U,$]=this._win.getSize();return{x:G,y:Q,width:U,height:$}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(G){this.useNativeFullScreen()?this.setNativeFullScreen(G):this.setSimpleFullScreen(G),this.sendWhenReady(G?"vscode:enterFullScreen":"vscode:leaveFullScreen",R.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(G){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(G)}setSimpleFullScreen(G){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(G),this._win.webContents.focus()}useNativeFullScreen(){const G=this.configurationService.getValue("window");return!G||typeof G.nativeFullScreen!="boolean"||G.nativeTabs?!0:G.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let G=(0,k.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(G)<0&&(G="classic"),G}setMenuBarVisibility(G,Q=!0){d.isMacintosh||(G==="toggle"&&Q&&this.send("vscode:showInfoMessage",(0,M.localize)(10,null)),G==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(G)}):this.doSetMenuBarVisibility(G))}doSetMenuBarVisibility(G){const Q=this.isFullScreen;switch(G){case"classic":this._win.setMenuBarVisibility(!Q),this._win.autoHideMenuBar=Q;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(G,Q,...U){this.isReady?this.send(G,...U):this.ready().then(()=>{Q.isCancellationRequested||this.send(G,...U)})}send(G,...Q){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${G} for window that is destroyed`);return}this._win.webContents.send(G,...Q)}}updateTouchBar(G){!d.isMacintosh||this.touchBarGroups.forEach((Q,U)=>{const $=G[U];Q.segments=this.createTouchBarGroupSegments($)})}createTouchBar(){if(!!d.isMacintosh){for(let G=0;G<10;G++){const Q=this.createTouchBarGroup();this.touchBarGroups.push(Q)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(G=[]){const Q=this.createTouchBarGroupSegments(G),U=new n.TouchBar.TouchBarSegmentedControl({segments:Q,mode:"buttons",segmentStyle:"automatic",change:$=>{this.sendWhenReady("vscode:runAction",R.CancellationToken.None,{id:U.segments[$].id,from:"touchbar"})}});return U}createTouchBarGroupSegments(G=[]){return G.map(U=>{let $;U.icon&&!r.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===f.Schemas.file&&($=n.nativeImage.createFromPath(E.URI.revive(U.icon.dark).fsPath),$.isEmpty()&&($=void 0));let F;return typeof U.title=="string"?F=U.title:F=U.title.value,{id:U.id,label:$?void 0:F,icon:$}})}dispose(){super.dispose(),this._win=null}};x=he([ee(1,g.ILogService),ee(2,p.IEnvironmentMainService),ee(3,w.IFileService),ee(4,l.IStorageMainService),ee(5,i.IConfigurationService),ee(6,a.IThemeMainService),ee(7,I.IWorkspacesManagementMainService),ee(8,c.IBackupMainService),ee(9,u.ITelemetryService),ee(10,t.IDialogMainService),ee(11,o.ILifecycleMainService),ee(12,b.IProductService),ee(13,_.IProtocolMainService)],x),e.CodeWindow=x}),define(J[62],Z([0,1,152,36,39,14,6,31,5,3,27,45,9,15,7,10,18,22,4,2]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P,I,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,c.createDecorator)("workspacesHistoryMainService");let a=class ze extends h.Disposable{constructor(w,f,L,R){super();this.stateMainService=w,this.logService=f,this.workspacesManagementMainService=L,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new p.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(w=>this.addRecentlyOpened([{workspace:w.workspace}])))}handleWindowsJumpList(){!g.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(w){const f=[],L=[];for(let R of w)if((0,i.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&s(f,R.workspace)===-1&&f.push(R);else if((0,i.isRecentFolder)(R))r(f,R.folderUri)===-1&&f.push(R);else{const _=o(L,R.fileUri)>=0,C=R.fileUri.scheme===v.Schemas.file&&ze.COMMON_FILES_FILTER.indexOf((0,y.basename)(R.fileUri))>=0;!_&&!C&&(L.push(R),g.isWindows&&R.fileUri.scheme===v.Schemas.file&&S.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(f,L),f.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(f.length=ze.MAX_TOTAL_RECENT_ENTRIES),L.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(L.length=ze.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:f,files:L}),this._onDidChangeRecentlyOpened.fire(),g.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(w){const f=C=>{const K=t(C);for(const x of w)if(y.extUriBiasedIgnorePathCase.isEqual(x,K))return!1;return!0},L=this.getRecentlyOpened(),R=L.workspaces.filter(f),_=L.files.filter(f);(R.length!==L.workspaces.length||_.length!==L.files.length)&&(this.saveRecentlyOpened({files:_,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),g.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!g.isMacintosh)return;S.app.clearRecentDocuments();const w=this.getRecentlyOpened(),f=[];let L=0;for(let _=0;_<w.workspaces.length&&L<ze.MAX_MACOS_DOCK_RECENT_WORKSPACES;_++){const C=t(w.workspaces[_]);if(C.scheme===v.Schemas.file){const K=(0,y.originalFSPath)(C);await P.Promises.exists(K)&&(f.push(K),L++)}}const R=[];for(let _=0;_<w.files.length&&L<ze.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;_++){const C=t(w.files[_]);if(C.scheme===v.Schemas.file){const K=(0,y.originalFSPath)(C);if(ze.COMMON_FILES_FILTER.includes((0,y.basename)(C))||f.includes(K))continue;await P.Promises.exists(K)&&(R.push(K),L++)}}R.reverse().forEach(_=>S.app.addRecentDocument(_)),f.reverse().forEach(_=>S.app.addRecentDocument(_))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(w){const f=[],L=[],R=w?.config?.workspace;(0,i.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?f.push({workspace:R}):(0,i.isSingleFolderWorkspaceIdentifier)(R)&&f.push({folderUri:R.uri});const _=w?.config?.filesToOpenOrCreate;if(_)for(let C of _){const K=C.fileUri;K&&o(L,K)===-1&&L.push({fileUri:K})}return this.addEntriesFromStorage(f,L),{workspaces:f,files:L}}addEntriesFromStorage(w,f){let L=this.getRecentlyOpenedFromStorage();for(let R of L.workspaces){let _=(0,i.isRecentFolder)(R)?r(w,R.folderUri):s(w,R.workspace);_>=0?w[_].label=w[_].label||R.label:w.push(R)}for(let R of L.files){let _=o(f,R.fileUri);_>=0?f[_].label=f[_].label||R.label:f.push(R)}}getRecentlyOpenedFromStorage(){const w=this.stateMainService.getItem(ze.recentlyOpenedStorageKey);return(0,i.restoreRecentlyOpened)(w,this.logService)}saveRecentlyOpened(w){const f=(0,i.toStoreData)(w);this.stateMainService.setItem(ze.recentlyOpenedStorageKey,f)}updateWindowsJumpList(){if(!g.isWindows)return;const w=[];if(w.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(0,null),description:(0,m.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let f=[];for(let _ of S.app.getJumpListSettings().removedItems){const C=_.args;if(C){const K=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);K&&f.push(d.URI.parse(K[2]))}}this.removeRecentlyOpened(f);let L=!1;const R=(0,M.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(_=>{const C=(0,i.isRecentWorkspace)(_)?_.workspace:_.folderUri,{title:K,description:x}=this.getWindowsJumpListLabel(C,_.label);let ie;return d.URI.isUri(C)?ie=`--folder-uri "${C.toString()}"`:(L=!0,ie=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:K.substr(0,255),description:x.substr(0,255),program:process.execPath,args:ie,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&w.push({type:"custom",name:L?(0,m.localize)(2,null):(0,m.localize)(3,null),items:R})}w.push({type:"recent"});try{S.app.setJumpList(w)}catch(f){this.logService.warn("updateWindowsJumpList#setJumpList",f)}}getWindowsJumpListLabel(w,f){if(f)return{title:(0,n.splitName)(f).name,description:f};if(d.URI.isUri(w))return{title:(0,y.basename)(w),description:u(w)};if(this.workspacesManagementMainService.isUntitledWorkspace(w))return{title:(0,m.localize)(4,null),description:""};let L=(0,y.basename)(w.configPath);return L.endsWith(i.WORKSPACE_EXTENSION)&&(L=L.substr(0,L.length-i.WORKSPACE_EXTENSION.length-1)),{title:(0,m.localize)(5,null,L),description:u(w.configPath)}}};a.MAX_TOTAL_RECENT_ENTRIES=100,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=he([ee(0,D.IStateMainService),ee(1,E.ILogService),ee(2,b.IWorkspacesManagementMainService),ee(3,I.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a;function u(l){return l.scheme==="file"?(0,n.normalizeDriveLetter)(l.fsPath):l.toString()}function t(l){return(0,i.isRecentFolder)(l)?l.folderUri:(0,i.isRecentFile)(l)?l.fileUri:l.workspace.configPath}function s(l,w){return l.findIndex(f=>(0,i.isRecentWorkspace)(f)&&f.workspace.id===w.id)}function r(l,w){return l.findIndex(f=>(0,i.isRecentFolder)(f)&&y.extUriBiasedIgnorePathCase.isEqual(f.folderUri,w))}function o(l,w){return l.findIndex(f=>y.extUriBiasedIgnorePathCase.isEqual(f.fileUri,w))}}),define(J[234],Z([0,1,144,3,24,14,61,21,32,42,20,9,6,31,35,62,182,7,39,22,46,25]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P,I,c,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let s=class wt{constructor(l,w,f,L,R,_,C,K,x,ie,G){this.updateService=l,this.configurationService=w,this.windowsMainService=f,this.environmentMainService=L,this.telemetryService=R,this.workspacesHistoryMainService=_,this.stateMainService=C,this.lifecycleMainService=K,this.logService=x,this.nativeHostMainService=ie,this.productService=G,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new b.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new b.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,E.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const l=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);l&&(l.menus&&(this.menubarMenus=l.menus),l.keybindings&&(this.keybindings=l.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(_,C,K)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(_,C,K)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(_,C,K)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(K),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(_,C,K)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(K),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const l=this.productService.twitterUrl;l&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(l,"openTwitterUrl"));const w=this.productService.requestFeatureUrl;w&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(w,"openUserVoiceUrl"));const f=this.productService.reportIssueUrl;f&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(f,"openReportIssues"));const L=this.productService.licenseUrl;L&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const _=L.indexOf("?")>0?"&":"?";this.openUrl(`${L}${_}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(L,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&L&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(l=>this.onDidChangeWindowsCount(l)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let l=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;let l=this.configurationService.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,w){this.menubarMenus=l.menus,this.keybindings=l.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,l),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(l){!M.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.closedLastWindow=l.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const l=S.Menu.getApplicationMenu();if(l&&this.oldMenus.push(l),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(M.isMacintosh?new S.Menu:null);return}const w=new S.Menu;let f;if(M.isMacintosh){const R=new S.Menu;f=new S.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),w.append(f)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new S.Menu;R.append(new S.MenuItem({label:this.mnemonicLabel(m.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(m.localize(1,null)),submenu:R});this.setMenuById(R,"File"),w.append(_)}if(this.shouldDrawMenu("Edit")){const R=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(m.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),w.append(_)}if(this.shouldDrawMenu("Selection")){const R=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(m.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),w.append(_)}if(this.shouldDrawMenu("View")){const R=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(m.localize(4,null)),submenu:R});this.setMenuById(R,"View"),w.append(_)}if(this.shouldDrawMenu("Go")){const R=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(m.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),w.append(_)}if(this.shouldDrawMenu("Run")){const R=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(m.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),w.append(_)}if(this.shouldDrawMenu("Terminal")){const R=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(m.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),w.append(_)}let L;if(this.shouldDrawMenu("Window")){const R=new S.Menu;L=new S.MenuItem({label:this.mnemonicLabel(m.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(L&&w.append(L),this.shouldDrawMenu("Help")){const R=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(m.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),w.append(_)}w.items&&w.items.length>0?S.Menu.setApplicationMenu(w):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(l){const w=this.createMenuItem(m.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),f=this.getUpdateMenuItems();let L;if(this.shouldDrawMenu("Preferences")){const Q=new S.Menu;this.setMenuById(Q,"Preferences"),L=new S.MenuItem({label:this.mnemonicLabel(m.localize(11,null)),submenu:Q})}const R=new S.Menu,_=new S.MenuItem({label:m.localize(12,null),role:"services",submenu:R}),C=new S.MenuItem({label:m.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),K=new S.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new S.MenuItem({label:m.localize(15,null),role:"unhide"}),ie=new S.MenuItem(this.likeAction("workbench.action.quit",{label:m.localize(16,null,this.productService.nameLong),click:()=>{const Q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||Q?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),G=[w];G.push(...f),L&&G.push(r(),L),G.push(r(),_,r(),C,K,x,r(),ie),G.forEach(Q=>l.append(Q))}shouldDrawMenu(l){if(!M.isMacintosh&&(0,E.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(l){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[l];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[l]}}setMenu(l,w){w.forEach(f=>{if((0,P.isMenubarMenuItemSeparator)(f))l.append(r());else if((0,P.isMenubarMenuItemSubmenu)(f)){const L=new S.Menu,R=new S.MenuItem({label:this.mnemonicLabel(f.label),submenu:L});this.setMenu(L,f.submenu.items),l.append(R)}else(0,P.isMenubarMenuItemRecentAction)(f)?l.append(this.createOpenRecentMenuItem(f)):(0,P.isMenubarMenuItemAction)(f)&&(f.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(l),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[f.id]?l.append(new S.MenuItem(this.likeAction(f.id,{label:this.mnemonicLabel(f.label),click:this.fallbackMenuHandlers[f.id]}))):l.append(this.createMenuItem(f.label,f.id,!1,f.checked)):l.append(this.createMenuItem(f.label,f.id,f.enabled!==!1,!!f.checked)):l.append(this.createMenuItem(f.label,f.id,f.enabled!==!1,!!f.checked)))})}setMenuById(l,w){this.menubarMenus&&this.menubarMenus[w]&&this.setMenu(l,this.menubarMenus[w].items)}insertCheckForUpdatesItems(l){const w=this.getUpdateMenuItems();w.length&&(w.forEach(f=>l.append(f)),l.append(r()))}createOpenRecentMenuItem(l){const w=I.URI.revive(l.uri),f=l.id,L=f==="openRecentFile"?{fileUri:w}:f==="openRecentWorkspace"?{workspaceUri:w}:{folderUri:w};return new S.MenuItem(this.likeAction(f,{label:l.label,click:(R,_,C)=>{const K=this.isOptionClick(C);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[L],forceNewWindow:K,gotoLineMode:!1,remoteAuthority:l.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([w])}},!1))}isOptionClick(l){return!!(l&&(!M.isMacintosh&&(l.ctrlKey||l.shiftKey)||M.isMacintosh&&(l.metaKey||l.altKey)))}createRoleMenuItem(l,w,f){const L={label:this.mnemonicLabel(l),role:f,enabled:!0};return new S.MenuItem(this.withKeybinding(w,L))}setMacWindowMenu(l){const w=new S.MenuItem({label:m.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),f=new S.MenuItem({label:m.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),L=new S.MenuItem({label:m.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(m.localize(20,null),"workbench.action.switchWindow"),_=[];this.currentEnableNativeTabs&&(_.push(r()),_.push(this.createMenuItem(m.localize(21,null),"workbench.action.newWindowTab")),_.push(this.createRoleMenuItem(m.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),_.push(this.createRoleMenuItem(m.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),_.push(this.createRoleMenuItem(m.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),_.push(this.createRoleMenuItem(m.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[w,f,r(),R,..._,r(),L].forEach(C=>l.append(C))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:m.localize(27,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:m.localize(29,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:m.localize(31,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(l,w,f,L){const R=this.mnemonicLabel(l),_=typeof w=="function"?w:(G,Q,U)=>{const $=G?G.userSettingsLabel:null;let F=w;Array.isArray(w)&&(F=this.isOptionClick(U)?w[1]:w[0]),$&&U.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:$}):this.runActionInRenderer({type:"commandId",commandId:F})},C=typeof f=="boolean"?f:this.windowsMainService.getWindowCount()>0,K=typeof L=="boolean"?L:!1,x={label:R,click:_,enabled:C};K&&(x.type="checkbox",x.checked=K);let ie;return typeof w=="string"?ie=w:Array.isArray(w)&&(ie=w[0]),M.isMacintosh&&(ie==="editor.action.clipboardCutAction"?x.role="cut":ie==="editor.action.clipboardCopyAction"?x.role="copy":ie==="editor.action.clipboardPasteAction"&&(x.role="paste"),ie==="undo"?x.click=this.makeContextAwareClickHandler(_,{inDevTools:G=>G.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):ie==="redo"?x.click=this.makeContextAwareClickHandler(_,{inDevTools:G=>G.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):ie==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(_,{inDevTools:G=>G.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(ie,x))}makeContextAwareClickHandler(l,w){return(f,L,R)=>{const _=S.BrowserWindow.getFocusedWindow();if(!_)return w.inNoWindow();if(_.webContents.isDevToolsFocused()&&_.webContents.devToolsWebContents)return w.inDevTools(_.webContents.devToolsWebContents);l(f,L||_,R)}}runActionInRenderer(l){let w=S.BrowserWindow.getFocusedWindow();if(!w){const L=this.windowsMainService.getLastActiveWindow();L?.isMinimized()&&(w=L.win)}const f=w?this.windowsMainService.getWindowById(w.id):void 0;if(f){if(this.logService.trace("menubar#runActionInRenderer",l),M.isMacintosh&&!this.environmentMainService.isBuilt&&!f.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const L={id:l.commandId,from:"menu"};f.sendWhenReady("vscode:runAction",u.CancellationToken.None,L)}else{const L={userSettingsLabel:l.userSettingsLabel};f.sendWhenReady("vscode:runKeybinding",u.CancellationToken.None,L)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",l)}withKeybinding(l,w){const f=typeof l=="string"?this.keybindings[l]:void 0;if(f?.label){if(f.isNative!==!1)w.accelerator=f.label,w.userSettingsLabel=f.userSettingsLabel;else if(typeof w.label=="string"){const L=w.label.indexOf("[");L>=0?w.label=`${w.label.substr(0,L)} [${f.label}]`:w.label=`${w.label} [${f.label}]`}}else w.accelerator=void 0;return w}likeAction(l,w,f=!w.accelerator){f&&(w=this.withKeybinding(l,w));const L=w.click;return w.click=(R,_,C)=>{this.reportMenuActionTelemetry(l),L&&L(R,_,C)},w}openUrl(l,w){this.nativeHostMainService.openExternal(void 0,l),this.reportMenuActionTelemetry(w)}reportMenuActionTelemetry(l){this.telemetryService.publicLog2("workbenchActionExecuted",{id:l,from:t})}mnemonicLabel(l){return(0,y.mnemonicMenuLabel)(l,!this.currentEnableMenuBarMnemonics)}};s.lastKnownMenubarStorageKey="lastKnownMenubarData",s=he([ee(0,g.IUpdateService),ee(1,n.IConfigurationService),ee(2,d.IWindowsMainService),ee(3,D.IEnvironmentMainService),ee(4,p.ITelemetryService),ee(5,v.IWorkspacesHistoryMainService),ee(6,c.IStateMainService),ee(7,h.ILifecycleMainService),ee(8,k.ILogService),ee(9,a.INativeHostMainService),ee(10,i.IProductService)],s),e.Menubar=s;function r(){return new S.MenuItem({type:"separator"})}}),define(J[235],Z([0,1,234,6,4,22]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,D.createDecorator)("menubarMainService");let E=class{constructor(p,g,i){this.instantiationService=p,this.lifecycleMainService=g,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(m.Menubar)}async updateMenubar(p,g){this.logService.trace("menubarService#updateMenubar",p),(await this.menubar).updateMenu(g,p)}};E=he([ee(0,D.IInstantiationService),ee(1,S.ILifecycleMainService),ee(2,M.ILogService)],E),e.MenubarMainService=E}),define(J[236],Z([0,1,29,26,49,72,8,150,36,52,24,39,233,14,22,21,6,61,99,5,20,62,3,27,4,10,7,15,73,216,45,100,43,2,53,13,30,31,25,19,33,55]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P,I,c,h,a,u,t,s,r,o,l,w,f,L,R,_,C,K,x,ie,G,Q,U,$,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function B(T){return(0,s.isWorkspaceIdentifier)(T?.workspace)}function W(T){return(0,s.isSingleFolderWorkspaceIdentifier)(T?.workspace)}let z=class Xe extends K.Disposable{constructor(A,O,H,Y,q,X,ne,se,ae,de,re,ce,be,ve,Ee){super();this.machineId=A,this.initialUserEnv=O,this.logService=H,this.stateMainService=Y,this.environmentMainService=q,this.lifecycleMainService=X,this.backupMainService=ne,this.configurationService=se,this.workspacesHistoryMainService=ae,this.workspacesManagementMainService=de,this.instantiationService=re,this.dialogMainService=ce,this.fileService=be,this.productService=ve,this.protocolMainService=Ee,this._onDidOpenWindow=this._register(new h.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new h.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new h.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new h.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new L.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const O=new K.DisposableStore;if(O.add(h.Event.any(A.onDidClose,A.onDidDestroy)(()=>O.dispose())),A.config.extensionDevelopmentPath)for(const H of A.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(l.URI.file(H)));A.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(l.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,O){let H=this.environmentMainService.args;const Y=O?.remoteAuthority||void 0,q=!0,X=O?.forceReuseWindow,ne=!X;return this.open({...A,cli:H,forceEmpty:q,forceNewWindow:ne,forceReuseWindow:X,remoteAuthority:Y})}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const O=[],H=[],Y=[],q=[],X=[];let ne,se=0;const ae=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const ve of ae)W(ve)?A.addMode?O.push(ve):H.push(ve):B(ve)?Y.push(ve):ve.fileUri?(ne||(ne={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ve.remoteAuthority}),ne.filesToOpenOrCreate.push(ve)):ve.backupPath?X.push({backupFolder:(0,E.basename)(ve.backupPath),remoteAuthority:ve.remoteAuthority}):se++;A.diffMode&&ne?.filesToOpenOrCreate.length===2&&(ne.filesToDiff=ne.filesToOpenOrCreate,ne.filesToOpenOrCreate=[]),ne&&A.waitMarkerFileURI&&(ne.filesToWait={paths:[...ne.filesToDiff,...ne.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(q.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),Y.push(...q),X.push(...this.backupMainService.getEmptyWindowBackupPaths())):X.length=0;const{windows:de,filesOpenedInWindow:re}=this.doOpen(A,Y,H,X,se,ne,O);if(this.logService.trace(`windowsManager#open used window count ${de.length} (workspacesToOpen: ${Y.length}, foldersToOpen: ${H.length}, emptyToRestore: ${X.length}, emptyToOpen: ${se})`),de.length>1)if(re)re.focus();else{const ve=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let Ee=!0,Te=!0;if(ve){const ye=de.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),Ee=!1,Te=!1)}if(Ee)for(let ye=de.length-1;ye>=0;ye--){const we=de[ye];if(!(we.openedWorkspace&&q.some(Ie=>we.openedWorkspace&&Ie.workspace.id===we.openedWorkspace.id)||we.backupPath&&X.some(Ie=>we.backupPath&&Ie.backupFolder===(0,E.basename)(we.backupPath)))){we.focus(),Te=!1;break}}Te&&de[de.length-1].focus()}const ce=ne&&ne.filesToDiff.length>0;if(!de.some(ve=>ve.isExtensionDevelopmentHost)&&!ce&&!A.noRecentEntry){const ve=[];for(const Ee of ae)B(Ee)&&!Ee.transient?ve.push({label:Ee.label,workspace:Ee.workspace,remoteAuthority:Ee.remoteAuthority}):W(Ee)?ve.push({label:Ee.label,folderUri:Ee.workspace.uri,remoteAuthority:Ee.remoteAuthority}):Ee.fileUri&&ve.push({label:Ee.label,fileUri:Ee.fileUri,remoteAuthority:Ee.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ve)}const be=A.waitMarkerFileURI;return A.context===0&&be&&de.length===1&&de[0]&&(async()=>{await de[0].whenClosedOrLoaded;try{await this.fileService.del(be)}catch(ve){}})(),de}doOpen(A,O,H,Y,q,X,ne){const se=[];let ae;function de(ye,we){se.push(ye),we&&(ae=ye,X=void 0)}let{openFolderInNewWindow:re,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&ne.length>0){const ye=ne[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(ye);we&&de(this.doAddFoldersToExistingWindow(we,ne.map(Ie=>Ie.workspace.uri)))}const be=H.length+O.length+Y.length;if(X&&be===0){const ye=X.filesToOpenOrCreate[0]||X.filesToDiff[0],we=this.getWindows().filter(De=>X&&De.remoteAuthority===X.remoteAuthority);let Ie;ye?.fileUri&&!ce&&((A.context===4||A.context===0||A.context===1)&&(Ie=(0,c.findWindowOnFile)(we,ye.fileUri,De=>De.configPath.scheme===o.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(De.configPath):void 0)),Ie||(Ie=this.doGetLastActiveWindow(we))),Ie?(0,s.isWorkspaceIdentifier)(Ie.openedWorkspace)?O.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):(0,s.isSingleFolderWorkspaceIdentifier)(Ie.openedWorkspace)?H.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):de(this.doOpenFilesInExistingWindow(A,Ie,X),!0):de(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:X,forceNewWindow:!0,remoteAuthority:X.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const ve=(0,p.distinct)(O,ye=>ye.workspace.id);if(ve.length>0){const ye=(0,p.coalesce)(ve.map(we=>(0,c.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.configPath)));if(ye.length>0){const we=ye[0],Ie=X?.remoteAuthority===we.remoteAuthority?X:void 0;de(this.doOpenFilesInExistingWindow(A,we,Ie),!!Ie),re=!0}ve.forEach(we=>{if(ye.some(Oe=>Oe.openedWorkspace&&Oe.openedWorkspace.id===we.workspace.id))return;const Ie=we.remoteAuthority,De=X?.remoteAuthority===Ie?X:void 0;de(this.doOpenFolderOrWorkspace(A,we,re,De),!!De),re=!0})}const Ee=(0,p.distinct)(H,ye=>w.extUriBiasedIgnorePathCase.getComparisonKey(ye.workspace.uri));if(Ee.length>0){const ye=(0,p.coalesce)(Ee.map(we=>(0,c.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.uri)));if(ye.length>0){const we=ye[0],Ie=X?.remoteAuthority===we.remoteAuthority?X:void 0;de(this.doOpenFilesInExistingWindow(A,we,Ie),!!Ie),re=!0}Ee.forEach(we=>{if(ye.some(Oe=>(0,s.isSingleFolderWorkspaceIdentifier)(Oe.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(Oe.openedWorkspace.uri,we.workspace.uri)))return;const Ie=we.remoteAuthority,De=X?.remoteAuthority===Ie?X:void 0;de(this.doOpenFolderOrWorkspace(A,we,re,De),!!De),re=!0})}const Te=(0,p.distinct)(Y,ye=>ye.backupFolder);if(Te.length>0&&Te.forEach(ye=>{const we=ye.remoteAuthority,Ie=X?.remoteAuthority===we?X:void 0;de(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:Ie,remoteAuthority:we,forceNewWindow:!0,forceNewTabbedWindow:A.forceNewTabbedWindow,emptyWindowBackupInfo:ye}),!!Ie),re=!0}),se.length===0||X){X&&!q&&q++;const ye=X?X.remoteAuthority:A.remoteAuthority;for(let we=0;we<q;we++)de(this.doOpenEmpty(A,re,ye,X),!!X),re=!0}return{windows:(0,p.distinct)(se),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(A,O,H){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),O.focus();const Y={filesToOpenOrCreate:H?.filesToOpenOrCreate,filesToDiff:H?.filesToDiff,filesToWait:H?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",U.CancellationToken.None,Y),O}doAddFoldersToExistingWindow(A,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),A.focus();const H={foldersToAdd:O};return A.sendWhenReady("vscode:addFolders",U.CancellationToken.None,H),A}doOpenEmpty(A,O,H,Y,q){return!O&&!q&&typeof A.contextWindowId=="number"&&(q=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:H,forceNewWindow:O,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:q})}doOpenFolderOrWorkspace(A,O,H,Y,q){return!H&&!q&&typeof A.contextWindowId=="number"&&(q=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:H,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:q})}getPathsToOpen(A){let O,H=!1,Y=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(A),H=!0):A.forceEmpty?O=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(O=this.doExtractPathsFromCLI(A.cli),O.length===0&&O.push(Object.create(null)),H=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),Y=!0),!A.addMode&&H){const q=O.filter(X=>W(X));if(q.length>1){const X=q[0].remoteAuthority;if(q.every(ne=>ne.remoteAuthority===X)){const ne=this.workspacesManagementMainService.createUntitledWorkspaceSync(q.map(se=>({uri:se.workspace.uri})));O.push({workspace:ne,remoteAuthority:X}),O=O.filter(se=>!W(se))}}}return A.initialStartup&&!Y&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(q=>B(q)||W(q)||q.backupPath)),O}doExtractPathsFromAPI(A){const O=[],H={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const Y of(0,p.coalesce)(A.urisToOpen||[])){const q=this.resolveOpenable(Y,H);if(q)q.label=Y.label,O.push(q);else{const X=this.resourceFromOpenable(Y),ne={title:this.productService.nameLong,type:"info",buttons:[(0,Q.mnemonicButtonLabel)((0,n.localize)(0,null))],defaultId:0,message:X.scheme===o.Schemas.file?(0,n.localize)(1,null):(0,n.localize)(2,null),detail:X.scheme===o.Schemas.file?(0,n.localize)(3,null,(0,Q.getPathLabel)(X.fsPath,this.environmentMainService)):(0,n.localize)(4,null,X.toString()),noLink:!0};this.dialogMainService.showMessageBox(ne,(0,ie.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(A){const O=[],H={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},Y=A["folder-uri"];if(Y)for(const ne of Y){const se=this.cliArgToUri(ne);if(se){const ae=this.resolveOpenable({folderUri:se},H);ae&&O.push(ae)}}const q=A["file-uri"];if(q)for(const ne of q){const se=this.cliArgToUri(ne);if(se){const ae=this.resolveOpenable((0,s.hasWorkspaceFileExtension)(ne)?{workspaceUri:se}:{fileUri:se},H);ae&&O.push(ae)}}const X=A._;for(const ne of X){const se=H.remoteAuthority?this.doResolvePathRemote(ne,H):this.doResolveFilePath(ne,H);se&&O.push(se)}return O}cliArgToUri(A){try{const O=l.URI.parse(A);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${A}, ${O.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const O=[];A!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const H=[];for(const Y of O)if(Y.workspace){const q=this.resolveOpenable({workspaceUri:Y.workspace.configPath},{remoteAuthority:Y.remoteAuthority,rejectTransientWorkspaces:!0});B(q)&&H.push(q)}else if(Y.folderUri){const q=this.resolveOpenable({folderUri:Y.folderUri},{remoteAuthority:Y.remoteAuthority});W(q)&&H.push(q)}else A!=="folders"&&Y.backupPath&&H.push({backupPath:Y.backupPath,remoteAuthority:Y.remoteAuthority});return H}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,O=Object.create(null)){let H=this.resourceFromOpenable(A);return H.scheme===o.Schemas.file?((0,I.isFileToOpen)(A)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(H.fsPath,O)):this.doResolveRemoteOpenable(A,O)}doResolveRemoteOpenable(A,O){let H=this.resourceFromOpenable(A);const Y=(0,f.getRemoteAuthority)(H)||O.remoteAuthority;if(H=(0,w.removeTrailingPathSeparator)((0,w.normalizePath)(H)),(0,I.isFileToOpen)(A)){if(O.gotoLineMode){const{path:q,line:X,column:ne}=(0,G.parseLineAndColumnAware)(H.path);return{fileUri:H.with({path:q}),selection:X?{startLineNumber:X,startColumn:ne||1}:void 0,remoteAuthority:Y}}return{fileUri:H,remoteAuthority:Y}}else if((0,I.isWorkspaceToOpen)(A))return{workspace:(0,_.getWorkspaceIdentifier)(H),remoteAuthority:Y};return{workspace:(0,_.getSingleFolderWorkspaceIdentifier)(H),remoteAuthority:Y}}resourceFromOpenable(A){return(0,I.isWorkspaceToOpen)(A)?A.workspaceUri:(0,I.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,O){let H,Y;O.gotoLineMode&&({path:A,line:H,column:Y}=(0,G.parseLineAndColumnAware)(A)),A=(0,G.sanitizeFilePath)((0,E.normalize)(A),(0,F.cwd)());try{const q=(0,m.statSync)(A);if(q.isFile()){if(!O.forceOpenWorkspaceAsFile){const X=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.URI.file(A));if(X)return X.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:X.id,configPath:X.configPath},remoteAuthority:X.remoteAuthority,exists:!0,transient:X.transient}}return{fileUri:l.URI.file(A),selection:H?{startLineNumber:H,startColumn:Y||1}:void 0,exists:!0}}else if(q.isDirectory())return{workspace:(0,_.getSingleFolderWorkspaceIdentifier)(l.URI.file(A),q),exists:!0}}catch(q){const X=l.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([X]),O.ignoreFileNotFound)return{fileUri:X,exists:!1}}}doResolvePathRemote(A,O){const H=A.charCodeAt(0),Y=O.remoteAuthority;let q,X;O.gotoLineMode&&({path:A,line:q,column:X}=(0,G.parseLineAndColumnAware)(A)),H!==47&&((0,G.isWindowsDriveLetter)(H)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,G.toSlashes)(A)),A=`/${A}`);const ne=l.URI.from({scheme:o.Schemas.vscodeRemote,authority:Y,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,s.hasWorkspaceFileExtension)(A))return O.forceOpenWorkspaceAsFile?{fileUri:ne,selection:q?{startLineNumber:q,startColumn:X||1}:void 0,remoteAuthority:O.remoteAuthority}:{workspace:(0,_.getWorkspaceIdentifier)(ne),remoteAuthority:Y};if(O.gotoLineMode||E.posix.basename(A).indexOf(".")!==-1)return{fileUri:ne,selection:q?{startLineNumber:q,startColumn:X||1}:void 0,remoteAuthority:Y}}return{workspace:(0,_.getSingleFolderWorkspaceIdentifier)(ne),remoteAuthority:Y}}shouldOpenNewWindow(A){const O=this.configurationService.getValue("window"),H=O?.openFoldersInNewWindow||"default",Y=O?.openFilesInNewWindow||"off";let q=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(H==="on"||H==="off")&&(q=H==="on");let X=!1;return A.forceNewWindow||A.forceReuseWindow?X=!!A.forceNewWindow&&!A.forceReuseWindow:(t.isMacintosh?A.context===1&&(X=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(X=!0),!A.cli.extensionDevelopmentPath&&(Y==="on"||Y==="off")&&(X=Y==="on")),{openFolderInNewWindow:!!q,openFilesInNewWindow:X}}openExtensionDevelopmentHostWindow(A,O){const H=(0,c.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(H)return this.lifecycleMainService.reload(H,O.cli),H.focus(),[H];let Y=O.cli["folder-uri"]||[],q=O.cli["file-uri"]||[],X=O.cli._;if(!X.length&&!Y.length&&!q.length&&!O.cli.extensionTestsPath){const de=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,re=de&&(de.workspace||de.folderUri);re&&(l.URI.isUri(re)?re.scheme===o.Schemas.file?X=[re.fsPath]:Y=[re.toString()]:re.configPath.scheme===o.Schemas.file?X=[(0,w.originalFSPath)(re.configPath)]:q=[re.configPath.toString()])}let ne=O.remoteAuthority;for(const de of A)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=l.URI.parse(de),ce=(0,f.getRemoteAuthority)(re);ce&&(ne?ce!==ne&&this.logService.error("more than one extension development path authority"):ne=ce)}X=X.filter(de=>{const re=l.URI.file(de);return(0,c.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:(0,f.getRemoteAuthority)(re)===ne}),Y=Y.filter(de=>{const re=this.cliArgToUri(de);return re&&!!(0,c.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,f.getRemoteAuthority)(re)===ne:!1}),q=q.filter(de=>{const re=this.cliArgToUri(de);return re&&!!(0,c.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,f.getRemoteAuthority)(re)===ne:!1}),O.cli._=X,O.cli["folder-uri"]=Y,O.cli["file-uri"]=q;const se=!X.length&&!Y.length&&!q.length,ae={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:se,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:ne};return this.open(ae)}openInBrowserWindow(A){const O=this.configurationService.getValue("window"),H={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,E.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:D.default,isInitialStartup:A.initialStartup,perfMarks:(0,S.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,accessibilitySupport:y.app.accessibilitySupportEnabled,colorScheme:{dark:y.nativeTheme.shouldUseDarkColors,highContrast:y.nativeTheme.shouldUseInvertedColorScheme||y.nativeTheme.shouldUseHighContrastColors}};let Y;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(Y=A.windowToUse||this.getLastActiveWindow(),Y&&Y.focus()),Y){const q=Y.config;!H.extensionDevelopmentPath&&q&&!!q.extensionDevelopmentPath&&(H.extensionDevelopmentPath=q.extensionDevelopmentPath,H.verbose=q.verbose,H["inspect-brk-extensions"]=q["inspect-brk-extensions"],H.debugId=q.debugId,H["inspect-extensions"]=q["inspect-extensions"],H["extensions-dir"]=q["extensions-dir"])}else{const q=this.windowsStateHandler.getNewWindowState(H);(0,S.mark)("code/willCreateCodeWindow");const X=Y=this.instantiationService.createInstance(k.CodeWindow,{state:q,extensionDevelopmentPath:H.extensionDevelopmentPath,isExtensionTestHost:!!H.extensionTestsPath});if((0,S.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const se=this.getLastActiveWindow();se&&se.addTabbedWindow(X)}Xe.WINDOWS.push(X),this._onDidOpenWindow.fire(X),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,C.once)(X.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(X)),(0,C.once)(X.onDidClose)(()=>this.onWindowClosed(X)),(0,C.once)(X.onDidDestroy)(()=>this._onDidDestroyWindow.fire(X));const ne=(0,ie.assertIsDefined)(X.win?.webContents);ne.removeAllListeners("devtools-reload-page"),ne.on("devtools-reload-page",()=>this.lifecycleMainService.reload(X)),this.lifecycleMainService.registerWindow(X)}return H.windowId=Y.id,Y.isReady?this.lifecycleMainService.unload(Y,4).then(q=>{q||this.doOpenInBrowserWindow(Y,H,A)}):this.doOpenInBrowserWindow(Y,H,A),Y}doOpenInBrowserWindow(A,O,H){if(!O.extensionDevelopmentPath)if((0,s.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,s.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync(O.workspace.uri);else{const Y=H.emptyWindowBackupInfo&&H.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(Y,O.remoteAuthority)}A.load(O)}onWindowClosed(A){const O=Xe.WINDOWS.indexOf(A);Xe.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=y.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(O=>O.remoteAuthority===A))}doGetLastActiveWindow(A){const O=Math.max.apply(Math,A.map(H=>H.lastFocusTime));return A.find(H=>H.lastFocusTime===O)}sendToFocused(A,...O){const H=this.getFocusedWindow()||this.getLastActiveWindow();H&&H.sendWhenReady(A,U.CancellationToken.None,...O)}sendToAll(A,O,H){for(const Y of this.getWindows())H&&H.indexOf(Y.id)>=0||Y.sendWhenReady(A,U.CancellationToken.None,O)}getWindows(){return Xe.WINDOWS}getWindowCount(){return Xe.WINDOWS.length}getWindowById(A){const O=this.getWindows().filter(H=>H.id===A);return(0,p.firstOrDefault)(O)}getWindowByWebContents(A){const O=y.BrowserWindow.fromWebContents(A);if(!!O)return this.getWindowById(O.id)}};z.WINDOWS=[],z=he([ee(2,P.ILogService),ee(3,b.IStateMainService),ee(4,i.IEnvironmentMainService),ee(5,d.ILifecycleMainService),ee(6,g.IBackupMainService),ee(7,v.IConfigurationService),ee(8,u.IWorkspacesHistoryMainService),ee(9,R.IWorkspacesManagementMainService),ee(10,r.IInstantiationService),ee(11,x.IDialogMainService),ee(12,$.IFileService),ee(13,a.IProductService),ee(14,N.IProtocolMainService)],z),e.WindowsMainService=z}),define(J[237],Z([0,1,45,35,62,52]),function(V,e,m,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let E=class{constructor(p,g,i,b){this.workspacesManagementMainService=p,this.windowsMainService=g,this.workspacesHistoryMainService=i,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(p,g){const i=this.windowsMainService.getWindowById(p);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),g)}createUntitledWorkspace(p,g,i){return this.workspacesManagementMainService.createUntitledWorkspace(g,i)}deleteUntitledWorkspace(p,g){return this.workspacesManagementMainService.deleteUntitledWorkspace(g)}getWorkspaceIdentifier(p,g){return this.workspacesManagementMainService.getWorkspaceIdentifier(g)}async getRecentlyOpened(p){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(p))}async addRecentlyOpened(p,g){return this.workspacesHistoryMainService.addRecentlyOpened(g)}async removeRecentlyOpened(p,g){return this.workspacesHistoryMainService.removeRecentlyOpened(g)}async clearRecentlyOpened(p){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};E=he([ee(0,m.IWorkspacesManagementMainService),ee(1,M.IWindowsMainService),ee(2,D.IWorkspacesHistoryMainService),ee(3,S.IBackupMainService)],E),e.WorkspacesMainService=E}),define(J[238],Z([0,1,26,29,14,3,236,22,89,42,205,34,122,83,224,101,4,71,69,6,39,24,21,97,206,32,96,200,201,197,20,228,2,35,7,27,237,66,232,231,226,230,180,16,208,229,235,119,8,15,131,10,227,98,214,219,52,62,207,45,70,157,46,53,13,31,211,209,19,40,28,17,87,212,196,54,30,169,185,43,73,74,88,172,178]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P,I,c,h,a,u,t,s,r,o,l,w,f,L,R,_,C,K,x,ie,G,Q,U,$,F,N,B,W,z,T,A,O,H,Y,q,X,ne,se,ae,de,re,ce,be,ve,Ee,Te,ye,we,Ie,De,Oe,Ue,je,Qe,$e,nt,Ce,ct,Je,ut,Ke,rt,st,j,te,oe,le,fe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pe=class extends C.Disposable{constructor(ue,ge,pe,me,ke,Le,Me,Ae,Re,Ne){super();this.mainProcessNodeIpcServer=ue,this.userEnv=ge,this.mainInstantiationService=pe,this.logService=me,this.environmentMainService=ke,this.lifecycleMainService=Le,this.configurationService=Me,this.stateMainService=Ae,this.fileService=Re,this.productService=Ne,this.configureSession(),this.registerListeners()}configureSession(){const ue=me=>me?.startsWith(`${X.Schemas.vscodeWebview}://`),ge=new Set(["clipboard-read","clipboard-sanitized-write"]);D.session.defaultSession.setPermissionRequestHandler((me,ke,Le,Me)=>ue(Me.requestingUrl)?Le(ge.has(ke)):Le(!1)),D.session.defaultSession.setPermissionCheckHandler((me,ke,Le,Me)=>ue(Me.requestingUrl)?ge.has(ke):!1);const pe=D.session.defaultSession;typeof pe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&pe.setCodeCachePath((0,H.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,W.setUnexpectedErrorHandler)(pe=>this.onUnexpectedError(pe)),process.on("uncaughtException",pe=>this.onUnexpectedError(pe)),process.on("unhandledRejection",pe=>(0,W.onUnexpectedError)(pe)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,O.registerContextMenuListener)(),D.app.on("accessibility-support-changed",(pe,me)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",me)}),D.app.on("activate",(pe,me)=>{this.logService.trace("app#activate"),me||this.windowsMainService?.openEmptyWindow({context:1})}),D.app.on("web-contents-created",(pe,me)=>{me.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),me.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let ue=[],ge;D.app.on("open-file",(pe,me)=>{this.logService.trace("app#open-file: ",me),pe.preventDefault(),ue.push(this.getWindowOpenableFromPathSync(me)),ge!==void 0&&(clearTimeout(ge),ge=void 0),ge=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:ue,gotoLineMode:!1,preferNewWindow:!0}),ue=[],ge=void 0},100)}),D.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),D.ipcMain.handle("vscode:fetchShellEnv",pe=>{const me=this.windowsMainService?.getWindowByWebContents(pe.sender);let ke,Le;return me?.config?(ke=me.config,Le={...process.env,...me.config.userEnv}):(ke=this.environmentMainService.args,Le=process.env),(0,p.resolveShellEnv)(this.logService,ke,Le)}),D.ipcMain.handle("vscode:writeNlsFile",(pe,me,ke)=>{const Le=this.validateNlsPath([me]);if(!Le||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,nt.VSBuffer.fromString(ke))}),D.ipcMain.handle("vscode:readNlsFile",async(pe,...me)=>{const ke=this.validateNlsPath(me);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),D.ipcMain.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),D.ipcMain.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),D.ipcMain.on("vscode:reloadWindow",pe=>pe.sender.reload())}validateNlsPath(ue){let ge;for(const pe of ue)typeof pe=="string"&&(typeof ge!="string"?ge=pe:ge=(0,H.join)(ge,pe));if(!(typeof ge!="string"||!(0,H.isAbsolute)(ge)||!(0,Ke.isEqualOrParent)(ge,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return x.URI.file(ge)}onUnexpectedError(ue){if(ue){const ge={message:`[uncaught exception in main]: ${ue.message}`,stack:ue.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ge))}this.logService.error(`[uncaught exception in main]: ${ue}`),ue.stack&&this.logService.error(ue.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ue=this.productService.win32AppUserModelId;S.isWindows&&ue&&D.app.setAppUserModelId(ue);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!D.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&D.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Re){this.logService.error(Re)}const ge=new k.Server;this.logService.trace("Resolving machine identifier...");const pe=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${pe}`);const{sharedProcess:me,sharedProcessReady:ke,sharedProcessClient:Le}=this.setupSharedProcess(pe),Me=await this.initServices(pe,me,ke);if(this.environmentMainService.driverHandle){const Re=await(0,T.serve)(ge,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Re)}this._register(Me.createInstance(_.ProxyAuthHandler)),Me.invokeFunction(Re=>this.initChannels(Re,ge,Le));const Ae=Me.invokeFunction(Re=>this.openFirstWindow(Re,ge));Me.invokeFunction(Re=>this.afterWindowOpen(Re,me)),this.environmentMainService.args.trace&&Me.invokeFunction(Re=>this.stopTracingEventually(Re,Ae))}async resolveMachineId(){let ue=this.stateMainService.getItem(o.machineIdKey);return(!ue||S.isMacintosh&&ue==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(ue=await(0,Q.getMachineId)(),this.stateMainService.setItem(o.machineIdKey,ue)),ue}setupSharedProcess(ue){const ge=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,ue,this.userEnv)),pe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await ge.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new y.Client(ke,"main")})(),me=(async()=>(await ge.whenReady(),pe))();return{sharedProcess:ge,sharedProcessReady:me,sharedProcessClient:pe}}async initServices(ue,ge,pe){const me=new I.ServiceCollection;switch(process.platform){case"win32":me.set(g.IUpdateService,new c.SyncDescriptor(U.Win32UpdateService));break;case"linux":S.isLinuxSnap?me.set(g.IUpdateService,new c.SyncDescriptor(ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):me.set(g.IUpdateService,new c.SyncDescriptor($.LinuxUpdateService));break;case"darwin":me.set(g.IUpdateService,new c.SyncDescriptor(F.DarwinUpdateService));break}me.set(K.IWindowsMainService,new c.SyncDescriptor(E.WindowsMainService,[ue,this.userEnv])),me.set(we.IDialogMainService,new c.SyncDescriptor(we.DialogMainService)),me.set(v.ILaunchMainService,new c.SyncDescriptor(v.LaunchMainService)),me.set(Ee.IDiagnosticsService,b.ProxyChannel.toService((0,b.getDelayedChannel)(pe.then(Le=>Le.getChannel("diagnostics"))))),me.set(N.IIssueMainService,new c.SyncDescriptor(N.IssueMainService,[this.userEnv])),me.set(Ce.IEncryptionMainService,new c.SyncDescriptor(Ce.EncryptionMainService,[ue])),me.set(Je.IKeyboardLayoutMainService,new c.SyncDescriptor(Je.KeyboardLayoutMainService)),me.set(ye.INativeHostMainService,new c.SyncDescriptor(ye.NativeHostMainService,[ge])),me.set(Ue.IWebviewManagerService,new c.SyncDescriptor(Oe.WebviewMainService)),me.set(ie.IWorkspacesService,new c.SyncDescriptor(G.WorkspacesMainService)),me.set(ve.IWorkspacesManagementMainService,new c.SyncDescriptor(ve.WorkspacesManagementMainService)),me.set(ce.IWorkspacesHistoryMainService,new c.SyncDescriptor(ce.WorkspacesHistoryMainService)),me.set(A.IMenubarMainService,new c.SyncDescriptor(A.MenubarMainService)),me.set(rt.IExtensionUrlTrustService,new c.SyncDescriptor(st.ExtensionUrlTrustService)),me.set(se.IStorageMainService,new c.SyncDescriptor(se.StorageMainService)),S.isWindows?me.set(le.IExternalTerminalMainService,new c.SyncDescriptor(fe.WindowsExternalTerminalService)):S.isMacintosh?me.set(le.IExternalTerminalMainService,new c.SyncDescriptor(fe.MacExternalTerminalService)):S.isLinux&&me.set(le.IExternalTerminalMainService,new c.SyncDescriptor(fe.LinuxExternalTerminalService));const ke=new de.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(me.set(re.IBackupMainService,ke),me.set(s.IURLService,new c.SyncDescriptor(be.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Le=(0,b.getDelayedChannel)(pe.then(Ve=>Ve.getChannel("telemetryAppender"))),Me=new w.TelemetryAppenderClient(Le),Ae=(0,L.resolveCommonProperties)(this.fileService,(0,m.release)(),(0,m.hostname)(),process.arch,this.productService.commit,this.productService.version,ue,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Re=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ne={appender:Me,commonProperties:Ae,piiPaths:Re,sendErrorTelemetry:!0};me.set(o.ITelemetryService,new c.SyncDescriptor(f.TelemetryService,[Ne]))}else me.set(o.ITelemetryService,l.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(me)}initChannels(ue,ge,pe){const me=b.ProxyChannel.fromService(ue.get(v.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",me),ge.registerChannel(Se.UserConfigurationFileServiceId,b.ProxyChannel.fromService(new Se.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const ke=new i.UpdateChannel(ue.get(g.IUpdateService));ge.registerChannel("update",ke);const Le=b.ProxyChannel.fromService(ue.get(N.IIssueMainService));ge.registerChannel("issue",Le);const Me=b.ProxyChannel.fromService(ue.get(Ce.IEncryptionMainService));ge.registerChannel("encryption",Me);const Ae=b.ProxyChannel.fromService(ue.get(oe.ISignService));ge.registerChannel("sign",Ae);const Re=b.ProxyChannel.fromService(ue.get(Je.IKeyboardLayoutMainService));ge.registerChannel("keyboardLayout",Re),this.nativeHostMainService=ue.get(ye.INativeHostMainService);const Ne=b.ProxyChannel.fromService(this.nativeHostMainService);ge.registerChannel("nativeHost",Ne),pe.then(Be=>Be.registerChannel("nativeHost",Ne));const Ve=b.ProxyChannel.fromService(ue.get(ie.IWorkspacesService));ge.registerChannel("workspaces",Ve);const Ze=b.ProxyChannel.fromService(ue.get(A.IMenubarMainService));ge.registerChannel("menubar",Ze);const xe=b.ProxyChannel.fromService(ue.get(s.IURLService));ge.registerChannel("url",xe);const ht=b.ProxyChannel.fromService(ue.get(rt.IExtensionUrlTrustService));ge.registerChannel("extensionUrlTrust",ht);const _e=b.ProxyChannel.fromService(ue.get(Ue.IWebviewManagerService));ge.registerChannel("webview",_e);const et=this._register(new ae.StorageDatabaseChannel(this.logService,ue.get(se.IStorageMainService)));ge.registerChannel("storage",et),pe.then(Be=>Be.registerChannel("storage",et));const tt=b.ProxyChannel.fromService(ue.get(le.IExternalTerminalMainService));ge.registerChannel("externalTerminal",tt);const Ge=new B.LogLevelChannel(ue.get(h.ILogService));ge.registerChannel("logLevel",Ge),pe.then(Be=>Be.registerChannel("logLevel",Ge));const it=new B.LoggerChannel(ue.get(h.ILoggerService));ge.registerChannel("logger",it),pe.then(Be=>Be.registerChannel("logger",it));const ot=new Te.ElectronExtensionHostDebugBroadcastChannel(ue.get(K.IWindowsMainService));ge.registerChannel("extensionhostdebugservice",ot)}openFirstWindow(ue,ge){const pe=this.windowsMainService=ue.get(K.IWindowsMainService),me=ue.get(s.IURLService),ke=ue.get(ye.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(We=>{try{return{uri:x.URI.parse(We),url:We}}catch{return}}).filter(We=>{if(!We||this.shouldBlockURI(We.uri))return!1;const Ye=this.getWindowOpenableFromProtocolLink(We.uri);return Ye?(Le.push(Ye),!1):!0}),Ae=this,Re=this.environmentMainService,Ne=this.productService;me.registerHandler({async handleURL(We,Ye){if(We.scheme===Ne.urlProtocol&&We.path==="workspace"&&(We=We.with({authority:"file",path:x.URI.parse(We.query).path,query:""})),Ae.shouldBlockURI(We))return!0;const vt=Ae.getWindowOpenableFromProtocolLink(We);if(vt){const[ft]=pe.open({context:5,cli:{...Re.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(S.isMacintosh&&pe.getWindowCount()===0){const[ft]=pe.open({context:5,cli:{...Re.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,te.getRemoteAuthority)(We)});return await ft.ready(),me.open(We,Ye)}return!1}});const Ve=this._register(new ct.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Ze=new b.StaticRouter(We=>Ve.getActiveClientId().then(Ye=>We===Ye)),xe=new r.URLHandlerRouter(Ze),ht=ge.getChannel("urlHandler",xe);me.registerHandler(new r.URLHandlerChannelClient(ht)),this._register(new z.ElectronURLListener(Me,me,pe,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,et=global.macOpenFiles,tt=(0,ut.isLaunchedFromCli)(process.env)?0:4,Ge=_e._.length,it=!!_e["folder-uri"],ot=!!_e["file-uri"],Be=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?x.URI.file(_e.waitMarkerFilePath):void 0,pt=_e.remote||void 0;return Le.length>0?pe.open({context:tt,cli:_e,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Ge&&!it&&!ot?pe.open({context:tt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Be,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):et.length&&!Ge&&!it&&!ot?pe.open({context:1,cli:_e,urisToOpen:et.map(We=>this.getWindowOpenableFromPathSync(We)),noRecentEntry:Be,waitMarkerFileURI:dt,initialStartup:!0}):pe.open({context:tt,cli:_e,forceNewWindow:_e["new-window"]||!Ge&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:Be,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(ue){return!!(ue.authority===X.Schemas.file&&S.isWindows&&D.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,De.mnemonicButtonLabel)((0,q.localize)(0,null)),(0,De.mnemonicButtonLabel)((0,q.localize)(1,null))],defaultId:0,cancelId:1,message:(0,q.localize)(2,null,(0,De.getPathLabel)(ue.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,q.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(ue){if(!!ue.path){if(ue.authority===X.Schemas.file)return{fileUri:x.URI.file(ue.fsPath)};if(ue.authority===X.Schemas.vscodeRemote){const ge=ue.path.indexOf(H.posix.sep,1);if(ge!==-1){const pe=ue.path.substring(1,ge),me=ue.path.substring(ge),ke=x.URI.from({scheme:X.Schemas.vscodeRemote,authority:pe,path:me,query:ue.query,fragment:ue.fragment});return(0,ie.hasWorkspaceFileExtension)(me)?{workspaceUri:ke}:/:[\d]+$/.test(me)?{fileUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(ue){try{if((0,M.statSync)(ue).isDirectory())return{folderUri:x.URI.file(ue)};if((0,ie.hasWorkspaceFileExtension)(ue))return{workspaceUri:x.URI.file(ue)}}catch(ge){}return{fileUri:x.URI.file(ue)}}async afterWindowOpen(ue,ge){this.lifecycleMainService.phase=3;let pe=!1;(0,j.once)(this.lifecycleMainService.onWillShutdown)(()=>pe=!0);const me=ue.get(o.ITelemetryService);this._register(ge.onDidError(({type:Me,details:Ae})=>{let Re;switch(Me){case 1:Re="SharedProcess: detected unresponsive window";break;case 2:Re=`SharedProcess: crashed (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break;case 3:Re=`SharedProcess: failed to load (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break}(0,W.onUnexpectedError)(new Error(Re)),me.publicLog2("sharedprocesserror",{type:Me,reason:Ae?.reason,code:Ae?.exitCode,visible:ge.isVisible(),shuttingdown:pe})}));const ke=this.productService.win32MutexName;if(S.isWindows&&ke)try{const Me=V.__$__nodeRequire("windows-mutex").Mutex,Ae=new Me(ke);(0,j.once)(this.lifecycleMainService.onWillShutdown)(()=>Ae.release())}catch(Me){this.logService.error(Me)}D.protocol.registerHttpProtocol(X.Schemas.vscodeRemoteResource,(Me,Ae)=>{Ae({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const Le=ue.get(g.IUpdateService);(Le instanceof U.Win32UpdateService||Le instanceof $.LinuxUpdateService||Le instanceof F.DarwinUpdateService)&&Le.initialize(),(0,p.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Ae=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,Qe.stripComments)(Ae))["enable-crash-reporter"]===void 0){const Ne=this.configurationService.getValue("telemetry.enableCrashReporter"),Ve=typeof Ne=="boolean"?Ne:!0,Ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ve},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,$e.generateUuid)()}"`,"}"],xe=Ae.substring(0,Ae.length-2).concat(`,
`,Ze.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,nt.VSBuffer.fromString(xe))}}catch(Me){this.logService.error(Me)}}stopTracingEventually(ue,ge){this.logService.info("Tracing: waiting for windows to get ready...");const pe=ue.get(we.IDialogMainService);let me=!1;const ke=async Me=>{if(me)return;me=!0;const Ae=await D.contentTracing.stopRecording((0,Y.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ae}`):pe.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,q.localize)(4,null),detail:(0,q.localize)(5,null,Ae),buttons:[(0,De.mnemonicButtonLabel)((0,q.localize)(6,null))],defaultId:0,noLink:!0},(0,Ie.withNullAsUndefined)(D.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>ke(!0),3e4);Promise.all(ge.map(Me=>Me.ready())).then(()=>{clearTimeout(Le),ke(!1)})}};Pe=he([ee(2,P.IInstantiationService),ee(3,h.ILogService),ee(4,u.IEnvironmentMainService),ee(5,n.ILifecycleMainService),ee(6,t.IConfigurationService),ee(7,a.IStateMainService),ee(8,je.IFileService),ee(9,R.IProductService)],Pe),e.CodeApplication=Pe}),define(J[242],Z([0,1,14,29,18,11,3,72,49,54,161,22,34,56,174,71,69,6,225,39,21,189,51,223,238,31,92,91,16,60,43,74,195,198,183,184,10,19,94,221,20,30,23,8,36,24,67,96,181,33,55,186,9,204]),function(V,e,m,M,D,S,E,n,p,g,i,b,k,y,d,v,P,I,c,h,a,u,t,s,r,o,l,w,f,L,R,_,C,K,x,ie,G,Q,U,$,F,N,B,W,z,T,A,O,H,Y,q,X,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class se{main(){try{this.startup()}catch(re){console.error(re.message),m.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(we=>console.error(we));const[re,ce,be,ve,Ee,Te,ye]=this.createServices();try{try{await this.initServices(be,ve,Ee)}catch(we){throw this.handleStartupDataDirError(be,ye.nameLong,we),we}await re.invokeFunction(async we=>{const Ie=we.get(I.ILogService),De=we.get(b.ILifecycleMainService),Oe=we.get(Q.IFileService),Ue=await this.claimInstance(Ie,be,De,re,ye,!0);return Te.logger=new l.SpdLogLogger("main",(0,W.join)(be.logsPath,"main.log"),!0,Te.getLevel()),(0,R.once)(De.onWillShutdown)(()=>{Oe.dispose(),ve.dispose()}),re.createInstance(r.CodeApplication,Ue,ce).startup()})}catch(we){re.invokeFunction(this.quit,we)}}createServices(){const re=new v.ServiceCollection,ce={_serviceBrand:void 0,...p.default};re.set(F.IProductService,ce);const be=new T.EnvironmentMainService(this.resolveArgs(),ce),ve=this.patchEnvironment(be);re.set(T.IEnvironmentMainService,be);const Ee=new w.BufferLogService,Te=new I.MultiplexLogService([new I.ConsoleMainLogger((0,I.getLogLevel)(be)),Ee]);process.once("exit",()=>Te.dispose()),re.set(I.ILogService,Te);const ye=new x.FileService(Te);re.set(Q.IFileService,ye);const we=new ie.DiskFileSystemProvider(Te);ye.registerProvider(G.Schemas.file,we),re.set(I.ILoggerService,new H.LoggerService(Te,ye));const Ie=new u.ConfigurationService(be.settingsResource,ye);re.set(a.IConfigurationService,Ie),re.set(b.ILifecycleMainService,new P.SyncDescriptor(b.LifecycleMainService));const De=new c.StateMainService(be,Te,ye);return re.set(h.IStateMainService,De),re.set(t.IRequestService,new P.SyncDescriptor(s.RequestMainService)),re.set(L.IThemeMainService,new P.SyncDescriptor(L.ThemeMainService)),re.set(_.ISignService,new P.SyncDescriptor(C.SignService)),re.set(U.ITunnelService,new P.SyncDescriptor($.TunnelService)),re.set(q.IProtocolMainService,new P.SyncDescriptor(X.ProtocolMainService)),[new d.InstantiationService(re,!0),ve,be,Ie,De,Ee,ce]}patchEnvironment(re){const ce={VSCODE_IPC_HOOK:re.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(be=>{const ve=process.env[be];typeof ve=="string"&&(ce[be]=ve)}),Object.assign(process.env,ce),ce}initServices(re,ce,be){return ne.Promises.settled([Promise.all([re.extensionsPath,re.codeCachePath,re.logsPath,re.globalStorageHome.fsPath,re.workspaceStorageHome.fsPath,re.backupHome].map(ve=>ve?D.Promises.mkdir(ve,{recursive:!0}):void 0)),ce.initialize(),be.init()])}async claimInstance(re,ce,be,ve,Ee,Te){let ye;try{(0,n.mark)("code/willStartMainServer"),ye=await(0,y.serve)(ce.mainIPCHandle),(0,n.mark)("code/didStartMainServer"),(0,R.once)(be.onWillShutdown)(()=>ye.dispose())}catch(we){if(we.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,Ee.nameLong,we),we;let Ie;try{Ie=await(0,y.connect)(ce.mainIPCHandle,"main")}catch(Ue){if(!Te||E.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.showStartupWarningDialog((0,S.localize)(0,null,Ee.nameShort),(0,S.localize)(1,null),Ee.nameLong),Ue;try{(0,M.unlinkSync)(ce.mainIPCHandle)}catch(je){throw re.warn("Could not delete obsolete instance handle",je),je}return this.claimInstance(re,ce,be,ve,Ee,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const Ue="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw re.error(Ue),Ie.dispose(),new Error(Ue)}let De;!ce.args.wait&&!ce.args.status&&(De=setTimeout(()=>{this.showStartupWarningDialog((0,S.localize)(2,null,Ee.nameShort),(0,S.localize)(3,null),Ee.nameLong)},1e4));const Oe=k.ProxyChannel.toService(Ie.getChannel("launch"),{disableMarshalling:!0});if(ce.args.status)return ve.invokeFunction(async()=>{const Ue=new K.DiagnosticsService(O.NullTelemetryService,Ee),je=await Oe.getMainProcessInfo(),Qe=await Oe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),$e=await Ue.getDiagnostics(je,Qe);throw console.log($e),new f.ExpectedError});throw E.isWindows&&await this.windowsAllowSetForegroundWindow(Oe,re),re.trace("Sending env to running instance..."),await Oe.start(ce.args,process.env),Ie.dispose(),De&&clearTimeout(De),new f.ExpectedError("Sent env to running instance. Terminating...")}if(this.createLockfile(re,be,ce),ce.args.status)throw re.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(re,ce,be){if(be.code==="EACCES"||be.code==="EPERM"){const ve=(0,z.coalesce)([re.userDataPath,re.extensionsPath,y.XDG_RUNTIME_DIR]).map(Ee=>(0,o.getPathLabel)(Ee,re));this.showStartupWarningDialog((0,S.localize)(4,null),(0,S.localize)(5,null,(0,A.toErrorMessage)(be),ve.join(`
`)),ce)}}showStartupWarningDialog(re,ce,be){m.dialog.showMessageBoxSync({title:be,type:"warning",buttons:[(0,o.mnemonicButtonLabel)((0,S.localize)(6,null))],message:re,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(re,ce){if(E.isWindows){const be=await re.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",be);try{(await new Promise((ve,Ee)=>{V(["windows-foreground-love"],ve,Ee)})).allowSetForegroundWindow(be)}catch(ve){ce.error(ve)}}}quit(re,ce){const be=re.get(I.ILogService),ve=re.get(b.ILifecycleMainService);let Ee=0;ce&&(ce.isExpected?ce.message&&be.trace(ce.message):(Ee=1,ce.stack?be.error(ce.stack):be.error(`Startup error: ${ce.toString()}`))),ve.kill(Ee)}async createLockfile(re,ce,be){D.Promises.writeFile(be.mainLockfile,String(process.pid)).catch(ve=>{re.warn(`Error writing main lockfile: ${ve.stack}`)}),(0,R.once)(ce.onWillShutdown)(()=>{try{(0,M.unlinkSync)(be.mainLockfile)}catch{}})}resolveArgs(){const re=this.validatePaths((0,g.parseMainProcessArgv)(process.argv));if(re.wait&&!re.waitMarkerFilePath){const ce=(0,i.createWaitMarkerFile)(re.verbose);ce&&((0,g.addArg)(process.argv,"--waitMarkerFilePath",ce),re.waitMarkerFilePath=ce)}return re}validatePaths(re){if(re["open-url"]&&(re._urls=re._,re._=[]),!re.remote){const ce=this.doValidatePaths(re._,re.goto);re._=ce}return re}doValidatePaths(re,ce){const be=(0,Y.cwd)(),ve=re.map(ye=>{let we=String(ye),Ie;ce&&(Ie=(0,N.parseLineAndColumnAware)(we),we=Ie.path),we&&(we=this.preparePath(be,we));const De=(0,N.sanitizeFilePath)(we,be),Oe=(0,W.basename)(De);return Oe&&!(0,N.isValidBasename)(Oe)?null:ce&&Ie?(Ie.path=De,this.toPath(Ie)):De}),Ee=E.isWindows||E.isMacintosh,Te=(0,z.distinct)(ve,ye=>ye&&Ee?ye.toLowerCase():ye||"");return(0,z.coalesce)(Te)}preparePath(re,ce){return E.isWindows&&(ce=(0,B.rtrim)(ce,'"')),ce=(0,B.trim)((0,B.trim)(ce," "),"	"),E.isWindows&&(ce=(0,W.resolve)(re,ce),ce=(0,B.rtrim)(ce,".")),ce}toPath(re){const ce=[re.path];return typeof re.line=="number"&&ce.push(String(re.line)),typeof re.column=="number"&&ce.push(String(re.column)),ce.join(":")}}new se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/379476f0e13988d90fab105c5c19e7abc8b1dea8/core/vs/code/electron-main/main.js.map
