/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/platform","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/process","vs/base/common/hash","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(ee){for(var e=[],m=0,R=ee.length;m<R;m++)e[m]=be[ee[m]];return e};define(be[41],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(R,S){if(!R)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=m}),define(be[51],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function R(n){const C=[];for(let l in n)m.call(n,l)&&C.push(n[l]);return C}e.values=R;function S(n,C){for(let l in n)if(m.call(n,l)&&C({key:l,value:n[l]},function(){delete n[l]})===!1)return}e.forEach=S;function _(n,C){const l=Object.create(null);for(const h of n){const c=C(h);let g=l[c];g||(g=l[c]=[]),g.push(h)}return l}e.groupBy=_;function I(n){const C=Object.create(null);return n&&n.forEach((l,h)=>{C[h]=l}),C}e.fromMap=I;function y(n,C){const l=[],h=[];for(let c of n)C.has(c)||l.push(c);for(let c of C)n.has(c)||h.push(c);return{removed:l,added:h}}e.diffSets=y;function E(n,C){const l=[],h=[];for(let[c,g]of n)C.has(c)||l.push(g);for(let[c,g]of C)n.has(c)||h.push(g);return{removed:l,added:h}}e.diffMaps=E;class k{constructor(){this.map=new Map}add(C,l){let h=this.map.get(C);h||(h=new Set,this.map.set(C,h)),h.add(l)}delete(C,l){const h=this.map.get(C);!h||(h.delete(l),h.size===0&&this.map.delete(C))}forEach(C,l){const h=this.map.get(C);!h||h.forEach(l)}}e.SetMap=k}),define(be[52],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(I){return(y,E,k)=>{let n=null,C=null;if(typeof k.value=="function"?(n="value",C=k.value):typeof k.get=="function"&&(n="get",C=k.get),!C)throw new Error("not supported");k[n]=I(C,E)}}e.createDecorator=m;function R(I,y,E){let k=null,n=null;if(typeof E.value=="function"?(k="value",n=E.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(k="get",n=E.get),!n)throw new Error("not supported");const C=`$memoize$${y}`;E[k]=function(...l){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,l)}),this[C]}}e.memoize=R;function S(I,y,E){return m((k,n)=>{const C=`$debounce$${n}`,l=`$debounce$result$${n}`;return function(...h){this[l]||(this[l]=E?E():void 0),clearTimeout(this[C]),y&&(this[l]=y(this[l],...h),h=[this[l]]),this[C]=setTimeout(()=>{k.apply(this,h),this[l]=E?E():void 0},I)}})}e.debounce=S;function _(I,y,E){return m((k,n)=>{const C=`$throttle$timer$${n}`,l=`$throttle$result$${n}`,h=`$throttle$lastRun$${n}`,c=`$throttle$pending$${n}`;return function(...g){if(this[l]||(this[l]=E?E():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),y&&(this[l]=y(this[l],...g)),this[c])return;const b=this[h]+I;b<=Date.now()?(this[h]=Date.now(),k.apply(this,[this[l]]),this[l]=E?E():void 0):(this[c]=!0,this[C]=setTimeout(()=>{this[c]=!1,this[h]=Date.now(),k.apply(this,[this[l]]),this[l]=E?E():void 0},b-Date.now()))}})}e.throttle=_}),define(be[12],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function R(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=R;function S(v){E(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=S;function _(v){E(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=_;function I(v){if(v instanceof Error){let{name:t,message:r}=v;const s=v.stacktrace||v.stack;return{$isError:!0,name:t,message:r,stack:s}}return v}e.transformErrorForSerialization=I;const y="Canceled";function E(v){return v instanceof Error&&v.name===y&&v.message===y}e.isPromiseCanceledError=E;class k extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=k;function n(){const v=new Error(y);return v.name=v.message,v}e.canceled=n;function C(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=C;function l(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=l;function h(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function c(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function g(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=g;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function a(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=a;function f(v,t=Object.create(null)){const r=new Error(v);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=f}),define(be[17],Ee([0,1,12]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R($,ne=0){return $[$.length-(1+ne)]}e.tail=R;function S($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=S;function _($,ne,de=(ye,Ne)=>ye===Ne){if($===ne)return!0;if(!$||!ne||$.length!==ne.length)return!1;for(let ye=0,Ne=$.length;ye<Ne;ye++)if(!de($[ye],ne[ye]))return!1;return!0}e.equals=_;function I($,ne,de){let ye=0,Ne=$.length-1;for(;ye<=Ne;){const Me=(ye+Ne)/2|0,$e=de($[Me],ne);if($e<0)ye=Me+1;else if($e>0)Ne=Me-1;else return Me}return-(ye+1)}e.binarySearch=I;function y($,ne){let de=0,ye=$.length;if(ye===0)return 0;for(;de<ye;){const Ne=Math.floor((de+ye)/2);ne($[Ne])?ye=Ne:de=Ne+1}return de}e.findFirstInSorted=y;function E($,ne,de){if($=$|0,$>=ne.length)throw new TypeError("invalid index");let ye=ne[Math.floor(ne.length*Math.random())],Ne=[],Me=[],$e=[];for(let Xe of ne){const qe=de(Xe,ye);qe<0?Ne.push(Xe):qe>0?Me.push(Xe):$e.push(Xe)}return $<Ne.length?E($,Ne,de):$<Ne.length+$e.length?$e[0]:E($-(Ne.length+$e.length),Me,de)}e.quickSelect=E;function k($,ne){const de=[];let ye;for(const Ne of $.slice(0).sort(ne))!ye||ne(ye[0],Ne)!==0?(ye=[Ne],de.push(ye)):ye.push(Ne);return de}e.groupBy=k;function n($,ne,de){const ye=[];function Ne(Xe,qe,je){if(qe===0&&je.length===0)return;const U=ye[ye.length-1];U&&U.start+U.deleteCount===Xe?(U.deleteCount+=qe,U.toInsert.push(...je)):ye.push({start:Xe,deleteCount:qe,toInsert:je})}let Me=0,$e=0;for(;;){if(Me===$.length){Ne(Me,0,ne.slice($e));break}if($e===ne.length){Ne(Me,$.length-Me,[]);break}const Xe=$[Me],qe=ne[$e],je=de(Xe,qe);je===0?(Me+=1,$e+=1):je<0?(Ne(Me,1,[]),Me+=1):je>0&&(Ne(Me,0,[qe]),$e+=1)}return ye}e.sortedDiff=n;function C($,ne,de){const ye=n($,ne,de),Ne=[],Me=[];for(const $e of ye)Ne.push(...$.slice($e.start,$e.start+$e.deleteCount)),Me.push(...$e.toInsert);return{removed:Ne,added:Me}}e.delta=C;function l($,ne,de){if(de===0)return[];const ye=$.slice(0,de).sort(ne);return c($,ne,ye,de,$.length),ye}e.top=l;function h($,ne,de,ye,Ne){return de===0?Promise.resolve([]):new Promise((Me,$e)=>{(async()=>{const Xe=$.length,qe=$.slice(0,de).sort(ne);for(let je=de,U=Math.min(de+ye,Xe);je<Xe;je=U,U=Math.min(U+ye,Xe)){if(je>de&&await new Promise(G=>setTimeout(G)),Ne&&Ne.isCancellationRequested)throw(0,m.canceled)();c($,ne,qe,je,U)}return qe})().then(Me,$e)})}e.topAsync=h;function c($,ne,de,ye,Ne){for(const Me=de.length;ye<Ne;ye++){const $e=$[ye];if(ne($e,de[Me-1])<0){de.pop();const Xe=y(de,qe=>ne($e,qe)<0);de.splice(Xe,0,$e)}}}function g($){return $.filter(ne=>!!ne)}e.coalesce=g;function b($){let ne=0;for(let de=0;de<$.length;de++)$[de]&&($[ne]=$[de],ne+=1);$.length=ne}e.coalesceInPlace=b;function w($,ne,de){$.splice(de,0,$.splice(ne,1)[0])}e.move=w;function P($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=P;function a($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=a;function f($,ne){if(!ne)return $.filter((ye,Ne)=>$.indexOf(ye)===Ne);const de=Object.create(null);return $.filter(ye=>{const Ne=ne(ye);return de[Ne]?!1:(de[Ne]=!0,!0)})}e.distinct=f;function v($){const ne=new Set;return $.filter(de=>ne.has(de)?!1:(ne.add(de),!0))}e.distinctES6=v;function t($){const ne=Object.create(null);return de=>{const ye=$(de);return ne[ye]?!1:(ne[ye]=!0,!0)}}e.uniqueFilter=t;function r($,ne){for(let de=$.length-1;de>=0;de--){const ye=$[de];if(ne(ye))return de}return-1}e.lastIndex=r;function s($,ne){return $.length>0?$[0]:ne}e.firstOrDefault=s;function i($,ne,de=(ye,Ne)=>ye===Ne){let ye=0;for(let Ne=0,Me=Math.min($.length,ne.length);Ne<Me&&de($[Ne],ne[Ne]);Ne++)ye++;return ye}e.commonPrefixLength=i;function u($){return[].concat(...$)}e.flatten=u;function d($,ne){let de=typeof ne=="number"?$:0;typeof ne=="number"?de=$:(de=0,ne=$);const ye=[];if(de<=ne)for(let Ne=de;Ne<ne;Ne++)ye.push(Ne);else for(let Ne=de;Ne>ne;Ne--)ye.push(Ne);return ye}e.range=d;function p($,ne,de){return $.reduce((ye,Ne)=>(ye[ne(Ne)]=de?de(Ne):Ne,ye),Object.create(null))}e.index=p;function D($,ne){return $.push(ne),()=>T($,ne)}e.insert=D;function T($,ne){const de=$.indexOf(ne);if(de>-1)return $.splice(de,1),ne}e.remove=T;function o($,ne,de){const ye=$.slice(0,ne),Ne=$.slice(ne);return ye.concat(de,Ne)}e.arrayInsert=o;function A($,ne){let de;if(typeof ne=="number"){let ye=ne;de=()=>{const Ne=Math.sin(ye++)*179426549;return Ne-Math.floor(Ne)}}else de=Math.random;for(let ye=$.length-1;ye>0;ye-=1){const Ne=Math.floor(de()*(ye+1)),Me=$[ye];$[ye]=$[Ne],$[Ne]=Me}}e.shuffle=A;function F($,ne){const de=$.indexOf(ne);de>-1&&($.splice(de,1),$.unshift(ne))}e.pushToStart=F;function x($,ne){const de=$.indexOf(ne);de>-1&&($.splice(de,1),$.push(ne))}e.pushToEnd=x;function K($,ne){return Array.isArray($)?$.map(ne):ne($)}e.mapArrayOrNot=K;function le($){return Array.isArray($)?$:[$]}e.asArray=le;function oe($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=oe;function V($,ne){for(const de of $){const ye=ne(de);if(ye!==void 0)return ye}}e.mapFind=V;function W($,ne,de){const ye=Q($,ne),Ne=$.length,Me=de.length;$.length=Ne+Me;for(let $e=Ne-1;$e>=ye;$e--)$[$e+Me]=$[$e];for(let $e=0;$e<Me;$e++)$[$e+ye]=de[$e]}e.insertInto=W;function L($,ne,de,ye){const Ne=Q($,ne),Me=$.splice(Ne,de);return W($,Ne,ye),Me}e.splice=L;function Q($,ne){return ne<0?Math.max(ne+$.length,0):Math.min(ne,$.length)}function O($,ne){let de=Number.MAX_SAFE_INTEGER,ye=0;return $.forEach((Ne,Me)=>{const $e=ne(Ne);$e<de&&(de=$e,ye=Me)}),ye}e.minIndex=O;function j($,ne){let de=Number.MIN_SAFE_INTEGER,ye=0;return $.forEach((Ne,Me)=>{const $e=ne(Ne);$e>de&&(de=$e,ye=Me)}),ye}e.maxIndex=j;class he{constructor(ne){this.items=ne,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ne){let de=this.firstIdx;for(;de<this.items.length&&ne(this.items[de]);)de++;const ye=de===this.firstIdx?null:this.items.slice(this.firstIdx,de);return this.firstIdx=de,ye}takeFromEndWhile(ne){let de=this.lastIdx;for(;de>=0&&ne(this.items[de]);)de--;const ye=de===this.lastIdx?null:this.items.slice(de+1,this.lastIdx+1);return this.lastIdx=de,ye}}e.ArrayQueue=he}),define(be[53],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(R){const S=this;let _=!1,I;return function(){return _||(_=!0,I=R.apply(S,arguments)),I}}e.once=m}),define(be[54],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(be[55],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(R){function S(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}R.is=S;const _=Object.freeze([]);function I(){return _}R.empty=I;function*y(v){yield v}R.single=y;function E(v){return v||_}R.from=E;function k(v){return!v||v[Symbol.iterator]().next().done===!0}R.isEmpty=k;function n(v){return v[Symbol.iterator]().next().value}R.first=n;function C(v,t){for(const r of v)if(t(r))return!0;return!1}R.some=C;function l(v,t){for(const r of v)if(t(r))return r}R.find=l;function*h(v,t){for(const r of v)t(r)&&(yield r)}R.filter=h;function*c(v,t){let r=0;for(const s of v)yield t(s,r++)}R.map=c;function*g(...v){for(const t of v)for(const r of t)yield r}R.concat=g;function*b(v){for(const t of v)for(const r of t)yield r}R.concatNested=b;function w(v,t,r){let s=r;for(const i of v)s=t(s,i);return s}R.reduce=w;function*P(v,t,r=v.length){for(t<0&&(t+=v.length),r<0?r+=v.length:r>v.length&&(r=v.length);t<r;t++)yield v[t]}R.slice=P;function a(v,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,v];const s=v[Symbol.iterator]();for(let i=0;i<t;i++){const u=s.next();if(u.done)return[r,R.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return s}}]}R.consume=a;function f(v,t,r=(s,i)=>s===i){const s=v[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const u=s.next(),d=i.next();if(u.done!==d.done)return!1;if(u.done)return!0;if(!r(u.value,d.value))return!1}}R.equals=f})(m=e.Iterable||(e.Iterable={}))}),define(be[111],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(t){t.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function I(t,r=!1){let s=0,i=t.length,u="",d=0,p=16,D=0;function T(oe){let V=0,W=0;for(;V<oe;){const L=t.charCodeAt(s);if(L>=48&&L<=57)W=W*16+L-48;else if(L>=65&&L<=70)W=W*16+L-65+10;else if(L>=97&&L<=102)W=W*16+L-97+10;else break;s++,V++}return V<oe&&(W=-1),W}function o(oe){s=oe,u="",d=0,p=16,D=0}function A(){const oe=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return D=3,t.substring(oe,s);let V=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;V=s}else D=3;return t.substring(oe,V)}function F(){let oe="",V=s;for(;;){if(s>=i){oe+=t.substring(V,s),D=2;break}const W=t.charCodeAt(s);if(W===34){oe+=t.substring(V,s),s++;break}if(W===92){if(oe+=t.substring(V,s),s++,s>=i){D=2;break}switch(t.charCodeAt(s++)){case 34:oe+='"';break;case 92:oe+="\\";break;case 47:oe+="/";break;case 98:oe+="\b";break;case 102:oe+="\f";break;case 110:oe+=`
`;break;case 114:oe+="\r";break;case 116:oe+="	";break;case 117:const Q=T(4);Q>=0?oe+=String.fromCharCode(Q):D=4;break;default:D=5}V=s;continue}if(W>=0&&W<=31)if(E(W)){oe+=t.substring(V,s),D=2;break}else D=6;s++}return oe}function x(){if(u="",D=0,d=s,s>=i)return d=i,p=17;let oe=t.charCodeAt(s);if(y(oe)){do s++,u+=String.fromCharCode(oe),oe=t.charCodeAt(s);while(y(oe));return p=15}if(E(oe))return s++,u+=String.fromCharCode(oe),oe===13&&t.charCodeAt(s)===10&&(s++,u+=`
`),p=14;switch(oe){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,u=F(),p=10;case 47:const V=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!E(t.charCodeAt(s));)s++;return u=t.substring(V,s),p=12}if(t.charCodeAt(s+1)===42){s+=2;const W=i-1;let L=!1;for(;s<W;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,L=!0;break}s++}return L||(s++,D=1),u=t.substring(V,s),p=13}return u+=String.fromCharCode(oe),s++,p=16;case 45:if(u+=String.fromCharCode(oe),s++,s===i||!k(t.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=A(),p=11;default:for(;s<i&&K(oe);)s++,oe=t.charCodeAt(s);if(d!==s){switch(u=t.substring(d,s),u){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return u+=String.fromCharCode(oe),s++,p=16}}function K(oe){if(y(oe)||E(oe))return!1;switch(oe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let oe;do oe=x();while(oe>=12&&oe<=15);return oe}return{setPosition:o,getPosition:()=>s,scan:r?le:x,getToken:()=>p,getTokenValue:()=>u,getTokenOffset:()=>d,getTokenLength:()=>s-d,getTokenError:()=>D}}e.createScanner=I;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function C(t,r){const s=[],i=new Object;let u;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function D(T,o,A,F){d.value=T,d.offset=o,d.length=A,d.type=F,d.colonOffset=void 0,u=d}try{a(t,{onObjectBegin:(T,o)=>{if(r<=T)throw i;u=void 0,p=r>T,s.push("")},onObjectProperty:(T,o,A)=>{if(r<o||(D(T,o,A,"property"),s[s.length-1]=T,r<=o+A))throw i},onObjectEnd:(T,o)=>{if(r<=T)throw i;u=void 0,s.pop()},onArrayBegin:(T,o)=>{if(r<=T)throw i;u=void 0,s.push(0)},onArrayEnd:(T,o)=>{if(r<=T)throw i;u=void 0,s.pop()},onLiteralValue:(T,o,A)=>{if(r<o||(D(T,o,A,v(T)),r<=o+A))throw i},onSeparator:(T,o,A)=>{if(r<=o)throw i;if(T===":"&&u&&u.type==="property")u.colonOffset=o,p=!1,u=void 0;else if(T===","){const F=s[s.length-1];typeof F=="number"?s[s.length-1]=F+1:(p=!0,s[s.length-1]=""),u=void 0}}})}catch(T){if(T!==i)throw T}return{path:s,previousNode:u,isAtPropertyKey:p,matches:T=>{let o=0;for(let A=0;o<T.length&&A<s.length;A++)if(T[o]===s[A]||T[o]==="*")o++;else if(T[o]!=="**")return!1;return o===T.length}}}e.getLocation=C;function l(t,r=[],s=_.DEFAULT){let i=null,u=[];const d=[];function p(T){Array.isArray(u)?u.push(T):i!==null&&(u[i]=T)}return a(t,{onObjectBegin:()=>{const T={};p(T),d.push(u),u=T,i=null},onObjectProperty:T=>{i=T},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{const T=[];p(T),d.push(u),u=T,i=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:p,onError:(T,o,A)=>{r.push({error:T,offset:o,length:A})}},s),u[0]}e.parse=l;function h(t,r=[],s=_.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(T){i.type==="property"&&(i.length=T-i.offset,i=i.parent)}function d(T){return i.children.push(T),T}a(t,{onObjectBegin:T=>{i=d({type:"object",offset:T,length:-1,parent:i,children:[]})},onObjectProperty:(T,o,A)=>{i=d({type:"property",offset:o,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:T,offset:o,length:A,parent:i})},onObjectEnd:(T,o)=>{i.length=T+o-i.offset,i=i.parent,u(T+o)},onArrayBegin:(T,o)=>{i=d({type:"array",offset:T,length:-1,parent:i,children:[]})},onArrayEnd:(T,o)=>{i.length=T+o-i.offset,i=i.parent,u(T+o)},onLiteralValue:(T,o,A)=>{d({type:v(T),offset:o,length:A,parent:i,value:T}),u(o+A)},onSeparator:(T,o,A)=>{i.type==="property"&&(T===":"?i.colonOffset=o:T===","&&u(o))},onError:(T,o,A)=>{r.push({error:T,offset:o,length:A})}},s);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=h;function c(t,r){if(!t)return;let s=t;for(let i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const d of s.children)if(Array.isArray(d.children)&&d.children[0].value===i){s=d.children[1],u=!0;break}if(!u)return}else{const u=i;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}e.findNodeAtLocation=c;function g(t){if(!t.parent||!t.parent.children)return[];const r=g(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=g;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const r=Object.create(null);for(let s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=b(i))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function w(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=w;function P(t,r,s=!1){if(w(t,r,s)){const i=t.children;if(Array.isArray(i))for(let u=0;u<i.length&&i[u].offset<=r;u++){const d=P(i[u],r,s);if(d)return d}return t}}e.findNodeAtOffset=P;function a(t,r,s=_.DEFAULT){const i=I(t,!1);function u(de){return de?()=>de(i.getTokenOffset(),i.getTokenLength()):()=>!0}function d(de){return de?ye=>de(ye,i.getTokenOffset(),i.getTokenLength()):()=>!0}const p=u(r.onObjectBegin),D=d(r.onObjectProperty),T=u(r.onObjectEnd),o=u(r.onArrayBegin),A=u(r.onArrayEnd),F=d(r.onLiteralValue),x=d(r.onSeparator),K=u(r.onComment),le=d(r.onError),oe=s&&s.disallowComments,V=s&&s.allowTrailingComma;function W(){for(;;){const de=i.scan();switch(i.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:oe||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(de){case 12:case 13:oe?L(10):K();break;case 16:L(1);break;case 15:case 14:break;default:return de}}}function L(de,ye=[],Ne=[]){if(le(de),ye.length+Ne.length>0){let Me=i.getToken();for(;Me!==17;){if(ye.indexOf(Me)!==-1){W();break}else if(Ne.indexOf(Me)!==-1)break;Me=W()}}}function Q(de){const ye=i.getTokenValue();return de?F(ye):D(ye),W(),!0}function O(){switch(i.getToken()){case 11:let de=0;try{de=JSON.parse(i.getTokenValue()),typeof de!="number"&&(L(2),de=0)}catch(ye){L(2)}F(de);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return W(),!0}function j(){return i.getToken()!==10?(L(3,[],[2,5]),!1):(Q(!1),i.getToken()===6?(x(":"),W(),ne()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function he(){p(),W();let de=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(de||L(4,[],[]),x(","),W(),i.getToken()===2&&V)break}else de&&L(6,[],[]);j()||L(4,[],[2,5]),de=!0}return T(),i.getToken()!==2?L(7,[2],[]):W(),!0}function $(){o(),W();let de=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(de||L(4,[],[]),x(","),W(),i.getToken()===4&&V)break}else de&&L(6,[],[]);ne()||L(4,[],[4,5]),de=!0}return A(),i.getToken()!==4?L(8,[4],[]):W(),!0}function ne(){switch(i.getToken()){case 3:return $();case 1:return he();case 10:return Q(!0);default:return O()}}return W(),i.getToken()===17?s.allowEmptyContent?!0:(L(4,[],[]),!1):ne()?(i.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}e.visit=a;function f(t,r){let s=I(t),i=[],u,d=0,p;do switch(p=s.getPosition(),u=s.scan(),u){case 12:case 13:case 17:d!==p&&i.push(t.substring(d,p)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),d=s.getPosition();break}while(u!==17);return i.join("")}e.stripComments=f;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(be[112],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(S){this.executor=S,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(S){return new m(()=>S(this.getValue()))}}e.Lazy=m}),define(be[6],Ee([0,1,53,55]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const S=!1;let _=null;function I(s){_=s}if(e.setDisposableTracker=I,S){const s="__is_disposable_tracked__";I(new class{trackDisposable(i){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[s]||console.log(u)},3e3)}setParent(i,u){if(i&&i!==P.None)try{i[s]=!0}catch{}}markAsDisposed(i){if(i&&i!==P.None)try{i[s]=!0}catch{}}markAsSingleton(i){}})}function y(s){return _?.trackDisposable(s),s}function E(s){_?.markAsDisposed(s)}function k(s,i){_?.setParent(s,i)}function n(s,i){if(!!_)for(const u of s)_.setParent(u,i)}function C(s){return _?.markAsSingleton(s),s}e.markAsSingleton=C;class l extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=l;function h(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=h;function c(s){if(R.Iterable.is(s)){let i=[];for(const u of s)if(u)try{u.dispose()}catch(d){i.push(d)}if(i.length===1)throw i[0];if(i.length>1)throw new l(i);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=c;function g(...s){const i=b(()=>c(s));return n(s,i),i}e.combinedDisposable=g;function b(s){const i=y({dispose:(0,m.once)(()=>{E(i),s()})});return i}e.toDisposable=b;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}clear(){try{c(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return k(i,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new w,y(this),k(this._store,this)}dispose(){E(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&k(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&k(i,null),i}}e.MutableDisposable=a;class f{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class v{constructor(){this.references=new Map}acquire(i,...u){let d=this.references.get(i);d||(d={counter:0,object:this.createReferencedObject(i,...u)},this.references.set(i,d));const{object:p}=d,D=(0,m.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(i,d.object),this.references.delete(i))});return d.counter++,{object:p,dispose:D}}}e.ReferenceCollection=v;class t{constructor(i){this.referenceCollection=i}async acquire(i,...u){const d=this.referenceCollection.acquire(i,...u);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(p){throw d.dispose(),p}}}e.AsyncReferenceCollection=t;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r}),define(be[80],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(_){this.element=_,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class R{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let _=this._first;for(;_!==m.Undefined;){const I=_.next;_.prev=m.Undefined,_.next=m.Undefined,_=I}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,I){const y=new m(_);if(this._first===m.Undefined)this._first=y,this._last=y;else if(I){const k=this._last;this._last=y,y.prev=k,k.next=y}else{const k=this._first;this._first=y,y.next=k,k.prev=y}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(y))}}shift(){if(this._first!==m.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==m.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==m.Undefined&&_.next!==m.Undefined){const I=_.prev;I.next=_.next,_.next.prev=I}else _.prev===m.Undefined&&_.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):_.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):_.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==m.Undefined;)yield _.element,_=_.next}}e.LinkedList=R}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(De,Se){for(var Pe=0;Pe<Se.length;Pe++){var se=Se[Pe];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(De,se.key,se)}}function e(De,Se,Pe){return Se&&ee(De.prototype,Se),Pe&&ee(De,Pe),De}function m(De,Se){if(!!De){if(typeof De=="string")return R(De,Se);var Pe=Object.prototype.toString.call(De).slice(8,-1);if(Pe==="Object"&&De.constructor&&(Pe=De.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(De);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return R(De,Se)}}function R(De,Se){(Se==null||Se>De.length)&&(Se=De.length);for(var Pe=0,se=new Array(Se);Pe<Se;Pe++)se[Pe]=De[Pe];return se}function S(De,Se){var Pe;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Pe=m(De))||Se&&De&&typeof De.length=="number"){Pe&&(De=Pe);var se=0;return function(){return se>=De.length?{done:!0}:{done:!1,value:De[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=De[Symbol.iterator](),Pe.next.bind(Pe)}function _(De){var Se={exports:{}};return De(Se,Se.exports),Se.exports}var I=_(function(De){function Se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(se){De.exports.defaults=se}De.exports={defaults:Se(),getDefaults:Se,changeDefaults:Pe}}),y=/[&<>"']/,E=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(Se){return C[Se]};function h(De,Se){if(Se){if(y.test(De))return De.replace(E,l)}else if(k.test(De))return De.replace(n,l);return De}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(De){return De.replace(c,function(Se,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var b=/(^|[^\[])\^/g;function w(De,Se){De=De.source||De,Se=Se||"";var Pe={replace:function(ae,fe){return fe=fe.source||fe,fe=fe.replace(b,"$1"),De=De.replace(ae,fe),Pe},getRegex:function(){return new RegExp(De,Se)}};return Pe}var P=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(De,Se,Pe){if(De){var se;try{se=decodeURIComponent(g(Pe)).replace(P,"").toLowerCase()}catch(ae){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Se&&!a.test(Pe)&&(Pe=i(Se,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(ae){return null}return Pe}var v={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(De,Se){v[" "+De]||(t.test(De)?v[" "+De]=De+"/":v[" "+De]=D(De,"/",!0)),De=v[" "+De];var Pe=De.indexOf(":")===-1;return Se.substring(0,2)==="//"?Pe?Se:De.replace(r,"$1")+Se:Se.charAt(0)==="/"?Pe?Se:De.replace(s,"$1")+Se:De+Se}var u={exec:function(){}};function d(De){for(var Se=1,Pe,se;Se<arguments.length;Se++){Pe=arguments[Se];for(se in Pe)Object.prototype.hasOwnProperty.call(Pe,se)&&(De[se]=Pe[se])}return De}function p(De,Se){var Pe=De.replace(/\|/g,function(fe,pe,B){for(var me=!1,we=pe;--we>=0&&B[we]==="\\";)me=!me;return me?"|":" |"}),se=Pe.split(/ \|/),ae=0;if(se.length>Se)se.splice(Se);else for(;se.length<Se;)se.push("");for(;ae<se.length;ae++)se[ae]=se[ae].trim().replace(/\\\|/g,"|");return se}function D(De,Se,Pe){var se=De.length;if(se===0)return"";for(var ae=0;ae<se;){var fe=De.charAt(se-ae-1);if(fe===Se&&!Pe)ae++;else if(fe!==Se&&Pe)ae++;else break}return De.substr(0,se-ae)}function T(De,Se){if(De.indexOf(Se[1])===-1)return-1;for(var Pe=De.length,se=0,ae=0;ae<Pe;ae++)if(De[ae]==="\\")ae++;else if(De[ae]===Se[0])se++;else if(De[ae]===Se[1]&&(se--,se<0))return ae;return-1}function o(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(De,Se){if(Se<1)return"";for(var Pe="";Se>1;)Se&1&&(Pe+=De),Se>>=1,De+=De;return Pe+De}var F={escape:h,unescape:g,edit:w,cleanUrl:f,resolveUrl:i,noopTest:u,merge:d,splitCells:p,rtrim:D,findClosingBracket:T,checkSanitizeDeprecation:o,repeatString:A},x=I.defaults,K=F.rtrim,le=F.splitCells,oe=F.escape,V=F.findClosingBracket;function W(De,Se,Pe){var se=Se.href,ae=Se.title?oe(Se.title):null,fe=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:se,title:ae,text:fe}:{type:"image",raw:Pe,href:se,title:ae,text:oe(fe)}}function L(De,Se){var Pe=De.match(/^(\s+)(?:```)/);if(Pe===null)return Se;var se=Pe[1];return Se.split(`
`).map(function(ae){var fe=ae.match(/^\s+/);if(fe===null)return ae;var pe=fe[0];return pe.length>=se.length?ae.slice(se.length):ae}).join(`
`)}var Q=function(){function De(Pe){this.options=Pe||x}var Se=De.prototype;return Se.space=function(se){var ae=this.rules.block.newline.exec(se);if(ae)return ae[0].length>1?{type:"space",raw:ae[0]}:{raw:`
`}},Se.code=function(se){var ae=this.rules.block.code.exec(se);if(ae){var fe=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:K(fe,`
`)}}},Se.fences=function(se){var ae=this.rules.block.fences.exec(se);if(ae){var fe=ae[0],pe=L(fe,ae[3]||"");return{type:"code",raw:fe,lang:ae[2]?ae[2].trim():ae[2],text:pe}}},Se.heading=function(se){var ae=this.rules.block.heading.exec(se);if(ae){var fe=ae[2].trim();if(/#$/.test(fe)){var pe=K(fe,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(fe=pe.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:fe}}},Se.nptable=function(se){var ae=this.rules.block.nptable.exec(se);if(ae){var fe={type:"table",header:le(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[],raw:ae[0]};if(fe.header.length===fe.align.length){var pe=fe.align.length,B;for(B=0;B<pe;B++)/^ *-+: *$/.test(fe.align[B])?fe.align[B]="right":/^ *:-+: *$/.test(fe.align[B])?fe.align[B]="center":/^ *:-+ *$/.test(fe.align[B])?fe.align[B]="left":fe.align[B]=null;for(pe=fe.cells.length,B=0;B<pe;B++)fe.cells[B]=le(fe.cells[B],fe.header.length);return fe}}},Se.hr=function(se){var ae=this.rules.block.hr.exec(se);if(ae)return{type:"hr",raw:ae[0]}},Se.blockquote=function(se){var ae=this.rules.block.blockquote.exec(se);if(ae){var fe=ae[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ae[0],text:fe}}},Se.list=function(se){var ae=this.rules.block.list.exec(se);if(ae){var fe=ae[0],pe=ae[2],B=pe.length>1,me={type:"list",raw:fe,ordered:B,start:B?+pe.slice(0,-1):"",loose:!1,items:[]},we=ae[0].match(this.rules.block.item),Ie=!1,Oe,He,Ze,Ke,Je,ut,mt,bt,ot=we.length;Ze=this.rules.block.listItemStart.exec(we[0]);for(var at=0;at<ot;at++){if(Oe=we[at],fe=Oe,at!==ot-1){if(Ke=this.rules.block.listItemStart.exec(we[at+1]),this.options.pedantic?Ke[1].length>Ze[1].length:Ke[1].length>Ze[0].length||Ke[1].length>3){we.splice(at,2,we[at]+`
`+we[at+1]),at--,ot--;continue}else(!this.options.pedantic||this.options.smartLists?Ke[2][Ke[2].length-1]!==pe[pe.length-1]:B===(Ke[2].length===1))&&(Je=we.slice(at+1).join(`
`),me.raw=me.raw.substring(0,me.raw.length-Je.length),at=ot-1);Ze=Ke}He=Oe.length,Oe=Oe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Oe.indexOf(`
 `)&&(He-=Oe.length,Oe=this.options.pedantic?Oe.replace(/^ {1,4}/gm,""):Oe.replace(new RegExp("^ {1,"+He+"}","gm"),"")),ut=Ie||/\n\n(?!\s*$)/.test(Oe),at!==ot-1&&(Ie=Oe.charAt(Oe.length-1)===`
`,ut||(ut=Ie)),ut&&(me.loose=!0),this.options.gfm&&(mt=/^\[[ xX]\] /.test(Oe),bt=void 0,mt&&(bt=Oe[1]!==" ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),me.items.push({type:"list_item",raw:fe,task:mt,checked:bt,loose:ut,text:Oe})}return me}},Se.html=function(se){var ae=this.rules.block.html.exec(se);if(ae)return{type:this.options.sanitize?"paragraph":"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):oe(ae[0]):ae[0]}},Se.def=function(se){var ae=this.rules.block.def.exec(se);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var fe=ae[1].toLowerCase().replace(/\s+/g," ");return{tag:fe,raw:ae[0],href:ae[2],title:ae[3]}}},Se.table=function(se){var ae=this.rules.block.table.exec(se);if(ae){var fe={type:"table",header:le(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=ae[0];var pe=fe.align.length,B;for(B=0;B<pe;B++)/^ *-+: *$/.test(fe.align[B])?fe.align[B]="right":/^ *:-+: *$/.test(fe.align[B])?fe.align[B]="center":/^ *:-+ *$/.test(fe.align[B])?fe.align[B]="left":fe.align[B]=null;for(pe=fe.cells.length,B=0;B<pe;B++)fe.cells[B]=le(fe.cells[B].replace(/^ *\| *| *\| *$/g,""),fe.header.length);return fe}}},Se.lheading=function(se){var ae=this.rules.block.lheading.exec(se);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1]}},Se.paragraph=function(se){var ae=this.rules.block.paragraph.exec(se);if(ae)return{type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1]}},Se.text=function(se){var ae=this.rules.block.text.exec(se);if(ae)return{type:"text",raw:ae[0],text:ae[0]}},Se.escape=function(se){var ae=this.rules.inline.escape.exec(se);if(ae)return{type:"escape",raw:ae[0],text:oe(ae[1])}},Se.tag=function(se,ae,fe){var pe=this.rules.inline.tag.exec(se);if(pe)return!ae&&/^<a /i.test(pe[0])?ae=!0:ae&&/^<\/a>/i.test(pe[0])&&(ae=!1),!fe&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?fe=!0:fe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(fe=!1),{type:this.options.sanitize?"text":"html",raw:pe[0],inLink:ae,inRawBlock:fe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):oe(pe[0]):pe[0]}},Se.link=function(se){var ae=this.rules.inline.link.exec(se);if(ae){var fe=ae[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var pe=K(fe.slice(0,-1),"\\");if((fe.length-pe.length)%2==0)return}else{var B=V(ae[2],"()");if(B>-1){var me=ae[0].indexOf("!")===0?5:4,we=me+ae[1].length+B;ae[2]=ae[2].substring(0,B),ae[0]=ae[0].substring(0,we).trim(),ae[3]=""}}var Ie=ae[2],Oe="";if(this.options.pedantic){var He=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);He&&(Ie=He[1],Oe=He[3])}else Oe=ae[3]?ae[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(fe)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),W(ae,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},ae[0])}},Se.reflink=function(se,ae){var fe;if((fe=this.rules.inline.reflink.exec(se))||(fe=this.rules.inline.nolink.exec(se))){var pe=(fe[2]||fe[1]).replace(/\s+/g," ");if(pe=ae[pe.toLowerCase()],!pe||!pe.href){var B=fe[0].charAt(0);return{type:"text",raw:B,text:B}}return W(fe,pe,fe[0])}},Se.emStrong=function(se,ae,fe){fe===void 0&&(fe="");var pe=this.rules.inline.emStrong.lDelim.exec(se);if(!!pe&&!(pe[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=pe[1]||pe[2]||"";if(!B||B&&(fe===""||this.rules.inline.punctuation.exec(fe))){var me=pe[0].length-1,we,Ie,Oe=me,He=0,Ze=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ze.lastIndex=0,ae=ae.slice(-1*se.length+me);(pe=Ze.exec(ae))!=null;)if(we=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!we){if(Ie=we.length,pe[3]||pe[4]){Oe+=Ie;continue}else if((pe[5]||pe[6])&&me%3&&!((me+Ie)%3)){He+=Ie;continue}if(Oe-=Ie,!(Oe>0)){if(Oe+He-Ie<=0&&!ae.slice(Ze.lastIndex).match(Ze)&&(Ie=Math.min(Ie,Ie+Oe+He)),Math.min(me,Ie)%2)return{type:"em",raw:se.slice(0,me+pe.index+Ie+1),text:se.slice(1,me+pe.index+Ie)};if(Math.min(me,Ie)%2==0)return{type:"strong",raw:se.slice(0,me+pe.index+Ie+1),text:se.slice(2,me+pe.index+Ie-1)}}}}}},Se.codespan=function(se){var ae=this.rules.inline.code.exec(se);if(ae){var fe=ae[2].replace(/\n/g," "),pe=/[^ ]/.test(fe),B=/^ /.test(fe)&&/ $/.test(fe);return pe&&B&&(fe=fe.substring(1,fe.length-1)),fe=oe(fe,!0),{type:"codespan",raw:ae[0],text:fe}}},Se.br=function(se){var ae=this.rules.inline.br.exec(se);if(ae)return{type:"br",raw:ae[0]}},Se.del=function(se){var ae=this.rules.inline.del.exec(se);if(ae)return{type:"del",raw:ae[0],text:ae[2]}},Se.autolink=function(se,ae){var fe=this.rules.inline.autolink.exec(se);if(fe){var pe,B;return fe[2]==="@"?(pe=oe(this.options.mangle?ae(fe[1]):fe[1]),B="mailto:"+pe):(pe=oe(fe[1]),B=pe),{type:"link",raw:fe[0],text:pe,href:B,tokens:[{type:"text",raw:pe,text:pe}]}}},Se.url=function(se,ae){var fe;if(fe=this.rules.inline.url.exec(se)){var pe,B;if(fe[2]==="@")pe=oe(this.options.mangle?ae(fe[0]):fe[0]),B="mailto:"+pe;else{var me;do me=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(me!==fe[0]);pe=oe(fe[0]),fe[1]==="www."?B="http://"+pe:B=pe}return{type:"link",raw:fe[0],text:pe,href:B,tokens:[{type:"text",raw:pe,text:pe}]}}},Se.inlineText=function(se,ae,fe){var pe=this.rules.inline.text.exec(se);if(pe){var B;return ae?B=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):oe(pe[0]):pe[0]:B=oe(this.options.smartypants?fe(pe[0]):pe[0]),{type:"text",raw:pe[0],text:B}}},De}(),O=F.noopTest,j=F.edit,he=F.merge,$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:O,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=j($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,$.item=j($.item,"gm").replace(/bull/g,$.bullet).getRegex(),$.listItemStart=j(/^( *)(bull)/).replace("bull",$.bullet).getRegex(),$.list=j($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=j($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=j($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.blockquote=j($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=he({},$),$.gfm=he({},$.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.nptable=j($.gfm.nptable).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.gfm.table=j($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.pedantic=he({},$.normal,{html:j(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:j($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=j(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=j($._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=j(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=j(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=j(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=j(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=j(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=j(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=j(ne.reflink).replace("label",ne._label).getRegex(),ne.reflinkSearch=j(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=he({},ne),ne.pedantic=he({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:j(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:j(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=he({},ne.normal,{escape:j(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ne.gfm.url=j(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=he({},ne.gfm,{br:j(ne.br).replace("{2,}","*").getRegex(),text:j(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:$,inline:ne},ye=I.defaults,Ne=de.block,Me=de.inline,$e=F.repeatString;function Xe(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function qe(De){var Se="",Pe,se,ae=De.length;for(Pe=0;Pe<ae;Pe++)se=De.charCodeAt(Pe),Math.random()>.5&&(se="x"+se.toString(16)),Se+="&#"+se+";";return Se}var je=function(){function De(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||ye,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var se={block:Ne.normal,inline:Me.normal};this.options.pedantic?(se.block=Ne.pedantic,se.inline=Me.pedantic):this.options.gfm&&(se.block=Ne.gfm,this.options.breaks?se.inline=Me.breaks:se.inline=Me.gfm),this.tokenizer.rules=se}De.lex=function(se,ae){var fe=new De(ae);return fe.lex(se)},De.lexInline=function(se,ae){var fe=new De(ae);return fe.inlineTokens(se)};var Se=De.prototype;return Se.lex=function(se){return se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens,!0),this.inline(this.tokens),this.tokens},Se.blockTokens=function(se,ae,fe){ae===void 0&&(ae=[]),fe===void 0&&(fe=!0),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var pe,B,me,we;se;){if(pe=this.tokenizer.space(se)){se=se.substring(pe.raw.length),pe.type&&ae.push(pe);continue}if(pe=this.tokenizer.code(se)){se=se.substring(pe.raw.length),we=ae[ae.length-1],we&&we.type==="paragraph"?(we.raw+=`
`+pe.raw,we.text+=`
`+pe.text):ae.push(pe);continue}if(pe=this.tokenizer.fences(se)){se=se.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.heading(se)){se=se.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.nptable(se)){se=se.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.hr(se)){se=se.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.blockquote(se)){se=se.substring(pe.raw.length),pe.tokens=this.blockTokens(pe.text,[],fe),ae.push(pe);continue}if(pe=this.tokenizer.list(se)){for(se=se.substring(pe.raw.length),me=pe.items.length,B=0;B<me;B++)pe.items[B].tokens=this.blockTokens(pe.items[B].text,[],!1);ae.push(pe);continue}if(pe=this.tokenizer.html(se)){se=se.substring(pe.raw.length),ae.push(pe);continue}if(fe&&(pe=this.tokenizer.def(se))){se=se.substring(pe.raw.length),this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(se)){se=se.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.lheading(se)){se=se.substring(pe.raw.length),ae.push(pe);continue}if(fe&&(pe=this.tokenizer.paragraph(se))){se=se.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.text(se)){se=se.substring(pe.raw.length),we=ae[ae.length-1],we&&we.type==="text"?(we.raw+=`
`+pe.raw,we.text+=`
`+pe.text):ae.push(pe);continue}if(se){var Ie="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return ae},Se.inline=function(se){var ae,fe,pe,B,me,we,Ie=se.length;for(ae=0;ae<Ie;ae++)switch(we=se[ae],we.type){case"paragraph":case"text":case"heading":{we.tokens=[],this.inlineTokens(we.text,we.tokens);break}case"table":{for(we.tokens={header:[],cells:[]},B=we.header.length,fe=0;fe<B;fe++)we.tokens.header[fe]=[],this.inlineTokens(we.header[fe],we.tokens.header[fe]);for(B=we.cells.length,fe=0;fe<B;fe++)for(me=we.cells[fe],we.tokens.cells[fe]=[],pe=0;pe<me.length;pe++)we.tokens.cells[fe][pe]=[],this.inlineTokens(me[pe],we.tokens.cells[fe][pe]);break}case"blockquote":{this.inline(we.tokens);break}case"list":{for(B=we.items.length,fe=0;fe<B;fe++)this.inline(we.items[fe].tokens);break}}return se},Se.inlineTokens=function(se,ae,fe,pe){ae===void 0&&(ae=[]),fe===void 0&&(fe=!1),pe===void 0&&(pe=!1);var B,me,we=se,Ie,Oe,He;if(this.tokens.links){var Ze=Object.keys(this.tokens.links);if(Ze.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)Ze.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,Ie.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;){if(Oe||(He=""),Oe=!1,B=this.tokenizer.escape(se)){se=se.substring(B.raw.length),ae.push(B);continue}if(B=this.tokenizer.tag(se,fe,pe)){se=se.substring(B.raw.length),fe=B.inLink,pe=B.inRawBlock;var Ke=ae[ae.length-1];Ke&&B.type==="text"&&Ke.type==="text"?(Ke.raw+=B.raw,Ke.text+=B.text):ae.push(B);continue}if(B=this.tokenizer.link(se)){se=se.substring(B.raw.length),B.type==="link"&&(B.tokens=this.inlineTokens(B.text,[],!0,pe)),ae.push(B);continue}if(B=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(B.raw.length);var Je=ae[ae.length-1];B.type==="link"?(B.tokens=this.inlineTokens(B.text,[],!0,pe),ae.push(B)):Je&&B.type==="text"&&Je.type==="text"?(Je.raw+=B.raw,Je.text+=B.text):ae.push(B);continue}if(B=this.tokenizer.emStrong(se,we,He)){se=se.substring(B.raw.length),B.tokens=this.inlineTokens(B.text,[],fe,pe),ae.push(B);continue}if(B=this.tokenizer.codespan(se)){se=se.substring(B.raw.length),ae.push(B);continue}if(B=this.tokenizer.br(se)){se=se.substring(B.raw.length),ae.push(B);continue}if(B=this.tokenizer.del(se)){se=se.substring(B.raw.length),B.tokens=this.inlineTokens(B.text,[],fe,pe),ae.push(B);continue}if(B=this.tokenizer.autolink(se,qe)){se=se.substring(B.raw.length),ae.push(B);continue}if(!fe&&(B=this.tokenizer.url(se,qe))){se=se.substring(B.raw.length),ae.push(B);continue}if(B=this.tokenizer.inlineText(se,pe,Xe)){se=se.substring(B.raw.length),B.raw.slice(-1)!=="_"&&(He=B.raw.slice(-1)),Oe=!0,me=ae[ae.length-1],me&&me.type==="text"?(me.raw+=B.raw,me.text+=B.text):ae.push(B);continue}if(se){var ut="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ut);break}else throw new Error(ut)}}return ae},e(De,null,[{key:"rules",get:function(){return{block:Ne,inline:Me}}}]),De}(),U=I.defaults,G=F.cleanUrl,X=F.escape,re=function(){function De(Pe){this.options=Pe||U}var Se=De.prototype;return Se.code=function(se,ae,fe){var pe=(ae||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(se,pe);B!=null&&B!==se&&(fe=!0,se=B)}return se=se.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+X(pe,!0)+'">'+(fe?se:X(se,!0))+`</code></pre>
`:"<pre><code>"+(fe?se:X(se,!0))+`</code></pre>
`},Se.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Se.html=function(se){return se},Se.heading=function(se,ae,fe,pe){return this.options.headerIds?"<h"+ae+' id="'+this.options.headerPrefix+pe.slug(fe)+'">'+se+"</h"+ae+`>
`:"<h"+ae+">"+se+"</h"+ae+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(se,ae,fe){var pe=ae?"ol":"ul",B=ae&&fe!==1?' start="'+fe+'"':"";return"<"+pe+B+`>
`+se+"</"+pe+`>
`},Se.listitem=function(se){return"<li>"+se+`</li>
`},Se.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(se){return"<p>"+se+`</p>
`},Se.table=function(se,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ae+`</table>
`},Se.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Se.tablecell=function(se,ae){var fe=ae.header?"th":"td",pe=ae.align?"<"+fe+' align="'+ae.align+'">':"<"+fe+">";return pe+se+"</"+fe+`>
`},Se.strong=function(se){return"<strong>"+se+"</strong>"},Se.em=function(se){return"<em>"+se+"</em>"},Se.codespan=function(se){return"<code>"+se+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(se){return"<del>"+se+"</del>"},Se.link=function(se,ae,fe){if(se=G(this.options.sanitize,this.options.baseUrl,se),se===null)return fe;var pe='<a href="'+X(se)+'"';return ae&&(pe+=' title="'+ae+'"'),pe+=">"+fe+"</a>",pe},Se.image=function(se,ae,fe){if(se=G(this.options.sanitize,this.options.baseUrl,se),se===null)return fe;var pe='<img src="'+se+'" alt="'+fe+'"';return ae&&(pe+=' title="'+ae+'"'),pe+=this.options.xhtml?"/>":">",pe},Se.text=function(se){return se},De}(),q=function(){function De(){}var Se=De.prototype;return Se.strong=function(se){return se},Se.em=function(se){return se},Se.codespan=function(se){return se},Se.del=function(se){return se},Se.html=function(se){return se},Se.text=function(se){return se},Se.link=function(se,ae,fe){return""+fe},Se.image=function(se,ae,fe){return""+fe},Se.br=function(){return""},De}(),ie=function(){function De(){this.seen={}}var Se=De.prototype;return Se.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(se,ae){var fe=se,pe=0;if(this.seen.hasOwnProperty(fe)){pe=this.seen[se];do pe++,fe=se+"-"+pe;while(this.seen.hasOwnProperty(fe))}return ae||(this.seen[se]=pe,this.seen[fe]=0),fe},Se.slug=function(se,ae){ae===void 0&&(ae={});var fe=this.serialize(se);return this.getNextSafeSlug(fe,ae.dryrun)},De}(),ge=I.defaults,Re=F.unescape,We=function(){function De(Pe){this.options=Pe||ge,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new ie}De.parse=function(se,ae){var fe=new De(ae);return fe.parse(se)},De.parseInline=function(se,ae){var fe=new De(ae);return fe.parseInline(se)};var Se=De.prototype;return Se.parse=function(se,ae){ae===void 0&&(ae=!0);var fe="",pe,B,me,we,Ie,Oe,He,Ze,Ke,Je,ut,mt,bt,ot,at,_e,ke,Y,H=se.length;for(pe=0;pe<H;pe++)switch(Je=se[pe],Je.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,Re(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(Ze="",He="",we=Je.header.length,B=0;B<we;B++)He+=this.renderer.tablecell(this.parseInline(Je.tokens.header[B]),{header:!0,align:Je.align[B]});for(Ze+=this.renderer.tablerow(He),Ke="",we=Je.cells.length,B=0;B<we;B++){for(Oe=Je.tokens.cells[B],He="",Ie=Oe.length,me=0;me<Ie;me++)He+=this.renderer.tablecell(this.parseInline(Oe[me]),{header:!1,align:Je.align[me]});Ke+=this.renderer.tablerow(He)}fe+=this.renderer.table(Ze,Ke);continue}case"blockquote":{Ke=this.parse(Je.tokens),fe+=this.renderer.blockquote(Ke);continue}case"list":{for(ut=Je.ordered,mt=Je.start,bt=Je.loose,we=Je.items.length,Ke="",B=0;B<we;B++)at=Je.items[B],_e=at.checked,ke=at.task,ot="",at.task&&(Y=this.renderer.checkbox(_e),bt?at.tokens.length>0&&at.tokens[0].type==="text"?(at.tokens[0].text=Y+" "+at.tokens[0].text,at.tokens[0].tokens&&at.tokens[0].tokens.length>0&&at.tokens[0].tokens[0].type==="text"&&(at.tokens[0].tokens[0].text=Y+" "+at.tokens[0].tokens[0].text)):at.tokens.unshift({type:"text",text:Y}):ot+=Y),ot+=this.parse(at.tokens,bt),Ke+=this.renderer.listitem(ot,ke,_e);fe+=this.renderer.list(Ke,ut,mt);continue}case"html":{fe+=this.renderer.html(Je.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(Ke=Je.tokens?this.parseInline(Je.tokens):Je.text;pe+1<H&&se[pe+1].type==="text";)Je=se[++pe],Ke+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);fe+=ae?this.renderer.paragraph(Ke):Ke;continue}default:{var Fe='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}return fe},Se.parseInline=function(se,ae){ae=ae||this.renderer;var fe="",pe,B,me=se.length;for(pe=0;pe<me;pe++)switch(B=se[pe],B.type){case"escape":{fe+=ae.text(B.text);break}case"html":{fe+=ae.html(B.text);break}case"link":{fe+=ae.link(B.href,B.title,this.parseInline(B.tokens,ae));break}case"image":{fe+=ae.image(B.href,B.title,B.text);break}case"strong":{fe+=ae.strong(this.parseInline(B.tokens,ae));break}case"em":{fe+=ae.em(this.parseInline(B.tokens,ae));break}case"codespan":{fe+=ae.codespan(B.text);break}case"br":{fe+=ae.br();break}case"del":{fe+=ae.del(this.parseInline(B.tokens,ae));break}case"text":{fe+=ae.text(B.text);break}default:{var we='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(we);return}else throw new Error(we)}}return fe},De}(),ve=F.merge,Ye=F.checkSanitizeDeprecation,z=F.escape,Z=I.getDefaults,ce=I.changeDefaults,Ue=I.defaults;function xe(De,Se,Pe){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof Se=="function"&&(Pe=Se,Se=null),Se=ve({},xe.defaults,Se||{}),Ye(Se),Pe){var se=Se.highlight,ae;try{ae=je.lex(De,Se)}catch(me){return Pe(me)}var fe=function(we){var Ie;if(!we)try{Ie=We.parse(ae,Se)}catch(Oe){we=Oe}return Se.highlight=se,we?Pe(we):Pe(null,Ie)};if(!se||se.length<3||(delete Se.highlight,!ae.length))return fe();var pe=0;xe.walkTokens(ae,function(me){me.type==="code"&&(pe++,setTimeout(function(){se(me.text,me.lang,function(we,Ie){if(we)return fe(we);Ie!=null&&Ie!==me.text&&(me.text=Ie,me.escaped=!0),pe--,pe===0&&fe()})},0))}),pe===0&&fe();return}try{var B=je.lex(De,Se);return Se.walkTokens&&xe.walkTokens(B,Se.walkTokens),We.parse(B,Se)}catch(me){if(me.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+z(me.message+"",!0)+"</pre>";throw me}}xe.options=xe.setOptions=function(De){return ve(xe.defaults,De),ce(xe.defaults),xe},xe.getDefaults=Z,xe.defaults=Ue,xe.use=function(De){var Se=ve({},De);if(De.renderer&&function(){var se=xe.defaults.renderer||new re,ae=function(B){var me=se[B];se[B]=function(){for(var we=arguments.length,Ie=new Array(we),Oe=0;Oe<we;Oe++)Ie[Oe]=arguments[Oe];var He=De.renderer[B].apply(se,Ie);return He===!1&&(He=me.apply(se,Ie)),He}};for(var fe in De.renderer)ae(fe);Se.renderer=se}(),De.tokenizer&&function(){var se=xe.defaults.tokenizer||new Q,ae=function(B){var me=se[B];se[B]=function(){for(var we=arguments.length,Ie=new Array(we),Oe=0;Oe<we;Oe++)Ie[Oe]=arguments[Oe];var He=De.tokenizer[B].apply(se,Ie);return He===!1&&(He=me.apply(se,Ie)),He}};for(var fe in De.tokenizer)ae(fe);Se.tokenizer=se}(),De.walkTokens){var Pe=xe.defaults.walkTokens;Se.walkTokens=function(se){De.walkTokens(se),Pe&&Pe(se)}}xe.setOptions(Se)},xe.walkTokens=function(De,Se){for(var Pe=S(De),se;!(se=Pe()).done;){var ae=se.value;switch(Se(ae),ae.type){case"table":{for(var fe=S(ae.tokens.header),pe;!(pe=fe()).done;){var B=pe.value;xe.walkTokens(B,Se)}for(var me=S(ae.tokens.cells),we;!(we=me()).done;)for(var Ie=we.value,Oe=S(Ie),He;!(He=Oe()).done;){var Ze=He.value;xe.walkTokens(Ze,Se)}break}case"list":{xe.walkTokens(ae.items,Se);break}default:ae.tokens&&xe.walkTokens(ae.tokens,Se)}}},xe.parseInline=function(De,Se){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");Se=ve({},xe.defaults,Se||{}),Ye(Se);try{var Pe=je.lexInline(De,Se);return Se.walkTokens&&xe.walkTokens(Pe,Se.walkTokens),We.parseInline(Pe,Se)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+z(se.message+"",!0)+"</pre>";throw se}},xe.Parser=We,xe.parser=We.parse,xe.Renderer=re,xe.TextRenderer=q,xe.Lexer=je,xe.lexer=je.lex,xe.Tokenizer=Q,xe.Slugger=ie,xe.parse=xe;var et=xe;return et}),define(be[81],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(I,y,E){return Math.min(Math.max(I,y),E)}e.clamp=m;function R(I,y){return(y+I%y)%y}e.rot=R;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class _{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=_}),function(){function ee(S){const _=[];typeof S=="number"&&_.push("code/timeOrigin",S);function I(E){_.push(E,Date.now())}function y(){const E=[];for(let k=0;k<_.length;k+=2)E.push({name:_[k],startTime:_[k+1]});return E}return{mark:I,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const I of performance.getEntriesByType("mark"))_.push({name:I.name,startTime:Math.round(S+I.startTime)});return _}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function m(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=m(R))}(),define(be[22],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const m="en";let R=!1,S=!1,_=!1,I=!1,y=!1,E=!1,k=!1,n,C=m,l,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?c=e.globals.vscode.process:typeof process!="undefined"&&(c=process);const g=typeof c?.versions?.electron=="string"&&c.type==="renderer";if(e.isElectronSandboxed=g&&c?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=c?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!g)h=navigator.userAgent,R=h.indexOf("Windows")>=0,S=h.indexOf("Macintosh")>=0,k=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=h.indexOf("Linux")>=0,E=!0,n=navigator.language,C=n;else if(typeof c=="object"){R=c.platform==="win32",S=c.platform==="darwin",_=c.platform==="linux",I=_&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,n=m,C=m;const s=c.env.VSCODE_NLS_CONFIG;if(s)try{const i=JSON.parse(s),u=i.availableLanguages["*"];n=i.locale,C=u||m,l=i._translationsConfigFile}catch(i){}y=!0}else console.error("Unable to resolve platform.");var b;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function w(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let P=0;S?P=1:R?P=3:_&&(P=2),e.isWindows=R,e.isMacintosh=S,e.isLinux=_,e.isLinuxSnap=I,e.isNative=y,e.isWeb=E,e.isIOS=k,e.platform=P,e.userAgent=h,e.language=C;var a;(function(s){function i(){return e.language}s.value=i;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=u;function d(){return e.language==="en"}s.isDefault=d})(a=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=l,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeSetImmediateId)for(let D=0,T=u.length;D<T;D++){const o=u[D];if(o.id===p.data.vscodeSetImmediateId){u.splice(D,1),o.callback();return}}});let d=0;return p=>{const D=++d;u.push({id:D,callback:p}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof c?.nextTick=="function")return c.nextTick.bind(c);const i=Promise.resolve();return u=>i.then(u)}();var f;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||k?2:R?1:3;let v=!0,t=!1;function r(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,v=new Uint16Array(s.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=r}),define(be[42],Ee([0,1,22]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const S=m.globals.vscode.process;R={get platform(){return S.platform},get env(){return S.env},cwd(){return S.cwd()},nextTick(_){return(0,m.setImmediate)(_)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(S){return process.nextTick(S)}}:R={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(S){return(0,m.setImmediate)(S)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(be[14],Ee([0,1,42]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,S=97,_=90,I=122,y=46,E=47,k=92,n=58,C=63;class l extends Error{constructor(f,v,t){let r;typeof v=="string"&&v.indexOf("not ")===0?(r="must not be",v=v.replace(/^not /,"")):r="must be";const s=f.indexOf(".")!==-1?"property":"argument";let i=`The "${f}" ${s} ${r} of type ${v}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function h(a,f){if(typeof a!="string")throw new l(f,"string",a)}function c(a){return a===E||a===k}function g(a){return a===E}function b(a){return a>=R&&a<=_||a>=S&&a<=I}function w(a,f,v,t){let r="",s=0,i=-1,u=0,d=0;for(let p=0;p<=a.length;++p){if(p<a.length)d=a.charCodeAt(p);else{if(t(d))break;d=E}if(t(d)){if(!(i===p-1||u===1))if(u===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==y||r.charCodeAt(r.length-2)!==y){if(r.length>2){const D=r.lastIndexOf(v);D===-1?(r="",s=0):(r=r.slice(0,D),s=r.length-1-r.lastIndexOf(v)),i=p,u=0;continue}else if(r.length!==0){r="",s=0,i=p,u=0;continue}}f&&(r+=r.length>0?`${v}..`:"..",s=2)}else r.length>0?r+=`${v}${a.slice(i+1,p)}`:r=a.slice(i+1,p),s=p-i-1;i=p,u=0}else d===y&&u!==-1?++u:u=-1}return r}function P(a,f){if(f===null||typeof f!="object")throw new l("pathObject","Object",f);const v=f.dir||f.root,t=f.base||`${f.name||""}${f.ext||""}`;return v?v===f.root?`${v}${t}`:`${v}${a}${t}`:t}e.win32={resolve(...a){let f="",v="",t=!1;for(let r=a.length-1;r>=-1;r--){let s;if(r>=0){if(s=a[r],h(s,"path"),s.length===0)continue}else f.length===0?s=m.cwd():(s=m.env[`=${f}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==f.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${f}\\`));const i=s.length;let u=0,d="",p=!1;const D=s.charCodeAt(0);if(i===1)c(D)&&(u=1,p=!0);else if(c(D))if(p=!0,c(s.charCodeAt(1))){let T=2,o=T;for(;T<i&&!c(s.charCodeAt(T));)T++;if(T<i&&T!==o){const A=s.slice(o,T);for(o=T;T<i&&c(s.charCodeAt(T));)T++;if(T<i&&T!==o){for(o=T;T<i&&!c(s.charCodeAt(T));)T++;(T===i||T!==o)&&(d=`\\\\${A}\\${s.slice(o,T)}`,u=T)}}}else u=1;else b(D)&&s.charCodeAt(1)===n&&(d=s.slice(0,2),u=2,i>2&&c(s.charCodeAt(2))&&(p=!0,u=3));if(d.length>0)if(f.length>0){if(d.toLowerCase()!==f.toLowerCase())continue}else f=d;if(t){if(f.length>0)break}else if(v=`${s.slice(u)}\\${v}`,t=p,p&&f.length>0)break}return v=w(v,!t,"\\",c),t?`${f}\\${v}`:`${f}${v}`||"."},normalize(a){h(a,"path");const f=a.length;if(f===0)return".";let v=0,t,r=!1;const s=a.charCodeAt(0);if(f===1)return g(s)?"\\":a;if(c(s))if(r=!0,c(a.charCodeAt(1))){let u=2,d=u;for(;u<f&&!c(a.charCodeAt(u));)u++;if(u<f&&u!==d){const p=a.slice(d,u);for(d=u;u<f&&c(a.charCodeAt(u));)u++;if(u<f&&u!==d){for(d=u;u<f&&!c(a.charCodeAt(u));)u++;if(u===f)return`\\\\${p}\\${a.slice(d)}\\`;u!==d&&(t=`\\\\${p}\\${a.slice(d,u)}`,v=u)}}}else v=1;else b(s)&&a.charCodeAt(1)===n&&(t=a.slice(0,2),v=2,f>2&&c(a.charCodeAt(2))&&(r=!0,v=3));let i=v<f?w(a.slice(v),!r,"\\",c):"";return i.length===0&&!r&&(i="."),i.length>0&&c(a.charCodeAt(f-1))&&(i+="\\"),t===void 0?r?`\\${i}`:i:r?`${t}\\${i}`:`${t}${i}`},isAbsolute(a){h(a,"path");const f=a.length;if(f===0)return!1;const v=a.charCodeAt(0);return c(v)||f>2&&b(v)&&a.charCodeAt(1)===n&&c(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let f,v;for(let s=0;s<a.length;++s){const i=a[s];h(i,"path"),i.length>0&&(f===void 0?f=v=i:f+=`\\${i}`)}if(f===void 0)return".";let t=!0,r=0;if(typeof v=="string"&&c(v.charCodeAt(0))){++r;const s=v.length;s>1&&c(v.charCodeAt(1))&&(++r,s>2&&(c(v.charCodeAt(2))?++r:t=!1))}if(t){for(;r<f.length&&c(f.charCodeAt(r));)r++;r>=2&&(f=`\\${f.slice(r)}`)}return e.win32.normalize(f)},relative(a,f){if(h(a,"from"),h(f,"to"),a===f)return"";const v=e.win32.resolve(a),t=e.win32.resolve(f);if(v===t||(a=v.toLowerCase(),f=t.toLowerCase(),a===f))return"";let r=0;for(;r<a.length&&a.charCodeAt(r)===k;)r++;let s=a.length;for(;s-1>r&&a.charCodeAt(s-1)===k;)s--;const i=s-r;let u=0;for(;u<f.length&&f.charCodeAt(u)===k;)u++;let d=f.length;for(;d-1>u&&f.charCodeAt(d-1)===k;)d--;const p=d-u,D=i<p?i:p;let T=-1,o=0;for(;o<D;o++){const F=a.charCodeAt(r+o);if(F!==f.charCodeAt(u+o))break;F===k&&(T=o)}if(o!==D){if(T===-1)return t}else{if(p>D){if(f.charCodeAt(u+o)===k)return t.slice(u+o+1);if(o===2)return t.slice(u+o)}i>D&&(a.charCodeAt(r+o)===k?T=o:o===2&&(T=3)),T===-1&&(T=0)}let A="";for(o=r+T+1;o<=s;++o)(o===s||a.charCodeAt(o)===k)&&(A+=A.length===0?"..":"\\..");return u+=T,A.length>0?`${A}${t.slice(u,d)}`:(t.charCodeAt(u)===k&&++u,t.slice(u,d))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const f=e.win32.resolve(a);if(f.length<=2)return a;if(f.charCodeAt(0)===k){if(f.charCodeAt(1)===k){const v=f.charCodeAt(2);if(v!==C&&v!==y)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(b(f.charCodeAt(0))&&f.charCodeAt(1)===n&&f.charCodeAt(2)===k)return`\\\\?\\${f}`;return a},dirname(a){h(a,"path");const f=a.length;if(f===0)return".";let v=-1,t=0;const r=a.charCodeAt(0);if(f===1)return c(r)?a:".";if(c(r)){if(v=t=1,c(a.charCodeAt(1))){let u=2,d=u;for(;u<f&&!c(a.charCodeAt(u));)u++;if(u<f&&u!==d){for(d=u;u<f&&c(a.charCodeAt(u));)u++;if(u<f&&u!==d){for(d=u;u<f&&!c(a.charCodeAt(u));)u++;if(u===f)return a;u!==d&&(v=t=u+1)}}}}else b(r)&&a.charCodeAt(1)===n&&(v=f>2&&c(a.charCodeAt(2))?3:2,t=v);let s=-1,i=!0;for(let u=f-1;u>=t;--u)if(c(a.charCodeAt(u))){if(!i){s=u;break}}else i=!1;if(s===-1){if(v===-1)return".";s=v}return a.slice(0,s)},basename(a,f){f!==void 0&&h(f,"ext"),h(a,"path");let v=0,t=-1,r=!0,s;if(a.length>=2&&b(a.charCodeAt(0))&&a.charCodeAt(1)===n&&(v=2),f!==void 0&&f.length>0&&f.length<=a.length){if(f===a)return"";let i=f.length-1,u=-1;for(s=a.length-1;s>=v;--s){const d=a.charCodeAt(s);if(c(d)){if(!r){v=s+1;break}}else u===-1&&(r=!1,u=s+1),i>=0&&(d===f.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=u))}return v===t?t=u:t===-1&&(t=a.length),a.slice(v,t)}for(s=a.length-1;s>=v;--s)if(c(a.charCodeAt(s))){if(!r){v=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":a.slice(v,t)},extname(a){h(a,"path");let f=0,v=-1,t=0,r=-1,s=!0,i=0;a.length>=2&&a.charCodeAt(1)===n&&b(a.charCodeAt(0))&&(f=t=2);for(let u=a.length-1;u>=f;--u){const d=a.charCodeAt(u);if(c(d)){if(!s){t=u+1;break}continue}r===-1&&(s=!1,r=u+1),d===y?v===-1?v=u:i!==1&&(i=1):v!==-1&&(i=-1)}return v===-1||r===-1||i===0||i===1&&v===r-1&&v===t+1?"":a.slice(v,r)},format:P.bind(null,"\\"),parse(a){h(a,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return f;const v=a.length;let t=0,r=a.charCodeAt(0);if(v===1)return c(r)?(f.root=f.dir=a,f):(f.base=f.name=a,f);if(c(r)){if(t=1,c(a.charCodeAt(1))){let T=2,o=T;for(;T<v&&!c(a.charCodeAt(T));)T++;if(T<v&&T!==o){for(o=T;T<v&&c(a.charCodeAt(T));)T++;if(T<v&&T!==o){for(o=T;T<v&&!c(a.charCodeAt(T));)T++;T===v?t=T:T!==o&&(t=T+1)}}}}else if(b(r)&&a.charCodeAt(1)===n){if(v<=2)return f.root=f.dir=a,f;if(t=2,c(a.charCodeAt(2))){if(v===3)return f.root=f.dir=a,f;t=3}}t>0&&(f.root=a.slice(0,t));let s=-1,i=t,u=-1,d=!0,p=a.length-1,D=0;for(;p>=t;--p){if(r=a.charCodeAt(p),c(r)){if(!d){i=p+1;break}continue}u===-1&&(d=!1,u=p+1),r===y?s===-1?s=p:D!==1&&(D=1):s!==-1&&(D=-1)}return u!==-1&&(s===-1||D===0||D===1&&s===u-1&&s===i+1?f.base=f.name=a.slice(i,u):(f.name=a.slice(i,s),f.base=a.slice(i,u),f.ext=a.slice(s,u))),i>0&&i!==t?f.dir=a.slice(0,i-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let f="",v=!1;for(let t=a.length-1;t>=-1&&!v;t--){const r=t>=0?a[t]:m.cwd();h(r,"path"),r.length!==0&&(f=`${r}/${f}`,v=r.charCodeAt(0)===E)}return f=w(f,!v,"/",g),v?`/${f}`:f.length>0?f:"."},normalize(a){if(h(a,"path"),a.length===0)return".";const f=a.charCodeAt(0)===E,v=a.charCodeAt(a.length-1)===E;return a=w(a,!f,"/",g),a.length===0?f?"/":v?"./":".":(v&&(a+="/"),f?`/${a}`:a)},isAbsolute(a){return h(a,"path"),a.length>0&&a.charCodeAt(0)===E},join(...a){if(a.length===0)return".";let f;for(let v=0;v<a.length;++v){const t=a[v];h(t,"path"),t.length>0&&(f===void 0?f=t:f+=`/${t}`)}return f===void 0?".":e.posix.normalize(f)},relative(a,f){if(h(a,"from"),h(f,"to"),a===f||(a=e.posix.resolve(a),f=e.posix.resolve(f),a===f))return"";const v=1,t=a.length,r=t-v,s=1,i=f.length-s,u=r<i?r:i;let d=-1,p=0;for(;p<u;p++){const T=a.charCodeAt(v+p);if(T!==f.charCodeAt(s+p))break;T===E&&(d=p)}if(p===u)if(i>u){if(f.charCodeAt(s+p)===E)return f.slice(s+p+1);if(p===0)return f.slice(s+p)}else r>u&&(a.charCodeAt(v+p)===E?d=p:p===0&&(d=0));let D="";for(p=v+d+1;p<=t;++p)(p===t||a.charCodeAt(p)===E)&&(D+=D.length===0?"..":"/..");return`${D}${f.slice(s+d)}`},toNamespacedPath(a){return a},dirname(a){if(h(a,"path"),a.length===0)return".";const f=a.charCodeAt(0)===E;let v=-1,t=!0;for(let r=a.length-1;r>=1;--r)if(a.charCodeAt(r)===E){if(!t){v=r;break}}else t=!1;return v===-1?f?"/":".":f&&v===1?"//":a.slice(0,v)},basename(a,f){f!==void 0&&h(f,"ext"),h(a,"path");let v=0,t=-1,r=!0,s;if(f!==void 0&&f.length>0&&f.length<=a.length){if(f===a)return"";let i=f.length-1,u=-1;for(s=a.length-1;s>=0;--s){const d=a.charCodeAt(s);if(d===E){if(!r){v=s+1;break}}else u===-1&&(r=!1,u=s+1),i>=0&&(d===f.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=u))}return v===t?t=u:t===-1&&(t=a.length),a.slice(v,t)}for(s=a.length-1;s>=0;--s)if(a.charCodeAt(s)===E){if(!r){v=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":a.slice(v,t)},extname(a){h(a,"path");let f=-1,v=0,t=-1,r=!0,s=0;for(let i=a.length-1;i>=0;--i){const u=a.charCodeAt(i);if(u===E){if(!r){v=i+1;break}continue}t===-1&&(r=!1,t=i+1),u===y?f===-1?f=i:s!==1&&(s=1):f!==-1&&(s=-1)}return f===-1||t===-1||s===0||s===1&&f===t-1&&f===v+1?"":a.slice(f,t)},format:P.bind(null,"/"),parse(a){h(a,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return f;const v=a.charCodeAt(0)===E;let t;v?(f.root="/",t=1):t=0;let r=-1,s=0,i=-1,u=!0,d=a.length-1,p=0;for(;d>=t;--d){const D=a.charCodeAt(d);if(D===E){if(!u){s=d+1;break}continue}i===-1&&(u=!1,i=d+1),D===y?r===-1?r=d:p!==1&&(p=1):r!==-1&&(p=-1)}if(i!==-1){const D=s===0&&v?1:s;r===-1||p===0||p===1&&r===i-1&&r===s+1?f.base=f.name=a.slice(D,i):(f.name=a.slice(D,r),f.base=a.slice(D,i),f.ext=a.slice(r,i))}return s>0?f.dir=a.slice(0,s-1):v&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[56],Ee([0,1,22]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=m.globals.performance&&typeof m.globals.performance.now=="function";class S{constructor(I){this._highResolution=R&&I,this._startTime=this._now(),this._stopTime=-1}static create(I=!0){return new S(I)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=S}),define(be[3],Ee([0,1,12,53,6,80,56]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var y;(function(a){a.None=()=>S.Disposable.None;function f(oe){return(V,W=null,L)=>{let Q=!1,O;return O=oe(j=>{if(!Q)return O?O.dispose():Q=!0,V.call(W,j)},null,L),Q&&O.dispose(),O}}a.once=f;function v(oe,V){return d((W,L=null,Q)=>oe(O=>W.call(L,V(O)),null,Q))}a.map=v;function t(oe,V){return d((W,L=null,Q)=>oe(O=>{V(O),W.call(L,O)},null,Q))}a.forEach=t;function r(oe,V){return d((W,L=null,Q)=>oe(O=>V(O)&&W.call(L,O),null,Q))}a.filter=r;function s(oe){return oe}a.signal=s;function i(...oe){return(V,W=null,L)=>(0,S.combinedDisposable)(...oe.map(Q=>Q(O=>V.call(W,O),null,L)))}a.any=i;function u(oe,V,W){let L=W;return v(oe,Q=>(L=V(L,Q),L))}a.reduce=u;function d(oe){let V;const W=new l({onFirstListenerAdd(){V=oe(W.fire,W)},onLastListenerRemove(){V.dispose()}});return W.event}function p(oe,V,W=100,L=!1,Q){let O,j,he,$=0;const ne=new l({leakWarningThreshold:Q,onFirstListenerAdd(){O=oe(de=>{$++,j=V(j,de),L&&!he&&(ne.fire(j),j=void 0),clearTimeout(he),he=setTimeout(()=>{const ye=j;j=void 0,he=void 0,(!L||$>1)&&ne.fire(ye),$=0},W)})},onLastListenerRemove(){O.dispose()}});return ne.event}a.debounce=p;function D(oe,V=(W,L)=>W===L){let W=!0,L;return r(oe,Q=>{const O=W||!V(Q,L);return W=!1,L=Q,O})}a.latch=D;function T(oe,V){return[a.filter(oe,V),a.filter(oe,W=>!V(W))]}a.split=T;function o(oe,V=!1,W=[]){let L=W.slice(),Q=oe(he=>{L?L.push(he):j.fire(he)});const O=()=>{L&&L.forEach(he=>j.fire(he)),L=null},j=new l({onFirstListenerAdd(){Q||(Q=oe(he=>j.fire(he)))},onFirstListenerDidAdd(){L&&(V?setTimeout(O):O())},onLastListenerRemove(){Q&&Q.dispose(),Q=null}});return j.event}a.buffer=o;class A{constructor(V){this.event=V}map(V){return new A(v(this.event,V))}forEach(V){return new A(t(this.event,V))}filter(V){return new A(r(this.event,V))}reduce(V,W){return new A(u(this.event,V,W))}latch(){return new A(D(this.event))}debounce(V,W=100,L=!1,Q){return new A(p(this.event,V,W,L,Q))}on(V,W,L){return this.event(V,W,L)}once(V,W,L){return f(this.event)(V,W,L)}}function F(oe){return new A(oe)}a.chain=F;function x(oe,V,W=L=>L){const L=(...he)=>j.fire(W(...he)),Q=()=>oe.on(V,L),O=()=>oe.removeListener(V,L),j=new l({onFirstListenerAdd:Q,onLastListenerRemove:O});return j.event}a.fromNodeEventEmitter=x;function K(oe,V,W=L=>L){const L=(...he)=>j.fire(W(...he)),Q=()=>oe.addEventListener(V,L),O=()=>oe.removeEventListener(V,L),j=new l({onFirstListenerAdd:Q,onLastListenerRemove:O});return j.event}a.fromDOMEventEmitter=K;function le(oe){return new Promise(V=>f(oe)(V))}a.toPromise=le})(y=e.Event||(e.Event={}));class E{constructor(f){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${f}_${E._idPool++}`}start(f){this._stopWatch=new I.StopWatch(!0),this._listenerCount=f}stop(){if(this._stopWatch){const f=this._stopWatch.elapsed();this._elapsedOverall+=f,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${f.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let k=-1;function n(a){const f=k;return k=a,{dispose(){k=f}}}e.setGlobalLeakWarningThreshold=n;class C{constructor(f,v=Math.random().toString(18).slice(2,5)){this.customThreshold=f,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(f){let v=k;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||f<v)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let s,i=0;for(const[u,d]of this._stacks)(!s||i<d)&&(s=u,i=d);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${i}):`),console.warn(s)}return()=>{const s=this._stacks.get(t)||0;this._stacks.set(t,s-1)}}}class l{constructor(f){this._disposed=!1,this._options=f,this._leakageMon=k>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0}get event(){return this._event||(this._event=(f,v,t)=>{this._listeners||(this._listeners=new _.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(v?[f,v]:f);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,f,v);const i=this._leakageMon?.check(this._listeners.size),u=(0,S.toDisposable)(()=>{i&&i(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof S.DisposableStore?t.add(u):Array.isArray(t)&&t.push(u),u}),this._event}fire(f){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,f]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(r){(0,m.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class h extends l{async fireAsync(f,v,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,f]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[r,s]=this._asyncDeliveryQueue.shift(),i=[],u={...s,waitUntil:d=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(d=t(d,typeof r=="function"?r:r[0])),i.push(d)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(d){(0,m.onUnexpectedError)(d);continue}Object.freeze(i),await Promise.allSettled(i).then(d=>{for(const p of d)p.status==="rejected"&&(0,m.onUnexpectedError)(p.reason)})}}}}e.AsyncEmitter=h;class c extends l{constructor(f){super(f);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=f?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const f=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(f))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(f){this._listeners&&(this._isPaused!==0?this._eventQueue.push(f):super.fire(f))}}e.PauseableEmitter=c;class g extends c{constructor(f){super(f);this._delay=f.delay??100}fire(f){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(f)}}e.DebounceEmitter=g;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(f){const v={event:f,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const t=()=>{this.hasListeners&&this.unhook(v);const r=this.events.indexOf(v);this.events.splice(r,1)};return(0,S.toDisposable)((0,R.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(f=>this.hook(f))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(f=>this.unhook(f))}hook(f){f.listener=f.event(v=>this.emitter.fire(v))}unhook(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class w{constructor(){this.buffers=[]}wrapEvent(f){return(v,t,r)=>f(s=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>v.call(t,s)):v.call(t,s)},void 0,r)}bufferEvents(f){const v=[];this.buffers.push(v);const t=f();return this.buffers.pop(),v.forEach(r=>r()),t}}e.EventBufferer=w;class P{constructor(){this.listening=!1,this.inputEvent=y.None,this.inputEventListener=S.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(f){this.inputEvent=f,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=f(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(be[20],Ee([0,1,3]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(y,E){const k=setTimeout(y.bind(E),0);return{dispose(){clearTimeout(k)}}});var S;(function(y){function E(k){return k===y.None||k===y.Cancelled||k instanceof _?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}y.isCancellationToken=E,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(S=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=S.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=I}),define(be[35],Ee([0,1,3]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(C){const l=this._icons.get(C.id);l?C.description?l.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const S=new R;e.iconRegistry=S;function _(n,C){return new y(n,C)}e.registerCodicon=_;function I(n){return n?n.replace(/\$\((.*?)\)/g,(C,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=I;class y{constructor(C,l,h){this.id=C,this.definition=l,this.description=h,S.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=y;function E(n,C){const l=["codicon","codicon-"+n];return C&&l.push("codicon-modifier-"+C),l}e.getClassNamesArray=E;var k;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function l(g){if(g instanceof y)return["codicon","codicon-"+g.id];const b=C.exec(g.id);if(!b)return l(y.error);let[,w,P]=b;const a=["codicon","codicon-"+w];return P&&a.push("codicon-modifier-"+P.substr(1)),a}n.asClassNameArray=l;function h(g){return l(g).join(" ")}n.asClassName=h;function c(g){return"."+l(g).join(".")}n.asCSSSelector=c})(k=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(y=e.Codicon||(e.Codicon={}))}),define(be[113],Ee([0,1,12,6]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(a){const f=a;return f?[f.on,f.pause,f.resume,f.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=S;function _(a){const f=a;return f?S(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=_;function I(a,f){return new y(a,f)}e.newWriteableStream=I;class y{constructor(f,v){this.reducer=f,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(v=>v(f))}emitError(f){this.listeners.error.length===0?(0,m.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(v=>v(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,v){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(f,v){if(this.state.destroyed)return;let t;switch(f){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(v);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(a,f){const v=[];let t;for(;(t=a.read())!==null;)v.push(t);return f(v)}e.consumeReadable=E;function k(a,f,v){const t=[];let r;for(;(r=a.read())!==null&&t.length<v;)t.push(r);return r===null&&t.length>0?f(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return a.read()}}}e.peekReadable=k;function n(a,f){return new Promise((v,t)=>{const r=[];C(a,{onData:s=>{f&&r.push(s)},onError:s=>{f?t(s):v(void 0)},onEnd:()=>{v(f?f(r):void 0)}})})}e.consumeStream=n;function C(a,f){a.on("error",v=>f.onError(v)),a.on("end",()=>f.onEnd()),a.on("data",v=>f.onData(v))}e.listenStream=C;function l(a,f){return new Promise((v,t)=>{const r=new R.DisposableStore,s=[],i=p=>{if(s.push(p),s.length>f)return r.dispose(),a.pause(),v({stream:a,buffer:s,ended:!1})},u=p=>t(p),d=()=>v({stream:a,buffer:s,ended:!0});r.add((0,R.toDisposable)(()=>a.removeListener("error",u))),a.on("error",u),r.add((0,R.toDisposable)(()=>a.removeListener("end",d))),a.on("end",d),r.add((0,R.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=l;function h(a,f){const v=I(f);return v.end(a),v}e.toStream=h;function c(){const a=I(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=c;function g(a){let f=!1;return{read:()=>f?null:(f=!0,a)}}e.toReadable=g;function b(a,f,v){const t=I(v);return C(a,{onData:r=>t.write(f.data(r)),onError:r=>t.error(f.error?f.error(r):r),onEnd:()=>t.end()}),t}e.transform=b;function w(a,f,v){let t=!1;return{read:()=>{const r=f.read();return t?r:(t=!0,r!==null?v([a,r]):a)}}}e.prefixedReadable=w;function P(a,f,v){let t=!1;const r=I(v);return C(f,{onData:s=>t?r.write(s):(t=!0,r.write(v([a,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(a)),r.end()}}),r}e.prefixedStream=P}),define(be[8],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=m;const R=/{(\d+)}/g;function S(B,...me){return me.length===0?B:B.replace(R,function(we,Ie){const Oe=parseInt(Ie,10);return isNaN(Oe)||Oe<0||Oe>=me.length?we:me[Oe]})}e.format=S;const _=/{([^}]+)}/g;function I(B,me){return B.replace(_,(we,Ie)=>me[Ie]??we)}e.format2=I;function y(B){return B.replace(/[<>&]/g,function(me){switch(me){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return me}})}e.escape=y;function E(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function k(B,me){let we=0;const Ie=me.charCodeAt(0);for(let Oe=B.length-1;Oe>=0;Oe--)B.charCodeAt(Oe)===Ie&&we++;return we}e.count=k;function n(B,me,we="\u2026"){return B.length<=me?B:`${B.substr(0,me)}${we}`}e.truncate=n;function C(B,me=" "){const we=l(B,me);return h(we,me)}e.trim=C;function l(B,me){if(!B||!me)return B;const we=me.length;if(we===0||B.length===0)return B;let Ie=0;for(;B.indexOf(me,Ie)===Ie;)Ie=Ie+we;return B.substring(Ie)}e.ltrim=l;function h(B,me){if(!B||!me)return B;const we=me.length,Ie=B.length;if(we===0||Ie===0)return B;let Oe=Ie,He=-1;for(;He=B.lastIndexOf(me,Oe-1),!(He===-1||He+we!==Oe);){if(He===0)return"";Oe=He}return B.substring(0,Oe)}e.rtrim=h;function c(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function g(B){return B.replace(/\*/g,"")}e.stripWildcards=g;function b(B,me,we={}){if(!B)throw new Error("Cannot create regex from empty string");me||(B=E(B)),we.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let Ie="";return we.global&&(Ie+="g"),we.matchCase||(Ie+="i"),we.multiline&&(Ie+="m"),we.unicode&&(Ie+="u"),new RegExp(B,Ie)}e.createRegExp=b;function w(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function P(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function a(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=a;function f(B){return B.split(/\r\n|\r|\n/)}e.splitLines=f;function v(B){for(let me=0,we=B.length;me<we;me++){const Ie=B.charCodeAt(me);if(Ie!==32&&Ie!==9)return me}return-1}e.firstNonWhitespaceIndex=v;function t(B,me=0,we=B.length){for(let Ie=me;Ie<we;Ie++){const Oe=B.charCodeAt(Ie);if(Oe!==32&&Oe!==9)return B.substring(me,Ie)}return B.substring(me,we)}e.getLeadingWhitespace=t;function r(B,me=B.length-1){for(let we=me;we>=0;we--){const Ie=B.charCodeAt(we);if(Ie!==32&&Ie!==9)return we}return-1}e.lastNonWhitespaceIndex=r;function s(B,me){return B<me?-1:B>me?1:0}e.compare=s;function i(B,me,we=0,Ie=B.length,Oe=0,He=me.length){for(;we<Ie&&Oe<He;we++,Oe++){let Je=B.charCodeAt(we),ut=me.charCodeAt(Oe);if(Je<ut)return-1;if(Je>ut)return 1}const Ze=Ie-we,Ke=He-Oe;return Ze<Ke?-1:Ze>Ke?1:0}e.compareSubstring=i;function u(B,me){return d(B,me,0,B.length,0,me.length)}e.compareIgnoreCase=u;function d(B,me,we=0,Ie=B.length,Oe=0,He=me.length){for(;we<Ie&&Oe<He;we++,Oe++){let Je=B.charCodeAt(we),ut=me.charCodeAt(Oe);if(Je===ut)continue;const mt=Je-ut;if(!(mt===32&&D(ut))&&!(mt===-32&&D(Je)))return p(Je)&&p(ut)?mt:i(B.toLowerCase(),me.toLowerCase(),we,Ie,Oe,He)}const Ze=Ie-we,Ke=He-Oe;return Ze<Ke?-1:Ze>Ke?1:0}e.compareSubstringIgnoreCase=d;function p(B){return B>=97&&B<=122}e.isLowerAsciiLetter=p;function D(B){return B>=65&&B<=90}e.isUpperAsciiLetter=D;function T(B){return p(B)||D(B)}function o(B,me){return B.length===me.length&&A(B,me)}e.equalsIgnoreCase=o;function A(B,me,we=B.length){for(let Ie=0;Ie<we;Ie++){const Oe=B.charCodeAt(Ie),He=me.charCodeAt(Ie);if(Oe!==He){if(T(Oe)&&T(He)){const Ze=Math.abs(Oe-He);if(Ze!==0&&Ze!==32)return!1}else if(String.fromCharCode(Oe).toLowerCase()!==String.fromCharCode(He).toLowerCase())return!1}}return!0}function F(B,me){const we=me.length;return me.length>B.length?!1:A(B,me,we)}e.startsWithIgnoreCase=F;function x(B,me){let we,Ie=Math.min(B.length,me.length);for(we=0;we<Ie;we++)if(B.charCodeAt(we)!==me.charCodeAt(we))return we;return Ie}e.commonPrefixLength=x;function K(B,me){let we,Ie=Math.min(B.length,me.length);const Oe=B.length-1,He=me.length-1;for(we=0;we<Ie;we++)if(B.charCodeAt(Oe-we)!==me.charCodeAt(He-we))return we;return Ie}e.commonSuffixLength=K;function le(B){return 55296<=B&&B<=56319}e.isHighSurrogate=le;function oe(B){return 56320<=B&&B<=57343}e.isLowSurrogate=oe;function V(B,me){return(B-55296<<10)+(me-56320)+65536}e.computeCodePoint=V;function W(B,me,we){const Ie=B.charCodeAt(we);if(le(Ie)&&we+1<me){const Oe=B.charCodeAt(we+1);if(oe(Oe))return V(Ie,Oe)}return Ie}e.getNextCodePoint=W;function L(B,me){const we=B.charCodeAt(me-1);if(oe(we)&&me>1){const Ie=B.charCodeAt(me-2);if(le(Ie))return V(Ie,we)}return we}function Q(B,me){const we=De.getInstance(),Ie=me,Oe=B.length,He=W(B,Oe,me);me+=He>=65536?2:1;let Ze=we.getGraphemeBreakType(He);for(;me<Oe;){const Ke=W(B,Oe,me),Je=we.getGraphemeBreakType(Ke);if(xe(Ze,Je))break;me+=Ke>=65536?2:1,Ze=Je}return me-Ie}e.nextCharLength=Q;function O(B,me){const we=De.getInstance(),Ie=me,Oe=L(B,me);me-=Oe>=65536?2:1;let He=we.getGraphemeBreakType(Oe);for(;me>0;){const Ze=L(B,me),Ke=we.getGraphemeBreakType(Ze);if(xe(Ke,He))break;me-=Ze>=65536?2:1,He=Ke}return Ie-me}e.prevCharLength=O;function j(B,me){const we=De.getInstance(),Ie=B.length,Oe=me,He=W(B,Ie,me),Ze=we.getGraphemeBreakType(He);me+=He>=65536?2:1;let Ke=Ze;for(;me<Ie;){const ut=W(B,Ie,me),mt=we.getGraphemeBreakType(ut);if(xe(Ke,mt))break;me+=ut>=65536?2:1,Ke=mt}const Je=me;for(me=Oe,Ke=Ze;me>0;){const ut=L(B,me),mt=we.getGraphemeBreakType(ut);if(xe(mt,Ke))break;me-=ut>=65536?2:1,Ke=mt}return[me,Je]}function he(B,me){return me>0&&oe(B.charCodeAt(me))?j(B,me-1):j(B,me)}e.getCharContainingOffset=he;function $(B){const me=B.length;let we=0,Ie=0;for(;Ie<me;){const Ze=W(B,me,Ie);Ie+=Ze>=65536?2:1,Ze<128?we+=1:Ze<2048?we+=2:Ze<65536?we+=3:we+=4}const Oe=new Uint8Array(we);Ie=0;let He=0;for(;Ie<me;){const Ze=W(B,me,Ie);Ie+=Ze>=65536?2:1,Ze<128?Oe[He++]=Ze:Ze<2048?(Oe[He++]=192|(Ze&1984)>>>6,Oe[He++]=128|(Ze&63)>>>0):Ze<65536?(Oe[He++]=224|(Ze&61440)>>>12,Oe[He++]=128|(Ze&4032)>>>6,Oe[He++]=128|(Ze&63)>>>0):(Oe[He++]=240|(Ze&1835008)>>>18,Oe[He++]=128|(Ze&258048)>>>12,Oe[He++]=128|(Ze&4032)>>>6,Oe[He++]=128|(Ze&63)>>>0)}return Oe}e.encodeUTF8=$;function ne(B){const me=B.byteLength,we=[];let Ie=0;for(;Ie<me;){const Oe=B[Ie];let He;if(Oe>=240&&Ie+3<me?He=(B[Ie++]&7)<<18>>>0|(B[Ie++]&63)<<12>>>0|(B[Ie++]&63)<<6>>>0|(B[Ie++]&63)<<0>>>0:Oe>=224&&Ie+2<me?He=(B[Ie++]&15)<<12>>>0|(B[Ie++]&63)<<6>>>0|(B[Ie++]&63)<<0>>>0:Oe>=192&&Ie+1<me?He=(B[Ie++]&31)<<6>>>0|(B[Ie++]&63)<<0>>>0:He=B[Ie++],He>=0&&He<=55295||He>=57344&&He<=65535)we.push(String.fromCharCode(He));else if(He>=65536&&He<=1114111){const Ze=He-65536,Ke=55296+((Ze&1047552)>>>10),Je=56320+((Ze&1023)>>>0);we.push(String.fromCharCode(Ke)),we.push(String.fromCharCode(Je))}else we.push(String.fromCharCode(65533))}return we.join("")}e.decodeUTF8=ne;const de=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ye(B){return de.test(B)}e.containsRTL=ye;const Ne=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Me(B){return Ne.test(B)}e.containsEmoji=Me;const $e=/^[\t\n\r\x20-\x7E]*$/;function Xe(B){return $e.test(B)}e.isBasicASCII=Xe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function qe(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=qe;function je(B){for(let me=0,we=B.length;me<we;me++)if(U(B.charCodeAt(me)))return!0;return!1}e.containsFullWidthCharacter=je;function U(B){return B=+B,B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=U;function G(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129003||B>=129280&&B<=129535||B>=129648&&B<=129750}e.isEmojiImprecise=G;function X(B,me){if(B.length<me)return B;const we=/\b/g;let Ie=0;for(;we.test(B)&&!(B.length-we.lastIndex<me);)Ie=we.lastIndex,we.lastIndex+=1;return B.substring(Ie).replace(/^\s/,"")}e.lcut=X;const re=/\x1B\x5B[12]?K/g,q=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function ge(B){return B&&(B=B.replace(re,""),B=B.replace(q,""),B=B.replace(ie,"")),B}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function We(B){return Re(B)?B.substr(1):B}e.stripUTF8BOM=We;function ve(B,me){if(!B||!me||B.length<me.length)return!1;const we=me.length,Ie=B.toLowerCase();let Oe=0,He=-1;for(;Oe<we;){const Ze=Ie.indexOf(me[Oe],He+1);if(Ze<0)return!1;He=Ze,Oe++}return!0}e.fuzzyContains=ve;function Ye(B,me=!1){return B?(me&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=Ye;function z(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=z;function Z(B,me=1){if(me===0)return"";let we=-1;do we=B.indexOf(`
`,we+1),me--;while(me>0&&we>=0);return we===-1?B:(B[we-1]==="\r"&&we--,B.substr(0,we))}e.getNLines=Z;function ce(B){const me=90-65+1;return B=B%(2*me),B<me?String.fromCharCode(97+B):String.fromCharCode(65+B-me)}e.singleLetterHash=ce;function Ue(B){return De.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=Ue;function xe(B,me){return B===0?me!==5&&me!==7:B===2&&me===3?!1:B===4||B===2||B===3||me===4||me===2||me===3?!0:!(B===8&&(me===8||me===9||me===11||me===12)||(B===11||B===9)&&(me===9||me===10)||(B===12||B===10)&&me===10||me===5||me===13||me===7||B===1||B===13&&me===14||B===6&&me===6)}e.breakBetweenGraphemeBreakType=xe;var et;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class De{constructor(){this._data=Se()}static getInstance(){return De._INSTANCE||(De._INSTANCE=new De),De._INSTANCE}getGraphemeBreakType(me){if(me<32)return me===10?3:me===13?2:4;if(me<127)return 0;const we=this._data,Ie=we.length/3;let Oe=1;for(;Oe<=Ie;)if(me<we[3*Oe])Oe=2*Oe;else if(me>we[3*Oe+1])Oe=2*Oe+1;else return we[3*Oe+2];return 0}}De._INSTANCE=null;function Se(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Pe(B,me){if(B===0)return 0;const we=se(B,me);if(we!==void 0)return we;const Ie=L(me,B);return B-=ae(Ie),B}e.getLeftDeleteOffset=Pe;function se(B,me){let we=L(me,B);for(B-=ae(we);fe(we)||we===65039||we===8419;){if(B===0)return;we=L(me,B),B-=ae(we)}if(!!G(we)){if(B>=0){const Ie=L(me,B);Ie===8205&&(B-=ae(Ie))}return B}}function ae(B){return B>=65536?2:1}function fe(B){return 127995<=B&&B<=127999}var pe;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(pe||(pe={}))}),define(be[24],Ee([0,1,8,113]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const S=typeof Buffer!="undefined",_=typeof TextEncoder!="undefined",I=typeof TextDecoder!="undefined";let y,E;class k{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return S?new k(Buffer.allocUnsafe(p)):new k(new Uint8Array(p))}static wrap(p){return S&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new k(p)}static fromString(p,D){return!(D?.dontUseNodeBuffer||!1)&&S?new k(Buffer.from(p)):_?(y||(y=new TextEncoder),new k(y.encode(p))):new k(m.encodeUTF8(p))}static concat(p,D){if(typeof D=="undefined"){D=0;for(let A=0,F=p.length;A<F;A++)D+=p[A].byteLength}const T=k.alloc(D);let o=0;for(let A=0,F=p.length;A<F;A++){const x=p[A];T.set(x,o),o+=x.byteLength}return T}toString(){return S?this.buffer.toString():I?(E||(E=new TextDecoder),E.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(p,D){return new k(this.buffer.subarray(p,D))}set(p,D){p instanceof k?this.buffer.set(p.buffer,D):this.buffer.set(p,D)}readUInt32BE(p){return l(this.buffer,p)}writeUInt32BE(p,D){h(this.buffer,p,D)}readUInt32LE(p){return c(this.buffer,p)}writeUInt32LE(p,D){g(this.buffer,p,D)}readUInt8(p){return b(this.buffer,p)}writeUInt8(p,D){w(this.buffer,p,D)}}e.VSBuffer=k;function n(d,p){return d[p+0]<<0>>>0|d[p+1]<<8>>>0}e.readUInt16LE=n;function C(d,p,D){d[D+0]=p&255,p=p>>>8,d[D+1]=p&255}e.writeUInt16LE=C;function l(d,p){return d[p]*2**24+d[p+1]*2**16+d[p+2]*2**8+d[p+3]}e.readUInt32BE=l;function h(d,p,D){d[D+3]=p,p=p>>>8,d[D+2]=p,p=p>>>8,d[D+1]=p,p=p>>>8,d[D]=p}e.writeUInt32BE=h;function c(d,p){return d[p+0]<<0>>>0|d[p+1]<<8>>>0|d[p+2]<<16>>>0|d[p+3]<<24>>>0}e.readUInt32LE=c;function g(d,p,D){d[D+0]=p&255,p=p>>>8,d[D+1]=p&255,p=p>>>8,d[D+2]=p&255,p=p>>>8,d[D+3]=p&255}e.writeUInt32LE=g;function b(d,p){return d[p]}e.readUInt8=b;function w(d,p,D){d[D]=p}e.writeUInt8=w;function P(d){return R.consumeReadable(d,p=>k.concat(p))}e.readableToBuffer=P;function a(d){return R.toReadable(d)}e.bufferToReadable=a;function f(d){return R.consumeStream(d,p=>k.concat(p))}e.streamToBuffer=f;async function v(d){return d.ended?k.concat(d.buffer):k.concat([...d.buffer,await f(d.stream)])}e.bufferedStreamToBuffer=v;function t(d){return R.toStream(d,p=>k.concat(p))}e.bufferToStream=t;function r(d){return R.transform(d,{data:p=>typeof p=="string"?k.fromString(p):k.wrap(p)},p=>k.concat(p))}e.streamToBufferReadableStream=r;function s(d){return R.newWriteableStream(p=>k.concat(p),d)}e.newWriteableBufferStream=s;function i(d,p){return R.prefixedReadable(d,p,D=>k.concat(D))}e.prefixedBufferReadable=i;function u(d,p){return R.prefixedStream(d,p,D=>k.concat(D))}e.prefixedBufferStream=u}),define(be[43],Ee([0,1,8]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return S(w,0)}e.hash=R;function S(w,P){switch(typeof w){case"object":return w===null?_(349,P):Array.isArray(w)?E(w,P):k(w,P);case"string":return y(w,P);case"boolean":return I(w,P);case"number":return _(w,P);case"undefined":return _(937,P);default:return _(617,P)}}e.doHash=S;function _(w,P){return(P<<5)-P+w|0}function I(w,P){return _(w?433:863,P)}function y(w,P){P=_(149417,P);for(let a=0,f=w.length;a<f;a++)P=_(w.charCodeAt(a),P);return P}e.stringHash=y;function E(w,P){return P=_(104579,P),w.reduce((a,f)=>S(f,a),P)}function k(w,P){return P=_(181387,P),Object.keys(w).sort().reduce((a,f)=>(a=y(f,a),S(w[f],a)),P)}class n{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=S(P,this._value),this._value}}e.Hasher=n;var C;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function l(w,P,a=32){const f=a-P,v=~((1<<f)-1);return(w<<P|(v&w)>>>f)>>>0}function h(w,P=0,a=w.byteLength,f=0){for(let v=0;v<a;v++)w[P+v]=f}function c(w,P,a="0"){for(;w.length<P;)w=a+w;return w}function g(w,P=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(a=>a.toString(16).padStart(2,"0")).join(""):c((w>>>0).toString(16),P/4)}e.toHexString=g;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const a=P.length;if(a===0)return;const f=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=P.charCodeAt(0),s=0);;){let i=r;if(m.isHighSurrogate(r))if(s+1<a){const u=P.charCodeAt(s+1);m.isLowSurrogate(u)?(s++,i=m.computeCodePoint(r,u)):i=65533}else{t=r;break}else m.isLowSurrogate(r)&&(i=65533);if(v=this._push(f,v,i),s++,s<a)r=P.charCodeAt(s);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(P,a,f){return f<128?P[a++]=f:f<2048?(P[a++]=192|(f&1984)>>>6,P[a++]=128|(f&63)>>>0):f<65536?(P[a++]=224|(f&61440)>>>12,P[a++]=128|(f&4032)>>>6,P[a++]=128|(f&63)>>>0):(P[a++]=240|(f&1835008)>>>18,P[a++]=128|(f&258048)>>>12,P[a++]=128|(f&4032)>>>6,P[a++]=128|(f&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=b._bigBlock32,a=this._buffDV;for(let p=0;p<64;p+=4)P.setUint32(p,a.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)P.setUint32(p,l(P.getUint32(p-12,!1)^P.getUint32(p-32,!1)^P.getUint32(p-56,!1)^P.getUint32(p-64,!1),1),!1);let f=this._h0,v=this._h1,t=this._h2,r=this._h3,s=this._h4,i,u,d;for(let p=0;p<80;p++)p<20?(i=v&t|~v&r,u=1518500249):p<40?(i=v^t^r,u=1859775393):p<60?(i=v&t|v&r|t&r,u=2400959708):(i=v^t^r,u=3395469782),d=l(f,5)+i+s+u+P.getUint32(p*4,!1)&4294967295,s=r,r=t,t=l(v,30),v=f,f=d;this._h0=this._h0+f&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[36],Ee([0,1,8]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(R||(R={})),function(S){const _="error",I="warning",y="warn",E="info",k="ignore";function n(l){return l?m.equalsIgnoreCase(_,l)?S.Error:m.equalsIgnoreCase(I,l)||m.equalsIgnoreCase(y,l)?S.Warning:m.equalsIgnoreCase(E,l)?S.Info:S.Ignore:S.Ignore}S.fromValue=n;function C(l){switch(l){case S.Error:return _;case S.Warning:return I;case S.Info:return E;default:return k}}S.toString=C}(R||(R={})),e.default=R}),define(be[10],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(p){return Array.isArray(p)}e.isArray=m;function R(p){return typeof p=="string"}e.isString=R;function S(p){return Array.isArray(p)&&p.every(D=>R(D))}e.isStringArray=S;function _(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=_;function I(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=I;function y(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=y;function E(p){return p===!0||p===!1}e.isBoolean=E;function k(p){return typeof p=="undefined"}e.isUndefined=k;function n(p){return!C(p)}e.isDefined=n;function C(p){return k(p)||p===null}e.isUndefinedOrNull=C;function l(p,D){if(!p)throw new Error(D?`Unexpected type, expected '${D}'`:"Unexpected type")}e.assertType=l;function h(p){if(C(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=h;function c(...p){const D=[];for(let T=0;T<p.length;T++){const o=p[T];if(C(o))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);D.push(o)}return D}e.assertAllDefined=c;const g=Object.prototype.hasOwnProperty;function b(p){if(!_(p))return!1;for(let D in p)if(g.call(p,D))return!1;return!0}e.isEmptyObject=b;function w(p){return typeof p=="function"}e.isFunction=w;function P(...p){return p.length>0&&p.every(w)}e.areFunctions=P;function a(p,D){const T=Math.min(p.length,D.length);for(let o=0;o<T;o++)f(p[o],D[o])}e.validateConstraints=a;function f(p,D){if(R(D)){if(typeof p!==D)throw new Error(`argument does not match constraint: typeof ${D}`)}else if(w(D)){try{if(p instanceof D)return}catch{}if(!C(p)&&p.constructor===D||D.length===1&&D.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function v(p){let D=[],T=Object.getPrototypeOf(p);for(;Object.prototype!==T;)D=D.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return D}e.getAllPropertyNames=v;function t(p){const D=[];for(const T of v(p))typeof p[T]=="function"&&D.push(T);return D}e.getAllMethodNames=t;function r(p,D){const T=A=>function(){const F=Array.prototype.slice.call(arguments,0);return D(A,F)};let o={};for(const A of p)o[A]=T(A);return o}e.createProxyObject=r;function s(p){return p===null?void 0:p}e.withNullAsUndefined=s;function i(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=i;function u(p){return class{constructor(){return new Proxy({},{get(D,T){if(D[T])return D[T];throw new Error(`Not Implemented: ${p}->${String(T)}`)}})}}}e.NotImplementedProxy=u;function d(p,D="Unreachable"){throw new Error(D)}e.assertNever=d}),define(be[44],Ee([0,1,22,8,14,10]),function(ee,e,m,R,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(s){return s===47||s===92}e.isPathSeparator=I;function y(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=y;function E(s){return s.indexOf("/")===-1&&(s=y(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=E;function k(s,i=S.posix.sep){if(!s)return"";const u=s.length,d=s.charCodeAt(0);if(I(d)){if(I(s.charCodeAt(1))&&!I(s.charCodeAt(2))){let D=3;const T=D;for(;D<u&&!I(s.charCodeAt(D));D++);if(T!==D&&!I(s.charCodeAt(D+1))){for(D+=1;D<u;D++)if(I(s.charCodeAt(D)))return s.slice(0,D+1).replace(/[\\/]/g,i)}}return i}else if(w(d)&&s.charCodeAt(1)===58)return I(s.charCodeAt(2))?s.slice(0,2)+i:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<u;p++)if(I(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=k;function n(s){if(!m.isWindows||!s||s.length<5)return!1;let i=s.charCodeAt(0);if(i!==92||(i=s.charCodeAt(1),i!==92))return!1;let u=2;const d=u;for(;u<s.length&&(i=s.charCodeAt(u),i!==92);u++);return!(d===u||(i=s.charCodeAt(u+1),isNaN(i)||i===92))}e.isUNC=n;const C=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(s,i=m.isWindows){const u=i?C:l;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||i&&h.test(s)||s==="."||s===".."||i&&s[s.length-1]==="."||i&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=c;function g(s,i,u){const d=s===i;return!u||d?d:!s||!i?!1:(0,R.equalsIgnoreCase)(s,i)}e.isEqual=g;function b(s,i,u,d=S.sep){if(s===i)return!0;if(!s||!i||i.length>s.length)return!1;if(u){if(!(0,R.startsWithIgnoreCase)(s,i))return!1;if(i.length===s.length)return!0;let D=i.length;return i.charAt(i.length-1)===d&&D--,s.charAt(D)===d}return i.charAt(i.length-1)!==d&&(i+=d),s.indexOf(i)===0}e.isEqualOrParent=b;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function P(s,i){return m.isWindows&&s.endsWith(":")&&(s+=S.sep),(0,S.isAbsolute)(s)||(s=(0,S.join)(i,s)),s=(0,S.normalize)(s),m.isWindows?(s=(0,R.rtrim)(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=(0,R.rtrim)(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=P;function a(s){const i=(0,S.normalize)(s);return m.isWindows?s.length>3?!1:f(i)&&(s.length===2||i.charCodeAt(2)===92):i===S.posix.sep}e.isRootOrDriveLetter=a;function f(s){return m.isWindows?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function v(s){return f(s)?s[0]:void 0}e.getDriveLetter=v;function t(s,i,u){return i.length>s.length?-1:s===i?0:(u&&(s=s.toLowerCase(),i=i.toLowerCase()),s.indexOf(i))}e.indexOfPath=t;function r(s){const i=s.split(":");let u,d,p;if(i.forEach(D=>{const T=Number(D);(0,_.isNumber)(T)?d===void 0?d=T:p===void 0&&(p=T):u=u?[u,D].join(":"):D}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:d!==void 0?d:void 0,column:p!==void 0?p:d!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(be[23],Ee([0,1,10]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const b=Array.isArray(g)?[]:{};return Object.keys(g).forEach(w=>{g[w]&&typeof g[w]=="object"?b[w]=R(g[w]):b[w]=g[w]}),b}e.deepClone=R;function S(g){if(!g||typeof g!="object")return g;const b=[g];for(;b.length>0;){const w=b.shift();Object.freeze(w);for(const P in w)if(_.call(w,P)){const a=w[P];typeof a=="object"&&!Object.isFrozen(a)&&b.push(a)}}return g}e.deepFreeze=S;const _=Object.prototype.hasOwnProperty;function I(g,b){return y(g,b,new Set)}e.cloneAndChange=I;function y(g,b,w){if((0,m.isUndefinedOrNull)(g))return g;const P=b(g);if(typeof P!="undefined")return P;if((0,m.isArray)(g)){const a=[];for(const f of g)a.push(y(f,b,w));return a}if((0,m.isObject)(g)){if(w.has(g))throw new Error("Cannot clone recursive data-structure");w.add(g);const a={};for(let f in g)_.call(g,f)&&(a[f]=y(g[f],b,w));return w.delete(g),a}return g}function E(g,b,w=!0){return(0,m.isObject)(g)?((0,m.isObject)(b)&&Object.keys(b).forEach(P=>{P in g?w&&((0,m.isObject)(g[P])&&(0,m.isObject)(b[P])?E(g[P],b[P],w):g[P]=b[P]):g[P]=b[P]}),g):b}e.mixin=E;function k(g,b){if(g===b)return!0;if(g==null||b===null||b===void 0||typeof g!=typeof b||typeof g!="object"||Array.isArray(g)!==Array.isArray(b))return!1;let w,P;if(Array.isArray(g)){if(g.length!==b.length)return!1;for(w=0;w<g.length;w++)if(!k(g[w],b[w]))return!1}else{const a=[];for(P in g)a.push(P);a.sort();const f=[];for(P in b)f.push(P);if(f.sort(),!k(a,f))return!1;for(w=0;w<a.length;w++)if(!k(g[a[w]],b[a[w]]))return!1}return!0}e.equals=k;function n(g){const b=new Set;return JSON.stringify(g,(w,P)=>{if((0,m.isObject)(P)||Array.isArray(P)){if(b.has(P))return"[Circular]";b.add(P)}return P})}e.safeStringify=n;function C(g,b,w){const P=b(g);return typeof P=="undefined"?w:P}e.getOrDefault=C;function l(g,b){const w=Object.create(null);return!g||!b||Object.keys(b).forEach(a=>{const f=g[a],v=b[a];k(f,v)||(w[a]=v)}),w}e.distinct=l;function h(g,b){const w=b.toLowerCase(),P=Object.keys(g).find(a=>a.toLowerCase()===w);return P?g[P]:g[b]}e.getCaseInsensitive=h;function c(g,b){const w=Object.create(null);for(const P of Object.keys(g))b(P,g[P])&&(w[P]=g[P]);return w}e.filter=c}),define(be[82],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(_){_[_.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",_[_.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",_[_.MAX_UINT_8=255]="MAX_UINT_8",_[_.MAX_UINT_16=65535]="MAX_UINT_16",_[_.MAX_UINT_32=4294967295]="MAX_UINT_32",_[_.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function R(_){return _<0?0:_>255?255:_|0}e.toUint8=R;function S(_){return _<0?0:_>4294967295?4294967295:_|0}e.toUint32=S}),define(be[2],Ee([0,1,22,14]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,_=/^\//,I=/^\/\//;function y(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!S.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!_.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(s,i){return!s&&!i?"file":s}function k(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const n="",C="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(i,u,d,p,D,T=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=E(i,T),this.authority=u||n,this.path=k(this.scheme,d||n),this.query=p||n,this.fragment=D||n,y(this,T))}static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return a(this,!1)}with(i){if(!i)return this;let{scheme:u,authority:d,path:p,query:D,fragment:T}=i;return u===void 0?u=this.scheme:u===null&&(u=n),d===void 0?d=this.authority:d===null&&(d=n),p===void 0?p=this.path:p===null&&(p=n),D===void 0?D=this.query:D===null&&(D=n),T===void 0?T=this.fragment:T===null&&(T=n),u===this.scheme&&d===this.authority&&p===this.path&&D===this.query&&T===this.fragment?this:new g(u,d,p,D,T)}static parse(i,u=!1){const d=l.exec(i);return d?new g(d[2]||n,r(d[4]||n),r(d[5]||n),r(d[7]||n),r(d[9]||n),u):new g(n,n,n,n,n)}static file(i){let u=n;if(m.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const d=i.indexOf(C,2);d===-1?(u=i.substring(2),i=C):(u=i.substring(2,d),i=i.substring(d)||C)}return new g("file",u,i,n,n)}static from(i){const u=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return y(u,!0),u}static joinPath(i,...u){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return m.isWindows&&i.scheme==="file"?d=h.file(R.win32.join(a(i,!0),...u)).path:d=R.posix.join(i.path,...u),i.with({path:d})}toString(i=!1){return f(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const u=new g(i);return u._formatted=i.external,u._fsPath=i._sep===c?i.fsPath:null,u}}else return i}}e.URI=h;const c=m.isWindows?1:void 0;class g extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(i=!1){return i?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=c),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,i){let u,d=-1;for(let p=0;p<s.length;p++){const D=s.charCodeAt(p);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||i&&D===47)d!==-1&&(u+=encodeURIComponent(s.substring(d,p)),d=-1),u!==void 0&&(u+=s.charAt(p));else{u===void 0&&(u=s.substr(0,p));const T=b[D];T!==void 0?(d!==-1&&(u+=encodeURIComponent(s.substring(d,p)),d=-1),u+=T):d===-1&&(d=p)}}return d!==-1&&(u+=encodeURIComponent(s.substring(d))),u!==void 0?u:s}function P(s){let i;for(let u=0;u<s.length;u++){const d=s.charCodeAt(u);d===35||d===63?(i===void 0&&(i=s.substr(0,u)),i+=b[d]):i!==void 0&&(i+=s[u])}return i!==void 0?i:s}function a(s,i){let u;return s.authority&&s.path.length>1&&s.scheme==="file"?u=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?u=s.path.substr(1):u=s.path[1].toLowerCase()+s.path.substr(2):u=s.path,m.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=a;function f(s,i){const u=i?P:w;let d="",{scheme:p,authority:D,path:T,query:o,fragment:A}=s;if(p&&(d+=p,d+=":"),(D||p==="file")&&(d+=C,d+=C),D){let F=D.indexOf("@");if(F!==-1){const x=D.substr(0,F);D=D.substr(F+1),F=x.indexOf(":"),F===-1?d+=u(x,!1):(d+=u(x.substr(0,F),!1),d+=":",d+=u(x.substr(F+1),!1)),d+="@"}D=D.toLowerCase(),F=D.indexOf(":"),F===-1?d+=u(D,!1):(d+=u(D.substr(0,F),!1),d+=D.substr(F))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const F=T.charCodeAt(1);F>=65&&F<=90&&(T=`/${String.fromCharCode(F+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const F=T.charCodeAt(0);F>=65&&F<=90&&(T=`${String.fromCharCode(F+32)}:${T.substr(2)}`)}d+=u(T,!0)}return o&&(d+="?",d+=u(o,!1)),A&&(d+="#",d+=i?A:w(A,!1)),d}function v(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+v(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,i=>v(i)):s}});var it=this&&this.__classPrivateFieldSet||function(ee,e,m,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Be=this&&this.__classPrivateFieldGet||function(ee,e,m,R){if(m==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?R:m==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[21],Ee([0,1,2,8]),function(ee,e,m,R){"use strict";var S,_,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(t,r,s){let i=t.get(r);return i===void 0&&(i=s,t.set(r,i)),i}e.getOrSet=y;function E(t){const r=[];return t.forEach((s,i)=>{r.push(`${i} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=E;function k(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=k;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}e.StringIterator=n;class C{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class l{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class c{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,R.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class b{constructor(r){this._iter=r}static forUris(r=()=>!1){return new b(new c(r))}static forPaths(){return new b(new l)}static forStrings(){return new b(new n)}static forConfigKeys(){return new b(new C)}clear(){this._root=void 0}set(r,s){const i=this._iter.reset(r);let u;for(this._root||(this._root=new g,this._root.segment=i.value()),u=this._root;;){const p=i.cmp(u.segment);if(p>0)u.left||(u.left=new g,u.left.segment=i.value()),u=u.left;else if(p<0)u.right||(u.right=new g,u.right.segment=i.value()),u=u.right;else if(i.hasNext())i.next(),u.mid||(u.mid=new g,u.mid.segment=i.value()),u=u.mid;else break}const d=u.value;return u.value=s,u.key=r,d}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const u=s.cmp(i.segment);if(u>0)i=i.left;else if(u<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const i=this._iter.reset(r),u=[];let d=this._root;for(;d;){const p=i.cmp(d.segment);if(p>0)u.push([1,d]),d=d.left;else if(p<0)u.push([-1,d]),d=d.right;else if(i.hasNext())i.next(),u.push([0,d]),d=d.mid;else{for(s?(d.left=void 0,d.mid=void 0,d.right=void 0):d.value=void 0;u.length>0&&d.isEmpty();){let[D,T]=u.pop();switch(D){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}d=T}break}}}findSubstr(r){const s=this._iter.reset(r);let i=this._root,u;for(;i;){const d=s.cmp(i.segment);if(d>0)i=i.left;else if(d<0)i=i.right;else if(s.hasNext())s.next(),u=i.value||u,i=i.mid;else break}return i&&i.value||u}findSuperstr(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const u=s.cmp(i.segment);if(u>0)i=i.left;else if(u<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[s,i]of this)r(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const i=s.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&s.push(i.left),i.mid&&s.push(i.mid),i.right&&s.push(i.right))}}}e.TernarySearchTree=b;class w{constructor(r,s){this[S]="ResourceMap",r instanceof w?(this.map=new Map(r.map),this.toKey=s??w.defaultToKey):(this.map=new Map,this.toKey=r??w.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[i,u]of this.map)r(u,m.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield m.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[m.URI.parse(r[0]),r[1]]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[m.URI.parse(r[0]),r[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var P;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class a{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const i=this._map.get(r);if(!!i)return s!==0&&this.touch(i,s),i.value}set(r,s,i=0){let u=this._map.get(r);if(u)u.value=s,i!==0&&this.touch(u,i);else{switch(u={key:r,value:s,next:void 0,previous:void 0},i){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const i=this._state;let u=this._head;for(;u;){if(s?r.bind(s)(u.value,u.key,this):r(u.value,u.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,s=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const d={value:i.key,done:!1};return i=i.next,d}else return{value:void 0,done:!0}}};return u}values(){const r=this,s=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const d={value:i.value,done:!1};return i=i.next,d}else return{value:void 0,done:!0}}};return u}entries(){const r=this,s=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const d={value:[i.key,i.value],done:!1};return i=i.next,d}else return{value:void 0,done:!0}}};return u}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,i=this.size;for(;s&&i>r;)this._map.delete(s.key),s=s.next,i--;this._head=s,this._size=i,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,i=r.previous;if(!s||!i)throw new Error("Invalid list");s.previous=i,i.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const i=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(i.previous=u,u.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const i=r.next,u=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=u,u.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,i)=>{r.push([i,s])}),r}fromJSON(r){this.clear();for(const[s,i]of r)this.set(s,i)}}e.LinkedMap=a;class f extends a{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class v{constructor(r){I.set(this,void 0),it(this,I,r,"f")}get size(){return Be(this,I,"f").size}forEach(r,s){Be(this,I,"f").forEach(r,s)}get(r){return Be(this,I,"f").get(r)}has(r){return Be(this,I,"f").has(r)}entries(){return Be(this,I,"f").entries()}keys(){return Be(this,I,"f").keys()}values(){return Be(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return Be(this,I,"f").entries()}}e.ReadonlyMapView=v}),define(be[114],Ee([0,1,21,8]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...q){return function(ie,ge){for(let Re=0,We=q.length;Re<We;Re++){const ve=q[Re](ie,ge);if(ve)return ve}return null}}e.or=S,e.matchesStrictPrefix=_.bind(void 0,!1),e.matchesPrefix=_.bind(void 0,!0);function _(q,ie,ge){if(!ge||ge.length<ie.length)return null;let Re;return q?Re=R.startsWithIgnoreCase(ge,ie):Re=ge.indexOf(ie)===0,Re?ie.length>0?[{start:0,end:ie.length}]:[]:null}function I(q,ie){const ge=ie.toLowerCase().indexOf(q.toLowerCase());return ge===-1?null:[{start:ge,end:ge+q.length}]}e.matchesContiguousSubString=I;function y(q,ie){return E(q.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=y;function E(q,ie,ge,Re){if(ge===q.length)return[];if(Re===ie.length)return null;if(q[ge]===ie[Re]){let We=null;return(We=E(q,ie,ge+1,Re+1))?w({start:Re,end:Re+1},We):null}return E(q,ie,ge,Re+1)}function k(q){return 97<=q&&q<=122}function n(q){return 65<=q&&q<=90}e.isUpper=n;function C(q){return 48<=q&&q<=57}function l(q){return q===32||q===9||q===10||q===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>h.add(q.charCodeAt(0)));function c(q){return l(q)||h.has(q)}function g(q,ie){return q===ie||c(q)&&c(ie)}function b(q){return k(q)||n(q)||C(q)}function w(q,ie){return ie.length===0?ie=[q]:q.end===ie[0].start?ie[0].start=q.start:ie.unshift(q),ie}function P(q,ie){for(let ge=ie;ge<q.length;ge++){const Re=q.charCodeAt(ge);if(n(Re)||C(Re)||ge>0&&!b(q.charCodeAt(ge-1)))return ge}return q.length}function a(q,ie,ge,Re){if(ge===q.length)return[];if(Re===ie.length)return null;if(q[ge]!==ie[Re].toLowerCase())return null;{let We=null,ve=Re+1;for(We=a(q,ie,ge+1,Re+1);!We&&(ve=P(ie,ve))<ie.length;)We=a(q,ie,ge+1,ve),ve++;return We===null?null:w({start:Re,end:Re+1},We)}}function f(q){let ie=0,ge=0,Re=0,We=0,ve=0;for(let Ue=0;Ue<q.length;Ue++)ve=q.charCodeAt(Ue),n(ve)&&ie++,k(ve)&&ge++,b(ve)&&Re++,C(ve)&&We++;const Ye=ie/q.length,z=ge/q.length,Z=Re/q.length,ce=We/q.length;return{upperPercent:Ye,lowerPercent:z,alphaPercent:Z,numericPercent:ce}}function v(q){const{upperPercent:ie,lowerPercent:ge}=q;return ge===0&&ie>.6}function t(q){const{upperPercent:ie,lowerPercent:ge,alphaPercent:Re,numericPercent:We}=q;return ge>.2&&ie<.8&&Re>.6&&We<.2}function r(q){let ie=0,ge=0,Re=0,We=0;for(let ve=0;ve<q.length;ve++)Re=q.charCodeAt(ve),n(Re)&&ie++,k(Re)&&ge++,l(Re)&&We++;return(ie===0||ge===0)&&We===0?q.length<=30:ie<=5}function s(q,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!r(q)||ie.length>60)return null;const ge=f(ie);if(!t(ge)){if(!v(ge))return null;ie=ie.toLowerCase()}let Re=null,We=0;for(q=q.toLowerCase();We<ie.length&&(Re=a(q,ie,0,We))===null;)We=P(ie,We+1);return Re}e.matchesCamelCase=s;function i(q,ie,ge=!1){if(!ie||ie.length===0)return null;let Re=null,We=0;for(q=q.toLowerCase(),ie=ie.toLowerCase();We<ie.length&&(Re=u(q,ie,0,We,ge))===null;)We=d(ie,We+1);return Re}e.matchesWords=i;function u(q,ie,ge,Re,We){if(ge===q.length)return[];if(Re===ie.length)return null;if(g(q.charCodeAt(ge),ie.charCodeAt(Re))){let ve=null,Ye=Re+1;if(ve=u(q,ie,ge+1,Re+1,We),!We)for(;!ve&&(Ye=d(ie,Ye))<ie.length;)ve=u(q,ie,ge+1,Ye,We),Ye++;return ve===null?null:w({start:Re,end:Re+1},ve)}else return null}function d(q,ie){for(let ge=ie;ge<q.length;ge++)if(c(q.charCodeAt(ge))||ge>0&&c(q.charCodeAt(ge-1)))return ge;return q.length}const p=S(e.matchesPrefix,s,I),D=S(e.matchesPrefix,s,y),T=new m.LRUCache(1e4);function o(q,ie,ge=!1){if(typeof q!="string"||typeof ie!="string")return null;let Re=T.get(q);Re||(Re=new RegExp(R.convertSimple2RegExpPattern(q),"i"),T.set(q,Re));const We=Re.exec(ie);return We?[{start:We.index,end:We.index+We[0].length}]:ge?D(q,ie):p(q,ie)}e.matchesFuzzy=o;function A(q,ie){const ge=Xe(q,q.toLowerCase(),0,ie,ie.toLowerCase(),0,!0);return ge?x(ge):null}e.matchesFuzzy2=A;function F(q,ie,ge,Re,We,ve){const Ye=Math.min(13,q.length);for(;ge<Ye;ge++){const z=Xe(q,ie,ge,Re,We,ve,!1);if(z)return z}return[0,ve]}e.anyScore=F;function x(q){if(typeof q=="undefined")return[];const ie=[],ge=q[1];for(let Re=q.length-1;Re>1;Re--){const We=q[Re]+ge,ve=ie[ie.length-1];ve&&ve.end===We?ve.end=We+1:ie.push({start:We,end:We+1})}return ie}e.createMatches=x;const K=128;function le(){const q=[],ie=[];for(let ge=0;ge<=K;ge++)ie[ge]=0;for(let ge=0;ge<=K;ge++)q.push(ie.slice(0));return q}function oe(q){const ie=[];for(let ge=0;ge<=q;ge++)ie[ge]=0;return ie}const V=oe(2*K),W=oe(2*K),L=le(),Q=le(),O=le(),j=!1;function he(q,ie,ge,Re,We){function ve(z,Z,ce=" "){for(;z.length<Z;)z=ce+z;return z}let Ye=` |   |${Re.split("").map(z=>ve(z,3)).join("|")}
`;for(let z=0;z<=ge;z++)z===0?Ye+=" |":Ye+=`${ie[z-1]}|`,Ye+=q[z].slice(0,We+1).map(Z=>ve(Z.toString(),3)).join("|")+`
`;return Ye}function $(q,ie,ge,Re){q=q.substr(ie),ge=ge.substr(Re),console.log(he(Q,q,q.length,ge,ge.length)),console.log(he(O,q,q.length,ge,ge.length)),console.log(he(L,q,q.length,ge,ge.length))}function ne(q,ie){if(ie<0||ie>=q.length)return!1;const ge=q.codePointAt(ie);switch(ge){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(ge)}}function de(q,ie){if(ie<0||ie>=q.length)return!1;switch(q.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function ye(q,ie,ge){return ie[q]!==ge[q]}function Ne(q,ie,ge,Re,We,ve,Ye=!1){for(;ie<ge&&We<ve;)q[ie]===Re[We]&&(Ye&&(V[ie]=We),ie+=1),We+=1;return ie===ge}e.isPatternInWord=Ne;var Me;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var $e;(function(q){q.Default=[-100,0];function ie(ge){return!ge||ge.length===2&&ge[0]===-100&&ge[1]===0}q.isDefault=ie})($e=e.FuzzyScore||(e.FuzzyScore={}));function Xe(q,ie,ge,Re,We,ve,Ye){const z=q.length>K?K:q.length,Z=Re.length>K?K:Re.length;if(ge>=z||ve>=Z||z-ge>Z-ve||!Ne(ie,ge,z,We,ve,Z,!0))return;qe(z,Z,ge,ve,ie,We);let ce=1,Ue=1,xe=ge,et=ve;const De=[!1];for(ce=1,xe=ge;xe<z;ce++,xe++){const fe=V[xe],pe=W[xe],B=xe+1<z?W[xe+1]:Z;for(Ue=fe-ve+1,et=fe;et<B;Ue++,et++){let me=Number.MIN_SAFE_INTEGER,we=!1;et<=pe&&(me=je(q,ie,xe,ge,Re,We,et,Z,ve,L[ce-1][Ue-1]===0,De));let Ie=0;me!==Number.MAX_SAFE_INTEGER&&(we=!0,Ie=me+Q[ce-1][Ue-1]);const Oe=et>fe,He=Oe?Q[ce][Ue-1]+(L[ce][Ue-1]>0?-5:0):0,Ze=et>fe+1&&L[ce][Ue-1]>0,Ke=Ze?Q[ce][Ue-2]+(L[ce][Ue-2]>0?-5:0):0;if(Ze&&(!Oe||Ke>=He)&&(!we||Ke>=Ie))Q[ce][Ue]=Ke,O[ce][Ue]=3,L[ce][Ue]=0;else if(Oe&&(!we||He>=Ie))Q[ce][Ue]=He,O[ce][Ue]=2,L[ce][Ue]=0;else if(we)Q[ce][Ue]=Ie,O[ce][Ue]=1,L[ce][Ue]=L[ce-1][Ue-1]+1;else throw new Error("not possible")}}if(j&&$(q,ge,Re,ve),!De[0]&&!Ye)return;ce--,Ue--;const Se=[Q[ce][Ue],ve];let Pe=0,se=0;for(;ce>=1;){let fe=Ue;do{const pe=O[ce][fe];if(pe===3)fe=fe-2;else if(pe===2)fe=fe-1;else break}while(fe>=1);Pe>1&&ie[ge+ce-1]===We[ve+Ue-1]&&!ye(fe+ve-1,Re,We)&&Pe+1>L[ce][fe]&&(fe=Ue),fe===Ue?Pe++:Pe=1,se||(se=fe),ce--,Ue=fe-1,Se.push(Ue)}Z===z&&(Se[0]+=2);const ae=se-z;return Se[0]-=ae,Se}e.fuzzyScore=Xe;function qe(q,ie,ge,Re,We,ve){let Ye=q-1,z=ie-1;for(;Ye>=ge&&z>=Re;)We[Ye]===ve[z]&&(W[Ye]=z,Ye--),z--}function je(q,ie,ge,Re,We,ve,Ye,z,Z,ce,Ue){if(ie[ge]!==ve[Ye])return Number.MIN_SAFE_INTEGER;let xe=1,et=!1;return Ye===ge-Re?xe=q[ge]===We[Ye]?7:5:ye(Ye,We,ve)&&(Ye===0||!ye(Ye-1,We,ve))?(xe=q[ge]===We[Ye]?7:5,et=!0):ne(ve,Ye)&&(Ye===0||!ne(ve,Ye-1))?xe=5:(ne(ve,Ye-1)||de(ve,Ye-1))&&(xe=5,et=!0),xe>1&&ge===Re&&(Ue[0]=!0),et||(et=ye(Ye,We,ve)||ne(ve,Ye-1)||de(ve,Ye-1)),ge===Re?Ye>Z&&(xe-=et?3:5):ce?xe+=et?2:0:xe+=et?0:1,Ye+1===z&&(xe-=et?3:5),xe}function U(q,ie,ge,Re,We,ve,Ye){return X(q,ie,ge,Re,We,ve,!0,Ye)}e.fuzzyScoreGracefulAggressive=U;function G(q,ie,ge,Re,We,ve,Ye){return X(q,ie,ge,Re,We,ve,!1,Ye)}e.fuzzyScoreGraceful=G;function X(q,ie,ge,Re,We,ve,Ye,z){let Z=Xe(q,ie,ge,Re,We,ve,z);if(Z&&!Ye)return Z;if(q.length>=3){const ce=Math.min(7,q.length-1);for(let Ue=ge+1;Ue<ce;Ue++){const xe=re(q,Ue);if(xe){const et=Xe(xe,xe.toLowerCase(),ge,Re,We,ve,z);et&&(et[0]-=3,(!Z||et[0]>Z[0])&&(Z=et))}}}return Z}function re(q,ie){if(ie+1>=q.length)return;const ge=q[ie],Re=q[ie+1];if(ge!==Re)return q.slice(0,ie)+Re+ge+q.slice(ie+2)}}),define(be[115],Ee([0,1,35,114,8]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const _=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(`(\\\\)?${_.source}`,"g");function y(g){return g.replace(I,(b,w)=>w?b:`\\${b}`)}e.escapeIcons=y;const E=new RegExp(`\\\\${_.source}`,"g");function k(g){return g.replace(E,b=>`\\${b}`)}e.markdownEscapeEscapedIcons=k;const n=new RegExp(`(\\s)?(\\\\)?${_.source}(\\s)?`,"g");function C(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(n,(b,w,P,a)=>P?b:w||a||"")}e.stripIcons=C;function l(g){const b=g.indexOf(e.iconStartMarker);return b===-1?{text:g}:h(g,b)}e.parseLabelWithIcons=l;function h(g,b){const w=[];let P="";function a(d){if(d){P+=d;for(const p of d)w.push(t)}}let f=-1,v="",t=0,r,s,i=b;const u=g.length;for(a(g.substr(0,b));i<u;)r=g[i],s=g[i+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(f=i,a(v),v=e.iconStartMarker,i++):r===")"&&f!==-1?(t+=i-f+1,f=-1,v=""):f!==-1?/^[a-z0-9\-]$/i.test(r)?v+=r:(a(v),f=-1,v=""):a(r),i++;return a(v),{text:P,iconOffsets:w}}function c(g,b,w=!1){const{text:P,iconOffsets:a}=b;if(!a||a.length===0)return(0,R.matchesFuzzy)(g,P,w);const f=(0,S.ltrim)(P," "),v=P.length-f.length,t=(0,R.matchesFuzzy)(g,f,w);if(t)for(const r of t){const s=a[r.start+v]+v;r.start+=s,r.end+=s}return t}e.matchesFuzzyIconAware=c}),define(be[83],Ee([0,1,115,12]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class _{constructor(h="",c=!1){if(this.value=h,typeof this.value!="string")throw(0,R.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1)}appendText(h,c=0){return this.value+=k(this.supportThemeIcons?(0,m.escapeIcons)(h):h).replace(/([ \t]+)/g,(g,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,c){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=_;function I(l){return y(l)?!l.value:Array.isArray(l)?l.every(I):!0}e.isEmptyMarkdownString=I;function y(l){return l instanceof _?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function E(l,h){return l===h?!0:!l||!h?!1:l.value===h.value&&l.isTrusted===h.isTrusted&&l.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=E;function k(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function n(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function C(l){const h=[],c=l.split("|").map(b=>b.trim());l=c[0];const g=c[1];if(g){const b=/height=(\d+)/.exec(g),w=/width=(\d+)/.exec(g),P=b?b[1]:"",a=w?w[1]:"",f=isFinite(parseInt(a)),v=isFinite(parseInt(P));f&&h.push(`width="${a}"`),v&&h.push(`height="${P}"`)}return{href:l,dimensions:h}}e.parseHrefAndDimensions=C}),define(be[57],Ee([0,1,24,8,2]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function _(n){return JSON.stringify(n,E)}e.stringify=_;function I(n){let C=JSON.parse(n);return C=k(C),C}e.parse=I;var y;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(y=e.MarshalledId||(e.MarshalledId={}));function E(n,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,R.regExpFlags)(C)}:C}function k(n,C=0){if(!n||C>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return S.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof m.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let l=0;l<n.length;++l)n[l]=k(n[l],C+1);else for(const l in n)Object.hasOwnProperty.call(n,l)&&(n[l]=k(n[l],C+1))}return n}e.revive=k}),define(be[11],Ee([0,1,2,22]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.userData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp"})(S=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,k,n){this._hosts[E]=k,this._ports[E]=n}setConnectionToken(E,k){this._connectionTokens[E]=k}rewrite(E){if(this._delegate)return this._delegate(E);const k=E.authority;let n=this._hosts[k];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const C=this._ports[k],l=this._connectionTokens[k];let h=`path=${encodeURIComponent(E.path)}`;return typeof l=="string"&&(h+=`&tkn=${encodeURIComponent(l)}`),m.URI.from({scheme:R.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${n}:${C}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new _;class I{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(E,k,n){const C=this.toUri(E,k);if(C.scheme===S.vscodeRemote)return e.RemoteAuthorities.rewrite(C);let l=!1;return R.isNative&&(n||R.isPreferringBrowserCodeLoad)&&C.scheme===S.file&&(l=!0),C.scheme===S.file&&typeof R.globals.importScripts=="function"&&R.globals.origin==="vscode-file://vscode-app"&&(l=!0),l?C.with({scheme:S.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(E,k){const n=this.toUri(E,k);return n.scheme===S.vscodeFileResource?n.with({scheme:S.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(E,k){return m.URI.isUri(E)?E:m.URI.parse(k.toUrl(E))}}e.FileAccess=new I}),define(be[25],Ee([0,1,44,14,2,8,11,22]),function(ee,e,m,R,S,_,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(h){return(0,S.uriToFsPath)(h,!0)}e.originalFSPath=E;class k{constructor(c){this._ignorePathCasing=c}compare(c,g,b=!1){return c===g?0:(0,_.compare)(this.getComparisonKey(c,b),this.getComparisonKey(g,b))}isEqual(c,g,b=!1){return c===g?!0:!c||!g?!1:this.getComparisonKey(c,b)===this.getComparisonKey(g,b)}getComparisonKey(c,g=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,g,b=!1){if(c.scheme===g.scheme){if(c.scheme===I.Schemas.file)return m.isEqualOrParent(E(c),E(g),this._ignorePathCasing(c))&&c.query===g.query&&(b||c.fragment===g.fragment);if((0,e.isEqualAuthority)(c.authority,g.authority))return m.isEqualOrParent(c.path,g.path,this._ignorePathCasing(c),"/")&&c.query===g.query&&(b||c.fragment===g.fragment)}return!1}joinPath(c,...g){return S.URI.joinPath(c,...g)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return R.posix.basename(c.path)}extname(c){return R.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let g;return c.scheme===I.Schemas.file?g=S.URI.file(R.dirname(E(c))).path:(g=R.posix.dirname(c.path),c.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),g="/")),c.with({path:g})}normalizePath(c){if(!c.path.length)return c;let g;return c.scheme===I.Schemas.file?g=S.URI.file(R.normalize(E(c))).path:g=R.posix.normalize(c.path),c.with({path:g})}relativePath(c,g){if(c.scheme!==g.scheme||!(0,e.isEqualAuthority)(c.authority,g.authority))return;if(c.scheme===I.Schemas.file){const P=R.relative(E(c),E(g));return y.isWindows?m.toSlashes(P):P}let b=c.path||"/",w=g.path||"/";if(this._ignorePathCasing(c)){let P=0;for(const a=Math.min(b.length,w.length);P<a&&!(b.charCodeAt(P)!==w.charCodeAt(P)&&b.charAt(P).toLowerCase()!==w.charAt(P).toLowerCase());P++);b=w.substr(0,P)+b.substr(P)}return R.posix.relative(b,w)}resolvePath(c,g){if(c.scheme===I.Schemas.file){const b=S.URI.file(R.resolve(E(c),g));return c.with({authority:b.authority,path:b.path})}return g=m.toPosixPath(g),c.with({path:R.posix.resolve(c.path,g)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,g){return c===g||(0,_.equalsIgnoreCase)(c,g)}hasTrailingPathSeparator(c,g=R.sep){if(c.scheme===I.Schemas.file){const b=E(c);return b.length>m.getRoot(b).length&&b[b.length-1]===g}else{const b=c.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,g=R.sep){return(0,e.hasTrailingPathSeparator)(c,g)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,g=R.sep){let b=!1;if(c.scheme===I.Schemas.file){const w=E(c);b=w!==void 0&&w.length===m.getRoot(w).length&&w[w.length-1]===g}else{g="/";const w=c.path;b=w.length===1&&w.charCodeAt(w.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(c,g)?c.with({path:c.path+"/"}):c}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(h=>h.scheme===I.Schemas.file?!y.isLinux:!0),e.extUriIgnorePathCase=new k(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(h,c){const g=[];for(let b=0;b<h.length;b++){const w=c(h[b]);h.some((P,a)=>a===b?!1:(0,e.isEqualOrParent)(w,c(P)))||g.push(h[b])}return g}e.distinctParents=n;var C;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function c(g){const b=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(a=>{const[f,v]=a.split(":");f&&v&&b.set(f,v)});const P=g.path.substring(0,g.path.indexOf(";"));return P&&b.set(h.META_DATA_MIME,P),b}h.parseMetaData=c})(C=e.DataUri||(e.DataUri={}));function l(h,c,g){if(c){let b=h.path;return b&&b[0]!==R.posix.sep&&(b=R.posix.sep+b),h.with({scheme:g,authority:c,path:b})}return h.with({scheme:g})}e.toLocalResource=l}),define(be[15],Ee([0,1,20,12,3,6,25]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(W){return!!W&&typeof W.then=="function"}e.isThenable=y;function E(W){const L=new m.CancellationTokenSource,Q=W(L.token),O=new Promise((j,he)=>{const $=L.token.onCancellationRequested(()=>{$.dispose(),L.dispose(),he((0,R.canceled)())});Promise.resolve(Q).then(ne=>{$.dispose(),L.dispose(),j(ne)},ne=>{$.dispose(),L.dispose(),he(ne)})});return new class{cancel(){L.cancel()}then(j,he){return O.then(j,he)}catch(j){return this.then(void 0,j)}finally(j){return O.finally(j)}}}e.createCancelablePromise=E;function k(W,L,Q){return Promise.race([W,new Promise(O=>L.onCancellationRequested(()=>O(Q)))])}e.raceCancellation=k;async function n(W){let L=-1;const Q=W.map((j,he)=>j.then($=>(L=he,$))),O=await Promise.race(Q);return W.forEach((j,he)=>{he!==L&&j.cancel()}),O}e.raceCancellablePromises=n;function C(W,L,Q){let O;const j=setTimeout(()=>{O?.(void 0),Q?.()},L);return Promise.race([W.finally(()=>clearTimeout(j)),new Promise(he=>O=he)])}e.raceTimeout=C;function l(W){return new Promise((L,Q)=>{const O=W();y(O)?O.then(L,Q):L(O)})}e.asPromise=l;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const Q=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(Q,Q).then(O)})}return new Promise((Q,O)=>{this.queuedPromise.then(Q,O)})}return this.activePromise=L(),new Promise((Q,O)=>{this.activePromise.then(j=>{this.activePromise=null,Q(j)},j=>{this.activePromise=null,O(j)})})}}e.Throttler=h;class c{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=c;class g{constructor(){this.promiseMap=new Map}queue(L,Q){const j=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.promiseMap.get(L)===j&&this.promiseMap.delete(L)});return this.promiseMap.set(L,j),j}}e.SequencerByKey=g;class b{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,Q=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,j)=>{this.doResolve=O,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},Q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class w{constructor(L){this.delayer=new b(L),this.throttler=new h}trigger(L,Q){return this.delayer.trigger(()=>this.throttler.queue(L),Q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class P{constructor(){this._isOpen=!1,this._promise=new Promise((L,Q)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=P;class a extends P{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function f(W,L){return L?new Promise((Q,O)=>{const j=setTimeout(()=>{he.dispose(),Q()},W),he=L.onCancellationRequested(()=>{clearTimeout(j),he.dispose(),O((0,R.canceled)())})}):E(Q=>f(W,Q))}e.timeout=f;function v(W,L=0){const Q=setTimeout(W,L);return(0,_.toDisposable)(()=>clearTimeout(Q))}e.disposableTimeout=v;function t(W){const L=[];let Q=0;const O=W.length;function j(){return Q<O?W[Q++]():null}function he($){$!=null&&L.push($);const ne=j();return ne?ne.then(he):Promise.resolve(L)}return Promise.resolve(null).then(he)}e.sequence=t;function r(W,L=O=>!!O,Q=null){let O=0;const j=W.length,he=()=>{if(O>=j)return Promise.resolve(Q);const $=W[O++];return Promise.resolve($()).then(de=>L(de)?Promise.resolve(de):he())};return he()}e.first=r;function s(W,L=O=>!!O,Q=null){if(W.length===0)return Promise.resolve(Q);let O=W.length;const j=()=>{O=-1;for(const he of W)he.cancel?.()};return new Promise((he,$)=>{for(const ne of W)ne.then(de=>{--O>=0&&L(de)?(j(),he(de)):O===0&&he(Q)}).catch(de=>{--O>=0&&(j(),$(de))})})}e.firstParallel=s;class i{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((Q,O)=>{this.outstandingPromises.push({factory:L,c:Q,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const Q=L.factory();Q.then(L.c,L.e),Q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class u extends i{constructor(){super(1)}}e.Queue=u;class d{constructor(){this.queues=new Map}queueFor(L,Q=I.extUri){const O=Q.getComparisonKey(L);let j=this.queues.get(O);return j||(j=new u,S.Event.once(j.onFinished)(()=>{j?.dispose(),this.queues.delete(O)}),this.queues.set(O,j)),j}dispose(){this.queues.forEach(L=>L.dispose()),this.queues.clear()}}e.ResourceQueue=d;class p{constructor(L,Q){this._token=-1,typeof L=="function"&&typeof Q=="number"&&this.setIfNotSet(L,Q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,Q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},Q)}setIfNotSet(L,Q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},Q))}}e.TimeoutTimer=p;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,Q){this.cancel(),this._token=setInterval(()=>{L()},Q)}}e.IntervalTimer=D;class T{constructor(L,Q){this.timeoutToken=-1,this.runner=L,this.timeout=Q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class o extends T{constructor(L,Q){super(L,Q);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=o;class A extends _.Disposable{constructor(L,Q,O,j){super();this.maxWorkChunkSize=L,this.maxPendingWork=Q,this.throttleDelay=O,this.handler=j,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.maxPendingWork)return!1}else if(this.pending+L.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=A,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=L=>{const Q=setTimeout(()=>L(W));let O=!1;return{dispose(){O||(O=!0,clearTimeout(Q))}}}}else e.runWhenIdle=(W,L)=>{const Q=requestIdleCallback(W,typeof L=="number"?{timeout:L}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(Q))}}}}();class F{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(Q){this._error=Q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=F;async function x(W,L,Q){let O;for(let j=0;j<Q;j++)try{return await W()}catch(he){O=he,await f(L)}throw O}e.retry=x;class K{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,Q,O){return this._pending={taskId:L,cancel:()=>O?.(),promise:Q},Q.then(()=>this.donePending(L),()=>this.donePending(L)),Q}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let Q,O;const j=new Promise((he,$)=>{Q=he,O=$});this._next={run:L,promise:j,promiseResolve:Q,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=K;class le{constructor(L){this.interval=L,this.lastIncrementTime=0,this.value=0}increment(){const L=Date.now();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=le;class oe{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,Q)=>{this.completeCallback=L,this.errorCallback=Q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(Q=>{this.completeCallback(L),this.resolved=!0,Q()})}error(L){return new Promise(Q=>{this.errorCallback(L),this.rejected=!0,Q()})}cancel(){new Promise(L=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=oe;var V;(function(W){async function L(Q){let O;const j=await Promise.all(Q.map(he=>he.then($=>$,$=>{O||(O=$)})));if(typeof O!="undefined")throw O;return j}W.settled=L})(V=e.Promises||(e.Promises={}))}),define(be[116],Ee([0,1,14,15]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new R.IdleValue(()=>{const T=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:T,collatorIsNumeric:T.resolvedOptions().numeric}}),_=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function y(T,o,A=!1){const F=T||"",x=o||"",K=S.value.collator.compare(F,x);return S.value.collatorIsNumeric&&K===0&&F!==x?F<x?-1:1:K}e.compareFileNames=y;function E(T,o){const A=_.value.collator;return T=T||"",o=o||"",v(A,T,o)}e.compareFileNamesDefault=E;function k(T,o){const A=_.value.collator;return T=T||"",o=o||"",i(T,o)||v(A,T,o)}e.compareFileNamesUpper=k;function n(T,o){const A=_.value.collator;return T=T||"",o=o||"",s(T,o)||v(A,T,o)}e.compareFileNamesLower=n;function C(T,o){return T=T||"",o=o||"",T===o?0:T<o?-1:1}e.compareFileNamesUnicode=C;function l(T,o,A=!1){A||(T=T&&T.toLowerCase(),o=o&&o.toLowerCase());const[F,x]=a(T),[K,le]=a(o);return F!==K?F<K?-1:1:x===le?0:x<le?-1:1}e.noIntlCompareFileNames=l;function h(T,o){const[A,F]=a(T),[x,K]=a(o);let le=S.value.collator.compare(F,K);if(le===0){if(S.value.collatorIsNumeric&&F!==K)return F<K?-1:1;if(le=S.value.collator.compare(A,x),S.value.collatorIsNumeric&&le===0&&A!==x)return A<x?-1:1}return le}e.compareFileExtensions=h;function c(T,o){T=T||"",o=o||"";const A=f(T),F=f(o),x=_.value.collator,K=I.value.collator;return v(K,A,F)||v(x,T,o)}e.compareFileExtensionsDefault=c;function g(T,o){T=T||"",o=o||"";const A=f(T),F=f(o),x=_.value.collator,K=I.value.collator;return v(K,A,F)||i(T,o)||v(x,T,o)}e.compareFileExtensionsUpper=g;function b(T,o){T=T||"",o=o||"";const A=f(T),F=f(o),x=_.value.collator,K=I.value.collator;return v(K,A,F)||s(T,o)||v(x,T,o)}e.compareFileExtensionsLower=b;function w(T,o){T=T||"",o=o||"";const A=f(T).toLowerCase(),F=f(o).toLowerCase();return A!==F?A<F?-1:1:T!==o?T<o?-1:1:0}e.compareFileExtensionsUnicode=w;const P=/^(.*?)(\.([^.]*))?$/;function a(T,o=!1){const A=T?P.exec(T):[];let F=[A&&A[1]||"",A&&A[3]||""];return o&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function f(T){const o=T?P.exec(T):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function v(T,o,A){let F=T.compare(o,A);return F!==0?F:o.length!==A.length?o.length<A.length?-1:1:0}function t(T){const o=T.charAt(0);return o.toLocaleUpperCase()!==o}function r(T){const o=T.charAt(0);return o.toLocaleLowerCase()!==o}function s(T,o){return t(T)&&r(o)?-1:r(T)&&t(o)?1:0}function i(T,o){return r(T)&&t(o)?-1:t(T)&&r(o)?1:0}function u(T,o,A=!1){return A||(T=T&&T.toLowerCase(),o=o&&o.toLowerCase()),T===o?0:T<o?-1:1}function d(T,o,A=!1){const F=T.split(m.sep),x=o.split(m.sep),K=F.length-1,le=x.length-1;let oe,V;for(let W=0;;W++){if(oe=K===W,V=le===W,oe&&V)return y(F[W],x[W],A);if(oe)return-1;if(V)return 1;const L=u(F[W],x[W],A);if(L!==0)return L}}e.comparePaths=d;function p(T,o,A){const F=T.toLowerCase(),x=o.toLowerCase(),K=D(T,o,A);if(K)return K;const le=F.endsWith(A),oe=x.endsWith(A);if(le!==oe)return le?-1:1;const V=y(F,x);return V!==0?V:F.localeCompare(x)}e.compareAnything=p;function D(T,o,A){const F=T.toLowerCase(),x=o.toLowerCase(),K=F.startsWith(A),le=x.startsWith(A);if(K!==le)return K?-1:1;if(K&&le){if(F.length<x.length)return-1;if(F.length>x.length)return 1}return 0}e.compareByPrefix=D}),define(be[27],Ee([0,1,8,44,14,21,15]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y;const E="**",k="/",n="[/\\\\]",C="[^/\\\\]",l=/\//g;function h(j){switch(j){case 0:return"";case 1:return`${C}*?`;default:return`(?:${n}|${C}+${n}|${n}${C}+)*?`}}function c(j,he){if(!j)return[];const $=[];let ne=!1,de=!1,ye="";for(const Ne of j){switch(Ne){case he:if(!ne&&!de){$.push(ye),ye="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":de=!0;break;case"]":de=!1;break}ye+=Ne}return ye&&$.push(ye),$}e.splitGlobAware=c;function g(j){if(!j)return"";let he="";const $=c(j,k);if($.every(ne=>ne===E))he=".*";else{let ne=!1;$.forEach((de,ye)=>{if(de===E){ne||(he+=h(2),ne=!0);return}let Ne=!1,Me="",$e=!1,Xe="";for(const qe of de){if(qe!=="}"&&Ne){Me+=qe;continue}if($e&&(qe!=="]"||!Xe)){let je;qe==="-"?je=qe:(qe==="^"||qe==="!")&&!Xe?je="^":qe===k?je="":je=m.escapeRegExpCharacters(qe),Xe+=je;continue}switch(qe){case"{":Ne=!0;continue;case"[":$e=!0;continue;case"}":he+=`(?:${c(Me,",").map(G=>g(G)).join("|")})`,Ne=!1,Me="";break;case"]":he+="["+Xe+"]",$e=!1,Xe="";break;case"?":he+=C;continue;case"*":he+=h(1);continue;default:he+=m.escapeRegExpCharacters(qe)}}ye<$.length-1&&($[ye+1]!==E||ye+2<$.length)&&(he+=n),ne=!1})}return he}const b=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new _.LRUCache(1e4),r=function(){return!1},s=function(){return null};function i(j,he){if(!j)return s;let $;typeof j!="string"?$=j.pattern:$=j,$=$.trim();const ne=`${$}_${!!he.trimForExclusions}`;let de=t.get(ne);if(de)return u(de,j);let ye;if(b.test($)){const Ne=$.substr(4);de=function(Me,$e){return typeof Me=="string"&&Me.endsWith(Ne)?$:null}}else(ye=w.exec(d($,he)))?de=p(ye[1],$):(he.trimForExclusions?a:P).test($)?de=D($,he):(ye=f.exec(d($,he)))?de=T(ye[1].substr(1),$,!0):(ye=v.exec(d($,he)))?de=T(ye[1],$,!1):de=o($);return t.set(ne,de),u(de,j)}function u(j,he){return typeof he=="string"?j:function($,ne){return R.isEqualOrParent($,he.base)?j(S.relative(he.base,$),ne):null}}function d(j,he){return he.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function p(j,he){const $=`/${j}`,ne=`\\${j}`,de=function(Ne,Me){return typeof Ne!="string"?null:Me?Me===j?he:null:Ne===j||Ne.endsWith($)||Ne.endsWith(ne)?he:null},ye=[j];return de.basenames=ye,de.patterns=[he],de.allBasenames=ye,de}function D(j,he){const $=O(j.slice(1,-1).split(",").map(Me=>i(Me,he)).filter(Me=>Me!==s),j),ne=$.length;if(!ne)return s;if(ne===1)return $[0];const de=function(Me,$e){for(let Xe=0,qe=$.length;Xe<qe;Xe++)if($[Xe](Me,$e))return j;return null},ye=$.find(Me=>!!Me.allBasenames);ye&&(de.allBasenames=ye.allBasenames);const Ne=$.reduce((Me,$e)=>$e.allPaths?Me.concat($e.allPaths):Me,[]);return Ne.length&&(de.allPaths=Ne),de}function T(j,he,$){const ne=S.sep===S.posix.sep,de=ne?j:j.replace(l,S.sep),ye=S.sep+de,Ne=S.posix.sep+j,Me=$?function($e,Xe){return typeof $e=="string"&&($e===de||$e.endsWith(ye)||!ne&&($e===j||$e.endsWith(Ne)))?he:null}:function($e,Xe){return typeof $e=="string"&&($e===de||!ne&&$e===j)?he:null};return Me.allPaths=[($?"*/":"./")+j],Me}function o(j){try{const he=new RegExp(`^${g(j)}$`);return function($){return he.lastIndex=0,typeof $=="string"&&he.test($)?j:null}}catch(he){return s}}function A(j,he,$){return!j||typeof he!="string"?!1:F(j)(he,void 0,$)}e.match=A;function F(j,he={}){if(!j)return r;if(typeof j=="string"||oe(j)){const $=i(j,he);if($===s)return r;const ne=function(de,ye){return!!$(de,ye)};return $.allBasenames&&(ne.allBasenames=$.allBasenames),$.allPaths&&(ne.allPaths=$.allPaths),ne}return L(j,he)}e.parse=F;function x(j){if(!j)return;let he;return $=>(he||(he=(j()||Promise.resolve([])).then(ne=>ne?le(ne):{})),he.then(ne=>!!ne[$]))}e.hasSiblingPromiseFn=x;function K(j){if(!j)return;let he;return $=>{if(!he){const ne=j();he=ne?le(ne):{}}return!!he[$]}}e.hasSiblingFn=K;function le(j){const he={};for(const $ of j)he[$]=!0;return he}function oe(j){const he=j;return he&&typeof he.base=="string"&&typeof he.pattern=="string"}e.isRelativePattern=oe;function V(j){return j.allBasenames||[]}e.getBasenameTerms=V;function W(j){return j.allPaths||[]}e.getPathTerms=W;function L(j,he){const $=O(Object.getOwnPropertyNames(j).map(Me=>Q(Me,j[Me],he)).filter(Me=>Me!==s)),ne=$.length;if(!ne)return s;if(!$.some(Me=>!!Me.requiresSiblings)){if(ne===1)return $[0];const Me=function(qe,je){for(let U=0,G=$.length;U<G;U++){const X=$[U](qe,je);if(X)return X}return null},$e=$.find(qe=>!!qe.allBasenames);$e&&(Me.allBasenames=$e.allBasenames);const Xe=$.reduce((qe,je)=>je.allPaths?qe.concat(je.allPaths):qe,[]);return Xe.length&&(Me.allPaths=Xe),Me}const de=function(Me,$e,Xe){let qe;for(let je=0,U=$.length;je<U;je++){const G=$[je];G.requiresSiblings&&Xe&&($e||($e=S.basename(Me)),qe||(qe=$e.substr(0,$e.length-S.extname(Me).length)));const X=G(Me,$e,qe,Xe);if(X)return X}return null},ye=$.find(Me=>!!Me.allBasenames);ye&&(de.allBasenames=ye.allBasenames);const Ne=$.reduce((Me,$e)=>$e.allPaths?Me.concat($e.allPaths):Me,[]);return Ne.length&&(de.allPaths=Ne),de}function Q(j,he,$){if(he===!1)return s;const ne=i(j,$);if(ne===s)return s;if(typeof he=="boolean")return ne;if(he){const de=he.when;if(typeof de=="string"){const ye=(Ne,Me,$e,Xe)=>{if(!Xe||!ne(Ne,Me))return null;const qe=de.replace("$(basename)",$e),je=Xe(qe);return(0,I.isThenable)(je)?je.then(U=>U?j:null):je?j:null};return ye.requiresSiblings=!0,ye}}return ne}function O(j,he){const $=j.filter(Me=>!!Me.basenames);if($.length<2)return j;const ne=$.reduce((Me,$e)=>{const Xe=$e.basenames;return Xe?Me.concat(Xe):Me},[]);let de;if(he){de=[];for(let Me=0,$e=ne.length;Me<$e;Me++)de.push(he)}else de=$.reduce((Me,$e)=>{const Xe=$e.patterns;return Xe?Me.concat(Xe):Me},[]);const ye=function(Me,$e){if(typeof Me!="string")return null;if(!$e){let qe;for(qe=Me.length;qe>0;qe--){const je=Me.charCodeAt(qe-1);if(je===47||je===92)break}$e=Me.substr(qe)}const Xe=ne.indexOf($e);return Xe!==-1?de[Xe]:null};ye.basenames=ne,ye.patterns=de,ye.allBasenames=ne;const Ne=j.filter(Me=>!Me.basenames);return Ne.push(ye),Ne}}),define(be[84],Ee([0,1,2,14,8,11,22,25,44]),function(ee,e,m,R,S,_,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(i,u,d){if(typeof i=="string"&&(i=m.URI.file(i)),d){const D=d.getWorkspaceFolder(i);if(D){const T=d.getWorkspace().folders.length>1;let o;if((0,y.isEqual)(D.uri,i)?o="":o=(0,y.relativePath)(D.uri,i),T){const A=D.name?D.name:(0,y.basename)(D.uri);o=o?A+" \u2022 "+o:A}return o}}if(i.scheme!==_.Schemas.file&&i.scheme!==_.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,E.hasDriveLetter)(i.fsPath))return(0,R.normalize)(C(i.fsPath));let p=(0,R.normalize)(i.fsPath);return!I.isWindows&&u?.userHome&&(p=h(p,u.userHome.fsPath)),p}e.getPathLabel=k;function n(i){if(!i)return;typeof i=="string"&&(i=m.URI.file(i));const u=(0,y.basename)(i)||(i.scheme===_.Schemas.file?i.fsPath:i.path);return I.isWindows&&(0,E.isRootOrDriveLetter)(u)?C(u):u}e.getBaseLabel=n;function C(i){return(0,E.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let l=Object.create(null);function h(i,u){if(I.isWindows||!i||!u)return i;let d=l.original===u?l.normalized:void 0;return d||(d=`${(0,S.rtrim)(u,R.posix.sep)}${R.posix.sep}`,l={original:u,normalized:d}),(I.isLinux?i.startsWith(d):(0,S.startsWithIgnoreCase)(i,d))&&(i=`~/${i.substr(d.length)}`),i}e.tildify=h;function c(i,u){return i.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=c;const g="\u2026",b="\\\\",w="~";function P(i,u=R.sep){const d=new Array(i.length);let p=!1;for(let D=0;D<i.length;D++){let T=i[D];if(T===""){d[D]=`.${u}`;continue}if(!T){d[D]=T;continue}p=!0;let o="";T.indexOf(b)===0?(o=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length)):T.indexOf(u)===0?(o=T.substr(0,T.indexOf(u)+u.length),T=T.substr(T.indexOf(u)+u.length)):T.indexOf(w)===0&&(o=T.substr(0,T.indexOf(w)+w.length),T=T.substr(T.indexOf(w)+w.length));const A=T.split(u);for(let F=1;p&&F<=A.length;F++)for(let x=A.length-F;p&&x>=0;x--){p=!1;let K=A.slice(x,x+F).join(u);for(let le=0;!p&&le<i.length;le++)if(le!==D&&i[le]&&i[le].indexOf(K)>-1){const oe=x+F===A.length,V=x>0&&i[le].indexOf(u)>-1?u+K:K,W=i[le].endsWith(V);p=!oe||W}if(!p){let le="";(A[0].endsWith(":")||o!=="")&&(x===1&&(x=0,F++,K=A[0]+u+K),x>0&&(le=A[0]+u),le=o+le),x>0&&(le=le+g+u),le=le+K,x+F<A.length&&(le=le+u+g),d[D]=le}}p&&(d[D]=T)}return d}e.shorten=P;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function f(i,u=Object.create(null)){const d=[];let p=!1,D="";for(const T of i)if(T==="$"||p&&T==="{")D&&d.push({value:D,type:a.TEXT}),D="",p=!0;else if(T==="}"&&p){const o=u[D];if(typeof o=="string")o.length&&d.push({value:o,type:a.VARIABLE});else if(o){const A=d[d.length-1];(!A||A.type!==a.SEPARATOR)&&d.push({value:o.label,type:a.SEPARATOR})}D="",p=!1}else D+=T;return D&&!p&&d.push({value:D,type:a.TEXT}),d.filter((T,o)=>{if(T.type===a.SEPARATOR){const A=d[o-1],F=d[o+1];return[A,F].every(x=>x&&(x.type===a.VARIABLE||x.type===a.TEXT)&&x.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=f;function v(i,u){return I.isMacintosh||u?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):i.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(i,u){return I.isMacintosh||u?i.replace(/\(&&\w\)|&&/g,""):I.isWindows?i.replace(/&&|&/g,d=>d==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(i){const u=i.indexOf("/")!==-1?R.posix:R.win32,d=u.basename(i),p=u.dirname(i);return d.length?{name:d,parentPath:p}:{name:p,parentPath:""}}e.splitName=s}),define(be[85],Ee([0,1,14,8,27,11,25]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var y;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(y=e.Mimes||(e.Mimes={}));let E=[],k=[],n=[];function C(r,s=!1){const i=l(r);E.push(i),i.userConfigured?n.push(i):k.push(i),s&&!i.userConfigured&&E.forEach(u=>{u.mime===i.mime||u.userConfigured||(i.extension&&u.extension===i.extension&&console.warn(`Overwriting extension <<${i.extension}>> to now point to mime <<${i.mime}>>`),i.filename&&u.filename===i.filename&&console.warn(`Overwriting filename <<${i.filename}>> to now point to mime <<${i.mime}>>`),i.filepattern&&u.filepattern===i.filepattern&&console.warn(`Overwriting filepattern <<${i.filepattern}>> to now point to mime <<${i.mime}>>`),i.firstline&&u.firstline===i.firstline&&console.warn(`Overwriting firstline <<${i.firstline}>> to now point to mime <<${i.mime}>>`))})}e.registerTextMime=C;function l(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(m.posix.sep)>=0:!1}}function h(r){r?(E=E.filter(s=>!s.userConfigured),n=[]):(E=[],k=[],n=[])}e.clearTextMimes=h;function c(r,s){let i;if(r)switch(r.scheme){case _.Schemas.file:i=r.fsPath;break;case _.Schemas.data:i=I.DataUri.parseMetaData(r).get(I.DataUri.META_DATA_LABEL);break;default:i=r.path}if(!i)return[y.unknown];i=i.toLowerCase();const u=(0,m.basename)(i),d=g(i,u,n);if(d)return[d,y.text];const p=g(i,u,k);if(p)return[p,y.text];if(s){const D=b(s);if(D)return[D,y.text]}return[y.unknown]}e.guessMimeTypes=c;function g(r,s,i){let u=null,d=null,p=null;for(let D=i.length-1;D>=0;D--){const T=i[D];if(s===T.filenameLowercase){u=T;break}if(T.filepattern&&(!d||T.filepattern.length>d.filepattern.length)){const o=T.filepatternOnPath?r:s;(0,S.match)(T.filepatternLowercase,o)&&(d=T)}T.extension&&(!p||T.extension.length>p.extension.length)&&s.endsWith(T.extensionLowercase)&&(p=T)}return u?u.mime:d?d.mime:p?p.mime:null}function b(r){if((0,R.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let s=E.length-1;s>=0;s--){const i=E[s];if(!i.firstline)continue;const u=r.match(i.firstline);if(u&&u.length>0)return i.mime}return null}function w(r){return r?typeof r=="string"?r===y.binary||r===y.text||r===y.unknown:r.length===1&&w(r[0]):!0}e.isUnspecific=w;const P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(r){const s=(0,m.extname)(r);return P[s.toLowerCase()]}e.getMediaMime=a;function f(r){for(const s in P)if(P[s]===r)return s}e.getExtensionForMimeType=f;const v=/^(.+)\/(.+?)(;.+)?$/;function t(r,s){const i=v.exec(r);return i?`${i[1].toLowerCase()}/${i[2].toLowerCase()}${i[3]??""}`:s?void 0:r}e.normalizeMimeType=t}),define(be[117],Ee([0,1,2]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(n){return n.toJSON()}class S{constructor(C){this._uriTransformer=C}transformIncoming(C){const l=this._uriTransformer.transformIncoming(C);return l===C?C:R(m.URI.from(l))}transformOutgoing(C){const l=this._uriTransformer.transformOutgoing(C);return l===C?C:R(m.URI.from(l))}transformOutgoingURI(C){const l=this._uriTransformer.transformOutgoing(C);return l===C?C:m.URI.from(l)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function _(n,C,l){if(!n||l>200)return null;if(typeof n=="object"){if(n instanceof m.URI)return C.transformOutgoing(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const c=_(n[h],C,l+1);c!==null&&(n[h]=c)}}return null}function I(n,C){const l=_(n,C,0);return l===null?n:l}e.transformOutgoingURIs=I;function y(n,C,l,h){if(!n||h>200)return null;if(typeof n=="object"){if(n.$mid===1)return l?m.URI.revive(C.transformIncoming(n)):C.transformIncoming(n);for(let c in n)if(Object.hasOwnProperty.call(n,c)){const g=y(n[c],C,l,h+1);g!==null&&(n[c]=g)}}return null}function E(n,C){const l=y(n,C,!1,0);return l===null?n:l}e.transformIncomingURIs=E;function k(n,C){const l=y(n,C,!0,0);return l===null?n:l}e.transformAndReviveIncomingURIs=k}),define(be[37],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(E){return m.test(E)}e.isUUID=R;const S=new Uint8Array(16),_=[];for(let E=0;E<256;E++)_.push(E.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(E){for(let k=0;k<E.length;k++)E[k]=Math.floor(Math.random()*256);return E};function y(){I(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let E=0,k="";return k+=_[S[E++]],k+=_[S[E++]],k+=_[S[E++]],k+=_[S[E++]],k+="-",k+=_[S[E++]],k+=_[S[E++]],k+="-",k+=_[S[E++]],k+=_[S[E++]],k+="-",k+=_[S[E++]],k+=_[S[E++]],k+="-",k+=_[S[E++]],k+=_[S[E++]],k+=_[S[E++]],k+=_[S[E++]],k+=_[S[E++]],k+=_[S[E++]],k}e.generateUuid=y}),define(be[86],Ee([0,1,82]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(y){let E=(0,m.toUint8)(y);this._defaultValue=E,this._asciiMap=R._createAsciiMap(E),this._map=new Map}static _createAsciiMap(y){let E=new Uint8Array(256);for(let k=0;k<256;k++)E[k]=y;return E}set(y,E){let k=(0,m.toUint8)(E);y>=0&&y<256?this._asciiMap[y]=k:this._map.set(y,k)}get(y){return y>=0&&y<256?this._asciiMap[y]:this._map.get(y)||this._defaultValue}}e.CharacterClassifier=R;var S;(function(I){I[I.False=0]="False",I[I.True=1]="True"})(S||(S={}));class _{constructor(){this._actual=new R(0)}add(y){this._actual.set(y,1)}has(y){return this._actual.get(y)===1}}e.CharacterSet=_}),define(be[118],Ee([0,1,86]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(I){I[I.Regular=0]="Regular",I[I.Whitespace=1]="Whitespace",I[I.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class S extends m.CharacterClassifier{constructor(y){super(0);for(let E=0,k=y.length;E<k;E++)this.set(y.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=S;function _(I){let y={};return E=>(y.hasOwnProperty(E)||(y[E]=I(E)),y[E])}e.getMapForWordSeparators=_(I=>new S(I))}),define(be[38],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(S,_){this.lineNumber=S,this.column=_}with(S=this.lineNumber,_=this.column){return S===this.lineNumber&&_===this.column?this:new m(S,_)}delta(S=0,_=0){return this.with(this.lineNumber+S,this.column+_)}equals(S){return m.equals(this,S)}static equals(S,_){return!S&&!_?!0:!!S&&!!_&&S.lineNumber===_.lineNumber&&S.column===_.column}isBefore(S){return m.isBefore(this,S)}static isBefore(S,_){return S.lineNumber<_.lineNumber?!0:_.lineNumber<S.lineNumber?!1:S.column<_.column}isBeforeOrEqual(S){return m.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,_){return S.lineNumber<_.lineNumber?!0:_.lineNumber<S.lineNumber?!1:S.column<=_.column}static compare(S,_){let I=S.lineNumber|0,y=_.lineNumber|0;if(I===y){let E=S.column|0,k=_.column|0;return E-k}return I-y}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new m(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}}e.Position=m}),define(be[31],Ee([0,1,38]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(_,I,y,E){_>y||_===y&&I>E?(this.startLineNumber=y,this.startColumn=E,this.endLineNumber=_,this.endColumn=I):(this.startLineNumber=_,this.startColumn=I,this.endLineNumber=y,this.endColumn=E)}isEmpty(){return R.isEmpty(this)}static isEmpty(_){return _.startLineNumber===_.endLineNumber&&_.startColumn===_.endColumn}containsPosition(_){return R.containsPosition(this,_)}static containsPosition(_,I){return!(I.lineNumber<_.startLineNumber||I.lineNumber>_.endLineNumber||I.lineNumber===_.startLineNumber&&I.column<_.startColumn||I.lineNumber===_.endLineNumber&&I.column>_.endColumn)}containsRange(_){return R.containsRange(this,_)}static containsRange(_,I){return!(I.startLineNumber<_.startLineNumber||I.endLineNumber<_.startLineNumber||I.startLineNumber>_.endLineNumber||I.endLineNumber>_.endLineNumber||I.startLineNumber===_.startLineNumber&&I.startColumn<_.startColumn||I.endLineNumber===_.endLineNumber&&I.endColumn>_.endColumn)}strictContainsRange(_){return R.strictContainsRange(this,_)}static strictContainsRange(_,I){return!(I.startLineNumber<_.startLineNumber||I.endLineNumber<_.startLineNumber||I.startLineNumber>_.endLineNumber||I.endLineNumber>_.endLineNumber||I.startLineNumber===_.startLineNumber&&I.startColumn<=_.startColumn||I.endLineNumber===_.endLineNumber&&I.endColumn>=_.endColumn)}plusRange(_){return R.plusRange(this,_)}static plusRange(_,I){let y,E,k,n;return I.startLineNumber<_.startLineNumber?(y=I.startLineNumber,E=I.startColumn):I.startLineNumber===_.startLineNumber?(y=I.startLineNumber,E=Math.min(I.startColumn,_.startColumn)):(y=_.startLineNumber,E=_.startColumn),I.endLineNumber>_.endLineNumber?(k=I.endLineNumber,n=I.endColumn):I.endLineNumber===_.endLineNumber?(k=I.endLineNumber,n=Math.max(I.endColumn,_.endColumn)):(k=_.endLineNumber,n=_.endColumn),new R(y,E,k,n)}intersectRanges(_){return R.intersectRanges(this,_)}static intersectRanges(_,I){let y=_.startLineNumber,E=_.startColumn,k=_.endLineNumber,n=_.endColumn,C=I.startLineNumber,l=I.startColumn,h=I.endLineNumber,c=I.endColumn;return y<C?(y=C,E=l):y===C&&(E=Math.max(E,l)),k>h?(k=h,n=c):k===h&&(n=Math.min(n,c)),y>k||y===k&&E>n?null:new R(y,E,k,n)}equalsRange(_){return R.equalsRange(this,_)}static equalsRange(_,I){return!!_&&!!I&&_.startLineNumber===I.startLineNumber&&_.startColumn===I.startColumn&&_.endLineNumber===I.endLineNumber&&_.endColumn===I.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(_){return new m.Position(_.endLineNumber,_.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(_){return new m.Position(_.startLineNumber,_.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(_,I){return new R(this.startLineNumber,this.startColumn,_,I)}setStartPosition(_,I){return new R(_,I,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(_){return new R(_.startLineNumber,_.startColumn,_.startLineNumber,_.startColumn)}static fromPositions(_,I=_){return new R(_.lineNumber,_.column,I.lineNumber,I.column)}static lift(_){return _?new R(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn):null}static isIRange(_){return _&&typeof _.startLineNumber=="number"&&typeof _.startColumn=="number"&&typeof _.endLineNumber=="number"&&typeof _.endColumn=="number"}static areIntersectingOrTouching(_,I){return!(_.endLineNumber<I.startLineNumber||_.endLineNumber===I.startLineNumber&&_.endColumn<I.startColumn||I.endLineNumber<_.startLineNumber||I.endLineNumber===_.startLineNumber&&I.endColumn<_.startColumn)}static areIntersecting(_,I){return!(_.endLineNumber<I.startLineNumber||_.endLineNumber===I.startLineNumber&&_.endColumn<=I.startColumn||I.endLineNumber<_.startLineNumber||I.endLineNumber===_.startLineNumber&&I.endColumn<=_.startColumn)}static compareRangesUsingStarts(_,I){if(_&&I){const k=_.startLineNumber|0,n=I.startLineNumber|0;if(k===n){const C=_.startColumn|0,l=I.startColumn|0;if(C===l){const h=_.endLineNumber|0,c=I.endLineNumber|0;if(h===c){const g=_.endColumn|0,b=I.endColumn|0;return g-b}return h-c}return C-l}return k-n}return(_?1:0)-(I?1:0)}static compareRangesUsingEnds(_,I){return _.endLineNumber===I.endLineNumber?_.endColumn===I.endColumn?_.startLineNumber===I.startLineNumber?_.startColumn-I.startColumn:_.startLineNumber-I.startLineNumber:_.endColumn-I.endColumn:_.endLineNumber-I.endLineNumber}static spansMultipleLines(_){return _.endLineNumber>_.startLineNumber}}e.Range=R}),define(be[119],Ee([0,1,38,31]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var S;(function(I){I[I.LTR=0]="LTR",I[I.RTL=1]="RTL"})(S=e.SelectionDirection||(e.SelectionDirection={}));class _ extends R.Range{constructor(y,E,k,n){super(y,E,k,n);this.selectionStartLineNumber=y,this.selectionStartColumn=E,this.positionLineNumber=k,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return _.selectionsEqual(this,y)}static selectionsEqual(y,E){return y.selectionStartLineNumber===E.selectionStartLineNumber&&y.selectionStartColumn===E.selectionStartColumn&&y.positionLineNumber===E.positionLineNumber&&y.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,E){return this.getDirection()===0?new _(this.startLineNumber,this.startColumn,y,E):new _(y,E,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(y,E){return this.getDirection()===0?new _(y,E,this.endLineNumber,this.endColumn):new _(this.endLineNumber,this.endColumn,y,E)}static fromPositions(y,E=y){return new _(y.lineNumber,y.column,E.lineNumber,E.column)}static liftSelection(y){return new _(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,E){if(y&&!E||!y&&E)return!1;if(!y&&!E)return!0;if(y.length!==E.length)return!1;for(let k=0,n=y.length;k<n;k++)if(!this.selectionsEqual(y[k],E[k]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,E,k,n,C){return C===0?new _(y,E,k,n):new _(k,n,y,E)}}e.Selection=_}),define(be[87],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var m;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(m=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var _;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(_=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var I;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(I=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),this.indentSize=g.tabSize|0,this.insertSpaces=Boolean(g.insertSpaces),this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=Boolean(g.trimAutoWhitespace)}equals(g){return this.tabSize===g.tabSize&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class E{constructor(g,b){this._findMatchBrand=void 0,this.range=g,this.matches=b}}e.FindMatch=E;var k;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right",c[c.None=2]="None"})(n=e.PositionAffinity||(e.PositionAffinity={}));var C;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(C=e.ModelConstants||(e.ModelConstants={}));class l{constructor(g,b,w,P,a,f){this.identifier=g,this.range=b,this.text=w,this.forceMoveMarkers=P,this.isAutoWhitespaceEdit=a,this._isTracked=f}}e.ValidAnnotatedEditOperation=l;class h{constructor(g,b,w){this.reverseEdits=g,this.changes=b,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=h}),define(be[120],Ee([0,1,8,118,38,31,87]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const y=999;class E{constructor(a,f,v,t){this.searchString=a,this.isRegex=f,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=k(this.searchString):a=this.searchString.indexOf(`
`)>=0;let f=null;try{f=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(t){return null}if(!f)return null;let v=!this.isRegex&&!a;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new n(f,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=E;function k(P){if(!P||P.length===0)return!1;for(let a=0,f=P.length;a<f;a++)if(P.charCodeAt(a)===92){if(a++,a>=f)break;const t=P.charCodeAt(a);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class n{constructor(a,f,v){this.regex=a,this.wordSeparators=f,this.simpleSearch=v}}e.SearchData=n;function C(P,a,f){if(!f)return new I.FindMatch(P,null);let v=[];for(let t=0,r=a.length;t<r;t++)v[t]=a[t];return new I.FindMatch(P,v)}e.createFindMatch=C;class l{constructor(a){let f=[],v=0;for(let t=0,r=a.length;t<r;t++)a.charCodeAt(t)===10&&(f[v++]=t);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(a){const f=this._lineFeedsOffsets;let v=0,t=f.length-1;if(t===-1||a<=f[0])return 0;for(;v<t;){const r=v+((t-v)/2>>0);f[r]>=a?t=r-1:f[r+1]>=a?(v=r,t=r):v=r+1}return v+1}}class h{static findMatches(a,f,v,t,r){const s=f.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(a,v,new w(s.wordSeparators,s.regex),t,r):this._doFindMatchesLineByLine(a,v,s,t,r):[]}static _getMultilineMatchRange(a,f,v,t,r,s){let i,u=0;t?(u=t.findLineFeedCountBeforeOffset(r),i=f+r+u):i=f+r;let d;if(t){let o=t.findLineFeedCountBeforeOffset(r+s.length)-u;d=i+s.length+o}else d=i+s.length;const p=a.getPositionAt(i),D=a.getPositionAt(d);return new _.Range(p.lineNumber,p.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(a,f,v,t,r){const s=a.getOffsetAt(f.getStartPosition()),i=a.getValueInRange(f,1),u=a.getEOL()===`\r
`?new l(i):null,d=[];let p=0,D;for(v.reset(0);D=v.next(i);)if(d[p++]=C(this._getMultilineMatchRange(a,s,i,u,D.index,D[0]),D,t),p>=r)return d;return d}static _doFindMatchesLineByLine(a,f,v,t,r){const s=[];let i=0;if(f.startLineNumber===f.endLineNumber){const d=a.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return i=this._findMatchesInLine(v,d,f.startLineNumber,f.startColumn-1,i,s,t,r),s}const u=a.getLineContent(f.startLineNumber).substring(f.startColumn-1);i=this._findMatchesInLine(v,u,f.startLineNumber,f.startColumn-1,i,s,t,r);for(let d=f.startLineNumber+1;d<f.endLineNumber&&i<r;d++)i=this._findMatchesInLine(v,a.getLineContent(d),d,0,i,s,t,r);if(i<r){const d=a.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);i=this._findMatchesInLine(v,d,f.endLineNumber,0,i,s,t,r)}return s}static _findMatchesInLine(a,f,v,t,r,s,i,u){const d=a.wordSeparators;if(!i&&a.simpleSearch){const T=a.simpleSearch,o=T.length,A=f.length;let F=-o;for(;(F=f.indexOf(T,F+o))!==-1;)if((!d||b(d,f,A,F,o))&&(s[r++]=new I.FindMatch(new _.Range(v,F+1+t,v,F+1+o+t),null),r>=u))return r;return r}const p=new w(a.wordSeparators,a.regex);let D;p.reset(0);do if(D=p.next(f),D&&(s[r++]=C(new _.Range(v,D.index+1+t,v,D.index+1+D[0].length+t),D,i),r>=u))return r;while(D);return r}static findNextMatch(a,f,v,t){const r=f.parseSearchRequest();if(!r)return null;const s=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(a,v,s,t):this._doFindNextMatchLineByLine(a,v,s,t)}static _doFindNextMatchMultiline(a,f,v,t){const r=new S.Position(f.lineNumber,1),s=a.getOffsetAt(r),i=a.getLineCount(),u=a.getValueInRange(new _.Range(r.lineNumber,r.column,i,a.getLineMaxColumn(i)),1),d=a.getEOL()===`\r
`?new l(u):null;v.reset(f.column-1);let p=v.next(u);return p?C(this._getMultilineMatchRange(a,s,u,d,p.index,p[0]),p,t):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(a,new S.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(a,f,v,t){const r=a.getLineCount(),s=f.lineNumber,i=a.getLineContent(s),u=this._findFirstMatchInLine(v,i,s,f.column,t);if(u)return u;for(let d=1;d<=r;d++){const p=(s+d-1)%r,D=a.getLineContent(p+1),T=this._findFirstMatchInLine(v,D,p+1,1,t);if(T)return T}return null}static _findFirstMatchInLine(a,f,v,t,r){a.reset(t-1);const s=a.next(f);return s?C(new _.Range(v,s.index+1,v,s.index+1+s[0].length),s,r):null}static findPreviousMatch(a,f,v,t){const r=f.parseSearchRequest();if(!r)return null;const s=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(a,v,s,t):this._doFindPreviousMatchLineByLine(a,v,s,t)}static _doFindPreviousMatchMultiline(a,f,v,t){const r=this._doFindMatchesMultiline(a,new _.Range(1,1,f.lineNumber,f.column),v,t,10*y);if(r.length>0)return r[r.length-1];const s=a.getLineCount();return f.lineNumber!==s||f.column!==a.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(a,new S.Position(s,a.getLineMaxColumn(s)),v,t):null}static _doFindPreviousMatchLineByLine(a,f,v,t){const r=a.getLineCount(),s=f.lineNumber,i=a.getLineContent(s).substring(0,f.column-1),u=this._findLastMatchInLine(v,i,s,t);if(u)return u;for(let d=1;d<=r;d++){const p=(r+s-d-1)%r,D=a.getLineContent(p+1),T=this._findLastMatchInLine(v,D,p+1,t);if(T)return T}return null}static _findLastMatchInLine(a,f,v,t){let r=null,s;for(a.reset(0);s=a.next(f);)r=C(new _.Range(v,s.index+1,v,s.index+1+s[0].length),s,t);return r}}e.TextModelSearch=h;function c(P,a,f,v,t){if(v===0)return!0;const r=a.charCodeAt(v-1);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=a.charCodeAt(v);if(P.get(s)!==0)return!0}return!1}function g(P,a,f,v,t){if(v+t===f)return!0;const r=a.charCodeAt(v+t);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=a.charCodeAt(v+t-1);if(P.get(s)!==0)return!0}return!1}function b(P,a,f,v,t){return c(P,a,f,v,t)&&g(P,a,f,v,t)}e.isValidMatch=b;class w{constructor(a,f){this._wordSeparators=a,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const f=a.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(v=this._searchRegex.exec(a),!v))return null;const t=v.index,r=v[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){m.getNextCodePoint(a,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||b(this._wordSeparators,a,f,t,r))return v}while(v);return null}}e.Searcher=w}),define(be[88],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(y=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)y.indexOf(k)>=0||(E+="\\"+k);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=m();function R(y){let E=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)E=y;else{let k="g";y.ignoreCase&&(k+="i"),y.multiline&&(k+="m"),y.unicode&&(k+="u"),E=new RegExp(y.source,k)}return E.lastIndex=0,E}e.ensureValidWordDefinition=R;const S={maxLen:1e3,windowSize:15,timeBudget:150};function _(y,E,k,n,C=S){if(k.length>C.maxLen){let b=y-C.maxLen/2;return b<0?b=0:n+=b,k=k.substring(b,y+C.maxLen/2),_(y,E,k,n,C)}const l=Date.now(),h=y-1-n;let c=-1,g=null;for(let b=1;!(Date.now()-l>=C.timeBudget);b++){const w=h-C.windowSize*b;E.lastIndex=Math.max(0,w);const P=I(E,k,h,c);if(!P&&g||(g=P,w<=0))break;c=w}if(g){let b={word:g[0],startColumn:n+1+g.index,endColumn:n+1+g.index+g[0].length};return E.lastIndex=0,b}return null}e.getWordAtText=_;function I(y,E,k,n){let C;for(;C=y.exec(E);){const l=C.index||0;if(l<=k&&y.lastIndex>=k)return C;if(n>0&&l>n)return null}return null}}),define(be[121],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class R{constructor(y){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=y.open,this.close=y.close,this._standardTokenMask=0,Array.isArray(y.notIn))for(let E=0,k=y.notIn.length;E<k;E++)switch(y.notIn[E]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(y){return(this._standardTokenMask&y)==0}}e.StandardAutoClosingPairConditional=R;class S{constructor(y){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of y)_(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),_(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),_(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),_(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&_(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=S;function _(I,y,E){I.has(y)?I.get(y).push(E):I.set(y,[E])}}),define(be[58],Ee([0,1,27,14]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(_,I,y,E){if(Array.isArray(_)){let k=0;for(const n of _){const C=S(n,I,y,E);if(C===10)return C;C>k&&(k=C)}return k}else{if(typeof _=="string")return E?_==="*"?5:_===y?10:0:0;if(_){const{language:k,pattern:n,scheme:C,hasAccessToAllModels:l}=_;if(!E&&!l)return 0;let h=0;if(C)if(C===I.scheme)h=10;else if(C==="*")h=5;else return 0;if(k)if(k===y)h=10;else if(k==="*")h=Math.max(h,5);else return 0;if(n){let c;if(typeof n=="string"?c=n:c={...n,base:(0,R.normalize)(n.base)},c===I.fsPath||(0,m.match)(c,I.fsPath))h=10;else return 0}return h}else return 0}}e.score=S}),define(be[122],Ee([0,1,86]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class S{constructor(c,g,b){const w=new Uint8Array(c*g);for(let P=0,a=c*g;P<a;P++)w[P]=b;this._data=w,this.rows=c,this.cols=g}get(c,g){return this._data[c*this.cols+g]}set(c,g,b){this._data[c*this.cols+g]=b}}e.Uint8Matrix=S;class _{constructor(c){let g=0,b=0;for(let P=0,a=c.length;P<a;P++){let[f,v,t]=c[P];v>g&&(g=v),f>b&&(b=f),t>b&&(b=t)}g++,b++;let w=new S(b,g,0);for(let P=0,a=c.length;P<a;P++){let[f,v,t]=c[P];w.set(f,v,t)}this._states=w,this._maxCharCode=g}nextState(c,g){return g<0||g>=this._maxCharCode?0:this._states.get(c,g)}}e.StateMachine=_;let I=null;function y(){return I===null&&(I=new _([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),I}var E;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let k=null;function n(){if(k===null){k=new m.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<h.length;g++)k.set(h.charCodeAt(g),1);const c=".,;";for(let g=0;g<c.length;g++)k.set(c.charCodeAt(g),2)}return k}class C{static _createLink(c,g,b,w,P){let a=P-1;do{const f=g.charCodeAt(a);if(c.get(f)!==2)break;a--}while(a>w);if(w>0){const f=g.charCodeAt(w-1),v=g.charCodeAt(a);(f===40&&v===41||f===91&&v===93||f===123&&v===125)&&a--}return{range:{startLineNumber:b,startColumn:w+1,endLineNumber:b,endColumn:a+2},url:g.substring(w,a+1)}}static computeLinks(c,g=y()){const b=n();let w=[];for(let P=1,a=c.getLineCount();P<=a;P++){const f=c.getLineContent(P),v=f.length;let t=0,r=0,s=0,i=1,u=!1,d=!1,p=!1,D=!1;for(;t<v;){let T=!1;const o=f.charCodeAt(t);if(i===13){let A;switch(o){case 40:u=!0,A=0;break;case 41:A=u?0:1;break;case 91:p=!0,d=!0,A=0;break;case 93:p=!1,A=d?0:1;break;case 123:D=!0,A=0;break;case 125:A=D?0:1;break;case 39:A=s===34||s===96?0:1;break;case 34:A=s===39||s===96?0:1;break;case 96:A=s===39||s===34?0:1;break;case 42:A=s===42?1:0;break;case 124:A=s===124?1:0;break;case 32:A=p?0:1;break;default:A=b.get(o)}A===1&&(w.push(C._createLink(b,f,P,r,t)),T=!0)}else if(i===12){let A;o===91?(d=!0,A=0):A=b.get(o),A===1?T=!0:i=13}else i=g.nextState(i,o),i===0&&(T=!0);T&&(i=1,u=!1,d=!1,D=!1,r=t+1,s=o),t++}i===13&&w.push(C._createLink(b,f,P,r,v))}return w}}e.LinkComputer=C;function l(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:C.computeLinks(h)}e.computeLinks=l}),define(be[123],Ee([0,1,3,6]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class S{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,y){return this._map.set(I,y),this.fire([I]),(0,R.toDisposable)(()=>{this._map.get(I)===y&&(this._map.delete(I),this.fire([I]))})}registerPromise(I,y){let E=null,k=!1;return this._promises.set(I,y.then(n=>{this._promises.delete(I),!(k||!n)&&(E=this.register(I,n))})),(0,R.toDisposable)(()=>{k=!0,E&&E.dispose()})}getPromise(I){const y=this.get(I);if(y)return Promise.resolve(y);const E=this._promises.get(I);return E?E.then(k=>this.get(I)):null}get(I){return this._map.get(I)||null}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=S}),define(be[89],Ee([0,1,24,22]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(S||(S={}));function _(C){for(let l=0,h=C.length;l<h;l+=4){const c=C[l+0],g=C[l+1],b=C[l+2],w=C[l+3];C[l+0]=w,C[l+1]=b,C[l+2]=g,C[l+3]=c}}function I(C){const l=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return R.isLittleEndian()||_(l),m.VSBuffer.wrap(l)}function y(C){const l=C.buffer;if(R.isLittleEndian()||_(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const h=new Uint8Array(l.byteLength);return h.set(l),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function E(C){const l=new Uint32Array(k(C));let h=0;if(l[h++]=C.id,C.type==="full")l[h++]=1,l[h++]=C.data.length,l.set(C.data,h),h+=C.data.length;else{l[h++]=2,l[h++]=C.deltas.length;for(const c of C.deltas)l[h++]=c.start,l[h++]=c.deleteCount,c.data?(l[h++]=c.data.length,l.set(c.data,h),h+=c.data.length):l[h++]=0}return I(l)}e.encodeSemanticTokensDto=E;function k(C){let l=0;if(l+=1+1,C.type==="full")l+=1+C.data.length;else{l+=1,l+=(1+1+1)*C.deltas.length;for(const h of C.deltas)h.data&&(l+=h.data.length)}return l}function n(C){const l=y(C);let h=0;const c=l[h++];if(l[h++]===1){const P=l[h++],a=l.subarray(h,h+P);return h+=P,{id:c,type:"full",data:a}}const b=l[h++];let w=[];for(let P=0;P<b;P++){const a=l[h++],f=l[h++],v=l[h++];let t;v>0&&(t=l.subarray(h,h+v),h+=v),w[P]={start:a,deleteCount:f,data:t}}return{id:c,type:"delta",deltas:w}}e.decodeSemanticTokensDto=n}),define(be[90],Ee([0,1,82]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(I,y){this._prefixSumIndexOfResultBrand=void 0,this.index=I,this.remainder=y}}e.PrefixSumIndexOfResult=R;class S{constructor(I){this.values=I,this.prefixSum=new Uint32Array(I.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(I,y){I=(0,m.toUint32)(I);const E=this.values,k=this.prefixSum,n=y.length;return n===0?!1:(this.values=new Uint32Array(E.length+n),this.values.set(E.subarray(0,I),0),this.values.set(E.subarray(I),I+n),this.values.set(y,I),I-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=I-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(I,y){return I=(0,m.toUint32)(I),y=(0,m.toUint32)(y),this.values[I]===y?!1:(this.values[I]=y,I-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=I-1),!0)}removeValues(I,y){I=(0,m.toUint32)(I),y=(0,m.toUint32)(y);const E=this.values,k=this.prefixSum;if(I>=E.length)return!1;let n=E.length-I;return y>=n&&(y=n),y===0?!1:(this.values=new Uint32Array(E.length-y),this.values.set(E.subarray(0,I),0),this.values.set(E.subarray(I+y),I),this.prefixSum=new Uint32Array(this.values.length),I-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=I-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(I){return I<0?0:(I=(0,m.toUint32)(I),this._getPrefixSum(I))}_getPrefixSum(I){if(I<=this.prefixSumValidIndex[0])return this.prefixSum[I];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),I>=this.values.length&&(I=this.values.length-1);for(let E=y;E<=I;E++)this.prefixSum[E]=this.prefixSum[E-1]+this.values[E];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],I),this.prefixSum[I]}getIndexOf(I){I=Math.floor(I),this.getTotalSum();let y=0,E=this.values.length-1,k=0,n=0,C=0;for(;y<=E;)if(k=y+(E-y)/2|0,n=this.prefixSum[k],C=n-this.values[k],I<C)E=k-1;else if(I>=n)y=k+1;else break;return new R(k,I-C)}}e.PrefixSumComputer=S}),define(be[124],Ee([0,1,8,38,90]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class _{constructor(y,E,k,n){this._uri=y,this._lines=E,this._eol=k,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(y){y.eol&&y.eol!==this._eol&&(this._eol=y.eol,this._lineStarts=null);const E=y.changes;for(const k of E)this._acceptDeleteRange(k.range),this._acceptInsertText(new R.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=y.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const y=this._eol.length,E=this._lines.length,k=new Uint32Array(E);for(let n=0;n<E;n++)k[n]=this._lines[n].length+y;this._lineStarts=new S.PrefixSumComputer(k)}}_setLineText(y,E){this._lines[y]=E,this._lineStarts&&this._lineStarts.changeValue(y,this._lines[y].length+this._eol.length)}_acceptDeleteRange(y){if(y.startLineNumber===y.endLineNumber){if(y.startColumn===y.endColumn)return;this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.startLineNumber-1].substring(y.endColumn-1));return}this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.endLineNumber-1].substring(y.endColumn-1)),this._lines.splice(y.startLineNumber,y.endLineNumber-y.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(y.startLineNumber,y.endLineNumber-y.startLineNumber)}_acceptInsertText(y,E){if(E.length===0)return;let k=(0,m.splitLines)(E);if(k.length===1){this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+k[0]+this._lines[y.lineNumber-1].substring(y.column-1));return}k[k.length-1]+=this._lines[y.lineNumber-1].substring(y.column-1),this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+k[0]);let n=new Uint32Array(k.length-1);for(let C=1;C<k.length;C++)this._lines.splice(y.lineNumber+C-1,0,k[C]),n[C-1]=k[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(y.lineNumber,n)}}e.MirrorTextModel=_}),define(be[125],Ee([18,19]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(be[59],Ee([0,1,125,10,17]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(k,n){return n&&(k.stack||k.stacktrace)?m.localize(0,null,y(k),I(k.stack)||I(k.stacktrace)):y(k)}function I(k){return Array.isArray(k)?k.join(`
`):k}function y(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?m.localize(1,null,k.message):k.message||m.localize(2,null)}function E(k=null,n=!1){if(!k)return m.localize(3,null);if(Array.isArray(k)){const C=S.coalesce(k),l=E(C[0],n);return C.length>1?m.localize(4,null,l,C.length):l}if(R.isString(k))return k;if(k.detail){const C=k.detail;if(C.error)return _(C.error,n);if(C.exception)return _(C.exception,n)}return k.stack?_(k,n):k.message?k.message:m.localize(5,null)}e.toErrorMessage=E}),define(be[126],Ee([18,19]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(be[127],Ee([0,1,126,22,88]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var _;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(_=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=I;class y{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,ce){this._values[Z]=ce}}e.ValidatedEditorOptions=y;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class k{constructor(Z,ce,Ue,xe){this.id=Z,this.name=ce,this.defaultValue=Ue,this.schema=xe}compute(Z,ce,Ue){return Ue}}class n{constructor(Z,ce=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=ce}validate(Z){return this.defaultValue}}class C{constructor(Z,ce,Ue,xe){this.id=Z,this.name=ce,this.defaultValue=Ue,this.schema=xe}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,ce,Ue){return Ue}}function l(z,Z){return typeof z=="undefined"?Z:z==="false"?!1:Boolean(z)}e.boolean=l;class h extends C{constructor(Z,ce,Ue,xe=void 0){typeof xe!="undefined"&&(xe.type="boolean",xe.default=Ue),super(Z,ce,Ue,xe)}validate(Z){return l(Z,this.defaultValue)}}class c extends C{constructor(Z,ce,Ue,xe,et,De=void 0){typeof De!="undefined"&&(De.type="integer",De.default=Ue,De.minimum=xe,De.maximum=et),super(Z,ce,Ue,De),this.minimum=xe,this.maximum=et}static clampedInt(Z,ce,Ue,xe){if(typeof Z=="undefined")return ce;let et=parseInt(Z,10);return isNaN(et)?ce:(et=Math.max(Ue,et),et=Math.min(xe,et),et|0)}validate(Z){return c.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class g extends C{constructor(Z,ce,Ue,xe,et){typeof et!="undefined"&&(et.type="number",et.default=Ue),super(Z,ce,Ue,et),this.validationFn=xe}static clamp(Z,ce,Ue){return Z<ce?ce:Z>Ue?Ue:Z}static float(Z,ce){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return ce;const Ue=parseFloat(Z);return isNaN(Ue)?ce:Ue}validate(Z){return this.validationFn(g.float(Z,this.defaultValue))}}class b extends C{static string(Z,ce){return typeof Z!="string"?ce:Z}constructor(Z,ce,Ue,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.default=Ue),super(Z,ce,Ue,xe)}validate(Z){return b.string(Z,this.defaultValue)}}function w(z,Z,ce){return typeof z!="string"||ce.indexOf(z)===-1?Z:z}e.stringSet=w;class P extends C{constructor(Z,ce,Ue,xe,et=void 0){typeof et!="undefined"&&(et.type="string",et.enum=xe,et.default=Ue),super(Z,ce,Ue,et),this._allowedValues=xe}validate(Z){return w(Z,this.defaultValue,this._allowedValues)}}class a extends k{constructor(Z,ce,Ue,xe,et,De,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.enum=et,Se.default=xe),super(Z,ce,Ue,Se),this._allowedValues=et,this._convert=De}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function f(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,ce,Ue){return Ue===0?Z.accessibilitySupport:Ue}}class t extends k{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{insertSpace:l(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(z){switch(z){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function d(z){switch(z){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class p extends n{constructor(){super(126,[64,31])}compute(Z,ce,Ue){const xe=["monaco-editor"];return ce.get(31)&&xe.push(ce.get(31)),Z.extraEditorClassName&&xe.push(Z.extraEditorClassName),ce.get(64)==="default"?xe.push("mouse-default"):ce.get(64)==="copy"&&xe.push("mouse-copy"),ce.get(99)&&xe.push("showUnused"),ce.get(124)&&xe.push("showDeprecated"),xe.join(" ")}}class D extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Z,ce,Ue){return Ue&&Z.emptySelectionClipboard}}class T extends k{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:m.localize(16,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:m.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{cursorMoveOnType:l(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":w(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":w(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(ce.loop,this.defaultValue.loop)}}}class o extends k{constructor(){super(42,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?o.OFF:Z==="true"?o.ON:Z:Boolean(Z)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class A extends n{constructor(){super(41)}compute(Z,ce,Ue){return Z.fontInfo}}class F extends C{constructor(){super(43,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(Z){let ce=g.float(Z,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(ce,6,100)}compute(Z,ce,Ue){return Z.fontInfo.fontSize}}class x extends k{constructor(){super(44,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(c.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class K extends k{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(48,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...ce},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...ce},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Ue,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Ue,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Ue,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Ue,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Ue,description:m.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{multiple:w(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??w(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??w(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??w(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??w(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??w(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends k{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(51,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:m.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),delay:c.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:l(ce.sticky,this.defaultValue.sticky)}}}var oe;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(oe=e.RenderMinimap||(e.RenderMinimap={}));class V extends n{constructor(){super(129,[47,56,35,63,91,58,59,93,116,119,120,121,2])}compute(Z,ce,Ue){return V.computeLayout(ce,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const ce=Z.height/Z.lineHeight,Ue=Z.scrollBeyondLastLine?ce-1:0,xe=(Z.viewLineCount+Ue)/(Z.pixelRatio*Z.height),et=Math.floor(Z.viewLineCount/xe);return{typicalViewportLineCount:ce,extraLinesBeyondLastLine:Ue,desiredRatio:xe,minimapLineCount:et}}static _computeMinimapLayout(Z,ce){const Ue=Z.outerWidth,xe=Z.outerHeight,et=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const De=ce.stableMinimapLayoutInput,Se=De&&Z.outerHeight===De.outerHeight&&Z.lineHeight===De.lineHeight&&Z.typicalHalfwidthCharacterWidth===De.typicalHalfwidthCharacterWidth&&Z.pixelRatio===De.pixelRatio&&Z.scrollBeyondLastLine===De.scrollBeyondLastLine&&Z.minimap.enabled===De.minimap.enabled&&Z.minimap.side===De.minimap.side&&Z.minimap.size===De.minimap.size&&Z.minimap.showSlider===De.minimap.showSlider&&Z.minimap.renderCharacters===De.minimap.renderCharacters&&Z.minimap.maxColumn===De.minimap.maxColumn&&Z.minimap.scale===De.minimap.scale&&Z.verticalScrollbarWidth===De.verticalScrollbarWidth&&Z.isViewportWrapping===De.isViewportWrapping,Pe=Z.lineHeight,se=Z.typicalHalfwidthCharacterWidth,ae=Z.scrollBeyondLastLine,fe=Z.minimap.renderCharacters;let pe=et>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const B=Z.minimap.maxColumn,me=Z.minimap.size,we=Z.minimap.side,Ie=Z.verticalScrollbarWidth,Oe=Z.viewLineCount,He=Z.remainingWidth,Ze=Z.isViewportWrapping,Ke=fe?2:3;let Je=Math.floor(et*xe);const ut=Je/et;let mt=!1,bt=!1,ot=Ke*pe,at=pe/et,_e=1;if(me==="fill"||me==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeyondLastLine:ct,desiredRatio:yt,minimapLineCount:kt}=V.computeContainedMinimapLineCount({viewLineCount:Oe,scrollBeyondLastLine:ae,height:xe,lineHeight:Pe,pixelRatio:et});if(Oe/kt>1)mt=!0,bt=!0,pe=1,ot=1,at=pe/et;else{let ft=!1,dt=pe+1;if(me==="fit"){const vt=Math.ceil((Oe+ct)*ot);Ze&&Se&&He<=ce.stableFitRemainingWidth?(ft=!0,dt=ce.stableFitMaxMinimapScale):ft=vt>Je}if(me==="fill"||ft){mt=!0;const vt=pe;ot=Math.min(Pe*et,Math.max(1,Math.floor(1/yt))),Ze&&Se&&He<=ce.stableFitRemainingWidth&&(dt=ce.stableFitMaxMinimapScale),pe=Math.min(dt,Math.max(1,Math.floor(ot/Ke))),pe>vt&&(_e=Math.min(2,pe/vt)),at=pe/et/_e,Je=Math.ceil(Math.max(Ge,Oe+ct)*ot),Ze?(ce.stableMinimapLayoutInput=Z,ce.stableFitRemainingWidth=He,ce.stableFitMaxMinimapScale=pe):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const ke=Math.floor(B*at),Y=Math.min(ke,Math.max(0,Math.floor((He-Ie-2)*at/(se+at)))+e.MINIMAP_GUTTER_WIDTH);let H=Math.floor(et*Y);const Fe=H/et;H=Math.floor(H*_e);const Te=fe?1:2,tt=we==="left"?0:Ue-Y-Ie;return{renderMinimap:Te,minimapLeft:tt,minimapWidth:Y,minimapHeightIsEditorHeight:mt,minimapIsSampling:bt,minimapScale:pe,minimapLineHeight:ot,minimapCanvasInnerWidth:H,minimapCanvasInnerHeight:Je,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:ut}}static computeLayout(Z,ce){const Ue=ce.outerWidth|0,xe=ce.outerHeight|0,et=ce.lineHeight|0,De=ce.lineNumbersDigitCount|0,Se=ce.typicalHalfwidthCharacterWidth,Pe=ce.maxDigitWidth,se=ce.pixelRatio,ae=ce.viewLineCount,fe=Z.get(121),pe=fe==="inherit"?Z.get(120):fe,B=pe==="inherit"?Z.get(116):pe,me=Z.get(119),we=Z.get(2),Ie=ce.isDominatedByLongLines,Oe=Z.get(47),He=Z.get(58).renderType!==0,Ze=Z.get(59),Ke=Z.get(93),Je=Z.get(63),ut=Z.get(91),mt=ut.verticalScrollbarSize,bt=ut.verticalHasArrows,ot=ut.arrowSize,at=ut.horizontalScrollbarSize,_e=Z.get(56),ke=Z.get(35);let Y;if(typeof _e=="string"&&/^\d+(\.\d+)?ch$/.test(_e)){const It=parseFloat(_e.substr(0,_e.length-2));Y=c.clampedInt(It*Se,0,0,1e3)}else Y=c.clampedInt(_e,0,0,1e3);ke&&(Y+=16);let H=0;if(He){const It=Math.max(De,Ze);H=Math.round(It*Pe)}let Fe=0;Oe&&(Fe=et);let Te=0,tt=Te+Fe,Ge=tt+H,ct=Ge+Y;const yt=Ue-Fe-H-Y;let kt=!1,Dt=!1,ft=-1;we!==2&&(pe==="inherit"&&Ie?(kt=!0,Dt=!0):B==="on"||B==="bounded"?Dt=!0:B==="wordWrapColumn"&&(ft=me));const dt=V._computeMinimapLayout({outerWidth:Ue,outerHeight:xe,lineHeight:et,typicalHalfwidthCharacterWidth:Se,pixelRatio:se,scrollBeyondLastLine:Ke,minimap:Je,verticalScrollbarWidth:mt,viewLineCount:ae,remainingWidth:yt,isViewportWrapping:Dt},ce.memory||new E);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Te+=dt.minimapWidth,tt+=dt.minimapWidth,Ge+=dt.minimapWidth,ct+=dt.minimapWidth);const vt=yt-dt.minimapWidth,Et=Math.max(1,Math.floor((vt-mt-2)/Se)),Tt=bt?ot:0;return Dt&&(ft=Math.max(1,Et),B==="bounded"&&(ft=Math.min(ft,me))),{width:Ue,height:xe,glyphMarginLeft:Te,glyphMarginWidth:Fe,lineNumbersLeft:tt,lineNumbersWidth:H,decorationsLeft:Ge,decorationsWidth:Y,contentLeft:ct,contentWidth:vt,minimap:dt,viewportColumn:Et,isWordWrapMinified:kt,isViewportWrapping:Dt,wrappingColumn:ft,verticalScrollbarWidth:mt,horizontalScrollbarHeight:at,overviewRuler:{top:Tt,width:mt,height:xe-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=V;class W extends k{constructor(){const Z={enabled:!0};super(55,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:m.localize(42,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:l(Z.enabled,this.defaultValue.enabled)}}}class L extends k{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"boolean",default:Z.enabled,description:m.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:m.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,description:m.localize(45,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(ce.fontFamily,this.defaultValue.fontFamily)}}}class Q extends g{constructor(){super(57,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>g.clamp(Z,0,150),{markdownDescription:m.localize(46,null)})}compute(Z,ce,Ue){return Z.fontInfo.lineHeight}}class O extends k{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(63,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:m.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(48,null),m.localize(49,null),m.localize(50,null)],default:Z.size,description:m.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:m.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:m.localize(53,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:m.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:m.localize(56,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),size:w(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ce.side,this.defaultValue.side,["right","left"]),showSlider:w(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(ce.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ce.scale,1,1,3),maxColumn:c.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function j(z){return z==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class he extends k{constructor(){super(73,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{top:c.clampedInt(ce.top,0,0,1e3),bottom:c.clampedInt(ce.bottom,0,0,1e3)}}}class $ extends k{constructor(){const Z={enabled:!0,cycle:!1};super(74,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:m.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:m.localize(60,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),cycle:l(ce.cycle,this.defaultValue.cycle)}}}class ne extends n{constructor(){super(127)}compute(Z,ce,Ue){return Z.pixelRatio}}class de extends k{constructor(){const Z={other:!0,comments:!1,strings:!1};super(77,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:m.localize(61,null)},comments:{type:"boolean",default:Z.comments,description:m.localize(62,null)},other:{type:"boolean",default:Z.other,description:m.localize(63,null)}}}],default:Z,description:m.localize(64,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const ce=Z,Ue={other:l(ce.other,this.defaultValue.other),comments:l(ce.comments,this.defaultValue.comments),strings:l(ce.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var ye;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(ye=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ne extends k{constructor(){super(58,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(65,null),m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:"on",description:m.localize(69,null)})}validate(Z){let ce=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(ce=4,Ue=Z):Z==="interval"?ce=3:Z==="relative"?ce=2:Z==="on"?ce=1:ce=0),{renderType:ce,renderFn:Ue}}}function Me(z){const Z=z.get(86);return Z==="editable"?z.get(79):Z!=="on"}e.filterValidationDecorations=Me;class $e extends k{constructor(){const Z=[],ce={type:"number",description:m.localize(70,null)};super(90,"rulers",Z,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:m.localize(71,null),format:"color-hex"}}}]},default:Z,description:m.localize(72,null)})}validate(Z){if(Array.isArray(Z)){let ce=[];for(let Ue of Z)if(typeof Ue=="number")ce.push({column:c.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const xe=Ue;ce.push({column:c.clampedInt(xe.column,0,0,1e4),color:xe.color})}return ce.sort((Ue,xe)=>Ue.column-xe.column),ce}return this.defaultValue}}function Xe(z,Z){if(typeof z!="string")return Z;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends k{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(73,null),m.localize(74,null),m.localize(75,null)],default:"auto",description:m.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(77,null),m.localize(78,null),m.localize(79,null)],default:"auto",description:m.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:m.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:m.localize(83,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z,Ue=c.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=c.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Xe(ce.vertical,this.defaultValue.vertical),horizontal:Xe(ce.horizontal,this.defaultValue.horizontal),useShadows:l(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:c.clampedInt(ce.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:c.clampedInt(ce.verticalSliderSize,xe,0,1e3),scrollByPage:l(ce.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends k{constructor(){const Z={enabled:!1,mode:"subwordSmart"};super(53,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:m.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[m.localize(85,null),m.localize(86,null),m.localize(87,null)],default:Z.mode,description:m.localize(88,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),mode:w(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class U extends k{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(89,null),m.localize(90,null)],default:Z.insertMode,description:m.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:m.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:m.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:m.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:m.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:m.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:m.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:m.localize(98,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[m.localize(99,null),m.localize(100,null),m.localize(101,null)],default:Z.previewMode,description:m.localize(102,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:m.localize(103,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(104,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(105,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(106,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(107,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(108,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(109,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(110,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(111,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(112,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(113,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(114,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(115,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{insertMode:w(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(ce.showIcons,this.defaultValue.showIcons),showStatusBar:l(ce.showStatusBar,this.defaultValue.showStatusBar),preview:l(ce.preview,this.defaultValue.preview),previewMode:w(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(ce.showMethods,this.defaultValue.showMethods),showFunctions:l(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:l(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(ce.showDeprecated,this.defaultValue.showDeprecated),showFields:l(ce.showFields,this.defaultValue.showFields),showVariables:l(ce.showVariables,this.defaultValue.showVariables),showClasses:l(ce.showClasses,this.defaultValue.showClasses),showStructs:l(ce.showStructs,this.defaultValue.showStructs),showInterfaces:l(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:l(ce.showModules,this.defaultValue.showModules),showProperties:l(ce.showProperties,this.defaultValue.showProperties),showEvents:l(ce.showEvents,this.defaultValue.showEvents),showOperators:l(ce.showOperators,this.defaultValue.showOperators),showUnits:l(ce.showUnits,this.defaultValue.showUnits),showValues:l(ce.showValues,this.defaultValue.showValues),showConstants:l(ce.showConstants,this.defaultValue.showConstants),showEnums:l(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:l(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(ce.showKeywords,this.defaultValue.showKeywords),showWords:l(ce.showWords,this.defaultValue.showWords),showColors:l(ce.showColors,this.defaultValue.showColors),showFiles:l(ce.showFiles,this.defaultValue.showFiles),showReferences:l(ce.showReferences,this.defaultValue.showReferences),showFolders:l(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:l(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(ce.showSnippets,this.defaultValue.showSnippets),showUsers:l(ce.showUsers,this.defaultValue.showUsers),showIssues:l(ce.showIssues,this.defaultValue.showIssues)}}}class G extends k{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(135,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class X extends n{constructor(){super(128,[79])}compute(Z,ce,Ue){return ce.get(79)?!0:Z.tabFocusMode}}var re;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function q(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ie extends n{constructor(){super(130,[129])}compute(Z,ce,Ue){const xe=ce.get(129);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}const ge="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Re:R.isLinux?We:ge,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ve(z){return e.editorOptionsRegistry[z.id]=z,z}var Ye;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.codeLens=12]="codeLens",z[z.codeLensFontFamily=13]="codeLensFontFamily",z[z.codeLensFontSize=14]="codeLensFontSize",z[z.colorDecorators=15]="colorDecorators",z[z.columnSelection=16]="columnSelection",z[z.comments=17]="comments",z[z.contextmenu=18]="contextmenu",z[z.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",z[z.cursorBlinking=20]="cursorBlinking",z[z.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",z[z.cursorStyle=22]="cursorStyle",z[z.cursorSurroundingLines=23]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",z[z.cursorWidth=25]="cursorWidth",z[z.disableLayerHinting=26]="disableLayerHinting",z[z.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",z[z.domReadOnly=28]="domReadOnly",z[z.dragAndDrop=29]="dragAndDrop",z[z.emptySelectionClipboard=30]="emptySelectionClipboard",z[z.extraEditorClassName=31]="extraEditorClassName",z[z.fastScrollSensitivity=32]="fastScrollSensitivity",z[z.find=33]="find",z[z.fixedOverflowWidgets=34]="fixedOverflowWidgets",z[z.folding=35]="folding",z[z.foldingStrategy=36]="foldingStrategy",z[z.foldingHighlight=37]="foldingHighlight",z[z.foldingImportsByDefault=38]="foldingImportsByDefault",z[z.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=40]="fontFamily",z[z.fontInfo=41]="fontInfo",z[z.fontLigatures=42]="fontLigatures",z[z.fontSize=43]="fontSize",z[z.fontWeight=44]="fontWeight",z[z.formatOnPaste=45]="formatOnPaste",z[z.formatOnType=46]="formatOnType",z[z.glyphMargin=47]="glyphMargin",z[z.gotoLocation=48]="gotoLocation",z[z.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",z[z.hover=51]="hover",z[z.inDiffEditor=52]="inDiffEditor",z[z.inlineSuggest=53]="inlineSuggest",z[z.letterSpacing=54]="letterSpacing",z[z.lightbulb=55]="lightbulb",z[z.lineDecorationsWidth=56]="lineDecorationsWidth",z[z.lineHeight=57]="lineHeight",z[z.lineNumbers=58]="lineNumbers",z[z.lineNumbersMinChars=59]="lineNumbersMinChars",z[z.linkedEditing=60]="linkedEditing",z[z.links=61]="links",z[z.matchBrackets=62]="matchBrackets",z[z.minimap=63]="minimap",z[z.mouseStyle=64]="mouseStyle",z[z.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=66]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",z[z.multiCursorModifier=68]="multiCursorModifier",z[z.multiCursorPaste=69]="multiCursorPaste",z[z.occurrencesHighlight=70]="occurrencesHighlight",z[z.overviewRulerBorder=71]="overviewRulerBorder",z[z.overviewRulerLanes=72]="overviewRulerLanes",z[z.padding=73]="padding",z[z.parameterHints=74]="parameterHints",z[z.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",z[z.quickSuggestions=77]="quickSuggestions",z[z.quickSuggestionsDelay=78]="quickSuggestionsDelay",z[z.readOnly=79]="readOnly",z[z.renameOnType=80]="renameOnType",z[z.renderControlCharacters=81]="renderControlCharacters",z[z.renderIndentGuides=82]="renderIndentGuides",z[z.renderFinalNewline=83]="renderFinalNewline",z[z.renderLineHighlight=84]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=86]="renderValidationDecorations",z[z.renderWhitespace=87]="renderWhitespace",z[z.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",z[z.roundedSelection=89]="roundedSelection",z[z.rulers=90]="rulers",z[z.scrollbar=91]="scrollbar",z[z.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=93]="scrollBeyondLastLine",z[z.scrollPredominantAxis=94]="scrollPredominantAxis",z[z.selectionClipboard=95]="selectionClipboard",z[z.selectionHighlight=96]="selectionHighlight",z[z.selectOnLineNumbers=97]="selectOnLineNumbers",z[z.showFoldingControls=98]="showFoldingControls",z[z.showUnused=99]="showUnused",z[z.snippetSuggestions=100]="snippetSuggestions",z[z.smartSelect=101]="smartSelect",z[z.smoothScrolling=102]="smoothScrolling",z[z.stickyTabStops=103]="stickyTabStops",z[z.stopRenderingLineAfter=104]="stopRenderingLineAfter",z[z.suggest=105]="suggest",z[z.suggestFontSize=106]="suggestFontSize",z[z.suggestLineHeight=107]="suggestLineHeight",z[z.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",z[z.suggestSelection=109]="suggestSelection",z[z.tabCompletion=110]="tabCompletion",z[z.tabIndex=111]="tabIndex",z[z.unusualLineTerminators=112]="unusualLineTerminators",z[z.useShadowDOM=113]="useShadowDOM",z[z.useTabStops=114]="useTabStops",z[z.wordSeparators=115]="wordSeparators",z[z.wordWrap=116]="wordWrap",z[z.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=119]="wordWrapColumn",z[z.wordWrapOverride1=120]="wordWrapOverride1",z[z.wordWrapOverride2=121]="wordWrapOverride2",z[z.wrappingIndent=122]="wrappingIndent",z[z.wrappingStrategy=123]="wrappingStrategy",z[z.showDeprecated=124]="showDeprecated",z[z.inlayHints=125]="inlayHints",z[z.editorClassName=126]="editorClassName",z[z.pixelRatio=127]="pixelRatio",z[z.tabFocusMode=128]="tabFocusMode",z[z.layoutInfo=129]="layoutInfo",z[z.wrappingInfo=130]="wrappingInfo"})(Ye=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(136,null)})),acceptSuggestionOnEnter:ve(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(137,null),""],markdownDescription:m.localize(138,null)})),accessibilitySupport:ve(new v),accessibilityPageSize:ve(new c(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(139,null)})),ariaLabel:ve(new b(4,"ariaLabel",m.localize(140,null))),autoClosingBrackets:ve(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(141,null),m.localize(142,null),""],description:m.localize(143,null)})),autoClosingDelete:ve(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(144,null),""],description:m.localize(145,null)})),autoClosingOvertype:ve(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(146,null),""],description:m.localize(147,null)})),autoClosingQuotes:ve(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(148,null),m.localize(149,null),""],description:m.localize(150,null)})),autoIndent:ve(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[m.localize(151,null),m.localize(152,null),m.localize(153,null),m.localize(154,null),m.localize(155,null)],description:m.localize(156,null)})),automaticLayout:ve(new h(10,"automaticLayout",!1)),autoSurround:ve(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(157,null),m.localize(158,null),m.localize(159,null),""],description:m.localize(160,null)})),stickyTabStops:ve(new h(103,"stickyTabStops",!1,{description:m.localize(161,null)})),codeLens:ve(new h(12,"codeLens",!0,{description:m.localize(162,null)})),codeLensFontFamily:ve(new b(13,"codeLensFontFamily","",{description:m.localize(163,null)})),codeLensFontSize:ve(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(164,null)})),colorDecorators:ve(new h(15,"colorDecorators",!0,{description:m.localize(165,null)})),columnSelection:ve(new h(16,"columnSelection",!1,{description:m.localize(166,null)})),comments:ve(new t),contextmenu:ve(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new h(19,"copyWithSyntaxHighlighting",!0,{description:m.localize(167,null)})),cursorBlinking:ve(new a(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:m.localize(168,null)})),cursorSmoothCaretAnimation:ve(new h(21,"cursorSmoothCaretAnimation",!1,{description:m.localize(169,null)})),cursorStyle:ve(new a(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],d,{description:m.localize(170,null)})),cursorSurroundingLines:ve(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(171,null)})),cursorSurroundingLinesStyle:ve(new P(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(172,null),m.localize(173,null)],description:m.localize(174,null)})),cursorWidth:ve(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(175,null)})),disableLayerHinting:ve(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new h(28,"domReadOnly",!1)),dragAndDrop:ve(new h(29,"dragAndDrop",!0,{description:m.localize(176,null)})),emptySelectionClipboard:ve(new D),extraEditorClassName:ve(new b(31,"extraEditorClassName","")),fastScrollSensitivity:ve(new g(32,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:m.localize(177,null)})),find:ve(new T),fixedOverflowWidgets:ve(new h(34,"fixedOverflowWidgets",!1)),folding:ve(new h(35,"folding",!0,{description:m.localize(178,null)})),foldingStrategy:ve(new P(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(179,null),m.localize(180,null)],description:m.localize(181,null)})),foldingHighlight:ve(new h(37,"foldingHighlight",!0,{description:m.localize(182,null)})),foldingImportsByDefault:ve(new h(38,"foldingImportsByDefault",!1,{description:m.localize(183,null)})),unfoldOnClickAfterEndOfLine:ve(new h(39,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(184,null)})),fontFamily:ve(new b(40,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(185,null)})),fontInfo:ve(new A),fontLigatures2:ve(new o),fontSize:ve(new F),fontWeight:ve(new x),formatOnPaste:ve(new h(45,"formatOnPaste",!1,{description:m.localize(186,null)})),formatOnType:ve(new h(46,"formatOnType",!1,{description:m.localize(187,null)})),glyphMargin:ve(new h(47,"glyphMargin",!0,{description:m.localize(188,null)})),gotoLocation:ve(new K),hideCursorInOverviewRuler:ve(new h(49,"hideCursorInOverviewRuler",!1,{description:m.localize(189,null)})),highlightActiveIndentGuide:ve(new h(50,"highlightActiveIndentGuide",!0,{description:m.localize(190,null)})),hover:ve(new le),inDiffEditor:ve(new h(52,"inDiffEditor",!1)),letterSpacing:ve(new g(54,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>g.clamp(z,-5,20),{description:m.localize(191,null)})),lightbulb:ve(new W),lineDecorationsWidth:ve(new C(56,"lineDecorationsWidth",10)),lineHeight:ve(new Q),lineNumbers:ve(new Ne),lineNumbersMinChars:ve(new c(59,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new h(60,"linkedEditing",!1,{description:m.localize(192,null)})),links:ve(new h(61,"links",!0,{description:m.localize(193,null)})),matchBrackets:ve(new P(62,"matchBrackets","always",["always","near","never"],{description:m.localize(194,null)})),minimap:ve(new O),mouseStyle:ve(new P(64,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new g(65,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:m.localize(195,null)})),mouseWheelZoom:ve(new h(66,"mouseWheelZoom",!1,{markdownDescription:m.localize(196,null)})),multiCursorMergeOverlapping:ve(new h(67,"multiCursorMergeOverlapping",!0,{description:m.localize(197,null)})),multiCursorModifier:ve(new a(68,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],j,{markdownEnumDescriptions:[m.localize(198,null),m.localize(199,null)],markdownDescription:m.localize(200,null)})),multiCursorPaste:ve(new P(69,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(201,null),m.localize(202,null)],markdownDescription:m.localize(203,null)})),occurrencesHighlight:ve(new h(70,"occurrencesHighlight",!0,{description:m.localize(204,null)})),overviewRulerBorder:ve(new h(71,"overviewRulerBorder",!0,{description:m.localize(205,null)})),overviewRulerLanes:ve(new c(72,"overviewRulerLanes",3,0,3)),padding:ve(new he),parameterHints:ve(new $),peekWidgetDefaultFocus:ve(new P(75,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(206,null),m.localize(207,null)],description:m.localize(208,null)})),definitionLinkOpensInPeek:ve(new h(76,"definitionLinkOpensInPeek",!1,{description:m.localize(209,null)})),quickSuggestions:ve(new de),quickSuggestionsDelay:ve(new c(78,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(210,null)})),readOnly:ve(new h(79,"readOnly",!1)),renameOnType:ve(new h(80,"renameOnType",!1,{description:m.localize(211,null),markdownDeprecationMessage:m.localize(212,null)})),renderControlCharacters:ve(new h(81,"renderControlCharacters",!1,{description:m.localize(213,null)})),renderIndentGuides:ve(new h(82,"renderIndentGuides",!0,{description:m.localize(214,null)})),renderFinalNewline:ve(new h(83,"renderFinalNewline",!0,{description:m.localize(215,null)})),renderLineHighlight:ve(new P(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(216,null)],description:m.localize(217,null)})),renderLineHighlightOnlyWhenFocus:ve(new h(85,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(218,null)})),renderValidationDecorations:ve(new P(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new P(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(219,null),m.localize(220,null),m.localize(221,null),""],description:m.localize(222,null)})),revealHorizontalRightPadding:ve(new c(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ve(new h(89,"roundedSelection",!0,{description:m.localize(223,null)})),rulers:ve(new $e),scrollbar:ve(new qe),scrollBeyondLastColumn:ve(new c(92,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(224,null)})),scrollBeyondLastLine:ve(new h(93,"scrollBeyondLastLine",!0,{description:m.localize(225,null)})),scrollPredominantAxis:ve(new h(94,"scrollPredominantAxis",!0,{description:m.localize(226,null)})),selectionClipboard:ve(new h(95,"selectionClipboard",!0,{description:m.localize(227,null),included:R.isLinux})),selectionHighlight:ve(new h(96,"selectionHighlight",!0,{description:m.localize(228,null)})),selectOnLineNumbers:ve(new h(97,"selectOnLineNumbers",!0)),showFoldingControls:ve(new P(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(229,null),m.localize(230,null)],description:m.localize(231,null)})),showUnused:ve(new h(99,"showUnused",!0,{description:m.localize(232,null)})),showDeprecated:ve(new h(124,"showDeprecated",!0,{description:m.localize(233,null)})),inlayHints:ve(new L),snippetSuggestions:ve(new P(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(234,null),m.localize(235,null),m.localize(236,null),m.localize(237,null)],description:m.localize(238,null)})),smartSelect:ve(new G),smoothScrolling:ve(new h(102,"smoothScrolling",!1,{description:m.localize(239,null)})),stopRenderingLineAfter:ve(new c(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ve(new U),inlineSuggest:ve(new je),suggestFontSize:ve(new c(106,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(240,null)})),suggestLineHeight:ve(new c(107,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(241,null)})),suggestOnTriggerCharacters:ve(new h(108,"suggestOnTriggerCharacters",!0,{description:m.localize(242,null)})),suggestSelection:ve(new P(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),tabCompletion:ve(new P(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(247,null),m.localize(248,null),m.localize(249,null)],description:m.localize(250,null)})),tabIndex:ve(new c(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ve(new P(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),useShadowDOM:ve(new h(113,"useShadowDOM",!0)),useTabStops:ve(new h(114,"useTabStops",!0,{description:m.localize(255,null)})),wordSeparators:ve(new b(115,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:m.localize(256,null)})),wordWrap:ve(new P(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(257,null),m.localize(258,null),m.localize(259,null),m.localize(260,null)],description:m.localize(261,null)})),wordWrapBreakAfterCharacters:ve(new b(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new b(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new c(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(262,null)})),wordWrapOverride1:ve(new P(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new P(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ve(new a(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],q,{enumDescriptions:[m.localize(263,null),m.localize(264,null),m.localize(265,null),m.localize(266,null)],description:m.localize(267,null)})),wrappingStrategy:ve(new P(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),editorClassName:ve(new p),pixelRatio:ve(new ne),tabFocusMode:ve(new X),layoutInfo:ve(new V),wrappingInfo:ve(new ie)}}),define(be[128],Ee([18,19]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[129],Ee([18,19]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[130],Ee([18,19]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(be[131],Ee([18,19]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(be[132],Ee([18,19]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(be[133],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[134],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[135],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(be[136],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[137],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[138],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[139],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[140],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(be[141],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(be[142],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[143],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[144],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[145],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[146],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(I){I[I.ACTIVATE=1]="ACTIVATE",I[I.RESTORE=2]="RESTORE",I[I.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var R;(function(I){I[I.PICK=0]="PICK",I[I.DISABLED=1]="DISABLED",I[I.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(R=e.EditorResolution||(e.EditorResolution={}));var S;(function(I){I[I.API=0]="API",I[I.USER=1]="USER"})(S=e.EditorOpenContext||(e.EditorOpenContext={}));var _;(function(I){I[I.Center=0]="Center",I[I.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",I[I.NearTop=2]="NearTop",I[I.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(_=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[147],Ee([0,1,129]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function _(l){return l=l.trim(),l==="*"||R.test(l)}e.isValidVersionStr=_;function I(l){if(!_(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=l.match(R);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=I;function y(l){if(!l)return null;let h=l.majorBase,c=l.majorMustEqual,g=l.minorBase,b=l.minorMustEqual,w=l.patchBase,P=l.patchMustEqual;l.hasCaret&&(h===0||(b=!1),P=!1);let a=0;if(l.preRelease){const f=S.exec(l.preRelease);if(f){const[,v,t,r]=f;a=Date.UTC(Number(v),Number(t)-1,Number(r))}}return{majorBase:h,majorMustEqual:c,minorBase:g,minorMustEqual:b,patchBase:w,patchMustEqual:P,isMinimum:l.hasGreaterEquals,notBefore:a}}e.normalizeVersion=y;function E(l,h,c){let g;typeof l=="string"?g=y(I(l)):g=l;let b;h instanceof Date?b=h.getTime():typeof h=="string"&&(b=new Date(h).getTime());let w;if(typeof c=="string"?w=y(I(c)):w=c,!g||!w)return!1;let P=g.majorBase,a=g.minorBase,f=g.patchBase,v=w.majorBase,t=w.minorBase,r=w.patchBase,s=w.notBefore,i=w.majorMustEqual,u=w.minorMustEqual,d=w.patchMustEqual;return w.isMinimum?P>v?!0:P<v?!1:a>t?!0:a<t||b&&b<s?!1:f>=r:(P===1&&v===0&&(!i||!u||!d)&&(v=1,t=0,r=0,i=!0,u=!1,d=!1),P<v?!1:P>v?!i:a<t?!1:a>t?!u:f<r?!1:f>r?!d:!(b&&b<s))}e.isValidVersion=E;function k(l,h,c,g){return c.isBuiltin||typeof c.main=="undefined"?!0:C(l,h,c.engines.vscode,g)}e.isValidExtensionVersion=k;function n(l,h,c){return l==="*"||C(h,c,l)}e.isEngineValid=n;function C(l,h,c,g=[]){let b=y(I(c));if(!b)return g.push(m.localize(0,null,c)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return g.push(m.localize(1,null,c)),!1}else if(!b.majorMustEqual)return g.push(m.localize(2,null,c)),!1;return E(l,h,b)?!0:(g.push(m.localize(3,null,l,c)),!1)}}),define(be[91],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(S,_=[],I=!1){this.ctor=S,this.staticArguments=_,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=m}),define(be[60],Ee([0,1,91]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function S(I,y,E){y instanceof m.SyncDescriptor||(y=new m.SyncDescriptor(y,[],E)),R.push([I,y])}e.registerSingleton=S;function _(){return R}e.getSingletonServiceDescriptors=_}),define(be[148],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=m;class R{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let I of this._nodes.values())I.outgoing.size===0&&_.push(I);return _}insertEdge(_,I){const y=this.lookupOrInsertNode(_),E=this.lookupOrInsertNode(I);y.outgoing.set(this._hashFn(I),E),E.incoming.set(this._hashFn(_),y)}removeNode(_){const I=this._hashFn(_);this._nodes.delete(I);for(let y of this._nodes.values())y.outgoing.delete(I),y.incoming.delete(I)}lookupOrInsertNode(_){const I=this._hashFn(_);let y=this._nodes.get(I);return y||(y=new m(_),this._nodes.set(I,y)),y}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[I,y]of this._nodes)_.push(`${I}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return _.join(`
`)}findCycleSlow(){for(let[_,I]of this._nodes){const y=new Set([_]),E=this._findCycle(I,y);if(E)return E}}_findCycle(_,I){for(let[y,E]of _.outgoing){if(I.has(y))return[...I,y].join(" -> ");I.add(y);const k=this._findCycle(E,I);if(k)return k;I.delete(y)}}}e.Graph=R}),define(be[4],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function E(k){return k[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=E})(m=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function R(y,E,k,n){E[m.DI_TARGET]===E?E[m.DI_DEPENDENCIES].push({id:y,index:k,optional:n}):(E[m.DI_DEPENDENCIES]=[{id:y,index:k,optional:n}],E[m.DI_TARGET]=E)}function S(y){if(m.serviceIds.has(y))return m.serviceIds.get(y);const E=function(k,n,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(E,k,C,!1)};return E.toString=()=>y,m.serviceIds.set(y,E),E}e.createDecorator=S;function _(y){return y}e.refineServiceDecorator=_;function I(y){return function(E,k,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(y,E,n,!0)}}e.optional=I}),define(be[149],Ee([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function R(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(be[150],Ee([0,1,3,43,6,21,81,58,149]),function(ee,e,m,R,S,_,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(k):!!l.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(h,c){let g={selector:h,provider:c,_score:-1,_time:this._clock++};return this._entries.push(g),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,S.toDisposable)(()=>{if(g){let b=this._entries.indexOf(g);b>=0&&(this._entries.splice(b,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),g=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const c=[];for(let g of this._entries)g._score>0&&c.push(g.provider);return c}ordered(h){const c=[];return this._orderedForEach(h,g=>c.push(g.provider)),c}orderedGroups(h){const c=[];let g,b;return this._orderedForEach(h,w=>{g&&b===w._score?g.push(w.provider):(b=w._score,g=[w.provider],c.push(g))}),c}_orderedForEach(h,c){if(!!h){this._updateScores(h);for(const g of this._entries)g._score>0&&c(g)}}_updateScores(h){let c={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let g of this._entries)if(g._score=(0,y.score)(g.selector,h.uri,h.getLanguageIdentifier().language,(0,E.shouldSynchronizeModel)(h)),k(g.selector)&&g._score>0){for(let b of this._entries)b._score=0;g._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(h,c){return h._score<c._score?1:h._score>c._score?-1:h._time<c._time?1:h._time>c._time?-1:0}}e.LanguageFeatureRegistry=n;class C{constructor(h,c,g=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=c,this.max=g,this._cache=new _.LRUCache(50,.7)}_key(h){return h.id+(0,R.hash)(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const c=this._key(h),g=this._cache.get(c);return this._clamp(g?.value)}update(h,c){const g=this._key(h);let b=this._cache.get(g);return b||(b=new I.MovingAverage,this._cache.set(g,b)),b.update(c),this.get(h)}}e.LanguageFeatureRequestDelays=C}),define(be[61],Ee([0,1,2,31,150,123,35]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var y;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(y=e.LanguageId||(e.LanguageId={}));class E{constructor(A,F){this.language=A,this.id=F}}e.LanguageIdentifier=E;var k;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var n;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var C;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(A){return(A&255)>>>0}static getTokenType(A){return(A&1792)>>>8}static getFontStyle(A){return(A&14336)>>>11}static getForeground(A){return(A&8372224)>>>14}static getBackground(A){return(A&4286578688)>>>23}static getClassNameFromMetadata(A){let F=this.getForeground(A),x="mtk"+F,K=this.getFontStyle(A);return K&1&&(x+=" mtki"),K&2&&(x+=" mtkb"),K&4&&(x+=" mtku"),x}static getInlineStyleFromMetadata(A,F){const x=this.getForeground(A),K=this.getFontStyle(A);let le=`color: ${F[x]};`;return K&1&&(le+="font-style: italic;"),K&2&&(le+="font-weight: bold;"),K&4&&(le+="text-decoration: underline;"),le}}e.TokenMetadata=h;var c;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(A){const F=o[A];let x=F&&I.iconRegistry.get(F);return x||(console.info("No codicon found for CompletionItemKind "+A),x=I.Codicon.symbolProperty),x.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(A,F){let x=o[A];return typeof x=="undefined"&&!F&&(x=9),x}}();var g;(function(o){o[o.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&m.URI.isUri(o.uri)&&R.Range.isIRange(o.range)&&(R.Range.isIRange(o.originSelectionRange)||R.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var r;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var s;(function(o){o[o.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var i;(function(o){const A=new Map;A.set("file",0),A.set("module",1),A.set("namespace",2),A.set("package",3),A.set("class",4),A.set("method",5),A.set("property",6),A.set("field",7),A.set("constructor",8),A.set("enum",9),A.set("interface",10),A.set("function",11),A.set("variable",12),A.set("constant",13),A.set("string",14),A.set("number",15),A.set("boolean",16),A.set("array",17),A.set("object",18),A.set("key",19),A.set("null",20),A.set("enum-member",21),A.set("struct",22),A.set("event",23),A.set("operator",24),A.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function x(oe){return A.get(oe)}o.fromString=x;function K(oe){return F.get(oe)}o.toString=K;function le(oe,V){const W=F.get(oe);let L=W&&I.iconRegistry.get("symbol-"+W);return L||(console.info("No codicon found for SymbolKind "+oe),L=I.Codicon.symbolProperty),`${V?"inline":"block"} ${L.classNames}`}o.toCssClassName=le})(i=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(A){this.value=A}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var d;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(d=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var D;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(D=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new _.TokenizationRegistryImpl;var T;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(T=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[45],Ee([0,1,8,4,22]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=S.userAgent||"";const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",S.isMacintosh),I.set("isLinux",S.isLinux),I.set("isWindows",S.isWindows),I.set("isWeb",S.isWeb),I.set("isMacNative",S.isMacintosh&&!S.isWeb),I.set("isEdge",_.indexOf("Edg/")>=0),I.set("isFirefox",_.indexOf("Firefox")>=0),I.set("isChrome",_.indexOf("Chrome")>=0),I.set("isSafari",_.indexOf("Safari")>=0);const y=Object.prototype.hasOwnProperty;var E;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return C.INSTANCE}static true(){return l.INSTANCE}static has(o){return h.create(o)}static equals(o,A){return c.create(o,A)}static notEquals(o,A){return w.create(o,A)}static regex(o,A){return r.create(o,A)}static in(o,A){return g.create(o,A)}static not(o){return P.create(o)}static and(...o){return i.create(o)}static or(...o){return u.create(o)}static greater(o,A){return a.create(o,A)}static less(o,A){return v.create(o,A)}static deserialize(o,A=!1){if(!!o)return this._deserializeOrExpression(o,A)}static _deserializeOrExpression(o,A){let F=o.split("||");return u.create(F.map(x=>this._deserializeAndExpression(x,A)))}static _deserializeAndExpression(o,A){let F=o.split("&&");return i.create(F.map(x=>this._deserializeOne(x,A)))}static _deserializeOne(o,A){if(o=o.trim(),o.indexOf("!=")>=0){let F=o.split("!=");return w.create(F[0].trim(),this._deserializeValue(F[1],A))}if(o.indexOf("==")>=0){let F=o.split("==");return c.create(F[0].trim(),this._deserializeValue(F[1],A))}if(o.indexOf("=~")>=0){let F=o.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],A))}if(o.indexOf(" in ")>=0){let F=o.split(" in ");return g.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const F=o.split(">=");return f.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const F=o.split(">");return a.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const F=o.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const F=o.split("<");return v.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(o)?P.create(o.substr(1).trim()):h.create(o)}static _deserializeValue(o,A){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let F=/^'([^']*)'$/.exec(o);return F?F[1].trim():o}static _deserializeRegexValue(o,A){if((0,m.isFalsyOrWhitespace)(o)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=o.indexOf("/"),x=o.lastIndexOf("/");if(F===x||F<0){if(A)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let K=o.slice(F+1,x),le=o[x+1]==="i"?"i":"";try{return new RegExp(K,le)}catch(oe){if(A)throw new Error(`bad regexp-value '${o}', parse error: ${oe}`);return console.warn(`bad regexp-value '${o}', parse error: ${oe}`),null}}}e.ContextKeyExpr=k;function n(T,o){return T.cmp(o)}class C{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class l{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class h{constructor(o){this.key=o,this.type=2}static create(o){const A=I.get(o);return typeof A=="boolean"?A?l.INSTANCE:C.INSTANCE:new h(o)}cmp(o){return o.type!==this.type?this.type-o.type:p(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return P.create(this.key)}}e.ContextKeyDefinedExpr=h;class c{constructor(o,A){this.key=o,this.value=A,this.type=4}static create(o,A){if(typeof A=="boolean")return A?h.create(o):P.create(o);const F=I.get(o);return typeof F=="boolean"?A===(F?"true":"false")?l.INSTANCE:C.INSTANCE:new c(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class g{constructor(o,A){this.key=o,this.valueKey=A,this.type=10}static create(o,A){return new g(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const A=o.getValue(this.valueKey),F=o.getValue(this.key);return Array.isArray(A)?A.indexOf(F)>=0:typeof F=="string"&&typeof A=="object"&&A!==null?y.call(A,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return b.create(this)}}e.ContextKeyInExpr=g;class b{constructor(o){this._actual=o,this.type=11}static create(o){return new b(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new b(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class w{constructor(o,A){this.key=o,this.value=A,this.type=5}static create(o,A){if(typeof A=="boolean")return A?P.create(o):h.create(o);const F=I.get(o);return typeof F=="boolean"?A===(F?"true":"false")?C.INSTANCE:l.INSTANCE:new w(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class P{constructor(o){this.key=o,this.type=3}static create(o){const A=I.get(o);return typeof A=="boolean"?A?C.INSTANCE:l.INSTANCE:new P(o)}cmp(o){return o.type!==this.type?this.type-o.type:p(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=P;class a{constructor(o,A){this.key=o,this.value=A,this.type=12}static create(o,A){return new a(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=a;class f{constructor(o,A){this.key=o,this.value=A,this.type=13}static create(o,A){return new f(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=f;class v{constructor(o,A){this.key=o,this.value=A,this.type=14}static create(o,A){return new v(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(o,A){this.key=o,this.value=A,this.type=15}static create(o,A){return new t(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(o,A){this.key=o,this.regexp=A,this.type=7}static create(o,A){return new r(o,A)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const A=this.regexp?this.regexp.source:"",F=o.regexp?o.regexp.source:"";return A<F?-1:A>F?1:0}equals(o){if(o.type===this.type){const A=this.regexp?this.regexp.source:"",F=o.regexp?o.regexp.source:"";return this.key===o.key&&A===F}return!1}evaluate(o){let A=o.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=r;class s{constructor(o){this._actual=o,this.type=8}static create(o){return new s(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new s(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class i{constructor(o){this.expr=o,this.type=6}static create(o){return i._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let A=0,F=this.expr.length;A<F;A++){const x=n(this.expr[A],o.expr[A]);if(x!==0)return x}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].equals(o.expr[A]))return!1;return!0}return!1}evaluate(o){for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].evaluate(o))return!1;return!0}static _normalizeArr(o){const A=[];let F=!1;for(const x of o)if(!!x){if(x.type===1){F=!0;continue}if(x.type===0)return C.INSTANCE;if(x.type===6){A.push(...x.expr);continue}A.push(x)}if(A.length===0&&F)return l.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];for(A.sort(n);A.length>1;){const x=A[A.length-1];if(x.type!==9)break;A.pop();const K=A.pop(),le=u.create(x.expr.map(oe=>i.create([oe,K])));le&&(A.push(le),A.sort(n))}return A.length===1?A[0]:new i(A)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let A of this.expr)o.push(...A.keys());return o}map(o){return new i(this.expr.map(A=>A.map(o)))}negate(){let o=[];for(let A of this.expr)o.push(A.negate());return u.create(o)}}e.ContextKeyAndExpr=i;class u{constructor(o){this.expr=o,this.type=9}static create(o){const A=u._normalizeArr(o);if(A.length!==0)return A.length===1?A[0]:new u(A)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let A=0,F=this.expr.length;A<F;A++){const x=n(this.expr[A],o.expr[A]);if(x!==0)return x}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].equals(o.expr[A]))return!1;return!0}return!1}evaluate(o){for(let A=0,F=this.expr.length;A<F;A++)if(this.expr[A].evaluate(o))return!0;return!1}static _normalizeArr(o){let A=[],F=!1;if(o){for(let x=0,K=o.length;x<K;x++){const le=o[x];if(!!le){if(le.type===0){F=!0;continue}if(le.type===1)return[l.INSTANCE];if(le.type===9){A=A.concat(le.expr);continue}A.push(le)}}if(A.length===0&&F)return[C.INSTANCE];A.sort(n)}return A}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let A of this.expr)o.push(...A.keys());return o}map(o){return new u(this.expr.map(A=>A.map(o)))}negate(){let o=[];for(let F of this.expr)o.push(F.negate());const A=F=>F.type===9?F.expr:[F];for(;o.length>1;){const F=o.shift(),x=o.shift(),K=[];for(const le of A(F))for(const oe of A(x))K.push(k.and(le,oe));o.unshift(k.or(...K))}return o[0]}}e.ContextKeyOrExpr=u;class d extends h{constructor(o,A,F){super(o);this._defaultValue=A,typeof F=="object"?d._info.push({...F,key:o}):F!==!0&&d._info.push({key:o,description:F,type:A!=null?typeof A:void 0})}static all(){return d._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(o){return k.equals(this.key,o)}notEqualsTo(o){return k.notEquals(this.key,o)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(T,o){return T<o?-1:T>o?1:0}function D(T,o,A,F){return T<A?-1:T>A?1:o<F?-1:o>F?1:0}}),define(be[151],Ee([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],Ee([0,1,8,4]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=S;function _(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class y{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,l){if(typeof C=="undefined"||C===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof C=="string"||typeof l=="string"){let h=typeof C=="string"?C:C.value,c=typeof l=="string"?l:l.value;return m.equalsIgnoreCase(h,c)}return C._lower===l._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=y;function E(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function k(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=k,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[152],Ee([0,1,8,26]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(c,g){return c.uuid&&g.uuid?c.uuid===g.uuid:c.id===g.id?!0:(0,m.compareIgnoreCase)(c.id,g.id)===0}e.areSameExtensions=S;class _{constructor(g,b){this.version=b,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof _?S(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=_;function I(c,g){return`${c}.${g}`}e.getExtensionId=I;function y(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function E(c,g){return y(I(c,g))}e.getGalleryExtensionId=E;function k(c,g){const b=[],w=P=>{for(const a of b)if(a.some(f=>S(g(f),g(P))))return a;return null};for(const P of c){const a=w(P);a?a.push(P):b.push([P])}return b}e.groupByExtension=k;function n(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function C(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function l(c){const g=new Set;for(const b of c)b.malicious&&g.add(b.id.id);return g}e.getMaliciousExtensionsSet=l;function h(c,g){const b=[],w=g.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const P=w.shift();if(P&&b.every(a=>!S(a.identifier,{id:P}))){const a=c.filter(f=>S(f.identifier,{id:P}));a.length===1&&(b.push(a[0]),w.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=h}),define(be[62],Ee([0,1,130,14,2,4,8,10,21]),function(ee,e,m,R,S,_,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function k(V){return V.create===!0}e.isFileOpenForWriteOptions=k;var n;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var C;(function(V){V[V.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var l;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=h;function c(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=c;function g(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function b(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=b;var w;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(W,L){super(W);this.code=L}}e.FileSystemProviderError=P;function a(V,W){const L=new P(V.toString(),W);return v(L,W),L}e.createFileSystemProviderError=a;function f(V){return V||a((0,m.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=f;function v(V,W){return V.name=W?`${W} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=v;function t(V){if(!V)return w.Unknown;if(V instanceof P)return V.code;const W=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!W)return w.Unknown;switch(W[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function r(V){if(V instanceof D)return V.fileOperationResult;switch(t(V)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class i{constructor(W,L,Q){this.resource=W,this.operation=L,this.target=Q}isOperation(W){return this.operation===W}}e.FileOperationEvent=i;var u;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class d{constructor(W,L){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const Q of W)switch(Q.type){case 1:this.added||(this.added=E.TernarySearchTree.forUris(()=>L)),this.added.set(Q.resource,Q);break;case 0:this.updated||(this.updated=E.TernarySearchTree.forUris(()=>L)),this.updated.set(Q.resource,Q);break;case 2:this.deleted||(this.deleted=E.TernarySearchTree.forUris(()=>L)),this.deleted.set(Q.resource,Q);break}}contains(W,...L){return this.doContains(W,{includeChildren:!1},...L)}affects(W,...L){return this.doContains(W,{includeChildren:!0},...L)}doContains(W,L,...Q){if(!W)return!1;const O=Q.length>0;return!!((!O||Q.includes(1))&&(this.added?.get(W)||L.includeChildren&&this.added?.findSuperstr(W))||(!O||Q.includes(0))&&(this.updated?.get(W)||L.includeChildren&&this.updated?.findSuperstr(W))||(!O||Q.includes(2))&&(this.deleted?.findSubstr(W)||L.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function p(V,W,L){return!V||!W||V===W||W.length>V.length?!1:(W.charAt(W.length-1)!==R.sep&&(W+=R.sep),L?(0,I.startsWithIgnoreCase)(V,W):V.indexOf(W)===0)}e.isParent=p;class D extends Error{constructor(W,L,Q){super(W);this.fileOperationResult=L,this.options=Q}}e.FileOperationError=D;class T extends D{constructor(W,L,Q){super(W,2,Q);this.stat=L}}e.NotModifiedSinceFileOperationError=T;var o;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=F;async function x(V,W){if(!W.canHandleResource(S.URI.from({scheme:V.scheme})))return new Promise(L=>{const Q=W.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===V.scheme&&O.added&&(Q.dispose(),L())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class K{static formatSize(W){return(0,y.isNumber)(W)||(W=0),W<K.KB?(0,m.localize)(1,null,W.toFixed(0)):W<K.MB?(0,m.localize)(2,null,(W/K.KB).toFixed(2)):W<K.GB?(0,m.localize)(3,null,(W/K.MB).toFixed(2)):W<K.TB?(0,m.localize)(4,null,(W/K.GB).toFixed(2)):(0,m.localize)(5,null,(W/K.TB).toFixed(2))}}e.ByteSize=K,K.KB=1024,K.MB=K.KB*K.KB,K.GB=K.MB*K.KB,K.TB=K.GB*K.KB;var le;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(le=e.Arch||(e.Arch={}));function oe(V){return{maxFileSize:V===0?300*K.MB:16*K.GB,maxHeapSize:V===0?700*K.MB:2*700*K.MB}}e.getPlatformLimits=oe}),define(be[63],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...S){this._entries=new Map;for(let[_,I]of S)this.set(_,I)}set(S,_){const I=this._entries.get(S);return this._entries.set(S,_),I}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=m}),define(be[153],Ee([0,1,12,148,91,4,63,15]),function(ee,e,m,R,S,_,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const E=!1;class k extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class n{constructor(c=new I.ServiceCollection,g=!1,b){this._activeInstantiations=new Set,this._services=c,this._strict=g,this._parent=b,this._services.set(_.IInstantiationService,this)}createChild(c){return new n(c,this._strict,this)}invokeFunction(c,...g){let b=l.traceInvocation(c),w=!1;try{return c({get:(a,f)=>{if(w)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(a,b);if(!v&&f!==_.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return v}},...g)}finally{w=!0,b.stop()}}createInstance(c,...g){let b,w;return c instanceof S.SyncDescriptor?(b=l.traceCreation(c.ctor),w=this._createInstance(c.ctor,c.staticArguments.concat(g),b)):(b=l.traceCreation(c),w=this._createInstance(c,g,b)),b.stop(),w}_createInstance(c,g=[],b){let w=_._util.getServiceDependencies(c).sort((f,v)=>f.index-v.index),P=[];for(const f of w){let v=this._getOrCreateServiceInstance(f.id,b);if(!v&&this._strict&&!f.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${f.id}.`);P.push(v)}let a=w.length>0?w[0].index:g.length;if(g.length!==a){console.warn(`[createInstance] First service dependency of ${c.name} at position ${a+1} conflicts with ${g.length} static arguments`);let f=a-g.length;f>0?g=g.concat(new Array(f)):g=g.slice(0,a)}return new c(...[...g,...P])}_setServiceInstance(c,g){if(this._services.get(c)instanceof S.SyncDescriptor)this._services.set(c,g);else if(this._parent)this._parent._setServiceInstance(c,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let g=this._services.get(c);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):g}_getOrCreateServiceInstance(c,g){let b=this._getServiceInstanceOrDescriptor(c);return b instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,b,g.branch(c,!0)):(g.branch(c,!1),b)}_safeCreateAndCacheServiceInstance(c,g,b){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,g,b)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,g,b){const w=new R.Graph(f=>f.id.toString());let P=0;const a=[{id:c,desc:g,_trace:b}];for(;a.length;){const f=a.pop();if(w.lookupOrInsertNode(f),P++>1e3)throw new k(w);for(let v of _._util.getServiceDependencies(f.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${c} depends on ${v.id} which is NOT registered.`),t instanceof S.SyncDescriptor){const r={id:v.id,desc:t,_trace:f._trace.branch(v.id,!0)};w.insertEdge(f,r),a.push(r)}}}for(;;){const f=w.roots();if(f.length===0){if(!w.isEmpty())throw new k(w);break}for(const{data:v}of f){if(this._getServiceInstanceOrDescriptor(v.id)instanceof S.SyncDescriptor){const r=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,r)}w.removeNode(v)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,g,b=[],w,P){if(this._services.get(c)instanceof S.SyncDescriptor)return this._createServiceInstance(g,b,w,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,g,b,w,P);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(c,g=[],b,w){if(b){const P=new y.IdleValue(()=>this._createInstance(c,g,w));return new Proxy(Object.create(null),{get(a,f){if(f in a)return a[f];let v=P.value,t=v[f];return typeof t!="function"||(t=t.bind(v),a[f]=t),t},set(a,f,v){return P.value[f]=v,!0}})}else return this._createInstance(c,g,w)}}e.InstantiationService=n;var C;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(C||(C={}));class l{constructor(c,g){this.type=c,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return E?new l(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(c){return E?new l(0,c.name):l._None}branch(c,g){let b=new l(2,c.toString());return this._dep.push([c,g,b]),b}stop(){let c=Date.now()-this._start;l._totals+=c;let g=!1;function b(P,a){let f=[],v=new Array(P+1).join("	");for(const[t,r,s]of a._dep)if(r&&s){g=!0,f.push(`${v}CREATES -> ${t}`);let i=b(P+1,s);i&&f.push(i)}else f.push(`${v}uses -> ${t}`);return f.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(c>2||g)&&console.log(w.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(be[16],Ee([0,1,4,6,22,3,59]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function y(){return new Date().toISOString()}var E;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;class k extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class n extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(E.Trace)&&this.log(E.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(E.Debug)&&this.log(E.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(E.Info)&&this.log(E.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(E.Warning)&&this.log(E.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(E.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(E.Error,this.format(s))}else this.log(E.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(E.Critical)&&this.log(E.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let i=t[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch(u){}r+=(s>0?" ":"")+i}return r}}e.AbstractMessageLogger=n;class C extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!S.isWindows}trace(t,...r){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}debug(t,...r){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}info(t,...r){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}warn(t,...r){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,t,...r):console.warn(`[main ${y()}]`,t,...r))}error(t,...r){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,t,...r):console.error(`[main ${y()}]`,t,...r))}critical(t,...r){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,t,...r):console.error(`[main ${y()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class l extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=l;class h extends k{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,I.toErrorMessage)(t,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class c extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class g extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=g;class b extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,r?.always?E.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class w{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(t){}getLevel(){return E.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=w;function P(v){if(v.verbose)return E.Trace;if(typeof v.logLevel=="string"){const t=a(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=P;function a(v){switch(v){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=a;function f(v){switch(v){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=f}),define(be[92],Ee([0,1,4,131,36]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var _;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(_=e.MarkerTag||(e.MarkerTag={}));var I;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function k(c,g){return g-c}E.compare=k;const n=Object.create(null);n[E.Error]=(0,R.localize)(0,null),n[E.Warning]=(0,R.localize)(1,null),n[E.Info]=(0,R.localize)(2,null);function C(c){return n[c]||""}E.toString=C;function l(c){switch(c){case S.default.Error:return E.Error;case S.default.Warning:return E.Warning;case S.default.Info:return E.Info;case S.default.Ignore:return E.Hint}}E.fromSeverity=l;function h(c){switch(c){case E.Error:return S.default.Error;case E.Warning:return S.default.Warning;case E.Info:return S.default.Info;case E.Hint:return S.default.Ignore}}E.toSeverity=h}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var y;(function(E){const k="";function n(l){return C(l,!0)}E.makeKey=n;function C(l,h){let c=[k];return l.source?c.push(l.source.replace("\xA6","\\\xA6")):c.push(k),l.code?typeof l.code=="string"?c.push(l.code.replace("\xA6","\\\xA6")):c.push(l.code.value.replace("\xA6","\\\xA6")):c.push(k),l.severity!==void 0&&l.severity!==null?c.push(I.toString(l.severity)):c.push(k),l.message&&h?c.push(l.message.replace("\xA6","\\\xA6")):c.push(k),l.startLineNumber!==void 0&&l.startLineNumber!==null?c.push(l.startLineNumber.toString()):c.push(k),l.startColumn!==void 0&&l.startColumn!==null?c.push(l.startColumn.toString()):c.push(k),l.endLineNumber!==void 0&&l.endLineNumber!==null?c.push(l.endLineNumber.toString()):c.push(k),l.endColumn!==void 0&&l.endColumn!==null?c.push(l.endColumn.toString()):c.push(k),c.push(k),c.join("\xA6")}E.makeKeyOptionalMessage=C})(y=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,m.createDecorator)("markerService")}),define(be[154],Ee([0,1,36,4,3]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=m.default,e.INotificationService=(0,R.createDecorator)("notificationService");var _;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(_=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class y{constructor(){this.progress=new E,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=y;class E{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=E}),define(be[155],Ee([0,1,6,8,2,4]),function(ee,e,m,R,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,_.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(y){return{resolved:y,dispose(){}}}});function I(y,E){return S.URI.isUri(y)?(0,R.equalsIgnoreCase)(y.scheme,E):(0,R.startsWithIgnoreCase)(y,E+":")}e.matchesScheme=I});var ze=this&&this.__decorate||function(ee,e,m,R){var S=arguments.length,_=S<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,m):R,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(ee,e,m,R);else for(var y=ee.length-1;y>=0;y--)(I=ee[y])&&(_=(S<3?I(_):S>3?I(e,m,_):I(e,m))||_);return S>3&&_&&Object.defineProperty(e,m,_),_},Ve=this&&this.__param||function(ee,e){return function(m,R){e(m,R,ee)}};define(be[156],Ee([0,1,4,20,6,15]),function(ee,e,m,R,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,m.createDecorator)("progressService");var I;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class y{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=y,y.None=Object.freeze({report(){}});let E=class extends S.Disposable{constructor(C,l){super();this.deferred=new _.DeferredPromise,l.withProgress(C,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};E=ze([Ve(1,e.IProgressService)],E),e.UnmanagedProgress=E;class k extends S.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(C){this.stop();const l=++this.currentOperationId,h=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:h.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,m.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,10,41]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(I,y){R.ok(m.isString(I)),R.ok(m.isObject(y)),R.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,y)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new S}),define(be[93],Ee([0,1,28,3]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class _{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,k){this.schemasById[S(E)]=k,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new _;m.Registry.add(e.Extensions.JSONContribution,I)}),define(be[64],Ee([0,1,128,3,28,10,93]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const k=S.Registry.as(I.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(P,a=!0){this.registerConfigurations([P],a)}registerConfigurations(P,a=!0){const f=[];P.forEach(v=>{f.push(...this.validateAndRegisterProperties(v,a,v.extensionInfo)),this.configurationContributors.push(v),this.registerJSONConfiguration(v)}),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterConfigurations(P){const a=[],f=v=>{if(v.properties)for(const t in v.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,v.properties[t]);v.allOf&&v.allOf.forEach(t=>f(t))};for(const v of P){f(v);const t=this.configurationContributors.indexOf(v);t!==-1&&this.configurationContributors.splice(t,1)}k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(P){const a=[],f=[];for(const v of P)for(const t in v)if(a.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...v[t]};const r={type:"object",default:this.defaultValues[t],description:m.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};f.push(l(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=v[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(P){const a=[];for(const f of P)for(const v in f)if(a.push(v),delete this.defaultValues[v],e.OVERRIDE_PROPERTY_PATTERN.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const a of P)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(P,a=!0,f,v=3){v=_.isUndefinedOrNull(P.scope)?v:P.scope;let t=[],r=P.properties;if(r)for(let i in r){if(a&&g(i)){delete r[i];continue}const u=r[i];if(this.updatePropertyDefaultValue(i,u),e.OVERRIDE_PROPERTY_PATTERN.test(i)?u.scope=void 0:(u.scope=_.isUndefinedOrNull(u.scope)?v:u.scope,u.restricted=_.isUndefinedOrNull(u.restricted)?!!f?.restrictedConfigurations?.includes(i):u.restricted),r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),t.push(i)}let s=P.allOf;if(s)for(let i of s)t.push(...this.validateAndRegisterProperties(i,a,f,v));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(P){const a=f=>{let v=f.properties;if(v)for(const r in v)this.updateSchema(r,v[r]);let t=f.allOf;t&&t.forEach(a)};a(P)}updateSchema(P,a){switch(e.allSettings.properties[P]=a,a.scope){case 1:e.applicationSettings.properties[P]=a;break;case 2:e.machineSettings.properties[P]=a;break;case 6:e.machineOverridableSettings.properties[P]=a;break;case 3:e.windowSettings.properties[P]=a;break;case 4:e.resourceSettings.properties[P]=a;break;case 5:e.resourceSettings.properties[P]=a,this.resourceLanguageSettingsSchema.properties[P]=a;break}}removeFromSchema(P,a){switch(delete e.allSettings.properties[P],a.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const a=`[${P}]`,f={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,f),e.allSettings.properties[a]=f,e.applicationSettings.properties[a]=f,e.machineSettings.properties[a]=f,e.machineOverridableSettings.properties[a]=f,e.windowSettings.properties[a]=f,e.resourceSettings.properties[a]=f}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,a){let f=this.defaultValues[P];_.isUndefined(f)&&(f=a.default),_.isUndefined(f)&&(f=h(a.type)),a.default=f}}const C="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(C);function l(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=l;function h(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const c=new n;S.Registry.add(e.Extensions.Configuration,c);function g(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?m.localize(5,null,w):c.getConfigurationProperties()[w]!==void 0?m.localize(6,null,w):null:m.localize(4,null)}e.validateProperty=g;function b(){const w=[],P=c.getConfigurationProperties();for(const a of Object.keys(P))w.push([a,P[a].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=b}),define(be[94],Ee([0,1,23,10,2,28,4,64]),function(ee,e,m,R,S,_,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function E(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof S.URI)}e.isConfigurationOverrides=E;var k;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function C(r,s){const i=s?r?s.keys.filter(A=>r.keys.indexOf(A)===-1):[...s.keys]:[],u=r?s?r.keys.filter(A=>s.keys.indexOf(A)===-1):[...r.keys]:[],d=[];if(s&&r){for(const A of r.keys)if(s.keys.indexOf(A)!==-1){const F=w(r.contents,A),x=w(s.contents,A);m.equals(F,x)||d.push(A)}}const p=[],D=A=>{const F={};for(const x of A)for(const K of x.identifiers)F[v(K)]=x;return F},T=s?D(s.overrides):{},o=r?D(r.overrides):{};if(Object.keys(T).length)for(const A of i){const F=T[A];F&&p.push([(0,y.overrideIdentifierFromKey)(A),F.keys])}if(Object.keys(o).length)for(const A of u){const F=o[A];F&&p.push([(0,y.overrideIdentifierFromKey)(A),F.keys])}if(Object.keys(T).length&&Object.keys(o).length)for(const A of d){const F=o[A],x=T[A];if(F&&x){const K=C({contents:F.contents,keys:F.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});p.push([(0,y.overrideIdentifierFromKey)(A),[...K.added,...K.removed,...K.updated]])}}return{added:i,removed:u,updated:d,overrides:p}}e.compare=C;function l(r,s){const i=[];for(const u of Object.keys(r))if(y.OVERRIDE_PROPERTY_PATTERN.test(u)){const d={};for(const p in r[u])d[p]=r[u][p];i.push({identifiers:[(0,y.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(d),contents:h(d,s)})}return i}e.toOverrides=l;function h(r,s){const i=Object.create(null);for(let u in r)c(i,u,r[u],s);return i}e.toValuesTree=h;function c(r,s,i,u){const d=s.split("."),p=d.pop();let D=r;for(let T=0;T<d.length;T++){let o=d[T],A=D[o];switch(typeof A){case"undefined":A=D[o]=Object.create(null);break;case"object":break;default:u(`Ignoring ${s} as ${d.slice(0,T+1).join(".")} is ${JSON.stringify(A)}`);return}D=A}if(typeof D=="object"&&D!==null)try{D[p]=i}catch(T){u(`Ignoring ${s} as ${d.join(".")} is ${JSON.stringify(D)}`)}else u(`Ignoring ${s} as ${d.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=c;function g(r,s){const i=s.split(".");b(r,i)}e.removeFromValueTree=g;function b(r,s){const i=s.shift();if(s.length===0){delete r[i];return}if(Object.keys(r).indexOf(i)!==-1){const u=r[i];typeof u=="object"&&!Array.isArray(u)&&(b(u,s),Object.keys(u).length===0&&delete r[i])}}function w(r,s,i){function u(D,T){let o=D;for(const A of T){if(typeof o!="object"||o===null)return;o=o[A]}return o}const d=s.split("."),p=u(r,d);return typeof p=="undefined"?i:p}e.getConfigurationValue=w;function P(r,s,i){Object.keys(s).forEach(u=>{u!=="__proto__"&&(u in r?R.isObject(r[u])&&R.isObject(s[u])?P(r[u],s[u],i):i&&(r[u]=s[u]):r[u]=s[u])})}e.merge=P;function a(){const r=_.Registry.as(y.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=a;function f(){const r=Object.create(null),s=_.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(let i in s){let u=s[i].default;c(r,i,u,d=>console.error(`Conflict in default settings: ${d}`))}return r}e.getDefaultValues=f;function v(r){return`[${r}]`}e.keyFromOverrideIdentifier=v;function t(r,s,i){const u=r.inspect(s),d=r.inspect(i);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:u.defaultValue}e.getMigratedSettingValue=t}),define(be[157],Ee([0,1,111,21,17,10,23,2,64,94,28,6,3]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,k.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const i of S.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[i],d=r[i];d&&(typeof u=="object"&&typeof d=="object"?(u=I.deepClone(u),this.mergeContents(u,d)):u=d),s[i]=u}return new h(s,this.keys,this.overrides)}merge(...t){const r=I.deepClone(this.contents),s=I.deepClone(this.overrides),i=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const d of u.overrides){const[p]=s.filter(D=>S.equals(D.identifiers,d.identifiers));p?this.mergeContents(p.contents,d.contents):s.push(I.deepClone(d))}for(const d of u.keys)i.indexOf(d)===-1&&i.push(d)}return new h(r,i,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&_.isObject(t[s])&&_.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=I.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?I.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,k.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=h;class c extends h{constructor(){const t=(0,k.getDefaultValues)(),r=(0,k.getConfigurationKeys)(),s=[];for(const i of Object.keys(t))E.OVERRIDE_PROPERTY_PATTERN.test(i)&&s.push({identifiers:[(0,E.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,k.toValuesTree)(t[i],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,s)}}e.DefaultConfigurationModel=c;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!_.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:i,overrides:u,restricted:d}=this.doParseRaw(t,r);this._configurationModel=new h(s,i,u),this._restrictedConfigurations=d||[]}doParseContent(t){let r={},s=null,i=[],u=[],d=[];function p(T){Array.isArray(i)?i.push(T):s!==null&&(i[s]=T)}let D={onObjectBegin:()=>{let T={};p(T),u.push(i),i=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{i=u.pop()},onArrayBegin:()=>{let T=[];p(T),u.push(i),i=T,s=null},onArrayEnd:()=>{i=u.pop()},onLiteralValue:p,onError:(T,o,A)=>{d.push({error:T,offset:o,length:A})}};if(t)try{m.visit(t,D),r=i[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return r}doParseRaw(t,r){const s=n.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,s,!0,r);t=i.raw;const u=(0,k.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),d=Object.keys(t),p=(0,k.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:u,keys:d,overrides:p,restricted:i.restricted}}filter(t,r,s,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const u={},d=[];for(let p in t)if(E.OVERRIDE_PROPERTY_PATTERN.test(p)&&s){const D=this.filter(t[p],r,!1,i);u[p]=D.raw,d.push(...D.restricted)}else{const D=r[p],T=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&d.push(p),(T===void 0||i.scopes===void 0||i.scopes.includes(T))&&(i.skipRestricted&&D?.restricted||(u[p]=t[p]))}return{raw:u,restricted:d}}}e.ConfigurationModelParser=g;class b extends C.Disposable{constructor(t,r,s,i){super();this.userSettingsResource=t,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(l.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class w{constructor(t,r,s=new h,i=new h,u=new R.ResourceMap,d=new h,p=new R.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=u,this._memoryConfiguration=d,this._memoryConfigurationByResource=p,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new h,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(t):i.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const i=this.getConsolidateConfigurationModel(r,s),u=this.getFolderConfigurationModelForResource(r.resource,s),d=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,p=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),A=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,x=r.overrideIdentifier?d.override(r.overrideIdentifier).getValue(t):d.getValue(t),K=i.getValue(t),le=S.distinct(S.flatten(i.overrides.map(oe=>oe.identifiers))).filter(oe=>i.getOverrideValue(t,oe)!==void 0);return{defaultValue:p,userValue:D,userLocalValue:T,userRemoteValue:o,workspaceValue:A,workspaceFolderValue:F,memoryValue:x,value:K,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:u?.freeze().getValue(t),override:r.overrideIdentifier?u?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:d.getValue(t),override:r.overrideIdentifier?d.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:le.length?le:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(i=>E.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const u=(0,E.overrideIdentifierFromKey)(i),d=this._defaultConfiguration.getKeysForOverrideIdentifier(u),p=t.getKeysForOverrideIdentifier(u),D=[...p.filter(T=>d.indexOf(T)===-1),...d.filter(T=>p.indexOf(T)===-1),...d.filter(T=>!I.equals(this._defaultConfiguration.override(u).getValue(T),t.override(u).getValue(T)))];return[u,D]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:u}=(0,k.compare)(this.localUserConfiguration,t),d=[...r,...s,...i];return d.length&&this.updateLocalUserConfiguration(t),{keys:d,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:u}=(0,k.compare)(this.remoteUserConfiguration,t);let d=[...r,...s,...i];return d.length&&this.updateRemoteUserConfiguration(t),{keys:d,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:i,overrides:u}=(0,k.compare)(this.workspaceConfiguration,t);let d=[...r,...s,...i];return d.length&&this.updateWorkspaceConfiguration(t),{keys:d,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:i,updated:u,removed:d,overrides:p}=(0,k.compare)(s,r);let D=[...i,...u,...d];return(D.length||!s)&&this.updateFolderConfiguration(t,r),{keys:D,overrides:p}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:i,removed:u,overrides:d}=(0,k.compare)(r,void 0);return{keys:[...s,...i,...u],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const i=r.getFolder(t);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const u=this._memoryConfigurationByResource.get(t);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(r=s.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:i,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:i,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((d,p)=>(d.set(y.URI.revive(p[0]),this.parseConfigurationModel(p[1])),d),new R.ResourceMap);return new w(r,s,new h,i,u,new h,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function P(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,r=new Map;for(const i of v)i.keys.forEach(u=>t.add(u)),i.overrides.forEach(([u,d])=>{const p=(0,R.getOrSet)(r,u,new Set);d.forEach(D=>p.add(D))});const s=[];return r.forEach((i,u)=>s.push([u,[...i.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=P;class a{constructor(t,r,s,i){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(p=>u.add(p)),t.overrides.forEach(([,p])=>p.forEach(D=>u.add(D))),this.affectedKeys=[...u.values()];const d=new h;this.affectedKeys.forEach(p=>d.setValue(p,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!I.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,k.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(t=t[i],!t)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=a;class f extends a{constructor(t,r,s,i){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=f}),define(be[95],Ee([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var R;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(I,y=R.Unknown,E){super(I);this._message=I,this._code=y,this._detail=E,this.isHandled=y===R.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(I){return I instanceof S&&I._code===R.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof S&&I._code===R.NoResolverFound}static isHandled(I){return I instanceof S&&I.isHandled}}e.RemoteAuthorityResolverError=S}),define(be[96],Ee([0,1,11]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(k){return k.scheme===m.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=R;function S(k){if(!k)return;const n=k.indexOf("+");return n<0?k:k.substr(0,n)}e.getRemoteName=S;function _(k){return k.scheme!==m.Schemas.file&&k.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=_;function I(k){if(k.folders.length)return k.folders.every(n=>_(n.uri))?k.folders[0].uri:void 0;if(k.configuration&&_(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=I;function y(k){return I(k)?.scheme}e.getVirtualWorkspaceScheme=y;function E(k){return I(k)!==void 0}e.isVirtualWorkspace=E}),define(be[158],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,_,I=5){let y;return y=_(E=>{const k=typeof E=="string"?E:E.data;let n=this._terminalBufferMap.get(S);if(n){n.data.push(k);return}const C=setTimeout(()=>this.flushBuffer(S),I);n={data:[k],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(S),y.dispose()}},this._terminalBufferMap.set(S,n)}),y}stopBuffering(S){const _=this._terminalBufferMap.get(S);_&&_.dispose()}flushBuffer(S){const _=this._terminalBufferMap.get(S);_&&(this._terminalBufferMap.delete(S),this._callback(S,_.data.join("")))}}e.TerminalDataBufferer=m}),define(be[159],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(be[65],Ee([0,1,4,6,28,3,159,35]),function(ee,e,m,R,S,_,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,m.createDecorator)("themeService");var E;(function(b){function w(P){return P&&typeof P=="object"&&typeof P.id=="string"}b.isThemeColor=w})(E=e.ThemeColor||(e.ThemeColor={}));function k(b){return{id:b}}e.themeColorFromId=k;var n;(function(b){function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||E.isThemeColor(r.color))}b.isThemeIcon=w;const P=new RegExp(`^\\$\\((${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?)\\)$`);function a(r){const s=P.exec(r);if(!s)return;let[,i]=s;return{id:i}}b.fromString=a;function f(r,s){let i=r.id;const u=i.lastIndexOf("~");return u!==-1&&(i=i.substring(0,u)),s&&(i=`${i}~${s}`),{id:i}}b.modify=f;function v(r,s){return r.id===s.id&&r.color?.id===s.color?.id}b.isEqual=v;function t(r,s){return{id:r.id,color:s?k(s):void 0}}b.asThemeIcon=t,b.asClassNameArray=y.CSSIcon.asClassNameArray,b.asClassName=y.CSSIcon.asClassName,b.asCSSSelector=y.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=y.Codicon.file,e.FolderThemeIcon=y.Codicon.folder;function C(b){switch(b){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new _.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,R.toDisposable)(()=>{const P=this.themingParticipants.indexOf(w);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new l;S.Registry.add(e.Extensions.ThemingContribution,h);function c(b){return h.onColorThemeChange(b)}e.registerThemingParticipant=c;class g extends R.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,P){let a=this.theme.getColor(w);return a&&P&&(a=P(a,this.theme)),a?a.toString():null}}e.Themable=g}),define(be[160],Ee([0,1,28,65,3,132,93,15,35]),function(ee,e,m,R,S,_,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,_.localize)(0,null)},fontCharacter:{type:"string",description:(0,_.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${E.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,P,a,f){const v=this.iconsById[w];if(v){if(a&&!v.description){v.description=a,this.iconSchema.properties[w].markdownDescription=`${a} $(${w})`;const s=this.iconReferenceSchema.enum.indexOf(w);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=a),this._onDidChange.fire()}return v}let t={id:w,description:a,defaults:P,deprecationMessage:f};this.iconsById[w]=t;let r={$ref:"#/definitions/icons"};return f&&(r.deprecationMessage=f),a&&(r.markdownDescription=`${a}: $(${w})`),this.iconSchema.properties[w]=r,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const P=this.iconReferenceSchema.enum.indexOf(w);P!==-1&&(this.iconReferenceSchema.enum.splice(P,1),this.iconReferenceSchema.enumDescriptions.splice(P,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,P){const a=this.iconFontsById[w];if(a)return a;let f={id:w,definition:P};return this.iconFontsById[w]=f,this._onDidChange.fire(),f}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(v,t)=>v.id.localeCompare(t.id),P=v=>{for(;R.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of f.filter(t=>!!t.description).sort(w))a.push(`|<i class="${P(v)}"></i>|${v.id}|${R.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const v of f.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(w))a.push(`|<i class="${P(v)}"></i>|${v.id}|`);return a.join(`
`)}}const n=new k;m.Registry.add(e.Extensions.IconContribution,n);function C(b,w,P,a){return n.registerIcon(b,w,P,a)}e.registerIcon=C;function l(){return n}e.getIconRegistry=l;function h(){for(const b of E.iconRegistry.all)n.registerIcon(b.id,b.definition,b.description);E.iconRegistry.onDidRegister(b=>n.registerIcon(b.id,b.definition,b.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let c=m.Registry.as(I.Extensions.JSONContribution);c.registerSchema(e.iconsSchemaId,n.getIconSchema());const g=new y.RunOnceScheduler(()=>c.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{g.isScheduled()||g.schedule()}),e.widgetClose=C("widget-close",E.Codicon.close,(0,_.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",E.Codicon.arrowUp,(0,_.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",E.Codicon.arrowDown,(0,_.localize)(4,null)),e.syncing=R.ThemeIcon.modify(E.Codicon.sync,"spin")}),define(be[46],Ee([0,1,2,25,4,21]),function(ee,e,m,R,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");var I;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function y(l){const h=l;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=y;function E(l){const h=l;return!!(h&&typeof h=="object"&&m.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=E;class k{constructor(h,c,g,b){this._id=h,this._configuration=g,this._ignorePathCasing=b,this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class n{constructor(h,c){this.raw=c,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,R.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function C(l){return new n({uri:l,index:0,name:(0,R.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=C}),define(be[66],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const _=this._idPool++;return this._data.set(_,S),this.logDebugInfo(),_}get(S,_){return this._data.has(S)?this._data.get(S)[_]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(be[67],Ee([0,1,2,3,4]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class _{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(E=>({name:E.name,group:E.group,resource:m.URI.revive(E.resource),isActive:E.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=_}),define(be[47],Ee([0,1,11,4]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(I,y){y===null?this._providerInfo.delete(I):this._providerInfo.set(I,y)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(be[161],Ee([0,1,15]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(I,y,E){this._deferredPromises=new Map,this._id=I,this._shared=y,this._storage=E,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of k.values())n.complete()}catch(n){for(const C of k.values())C.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this._init}get(I,y){let E=this._value[I];return typeof E=="undefined"&&(E=y),E}update(I,y){this._value[I]=y;let E=this._deferredPromises.get(I);if(E!==void 0)return E.p;const k=new m.DeferredPromise;return this._deferredPromises.set(I,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class S extends R{constructor(I,y){super(I.identifier.value,!0,y);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=S}),define(be[162],Ee([0,1,3,2,16]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let _=class{constructor(y,E){this._logService=y,this._notebooksAndEditors=E,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(y,E,k){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(y)).acceptModelChanged(E,k)}$acceptDirtyStateChanged(y,E){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(y)).acceptDirty(E)}$acceptModelSaved(y){const E=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(y));this._onDidSaveNotebookDocument.fire(E.apiNotebook)}$acceptDocumentPropertiesChanged(y,E){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",y.path,E);const k=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(y));k.acceptDocumentPropertiesChanged(E),E.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:k.apiNotebook})}};_=ze([Ve(0,S.ILogService)],_),e.ExtHostNotebookDocuments=_}),define(be[13],Ee([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class R{constructor(_){this.getProxy=_.getProxy.bind(_),this.set=_.set.bind(_),this.assertRegistered=_.assertRegistered.bind(_),this.drain=_.drain.bind(_)}}e.ExtHostRpcService=R});var it=this&&this.__classPrivateFieldSet||function(ee,e,m,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Be=this&&this.__classPrivateFieldGet||function(ee,e,m,R){if(m==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?R:m==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[163],Ee([0,1,26,3]),function(ee,e,m,R){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class _{constructor(y,E){S.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(y.identifier),it(this,S,E,"f"),Be(this,S,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(y){return Be(this,S,"f").get(this._id,y)}store(y,E){return Be(this,S,"f").store(this._id,y,E)}delete(y){return Be(this,S,"f").delete(this._id,y)}}e.ExtensionSecrets=_,S=new WeakMap}),define(be[97],Ee([0,1,4,3]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(I){this._enabled=I}$onDidChangeTelemetryEnabled(I){this._enabled=I,this._onDidChangeTelemetryEnabled.fire(I)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(be[68],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(P){P[P.Upsert=0]="Upsert",P[P.RemoveChild=1]="RemoveChild",P[P.Invalidated=2]="Invalidated",P[P.SetProp=3]="SetProp",P[P.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const R=new WeakMap,S=(P,a)=>{const f={controllerId:a};return R.set(P,f),f};e.createPrivateApiFor=S;const _=P=>R.get(P);e.getPrivateApiFor=_;const I=(P,a,f,v)=>{let t=f;return{enumerable:!0,configurable:!1,get(){return t},set(r){v(t,r)||(t=r,P.listener?.({op:3,key:a,value:r}))}}},y=(P,a)=>P===a,E={range:(P,a)=>P===a?!0:!P||!a?!1:P.isEqual(a),label:y,description:y,busy:y,error:y,canResolveChildren:y},k=Object.keys(E),n=(P,a)=>({range:I(P,"range",void 0,E.range),label:I(P,"label",a,E.label),description:I(P,"description",void 0,E.description),canResolveChildren:I(P,"canResolveChildren",!1,E.canResolveChildren),busy:I(P,"busy",!1,E.busy),error:I(P,"error",void 0,E.error)}),C=(P,a)=>{const f=new Map;for(const v of k)E[v](P[v],a[v])||f.set(v,a[v]);return f};e.diffTestItems=C;class l extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=l;class h extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class c extends Error{constructor(a,f,v){super(`TestItem with ID "${a}" is from controller "${f}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=c;const g=P=>{const a=(0,e.getPrivateApiFor)(P);let f=new Map;return{get size(){return f.size},forEach(v,t){for(const r of f.values())v.call(t,r,this)},replace(v){const t=new Map,r=new Set(f.keys()),s={op:4,ops:[]};for(const i of v){if(!(i instanceof b))throw new h(i.id);const u=(0,e.getPrivateApiFor)(i).controllerId;if(u!==a.controllerId)throw new c(i.id,u,a.controllerId);if(t.has(i.id))throw new l(i.id);t.set(i.id,i),r.delete(i.id),s.ops.push({op:0,item:i})}for(const i of r.keys())s.ops.push({op:1,id:i});a.listener?.(s),f=t},add(v){if(!(v instanceof b))throw new h(v.id);f.set(v.id,v),a.listener?.({op:0,item:v})},delete(v){f.delete(v)&&a.listener?.({op:1,id:v})},get(v){return f.get(v)},toJSON(){return Array.from(f.values())},[Symbol.iterator](){return f.values()}}};class b{constructor(a,f,v,t){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const r=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof w?void 0:r.parent}},children:{value:g(this),enumerable:!0,writable:!1},...n(r,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=b;class w extends b{constructor(a,f){super(a,a,f,void 0)}}e.TestItemRootImpl=w}),define(be[69],Ee([0,1,4,3,13]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var _;(function(y){function E(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}y.fromApiTunnel=E;function k(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}y.fromServiceTunnel=k})(_=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let I=class{constructor(E){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(E){return E}async openTunnel(E,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(E){return{dispose:()=>{}}}registerPortsAttributesProvider(E,k){return{dispose:()=>{}}}async $providePortAttributes(E,k,n,C,l){return[]}async $forwardPort(E,k){}async $closeTunnel(E){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=ze([Ve(0,S.IExtHostRpcService)],I),e.ExtHostTunnelService=I});var it=this&&this.__classPrivateFieldSet||function(ee,e,m,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Be=this&&this.__classPrivateFieldGet||function(ee,e,m,R){if(m==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?R:m==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[7],Ee([0,1,17,12,83,21,85,10,2,37,62,95]),function(ee,e,m,R,S,_,I,y,E,k,n,C){"use strict";var l,h,c,g,b,w,P,a,f,v,t,r,s,i,u,d,p,D,T,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(N){function M(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(M,N),Object.setPrototypeOf(M.prototype,N.prototype),M}let F=b=class{constructor(M){l.set(this,void 0),it(this,l,M,"f")}static from(...M){let te=M;return new b(function(){if(te){for(const Ce of te)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();te=void 0}})}dispose(){typeof Be(this,l,"f")=="function"&&(Be(this,l,"f").call(this),it(this,l,void 0,"f"))}};l=new WeakMap,F=b=ze([A],F),e.Disposable=F;let x=w=class{constructor(M,te){if(M<0)throw(0,R.illegalArgument)("line must be non-negative");if(te<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=M,this._character=te}static Min(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let Ce=1;Ce<M.length;Ce++){const Qe=M[Ce];Qe.isBefore(te)&&(te=Qe)}return te}static Max(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let Ce=1;Ce<M.length;Ce++){const Qe=M[Ce];Qe.isAfter(te)&&(te=Qe)}return te}static isPosition(M){if(!M)return!1;if(M instanceof w)return!0;let{line:te,character:Ce}=M;return typeof te=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,te=0){if(M===null||te===null)throw(0,R.illegalArgument)();let Ce;return typeof M=="undefined"?Ce=0:typeof M=="number"?Ce=M:(Ce=typeof M.lineDelta=="number"?M.lineDelta:0,te=typeof M.characterDelta=="number"?M.characterDelta:0),Ce===0&&te===0?this:new w(this.line+Ce,this.character+te)}with(M,te=this.character){if(M===null||te===null)throw(0,R.illegalArgument)();let Ce;return typeof M=="undefined"?Ce=this.line:typeof M=="number"?Ce=M:(Ce=typeof M.line=="number"?M.line:this.line,te=typeof M.character=="number"?M.character:this.character),Ce===this.line&&te===this.character?this:new w(Ce,te)}toJSON(){return{line:this.line,character:this.character}}};x=w=ze([A],x),e.Position=x;let K=P=class{constructor(M,te,Ce,Qe){let nt,rt;if(typeof M=="number"&&typeof te=="number"&&typeof Ce=="number"&&typeof Qe=="number"?(nt=new x(M,te),rt=new x(Ce,Qe)):M instanceof x&&te instanceof x&&(nt=M,rt=te),!nt||!rt)throw new Error("Invalid arguments");nt.isBefore(rt)?(this._start=nt,this._end=rt):(this._start=rt,this._end=nt)}static isRange(M){return M instanceof P?!0:M?x.isPosition(M.start)&&x.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof P?this.contains(M._start)&&this.contains(M._end):M instanceof x?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const te=x.Max(M.start,this._start),Ce=x.Min(M.end,this._end);if(!te.isAfter(Ce))return new P(te,Ce)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const te=x.Min(M.start,this._start),Ce=x.Max(M.end,this.end);return new P(te,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,te=this.end){if(M===null||te===null)throw(0,R.illegalArgument)();let Ce;return M?x.isPosition(M)?Ce=M:(Ce=M.start||this.start,te=M.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&te.isEqual(this.end)?this:new P(Ce,te)}toJSON(){return[this.start,this.end]}};K=P=ze([A],K),e.Range=K;let le=a=class extends K{constructor(M,te,Ce,Qe){let nt,rt;if(typeof M=="number"&&typeof te=="number"&&typeof Ce=="number"&&typeof Qe=="number"?(nt=new x(M,te),rt=new x(Ce,Qe)):M instanceof x&&te instanceof x&&(nt=M,rt=te),!nt||!rt)throw new Error("Invalid arguments");super(nt,rt);this._anchor=nt,this._active=rt}static isSelection(M){return M instanceof a?!0:M?K.isRange(M)&&x.isPosition(M.anchor)&&x.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};le=a=ze([A],le),e.Selection=le;class oe{constructor(M,te,Ce){if(typeof M!="string"||M.length===0)throw(0,R.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,R.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,R.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(te),this.connectionToken=Ce}}e.ResolvedAuthority=oe;class V extends Error{constructor(M,te=C.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(M);this._message=M,this._code=te,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(M,te){return new V(M,C.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(M){return new V(M,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var W;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var L;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Q=f=class{constructor(M,te){this._range=M,this._newText=te}static isTextEdit(M){return M instanceof f?!0:M?K.isRange(M)&&typeof M.newText=="string":!1}static replace(M,te){return new f(M,te)}static insert(M,te){return f.replace(new K(M,M),te)}static delete(M){return f.replace(M,"")}static setEndOfLine(M){const te=new f(new K(new x(0,0),new x(0,0)),"");return te.newEol=M,te}get range(){return this._range}set range(M){if(M&&!K.isRange(M))throw(0,R.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,R.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,R.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Q=f=ze([A],Q),e.TextEdit=Q;var O;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let j=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,te,Ce,Qe){this._edits.push({_type:1,from:M,to:te,options:Ce,metadata:Qe})}createFile(M,te,Ce){this._edits.push({_type:1,from:void 0,to:M,options:te,metadata:Ce})}deleteFile(M,te,Ce){this._edits.push({_type:1,from:M,to:void 0,options:te,metadata:Ce})}replaceNotebookMetadata(M,te,Ce){this._edits.push({_type:3,metadata:Ce,uri:M,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(M,te,Ce,Qe,nt){let rt,lt,St=[],At;if(Bt.isNotebookRange(te)&&Ft.isNotebookCellDataArray(Ce)&&!Ft.isNotebookCellDataArray(Qe)?(rt=te.start,lt=te.end,St=Ce,At=Qe):typeof te=="number"&&typeof Ce=="number"&&Ft.isNotebookCellDataArray(Qe)&&(rt=te,lt=Ce,St=Qe,At=nt),rt===void 0||lt===void 0)throw new Error("Invalid arguments");(rt!==lt||St.length>0)&&this._edits.push({_type:5,uri:M,index:rt,count:lt-rt,cells:St,metadata:At})}replaceNotebookCellMetadata(M,te,Ce,Qe){this._edits.push({_type:3,metadata:Qe,uri:M,edit:{editType:8,index:te,metadata:Ce}})}replace(M,te,Ce,Qe){this._edits.push({_type:2,uri:M,edit:new Q(te,Ce),metadata:Qe})}insert(M,te,Ce,Qe){this.replace(M,new K(te,te),Ce,Qe)}delete(M,te,Ce){this.replace(M,te,"",Ce)}has(M){return this._edits.some(te=>te._type===2&&te.uri.toString()===M.toString())}set(M,te){if(te)for(const Ce of te)Ce&&this._edits.push({_type:2,uri:M,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Qe=this._edits[Ce];Qe._type===2&&Qe.uri.toString()===M.toString()&&(this._edits[Ce]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get(M){const te=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===M.toString()&&te.push(Ce.edit);return te}entries(){const M=new _.ResourceMap;for(let te of this._edits)if(te._type===2){let Ce=M.get(te.uri);Ce||(Ce=[te.uri,[]],M.set(te.uri,Ce)),Ce[1].push(te.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};j=ze([A],j),e.WorkspaceEdit=j;let he=v=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof v?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=v._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,te=this._tabstop++){if(typeof M=="function"){const Ce=new v;Ce._tabstop=this._tabstop,M(Ce),this._tabstop=Ce._tabstop,M=Ce.value}else M=v._escape(M);return this.value+="${",this.value+=te,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,te=this._tabstop++){const Ce=M.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(M,te){if(typeof te=="function"){const Ce=new v;Ce._tabstop=this._tabstop,te(Ce),this._tabstop=Ce._tabstop,te=Ce.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,te&&(this.value+=":",this.value+=te),this.value+="}",this}};he=v=ze([A],he),e.SnippetString=he;var $;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})($=e.DiagnosticTag||(e.DiagnosticTag={}));var ne;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(ne=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=t=class{constructor(M,te){if(this.uri=M,te)if(te instanceof K)this.range=te;else if(te instanceof x)this.range=new K(te,te);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof t?!0:M?K.isRange(M.range)&&E.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};de=t=ze([A],de),e.Location=de;let ye=class{constructor(M,te){this.location=M,this.message=te}static is(M){return M?typeof M.message=="string"&&M.location&&K.isRange(M.location.range)&&E.URI.isUri(M.location.uri):!1}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.location.range.isEqual(te.location.range)&&M.location.uri.toString()===te.location.uri.toString()}};ye=ze([A],ye),e.DiagnosticRelatedInformation=ye;let Ne=class{constructor(M,te,Ce=ne.Error){if(!K.isRange(M))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=M,this.message=te,this.severity=Ce}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.severity===te.severity&&M.code===te.code&&M.severity===te.severity&&M.source===te.source&&M.range.isEqual(te.range)&&(0,m.equals)(M.tags,te.tags)&&(0,m.equals)(M.relatedInformation,te.relatedInformation,ye.isEqual)}};Ne=ze([A],Ne),e.Diagnostic=Ne;let Me=class{constructor(M,te){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=te}};Me=ze([A],Me),e.Hover=Me;var $e;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})($e=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Xe=class{constructor(M,te=$e.Text){this.range=M,this.kind=te}toJSON(){return{range:this.range,kind:$e[this.kind]}}};Xe=ze([A],Xe),e.DocumentHighlight=Xe;var qe;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(qe=e.SymbolKind||(e.SymbolKind={}));var je;(function(N){N[N.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let U=r=class{constructor(M,te,Ce,Qe,nt){this.name=M,this.kind=te,this.containerName=nt,typeof Ce=="string"&&(this.containerName=Ce),Qe instanceof de?this.location=Qe:Ce instanceof K&&(this.location=new de(Qe,Ce)),r.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:qe[this.kind],location:this.location,containerName:this.containerName}}};U=r=ze([A],U),e.SymbolInformation=U;let G=s=class{constructor(M,te,Ce,Qe,nt){this.name=M,this.detail=te,this.kind=Ce,this.range=Qe,this.selectionRange=nt,this.children=[],s.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(s.validate)}};G=s=ze([A],G),e.DocumentSymbol=G;var X;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let re=class{constructor(M,te){this.title=M,this.kind=te}};re=ze([A],re),e.CodeAction=re;let q=i=class{constructor(M){this.value=M}append(M){return new i(this.value?this.value+i.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+i.sep)}};q.sep=".",q=i=ze([A],q),e.CodeActionKind=q,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll");let ie=class{constructor(M,te){if(this.range=M,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ie=ze([A],ie),e.SelectionRange=ie;class ge{constructor(M,te,Ce,Qe,nt,rt){this.kind=M,this.name=te,this.detail=Ce,this.uri=Qe,this.range=nt,this.selectionRange=rt}}e.CallHierarchyItem=ge;class Re{constructor(M,te){this.fromRanges=te,this.from=M}}e.CallHierarchyIncomingCall=Re;class We{constructor(M,te){this.fromRanges=te,this.to=M}}e.CallHierarchyOutgoingCall=We;var ve;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(ve=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ye=class{constructor(M,te){this.range=M,this.command=te}get isResolved(){return!!this.command}};Ye=ze([A],Ye),e.CodeLens=Ye;let z=u=class{constructor(M,te=!1){h.set(this,void 0),it(this,h,new S.MarkdownString(M,{supportThemeIcons:te}),"f")}static isMarkdownString(M){return M instanceof u?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Be(this,h,"f").value}set value(M){Be(this,h,"f").value=M}get isTrusted(){return Be(this,h,"f").isTrusted}set isTrusted(M){Be(this,h,"f").isTrusted=M}get supportThemeIcons(){return Be(this,h,"f").supportThemeIcons}set supportThemeIcons(M){Be(this,h,"f").supportThemeIcons=M}appendText(M){return Be(this,h,"f").appendText(M),this}appendMarkdown(M){return Be(this,h,"f").appendMarkdown(M),this}appendCodeblock(M,te){return Be(this,h,"f").appendCodeblock(te??"",M),this}};h=new WeakMap,z=u=ze([A],z),e.MarkdownString=z;let Z=class{constructor(M,te){this.label=M,this.documentation=te}};Z=ze([A],Z),e.ParameterInformation=Z;let ce=class{constructor(M,te){this.label=M,this.documentation=te,this.parameters=[]}};ce=ze([A],ce),e.SignatureInformation=ce;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=ze([A],Ue),e.SignatureHelp=Ue;var xe;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let De=class{constructor(M,te,Ce){this.text=M,this.position=te,this.kind=Ce}};De=ze([A],De),e.InlayHint=De;var Se;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Pe;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Pe=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(N){N[N.Deprecated=1]="Deprecated"})(se=e.CompletionItemTag||(e.CompletionItemTag={}));let ae=class{constructor(M,te){this.label=M,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ae=ze([A],ae),e.CompletionItem=ae;let fe=class{constructor(M=[],te=!1){this.items=M,this.isIncomplete=te}};fe=ze([A],fe),e.CompletionList=fe;let pe=class{constructor(M,te,Ce){this.text=M,this.range=te,this.command=Ce}};pe=ze([A],pe),e.InlineSuggestion=pe;let B=class{constructor(M){this.items=M}};B=ze([A],B),e.InlineSuggestions=B;var me;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(me=e.ViewColumn||(e.ViewColumn={}));var we;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(we=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Oe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Oe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var He;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(He=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ze;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ke;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(Ke=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Je;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(Je=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function M(te){switch(te){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=M}(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ut=class{constructor(M,te){if(te&&!E.URI.isUri(te))throw(0,R.illegalArgument)("target");if(!K.isRange(M)||M.isEmpty)throw(0,R.illegalArgument)("range");this.range=M,this.target=te}};ut=ze([A],ut),e.DocumentLink=ut;let mt=class{constructor(M,te,Ce,Qe){this.red=M,this.green=te,this.blue=Ce,this.alpha=Qe}};mt=ze([A],mt),e.Color=mt;let bt=class{constructor(M,te){if(te&&!(te instanceof mt))throw(0,R.illegalArgument)("color");if(!K.isRange(M)||M.isEmpty)throw(0,R.illegalArgument)("range");this.range=M,this.color=te}};bt=ze([A],bt),e.ColorInformation=bt;let ot=class{constructor(M){if(!M||typeof M!="string")throw(0,R.illegalArgument)("label");this.label=M}};ot=ze([A],ot),e.ColorPresentation=ot;var at;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(at=e.ColorFormat||(e.ColorFormat={}));var _e;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(_e=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ke{constructor(M,te,Ce){if(this.startIndex=M,this.length=te,this.tooltip=Ce,typeof M!="number"||M<0)throw(0,R.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,R.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=ke;class Y{constructor(M){this.options=M,typeof M!="object"&&(0,R.illegalArgument)("options")}}e.TerminalProfile=Y;var H;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(H=e.TaskRevealKind||(e.TaskRevealKind={}));var Fe;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(Fe=e.TaskPanelKind||(e.TaskPanelKind={}));let Te=d=class{constructor(M,te){if(typeof M!="string"||typeof te!="string")throw(0,R.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}get id(){return this._id}};Te.Clean=new d("clean","Clean"),Te.Build=new d("build","Build"),Te.Rebuild=new d("rebuild","Rebuild"),Te.Test=new d("test","Test"),Te=d=ze([A],Te),e.TaskGroup=Te;function tt(N){let M="";for(let te=0;te<N.length;te++)M+=N[te].replace(/,/g,",,")+",";return M}let Ge=class{constructor(M,te,Ce){if(typeof M!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=M,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Ce):this._options=te)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,R.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let te of this._args)M.push(te);return tt(M)}};Ge=ze([A],Ge),e.ProcessExecution=Ge;let ct=class{constructor(M,te,Ce){if(this._args=[],Array.isArray(te)){if(!M)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,R.illegalArgument)("command");this._command=M,this._args=te,this._options=Ce}else{if(typeof M!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=M,this._options=te}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,R.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)M.push(typeof te=="string"?te:te.value);return tt(M)}};ct=ze([A],ct),e.ShellExecution=ct;var yt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(yt=e.ShellQuoting||(e.ShellQuoting={}));var kt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(kt=e.TaskScope||(e.TaskScope={}));class Dt{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Dt;let ft=p=class{constructor(M,te,Ce,Qe,nt,rt){this.__deprecated=!1,this._definition=this.definition=M;let lt;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Ce,this.execution=Qe,lt=nt,this.__deprecated=!0):te===kt.Global||te===kt.Workspace?(this.target=te,this._name=this.name=Ce,this._source=this.source=Qe,this.execution=nt,lt=rt):(this.target=te,this._name=this.name=Ce,this._source=this.source=Qe,this.execution=nt,lt=rt),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:p.ProcessType,id:this._execution.computeId()}:this._execution instanceof ct?this._definition={type:p.ShellType,id:this._execution.computeId()}:this._execution instanceof Dt?this._definition={type:p.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:p.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const te=this._definition.type;(p.EmptyType===te||p.ProcessType===te||p.ShellType===te||p.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=p=ze([A],ft),e.Task=ft;var dt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(M,te=Et.None){this.collapsibleState=te,E.URI.isUri(M)?this.resourceUri=M:this.label=M}};vt=ze([A],vt),e.TreeItem=vt;var Et;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Tt=class{constructor(M,te){this.id=M,this.color=te}};Tt=ze([A],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let It=class{constructor(M){this.id=M}};It=ze([A],It),e.ThemeColor=It;var bn;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(bn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(M,te){if(typeof M!="string"&&(!M||!E.URI.isUri(M)&&!E.URI.isUri(M.uri)))throw(0,R.illegalArgument)("base");if(typeof te!="string")throw(0,R.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=E.URI.file(M),this.base=M):E.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=te}};Vt=ze([A],Vt),e.RelativePattern=Vt;let _t=class{constructor(M,te,Ce,Qe){this.enabled=typeof M=="boolean"?M:!0,typeof te=="string"&&(this.condition=te),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};_t=ze([A],_t),e.Breakpoint=_t;let Yt=class extends _t{constructor(M,te,Ce,Qe,nt){super(te,Ce,Qe,nt);if(M===null)throw(0,R.illegalArgument)("location");this.location=M}};Yt=ze([A],Yt),e.SourceBreakpoint=Yt;let Jt=class extends _t{constructor(M,te,Ce,Qe,nt){super(te,Ce,Qe,nt);this.functionName=M}};Jt=ze([A],Jt),e.FunctionBreakpoint=Jt;let gt=class extends _t{constructor(M,te,Ce,Qe,nt,rt,lt){super(Qe,nt,rt,lt);if(!te)throw(0,R.illegalArgument)("dataId");this.label=M,this.dataId=te,this.canPersist=Ce}};gt=ze([A],gt),e.DataBreakpoint=gt;let qt=class{constructor(M,te,Ce){this.command=M,this.args=te||[],this.options=Ce}};qt=ze([A],qt),e.DebugAdapterExecutable=qt;let Wt=class{constructor(M,te){this.port=M,this.host=te}};Wt=ze([A],Wt),e.DebugAdapterServer=Wt;let Xt=class{constructor(M){this.path=M}};Xt=ze([A],Xt),e.DebugAdapterNamedPipeServer=Xt;let Zt=class{constructor(M){this.implementation=M}};Zt=ze([A],Zt),e.DebugAdapterInlineImplementation=Zt;let Pt=class{constructor(M,te){this.range=M,this.expression=te}};Pt=ze([A],Pt),e.EvaluatableExpression=Pt;var dn;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor(M,te){this.range=M,this.text=te}};en=ze([A],en),e.InlineValueText=en;let xt=class{constructor(M,te,Ce=!0){this.range=M,this.variableName=te,this.caseSensitiveLookup=Ce}};xt=ze([A],xt),e.InlineValueVariableLookup=xt;let ht=class{constructor(M,te){this.range=M,this.expression=te}};ht=ze([A],ht),e.InlineValueEvaluatableExpression=ht;let tn=class{constructor(M,te){this.frameId=M,this.stoppedLocation=te}};tn=ze([A],tn),e.InlineValueContext=tn;var Mt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Mt=e.FileChangeType||(e.FileChangeType={}));let Nt=D=class extends Error{constructor(M,te=n.FileSystemProviderErrorCode.Unknown,Ce){super(E.URI.isUri(M)?M.toString(!0):M);this.code=Ce?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(M){return new D(M,n.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(M){return new D(M,n.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(M){return new D(M,n.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(M){return new D(M,n.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(M){return new D(M,n.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(M){return new D(M,n.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};Nt=D=ze([A],Nt),e.FileSystemError=Nt;let jt=class{constructor(M,te,Ce){this.start=M,this.end=te,this.kind=Ce}};jt=ze([A],jt),e.FoldingRange=jt;var En;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class fn{constructor(M,te=[]){this.tokenTypes=M,this.tokenModifiers=te}}e.SemanticTokensLegend=fn;function nn(N){return typeof N=="undefined"||(0,y.isStringArray)(N)}class rn{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let te=0,Ce=M.tokenTypes.length;te<Ce;te++)this._tokenTypeStrToInt.set(M.tokenTypes[te],te);for(let te=0,Ce=M.tokenModifiers.length;te<Ce;te++)this._tokenModifierStrToInt.set(M.tokenModifiers[te],te)}}push(M,te,Ce,Qe,nt){if(typeof M=="number"&&typeof te=="number"&&typeof Ce=="number"&&typeof Qe=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(M,te,Ce,Qe,nt);if(K.isRange(M)&&typeof te=="string"&&nn(Ce))return this._push(M,te,Ce);throw(0,R.illegalArgument)()}_push(M,te,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Qe=M.start.line,nt=M.start.character,rt=M.end.character-M.start.character,lt=this._tokenTypeStrToInt.get(te);let St=0;if(Ce)for(const At of Ce){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(At);St|=1<<Rt>>>0}this._pushEncoded(Qe,nt,rt,lt,St)}_pushEncoded(M,te,Ce,Qe,nt){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let At=0,Rt=0;for(let Lt=0;Lt<St;Lt++){let Ot=this._data[5*Lt],un=this._data[5*Lt+1];Ot===0?(Ot=At,un+=Rt):Ot+=At,this._data[5*Lt]=Ot,this._data[5*Lt+1]=un,At=Ot,Rt=un}}let rt=M,lt=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=nt,this._prevLine=M,this._prevChar=te}static _sortAndDeltaEncode(M){let te=[];const Ce=M.length/5|0;for(let lt=0;lt<Ce;lt++)te[lt]=lt;te.sort((lt,St)=>{const At=M[5*lt],Rt=M[5*St];if(At===Rt){const Lt=M[5*lt+1],Ot=M[5*St+1];return Lt-Ot}return At-Rt});const Qe=new Uint32Array(M.length);let nt=0,rt=0;for(let lt=0;lt<Ce;lt++){const St=5*te[lt],At=M[St+0],Rt=M[St+1],Lt=M[St+2],Ot=M[St+3],un=M[St+4],Un=At-nt,jn=Un===0?Rt-rt:Rt,cn=5*lt;Qe[cn+0]=Un,Qe[cn+1]=jn,Qe[cn+2]=Lt,Qe[cn+3]=Ot,Qe[cn+4]=un,nt=At,rt=Rt}return Qe}build(M){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),M):new Ht(rn._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=rn;class Ht{constructor(M,te){this.resultId=te,this.data=M}}e.SemanticTokens=Ht;class sn{constructor(M,te,Ce){this.start=M,this.deleteCount=te,this.data=Ce}}e.SemanticTokensEdit=sn;class yn{constructor(M,te){this.resultId=te,this.edits=M}}e.SemanticTokensEdits=yn;var Sn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var zt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(zt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Tt("arrow-left")},Gt=ze([A],Gt),e.QuickInputButtons=Gt;var Dn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(M,te,Ce){this.badge=M,this.tooltip=te,this.color=Ce}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let on=class{constructor(M){this.kind=M}};on=ze([A],on),e.ColorTheme=on;var an;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(M,te){if(M<0)throw(0,R.illegalArgument)("start must be positive");if(te<0)throw(0,R.illegalArgument)("end must be positive");M<=te?(this._start=M,this._end=te):(this._start=te,this._end=M)}static isNotebookRange(M){return M instanceof Bt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let te=this._start,Ce=this._end;return M.start!==void 0&&(te=M.start),M.end!==void 0&&(Ce=M.end),te===this._start&&Ce===this._end?this:new Bt(te,Ce)}}e.NotebookRange=Bt;class Ft{constructor(M,te,Ce,Qe,nt,rt,lt){this.kind=M,this.value=te,this.languageId=Ce,this.mime=Qe,this.outputs=nt??[],this.metadata=rt,this.executionSummary=lt,Ft.validate(this)}static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(te=>Ft.isNotebookCellData(te))}static isNotebookCellData(M){return!0}}e.NotebookCellData=Ft;class Kt{constructor(M){this.cells=M}}e.NotebookData=Kt;class Le{constructor(M,te){this.data=M,this.mime=te;const Ce=(0,I.normalizeMimeType)(te,!0);if(!Ce)throw new Error("INVALID mime type, must not be empty or falsy: "+te);this.mime=Ce}static isNotebookCellOutputItem(M){return M instanceof Le?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const te={name:M.name,message:M.message,stack:M.stack};return Le.json(te,"application/vnd.code.notebook.error")}static stdout(M){return Le.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Le.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,te="application/octet-stream"){return new Le(M,te)}static text(M,te=I.Mimes.text){const Ce=Be(Le,c,"f",g).encode(String(M));return new Le(Ce,te)}static json(M,te="application/json"){const Ce=JSON.stringify(M,void 0,"	");return Le.text(Ce,te)}}e.NotebookCellOutputItem=Le,c=Le,g={value:new TextEncoder};class $t{constructor(M,te,Ce){this.items=$t.ensureUniqueMimeTypes(M,!0),typeof te=="string"?(this.id=te,this.metadata=Ce):(this.id=(0,k.generateUuid)(),this.metadata=te??Ce)}static isNotebookCellOutput(M){return M instanceof $t?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&(0,y.isArray)(M.items)}static ensureUniqueMimeTypes(M,te=!1){const Ce=new Set,Qe=new Set;for(let nt=0;nt<M.length;nt++){const rt=M[nt],lt=(0,I.normalizeMimeType)(rt.mime);if(!Ce.has(lt)){Ce.add(lt);continue}Qe.add(nt),te&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Qe.size===0?M:M.filter((nt,rt)=>!Qe.has(rt))}}e.NotebookCellOutput=$t;var mn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(mn=e.NotebookCellKind||(e.NotebookCellKind={}));var pt;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(pt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var kn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(kn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var In;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(In=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gn{constructor(M,te){this.text=M,this.alignment=te}}e.NotebookCellStatusBarItem=gn;var pn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pn{constructor(M,te=[]){this.uri=M,this.provides=(0,m.asArray)(te)}}e.NotebookRendererScript=Pn;let ln=class{constructor(M,te){this.label=M,this.timestamp=te}};ln=ze([A],ln),e.TimelineItem=ln;var An;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var vn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(vn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor(M,te){this.ranges=M,this.wordPattern=te}}e.LinkedEditingRanges=Rn;class Fn{constructor(M,te){this._port=M,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Ln;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Ln=e.TestResultState||(e.TestResultState={}));var Mn;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information",N[N.Hint=3]="Hint"})(Mn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Nn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Nn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let J=class{constructor(M,te,Ce){this.include=M,this.exclude=te,this.profile=Ce}};J=ze([A],J),e.TestRunRequest=J;let ue=T=class{constructor(M){this.message=M}static diff(M,te,Ce){const Qe=new T(M);return Qe.expectedOutput=te,Qe.actualOutput=Ce,Qe}};ue=T=ze([A],ue),e.TestMessage=ue;let Ae=class{constructor(M,te){this.covered=M,this.total=te}};Ae=ze([A],Ae),e.CoveredCount=Ae;let st=o=class{constructor(M,te,Ce,Qe){this.uri=M,this.statementCoverage=te,this.branchCoverage=Ce,this.functionCoverage=Qe}static fromDetails(M,te){const Ce=new Ae(0,0),Qe=new Ae(0,0),nt=new Ae(0,0);for(const lt of te)if("branches"in lt){Ce.total+=1,Ce.covered+=lt.executionCount>0?1:0;for(const St of lt.branches)Qe.total+=1,Qe.covered+=St.executionCount>0?1:0}else nt.total+=1,nt.covered+=lt.executionCount>0?1:0;const rt=new o(M,Ce,Qe.total>0?Qe:void 0,nt.total>0?nt:void 0);return rt.detailedCoverage=te,rt}};st=o=ze([A],st),e.FileCoverage=st;let wt=class{constructor(M,te,Ce=[]){this.executionCount=M,this.location=te,this.branches=Ce}};wt=ze([A],wt),e.StatementCoverage=wt;let Ct=class{constructor(M,te){this.executionCount=M,this.location=te}};Ct=ze([A],Ct),e.BranchCoverage=Ct;let On=class{constructor(M,te){this.executionCount=M,this.location=te}};On=ze([A],On),e.FunctionCoverage=On;var Hn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor(M,te,Ce,Qe,nt,rt){this.kind=M,this.name=te,this.detail=Ce,this.uri=Qe,this.range=nt,this.selectionRange=rt}}e.TypeHierarchyItem=qn}),define(be[98],Ee([0,1,41,11,8,124,88,7,17]),function(ee,e,m,R,S,_,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function n(c,g){g?k.set(c,g):k.delete(c)}e.setWordDefinitionFor=n;function C(c){return k.get(c)}e.getWordDefinitionFor=C;class l extends _.MirrorTextModel{constructor(g,b,w,P,a,f,v,t){super(b,w,P,a);this._proxy=g,this._languageId=f,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,E.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===R.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(b){return b?g._getTextInRange(b):g.getText()},get eol(){return g._eol===`
`?y.EndOfLine.LF:y.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(b){return g._lineAt(b)},offsetAt(b){return g._offsetAt(b)},positionAt(b){return g._positionAt(b)},validateRange(b){return g._validateRange(b)},validatePosition(b){return g._validatePosition(b)},getWordRangeAtPosition(b,w){return g._getWordRangeAtPosition(b,w)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,m.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,m.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const b=this._validateRange(g);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const w=this._eol,P=b.start.line,a=b.end.line,f=[];f.push(this._lines[P].substring(b.start.character));for(let v=P+1;v<a;v++)f.push(this._lines[v]);return f.push(this._lines[a].substring(0,b.end.character)),f.join(w)}_lineAt(g){let b;if(g instanceof y.Position?b=g.line:typeof g=="number"&&(b=g),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new h(b,this._lines[b],b===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(g),w=this._lines[b.index].length;return new y.Position(b.index,Math.min(b.remainder,w))}_validateRange(g){if(!(g instanceof y.Range))throw new Error("Invalid argument");const b=this._validatePosition(g.start),w=this._validatePosition(g.end);return b===g.start&&w===g.end?g:new y.Range(b.line,b.character,w.line,w.character)}_validatePosition(g){if(!(g instanceof y.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:b,character:w}=g,P=!1;if(b<0)b=0,w=0,P=!0;else if(b>=this._lines.length)b=this._lines.length-1,w=this._lines[b].length,P=!0;else{const a=this._lines[b].length;w<0?(w=0,P=!0):w>a&&(w=a,P=!0)}return P?new y.Position(b,w):g}_getWordRangeAtPosition(g,b){const w=this._validatePosition(g);if(!b)b=C(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const P=(0,I.getWordAtText)(w.character+1,(0,I.ensureValidWordDefinition)(b),this._lines[w.line],0);if(P)return new y.Range(w.line,P.startColumn-1,w.line,P.endColumn-1)}}e.ExtHostDocumentData=l;class h{constructor(g,b,w){this._line=g,this._text=b,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new y.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new y.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(be[164],Ee([0,1,7,3,90,6,58,21,2,37]),function(ee,e,m,R,S,_,I,y,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(l,h,c,g){this._notebook=c,this._selector=g,this._disposables=new _.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=E.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(w=>{const P=this._cellUris.get(w.document.uri);P!==void 0&&(this._cellLengths.changeValue(P,this._cells[P].document.getText().length+1),this._cellLines.changeValue(P,this._cells[P].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const b=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(w=>b(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new y.ResourceMap;const l=[],h=[];for(const c of this._notebook.getCells())c.kind===m.NotebookCellKind.Code&&(!this._selector||(0,I.score)(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),l.push(c.document.getText().length+1),h.push(c.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(l){if(!l){let P="";for(const a of this._cells)P+=a.document.getText()+`
`;return P=P.slice(0,-1),P}if(l.isEmpty)return"";const h=this.locationAt(l.start),c=this.locationAt(l.end),g=this._cellUris.get(h.uri),b=this._cellUris.get(c.uri);if(g===void 0||b===void 0)return"";if(g===b)return this._cells[g].document.getText(new m.Range(h.range.start,c.range.end));const w=[this._cells[g].document.getText(new m.Range(h.range.start,new m.Position(this._cells[g].document.lineCount,0)))];for(let P=g+1;P<b;P++)w.push(this._cells[P].document.getText());return w.push(this._cells[b].document.getText(new m.Range(new m.Position(0,0),c.range.end))),w.join(`
`)}offsetAt(l){const h=this._cellLines.getIndexOf(l.line),c=this._cellLengths.getPrefixSum(h.index-1),g=this._cells[h.index].document.offsetAt(l.with(h.remainder));return c+g}positionAt(l){if(typeof l=="number"){const c=this._cellLengths.getIndexOf(l),g=this._cellLines.getPrefixSum(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(g)}const h=this._cellUris.get(l.uri);if(h!==void 0){const c=this._cellLines.getPrefixSum(h-1);return new m.Position(c+l.range.start.line,l.range.start.character)}return new m.Position(0,0)}locationAt(l){m.Range.isRange(l)||(l=new m.Range(l,l));const h=this._cellLines.getIndexOf(l.start.line);let c=h;l.isEmpty||(c=this._cellLines.getIndexOf(l.end.line));const g=new m.Position(h.remainder,l.start.character),b=new m.Position(c.remainder,l.end.character),w=new m.Range(g,b),P=this._cells[h.index];return new m.Location(P.document.uri,P.document.validateRange(w))}contains(l){return this._cellUris.has(l)}validateRange(l){const h=this.validatePosition(l.start),c=this.validatePosition(l.end);return l.with(h,c)}validatePosition(l){const h=this._cellLines.getIndexOf(l.line),c=new m.Position(h.remainder,l.character),g=this._cells[h.index].document.validatePosition(c),b=this._cellLines.getPrefixSum(h.index-1);return new m.Position(b+g.line,g.character)}}e.ExtHostNotebookConcatDocument=n}),define(be[165],Ee([0,1,7,13,3]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let _=class{constructor(y){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(y){let E=y==="light"?m.ColorThemeKind.Light:y==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};_=ze([Ve(0,R.IExtHostRpcService)],_),e.ExtHostTheming=_}),define(be[70],Ee([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class R{constructor(_){_?(this.transformIncoming=_.transformIncoming.bind(_),this.transformOutgoing=_.transformOutgoing.bind(_),this.transformOutgoingURI=_.transformOutgoingURI.bind(_),this.transformOutgoingScheme=_.transformOutgoingScheme.bind(_)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=R}),define(be[166],Ee([0,1,24]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(E){let k=this.buffers.indexOf(E);return k<0&&(k=this.buffers.length,this.buffers.push(E)),k}}function S(y,E){if(E.serializeBuffersForPostMessage){const k=new R,n=(h,c)=>{if(c instanceof ArrayBuffer){const g=k.add(c);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(c)){const g=_(c);if(g){const b=k.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:g,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},C=JSON.stringify(y,n),l=k.buffers.map(h=>{const c=new Uint8Array(h);return m.VSBuffer.wrap(c)});return{message:C,buffers:l}}else return{message:JSON.stringify(y),buffers:[]}}e.serializeWebviewMessage=S;function _(y){switch(y.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(y,E){const k=E.map(l=>{const h=new ArrayBuffer(l.byteLength);return new Uint8Array(h).set(l.buffer),h}),n=E.length?(l,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const c=h,{index:g}=c,b=k[g];if(c.view)switch(c.view.type){case 1:return new Int8Array(b,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return h}:void 0;return{message:JSON.parse(y,n),arrayBuffers:k}}e.deserializeWebviewMessage=I}),define(be[167],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(R){function S(I){const y={items:new Map};return I.types.forEach((E,k)=>{y.items.set(E,{asString:async()=>I.items[k].asString})}),y}R.toITreeDataTransfer=S;async function _(I){const y={types:[],items:[]},E=Array.from(I.items.entries());for(const k of E)y.types.push(k[0]),y.items.push({asString:await k[1].asString()});return y}R.toTreeDataTransferDTO=_})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[71],Ee([0,1,11,2]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(_,I){return _.scheme===m.Schemas.http||_.scheme===m.Schemas.https?_:(I&&I.authority&&I.isRemote&&_.scheme===m.Schemas.file&&(_=R.URI.from({scheme:m.Schemas.vscodeRemote,authority:I.authority,path:_.path})),R.URI.from({scheme:m.Schemas.https,authority:`${_.scheme}+${_.authority}.${e.webviewRootResourceAuthority}`,path:_.path,fragment:_.fragment,query:_.query}))}e.asWebviewUri=S}),define(be[168],Ee([0,1,3,6,71]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class _{constructor(y,E,k){this._proxy=y,this._editors=E,this._initData=k,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const n=E.getVisibleTextEditors();for(const C of this._insets.values())n.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,E,k,n,C){let l;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===y){l=a;break}if(!l)throw new Error("not a visible editor");const h=this,c=this._handlePool++,g=new m.Emitter,b=new m.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,S.asWebviewUri)(a,h._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(a){this._options=a,h._proxy.$setOptions(c,a)}get options(){return this._options}set html(a){this._html=a,h._proxy.$setHtml(c,a)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(a){return h._proxy.$postMessage(c,a)}},P=new class{constructor(){this.editor=y,this.line=E,this.height=k,this.webview=w,this.onDidDispose=b.event}dispose(){h._insets.has(c)&&(h._insets.delete(c),h._proxy.$disposeEditorInset(c),b.fire(),b.dispose(),g.dispose())}};return this._proxy.$createEditorInset(c,l.id,l.value.document.uri,E+1,k,n||{},C.identifier,C.extensionLocation),this._insets.set(c,{editor:y,inset:P,onDidReceiveMessage:g}),P}$onDidDispose(y){const E=this._insets.get(y);E&&E.inset.dispose()}$onDidReceiveMessage(y,E){const k=this._insets.get(y);k&&k.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=_}),define(be[169],Ee([0,1,140,10,2,6,4,45,28,17,11]),function(ee,e,m,R,S,_,I,y,E,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new y.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new y.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new y.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new y.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new y.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorContext=new y.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new y.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new y.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new y.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.EditorGroupEditorsCountContext=new y.RawContextKey("groupEditorsCount",0,(0,m.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new y.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(12,null)),e.ActiveEditorGroupIndexContext=new y.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(13,null)),e.ActiveEditorGroupLastContext=new y.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(14,null)),e.MultipleEditorGroupsContext=new y.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new y.RawContextKey("editorIsOpen",!1,(0,m.localize)(16,null)),e.InEditorZenModeContext=new y.RawContextKey("inZenMode",!1,(0,m.localize)(17,null)),e.IsCenteredLayoutContext=new y.RawContextKey("isCenteredLayout",!1,(0,m.localize)(18,null)),e.SplitEditorsVertically=new y.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(19,null)),e.EditorAreaVisibleContext=new y.RawContextKey("editorAreaVisible",!0,(0,m.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function C(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=C;function l(o){if(a(o))return!1;const A=o;return S.URI.isUri(A?.resource)}e.isResourceEditorInput=l;function h(o){if(a(o))return!1;const A=o;return A?.original!==void 0&&A.modified!==void 0}e.isResourceDiffEditorInput=h;function c(o){if(a(o))return!1;const A=o;return A?A?.resource===void 0||A.resource.scheme===n.Schemas.untitled||A.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=c;var g;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(g=e.Verbosity||(e.Verbosity={}));var b;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var w;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class P extends _.Disposable{}e.AbstractEditorInput=P;function a(o){return o instanceof P}e.isEditorInput=a;function f(o){const A=o;return S.URI.isUri(A?.preferredResource)}function v(o){const A=o;return a(A?.primary)&&a(A?.secondary)}e.isSideBySideEditorInput=v;function t(o){return a(o?.editor)}e.isEditorInputWithOptions=t;function r(o){const A=o;return t(o)&&A?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function s(o){const A=o;return typeof A?.groupId=="number"&&a(A.editor)}e.isEditorIdentifier=s;var i;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(i=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(A,F){if(!A)return;const x=v(A)?A.primary:h(A)?A.modified:void 0,K=v(A)?A.secondary:h(A)?A.original:void 0;if(F?.supportSideBySide&&x&&K){if(F?.supportSideBySide===i.BOTH)return{primary:this.getOriginalUri(x,{filterByScheme:F.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:F.filterByScheme})};A=F.supportSideBySide===i.PRIMARY?x:K}if(h(A))return;const le=f(A)?A.preferredResource:A.resource;return!le||!F||!F.filterByScheme?le:this.filterUri(le,F.filterByScheme)}getCanonicalUri(A,F){if(!A)return;const x=v(A)?A.primary:h(A)?A.modified:void 0,K=v(A)?A.secondary:h(A)?A.original:void 0;if(F?.supportSideBySide&&x&&K){if(F?.supportSideBySide===i.BOTH)return{primary:this.getCanonicalUri(x,{filterByScheme:F.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:F.filterByScheme})};A=F.supportSideBySide===i.PRIMARY?x:K}if(h(A))return;const le=A.resource;return!le||!F||!F.filterByScheme?le:this.filterUri(le,F.filterByScheme)}filterUri(A,F){if(Array.isArray(F)){if(F.some(x=>A.scheme===x))return A}else if(F===A.scheme)return A}}e.EditorResourceAccessor=new u;var d;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(d=e.CloseDirection||(e.CloseDirection={}));class p{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(A){const F=this.instantiationService=A.get(I.IInstantiationService);for(const[x,K]of this.editorSerializerConstructors)this.createEditorSerializer(x,K,F);this.editorSerializerConstructors.clear()}createEditorSerializer(A,F,x){const K=x.createInstance(F);this.editorSerializerInstances.set(A,K)}registerFileEditorFactory(A){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=A}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(A,F){if(this.editorSerializerConstructors.has(A)||this.editorSerializerInstances.has(A))throw new Error(`A editor serializer with type ID '${A}' was already registered.`);return this.instantiationService?this.createEditorSerializer(A,F,this.instantiationService):this.editorSerializerConstructors.set(A,F),(0,_.toDisposable)(()=>{this.editorSerializerConstructors.delete(A),this.editorSerializerInstances.delete(A)})}getEditorSerializer(A){return this.editorSerializerInstances.get(typeof A=="string"?A:A.typeId)}}E.Registry.add(e.EditorExtensions.EditorFactory,new p);async function D(o,A){if(!o||!o.length)return[];const F=await Promise.all(o.map(async x=>{const K=S.URI.revive(x.fileUri);if(!K||(await A.activateProvider(K.scheme),!A.canHandleResource(K)))return;const le=typeof x.exists=="boolean"?x.exists:await A.exists(K);if(!le&&x.openOnlyIfExists)return;const oe=le&&!(0,R.isUndefined)(x.selection)?{selection:x.selection,pinned:!0,override:x.editorOverrideId}:{pinned:!0,override:x.editorOverrideId};let V;return le?V={resource:K,options:oe,forceFile:!0}:V={resource:K,options:oe,forceUntitled:!0},V}));return(0,k.coalesce)(F)}e.pathsToEditors=D;var T;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(T=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[170],Ee([0,1,3,45,141,4,6,21,28,17,51,23,35,160]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",l.Codicon.window,(0,S.localize)(0,null));var c;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(c=e.Extensions||(e.Extensions={}));var g;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel"})(g=e.ViewContainerLocation||(e.ViewContainerLocation={}));function b(u){switch(u){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=b;function w(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=w;class P extends I.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new m.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new m.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(d,p,D){const T=this.get(d.id);if(T)return T;const o=d;return o.openCommandActionDescriptor=D?.donotRegisterOpenCommand?void 0:o.openCommandActionDescriptor??{id:o.id},(0,y.getOrSet)(this.viewContainers,p,[]).push(o),D?.isDefault&&this.defaultViewContainers.push(o),this._onDidRegister.fire({viewContainer:o,viewContainerLocation:p}),o}deregisterViewContainer(d){for(const p of this.viewContainers.keys()){const D=this.viewContainers.get(p),T=D?.indexOf(d);if(T!==-1){D?.splice(T,1),D.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:d,viewContainerLocation:p});return}}}get(d){return this.all.filter(p=>p.id===d)[0]}getViewContainers(d){return[...this.viewContainers.get(d)||[]]}getViewContainerLocation(d){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(D=>D?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===d)}}E.Registry.add(c.ViewContainersRegistry,new P);var a;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function f(u,d){const p=u.group??a.More,D=d.group??a.More;return p!==D?p.localeCompare(D):(u.order??5)-(d.order??5)}class v extends I.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new m.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new m.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new m.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new m.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(d,p){this.registerViews2([{views:d,viewContainer:p}])}registerViews2(d){d.forEach(({views:p,viewContainer:D})=>this.addViews(p,D)),this._onViewsRegistered.fire(d)}deregisterViews(d,p){const D=this.removeViews(d,p);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:p})}moveViews(d,p){for(const D of this._views.keys())if(D!==p){const T=this.removeViews(d,D);T.length&&(this.addViews(T,p),this._onDidChangeContainer.fire({views:T,from:D,to:p}))}}getViews(d){return this._views.get(d)||[]}getView(d){for(const p of this._viewContainers){const D=(this._views.get(p)||[]).filter(T=>T.id===d)[0];if(D)return D}return null}getViewContainer(d){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(T=>T.id===d)[0])return p;return null}registerViewWelcomeContent(d,p){return this._viewWelcomeContents.add(d,p),this._onDidChangeViewWelcomeContent.fire(d),(0,I.toDisposable)(()=>{this._viewWelcomeContents.delete(d,p),this._onDidChangeViewWelcomeContent.fire(d)})}registerViewWelcomeContent2(d,p){const D=new Map;for(const[T,o]of p)this._viewWelcomeContents.add(d,o),D.set(T,(0,I.toDisposable)(()=>{this._viewWelcomeContents.delete(d,o),this._onDidChangeViewWelcomeContent.fire(d)}));return this._onDidChangeViewWelcomeContent.fire(d),D}getViewWelcomeContent(d){const p=[];return this._viewWelcomeContents.forEach(d,D=>p.push(D)),p.sort(f)}addViews(d,p){let D=this._views.get(p);D||(D=[],this._views.set(p,D),this._viewContainers.push(p));for(const T of d){if(this.getView(T.id)!==null)throw new Error((0,S.localize)(1,null,T.id));D.push(T)}}removeViews(d,p){const D=this._views.get(p);if(!D)return[];const T=[],o=[];for(const A of D)d.includes(A)?T.push(A):o.push(A);return T.length&&(o.length?this._views.set(p,o):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),T}}E.Registry.add(c.ViewsRegistry,new v),e.IViewsService=(0,_.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,S.localize)(2,null));function t(u){return`view.${u}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,_.createDecorator)("viewDescriptorService");var r;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(d,p){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,d),this._hasResolve=!!p,this.resolve=async D=>{if(p&&!this.resolved){const T=await p(D);T&&(this.tooltip=this.tooltip??T.tooltip,this.command=this.command??T.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[171],Ee([0,1,3,15,142]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class _{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(y){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=y}onEvent(y){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=y}onRequest(y){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=y}sendResponse(y){y.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${y.command}`)):this.internalSend("response",y)}sendRequest(y,E,k,n){const C={command:y};if(E&&Object.keys(E).length>0&&(C.arguments=E),this.internalSend("request",C),typeof n=="number"){const l=setTimeout(()=>{clearTimeout(l);const h=this.pendingRequests.get(C.seq);if(h){this.pendingRequests.delete(C.seq);const c={type:"response",seq:0,request_seq:C.seq,success:!1,command:y,message:(0,S.localize)(0,null,n,y)};h(c)}},n)}return k&&this.pendingRequests.set(C.seq,k),C.seq}acceptMessage(y){this.messageCallback?this.messageCallback(y):(this.queue.push(y),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(y,E){return y.type!=="event"||E.type!=="event"}async processQueue(){let y;for(;this.queue.length;){if((!y||this.needsTaskBoundaryBetween(this.queue[0],y))&&await(0,R.timeout)(0),y=this.queue.shift(),!y)return;switch(y.type){case"event":this.eventCallback&&this.eventCallback(y);break;case"request":this.requestCallback&&this.requestCallback(y);break;case"response":const E=y,k=this.pendingRequests.get(E.request_seq);k&&(this.pendingRequests.delete(E.request_seq),k(E));break}}}internalSend(y,E){E.type=y,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const y=new Map;this.pendingRequests.forEach((E,k)=>y.set(k,E)),await(0,R.timeout)(500),y.forEach((E,k)=>{E({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=_}),define(be[172],Ee([0,1,8,2,14,23,11]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const y=/{([^}]+)}/g;function E(r,s,i){return r.replace(y,function(u,d){return s&&d.length>0&&d[0]!=="_"?u:i&&i.hasOwnProperty(d)?i[d]:u})}e.formatPII=E;function k(r){const s={};for(const i of Object.keys(r))i.startsWith("!")||(s[i]=r[i]);return s}e.filterExceptionsFromTelemetry=k;function n(r){return r.configuration.request==="attach"&&!C(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function C(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(s,"extensionhost")||(0,m.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?C(r.parentSession):void 0}e.getExtensionHostDebugSession=C;function l(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=l;function h(r,s,i){let u,d=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,D=null;for(;D=p.exec(r);){let T=D.index+1,o=T+D[0].length;if(T<=s&&o>=i){u=D[0],d=T;break}}if(u){let T=/\w+/g,o=null;for(;(o=T.exec(u))&&!(o.index+1+d+o[0].length>=i););o&&(u=u.substring(0,T.lastIndex))}return u?{start:d,end:d+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(r){return!!(r&&r.match(c))}e.isUri=g;function b(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(g(r.path))return R.URI.parse(r.path);if((0,S.isAbsolute)(r.path))return R.URI.file(r.path)}return r.path}function w(r){if(typeof r.path=="object"){const s=R.URI.revive(r.path);if(s)return s.scheme===I.Schemas.file?s.fsPath:s.toString()}return r.path}function P(r,s){const i=s?b:w,u=(0,_.deepClone)(r);return f(u,(d,p)=>{d&&p&&(p.path=i(p))}),u}e.convertToDAPaths=P;function a(r,s){const i=s?b:w,u=(0,_.deepClone)(r);return f(u,(d,p)=>{!d&&p&&(p.path=i(p))}),u}e.convertToVSCPaths=a;function f(r,s){switch(r.type){case"event":const i=r;switch(i.event){case"output":s(!1,i.body.source);break;case"loadedSource":s(!1,i.body.source);break;case"breakpoint":s(!1,i.body.breakpoint.source);break;default:break}break;case"request":const u=r;switch(u.command){case"setBreakpoints":s(!0,u.arguments.source);break;case"breakpointLocations":s(!0,u.arguments.source);break;case"source":s(!0,u.arguments.source);break;case"gotoTargets":s(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(p=>s(!1,p));break;default:break}break;case"response":const d=r;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(p=>s(!1,p.source));break;case"loadedSources":d.body.sources.forEach(p=>s(!1,p));break;case"scopes":d.body.scopes.forEach(p=>s(!1,p.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(p=>s(!1,p.source));break;case"setBreakpoints":d.body.breakpoints.forEach(p=>s(!1,p.source));break;default:break}break}}function v(r){return r.filter(s=>!s.presentation?.hidden).sort((s,i)=>s.presentation?i.presentation?s.presentation.group?i.presentation.group?s.presentation.group!==i.presentation.group?s.presentation.group.localeCompare(i.presentation.group):t(s.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(s.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=v;function t(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}}),define(be[72],Ee([0,1,27,85,11,14,22,45]),function(ee,e,m,R,S,_,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var E;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(E=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var b;(function(o){o.scheme=S.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function F(V,W){return V.with({scheme:o.scheme,fragment:`ch${W.toString().padStart(7,"0")}${V.scheme!==S.Schemas.file?V.scheme:""}`})}o.generate=F;function x(V){if(V.scheme!==o.scheme)return;const W=A.exec(V.fragment);return W?{handle:Number(W[1]),notebook:V.with({scheme:V.fragment.substr(W[0].length)||S.Schemas.file,fragment:null})}:void 0}o.parse=x;function K(V){if(V.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const W=A.exec(V.fragment);return W?{handle:Number(W[1]),notebook:V.with({scheme:V.fragment.substr(W[0].length)||S.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=K;function le(V,W,L){return V.with({scheme:L,fragment:`ch${W.toString().padStart(7,"0")}${V.scheme!==S.Schemas.file?V.scheme:""}`})}o.generateCellUri=le;function oe(V,W){if(V.scheme!==W)return;const L=A.exec(V.fragment);return L?{handle:Number(L[1]),notebook:V.with({scheme:V.fragment.substr(L[0].length)||S.Schemas.file,fragment:null})}:void 0}o.parseCellUri=oe})(b=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function P(o){return w.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=P;function a(o){return w.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function f(o){return w.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=f;function v(o,A){return I.isWindows&&(o=o.replace(/\//g,"\\"),A=A.replace(/\//g,"\\")),m.match(o,A)}function t(o,A,F){let x=0;for(let K=0;K<A.length;K++){if(v(A[K],o))return x;x++}for(let K=0;K<F.length;K++){if(v(F[K],o))return x;x++}return x}function r(o,A,F){return o.sort((x,K)=>t(x,A,F)-t(K,A,F))}e.sortMimeTypes=r;function s(o,A,F,x=(K,le)=>K===le){const K=[];function le(W,L,Q){if(L===0&&Q.length===0)return;const O=K[K.length-1];O&&O.start+O.deleteCount===W?(O.deleteCount+=L,O.toInsert.push(...Q)):K.push({start:W,deleteCount:L,toInsert:Q})}let oe=0,V=0;for(;;){if(oe===o.length){le(oe,0,A.slice(V));break}if(V===A.length){le(oe,o.length-oe,[]);break}const W=o[oe],L=A[V];if(x(W,L)){oe+=1,V+=1;continue}F(L)?(le(oe,1,[]),oe+=1):(le(oe,0,[L]),V+=1)}return K}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(o){o.default="default",o.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(o){const A=o;return!!((typeof A.include=="string"||m.isRelativePattern(A.include))&&(typeof A.exclude=="string"||m.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=u;function d(o,A,F){if(Array.isArray(o.viewType)&&o.viewType.indexOf(A)>=0||o.viewType===A)return!0;if(o.filenamePattern){let x=u(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,K=u(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(m.match(x,(0,_.basename)(F.fsPath).toLowerCase()))return!(K&&m.match(K,(0,_.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class p{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)A[F]=this.textModel.cells[F].getHashValue();return A}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var D;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(D=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class T{static create(A){return`${T._prefix}${A}`}static parse(A){if(A.startsWith(T._prefix))return A.substr(T._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=T,T._prefix="notebook/"}),define(be[173],Ee([0,1,144,4,45]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[174],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=m;function R(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=R}),define(be[99],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.identifyTest=e.TestResultState=void 0;var m;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));const R=C=>({testId:C.item.extId,controllerId:C.controllerId});e.identifyTest=R;var S;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(C,l)=>{l.expand!==void 0&&(C.expand=l.expand),l.item!==void 0&&(C.item=C.item?Object.assign(C.item,l.item):l.item)};e.applyTestItemUpdate=I;var y;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(y=e.DetailType||(e.DetailType={}));var E;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",C[C.Retire=4]="Retire"})(E=e.TestDiffOpType||(e.TestDiffOpType={}));class k{add(l){}update(l){}remove(l,h){}complete(){}}e.IncrementalChangeCollector=k;class n{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(l){const h=this.createChangeCollector();for(const c of l)switch(c[0]){case 0:{const g=c[1];if(g.parent){if(this.items.has(g.parent)){const b=this.items.get(g.parent);b.children.add(g.item.extId);const w=this.createItem(g,b);this.items.set(g.item.extId,w),h.add(w)}}else{const b=this.createItem(g);this.roots.add(b),this.items.set(g.item.extId,b),h.add(b)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=c[1],b=this.items.get(g.extId);if(!b)break;g.expand!==void 0&&(b.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(b,g),h.update(b);break}case 2:{const g=this.items.get(c[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const b=[[c[1]]];for(;b.length;)for(const w of b.pop()){const P=this.items.get(w);P&&(b.push(P.children),this.items.delete(w),h.remove(P,P!==g),P.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(c[1]);break;case 3:this.updatePendingRoots(c[1]);break}h.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=n}),define(be[73],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(_){_.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var R;(function(_){_[_.IsSame=0]="IsSame",_[_.Disconnected=1]="Disconnected",_[_.IsChild=2]="IsChild",_[_.IsParent=3]="IsParent"})(R=e.TestPosition||(e.TestPosition={}));class S{constructor(I,y=I.length){if(this.path=I,this.viewEnd=y,I.length===0||y<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(I,y,E=I.parent){if(I.id===y)return new S([y]);let k=[I.id];for(let n=E;n&&n.id!==y;n=n.parent)k.push(n.id);return k.push(y),new S(k.reverse())}static fromString(I){return new S(I.split("\0"))}static join(I,y){return new S([...I.path,y])}static joinToString(I,y){return I.toString()+"\0"+y}static compare(I,y){return I===y?0:y.startsWith(I+"\0")?2:I.startsWith(y+"\0")?3:1}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let I=1;I<=this.viewEnd;I++)yield new S(this.path,I)}compare(I){if(typeof I=="string")return S.compare(this.toString(),I);for(let y=0;y<I.viewEnd&&y<this.viewEnd;y++)if(I.path[y]!==this.path[y])return 1;return I.viewEnd>this.viewEnd?2:I.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let I=1;I<this.viewEnd;I++)this.stringifed+="\0",this.stringifed+=this.path[I]}return this.stringifed}}e.TestId=S}),define(be[175],Ee([0,1,14,42,10,23,22,84,145]),function(ee,e,m,R,S,_,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(C,l,h){this._contributedVariables=new Map,this._context=C,this._labelService=l,h&&(this._envVariablesPromise=h.then(c=>this.prepareEnv(c)))}prepareEnv(C){if(I.isWindows){const l=Object.create(null);return Object.keys(C).forEach(h=>{l[h.toLowerCase()]=C[h]}),l}return C}resolveWithEnvironment(C,l,h){return this.recursiveResolve(this.prepareEnv(C),l?l.uri:void 0,h)}async resolveAsync(C,l){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,l)}async resolveAnyBase(C,l,h,c){const g=_.deepClone(l);return I.isWindows&&g.windows?Object.keys(g.windows).forEach(b=>g[b]=g.windows[b]):I.isMacintosh&&g.osx?Object.keys(g.osx).forEach(b=>g[b]=g.osx[b]):I.isLinux&&g.linux&&Object.keys(g.linux).forEach(b=>g[b]=g.linux[b]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,g,h,c)}async resolveAnyAsync(C,l,h){return this.resolveAnyBase(C,l,h)}async resolveAnyMap(C,l,h){const c=new Map;return{newConfig:await this.resolveAnyBase(C,l,h,c),resolvedVariables:c}}resolveWithInteractionReplace(C,l,h,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,l,h,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,l){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,l)}recursiveResolve(C,l,h,c,g){if(S.isString(h))return this.resolveString(C,l,h,c,g);if(S.isArray(h))return h.map(b=>this.recursiveResolve(C,l,b,c,g));if(S.isObject(h)){let b=Object.create(null);return Object.keys(h).forEach(w=>{const P=this.resolveString(C,l,w,c,g);b[P]=this.recursiveResolve(C,l,h[w],c,g)}),b}return h}resolveString(C,l,h,c,g){return h.replace(k.VARIABLE_REGEXP,(w,P)=>{if(P.includes(k.VARIABLE_LHS))return w;let a=this.evaluateSingleVariable(C,w,P,l,c);return g&&g.set(P,a),a!==w&&S.isString(a)&&a.match(k.VARIABLE_REGEXP)&&(a=this.resolveString(C,l,a,c,g)),a})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,l,h,c,g){let b;const w=h.split(":");w.length>1&&(h=w[0],b=w[1]);const P=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,E.localize)(0,null,l))},a=()=>{const v=P();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,E.localize)(1,null,l,m.basename(v)))},f=()=>{if(b){const v=this._context.getFolderUri(b);if(v)return v;throw new Error((0,E.localize)(2,null,l,b))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error((0,E.localize)(3,null,l)):new Error((0,E.localize)(4,null,l))};switch(h){case"env":if(b){if(C){const v=C[I.isWindows?b.toLowerCase():b];if(S.isString(v))return v}return""}throw new Error((0,E.localize)(5,null,l));case"config":if(b){const v=this._context.getConfigurationValue(c,b);if(S.isUndefinedOrNull(v))throw new Error((0,E.localize)(6,null,l,b));if(S.isObject(v))throw new Error((0,E.localize)(7,null,l,b));return v}throw new Error((0,E.localize)(8,null,l));case"command":return this.resolveFromMap(l,b,g,"command");case"input":return this.resolveFromMap(l,b,g,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,y.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return c||b?(0,y.normalizeDriveLetter)(this.fsPath(f())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(f()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,E.localize)(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,E.localize)(10,null,l));case"file":return P();case"fileWorkspaceFolder":return a();case"relativeFile":return c||b?m.relative(this.fsPath(f()),P()):P();case"relativeFileDirname":const r=m.dirname(P());if(c||b){const d=m.relative(this.fsPath(f()),r);return d.length===0?".":d}return r;case"fileDirname":return m.dirname(P());case"fileExtname":return m.extname(P());case"fileBasename":return m.basename(P());case"fileBasenameNoExtension":const s=m.basename(P());return s.slice(0,s.length-m.extname(s).length);case"fileDirnameBasename":return m.basename(m.dirname(P()));case"execPath":const i=this._context.getExecPath();return i||l;case"execInstallFolder":const u=this._context.getAppRoot();return u||l;case"pathSeparator":return m.sep;default:try{const d=b?`${h}:${b}`:h;return this.resolveFromMap(l,d,g,void 0)}catch(d){return l}}}}resolveFromMap(C,l,h,c){if(l&&h){const g=c===void 0?h[l]:h[c+":"+l];if(typeof g=="string")return g;throw new Error((0,E.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[100],Ee([0,1,4,169]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var S;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var _;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(_=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var y;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function k(g){const b=g;return(0,R.isEditorInput)(b?.editor)&&(0,R.isEditorInput)(b?.replacement)}e.isEditorReplacement=k;var n;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.EDITOR_OPEN=2]="EDITOR_OPEN",g[g.EDITOR_CLOSE=3]="EDITOR_CLOSE",g[g.EDITOR_MOVE=4]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=6]="EDITOR_LABEL",g[g.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",g[g.EDITOR_PIN=8]="EDITOR_PIN",g[g.EDITOR_STICKY=9]="EDITOR_STICKY",g[g.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var l;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(l=e.OpenEditorContext||(e.OpenEditorContext={}));function h(g){const b=g;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=h;function c(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=c}),define(be[176],Ee([0,1,4,100]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(_){const I=_;return typeof _=="number"||(0,R.isEditorGroup)(I)}e.isPreferredGroup=S}),define(be[9],Ee([0,1,17,83,233,57,23,10,2,31,61,146,92,68,72,73,176,7]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var P;(function(_e){function ke(H){const{selectionStartLineNumber:Fe,selectionStartColumn:Te,positionLineNumber:tt,positionColumn:Ge}=H,ct=new w.Position(Fe-1,Te-1),yt=new w.Position(tt-1,Ge-1);return new w.Selection(ct,yt)}_e.to=ke;function Y(H){const{anchor:Fe,active:Te}=H;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}_e.from=Y})(P=e.Selection||(e.Selection={}));var a;(function(_e){function ke(H){if(!H)return;const{start:Fe,end:Te}=H;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}_e.from=ke;function Y(H){if(!H)return;const{startLineNumber:Fe,startColumn:Te,endLineNumber:tt,endColumn:Ge}=H;return new w.Range(Fe-1,Te-1,tt-1,Ge-1)}_e.to=Y})(a=e.Range||(e.Range={}));var f;(function(_e){function ke(Y){switch(Y){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}_e.to=ke})(f=e.TokenType||(e.TokenType={}));var v;(function(_e){function ke(H){return new w.Position(H.lineNumber-1,H.column-1)}_e.to=ke;function Y(H){return{lineNumber:H.line+1,column:H.character+1}}_e.from=Y})(v=e.Position||(e.Position={}));var t;(function(_e){function ke(H){switch(H){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}_e.from=ke;function Y(H){switch(H){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}_e.to=Y})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(_e){function ke(H){let Fe;return H.code&&((0,y.isString)(H.code)||(0,y.isNumber)(H.code)?Fe=String(H.code):Fe={value:String(H.code.value),target:H.code.target}),{...a.from(H.range),message:H.message,source:H.source,code:Fe,severity:i.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(s.from),tags:Array.isArray(H.tags)?(0,m.coalesce)(H.tags.map(t.from)):void 0}}_e.from=ke;function Y(H){const Fe=new w.Diagnostic(a.to(H),H.message,i.to(H.severity));return Fe.source=H.source,Fe.code=(0,y.isString)(H.code)?H.code:H.code?.value,Fe.relatedInformation=H.relatedInformation&&H.relatedInformation.map(s.to),Fe.tags=H.tags&&(0,m.coalesce)(H.tags.map(t.to)),Fe}_e.to=Y})(r=e.Diagnostic||(e.Diagnostic={}));var s;(function(_e){function ke(H){return{...a.from(H.location.range),message:H.message,resource:H.location.uri}}_e.from=ke;function Y(H){return new w.DiagnosticRelatedInformation(new w.Location(H.resource,a.to(H)),H.message)}_e.to=Y})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(_e){function ke(H){switch(H){case w.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}_e.from=ke;function Y(H){switch(H){case l.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}_e.to=Y})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(_e){function ke(H){return typeof H=="number"&&H>=w.ViewColumn.One?H-1:H===w.ViewColumn.Beside?b.SIDE_GROUP:b.ACTIVE_GROUP}_e.from=ke;function Y(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=Y})(u=e.ViewColumn||(e.ViewColumn={}));function d(_e){return typeof _e.range!="undefined"}function p(_e){return _e.length===0?!0:!!d(_e[0])}e.isDecorationOptionsArr=p;var D;(function(_e){function ke(Ge){return Ge.map(_e.from)}_e.fromMany=ke;function Y(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function H(Ge){let ct;if(Y(Ge)){const{language:ft,value:dt}=Ge;ct={value:"```"+ft+`
`+dt+"\n```\n"}}else w.MarkdownString.isMarkdownString(Ge)?ct={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?ct={value:Ge}:ct={value:""};const yt=Object.create(null);ct.uris=yt;const kt=ft=>{try{let dt=E.URI.parse(ft,!0);dt=dt.with({query:Fe(dt.query,yt)}),yt[ft]=dt}catch(dt){}return""},Dt=new S.Renderer;return Dt.link=kt,Dt.image=ft=>kt(R.parseHrefAndDimensions(ft).href),S(ct.value,{renderer:Dt}),ct}_e.from=H;function Fe(Ge,ct){if(!Ge)return Ge;let yt;try{yt=(0,_.parse)(Ge)}catch(Dt){}if(!yt)return Ge;let kt=!1;return yt=(0,I.cloneAndChange)(yt,Dt=>{if(E.URI.isUri(Dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=Dt,kt=!0,ft}else return}),kt?JSON.stringify(yt):Ge}function Te(Ge){const ct=new w.MarkdownString(Ge.value,Ge.supportThemeIcons);return ct.isTrusted=Ge.isTrusted,ct}_e.to=Te;function tt(Ge){if(!!Ge)return typeof Ge=="string"?Ge:_e.from(Ge)}_e.fromStrict=tt})(D=e.MarkdownString||(e.MarkdownString={}));function T(_e){return p(_e)?_e.map(ke=>({range:a.from(ke.range),hoverMessage:Array.isArray(ke.hoverMessage)?D.fromMany(ke.hoverMessage):ke.hoverMessage?D.from(ke.hoverMessage):void 0,renderOptions:ke.renderOptions})):_e.map(ke=>({range:a.from(ke)}))}e.fromRangeOrRangeWithMessage=T;function o(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?E.URI.file(_e):_e}e.pathOrURIToURI=o;var A;(function(_e){function ke(Y){return typeof Y=="undefined"?Y:{contentText:Y.contentText,contentIconPath:Y.contentIconPath?o(Y.contentIconPath):void 0,border:Y.border,borderColor:Y.borderColor,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,color:Y.color,backgroundColor:Y.backgroundColor,margin:Y.margin,width:Y.width,height:Y.height}}_e.from=ke})(A=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(_e){function ke(Y){return typeof Y=="undefined"?Y:{backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?o(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?A.from(Y.before):void 0,after:Y.after?A.from(Y.after):void 0}}_e.from=ke})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var x;(function(_e){function ke(Y){if(typeof Y=="undefined")return Y;switch(Y){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=ke})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var K;(function(_e){function ke(Y){return{isWholeLine:Y.isWholeLine,rangeBehavior:Y.rangeBehavior?x.from(Y.rangeBehavior):void 0,overviewRulerLane:Y.overviewRulerLane,light:Y.light?F.from(Y.light):void 0,dark:Y.dark?F.from(Y.dark):void 0,backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?o(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?A.from(Y.before):void 0,after:Y.after?A.from(Y.after):void 0}}_e.from=ke})(K=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var le;(function(_e){function ke(H){return{text:H.newText,eol:H.newEol&&ce.from(H.newEol),range:a.from(H.range)}}_e.from=ke;function Y(H){const Fe=new w.TextEdit(a.to(H.range),H.text);return Fe.newEol=typeof H.eol=="undefined"?void 0:ce.to(H.eol),Fe}_e.to=Y})(le=e.TextEdit||(e.TextEdit={}));var oe;(function(_e){function ke(H,Fe,Te){const tt={edits:[]};if(H instanceof w.WorkspaceEdit)for(let Ge of H._allEntries())if(Ge._type===1)tt.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const ct=Fe?.getDocument(Ge.uri);tt.edits.push({_type:2,resource:Ge.uri,edit:le.from(Ge.edit),modelVersionId:ct?.version,metadata:Ge.metadata})}else Ge._type===3?tt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Te?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version}):Ge._type===5&&tt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Te?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(B.from)}});return tt}_e.from=ke;function Y(H){const Fe=new w.WorkspaceEdit;for(const Te of H.edits)Te.edit?Fe.replace(E.URI.revive(Te.resource),a.to(Te.edit.range),Te.edit.text):Fe.renameFile(E.URI.revive(Te.oldUri),E.URI.revive(Te.newUri),Te.options);return Fe}_e.to=Y})(oe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(_e){const ke=Object.create(null);ke[w.SymbolKind.File]=0,ke[w.SymbolKind.Module]=1,ke[w.SymbolKind.Namespace]=2,ke[w.SymbolKind.Package]=3,ke[w.SymbolKind.Class]=4,ke[w.SymbolKind.Method]=5,ke[w.SymbolKind.Property]=6,ke[w.SymbolKind.Field]=7,ke[w.SymbolKind.Constructor]=8,ke[w.SymbolKind.Enum]=9,ke[w.SymbolKind.Interface]=10,ke[w.SymbolKind.Function]=11,ke[w.SymbolKind.Variable]=12,ke[w.SymbolKind.Constant]=13,ke[w.SymbolKind.String]=14,ke[w.SymbolKind.Number]=15,ke[w.SymbolKind.Boolean]=16,ke[w.SymbolKind.Array]=17,ke[w.SymbolKind.Object]=18,ke[w.SymbolKind.Key]=19,ke[w.SymbolKind.Null]=20,ke[w.SymbolKind.EnumMember]=21,ke[w.SymbolKind.Struct]=22,ke[w.SymbolKind.Event]=23,ke[w.SymbolKind.Operator]=24,ke[w.SymbolKind.TypeParameter]=25;function Y(Fe){return typeof ke[Fe]=="number"?ke[Fe]:6}_e.from=Y;function H(Fe){for(const Te in ke)if(ke[Te]===Fe)return Number(Te);return w.SymbolKind.Property}_e.to=H})(V=e.SymbolKind||(e.SymbolKind={}));var W;(function(_e){function ke(H){switch(H){case w.SymbolTag.Deprecated:return 1}}_e.from=ke;function Y(H){switch(H){case 1:return w.SymbolTag.Deprecated}}_e.to=Y})(W=e.SymbolTag||(e.SymbolTag={}));var L;(function(_e){function ke(H){return{name:H.name,kind:V.from(H.kind),tags:H.tags&&H.tags.map(W.from),containerName:H.containerName,location:$.from(H.location)}}_e.from=ke;function Y(H){const Fe=new w.SymbolInformation(H.name,V.to(H.kind),H.containerName,$.to(H.location));return Fe.tags=H.tags&&H.tags.map(W.to),Fe}_e.to=Y})(L=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(_e){function ke(H){const Fe={name:H.name||"!!MISSING: name!!",detail:H.detail,range:a.from(H.range),selectionRange:a.from(H.selectionRange),kind:V.from(H.kind),tags:H.tags?.map(W.from)??[]};return H.children&&(Fe.children=H.children.map(ke)),Fe}_e.from=ke;function Y(H){const Fe=new w.DocumentSymbol(H.name,H.detail,V.to(H.kind),a.to(H.range),a.to(H.selectionRange));return(0,m.isNonEmptyArray)(H.tags)&&(Fe.tags=H.tags.map(W.to)),H.children&&(Fe.children=H.children.map(Y)),Fe}_e.to=Y})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var O;(function(_e){function ke(H){const Fe=new w.CallHierarchyItem(V.to(H.kind),H.name,H.detail||"",E.URI.revive(H.uri),a.to(H.range),a.to(H.selectionRange));return Fe._sessionId=H._sessionId,Fe._itemId=H._itemId,Fe}_e.to=ke;function Y(H,Fe,Te){if(Fe=Fe??H._sessionId,Te=Te??H._itemId,Fe===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Te,name:H.name,detail:H.detail,kind:V.from(H.kind),uri:H.uri,range:a.from(H.range),selectionRange:a.from(H.selectionRange),tags:H.tags?.map(W.from)}}_e.from=Y})(O=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(_e){function ke(Y){return new w.CallHierarchyIncomingCall(O.to(Y.from),Y.fromRanges.map(H=>a.to(H)))}_e.to=ke})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var he;(function(_e){function ke(Y){return new w.CallHierarchyOutgoingCall(O.to(Y.to),Y.fromRanges.map(H=>a.to(H)))}_e.to=ke})(he=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(_e){function ke(H){return{range:H.range&&a.from(H.range),uri:H.uri}}_e.from=ke;function Y(H){return new w.Location(E.URI.revive(H.uri),a.to(H.range))}_e.to=Y})($=e.location||(e.location={}));var ne;(function(_e){function ke(H){const Fe=H,Te=H;return{originSelectionRange:Fe.originSelectionRange?a.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Te.uri,range:a.from(Fe.targetRange?Fe.targetRange:Te.range),targetSelectionRange:Fe.targetSelectionRange?a.from(Fe.targetSelectionRange):void 0}}_e.from=ke;function Y(H){return{targetUri:E.URI.revive(H.uri),targetRange:a.to(H.range),targetSelectionRange:H.targetSelectionRange?a.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?a.to(H.originSelectionRange):void 0}}_e.to=Y})(ne=e.DefinitionLink||(e.DefinitionLink={}));var de;(function(_e){function ke(H){return{range:a.from(H.range),contents:D.fromMany(H.contents)}}_e.from=ke;function Y(H){return new w.Hover(H.contents.map(D.to),a.to(H.range))}_e.to=Y})(de=e.Hover||(e.Hover={}));var ye;(function(_e){function ke(H){return{range:a.from(H.range),expression:H.expression}}_e.from=ke;function Y(H){return new w.EvaluatableExpression(a.to(H.range),H.expression)}_e.to=Y})(ye=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ne;(function(_e){function ke(H){if(H instanceof w.InlineValueText)return{type:"text",range:a.from(H.range),text:H.text};if(H instanceof w.InlineValueVariableLookup)return{type:"variable",range:a.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=ke;function Y(H){switch(H.type){case"text":return{range:a.to(H.range),text:H.text};case"variable":return{range:a.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:a.to(H.range),expression:H.expression}}}_e.to=Y})(Ne=e.InlineValue||(e.InlineValue={}));var Me;(function(_e){function ke(H){return{frameId:H.frameId,stoppedLocation:a.from(H.stoppedLocation)}}_e.from=ke;function Y(H){return new w.InlineValueContext(H.frameId,a.to(H.stoppedLocation))}_e.to=Y})(Me=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(_e){function ke(H){return{range:a.from(H.range),kind:H.kind}}_e.from=ke;function Y(H){return new w.DocumentHighlight(a.to(H.range),H.kind)}_e.to=Y})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var Xe;(function(_e){function ke(Y){switch(Y){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}_e.to=ke})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(_e){function ke(Y){return{triggerKind:Xe.to(Y.triggerKind),triggerCharacter:Y.triggerCharacter}}_e.to=ke})(qe=e.CompletionContext||(e.CompletionContext={}));var je;(function(_e){function ke(H){switch(H){case w.CompletionItemTag.Deprecated:return 1}}_e.from=ke;function Y(H){switch(H){case 1:return w.CompletionItemTag.Deprecated}}_e.to=Y})(je=e.CompletionItemTag||(e.CompletionItemTag={}));var U;(function(_e){const ke=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function Y(Te){return ke.get(Te)??9}_e.from=Y;const H=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function Fe(Te){return H.get(Te)??w.CompletionItemKind.Property}_e.to=Fe})(U=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(_e){function ke(Y,H){const Fe=new w.CompletionItem(Y.label);return Fe.insertText=Y.insertText,Fe.kind=U.to(Y.kind),Fe.tags=Y.tags?.map(je.to),Fe.detail=Y.detail,Fe.documentation=R.isMarkdownString(Y.documentation)?D.to(Y.documentation):Y.documentation,Fe.sortText=Y.sortText,Fe.filterText=Y.filterText,Fe.preselect=Y.preselect,Fe.commitCharacters=Y.commitCharacters,k.Range.isIRange(Y.range)?Fe.range=a.to(Y.range):typeof Y.range=="object"&&(Fe.range={inserting:a.to(Y.range.insert),replacing:a.to(Y.range.replace)}),Fe.keepWhitespace=typeof Y.insertTextRules=="undefined"?!1:Boolean(Y.insertTextRules&1),typeof Y.insertTextRules!="undefined"&&Y.insertTextRules&4?Fe.insertText=new w.SnippetString(Y.insertText):(Fe.insertText=Y.insertText,Fe.textEdit=Fe.range instanceof w.Range?new w.TextEdit(Fe.range,Fe.insertText):void 0),Y.additionalTextEdits&&Y.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Y.additionalTextEdits.map(Te=>le.to(Te))),Fe.command=H&&Y.command?H.fromInternal(Y.command):void 0,Fe}_e.to=ke})(G=e.CompletionItem||(e.CompletionItem={}));var X;(function(_e){function ke(H){return{label:H.label,documentation:H.documentation?D.fromStrict(H.documentation):void 0}}_e.from=ke;function Y(H){return{label:H.label,documentation:R.isMarkdownString(H.documentation)?D.to(H.documentation):H.documentation}}_e.to=Y})(X=e.ParameterInformation||(e.ParameterInformation={}));var re;(function(_e){function ke(H){return{label:H.label,documentation:H.documentation?D.fromStrict(H.documentation):void 0,parameters:Array.isArray(H.parameters)?H.parameters.map(X.from):[],activeParameter:H.activeParameter}}_e.from=ke;function Y(H){return{label:H.label,documentation:R.isMarkdownString(H.documentation)?D.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(X.to):[],activeParameter:H.activeParameter}}_e.to=Y})(re=e.SignatureInformation||(e.SignatureInformation={}));var q;(function(_e){function ke(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(re.from):[]}}_e.from=ke;function Y(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(re.to):[]}}_e.to=Y})(q=e.SignatureHelp||(e.SignatureHelp={}));var ie;(function(_e){function ke(H){return{text:H.text,position:v.from(H.position),kind:ge.from(H.kind??w.InlayHintKind.Other),whitespaceBefore:H.whitespaceBefore,whitespaceAfter:H.whitespaceAfter}}_e.from=ke;function Y(H){const Fe=new w.InlayHint(H.text,v.to(H.position),ge.to(H.kind));return Fe.whitespaceAfter=H.whitespaceAfter,Fe.whitespaceBefore=H.whitespaceBefore,Fe}_e.to=Y})(ie=e.InlayHint||(e.InlayHint={}));var ge;(function(_e){function ke(H){return H}_e.from=ke;function Y(H){return H}_e.to=Y})(ge=e.InlayHintKind||(e.InlayHintKind={}));var Re;(function(_e){function ke(H){return{range:a.from(H.range),url:H.target,tooltip:H.tooltip}}_e.from=ke;function Y(H){let Fe;if(H.url)try{Fe=typeof H.url=="string"?E.URI.parse(H.url,!0):E.URI.revive(H.url)}catch(Te){}return new w.DocumentLink(a.to(H.range),Fe)}_e.to=Y})(Re=e.DocumentLink||(e.DocumentLink={}));var We;(function(_e){function ke(H){const Fe=new w.ColorPresentation(H.label);return H.textEdit&&(Fe.textEdit=le.to(H.textEdit)),H.additionalTextEdits&&(Fe.additionalTextEdits=H.additionalTextEdits.map(Te=>le.to(Te))),Fe}_e.to=ke;function Y(H){return{label:H.label,textEdit:H.textEdit?le.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Fe=>le.from(Fe)):void 0}}_e.from=Y})(We=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(_e){function ke(H){return new w.Color(H[0],H[1],H[2],H[3])}_e.to=ke;function Y(H){return[H.red,H.green,H.blue,H.alpha]}_e.from=Y})(ve=e.Color||(e.Color={}));var Ye;(function(_e){function ke(H){return{range:a.from(H.range)}}_e.from=ke;function Y(H){return new w.SelectionRange(a.to(H.range))}_e.to=Y})(Ye=e.SelectionRange||(e.SelectionRange={}));var z;(function(_e){function ke(Y){switch(Y){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}_e.to=ke})(z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Z;(function(_e){function ke(H){switch(H){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=ke;function Y(H){switch(H){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}_e.to=Y})(Z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ce;(function(_e){function ke(H){if(H===w.EndOfLine.CRLF)return 1;if(H===w.EndOfLine.LF)return 0}_e.from=ke;function Y(H){if(H===1)return w.EndOfLine.CRLF;if(H===0)return w.EndOfLine.LF}_e.to=Y})(ce=e.EndOfLine||(e.EndOfLine={}));var Ue;(function(_e){function ke(Y){if(typeof Y=="object")return Y.viewId;switch(Y){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=ke})(Ue=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(_e){function ke(Y){const H={start:Y.start+1,end:Y.end+1};return Y.kind&&(H.kind=et.from(Y.kind)),H}_e.from=ke})(xe=e.FoldingRange||(e.FoldingRange={}));var et;(function(_e){function ke(Y){if(Y)switch(Y){case w.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}_e.from=ke})(et=e.FoldingRangeKind||(e.FoldingRangeKind={}));var De;(function(_e){function ke(Y){if(Y)return{pinned:typeof Y.preview=="boolean"?!Y.preview:void 0,inactive:Y.background,preserveFocus:Y.preserveFocus,selection:typeof Y.selection=="object"?a.from(Y.selection):void 0,override:typeof Y.override=="boolean"?C.EditorResolution.DISABLED:void 0}}_e.from=ke})(De=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Se;(function(_e){function ke(H){return H instanceof w.RelativePattern||typeof H=="string"?H:Y(H)?new w.RelativePattern(H.base,H.pattern):H}_e.from=ke;function Y(H){const Fe=H;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(Se=e.GlobPattern||(e.GlobPattern={}));var Pe;(function(_e){function ke(Y){if(Y){if(Array.isArray(Y))return Y.map(ke);if(typeof Y=="string")return Y;{const H=Y;return{language:H.language,scheme:H.scheme,pattern:typeof H.pattern=="undefined"?void 0:Se.from(H.pattern),exclusive:H.exclusive}}}else return}_e.from=ke})(Pe=e.LanguageSelector||(e.LanguageSelector={}));var se;(function(_e){function ke(H){return{start:H.start,end:H.end}}_e.from=ke;function Y(H){return new w.NotebookRange(H.start,H.end)}_e.to=Y})(se=e.NotebookRange||(e.NotebookRange={}));var ae;(function(_e){function ke(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}_e.to=ke;function Y(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}_e.from=Y})(ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var fe;(function(_e){function ke(H){switch(H){case w.NotebookCellKind.Markup:return c.CellKind.Markup;case w.NotebookCellKind.Code:default:return c.CellKind.Code}}_e.from=ke;function Y(H){switch(H){case c.CellKind.Markup:return w.NotebookCellKind.Markup;case c.CellKind.Code:default:return w.NotebookCellKind.Code}}_e.to=Y})(fe=e.NotebookCellKind||(e.NotebookCellKind={}));var pe;(function(_e){function ke(H){const Fe={metadata:H.metadata??Object.create(null),cells:[]};for(let Te of H.cells)w.NotebookCellData.validate(Te),Fe.cells.push(B.from(Te));return Fe}_e.from=ke;function Y(H){const Fe=new w.NotebookData(H.cells.map(B.to));return(0,y.isEmptyObject)(H.metadata)||(Fe.metadata=H.metadata),Fe}_e.to=Y})(pe=e.NotebookData||(e.NotebookData={}));var B;(function(_e){function ke(H){return{cellKind:fe.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:ae.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(we.from):[]}}_e.from=ke;function Y(H){return new w.NotebookCellData(fe.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(we.to):void 0,H.metadata,H.internalMetadata?ae.to(H.internalMetadata):void 0)}_e.to=Y})(B=e.NotebookCellData||(e.NotebookCellData={}));var me;(function(_e){function ke(H){return{mime:H.mime,valueBytes:Array.from(H.data)}}_e.from=ke;function Y(H){return new w.NotebookCellOutputItem(new Uint8Array(H.valueBytes),H.mime)}_e.to=Y})(me=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var we;(function(_e){function ke(H){return{outputId:H.id,items:H.items.map(me.from),metadata:H.metadata}}_e.from=ke;function Y(H){const Fe=H.items.map(me.to);return new w.NotebookCellOutput(Fe,H.outputId,H.metadata)}_e.to=Y})(we=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(_e){function ke(Te){if(Te!=null){if(Te instanceof w.RelativePattern||typeof Te=="string")return Te;if(Fe(Te))return new w.RelativePattern(Te.base,Te.pattern);if(H(Te))return{include:Se.from(Te.include)||void 0,exclude:Se.from(Te.exclude)||void 0}}}_e.from=ke;function Y(Te){return typeof Te=="string"?Te:Fe(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}_e.to=Y;function H(Te){const tt=Te,Ge=Se.from(tt.include);if(!(Ge&&Ge instanceof w.RelativePattern||typeof Ge=="string"))return!1;const ct=Se.from(tt.exclude);return!!(ct&&ct instanceof w.RelativePattern||typeof ct=="string")}function Fe(Te){const tt=Te;return tt&&typeof tt.base=="string"&&typeof tt.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Oe;(function(_e){function ke(Y){return{backgroundColor:Y.backgroundColor,borderColor:Y.borderColor,top:Y.top?A.from(Y.top):void 0}}_e.from=ke})(Oe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var He;(function(_e){function ke(Y,H,Fe){const Te=typeof Y.command=="string"?{title:"",command:Y.command}:Y.command;return{alignment:Y.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Te,Fe),text:Y.text,tooltip:Y.tooltip,accessibilityInformation:Y.accessibilityInformation,priority:Y.priority}}_e.from=ke})(He=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ze;(function(_e){function ke(Y){return{transientOutputs:Y?.transientOutputs??!1,transientCellMetadata:Y?.transientCellMetadata??{},transientDocumentMetadata:Y?.transientDocumentMetadata??{}}}_e.from=ke})(Ze=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ke;(function(_e){function ke(H){return{uri:H.uri,provides:H.provides}}_e.from=ke;function Y(H){return new w.NotebookRendererScript(E.URI.revive(H.uri),H.provides)}_e.to=Y})(Ke=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Je;(function(_e){function ke(H){return{message:D.fromStrict(H.message)||"",severity:w.TestMessageSeverity.Error,expectedOutput:H.expectedOutput,actualOutput:H.actualOutput,location:H.location?$.from(H.location):void 0}}_e.from=ke;function Y(H){const Fe=new w.TestMessage(typeof H.message=="string"?H.message:D.to(H.message));return Fe.actualOutput=H.actualOutput,Fe.expectedOutput=H.expectedOutput,Fe}_e.to=Y})(Je=e.TestMessage||(e.TestMessage={}));var ut;(function(_e){function ke(Te){return{extId:g.TestId.fromExtHostTestItem(Te,(0,h.getPrivateApiFor)(Te).controllerId).toString(),label:Te.label,uri:Te.uri,range:a.from(Te.range)||null,description:Te.description||null,error:Te.error&&D.fromStrict(Te.error)||null}}_e.from=ke;function Y(Te){return{id:g.TestId.fromString(Te.extId).localId,label:Te.label,uri:E.URI.revive(Te.uri),range:a.to(Te.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Te.description||void 0}}_e.toPlain=Y;function H(Te){const tt=g.TestId.fromString(Te.extId),Ge=new h.TestItemImpl(tt.controllerId,tt.localId,Te.label,E.URI.revive(Te.uri));return Ge.range=a.to(Te.range||void 0),Ge.description=Te.description||void 0,Ge}function Fe(Te){let tt;for(const Ge of Te.tests){const ct=H(Ge.item);(0,h.getPrivateApiFor)(ct).parent=tt,tt=ct}return tt}_e.toItemFromContext=Fe})(ut=e.TestItem||(e.TestItem={}));var mt;(function(_e){const ke=(H,Fe)=>{const Te={...ut.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(tt=>({state:tt.state,duration:tt.duration,messages:tt.messages.map(Je.to)})),children:H.children.map(tt=>Fe.get(tt)).filter(y.isDefined).map(tt=>ke(tt,Fe))};for(const tt of Te.children)tt.parent=Te;return Te};function Y(H){const Fe=[],Te=new Map;for(const tt of H.items)Te.set(tt.item.extId,tt),H.request.targets.some(Ge=>Ge.controllerId===tt.controllerId&&Ge.testIds.includes(tt.item.extId))&&Fe.push(tt);return{completedAt:H.completedAt,results:Fe.map(tt=>ke(tt,Te))}}_e.to=Y})(mt=e.TestResults||(e.TestResults={}));var bt;(function(_e){function ke(Te){return{covered:Te.covered,total:Te.covered}}function Y(Te){return"line"in Te?v.from(Te):a.from(Te)}function H(Te){return"branches"in Te?{count:Te.executionCount,location:Y(Te.location),type:1,branches:Te.branches.length?Te.branches.map(tt=>({count:tt.executionCount,location:tt.location&&Y(tt.location)})):void 0}:{type:0,count:Te.executionCount,location:Y(Te.location)}}_e.fromDetailed=H;function Fe(Te){return{uri:Te.uri,statement:ke(Te.statementCoverage),branch:Te.branchCoverage&&ke(Te.branchCoverage),function:Te.functionCoverage&&ke(Te.functionCoverage),details:Te.detailedCoverage?.map(H)}}_e.fromFile=Fe})(bt=e.TestCoverage||(e.TestCoverage={}));var ot;(function(_e){function ke(Y){switch(Y){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}_e.to=ke})(ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var at;(function(_e){function ke(H){const Fe=new w.TypeHierarchyItem(V.to(H.kind),H.name,H.detail||"",E.URI.revive(H.uri),a.to(H.range),a.to(H.selectionRange));return Fe._sessionId=H._sessionId,Fe._itemId=H._itemId,Fe}_e.to=ke;function Y(H,Fe,Te){if(Fe=Fe??H._sessionId,Te=Te??H._itemId,Fe===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Te,kind:V.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:a.from(H.range),selectionRange:a.from(H.selectionRange),tags:H.tags?.map(W.from)}}_e.from=Y})(at=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[177],Ee([0,1,2,12,7,9,80]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class y{constructor(k,n,C,l={timeout:1500,errors:3}){this._logService=k,this._documents=n,this._mainThreadBulkEdits=C,this._thresholds=l,this._callbacks=new I.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(n,C,l)=>{const c={dispose:this._callbacks.push([n,C,k])};return Array.isArray(l)&&l.push(c),c}}async $participateInSave(k,n){const C=m.URI.revive(k);let l=!1;const h=setTimeout(()=>l=!0,this._thresholds.timeout),c=[];try{for(let g of[...this._callbacks]){if(l)break;const b=this._documents.getDocument(C),w=await this._deliverEventAsyncAndBlameBadListeners(g,{document:b,reason:_.TextDocumentSaveReason.to(n)});c.push(w)}}finally{clearTimeout(h)}return c}_deliverEventAsyncAndBlameBadListeners([k,n,C],l){const h=this._badListeners.get(k);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,k,n,l).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const g=this._badListeners.get(k);this._badListeners.set(k,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,n,C,l){const h=[],c=Date.now(),{document:g,reason:b}=l,{version:w}=g,P=Object.freeze({document:g,reason:b,waitUntil(a){if(Object.isFrozen(h))throw(0,R.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(a))}});try{n.apply(C,[P])}catch(a){return Promise.reject(a)}return Object.freeze(h),new Promise((a,f)=>{const v=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(v),a(t)}).catch(t=>{clearTimeout(v),f(t)})}).then(a=>{const f={edits:[]};for(const v of a)if(Array.isArray(v)&&v.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:r,range:s}of v)f.edits.push({_type:2,resource:g.uri,edit:{range:s&&_.Range.from(s),text:t,eol:r&&_.EndOfLine.from(r)}});if(f.edits.length!==0)return w===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=y}),define(be[178],Ee([0,1,3,27,2,9,7]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(n,C,l,h,c){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,l&&(this._config+=1),h&&(this._config+=2),c&&(this._config+=4);const g=(0,R.parse)(C),b=n(w=>{if(!l)for(let P of w.created){const a=S.URI.revive(P);g(a.fsPath)&&this._onDidCreate.fire(a)}if(!h)for(let P of w.changed){const a=S.URI.revive(P);g(a.fsPath)&&this._onDidChange.fire(a)}if(!c)for(let P of w.deleted){const a=S.URI.revive(P);g(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=I.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,b)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class E{constructor(n,C,l){this._logService=C,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,C,l,h){return new y(this._onFileSystemEvent.event,n,C,l,h)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,C){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:C.map(l=>({oldUri:S.URI.revive(l.source),newUri:S.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:C.map(l=>S.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:C.map(l=>S.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,C){return(l,h,c)=>{const g=function(w){l.call(h,w)};return g.extension=n,C.event(g,void 0,c)}}async $onWillRunFileOperation(n,C,l,h){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:C.map(c=>({oldUri:S.URI.revive(c.source),newUri:S.URI.revive(c.target)}))},l,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:C.map(c=>S.URI.revive(c.target))},l,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:C.map(c=>S.URI.revive(c.target))},l,h)}}async _fireWillEvent(n,C,l,h){const c=new Set,g=[];if(await n.fireAsync(C,h,async(w,P)=>{const a=Date.now(),f=await Promise.resolve(w);f instanceof I.WorkspaceEdit&&(g.push(f),c.add(P.extension.displayName??P.extension.identifier.value)),Date.now()-a>l&&this._logService.warn("SLOW file-participant",P.extension.identifier)}),h.isCancellationRequested||g.length===0)return;const b={edits:[]};for(let w of g){let{edits:P}=_.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);b.edits=b.edits.concat(P)}return{edit:b,extensionNames:Array.from(c)}}}e.ExtHostFileSystemEventService=E}),define(be[179],Ee([0,1,11,23,2,9,7,72]),function(ee,e,m,R,S,_,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class E{constructor(l,h,c,g){this.start=l,this.deletedCount=h,this.deletedItems=c,this.items=g}static asApiEvents(l){return l.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(c=>c.apiCell)}))}}class k{constructor(l,h,c){this.notebook=l,this._extHostDocument=h,this._cellData=c,this.handle=c.handle,this.uri=S.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(_.NotebookCellOutput.to),this._internalMetadata=c.internalMetadata??{},this._metadata=Object.freeze(c.metadata??{}),this._previousResult=Object.freeze(_.NotebookCellExecutionSummary.to(c.internalMetadata??{}))}static asModelAddData(l,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:_.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return l._mime},set mime(c){l._mime=c},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(_.NotebookCellOutput.to)}setOutputItems(l,h,c){const g=c.map(_.NotebookCellOutputItem.to),b=this._outputs.find(w=>w.id===l);b&&(h||(b.items.length=0),b.items.push(...g))}setMetadata(l){this._metadata=Object.freeze(l)}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=Object.freeze(_.NotebookCellExecutionSummary.to(l))}setMime(l){}}e.ExtHostCell=k;class n{constructor(l,h,c,g,b,w){this._proxy=l,this._textDocumentsAndEditors=h,this._textDocuments=c,this._emitter=g,this.uri=b,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===m.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(h){return h=l._validateIndex(h),l._cells[h].apiCell},getCells(h){return(h?l._getCells(h):l._cells).map(g=>g.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.freeze({...this._metadata,...l.metadata}))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,h){this._versionId=l.versionId,this._isDirty=h;for(const c of l.rawEvents)c.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===y.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===y.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===y.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===y.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===y.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let h=l.start|0,c=l.end|0;return h<0&&(h=0),c>this._cells.length&&(c=this._cells.length),l.with({start:h,end:c})}_getCells(l){l=this._validateRange(l);const h=[];for(let c=l.start;c<l.end;c++)h.push(this._cells[c]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,h){if(this._disposed)return;const c=[],g=[],b=[];l.reverse().forEach(w=>{const a=w[2].map(t=>{const r=new k(this,this._textDocumentsAndEditors,t);return h||g.push(k.asModelAddData(this.apiNotebook,t)),r}),f=new E(w[0],w[1],[],a),v=this._cells.splice(w[0],w[1],...a);for(const t of v)b.push(t.uri),f.deletedItems.push(t.apiCell);c.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:b}),h||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:E.asApiEvents(c)}))}_moveCell(l,h){const c=this._cells.splice(l,1);this._cells.splice(h,0,...c);const g=[new E(l,1,c.map(b=>b.apiCell),[]),new E(h,0,[],c)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:E.asApiEvents(g)}))}_setCellOutputs(l,h){const c=this._cells[l];c.setOutputs(h),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(l,h,c,g){const b=this._cells[l];b.setOutputItems(h,c,g),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_changeCellLanguage(l,h){const c=this._cells[l];c.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(c.uri,h)}_changeCellMime(l,h){const c=this._cells[l];c.apiCell.mime=h}_changeCellMetadata(l,h){const c=this._cells[l],g=c.apiCell.metadata;c.setMetadata(h);const b=c.apiCell.metadata;(0,R.equals)(g,b)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(l,h){const c=this._cells[l],g=c.internalMetadata;if(c.setInternalMetadata(h),g.runState!==h.runState){const b=h.runState??I.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:c.apiCell,state:b}))}}getCellFromApiCell(l){return this._cells.find(h=>h.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(h=>h.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(be[101],Ee([0,1,7,9,12]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class _{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:E,metadata:k})}replaceCells(E,k,n){this._throwIfFinalized(),!(E===k&&n.length===0)&&this._collectedEdits.push({editType:1,index:E,count:k-E,cells:n.map(R.NotebookCellData.from)})}}class I{constructor(E,k,n,C,l,h){this.id=E,this._proxy=k,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=C,this._viewColumn=h}get apiEditor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.apiNotebook},get selections(){return E._selections},set selections(k){if(!Array.isArray(k)||!k.every(m.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");E._selections=k,E._trySetSelections(k)},get visibleRanges(){return E._visibleRanges},revealRange(k,n){E._proxy.$tryRevealRange(E.id,R.NotebookRange.from(k),n??m.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},edit(k){const n=new _(this.document.version);return k(n),E._applyEdit(n.finalize())},setDecorations(k,n){return E.setDecorations(k,n)}},I.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(R.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const k=[];let n=-1;for(let C=0;C<E.cellEdits.length;C++){if(n<0){k.push(E.cellEdits[C]),n++;continue}const h=k[n],c=E.cellEdits[C];if(h.editType===1&&c.editType===1&&h.index===c.index){h.cells.push(...E.cellEdits[C].cells),h.count+=E.cellEdits[C].count;continue}k.push(E.cellEdits[C]),n++}return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,k)}setDecorations(E,k){if(!(k.isEmpty&&!this._hasDecorationsForKey.has(E.key)))return k.isEmpty?this._hasDecorationsForKey.delete(E.key):this._hasDecorationsForKey.add(E.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(k),E.key)}}e.ExtHostNotebookEditor=I,I.apiEditorsToExtHost=new WeakMap}),define(be[180],Ee([0,1,9,156,135,20,52]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,l,h){const c=this._handles++,{title:g,location:b,cancellable:w}=l,P={label:(0,S.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(c,{location:m.ProgressLocation.from(b),title:g,source:P,cancellable:w},C),this._withProgress(c,h,!!w)}_withProgress(C,l,h){let c;h&&(c=new _.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,c));const g=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),c&&c.dispose()};let b;try{b=l(new k(this._proxy,C),h&&c?c.token:_.CancellationToken.None)}catch(w){throw g(C),w}return b.then(w=>g(C),w=>g(C)),b}$acceptProgressCanceled(C){const l=this._mapHandleToCancellationSource.get(C);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=y;function E(n,C){return n.message=C.message,typeof C.increment=="number"&&(typeof n.increment=="number"?n.increment+=C.increment:n.increment=C.increment),n}class k extends R.Progress{constructor(C,l){super(h=>this.throttledReport(h));this._proxy=C,this._handle=l}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}ze([(0,I.throttle)(100,(n,C)=>E(n,C),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(be[102],Ee([0,1,41,12,54,9,7]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class y{constructor(l,h,c){const g=y._Keys.nextId();l.$registerTextEditorDecorationType(h.identifier,g,_.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:g,dispose(){l.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=y,y._Keys=new S.IdGenerator("TextEditorDecorationType");class E{constructor(l,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,h){this._throwIfFinalized();let c=null;if(l instanceof I.Position)c=new I.Range(l,l);else if(l instanceof I.Range)c=l;else throw new Error("Unrecognized location");this._pushEdit(c,h,!1)}insert(l,h){this._throwIfFinalized(),this._pushEdit(new I.Range(l,l),h,!0)}delete(l){this._throwIfFinalized();let h=null;if(l instanceof I.Range)h=l;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(l,h,c){const g=this._document.validateRange(l);this._collectedEdits.push({range:g,text:h,forceMoveMarkers:c})}setEndOfLine(l){if(this._throwIfFinalized(),l!==I.EndOfLine.LF&&l!==I.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=E;class k{constructor(l,h,c,g){this._proxy=l,this._id=h,this._accept(c),this._logService=g;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(w){b._setTabSize(w)},get insertSpaces(){return b._insertSpaces},set insertSpaces(w){b._setInsertSpaces(w)},get cursorStyle(){return b._cursorStyle},set cursorStyle(w){b._setCursorStyle(w)},get lineNumbers(){return b._lineNumbers},set lineNumbers(w){b._setLineNumbers(w)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=_.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const h=Math.floor(l);return h>0?h:null}if(typeof l=="string"){const h=parseInt(l,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(l){const h=this._validateTabSize(l);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const h=this._validateInsertSpaces(l);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:_.TextEditorLineNumbersStyle.from(l)})))}assign(l){const h={};let c=!1;if(typeof l.tabSize!="undefined"){const g=this._validateTabSize(l.tabSize);g==="auto"?(c=!0,h.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,c=!0,h.tabSize=g)}if(typeof l.insertSpaces!="undefined"){const g=this._validateInsertSpaces(l.insertSpaces);g==="auto"?(c=!0,h.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,c=!0,h.insertSpaces=g)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,c=!0,h.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,c=!0,h.lineNumbers=_.TextEditorLineNumbersStyle.from(l.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(l){l.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=k;class n{constructor(l,h,c,g,b,w,P,a){this.id=l,this._proxy=h,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new k(this._proxy,this.id,w,c),this._visibleRanges=P,this._viewColumn=a;const f=this;this.value=Object.freeze({get document(){return g.getValue()},set document(v){throw(0,R.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(v){if(!(v instanceof I.Selection))throw(0,R.illegalArgument)("selection");f._selections=[v],f._trySetSelection()},get selections(){return f._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof I.Selection)))throw(0,R.illegalArgument)("selections");f._selections=v,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(v){throw(0,R.readonly)("visibleRanges")},get options(){return f._options.value},set options(v){f._disposed||f._options.assign(v)},get viewColumn(){return f._viewColumn},set viewColumn(v){throw(0,R.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new E(g.getValue(),t);return v(r),f._applyEdit(r)},insertSnippet(v,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=f._selections.map(i=>_.Range.from(i));else if(t instanceof I.Position){const{lineNumber:i,column:u}=_.Position.from(t);s=[{startLineNumber:i,startColumn:u,endLineNumber:i,endColumn:u}]}else if(t instanceof I.Range)s=[_.Range.from(t)];else{s=[];for(const i of t)if(i instanceof I.Range)s.push(_.Range.from(i));else{const{lineNumber:u,column:d}=_.Position.from(i);s.push({startLineNumber:u,startColumn:d,endLineNumber:u,endColumn:d})}}return h.$tryInsertSnippet(l,v.value,s,r)},setDecorations(v,t){const r=t.length===0;r&&!f._hasDecorationsForKey.has(v.key)||(r?f._hasDecorationsForKey.delete(v.key):f._hasDecorationsForKey.add(v.key),f._runOnProxy(()=>{if(_.isDecorationOptionsArr(t))return h.$trySetDecorations(l,v.key,_.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,u=t.length;i<u;i++){const d=t[i];s[4*i]=d.start.line+1,s[4*i+1]=d.start.character+1,s[4*i+2]=d.end.line+1,s[4*i+3]=d.end.character+1}return h.$trySetDecorationsFast(l,v.key,s)}}))},revealRange(v,t){f._runOnProxy(()=>h.$tryRevealRange(l,_.Range.from(v),t||I.TextEditorRevealType.Default))},show(v){h.$tryShowEditor(l,_.ViewColumn.from(v))},hide(){h.$tryHideEditor(l)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,m.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,m.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,m.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,m.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(_.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const h=l.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const c=h.edits.map(b=>b.range);c.sort((b,w)=>b.end.line===w.end.line?b.end.character===w.end.character?b.start.line===w.start.line?b.start.character-w.start.character:b.start.line-w.start.line:b.end.character-w.end.character:b.end.line-w.end.line);for(let b=0,w=c.length-1;b<w;b++){const P=c[b].end;if(c[b+1].start.isBefore(P))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=h.edits.map(b=>({range:_.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,g,{setEndOfLine:typeof h.setEndOfLine=="number"?_.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=n}),define(be[181],Ee([0,1,138,25,2,3,6,170,15,7,10,17,9,20,167]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(P,a){if((0,n.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let f;return Array.isArray(P.highlights)&&(f=P.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),f=f.length?f:void 0),{label:P.label,highlights:f}}}class b{constructor(a,f,v){this._proxy=a,this.commands=f,this.logService=v,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}f.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>t(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(a,f,v){const t=this.createTreeView(a,{treeDataProvider:f},v);return{dispose:()=>t.dispose()}}createTreeView(a,f,v){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=f.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,canDragAndDrop:t}),s=this.createExtHostTreeView(a,f,v);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(i){s.message=i},get title(){return s.title},set title(i){s.title=i},get description(){return s.description},set description(i){s.description=i},reveal:(i,u)=>s.reveal(i,u),dispose:async()=>{await r,this.treeViews.delete(a),s.dispose()}}}$getChildren(a,f){const v=this.treeViews.get(a);return v?v.getChildren(f):Promise.reject(new Error((0,m.localize)(0,null,a)))}async $onDrop(a,f,v){const t=this.treeViews.get(a);if(!t)return Promise.reject(new Error((0,m.localize)(1,null,a)));const r=c.TreeDataTransferConverter.toITreeDataTransfer(f);if(r.items.has(y.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await r.items.get(y.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(u=>t.getExtensionElement(u)).filter(u=>!!u);i.length>0?r.items.set(y.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):r.items.delete(y.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,v)}async $hasResolve(a){const f=this.treeViews.get(a);if(!f)throw new Error((0,m.localize)(2,null,a));return f.hasResolve}$resolve(a,f,v){const t=this.treeViews.get(a);if(!t)throw new Error((0,m.localize)(3,null,a));return t.resolveTreeItem(f,v)}$setExpanded(a,f,v){const t=this.treeViews.get(a);if(!t)throw new Error((0,m.localize)(4,null,a));t.setExpanded(f,v)}$setSelection(a,f){const v=this.treeViews.get(a);if(!v)throw new Error((0,m.localize)(5,null,a));v.setSelection(f)}$setVisible(a,f){const v=this.treeViews.get(a);if(!v)throw new Error((0,m.localize)(6,null,a));v.setVisible(f)}createExtHostTreeView(a,f,v){const t=new w(a,f,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(a,t),t}convertArgument(a){const f=this.treeViews.get(a.$treeViewId);return f?f.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=b;class w extends I.Disposable{constructor(a,f,v,t,r,s){super();if(this.viewId=a,this.proxy=v,this.commands=t,this.logService=r,this.extension=s,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,s.contributes&&s.contributes.views)for(const d in s.contributes.views)for(const p of s.contributes.views[d])p.id===a&&(this._title=p.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(d=>this._onDidChangeData.fire({message:!1,element:d}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(d=>this._onDidChangeData.fire({message:!1,element:d})));let i,u;this._register(_.Event.debounce(this._onDidChangeData.event,(d,p)=>(d||(d={message:!1,elements:[]}),p.element!==!1&&(i||(i=new Promise(D=>u=D),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(p.element)?d.elements.push(...p.element):d.elements.push(p.element)),p.message&&(d.message=!0),d),200,!0)(({message:d,elements:p})=>{p.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const D=u;return i=null,this.refresh(p).then(()=>D())})),d&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,n.isUndefinedOrNull)(a))}getChildren(a){const f=a?this.getExtensionElement(a):void 0;if(a&&!f)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);const v=this.getChildrenNodes(a);return(v?Promise.resolve(v):this.fetchChildrenNodes(f)).then(t=>t.map(r=>r.item))}getExtensionElement(a){return this.elements.get(a)}reveal(a,f){f=f||{select:!0,focus:!1};const v=(0,n.isUndefinedOrNull)(f.select)?!0:f.select,t=(0,n.isUndefinedOrNull)(f.focus)?!1:f.focus,r=(0,n.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(s=>this.resolveTreeNode(a,s[s.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:s.map(u=>u.item)},{select:v,focus:t,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:t,expand:r})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,f){const v=this.getExtensionElement(a);v&&(f?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(a){(0,C.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,f){const v=this.getExtensionElement(f);if(!!v)return(0,E.asPromise)(()=>this.dndController?.onDrop(a,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,f){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(a);if(v){const t=this.nodes.get(v);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,v,f)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(f=>f?this.resolveUnknownParentChain(f).then(v=>this.resolveTreeNode(f,v[v.length-1]).then(t=>(v.push(t),v))):Promise.resolve([]))}resolveParent(a){const f=this.nodes.get(a);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,f){const v=this.nodes.get(a);return v?Promise.resolve(v):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>this.createHandle(a,t,f,!0)).then(t=>this.getChildren(f?f.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(a){if(a){let f;if(typeof a=="string"){const v=this.getExtensionElement(a);f=v?this.nodes.get(v):void 0}else f=a;return f&&f.children||null}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const f=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=a?this.nodes.get(a):void 0,t=await this.dataProvider.getChildren(a);if(f.token.isCancellationRequested)return[];const r=await Promise.all((0,C.coalesce)(t||[]).map(async s=>{const i=await this.dataProvider.getTreeItem(s);return i&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(s,i,v):null}));return f.token.isCancellationRequested?[]:(0,C.coalesce)(r)}finally{f.dispose()}}refresh(a){if(a.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(a);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const f=new Set,v=a.map(r=>this.nodes.get(r));for(const r of v)if(r&&!f.has(r.item.handle)){let s=r;for(;s&&s.parent&&v.findIndex(i=>s&&s.parent&&i&&i.item.handle===s.parent.item.handle)===-1;){const i=this.elements.get(s.parent.item.handle);s=i?this.nodes.get(i):void 0}s&&!s.parent&&f.add(r.item.handle)}const t=[];return f.forEach(r=>{const s=this.elements.get(r);if(s){const i=this.nodes.get(s);i&&(!i.parent||!f.has(i.parent.item.handle))&&t.push(r)}}),t}refreshHandles(a){const f={};return Promise.all(a.map(v=>this.refreshNode(v).then(t=>{t&&(f[v]=t.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(a){const f=this.getExtensionElement(a);if(f){const v=this.nodes.get(f);if(v)return this.clearChildren(f),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(t=>{if(t){const r=this.createTreeNode(f,t,v.parent);return this.updateNodeCache(f,r,v,v.parent),v.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,f,v){const t=this.createTreeNode(a,f,v);if(f.id&&this.elements.has(t.item.handle))throw new Error((0,m.localize)(7,null,f.id));return this.addNodeToCache(a,t),this.addNodeToParentCache(t,v),t}getTooltip(a){return k.MarkdownString.isMarkdownString(a)?l.MarkdownString.from(a):a}getCommand(a,f){return f?this.commands.toInternal(f,a):void 0}createTreeNode(a,f,v){const t=new I.DisposableStore,r=this.createHandle(a,f,v),s=this.getLightIconPath(f);return{item:{handle:r,parentHandle:v?v.item.handle:void 0,label:g(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(t,f.command),contextValue:f.contextValue,icon:s,iconDark:this.getDarkIconPath(f)||s,themeIcon:this.getThemeIcon(f),collapsibleState:(0,n.isUndefinedOrNull)(f.collapsibleState)?k.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:v,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(a){return a.iconPath instanceof k.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:f,label:v,resourceUri:t},r,s){if(f)return`${w.ID_HANDLE_PREFIX}/${f}`;const i=g(v,this.extension),u=r?r.item.handle:w.LABEL_HANDLE_PREFIX;let d=i?i.label:t?(0,R.basename)(t):"";d=d.indexOf("/")!==-1?d.replace("/","//"):d;const p=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,D=this.getChildrenNodes(r)||[];let T,o=0;do{if(T=`${u}/${o}:${d}`,s||!this.elements.has(T)||p===T)break;o++}while(o<=D.length);return T}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof k.ThemeIcon))return typeof a.iconPath=="string"||S.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof k.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return S.URI.isUri(a)?a:S.URI.file(a)}addNodeToCache(a,f){this.elements.set(f.item.handle,a),this.nodes.set(a,f)}updateNodeCache(a,f,v,t){this.elements.delete(f.item.handle),this.nodes.delete(a),f.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(a,f);const r=this.getChildrenNodes(t)||[],s=r.filter(i=>i.item.handle===v.item.handle)[0];s&&r.splice(r.indexOf(s),1,f)}addNodeToParentCache(a,f){f?(f.children||(f.children=[]),f.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const f=this.nodes.get(a);if(f){if(f.children)for(const v of f.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}f.children=void 0}}else this.clearAll()}clear(a){const f=this.nodes.get(a);if(f){if(f.children)for(const v of f.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}this.nodes.delete(a),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}w.LABEL_HANDLE_PREFIX="0",w.ID_HANDLE_PREFIX="1"}),define(be[182],Ee([0,1,15,3,6,10,68,9,99,73]),function(ee,e,m,R,S,_,I,y,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends S.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.root=new I.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const h=this.diff[this.diff.length-1];if(h&&l[0]===1){if(h[0]===1&&h[1].extId===l[1].extId){(0,E.applyTestItemUpdate)(h[1],l[1]);return}if(h[0]===0&&h[1].item.extId===l[1].extId){(0,E.applyTestItemUpdate)(h[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,h){const c=this.tree.get(l);if(!!c){if((c.expandLevels===void 0||h>c.expandLevels)&&(c.expandLevels=h),c.expand===1){const g=this.resolveChildren(c);return g.isOpen()?this.expandChildren(c,h-1):g.wait().then(()=>this.expandChildren(c,h-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,h-1)):this.expandChildren(c,h-1)}}dispose(){for(const l of this.tree.values())(0,I.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,h){switch(h.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(k.TestId.joinToString(l.fullId,h.id));break;case 0:this.upsertItem(h.item,l);break;case 4:for(const w of h.ops)this.onTestItemEvent(l,w);break;case 3:const{key:c,value:g}=h,b=l.fullId.toString();switch(c){case"canResolveChildren":this.updateExpandability(l);break;case"range":this.pushDiff([1,{extId:b,item:{range:y.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:b,item:{error:y.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:b,item:{[c]:g??null}}]);break}break;default:(0,_.assertNever)(h)}}upsertItem(l,h){if(!(l instanceof I.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const c=k.TestId.fromExtHostTestItem(l,this.root.id,h?.actual),g=(0,I.getPrivateApiFor)(l);g.parent&&g.parent!==h?.actual&&g.parent.children.delete(l.id);let b=this.tree.get(c.toString());if(!b){b={fullId:c,actual:l,parent:h?c.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},this.tree.set(b.fullId.toString(),b),this.setItemParent(l,h),this.pushDiff([0,{parent:b.parent&&b.parent.toString(),controllerId:this.controllerId,expand:b.expand,item:y.TestItem.from(l)}]),this.connectItemAndChildren(l,b,h);return}if(b.actual===l){this.connectItem(l,b,h);return}const w=b.actual.children,P=b.actual,a=(0,I.diffTestItems)(P,l);(0,I.getPrivateApiFor)(P).listener=void 0,b.actual=l,b.expand=0;for(const[f,v]of a)this.onTestItemEvent(b,{op:3,key:f,value:v});this.connectItemAndChildren(l,b,h);for(const f of w)l.children.get(f.id)||this.removeItem(k.TestId.joinToString(c,f.id))}setItemParent(l,h){(0,I.getPrivateApiFor)(l).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(l,h,c){this.setItemParent(l,c);const g=(0,I.getPrivateApiFor)(l);g.parent=c?.actual,g.listener=b=>this.onTestItemEvent(h,b),this.updateExpandability(h)}connectItemAndChildren(l,h,c){this.connectItem(l,h,c);for(const g of l.children)this.upsertItem(g,h)}updateExpandability(l){let h;this._resolveHandler?l.resolveBarrier?h=l.resolveBarrier.isOpen()?3:2:h=l.actual.canResolveChildren?1:0:h=0,h!==l.expand&&(l.expand=h,this.pushDiff([1,{extId:l.fullId.toString(),expand:h}]),h===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,h){if(h<0)return;const c=[];for(const g of l.actual.children){const b=this.expand(k.TestId.joinToString(l.fullId,g.id),h);(0,m.isThenable)(b)&&c.push(b)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const b=new m.Barrier;return b.open(),b}l.expand=2,this.pushExpandStateUpdate(l);const h=l.resolveBarrier=new m.Barrier,c=b=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=b.stack||b.message||String(b))};let g;try{g=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(b){c(b)}return(0,m.isThenable)(g)?g.catch(c).then(()=>{h.open(),this.updateExpandability(l)}):(h.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const h=this.tree.get(l);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const c=[h];for(;c.length;){const g=c.pop();if(!!g){(0,I.getPrivateApiFor)(g.actual).listener=void 0,this.tree.delete(g.fullId.toString());for(const b of g.actual.children)c.push(this.tree.get(k.TestId.joinToString(g.fullId,b.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=n}),define(be[183],Ee([0,1,4,151]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(R.IEnvironmentService)}),define(be[184],Ee([0,1,26,3,14]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class _{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=_;class I{constructor(n){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let C of n.activationEvents)C==="onUri"&&(C=`onUri:${m.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(n)}}keepOnly(n){const C=new Set;n.forEach(l=>C.add(m.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>C.has(m.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,C){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const l=I._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(l.map(h=>h.identifier)),C.length>0){const h=new Set;C.forEach(c=>h.add(m.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!h.has(m.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new _(l)}static _findLoopingExtensions(n){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(b){this._nodesSet.has(b)||(this._nodesSet.add(b),this._nodesArr.push(b))}addArc(b,w){this.addNode(b),this.addNode(w),this._arcs.has(b)?this._arcs.get(b).push(w):this._arcs.set(b,[w])}getArcs(b){return this._arcs.has(b)?this._arcs.get(b):[]}hasOnlyGoodArcs(b,w){const P=C.getArcs(b);for(let a=0;a<P.length;a++)if(!w.has(P[a]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let b of n){const w=m.ExtensionIdentifier.toKey(b.identifier);if(l.set(w,b),b.extensionDependencies)for(let P of b.extensionDependencies){const a=m.ExtensionIdentifier.toKey(P);C.addArc(w,a)}}let h=new Set;C.getNodes().filter(b=>C.getArcs(b).length===0).forEach(b=>h.add(b));let c=C.getNodes().filter(b=>!h.has(b)),g;do{g=!1;for(let b=0;b<c.length;b++){const w=c[b];C.hasOnlyGoodArcs(w,h)&&(c.splice(b,1),b--,h.add(w),g=!0)}}while(g);return c.map(b=>l.get(b))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const C=this._activationMap.get(n);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const C=this._extensionsMap.get(m.ExtensionIdentifier.toKey(n));return C||void 0}}e.ExtensionDescriptionRegistry=I;var y;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(y||(y={}));function E(k,n){const C=k.isBuiltin?0:k.isUnderDevelopment?2:1,l=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(C!==l)return C-l;const h=S.posix.basename(k.extensionLocation.path),c=S.posix.basename(n.extensionLocation.path);return h<c?-1:h>c?1:0}}),define(be[185],Ee([0,1,24]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function _(y){const E=m.VSBuffer.alloc(1);switch(y){case 0:E.writeUInt8(1,0);break;case 1:E.writeUInt8(2,0);break;case 2:E.writeUInt8(3,0);break}return E}e.createMessageOfType=_;function I(y,E){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return E===0;case 2:return E===1;case 3:return E===2;default:return!1}}e.isMessageOfType=I}),define(be[30],Ee([0,1,3,2,4,26,152]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new _.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class y{constructor(P){this.dependency=P}}e.MissingExtensionDependency=y;var E;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(P,a,f,v){this.codeLoadingTime=P,this.activateCallTime=a,this.activateResolvedTime=f,this.activationReason=v}}e.ActivationTimes=k;class n{constructor(P,a){this.description=P,this.value=a}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var C;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function l(w){w.enableProposedApi||h(w)}e.checkProposedApiEnabled=l;function h(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=h;function c(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=c;function g(w,P){return{identifier:new _.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!P,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid}}e.toExtensionDescription=g;class b{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(P){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(P){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(P){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(P){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(P,a){return Promise.resolve()}_onWillActivateExtension(P){}_onDidActivateExtension(P,a,f,v,t){}_onDidActivateExtensionError(P,a){}_onExtensionRuntimeError(P,a){}_onExtensionHostExit(P){}}e.NullExtensionService=b}),define(be[186],Ee([0,1,26,30,16]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const _=Promise.resolve(void 0);class I{constructor(c,g,b,w){this.startup=c,this.codeLoadingTime=g,this.activateCallTime=b,this.activateResolvedTime=w}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class y{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,g){return c===-1||g===-1?-1:g-c}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class E{constructor(c,g,b,w,P,a){this.activationFailed=c,this.activationFailedError=g,this.activationTimes=b,this.module=w,this.exports=P,this.subscriptions=a}}e.ActivatedExtension=E;class k extends E{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class n extends E{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class C extends E{constructor(c){super(!0,c,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=C;let l=class{constructor(c,g,b,w,P){this._logService=P,this._registry=c,this._resolvedExtensionsSet=new Set,g.forEach(a=>this._resolvedExtensionsSet.add(m.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,b.forEach(a=>this._hostExtensionsMap.set(m.ExtensionIdentifier.toKey(a),a)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const g=m.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(g)}getActivatedExtension(c){const g=m.ExtensionIdentifier.toKey(c),b=this._activatedExtensions.get(g);if(!b)throw new Error("Extension `"+c.value+"` is not known or not activated");return b}activateByEvent(c,g){if(this._alreadyActivatedEvents[c])return _;const b=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(b.map(w=>({id:w.identifier,reason:{startup:g,extensionId:w.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,g){const b=this._registry.getExtensionDescription(c);if(!b)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:b.identifier,reason:g}])}_handleActivateRequest(c,g,b){if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(c.id))){g[m.ExtensionIdentifier.toKey(c.id)]=c;return}const w=this._registry.getExtensionDescription(c.id);if(!w){const f=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,f,new R.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(c.id),new C(f));return}const P=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let a=!0;for(let f=0,v=P.length;f<v;f++){const t=P[f];if(this._resolvedExtensionsSet.has(m.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(m.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const d=w.displayName||w.identifier.value,p=this._registry.getExtensionDescription(t),D=p&&p.displayName||t,T=new Error(`Cannot activate the '${d}' extension because its dependency '${D}' failed to activate`);T.detail=r.activationFailedError,this._host.onExtensionActivationError(w.identifier,T,null),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(w.identifier),new C(T));return}if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(t))){a=!1,g[m.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(m.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){a=!1,g[m.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:c.reason};continue}const i=w.displayName||w.identifier.value,u=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,u,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(w.identifier),new C(u));return}a?g[m.ExtensionIdentifier.toKey(w.identifier)]=c:b.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(P=>!this._activatedExtensions.has(m.ExtensionIdentifier.toKey(P.id))),c.length===0))return Promise.resolve(void 0);const g=Object.create(null),b=[];for(let P=0,a=c.length;P<a;P++)this._handleActivateRequest(c[P],g,b);for(let P=0,a=b.length;P<a;P++){const f=m.ExtensionIdentifier.toKey(b[P].id);g[f]&&delete g[f]}const w=Object.keys(g).map(P=>g[P]);return b.length===0?Promise.all(w.map(P=>this._activateExtension(P.id,P.reason))).then(P=>{}):this._activateExtensions(w).then(P=>this._activateExtensions(b))}_activateExtension(c,g){const b=m.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(b))return Promise.resolve(void 0);const w=this._activatingExtensions.get(b);if(w)return w;const P=this._host.actualActivateExtension(c,g).then(void 0,a=>{const f=new Error;return a&&a.name&&(f.name=a.name),a&&a.message?f.message=`Activating extension '${c.value}' failed: ${a.message}.`:f.message=`Activating extension '${c.value}' failed: ${a}.`,a&&a.stack&&(f.stack=a.stack),this._host.onExtensionActivationError(c,f,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(a),new C(a)}).then(a=>{this._activatedExtensions.set(b,a),this._activatingExtensions.delete(b)});return this._activatingExtensions.set(b,P),P}};l=ze([Ve(4,S.ILogService)],l),e.ExtensionsActivator=l}),define(be[187],Ee([0,1,12]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,I)=>{this._actualOk=_,this._actualErr=I,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,m.onUnexpectedError)(_))}then(_,I){return this._ensureActual().then(_,I)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=R}),define(be[103],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(E,k){this._proxyIdentifierBrand=void 0,this.isMain=E,this.sid=k,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const R=[];function S(y){const E=new m(!0,y);return R[E.nid]=E,E}e.createMainContextProxyIdentifier=S;function _(y){const E=new m(!1,y);return R[E.nid]=E,E}e.createExtHostContextProxyIdentifier=_;function I(y){return R[y].sid}e.getStringIdentifierForProxy=I}),define(be[5],Ee([0,1,57,2,103]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var _;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(_=e.UIKind||(e.UIKind={}));var I;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(I=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(E=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(a){a.name="$ident";function f(t,r){return Object.defineProperty(t,a.name,{value:r,enumerable:!0}),t}a.mixin=f;function v(t){return t[a.name]}a.of=v})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(f){return f._id=h._n++,f}}e.IdObject=h,h._n=0;var c;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var b;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(b=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(a){if(a&&a.edits)for(const f of a.edits)typeof f.resource=="object"?f.resource=R.URI.revive(f.resource):(f.newUri=R.URI.revive(f.newUri),f.oldUri=R.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,m.revive)(f.metadata));return a}e.reviveWorkspaceEditDto=w;var P;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(P=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,S.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,S.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,S.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,S.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,S.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,S.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,S.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,S.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[74],Ee([0,1,5,3,4]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class _{constructor(y){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=y.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(y){this._onDidChangePassword.fire(y)}get(y,E){return this._proxy.$getPassword(y,E)}store(y,E,k){return this._proxy.$setPassword(y,E,k)}delete(y,E){return this._proxy.$deletePassword(y,E)}}e.ExtHostSecretState=_,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")}),define(be[75],Ee([0,1,4,16,5,13]),function(ee,e,m,R,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(E,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(S.MainContext.MainThreadTelemetry)}report(E,k,n){const C=this.getUsageKey(E,k);this._reportedUsages.has(C)||(this._reportedUsages.add(C),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:E}))}getUsageKey(E,k){return`${E}-${k.identifier.value}`}};I=ze([Ve(0,_.IExtHostRpcService),Ve(1,R.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(y,E,k){}})}),define(be[188],Ee([0,1,3,5,7,26]),function(ee,e,m,R,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,k,n,C={}){const l=_.ExtensionIdentifier.toKey(E.identifier),h=this._inFlightRequests.get(l)||[],c=[...n].sort().join(" ");let g=h.find(b=>b.scopes===c);if(g)return g.result;{const b=this._getSession(E,l,k,n,C);g={scopes:c,result:b},h.push(g),this._inFlightRequests.set(l,h);try{await b}finally{const w=h.findIndex(P=>P.scopes===c);w>-1&&(h.splice(w),this._inFlightRequests.set(l,h))}return b}}async _getSession(E,k,n,C,l={}){await this._proxy.$ensureProvider(n);const h=E.displayName||E.name;return this._proxy.$getSession(n,C,k,h,l)}async removeSession(E,k){const n=this._authenticationProviders.get(E);return n?n.provider.removeSession(k):this._proxy.$removeSession(E,k)}registerAuthenticationProvider(E,k,n,C){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:k,provider:n,options:C??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===E)||this._providers.push({id:E,label:k});const l=n.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(E,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,k,C?.supportsMultipleAccounts??!1),new S.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(E);const h=this._providers.findIndex(c=>c.id===E);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,k){const n=this._authenticationProviders.get(E);if(n)return Promise.resolve(n.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,k){const n=this._authenticationProviders.get(E);if(n)return Promise.resolve(n.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,k){const n=this._authenticationProviders.get(E);if(n)return Promise.resolve(n.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,k){return this._onDidChangeSessions.fire({provider:{id:E,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(be[189],Ee([0,1,5,13,9]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(y,E){this._extHostDocumentsAndEditors=E,this._proxy=y.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(y){const E=S.WorkspaceEdit.from(y,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(E)}};_=ze([Ve(0,R.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(be[190],Ee([0,1,5]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(_){const I=_.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(y){return I.$writeText(y)}})}}e.ExtHostClipboard=R}),define(be[48],Ee([0,1,10,7,9,23,5,17,16,57,31,38,2,6,4,13]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let b=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(I.MainContext.MainThreadCommands),this._logService=r,this.converter=new w(this,s=>{const i=this._apiCommands.get(s);return i?.result===a.Void?i:void 0},r),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,_.cloneAndChange)(s,function(i){if(n.Range.isIRange(i))return S.Range.to(i);if(C.Position.isIPosition(i))return S.Position.to(i);if(n.Range.isIRange(i.range)&&l.URI.isUri(i.uri))return S.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...s)=>{const i=t.args.map((d,p)=>{if(!d.validate(s[p]))throw new Error(`Invalid argument '${d.name}' when running '${t.id}', received: ${s[p]}`);return d.convert(s[p])}),u=await this.executeCommand(t.internalId,...i);return t.result.convert(u,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,s,i,u){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:s,thisArg:i,description:u}),t&&this._proxy.$registerCommand(r),new R.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,s){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const i=(0,_.cloneAndChange)(r,function(u){if(u instanceof R.Position)return S.Position.from(u);if(u instanceof R.Range)return S.Range.from(u);if(u instanceof R.Location)return S.location.from(u);if(R.NotebookRange.isNotebookRange(u))return S.NotebookRange.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,i,s);return(0,k.revive)(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw u}}}async _executeContributedCommand(t,r){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:i,thisArg:u,description:d}=s;if(d)for(let p=0;p<d.args.length;p++)try{(0,m.validateConstraint)(r[p],d.args[p].constraint)}catch(D){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${d.args[p].name}' - ${d.args[p].description}`)}try{return await i.apply(u,r)}catch(p){if(t===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...r);D&&(t=D.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(s=>this._argumentProcessors.reduce((i,u)=>u.processArgument(i),s)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(s=>s[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,s]of this._commands){let{description:i}=s;i&&(t[r]=i)}return Promise.resolve(t)}};b=ze([Ve(0,g.IExtHostRpcService),Ve(1,E.ILogService)],b),e.ExtHostCommands=b,e.IExtHostCommands=(0,c.createDecorator)("IExtHostCommands");class w{constructor(t,r,s){this._commands=t,this._lookupApiCommand=r,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const i=this._lookupApiCommand(t.command);if(i)s.id=i.internalId,s.arguments=i.args.map((u,d)=>u.convert(t.arguments&&t.arguments[d]));else if((0,y.isNonEmptyArray)(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),r.add((0,h.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),s.$ident=u,s.id=this.delegatingCommandId,s.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return s}fromInternal(t){const r=I.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class P{constructor(t,r,s,i){this.name=t,this.description=r,this.validate=s,this.convert=i}optional(){return new P(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new P(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",v=>l.URI.isUri(v),v=>v),P.Position=new P("position","A position in a text document",v=>R.Position.isPosition(v),S.Position.from),P.Range=new P("range","A range in a text document",v=>R.Range.isRange(v),S.Range.from),P.Selection=new P("selection","A selection in a text document",v=>R.Selection.isSelection(v),S.Selection.from),P.Number=new P("number","",v=>typeof v=="number",v=>v),P.String=new P("string","",v=>typeof v=="string",v=>v),P.CallHierarchyItem=new P("item","A call hierarchy item",v=>v instanceof R.CallHierarchyItem,S.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",v=>v instanceof R.TypeHierarchyItem,S.TypeHierarchyItem.from);class a{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=a,a.Void=new a("no result",v=>v);class f{constructor(t,r,s,i,u){this.id=t,this.internalId=r,this.description=s,this.args=i,this.result=u}}e.ApiCommand=f}),define(be[191],Ee([0,1,9,7,61,48,17,89]),function(ee,e,m,R,S,_,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(m.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,h)=>{if((0,I.isFalsyOrEmpty)(l))return;class c extends R.SymbolInformation{static to(b){const w=new c(b.name,m.SymbolKind.to(b.kind),b.containerName||"",new R.Location(h[0],m.Range.to(b.range)));return w.detail=b.detail,w.range=w.location.range,w.selectionRange=m.Range.to(b.selectionRange),w.children=b.children?b.children.map(c.to):[],w}}return l.map(c.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(m.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(m.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(h=>R.Position.isPosition(h)),l=>l.map(m.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(h=>{let c;for(const g of h.reverse())c=new R.SelectionRange(m.Range.to(g),c);return c}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const h=[];if(Array.isArray(l))for(let c of l)h.push(...c[1].map(m.WorkspaceSymbol.to));return h})),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return m.WorkspaceEdit.to(l)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(m.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=(0,y.decodeSemanticTokensDto)(l);if(h.type==="full")return new R.SemanticTokens(h.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=(0,y.decodeSemanticTokensDto)(l);if(h.type==="full")return new R.SemanticTokens(h.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,h,c)=>{if(!l)return new R.CompletionList([]);const g=l.suggestions.map(b=>m.CompletionItem.to(b,c));return new R.CompletionList(g,l.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return m.SignatureHelp.to(l)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,h,c)=>n(g=>new R.CodeLens(m.Range.to(g.range),g.command&&c.fromInternal(g.command)))(l))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.Range.isRange(l),l=>R.Selection.isSelection(l)?m.Selection.from(l):m.Range.from(l)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,h,c)=>n(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(g.command)}else{const b=new R.CodeAction(g.title,g.kind?new R.CodeActionKind(g.kind):void 0);return g.edit&&(b.edit=m.WorkspaceEdit.to(g.edit)),g.command&&(b.command=c.fromInternal(g.command)),b.isPreferred=g.isPreferred,b}})(l))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(h=>new R.ColorInformation(m.Range.to(h.range),m.Color.to(h.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",l=>l instanceof R.Color,m.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:m.Range.from(l.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(m.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(m.InlayHint.to))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(h=>m.NotebookExclusiveDocumentPattern.to(h))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(m.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to)))];class k{static register(h){E.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=k;function n(l){return h=>{if(Array.isArray(h))return h.map(l)}}function C(l){if(!Array.isArray(l))return;const h=[];for(const c of l)S.isLocationLink(c)?h.push(m.DefinitionLink.to(c)):h.push(m.location.to(c));return h}}),define(be[192],Ee([0,1,15,52,3,6,2,61,26,9,7,5]),function(ee,e,m,R,S,_,I,y,E,k,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(h,c,g){const b=h.getProxy(C.MainContext.MainThreadComments);class w{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,c.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const u=this._commentControllers.get(i.handle);return u||i}else if(i&&i.$mid===7){const u=this._commentControllers.get(i.commentControlHandle);if(!u)return i;const d=u.getCommentThread(i.commentThreadHandle);return d||i}else if(i&&i.$mid===8){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const d=u.getCommentThread(i.thread.commentThreadHandle);return d?{thread:d,text:i.text}:i}else if(i&&i.$mid===9){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const d=u.getCommentThread(i.thread.commentThreadHandle);if(!d)return i;let p=i.commentUniqueId,D=d.getCommentByUniqueId(p);return D||i}else if(i&&i.$mid===10){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const d=u.getCommentThread(i.thread.commentThreadHandle);if(!d)return i;let p=i.text,D=i.commentUniqueId,T=d.getCommentByUniqueId(D);return T?(T.body=p,T):i}return i}})}createCommentController(i,u,d){const p=w.handlePool++,D=new a(i,p,u,d);this._commentControllers.set(D.handle,D);const T=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(i.identifier))||[];return T.push(D),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(i.identifier),T),D.value}$createCommentThreadTemplate(i,u,d){const p=this._commentControllers.get(i);!p||p.$createCommentThreadTemplate(u,d)}async $updateCommentThreadTemplate(i,u,d){const p=this._commentControllers.get(i);!p||p.$updateCommentThreadTemplate(u,d)}$deleteCommentThread(i,u){const d=this._commentControllers.get(i);d&&d.$deleteCommentThread(u)}$provideCommentingRanges(i,u,d){const p=this._commentControllers.get(i);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const D=g.getDocument(I.URI.revive(u));return(0,m.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(D,d)).then(T=>T?T.map(o=>k.Range.from(o)):void 0)}$toggleReaction(i,u,d,p,D){const T=this._commentControllers.get(i);return!T||!T.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const o=T.getCommentThread(u);if(o){const A=o.getCommentByUniqueId(p.uniqueIdInThread);if(T!==void 0&&A&&T.reactionHandler)return T.reactionHandler(A,t(D))}return Promise.resolve(void 0)})}dispose(){}}w.handlePool=0;class P{constructor(i,u,d,p,D,T,o){this._commentControllerHandle=u,this._id=d,this._uri=p,this._range=D,this._comments=T,this.handle=P._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputDisposables.value=new _.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),b.$createCommentThread(u,this.handle,this._id,this._uri,k.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=T,this._localDisposables.push({dispose:()=>{b.$deleteCommentThread(u,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(F){A.range=F},get comments(){return A.comments},set comments(F){A.comments=F},get collapsibleState(){return A.collapsibleState},set collapsibleState(F){A.collapsibleState=F},get canReply(){return A.canReply},set canReply(F){A.canReply=F},get contextValue(){return A.contextValue},set contextValue(F){A.contextValue=F},get label(){return A.label},set label(F){A.label=F},dispose:()=>{A.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new _.DisposableStore);const i=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),u={};i("range")&&(u.range=k.Range.from(this._range)),i("label")&&(u.label=this.label),i("contextValue")&&(u.contextValue=this.contextValue),i("comments")&&(u.comments=this._comments.map(d=>f(this,d,this._commentsMap))),i("collapsibleState")&&(u.collapseState=r(this._collapseState)),i("canReply")&&(u.canReply=this.canReply),this.modifications={},b.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(i){for(let u of this._commentsMap){let d=u[0],p=u[1];if(i===p)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}P._handlePool=0,ze([(0,R.debounce)(100)],P.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(i,u,d,p){this._extension=i,this._handle=u,this._id=d,this._label=p,this._threads=new Map,b.$registerCommentController(this.handle,d,p);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(T){D.options=T},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(T){D.commentingRangeProvider=T},get reactionHandler(){return D.reactionHandler},set reactionHandler(T){D.reactionHandler=T},createCommentThread(T,o,A){return D.createCommentThread(T,o,A).value},dispose:()=>{D.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{b.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,b.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,b.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,u,d,p){if(typeof i=="string"){const D=new P(this.id,this.handle,i,u,d,p,this._extension.identifier);return this._threads.set(D.handle,D),D}else{const D=new P(this.id,this.handle,void 0,i,u,d,this._extension.identifier);return this._threads.set(D.handle,D),D}}$createCommentThreadTemplate(i,u){const d=new P(this.id,this.handle,void 0,I.URI.revive(i),k.Range.to(u),[],this._extension.identifier);return d.collapsibleState=y.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(i,u){let d=this._threads.get(i);d&&(d.range=k.Range.to(u))}$deleteCommentThread(i){let u=this._threads.get(i);u&&u.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function f(s,i,u){let d=u.get(i);d||(d=++s.commentHandle,u.set(i,d));const p=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:d,body:k.MarkdownString.from(i.body),userName:i.author.name,userIconPath:p,label:i.label,commentReactions:i.reactions?i.reactions.map(D=>v(D)):void 0}}function v(s){return{label:s.label,iconPath:s.iconPath?k.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function t(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?I.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function r(s){if(s!==void 0)switch(s){case n.CommentThreadCollapsibleState.Expanded:return y.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return y.CommentThreadCollapsibleState.Collapsed}return y.CommentThreadCollapsibleState.Collapsed}return new w}e.createExtHostComments=l}),define(be[104],Ee([0,1,2,5,7,4,13,16,17,8,14]),function(ee,e,m,R,S,_,I,y,E,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class wn{constructor(h,c){this._logService=c,this._provider=new Map,this._proxy=h.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,c){const g=wn._handlePool++;this._provider.set(g,{provider:h,extensionId:c}),this._proxy.$registerDecorationProvider(g,c.value);const b=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(g,null);return}let P=(0,E.asArray)(w);if(P.length<=wn._maxEventSize){this._proxy.$onDidChange(g,P);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,P.length);const a=P.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),f=(0,E.groupBy)(a,(t,r)=>t.rank-r.rank||(0,k.compare)(t.uri.path,r.uri.path));let v=[];e:for(let t of f){let r;for(let s of t){let i=(0,n.dirname)(s.uri.path);if(r!==i&&(r=i,v.push(s.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(g,v)});return new S.Disposable(()=>{b?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(h,c,g){if(!this._provider.has(h))return Object.create(null);const b=Object.create(null),{provider:w,extensionId:P}=this._provider.get(h);return await Promise.all(c.map(async a=>{try{const{uri:f,id:v}=a,t=await Promise.resolve(w.provideFileDecoration(m.URI.revive(f),g));if(!t)return;try{S.FileDecoration.validate(t),b[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${P.value}': ${r}`)}}catch(f){this._logService.error(f)}})),b}};C._handlePool=0,C._maxEventSize=250,C=ze([Ve(0,I.IExtHostRpcService),Ve(1,y.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,_.createDecorator)("IExtHostDecorations")}),define(be[193],Ee([0,1,133,92,2,5,7,9,3,16,21]),function(ee,e,m,R,S,_,I,y,E,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(c,g,b,w,P){this._name=c,this._owner=g,this._maxDiagnosticsPerFile=b,this._proxy=w,this._onDidChangeDiagnostics=P,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,g){if(!c){this.clear();return}this._checkDisposed();let b=[];if(S.URI.isUri(c)){if(!g){this.delete(c);return}this._data.set(c,g.slice()),b=[c]}else if(Array.isArray(c)){b=[];let P;c=[...c].sort(C._compareIndexedTuplesByUri);for(const a of c){const[f,v]=a;if((!P||f.toString()!==P.toString())&&(P&&this._data.get(P).length===0&&this._data.delete(P),P=f,b.push(f),this._data.set(f,[])),v){const t=this._data.get(f);t&&t.push(...v)}else{const t=this._data.get(f);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(b),!this._proxy)return;const w=[];for(let P of b){let a=[];const f=this._data.get(P);if(f)if(f.length>this._maxDiagnosticsPerFile){a=[];const v=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of f)if(r.severity===v[t]&&a.push(y.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;a.push({severity:R.MarkerSeverity.Info,message:(0,m.localize)(0,null,f.length-this._maxDiagnosticsPerFile),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=f.map(v=>y.Diagnostic.from(v));w.push([P,a])}this._proxy.$changeMany(this._owner,w)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,g){this._checkDisposed();for(let b of this._data.keys())c.apply(g,[b,this.get(b),this])}get(c){this._checkDisposed();const g=this._data.get(c);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,g){return c[0].toString()<g[0].toString()?-1:c[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=C;let l=class Qt{constructor(c,g){this._logService=g,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:b=>b.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,Qt._mapper),this._proxy=c.getProxy(_.MainContext.MainThreadDiagnostics)}static _mapper(c){const g=new n.ResourceMap;for(const b of c)g.set(b,b);return{uris:Object.freeze(Array.from(g.values()))}}createDiagnosticCollection(c,g){const{_collections:b,_proxy:w,_onDidChangeDiagnostics:P,_logService:a}=this,f=new class{$changeMany(r,s){w.$changeMany(r,s),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,r,s.length===0?"CLEARING":s)}$clear(r){w.$clear(r),a.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,r)}dispose(){w.dispose()}};let v;if(!g)g="_generated_diagnostic_collection_name_#"+Qt._idPool++,v=g;else if(!b.has(g))v=g;else{this._logService.warn(`DiagnosticCollection with name '${g}' does already exist.`);do v=g+Qt._idPool++;while(b.has(v))}return new class extends C{constructor(){super(g,v,Qt._maxDiagnosticsPerFile,f,P);b.set(v,this)}dispose(){super.dispose(),b.delete(v)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const g=new Map,b=[];for(const w of this._collections.values())w.forEach((P,a)=>{let f=g.get(P.toString());typeof f=="undefined"&&(f=b.length,g.set(P.toString(),f),b.push([P,[]])),b[f][1]=b[f][1].concat(...a)});return b}}_getDiagnostics(c){let g=[];for(let b of this._collections.values())b.has(c)&&(g=g.concat(b.get(c)));return g}$acceptMarkersChange(c){if(!this._mirrorCollection){const g="_generated_mirror",b=new C(g,g,Qt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(g,b),this._mirrorCollection=b}for(const[g,b]of c)this._mirrorCollection.set(S.URI.revive(g),b.map(y.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=ze([Ve(1,k.ILogService)],l),e.ExtHostDiagnostics=l}),define(be[194],Ee([0,1,2,5]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(I){this._proxy=I.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(I){return this._proxy.$showOpenDialog(I).then(y=>y?y.map(E=>m.URI.revive(E)):void 0)}showSaveDialog(I){return this._proxy.$showSaveDialog(I).then(y=>y?m.URI.revive(y):void 0)}}e.ExtHostDialogs=S}),define(be[195],Ee([0,1,12,2,7,5,11,20,8]),function(ee,e,m,R,S,_,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(C,l,h){this._documentsAndEditors=l,this._logService=h,this._documentContentProviders=new Map,this._proxy=C.getProxy(_.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,l){if(Object.keys(I.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const h=k._handlePool++;this._documentContentProviders.set(h,l),this._proxy.$registerTextContentProvider(h,C);let c;return typeof l.onDidChange=="function"&&(c=l.onDidChange(g=>{if(g.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(h,g).then(b=>{if(!b&&typeof b!="string")return;const w=this._documentsAndEditors.getDocument(g);if(!w)return;const P=(0,E.splitLines)(b);if(!w.equalLines(P))return this._proxy.$onVirtualDocumentChange(g,b)},m.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(C,l){const h=this._documentContentProviders.get(C);return h?Promise.resolve(h.provideTextDocumentContent(R.URI.revive(l),y.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(be[196],Ee([0,1,3,6,2,5,98,9,10,23,7]),function(ee,e,m,R,S,_,I,y,E,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class C{constructor(h,c){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(_.MainContext.MainThreadDocuments),this._documentsAndEditors=c,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const b of g)this._onDidRemoveDocument.fire(b.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const b of g)this._onDidAddDocument.fire(b.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const c=this._documentsAndEditors.getDocument(h);if(c)return c}getDocument(h){const c=this.getDocumentData(h);if(!c?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return c.document}ensureDocumentData(h){const c=this._documentsAndEditors.getDocument(h);if(c)return Promise.resolve(c);let g=this._documentLoader.get(h.toString());return g||(g=this._proxy.$tryOpenDocument(h).then(b=>{this._documentLoader.delete(h.toString());const w=S.URI.revive(b);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(w))},b=>(this._documentLoader.delete(h.toString()),Promise.reject(b))),this._documentLoader.set(h.toString(),g)),g}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(c=>S.URI.revive(c))}$acceptModelModeChanged(h,c){const g=S.URI.revive(h),b=this._documentsAndEditors.getDocument(g);if(!b)throw new Error("unknown document");this._onDidRemoveDocument.fire(b.document),b._acceptLanguageId(c),this._onDidAddDocument.fire(b.document)}$acceptModelSaved(h){const c=S.URI.revive(h),g=this._documentsAndEditors.getDocument(c);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(h,c){const g=S.URI.revive(h),b=this._documentsAndEditors.getDocument(g);if(!b)throw new Error("unknown document");b._acceptIsDirty(c),this._onDidChangeDocument.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,c,g){const b=S.URI.revive(h),w=this._documentsAndEditors.getDocument(b);if(!w)throw new Error("unknown document");w._acceptIsDirty(g),w.onEvents(c);let P;c.isUndoing?P=n.TextDocumentChangeReason.Undo:c.isRedoing&&(P=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:w.document,contentChanges:c.changes.map(a=>({range:y.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:P}))}setWordDefinitionFor(h,c){(0,I.setWordDefinitionFor)(h,c)}}e.ExtHostDocuments=C}),define(be[49],Ee([0,1,41,3,6,2,4,5,98,13,102,9,16,21,11,55,112]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let P=class{constructor(f,v){this._extHostRpc=f,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const v=[],t=[],r=[];if(f.removedDocuments)for(const s of f.removedDocuments){const i=_.URI.revive(s),u=this._documents.get(i);u?.unref()&&(this._documents.delete(i),v.push(u.value))}if(f.addedDocuments)for(const s of f.addedDocuments){const i=_.URI.revive(s.uri);let u=this._documents.get(i);if(u&&i.scheme!==c.Schemas.vscodeNotebookCell&&i.scheme!==c.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);u||(u=new w(new E.ExtHostDocumentData(this._extHostRpc.getProxy(y.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(i,u),t.push(u.value)),u.ref()}if(f.removedEditors)for(const s of f.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&r.push(i)}if(f.addedEditors)for(const s of f.addedEditors){const i=_.URI.revive(s.documentUri);m.ok(this._documents.has(i),`document '${i}' does not exist`),m.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const u=this._documents.get(i).value,d=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(y.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>u.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(p=>C.Range.to(p)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,d)}f.newActiveEditor!==void 0&&(m.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,S.dispose)(v),(0,S.dispose)(r),f.removedDocuments&&this._onDidRemoveDocuments.fire(v),f.addedDocuments&&this._onDidAddDocuments.fire(t),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return f?v:v?.value}allEditors(){return[...this._editors.values()]}};P=ze([Ve(0,k.IExtHostRpcService),Ve(1,l.ILogService)],P),e.ExtHostDocumentsAndEditors=P,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[197],Ee([0,1,2,5,6,7,9,122,8,24]),function(ee,e,m,R,S,_,I,y,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const c=this._schemes.indexOf(h);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),c=[];let g,b,w=14,P=14;for(const a of h){let f=g?(0,E.commonPrefixLength)(g,a):0;for(f===0?b=1:b=P;f<a.length;f++)f+1===a.length?(w=P,P=9):P+=1,c.push([b,a.toUpperCase().charCodeAt(f),P]),c.push([b,a.toLowerCase().charCodeAt(f),P]),b=P;g=a,P=w}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new y.StateMachine(c)}}provideDocumentLinks(h){this._initStateMachine();const c=[],g=y.LinkComputer.computeLinks({getLineContent(b){return h.lineAt(b-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const b of g){const w=I.DocumentLink.to(b);w.target&&c.push(w)}return c}}class C{constructor(h,c){this._extHostLanguageFeatures=c,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,c,g,b={},w){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(P,g),this._enableProposedApi.set(P,w??!1);let a=2;b.isCaseSensitive&&(a+=1024),b.isReadonly&&(a+=2048),typeof g.copy=="function"&&(a+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&(a+=4),this._proxy.$registerFileSystemProvider(P,c,a).catch(v=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${c}`),console.error(v)});const f=g.onDidChangeFile(v=>{const t=[];for(const r of v){let{uri:s,type:i}=r;if(s.scheme!==c)continue;let u;switch(i){case _.FileChangeType.Changed:u=0;break;case _.FileChangeType.Created:u=1;break;case _.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:u})}this._proxy.$onFileSystemChange(P,t)});return(0,S.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(P),this._enableProposedApi.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(h,c){const{type:g,ctime:b,mtime:w,size:P,permissions:a}=h;return c?{type:g,ctime:b,mtime:w,size:P,permissions:a}:{type:g,ctime:b,mtime:w,size:P}}$stat(h,c){return Promise.resolve(this._getFsProvider(h).stat(m.URI.revive(c))).then(g=>C._asIStat(g,this._enableProposedApi.get(h)??!1))}$readdir(h,c){return Promise.resolve(this._getFsProvider(h).readDirectory(m.URI.revive(c)))}$readFile(h,c){return Promise.resolve(this._getFsProvider(h).readFile(m.URI.revive(c))).then(g=>k.VSBuffer.wrap(g))}$writeFile(h,c,g,b){return Promise.resolve(this._getFsProvider(h).writeFile(m.URI.revive(c),g.buffer,b))}$delete(h,c,g){return Promise.resolve(this._getFsProvider(h).delete(m.URI.revive(c),g))}$rename(h,c,g,b){return Promise.resolve(this._getFsProvider(h).rename(m.URI.revive(c),m.URI.revive(g),b))}$copy(h,c,g,b){const w=this._getFsProvider(h);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(m.URI.revive(c),m.URI.revive(g),b))}$mkdir(h,c){return Promise.resolve(this._getFsProvider(h).createDirectory(m.URI.revive(c)))}$watch(h,c,g,b){const w=this._getFsProvider(h).watch(m.URI.revive(g),b);this._watches.set(c,w)}$unwatch(h,c){const g=this._watches.get(c);g&&(g.dispose(),this._watches.delete(c))}$open(h,c,g){const b=this._getFsProvider(h);if(!b.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(b.open(m.URI.revive(c),g))}$close(h,c){const g=this._getFsProvider(h);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(c))}$read(h,c,g,b){const w=this._getFsProvider(h);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const P=k.VSBuffer.alloc(b);return Promise.resolve(w.read(c,g,P.buffer,0,b)).then(a=>P.slice(0,a))}$write(h,c,g,b){const w=this._getFsProvider(h);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(c,g,b.buffer,0,b.byteLength))}_getFsProvider(h){const c=this._fsProvider.get(h);if(!c){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return c}}e.ExtHostFileSystem=C}),define(be[76],Ee([0,1,5,62,7,24,4,13,47]),function(ee,e,m,R,S,_,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Ut{constructor(C,l){const h=C.getProxy(m.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return h.$stat(c).catch(Ut._handleError)},readDirectory(c){return h.$readdir(c).catch(Ut._handleError)},createDirectory(c){return h.$mkdir(c).catch(Ut._handleError)},async readFile(c){return h.$readFile(c).then(g=>g.buffer).catch(Ut._handleError)},writeFile(c,g){return h.$writeFile(c,_.VSBuffer.wrap(g)).catch(Ut._handleError)},delete(c,g){return h.$delete(c,{recursive:!1,useTrash:!1,...g}).catch(Ut._handleError)},rename(c,g,b){return h.$rename(c,g,{overwrite:!1,...b}).catch(Ut._handleError)},copy(c,g,b){return h.$copy(c,g,{overwrite:!1,...b}).catch(Ut._handleError)},isWritableFileSystem(c){const g=l.getCapabilities(c);if(typeof g=="number")return!(g&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new S.FileSystemError(String(C));if(C.name==="ENOPRO")throw S.FileSystemError.Unavailable(C.message);switch(C.name){case R.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(C.message);case R.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(C.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(C.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(C.message);case R.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(C.message);case R.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(C.message);default:throw new S.FileSystemError(C.message,C.name)}}};k=ze([Ve(0,y.IExtHostRpcService),Ve(1,E.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(be[198],Ee([0,1,2,48]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(I,y,E,k){this._extHostNotebooks=y,this._textDocumentsAndEditors=E,this._commands=k;const n=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",C=>!0,C=>C),new R.ApiCommandArgument("resource","Interactive resource Uri",C=>!0,C=>C),new R.ApiCommandArgument("controllerId","Notebook controller Id",C=>!0,C=>C),new R.ApiCommandArgument("title","Interactive editor title",C=>!0,C=>C)],new R.ApiCommandResult("Notebook and input URI",C=>{if(C.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(C.notebookEditorId);return{notebookUri:m.URI.revive(C.notebookUri),inputUri:m.URI.revive(C.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:m.URI.revive(C.notebookUri),inputUri:m.URI.revive(C.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(I,y,E,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:y,lines:[""],modeId:E,uri:I,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=S}),define(be[199],Ee([0,1,6,5]),function(ee,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(I){this._handlePool=0,this._proxy=I.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const y=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(y,I),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(y)})}}e.ExtHostLabelService=S}),define(be[200],Ee([0,1,2,23,9,7,5,8,31,17,10,119,6,89,54,66,56,12,3]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentSymbols(U,G){const X=this._documents.getDocument(U),re=await this._provider.provideDocumentSymbols(X,G);if(!(0,k.isFalsyOrEmpty)(re))return re[0]instanceof _.DocumentSymbol?re.map(S.DocumentSymbol.from):a._asDocumentSymbolTree(re)}static _asDocumentSymbolTree(U){U=U.slice(0).sort((re,q)=>{let ie=re.location.range.start.compareTo(q.location.range.start);return ie===0&&(ie=q.location.range.end.compareTo(re.location.range.end)),ie});const G=[],X=[];for(const re of U){const q={name:re.name||"!!MISSING: name!!",kind:S.SymbolKind.from(re.kind),tags:re.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:re.containerName,range:S.Range.from(re.location.range),selectionRange:S.Range.from(re.location.range),children:[]};for(;;){if(X.length===0){X.push(q),G.push(q);break}const ie=X[X.length-1];if(E.Range.containsRange(ie.range,q.range)&&!E.Range.equalsRange(ie.range,q.range)){ie.children&&ie.children.push(q),X.push(q);break}X.pop()}}return G}}class f{constructor(U,G,X){this._documents=U,this._commands=G,this._provider=X,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,G){const X=this._documents.getDocument(U),re=await this._provider.provideCodeLenses(X,G);if(!re||G.isCancellationRequested)return;const q=this._cache.add(re),ie=new l.DisposableStore;this._disposables.set(q,ie);const ge={cacheId:q,lenses:[]};for(let Re=0;Re<re.length;Re++)ge.lenses.push({cacheId:[q,Re],range:S.Range.from(re[Re].range),command:this._commands.toInternal(re[Re].command,ie)});return ge}async resolveCodeLens(U,G){const X=U.cacheId&&this._cache.get(...U.cacheId);if(!X)return;let re;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?re=X:re=await this._provider.resolveCodeLens(X,G),re||(re=X),G.isCancellationRequested)return;const q=U.cacheId&&this._disposables.get(U.cacheId[0]);if(!!q)return U.command=this._commands.toInternal(re.command??f._badCmd,q),U}releaseCodeLenses(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(je){return Array.isArray(je)?je.map(S.DefinitionLink.from):je?[S.DefinitionLink.from(je)]:[]}class t{constructor(U,G){this._documents=U,this._provider=G}async provideDefinition(U,G,X){const re=this._documents.getDocument(U),q=S.Position.to(G),ie=await this._provider.provideDefinition(re,q,X);return v(ie)}}class r{constructor(U,G){this._documents=U,this._provider=G}async provideDeclaration(U,G,X){const re=this._documents.getDocument(U),q=S.Position.to(G),ie=await this._provider.provideDeclaration(re,q,X);return v(ie)}}class s{constructor(U,G){this._documents=U,this._provider=G}async provideImplementation(U,G,X){const re=this._documents.getDocument(U),q=S.Position.to(G),ie=await this._provider.provideImplementation(re,q,X);return v(ie)}}class i{constructor(U,G){this._documents=U,this._provider=G}async provideTypeDefinition(U,G,X){const re=this._documents.getDocument(U),q=S.Position.to(G),ie=await this._provider.provideTypeDefinition(re,q,X);return v(ie)}}class u{constructor(U,G){this._documents=U,this._provider=G}async provideHover(U,G,X){const re=this._documents.getDocument(U),q=S.Position.to(G),ie=await this._provider.provideHover(re,q,X);if(!(!ie||(0,k.isFalsyOrEmpty)(ie.contents)))return ie.range||(ie.range=re.getWordRangeAtPosition(q)),ie.range||(ie.range=new _.Range(q,q)),S.Hover.from(ie)}}class d{constructor(U,G){this._documents=U,this._provider=G}async provideEvaluatableExpression(U,G,X){const re=this._documents.getDocument(U),q=S.Position.to(G),ie=await this._provider.provideEvaluatableExpression(re,q,X);if(ie)return S.EvaluatableExpression.from(ie)}}class p{constructor(U,G){this._documents=U,this._provider=G}async provideInlineValues(U,G,X,re){const q=this._documents.getDocument(U),ie=await this._provider.provideInlineValues(q,S.Range.to(G),S.InlineValueContext.to(X),re);if(Array.isArray(ie))return ie.map(ge=>S.InlineValue.from(ge))}}class D{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentHighlights(U,G,X){const re=this._documents.getDocument(U),q=S.Position.to(G),ie=await this._provider.provideDocumentHighlights(re,q,X);if(Array.isArray(ie))return ie.map(S.DocumentHighlight.from)}}class T{constructor(U,G){this._documents=U,this._provider=G}async provideLinkedEditingRanges(U,G,X){const re=this._documents.getDocument(U),q=S.Position.to(G),ie=await this._provider.provideLinkedEditingRanges(re,q,X);if(ie&&Array.isArray(ie.ranges))return{ranges:(0,k.coalesce)(ie.ranges.map(S.Range.from)),wordPattern:ie.wordPattern}}}class o{constructor(U,G){this._documents=U,this._provider=G}async provideReferences(U,G,X,re){const q=this._documents.getDocument(U),ie=S.Position.to(G),ge=await this._provider.provideReferences(q,ie,X,re);if(Array.isArray(ge))return ge.map(S.location.from)}}class A{constructor(U,G,X,re,q,ie,ge){this._documents=U,this._commands=G,this._diagnostics=X,this._provider=re,this._logService=q,this._extension=ie,this._apiDeprecation=ge,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(U,G,X,re){const q=this._documents.getDocument(U),ie=C.Selection.isISelection(G)?S.Selection.to(G):S.Range.to(G),ge=[];for(const Z of this._diagnostics.getDiagnostics(U))if(ie.intersection(Z.range)&&ge.push(Z)>A._maxCodeActionsPerFile)break;const Re={diagnostics:ge,only:X.only?new _.CodeActionKind(X.only):void 0,triggerKind:S.CodeActionTriggerKind.to(X.trigger)},We=await this._provider.provideCodeActions(q,ie,Re,re);if(!(0,k.isNonEmptyArray)(We)||re.isCancellationRequested)return;const ve=this._cache.add(We),Ye=new l.DisposableStore;this._disposables.set(ve,Ye);const z=[];for(let Z=0;Z<We.length;Z++){const ce=We[Z];!ce||(A._isCommand(ce)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),z.push({_isSynthetic:!0,title:ce.title,command:this._commands.toInternal(ce,Ye)})):(Re.only&&(ce.kind?Re.only.contains(ce.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${ce.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),z.push({cacheId:[ve,Z],title:ce.title,command:ce.command&&this._commands.toInternal(ce.command,Ye),diagnostics:ce.diagnostics&&ce.diagnostics.map(S.Diagnostic.from),edit:ce.edit&&S.WorkspaceEdit.from(ce.edit),kind:ce.kind&&ce.kind.value,isPreferred:ce.isPreferred,disabled:ce.disabled?.reason})))}return{cacheId:ve,actions:z}}async resolveCodeAction(U,G){const[X,re]=U,q=this._cache.get(X,re);if(!q||A._isCommand(q)||!this._provider.resolveCodeAction)return;const ie=await this._provider.resolveCodeAction(q,G)??q;return ie?.edit?S.WorkspaceEdit.from(ie.edit):void 0}releaseCodeActions(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}A._maxCodeActionsPerFile=1e3;class F{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentFormattingEdits(U,G,X){const re=this._documents.getDocument(U),q=await this._provider.provideDocumentFormattingEdits(re,G,X);if(Array.isArray(q))return q.map(S.TextEdit.from)}}class x{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentRangeFormattingEdits(U,G,X,re){const q=this._documents.getDocument(U),ie=S.Range.to(G),ge=await this._provider.provideDocumentRangeFormattingEdits(q,ie,X,re);if(Array.isArray(ge))return ge.map(S.TextEdit.from)}}class K{constructor(U,G){this._documents=U,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,G,X,re,q){const ie=this._documents.getDocument(U),ge=S.Position.to(G),Re=await this._provider.provideOnTypeFormattingEdits(ie,ge,X,re,q);if(Array.isArray(Re))return Re.map(S.TextEdit.from)}}class le{constructor(U,G){this._provider=U,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(U,G){const X=I.IdObject.mixin({symbols:[]}),re=await this._provider.provideWorkspaceSymbols(U,G);if((0,k.isNonEmptyArray)(re))for(const q of re){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const ie=I.IdObject.mixin(S.WorkspaceSymbol.from(q));this._symbolCache.set(ie._id,q),X.symbols.push(ie)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(U,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return U;const X=this._symbolCache.get(U._id);if(X){const re=await this._provider.resolveWorkspaceSymbol(X,G);return re&&(0,R.mixin)(U,S.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols(U){const G=this._resultCache.get(U);if(G){for(let[X,re]=G;X<=re;X++)this._symbolCache.delete(X);this._resultCache.delete(U)}}}class oe{constructor(U,G,X){this._documents=U,this._provider=G,this._logService=X}static supportsResolving(U){return typeof U.prepareRename=="function"}async provideRenameEdits(U,G,X,re){const q=this._documents.getDocument(U),ie=S.Position.to(G);try{const ge=await this._provider.provideRenameEdits(q,ie,X,re);return ge?S.WorkspaceEdit.from(ge):void 0}catch(ge){const Re=oe._asMessage(ge);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(ge)}}async resolveRenameLocation(U,G,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument(U),q=S.Position.to(G);try{const ie=await this._provider.prepareRename(re,q,X);let ge,Re;if(_.Range.isRange(ie)?(ge=ie,Re=re.getText(ie)):(0,n.isObject)(ie)&&(ge=ie.range,Re=ie.placeholder),!ge||!Re)return;if(ge.start.line>q.line||ge.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(ge),text:Re}}catch(ie){const ge=oe._asMessage(ie);return ge?{rejectReason:ge,range:void 0,text:void 0}:Promise.reject(ie)}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class V{constructor(U,G){this.resultId=U,this.tokens=G}}class W{constructor(U,G){this._documents=U,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(U,G,X){const re=this._documents.getDocument(U),q=G!==0?this._previousResults.get(G):null;let ie=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(re,q.resultId,X):await this._provider.provideDocumentSemanticTokens(re,X);return q&&this._previousResults.delete(G),ie?(ie=W._fixProvidedSemanticTokens(ie),this._send(W._convertToEdits(q,ie),ie)):null}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return W._isSemanticTokens(U)?W._isCorrectSemanticTokens(U)?U:new _.SemanticTokens(new Uint32Array(U.data),U.resultId):W._isSemanticTokensEdits(U)?W._isCorrectSemanticTokensEdits(U)?U:new _.SemanticTokensEdits(U.edits.map(G=>new _.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const G of U.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,G){if(!W._isSemanticTokens(G)||!U||!U.tokens)return G;const X=U.tokens,re=X.length,q=G.data,ie=q.length;let ge=0;const Re=Math.min(re,ie);for(;ge<Re&&X[ge]===q[ge];)ge++;if(ge===re&&ge===ie)return new _.SemanticTokensEdits([],G.resultId);let We=0;const ve=Re-ge;for(;We<ve&&X[re-We-1]===q[ie-We-1];)We++;return new _.SemanticTokensEdits([{start:ge,deleteCount:re-ge-We,data:q.subarray(ge,ie-We)}],G.resultId)}_send(U,G){if(W._isSemanticTokens(U)){const X=this._nextResultId++;return this._previousResults.set(X,new V(U.resultId,U.data)),(0,h.encodeSemanticTokensDto)({id:X,type:"full",data:U.data})}if(W._isSemanticTokensEdits(U)){const X=this._nextResultId++;return W._isSemanticTokens(G)?this._previousResults.set(X,new V(G.resultId,G.data)):this._previousResults.set(X,new V(U.resultId)),(0,h.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(U.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class L{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentRangeSemanticTokens(U,G,X){const re=this._documents.getDocument(U),q=await this._provider.provideDocumentRangeSemanticTokens(re,S.Range.to(G),X);return q?this._send(q):null}_send(U){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}e.DocumentRangeSemanticTokensAdapter=L;class Q{constructor(U,G,X,re,q){this._documents=U,this._commands=G,this._provider=X,this._apiDeprecation=re,this._extension=q,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}async provideCompletionItems(U,G,X,re){const q=this._documents.getDocument(U),ie=S.Position.to(G),ge=q.getWordRangeAtPosition(ie)||new _.Range(ie,ie),Re=ge.with({end:ie}),We=new b.StopWatch(!0),ve=await this._provider.provideCompletionItems(q,ie,re,S.CompletionContext.to(X));if(!ve||re.isCancellationRequested)return;const Ye=Array.isArray(ve)?new _.CompletionList(ve):ve,z=Q.supportsResolving(this._provider)?this._cache.add(Ye.items):this._cache.add([]),Z=new l.DisposableStore;this._disposables.set(z,Z);const ce=[],Ue={x:z,b:ce,a:{replace:S.Range.from(ge),insert:S.Range.from(Re)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let xe=0;xe<Ye.items.length;xe++){const et=Ye.items[xe],De=this._convertCompletionItem(et,[z,xe],Re,ge);ce.push(De)}return Ue}async resolveCompletionItem(U,G){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...U);if(!X)return;const re=await this._provider.resolveCompletionItem(X,G);if(!!re)return this._convertCompletionItem(re,U)}releaseCompletionItems(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,G,X,re){const q=this._disposables.get(G[0]);if(!q)throw Error("DisposableStore is missing...");const ie={x:G,a:U.label,b:U.kind!==void 0?S.CompletionItemKind.from(U.kind):void 0,n:U.tags&&U.tags.map(S.CompletionItemTag.from),c:U.detail,d:typeof U.documentation=="undefined"?void 0:S.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters,l:U.additionalTextEdits&&U.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(U.command,q)};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=U.textEdit.newText):typeof U.insertText=="string"?ie.h=U.insertText:U.insertText instanceof _.SnippetString&&(ie.h=U.insertText.value,ie.i|=4);let ge;return U.textEdit?ge=U.textEdit.range:U.range&&(ge=U.range),_.Range.isRange(ge)?ie.j=S.Range.from(ge):ge&&(!X?.isEqual(ge.inserting)||!re?.isEqual(ge.replacing))&&(ie.j={insert:S.Range.from(ge.inserting),replace:S.Range.from(ge.replacing)}),ie}}class O{constructor(U,G,X){this._documents=U,this._provider=G,this._commands=X,this._cache=new g.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(U,G,X,re){const q=this._documents.getDocument(U),ie=S.Position.to(G),ge=await this._provider.provideInlineCompletionItems(q,ie,X,re);if(!ge||re.isCancellationRequested)return;const Re=(0,n.isArray)(ge)?{items:ge}:ge,We=this._cache.add(Re.items);let ve;return{pid:We,items:Re.items.map((Ye,z)=>{let Z;return Ye.command&&(ve||(ve=new l.DisposableStore,this._disposables.set(We,ve)),Z=this._commands.toInternal(Ye.command,ve)),{text:Ye.text,range:Ye.range?S.Range.from(Ye.range):void 0,command:Z,idx:z}})}}disposeCompletions(U){this._cache.delete(U);const G=this._disposables.get(U);G&&G.clear(),this._disposables.delete(U)}handleDidShowCompletionItem(U,G){const X=this._cache.get(U,G);X&&j.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class j{constructor(){this._onDidShowCompletionItemEmitter=new P.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(U){let G=j.map.get(U);return G||(G=new j,j.map.set(U,G)),G}fireOnDidShowCompletionItem(U){this._onDidShowCompletionItemEmitter.fire(U)}}e.InlineCompletionController=j,j.map=new WeakMap;class he{constructor(U,G){this._documents=U,this._provider=G,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(U,G,X,re){const q=this._documents.getDocument(U),ie=S.Position.to(G),ge=this.reviveContext(X),Re=await this._provider.provideSignatureHelp(q,ie,re,ge);if(Re){const We=this._cache.add([Re]);return{...S.SignatureHelp.from(Re),id:We}}}reviveContext(U){let G;if(U.activeSignatureHelp){const X=S.SignatureHelp.to(U.activeSignatureHelp),re=this._cache.get(U.activeSignatureHelp.id,0);re?(G=re,G.activeSignature=X.activeSignature,G.activeParameter=X.activeParameter):G=X}return{...U,activeSignatureHelp:G}}releaseSignatureHelp(U){this._cache.delete(U)}}class ${constructor(U,G){this._documents=U,this._provider=G}async provideInlayHints(U,G,X){const re=this._documents.getDocument(U),q=await this._provider.provideInlayHints(re,S.Range.to(G),X);return q?{hints:q.map(S.InlayHint.from)}:void 0}}class ne{constructor(U,G){this._documents=U,this._provider=G,this._cache=new g.Cache("DocumentLink")}async provideLinks(U,G){const X=this._documents.getDocument(U),re=await this._provider.provideDocumentLinks(X,G);if(!(!Array.isArray(re)||re.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.filter(ne._validateLink).map(S.DocumentLink.from)};{const q=this._cache.add(re),ie={links:[],id:q};for(let ge=0;ge<re.length;ge++){if(!ne._validateLink(re[ge]))continue;const Re=S.DocumentLink.from(re[ge]);Re.cacheId=[q,ge],ie.links.push(Re)}return ie}}}static _validateLink(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,G){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...U);if(!X)return;const re=await this._provider.resolveDocumentLink(X,G);if(!(!re||!ne._validateLink(re)))return S.DocumentLink.from(re)}releaseLinks(U){this._cache.delete(U)}}class de{constructor(U,G){this._documents=U,this._provider=G}async provideColors(U,G){const X=this._documents.getDocument(U),re=await this._provider.provideDocumentColors(X,G);return Array.isArray(re)?re.map(ie=>({color:S.Color.from(ie.color),range:S.Range.from(ie.range)})):[]}async provideColorPresentations(U,G,X){const re=this._documents.getDocument(U),q=S.Range.to(G.range),ie=S.Color.to(G.color),ge=await this._provider.provideColorPresentations(ie,{document:re,range:q},X);if(!!Array.isArray(ge))return ge.map(S.ColorPresentation.from)}}class ye{constructor(U,G){this._documents=U,this._provider=G}async provideFoldingRanges(U,G,X){const re=this._documents.getDocument(U),q=await this._provider.provideFoldingRanges(re,G,X);if(!!Array.isArray(q))return q.map(S.FoldingRange.from)}}class Ne{constructor(U,G,X){this._documents=U,this._provider=G,this._logService=X}async provideSelectionRanges(U,G,X){const re=this._documents.getDocument(U),q=G.map(S.Position.to),ie=await this._provider.provideSelectionRanges(re,q,X);if(!(0,k.isNonEmptyArray)(ie))return[];if(ie.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ge=[];for(let Re=0;Re<q.length;Re++){const We=[];ge.push(We);let ve=q[Re],Ye=ie[Re];for(;;){if(!Ye.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(We.push(S.SelectionRange.from(Ye)),!Ye.parent)break;ve=Ye.range,Ye=Ye.parent}}return ge}}class Me{constructor(U,G){this._documents=U,this._provider=G,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(U,G,X){const re=this._documents.getDocument(U),q=S.Position.to(G),ie=await this._provider.prepareCallHierarchy(re,q,X);if(!ie)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ie)?ie.map(Re=>this._cacheAndConvertItem(ge,Re)):[this._cacheAndConvertItem(ge,ie)]}async provideCallsTo(U,G,X){const re=this._itemFromCache(U,G);if(!re)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(re,X);if(!!q)return q.map(ie=>({from:this._cacheAndConvertItem(U,ie.from),fromRanges:ie.fromRanges.map(ge=>S.Range.from(ge))}))}async provideCallsFrom(U,G,X){const re=this._itemFromCache(U,G);if(!re)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(re,X);if(!!q)return q.map(ie=>({to:this._cacheAndConvertItem(U,ie.to),fromRanges:ie.fromRanges.map(ge=>S.Range.from(ge))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,G){const X=this._cache.get(U),re=S.CallHierarchyItem.from(G,U,X.size.toString(36));return X.set(re._itemId,G),re}_itemFromCache(U,G){return this._cache.get(U)?.get(G)}}class $e{constructor(U,G){this._documents=U,this._provider=G,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(U,G,X){const re=this._documents.getDocument(U),q=S.Position.to(G),ie=await this._provider.prepareTypeHierarchy(re,q,X);if(!ie)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ie)?ie.map(Re=>this._cacheAndConvertItem(ge,Re)):[this._cacheAndConvertItem(ge,ie)]}async provideSupertypes(U,G,X){const re=this._itemFromCache(U,G);if(!re)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(re,X);if(!!q)return q.map(ie=>this._cacheAndConvertItem(U,ie))}async provideSubtypes(U,G,X){const re=this._itemFromCache(U,G);if(!re)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(re,X);if(!!q)return q.map(ie=>this._cacheAndConvertItem(U,ie))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,G){const X=this._cache.get(U),re=S.TypeHierarchyItem.from(G,U,X.size.toString(36));return X.set(re._itemId,G),re}_itemFromCache(U,G){return this._cache.get(U)?.get(G)}}class Xe{constructor(U,G){this.adapter=U,this.extension=G}}class qe{constructor(U,G,X,re,q,ie,ge){this._adapter=new Map,this._uriTransformer=G,this._proxy=U.getProxy(I.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=re,this._diagnostics=q,this._logService=ie,this._apiDeprecation=ge}_transformDocumentSelector(U){return(0,k.coalesce)((0,k.asArray)(U).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector(U){if(typeof U=="string")return{$serialized:!0,language:U};if(U)return{$serialized:!0,language:U.language,scheme:this._transformScheme(U.scheme),pattern:typeof U.pattern=="undefined"?void 0:S.GlobPattern.from(U.pattern),exclusive:U.exclusive}}_transformScheme(U){return this._uriTransformer&&typeof U=="string"?this._uriTransformer.transformOutgoingScheme(U):U}_createDisposable(U){return new _.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return qe._handlePool++}_withAdapter(U,G,X,re,q=!1){const ie=this._adapter.get(U);if(!ie)return Promise.resolve(re);if(ie.adapter instanceof G){let ge;ie.extension&&(ge=Date.now(),this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${G.name}'`));const Re=X(ie.adapter,ie.extension),We=ie.extension;return We&&Promise.resolve(Re).then(()=>this._logService.trace(`[${We.identifier.value}] provider DONE after ${Date.now()-ge}ms`),ve=>{q&&ve instanceof w.CancellationError||(this._logService.error(`[${We.identifier.value}] provider FAILED`),this._logService.error(ve))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(U,G){const X=this._nextHandle();return this._adapter.set(X,new Xe(U,G)),X}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,G,X,re){const q=this._addNewAdapter(new a(this._documents,X),U),ie=re&&re.label||qe._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(G),ie),this._createDisposable(q)}$provideDocumentSymbols(U,G,X){return this._withAdapter(U,a,re=>re.provideDocumentSymbols(m.URI.revive(G),X),void 0)}registerCodeLensProvider(U,G,X){const re=this._nextHandle(),q=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new Xe(new f(this._documents,this._commands.converter,X),U)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(G),q);let ie=this._createDisposable(re);if(q!==void 0){const ge=X.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(q));ie=_.Disposable.from(ie,ge)}return ie}$provideCodeLenses(U,G,X){return this._withAdapter(U,f,re=>re.provideCodeLenses(m.URI.revive(G),X),void 0)}$resolveCodeLens(U,G,X){return this._withAdapter(U,f,re=>re.resolveCodeLens(G,X),void 0)}$releaseCodeLenses(U,G){this._withAdapter(U,f,X=>Promise.resolve(X.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(U,G,X){const re=this._addNewAdapter(new t(this._documents,X),U);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDefinition(U,G,X,re){return this._withAdapter(U,t,q=>q.provideDefinition(m.URI.revive(G),X,re),[])}registerDeclarationProvider(U,G,X){const re=this._addNewAdapter(new r(this._documents,X),U);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDeclaration(U,G,X,re){return this._withAdapter(U,r,q=>q.provideDeclaration(m.URI.revive(G),X,re),[])}registerImplementationProvider(U,G,X){const re=this._addNewAdapter(new s(this._documents,X),U);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideImplementation(U,G,X,re){return this._withAdapter(U,s,q=>q.provideImplementation(m.URI.revive(G),X,re),[])}registerTypeDefinitionProvider(U,G,X){const re=this._addNewAdapter(new i(this._documents,X),U);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideTypeDefinition(U,G,X,re){return this._withAdapter(U,i,q=>q.provideTypeDefinition(m.URI.revive(G),X,re),[])}registerHoverProvider(U,G,X,re){const q=this._addNewAdapter(new u(this._documents,X),U);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideHover(U,G,X,re){return this._withAdapter(U,u,q=>q.provideHover(m.URI.revive(G),X,re),void 0)}registerEvaluatableExpressionProvider(U,G,X,re){const q=this._addNewAdapter(new d(this._documents,X),U);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideEvaluatableExpression(U,G,X,re){return this._withAdapter(U,d,q=>q.provideEvaluatableExpression(m.URI.revive(G),X,re),void 0)}registerInlineValuesProvider(U,G,X,re){const q=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ie=this._addNewAdapter(new p(this._documents,X),U);this._proxy.$registerInlineValuesProvider(ie,this._transformDocumentSelector(G),q);let ge=this._createDisposable(ie);if(q!==void 0){const Re=X.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(q));ge=_.Disposable.from(ge,Re)}return ge}$provideInlineValues(U,G,X,re,q){return this._withAdapter(U,p,ie=>ie.provideInlineValues(m.URI.revive(G),X,re,q),void 0)}registerDocumentHighlightProvider(U,G,X){const re=this._addNewAdapter(new D(this._documents,X),U);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDocumentHighlights(U,G,X,re){return this._withAdapter(U,D,q=>q.provideDocumentHighlights(m.URI.revive(G),X,re),void 0)}registerLinkedEditingRangeProvider(U,G,X){const re=this._addNewAdapter(new T(this._documents,X),U);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideLinkedEditingRanges(U,G,X,re){return this._withAdapter(U,T,async q=>{const ie=await q.provideLinkedEditingRanges(m.URI.revive(G),X,re);if(ie)return{ranges:ie.ranges,wordPattern:ie.wordPattern?qe._serializeRegExp(ie.wordPattern):void 0}},void 0)}registerReferenceProvider(U,G,X){const re=this._addNewAdapter(new o(this._documents,X),U);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideReferences(U,G,X,re,q){return this._withAdapter(U,o,ie=>ie.provideReferences(m.URI.revive(G),X,re,q),void 0)}registerCodeActionProvider(U,G,X,re){const q=new l.DisposableStore,ie=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,X,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(ie,this._transformDocumentSelector(G),{providedKinds:re?.providedCodeActionKinds?.map(ge=>ge.value),documentation:re?.documentation?.map(ge=>({kind:ge.kind.value,command:this._commands.converter.toInternal(ge.command,q)}))},qe._extLabel(U),Boolean(X.resolveCodeAction)),q.add(this._createDisposable(ie)),q}$provideCodeActions(U,G,X,re,q){return this._withAdapter(U,A,ie=>ie.provideCodeActions(m.URI.revive(G),X,re,q),void 0)}$resolveCodeAction(U,G,X){return this._withAdapter(U,A,re=>re.resolveCodeAction(G,X),void 0)}$releaseCodeActions(U,G){this._withAdapter(U,A,X=>Promise.resolve(X.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(U,G,X){const re=this._addNewAdapter(new F(this._documents,X),U);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(G),U.identifier,U.displayName||U.name),this._createDisposable(re)}$provideDocumentFormattingEdits(U,G,X,re){return this._withAdapter(U,F,q=>q.provideDocumentFormattingEdits(m.URI.revive(G),X,re),void 0)}registerDocumentRangeFormattingEditProvider(U,G,X){const re=this._addNewAdapter(new x(this._documents,X),U);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(G),U.identifier,U.displayName||U.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits(U,G,X,re,q){return this._withAdapter(U,x,ie=>ie.provideDocumentRangeFormattingEdits(m.URI.revive(G),X,re,q),void 0)}registerOnTypeFormattingEditProvider(U,G,X,re){const q=this._addNewAdapter(new K(this._documents,X),U);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(G),re,U.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(U,G,X,re,q,ie){return this._withAdapter(U,K,ge=>ge.provideOnTypeFormattingEdits(m.URI.revive(G),X,re,q,ie),void 0)}registerWorkspaceSymbolProvider(U,G){const X=this._addNewAdapter(new le(G,this._logService),U);return this._proxy.$registerNavigateTypeSupport(X),this._createDisposable(X)}$provideWorkspaceSymbols(U,G,X){return this._withAdapter(U,le,re=>re.provideWorkspaceSymbols(G,X),{symbols:[]})}$resolveWorkspaceSymbol(U,G,X){return this._withAdapter(U,le,re=>re.resolveWorkspaceSymbol(G,X),void 0)}$releaseWorkspaceSymbols(U,G){this._withAdapter(U,le,X=>X.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(U,G,X){const re=this._addNewAdapter(new oe(this._documents,X,this._logService),U);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(G),oe.supportsResolving(X)),this._createDisposable(re)}$provideRenameEdits(U,G,X,re,q){return this._withAdapter(U,oe,ie=>ie.provideRenameEdits(m.URI.revive(G),X,re,q),void 0)}$resolveRenameLocation(U,G,X,re){return this._withAdapter(U,oe,q=>q.resolveRenameLocation(m.URI.revive(G),X,re),void 0)}registerDocumentSemanticTokensProvider(U,G,X,re){const q=this._nextHandle(),ie=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new Xe(new W(this._documents,X),U)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(G),re,ie);let ge=this._createDisposable(q);if(ie){const Re=X.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(ie));ge=_.Disposable.from(ge,Re)}return ge}$provideDocumentSemanticTokens(U,G,X,re){return this._withAdapter(U,W,q=>q.provideDocumentSemanticTokens(m.URI.revive(G),X,re),null,!0)}$releaseDocumentSemanticTokens(U,G){this._withAdapter(U,W,X=>X.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(U,G,X,re){const q=this._addNewAdapter(new L(this._documents,X),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(G),re),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(U,G,X,re){return this._withAdapter(U,L,q=>q.provideDocumentRangeSemanticTokens(m.URI.revive(G),X,re),null,!0)}registerCompletionItemProvider(U,G,X,re){const q=this._addNewAdapter(new Q(this._documents,this._commands.converter,X,this._apiDeprecation,U),U);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(G),re,Q.supportsResolving(X),`${U.identifier.value}(${re.join("")})`),this._createDisposable(q)}$provideCompletionItems(U,G,X,re,q){return this._withAdapter(U,Q,ie=>ie.provideCompletionItems(m.URI.revive(G),X,re,q),void 0)}$resolveCompletionItem(U,G,X){return this._withAdapter(U,Q,re=>re.resolveCompletionItem(G,X),void 0)}$releaseCompletionItems(U,G){this._withAdapter(U,Q,X=>X.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider(U,G,X){const re=this._addNewAdapter(new O(this._documents,X,this._commands.converter),U);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideInlineCompletions(U,G,X,re,q){return this._withAdapter(U,O,ie=>ie.provideInlineCompletions(m.URI.revive(G),X,re,q),void 0)}$handleInlineCompletionDidShow(U,G,X){this._withAdapter(U,O,async re=>{re.handleDidShowCompletionItem(G,X)},void 0)}$freeInlineCompletionsList(U,G){this._withAdapter(U,O,async X=>{X.disposeCompletions(G)},void 0)}registerSignatureHelpProvider(U,G,X,re){const q=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,ie=this._addNewAdapter(new he(this._documents,X),U);return this._proxy.$registerSignatureHelpProvider(ie,this._transformDocumentSelector(G),q),this._createDisposable(ie)}$provideSignatureHelp(U,G,X,re,q){return this._withAdapter(U,he,ie=>ie.provideSignatureHelp(m.URI.revive(G),X,re,q),void 0)}$releaseSignatureHelp(U,G){this._withAdapter(U,he,X=>X.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider(U,G,X){const re=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new $(this._documents,X),U);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(G),re);let ie=this._createDisposable(q);if(re!==void 0){const ge=X.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(re));ie=_.Disposable.from(ie,ge)}return ie}$provideInlayHints(U,G,X,re){return this._withAdapter(U,$,q=>q.provideInlayHints(m.URI.revive(G),X,re),void 0)}registerDocumentLinkProvider(U,G,X){const re=this._addNewAdapter(new ne(this._documents,X),U);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(G),typeof X.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks(U,G,X){return this._withAdapter(U,ne,re=>re.provideLinks(m.URI.revive(G),X),void 0)}$resolveDocumentLink(U,G,X){return this._withAdapter(U,ne,re=>re.resolveLink(G,X),void 0)}$releaseDocumentLinks(U,G){this._withAdapter(U,ne,X=>X.releaseLinks(G),void 0)}registerColorProvider(U,G,X){const re=this._addNewAdapter(new de(this._documents,X),U);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDocumentColors(U,G,X){return this._withAdapter(U,de,re=>re.provideColors(m.URI.revive(G),X),[])}$provideColorPresentations(U,G,X,re){return this._withAdapter(U,de,q=>q.provideColorPresentations(m.URI.revive(G),X,re),void 0)}registerFoldingRangeProvider(U,G,X){const re=this._nextHandle(),q=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new Xe(new ye(this._documents,X),U)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(G),q);let ie=this._createDisposable(re);if(q!==void 0){const ge=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));ie=_.Disposable.from(ie,ge)}return ie}$provideFoldingRanges(U,G,X,re){return this._withAdapter(U,ye,q=>q.provideFoldingRanges(m.URI.revive(G),X,re),void 0)}registerSelectionRangeProvider(U,G,X){const re=this._addNewAdapter(new Ne(this._documents,X,this._logService),U);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideSelectionRanges(U,G,X,re){return this._withAdapter(U,Ne,q=>q.provideSelectionRanges(m.URI.revive(G),X,re),[])}registerCallHierarchyProvider(U,G,X){const re=this._addNewAdapter(new Me(this._documents,X),U);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$prepareCallHierarchy(U,G,X,re){return this._withAdapter(U,Me,q=>Promise.resolve(q.prepareSession(m.URI.revive(G),X,re)),void 0)}$provideCallHierarchyIncomingCalls(U,G,X,re){return this._withAdapter(U,Me,q=>q.provideCallsTo(G,X,re),void 0)}$provideCallHierarchyOutgoingCalls(U,G,X,re){return this._withAdapter(U,Me,q=>q.provideCallsFrom(G,X,re),void 0)}$releaseCallHierarchy(U,G){this._withAdapter(U,Me,X=>Promise.resolve(X.releaseSession(G)),void 0)}registerTypeHierarchyProvider(U,G,X){const re=this._addNewAdapter(new $e(this._documents,X),U);return this._proxy.$registerTypeHierarchyProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$prepareTypeHierarchy(U,G,X,re){return this._withAdapter(U,$e,q=>Promise.resolve(q.prepareSession(m.URI.revive(G),X,re)),void 0)}$provideTypeHierarchySupertypes(U,G,X,re){return this._withAdapter(U,$e,q=>q.provideSupertypes(G,X,re),void 0)}$provideTypeHierarchySubtypes(U,G,X,re){return this._withAdapter(U,$e,q=>q.provideSubtypes(G,X,re),void 0)}$releaseTypeHierarchy(U,G){this._withAdapter(U,$e,X=>Promise.resolve(X.releaseSession(G)),void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:(0,y.regExpFlags)(U)}}static _serializeIndentationRule(U){return{decreaseIndentPattern:qe._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:qe._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?qe._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?qe._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:qe._serializeRegExp(U.beforeText),afterText:U.afterText?qe._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?qe._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(qe._serializeOnEnterRule)}setLanguageConfiguration(U,G,X){let{wordPattern:re}=X;if(re&&(0,y.regExpLeadsToEndlessLoop)(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(G,re):this._documents.setWordDefinitionFor(G,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const q=this._nextHandle(),ie={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?qe._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?qe._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?qe._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,G,ie),this._createDisposable(q)}$setWordDefinitions(U){for(const G of U)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=qe,qe._handlePool=0}),define(be[201],Ee([0,1,5,9,7,36,15]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(k,n){this._handlePool=0,this._proxy=k.getProxy(m.MainContext.MainThreadLanguages),this._documents=n}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,n){await this._proxy.$changeLanguage(k,n);const C=this._documents.getDocumentData(k);if(!C)throw new Error(`document '${k.toString}' NOT found`);return C.document}async tokenAtPosition(k,n){const C=k.version,l=R.Position.from(n),h=await this._proxy.$tokensAtPosition(k.uri,l),c={type:S.StandardTokenType.Other,range:k.getWordRangeAtPosition(n)??new S.Range(n.line,n.character,n.line,n.character)};if(!h)return c;const g={range:R.Range.to(h.range),type:R.TokenType.to(h.type)};return!g.range.contains(n)||C!==k.version?c:g}createLanguageStatusItem(k){const n=this._handlePool++,C=this._proxy,l={selector:k,text:"",detail:"",severity:S.LanguageStatusSeverity.Information};let h;const c=()=>{h?.dispose(),h=(0,I.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(n,{selector:l.selector,text:l.text,message:typeof l.detail=="string"?l.detail:R.MarkdownString.from(l.detail),severity:l.severity===S.LanguageStatusSeverity.Error?_.default.Error:l.severity===S.LanguageStatusSeverity.Warning?_.default.Warning:_.default.Info})},0)},g={get selector(){return l.selector},set selector(b){l.selector=b,c()},get text(){return l.text},set text(b){l.text=b,c()},get detail(){return l.detail},set detail(b){l.detail=b,c()},get severity(){return l.severity},set severity(b){l.severity=b,c()},dispose(){h?.dispose(),C.$removeLanguageStatus(n)}};return c(),g}}e.ExtHostLanguages=y}),define(be[202],Ee([0,1,5,16,30]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function _(y){return y&&y.title}let I=class{constructor(E,k){this._logService=k,this._proxy=E.getProxy(m.MainContext.MainThreadMessageService)}showMessage(E,k,n,C,l){const h={extension:E};let c;typeof C=="string"||_(C)?c=[C,...l]:(h.modal=C?.modal,h.useCustom=C?.useCustom,h.detail=C?.detail,c=l),h.useCustom&&(0,S.checkProposedApiEnabled)(E);const g=[];for(let b=0;b<c.length;b++){const w=c[b];if(typeof w=="string")g.push({title:w,handle:b,isCloseAffordance:!1});else if(typeof w=="object"){let{title:P,isCloseAffordance:a}=w;g.push({title:P,isCloseAffordance:!!a,handle:b})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(k,n,h,g).then(b=>{if(typeof b=="number")return c[b]})}};I=ze([Ve(1,R.ILogService)],I),e.ExtHostMessageService=I}),define(be[203],Ee([0,1,24,3,43,6,21,8,10,2,66,5,9,7,179,101]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class b{constructor(P,a,f,v,t){this._textDocumentsAndEditors=f,this._textDocuments=v,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new I.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=P.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=P.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=P.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=a.converter,a.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,i=r.cell.handle,d=this._documents.get(s)?.getCell(i);if(d)return d.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(P=>P.apiEditor)}getEditorById(P){const a=this._editors.get(P);if(!a)throw new Error(`unknown text editor: ${P}. known editors: ${[...this._editors.keys()]} `);return a}getIdByEditor(P){for(const[a,f]of this._editors)if(f.apiEditor===P)return a}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(P,a){const f=this._documents.get(P);if(!f&&!a)throw new Error(`NO notebook document for '${P}'`);return f}_getProviderData(P){const a=this._notebookContentProviders.get(P);if(!a)throw new Error(`NO provider for '${P}'`);return a}registerNotebookContentProvider(P,a,f,v,t){if((0,y.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(a))throw new Error(`Notebook provider for '${a}' already registered`);this._notebookContentProviders.set(a,{extension:P,provider:f});let r;return f.onDidChangeNotebookContentOptions&&(r=f.onDidChangeNotebookContentOptions(()=>{const s=l.NotebookDocumentContentOptions.from(f.options);this._notebookProxy.$updateNotebookProviderOptions(a,s)})),this._notebookProxy.$registerNotebookProvider({id:P.identifier,location:P.extensionLocation},a,l.NotebookDocumentContentOptions.from(v),b._convertNotebookRegistrationData(P,t)),new h.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(a),this._notebookProxy.$unregisterNotebookProvider(a)})}static _convertNotebookRegistrationData(P,a){if(!a)return;const f=a.filenamePattern.map(v=>l.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(a.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${a.filenamePattern}`);return}return{extension:P.identifier,providerDisplayName:P.displayName||P.name,displayName:a.displayName,filenamePattern:f,exclusive:a.exclusive||!1}}registerNotebookCellStatusBarItemProvider(P,a,f){const v=b._notebookStatusBarItemProviderHandlePool++,t=typeof f.onDidChangeCellStatusBarItems=="function"?b._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,f),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,t,a);let r;return t!==void 0&&(r=f.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,t),r&&r.dispose()})}async createNotebookDocument(P){const a=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:P.viewType,content:P.content&&l.NotebookData.from(P.content)});return k.URI.revive(a)}async openNotebookDocument(P){const a=this._documents.get(P);if(a)return a.apiNotebook;const f=await this._notebookDocumentsProxy.$tryOpenNotebook(P),v=this._documents.get(k.URI.revive(f));return(0,E.assertIsDefined)(v?.apiNotebook)}async showNotebookDocument(P,a){k.URI.isUri(P)&&(P=await this.openNotebookDocument(P));let f;typeof a=="object"?f={position:l.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selections:a.selections&&a.selections.map(l.NotebookRange.from),pinned:typeof a.preview=="boolean"?!a.preview:void 0}:f={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(P.uri,P.notebookType,f),t=v&&this._editors.get(v)?.apiEditor;if(t)return t;throw v?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(P,a,f,v){const t=this._notebookStatusBarItemProviders.get(P),r=k.URI.revive(a),s=this._documents.get(r);if(!s||!t)return;const i=s.getCellFromIndex(f);if(!i)return;const u=await t.provideCellStatusBarItems(i.apiCell,v);if(!u)return;const d=new _.DisposableStore,p=this._statusBarCache.add([d]),T=(Array.isArray(u)?u:[u]).map(o=>l.NotebookStatusBarItem.from(o,this._commandsConverter,d));return{cacheId:p,items:T}}$releaseNotebookCellStatusBarItems(P){this._statusBarCache.delete(P)}registerNotebookSerializer(P,a,f,v,t){if((0,y.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,f),this._notebookProxy.$registerNotebookSerializer(r,{id:P.identifier,location:P.extensionLocation},a,l.NotebookDocumentContentOptions.from(v),b._convertNotebookRegistrationData(P,t)),(0,_.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(P,a,f){const v=this._notebookSerializer.get(P);if(!v)throw new Error("NO serializer found");const t=await v.deserializeNotebook(a.buffer,f);return l.NotebookData.from(t)}async $notebookToData(P,a,f){const v=this._notebookSerializer.get(P);if(!v)throw new Error("NO serializer found");const t=await v.serializeNotebook(l.NotebookData.to(a),f);return m.VSBuffer.wrap(t)}async $openNotebook(P,a,f,v,t){const{provider:r}=this._getProviderData(P),s=await r.openNotebook(k.URI.revive(a),{backupId:f,untitledDocumentData:v?.buffer},t);return{metadata:s.metadata??Object.create(null),cells:s.cells.map(l.NotebookCellData.from)}}async $saveNotebook(P,a,f){const v=this.getNotebookDocument(k.URI.revive(a)),{provider:t}=this._getProviderData(P);return await t.saveNotebook(v.apiNotebook,f),!0}async $saveNotebookAs(P,a,f,v){const t=this.getNotebookDocument(k.URI.revive(a)),{provider:r}=this._getProviderData(P);return await r.saveNotebookAs(k.URI.revive(f),t.apiNotebook,v),!0}async $backupNotebook(P,a,f){const v=this.getNotebookDocument(k.URI.revive(a)),t=this._getProviderData(P),r=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),s=String((0,S.hash)([v.uri.toString(),this._backupIdPool++])),i=k.URI.joinPath(r,s),u=await t.provider.backupNotebook(v.apiNotebook,{destination:i},f);return v.updateBackup(u),u.id}_createExtHostEditor(P,a,f){if(this._editors.has(a))throw new Error(`editor with id ALREADY EXSIST: ${a}`);const v=new g.ExtHostNotebookEditor(a,this._notebookEditorsProxy,P,f.visibleRanges.map(l.NotebookRange.to),f.selections.map(l.NotebookRange.to),typeof f.viewColumn=="number"?l.ViewColumn.to(f.viewColumn):void 0);this._editors.set(a,v)}$acceptDocumentAndEditorsDelta(P){if(P.removedDocuments)for(const f of P.removedDocuments){const v=k.URI.revive(f),t=this._documents.get(v);t&&(t.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===v.toString()&&this._editors.delete(r.id)}if(P.addedDocuments){const f=[];for(const v of P.addedDocuments){const t=k.URI.revive(v.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const r=this,s=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(i){r._onDidChangeNotebookCells.fire(i)},emitCellOutputsChange(i){r._onDidChangeCellOutputs.fire(i)},emitCellMetadataChange(i){r._onDidChangeCellMetadata.fire(i)},emitCellExecutionStateChange(i){r._onDidChangeCellExecutionState.fire(i)}},t,v);f.push(...v.cells.map(i=>c.ExtHostCell.asModelAddData(s.apiNotebook,i))),this._documents.get(t)?.dispose(),this._documents.set(t,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(P.addedEditors)for(const f of P.addedEditors){if(this._editors.has(f.id))return;const v=k.URI.revive(f.documentUri),t=this._documents.get(v);t&&this._createExtHostEditor(t,f.id,f)}const a=[];if(P.removedEditors)for(const f of P.removedEditors){const v=this._editors.get(f);v&&(this._editors.delete(f),this._activeNotebookEditor?.id===v.id&&(this._activeNotebookEditor=void 0),a.push(v))}if(P.visibleEditors){this._visibleNotebookEditors=P.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const f=new Set;this._visibleNotebookEditors.forEach(v=>f.add(v.id));for(const v of this._editors.values()){const t=f.has(v.id);v._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}P.newActiveEditor===null?this._activeNotebookEditor=void 0:P.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(P.newActiveEditor)),P.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=b,b._notebookStatusBarItemProviderHandlePool=0}),define(be[204],Ee([0,1,3,54,16,5,13,9]),function(ee,e,m,R,S,_,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class E{constructor(C,l){const h=E._Keys.nextId();C.$registerNotebookEditorDecorationType(h,y.NotebookDecorationRenderOptions.from(l)),this.value={key:h,dispose(){C.$removeNotebookEditorDecorationType(h)}}}}E._Keys=new R.IdGenerator("NotebookEditorDecorationType");let k=class{constructor(C,l,h){this._logService=C,this._extHostRpc=l,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(C){return new E(this._extHostRpc.getProxy(_.MainContext.MainThreadNotebookEditors),C).value}$acceptEditorPropertiesChanged(C,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,l);const h=this._notebooksAndEditors.getEditorById(C);l.visibleRanges&&h._acceptVisibleRanges(l.visibleRanges.ranges.map(y.NotebookRange.to)),l.selections&&h._acceptSelections(l.selections.selections.map(y.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const l in C)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(y.ViewColumn.to(C[l]))}};k=ze([Ve(0,S.ILogService),Ve(1,I.IExtHostRpcService)],k),e.ExtHostNotebookEditors=k}),define(be[205],Ee([0,1,3,6,5,26,2,9,71,21,15,72,20,17,16,7,30]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,r,s,i){this._initData=r,this._extHostNotebook=s,this._logService=i,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(S.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,s,i,u,d){for(let O of this._kernelData.values())if(O.controller.id===r&&_.ExtensionIdentifier.equals(t.identifier,O.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const p=this._handlePool++,D=this;this._logService.trace(`NotebookController[${p}], CREATED by ${t.identifier.value}, ${r}`);const T=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${t.identifier}'`);let o=!1;const A=new R.DisposableStore,F=new m.Emitter,x=new m.Emitter,K={id:`${t.identifier.value}/${r}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:i||t.identifier.value,preloads:d?d.map(y.NotebookRendererScript.from):[]};let le=u??T,oe;this._proxy.$addKernel(p,K).catch(O=>{console.log(O),o=!0});let V=0;const W=()=>{if(o)return;const O=++V;Promise.resolve().then(()=>{O===V&&this._proxy.$updateKernel(p,K)})},L=new k.ResourceMap,Q={get id(){return r},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return K.label},set label(O){K.label=O??t.displayName??t.name,W()},get detail(){return K.detail??""},set detail(O){K.detail=O,W()},get description(){return K.description??""},set description(O){K.description=O,W()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(O){K.supportedLanguages=O,W()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(O){K.supportsExecutionOrder=O,W()},get rendererScripts(){return K.preloads?K.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return le},set executeHandler(O){le=O??T},get interruptHandler(){return oe},set interruptHandler(O){oe=O,K.supportsInterrupt=Boolean(O),W()},createNotebookCellExecution(O){if(o)throw new Error("notebook controller is DISPOSED");if(!L.has(O.notebook.uri))throw D._logService.trace(`NotebookController[${p}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(L.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${O.notebook.uri.toString()}`);return D._createNotebookCellExecution(O)},dispose:()=>{o||(this._logService.trace(`NotebookController[${p}], DISPOSED`),o=!0,this._kernelData.delete(p),A.dispose(),F.dispose(),x.dispose(),this._proxy.$removeKernel(p))},updateNotebookAffinity(O,j){D._proxy.$updateNotebookPriority(p,O.uri,j)},onDidReceiveMessage:x.event,postMessage(O,j){return(0,b.checkProposedApiEnabled)(t),D._proxy.$postMessage(p,j&&D._extHostNotebook.getIdByEditor(j),O)},asWebviewUri(O){return(0,b.checkProposedApiEnabled)(t),(0,E.asWebviewUri)(O,D._initData.remote)}};return this._kernelData.set(p,{extensionId:t.identifier,controller:Q,onDidReceiveMessage:x,onDidChangeSelection:F,associatedNotebooks:L}),Q}$acceptNotebookAssociation(t,r,s){const i=this._kernelData.get(t);if(i){const u=this._extHostNotebook.getNotebookDocument(I.URI.revive(r));s?i.associatedNotebooks.set(u.uri,!0):i.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,u.uri.toString(),s),i.onDidChangeSelection.fire({selected:s,notebook:u.apiNotebook})}}async $executeCells(t,r,s){const i=this._kernelData.get(t);if(!i)return;const u=this._extHostNotebook.getNotebookDocument(I.URI.revive(r)),d=[];for(let p of s){const D=u.getCell(p);D&&d.push(D.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,u.uri.toString(),d.length),await i.controller.executeHandler.call(i.controller,d,u.apiNotebook,i.controller)}catch(p){this._logService.error(`NotebookController[${t}] execute cells FAILED`,p),console.error(p)}}async $cancelCells(t,r,s){const i=this._kernelData.get(t);if(!i)return;const u=this._extHostNotebook.getNotebookDocument(I.URI.revive(r));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,u.apiNotebook);else for(let d of s){const p=u.getCell(d);p&&this._activeExecutions.get(p.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,r,s){const i=this._kernelData.get(t);if(!i)return;const u=this._extHostNotebook.getEditorById(r);i.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const i=new a(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,i);const u=i.onDidChangeState(()=>{i.state===P.Resolved&&(i.dispose(),u.dispose(),this._activeExecutions.delete(s.uri))});return i.asApiObject()}};w=ze([Ve(3,c.ILogService)],w),e.ExtHostNotebookKernels=w;var P;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(P||(P={}));class a extends R.Disposable{constructor(t,r,s){super();this._document=t,this._cell=r,this._proxy=s,this._onDidChangeState=new m.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=P.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new f(10,i=>this.applyEdits(i)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:C.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===P.Init)throw new Error("Must call start before modifying cell output");if(this._state===P.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let r=this._cell;if(t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const s=g.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return s===r.items?y.NotebookCellOutput.from(r):y.NotebookCellOutput.from({items:s,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,s){const i=this.cellIndexToHandle(r),u=this.validateAndConvertOutputs((0,h.asArray)(t));return this.applyEditSoon({editType:2,handle:i,append:s,outputs:u})}async updateOutputItems(t,r,s){return t=g.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(y.NotebookCellOutputItem.from),outputId:r.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===P.Resolved||t._state===P.Started)throw new Error("Cannot call start again");t._state=P.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:C.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,i){if(t._state===P.Resolved)throw new Error("Cannot call resolve twice");t._state=P.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:i??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,i){return t.verifyStateForOutput(),t.updateOutputs(s,i,!0)},replaceOutput(s,i){return t.verifyStateForOutput(),t.updateOutputs(s,i,!1)},appendOutputItems(s,i){return t.verifyStateForOutput(),t.updateOutputItems(s,i,!0)},replaceOutputItems(s,i){return t.verifyStateForOutput(),t.updateOutputItems(s,i,!1)}})}}class f{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,n.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(be[206],Ee([0,1,3,5,101]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class _{constructor(y,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,E,k){const n=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(E)?.fire({editor:n.apiEditor,message:k})}createRendererMessaging(y,E){if(!y.contributes?.notebookRenderer?.some(l=>l.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);const k=!!y.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(l,h,c)=>{const g=k?l:b=>{const w={};n.set(w,b.editor),l({editor:w,message:b.message})};return this.getOrCreateEmitterFor(E).event(g,h,c)},postMessage:(l,h)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(l)&&([l,h]=[h,l]);const c=k?h:n.get(h),g=c&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(c);return this.proxy.$postMessage(g?.id,E,l)}}}getOrCreateEmitterFor(y){let E=this._rendererMessageEmitters.get(y);return E||(E=new m.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,E),E)}}e.ExtHostNotebookRenderers=_}),define(be[105],Ee([0,1,5,3,6,24,4,13]),function(ee,e,m,R,S,_,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class E extends S.Disposable{constructor(c,g,b,w,P){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=P,this._id=P.$register(this.name,g,b,w),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?_.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(g=>this._proxy.$clear(g,c))}show(c,g){this.validate(),this._id.then(b=>this._proxy.$reveal(b,!!(typeof c=="boolean"?c:g)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=E;class k extends E{constructor(c,g,b){super(c,!1,void 0,g,b)}append(c){super.append(c),this._id.then(g=>this._proxy.$append(g,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class n extends E{constructor(c,g,b){super(c,!0,g,void 0,b)}append(c){throw new Error("Not supported")}}class C{constructor(c,g){this.name=c,this._channel=g}append(c){this._channel.then(g=>g.append(c))}appendLine(c){this._channel.then(g=>g.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,g){this._channel.then(b=>b.show(c,g))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=C;let l=class{constructor(c){this._proxy=c.getProxy(m.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c,g){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new k(c,g.identifier.value,this._proxy)}createOutputChannelFromLogFile(c,g){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!g)throw new Error("illegal argument `file`. must not be falsy");return new n(c,g,this._proxy)}};l=ze([Ve(0,y.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(be[207],Ee([0,1,15,20,3,6,5,2,7,12,17,36]),function(ee,e,m,R,S,_,I,y,E,k,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(h,c,g){const b=h.getProxy(I.MainContext.MainThreadQuickOpen);class w{constructor(i,u){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=u}showQuickPick(i,u,d,p=R.CancellationToken.None){this._onDidSelectItem=void 0;const D=Promise.resolve(i),T=++this._instances,o=b.$show(T,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},p),A={},F=o.then(()=>A);return Promise.race([F,D]).then(x=>{if(x!==A)return D.then(K=>{const le=[];for(let oe=0;oe<K.length;oe++){const V=K[oe];let W,L,Q,O,j;typeof V=="string"?W=V:(W=V.label,L=V.description,Q=V.detail,O=V.picked,j=V.alwaysShow),le.push({label:W,description:L,handle:oe,detail:Q,picked:O,alwaysShow:j})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=oe=>{d.onDidSelectItem(K[oe])}),b.$setItems(T,le),o.then(oe=>{if(typeof oe=="number")return K[oe];if(Array.isArray(oe))return oe.map(V=>K[V])})})}).then(void 0,x=>{if(!(0,k.isPromiseCanceledError)(x))return b.$setError(T,x),Promise.reject(x)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,u=R.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,b.$input(i,typeof this._validateInput=="function",u).then(void 0,d=>{if(!(0,k.isPromiseCanceledError)(d))return Promise.reject(d)})}$validateInput(i){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,u=R.CancellationToken.None){const d=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!d)return;const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(D=>D.uri.toString()===d.uri.toString())}createQuickPick(i,u){const d=new t(i,u,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(i){const u=new r(i,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(i,u){const d=this._sessions.get(i);d&&d._fireDidChangeValue(u)}$onDidAccept(i){const u=this._sessions.get(i);u&&u._fireDidAccept()}$onDidChangeActive(i,u){const d=this._sessions.get(i);d instanceof t&&d._fireDidChangeActive(u)}$onDidChangeSelection(i,u){const d=this._sessions.get(i);d instanceof t&&d._fireDidChangeSelection(u)}$onDidTriggerButton(i,u){const d=this._sessions.get(i);d&&d._fireDidTriggerButton(u)}$onDidHide(i){const u=this._sessions.get(i);u&&u._fireDidHide()}}class P{constructor(i,u){this._extensionId=i,this._onDidDispose=u,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((u,d)=>{const p=u===E.QuickInputButtons.Back?-1:d;this._handlesToButtons.set(p,u)}),this.update({buttons:i.map((u,d)=>({iconPath:a(u.iconPath),tooltip:u.tooltip,handle:u===E.QuickInputButtons.Back?-1:d}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const u=this._handlesToButtons.get(i);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,_.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(i){if(!this._disposed){for(const u of Object.keys(i)){const d=i[u];this._pendingUpdate[u]=d===void 0?null:d}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}P._nextId=1;function a(s){if(s instanceof E.ThemeIcon)return{id:s.id};const i=v(s),u=f(s);return{dark:typeof i=="string"?y.URI.file(i):i,light:typeof u=="string"?y.URI.file(u):u}}function f(s){return typeof s=="object"&&"light"in s?s.light:s}function v(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends P{constructor(i,u,d){super(i,d);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((u,d)=>{this._handlesToItems.set(d,u),this._itemsToHandles.set(u,d)}),this.update({items:i.map((u,d)=>({label:u.label,description:u.description,handle:d,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(i){const u=(0,n.coalesce)(i.map(d=>this._handlesToItems.get(d)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(i){const u=(0,n.coalesce)(i.map(d=>this._handlesToItems.get(d)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}}class r extends P{constructor(i,u){super(i,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?C.default.Error:C.default.Ignore})}}return new w(c,g)}e.createExtHostQuickOpen=l}),define(be[208],Ee([0,1,2,3,52,6,15,5,17,116,16,26,30,65]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function c(u){if(u)return typeof u.iconPath=="string"?m.URI.file(u.iconPath):m.URI.isUri(u.iconPath)||h.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function g(u,d){if(!u.iconPath&&!d.iconPath)return 0;if(u.iconPath){if(!d.iconPath)return 1}else return-1;const p=typeof u.iconPath=="string"?u.iconPath:m.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,D=typeof d.iconPath=="string"?d.iconPath:m.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,k.comparePaths)(p,D)}function b(u,d){let p=0;if(u.strikeThrough!==d.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==d.faded)return u.faded?1:-1;if(u.tooltip!==d.tooltip)return(u.tooltip||"").localeCompare(d.tooltip||"");if(p=g(u,d),p!==0)return p;if(u.light&&d.light)p=g(u.light,d.light);else{if(u.light)return 1;if(d.light)return-1}if(p!==0)return p;if(u.dark&&d.dark)p=g(u.dark,d.dark);else{if(u.dark)return 1;if(d.dark)return-1}return p}function w(u,d){if(u.command!==d.command)return u.command<d.command?-1:1;if(u.title!==d.title)return u.title<d.title?-1:1;if(u.tooltip!==d.tooltip){if(u.tooltip!==void 0&&d.tooltip!==void 0)return u.tooltip<d.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(u.arguments===d.arguments)return 0;if(u.arguments)if(d.arguments){if(u.arguments.length!==d.arguments.length)return u.arguments.length-d.arguments.length}else return 1;else return-1;for(let p=0;p<u.arguments.length;p++){const D=u.arguments[p],T=d.arguments[p];if(D!==T)return D<T?-1:1}return 0}function P(u,d){let p=(0,k.comparePaths)(u.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(p!==0)return p;if(u.command&&d.command)p=w(u.command,d.command);else{if(u.command)return 1;if(d.command)return-1}if(p!==0)return p;if(u.decorations&&d.decorations)p=b(u.decorations,d.decorations);else{if(u.decorations)return 1;if(d.decorations)return-1}return p}function a(u,d){for(let p=0;p<u.length;p++)if(u[p]!==d[p])return!1;return!0}function f(u,d){return u.command===d.command&&u.title===d.title&&u.tooltip===d.tooltip&&(u.arguments&&d.arguments?a(u.arguments,d.arguments):u.arguments===d.arguments)}function v(u,d){return(0,E.equals)(u,d,f)}class t{constructor(d,p,D){this._extension=d,this._proxy=p,this._sourceControlHandle=D,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(d){this._proxy.$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(d){if((0,l.checkProposedApiEnabled)(this._extension),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,d))}focus(){(0,l.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(d,p){(0,l.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,d,p)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=t;class r{constructor(d,p,D,T,o){this._proxy=d,this._commands=p,this._sourceControlHandle=D,this._id=T,this._label=o,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,p){const D=this._resourceStatesCommandsMap.get(d);return D?(0,I.asPromise)(()=>this._commands.executeCommand(D.command,...D.arguments||[],p)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(P),D=(0,E.sortedDiff)(this._resourceSnapshot,d,P).map(A=>{const F=A.toInsert.map(x=>{const K=this._resourceHandlePool++;this._resourceStatesMap.set(K,x);const le=x.resourceUri;let oe;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const de=new _.DisposableStore;oe=this._commands.converter.toInternal(x.command,de),this._resourceStatesDisposablesMap.set(K,de)}else this._resourceStatesCommandsMap.set(K,x.command);const V=c(x.decorations),W=x.decorations&&c(x.decorations.light)||V,L=x.decorations&&c(x.decorations.dark)||V,Q=[W,L],O=x.decorations&&x.decorations.tooltip||"",j=x.decorations&&!!x.decorations.strikeThrough,he=x.decorations&&!!x.decorations.faded,$=x.contextValue||"";return{rawResource:[K,le,Q,O,j,he,$,oe],handle:K}});return{start:A.start,deleteCount:A.deleteCount,toInsert:F}}),T=D.map(({start:A,deleteCount:F,toInsert:x})=>[A,F,x.map(K=>K.rawResource)]),o=D.reverse();for(const{start:A,deleteCount:F,toInsert:x}of o){const K=x.map(oe=>oe.handle),le=this._handlesSnapshot.splice(A,F,...K);for(const oe of le)this._resourceStatesMap.delete(oe),this._resourceStatesCommandsMap.delete(oe),this._resourceStatesDisposablesMap.get(oe)?.dispose(),this._resourceStatesDisposablesMap.delete(oe)}return this._resourceSnapshot=d,T}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class s{constructor(d,p,D,T,o,A){this._proxy=p,this._commands=D,this._id=T,this._label=o,this._rootUri=A,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new _.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new t(d,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,T,o,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,this._proxy.$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,this._proxy.$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new _.DisposableStore,this._acceptInputCommand=d;const p=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:p})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&v(this._statusBarCommands,d))return;this._statusBarDisposables.value=new _.DisposableStore,this._statusBarCommands=d;const p=(d||[]).map(D=>this._commands.converter.toInternal(D,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:p})}get selected(){return this._selected}createResourceGroup(d,p){const D=new r(this._proxy,this._commands,this.handle,d,p),T=R.Event.once(D.onDidDispose)(()=>this.createdResourceGroups.delete(D));return this.createdResourceGroups.set(D,T),this.eventuallyAddResourceGroups(),D}eventuallyAddResourceGroups(){const d=[],p=[];for(const[D,T]of this.createdResourceGroups){T.dispose();const o=D.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(D),this.eventuallyUpdateResourceStates()});R.Event.once(D.onDidDispose)(()=>{this.updatedResourceGroups.delete(D),o.dispose(),this._groups.delete(D.handle),this._proxy.$unregisterGroup(this.handle,D.handle)}),d.push([D.handle,D.id,D.label,D.features]);const A=D._takeResourceStateSnapshot();A.length>0&&p.push([D.handle,A]),this._groups.set(D.handle,D)}this._proxy.$registerGroups(this.handle,d,p),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(p=>{const D=p._takeResourceStateSnapshot();D.length!==0&&d.push([p.handle,D])}),d.length>0&&this._proxy.$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,ze([(0,S.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),ze([(0,S.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let i=class xn{constructor(d,p,D){this._commands=p,this.logService=D,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=d.getProxy(y.MainContext.MainThreadSCM),this._telemetry=d.getProxy(y.MainContext.MainThreadTelemetry),p.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===3){const o=this._sourceControls.get(T.sourceControlHandle);if(!o)return T;const A=o.getResourceGroup(T.groupHandle);return A?A.getResourceState(T.handle):T}else if(T&&T.$mid===4){const o=this._sourceControls.get(T.sourceControlHandle);return o?o.getResourceGroup(T.groupHandle):T}else if(T&&T.$mid===5){const o=this._sourceControls.get(T.handle);return o||T}return T}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,p,D,T){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,p,D,T),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const o=xn._handlePool++,A=new s(d,this._proxy,this._commands,p,D,T);this._sourceControls.set(o,A);const F=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(d.identifier))||[];return F.push(A),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(d.identifier),F),A}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const p=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(d.identifier)),D=p&&p[p.length-1];return D&&D.inputBox}$provideOriginalResource(d,p,D){const T=m.URI.revive(p);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,T.toString());const o=this._sourceControls.get(d);return!o||!o.quickDiffProvider||!o.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>o.quickDiffProvider.provideOriginalResource(T,D)).then(A=>A||null)}$onInputBoxValueChange(d,p){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const D=this._sourceControls.get(d);return D&&D.inputBox.$onInputBoxValueChange(p),Promise.resolve(void 0)}$executeResourceCommand(d,p,D,T){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,p,D);const o=this._sourceControls.get(d);if(!o)return Promise.resolve(void 0);const A=o.getResourceGroup(p);return A?A.$executeResourceCommand(D,T):Promise.resolve(void 0)}$validateInput(d,p,D){this.logService.trace("ExtHostSCM#$validateInput",d);const T=this._sourceControls.get(d);return!T||!T.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>T.inputBox.validateInput(p,D)).then(o=>o?Promise.resolve([o.message,o.type]):Promise.resolve(void 0))}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};i._handlePool=0,i=ze([Ve(2,n.ILogService)],i),e.ExtHostSCM=i});var it=this&&this.__classPrivateFieldSet||function(ee,e,m,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Be=this&&this.__classPrivateFieldGet||function(ee,e,m,R){if(m==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?R:m==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[209],Ee([0,1,7,5,136,6,9]),function(ee,e,m,R,S,_,I){"use strict";var y,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class k{constructor(h,c,g,b,w=m.StatusBarAlignment.Left,P){y.set(this,void 0),E.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new _.DisposableStore,it(this,y,h,"f"),it(this,E,c,"f"),this._entryId=k.ID_GEN++,this._extension=g,this._id=b,this._alignment=w,this._priority=P}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!k.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Be(this,E,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Be(this,E,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let c;this._name?c=this._name:c=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=k.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const b=this._tooltip?I.MarkdownString.fromStrict(this._tooltip):void 0;Be(this,y,"f").$setEntry(this._entryId,h,c,this._text,b,this._command?.internal,g,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=k,y=new WeakMap,E=new WeakMap,k.ID_GEN=0,k.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const c={message:h};return this._messages.unshift(c),this._update(),new m.Disposable(()=>{const g=this._messages.indexOf(c);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class C{constructor(h,c){this._proxy=h.getProxy(R.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new n(this)}createStatusBarEntry(h,c,g,b){return new k(this._proxy,this._commands,h,c,g,b)}setStatusBarMessage(h,c){const g=this._statusMessage.setMessage(h);let b;return typeof c=="number"?b=setTimeout(()=>g.dispose(),c):typeof c!="undefined"&&c.then(()=>g.dispose(),()=>g.dispose()),new m.Disposable(()=>{g.dispose(),clearTimeout(b)})}}e.ExtHostStatusBar=C}),define(be[77],Ee([0,1,5,3,4]),function(ee,e,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class _{constructor(y){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=y.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(y,E){this._proxy.$registerExtensionStorageKeysToSync(y,E)}getValue(y,E,k){return this._proxy.$getValue(y,E).then(n=>n||k)}setValue(y,E,k){return this._proxy.$setValue(y,E,k)}$acceptValue(y,E,k){this._onDidChangeStorage.fire({shared:y,key:E,value:k})}}e.ExtHostStorage=_,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(be[78],Ee([0,1,4,29,16,76,2]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let y=class{constructor(k,n,C){this._logService=n,this._extHostFileSystem=C,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(k){return I.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,n=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(I.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:I.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(C){this._logService.error("[ExtHostStorage]",C);return}}workspaceValue(k){if(this._value)return I.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return I.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};y=ze([Ve(0,R.IExtHostInitDataService),Ve(1,S.ILogService),Ve(2,_.IExtHostConsumerFileSystem)],y),e.ExtensionStoragePaths=y}),define(be[39],Ee([0,1,3,5,4,2,13,6,7,137,12,174,20,37,158,65,10]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class w{constructor(u,d,p,D){this._proxy=u,this._id=d,this._creationOptions=p,this._name=D,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(o=>this._pidPromiseComplete=o);const T=this;this.value={get name(){return T._name||""},get processId(){return T._pidPromise},get creationOptions(){return T._creationOptions},get exitStatus(){return T._exitStatus},sendText(o,A=!0){T._checkDisposed(),T._proxy.$sendText(T._id,o,A)},show(o){T._checkDisposed(),T._proxy.$show(T._id,o)},hide(){T._checkDisposed(),T._proxy.$hide(T._id)},dispose(){T._disposed||(T._disposed=!0,T._proxy.$dispose(T._id))},get dimensions(){if(!(T._cols===void 0||T._rows===void 0))return{columns:T._cols,rows:T._rows}}}}async create(u,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,b.withNullAsUndefined)(u.shellPath),shellArgs:(0,b.withNullAsUndefined)(u.shellArgs),cwd:(0,b.withNullAsUndefined)(u.cwd),env:(0,b.withNullAsUndefined)(u.env),icon:(0,b.withNullAsUndefined)(r(u.iconPath)),color:g.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,b.withNullAsUndefined)(u.message),strictEnv:(0,b.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,b.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,b.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,b.withNullAsUndefined)(d?.useShellEnvironment),isSplitTerminal:d?.isSplitTerminal,target:d?.target})}async createExtensionTerminal(u,d,p,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:g.ThemeColor.isThemeColor(D)?D.id:void 0,isSplitTerminal:u,target:d}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,d){return u===this._cols&&d===this._rows||u===0||d===0?!1:(this._cols=u,this._rows=d,!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=w;class P{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new m.Emitter,this._onProcessTitleChanged=new m.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new m.Emitter,this._onProcessShellTypeChanged=new m.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput&&this._pty.handleInput(u)}resize(u,d){this._pty.setDimensions&&this._pty.setDimensions({columns:u,rows:d})}async processBinary(u){}acknowledgeDataEvent(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose&&this._pty.onDidClose((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d&&{cols:d.columns,rows:d.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(d=>this._onProcessTitleChanged.fire(d)),this._pty.open(u||void 0),this._pty.setDimensions&&u&&this._pty.setDimensions(u),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=P;let a=1,f=class extends y.Disposable{constructor(u,d){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this._onDidOpenTerminal=new m.Emitter,this._onDidChangeActiveTerminal=new m.Emitter,this._onDidChangeTerminalDimensions=new m.Emitter,this._proxy=d.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[p,D]of this._terminalProcesses)D.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,d){const p=new w(this._proxy,(0,h.generateUuid)(),u,u.name),D=new P(u.pty);return p.createExtensionTerminal(d?.isSplitTerminal,d?.target,r(u.iconPath),s(u.color)).then(T=>{const o=this._setupExtHostProcessListeners(T,D);this._terminalProcessDisposables[T]=o}),this._terminals.push(p),p.value}attachPtyToTerminal(u,d){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const D=new P(d),T=this._setupExtHostProcessListeners(u,D);this._terminalProcessDisposables[u]=T}async $acceptActiveTerminalChanged(u){const d=this._activeTerminal;if(u===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(u);p&&(this._activeTerminal=p,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,d){const p=this._getTerminalById(u);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:d})}async $acceptTerminalDimensions(u,d,p){const D=this._getTerminalById(u);D&&D.setDimensions(d,p)&&this._onDidChangeTerminalDimensions.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptTerminalMaximumDimensions(u,d,p){this._terminalProcesses.get(u)?.resize(d,p)}async $acceptTerminalTitleChange(u,d){const p=this._getTerminalById(u);p&&(p.name=d)}async $acceptTerminalClosed(u,d){const p=this._getTerminalObjectIndexById(this._terminals,u);if(p!==null){const D=this._terminals.splice(p,1)[0];D.setExitCode(d),this._onDidCloseTerminal.fire(D.value)}}$acceptTerminalOpened(u,d,p,D){if(d){const A=this._getTerminalObjectIndexById(this._terminals,d);if(A!==null){this._terminals[A]._id=u,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const T={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:_.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},o=new w(this._proxy,u,T,p);this._terminals.push(o),this._onDidOpenTerminal.fire(o.value),o.isOpen=!0}async $acceptTerminalProcessId(u,d){const p=this._getTerminalById(u);p&&p._setProcessId(d)}async $startExtensionTerminal(u,d){const p=this._getTerminalById(u);if(!p)return{message:(0,k.localize)(0,null,u)};p.isOpen||await new Promise(T=>{const o=this.onDidOpenTerminal(async A=>{A===p.value&&(o.dispose(),T())})});const D=this._terminalProcesses.get(u);D?D.startSendingEvents(d):this._extensionTerminalAwaitingStart[u]={initialDimensions:d}}_setupExtHostProcessListeners(u,d){const p=new y.DisposableStore;p.add(d.onProcessReady(T=>this._proxy.$sendProcessReady(u,T.pid,T.cwd))),p.add(d.onProcessTitleChanged(T=>this._proxy.$sendProcessTitle(u,T))),this._bufferer.startBuffering(u,d.onProcessData),p.add(d.onProcessExit(T=>this._onProcessExit(u,T))),d.onProcessOverrideDimensions&&p.add(d.onProcessOverrideDimensions(T=>this._proxy.$sendOverrideDimensions(u,T))),this._terminalProcesses.set(u,d);const D=this._extensionTerminalAwaitingStart[u];return D&&d instanceof P&&(d.startSendingEvents(D.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),p}$acceptProcessAckDataEvent(u,d){this._terminalProcesses.get(u)?.acknowledgeDataEvent(d)}$acceptProcessInput(u,d){this._terminalProcesses.get(u)?.input(d)}$acceptProcessResize(u,d,p){try{this._terminalProcesses.get(u)?.resize(d,p)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown(u,d){this._terminalProcesses.get(u)?.shutdown(d)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(d=>this._proxy.$sendProcessInitialCwd(u,d))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(d=>this._proxy.$sendProcessCwd(u,d))}$acceptProcessRequestLatency(u){return u}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,d,p){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,p),this._proxy.$registerProfileProvider(d,u.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(u,d){const p=new l.CancellationTokenSource().token,D=await this._profileProviders.get(u)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,d);return}this.createTerminalFromOptions(D.options,d)}}async $provideLinks(u,d){const p=this._getTerminalById(u);if(!p)return[];this._terminalLinkCache.delete(u);const D=this._terminalLinkCancellationSource.get(u);D&&D.dispose(!0);const T=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,T);const o=[],A={terminal:p.value,line:d},F=[];for(const le of this._linkProviders)F.push(new Promise(async oe=>{T.token.onCancellationRequested(()=>oe({provider:le,links:[]}));const V=await le.provideTerminalLinks(A,T.token)||[];T.token.isCancellationRequested||oe({provider:le,links:V})}));const x=await Promise.all(F);if(T.token.isCancellationRequested)return[];const K=new Map;for(const le of x)le&&le.links.length>0&&o.push(...le.links.map(oe=>{const V={id:a++,startIndex:oe.startIndex,length:oe.length,label:oe.tooltip};return K.set(V.id,{provider:le.provider,link:oe}),V}));return this._terminalLinkCache.set(u,K),o}$activateLink(u,d){const p=this._terminalLinkCache.get(u)?.get(d);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(u,d){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const p=this._terminalProcessDisposables[u];p&&(p.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,d)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,d){const p=this._getTerminalObjectIndexById(u,d);return p!==null?u[p]:null}_getTerminalObjectIndexById(u,d){let p=null;return u.some((D,T)=>D._id===d?(p=T,!0):!1),p}getEnvironmentVariableCollection(u){let d=this._environmentVariableCollections.get(u.identifier.value);return d||(d=new v,this._setEnvironmentVariableCollection(u.identifier.value,d)),d}_syncEnvironmentVariableCollection(u,d){const p=(0,C.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(u,d.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(u){u.forEach(d=>{const p=d[0],D=new v(d[1]);this._setEnvironmentVariableCollection(p,D)})}$acceptDefaultProfile(u,d){this._defaultProfile=u,this._defaultAutomationProfile=d}_setEnvironmentVariableCollection(u,d){this._environmentVariableCollections.set(u,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,d)})}};f=ze([Ve(1,I.IExtHostRpcService)],f),e.BaseExtHostTerminalService=f;class v{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,d){this._setIfDiffers(u,{value:d,type:E.EnvironmentVariableMutatorType.Replace})}append(u,d){this._setIfDiffers(u,{value:d,type:E.EnvironmentVariableMutatorType.Append})}prepend(u,d){this._setIfDiffers(u,{value:d,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,d){const p=this.map.get(u);(!p||p.value!==d.value||p.type!==d.type)&&(this.map.set(u,d),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,d){this.map.forEach((p,D)=>u.call(d,D,p,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let t=class extends f{constructor(u){super(!1,u)}createTerminal(u,d,p){throw new n.NotSupportedError}createTerminalFromOptions(u,d){throw new n.NotSupportedError}};t=ze([Ve(0,I.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function r(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function s(i){return g.ThemeColor.isThemeColor(i)?i:void 0}});var it=this&&this.__classPrivateFieldSet||function(ee,e,m,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Be=this&&this.__classPrivateFieldGet||function(ee,e,m,R){if(m==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?R:m==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[210],Ee([0,1,24,20,3,53,43,55,6,23,10,37,5,13,68,9,7,182,99,73]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b,w,P,a){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(F,x){this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(l.MainContext.MainThreadTesting),this.observer=new D(this.proxy),this.runTracker=new r(this.proxy),x.registerArgumentProcessor({processArgument:K=>K?.$mid===13?g.TestItem.toItemFromContext(K):K})}createTestController(F,x){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const K=new E.DisposableStore,le=K.add(new w.SingleUseTestCollection(F));le.root.label=x;const oe=new Map,V=this.proxy,W={items:le.root.children,get label(){return x},set label(Q){x=Q,le.root.label=Q,V.$updateControllerLabel(F,x)},get id(){return F},createRunProfile:(Q,O,j,he)=>{let $=(0,I.hash)(Q);for(;oe.has($);)$++;const ne=new T(this.proxy,F,$,Q,O,j,he);return oe.set($,ne),ne},createTestItem(Q,O,j){return new c.TestItemImpl(F,Q,O,j)},createTestRun:(Q,O,j=!0)=>this.runTracker.createTestRun(F,le,Q,O,j),set resolveHandler(Q){le.resolveHandler=Q},get resolveHandler(){return le.resolveHandler},dispose:()=>{K.dispose()}};W.createRunConfiguration=W.createRunProfile,V.$registerTestController(F,x),K.add((0,E.toDisposable)(()=>V.$unregisterTestController(F)));const L={controller:W,collection:le,profiles:oe};return this.controllers.set(F,L),K.add((0,E.toDisposable)(()=>this.controllers.delete(F))),K.add(le.onDidGenerateDiff(Q=>V.$publishDiff(F,Q))),W}createTestObserver(){return this.observer.checkout()}async runTests(F,x=R.CancellationToken.None){const K=s(F);if(!K)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const le=this.controllers.get(K.controllerId);if(!le)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:F.include?.map(oe=>oe.id)??[le.collection.root.id],profileGroup:o[K.kind],profileId:K.profileId,controllerId:K.controllerId}],exclude:F.exclude?.map(oe=>({testId:oe.id,controllerId:K.controllerId}))},x)}$provideFileCoverage(F,x,K){return y.Iterable.find(this.runTracker.trackers,le=>le.id===F)?.getCoverage(x)?.provideFileCoverage(K)??Promise.resolve([])}$resolveFileCoverage(F,x,K,le){return y.Iterable.find(this.runTracker.trackers,oe=>oe.id===F)?.getCoverage(x)?.resolveFileCoverage(K,le)??Promise.resolve([])}$configureRunProfile(F,x){this.controllers.get(F)?.profiles.get(x)?.configureHandler?.()}$publishTestResults(F){this.results=Object.freeze(F.map(x=>(0,k.deepFreeze)(g.TestResults.to(x))).concat(this.results).sort((x,K)=>K.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:F,testId:x},K){const le=this.controllers.get(F)?.collection;le&&(await le.expand(x,K<0?Infinity:K),le.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F)}async $runControllerTests(F,x){const K=this.controllers.get(F.controllerId);if(!K)return;const{collection:le,profiles:oe}=K,V=oe.get(F.profileId);if(!V)return;const W=F.testIds.map(j=>le.tree.get(j)).filter(n.isDefined),L=F.excludeExtIds.map(j=>K.collection.tree.get(j)).filter(n.isDefined).filter(j=>W.some(he=>he.fullId.compare(j.fullId)===2));if(!W.length)return;const Q=new b.TestRunRequest(W.some(j=>j.actual instanceof c.TestItemRootImpl)?void 0:W.map(j=>j.actual),L.map(j=>j.actual),V),O=this.runTracker.prepareForMainThreadTestRun(Q,i.fromInternal(F,K.collection),x);try{await V.runHandler(Q,x)}finally{O.isRunning&&!x.isCancellationRequested&&await S.Event.toPromise(O.onEnd),this.runTracker.cancelRunById(F.runId)}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}};v=ze([Ve(0,h.IExtHostRpcService)],v),e.ExtHostTesting=v;class t extends E.Disposable{constructor(F,x,K){super();this.dto=F,this.proxy=x,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new S.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new R.CancellationTokenSource(K)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:le}of this.tasks.values())le.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(F){return this.tasks.get(F)?.coverage}createRun(F){const x=this.dto.id,K=this.dto.controllerId,le=(0,C.generateUuid)(),oe=new u(this.proxy,x,le),V=Q=>(O,...j)=>{if(W){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),Q(O,...j))};let W=!1;const L={isPersisted:this.dto.isPersisted,token:this.cts.token,name:F,get coverageProvider(){return oe.coverageProvider},set coverageProvider(Q){oe.coverageProvider=Q},enqueued:V(Q=>{this.proxy.$updateTestStateInRun(x,le,a.TestId.fromExtHostTestItem(Q,K).toString(),1)}),skipped:V(Q=>{this.proxy.$updateTestStateInRun(x,le,a.TestId.fromExtHostTestItem(Q,K).toString(),5)}),started:V(Q=>{this.proxy.$updateTestStateInRun(x,le,a.TestId.fromExtHostTestItem(Q,K).toString(),2)}),errored:V((Q,O,j)=>{this.proxy.$appendTestMessagesInRun(x,le,a.TestId.fromExtHostTestItem(Q,K).toString(),O instanceof Array?O.map(g.TestMessage.from):[g.TestMessage.from(O)]),this.proxy.$updateTestStateInRun(x,le,a.TestId.fromExtHostTestItem(Q,K).toString(),6,j)}),failed:V((Q,O,j)=>{this.proxy.$appendTestMessagesInRun(x,le,a.TestId.fromExtHostTestItem(Q,K).toString(),O instanceof Array?O.map(g.TestMessage.from):[g.TestMessage.from(O)]),this.proxy.$updateTestStateInRun(x,le,a.TestId.fromExtHostTestItem(Q,K).toString(),4,j)}),passed:V((Q,O)=>{this.proxy.$updateTestStateInRun(x,le,a.TestId.fromExtHostTestItem(Q,this.dto.controllerId).toString(),3,O)}),appendOutput:Q=>{W||this.proxy.$appendOutputToRun(x,le,m.VSBuffer.fromString(Q))},end:()=>{W||(W=!0,this.proxy.$finishedTestRunTask(x,le),this.tasks.delete(le),this.isRunning||this.dispose())}};return this.tasks.set(le,{run:L,coverage:oe}),this.proxy.$startedTestRunTask(x,{id:le,name:F,running:!0}),L}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(F){if(!(F instanceof c.TestItemImpl))throw new c.InvalidTestItemError(F.id);if(this.sharedTestIds.has(F.id))return;const x=[];for(;x.unshift(g.TestItem.from(F)),!(this.sharedTestIds.has(F.id)||(this.sharedTestIds.add(F.id),!F.parent));)F=F.parent;const K=this.dto.colllection.root;this.sharedTestIds.has(K.id)||(this.sharedTestIds.add(K.id),x.unshift(g.TestItem.from(K))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,x)}}class r{constructor(F){this.proxy=F,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(F,x,K){return this.getTracker(F,x,K)}cancelRunById(F){for(const x of this.tracked.values())if(x.id===F){x.dispose();return}}cancelAllRuns(){for(const F of this.tracked.values())F.dispose()}createTestRun(F,x,K,le,oe){const V=this.tracked.get(K);if(V)return V.createRun(le);const W=i.fromPublic(F,x,K,oe),L=s(K);this.proxy.$startedExtensionTestRun({controllerId:F,profile:L&&{group:o[L.kind],id:L.profileId},exclude:K.exclude?.map(O=>O.id)??[],id:W.id,include:K.include?.map(O=>O.id)??[x.root.id],persist:oe});const Q=this.getTracker(K,W);return Q.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),Q.createRun(le)}getTracker(F,x,K){const le=new t(x,this.proxy,K);return this.tracked.set(F,le),le.onEnd(()=>this.tracked.delete(F)),le}}e.TestRunCoordinator=r;const s=A=>{if(!!A.profile){if(!(A.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return A.profile}};class i{constructor(F,x,K,le,oe,V){this.controllerId=F,this.id=x,this.isPersisted=oe,this.colllection=V,this.includePrefix=K.map(W=>W+"\0"),this.excludePrefix=le.map(W=>W+"\0")}static fromPublic(F,x,K,le){return new i(F,(0,C.generateUuid)(),K.include?.map(oe=>a.TestId.fromExtHostTestItem(oe,F).toString())??[F],K.exclude?.map(oe=>a.TestId.fromExtHostTestItem(oe,F).toString())??[],le,x)}static fromInternal(F,x){return new i(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,x)}isIncluded(F){const x=a.TestId.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const K of this.excludePrefix)if(x===K||x.startsWith(K))return!1;for(const K of this.includePrefix)if(x===K||x.startsWith(K))return!0;return!1}}e.TestRunDto=i;class u{constructor(F,x,K){this.proxy=F,this.runId=x,this.taskId=K}set coverageProvider(F){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!F||(this._coverageProvider=F,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(F){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(F))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(x){throw this.fileCoverage=void 0,x}}async resolveFileCoverage(F,x){const K=await this.fileCoverage;let le=K?.[F];return!this._coverageProvider||!K||!le?[]:(le.detailedCoverage||(le=K[F]=await this._coverageProvider.resolveFileCoverage?.(le,x)??le),le.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class d extends P.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,g.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:x,removed:K}=this;return{get added(){return[...F].map(le=>le.revived)},get updated(){return[...x].map(le=>le.revived)},get removed(){return[...K].map(le=>le.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class p extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,x){return{...F,revived:g.TestItem.toPlain(F.item),depth:x?x.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=p;class D{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(x=>x.revived)},dispose:(0,_.once)(()=>{--F.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){return this.current?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.current?.tests.apply(F)}createObserverData(){const F=new p;return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}class T{constructor(F,x,K,le,oe,V,W=!1){this.controllerId=x,this.profileId=K,this._label=le,this.kind=oe,this.runHandler=V,this._isDefault=W,f.set(this,void 0),it(this,f,F,"f");const L=o[oe];if(typeof L!="number")throw new Error(`Unknown TestRunProfile.group ${oe}`);Be(this,f,"f").$publishTestRunProfile({profileId:K,controllerId:x,label:le,group:L,isDefault:W,hasConfigurationHandler:!1})}get label(){return this._label}set label(F){F!==this._label&&(this._label=F,Be(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get isDefault(){return this._isDefault}set isDefault(F){F!==this._isDefault&&(this._isDefault=F,Be(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get configureHandler(){return this._configureHandler}set configureHandler(F){F!==this._configureHandler&&(this._configureHandler=F,Be(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}dispose(){Be(this,f,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=T,f=new WeakMap;const o={[b.TestRunProfileKind.Coverage]:8,[b.TestRunProfileKind.Debug]:4,[b.TestRunProfileKind.Run]:2}}),define(be[211],Ee([0,1,3,17,5,102,9,7]),function(ee,e,m,R,S,_,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(n,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const C=this._extHostDocumentsAndEditors.allEditors();return n?C:C.map(l=>l.value)}async showTextDocument(n,C,l){let h;typeof C=="number"?h={position:I.ViewColumn.from(C),preserveFocus:l}:typeof C=="object"?h={position:I.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?I.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:h={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(n.uri,h),g=c&&this._extHostDocumentsAndEditors.getEditor(c);if(g)return g.value;throw c?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,C){return new _.TextEditorDecorationType(this._proxy,n,C).value}$acceptEditorPropertiesChanged(n,C){const l=this._extHostDocumentsAndEditors.getEditor(n);if(!l)throw new Error("unknown text editor");if(C.options&&l._acceptOptions(C.options),C.selections){const h=C.selections.selections.map(I.Selection.to);l._acceptSelections(h)}if(C.visibleRanges){const h=R.coalesce(C.visibleRanges.map(I.Range.to));l._acceptVisibleRanges(h)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...C.options,lineNumbers:I.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const h=y.TextEditorSelectionChangeKind.fromValue(C.selections.source),c=C.selections.selections.map(I.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:c,kind:h})}if(C.visibleRanges){const h=R.coalesce(C.visibleRanges.map(I.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:h})}}$acceptEditorPositionData(n){for(const C in n){const l=this._extHostDocumentsAndEditors.getEditor(C);if(!l)throw new Error("Unknown text editor");const h=I.ViewColumn.to(n[C]);l.value.viewColumn!==h&&(l._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:h}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=E}),define(be[212],Ee([0,1,2,4,5,6,7]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class y{constructor(n,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(S.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const h=l.uri===void 0?void 0:m.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(E(h))?.get(l.handle)}return l}})}async $getTimeline(n,C,l,h,c){return this._providers.get(n)?.provideTimeline(m.URI.revive(C),l,h,c)}registerTimelineProvider(n,C,l,h){const c=new _.DisposableStore,g=this.convertTimelineItem(C.id,h,c).bind(this);let b;C.onDidChange&&(b=C.onDidChange(P=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...P,id:C.id}),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:n,onDidChange:void 0,async provideTimeline(P,a,f,v){v?.resetCache&&(c.clear(),w.get(C.id)?.clear());const t=await C.provideTimeline(P,a,f);if(t==null)return;const r=g(P,v);return{...t,source:C.id,items:t.items.map(r)}},dispose(){for(const P of w.values())P.get(C.id)?.clear();b?.dispose(),c.dispose()}})}convertTimelineItem(n,C,l){return(h,c)=>{let g;if(c?.cacheResults){let b=this._itemsBySourceAndUriMap.get(n);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(n,b));const w=E(h);g=b.get(w),g===void 0&&(g=new Map,b.set(w,g))}return b=>{const{iconPath:w,...P}=b,a=`${n}|${b.id??b.timestamp}`;g?.set(a,b);let f,v,t;return b.iconPath&&(w instanceof I.ThemeIcon?t={id:w.id,color:w.color}:m.URI.isUri(w)?(f=w,v=w):{light:f,dark:v}=w),{...P,id:P.id??void 0,handle:a,source:n,command:b.command?C.toInternal(b.command,l):void 0,icon:f,iconDark:v,themeIcon:t,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,_.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=y;function E(k){return k?.toString()}}),define(be[213],Ee([0,1,6,11,2,5]),function(ee,e,m,R,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(E){this._openers=new Map,this._proxy=E.getProxy(_.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,k,n,C){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const l=C.schemes.find(h=>!I.supportedSchemes.has(h));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,n),this._proxy.$registerUriOpener(k,C.schemes,E,C.label),(0,m.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(E,k,n){const C=this._openers.get(E);if(!C)throw new Error(`Unknown opener with id: ${E}`);const l=S.URI.revive(k);return C.canOpenExternalUri(l,n)}async $openUri(E,k,n){const C=this._openers.get(E);if(!C)throw new Error(`Unknown opener id: '${E}'`);return C.openExternalUri(S.URI.revive(k.resolvedUri),{sourceUri:S.URI.revive(k.sourceUri)},n)}}e.ExtHostUriOpeners=I,I.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(be[214],Ee([0,1,5,2,6,12,26]),function(ee,e,m,R,S,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class y{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(k,n){if(this.handles.has(I.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const C=y.HandlePool++;return this.handles.add(I.ExtensionIdentifier.toKey(k)),this.handlers.set(C,n),this._proxy.$registerUriHandler(C,k),(0,S.toDisposable)(()=>{this.handles.delete(I.ExtensionIdentifier.toKey(k)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(k,n){const C=this.handlers.get(k);if(!C)return Promise.resolve(void 0);try{C.handleUri(R.URI.revive(n))}catch(l){(0,_.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(k){return R.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=y,y.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(ee,e,m,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Be=this&&this.__classPrivateFieldGet||function(ee,e,m,R){if(m==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?R:m==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[50],Ee([0,1,3,2,147,166,71,5]),function(ee,e,m,R,S,_,I,y){"use strict";var E,k,n,C,l,h,c,g,b,w,P,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(p,D,T,o,A,F,x){E.set(this,void 0),k.set(this,void 0),n.set(this,void 0),C.set(this,void 0),l.set(this,void 0),h.set(this,void 0),c.set(this,""),g.set(this,void 0),b.set(this,!1),w.set(this,!1),P.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new m.Emitter),this._onDidDispose=Be(this,a,"f").event,it(this,E,p,"f"),it(this,k,D,"f"),it(this,g,T,"f"),it(this,C,o,"f"),it(this,l,A,"f"),it(this,h,F,"f"),it(this,P,v(F),"f"),it(this,n,x,"f")}dispose(){it(this,b,!0,"f"),Be(this,a,"f").fire(),Be(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return it(this,w,!0,"f"),(0,I.asWebviewUri)(p,Be(this,C,"f").remote)}get cspSource(){return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,c,"f")}set html(p){this.assertNotDisposed(),Be(this,c,"f")!==p&&(it(this,c,p,"f"),!Be(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(it(this,w,!0,"f"),Be(this,n,"f").report("Webview vscode-resource: uris",Be(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,k,"f").$setHtml(Be(this,E,"f"),p))}get options(){return this.assertNotDisposed(),Be(this,g,"f")}set options(p){this.assertNotDisposed(),Be(this,k,"f").$setOptions(Be(this,E,"f"),s(Be(this,h,"f"),Be(this,l,"f"),p)),it(this,g,p,"f")}async postMessage(p){if(Be(this,b,"f"))return!1;const D=(0,_.serializeWebviewMessage)(p,{serializeBuffersForPostMessage:Be(this,P,"f")});return Be(this,k,"f").$postMessage(Be(this,E,"f"),D.message,...D.buffers)}assertNotDisposed(){if(Be(this,b,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,E=new WeakMap,k=new WeakMap,n=new WeakMap,C=new WeakMap,l=new WeakMap,h=new WeakMap,c=new WeakMap,g=new WeakMap,b=new WeakMap,w=new WeakMap,P=new WeakMap,a=new WeakMap;function v(d){try{const p=(0,S.normalizeVersion)((0,S.parseVersion)(d.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(p,D,T,o,A){this.initData=D,this.workspace=T,this._logService=o,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=p.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(p,D,...T){const o=this.getWebview(p);if(o){const{message:A}=(0,_.deserializeWebviewMessage)(D,T);o._onMessageEmitter.fire(A)}}$onMissingCsp(p,D){this._logService.warn(`${D} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,D,T){const o=new f(p,this._webviewProxy,i(D),this.initData,this.workspace,T,this._deprecationService);return this._webviews.set(p,o),o._onDidDispose(()=>{this._webviews.delete(p)}),o}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=t;function r(d){return{id:d.identifier,location:d.extensionLocation}}e.toExtensionData=r;function s(d,p,D){return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,portMapping:D.portMapping,localResourceRoots:D.localResourceRoots||u(d,p)}}e.serializeWebviewOptions=s;function i(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map(p=>R.URI.from(p))}}e.reviveOptions=i;function u(d,p){return[...(p?.getWorkspaceFolders()||[]).map(D=>D.uri),d.extensionLocation]}}),define(be[215],Ee([0,1,20,43,6,11,25,2,9,50,66,5,7]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=f(this.document.uri)+this._backupCounter++;return(0,I.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class c{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,s){const i=this.key(t,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const u=new h(r,s);return this._documents.set(i,u),u}delete(t,r){const s=this.key(t,r.uri);this._documents.delete(s)}key(t,r){return`${t}@@@${r}`}}var g;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(g||(g={}));class b{constructor(){this._providers=new Map}addTextProvider(t,r,s){return this.add(0,t,r,s)}addCustomProvider(t,r,s){return this.add(1,t,r,s)}get(t){return this._providers.get(t)}add(t,r,s,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:s,provider:i}),new l.Disposable(()=>this._providers.delete(r))}}class w{constructor(t,r,s,i,u){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=u,this._editorProviders=new b,this._documents=new c,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,s,i){const u=new S.DisposableStore;return P(s)?(u.add(this._editorProviders.addTextProvider(r,t,s)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),r,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(u.add(this._editorProviders.addCustomProvider(r,t,s)),this.supportEditing(s)&&u.add(s.onDidChangeCustomDocument(d=>{const p=this.getCustomDocumentEntry(r,d.document.uri);if(a(d)){const D=p.addEdit(d);this._proxy.$onDidEdit(d.document.uri,r,D,d.label)}else this._proxy.$onContentChange(d.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),l.Disposable.from(u,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,s,i,u){const d=this._editorProviders.get(r);if(!d)throw new Error(`No provider found for '${r}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${r}'`);const p=y.URI.revive(t),D=await d.provider.openCustomDocument(p,{backupId:s,untitledDocumentData:i?.buffer},u);let T;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(T=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(r,D,T),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(t,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=y.URI.revive(t),{document:u}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,u),u.dispose()}async $resolveWebviewEditor(t,r,s,i,u,d){const p=this._editorProviders.get(s);if(!p)throw new Error(`No provider found for '${s}'`);const D=E.ViewColumn.to(u),T=this._extHostWebview.createNewWebview(r,i.webviewOptions,p.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(r,s,i.title,D,i.panelOptions,T),A=y.URI.revive(t);switch(p.type){case 1:{const{document:F}=this.getCustomDocumentEntry(s,A);return p.provider.resolveCustomEditor(F,o,d)}case 0:{const F=this._extHostDocuments.getDocument(A);return p.provider.resolveCustomTextEditor(F,o,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,s){this.getCustomDocumentEntry(r,t).disposeEdits(s)}async $onMoveCustomEditor(t,r,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const u=this._extHostWebviewPanels.getWebviewPanel(t);if(!u)throw new Error("No webview found");const d=y.URI.revive(r),p=this._extHostDocuments.getDocument(d);await i.provider.moveCustomTextEditor(p,u,m.CancellationToken.None)}async $undo(t,r,s,i){return this.getCustomDocumentEntry(r,t).undo(s,i)}async $redo(t,r,s,i){return this.getCustomDocumentEntry(r,t).redo(s,i)}async $revert(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(t,r,s,i){const u=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(u.document,y.URI.revive(s),i)}async $backup(t,r,s){const i=this.getCustomDocumentEntry(r,t),d=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(d),d.id}getCustomDocumentEntry(t,r){const s=this._documents.get(t,y.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const s=this._editorProviders.get(t)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function P(v){return typeof v.resolveCustomTextEditor=="function"}function a(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function f(v){const t=v.scheme===_.Schemas.file||v.scheme===_.Schemas.untitled?v.fsPath:v.toString();return(0,R.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(ee,e,m,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Be=this&&this.__classPrivateFieldGet||function(ee,e,m,R){if(m==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?R:m==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[216],Ee([0,1,3,6,2,37,9,50,5,7]),function(ee,e,m,R,S,_,I,y,E,k){"use strict";var n,C,l,h,c,g,b,w,P,a,f,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends R.Disposable{constructor(d,p,D,T,o,A,F){super();n.set(this,void 0),C.set(this,void 0),l.set(this,void 0),h.set(this,void 0),c.set(this,void 0),g.set(this,void 0),b.set(this,void 0),w.set(this,void 0),P.set(this,!0),a.set(this,!0),f.set(this,!1),v.set(this,this._register(new m.Emitter)),this.onDidDispose=Be(this,v,"f").event,t.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,it(this,n,d,"f"),it(this,C,p,"f"),it(this,l,D,"f"),it(this,c,A,"f"),it(this,w,o,"f"),it(this,g,T,"f"),it(this,h,F,"f")}dispose(){Be(this,f,"f")||(it(this,f,!0,"f"),Be(this,v,"f").fire(),Be(this,C,"f").$disposeWebview(Be(this,n,"f")),Be(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,h,"f")}get viewType(){return this.assertNotDisposed(),Be(this,l,"f")}get title(){return this.assertNotDisposed(),Be(this,g,"f")}set title(d){this.assertNotDisposed(),Be(this,g,"f")!==d&&(it(this,g,d,"f"),Be(this,C,"f").$setTitle(Be(this,n,"f"),d))}get iconPath(){return this.assertNotDisposed(),Be(this,b,"f")}set iconPath(d){this.assertNotDisposed(),Be(this,b,"f")!==d&&(it(this,b,d,"f"),Be(this,C,"f").$setIconPath(Be(this,n,"f"),S.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Be(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,w,"f")=="number"&&Be(this,w,"f")<0))return Be(this,w,"f")}get active(){return this.assertNotDisposed(),Be(this,a,"f")}get visible(){return this.assertNotDisposed(),Be(this,P,"f")}_updateViewState(d){Be(this,f,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(it(this,a,d.active,"f"),it(this,P,d.visible,"f"),it(this,w,d.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(d,p){this.assertNotDisposed(),Be(this,C,"f").$reveal(Be(this,n,"f"),{viewColumn:d?I.ViewColumn.from(d):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Be(this,f,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,C=new WeakMap,l=new WeakMap,h=new WeakMap,c=new WeakMap,g=new WeakMap,b=new WeakMap,w=new WeakMap,P=new WeakMap,a=new WeakMap,f=new WeakMap,v=new WeakMap,t=new WeakMap;class s{constructor(d,p,D){this.webviews=p,this.workspace=D,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,_.generateUuid)()}createWebviewPanel(d,p,D,T,o={}){const A=typeof T=="object"?T.viewColumn:T,F={viewColumn:I.ViewColumn.from(A),preserveFocus:typeof T=="object"&&!!T.preserveFocus},x=(0,y.shouldSerializeBuffersForPostMessage)(d),K=s.newHandle();this._proxy.$createWebviewPanel((0,y.toExtensionData)(d),K,p,{title:D,panelOptions:i(o),webviewOptions:(0,y.serializeWebviewOptions)(d,this.workspace,o),serializeBuffersForPostMessage:x},F);const le=this.webviews.createNewWebview(K,o,d);return this.createNewWebviewPanel(K,p,D,A,o,le)}$onDidChangeWebviewPanelViewStates(d){const p=Object.keys(d);p.sort((D,T)=>{const o=d[D],A=d[T];return o.active?1:A.active?-1:+o.visible-+A.visible});for(const D of p){const T=this.getWebviewPanel(D);if(!T)continue;const o=d[D];T._updateViewState({active:o.active,visible:o.visible,viewColumn:I.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,p,D){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:D,extension:d}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(d)}),new k.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(d,p,D,T){const o=this._serializers.get(p);if(!o)throw new Error(`No serializer found for '${p}'`);const{serializer:A,extension:F}=o,x=this.webviews.createNewWebview(d,D.webviewOptions,F),K=this.createNewWebviewPanel(d,p,D.title,T,D.panelOptions,x);await A.deserializeWebviewPanel(K,D.state)}createNewWebviewPanel(d,p,D,T,o,A){const F=new r(d,this._proxy,p,D,T,o,A);return this._webviewPanels.set(d,F),F}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=s;function i(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(ee,e,m,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Be=this&&this.__classPrivateFieldGet||function(ee,e,m,R){if(m==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?R:m==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[217],Ee([0,1,3,6,50,5,7]),function(ee,e,m,R,S,_,I){"use strict";var y,E,k,n,C,l,h,c,g,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(f,v,t,r,s,i){super();y.set(this,void 0),E.set(this,void 0),k.set(this,void 0),n.set(this,void 0),C.set(this,!1),l.set(this,void 0),h.set(this,void 0),c.set(this,void 0),g.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Be(this,g,"f").event,b.set(this,this._register(new m.Emitter)),this.onDidDispose=Be(this,b,"f").event,it(this,k,t,"f"),it(this,h,r,"f"),it(this,y,f,"f"),it(this,E,v,"f"),it(this,n,s,"f"),it(this,l,i,"f")}dispose(){Be(this,C,"f")||(it(this,C,!0,"f"),Be(this,b,"f").fire(),Be(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,h,"f")}set title(f){this.assertNotDisposed(),Be(this,h,"f")!==f&&(it(this,h,f,"f"),Be(this,E,"f").$setWebviewViewTitle(Be(this,y,"f"),f))}get description(){return this.assertNotDisposed(),Be(this,c,"f")}set description(f){this.assertNotDisposed(),Be(this,c,"f")!==f&&(it(this,c,f,"f"),Be(this,E,"f").$setWebviewViewDescription(Be(this,y,"f"),f))}get visible(){return Be(this,l,"f")}get webview(){return Be(this,n,"f")}get viewType(){return Be(this,k,"f")}_setVisible(f){f===Be(this,l,"f")||Be(this,C,"f")||(it(this,l,f,"f"),Be(this,g,"f").fire())}show(f){this.assertNotDisposed(),Be(this,E,"f").$show(Be(this,y,"f"),!!f)}assertNotDisposed(){if(Be(this,C,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,E=new WeakMap,k=new WeakMap,n=new WeakMap,C=new WeakMap,l=new WeakMap,h=new WeakMap,c=new WeakMap,g=new WeakMap,b=new WeakMap;class P{constructor(f,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,v,t,r){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:f}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(f),v,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new I.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(f,v,t,r,s){const i=this._viewProviders.get(v);if(!i)throw new Error(`No view provider found for '${v}'`);const{provider:u,extension:d}=i,p=this._extHostWebview.createNewWebview(f,{},d),D=new w(f,this._proxy,v,t,p,!0);this._webviewViews.set(f,D),await u.resolveWebviewView(D,{state:r},s)}async $onDidChangeWebviewViewVisibility(f,v){this.getWebviewView(f)._setVisible(v)}async $disposeWebviewView(f){const v=this.getWebviewView(f);this._webviewViews.delete(f),v.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const v=this._webviewViews.get(f);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=P}),define(be[106],Ee([0,1,3,5,2,11,8,4,13]),function(ee,e,m,R,S,_,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Bn{constructor(C){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Bn.InitialState,this._proxy=C.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state={...this._state,focused:C},this._onDidChangeWindowState.fire(this._state))}openUri(C,l){let h;if(typeof C=="string"){h=C;try{C=S.URI.parse(C)}catch(c){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,I.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===_.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,h,l)}async asExternalUri(C,l){if((0,I.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(C,l);return S.URI.from(h)}};k.InitialState={focused:!0},k=ze([Ve(0,E.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,y.createDecorator)("IExtHostWindow")}),define(be[218],Ee([0,1,16,5,29,13]),function(ee,e,m,R,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let I=class extends m.AbstractLogger{constructor(E,k){super();this._proxy=E.getProxy(R.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(E){this.setLevel(E)}trace(E,...k){this.getLevel()<=m.LogLevel.Trace&&this._proxy.$log(this._logFile,m.LogLevel.Trace,Array.from(arguments))}debug(E,...k){this.getLevel()<=m.LogLevel.Debug&&this._proxy.$log(this._logFile,m.LogLevel.Debug,Array.from(arguments))}info(E,...k){this.getLevel()<=m.LogLevel.Info&&this._proxy.$log(this._logFile,m.LogLevel.Info,Array.from(arguments))}warn(E,...k){this.getLevel()<=m.LogLevel.Warning&&this._proxy.$log(this._logFile,m.LogLevel.Warning,Array.from(arguments))}error(E,...k){this.getLevel()<=m.LogLevel.Error&&this._proxy.$log(this._logFile,m.LogLevel.Error,Array.from(arguments))}critical(E,...k){this.getLevel()<=m.LogLevel.Critical&&this._proxy.$log(this._logFile,m.LogLevel.Critical,Array.from(arguments))}flush(){}};I=ze([Ve(0,_.IExtHostRpcService),Ve(1,S.IExtHostInitDataService)],I),e.ExtHostLogService=I}),define(be[219],Ee([0,1,15,20,12,3,6,117,187,103,24]),function(ee,e,m,R,S,_,I,y,E,k,n){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(i,u){try{return JSON.stringify(i,u)}catch(d){return"null"}}function h(i,u){return JSON.stringify(i,u)}function c(i){return i?(u,d)=>d&&d.$mid===1?i.transformOutgoing(d):d:null}var g;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},P=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class f extends I.Disposable{constructor(u,d=null,p=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=u,this._logger=d,this._uriTransformer=p,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,T=k.ProxyIdentifier.count;D<T;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(u=>{this._pendingRPCReplies[u].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(u){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(u){this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(u){this._responsiveState!==u&&(this._responsiveState=u,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(u){return this._uriTransformer?(0,y.transformIncomingURIs)(u,this._uriTransformer):u}getProxy(u){const{nid:d,sid:p}=u;return this._proxies[d]||(this._proxies[d]=this._createProxy(d,p)),this._proxies[d]}_createProxy(u,d){let p={get:(D,T)=>(typeof T=="string"&&!D[T]&&T.charCodeAt(0)===36&&(D[T]=(...o)=>this._remoteCall(u,T,o)),T===a?d:D[T])};return new Proxy(Object.create(null),p)}set(u,d){return this._locals[u.nid]=d,d}assertRegistered(u){for(let d=0,p=u.length;d<p;d++){const D=u[d];if(!this._locals[D.nid])throw new Error(`Missing actor ${D.sid} (isMain: ${D.isMain})`)}}_receiveOneMessage(u){if(this._isDisposed)return;const d=u.byteLength,p=v.read(u,0),D=p.readUInt8(),T=p.readUInt32();switch(D){case 1:case 2:{let{rpcId:o,method:A,args:F}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(F=(0,y.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(d,T,o,A,F,D===2);break}case 3:case 4:{let{rpcId:o,method:A,args:F}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(F=(0,y.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(d,T,o,A,F,D===4);break}case 5:{this._logger&&this._logger.logIncoming(d,T,0,"ack"),this._onDidReceiveAcknowledge(T);break}case 6:{this._receiveCancel(d,T);break}case 7:{this._receiveReply(d,T,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(p);this._uriTransformer&&(o=(0,y.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReply(d,T,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(p);this._receiveReply(d,T,o);break}case 10:{let o=t.deserializeReplyErrError(p);this._uriTransformer&&(o=(0,y.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReplyErr(d,T,o);break}case 11:{this._receiveReplyErr(d,T,void 0);break}default:console.error("received unexpected message"),console.error(u)}}_receiveRequest(u,d,p,D,T,o){this._logger&&this._logger.logIncoming(u,d,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(p)}.${D}(`,T);const A=String(d);let F,x;if(o){const le=new R.CancellationTokenSource;T.push(le.token),F=this._invokeHandler(p,D,T),x=()=>le.cancel()}else F=this._invokeHandler(p,D,T),x=w;this._cancelInvokedHandlers[A]=x;const K=t.serializeAcknowledged(d);this._logger&&this._logger.logOutgoing(K.byteLength,d,1,"ack"),this._protocol.send(K),F.then(le=>{delete this._cancelInvokedHandlers[A];const oe=t.serializeReplyOK(d,le,this._uriReplacer);this._logger&&this._logger.logOutgoing(oe.byteLength,d,1,"reply:",le),this._protocol.send(oe)},le=>{delete this._cancelInvokedHandlers[A];const oe=t.serializeReplyErr(d,le);this._logger&&this._logger.logOutgoing(oe.byteLength,d,1,"replyErr:",le),this._protocol.send(oe)})}_receiveCancel(u,d){this._logger&&this._logger.logIncoming(u,d,1,"receiveCancel");const p=String(d);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(u,d,p){this._logger&&this._logger.logIncoming(u,d,0,"receiveReply:",p);const D=String(d);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const T=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],T.resolveOk(p)}_receiveReplyErr(u,d,p){this._logger&&this._logger.logIncoming(u,d,0,"receiveReplyErr:",p);const D=String(d);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const T=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let o;p&&(p.$isError?(o=new Error,o.name=p.name,o.message=p.message,o.stack=p.stack):o=p),T.resolveErr(o)}_invokeHandler(u,d,p){try{return Promise.resolve(this._doInvokeHandler(u,d,p))}catch(D){return Promise.reject(D)}}_doInvokeHandler(u,d,p){const D=this._locals[u];if(!D)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(u));let T=D[d];if(typeof T!="function")throw new Error("Unknown method "+d+" on actor "+(0,k.getStringIdentifierForProxy)(u));return T.apply(D,p)}_remoteCall(u,d,p){if(this._isDisposed)return Promise.reject(S.canceled());let D=null;if(p.length>0&&R.CancellationToken.isCancellationToken(p[p.length-1])&&(D=p.pop()),D&&D.isCancellationRequested)return Promise.reject(S.canceled());const T=t.serializeRequestArguments(p,this._uriReplacer),o=++this._lastMessageId,A=String(o),F=new E.LazyPromise;D&&D.onCancellationRequested(()=>{const K=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(K.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[A]=F,this._onWillSendRequest(o);const x=t.serializeRequest(o,u,d,T,!!D);return this._logger&&this._logger.logOutgoing(x.byteLength,o,0,`request: ${(0,k.getStringIdentifierForProxy)(u)}.${d}(`,p),this._protocol.send(x),F}}e.RPCProtocol=f,C=P,f.UNRESPONSIVE_TIME=3*1e3;class v{constructor(u,d){this._buff=u,this._offset=d}static alloc(u,d,p){let D=new v(n.VSBuffer.alloc(p+1+4),0);return D.writeUInt8(u),D.writeUInt32(d),D}static read(u,d){return new v(u,d)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(u){this._buff.writeUInt8(u,this._offset),this._offset+=1}readUInt8(){const u=this._buff.readUInt8(this._offset);return this._offset+=1,u}writeUInt32(u){this._buff.writeUInt32BE(u,this._offset),this._offset+=4}readUInt32(){const u=this._buff.readUInt32BE(this._offset);return this._offset+=4,u}static sizeShortString(u){return 1+u.byteLength}writeShortString(u){this._buff.writeUInt8(u.byteLength,this._offset),this._offset+=1,this._buff.set(u,this._offset),this._offset+=u.byteLength}readShortString(){const u=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,p}static sizeLongString(u){return 4+u.byteLength}writeLongString(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readLongString(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,p}writeBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}static sizeVSBuffer(u){return 4+u.byteLength}writeVSBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readVSBuffer(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const d=this._buff.slice(this._offset,this._offset+u);return this._offset+=u,d}static sizeMixedArray(u,d){let p=0;p+=1;for(let D=0,T=u.length;D<T;D++){const o=u[D],A=d[D];switch(p+=1,A){case 1:p+=this.sizeLongString(o);break;case 2:p+=this.sizeVSBuffer(o);break;case 3:break}}return p}writeMixedArray(u,d){this._buff.writeUInt8(u.length,this._offset),this._offset+=1;for(let p=0,D=u.length;p<D;p++){const T=u[p];switch(d[p]){case 1:this.writeUInt8(1),this.writeLongString(T);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const u=this._buff.readUInt8(this._offset);this._offset+=1;let d=new Array(u);for(let p=0;p<u;p++)switch(this.readUInt8()){case 1:d[p]=this.readLongString();break;case 2:d[p]=this.readVSBuffer();break;case 3:d[p]=void 0;break}return d}}class t{static _arrayContainsBufferOrUndefined(u){for(let d=0,p=u.length;d<p;d++)if(u[d]instanceof n.VSBuffer||typeof u[d]=="undefined")return!0;return!1}static serializeRequestArguments(u,d){if(this._arrayContainsBufferOrUndefined(u)){let p=[],D=[];for(let T=0,o=u.length;T<o;T++){const A=u[T];A instanceof n.VSBuffer?(p[T]=A,D[T]=2):typeof A=="undefined"?(p[T]=n.VSBuffer.alloc(0),D[T]=3):(p[T]=n.VSBuffer.fromString(h(A,d)),D[T]=1)}return{type:"mixed",args:p,argsType:D}}return{type:"simple",args:h(u,d)}}static serializeRequest(u,d,p,D,T){return D.type==="mixed"?this._requestMixedArgs(u,d,p,D.args,D.argsType,T):this._requestJSONArgs(u,d,p,D.args,T)}static _requestJSONArgs(u,d,p,D,T){const o=n.VSBuffer.fromString(p),A=n.VSBuffer.fromString(D);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(o),F+=v.sizeLongString(A);let x=v.alloc(T?2:1,u,F);return x.writeUInt8(d),x.writeShortString(o),x.writeLongString(A),x.buffer}static deserializeRequestJSONArgs(u){const d=u.readUInt8(),p=u.readShortString(),D=u.readLongString();return{rpcId:d,method:p,args:JSON.parse(D)}}static _requestMixedArgs(u,d,p,D,T,o){const A=n.VSBuffer.fromString(p);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(A),F+=v.sizeMixedArray(D,T);let x=v.alloc(o?4:3,u,F);return x.writeUInt8(d),x.writeShortString(A),x.writeMixedArray(D,T),x.buffer}static deserializeRequestMixedArgs(u){const d=u.readUInt8(),p=u.readShortString(),D=u.readMixedArray(),T=new Array(D.length);for(let o=0,A=D.length;o<A;o++){const F=D[o];typeof F=="string"?T[o]=JSON.parse(F):T[o]=F}return{rpcId:d,method:p,args:T}}static serializeAcknowledged(u){return v.alloc(5,u,0).buffer}static serializeCancel(u){return v.alloc(6,u,0).buffer}static serializeReplyOK(u,d,p){return typeof d=="undefined"?this._serializeReplyOKEmpty(u):d instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(u,d):this._serializeReplyOKJSON(u,l(d,p))}static _serializeReplyOKEmpty(u){return v.alloc(7,u,0).buffer}static _serializeReplyOKVSBuffer(u,d){let p=0;p+=v.sizeVSBuffer(d);let D=v.alloc(8,u,p);return D.writeVSBuffer(d),D.buffer}static deserializeReplyOKVSBuffer(u){return u.readVSBuffer()}static _serializeReplyOKJSON(u,d){const p=n.VSBuffer.fromString(d);let D=0;D+=v.sizeLongString(p);let T=v.alloc(9,u,D);return T.writeLongString(p),T.buffer}static deserializeReplyOKJSON(u){const d=u.readLongString();return JSON.parse(d)}static serializeReplyErr(u,d){return d?this._serializeReplyErrEror(u,d):this._serializeReplyErrEmpty(u)}static _serializeReplyErrEror(u,d){const p=n.VSBuffer.fromString(l(S.transformErrorForSerialization(d),null));let D=0;D+=v.sizeLongString(p);let T=v.alloc(10,u,D);return T.writeLongString(p),T.buffer}static deserializeReplyErrError(u){const d=u.readLongString();return JSON.parse(d)}static _serializeReplyErrEmpty(u){return v.alloc(11,u,0).buffer}}var r;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var s;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(s||(s={}))}),define(be[220],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const m=function(_){const I=y=>{self.removeEventListener("message",I);const E=y.data;Object.defineProperties(self,{postMessage:{value(k,n){E.postMessage(k,n)}},onmessage:{get(){return E.onmessage},set(k){E.onmessage=k}}}),E.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),E.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(_)};self.addEventListener("message",I)}.toString();class R extends EventTarget{constructor(_,I,y){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${m})('${I}'))`,k=new Blob([E],{type:"application/javascript"}),n=URL.createObjectURL(k),C=new MessageChannel,l=n,h={type:"_newWorker",id:l,port:C.port2,url:n,options:y};_(h,[C.port2]),this.postMessage=C.port1.postMessage.bind(C.port1),this.terminate=()=>{const c={type:"_terminateWorker",id:l};C.port1.postMessage(c),URL.revokeObjectURL(n),C.port1.close(),C.port2.close()},Object.defineProperties(this,{onmessage:{get(){return C.port1.onmessage},set(c){C.port1.onmessage=c}},onmessageerror:{get(){return C.port1.onmessageerror},set(c){C.port1.onmessageerror=c}}}),C.port1.addEventListener("messageerror",c=>{const g=new MessageEvent("messageerror",{data:c.data});this.dispatchEvent(g)}),C.port1.addEventListener("message",c=>{const g=new MessageEvent("message",{data:c.data});this.dispatchEvent(g)}),C.port1.start()}}e.NestedWorker=R}),define(be[221],Ee([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(be[222],Ee([0,1,11,14,22,2,4,96,46,183,221]),function(ee,e,m,R,S,_,I,y,E,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,I.createDecorator)("pathService");let C=class $n{constructor(h,c,g,b){this.localUserHome=h,this.remoteAgentService=c,this.environmentService=g,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||S.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome||h})()}get defaultUriScheme(){return $n.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,c){if(h.remoteAuthority)return m.Schemas.vscodeRemote;const g=(0,y.getVirtualWorkspaceScheme)(c.getWorkspace());if(g)return g;const b=c.getWorkspace().folders[0];if(b)return b.uri.scheme;const w=c.getWorkspace().configuration;return w?w.scheme:m.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?R.win32:R.posix)}async fileURI(h){let c="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const b=h.indexOf("/",2);b===-1?(c=h.substring(2),h="/"):(c=h.substring(2,b),h=h.substring(b)||"/")}return _.URI.from({scheme:m.Schemas.file,authority:c,path:h,query:"",fragment:""})}};C=ze([Ve(1,n.IRemoteAgentService),Ve(2,k.IWorkbenchEnvironmentService),Ve(3,E.IWorkspaceContextService)],C),e.AbstractPathService=C}),define(be[107],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(I,y){this.line=I,this.character=y}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,y){return new m(0,0)}with(I){return new m(0,0)}}e.Position=m;class R{constructor(I,y,E,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(I,y),this.end=new m(E,k)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new R(0,0,0,0)}with(I){return new R(0,0,0,0)}}e.Range=R;var S;(function(_){_[_.Information=1]="Information",_[_.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[40],Ee([0,1,17,27,23,44,8,4,14,12,107]),function(ee,e,m,R,S,_,I,y,E,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const C="\u27EA ",l=" characters skipped \u27EB",h=(C.length+l.length+5)*2;e.ISearchService=(0,y.createDecorator)("searchService");var c;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function b(L){return!!L.preview}e.resultIsMatch=b;function w(L){return!!L.resource}e.isFileMatch=w;function P(L){return!!L.message}e.isProgressMessage=P;var a;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class f{constructor(Q){this.resource=Q,this.results=[]}}e.FileMatch=f;class v{constructor(Q,O,j){this.ranges=O;const he=Array.isArray(O)?O:[O];if(j&&j.matchLines===1&&t(he)){Q=(0,I.getNLines)(Q,j.matchLines);let $="",ne=0,de=0;const ye=Math.floor(j.charsPerLine/5),Ne=[];for(const Me of he){const $e=Math.max(Me.startColumn-ye,0),Xe=Me.startColumn+j.charsPerLine;if($e>de+ye+h){const qe=C+($e-de)+l;$+=qe+Q.slice($e,Xe),ne+=$e-(de+qe.length)}else $+=Q.slice(de,Xe);Ne.push(new s(0,Me.startColumn-ne,Me.endColumn-ne)),de=Xe}this.preview={text:$,matches:Array.isArray(this.ranges)?Ne:Ne[0]}}else{const $=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:Q,matches:(0,m.mapArrayOrNot)(O,ne=>new r(ne.startLineNumber-$,ne.startColumn,ne.endLineNumber-$,ne.endColumn))}}}}e.TextSearchMatch=v;function t(L){const Q=L[0].startLineNumber;for(const O of L)if(O.startLineNumber!==Q||O.endLineNumber!==Q)return!1;return!0}class r{constructor(Q,O,j,he){this.startLineNumber=Q,this.startColumn=O,this.endLineNumber=j,this.endColumn=he}}e.SearchRange=r;class s extends r{constructor(Q,O,j){super(Q,O,Q,j)}}e.OneLineRange=s;var i;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function u(L,Q=!0){const O=L&&L.files&&L.files.exclude,j=Q&&L&&L.search&&L.search.exclude;if(!O&&!j)return;if(!O||!j)return O||j;let he=Object.create(null);return he=S.mixin(he,S.deepClone(O)),he=S.mixin(he,S.deepClone(j),!0),he}e.getExcludes=u;function d(L,Q){return L.excludePattern&&R.match(L.excludePattern,Q)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&R.match(L.includePattern,Q)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(O=>{const j=O.folder.fsPath;if(_.isEqualOrParent(Q,j)){const he=E.relative(j,Q);return!O.includePattern||!!R.match(O.includePattern,he)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var p;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class D extends Error{constructor(Q,O){super(Q);this.code=O}}e.SearchError=D;function T(L){const Q=L.message;if((0,k.isPromiseCanceledError)(L))return new D(Q,p.canceled);try{const O=JSON.parse(Q);return new D(O.message,O.code)}catch(O){return new D(Q,p.other)}}e.deserializeSearchError=T;function o(L){const Q={message:L.message,code:L.code};return new Error(JSON.stringify(Q))}e.serializeSearchError=o;function A(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=A;function F(L){return L.type==="success"}e.isSerializedSearchSuccess=F;function x(L){return!!L.path}e.isSerializedFileMatch=x;function K(L,Q){const O=L.searchPath?L.searchPath:L.relativePath;return(0,I.fuzzyContains)(O,Q)}e.isFilePatternMatch=K;class le{constructor(Q){this.path=Q,this.results=[]}addMatch(Q){this.results.push(Q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=le;function oe(L,Q){const O={...L||{},...Q||{}};return Object.keys(O).filter(j=>{const he=O[j];return typeof he=="boolean"&&he})}e.resolvePatternsForProvider=oe;class V{constructor(Q,O){this._parsedIncludeExpression=null,this._excludeExpression={...Q.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let j=Q.includePattern;O.includePattern&&(j?j={...j,...O.includePattern}:j=O.includePattern),j&&(this._parsedIncludeExpression=R.parse(j))}includedInQuerySync(Q,O,j){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Q,O,j)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Q,O,j))}includedInQuery(Q,O,j){return Promise.resolve(this._parsedExcludeExpression(Q,O,j)).then($=>!!$).then($=>$?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(Q,O,j)).then(ne=>!!ne):Promise.resolve(!0)).then($=>$)}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=V;function W(L){for(const Q in L)if(typeof L[Q]!="boolean")return!0;return!1}}),define(be[32],Ee([0,1,17,15,20,3,21,11,81,25,8,10,2,139,4,16,154,46,47,29,13,7,40,5]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b,w,P,a,f,v,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(A,F,x){return new k.ExtUri(K=>p(K,x)).isEqual(A,F)}function i(A,F,x){return s(A.uri,F.uri,x)?0:(0,n.compare)(A.uri.toString(),F.uri.toString())}function u(A,F,x){return A.index!==F.index?A.index<F.index?-1:1:s(A.uri,F.uri,x)?(0,n.compare)(A.name,F.name):(0,n.compare)(A.uri.toString(),F.uri.toString())}function d(A,F,x,K){const le=A.slice(0).sort((V,W)=>x(V,W,K)),oe=F.slice(0).sort((V,W)=>x(V,W,K));return(0,m.delta)(le,oe,(V,W)=>x(V,W,K))}function p(A,F){const x=F.getCapabilities(A.scheme);return!(x&&x&1024)}class D extends w.Workspace{constructor(F,x,K,le,oe,V){super(F,K.map(W=>new w.WorkspaceFolder(W)),le,V);this._name=x,this._isUntitled=oe,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris(V),K.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(F,x,K,le){if(!F)return{workspace:null,added:[],removed:[]};const{id:oe,name:V,folders:W,configuration:L,isUntitled:Q}=F,O=[],j=x;x?W.forEach((de,ye)=>{const Ne=l.URI.revive(de.uri),Me=D._findFolder(K||x,Ne,le);Me?(Me.name=de.name,Me.index=de.index,O.push(Me)):O.push({uri:Ne,name:de.name,index:ye})}):O.push(...W.map(({uri:de,name:ye,index:Ne})=>({uri:l.URI.revive(de),name:ye,index:Ne}))),O.sort((de,ye)=>de.index<ye.index?-1:1);const he=new D(oe,V,O,L?l.URI.revive(L):null,!!Q,de=>p(de,le)),{added:$,removed:ne}=d(j?j.workspaceFolders:[],he.workspaceFolders,i,le);return{workspace:he,added:$,removed:ne}}static _findFolder(F,x,K){for(let le=0;le<F.folders.length;le++){const oe=F.workspaceFolders[le];if(s(oe.uri,x,K))return oe}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,x){return x&&this._structure.get(F)&&(F=(0,k.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let T=class{constructor(F,x,K,le){this._onDidChangeWorkspace=new _.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new _.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=le,this._extHostFileSystemInfo=K,this._requestIdProvider=new E.Counter,this._barrier=new R.Barrier,this._proxy=F.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(r.MainContext.MainThreadMessageService);const oe=x.workspace;this._confirmedWorkspace=oe?new D(oe.id,oe.name,[],oe.configuration?l.URI.revive(oe.configuration):null,!!oe.isUntitled,V=>p(V,K)):void 0}$initializeWorkspace(F,x){this._trusted=x,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:y.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,x,K,...le){const oe=[];if(Array.isArray(le)&&le.forEach(O=>{l.URI.isUri(O.uri)&&!oe.some(j=>s(j.uri,O.uri,this._extHostFileSystemInfo))&&oe.push({uri:O.uri,name:O.name||(0,k.basenameOrAuthority)(O.uri)})}),this._unconfirmedWorkspace||[x,K].some(O=>typeof O!="number"||O<0)||K===0&&oe.length===0)return!1;const V=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+K>V.length)return!1;const W=V.slice(0);W.splice(x,K,...oe.map(O=>({uri:O.uri,name:O.name||(0,k.basenameOrAuthority)(O.uri),index:void 0})));for(let O=0;O<W.length;O++){const j=W[O];if(W.some((he,$)=>$!==O&&s(j.uri,he.uri,this._extHostFileSystemInfo)))return!1}W.forEach((O,j)=>O.index=j);const{added:L,removed:Q}=d(V,W,u,this._extHostFileSystemInfo);if(L.length===0&&Q.length===0)return!1;if(this._proxy){const O=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(O,x,K,oe).then(void 0,j=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(b.Severity.Error,(0,h.localize)(0,null,O,j.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(F,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async getWorkspaceFolder2(F,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,x){let K,le="";if(typeof F=="string"?(K=l.URI.file(F),le=F):typeof F!="undefined"&&(K=F,le=F.fsPath),!K)return le;const oe=this.getWorkspaceFolder(K,!0);if(!oe)return le;typeof x=="undefined"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let V=(0,k.relativePath)(oe.uri,K);return x&&oe.name&&(V=`${oe.name}/${V}`),V}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:x,added:K,removed:le}=D.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:K,removed:le}))}findFiles(F,x,K,le,oe=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${le.value}, entryPoint: findFiles`);let V;if(x===null?V=!1:x&&(typeof x=="string"?V=x:V=x.pattern),oe&&oe.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:L}=o(F);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(W),(0,C.withUndefinedAsNull)(L),(0,C.withUndefinedAsNull)(V),(0,C.withUndefinedAsNull)(K),oe).then(Q=>Array.isArray(Q)?Q.map(O=>l.URI.revive(O)):[])}async findTextInFiles(F,x,K,le,oe=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${le.value}, entryPoint: findTextInFiles`);const V=this._requestIdProvider.getNext(),W=typeof x.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:L,folder:Q}=o(x.include),O=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,j={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:W,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:L,excludePattern:O},he=!1;if(this._activeSearchCallbacks[V]=$=>{if(he)return;const ne=l.URI.revive($.resource);$.results.forEach(de=>{(0,t.resultIsMatch)(de)?K({uri:ne,preview:{text:de.preview.text,matches:(0,m.mapArrayOrNot)(de.preview.matches,ye=>new v.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))},ranges:(0,m.mapArrayOrNot)(de.ranges,ye=>new v.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))}):K({uri:ne,text:de.text,lineNumber:de.lineNumber})})},oe.isCancellationRequested)return{};try{const $=await this._proxy.$startTextSearch(F,(0,C.withUndefinedAsNull)(Q),j,V,oe);return delete this._activeSearchCallbacks[V],$||{}}catch($){throw delete this._activeSearchCallbacks[V],$}}$handleTextSearchResult(F,x){this._activeSearchCallbacks[x]&&this._activeSearchCallbacks[x](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};T=ze([Ve(0,f.IExtHostRpcService),Ve(1,a.IExtHostInitDataService),Ve(2,P.IExtHostFileSystemInfo),Ve(3,g.ILogService)],T),e.ExtHostWorkspace=T,e.IExtHostWorkspace=(0,c.createDecorator)("IExtHostWorkspace");function o(A){let F,x;return A&&(typeof A=="string"?F=A:(F=A.pattern,x=A.baseFolder||l.URI.file(A.base))),{includePattern:F,folder:x}}}),define(be[33],Ee([0,1,23,3,32,5,7,157,64,10,15,4,13,16,2]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(r,s){if(s){const i=s.split(".");let u=r;for(let d=0;u&&d<i.length;d++)u=u[i[d]];return u}}function b(r){return r instanceof c.URI}function w(r){return r&&r.uri instanceof c.URI&&r.languageId&&typeof r.languageId=="string"}function P(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function a(r){return r&&r.uri instanceof c.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function f(r){if(b(r))return{resource:r};if(w(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(P(r))return{overrideIdentifier:r.languageId};if(a(r))return{resource:r.uri};if(r===null)return{resource:null}}let v=class{constructor(s,i,u){this._proxy=s.getProxy(_.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=u,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(s,i))}};v=ze([Ve(0,l.IExtHostRpcService),Ve(1,S.IExtHostWorkspace),Ve(2,h.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(s,i,u,d){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=d,this._extHostWorkspace=i,this._configuration=y.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=y.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,u))}getConfiguration(s,i,u){const d=f(i)||{},p=this._toReadonlyValue(s?g(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,d,u?.identifier);function D(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case I.ConfigurationTarget.Global:return 1;case I.ConfigurationTarget.Workspace:return 4;case I.ConfigurationTarget.WorkspaceFolder:return 5}}const T={has(o){return typeof g(p,o)!="undefined"},get:(o,A)=>{this._validateConfigurationAccess(s?`${s}.${o}`:o,d,u?.identifier);let F=g(p,o);if(typeof F=="undefined")F=A;else{let x;const K=(le,oe)=>{let V;const W=()=>{x=x||(0,m.deepClone)(p),V=V||g(x,oe)};return(0,k.isObject)(le)?new Proxy(le,{get:(L,Q)=>{if(typeof Q=="string"&&Q.toLowerCase()==="tojson")return W(),()=>V;if(x)return V=V||g(x,oe),V[Q];const O=L[Q];return typeof Q=="string"?K(O,`${oe}.${Q}`):O},set:(L,Q,O)=>(W(),V&&(V[Q]=O),!0),deleteProperty:(L,Q)=>(W(),V&&delete V[Q],!0),defineProperty:(L,Q,O)=>(W(),V&&Object.defineProperty(V,Q,O),!0)}):le};F=K(F,o)}return F},update:(o,A,F,x)=>{o=s?`${s}.${o}`:o;const K=D(F);return A!==void 0?this._proxy.$updateConfigurationOption(K,o,A,d,x):this._proxy.$removeConfigurationOption(K,o,d,x)},inspect:o=>{o=s?`${s}.${o}`:o;const A=(0,m.deepClone)(this._configuration.inspect(o,d,this._extHostWorkspace.workspace));if(A)return{key:o,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof p=="object"&&(0,m.mixin)(T,p,!1),Object.freeze(T)}_toReadonlyValue(s){const i=u=>(0,k.isObject)(u)?new Proxy(u,{get:(d,p)=>i(d[p]),set:(d,p,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(d,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(d,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return i(s)}_validateConfigurationAccess(s,i,u){const d=E.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),p=u?`[${u.value}] `:"";if(d===4){typeof i?.resource=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){i?.resource&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const u=new y.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,p)=>u.affectsConfiguration(d,f(p))})}_toMap(s){return s.reduce((i,u)=>(i.set(u[0],u[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(ee,e,m,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Be=this&&this.__classPrivateFieldGet||function(ee,e,m,R){if(m==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?R:m==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[108],Ee([0,1,2,15,3,5,23,7,32,49,33,20,39,13,29,4,11,22,16,75,173,12]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b,w,P,a,f,v){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(V){function W(Q){if(Q!=null)return Q}V.from=W;function L(Q){if(Q!=null)return Q}V.to=L})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(V){function W(Q){if(Q!=null)return Q}V.from=W;function L(Q){if(Q!=null)return Q}V.to=L})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(V){function W(Q){if(Q!=null)return Q}V.from=W;function L(Q){if(Q!=null)return Q}V.to=L})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var u;(function(V){function W(O){if(O){const j=O;return j&&!!j.process}else return!1}V.is=W;function L(O){if(O==null)return;const j={process:O.process,args:O.args};return O.options&&(j.options=i.from(O.options)),j}V.from=L;function Q(O){if(O!=null)return new y.ProcessExecution(O.process,O.args,O.options)}V.to=Q})(u=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var d;(function(V){function W(Q){if(Q!=null)return Q}V.from=W;function L(Q){if(Q!=null)return Q}V.to=L})(d=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var p;(function(V){function W(O){if(O){const j=O;return j&&(!!j.commandLine||!!j.command)}else return!1}V.is=W;function L(O){if(O==null)return;const j={};return O.commandLine!==void 0?j.commandLine=O.commandLine:(j.command=O.command,j.args=O.args),O.options&&(j.options=d.from(O.options)),j}V.from=L;function Q(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new y.ShellExecution(O.commandLine,O.options):new y.ShellExecution(O.command,O.args?O.args:[],O.options)}V.to=Q})(p=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var D;(function(V){function W(O){if(O){let j=O;return j&&j.customExecution==="customExecution"}else return!1}V.is=W;function L(O){return{customExecution:"customExecution"}}V.from=L;function Q(O,j){return j.get(O)}V.to=Q})(D=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var T;(function(V){function W(L,Q){let O;return L.scope!==void 0&&typeof L.scope!="number"?O=L.scope.uri:L.scope!==void 0&&typeof L.scope=="number"&&(L.scope===y.TaskScope.Workspace&&Q&&Q.workspaceFile?O=Q.workspaceFile:O=f.USER_TASKS_GROUP_KEY),{id:L._id,workspaceFolder:O}}V.from=W})(T=e.TaskHandleDTO||(e.TaskHandleDTO={}));var o;(function(V){function W(L){if(L!=null)return{_id:L.id,isDefault:L.isDefault}}V.from=W})(o=e.TaskGroupDTO||(e.TaskGroupDTO={}));var A;(function(V){function W(O,j){if(O==null)return[];const he=[];for(let $ of O){const ne=L($,j);ne&&he.push(ne)}return he}V.fromMany=W;function L(O,j){if(O==null)return;let he;O.execution instanceof y.ProcessExecution?he=u.from(O.execution):O.execution instanceof y.ShellExecution?he=p.from(O.execution):O.execution&&O.execution instanceof y.CustomExecution&&(he=D.from(O.execution));const $=r.from(O.definition);let ne;return O.scope?typeof O.scope=="number"?ne=O.scope:ne=O.scope.uri:ne=y.TaskScope.Workspace,!$||!ne?void 0:{_id:O._id,definition:$,name:O.name,source:{extensionId:j.identifier.value,label:O.source,scope:ne},execution:he,isBackground:O.isBackground,group:o.from(O.group),presentationOptions:s.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}V.from=L;async function Q(O,j,he){if(O==null)return;let $;u.is(O.execution)?$=u.to(O.execution):p.is(O.execution)?$=p.to(O.execution):D.is(O.execution)&&($=D.to(O._id,he));const ne=r.to(O.definition);let de;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?de=O.source.scope:de=await j.resolveWorkspaceFolder(m.URI.revive(O.source.scope)):de=y.TaskScope.Workspace),!ne||!de)return;const ye=new y.Task(ne,de,O.name,O.source.label,$,O.problemMatchers);return O.isBackground!==void 0&&(ye.isBackground=O.isBackground),O.group!==void 0&&(ye.group=y.TaskGroup.from(O.group._id),ye.group&&(ye.group=I.deepClone(ye.group),O.group.isDefault&&(ye.group.isDefault=O.group.isDefault))),O.presentationOptions&&(ye.presentationOptions=s.to(O.presentationOptions)),O._id&&(ye._id=O._id),O.detail&&(ye.detail=O.detail),ye}V.to=Q})(A=e.TaskDTO||(e.TaskDTO={}));var F;(function(V){function W(Q){return Q}V.from=W;function L(Q){if(!!Q)return Object.assign(Object.create(null),Q)}V.to=L})(F=e.TaskFilterDTO||(e.TaskFilterDTO={}));class x{constructor(W,L,Q){this._id=L,this._task=Q,t.set(this,void 0),it(this,t,W,"f")}get task(){return this._task}terminate(){Be(this,t,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}t=new WeakMap;var K;(function(V){function W(L){return{id:L._id,task:void 0}}V.from=W})(K=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let le=class{constructor(W,L,Q,O,j,he,$,ne){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=W.getProxy(_.MainContext.MainThreadTask),this._workspaceProvider=Q,this._editorService=O,this._configurationService=j,this._terminalService=he,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=ne,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,L,Q){if(!Q)return new y.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:L,provider:Q,extension:W}),this._proxy.$registerTaskProvider(O,L),new y.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(W,L){this._proxy.$registerTaskSystem(W,L)}fetchTasks(W){return this._proxy.$fetchTasks(F.from(W)).then(async L=>{const Q=[];for(let O of L){const j=await A.to(O,this._workspaceProvider,this._providedCustomExecutions2);j&&Q.push(j)}return Q})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(L=>W.push(L)),W}terminateTask(W){if(!(W instanceof x))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,L,Q){const O=this._providedCustomExecutions2.get(W.id);if(O){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,O),this._terminalService.attachPtyToTerminal(L,await O.callback(Q))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const L=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:L})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const L=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:L,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const L=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:L,exitCode:W.exitCode})}$provideTasks(W,L){const Q=this._handlers.get(W);if(!Q)return Promise.reject(new Error("no handler found"));const O=[],j=(0,R.asPromise)(()=>Q.provider.provideTasks(C.CancellationToken.None)).then(he=>this.provideTasksInternal(L,O,Q,he));return new Promise(he=>{j.then($=>{Promise.all(O).then(()=>{he($)})})})}async $resolveTask(W,L){const Q=this._handlers.get(W);if(!Q)return Promise.reject(new Error("no handler found"));if(L.definition.type!==Q.type)throw new Error(`Unexpected: Task of type [${L.definition.type}] cannot be resolved by provider of type [${Q.type}].`);const O=await A.to(L,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const j=await Q.provider.resolveTask(O,C.CancellationToken.None);if(!j)return;this.checkDeprecation(j,Q);const he=A.from(j,Q.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(he.execution)&&await this.addCustomExecution(he,j,!0),await this.resolveTaskInternal(he)}nextHandle(){return this._handleCounter++}async addCustomExecution(W,L,Q){const O=await this._proxy.$createTaskId(W);!Q&&!this._providedCustomExecutions2.has(O)&&this._notProvidedCustomExecutions.add(O),this._providedCustomExecutions2.set(O,L.execution)}async getTaskExecution(W,L){if(typeof W=="string"){const j=this._taskExecutionPromises.get(W);if(!j)throw new Error("Unexpected: The specified task is missing an execution");return j}let Q=this._taskExecutionPromises.get(W.id);if(Q)return Q;const O=new Promise(async(j,he)=>{const $=L||await A.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);$?j(new x(this,W.id,$)):he("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,O),O.then(j=>(this._taskExecutions.set(W.id,j),j),j=>Promise.reject(j))}checkDeprecation(W,L){W._deprecated&&this._deprecationService.report("Task.constructor",L.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let Q=this._notProvidedCustomExecutions.values(),O=Q.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=Q.next()}};le=ze([Ve(0,h.IExtHostRpcService),Ve(1,c.IExtHostInitDataService),Ve(2,E.IExtHostWorkspace),Ve(3,k.IExtHostDocumentsAndEditors),Ve(4,n.IExtHostConfiguration),Ve(5,l.IExtHostTerminalService),Ve(6,P.ILogService),Ve(7,a.IExtHostApiDeprecationService)],le),e.ExtHostTaskBase=le;let oe=class extends le{constructor(W,L,Q,O,j,he,$,ne){super(W,L,Q,O,j,he,$,ne);this.registerTaskSystem(b.Schemas.vscodeRemote,{scheme:b.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(W,L){if(!L.execution)throw new Error("Tasks to execute must include an execution");const Q=A.from(L,W);if(Q===void 0)throw new Error("Task is not valid");if(D.is(Q.execution))await this.addCustomExecution(Q,L,!1);else throw new v.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution(Q),L);return this._proxy.$executeTask(Q).catch(j=>{throw new Error(j)}),O}provideTasksInternal(W,L,Q,O){const j=[];if(O)for(let he of O){this.checkDeprecation(he,Q),(!he.definition||!W[he.definition.type])&&this._logService.warn(`The task [${he.source}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`);const $=A.from(he,Q.extension);$&&D.is($.execution)?(j.push($),L.push(this.addCustomExecution($,he,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:Q.extension}}async resolveTaskInternal(W){if(D.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,L){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,L,Q){}};oe=ze([Ve(0,h.IExtHostRpcService),Ve(1,c.IExtHostInitDataService),Ve(2,E.IExtHostWorkspace),Ve(3,k.IExtHostDocumentsAndEditors),Ve(4,n.IExtHostConfiguration),Ve(5,l.IExtHostTerminalService),Ve(6,P.ILogService),Ve(7,a.IExtHostApiDeprecationService)],oe),e.WorkerExtHostTask=oe,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(be[223],Ee([0,1,17,51,27,84,21,11,14,25,8,10,2,120,143,94,46,100,222,40]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b,w,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(D,T,o,A){this.configurationService=D,this.workspaceContextService=T,this.editorGroupsService=o,this.pathService=A}text(D,T,o={}){D=this.getContentPattern(D,o);const A=this.configurationService.getValue(),F=T&&T.some(K=>!this.configurationService.getValue({resource:K}).search.useRipgrep);return{...this.commonQuery(T?.map(b.toWorkspaceFolder),o),type:2,contentPattern:D,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:A.search.usePCRE2||F||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles}}getContentPattern(D,T){const o=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const A={...D,wordSeparators:o.editor.wordSeparators};return this.isCaseSensitive(D,T)&&(A.isCaseSensitive=!0),this.isMultiline(D)&&(A.isMultiline=!0),A}file(D,T={}){return{...this.commonQuery(D,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(D,T){return D?(D=Array.isArray(D)?D.map(i):i(D),T?this.parseSearchPaths(D):{pattern:t(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],T={}){const o=this.handleIncludeExclude(T.includePattern,T.expandPatterns),A=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),F=D.length>1,x=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(oe=>this.getFolderQueryForSearchPath(oe,T,A)):D.map(oe=>this.getFolderQueryForRoot(oe,T,A,F))).filter(oe=>!!oe),K={_reason:T._reason,folderQueries:x,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:A.pattern,includePattern:o.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const V=m.coalesce(m.flatten(this.editorGroupsService.groups.map(L=>L.editors.map(Q=>Q.resource)))).filter(L=>(0,a.pathIncludedInQuery)(K,L.fsPath)),W=this.commonQueryFromFileList(V);return{...K,...W}}const le=T.extraFileResources&&T.extraFileResources.filter(oe=>(0,a.pathIncludedInQuery)(K,oe.fsPath));return K.extraFileResources=le&&le.length?le:void 0,K}commonQueryFromFileList(D){const T=[],o=new I.ResourceMap,A={};let F=!1;return D.forEach(x=>{if(x.scheme===y.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(x)){const le=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:E.dirname(x.fsPath)});let oe=o.get(le);oe||(F=!0,oe={folder:le,includePattern:{}},T.push(oe),o.set(le,oe));const V=E.relative(le.fsPath,x.fsPath);(0,C.assertIsDefined)(oe.includePattern)[V.replace(/\\/g,"/")]=!0}else x.fsPath&&(F=!0,A[x.fsPath]=!0)}),{folderQueries:T,includePattern:A,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(D,T){if(T.isSmartCase){if(D.isRegExp){if(n.containsUppercaseCharacter(D.pattern,!0))return!0}else if(n.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,h.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const T=W=>E.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),A=(Array.isArray(D)?D:r(D)).map(W=>{const L=this.pathService.resolvedUserHome;return L?(0,_.untildify)(W,L.scheme===y.Schemas.file?L.fsPath:L.path):W}),F=R.groupBy(A,W=>T(W)?"searchPaths":"exprSegments"),x=(F.exprSegments||[]).map(W=>n.rtrim(W,"/")).map(W=>n.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),s(W))),K={},le=this.expandSearchPathPatterns(F.searchPaths||[]);le&&le.length&&(K.searchPaths=le);const oe=m.flatten(x),V=t(...oe);return V&&(K.pattern=V),K}getExcludesForFolder(D,T){return T.disregardExcludeSettings?void 0:(0,a.getExcludes)(D,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const T=m.flatten(D.map(A=>{let{pathPortion:F,globPortion:x}=v(A);x&&(x=u(x));const K=this.expandOneSearchPath(F);return m.flatten(K.map(le=>this.resolveOneSearchPathPattern(le,x)))})),o=new Map;return T.forEach(A=>{const F=A.searchPath.toString(),x=o.get(F);x?A.pattern&&(x.pattern=x.pattern||{},x.pattern[A.pattern]=!0):o.set(F,{searchPath:A.searchPath,pattern:A.pattern?t(A.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(D){if(E.isAbsolute(D)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==y.Schemas.file?[{searchPath:T[0].uri.with({path:D})}]:[{searchPath:l.URI.file(E.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=i(D),D.startsWith("../")||D===".."){const A=E.posix.resolve(T.path,D);return[{searchPath:T.with({path:A})}]}const o=u(D);return[{searchPath:T,pattern:o}]}else{if(D==="./"||D===".\\")return[];{const T=D.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(F=>{const x=T.match(new RegExp(`^${n.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return x?{match:x,folder:F}:null}).filter(C.isDefined);if(A.length)return A.map(F=>{const x=F.match[1];return{searchPath:F.folder.uri,pattern:x&&u(x)}});{const F=D.match(/\.[\/\\](.+)[\/\\]?/),x=F?F[1]:D,K=c.localize(0,null,x);throw new Error(K)}}}}resolveOneSearchPathPattern(D,T){const o=D.pattern&&T?`${D.pattern}/${T}`:D.pattern||T,A=[{searchPath:D.searchPath,pattern:o}];return o&&!o.endsWith("**")&&A.push({searchPath:D.searchPath,pattern:o+"/**"}),A}getFolderQueryForSearchPath(D,T,o){const A=this.getFolderQueryForRoot((0,b.toWorkspaceFolder)(D.searchPath),T,o,!1);return A?{...A,includePattern:D.pattern}:null}getFolderQueryForRoot(D,T,o,A){let F;const x=l.URI.isUri(D)?D:D.uri;if(o.searchPaths){const W=o.searchPaths.filter(L=>(0,k.isEqual)(L.searchPath,x))[0];if(W&&!W.pattern)return null;W&&(F=W.pattern)}const K=this.configurationService.getValue({resource:x}),oe={...this.getExcludesForFolder(K,T)||{},...F||{}},V=l.URI.isUri(D)?(0,k.basename)(D):D.name;return{folder:x,folderName:A?V:void 0,excludePattern:Object.keys(oe).length>0?oe:void 0,fileEncoding:K.files&&K.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!K.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!K.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!K.search.followSymlinks}}};f=ze([Ve(0,g.IConfigurationService),Ve(1,b.IWorkspaceContextService),Ve(2,w.IEditorGroupsService),Ve(3,P.IPathService)],f),e.QueryBuilder=f;function v(p){const D=p.match(/[\*\{\}\(\)\[\]\?]/);if(D){const T=D.index,o=p.substr(0,T).match(/[/|\\][^/\\]*$/);if(o){let A=p.substr(0,o.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:p.substr((o.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((D,T)=>(D[T]=!0,D),Object.create(null)):void 0}function r(p){return S.splitGlobAware(p,",").map(D=>D.trim()).filter(D=>!!D.length)}function s(p){return[`**/${p}/**`,`**/${p}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function i(p){return p.replace(/\\/g,"/")}function u(p){return i(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(p,D){p=m.distinct(p,A=>A.toString());const T=[],o=D.getWorkspace();return p&&p.forEach(A=>{let F;if(D.getWorkbenchState()===2)F=(0,k.relativePath)(o.folders[0].uri,A),F&&F!=="."&&(F="./"+F);else{const x=D.getWorkspaceFolder(A);if(x){const K=x.name;if(o.folders.filter(oe=>oe.name===K).length===1){const oe=(0,k.relativePath)(x.uri,A);oe===""?F=`./${x.name}`:F=`./${x.name}/${oe}`}else F=A.fsPath}}F&&T.push(F)}),T}e.resolveResourcesForSearchIncludes=d}),define(be[224],Ee([0,1,25,2,20,12,4,223,40,46]),function(ee,e,m,R,S,_,I,y,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function C(g,b){const w=b.activationEvents;if(!w)return Promise.resolve(void 0);const P=[],a=[];for(const i of w)if(/^workspaceContains:/.test(i)){const u=i.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||g.forceUsingSearch?a.push(u):P.push(u)}if(P.length===0&&a.length===0)return Promise.resolve(void 0);let f;const v=new Promise((i,u)=>{f=i}),t=i=>f({activationEvent:i}),r=Promise.all(P.map(i=>l(g,i,t))).then(()=>{}),s=h(g,b.identifier,a,t);return Promise.all([r,s]).then(()=>{f(void 0)}),v}e.checkActivateWorkspaceContainsExtension=C;async function l(g,b,w){for(const P of g.folders)if(await g.exists(m.joinPath(R.URI.revive(P),b))){w(`workspaceContains:${b}`);return}}async function h(g,b,w,P){if(w.length===0)return Promise.resolve(void 0);const a=new S.CancellationTokenSource,f=g.checkExists(g.folders,w,a.token),v=setTimeout(async()=>{a.cancel(),P(`workspaceContainsTimeout:${w.join(",")}`)},n);let t=!1;try{t=await f}catch(r){_.isPromiseCanceledError(r)||_.onUnexpectedError(r)}a.dispose(),clearTimeout(v),t&&P(`workspaceContains:${w.join(",")}`)}function c(g,b,w,P){const a=g.get(I.IInstantiationService),f=g.get(E.ISearchService),t=a.createInstance(y.QueryBuilder).file(b.map(r=>(0,k.toWorkspaceFolder)(R.URI.revive(r))),{_reason:"checkExists",includePattern:w,exists:!0});return f.fileSearch(t,P).then(r=>!!r.limitHit,r=>_.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=c});var it=this&&this.__classPrivateFieldSet||function(ee,e,m,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Be=this&&this.__classPrivateFieldGet||function(ee,e,m,R){if(m==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?R:m==="a"?R.call(ee):R?R.value:e.get(ee)};define(be[34],Ee([0,1,134,14,79,25,15,6,21,2,16,5,33,186,77,32,30,184,12,26,24,161,7,95,4,29,78,13,63,69,39,3,224,74,163]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b,w,P,a,f,v,t,r,s,i,u,d,p,D,T,o,A,F,x){"use strict";var K,le,oe;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let V=class Wn extends y.Disposable{constructor(O,j,he,$,ne,de,ye,Ne,Me,$e){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=j,this._extHostContext=he,this._initData=ye,this._extHostWorkspace=$,this._extHostConfiguration=ne,this._logService=de,this._extHostTunnelService=Me,this._extHostTerminalService=$e,this._disposables=new y.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new I.Barrier,this._readyToStartExtensionHost=new I.Barrier,this._readyToRunExtensions=new I.Barrier,this._eagerExtensionsActivated=new I.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=Ne,this._instaService=O.createChild(new p.ServiceCollection([c.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));const Xe=new Set;this._initData.hostExtensions.forEach(qe=>Xe.add(a.ExtensionIdentifier.toKey(qe))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(qe,je,U)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(qe,P.transformErrorForSerialization(je),U)},actualActivateExtension:async(qe,je)=>{if(Xe.has(a.ExtensionIdentifier.toKey(qe)))return await this._mainThreadExtensionsProxy.$activateExtension(qe,je),new h.HostExtension;const U=this._registry.getExtensionDescription(qe);return this._activateExtension(U,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){P.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(ne=>ne.identifier).filter(ne=>this.isActivated(ne)).map(ne=>this._deactivate(ne))}catch(j){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,j){return this._activator.activateByEvent(O,j)}_activateById(O,j){return this._activator.activateById(O,j)}activateByIdWithErrors(O,j){return this._activateById(O,j).then(()=>{const he=this._activator.getActivatedExtension(O);if(he.activationFailed)return Promise.reject(he.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=E.TernarySearchTree.forPaths(),j=this._registry.getAllExtensionDescriptions().map(he=>{if(!!this._getEntryPoint(he))return this._hostUtils.realpath(he.extensionLocation.fsPath).then($=>O.set(k.URI.file($).fsPath,he))});this._extensionPathIndex=Promise.all(j).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let j=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return j;const he=this._activator.getActivatedExtension(O);if(!he)return j;try{typeof he.module.deactivate=="function"&&(j=Promise.resolve(he.module.deactivate()).then(void 0,$=>(this._logService.error($),Promise.resolve(void 0))))}catch($){this._logService.error($)}try{(0,y.dispose)(he.subscriptions)}catch($){this._logService.error($)}return j}async _activateExtension(O,j){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,j).then(he=>{const $=he.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,$.codeLoadingTime,$.activateCallTime,$.activateResolvedTime,j),this._logExtensionActivationTimes(O,j,"success",$),he},he=>{throw this._logExtensionActivationTimes(O,j,"failure"),he})}_logExtensionActivationTimes(O,j,he,$){const ne=W(O,j);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ne,...$||{},outcome:he})}_doActivateExtension(O,j){const he=W(O,j);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",he);const $=this._getEntryPoint(O);if(!$)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(j)}`),this._logService.flush();const ne=new h.ExtensionActivationTimesBuilder(j.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,_.joinPath)(O.extensionLocation,$),ne),this._loadExtensionContext(O)]).then(de=>(S.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Wn._callActivate(this._logService,O.identifier,de[0],de[1],ne))).then(de=>(S.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),de))}_loadExtensionContext(O){const j=new v.ExtensionGlobalMemento(O,this._storage),he=new v.ExtensionMemento(O.identifier.value,!1,this._storage),$=new x.ExtensionSecrets(O,this._secretState),ne=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([j.whenReady,he.whenReady,this._storagePath.whenReady]).then(()=>{const ye=this;let Ne;return Object.freeze({globalState:j,workspaceState:he,secrets:$,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Me){return R.join(O.extensionLocation.fsPath,Me)},get storagePath(){return ye._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return ye._storagePath.globalValue(O).fsPath},get logPath(){return R.join(ye._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return k.URI.joinPath(ye._initData.logsLocation,O.identifier.value)},get storageUri(){return ye._storagePath.workspaceValue(O)},get globalStorageUri(){return ye._storagePath.globalValue(O)},get extensionMode(){return ne},get extension(){return Ne===void 0&&(Ne=new L(ye,O.identifier,O,de)),Ne},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(O),ye.extensionRuntime},get environmentVariableCollection(){return ye._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,j,he,$,ne){return he=he||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,j,he,$,ne).then(de=>new h.ActivatedExtension(!1,null,ne.build(),he,de,$.subscriptions))}static _callActivateOptional(O,j,he,$,ne){if(typeof he.activate=="function")try{ne.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${j.value}`);const de=typeof global=="object"?global:self,ye=he.activate.apply(de,[$]);return ne.activateCallStop(),ne.activateResolveStart(),Promise.resolve(ye).then(Ne=>(ne.activateResolveStop(),Ne))}catch(de){return Promise.reject(de)}else return Promise.resolve(he)}_activateOneStartupFinished(O,j){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:j}).then(void 0,he=>{this._logService.error(he)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const j of O.activationEvents)j==="onStartupFinished"&&this._activateOneStartupFinished(O,j)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,ne=>{this._logService.error(ne)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ne=>this._handleWorkspaceContainsEagerExtensions(ne.added)));const j=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],he=this._handleWorkspaceContainsEagerExtensions(j),$=Promise.all([O,he]).then(()=>{});return Promise.race([$,(0,I.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),$}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(j=>this._handleWorkspaceContainsEagerExtension(O,j))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,j){if(this.isActivated(j.identifier))return;const he=!this._initData.remote.isRemote&&!!this._initData.remote.authority,$={folders:O.map(de=>de.uri),forceUsingSearch:he,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,ye,Ne)=>this._mainThreadWorkspaceProxy.$checkExists(de,ye,Ne)},ne=await(0,A.checkActivateWorkspaceContainsExtension)($,j);if(!!ne)return this._activateById(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:ne.activationEvent}).then(void 0,de=>this._logService.error(de))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:j}=this._initData.environment;if(!O||!j)throw new Error(m.localize(0,null));const he=await this._loadCommonJSModule(null,j,new h.ExtensionActivationTimesBuilder(!1));if(!he||typeof he.run!="function")throw new Error(m.localize(1,null,j.toString()));return new Promise(($,ne)=>{const de=(Me,$e)=>{Me?ne(Me):$(typeof $e=="number"&&$e>0?1:0)},ye=(0,_.originalFSPath)(j),Ne=he.run(ye,de);Ne&&Ne.then&&Ne.then(()=>{$(0)}).catch(Me=>{ne(Me.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,j){return this._resolvers[O]=j,(0,y.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const j=O.indexOf("+");if(j===-1)throw new Error("Not an authority that can be resolved!");const he=O.substr(0,j);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${he}`,!1),{authorityPrefix:he,resolver:this._resolvers[he]}}async $resolveAuthority(O,j){const{authorityPrefix:he,resolver:$}=await this._activateAndGetResolver(O);if(!$)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${he}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions($)),S.mark(`code/extHost/willResolveAuthority/${he}`);const ne=await $.resolve(O,{resolveAttempt:j});S.mark(`code/extHost/didResolveAuthorityOK/${he}`);const de={authority:O,host:ne.host,port:ne.port,connectionToken:ne.connectionToken},ye={extensionHostEnv:ne.extensionHostEnv,isTrusted:ne.isTrusted};return{type:"ok",value:{authority:de,options:ye,tunnelInformation:{environmentTunnels:ne.environmentTunnels}}}}catch(ne){if(S.mark(`code/extHost/didResolveAuthorityError/${he}`),ne instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ne._code,message:ne._message,detail:ne._detail}};throw ne}}async $getCanonicalURI(O,j){const{authorityPrefix:he,resolver:$}=await this._activateAndGetResolver(O);if(!$)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${he}`);const ne=k.URI.revive(j);if(typeof $.getCanonicalURI=="undefined")return ne;const de=await(0,I.asPromise)(()=>$.getCanonicalURI(ne));return de||ne}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,j){return j===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(he=>this._activateByEvent(O,!1))}async $activate(O,j){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,j),!0):!1}async $deltaExtensions(O,j){O.forEach($=>$.extensionLocation=k.URI.revive($.extensionLocation));const he=await this.getExtensionPathIndex();return await Promise.all(j.map(async $=>{const ne=this._registry.getExtensionDescription($);if(!ne)return;const de=await this._hostUtils.realpath(ne.extensionLocation.fsPath);he.delete(k.URI.file(de).fsPath)})),await Promise.all(O.map(async $=>{const ne=await this._hostUtils.realpath($.extensionLocation.fsPath);he.set(k.URI.file(ne).fsPath,$)})),this._registry.deltaExtensions(O,j),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let j=f.VSBuffer.alloc(O),he=Math.random()%256;for(let $=0;$<O;$++)j.writeUInt8(he,$);return j}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};V=ze([Ve(0,s.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,d.IExtHostRpcService),Ve(3,g.IExtHostWorkspace),Ve(4,l.IExtHostConfiguration),Ve(5,n.ILogService),Ve(6,i.IExtHostInitDataService),Ve(7,u.IExtensionStoragePaths),Ve(8,D.IExtHostTunnelService),Ve(9,T.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function W(Q,O){return{id:Q.identifier.value,name:Q.name,extensionVersion:Q.version,publisherDisplayName:Q.publisher,activationEvents:Q.activationEvents?Q.activationEvents.join(","):null,isBuiltin:Q.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class L{constructor(O,j,he,$){K.set(this,void 0),le.set(this,void 0),oe.set(this,void 0),it(this,K,O,"f"),it(this,le,j,"f"),it(this,oe,he.identifier,"f"),this.id=he.identifier.value,this.extensionUri=he.extensionLocation,this.extensionPath=R.normalize((0,_.originalFSPath)(he.extensionLocation)),this.packageJSON=he,this.extensionKind=$}get isActive(){return Be(this,K,"f").isActivated(Be(this,oe,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,K,"f").getExtensionExports(Be(this,oe,"f"))}activate(){return Be(this,K,"f").activateByIdWithErrors(Be(this,oe,"f"),{startup:!1,extensionId:Be(this,le,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=L,K=new WeakMap,le=new WeakMap,oe=new WeakMap}),define(be[109],Ee([0,1,14,2,3,15,5,7,171,32,34,49,175,33,172,13,4,10,42,67]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b,w,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,b.createDecorator)("IExtHostDebugService");let f=class{constructor(p,D,T,o,A,F){this._workspaceService=D,this._extensionService=T,this._editorsService=o,this._configurationService=A,this._editorTabs=F,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=p.getProxy(I.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(x=>{x.onDidChange(K=>{this.registerAllDebugTypes(x)}),this.registerAllDebugTypes(x)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(p,D){const T=p;if(typeof T.sourceReference=="number"&&T.sourceReference>0){let o=`debug:${encodeURIComponent(T.path||"")}`,A="?";return D&&(o+=`${A}session=${encodeURIComponent(D.id)}`,A="&"),o+=`${A}ref=${T.sourceReference}`,R.URI.parse(o)}else{if(T.path)return R.URI.file(T.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const D=[];for(const T of p.getAllExtensionDescriptions())if(T.contributes){const o=T.contributes.debuggers;if(o&&o.length>0)for(const A of o)(0,c.isDebuggerMainContribution)(A)&&D.push(A.type)}this._debugServiceProxy.$registerDebugTypes(D)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const p=[];return this._breakpoints.forEach(D=>p.push(D)),p}addBreakpoints(p){this.startBreakpoints();const D=p.filter(A=>{const F=A.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,A),!0)});this.fireBreakpointChanges(D,[],[]);const T=[],o=new Map;for(const A of D)if(A instanceof y.SourceBreakpoint){let F=o.get(A.location.uri.toString());F||(F={type:"sourceMulti",uri:A.location.uri,lines:[]},o.set(A.location.uri.toString(),F),T.push(F)),F.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof y.FunctionBreakpoint&&T.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(T)}removeBreakpoints(p){this.startBreakpoints();const D=p.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],D,[]);const T=D.filter(F=>F instanceof y.SourceBreakpoint).map(F=>F.id),o=D.filter(F=>F instanceof y.FunctionBreakpoint).map(F=>F.id),A=D.filter(F=>F instanceof y.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(T,o,A)}startDebugging(p,D,T){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,D,{parentSessionID:T.parentSession?T.parentSession.id:void 0,lifecycleManagedByParent:T.lifecycleManagedByParent,repl:T.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:T.noDebug,compact:T.compact,debugUI:T.debugUI})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,D,T){if(!D)return new y.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:o,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,T,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,o),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(p,D,T){if(!T)return new y.Disposable(()=>{});if(!this.definesDebugType(p,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:o,factory:T}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,o),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==T),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(p,D){if(!D)return new y.Disposable(()=>{});const T=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:T,factory:D}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==D)})}async $runInTerminal(p,D){return Promise.resolve(void 0)}async $substituteVariables(p,D){if(!this._variableResolver){const[A,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,F)}let T;const o=await this.getFolder(p);return o&&(T={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(T,D)}createDebugAdapter(p,D){if(p.type==="implementation")return new i(p.implementation)}createSignService(){}async $startDASession(p,D){const T=this,o=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const F=this.convertToDto(A),x=this.createDebugAdapter(F,o);if(!x)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const K=x;return this._debugAdapters.set(p,K),this.getDebugAdapterTrackers(o).then(le=>(le&&this._debugAdaptersTrackers.set(p,le),K.onMessage(async oe=>{if(oe.type==="request"&&oe.command==="handshake"){const V=oe,W={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(V.arguments.value);W.body={signature:L},K.sendResponse(W)}else throw new Error("no signer")}catch(L){W.success=!1,W.message=L.message,K.sendResponse(W)}}else le&&le.onDidSendMessage&&le.onDidSendMessage(oe),oe=(0,c.convertToVSCPaths)(oe,!0),T._debugServiceProxy.$acceptDAMessage(p,oe)}),K.onError(oe=>{le&&le.onError&&le.onError(oe),this._debugServiceProxy.$acceptDAError(p,oe.name,oe.message,oe.stack)}),K.onExit(oe=>{le&&le.onExit&&le.onExit((0,w.withNullAsUndefined)(oe),void 0),this._debugServiceProxy.$acceptDAExit(p,(0,w.withNullAsUndefined)(oe),void 0)}),le&&le.onWillStartSession&&le.onWillStartSession(),K.startSession()))})}$sendDAMessage(p,D){D=(0,c.convertToDAPaths)(D,!1);const T=this._debugAdaptersTrackers.get(p);T&&T.onWillReceiveMessage&&T.onWillReceiveMessage(D);const o=this._debugAdapters.get(p);o&&o.sendMessage(D)}$stopDASession(p){const D=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),D&&D.onWillStopSession&&D.onWillStopSession();const T=this._debugAdapters.get(p);return this._debugAdapters.delete(p),T?T.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const D=[],T=[],o=[];if(p.added)for(const A of p.added){const F=A.id;if(F&&!this._breakpoints.has(F)){let x;if(A.type==="function")x=new y.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")x=new y.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const K=R.URI.revive(A.uri);x=new y.SourceBreakpoint(new y.Location(K,new y.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}x._id=F,this._breakpoints.set(F,x),D.push(x)}}if(p.removed)for(const A of p.removed){const F=this._breakpoints.get(A);F&&(this._breakpoints.delete(A),T.push(F))}if(p.changed){for(const A of p.changed)if(A.id){const F=this._breakpoints.get(A.id);if(F){if(F instanceof y.FunctionBreakpoint&&A.type==="function"){const x=F;x.enabled=A.enabled,x.condition=A.condition,x.hitCondition=A.hitCondition,x.logMessage=A.logMessage,x.functionName=A.functionName}else if(F instanceof y.SourceBreakpoint&&A.type==="source"){const x=F;x.enabled=A.enabled,x.condition=A.condition,x.hitCondition=A.hitCondition,x.logMessage=A.logMessage,x.location=new y.Location(R.URI.revive(A.uri),new y.Position(A.line,A.character))}o.push(F)}}}this.fireBreakpointChanges(D,T,o)}$provideDebugConfigurations(p,D,T){return(0,_.asPromise)(async()=>{const o=this.getConfigProviderByHandle(p);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(D);return o.provideDebugConfigurations(A,T)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(p,D,T,o){return(0,_.asPromise)(async()=>{const A=this.getConfigProviderByHandle(p);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(D);return A.resolveDebugConfiguration(F,T,o)})}$resolveDebugConfigurationWithSubstitutedVariables(p,D,T,o){return(0,_.asPromise)(async()=>{const A=this.getConfigProviderByHandle(p);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(D);return A.resolveDebugConfigurationWithSubstitutedVariables(F,T,o)})}async $provideDebugAdapter(p,D){const T=this.getAdapterDescriptorFactoryByHandle(p);if(!T)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(D);return this.getAdapterDescriptor(T,o).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(p){const D=await this.getSession(p);this._onDidStartDebugSession.fire(D)}async $acceptDebugSessionTerminated(p){const D=await this.getSession(p);D&&(this._onDidTerminateDebugSession.fire(D),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(p,D){const T=await this.getSession(p);T&&T._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(p,D){const o={session:await this.getSession(p),event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(p){if(p instanceof y.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof y.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const D=this._adapterFactories.filter(T=>T.type===p);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(p){const D=this._adapterFactories.filter(T=>T.handle===p);if(D.length>0)return D[0].factory}getConfigProviderByHandle(p){const D=this._configProviders.filter(T=>T.handle===p);if(D.length>0)return D[0].provider}definesDebugType(p,D){if(p.contributes){const T=p.contributes.debuggers;if(T&&T.length>0){for(const o of T)if(o.label&&o.type&&o.type===D)return!0}}return!1}getDebugAdapterTrackers(p){const T=p.configuration.type,o=this._trackerFactories.filter(A=>A.type===T||A.type==="*").map(A=>(0,_.asPromise)(()=>A.factory.createDebugAdapterTracker(p)).then(F=>F,F=>null));return Promise.race([Promise.all(o).then(A=>{const F=A.filter(x=>!!x);if(F.length>0)return new s(F)}),new Promise((A,F)=>{const x=setTimeout(()=>{clearTimeout(x),F(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(p,D){const T=D.configuration.debugServer;if(typeof T=="number")return Promise.resolve(new y.DebugAdapterServer(T));if(p){const A=await this._extensionService.getExtensionRegistry();return(0,_.asPromise)(()=>p.createDebugAdapterDescriptor(D,this.daExecutableFromPackage(D,A))).then(F=>{if(F)return F})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,o))}daExecutableFromPackage(p,D){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(p,D,T){(p.length>0||D.length>0||T.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:D,changed:T}))}async getSession(p){if(p)if(typeof p=="string"){const D=this._debugSessions.get(p);if(D)return D}else{let D=this._debugSessions.get(p.id);if(!D){const T=await this.getFolder(p.folderUri),o=p.parent?this._debugSessions.get(p.parent):void 0;D=new v(this._debugServiceProxy,p.id,p.type,p.name,T,p.configuration,o),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(p){if(p){const D=R.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}};f=ze([Ve(0,g.IExtHostRpcService),Ve(1,k.IExtHostWorkspace),Ve(2,n.IExtHostExtensionService),Ve(3,C.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,a.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class v{constructor(p,D,T,o,A,F,x){this._debugServiceProxy=p,this._id=D,this._type=T,this._name=o,this._workspaceFolder=A,this._configuration=F,this._parentSession=x}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(p){this._name=p,this._debugServiceProxy.$setDebugSessionName(this._id,p)}get parentSession(){return this._parentSession}_acceptNameChanged(p){this._name=p}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(p,D){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,p,D)}getDebugProtocolBreakpoint(p){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,p.id)}}e.ExtHostDebugSession=v;class t{constructor(p){this.value=Object.freeze({append(D){p.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=t;class r extends l.AbstractVariableResolverService{constructor(p,D,T,o,A){function F(){if(D){const x=D.activeEditor();if(x)return x.document.uri;const K=o.tabs.filter(le=>le.isActive);if(K.length>0)return K[0].resource}}super({getFolderUri:x=>{const K=p.filter(le=>le.name===x);if(K&&K.length>0)return K[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:(x,K)=>T.getConfiguration(void 0,x).get(K),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const x=F();if(x)return m.normalize(x.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const x=F();if(x){const K=A.getWorkspaceFolder(x);if(K)return m.normalize(K.uri.fsPath)}}},getSelectedText:()=>{if(D){const x=D.activeEditor();if(x&&!x.selection.isEmpty)return x.document.getText(x.selection)}},getLineNumber:()=>{if(D){const x=D.activeEditor();if(x)return String(x.selection.end.line+1)}}},void 0,Promise.resolve(P.env))}}e.ExtHostVariableResolverService=r;class s{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(D=>D.onError?D.onError(p):void 0)}onExit(p,D){this.trackers.forEach(T=>T.onExit?T.onExit(p,D):void 0)}}class i extends E.AbstractDebugAdapter{constructor(p){super();this.implementation=p,p.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends f{constructor(p,D,T,o,A,F){super(p,D,T,o,A,F)}createVariableResolver(p,D,T){return new r(p,D,T,this._editorTabs)}};u=ze([Ve(0,g.IExtHostRpcService),Ve(1,k.IExtHostWorkspace),Ve(2,n.IExtHostExtensionService),Ve(3,C.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,a.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(be[225],Ee([0,1,79,2,5,33,30,26,13,29,4,34,42,16]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(a,f,v,t,r,s,i){this._apiFactory=a,this._extensionRegistry=f,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,f,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,f,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let f of a.nodeModuleName)this._factories.set(f,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(f=>a.alternativeModuleName(f))}};c=ze([Ve(2,n.IInstantiationService),Ve(3,_.IExtHostConfiguration),Ve(4,C.IExtHostExtensionService),Ve(5,k.IExtHostInitDataService),Ve(6,h.ILogService)],c),e.RequireInterceptor=c;class g{constructor(a,f,v,t,r){this._apiFactory=a,this._extensionPaths=f,this._extensionRegistry=v,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,f){const v=this._extensionPaths.findSubstr(f.fsPath);if(v){let t=this._extApiImpl.get(y.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(y.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,s)=>t+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(I.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(a,f){this.nodeModuleName="keytar";const{environment:v}=f,t=a.getProxy(S.MainContext.MainThreadKeytar);if(v.appRoot){let r=v.appRoot.fsPath;l.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,s)=>t.$getPassword(r,s),setPassword:(r,s,i)=>t.$setPassword(r,s,i),deletePassword:(r,s)=>t.$deletePassword(r,s),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(a,f){return this._impl}alternativeModuleName(a){const f=a.length;if(f<=7||!this.alternativeNames)return;const v=f-7;if((a.charAt(v)==="/"||a.charAt(v)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};b=ze([Ve(0,E.IExtHostRpcService),Ve(1,k.IExtHostInitDataService)],b);let w=class{constructor(a,f,v){this._extensionPaths=a,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(S.MainContext.MainThreadTelemetry);const t=v.getProxy(S.MainContext.MainThreadWindow);this._impl=(r,s)=>{const i=R.URI.parse(r);return s?this.callOriginal(r,s):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,r,{}):this.callOriginal(r,s)}}load(a,f,v){const t=this._extensionPaths.findSubstr(f.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(a),this._impl}callOriginal(a,f){return this.sendNoForwardTelemetry(),this._original(a,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=ze([Ve(2,E.IExtHostRpcService)],w)}),define(be[226],Ee([0,1,15,12,79,6,2,5,219,16,60,63,29,153,13,70,34,39]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class P{constructor(f,v,t,r){this._disposables=new _.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new E.RPCProtocol(f,null,r),v=P._transform(v,this._rpcProtocol);const s=new C.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());s.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...v}),s.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),s.set(g.IURITransformerService,new g.URITransformerService(r)),s.set(b.IHostUtils,t);const i=new h.InstantiationService(s,!0),u=i.invokeFunction(T=>T.get(w.IExtHostTerminalService));this._disposables.add(u),this._logService=i.invokeFunction(T=>T.get(k.ILogService)),S.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=i.invokeFunction(T=>T.get(b.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const d=new WeakMap;this._extensionService.getExtensionPathIndex().then(T=>{Error.prepareStackTrace=(o,A)=>{let F="",x,K;for(const le of A)F+=`
	at ${le.toString()}`,K=le.getFileName(),!x&&K&&(x=T.findSubstr(K));return d.set(o,x),`${o.name||"Error"}: ${o.message||""}${F}`}});const p=this._rpcProtocol.getProxy(y.MainContext.MainThreadExtensionService),D=this._rpcProtocol.getProxy(y.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(T=>{const o=R.transformErrorForSerialization(T),A=d.get(T);A?p.$onExtensionRuntimeError(A.identifier,o):D.$onUnexpectedError(o)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,m.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,v){f.extensions.forEach(r=>r.extensionLocation=I.URI.revive(v.transformIncomingURIs(r.extensionLocation))),f.environment.appRoot=I.URI.revive(v.transformIncomingURIs(f.environment.appRoot));const t=f.environment.extensionDevelopmentLocationURI;return t&&(f.environment.extensionDevelopmentLocationURI=t.map(r=>I.URI.revive(v.transformIncomingURIs(r)))),f.environment.extensionTestsLocationURI=I.URI.revive(v.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=I.URI.revive(v.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=I.URI.revive(v.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=I.URI.revive(v.transformIncomingURIs(f.logsLocation)),f.logFile=I.URI.revive(v.transformIncomingURIs(f.logFile)),f.workspace=v.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=P}),define(be[227],Ee([0,1,14,20,59,27,25,56,40]),function(ee,e,m,R,S,_,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(l,h,c){this.config=l,this.provider=h,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&_.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&_.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const h=this.config.folderQueries||[];return new Promise((c,g)=>{const b=w=>{this.resultCount++,l(w)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const P=w.toString(),a=m.basename(P);this.globalExcludePattern&&this.globalExcludePattern(P,a)||this.matchFile(b,{base:w,basename:a})}),Promise.all(h.map(w=>this.searchInFolder(w,b))).then(w=>{c({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{g(new Error((0,S.toErrorMessage)(w)))})})}async searchInFolder(l,h){const c=new R.CancellationTokenSource,g=this.getSearchOptionsForFolder(l),b=this.initDirectoryTree(),w=new E.QueryGlobTester(this.config,l),P=!w.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(c),a=y.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,c.token),v=a.elapsed(),t=y.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(r=>{const s=m.posix.relative(l.folder.path,r.path);if(P){const i=m.basename(r.path);this.matchFile(h,{base:l.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(b,l.folder,s,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,w,h),{providerTime:v,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(l){const h=(0,E.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),c=(0,E.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:c,includes:h,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},h,c,g){if(c===this.filePattern){const w=m.basename(this.filePattern);this.matchFile(g,{base:h,relativePath:this.filePattern,basename:w})}function b(w){const P=m.basename(w),a=m.dirname(w);let f=l[a];f||(f=l[a]=[],b(a)),f.push({base:h,relativePath:w,basename:P})}b(c)}matchDirectoryTree({rootEntries:l,pathToEntries:h},c,g){const b=this,w=this.filePattern;function P(a){const f=_.hasSiblingFn(()=>a.map(v=>v.basename));for(let v=0,t=a.length;v<t;v++){const r=a[v],{relativePath:s,basename:i}=r;if(!c.includedInQuerySync(s,i,w!==i?f:void 0))continue;const u=h[s];if(u)P(u);else{if(s===w)continue;b.matchFile(g,r)}if(b.isLimitHit)break}}P(l)}matchFile(l,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(h))}}class n{constructor(){this.sessions=new Map}fileSearch(l,h,c,g){const b=this.getSessionTokenSource(l.cacheKey),w=new k(l,h,b&&b.token);let P=0;const a=f=>{P+=f.length,c(f.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(w,n.BATCH_SIZE,a,g).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:P,detailStats:f.stats}}))}clearCache(l){const h=this.getSessionTokenSource(l);h&&h.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new R.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:I.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,h,c,g){g.onCancellationRequested(()=>{l.cancel()});const b=P=>{P&&(w.push(P),h>0&&w.length>=h&&(c(w),w=[]))};let w=[];return l.search(b).then(P=>(w.length&&c(w),P),P=>(w.length&&c(w),Promise.reject(P)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(be[228],Ee([0,1,14,17,20,59,25,27,2,40,11,10]),function(ee,e,m,R,S,_,I,y,E,k,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(a,f,v){this.query=a,this.provider=f,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,f){const v=this.query.folderQueries||[],t=new S.CancellationTokenSource;return f.onCancellationRequested(()=>t.cancel()),new Promise((r,s)=>{this.collector=new c(a);let i=!1;const u=(d,p)=>{if(!i&&!this.isLimitHit){const D=this.resultSize(d);b(d)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const T=this.resultSize(d);this.resultCount+=T,(T>0||!b(d))&&this.collector.add(d,p)}};Promise.all(v.map((d,p)=>this.searchInFolder(d,D=>u(D,p),t.token))).then(d=>{t.dispose(),this.collector.flush();const p=d.some(D=>!!D&&!!D.limitHit);r({limitHit:this.isLimitHit||p,messages:(0,R.flatten)(d.map(D=>D?.message?(0,C.isArray)(D.message)?D.message:[D.message]:[])),stats:{type:"textSearchProvider"}})},d=>{t.dispose();const p=(0,_.toErrorMessage)(d);s(new Error(p))})})}resultSize(a){return b(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,f){const v=Array.isArray(a.ranges)?a.ranges:[a.ranges],t=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:v.slice(0,f),preview:{matches:t.slice(0,f),text:a.preview.text},uri:a.uri}}async searchInFolder(a,f,v){const t=new k.QueryGlobTester(this.query,a),r=[],s={report:d=>{if(!this.validateProviderResult(d))return;const p=a.folder.scheme===n.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(I.dirname(d.uri))):void 0,D=I.relativePath(a.folder,d.uri);D&&r.push(t.includedInQuery(D,m.basename(D),p).then(T=>{T&&f(d)}))}},i=this.getSearchOptionsForFolder(a),u=await this.provider.provideTextSearchResults(h(this.query.contentPattern),i,s,v);return await Promise.all(r),u}validateProviderResult(a){if(b(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const f=(0,k.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),v=(0,k.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),t={folder:E.URI.from(a.folder),excludes:v,includes:f,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function h(P){return{isCaseSensitive:P.isCaseSensitive||!1,isRegExp:P.isRegExp||!1,isWordMatch:P.isWordMatch||!1,isMultiline:P.isMultiline||!1,pattern:P.pattern}}class c{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,f=>this.sendItems(f))}add(a,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!I.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(g(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=c;function g(P){return b(P)?{preview:{matches:(0,R.mapArrayOrNot)(P.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:P.preview.text},ranges:(0,R.mapArrayOrNot)(P.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:P.text,lineNumber:P.lineNumber}}function b(P){return!!P.preview}e.extensionResultIsMatch=b;class w{constructor(a,f){this.maxBatchSize=a,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,f){!a||this.addItemToBatch(a,f)}addItems(a,f){!a||this.addItemsToBatch(a,f)}addItemToBatch(a,f){this.batch.push(a),this.batchSize+=f,this.onUpdate()}addItemsToBatch(a,f){this.batch=this.batch.concat(a),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(be[110],Ee([0,1,6,5,4,227,13,70,16,2,228]),function(ee,e,m,R,S,_,I,y,E,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let C=class{constructor(g,b,w){this.extHostRpc=g,this._uriTransformer=b,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new _.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,b){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const w=this._handlePool++;return this._textSearchProvider.set(w,b),this._proxy.$registerTextSearchProvider(w,this._transformScheme(g)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(g,b){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const w=this._handlePool++;return this._fileSearchProvider.set(w,b),this._proxy.$registerFileSearchProvider(w,this._transformScheme(g)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(g,b,w,P){const a=l(w),f=this._fileSearchProvider.get(g);if(f)return this._fileSearchManager.fileSearch(a,f,v=>{this._proxy.$handleFileMatch(g,b,v.map(t=>t.resource))},P);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,b,w,P){const a=this._textSearchProvider.get(g);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const f=l(w);return this.createTextSearchManager(f,a).search(t=>this._proxy.$handleTextMatch(g,b,t),P)}createTextSearchManager(g,b){return new n.TextSearchManager(g,b,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};C=ze([Ve(0,I.IExtHostRpcService),Ve(1,y.IURITransformerService),Ve(2,E.ILogService)],C),e.ExtHostSearch=C;function l(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(h),extraFileResources:c.extraFileResources&&c.extraFileResources.map(g=>k.URI.revive(g))}}e.reviveQuery=l;function h(c){return{...c,folder:k.URI.revive(c.folder)}}}),define(be[229],Ee([0,1,20,12,3,36,2,127,87,121,58,62,5,191,190,48,192,33,193,194,195,177,196,49,34,197,178,200,201,202,105,180,207,208,209,77,39,211,181,9,7,214,50,106,32,30,51,168,199,96,104,108,109,110,16,70,13,29,203,165,69,75,188,212,164,78,76,217,215,216,189,47,210,213,74,67,97,205,107,206,11,155,204,162,198]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b,w,P,a,f,v,t,r,s,i,u,d,p,D,T,o,A,F,x,K,le,oe,V,W,L,Q,O,j,he,$,ne,de,ye,Ne,Me,$e,Xe,qe,je,U,G,X,re,q,ie,ge,Re,We,ve,Ye,z,Z,ce,Ue,xe,et,De,Se,Pe,se,ae,fe,pe,B,me,we,Ie,Oe,He){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Ke){const Je=Ke.get(X.IExtHostInitDataService),ut=Ke.get(et.IExtHostFileSystemInfo),mt=Ke.get(z.IExtHostConsumerFileSystem),bt=Ke.get(s.IExtHostExtensionService),ot=Ke.get(he.IExtHostWorkspace),at=Ke.get(ae.IExtHostTelemetry),_e=Ke.get(w.IExtHostConfiguration),ke=Ke.get(U.IURITransformerService),Y=Ke.get(G.IExtHostRpcService),H=Ke.get(K.IExtHostStorage),Fe=Ke.get(Ye.IExtensionStoragePaths),Te=Ke.get(je.ILogService),tt=Ke.get(ie.IExtHostTunnelService),Ge=Ke.get(ge.IExtHostApiDeprecationService),ct=Ke.get(j.IExtHostWindow),yt=Ke.get(Pe.IExtHostSecretState),kt=Ke.get(se.IExtHostEditorTabs);Y.set(l.ExtHostContext.ExtHostFileSystemInfo,ut),Y.set(l.ExtHostContext.ExtHostLogService,Te),Y.set(l.ExtHostContext.ExtHostWorkspace,ot),Y.set(l.ExtHostContext.ExtHostConfiguration,_e),Y.set(l.ExtHostContext.ExtHostExtensionService,bt),Y.set(l.ExtHostContext.ExtHostStorage,H),Y.set(l.ExtHostContext.ExtHostTunnelService,tt),Y.set(l.ExtHostContext.ExtHostWindow,ct),Y.set(l.ExtHostContext.ExtHostSecretState,yt),Y.set(l.ExtHostContext.ExtHostTelemetry,at),Y.set(l.ExtHostContext.ExtHostEditorTabs,kt);const Dt=Y.set(l.ExtHostContext.ExtHostDecorations,Ke.get(Me.IExtHostDecorations)),ft=Y.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Ke.get(r.IExtHostDocumentsAndEditors)),dt=Y.set(l.ExtHostContext.ExtHostCommands,Ke.get(g.IExtHostCommands)),vt=Y.set(l.ExtHostContext.ExtHostTerminalService,Ke.get(le.IExtHostTerminalService)),Et=Y.set(l.ExtHostContext.ExtHostDebugService,Ke.get(Xe.IExtHostDebugService)),Tt=Y.set(l.ExtHostContext.ExtHostSearch,Ke.get(qe.IExtHostSearch)),It=Y.set(l.ExtHostContext.ExtHostTask,Ke.get($e.IExtHostTask)),bn=Y.set(l.ExtHostContext.ExtHostOutputService,Ke.get(T.IExtHostOutputService)),Vt=Y.set(l.ExtHostContext.ExtHostUrls,new Q.ExtHostUrls(Y)),_t=Y.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Y,ft)),Yt=Y.set(l.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(Y,ft,Te)),Jt=Y.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(Te,_t,Y.getProxy(l.MainContext.MainThreadBulkEdits))),gt=Y.set(l.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(Y,dt,ft,_t,Fe)),qt=Y.set(l.ExtHostContext.ExtHostNotebookDocuments,new Oe.ExtHostNotebookDocuments(Te,gt)),Wt=Y.set(l.ExtHostContext.ExtHostNotebookEditors,new Ie.ExtHostNotebookEditors(Te,Y,gt)),Xt=Y.set(l.ExtHostContext.ExtHostNotebookKernels,new fe.ExtHostNotebookKernels(Y,Je,gt,Te)),Zt=Y.set(l.ExtHostContext.ExtHostNotebookRenderers,new B.ExtHostNotebookRenderers(Y,gt)),Pt=Y.set(l.ExtHostContext.ExtHostEditors,new oe.ExtHostEditors(Y,ft)),dn=Y.set(l.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(Y.getProxy(l.MainContext.MainThreadTreeViews),dt,Te)),en=Y.set(l.ExtHostContext.ExtHostEditorInsets,new de.ExtHostEditorInsets(Y.getProxy(l.MainContext.MainThreadEditorInsets),Pt,Je)),xt=Y.set(l.ExtHostContext.ExtHostDiagnostics,new P.ExtHostDiagnostics(Y,Te)),ht=Y.set(l.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(Y,ke,_t,dt,xt,Te,Ge)),tn=Y.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Y,ht)),Mt=Y.set(l.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Y,Te,ft)),Nt=Y.set(l.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(Y,ot,dt)),jt=Y.set(l.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(Y,dt,Te)),En=Y.set(l.ExtHostContext.ExtHostComments,(0,b.createExtHostComments)(Y,dt,_t)),hn=Y.set(l.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(Y.getProxy(l.MainContext.MainThreadProgress))),_n=Y.set(l.ExtHostContext.ExtHosLabelService,new ye.ExtHostLabelService(Y)),fn=Y.set(l.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(Y)),nn=Y.set(l.ExtHostContext.ExtHostAuthentication,new Re.ExtHostAuthentication(Y)),rn=Y.set(l.ExtHostContext.ExtHostTimeline,new We.ExtHostTimeline(Y,dt)),Ht=Y.set(l.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(Y,{remote:Je.remote},ot,Te,Ge)),sn=Y.set(l.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(Y,Ht,ot)),yn=Y.set(l.ExtHostContext.ExtHostCustomEditors,new ce.ExtHostCustomEditors(Y,_t,Fe,Ht,sn)),Sn=Y.set(l.ExtHostContext.ExtHostWebviewViews,new Z.ExtHostWebviewViews(Y,Ht)),zt=Y.set(l.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(Y,dt)),Gt=Y.set(l.ExtHostContext.ExtHostUriOpeners,new Se.ExtHostUriOpeners(Y));Y.set(l.ExtHostContext.ExtHostInteractive,new He.ExtHostInteractive(Y,gt,ft,dt));const Dn=(0,ne.values)(l.ExtHostContext);Y.assertRegistered(Dn);const Cn=new xe.ExtHostBulkEdits(Y,ft),on=new c.ExtHostClipboard(Y),an=new D.ExtHostMessageService(Y,Te),Bt=new a.ExtHostDialogs(Y),Ft=new x.ExtHostStatusBar(Y,dt.converter),Kt=new p.ExtHostLanguages(Y,_t);return h.ExtHostApiCommands.register(dt),function(Le,$t,mn){const pt=function(){let J=!Le.isUnderDevelopment;function ue(Ae){J||(Te.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")ue(st);else{const wt=st;typeof wt.scheme=="undefined"&&ue(st),!Le.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,$.throwProposedApiError)(Le)}return st}}(),kn={getSession(J,ue,Ae){return Ae?.forceRecreate&&(0,$.checkProposedApiEnabled)(Le),nn.getSession(Le,J,ue,Ae)},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(J,ue,Ae,st){return nn.registerAuthenticationProvider(J,ue,Ae,st)}},In={registerCommand(J,ue,Ae){return dt.registerCommand(!0,J,ue,Ae)},registerTextEditorCommand(J,ue,Ae){return dt.registerCommand(!0,J,(...st)=>{const wt=Pt.getActiveTextEditor();if(!wt){Te.warn("Cannot execute "+J+" because there is no active text editor.");return}return wt.edit(Ct=>{ue.apply(Ae,[wt,Ct,...st])}).then(Ct=>{Ct||Te.warn("Edits from command "+J+" were not applied.")},Ct=>{Te.warn("An error occurred while running command "+J,Ct)})})},registerDiffInformationCommand:(J,ue,Ae)=>((0,$.checkProposedApiEnabled)(Le),dt.registerCommand(!0,J,async(...st)=>{const wt=ft.activeEditor(!0);if(!wt){Te.warn("Cannot execute "+J+" because there is no active text editor.");return}const Ct=await Pt.getDiffInformation(wt.id);ue.apply(Ae,[Ct,...st])})),executeCommand(J,...ue){return dt.executeCommand(J,...ue)},getCommands(J=!1){return dt.getCommands(J)}},gn={get machineId(){return Je.telemetryInfo.machineId},get sessionId(){return Je.telemetryInfo.sessionId},get language(){return Je.environment.appLanguage},get appName(){return Je.environment.appName},get appRoot(){return Je.environment.appRoot?.fsPath??""},get uriScheme(){return Je.environment.appUriScheme},get clipboard(){return on.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return at.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return at.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(Je.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ue){return ct.openUri(J,{allowTunneling:!!Je.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===Je.environment.appUriScheme)return Vt.createAppUri(J);try{return await ct.asExternalUri(J,{allowTunneling:!!Je.remote.authority})}catch(ue){if((0,we.matchesScheme)(J,me.Schemas.http)||(0,we.matchesScheme)(J,me.Schemas.https))return J;throw ue}},get remoteName(){return(0,Ne.getRemoteName)(Je.remote.authority)},get uiKind(){return Je.uiKind}};Je.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Je.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Pn={createTestController(J,ue){return zt.createTestController(J,ue)},createTestObserver(){return(0,$.checkProposedApiEnabled)(Le),zt.createTestObserver()},runTests(J){return(0,$.checkProposedApiEnabled)(Le),zt.runTests(J)},get onDidChangeTestResults(){return(0,$.checkProposedApiEnabled)(Le),zt.onResultsChanged},get testResults(){return(0,$.checkProposedApiEnabled)(Le),zt.results}},ln={getExtension(J){const ue=$t.getExtensionDescription(J);if(ue)return new s.Extension(bt,Le.identifier,ue,pn)},get all(){return $t.getAllExtensionDescriptions().map(J=>new s.Extension(bt,Le.identifier,J,pn))},get onDidChange(){return $t.onDidChange}},An={createDiagnosticCollection(J){return xt.createDiagnosticCollection(Le.identifier,J)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:J=>xt.getDiagnostics(J),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(J,ue){return Kt.changeLanguage(J.uri,ue)},match(J,ue){return(0,n.score)(W.LanguageSelector.from(J),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(J,ue,Ae){return ht.registerCodeActionProvider(Le,pt(J),ue,Ae)},registerCodeLensProvider(J,ue){return ht.registerCodeLensProvider(Le,pt(J),ue)},registerDefinitionProvider(J,ue){return ht.registerDefinitionProvider(Le,pt(J),ue)},registerDeclarationProvider(J,ue){return ht.registerDeclarationProvider(Le,pt(J),ue)},registerImplementationProvider(J,ue){return ht.registerImplementationProvider(Le,pt(J),ue)},registerTypeDefinitionProvider(J,ue){return ht.registerTypeDefinitionProvider(Le,pt(J),ue)},registerHoverProvider(J,ue){return ht.registerHoverProvider(Le,pt(J),ue,Le.identifier)},registerEvaluatableExpressionProvider(J,ue){return ht.registerEvaluatableExpressionProvider(Le,pt(J),ue,Le.identifier)},registerInlineValuesProvider(J,ue){return ht.registerInlineValuesProvider(Le,pt(J),ue,Le.identifier)},registerDocumentHighlightProvider(J,ue){return ht.registerDocumentHighlightProvider(Le,pt(J),ue)},registerLinkedEditingRangeProvider(J,ue){return ht.registerLinkedEditingRangeProvider(Le,pt(J),ue)},registerReferenceProvider(J,ue){return ht.registerReferenceProvider(Le,pt(J),ue)},registerRenameProvider(J,ue){return ht.registerRenameProvider(Le,pt(J),ue)},registerDocumentSymbolProvider(J,ue,Ae){return ht.registerDocumentSymbolProvider(Le,pt(J),ue,Ae)},registerWorkspaceSymbolProvider(J){return ht.registerWorkspaceSymbolProvider(Le,J)},registerDocumentFormattingEditProvider(J,ue){return ht.registerDocumentFormattingEditProvider(Le,pt(J),ue)},registerDocumentRangeFormattingEditProvider(J,ue){return ht.registerDocumentRangeFormattingEditProvider(Le,pt(J),ue)},registerOnTypeFormattingEditProvider(J,ue,Ae,...st){return ht.registerOnTypeFormattingEditProvider(Le,pt(J),ue,[Ae].concat(st))},registerDocumentSemanticTokensProvider(J,ue,Ae){return ht.registerDocumentSemanticTokensProvider(Le,pt(J),ue,Ae)},registerDocumentRangeSemanticTokensProvider(J,ue,Ae){return ht.registerDocumentRangeSemanticTokensProvider(Le,pt(J),ue,Ae)},registerSignatureHelpProvider(J,ue,Ae,...st){return typeof Ae=="object"?ht.registerSignatureHelpProvider(Le,pt(J),ue,Ae):ht.registerSignatureHelpProvider(Le,pt(J),ue,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(J,ue,...Ae){return ht.registerCompletionItemProvider(Le,pt(J),ue,Ae)},registerInlineCompletionItemProvider(J,ue){return(0,$.checkProposedApiEnabled)(Le),ht.registerInlineCompletionsProvider(Le,pt(J),ue)},registerDocumentLinkProvider(J,ue){return ht.registerDocumentLinkProvider(Le,pt(J),ue)},registerColorProvider(J,ue){return ht.registerColorProvider(Le,pt(J),ue)},registerFoldingRangeProvider(J,ue){return ht.registerFoldingRangeProvider(Le,pt(J),ue)},registerSelectionRangeProvider(J,ue){return ht.registerSelectionRangeProvider(Le,J,ue)},registerCallHierarchyProvider(J,ue){return ht.registerCallHierarchyProvider(Le,J,ue)},setLanguageConfiguration:(J,ue)=>ht.setLanguageConfiguration(Le,J,ue),getTokenInformationAtPosition(J,ue){return(0,$.checkProposedApiEnabled)(Le),Kt.tokenAtPosition(J,ue)},registerInlayHintsProvider(J,ue){return(0,$.checkProposedApiEnabled)(Le),ht.registerInlayHintsProvider(Le,J,ue)},registerTypeHierarchyProvider(J,ue){return(0,$.checkProposedApiEnabled)(Le),ht.registerTypeHierarchyProvider(Le,J,ue)},createLanguageStatusItem(J){return(0,$.checkProposedApiEnabled)(Le),Kt.createLanguageStatusItem(J)}},Tn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(J,ue,Ae){const st=await(I.URI.isUri(J)?Promise.resolve(vn.openTextDocument(J)):Promise.resolve(J));return Pt.showTextDocument(st,ue,Ae)},createTextEditorDecorationType(J){return Pt.createTextEditorDecorationType(Le,J)},onDidChangeActiveTextEditor(J,ue,Ae){return Pt.onDidChangeActiveTextEditor(J,ue,Ae)},onDidChangeVisibleTextEditors(J,ue,Ae){return Pt.onDidChangeVisibleTextEditors(J,ue,Ae)},onDidChangeTextEditorSelection(J,ue,Ae){return Pt.onDidChangeTextEditorSelection(J,ue,Ae)},onDidChangeTextEditorOptions(J,ue,Ae){return Pt.onDidChangeTextEditorOptions(J,ue,Ae)},onDidChangeTextEditorVisibleRanges(J,ue,Ae){return Pt.onDidChangeTextEditorVisibleRanges(J,ue,Ae)},onDidChangeTextEditorViewColumn(J,ue,Ae){return Pt.onDidChangeTextEditorViewColumn(J,ue,Ae)},onDidCloseTerminal(J,ue,Ae){return vt.onDidCloseTerminal(J,ue,Ae)},onDidOpenTerminal(J,ue,Ae){return vt.onDidOpenTerminal(J,ue,Ae)},onDidChangeActiveTerminal(J,ue,Ae){return vt.onDidChangeActiveTerminal(J,ue,Ae)},onDidChangeTerminalDimensions(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),vt.onDidChangeTerminalDimensions(J,ue,Ae)},onDidWriteTerminalData(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),vt.onDidWriteTerminalData(J,ue,Ae)},get state(){return ct.state},onDidChangeWindowState(J,ue,Ae){return ct.onDidChangeWindowState(J,ue,Ae)},showInformationMessage(J,...ue){return an.showMessage(Le,_.default.Info,J,ue[0],ue.slice(1))},showWarningMessage(J,...ue){return an.showMessage(Le,_.default.Warning,J,ue[0],ue.slice(1))},showErrorMessage(J,...ue){return an.showMessage(Le,_.default.Error,J,ue[0],ue.slice(1))},showQuickPick(J,ue,Ae){return Nt.showQuickPick(J,!!Le.enableProposedApi,ue,Ae)},showWorkspaceFolderPick(J){return Nt.showWorkspaceFolderPick(J)},showInputBox(J,ue){return Nt.showInput(J,ue)},showOpenDialog(J){return Bt.showOpenDialog(J)},showSaveDialog(J){return Bt.showSaveDialog(J)},createStatusBarItem(J,ue,Ae){let st,wt,Ct;return typeof J=="string"?(st=J,wt=ue,Ct=Ae):(wt=J,Ct=ue),Ft.createStatusBarEntry(Le,st,wt,Ct)},setStatusBarMessage(J,ue){return Ft.setStatusBarMessage(J,ue)},withScmProgress(J){return Ge.report("window.withScmProgress",Le,"Use 'withProgress' instead."),hn.withProgress(Le,{location:L.ProgressLocation.SourceControl},(ue,Ae)=>J({report(st){}}))},withProgress(J,ue){return hn.withProgress(Le,J,ue)},createOutputChannel(J){return bn.createOutputChannel(J,Le)},createWebviewPanel(J,ue,Ae,st){return sn.createWebviewPanel(Le,J,ue,Ae,st)},createWebviewTextEditorInset(J,ue,Ae,st){return(0,$.checkProposedApiEnabled)(Le),en.createWebviewEditorInset(J,ue,Ae,st,Le)},createTerminal(J,ue,Ae){return typeof J=="object"?(J.color&&(0,$.checkProposedApiEnabled)(Le),"pty"in J?vt.createExtensionTerminal(J):vt.createTerminalFromOptions(J)):vt.createTerminal(J,ue,Ae)},registerTerminalLinkProvider(J){return vt.registerLinkProvider(J)},registerTerminalProfileProvider(J,ue){return vt.registerProfileProvider(Le,J,ue)},registerTreeDataProvider(J,ue){return dn.registerTreeDataProvider(J,ue,Le)},createTreeView(J,ue){return dn.createTreeView(J,ue,Le)},registerWebviewPanelSerializer:(J,ue)=>sn.registerWebviewPanelSerializer(Le,J,ue),registerCustomEditorProvider:(J,ue,Ae={})=>yn.registerCustomEditorProvider(Le,J,ue,Ae),registerFileDecorationProvider(J){return Dt.registerFileDecorationProvider(J,Le.identifier)},registerUriHandler(J){return Vt.registerUriHandler(Le.identifier,J)},createQuickPick(){return Nt.createQuickPick(Le.identifier,!!Le.enableProposedApi)},createInputBox(){return Nt.createInputBox(Le.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(J,ue,Ae){return fn.onDidChangeActiveColorTheme(J,ue,Ae)},registerWebviewViewProvider(J,ue,Ae){return Sn.registerWebviewViewProvider(Le,J,ue,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,$.checkProposedApiEnabled)(Le),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),gt.onDidChangeActiveNotebookEditor(J,ue,Ae)},get visibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Le),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Le),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),Wt.onDidChangeNotebookEditorSelection(J,ue,Ae)},onDidChangeNotebookEditorVisibleRanges(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),Wt.onDidChangeNotebookEditorVisibleRanges(J,ue,Ae)},showNotebookDocument(J,ue){return(0,$.checkProposedApiEnabled)(Le),gt.showNotebookDocument(J,ue)},registerExternalUriOpener(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),Gt.registerExternalUriOpener(Le.identifier,J,ue,Ae)},get openEditors(){return(0,$.checkProposedApiEnabled)(Le),kt.tabs},get onDidChangeOpenEditors(){return(0,$.checkProposedApiEnabled)(Le),kt.onDidChangeTabs},getInlineCompletionItemController(J){return(0,$.checkProposedApiEnabled)(Le),d.InlineCompletionController.get(J)}},vn={get rootPath(){return Ge.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(J){throw R.readonly()},getWorkspaceFolder(J){return ot.getWorkspaceFolder(J)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(J){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(J){throw R.readonly()},updateWorkspaceFolders:(J,ue,...Ae)=>ot.updateWorkspaceFolders(Le,J,ue||0,...Ae),onDidChangeWorkspaceFolders:function(J,ue,Ae){return ot.onDidChangeWorkspace(J,ue,Ae)},asRelativePath:(J,ue)=>ot.getRelativePath(J,ue),findFiles:(J,ue,Ae,st)=>ot.findFiles(W.GlobPattern.from(J),W.GlobPattern.from(ue),Ae,Le.identifier,st),findTextInFiles:(J,ue,Ae,st)=>{let wt,Ct;return typeof ue=="object"?(wt=ue,Ct=Ae):(wt={},Ct=ue,st=Ae),ot.findTextInFiles(J,wt||{},Ct,Le.identifier,st)},saveAll:J=>ot.saveAll(J),applyEdit(J){return Cn.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ue,Ae,st)=>Mt.createFileSystemWatcher(W.GlobPattern.from(J),ue,Ae,st),get textDocuments(){return _t.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw R.readonly()},openTextDocument(J){let ue;const Ae=J;if(typeof J=="string")ue=Promise.resolve(I.URI.file(J));else if(I.URI.isUri(J))ue=Promise.resolve(J);else if(!Ae||typeof Ae=="object")ue=_t.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(st=>_t.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(J,ue,Ae)=>_t.onDidAddDocument(J,ue,Ae),onDidCloseTextDocument:(J,ue,Ae)=>_t.onDidRemoveDocument(J,ue,Ae),onDidChangeTextDocument:(J,ue,Ae)=>_t.onDidChangeDocument(J,ue,Ae),onDidSaveTextDocument:(J,ue,Ae)=>_t.onDidSaveDocument(J,ue,Ae),onWillSaveTextDocument:(J,ue,Ae)=>Jt.getOnWillSaveTextDocumentEvent(Le)(J,ue,Ae),get notebookDocuments(){return gt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,ue){let Ae;if(I.URI.isUri(J))Ae=J,await gt.openNotebookDocument(J);else if(typeof J=="string")Ae=I.URI.revive(await gt.createNotebookDocument({viewType:J,content:ue}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(J,ue,Ae,st){return gt.registerNotebookSerializer(Le,J,ue,Ae,Le.enableProposedApi?st:void 0)},registerNotebookContentProvider:(J,ue,Ae,st)=>((0,$.checkProposedApiEnabled)(Le),gt.registerNotebookContentProvider(Le,J,ue,Ae,Le.enableProposedApi?st:void 0)),onDidChangeConfiguration:(J,ue,Ae)=>mn.onDidChangeConfiguration(J,ue,Ae),getConfiguration(J,ue){return ue=arguments.length===1?void 0:ue,mn.getConfiguration(J,ue,Le)},registerTextDocumentContentProvider(J,ue){return Yt.registerTextDocumentContentProvider(J,ue)},registerTaskProvider:(J,ue)=>(Ge.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Le,J,ue)),registerFileSystemProvider(J,ue,Ae){return tn.registerFileSystemProvider(Le.identifier,J,ue,Ae,Le.enableProposedApi)},get fs(){return mt.value},registerFileSearchProvider:(J,ue)=>((0,$.checkProposedApiEnabled)(Le),Tt.registerFileSearchProvider(J,ue)),registerTextSearchProvider:(J,ue)=>((0,$.checkProposedApiEnabled)(Le),Tt.registerTextSearchProvider(J,ue)),registerRemoteAuthorityResolver:(J,ue)=>((0,$.checkProposedApiEnabled)(Le),bt.registerRemoteAuthorityResolver(J,ue)),registerResourceLabelFormatter:J=>((0,$.checkProposedApiEnabled)(Le),_n.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ue,Ae)=>Mt.onDidCreateFile(J,ue,Ae),onDidDeleteFiles:(J,ue,Ae)=>Mt.onDidDeleteFile(J,ue,Ae),onDidRenameFiles:(J,ue,Ae)=>Mt.onDidRenameFile(J,ue,Ae),onWillCreateFiles:(J,ue,Ae)=>Mt.getOnWillCreateFileEvent(Le)(J,ue,Ae),onWillDeleteFiles:(J,ue,Ae)=>Mt.getOnWillDeleteFileEvent(Le)(J,ue,Ae),onWillRenameFiles:(J,ue,Ae)=>Mt.getOnWillRenameFileEvent(Le)(J,ue,Ae),openTunnel:J=>((0,$.checkProposedApiEnabled)(Le),tt.openTunnel(Le,J).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,$.checkProposedApiEnabled)(Le),tt.getTunnels()},onDidChangeTunnels:(J,ue,Ae)=>((0,$.checkProposedApiEnabled)(Le),tt.onDidChangeTunnels(J,ue,Ae)),registerPortAttributesProvider:(J,ue)=>((0,$.checkProposedApiEnabled)(Le),tt.registerPortsAttributesProvider(J,ue)),registerTimelineProvider:(J,ue)=>((0,$.checkProposedApiEnabled)(Le),rn.registerTimelineProvider(J,ue,Le.identifier,dt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:J=>((0,$.checkProposedApiEnabled)(Le),ot.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ue,Ae)=>ot.onDidGrantWorkspaceTrust(J,ue,Ae)},Rn={get inputBox(){return Ge.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),jt.getLastInputBox(Le)},createSourceControl(J,ue,Ae){return jt.createSourceControl(Le,J,ue,Ae)}},Fn={createCommentController(J,ue){return En.createCommentController(Le,J,ue)}},Ln={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},onDidStartDebugSession(J,ue,Ae){return Et.onDidStartDebugSession(J,ue,Ae)},onDidTerminateDebugSession(J,ue,Ae){return Et.onDidTerminateDebugSession(J,ue,Ae)},onDidChangeActiveDebugSession(J,ue,Ae){return Et.onDidChangeActiveDebugSession(J,ue,Ae)},onDidReceiveDebugSessionCustomEvent(J,ue,Ae){return Et.onDidReceiveDebugSessionCustomEvent(J,ue,Ae)},onDidChangeBreakpoints(J,ue,Ae){return Et.onDidChangeBreakpoints(J,ue,Ae)},registerDebugConfigurationProvider(J,ue,Ae){return Et.registerDebugConfigurationProvider(J,ue,Ae||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ue){return Et.registerDebugAdapterDescriptorFactory(Le,J,ue)},registerDebugAdapterTrackerFactory(J,ue){return Et.registerDebugAdapterTrackerFactory(J,ue)},startDebugging(J,ue,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?Et.startDebugging(J,ue,{parentSession:Ae}):Et.startDebugging(J,ue,Ae||{})},stopDebugging(J){return Et.stopDebugging(J)},addBreakpoints(J){return Et.addBreakpoints(J)},removeBreakpoints(J){return Et.removeBreakpoints(J)},asDebugSourceUri(J,ue){return Et.asDebugSourceUri(J,ue)}},Mn={registerTaskProvider:(J,ue)=>It.registerTaskProvider(Le,J,ue),fetchTasks:J=>It.fetchTasks(J),executeTask:J=>It.executeTask(Le,J),get taskExecutions(){return It.taskExecutions},onDidStartTask:(J,ue,Ae)=>It.onDidStartTask(J,ue,Ae),onDidEndTask:(J,ue,Ae)=>It.onDidEndTask(J,ue,Ae),onDidStartTaskProcess:(J,ue,Ae)=>It.onDidStartTaskProcess(J,ue,Ae),onDidEndTaskProcess:(J,ue,Ae)=>It.onDidEndTaskProcess(J,ue,Ae)},Nn={createNotebookController(J,ue,Ae,st,wt){return Xt.createNotebookController(Le,J,ue,Ae,st,Le.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(J,ue)=>gt.registerNotebookCellStatusBarItemProvider(Le,J,ue),get onDidSaveNotebookDocument(){return(0,$.checkProposedApiEnabled)(Le),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,$.checkProposedApiEnabled)(Le),Wt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return Zt.createRendererMessaging(Le,J)},onDidChangeNotebookDocumentMetadata(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),qt.onDidChangeNotebookDocumentMetadata(J,ue,Ae)},onDidChangeNotebookCells(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),gt.onDidChangeNotebookCells(J,ue,Ae)},onDidChangeNotebookCellExecutionState(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),gt.onDidChangeNotebookCellExecutionState(J,ue,Ae)},onDidChangeCellOutputs(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),gt.onDidChangeCellOutputs(J,ue,Ae)},onDidChangeCellMetadata(J,ue,Ae){return(0,$.checkProposedApiEnabled)(Le),gt.onDidChangeCellMetadata(J,ue,Ae)},createConcatTextDocument(J,ue){return(0,$.checkProposedApiEnabled)(Le),new ve.ExtHostNotebookConcatDocument(gt,_t,J,ue)}};return{version:Je.version,authentication:kn,commands:In,comments:Fn,debug:Ln,env:gn,extensions:ln,languages:An,notebooks:Nn,scm:Rn,tasks:Mn,tests:Pn,window:Tn,workspace:vn,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:L.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,InlineCompletionItem:L.InlineSuggestion,InlineCompletionList:L.InlineSuggestions,Hover:L.Hover,IndentAction:k.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,Task2:L.Task,TaskGroup:L.TaskGroup,TaskGroup2:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TerminalLink:L.TerminalLink,TerminalProfile:L.TerminalProfile,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,TextDocumentChangeReason:L.TextDocumentChangeReason,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,TypeHierarchyItem:L.TypeHierarchyItem,UIKind:l.UIKind,Uri:I.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookRendererScript:L.NotebookRendererScript,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,PortAttributes:L.PortAttributes,LinkedEditingRanges:L.LinkedEditingRanges,TestResultState:L.TestResultState,TestRunRequest:L.TestRunRequest,TestMessage:L.TestMessage,TestRunProfileKind:L.TestRunProfileKind,TextSearchCompleteMessageType:pe.TextSearchCompleteMessageType,TestMessageSeverity:L.TestMessageSeverity,CoveredCount:L.CoveredCount,FileCoverage:L.FileCoverage,StatementCoverage:L.StatementCoverage,BranchCoverage:L.BranchCoverage,FunctionCoverage:L.FunctionCoverage,WorkspaceTrustState:L.WorkspaceTrustState,LanguageStatusSeverity:L.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ze}),define(be[230],Ee([0,1,60,105,32,104,33,48,49,39,108,109,110,77,69,75,106,76,47,74,97,67]),function(ee,e,m,R,S,_,I,y,E,k,n,C,l,h,c,g,b,w,P,a,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,m.registerSingleton)(y.IExtHostCommands,y.ExtHostCommands),(0,m.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration),(0,m.registerSingleton)(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),(0,m.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,m.registerSingleton)(_.IExtHostDecorations,_.ExtHostDecorations),(0,m.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(P.IExtHostFileSystemInfo,P.ExtHostFileSystemInfo),(0,m.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,m.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,m.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,m.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,m.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,m.registerSingleton)(c.IExtHostTunnelService,c.ExtHostTunnelService),(0,m.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow),(0,m.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace),(0,m.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,m.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,m.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(be[231],Ee([0,1,229,34,225,7,15,5,11]),function(ee,e,m,R,S,_,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(c){const g=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(w,...P)=>{P.forEach(t=>{if(!self.trustedTypes?.isScript(t))throw new Error("TrustedScripts only, please")});const a=P.slice(0,-1).join(","),f=P.pop().toString();return`(function anonymous(${a}) {
${f}
})`}});function b(...w){return g?self.eval(g.createScript("",...w)):new Function(...w)}c.create=b})(k||(k={}));class n extends S.RequireInterceptor{_installInterceptor(){}getModule(g,b){for(let w of this._alternatives){let P=w(g);if(P){g=P;break}}if(this._factories.has(g))return this._factories.get(g).load(g,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class C extends R.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=_.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const g=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);h(g,this._initData.environment.isExtensionDevelopmentDebug);const b=this._instaService.invokeFunction(m.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,b,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(g){return g.browser}async _loadCommonJSModule(g,b,w){b=b.with({path:l(b.path,".js")}),g&&performance.mark(`code/extHost/willFetchExtensionCode/${g.value}`);const P=await fetch(E.FileAccess.asBrowserUri(b).toString(!0));if(g&&performance.mark(`code/extHost/didFetchExtensionCode/${g.value}`),P.status!==200)throw new Error(P.statusText);const a=await P.text(),f=`${b.toString(!0)}#vscode-extension`,v=`${a}
//# sourceURL=${f}`;let t;try{t=k.create(C._ttpExtensionScripts?.createScript("module")??"module",C._ttpExtensionScripts?.createScript("exports")??"exports",C._ttpExtensionScripts?.createScript("require")??"require",C._ttpExtensionScripts?.createScript(v)??v)}catch(u){throw console.error(g?`Loading code for extension ${g.value} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${b.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}const r={},s={exports:r},i=u=>{const d=this._fakeModules.getModule(u,b);if(d===void 0)throw new Error(`Cannot load module '${u}'`);return d};try{return w.codeLoadingStart(),g&&performance.mark(`code/extHost/willLoadExtensionCode/${g.value}`),t(s,r,i),s.exports!==r?s.exports:r}finally{g&&performance.mark(`code/extHost/didLoadExtensionCode/${g.value}`),w.codeLoadingStop()}}async $setRemoteEnvironment(g){throw new Error("Not supported")}async _waitForDebuggerAttachment(g=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+g;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,I.timeout)(10)}}e.ExtHostExtensionService=C,C._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:c=>c});function l(c,g){return c.endsWith(g)?c:c+g}function h(c,g){b("info","log"),b("log","log"),b("warn","warn"),b("error","error");function b(a,f){const v=console[a];console[a]=function(){c.$logExtensionHostMessage({type:"__$console",severity:f,arguments:P(arguments)}),g&&v.apply(console,arguments)}}const w=1e5;function P(a){const f=[],v=[];if(a.length)for(let t=0;t<a.length;t++){if(typeof a[t]=="undefined")a[t]="undefined";else if(a[t]instanceof Error){const r=a[t];r.stack?a[t]=r.stack:a[t]=r.toString()}v.push(a[t])}try{const t=JSON.stringify(v,function(r,s){if(s&&typeof s=="object"){if(f.indexOf(s)!==-1)return"[Circular]";f.push(s)}return s});return t.length>w?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[232],Ee([0,1,60,16,34,78,231,218]),function(ee,e,m,R,S,_,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(S.IExtHostExtensionService,I.ExtHostExtensionService),(0,m.registerSingleton)(R.ILogService,y.ExtHostLogService),(0,m.registerSingleton)(_.IExtensionStoragePaths,_.ExtensionStoragePaths)}),define(be[234],Ee([0,1,24,3,185,226,220,14,79,11,2,230,232]),function(ee,e,m,R,S,_,I,y,E,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const C=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const P=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:f=>f}),a=self.Worker;Worker=function(f,v){/^file:/i.test(f.toString())&&(f=k.FileAccess.asBrowserUri(n.URI.parse(f.toString())).toString(!0));const t=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${f}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;v=v||{},v.name=v.name||y.basename(f.toString());const r=new Blob([t],{type:"application/javascript"}),s=URL.createObjectURL(r);return new a(P?P.createScriptURL(s):s,v)}}else self.Worker=class extends I.NestedWorker{constructor(P,a){super(l,P,{name:y.basename(P.toString()),...a})}};const h=new class{exit(P){C()}async exists(P){return!0}async realpath(P){return P}};class c{constructor(){const a=new MessageChannel,f=new R.Emitter;let v=!1;l(a.port2,[a.port2]),a.port1.onmessage=t=>{const{data:r}=t;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const s=m.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,S.isMessageOfType)(s,2)){v=!0,b("received terminate message from renderer");return}f.fire(s)},this.protocol={onMessage:f.event,send:t=>{if(!v){const r=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);a.port1.postMessage(r,[r])}}}}}function g(P){return new Promise(a=>{const f=P.onMessage(v=>{f.dispose();const t=JSON.parse(v.toString());P.send((0,S.createMessageOfType)(0)),a({protocol:P,initData:t})});P.send((0,S.createMessageOfType)(1))})}let b=P=>C();function w(){const P=new c;E.mark("code/extHost/willConnectToRenderer"),g(P.protocol).then(a=>{E.mark("code/extHost/didWaitForInitData");const f=new _.ExtensionHostMain(a.protocol,a.initData,h,null);b=v=>f.terminate(v)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/379476f0e13988d90fab105c5c19e7abc8b1dea8/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
